%define name w3perl
%define version 3.173
%define release 1%{?dist}
%define basedir /var/www/w3perl
%define docs %{basedir}/docs
%define cfg1 %{basedir}/config
%define cfg2 %{basedir}/resources/admin
%define cgi /usr/lib/cgi-bin/w3perl
%define perl_path %(which perl)


Summary: Web/ftp/mail/squid/cups/dhcp server log file analyzer
Name: %{name}
Version: %{version}
Release: %{release}
Source0: http://www.w3perl.com/download/%{name}-%{version}.tar.bz2
License: GPLv3+
Group: Networking/WWW
URL: http://www.w3perl.com/
BuildRequires: perl >= 5.0
Requires: perl >= 5.0
Requires: webserver
BuildRoot: %{_tmppath}/%{name}-buildroot
Prefix: %{basedir}
Prefix: %{cgi}
BuildArch: noarch

%description
W3Perl is a free web log file analyzer which is also able to parse FTP,
Mail, CUPS, DHCP and Squid log files.

It is one of the most powerful package as it includes advanced stats
like real-time, sessions, URL mapping, along with classical
stats like hosts, pages, traffic, countries, agents, referrers, errors,
file types, robots, search engines and much more.

It supports most logfile formats, including Apache (CLF, ECLF, NECLF)
or IIS (W3C, Microsoft or any variation). Logs can be daily or monthly
split and/or compressed.

A web administration tool allows you to manage your configuration
files to customize your stats output. A demo is available at
http://www.w3perl.com/demo/ 

%prep
%setup -q

%install
rm -rf $RPM_BUILD_ROOT
%{perl_path} install.pl -r $RPM_BUILD_ROOT -i $RPM_BUILD_ROOT%{basedir} -d $RPM_BUILD_ROOT%{cgi} -p %{perl_path}
ln -sf install.pl %{buildroot}%{basedir}/upgrade.pl

cat > $RPM_BUILD_ROOT%{basedir}/README.dpkg <<EOF

--- W3Perl has been successfully installed ---

The resource files are located in %{basedir}
The cgi scripts are located in %{cgi}

In order to get your stats :
    1- First, password protect the %{basedir}/admin directory
        * add an htaccess file or/and add your IP in %{basedir}/admin/pass.txt
    2- Open a browser to http://127.0.0.1/w3perl/admin
    3- Build your own configuration file
        * use 'clone' to start from a predefined configuration file
    4- Compute your stats either from web admin OR command line
           4a -> Web admin : Select 'Init all stats' with your configuration file
           4b -> Command line : Run cron-w3perl.pl -a -c <your config file>
    5- When completed, go back to admin and view the output

EOF

# No need to ship the license if it's standard
rm -f %{buildroot}%{basedir}/LICENCE

%post
chmod 755 %{cfg1}
chmod 755 %{cfg2}
chown www-data:www-data %{cfg1}
chown www-data:www-data %{cfg2}
chmod 644 %{cfg1}/*
chmod 644 %{cfg2}/*
chown www-data:www-data %{cfg1}/*
chown www-data:www-data %{cfg2}/*

# Relocatable
if test "x$RPM_INSTALL_PREFIX1" != "x" ; then
   perl -pi -e "s|conf_file = \"%{cgi}|conf_file = \"$RPM_INSTALL_PREFIX1| if (/\# install/)" $RPM_INSTALL_PREFIX1/libw3perl.pl
   perl -pi -e "s|cgipath = \"%{cgi}|cgipath = \"$RPM_INSTALL_PREFIX1| if (/\# cgipath_install/);" $RPM_INSTALL_PREFIX1/libw3perl.pl
   perl -pi -e "s|require \"%{cgi}|require \"$RPM_INSTALL_PREFIX1| if (/check_modules/);" $RPM_INSTALL_PREFIX1/libw3perl.pl
   perl -pi -e "s|cgipath = \"%{cgi}|cgipath = \"$RPM_INSTALL_PREFIX1|" $RPM_INSTALL_PREFIX1/init.pl
   perl -pi -e "s|w3perlpath = \"%{basedir}|w3perlpath = \"$RPM_INSTALL_PREFIX0|" $RPM_INSTALL_PREFIX1/init.pl
   perl -pi -e "s|require \"%{cgi}|require \"$RPM_INSTALL_PREFIX1|;" $RPM_INSTALL_PREFIX1/confstat.pl
   perl -pi -e "s|^Perl\s(.*)|Perl %{perl_path}|;" $RPM_INSTALL_PREFIX0/upgrade.txt
   perl -pi -e "s|%{basedir}|$RPM_INSTALL_PREFIX0|;" $RPM_INSTALL_PREFIX0/upgrade.txt
   perl -pi -e "s|%{cgi}|$RPM_INSTALL_PREFIX1|;" $RPM_INSTALL_PREFIX0/upgrade.txt
   perl -pi -e "s|%{basedir}|$RPM_INSTALL_PREFIX0|;" %{basedir}/README.dpkg
   perl -pi -e "s|%{cgi}|$RPM_INSTALL_PREFIX1|;" %{basedir}/README.dpkg
   rm $RPM_INSTALL_PREFIX0/libw3perl.pl
   rm $RPM_INSTALL_PREFIX0/cron-*
   rm $RPM_INSTALL_PREFIX0/check_modules.pl
   rm $RPM_INSTALL_PREFIX0/admin/scripts/*.pl
   rm $RPM_INSTALL_PREFIX0/config/config-ftp-iis.pl
   rm $RPM_INSTALL_PREFIX0/config/config-iis.pl
   rm $RPM_INSTALL_PREFIX0/config/config-win-abyss.pl
   rm $RPM_INSTALL_PREFIX0/config/config-win-apache.pl
   rm $RPM_INSTALL_PREFIX0/config/config-win.pl
   rm $RPM_INSTALL_PREFIX0/resources/admin/config-ftp-iis
   rm $RPM_INSTALL_PREFIX0/resources/admin/config-iis
   rm $RPM_INSTALL_PREFIX0/resources/admin/config-win-abyss
   rm $RPM_INSTALL_PREFIX0/resources/admin/config-win-apache
   rm $RPM_INSTALL_PREFIX0/resources/admin/config-win
   rm -r $RPM_INSTALL_PREFIX0/tools/windows
fi

if test "x$RPM_INSTALL_PREFIX1" == "x" ; then
   rm %{basedir}/libw3perl.pl
   rm %{basedir}/cron-*
   rm %{basedir}/check_modules.pl
   rm %{basedir}/admin/scripts/*.pl
   rm %{basedir}/config/config-ftp-iis.pl
   rm %{basedir}/config/config-iis.pl
   rm %{basedir}/config/config-win-abyss.pl
   rm %{basedir}/config/config-win-apache.pl
   rm %{basedir}/config/config-win.pl
   rm %{basedir}/resources/admin/config-ftp-iis
   rm %{basedir}/resources/admin/config-iis
   rm %{basedir}/resources/admin/config-win-abyss
   rm %{basedir}/resources/admin/config-win-apache
   rm %{basedir}/resources/admin/config-win
   rm -r %{basedir}/tools/windows
fi

# Upgrade
if [ "$1" = "2" ]; then
if test "x$RPM_INSTALL_PREFIX1" != "x" ; then
%{perl_path} $RPM_INSTALL_PREFIX0/upgrade.pl -i $RPM_INSTALL_PREFIX0 -d $RPM_INSTALL_PREFIX1
fi
if test "x$RPM_INSTALL_PREFIX1" == "x" ; then
%{perl_path} %{basedir}/upgrade.pl
fi
echo
echo "--- W3Perl has been successfully upgraded to %{version} ---"
echo
fi


if [ "$1" = "1" ]; then
cat %{basedir}/README.dpkg
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%doc %{basedir}/README.dpkg
%doc %{basedir}/README 
%doc %{basedir}/INSTALL 
%doc %{basedir}/VERSION
#%doc %{basedir}/LICENSE
%doc %{docs}

%{basedir}/index.html
%attr(0755,-,-) %{basedir}/*.pl
#%{basedir}/upgrade.pl
%{basedir}/upgrade.txt

%{basedir}/admin
%{basedir}/logs
%{basedir}/tools
%dir %{basedir}/resources
%dir %{basedir}

%{basedir}/resources/*.jpg
%{basedir}/resources/*.gif
%{basedir}/resources/*.png
%{basedir}/resources/*.ico
%{basedir}/resources/*.nsi
%{basedir}/resources/*.spec
%{basedir}/resources/fileext
%{basedir}/resources/pays-conv
%{basedir}/resources/pays-coord
%{basedir}/resources/upgrade
%{basedir}/resources/virus
%{basedir}/resources/robot.txt
%{basedir}/resources/gpl.txt
%{basedir}/resources/referrer-standard.txt
%{basedir}/resources/referrer-keyword.txt
%{basedir}/resources/resolv_users.csv.example
%{basedir}/resources/spip
%{basedir}/resources/css
%{basedir}/resources/pays
%{basedir}/resources/js
%{basedir}/resources/flags
%{basedir}/resources/help
%{basedir}/resources/os
%{basedir}/resources/homepage
%{basedir}/resources/lang
%{basedir}/resources/counter
%{basedir}/resources/new_package
%{basedir}/resources/Readme-tag.txt
%{basedir}/resources/tag_log.php
%{basedir}/resources/heatmap.php

%defattr(0755,www-data,www-data,-)
%dir %{cfg1}
%dir %{cfg2}

%attr(0644,www-data,www-data) %{cfg1}/*
%attr(0644,www-data,www-data) %{cfg2}/*

%defattr(0755,root,root,-)
%{cgi}

%changelog
* Mon Jun 03 2013 Laurent Domisse <domisse@w3perl.com> 1.173-1
- Remove Windows files

* Tue May 29 2013 Laurent Domisse <domisse@w3perl.com> 1.172-3
- Relocation available with --relocate /var/www/w3perl = NEWPATH --relocate /var/www/cgi-bin/w3perl = NEWCGIPATH

* Sat May 25 2013 Laurent Domisse <domisse@w3perl.com> 1.172-2
- Upgrade.txt file and symlink added, fix %defattr

* Tue May 21 2013 Laurent Domisse <domisse@w3perl.com> 1.172-1
- Cleanup
