#!/usr/bin/perl
# <plaintext>  just in case you look at this via a browser

#########################################################################
####                                                                #####
####                     W3PERL LIBRAIRY                            #####
####                                                                #####
####                                                                #####
####    domisse@w3perl.com                   version 29/08/2013     #####
####                                                                #####
#########################################################################

use Getopt::Std;
use POSIX;
use IO::Handle;
use Time::Local qw(timelocal_nocheck timelocal);

$w3perlcgiurl = "/cgi-bin/w3perl";

$status = getopts('abc:d:efg:hi:j:kl:mno:p:q:r:s:t:uvwxyz');
if (!($status)) {
    $msg = "Missing flag argument";
    &error_exit($msg);
}
if ($opt_d ne '') {
    if ($opt_d !~ /^([0-9]*)$/) {
	$msg = "Argument should be a number";
	&error_exit($msg);
    }
}

&ReadParse;

STDOUT->autoflush(1);
#$debug = 1;

#use File::Copy;
if ($netgeo == 1 || $geoipcity == 1) {
    require Geo::IP;
}

$cgipath = "/usr/lib/cgi-bin/w3perl/"; # cgipath_install
$dirsepurl = "/";
$dirsep = "/";

$cgipath_install = $cgipath;

if ($opt_c ne '') {
    $conf_file = $opt_c;
    $conf_file = &Windows_ShortPath($conf_file,0) if ($conf_file =~ /^\w:/);
    $conf_file = $cgipath.$conf_file if ($conf_file !~ /^\// && $conf_file !~ /^\w:/);
#    $conf_file = $cgipath.$conf_file if ($conf_file !~ /^\//);
} else {
    $conf_file = "/usr/lib/cgi-bin/w3perl/config.pl"; # install
}	


#use lib qw(/big/dom/xw3perl/GeoIP/lib/perl5/site_perl/5.6.1/i386-linux/);
###use lib qw(/usr/lib/cgi-bin/w3perl/); # Perl_modules

#$GeoIP->{cache} 
$pos = rindex($cgipath,"cgi");
$cgiurl = substr($cgipath,$pos-1,length($cgipath));

if (-f $conf_file) {
    if (!(-r $conf_file)) {
	print "Content-type: text/html\n\n" if ($ENV{'REQUEST_METHOD'} eq "GET");
	$msg = "Unable to read $conf_file !";
	# error_exit cannot be used as config file have not been loaded !
	print "$msg\n";
	exit;
#	&error_exit($msg);
    }
    require "$conf_file";
} else {
    $msg = "The ";
    $msg .= "default " if ($conf_file =~ /config$plext/);
    $msg .= "configuration file $conf_file cannot be found.\n";
    $msg .= "Please use the admin to build it or use the '-c' flag to load another one.\n";
    print "$msg\n";
    exit;
#    &error_exit($msg);
}

if ($crypt == 1) {
#    $localdomaine_crypt = crypt($localdomaine,&keycrypt(2));
    $localdomainename_crypt = crypt($localdomainename,&keycrypt(2));
    $localdomainename_crypt = substr($localdomainename_crypt,0,7);
}

#########################################################################
### Init values
#########################################################################

# 0 = jqplot / 1 = fly
$fly_set = 0 if ($fly_set eq '');

# Fly
@list_graph_name = ("graph3d","barchart","graphlinefill","graphline");

# Jqplot
@list_graph_name_jqplot = ("graphline","barchart","graphlinefill");
$xmax_jqplot = 600;
$ymax_jqplot = 400;
$xmax_home_jqplot = 300;
$ymax_home_jqplot = 150;
$default_graph_idx = 1;
@serie_color = ('#ff5555', '#55ff55','#5555ff', '#55ffff', '#ff55ff', '#ffff55','#aa0000', '#00aa00', '#0000aa', '#4ad5ac', '#c5d529','#9cb400','#EE9400','#bd8383');

$split_localhost = 1;
$nt = 0;

if (substr($pathinit,1,1) eq ':') {
    $nt = 1;
    $path = &Windows_ShortPath($path,1);
    $pathinit = &Windows_ShortPath($pathinit,0);
    $pathserver = &Windows_ShortPath($pathserver,0) if ($pathserver ne '');
    $cgipath = &Windows_ShortPath($cgipath,0);
    $cgipath_install = &Windows_ShortPath($cgipath_install,0);
    $FLY = &Windows_ShortPath($FLY,0) if ($fly_set == 1);
    if ($GZIP ne '') {
	$windows_bin_ext = ".exe";
	($tmp1,$tmp2) = split(/$windows_bin_ext\s/,$GZIP);
	$GZIP = $tmp1.$windows_bin_ext;
	$GZIP = &Windows_ShortPath($GZIP,0) if ($GZIP ne '');
	$GZIP = $GZIP." ".$tmp2;
    }
    $wget_bin = &Windows_ShortPath($wget_bin,0) if ($wget_bin ne '');
    for ($i=0;$i<=$#fileroot;$i++) {
	$fileroot[$i] = &Windows_ShortPath($fileroot[$i],0);
    }
}

$diradmin = "admin";
$dirconfig = "config";
$docscss = "docs.css";

if (!(-d "$pathinit$dirconfig")) {
    $msg = "W3Perl install directory not found.\n";
    $msg .= "Check your \$pathinit setting\n";
    print "$msg\n";
    exit;
}

$dirdate = "date";
$dirdays = "days";
$dirlist = "list";
$dirscript = "script";
$dirtmp = "tmp";
$dirframe = "frame";
$dirinc = "inc";
$dirpays = "pays";
$dirsite = "site";
$dirpage = "page";
$diros = "os";
$dirsession = "session";
$dirdocument = "document";
$dirproxy = "proxy";
$dirgraph = "graph";
$tmpfly = $path.$dirtmp.$dirsep."tmpfly";
$history = $path.$dirdata.$dirsep."history";
$filecpu = "cpu".$htmlext;
$baudrate = 5;       
$output_log = "output.log";
$progress_log = "progress.log";

## colors table

# for fly output

$square = 10;         # images are $square square pixels
@gcolor = ('rouge','vert','bleufonce','bleu','violet','jaune','marron','vertfonce','bleunuit','bleuclair','jaunefonce','kaki','orange','rose');
@flycolor = (255,85,85,85,255,85,85,85,255,85,255,255,255,85,255,255,255,85,170,0,0,0,170,0,0,0,170,74,213,172,197,213,41,156,180,0,238,148,0,189,131,131);


for ($i=0;$i<$#gcolor;$i++) {
    $gcolor[$i] .= $gifext;

    $red[$i] = $flycolor[3*$i];
    $green[$i] = $flycolor[3*$i+1];
    $blue[$i] = $flycolor[3*$i+2];
    }

undef @flycolor;

# last color index is 100 (others.gif)

$red[100] = 102;
$green[100] = 102;
$blue[100] = 102;

##################################################################
### generic file names
##################################################################

$favicon = "favicon";
$pngext = ".png";
$icoext = ".ico";
$csvext = ".csv";
$cssext = ".css";

$css_jqplot = "jquery.jqplot.min.css";
$jqplot_js = "jquery.jqplot.min.js";
$jquery_js = "jquery.js";
$dirjqplot = "jqplot";
$jqplot_excanvas = "excanvas.min.js";
$jqplot_plugin_TextRenderer = "jqplot.canvasTextRenderer.min.js";
$jqplot_plugin_AxisLabelRenderer ="jqplot.canvasAxisLabelRenderer.min.js";
$jqplot_plugin_highlighter = "jqplot.highlighter.min.js";
$jqplot_plugin_cursor = "jqplot.cursor.min.js";
$jqplot_plugin_dateAxisRenderer = "jqplot.dateAxisRenderer.min.js";
$jqplot_plugin_pieRenderer = "jqplot.pieRenderer.min.js";

$jqplot_plugin_canvasAxis = "jqplot.canvasAxisTickRenderer.min.js";
$jqplot_plugin_categoryAxis = "jqplot.categoryAxisRenderer.min.js";
$jqplot_plugin_barRenderer = "jqplot.barRenderer.min.js";
$jqplot_plugin_pointLabels = "jqplot.pointLabels.min.js";
$jqplot_plugin_pointLabels = "jqplot.pointLabels.min.js";
$jqplot_plugin_enhancedLegendRenderer = "jqplot.enhancedLegendRenderer.min.js";
$jqplot_plugin_canvasoverlay = "jqplot.canvasOverlay.min.js";

$dirjqplotplugins = "plugins";

### Logo file
# if you want to use your own logo ...
# default is a png file located in /resources/

$logo = "logo".$pngext if ($logo eq '');

### Data files ###

$file = $fileroot.$prefixlog; # a supprimer ? utilisez par cron-inc comme valeur par defaut
$fileagent = $fileroot.$agentlog;
$filerefer = $fileroot.$referlog;

$help = "index.html";
$paysgraph = "pays".$gifext;
$paysgraph2 = "pays2".$gifext;
$paysconv = "pays-conv";

$ip_table = "ip";

#

$datafile = "time-stat";
$statrepert = "time-repert";
$filerepertsize = "time-rsize";

#

$filenamehour = "stat-hour".$htmlext;
$filenameday = "stat-day".$htmlext;
$statnameweek = "stat-week".$htmlext;
$statnamemonth = "stat-month".$htmlext;
$tabnameyear = "tab-year".$htmlext;
$statnameyear = "stat-year".$htmlext;

$filenametabsize = "tab-size".$htmlext;

# 

$tabnamedays = "tab-days".$htmlext;
$tabnameweek = "tab-weeks".$htmlext;
$tabnamemonth = "tab-month".$htmlext;
$tabnamerefer = "refer".$htmlext;
$tabnamekeyword = "keyword".$htmlext;
$tabnamebrowser = "agent".$htmlext;
$tabnameerror = "error".$htmlext;

# version incrementale

$incgeneral = "general";
$incpage = "pages";
$incpagehost = "pagehost";
$incpays = "pays";
#$incservtot = "serv-tot";
$incservexterne = "serv-externe";
$incservinterne = "serv-interne";
$incpageselect = "pages-select";
$increpert = "repert";
$inchosts = "hosts";
$incscript = "script";
$incmethod = "method";
$incproxystatus = "proxy-status";
$incproxypeer = "proxy-peer";
$incproxyhosts = "proxy-host";

$increfengine = "refengine";
$increfkey = "refkey";
$increfsites = "refsite";
$increfpages = "refpages";
$increfin = "refin";
$increfselec = "refselec";
$increfexit = "refexit";

$incbrowser = "browser";
$incos = "os";
$dayagent = "dayagent";

$incerror = "error";
$incerrpage = "errpage";
$dayerror = "dayerror";

$incrobot = "robot";
$incvirtual = "virtual";
$incvirtualhtml = "virtualacc";

$incstatus = "status";
$incabort = "abort";
$incftp = "ftp";
$incftpday = "ftpday";

## nom des fichiers dans le repertoire Ressources

$refer = "refer".$htmlext;
$agent = "agent".$htmlext;
$error = "error".$htmlext;
$filesession = "index".$htmlext;
$menu = "index".$htmlext;
$filemoyenne = "moyenne".$htmlext;
$fileresumemenu = "menu".$htmlext;

# graphs used by pages and computed by week
$statweekrepert = "week_rep";

#### a supprimer ????

$file_now = "now".$htmlext;
$filehour = "stat-hour".$htmlext;
$fileday = "stat-day".$htmlext;
$fileweek = "stat-week".$htmlext;
$filemonth = "stat-month".$htmlext;

#

$filesites = "index".$htmlext;
$filepages = "index".$htmlext;
$filepays = "index".$htmlext;
$filerepert = "list-report".$htmlext;
$filescript = "index".$htmlext;

$filereport = $filerepert;  # a supprimer
$filevirtual = "virtual".$htmlext;

$unresolved = "unresolved".$htmlext;

# icons

$icon_hosts = "hosts".$pngext;
$icon_countries = "countries".$pngext;
$icon_pages = "pages".$pngext;
$icon_dir = "dir".$pngext;
$icon_hours = "hours".$pngext;
$icon_days = "days".$pngext;
$icon_weeks = "weeks".$pngext;
$icon_months = "months".$pngext;
$icon_refer = "refer".$pngext;
$icon_spider = "spider".$pngext;
$icon_session = "session".$pngext;
$icon_error = "error".$pngext;
$icon_agent = "agent".$pngext;
$icon_doc = "document".$pngext;
$icon_script = "script".$pngext;
$icon_virtual = "virtual".$pngext;
$icon_filetype = "filetype".$pngext;
$icon_screensize = "screensize".$pngext;
$icon_traffic = "traffic".$pngext;
$icon_virus = "virus".$pngext;
$icon_squid = "squid".$pngext;
$icon_status = "status".$pngext;
$icon_destination = "destination".$pngext;

$icon_tree = "tree".$pngext;
$icon_new = "new".$pngext;
$icon_linksym = "linksym".$pngext;
$icon_linkerr = "linkerr".$pngext;
$icon_docrepert = "docrepert".$pngext;
$icon_useless = "useless".$pngext;
$icon_linkabs = "linkabs".$pngext;
$icon_info = "info".$pngext;
$icon_info2 = "info2".$pngext;
$icon_temp = "temp".$pngext;
$icon_verif = "verif".$pngext;
$icon_pie = "pie".$pngext;
$icon_null = "null".$pngext;
$icon_links = "links".$pngext;
$icon_ima = "ima".$pngext;
$icon_trash = "trash".$pngext;
$icon_cdrom = "cdrom".$pngext;

$icon_duree = "duree".$pngext;
$icon_notes = "notes".$pngext;
$icon_descsess = "descsess".$pngext;
$icon_sessmul = "sessmul".$pngext;
$icon_time = "time".$pngext;
$icon_unread = "unread".$pngext;
$icon_login = "login".$pngext;
$icon_users = "users".$pngext;
$icon_reading = "reading".$pngext;

$icon_new_w3perl = "new_stat".$gifext;
$icon_fleched = "fleched".$pngext;
$icon_flecheg = "flecheg".$pngext;
$icon_flecheh = "flecheh".$pngext;
$icon_go = "go".$pngext;

$icon_weight = "weight".$pngext;
$icon_moyenne = "moyenne".$pngext;

$icon_pdf = "pdf".$pngext;
$icon_csv = "csv".$pngext;
$icon_print = "print".$pngext;
$icon_mail = "mail".$pngext;

$icon_year = "year".$pngext;
$icon_xml = "xml".$pngext;
$icon_hacker = "hacker".$pngext;
$icon_spam = "spam".$pngext;
$icon_bounce = "bounce".$pngext;

$dirdomain = "domain";
$dirdownload = "download";
$earthmap = "earth.jpg";

$extconv = "fileext";
$filetype = "filetype";

$dirflags = "flags";
$pagedate = "pagedate";
$pagehas = "pagehas";

$dirtraffic = "traffic";
$filevirus = "virus".$htmlext;
$virusdef = "virus";
$filesquid = "squid".$htmlext;

$icon_help = "help".$gifext;
$dirhelp = "help";

$doctype = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">";
$charset = "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">";

$dircsv = "csv";
$dirpdf = "pdf";
$dirjs = "js";
$dircss = "css";

$sorttablejs = "sorttable.js";
$helpjs = "help.js";
$calendarjs = "basiccalendar.js";

$css_w3perl = "w3perl.css";
$css_help = "help.css";

#$refspam_ip = "referrer-ip.txt";
$refspam_keyword = "referrer-keyword.txt";
$refspam_standard = "referrer-standard.txt";
$increferspam = "referer_spam";

$filescreensize = "screensize".$htmlext;

$miscstats_string = "/stats_w3perl_screensize/miscstats.js";
$incscreensize = "screensize";

$users = "users";
$pdfext = ".pdf";

$searchjs = "search.js";
$toggle_on = "chkCheckAll.gif";
$toggle_off = "chkUnCheckAll.gif";

#$nb_rss_item = 20;
$icon_mini_rss = "rss".$pngext;
$icon_rss = "rss".$pngext;
$filerss= "rss";
$xmlext = ".xml";
$dirxml = "xml";

$percentage_ima_bkg = "percentImage.png";
$percentage_ima = "percentImage_back1.png";

$fileheatmap = "heatmap";
$icon_heatmap = "heatmap".$pngext;

$array_down = "g-down".$gifext;
$array_up = "g-up".$gifext;
$array_same = "g-same".$gifext;

$filecity = "city";
$dircity = "city";

$worldmap_x = 500;
$worldmap_y = 250;
$icon_city = "city".$pngext;

$filecpu = "cpu";
$css_menu_w3perl = "menu.css";
$filetime = "time".$htmlext;
$filevisit = "visite".$htmlext;
$filemainsites = "sites".$htmlext;
$dureesession = "duree".$htmlext;
$filerobot = "robots".$htmlext;
$fileaverage = "pages".$htmlext;
$loginuser = "login";
#$filelogin = $loginuser.$htmlext;

$doclien = "doclien".$htmlext;
$docimage = "docimage".$htmlext;
$docsize = "docsize".$htmlext;
$docrepert = "docrepert".$htmlext;
$new = "newdoc".$htmlext;
$tree = "tree".$htmlext;
$frame = "frames".$htmlext;
$doublons = "doublons".$htmlext;
$imawidth = "width".$htmlext;
$imaalt = "alt".$htmlext;
$useless = "useless".$htmlext;
$cdrom = "cdrom".$htmlext;
$fileabsolute = "absolute".$htmlext;
$filelinksym = "symbolic".$htmlext;
$nofile = "nofile".$htmlext;

$locconf = "locconf";
$cornersjs = "rounded_corners.js";

$curvy_bottom_jss = "<script LANGUAGE=\"Javascript\" type=\"text/JavaScript\">\nwindow.onload = function() {\n var cookie = readCookie(\"style\");var title = cookie ? cookie : getPreferredStyleSheet();setActiveStyleSheet(title);\n";
# AJAX
if ($linkpath_url ne '') {
    $curvy_bottom_jss .= "UpdateCSSMenu();\n";
    $curvy_bottom_jss .= "UpdateToolHeader();\n";
}
$curvy_bottom_jss .= "ieFix(\'menucss\');\n }\n</script>\n";


$css_menu_iefixjs = "css_menu_iefix.js";

$dayrange = "dayrange".$plext;
$calendarpopupjs = "CalendarPopup.js";
$icon_calendar = "calendar.gif";

$homeicons2 = "homepage";
$icon_bookmark = "bookmark".$pngext;

$localhost_port = 80 if ($localhost_port eq '');
$localserver_port = 80 if ($localserver_port eq '');
$localserver_protocol = "http" if ($localserver_protocol eq '');
$localhost_protocol = "http" if ($localhost_protocol eq '');

$hostdate = "hostdate";
$miscstats_heatmap_url = "/w3perl/resources/heatmap.php";

$style_switcherjs = "styleswitcher.js";

$inc_user = 1 if ($inc_user eq ''); # default enabled

$count_max_pie = 10;
$pie_square = $ymax+5;
$others = "others".$gifext;
$incfilehost = "filehost";

$login_forbidden_str = "[\/]"; # Forbidden characters in login string (default '/' to avoid url spam)
$inchomepage = "homepage".$txtext;	 
$filerssdaily = "rss_daily".$txtext;
$incssvirtual = "ssvirtual";

$spam = "spam";
$titlename = 0 if (-z "$path$dirdata$dirsep$fileurl");
$titlename = 0 if ($dhcp_format == 1);
$increversehosts = "hosts_reverse";
$menuheader = "menuheader".$txtext;

$matrix = "matrix-animated-image.gif";

#########################################################################

$date_format =~ s/[\-\/ ]//g; # remove extra chracters if found 
@date_string = split(/%/,$date_format);

$mode_merge = 0;
#if (defined($fileroot) == 0) {
#    $mode_merge = 1;
#}
push(@fileroot,$fileroot) if (!(@fileroot));


#$mode_lb = 0;
#if ($#fileroot > 0) {
#    $mode_lb = 1;
#}

$dirtools = "tools";
$logresolvemerge_bin = $pathinit.$dirtools.$dirsep."logresolvemerge.pl";

if ($fly_set == 0) {
    $xmax = 600;
    $ymax = 300;
} else {
    $xmax = $xmax_jqplot;
    $ymax = $ymax_jqplot;
}

$xmax_home = $xmax/2;
$ymax_home = $ymax/2;

if ($fly_set == 1) {
    $diam_home = $ymax/2;
    $rayon_home = $diam_home/2;
    $pie_square_home = $diam_home+5;
}

$top_home = 5;

# Try to find pathserver

$bkg1 = $pathinit;
#$tmp = $pathinit;

if ($bkg1 =~ /\/(\w+)\/$tildealias/ && $tildealias ne '') {
    $tmp2 = $1;
    $bkg1 =~ s/.*\/$tildealias/\/~$tmp2/;
} else {
    $bkg1 = $linkpath_url;	
    $bkg1 = "/w3perl/" if (substr($cgipath,1,1) eq ':'); # Windows
}

$tmp1 = "docs".$dirsepurl."img".$dirsepurl."bg".$gifext;
$bkg = $bkg1.$tmp1;

if (!(-f "$path$tmp1")) {
    $tmp2 = $pathinit;
    $tmp3 = $pathserver;
    chop($tmp3);
    $tmp2 =~ s/$tmp3//;
    $bkg = $tmp2.$tmp1;
    $bkg1 = $tmp2;
}

$cssurl = $bkg1.$dirress.$dirsep.$dircss.$dirsep.$docscss;
$js_prototype = $bkg1.$dirress.$dirsep.$dirjs.$dirsep."prototype.js";
$js_progressbar = $bkg1.$dirress.$dirsep.$dirjs.$dirsep."jsProgressBarHandler.js";

$bkgline = $bkg1."docs".$dirsepurl."img".$dirsepurl."line".$gifext;
$bkglink = $bkg1.$diradmin.$dirsepurl."index.html";

# Filter except for pagegraph script

if ($0 !~ "pagegraph" && $0 !~ "pagesend" && $0 !~ "dayrange") {

&securecgi if ($ENV{'REQUEST_METHOD'} eq "GET" && $ENV{'HTTP_REFERER'} !~ /$cgiurl/ && $0 !~ "cron-hour");

if ($ENV{'REQUEST_METHOD'} eq "GET") {

    $out_header = 0;
    $out_header = 1 if ($0 =~ /cron-hour/ && $opt_n ne '' && $opt_z ne '');

    &ReadParse;

    if ($out_header == 0) {
	print "Content-type: text/html\n\n" if ($opt_y eq ''); # if ($0 !~ /cron-w3perl/);
	if ($opt_y eq '') {
	    print "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">\n";
	    print "<HTML>\n<HEAD>\n";
            print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n";
            print "<TITLE>Running scripts $0</TITLE>\n";
	    print "<link rel=\"stylesheet\" media=\"screen\" type=\"text/css\" href=\"$cssurl\">\n";
#	    print "<link rel=\"stylesheet\" media=\"screen\" type=\"text/css\" href=\"$css_progressbar\">\n";
	    print "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$js_prototype\"></script>\n";
	    print "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$js_progressbar\"></script>\n";
	    print "<script LANGUAGE=\"Javascript\" type=\"text/javascript\">\n";
	    print "function ToggleMenu(obj) {\n";
	    print "target = document.getElementById(obj);\n";
	    print "if (target.style.display == \"none\"){\n";
	    print "target.style.display = \"inline\";\n";
	    print "} else {\n";
	    print "target.style.display = \"none\";\n";
	    print "}\n";
	    print "}\n";
	    print "</SCRIPT>\n";
	    print "</HEAD>\n";
	    print "<BODY BACKGROUND=\"$bkg\" BGCOLOR=\"#FFFFFF\" TEXT=\"#000000\" LINK=\"#0000C0\" VLINK=\"#50508F\">\n";

	    print "<FORM NAME=\"link_res\">";
#	    print "<INPUT TYPE=\"hidden\" NAME=\"ima_res_link\" VALUE=\"$bkg1$dirress$dirsep\">\n";
	    print "<INPUT TYPE=\"hidden\" NAME=\"progressbar_step\" VALUE=\"1\">\n" if ($reverse_dns == 0);
	    print "<INPUT TYPE=\"hidden\" NAME=\"progressbar_step\" VALUE=\"0.1\">\n" if ($reverse_dns == 1);
	    print "</FORM>";
	    # Adding CSS style
	    print "<style type=\"text/css\">\n";
	    print "body {\n";
	    print "background-color: #FCFCFC;\n";
	    print "color: #202020;\n";
	    print "margin: 10px;\n";
	    print "font-family: Verdana, Geneva, Arial, sans-serif;\n";
	    print "font-size: small;\n";
	    print "}\n";
	    print "ul {\n";
	    print "list-style-type: square;\n";
	    print "padding:0px 5px;\n";
	    print "}\n";
	    print ".error_exit {\n";
	    print "color: #FF0000;\n";
	    print "font-weight: bold;\n";
	    print "}\n";
	    print ".warning_msg {\n";
	    print "color: #CC6600;\n";
	    print "font-weight: bold;\n";
	    print "}\n";
	    print ".status_ok {\n";
	    print "color: #00FF00;\n";
	    print "font-weight: bold;\n";
	    print "}\n";
	    print ".launch_title {\n";
	    print "color: #108010;\n";
	    print "font-weight: bold;\n";
	    print "}\n";
	    print ".launch_title a:link {text-decoration: none; color: #108010;}\n";
	    print ".launch_title a:visited {text-decoration: none; color: #108010;}\n";
	    print ".launch_title a:active {text-decoration: none; color: #108010;}\n";
	    print ".launch_title a:hover {text-decoration: none; color: #006000;}\n";
	    print ".launch_script {\n";
	    print "color: #50C050;\n";
	    print "font-weight: bold;\n";
	    print "}\n";
	    print ".launch_main {\n";
	    print "color: #3030C0;\n";
	    print "font-weight: bold;\n";
	    print "}\n";
	
	    print "</style>\n";

	    print "<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH=\"100%\">\n";
	    print "<TR>\n";
	    print "<TD WIDTH=130 VALIGN=TOP ALIGN=CENTER>\n";
	    print "<BR><A HREF=\"$bkglink\" class=\"admin_home\">Admin&nbsp;Home</A>\n";
#	    print "<P><IMG SRC=\"$bkgline\" WIDTH=110 HEIGHT=2 ALT=\"line\">\n</TD>\n";
	    print "</TD>\n";
	    print "<TD VALIGN=TOP ALIGN=CENTER>\n";
	    print "<B>" if ($0 =~ /cron-w3perl/);
	    print "<I>Computing $0 ...</I><BR>\n";
	    print "<BR>" if ($0 =~ /cron-w3perl/);
	    print "</B>" if ($0 =~ /cron-w3perl/);
	    print "</TD>\n</TR>\n<TR>\n";
	    print "<TD WIDTH=130 VALIGN=TOP></TD>\n";
	    print "<TD ALIGN=CENTER VALIGN=TOP></TD>\n</TR>\n<TR><TD WIDTH=130></TD>\n<TD>\n";
	}
    }
}
}

if ($netgeo == 1 || $reverse_geo == 1 || $geoipcity == 1 || $geoip_free == 1 || $enable_email == 1 || $spip == 1) {
    require "check_modules.pl";
#    if ($geoip_free == 1) {
#	$GeoIP = Geo::IPfree::new();
#	$GeoIP->Faster;
#    }
}

umask(002);

$backgrd2 = $backgrd;
$backgrd3 = $backgrd;
if ($backgrd =~ /background/i) {
    $backgrd =~ s/BACKGROUND="(.*)"/BACKGROUND="\.\.$dirsep\.\.$dirsep$dirress$dirsep$1"/i if ($background !~ /^\// && $background !~ /^http/);
    $backgrd2 =~ s/BACKGROUND="(.*)"/BACKGROUND="\.\.$dirsep\.\.$dirsep\.\.$dirsep$dirress$dirsep$1"/i if ($background !~ /^\// && $background !~ /^http/);
    $backgrd3 =~ s/BACKGROUND="(.*)"/BACKGROUND="$dirress$dirsep$1"/i if ($background !~ /^\// && $background !~ /^http/);
}

#########################################################################
### Check init have been ran (cron-pages.pl or cron-w3perl -a)
#########################################################################

if (!(-f "$path$dirinc$dirsep$incgeneral") && $mode_merge == 0 && $opt_y eq '' && ($0 !~ /cron-session/ && $0 !~ /cron-url/ && $0 !~ /cron-w3perl/ && $scriptname ne "cron-pages.pl")) {
        $msg = "\nError : You should first initialize your stats using :\n";
        $msg .= "- cron-pages.pl ";
        $msg .= "-c $opt_c " if ($opt_c ne '');
        $msg .= "(main stats) \n or \n";
        $msg .= "- cron-w3perl.pl ";
        $msg .= "-c $opt_c " if ($opt_c ne '');
        $msg .= "-a (all stats)\n\n";
        &error_exit($msg,1);
}


#########################################################################
### Making symbolic links to resources (unix only)
#########################################################################

#if ($type_serveur == 0 || $ftp_format == 1 || $mail_format == 1 || $squid_format == 1) {

&MakeDirectories;

if ($type_serveur == 0) {

# Dir resources

    $newfile = $path."resources";
    $oldfile = $pathinit."resources";	
    symlink($oldfile,$newfile) if (!(-l $newfile));
    
# Dir admin
    if ($hide_resources_menu == 0) {
	$newfile = $path."docs";
	$oldfile = $pathinit."docs";
	symlink($oldfile,$newfile) if (!(-l $newfile));
	
	$newfile = $path."admin";
	$oldfile = $pathinit."admin";
	symlink($oldfile,$newfile) if (!(-l $newfile));
    }
}

#########################################################################
### Language arrays
#########################################################################

#http://www.w3schools.com/tags/ref_language_codes.asp

%LangHTML = ( "uk" , "en-uk",
	  "us" , "en-us",
	  "fr" , "fr",
	  "sp" , "es",
	  "it" , "it",
	  "jp" , "ja",
	  "fi" , "fi",
	  "de" , "de",
	  "br" , "pt",
	  "pt" , "pt",
	  "hu" , "hu",
	  "th" , "th",
	  "cn" , "zh",
	  "nl" , "nl");

%Lang = ( "uk" , "*LangUK",
	  "us" , "*LangUS",
	  "fr" , "*LangFR",
	  "sp" , "*LangSP",
	  "it" , "*LangIT",
	  "jp" , "*LangJP",
	  "fi" , "*LangFI",
	  "de" , "*LangDE",
	  "br" , "*LangBR",
	  "pt" , "*LangPT",
	  "hu" , "*LangHU",
	  "th" , "*LangTH",
	  "cn" , "*LangCN",
	  "nl" , "*LangNL");


%Help = ( "uk" , "*HelpUK",
	  "us" , "*HelpUS",
	  "fr" , "*HelpFR",
	  "sp" , "*HelpSP",
	  "it" , "*HelpIT",
	  "jp" , "*HelpJP",
	  "fi" , "*HelpFI",
	  "de" , "*HelpDE",
	  "br" , "*HelpBR",
	  "pt" , "*HelpPT",
	  "hu" , "*HelpHU",
	  "th" , "*LangTH",
	  "cn" , "*LangCN",
	  "nl" , "*HelpNL");

%LangCountries = ( "uk" , "*CountryUK",
	  "us" , "*CountryUS",
	  "fr" , "*CountryFR",
	  "sp" , "*CountrySP",
	  "it" , "*CountryIT",
	  "jp" , "*CountryJP",
	  "fi" , "*CountryFI",
	  "de" , "*CountryDE",
	  "br" , "*CountryBR",
	  "pt" , "*CountryPT",
	  "hu" , "*CountryHU",
	  "th" , "*CountryTH",
	  "cn" , "*CountryCN",
	  "nl" , "*CountryNL");


#for ($i=0;$i<=$#lang;$i++) {
#    $tmp = $dirress.$dirsepurl."lang".$dirsepurl.$lang[$i].$plext if ($dirsep eq ".");
#    $tmp = $dirress.$dirsep."lang".$dirsep.$lang[$i].$plext if ($dirsep ne ".");
#    $tmp = $pathinit.$tmp;
#    require "$tmp";
#}

for ($i=0;$i<=$#lang;$i++) {
    $tmp = $dirress.$dirsepurl."lang".$dirsepurl.$lang[$i].$plext if ($dirsep eq ".");
    $tmp = $dirress.$dirsep."lang".$dirsep.$lang[$i].$plext if ($dirsep ne ".");
    $tmp = $pathinit.$tmp;
    require "$tmp";

    $tmp = $dirress.$dirsep."lang".$dirsep."help".$dirsep.$lang[$i].$plext;
    $tmp = $pathinit.$tmp;
    require "$tmp";

    $tmp = "Help".uc($lang[$i]);
    $tmp2 = "Lang".uc($lang[$i]);
    foreach $line (keys(%$tmp)) {
	$$tmp2{$line} = $$tmp{$line};
    }

    $tmp = $dirress.$dirsep."lang".$dirsep."country".$dirsep.$lang[$i].$plext;
    $tmp = $pathinit.$tmp;
    require "$tmp";

    $tmp = "Country".uc($lang[$i]);
    $tmp2 = "Lang".uc($lang[$i]);
    foreach $line (keys(%$tmp)) {
	$$tmp2{$line} = $$tmp{$line};
    }

    if ($dhcp_format == 1) {
	$tmp = eval($Lang{$lang[$i]});
	$$tmp{'Pages'} = $$tmp{'Mac_address'};
	$$tmp{'page'} = $$tmp{'Mac_address'};
	$$tmp{'pages'} = $$tmp{'Mac_address'};
	$$tmp{'accesses'} = $$tmp{'requests'};
	$$tmp{'Different_accesses'} = $$tmp{'Unique'};
    }

    if ($ftp_format == 1) {
	$tmp = eval($Lang{$lang[$i]});
	$$tmp{'Pages'} = $$tmp{'Files'};
#	$$tmp{'Requests'} = $$tmp{'Files'};
	$$tmp{'Different_accesses'} = $$tmp{'Unique'};
    }

    if ($cups_format == 1) {
	$tmp = eval($Lang{$lang[$i]});
	$$tmp{'Requests'} = $$tmp{'Pages'};
	$$tmp{'Pages'} = $$tmp{'Files'};
#	$$tmp{'Occurence'} = $$tmp{'Pages'};
	$$tmp{'requests'} = $$tmp{'pages'};
	$$tmp{'pages'} = $$tmp{'files'};

	$$tmp{'accesses'} = $$tmp{'files'};
	$$tmp{'Accesses'} = $$tmp{'Files'};
#	$$tmp{'Page'} = $$tmp{'Files'};
#	$$tmp{'Pages'} = $$tmp{'Files'};
	$$tmp{'Different_accesses'} = $$tmp{'Files'};

    }

    if ($mail_format == 1) {
	$tmp = eval($Lang{$lang[$i]});
	$$tmp{'Pages'} = $$tmp{'Emails'};
	$$tmp{'pages'} = $$tmp{'emails'};
#	$$tmp{'Accesses'} = $$tmp{'Emails'};
	$$tmp{'Accesses'} = $$tmp{'Unique'};
#	$$tmp{'Page_read'} = $$tmp{'Emails'};
	$$tmp{'Requests'} = $$tmp{'Emails_sent'};
	$$tmp{'requests'} = $$tmp{'emails_sent'};
	$$tmp{'Only_pages'} = $$tmp{'Only_emails'};
	$$tmp{'Different_accesses'} = $$tmp{'Unique'};
    }
}


# should map alternate_1.css, alternate_2.css ...
@alternate_css_style = ('Small', 'Large','Ocean');

&LoadLocconf($locconf) if ($nb_stats_run eq '');

#################################################################
####                          date                        #######
#################################################################

@last_day_show = ('2','3','5','7','10','14','21','30','90','180','365');

@days_counter = (0,31,59,90,120,151,181,212,243,273,304,334,365);

@day_of_week = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');

%month_of_year = ('Jan','31',
                  'Feb','28',
                  'Mar','31',
                  'Apr','30',
                  'May','31',
                  'Jun','30',
                  'Jul','31',
                  'Aug','31',
                  'Sep','30',
                  'Oct','31',
                  'Nov','30',
                  'Dec','31');

@month_nb = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');

%month_equiv = ( 'Jan','01',
                 'Feb','02',
                 'Mar','03',
                 'Apr','04',
                 'May','05',
                 'Jun','06',
                 'Jul','07',
                 'Aug','08',
                 'Sep','09',
                 'Oct','10',
                 'Nov','11',
                 'Dec','12');

#$datesyst = &ctime(time);
$datesyst = POSIX::ctime(time);
($dayletter,$month,$day,$hourdate,$a,$year) = split(/[ \t\n\[]+/,$datesyst);
$year = $a if ($year eq '');
$day = "0".$day if (length($day) == 1);
$monthindex = $month_equiv{$month};
$countmonth = $month_equiv{$month};
($hour,$minute,$second) = split(/:/,$hourdate);
$today = $day."/".$month."/".$year;
$fullyear = $year;
$fyear = $fullyear - 10;
$smallyear2_today = int($year/100);
$smallyear_today = $year - $smallyear2_today*100;
$ydaytoday = &nbday($today);

if (($year%4 == 0 && $year%100 != 0) || $year%400 == 0) {
    $month_of_year{'Feb'} = "29";
    $bisextil = 1;
}

# Conversion W3C logfile entry (lowercase).

%w3c_struct_logfile = ( 'date','%date',
                        'time','%time',
			'c-ip','%host',
			'c-dns','%host',
			'cs-username','%login',
			's-sitename','%null',
			's-computername','%null',
			's-ip','%null',
			's-port','%null',
			'cs-method','%method',
			'url','%page',
			'cs-uri-stem','%page',
			'cs-uri-query','%query',
			'sc-status','%status',
			'sc-win32-status','%null',
			'sc-bytes','%requetesize',
			'cs-bytes','%null',
			'time-taken','%null',
			'cs-version','%protocol',
			'cs-host','%null',
			'cs(user-agent)','%agent',
			'cs(cookie)','%null',
			'cs(referer)','%referer',
			'sc-substatus','%null');

%FailStatusMsgs = (-1,"Could Not Look Up Server",
                   -2,"Could Not Open Socket",
                   -3,"Could Not Bind Socket",
                   -4,"Could Not Connect",
		   000,"Used mostly with UDP traffic",
		   100,"Continue",
		   101,"Switching Protocols",
		   102,"Processing",
		   200,"OK",
		   201,"Created",
		   202,"Accepted",
		   203,"Non-Authoritative Information",
		   204,"No Content",
		   205,"Reset Content",
		   206,"Partial Content",
		   207,"Multi Status",
		   300,"Multiple Choices",
                   301,"Found, But Moved Permanently",
	           302,"Found, But Data Resides Under a Different URL",
	           303,"Method",
		   304,"Not Modified",
		   305,"Use Proxy",
		   307,"Temporary Redirect",
	           400,"Bad Request",
	           401,"Unauthorized",
	           402,"Payment Required",
	           403,"Forbidden",
	           404,"Not Found",
		   405,"Method Not Allowed",
		   406,"Not Acceptable",
		   407,"Proxy Authentication Required",
		   408,"Request Timeout",
		   409,"Conflict",
		   410,"Gone",
		   411,"Length Required",
		   412,"Precondition Failed",
		   413,"Request Entity Too Large",
		   414,"Request-URI Too Long",
		   415,"Unsupported Media Type",
		   416,"Requested Range Not Satisfiable",
		   417,"Expectation Failed",
		   423,"Locked error",
		   424,"Failed Dependency",
		   433,"Unprocessable Entity",
          	   500,"Internal Server Error",
          	   501,"Not Implemented",
          	   502,"Bad Gateway",
          	   503,"Service Unavailable",
		   504,"Gateway Timeout",
		   505,"HTTP Version Not Supported",
		   507,"Insufficient Storage",
		   530,"Invalid password",
		   600,"Squid header parsing error");

#          	   600,"Bad Request",
#		   601,"Not Implemented",
#          	   602,"Connection Failed",
#          	   603,"Timed Out");

if ($mail_format == 1) {
    %FailStatusMsgs = (200,"Sent",
#		       502,"Unrouteable",
#		       503,"Deferred",
#		       504,"Bounced",
		       403,"Greylistes",
		       500,"Retry timeout exceeded",
		       501,"Mailbox unknown",
		       502,"Unrouteable address",
		       503,"Mailbox unavailable",
		       504,"Relay access denied",
		       505,"Relay not permitted",
		       506,"Relay access denied",
		       507,"Recipient address rejected",
		       508,"User suspended");
#		       509,"Spam");
}

%code_info_tcp_udp = ("TCP_HIT","A valid copy of the requested object was in the cache",
		      "TCP_MISS","The requested object was not in the cache",
		      "TCP_REFRESH_HIT","The requested object was cached but STALE. The IMS query for the object resulted in \"304 not modified\"",
		      "TCP_REF_FAIL_HIT","The requested object was cached but STALE. The IMS query failed and the stale object was delivered",
		      "TCP_REFRESH_MISS","The requested object was cached but STALE. The IMS query returned the new content",
		      "TCP_CLIENT_REFRESH_MISS", "The client issued a \"no-cache\" pragma, or analogous cache control command. Thus, the cache has to refetch the object",
		      "TCP_IMS_HIT","The client issued an IMS request for an object which was in the cache and fresh",
		      "TCP_SWAPFAIL_MISS"," The object was believed to be in the cache, but could not be accessed",
		      "TCP_NEGATIVE_HIT","Request for a negatively cached object, e.g. \"404 not found\", for which the cache believes to know that it is inaccessible",
		      "TCP_MEM_HIT","A valid copy of the requested object was in the cache and it was in memory, thus avoiding disk accesses",
		      "TCP_DENIED", "Access was denied for this request",
		      "TCP_OFFLINE_HIT","The requested object was retrieved from the cache during offline mode",
		      "UDP_HIT","A valid copy of the requested object was in the cache",
		      "UDP_MISS","The requested object is not in this cache",
		      "UDP_DENIED", "Access was denied for this request",
		      "UDP_INVALID", "An invalid request was received",
		      "UDP_MISS_NOFETCH"," During \"-Y\" startup, or during frequent failures, a cache in hit only mode will return either UDP_HIT or this code. Neighbours will thus only fetch hits",
		      "NONE","Seen with errors and cachemgr requests");


%translate_agent = ('Mozilla','Netscape',
		    'MSIE','Microsoft Internet Explorer',
		    'Gecko','Gecko',
		    'Microsoft Internet Explorer','Microsoft Internet Explorer',
		    'Chrome','Chrome',
		    'Safari','Safari',
		    'Opera','Opera',
		    'Konqueror','Konqueror',
		    'Firefox','Firefox');

@agent = ('Mozilla','MSIE','Gecko','Microsoft Internet Explorer','Chrome','Safari','Opera','Konqueror','Firefox');

%translate_os = ('Win98','Windows 98',
		 'Win98 A','Windows 98',
		 'Windows 98','Windows 98',
		 'Windows98','Windows 98',
		 'Windows.98','Windows 98',
		 'Win 9x 4.90','Windows Me',
		 'Windows ME','Windows Me',
		 'Windows XP','Windows XP',
		 'Win95','Windows 95',
		 'Windows 95','Windows 95',
		 'Win32','Windows 95',		 
		 'Win16','Windows 3.1',
		 'Win3.1','Windows 3.1',
		 'Windows 16','Windows 3.1',
		 'Windows 3.1','Windows 3.1',		 
		 'WinNT','Windows NT',
		 'Windows NT','Windows NT',
		 'Windows-NT','Windows NT',
		 'Windows_NT','Windows NT',
		 'Win2k','Windows 2000',
		 'Windows 2000','Windows 2000',
		 'Windows 2000 5.0','Windows 2000',
		 'Windows NT 5.0','Windows 2000',
		 'Windows.NT 5.0','Windows 2000',
		 'Windows NT 5.1','Windows XP',
		 'WindowsXP','Windows XP',
		 'Windows XP 5.1','Windows XP',
		 'Windows NT 5.2','Windows Server 2003',
		 'Windows 5.2','Windows Server 2003',
                 'Windows NT 5.2 x64','Windows Server 2003',
		 'Windows NT 4.0','Windows NT',
		 'Windows NT 4.1','Windows NT',
		 'WinNT4.0','Windows NT',
		 'Windows NT 6.0','Windows Vista / Windows Server 2008',
		 'Windows 6.0','Windows Vista / Windows Server 2008',
		 'Windows NT 6.1','Windows Seven',
		 'Windows 6.1','Windows Seven',
		 'Windows NT 6.2','Windows 8 / Windows Server 2012',
		 'Windows 6.2','Windows 8 / Windows Server 2012',
		 'Windows 6.3','Windows Blue',
		 'Windows CE','Windows CE',
		 'WindowsCE','Windows CE',
		 'WinCE','Windows CE',
		 'Windows Mobile','Windows Mobile',
		 'WindowsMobile','Windows Mobile',
		 'Webtv','WebTV',
		 'Macintosh','Macintosh',
		 'Mac OS','Macintosh',
		 'Macintosh PPC','Macintosh PPC MacOS X',
		 'Macintosh Intel','Macintosh Intel MacOS X',
		 'Mac_PPC','Macintosh PPC',
		 'MacPPC','Macintosh PPC',
		 'Macintosh PPC Mac OS X 10.0','Macintosh PPC MacOS X Cheetah',
		 'Macintosh PPC Mac OS X 10.1','Macintosh PPC MacOS X Puma',
		 'Macintosh PPC Mac OS X 10.2','Macintosh PPC MacOS X Jaguar',
		 'Macintosh PPC Mac OS X 10.3','Macintosh PPC MacOS X Panther',
		 'Macintosh PPC Mac OS X 10.4','Macintosh PPC MacOS X Tiger',
		 'Macintosh PPC Mac OS X 10.5','Macintosh PPC MacOS X Leopard',
		 'Macintosh PPC Mac OS X 10.6','Macintosh PPC MacOS X Snow Leopard',
		 'Macintosh PPC Mac OS X 10.7','Macintosh PPC MacOS X Lion',
		 'Macintosh PPC Mac OS X 10.8','Macintosh PPC MacOS X Mountain Lion',
		 'Macintosh Intel Mac OS X 10.0','Macintosh Intel MacOS X Cheetah',
		 'Macintosh Intel Mac OS X 10.1','Macintosh Intel MacOS X Puma',
		 'Macintosh Intel Mac OS X 10.2','Macintosh Intel MacOS X Jaguar',
		 'Macintosh Intel Mac OS X 10.3','Macintosh Intel MacOS X Panther',
		 'Macintosh Intel Mac OS X 10.4','Macintosh Intel MacOS X Tiger',
		 'Macintosh Intel Mac OS X 10.5','Macintosh Intel MacOS X Leopard',
		 'Macintosh Intel Mac OS X 10.6','Macintosh Intel MacOS X Snow Leopard',
		 'Macintosh Intel Mac OS X 10.7','Macintosh Intel MacOS X Lion',
		 'Macintosh Intel Mac OS X 10.8','Macintosh Intel MacOS X Mountain Lion',
		 'Mac_PowerPC Mac','Macintosh PPC',
		 'Mac_PowerPC','Macintosh PPC');

@os = ('Win98','Win98 A','Windows 98','Windows98','Windows.98','Win 9x 4.90','Windows ME','Windows XP','Win95','Windows 95','Win32','Win16','Win3.1','Windows 16','Windows 3.1','WinNT','Windows NT','Windows-NT','Windows_NT','Win2k','Windows 2000','Windows 2000 5.0','Windows NT 5.0','Windows.NT 5.0','Windows NT 5.1','WindowsXP','Windows XP 5.1','Windows NT 5.2','Windows 5.2','Windows NT 5.2 x64','Windows NT 4.0','Windows NT 4.1','WinNT4.0','Windows NT 6.0','Windows 6.0','Windows NT 6.1','Windows 6.1','Windows NT 6.2','Windows 6.2','Windows 6.3','Windows CE','WindowsCE','WinCE','Windows Mobile','WindowsMobile','Webtv','Macintosh','Mac OS','Macintosh PPC','Macintosh Intel','Mac_PPC','MacPPC','Macintosh PPC Mac OS X 10.0','Macintosh PPC Mac OS X 10.1','Macintosh PPC Mac OS X 10.2','Macintosh PPC Mac OS X 10.3','Macintosh PPC Mac OS X 10.4','Macintosh PPC Mac OS X 10.5','Macintosh PPC Mac OS X 10.6','Macintosh PPC Mac OS X 10.7','Macintosh PPC Mac OS X 10.8','Macintosh Intel Mac OS X 10.0','Macintosh Intel Mac OS X 10.1','Macintosh Intel Mac OS X 10.2','Macintosh Intel Mac OS X 10.3','Macintosh Intel Mac OS X 10.4','Macintosh Intel Mac OS X 10.5','Macintosh Intel Mac OS X 10.6','Macintosh Intel Mac OS X 10.7','Macintosh Intel Mac OS X 10.8','Mac_PowerPC Mac','Mac_PowerPC');

%logfile_field_type = ("%year","\\d\\d\\d\\d",
		       "%smallyear","\\d\\d",
		       "%month","\\d\\d",
		       "%smallmonth","[\\d]+",
		       "%lettermonth","\\w\\w\\w",
		       "%day","\\d\\d",
		       "%smallday","[\\d]+",
		       "%hour","\\d\\d",
		       "%min","\\d\\d",
		       "%sec","\\d\\d",
		       "%rotate","[\\d]+");


%columns_menu = ('Main','1',
		 'When','2',
		 'Optional','3',
		 'Sessions','4',
		 'Documents','5',
		 'Resources','6');

%menu_color_actif = ('index','1',
                     '/site/','1',
		     '/page/','1',
		     '/pays/','1',
		     '/city/','1',
		     '/list/download','1',
		     '/list/list-report','1',
		     '/list/rss','1',
		     '/script/','1',
		     '/list/status','1',
		     '/list/filetype','1',
		     '/list/traffic','1',
		     '/date/','2',
		     '/list/users','3',
		     '/list/spam','3',
		     '/list/error','3',
		     '/list/refer','3',
		     '/list/keyword','3',
		     '/list/agent','3',
		     '/list/heatmap','3',
		     '/list/screensize','3',
		     '/session/','4',
		     '/document/','5',
		     '/list/cpu','6');

$table_lines_aff = 25;
$table_big_lines_aff = 100;
$max_item_page = 5000 if ($max_item_page eq ''); # max number of item to display to avoid browser crash !
$display_subitem = 10 if ($display_subitem eq '');
$cloudtag_max = 28;
$cloudtag_min = 8;
$count_cloud_max = 50;
@screen_ratio = ('16/9','16/10','4/3','3/2','5/4');
$listuserscsv = "liste_users".$csvext;
$listpagescsv = "liste_pages".$csvext;
$listsitescsv = "liste_sites".$csvext;
$listspamcsv = "liste_spam".$csvext;
$listspamextcsv = "liste_spam_ext".$csvext;
$listspamloccsv = "liste_spam_loc".$csvext;

@tld_unknown = ('a1','a2','adsl','att-com','dsnet','nt','tld','gbl','tor','mexdf','lan','htwdd','pqe','iop','cnc','priv','pix','doom','euro','ads','fsu','gdljal','rain','mtyxl','set','pau');
for ($i=0;$i<=$#tld_unknown;$i++) {
    $tld_unknown .= "$tld_unknown[$i]|";
}
chop($tld_unknown);

&CreateCSSMenu(0) if (!(-f "$path$dirinc$dirsep$menuheader"));

#################################################################
####      convert IIS date format to COMMON format        #######
#################################################################

sub date_common {
    local($date1,$date2) = @_;
    local($year,$month,$day,@val);
    local($msg);

    @val = split(/[\/\.-]/,$date1);

#    if ($date_string[1] eq '' || $date_string[2] eq '' || $date_string[3] eq '') {
    if ($date_string[1] eq '' && $date_string[2] eq '' && $date_string[3] eq '') {
	$msg = "Date string seems to be empty !\n";
	$msg .= "Check \$date_format in your configuration file";
#	$msg .= " and \$date_format" if ($logfile_format eq "Mdaemon" || $logfile_format eq "IIS");
	&error_exit($msg);
    }

    ${$date_string[1]} = $val[0];
    ${$date_string[2]} = $val[1];
    ${$date_string[3]} = $val[2];

    $day = "0".$day if (length($day) == 1);

    if ($year < 100) {
 	$year = "0".$year if (length($year) == 1);
 	if ($year <= $smallyear_today) {
 	    $year = $smallyear2_today.$year;
 	} else {
 	    $year = eval($smallyear2_today-1).$year;
 	}
    }

    $tmp = $month-1;
#    $date1 = $day."/".$month_nb[--$month]."/".$year;
    $date1 = $day."/".$month_nb[$tmp]."/".$year;

    $date2 = "0".$date2 if (length($date2) == 7); # IIS patch
    $date = $date1.":".$date2;
    $date;
}

#################################################################
####                   print flag value                   #######
#################################################################

sub id {
    local($affirmation) = @_;

    print "Yes\n" if ($affirmation == 1);
    print "No\n" if ($affirmation == 0);
}

#################################################################
####            compute hour and day format               #######
#################################################################

### entree : time en seconde, sortie : date, datehour et datemisc

sub get_time {
    local($timesec) = @_;
    local($sec,$min,$hour,$day,$month,$monthnumber,$year,$wday,$yday,$isdst);
    local($date,$datehour,$datemisc);

    ($sec,$min,$hour,$day,$monthnumber,$year,$wday,$yday,$isdst) = localtime($timesec);
    $month = $month_nb[$monthnumber];
    $sec = "0".$sec if (length($sec) == 1);
    $day = "0".$day if (length($day) == 1);
    $min = "0".$min if (length($min) == 1);
    $hour = "0".$hour if (length($hour) == 1);
    $wday = $day_of_week[$wday];
    $yday++;
    $isdst++;

# $year passe a 100 en 2000 !!!

    $year = substr($year,length($year)-2,length($year));
    $year = $smallyear2_today.$year;

#$year = '19'.$year if ($year > 95);
#$year = '20'.$year if ($year < 96);

    $date = "$day/$month/$year";
    $datehour = "$hour:$min:$sec";
    $datemisc = "$yday $wday $isdst";

    return($date,$datehour,$datemisc);

}

#################################################################
####            get date from timelocal                   #######
#################################################################

sub date_squid {
    local($date) = @_;
    local($tmp1);

    $tmp1 = localtime($date);
    (@tmp) = split(/\s+/,$tmp1);
    $tmp[2] = "0".$tmp[2] if ($tmp[2] < 10);
    $date = $tmp[2].$dirsep.$tmp[1].$dirsep.$tmp[4].":".$tmp[3];

    return $date;
    
}

#################################################################
####            compute number of days                    #######
#################################################################

sub nbdayan {
    local($jour) = @_;
    local($dayjour,$monthjour,$yearjour);

    ($dayjour,$monthjour,$yearjour) = split(/[\s+\/]/,$jour);

    $monthjour = $month_equiv{$monthjour};

    $y = $days_counter[$monthjour-1]+$dayjour;
    $y++ if ($monthjour > 2 && $bisextil == 1);
    $y;
}

#################################################################
####      return number of sec from 1st Jan 1970          #######
#################################################################

sub nb_sec_deb {
    local($date) = @_;
    local($jour,$heure,$minute,$seconde,$day,$month,$year,$sec_deb);

#    print "III $date\n";

    ($jour,$heure,$minute,$seconde) = split(/:/,$date);
#    ($day,$month,$year) = split(/\//,$jour);
    ($day,$month,$year) = split(/[\s+\/\-]/,$jour);


#    print "UU $jour - $day / $month / $year\n";

#    print "$date - $jour\n";
    # Date as 2012/Aug
    if ($year eq '') {
	$year = $day;
	$day = 1;
    }

    $heure = 0 if ($heure eq '');
    $minute = 0 if ($minute eq '');
    $seconde = 0 if ($seconde eq '');
    $day = 1 if ($day eq '');
    $month = 'Jan' if ($month eq '');

    $month = $month_equiv{$month}-1;

    $sec_deb = timelocal($seconde,$minute,$heure,$day,$month,$year);
#    print "AA $sec_deb - $heure,$minute,$seconde - $day,$month,$year\n";
    return $sec_deb;
}

#################################################################
####            compute number of days from 1970          #######
#################################################################

sub nbday {
    local($jour) = @_;
    local($dayjour,$monthjour,$monthjour2,$yearjour,$y);

    if ($jour =~ /^\d{1,2}[\s+\/\-]/) {

	($dayjour,$monthjour,$yearjour) = split(/[\s+\/\-]/,$jour);

	$monthjour2 = $monthjour-1 if ($monthjour !~ /\w\w\w/);
	$monthjour2 = $month_equiv{$monthjour}-1 if ($monthjour =~ /\w\w\w/);


	if ($dayjour < 1 || $dayjour > 31 || $monthjour2 > 11) {
	    &error_exit("Problem found with date format : $jour - should be dd-mm-yyyy ($url - $adresse)") if ($monthjour !~ /\w\w\w/);
	    &error_exit("Problem found with date format : $jour - should be dd-Mmm-yyyy ($url - $adresse)") if ($monthjour =~ /\w\w\w/);
	}

	$y = timelocal(59,59,23,$dayjour,$monthjour2,$yearjour);
	$y = int($y/86400);

    } else {
	&error_exit("Problem found with date format : $jour - should be dd-mm-yyyy ($url - $adresse)") if ($monthjour !~ /\w\w\w/ && $jour ne '');
	&error_exit("Problem found with date format : $jour - should be dd-Mmm-yyyy ($url - $adresse)") if ($monthjour =~ /\w\w\w/ && $jour ne '');
	&error_exit("Problem found with date format - No input date given") if ($jour eq '');
    }

    return($y);
}

#################################################################
####            compute date with intervalle              #######
#################################################################

sub date_intervalle {
    local($jour,$intervalle) = @_;
    local($date,$dayjour,$monthjour,$yearjour,$tmp);
    local(%month_of_year_tmp);

    %month_of_year_tmp = ('Jan','31',
                  'Feb','28',
                  'Mar','31',
                  'Apr','30',
                  'May','31',
                  'Jun','30',
                  'Jul','31',
                  'Aug','31',
                  'Sep','30',
                  'Oct','31',
                  'Nov','30',
                  'Dec','31');

    ($dayjour,$monthjour,$yearjour) = split(/[\s+\-\/]/,$jour);

    $dayjour = $dayjour+$intervalle;
    $countmonth = $month_equiv{$monthjour}-1;

    $month_of_year_tmp{'Feb'} = "28"; 
    $month_of_year_tmp{'Feb'} = "29" if (($yearjour%4 == 0 && $yearjour%100 != 0) || $yearjour%400 == 0);

    while ($dayjour < 1) {
	$countmonth--;
	if ($countmonth < 0) {
	    $yearjour--;
	    $countmonth = 11;
	    $month_of_year_tmp{'Feb'} = "28"; 
	    $month_of_year_tmp{'Feb'} = "29" if (($yearjour%4 == 0 && $yearjour%100 != 0) || $yearjour%400 == 0);
	}
	$monthjour = $month_nb[$countmonth];
	$dayjour = $month_of_year_tmp{$monthjour}+$dayjour;
    }

    while ($dayjour >  $month_of_year_tmp{$monthjour}) {    
	$dayjour = $dayjour-$month_of_year_tmp{$monthjour};
	$countmonth++;
	if ($countmonth > 11) {
	    $yearjour++;
	    $countmonth = 0;
	    $month_of_year_tmp{'Feb'} = "28"; 
	    $month_of_year_tmp{'Feb'} = "29" if (($yearjour%4 == 0 && $yearjour%100 != 0) || $yearjour%400 == 0);
	}
#	$countmonth = 0 if ($countmonth > 11);
	$monthjour = $month_nb[$countmonth];
    }
    
    $dayjour = "0".$dayjour if (length($dayjour) == 1);
    
    $date = "$dayjour"."/"."$monthjour"."/"."$yearjour";
    $date =~ s/[\/]/ /g;
    return $date;

}

#################################################################
####            Lookup for DNS reverse                    #######
#################################################################

sub reversedns {
    local($adr) = @_;
    local ($a,$b,$c,$d,$tmp,$adresse);

#    if ($old_revere == 1) {
#    $adr = $revdns{$adr} if ($revdns{$adr} ne '');
#    if (($adr =~ /[0-9]+$/ || $adr =~ /:/) && $revdns{$adr} eq '') {
#	($a,$b,$c,$d) = split(/\./,$adr);
#	$tmp = pack('C4',$a,$b,$c,$d);
#	($adresse) = gethostbyaddr($tmp,2);
#	$adresse =~ s/[\<\>\"\'\;\%\(\)\&\|\+]//g;
#	$tmp = substr($adresse,rindex($adresse,'.'));
#	print "$adr - $adresse - $tmp\n";
#	$adresse = $adr if (($adresse eq '') || $adresse =~ /[0-9]$/ || (length($tmp) < 3));
#	$revdns{$adr} = $adresse;
 #  } else {
#	$adresse = $adr;
 #   }
  #  }

#    print "II $adr - $revdns{$adr}\n";


#    $tid=0;

    if ($revdns{$adr} ne '') {
	$adresse = $revdns{$adr};
    } else {

#	$tid=$MaxNbOfThread?eval("threads->self->tid()"):0;
#	print "***** Thread id $tid: MakeDNSlookup started (for $adr)\n";

	if ($adr =~ /:/) {
	    $adr =~ s/^::ffff://;
	    $tmp = pack('n8', canonical_ipv6_address($adr));
#	    $adresse = gethostbyaddr($tmp, AF_INET6());
	    $adresse = gethostbyaddr($tmp, 10);
	    # Will fail is Perl < 5.14 and log contains ipv6 addresses ?
	} else {
	    ($a,$b,$c,$d) = split(/\./,$adr);
	    $tmp = pack('C4',$a,$b,$c,$d);
	    ($adresse) = gethostbyaddr($tmp,2);
	    $adresse =~ s/[\<\>\"\'\;\%\(\)\&\|\+]//g;
	}
	$tmp = substr($adresse,rindex($adresse,'.'));
	$adresse = $adr if ($adresse eq '' || $adresse =~ /[0-9]$/ || $adresse =~ /:/ || length($tmp) < 3);
	$revdns{$adr} = $adresse;
#	print "$adr - $revdns{$adr}\n";
#	print "." if ($ENV{'REQUEST_METHOD'} eq "GET" && ($0 !~ /cron-hour/ && $opt_n eq ''));
#	print "***** Thread id $tid: MakeDNSlookup done ($adr resolved into $adresse)\n";
#	delete $threadarray{$adr};
#	print "**** $adr deleted from threadarray\n";
    }

#    $aa = scalar(keys(%threadarray));
#    print "RESOLV $adr->$adresse - $aa\n";
    return($adresse);

}

sub canonical_ipv6_address {
    my @a = split /:/, shift;
    my @b = qw(0 0 0 0 0 0 0 0);
    my $i = 0;
    # comparison is numeric, so we use hex function
    while (defined $a[0] and $a[0] ne '') {$b[$i++] = hex(shift @a);}
    @a = reverse @a;
    $i = 7;
    while (defined $a[0] and $a[0] ne '') {$b[$i--] = hex(shift @a);}
    @b;
}


#struct hostent *he;
#struct in_addr ipv4addr;
#struct in6_addr ipv6addr;

#inet_pton(AF_INET, "192.0.2.34", &ipv4addr);
#he = gethostbyaddr(&ipv4addr, sizeof ipv4addr, AF_INET);
#printf("Host name: %s\n", he->h_name);

#inet_pton(AF_INET6, "2001:db8:63b3:1::beef", &ipv6addr);
#he = gethostbyaddr(&ipv6addr, sizeof ipv6addr, AF_INET6);
#printf("Host name: %s\n", he->h_name);
#getaddrinfogetnameinfo getaddrinfo perl 5.14 !

#################################################################
####                   GeoIP reverse (Geo::IP)            #######
#################################################################

#http://search.cpan.org/~borisz/Geo-IP-1.38/
sub get_geoip {
    local($adr) = @_;
    local ($pays);

#    if ($adr =~ /[0-9]+$/) {
#    my $pays = Geo::IP->new(GEOIP_MEMORY_CACHE|GEOIP_CHECK_CACHE); # GEOIP_STANDARD
    if ($adr =~ /[0-9]+$/ || $adr =~ /:/) {
	return $geoip_pays->country_code_by_addr($adr) if ($adr =~ /[0-9]+$/);
	return $geoipv6_pays->country_code_by_addr_v6($adr) if ($geoipv6_file ne '' && $adr =~ /:/);
    } else {
	return $geoip_pays->country_code_by_name($adr);
    }
#    }
}

sub init_geoip {
    $geoip_pays = Geo::IP->new(GEOIP_MEMORY_CACHE); # GEOIP_STANDARD
#    if ($geoipv6_file ne '') {

        # No need with Perl 5.14
#	if (int($]) < 13) {
#	    eval("use Socket6");
#	    if ($@) {
#		$geoipv6_file = "";
#		&error_exit("Error, Socket6 Perl module not found. IPv6 addresses cannot be mapped to country code\n",2);
#	    } else {
#		require Socket6;
#	    }
#	}
	if (-f $geoipv6_file) {
	    $geoipv6_pays = Geo::IP->open($geoipv6_file);
	    if ($geoipv6_pays->api ne 'CAPI') {
		&error_exit("Error, IPv6 support is currently only available if you use the CAPI from GeoIP C API\n");
	    }
	} else {
	    &error_exit("Error, Ipv6 database \$geoipv6_file not found\n") if ($geoipv6_file ne '');
	}

#    }
}

sub init_geoipcity {
    local($file) = @_;
    &error_exit("Error, $file should be first uncompressed.\nAlso dont forget to remove $zipext in the filename in your configuration file") if ($file =~ /$zipext$/);
    $geoipcity_maxmind = Geo::IP->open($file, GEOIP_MEMORY_CACHE);
#    $geoipcity_maxmind = Geo::IP->open($file, GEOIP_MEMORY_CACHE) if ($file !~ /$zipext$/);
#    $geoipcity_maxmind = Geo::IP->open("$GZIP $file |", GEOIP_MEMORY_CACHE) if ($file =~ /$zipext$/);
}

sub get_geoipcity {
    local($adr) = @_;
    local($city,$region_name,$city_country,$longitude,$latitude);

    $r = $geoipcity_maxmind->record_by_name($adr);
    if ($r) {
	$city = $r->city;
	$city_country = $r->country_code;
	$region_name = $r->region_name;
	$latitude = $r->latitude;
	$longitude = $r->longitude;
    }
    return ($city,$region_name,$city_country,$longitude,$latitude);
#    print $record->country_code,$record->country_code3,$record->country_name,$record->region,$record->region_name,$record->city,$record->postal_code,$record->latitude,$record->longitude;
}

#################################################################
####                   GeoIP reverse (Geo::IPfree)        #######
#################################################################

sub init_geoipfree {
    $GeoIP = Geo::IPfree->new(); ## Using the default DB!
    $GeoIP->Faster;
}

sub get_geoipfree {
    local($adr) = @_;
    local ($pays);

    ($pays) = $GeoIP->LookUp($adr) if ($adr !~ /:/);
#    print "LLL $adr - $pays\n";
    
#    if ($adr =~ /[0-9]+$/ || $adr =~ /:/) {
#	($pays) = $GeoIP->LookUp($adr) ;
#    } else {
#	($pays) = $GeoIP->LookUp($adr);
#   }

    return $pays;
}

#################################################################
####            Loading cities mapping                    #######
#################################################################
#      $pourcentage = (($val*1000)/$city_hit{"$pays:$adresse"})/10;
sub load_city_map {
    local($adr);

    open(CITY,"$path$dirinc$dirsep$filecity") || &error_exit("Error, unable to open $path$dirinc$dirsep$filecity");
    while (<CITY>) {
	chop;
	$tmp = ($city,$longitude,$latitude,$region_name,$nbcity,$city_hit,$city_access,$city_size,$city_spam) = split(/\t/);
#	if ($tmp == 5) { # Country
	if ($tmp == 5 || $tmp == 6) { # Country
	    $tmpcity = "country_city_".$city;
	    $tmpregion = "country_region_".$city;
	    $pays = $city;
	    $payslistcity{$city} = $longitude;
	    $payshtmlcity{$city} = $latitude;
	    $serverpayscity{$city} = $region_name;
	    $sizepayscity{$city} = $nbcity;
	    $spam_citypays{$city} = $city_hit;
	}
	if ($tmp >= 8) { # Cities for each country
	    $city_ext = "$pays:$city";

	    $$tmpcity{$city} = $nbcity;
	    $city_region{$city_ext} = $region_name;
	    $longitude{$city_ext} = $longitude;
	    $latitude{$city_ext} = $latitude;
	    $found_city{$pays} = 1;
	    push(@worldmap,$longitude);
	    push(@worldmap,$latitude);
	    push(@worldmap,$city_ext);
	    
	    $city_hit{$city_ext} = $city_hit;
	    $city_access{$city_ext} = $city_access;
	    $city_size{$city_ext} = $city_size;
	    $spam_city{$city_ext} = $city_spam;
	    $$tmpregion{$region_name} += $nbcity;
	    $count = 0;
	    $ville = $city;
	    $ville_ext = $city_ext;
	}
	if ($tmp == 1) { # Hosts for each city
	    $count++;
	    $adresse = $city;
	    $revcity{$adresse} = $ville;
	    $city_idx{$adresse} = $count;
	    $city_hosts{$ville_ext,$count} = $adresse;
	    $city_pays{$adresse} = $pays;
#	    print "$adresse - $revcity{$adresse} - $pays\n"; # if ($pays eq '');pldt.net
	}
    }
    close CITY;
}

sub load_unresolved_city  {
    local($adr,$tmp);
    
    $tmp = $unresolved;
    $tmp =~ s/$htmlext$//;
    open(CITY,"$path$dirinc$dirsep$filecity$tmp") || &error_exit("Error, unable to open $path$dirinc$dirsep$filecity$tmp");
    undef(@city_unresolved);
    while (<CITY>) {
	chop;
	$adr = $_;
#	($adr) = split(/\t/);
	push(@city_unresolved,$adr);
	$revcity2{$adr} = "Unknown";
    }
}


sub reload_city_map {
    local($mode) = @_;
    local($adr);

    open(CITY,"$path$dirinc$dirsep$filecity") || &error_exit("Error, unable to open $path$dirinc$dirsep$filecity");
    while (<CITY>) {
	chop;
	$tmp = ($city,$longitude,$latitude,$region_name,$nbcity,$city_hit,$city_access,$city_size) = split(/\t/);
	if ($tmp == 5 || $tmp == 6) { # Country
	    $pays = $city;
	    $tmpcity = "country_city_".$city;
#	    $payslistcity{$city} = $longitude;
#	    print "A $pays - $tmpcity\n";
	}
	if ($tmp >= 8) { # Cities for each country
	    $city_ext = "$pays:$city";
#	    $$tmpcity{$city} = $nbcity;
	    $city_region{$city_ext} = $region_name;
	    $longitude{$city_ext} = $longitude;
	    $latitude{$city_ext} = $latitude;
	    $count = 0;
	    $ville = $city;
	    $ville_ext = $city_ext;
#	    print "B - $city_ext\n";
	}
	if ($tmp == 1) { # Hosts for each city
#	    $$tmp_city{$city}++;
#	    $count = $$tmp_city{$city};
	    $count++;
	    $adresse = $city;
	    $city_pays{$city} = $pays;
	    $revcity{$city} = $ville if ($mode == 1);
	    $city_hosts{$ville_ext,$count} = $adresse;
#	    print "UU $city - $revcity{$city} - $pays\n";

	}
    }
    close CITY;
}

#################################################################
####            Loading file extension                    #######
#################################################################

sub load_resolv_users {
    local($tmp,$tmp1,$tmp2,$tmp3,$tmp4,$tmp5);

    open(USER_FILE,"$resolv_users_file");
    while (<USER_FILE>) {
	next if ($_ =~ /^#/);
	chop;
	next if ($_ eq '');
	if (($_ !~ /^\".*\"/) || ($_ !~ /\"[;,]\"/)) {
	    &error_exit("Error, $resolv_users_file is not a CSV file\nSee /w3perl/resources/resolv_users.csv as an example");
	}
	($tmp,$tmp1,$tmp2,$tmp3,$tmp4,$tmp5) = split(/[;,]/);
	$tmp =~ s/\"//g;
	$tmp1 =~ s/\"//g;
	$tmp2 =~ s/\"//g;
	$tmp3 =~ s/\"//g;
	$tmp3 =~ tr/[A-Z]/[a-z]/;
	$tmp3 = $tmp3.".".$localdomainename if ($tmp3 ne '' && $tmp3 !~ /$localdomainename$/ && $localdomainename ne "localhost");
	$tmp4 =~ s/\"//g;
	$tmp5 =~ s/\"//g;
	$resolv_user{$tmp3} = "$tmp $tmp1" if ($tmp3 ne '');
	$resolv_user{$tmp5} = "$tmp $tmp1" if ($tmp5 ne '' && $tmp3 eq '');
	$user_login{$tmp4} = "$tmp $tmp1" if ($tmp4 ne '');
	if ($tmp2 ne '') {
	    $revdns{$tmp2} = $tmp3 if ($tmp3 ne '');
	    $revdns{$tmp2} = $tmp2 if ($tmp3 eq '');
	}
#	if ($tmp5 ne '') {
#	    $revmacdns{$tmp5} = $tmp3 if ($tmp3 ne '');
#	    $revmacdns{$tmp5} = $tmp5 if ($tmp3 eq '');
#	}
    }
    close(USER_FILE);
#    $reverse_resolv = 1;
}

#################################################################
####            Loading file extension                    #######
#################################################################

sub load_fileext {
    local($tmp,$tmp1,$zone,$nb);

    open(EXTCONV,"$pathinit$dirress$dirsep$extconv") || &error_exit("Error, unable to open $pathinit$dirress$dirsep$extconv");
    while (<EXTCONV>) {
	chop;
	$nb = ($tmp,$tmp1) = split(/\s+\(/);
#	if ($tmp1 eq '') {
	if ($nb == 1) {
	    ($tmp,$tmp1) = split(/\s+/,$tmp);
	    $zonefile[$tmp1] = $tmp;
	    $nbzonefile++;
	} else {
	    ($tmp1,$zone) = split(/\)\s+/,$tmp1);
	    $tmp1 =~ s/\./$carext/;
	    $extfile{$tmp1} = $tmp;
	    $extfilenb{$tmp1} = $zone;
	}
    }
    close(EXTCONV);
}

#################################################################
####            Loading countries mapping                 #######
#################################################################

sub load_countries_map {
    local($tmp,$newpays,$zone,$pays,$nb);

    open(PAYSCONV,"$pathinit$dirress$dirsep$paysconv") || &error_exit("Error, unable to open $pathinit$dirress$dirsep$paysconv");
	
    while (<PAYSCONV>) {
	chop;
	$nb = ($newpays,$pays,$zone)=split(/\s+/);  # format 'France (.fr)'
#	if ($zone eq '') {
	if ($nb == 2) {
	    $zone[$pays] = $newpays;
	    $nbzone++;
	} else {
	    $pays =~ s/\(\.(.*)\)/$1/;
	    $newflag{$pays} = $newpays;
	    $flagpage{$pays} = $newflag{$pays};
	    $flagpage{$pays} .= $htmlext;
	    $zonepays{$pays} = $zone; 
	}
#	$country_generic .= "\.$pays$|" if ($zone == 9);
#	$country_generic .= "\.$pays\$|" if ($zone == 9);
	$country_generic .= "$pays\$|" if ($zone == 9);
    }
    $newflag{Unknown} = "Unknown";
    $flagpage{Unknown} = $unresolved;
    chop($country_generic);
    close (PAYSCONV);
}

#################################################################
####            Loading countries mapping                 #######
#################################################################

sub load_url_map {
    local($url,$title,$fileurl2);
    local($dirlogs);

    return if ($ftp_format == 1 || $squid_format == 1 || $mail_format == 1);
    return if ($cups_format == 1 && !(-f "$path$dirdata$dirsep$fileurl"));

    $dirlogs = "logs";

    if (-f "$path$dirdata$dirsep$fileurl") {
	open(URL,"$path$dirdata$dirsep$fileurl");
    } elsif (-f "$pathinit$dirlogs$dirsep$fileurl") {
	open(URL,"$pathinit$dirlogs$dirsep$fileurl");
    } else {
	$fileurl2 = $fileurl;
	$fileurl2 =~ s/$txtext//;
	if (-f $fileurl2) {
	    &error_exit("Your file $path$dirdata$dirsep$fileurl2 is too old\nRun back the cron-url.pl script or rename this file to $fileurl\n");
	} else {
	    &error_exit("Cannot open $path$dirdata$dirsep$fileurl\nMake sure cron-url.pl script have been launch first or unset \$titlename in your config file");
	}
    }
    while (<URL>) {
        ($url,$title) = split(/\"/);
	next if ($url =~ /^\#\#\#/);
        chop($url);
        $urlconv{$url} = $title;
#	print "I $url\n";
    }
    close(URL);
}

#################################################################
####                Loading DNS table                     #######
#################################################################

sub load_reverse_dns {
	local($ipdata,$tmp);

	if (-f "$path$dirdata$dirsep$ip_table") {
	    print "Loading DNS table\n" if ($opt_n eq '' && $ENV{'REQUEST_METHOD'} ne "GET");
	    print "<BR>" if ($opt_n eq '' && $ENV{'REQUEST_METHOD'} eq "GET");

	    open(IP,"$path$dirdata$dirsep$ip_table"); # || &error_exit("Cannot open $path$dirdata$dirsep$ip_table");
	    while (<IP>) {
		chop;
		($ipdata,$tmp) = split(/\t/);
		$revdns{$ipdata} = $tmp;
	    }
	    close(IP);
	} else {
	    print "Reverse dns cache file $path$dirdata$dirsep$ip_table not found\n";
#	    $reverse_dns = 0;
	}
}


$debug2 = 0;
$tabline = "vertfonce.gif";
$point = "transparent.png";

sub row_end_new {
    local(*FOUT,*L,$temp,$value,$racine,$oldvalue,$coi,$script) = @_;
    local($boucle2,$affrac,$it,$loop,$z,$val,$tmp,$k);

    $boucle2 = $rowboucle{$temp,$racine,$coi};

    $coi++;

    for ($it=1;$it<=$boucle2;$it++) {

        $affrac = $racine;

	$affrac = &clean_url($affrac,0);
#	$affrac =~ s/\+/\\+/g; # /C++/
#	$affrac =~ s/\)/\\)/g;
#        $affrac =~ s/\(/\\(/g;
#	$affrac =~ s/[\[\]]//g; # remove []
#        $affrac =~ s/\*/\\*/g;

#	for ($loop=$coi;$loop<=($maxdepth-$depthinit);$loop++) {
	for ($loop=$coi;$loop<=$maxdepth;$loop++) {

	    $match = 0;
	    $match2 = 0;
	    if ($racine ne '') {

		for ($z=1;$z<=$maxrowspan;$z++) {
#		    print "P - $z - $affrac - $depthrac{$temp,$z,$loop} - $depthrac{$temp,8,$loop}\n" if ($temp =~ /fun/ && $loop == 3);
		    if ($depthrac{$temp,$z,$loop} =~ m/$affrac/) {
			$affrac = $depthrac{$temp,$z,$loop};

			$affrac = &clean_url($affrac,0);
#			$affrac =~ s/\+/\\+/g; # /C++/
#			$affrac =~ s/\)/\\)/g;
#		        $affrac =~ s/\(/\\(/g;
#			$affrac =~ s/[\[\]]//g; # remove []
#	         	$affrac =~ s/\*/\\*/g;
			$match = 1;
			last;
		    }
		}
	    }
	    
	    $val = $rowspan{$temp,$z,$loop};
	    $val = 0 if ($match == 0);

	    $temp2 = $affrac;
	    $pos2 = rindex($temp2,$dirsepurl,length($temp2)-2);
	    $remind = substr($temp2,$pos2,length($temp2));

	    if ($val != 0) {
		$temp2 = $affrac;
		$temp2 =~ s/$remind//;
#	    $pos2 = rindex($temp2,$dirsepurl,length($temp2));
		$remind_prev = substr($temp2,0,length($temp2));
		$remind_prev .= $dirsepurl;
		$line_affrac{$remind_prev}++;
	    }

	    $loop2 = $loop+1;
	    for ($z2=1;$z2<=$maxrowspan;$z2++) {
		$zizi = index($depthrac{$temp,$z2,$loop2},$affrac);
		if ($zizi == 0) {
		    $match2 = 1;
		    last;
		}
	    }


	    for ($k=1;$k<$span{$it,$loop};$k++) {
		&add_extra_cell(0);
	    }


	    $cell = $val;
	    $cell = 0 if ($match2_old != 0 && $val_old == 1);
	    &add_extra_cell($cell);
#	    $line_affrac{$affrac} = 1;

	    $z3 = $it+1;
	    $span{$z3,$loop2} = 0;
	    $span{$z3,$loop2} = 2 if ($val != 1 && $val != 0);

	    print FOUT "<TD WIDTH=10";
	    print FOUT " ALIGN=LEFT VALIGN=MIDDLE";
	    print FOUT " ROWSPAN=$val" if ($val != 1 && $val !=0);
	    print FOUT ">";
	    print FOUT "A1&nbsp$remind_prev&nbsp;-&nbsp;$val&nbsp;-&nbsp;$z&nbsp;-&nbsp;$z3/$loop2&nbsp;$span{$z3,$loop2}" if ($debug2 == 1);
	    print FOUT "<IMG WIDTH=\"10\" HEIGHT=\"1\" SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$tabline\" ALT=\"$tabline\">" if ($val != 0);
#	    print FOUT "<IMG SRC="..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$" if ($val != 0);
#	    print FOUT "-!- $zozo | $remind - $depthrac{$temp,$z,$loop} - $affrac - $temp,$z,$loop - $match2" if ($val != 0);
#	    print FOUT "$depthrac{$temp,$z,$loop} - $affrac - $temp,$z,$loop - $match2";
	    print FOUT "</TD>\n";
	    print FOUT "<TD";
#	    print FOUT " CLASS=\"bordure\"" if ($val != 0);
	    print FOUT " ALIGN=CENTER VALIGN=MIDDLE";
	    print FOUT " ROWSPAN=$val" if ($val != 1 && $val !=0);
	    print FOUT ">";
	    print FOUT "&nbsp;" if ($val == 0);

	    if ($val != 0) {
		$freqracdepth{$affrac} = 0 if ($freqracdepth{$affrac} eq '');
		$freqrac{$affrac} = 0 if ($freqrac{$affrac} eq '' && $script == 2);
		$freqracurl{$affrac} = 0 if ($freqracurl{$affrac} eq '' && $script == 1);
		$frequpdate{$affrac} = 0 if ($frequpdate{$affrac} eq '');
		
		if ($freqracurl{$affrac} != 0 && $script == 1) { 
		    $tmp = $affrac;
		    chop($tmp);
		    $tmp =~ s/\//_/g if (length($tmp) < 249);
		    $tmp = substr($tmp,1,length($tmp));
		    $tmp = $tmp.$htmlext;
		}

		if ($script == 1) {
		    $tmp2 = 0;
		    $aff = 0;
		    for ($l=1;$l<=$count{$affrac};$l++) {
			$page = $newpageslues{$affrac,$l};
			$tmp2 += $pageslues{$page};
			$aff = 1 if ($pageslues{$page} > $seuilpage);
		    }
		}

		print FOUT "\n\n<DIV CLASS=\"curly\" STYLE='background: #C0FAC0; margin: 10px;padding : 5pt;'>\n";
		print FOUT "<TABLE WIDTH=\"100%\">\n<TR>\n";
		print FOUT "<TD ALIGN=CENTER CLASS=\"head\">\n";
		if ($script == 1) {
		    print FOUT "<A HREF=\"$tmp\">" if ($tmp2 > $seuilpage && $aff == 1);
		    print FOUT "$remind";
		    print FOUT "</A>" if ($tmp2 > $seuilpage && $aff == 1);
		} else {
		    print FOUT "$remind";
#		    print FOUT "$depthrac{$temp,$z,$loop} - $affrac - $remind - $racine - $loop / $maxdepth - $it / $boucle2";

		}

		if ($script == 1) {
		    if ($freqracurl{$affrac} != 0) {
			print FOUT "</TD>\n</TR>\n<TR>\n<TD ALIGN=CENTER>\n";
			print FOUT "<TABLE>\n";
			if ($freqrachtml{$affrac} != $tmp2) {
			    $tmp3 = int(100*$freqrachtml{$affrac}/$access) if ($access != 0);
			    $tmp3 = 0 if ($access == 0);
			    print FOUT "<TR CLASS=\"row2\">";
			    print FOUT "<TD>$freqrachtml{$affrac}</TD>\n";
			    print FOUT "<TD>($tmp3&nbsp;%)</TD>\n</TR>\n";
			}
			$tmp3 = int(100*$tmp2/$access) if ($access != 0);
			$tmp3 = 0 if ($access == 0);
			print FOUT "<TR CLASS=\"row2\">\n<TD>$tmp2</TD>\n";
			print FOUT "<TD>($tmp3&nbsp;%)</TD>\n</TR>\n</TABLE>\n";
		    }
		    print FOUT "</TD>\n</TR>\n</TABLE>\n";
		    print FOUT "</DIV>\n\n";
		}
		
		if ($script == 2) {
		    print FOUT "</TD>\n</TR>\n<TR>\n<TD ALIGN=CENTER>\n";
		    print FOUT "<TABLE>\n<TR CLASS=\"row2\">\n";
		    print FOUT "<TD>$freqracdepth{$affrac}</TD>\n";
		    print FOUT "<TD>$freqrachtml{$affrac}</TD>\n";
		    print FOUT "<TD>$frequpdate{$affrac}</TD>\n</TR>\n";
		    print FOUT "</TABLE>\n";
		    print FOUT "</TD>\n</TR>\n";
		    print FOUT "</TABLE>\n";
		    print FOUT "</DIV>\n\n";
		}
	    }

	    print FOUT "</TD>\n";

	    $depthrac{$temp,$z,$loop} = '' if ($match == 1);
	    $match2_old = $match2;
	    $val_old = $val;

	    print FOUT "<TD WIDTH=10";
	    print FOUT " ALIGN=RIGHT VALIGN=MIDDLE";
	    print FOUT " ROWSPAN=$val" if ($val != 1 && $val != 0);
	    print FOUT ">";
	    print FOUT "A2-$affrac-$line_affrac{$affrac}" if ($debug2 == 1);
	    print FOUT "<IMG WIDTH=\"10\" HEIGHT=\"1\" SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$tabline\" ALT=\"$tabline\">" if ($match2 != 0);
	    print FOUT "</TD>\n";

	    if ($val != 1 && $val !=0) {
		&row_end_new(*FOUT,*L,$temp,$val,$affrac,$val,$coi,$script);
		$loop = $maxdepth;
		$boucle2 =$rowboucle{$temp,$racine,$coi-1};
	    }
	    
        }
	if ($it != $boucle2) {
	    print FOUT "</TR>\n\n<TR>\n";
	}
	
    }
    $i = $maxdepth;
}

###












###

sub ComputeTreeNew {
    local(*FOUT,$script) = @_;
#	local($tmp,$tmp2);

    print FOUT "<TR>\n";

    for ($j=1;$j<=$depth{2};$j++) {
	$temp = $line{$j};
	$boucle = 1;
	if ($j != 1) {
	    $tmp = ($maxdepth*4)-2;
	    print FOUT "<TR><TD COLSPAN=\"$tmp\">&nbsp;</TD></TR>\n";
	    print FOUT "<TR><TD COLSPAN=\"$tmp\" CLASS=\"traith\"></TD></TR>\n";
	    print FOUT "<TR><TD COLSPAN=\"$tmp\">&nbsp;</TD></TR>\n";
	    print FOUT "<TR>\n";
	}

	for ($i=2;$i<=($maxdepth-$depthinit);$i++) {
	    
	    $boucle += $depthocc{$temp,$i}-1;
	    
	    for ($k=1;$k<=$boucle;$k++) {
		    
		$racine = $depthrac{$temp,$k,$i};
		$value = $rowspan{$temp,$k,$i};

		&add_extra_cell($value) if ($i != 2);

		print FOUT "<TD WIDTH=10";
		print FOUT " ALIGN=LEFT VALIGN=MIDDLE";
		print FOUT " ROWSPAN=$value" if ($value != 1 && $value != 0);
		print FOUT ">";
#		print FOUT "B1" if ($debug2 == 1);
		print FOUT "<IMG WIDTH=\"10\" HEIGHT=\"1\" SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$tabline\" ALT=\"$tabline\">" if ($i != 2 && $racine ne '');
#		print FOUT "---" if ($i != 2 && $racine ne '');
		print FOUT "</TD>\n";
		print FOUT "<TD";
		print FOUT " ALIGN=CENTER VALIGN=MIDDLE";
		print FOUT " ROWSPAN=$value" if ($value != 1 && $value != 0);
		print FOUT ">";
		print FOUT "&nbsp;" if ($value == 0);
		
		if ($value != 0) {
		    $temp2 = $racine;
		    $pos2 = rindex($temp2,$dirsepurl,length($temp2)-2);
		    $remind = substr($temp2,$pos2,length($temp2));
		    
		    $freqracdepth{$racine} = 0 if ($freqracdepth{$racine} eq '');
		    $freqracurl{$racine} = 0 if ($freqracurl{$racine} eq '');
	    
		    $tmp2 = 0;
		    $aff = 0;
		    for ($l=1;$l<=$count{$racine};$l++) {
			$page = $newpageslues{$racine,$l};
			$tmp2 += $pageslues{$page};
			$aff = 1 if ($pageslues{$page} > $seuilpage);
		    }
		    
		    print FOUT "\n\n<DIV CLASS=\"curly\" STYLE='background: #CACACA; margin: 10px;padding : 5pt;'>\n";
		    print FOUT "<TABLE BORDER=0 WIDTH=\"100%\">";
		    print FOUT "<TR>\n<TD CLASS=\"head\">";
		    if ($tmp2 > $seuilpage && $aff == 1) {
			$tmp = $racine;
			chop($tmp);
			$tmp =~ s/\//_/g if (length($tmp) < 249);
			$tmp = substr($tmp,1,length($tmp));
			$tmp = $tmp.$htmlext;
			$tmp = "index_".$htmlext if ($tmp eq $filepages);			    
			print FOUT "<A HREF=\"$tmp\">";
		    }
			
		    print FOUT "$remind";
		    print FOUT "</A>" if ($tmp2 > $seuilpage && $aff == 1);
			
		    print FOUT "</TD>\n</TR>\n";

		    if ($script == 2) {
			$freqracdepth{$racine} = 0 if ($freqracdepth{$racine} eq '');
			$freqrac{$racine} = 0 if ($freqrac{$racine} eq '');
			$frequpdate{$racine} = 0 if ($frequpdate{$racine} eq '');
		    
			print FOUT "<TR>\n<TD VALIGN=MIDDLE ALIGN=CENTER>\n";
			print FOUT "<TABLE WIDTH=\"100%\">\n<TR CLASS=\"row1\">\n";
			print FOUT "<TD>$freqracdepth{$racine}</TD>\n";
			print FOUT "<TD>$freqrachtml{$racine}</TD>\n";
			print FOUT "<TD>$frequpdate{$racine}</TD>\n</TR>\n";
			print FOUT "</TABLE>\n";
			print FOUT "</TD>\n</TR>\n";
		    }

		    if ($freqracurl{$racine} != 0 && $script == 1) {
			print FOUT "<TR>\n<TD VALIGN=MIDDLE ALIGN=CENTER>\n";
			print FOUT "<TABLE WIDTH=\"100%\">\n<TR CLASS=\"row1\">\n";
			if ($freqrachtml{$racine} != $tmp2) {
			    $tmp3 = int(100*$freqrachtml{$racine}/$access) if ($access != 0);
			    $tmp3 = 0 if ($access == 0);
			    print FOUT "<TD>$freqrachtml{$racine}</TD>\n";
			    print FOUT "<TD>($tmp3&nbsp;%)</TD>\n</TR>\n";
			}
			$tmp3 = int(100*$tmp2/$access) if ($access != 0);
			$tmp3 = 0 if ($access == 0);
			print FOUT "<TR CLASS=\"row1\">\n<TD>$tmp2</TD>\n";
			print FOUT "<TD>($tmp3&nbsp;%)</TD>\n</TR>\n";
			print FOUT "</TABLE>\n";
			print FOUT "</TD>\n</TR>\n";
		    }

		    print FOUT "</TABLE>\n";
		    print FOUT "</DIV>\n\n";
		    
		}
		
		print FOUT "</TD>\n";

		print FOUT "<TD WIDTH=10";
		print FOUT " ALIGN=RIGHT VALIGN=MIDDLE";
		print FOUT " ROWSPAN=$value" if ($value != 1 && $value != 0);
		$tmp9 = $i+1;
		print FOUT ">";
#		print FOUT "B2" if ($debug2 == 1);
#		print FOUT "---" if ($depthrac{$temp,$k,$tmp9} ne '');
		print FOUT "<IMG WIDTH=\"10\" HEIGHT=\"1\" SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$tabline\" ALT=\"$tabline\">" if ($depthrac{$temp,$k,$tmp9} ne '');
		print FOUT "</TD>\n";

		if ($value != 1 && $value != 0) {
		    &row_end_new(*FOUT,*L,$temp,$value,$racine,$value,$i,$script);
		}
	    }
	}
	
	print FOUT "</TR>\n\n";
    }
}



sub add_extra_cell {
    local($val) = @_;

    if ($val == 1) {
#    if ($val > 0) {
	print FOUT "<TD WIDTH=1 ALIGN=CENTER HEIGHT=\"100%\">\n\n";
	print FOUT "C1&nbsp;-&nbsp;$val&nbsp;-&nbsp;$line_affrac{$remind_prev}" if ($debug2 == 1);
	print FOUT "<TABLE BORDER=1 HEIGHT=\"100%\" CELLPADDING=0 CELLSPACING=0>\n";
	print FOUT "<TR>\n";
	print FOUT "<TD HEIGHT=\"50%\"";
	print FOUT "CLASS=\"traitv\"" if ($line_affrac{$remind_prev} == 2);
	print FOUT ">\n";
	print FOUT "<IMG WIDTH=\"1\" HEIGHT=\"100%\" SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$point\" ALT=\"$point\">";
	print FOUT "</TD>\n";
	print FOUT "</TR>\n";
	print FOUT "<TR>\n";
	print FOUT "<TD HEIGHT=\"50%\"";
	print FOUT "CLASS=\"traitv\"" if ($line_affrac{$remind_prev} == 1);
	print FOUT ">\n";
	print FOUT "<IMG WIDTH=\"1\" HEIGHT=\"100%\" SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$point\" ALT=\"$point\">";
	print FOUT "</TD>\n";
	print FOUT "</TR>\n";
	print FOUT "</TABLE>\n\n";
	print FOUT "</TD>\n";
    }

   if ($val > 1 || $val == 0) {
#    if ($val == 0) {
	print FOUT "<TD ALIGN=CENTER>";
	print FOUT "C2&nbsp;-&nbsp;$val&nbsp;-&nbsp;$k" if ($debug2 == 1);
	print FOUT "</TD>\n";
    }
    

}



#################################################################
####                Saving DNS table                      #######
#################################################################

sub save_reverse_dns {
	local($ipdata);
	
	open(IP,">$path$dirdata$dirsep$ip_table");
	foreach $ipdata (keys(%revdns)) {
		print IP "$ipdata\t$revdns{$ipdata}\n";
		}
	close(IP);
}


#################################################################
####         subroutine to compute the tree                 #####
#################################################################

sub row_end {
    local(*FOUT,*L,$temp,$value,$racine,$oldvalue,$coi,$script) = @_;
    local($boucle2,$affrac,$it,$loop,$z,$val,$tmp,$tmp6);

    $boucle2 = $rowboucle{$temp,$racine,$coi};

    $coi++;

    for ($it=1;$it<=$boucle2;$it++) {

        $affrac = $racine;
#	print "1 - $affrac\n" if ($affrac =~ /entertainment\//);
	$affrac = &clean_url($affrac,0);
#	print "2 - $affrac\n" if ($affrac =~ /entertainment\//);
#	$affrac =~ s/\+/\\+/g; # /C++/
#	$affrac =~ s/\)/\\)/g;
#        $affrac =~ s/\(/\\(/g;
#	$affrac =~ s/[\[\]]//g; # remove []
#        $affrac =~ s/\*/\\*/g;

#	for ($loop=$coi;$loop<=($maxdepth-$depthinit);$loop++) {
	for ($loop=$coi;$loop<=$maxdepth;$loop++) {

	    $match = 0;
	    $match2 = 0;
	    if ($racine ne '') {

		for ($z=1;$z<=$maxrowspan;$z++) {
#		    print "OO - $maxrowspan - $affrac\n" if ($affrac =~ /entertainment\//);
		    if ($depthrac{$temp,$z,$loop} =~ m/$affrac/) {
			$affrac = $depthrac{$temp,$z,$loop};
			$affrac = &clean_url($affrac,0);
#			$affrac =~ s/\+/\\+/g; # /C++/
#			$affrac =~ s/\)/\\)/g;
#		        $affrac =~ s/\(/\\(/g;
#			$affrac =~ s/[\[\]]//g; # remove []
#	         	$affrac =~ s/\*/\\*/g;
			$match = 1;
			last;
		    }
		}
	    }
	    
	    $val = $rowspan{$temp,$z,$loop};
	    $val = 0 if ($match == 0);

	    $temp2 = $affrac;
#	    $temp2 = $racine;
	    $pos2 = rindex($temp2,$dirsepurl,length($temp2)-2);
	    $remind = substr($temp2,$pos2,length($temp2));

	    $loop2 = $loop+1;
	    for ($z2=1;$z2<=$maxrowspan;$z2++) {
		$zizi = index($depthrac{$temp,$z2,$loop2},$affrac);
#		$zizi = index($depthrac{$temp,$z2,$loop2},$racine);
		if ($zizi == 0) {
		    $match2 = 1;
		    last;
		}
	    }

	    print FOUT "<TD WIDTH=10";
	    print FOUT " ALIGN=LEFT VALIGN=MIDDLE";
	    print FOUT " ROWSPAN=$val" if ($val != 1 && $val !=0);
	    print FOUT ">";
	    print FOUT "---" if ($val != 0);
	    print FOUT "</TD>\n";
	    print FOUT "<TD";
	    print FOUT " ALIGN=CENTER VALIGN=MIDDLE";
	    print FOUT " ROWSPAN=$val" if ($val != 1 && $val !=0);
	    print FOUT ">";
	    print FOUT "&nbsp;" if ($val == 0);

	    if ($val != 0) {
		$freqracdepth{$affrac} = 0 if ($freqracdepth{$affrac} eq '');
		$freqrac{$affrac} = 0 if ($freqrac{$affrac} eq '' && $script == 2);
		$freqracurl{$affrac} = 0 if ($freqracurl{$affrac} eq '' && $script == 1);
		$frequpdate{$affrac} = 0 if ($frequpdate{$affrac} eq '');
#		$freqracdepth{$racine} = 0 if ($freqracdepth{$racine} eq '');
#		$freqrac{$racine} = 0 if ($freqrac{$racine} eq '' && $script == 2);
#		$freqracurl{$racine} = 0 if ($freqracurl{$racine} eq '' && $script == 1);
#		$frequpdate{$racine} = 0 if ($frequpdate{$racine} eq '');
		
		if ($freqracurl{$affrac} != 0 && $script == 1) { 
		    $tmp = $affrac;
#		if ($freqracurl{$racine} != 0 && $script == 1) { 
#		    $tmp = $racine;
		    chop($tmp);
		    $tmp =~ s/\//_/g if (length($tmp) < 249);
		    $tmp = substr($tmp,1,length($tmp));
		    $tmp = &clean_url($tmp,2);
		    $tmp5 = $tmp."popup".$htmlext;
		    $tmp = $tmp.$htmlext;
		}

		if ($script == 1) {
		    $tmp2 = 0;
		    $aff = 0;
		    for ($l=1;$l<=$count{$affrac};$l++) {
			$page = $newpageslues{$affrac,$l};
#		    for ($l=1;$l<=$count{$racine};$l++) {
#			$page = $newpageslues{$racine,$l};
			$tmp2 += $pageslues{$page};
			$aff = 1 if ($pageslues{$page} > $seuilpage);
		    }
		}

		$aff = 2 if ($nt == 1 && length($tmp5) > $maxlength_dirpage);

		print FOUT "\n\n<DIV CLASS=\"curly\" STYLE='background: #C0FAC0; margin: 10px;padding : 5pt;'>\n";
#		print FOUT "\n\n<DIV STYLE='background: #C0FAC0; margin: 10px;padding : 5pt;'>\n";
		print FOUT "<TABLE WIDTH=\"100%\">\n<TR>\n";
#		print FOUT "<TD ALIGN=CENTER CLASS=\"head\">\n";
		print FOUT "<TD ALIGN=CENTER CLASS=\"head\"";
#		print FOUT " onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"javascript:overdiv++;overdiv++;popLayer('Accesses','$tmp5','','',2,'','400')\"" if ($w3perlcgiurl ne '' && -d $cgipath_install && $tmp2 > $seuilpage && $aff != 0);
		print FOUT " onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"javascript:overdiv++;overdiv++;popLayer('Accesses','$tmp5','','',2,'','400')\"" if ($tmp2 > $seuilpage && $aff != 0);
		print FOUT ">";
		if ($script == 1) {
		    print FOUT "<A HREF=\"$tmp\">" if ($tmp2 > $seuilpage && $aff == 1);
		    print FOUT "$remind";
		    print FOUT "</A>" if ($tmp2 > $seuilpage && $aff == 1);
		} else {
		    print FOUT "$remind";
		}

		if ($script == 1) {
		    if ($freqracurl{$affrac} != 0) {
#		    if ($freqracurl{$racine} != 0) {
			print FOUT "</TD>\n</TR>\n<TR>\n<TD ALIGN=CENTER>\n";
			print FOUT "<TABLE>\n";
			if ($freqrachtml{$affrac} != $tmp2) {
#			if ($freqrachtml{$racine} != $tmp2) {
			    $tmp3 = int(100*$freqrachtml{$affrac}/$access) if ($access != 0);
#			    $tmp3 = int(100*$freqrachtml{$racine}/$access) if ($access != 0);
			    $tmp3 = 0 if ($access == 0);
			    print FOUT "<TR CLASS=\"row2\" TITLE=\"Tree\">";
			    print FOUT "<TD>$freqrachtml{$affrac}</TD>\n";
#			    print FOUT "<TD>$freqrachtml{$racine}</TD>\n";
			    print FOUT "<TD>($tmp3&nbsp;%)</TD>\n</TR>\n";
			}
			$tmp3 = int(100*$tmp2/$access) if ($access != 0);
			$tmp3 = 0 if ($access == 0);
			print FOUT "<TR CLASS=\"row2\" TITLE=\"internal\">\n<TD>$tmp2</TD>\n";
			print FOUT "<TD>($tmp3&nbsp;%)</TD>\n</TR>\n</TABLE>\n";
		    }
		    print FOUT "</TD>\n</TR>\n</TABLE>\n";
		    print FOUT "</DIV>\n\n";
		}
		
		if ($script == 2) {
		    print FOUT "</TD>\n</TR>\n<TR>\n<TD ALIGN=CENTER>\n";
		    print FOUT "<TABLE>\n<TR CLASS=\"row2\">\n";
		    print FOUT "<TD TITLE=\"Tree\">$freqracdepth{$affrac}</TD>\n";
		    print FOUT "<TD TITLE=\"internal\">$freqrachtml{$affrac}</TD>\n";
		    print FOUT "<TD>$frequpdate{$affrac}</TD>\n</TR>\n";
#		    print FOUT "<TD TITLE=\"Tree\">$freqracdepth{$racine}</TD>\n";
#		    print FOUT "<TD TITLE=\"internal\">$freqrachtml{$racine}</TD>\n";
#		    print FOUT "<TD>$frequpdate{$racine}</TD>\n</TR>\n";
		    print FOUT "</TABLE>\n";
		    print FOUT "</TD>\n</TR>\n";
		    print FOUT "</TABLE>\n";
		    print FOUT "</DIV>\n\n";
		}
	    }

	    print FOUT "</TD>\n";

	    $depthrac{$temp,$z,$loop} = '' if ($match == 1);
	    
	    print FOUT "<TD WIDTH=10";
	    print FOUT " ALIGN=RIGHT VALIGN=MIDDLE";
	    print FOUT " ROWSPAN=$val" if ($val != 1 && $val != 0);
	    print FOUT ">";
	    print FOUT "---" if ($match2 != 0);
	    print FOUT "</TD>\n";

	    print FOUT "<TD";
	    print FOUT " CLASS=\"traitv\"" if ($val != 0 && $val != 1 && $match2 == 1);
	    print FOUT " ALIGN=CENTER VALIGN=MIDDLE";
	    print FOUT " ROWSPAN=$val" if ($val != 1 && $val !=0);
	    print FOUT "></TD>";

	    if ($val != 1 && $val !=0) {
#		print "P1 - $affrac\n"; # if ($affrac =~ /entertainment\//);
		$affrac =~ s/\/\\/\//g;
		&row_end(*FOUT,*L,$temp,$val,$affrac,$val,$coi,$script);
		$loop = $maxdepth;
		$boucle2 =$rowboucle{$temp,$racine,$coi-1};
	    }
	    
        }
	if ($it != $boucle2) {
	    print FOUT "</TR>\n\n<TR>\n";
	}
	
    }
    $i = $maxdepth;
}

#################################################################
####                 Compute HTML Tree                    #######
#################################################################

sub ComputeTree {
    local(*FOUT,$script) = @_;
#	local($tmp,$tmp2);
    local($tmp5,$tmp6);

    print FOUT "<TR>\n";

    for ($j=1;$j<=$depth{2};$j++) {
	$temp = $line{$j};
	$boucle = 1;
	if ($j != 1) {
	    $tmp = ($maxdepth*4)-2;
	    print FOUT "<TR><TD COLSPAN=\"$tmp\">&nbsp;</TD></TR>\n";
	    print FOUT "<TR><TD COLSPAN=\"$tmp\" CLASS=\"traith\"></TD></TR>\n";
	    print FOUT "<TR><TD COLSPAN=\"$tmp\">&nbsp;</TD></TR>\n";
	    print FOUT "<TR>\n";
	}

	for ($i=2;$i<=($maxdepth-$depthinit);$i++) {
	    
	    $boucle += $depthocc{$temp,$i}-1;
	    
	    for ($k=1;$k<=$boucle;$k++) {
		    
		$racine = $depthrac{$temp,$k,$i};
		$value = $rowspan{$temp,$k,$i};

		print FOUT "<TD WIDTH=10";
		print FOUT " ALIGN=LEFT VALIGN=MIDDLE";
		print FOUT " ROWSPAN=$value" if ($value != 1 && $value != 0);
		print FOUT ">";
		print FOUT "---" if ($i != 2 && $racine ne '');
		print FOUT "</TD>\n";
		print FOUT "<TD";
		print FOUT " ALIGN=CENTER VALIGN=MIDDLE";
		print FOUT " ROWSPAN=$value" if ($value != 1 && $value != 0);
		print FOUT ">";
		print FOUT "&nbsp;" if ($value == 0);
		
		if ($value != 0) {
		    $temp2 = $racine;
		    $pos2 = rindex($temp2,$dirsepurl,length($temp2)-2);
		    $remind = substr($temp2,$pos2,length($temp2));
		    
		    $freqracdepth{$racine} = 0 if ($freqracdepth{$racine} eq '');
		    $freqracurl{$racine} = 0 if ($freqracurl{$racine} eq '');
	    
		    $tmp2 = 0;
		    $aff = 0;
		    for ($l=1;$l<=$count{$racine};$l++) {
			$page = $newpageslues{$racine,$l};
			$tmp2 += $pageslues{$page};
			$aff = 1 if ($pageslues{$page} > $seuilpage);
		    }
		    
		    if ($tmp2 > $seuilpage && $aff == 1) {
			$tmp = $racine;
			chop($tmp);
			$tmp =~ s/\//_/g if (length($tmp) < 249);
			$tmp = substr($tmp,1,length($tmp));
			$tmp = &clean_url($tmp,2);
			$tmp5 = $tmp."popup".$htmlext;
			$tmp = $tmp.$htmlext;
#			print "AA $racine - $tmp\n";
			if ($tmp eq $filepages) {
			    $tmp = "index_".$htmlext;
			    $tmp5 = "index_popup".$htmlext;
			}
		    }

		    $aff = 2 if ($nt == 1 && length($tmp5) > $maxlength_dirpage);

		    print FOUT "\n\n<DIV CLASS=\"curly\" STYLE='background: #CACACA; margin: 10px;padding : 5pt;'>\n";
#		    print FOUT "\n\n<DIV STYLE='background: #CACACA; margin: 10px;padding : 5pt;'>\n";
		    print FOUT "<TABLE BORDER=0 WIDTH=\"100%\">";
		    print FOUT "<TR>\n";
		    print FOUT "<TD CLASS=\"head\"";
#		    print FOUT " onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"javascript:overdiv++;popLayer('Accesses','$tmp5','','',2,'','400')\"" if ($w3perlcgiurl ne '' && -d $cgipath_install && $tmp2 > $seuilpage && $aff != 0);
		    print FOUT " onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"javascript:overdiv++;popLayer('Accesses','$tmp5','','',2,'','400')\"" if ($tmp2 > $seuilpage && $aff != 0);
		    print FOUT ">";
		    print FOUT "<A HREF=\"$tmp\">" if ($tmp2 > $seuilpage && $aff == 1);			
		    print FOUT "$remind";
		    print FOUT "</A>" if ($tmp2 > $seuilpage && $aff == 1);
			
		    print FOUT "</TD>\n</TR>\n";

		    if ($script == 2) {
			$freqracdepth{$racine} = 0 if ($freqracdepth{$racine} eq '');
			$freqrac{$racine} = 0 if ($freqrac{$racine} eq '');
			$frequpdate{$racine} = 0 if ($frequpdate{$racine} eq '');
		    
			print FOUT "<TR>\n<TD VALIGN=MIDDLE ALIGN=CENTER>\n";
			print FOUT "<TABLE WIDTH=\"100%\">\n<TR CLASS=\"row1\">\n";
			print FOUT "<TD TITLE=\"Tree\">$freqracdepth{$racine}</TD>\n";
			print FOUT "<TD TITLE=\"internal\">$freqrachtml{$racine}</TD>\n";
			print FOUT "<TD>$frequpdate{$racine}</TD>\n</TR>\n";
			print FOUT "</TABLE>\n";
			print FOUT "</TD>\n</TR>\n";
		    }

		    if ($freqracurl{$racine} != 0 && $script == 1) {
			print FOUT "<TR>\n<TD VALIGN=MIDDLE ALIGN=CENTER>\n";
			print FOUT "<TABLE WIDTH=\"100%\">\n";
			if ($freqrachtml{$racine} != $tmp2) {
			    $tmp3 = int(100*$freqrachtml{$racine}/$access) if ($access != 0);
			    $tmp3 = 0 if ($access == 0);
			    print FOUT "<TR CLASS=\"row1\" TITLE=\"Tree\">\n";
			    print FOUT "<TD>$freqrachtml{$racine}</TD>\n";
			    print FOUT "<TD>($tmp3&nbsp;%)</TD>\n</TR>\n";
			}
			$tmp3 = int(100*$tmp2/$access) if ($access != 0);
			$tmp3 = 0 if ($access == 0);
			print FOUT "<TR CLASS=\"row1\" TITLE=\"internal\">\n<TD>$tmp2</TD>\n";
			print FOUT "<TD>($tmp3&nbsp;%)</TD>\n</TR>\n";
			print FOUT "</TABLE>\n";
			print FOUT "</TD>\n</TR>\n";
		    }

		    print FOUT "</TABLE>\n";
		    print FOUT "</DIV>\n\n";
		    
		}
		
		print FOUT "</TD>\n";

		print FOUT "<TD WIDTH=10";
		print FOUT " ALIGN=RIGHT VALIGN=MIDDLE";
		print FOUT " ROWSPAN=$value" if ($value != 1 && $value != 0);
		$tmp9 = $i+1;
		print FOUT ">";
		print FOUT "---" if ($depthrac{$temp,$k,$tmp9} ne '');
		print FOUT "</TD>\n";

		print FOUT "<TD";
		print FOUT " CLASS=\"traitv\"" if ($value != 0  && $value != 1 && $depthrac{$temp,$k,$tmp9} ne '');
		print FOUT " ALIGN=CENTER VALIGN=MIDDLE";
		print FOUT " ROWSPAN=$value" if ($value != 1 && $value != 0);
		print FOUT ">";
		print FOUT "</TD>";

		if ($value != 1 && $value != 0) {
		    &row_end(*FOUT,*L,$temp,$value,$racine,$value,$i,$script);
		}
	    }
	}
	
	print FOUT "</TR>\n\n";
    }
}


#################################################################
####                     Parsing forms                    #######
#################################################################
# Extracted from cgi-lib.pl from S.E.Brenner@bioc.cam.ac.uk


sub ReadParse {
  local (*in) = @_ if @_;
  local ($i, $key, $val);

  # Read in text
  if (&MethGet) {
    $in = $ENV{'QUERY_STRING'};
  } elsif (&MethPost) {
    read(STDIN,$in,$ENV{'CONTENT_LENGTH'});
  }

  @in = split(/[&;]/,$in);

  foreach $i (0 .. $#in) {
    # Convert plus's to spaces
    $in[$i] =~ s/\+/ /g;
#    $in[$i] = &escape_input($in[$i]);

    # Split into key and value.
    ($key, $val) = split(/=/,$in[$i],2); # splits on the first =.

    # Convert %XX from hex numbers to alphanumeric
    $key =~ s/%(..)/pack("c",hex($1))/ge;
    $val =~ s/%(..)/pack("c",hex($1))/ge;
    $val =~ s/\'//g;

    $opt = "opt_$key";
    $$opt = $val;             # Work only with perl 5 and above
#    eval "\$$opt = $val";
    
  }
  $ENV{'QUERY_STRING'} = '';
}

# MethGet
# Return true if this cgi call was using the GET request, false otherwise

sub MethGet {
  return ($ENV{'REQUEST_METHOD'} eq "GET");
}


# MethPost
# Return true if this cgi call was using the POST request, false otherwise

sub MethPost {
  return ($ENV{'REQUEST_METHOD'} eq "POST");
}

#################################################################
####       Parse html pages to replace accent             #######
#################################################################
# remplace les codes accent ascii accent par du html
# http://www.designvegetal.com/gadrat/cours/informatique/html/accents.html
# http://tlt.its.psu.edu/suggestions/international/web/codehtml.html
# http://www.pjb.com.au/comp/diacritics.html

sub accent2html {
    local($words) = @_;

    $words =~ s/\351/&eacute;/g;
    $words =~ s/\350/&egrave;/g;
    $words =~ s/\352/&ecirc;/g;
    $words =~ s/\353/&euml;/g;
    $words =~ s/\337/&szlig;/g;

    $words =~ s/\311/&Eacute;/g;
    $words =~ s/\310/&Egrave;/g;
    $words =~ s/\312/&Ecirc;/g;
    $words =~ s/\313/&Euml;/g;

    $words =~ s/\341/&aacute;/g;
    $words =~ s/\340/&agrave;/g;
    $words =~ s/\342/&acirc;/g;
    $words =~ s/\344/&auml;/g;
    $words =~ s/\343/&atilde;/g;
    $words =~ s/\345/&aring;/g;
    $words =~ s/\346/&aelig;/g;

    $words =~ s/\301/&Aacute;/g;
    $words =~ s/\300/&Agrave;/g;
    $words =~ s/\302/&Acirc;/g;
    $words =~ s/\304/&Auml;/g;
    $words =~ s/\303/&Atilde;/g;
    $words =~ s/\305/&Aring;/g;

    $words =~ s/\355/&iacute;/g;
    $words =~ s/\354/&igrave;/g;
    $words =~ s/\356/&icirc;/g;
    $words =~ s/\357/&iuml;/g;

    $words =~ s/\315/&Iacute;/g;
    $words =~ s/\314/&Igrave;/g;
    $words =~ s/\316/&Icirc;/g;
    $words =~ s/\317/&Iuml;/g;

    $words =~ s/\363/&oacute;/g;
    $words =~ s/\362/&ograve;/g;
    $words =~ s/\364/&ocirc;/g;
    $words =~ s/\366/&ouml;/g;
    $words =~ s/\370/&oslash;/g;

    $words =~ s/\323/&Oacute;/g;
    $words =~ s/\322/&Ograve;/g;
    $words =~ s/\324/&Ocirc;/g;
    $words =~ s/\326/&Ouml;/g;
    $words =~ s/\330/&Oslash;/g;

    $words =~ s/\372/&uacute;/g;
    $words =~ s/\371/&ugrave;/g;
    $words =~ s/\373/&ucirc;/g;
    $words =~ s/\374/&uuml;/g;

    $words =~ s/\332/&Uacute;/g;
    $words =~ s/\331/&Ugrave;/g;
    $words =~ s/\333/&Ucirc;/g;
    $words =~ s/\334/&Uuml;/g;

    $words =~ s/\375/&yacute;/g;
    $words =~ s/\377/&yuml;/g;

    $words =~ s/\335/&Yacute;/g;
    $words =~ s/\276/&Yuml;/g;

    $words =~ s/\347/&ccedil;/g;
    $words =~ s/\307/&Ccedil;/g;

    $words =~ s/\361/&ntilde;/g;
    $words =~ s/\321/&Ntilde;/g;

    return $words;
    
}

# supprime les accents en html
# http://www.utf8-chartable.de/

sub noaccentinhtml {
    local($words) = @_;

    $words =~ s/&eacute;/e/g;
    $words =~ s/&egrave;/e/g;
    $words =~ s/&ecirc;/e/g;
    $words =~ s/&euml;/e/g;

    $words =~ s/&Eacute;/E/g;
    $words =~ s/&Egrave;/E/g;
    $words =~ s/&Ecirc;/E/g;
    $words =~ s/&Euml;/E/g;

    $words =~ s/&aacute;/a/g;
    $words =~ s/&agrave;/a/g;
    $words =~ s/&acirc;/a/g;
    $words =~ s/&auml;/a/g;
    $words =~ s/&atilde;/a/g;
    $words =~ s/&aring;/a/g;
    $words =~ s/&aelig;/ae/g;

    $words =~ s/&Aacute;/A/g;
    $words =~ s/&Agrave;/A/g;
    $words =~ s/&Acirc;/A/g;
    $words =~ s/&Auml;/A/g;
    $words =~ s/&Atilde;/A/g;
    $words =~ s/&Aring;/A/g;

    $words =~ s/&iacute;/i/g;
    $words =~ s/&igrave;/i/g;
    $words =~ s/&icirc;/i/g;
    $words =~ s/&iuml;/i/g;

    $words =~ s/&Iacute;/I/g;
    $words =~ s/&Igrave;/I/g;
    $words =~ s/&Icirc;/I/g;
    $words =~ s/&Iuml;/I/g;

    $words =~ s/&oacute;/o/g;
    $words =~ s/&ograve;/o/g;
    $words =~ s/&ocirc;/o/g;
    $words =~ s/&ouml;/o/g;
    $words =~ s/&oslash;/o/g;

    $words =~ s/&Oacute;/O/g;
    $words =~ s/&Ograve;/O/g;
    $words =~ s/&Ocirc;/O/g;
    $words =~ s/&Ouml;/O/g;
    $words =~ s/&Oslash;/O/g;

    $words =~ s/&szlig;/ss/g;

    $words =~ s/&uacute;/u/g;
    $words =~ s/&ugrave;/u/g;
    $words =~ s/&ucirc;/u/g;
    $words =~ s/&uuml;/u/g;

    $words =~ s/&Uacute;/U/g;
    $words =~ s/&Ugrave;/U/g;
    $words =~ s/&Ucirc;/U/g;
    $words =~ s/&Uuml;/U/g;

    $words =~ s/&yacute;/y/g;
    $words =~ s/&yuml;/y/g;

    $words =~ s/&Yacute;/Y/g;
    $words =~ s/&Yuml;/Y/g;

    $words =~ s/&ccedil;/c/g;
    $words =~ s/&Ccedil;/C/g;

    $words =~ s/&ntilde;/n/g;
    $words =~ s/&Ntilde;/N/g;

    return $words;
}

# supprime les accents

sub noaccent {
    local($words) = @_;

    $words =~ s/\xc3\xa9/e/g;
    $words =~ s/\xc3\xa8/e/g;
    $words =~ s/\xc3\xaA/e/g;
    $words =~ s/\xc3\xab/e/g;

    $words =~ s/\xc3\x89/E/g;
    $words =~ s/\xc3\x88/E/g;
    $words =~ s/\xc3\x8a/E/g;
    $words =~ s/\xc3\x8b/E/g;

    $words =~ s/\xc3\xa0/a/g;
    $words =~ s/\xc3\xa1/a/g;
    $words =~ s/\xc3\xa2/a/g;
    $words =~ s/\xc3\xa3/a/g;
    $words =~ s/\xc3\xa4/a/g;
    $words =~ s/\xc3\xa5/a/g;

    $words =~ s/\xc3\x80/A/g;
    $words =~ s/\xc3\x81/A/g;
    $words =~ s/\xc3\x82/A/g;
    $words =~ s/\xc3\x83/A/g;
    $words =~ s/\xc3\x84/A/g;
    $words =~ s/\xc3\x85/A/g;
    $words =~ s/\xc3\x86/A/g;

    $words =~ s/\xc3\xac/i/g;
    $words =~ s/\xc3\xad/i/g;
    $words =~ s/\xc3\xae/i/g;
    $words =~ s/\xc3\xaf/i/g;

    $words =~ s/\xc3\x8c/I/g;
    $words =~ s/\xc3\x8d/I/g;
    $words =~ s/\xc3\x8e/I/g;
    $words =~ s/\xc3\x8f/I/g;

    $words =~ s/\xc3\xb2/o/g;
    $words =~ s/\xc3\xb3/o/g;
    $words =~ s/\xc3\xb4/o/g;
    $words =~ s/\xc3\xb5/o/g;
    $words =~ s/\xc3\xb6/o/g;

    $words =~ s/\xc3\x92/O/g;
    $words =~ s/\xc3\x93/O/g;
    $words =~ s/\xc3\x94/O/g;
    $words =~ s/\xc3\x95/O/g;
    $words =~ s/\xc3\x96/O/g;

    $words =~ s/\xc3\xb9/u/g;
    $words =~ s/\xc3\xba/u/g;
    $words =~ s/\xc3\xbb/u/g;
    $words =~ s/\xc3\xbc/u/g;

    $words =~ s/\xc3\x99/U/g;
    $words =~ s/\xc3\x9a/U/g;
    $words =~ s/\xc3\x9b/U/g;
    $words =~ s/\xc3\x9c/U/g;

    $words =~ s/\xc3\xbd/y/g;
    $words =~ s/\xc3\xbf/y/g;

    $words =~ s/\xc3\x9d/Y/g;

    $words =~ s/\xc3\xa7/c/g;
    $words =~ s/\xc3\x87/C/g;

    $words =~ s/\xc3\xb1/n/g;
    $words =~ s/\xc3\x91/N/g;

###

    $words =~ s/\351/e/g;
    $words =~ s/\350/e/g;
    $words =~ s/\352/e/g;
    $words =~ s/\353/e/g;
    $words =~ s/\337/ss/g;

    $words =~ s/\311/E/g;
    $words =~ s/\310/E/g;
    $words =~ s/\312/E/g;
    $words =~ s/\313/E/g;

    $words =~ s/\341/a/g;
    $words =~ s/\340/a/g;
    $words =~ s/\342/a/g;
    $words =~ s/\344/a/g;
    $words =~ s/\343/a/g;
    $words =~ s/\345/a/g;
    $words =~ s/\346/ae/g;

    $words =~ s/\301/A/g;
    $words =~ s/\300/A/g;
    $words =~ s/\302/A/g;
    $words =~ s/\303/A/g;
    $words =~ s/\304/A/g;
    $words =~ s/\305/A/g;

    $words =~ s/\355/i/g;
    $words =~ s/\354/i/g;
    $words =~ s/\356/i/g;
    $words =~ s/\353/i/g;

    $words =~ s/\315/I/g;
    $words =~ s/\314/I/g;
    $words =~ s/\316/I/g;
    $words =~ s/\317/I/g;

    $words =~ s/\363/o/g;
    $words =~ s/\362/o/g;
    $words =~ s/\364/o/g;
    $words =~ s/\366/o/g;
    $words =~ s/\370/o/g;

    $words =~ s/\323/O/g;
    $words =~ s/\322/O/g;
    $words =~ s/\324/O/g;
    $words =~ s/\326/O/g;
    $words =~ s/\330/O/g;

    $words =~ s/\372/u/g;
    $words =~ s/\371/u/g;
    $words =~ s/\373/u/g;
    $words =~ s/\374/u/g;

    $words =~ s/\332/U/g;
    $words =~ s/\331/U/g;
    $words =~ s/\333/U/g;
    $words =~ s/\334/U/g;

    $words =~ s/\375/y/g;
    $words =~ s/\377/y/g;

    $words =~ s/\335/Y/g;
    $words =~ s/\276/Y/g;

    $words =~ s/\347/c/g;
    $words =~ s/\307/C/g;

    $words =~ s/\361/n/g;
    $words =~ s/\321/N/g;

    return $words;
    
}


#################################################################
####                 Sort data by number                  #######
#################################################################

sub bynumber { 
$a <=> $b;
}

#################################################################
####                 Recursive delete                     #######
#################################################################

sub dodirdel {
    local($dir) = @_;
    local($i,$unlink,@filenames);
    local($unlink,$login,%seen,@list,$found);

    if (-d $dir) {
	opendir(SOURCEDIR,$dir);
	@filenames = readdir(SOURCEDIR);
	closedir(SOURCEDIR);

	$found = 0;
	for ($i=0;$i<=$#filenames;$i++) {
	    if (-f "$dir$dirsep$filenames[$i]") {
		$unlink = unlink("$dir$dirsep$filenames[$i]");
#		print "DELETE FILE $dir$dirsep$filenames[$i] - $unlink\n";
	    }

	    if (-d "$dir$dirsep$filenames[$i]" && $filenames[$i] ne '.' && $filenames[$i] ne '..') {
#		print "CHDIR $dir$dirsep$filenames[$i]\n";
		chdir "$dir$dirsep$filenames[$i]";
		&dodirdel("$dir$dirsep$filenames[$i]");
		chdir '..';
#		print "DEL DIR $dir$dirsep$filenames[$i]\n";
		$unlink = rmdir("$dir$dirsep$filenames[$i]");
		if ($unlink == 0) {
		    $found = 1;
		    ($login) = (stat("$dir$dirsep$filenames[$i]")) [4];
		    $login = getpwuid("$login") if ($nt == 0);
		    push(@list,$dir) unless $seen{$dir}++;
#		    print "$dir$dirsep$filenames[$i] cannot be deleted (owner is $login)\n";
		}
	    }
	}
    }
    print "WARNING : @list cannot be deleted (owner is $login)\n" if ($found == 1);
}


#################################################################
####            Compute real time running                 #######
#################################################################

sub timetaken {
local($a,$b) = @_;
local($hour1,$hour2,$minute1,$minute2,$sec1,$sec2);
local ($hour,$sec,$min,$tmp);

($hour1,$minute1,$sec1) = split(/:/,$a);
($hour2,$minute2,$sec2) = split(/:/,$b);

$sec1 = $hour1*3600+$minute1*60+$sec1;
$sec2 = $hour2*3600+$minute2*60+$sec2;

$tmp = $sec2-$sec1;
$tmp += 86400  if ($tmp < 0);

$hour = int($tmp/3600);
$min = int(($tmp-($hour*3600))/60);
$sec = $tmp-($hour*3600)-($min*60);

$hour = "0".$hour if (length($hour) == 1);
$min = "0".$min if (length($min) == 1);
$sec = "0".$sec if (length($sec) == 1);

return($hour,$min,$sec);
}

#################################################################
####                   Error debugging                    #######
#################################################################

sub error_open {
    local($file,$status) = @_;
    local($msg,$msg2);
    $status = 1 if ($status eq '');

    $msg = "Content-type: text/html\n\n" if ($ENV{'REQUEST_METHOD'} eq "GET");
#    print "<HTML><HEAD><TITLE>Stats</TITLE></HEAD>\n";
#    print "<BODY BGCOLOR=\"#FFFFFF\" TEXT=\"#000000\">\n";
    $msg .= "<P><DIR><FONT COLOR=\"#AA2020\">" if ($ENV{'REQUEST_METHOD'} eq "GET");
    $msg .= "Unable to open $file\n";
    $msg2 = "Unable to open $file\n";
    
    $msg .= "</FONT><BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    $msg .= " ==> check read permission.\n";
    $msg2 .= " ==> check read permission.\n";
    $msg .= " Make sure your web server can read this file\n" if ($ENV{'REQUEST_METHOD'} eq "GET");
    $msg .= "</DIR><P>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    $msg .= "\n";
    print "$msg";
    &StatusCompleted($scriptname,$status_script,$msg2);
    exit($status);
}


#################################################################
####                   Fatal Error                        #######
#################################################################

sub error_exit {
    local($msg,$status) = @_;
    $status = 1 if ($status eq '');
#    unlink($lockfile) if ($scriptname eq "cron-inc.pl" && -f $lockfile);
    print "Content-type: text/html\n\n" if ($scriptname eq "cron-hour.pl" && $opt_n ne '' && $opt_z ne '');
#    print "Content-type: text/html\n\n";
#    print "Content-type: text/html\n\n" if (($scriptname eq "cron-hour.pl" && $opt_n ne '') || $ENV{'REQUEST_METHOD'} eq "GET");
    print "<DIV CLASS=\"error_exit\">" if ($ENV{'REQUEST_METHOD'} eq "GET");
    $msg =~ s/\n/\<BR\>/g if ($ENV{'REQUEST_METHOD'} eq "GET");
#    print "$msg\n\n";
    $msg2 = $msg;
    $msg2 =~ s/<BR>//g;
    $msg2 =~ s/<P>//g;
    &output_log("$msg2\n\n") if ($status != 4);
    print "</DIV>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    print "</TD>\n</TR>\n</TABLE>\n</BODY>\n</HTML>\n" if ($ENV{'REQUEST_METHOD'} eq "GET" && $status == 1);
    $status_script = 1 if ($status == 2);

    if ($status != 4) {
	&StatusCompleted($scriptname,$status_script,$msg) if ($status != 4);
	open(MAININDEX,">$path$progress_log") || &error_exit("Error, unable to open $path$progress_log");
	$msg = "<B><FONT COLOR=\"#FF0000\">Error while processing :</FONT></B><BR>\n".$msg;
	print MAININDEX "$msg";
	close(MAININDEX);
    } else {
	print "$msg\n";
    }

    $status = 0 if ($status == 4);

    if ($status != 2) {
	if ($ENV{'REQUEST_METHOD'} eq "GET" && $opt_y ne '') {
	    print "</DIV>";
	    print "<script language=\"javascript\" type=\"text/JavaScript\">\n";
	    $tmp = $scriptname;
	    if ($scriptname eq "cron-hour.pl") {
		$tmp = $scriptname."1" if ($opt_n ne '');
		$tmp = $scriptname."2" if ($opt_b ne '');
	    }
	    print "ToggleMenu('TOGGLE_$tmp');\n";
#	    print "ToggleMenu('TOGGLE_$scriptname');\n";
	    print "</script>\n";
	}
	exit($status) if ($status != 3);
    }

    exit if ($status == 3);
}


#################################################################
####                   Warning Error                      #######
#################################################################

sub warning_msg {
    local($msg) = @_;
    print "<DIV CLASS=\"warning_msg\">" if ($ENV{'REQUEST_METHOD'} eq "GET");
    $msg =~ s/\n/\<BR\>/g if ($ENV{'REQUEST_METHOD'} eq "GET");
    print "$msg\n\n";
    print "</DIV>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET");
}


#################################################################
####                   yesterday                          #######
#################################################################

sub yesterday_date {
    local($day,$countmonth,$year) = @_;
#    local($month);

    $countmonth--;
    $day--;
    if ($day < 1) {
	$countmonth--;
	$year-- if ($countmonth < 0);
	$countmonth = 11 if ($countmonth < 0);
	$month = $month_nb[$countmonth];
	$day = $month_of_year{$month};
    }
    
    $day = "0".$day if (length($day) == 1);
    
    $yesterday = "$day"."/"."$month"."/"."$year";
#    $yesterday =~ s/[\/]/ /g;
    return $yesterday;

}

#################################################################
####                   Check referer cgi                  #######
#################################################################

sub securecgi {
  local($file) = @_;
  local($tmp1,$tmp2);

  print "Content-type: text/html\n\n";
  print "$doctype\n";
  print "<HTML><HEAD><TITLE>Installation forbidden access</TITLE></HEAD>\n";
  print "<BODY BGCOLOR=\"#FFFFFF\" TEXT=\"#000000\">\n";
  print "<P><BR><H3><CENTER>";
  print "Forbidden access\n";
  print "</H3><P></CENTER><BR>";
  print "<P><DIR><FONT COLOR=\"#AA2020\">" if ($ENV{'REQUEST_METHOD'} eq "GET");
  print "You should run scripts from the interface administration\n";
  print "</FONT><BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
  print " This is to avoid unsollicited access to your stats\n";
  print "</DIR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
  exit;
}

#################################################################
####                   Update homepage                    #######
#################################################################

sub load_basic_stats {
    local($tmp,$tmp1,$tmp2,$tmp3,$line);
    local($last_update,$hour_update);

    &LogoWidth("$logo") if ($logo !~ /^http/ && $logo ne '');
#    print "A - $logo - $logo_width\n";

    $nbfile = 0;
    $nbfiledom = 0;

    if (-f "$path$dirinc$dirsep$incgeneral") {
	open(GENERAL,"$path$dirinc$dirsep$incgeneral"); # || die &error_exit("Error, unable to open $path$dirinc$dirsep$incgeneral");
	while (<GENERAL>) {
	    ($date1,$date2,$date3,$reqtot,$reqdomtot,$totsize,$externesize,$domsize,$nbdays,$access,$accessdom,$tothtmlsize,$loglines,$proxy,$redirect,$unauthorized,$forbiden,$notfound,$exclpages,$excladdr,$exclframed,$exclrobots,$exclrefererspam,$paysunique,$bandwidth_input,$bandwidth_output,$nbfile,$nbfiledom) = split;
	}
	close GENERAL;
    }

    if (-f "$history") {
	open(INFILE,"$history"); # || &error_exit("Error, unable to open $history",1);
	while (<INFILE>) {
	    $line = $_;
	}
	close(INFILE);
    }

    $skip_city = 0;
    $filecity_ajax = $filecity."_search";

    $skip_city = 1;
    $skip_city = 0 if (-f "$path$dirinc$dirsep$filecity_ajax$txtext" || -f "$path$dirinc$dirsep$filecity_ajax");
    if (-f "$path$dirinc$dirsep$filecity_ajax$txtext") {
	$skip_city = 1 if (-z "$path$dirinc$dirsep$filecity_ajax$txtext");
    }
    if (-f "$path$dirinc$dirsep$filecity_ajax") {
	$skip_city = 1 if (-z "$path$dirinc$dirsep$filecity_ajax");
    }

#    print "POPO $skip_city\n";
#    $skip_city = 1 if (!(-f "$path$dirinc$dirsep$filecity_ajax$txtext" && !(-f "$path$dirinc$dirsep$filecity_ajax")) || -z "$path$dirinc$dirsep$filecity_ajax$txtext");

    &load_countries_map;

    $skip_pays = 0;
    if ($geoipcity == 1) {
	$skip_pays = 1;
	open(INFILE, "$path$dirinc$dirsep$incpays") || &error_exit("Error, unable to open $path$dirinc$dirsep$incpays",1);
	while (<INFILE>) {
	    ($pays) = split;
#	    next if ($pays eq "Unknown");
	    $skip_pays = 0 if ($pays !~ /$country_generic/);
	}
	close(INFILE);

    }

    ($tmp,$last_update,$hour_update) = split(/\s+/,$line);
    $last_update =~ s/\// /g;

    $nbdays = 0;
    open(INFILE, "$path$dirdata$dirsep$datafile") || &error_exit("Error, unable to open $path$dirdata$dirsep$datafile",1);
    while (<INFILE>) {
	$nbdays++;
    }
    close(INFILE);
    $nbdays -= 2; # remove header lines


    $firstday = "$date1"." "."$date2"." "."$date3";

    $yesterday = &date_intervalle($firstday,$nbdays-1);

# conversion en Megaoctets

    $notrafic = 0 if ($totsize != 0);

#    $totsize /= (1024*1024);
#    $externesize /= (1024*1024);
#    $domsize /= (1024*1024);
#    $bandwidth_input /= (1024*1024);
#    $bandwidth_output /= (1024*1024);

    if (-f "$path$dirinc$dirsep$virusdef") {
	$nb_virus = 0;
	open(VIRUS,"$path$dirinc$dirsep$virusdef");
	while (<VIRUS>) {
	    chop;
	    ($adresse,$tmp1,$tmp2,$tmp3) = split(/\t/);
	    if ($tmp3 ne '') {
		$nb_virus++;
	    }
	}
	close VIRUS;
    }

    $screensize_val = 0;
    if (-f "$path$dirinc$dirsep$incscreensize") {
	$screensize_val = 1;
    }

    $heatmap_val = 0;
    if (-f "$path$dirinc$dirsep$fileheatmap") {
	$heatmap_val = 1;
    }

    if (-f "$path$lang[$nblang]$dirsep$dirsession$dirsep$filerobot") {
	$sessionrobot = 1;
    }

    # RSS

    if (-f "$path$dirinc$dirsep$filerss") {
	open(RSS,"$path$dirinc$dirsep$filerss");
	while (<RSS>) {
	    chop;
	    ($adresse,$tmp1) = split(/\t/);
	    $rss_nb += $tmp1 if ($adresse =~ /^\//);
	}
	close(RSS);
    }

    # Scripts

    if ($inc_script == 1) {
	$scriptunique = 0;
	open(SCRIPT,"$path$dirinc$dirsep$incscript") || &error_exit("Error, unable to open $path$dirinc$dirsep$incscript");
	if (!(-f "$path$dirinc$dirsep$incmethod")) {
	    $tmp = <SCRIPT>;
	    $tmp = <SCRIPT>;
	    }
	while (<SCRIPT>) {
#	    chop;
	    $scriptunique++;
	}
	close(SCRIPT);
    }

    $pageunique = 0;
    if (-f "$path$dirinc$dirsep$incpage$txtext") {
	$tmp = "$path$dirinc$dirsep$incpage$txtext";
    } else {
	$tmp = "$path$dirinc$dirsep$incpage";
    }
    open(PAGESLUES,"$tmp"); # || die &error_exit("Error, unable to open $path$dirinc$dirsep$incpage");
    while (<PAGESLUES>) {
	$pageunique++;
    }
    close PAGESLUES;

#    if ($ftp_format == 1 || $mail_format == 1) {
    if (-f "$path$dirinc$dirsep$incftp$txtext") {
	$tmp = "$path$dirinc$dirsep$incftp$txtext";
    } else {
	$tmp = "$path$dirinc$dirsep$incftp";
    }
    if (-f $tmp) {
	open(FTP,"$tmp");
	$tmp = (<FTP>);
	chop($tmp);
	($nb_user,$user_local,$user_ext) = split(/\t/,$tmp);
	close(FTP);
    }
#    }

    $serverunique = 0;
    if (-f "$path$dirinc$dirsep$incservexterne$txtext") {
	$tmp = "$path$dirinc$dirsep$incservexterne$txtext";
    } else {
	$tmp = "$path$dirinc$dirsep$incservexterne";
    }
    open(SERVEXTERNE,"$tmp"); # || die &error_exit("Error, unable to open $path$dirinc$dirsep$incservexterne");
    while (<SERVEXTERNE>) {
	$serverunique++;
    }
    close SERVEXTERNE;

    $locserver = 0;
    if (-f "$path$dirinc$dirsep$incservinterne$txtext") {
	$tmp = "$path$dirinc$dirsep$incservinterne$txtext";
    } else {
	$tmp = "$path$dirinc$dirsep$incservinterne";
    }
    open(SERVINTERNE,"$tmp"); # || die &error_exit("Error, unable to open $path$dirinc$dirsep$incservinterne");
    while (<SERVINTERNE>) {
	$locserver++;
    }
    close SERVINTERNE;


    $serveruniquetot = $serverunique+$locserver;

    $virtualunique = 0;
    if (-f "$path$dirinc$dirsep$incvirtual$txtext") {
	$tmp = "$path$dirinc$dirsep$incvirtual$txtext";
    } else {
	$tmp = "$path$dirinc$dirsep$incvirtual";
    }
    if (-f "$tmp") {
	open(VIRTUAL,"$tmp"); # || die &error_exit("Error, unable to open $path$dirinc$dirsep$incvirtual");
	while (<VIRTUAL>) {
	    $virtualunique++;
	}
	close(VIRTUAL);
    }

    # To load $nbzone for CSS menu

    if (-f "$path$dirinc$dirsep$incstatus") {
	open(STATUS,"$path$dirinc$dirsep$incstatus");
	while (<STATUS>) {
	    chop;
	    ($status,$nb,$tmp1) = split(/\t/);
	    if ($tmp1 eq '') {
		$status_code{$status} = $nb;
	    }
	}
	close(STATUS);
    }

#    &LoadLocconf($locconf) if ($nb_stats_run eq '');
}

sub Load_DailyData {
    local($file,$dir,$page) = @_;
    local($i);

    $i = 0;
    $i = 1 if ($fly_set == 1);

    $line = 0;
#    $nbfile = 0;
#    $nbfiledom = 0;
    $start_date = '';

    $fileopen = "$path$dir$dirsep$file";

    if ($file eq $datafile) {
	undef(@listdate);

	$accessmax = 0;
	$reqmax = 0;
	$machmax = 0;
	$traficmax = 0;
	$docmax = 0;
	$usermax = 0;
	$scriptmax = 0;

	$allscriptcgi = 0;
	open(INFILE, "$fileopen") || &error_exit("Error, unable to open $fileopen",1);
	while (<INFILE>) {
	    $line++;

	    next if ($line < 3);
#	    next if ($line =~ /^#/);
	    ($jour,$month,$year,$m_tot,$m_new,$m_dom,$req_tot,$req_dom,$access_day,$totsize_day,$tothtmlsize,$domsize_day,$script_day,$pays_day,$doc_day,$user_day,$access_unique_day) = split('\s+');
	    next if ($jour eq '');
	    $listdate[$i] = "$jour $month $year";
	    $tabacc[$i] = $access_day if ($cups_format == 0);
	    $tabacc[$i] = $access_unique_day if ($cups_format == 1);
	    $tabreq[$i] = $req_tot;
	    $tabmm[$i] = $m_tot;
	    $tabdoc[$i] = $doc_day;
	    $tabuser[$i] = $user_day;
	    $tabtrafic[$i] = $totsize_day;
	    $tabscript[$i] = $script_day;
	    $accessmax = $access_day if ($access_day > $accessmax && $cups_format == 0);
	    $accessmax = $access_unique_day if ($access_unique_day > $accessmax && $cups_format == 1);
	    $usermax = $user_day if ($user_day > $usermax);
	    $reqmax = $req_tot if ($req_tot > $reqmax);
	    $machmax = $m_tot if ($m_tot > $machmax);
	    $traficmax = $totsize_day if ($totsize_day > $traficmax);
	    $docmax = $doc_day if ($doc_day > $docmax);
	    $scriptmax = $script_day if ($script_day > $scriptmax);
	    $i++;
	    $start_date = "$jour $month $year" if ($start_date eq '');
	    $allscriptcgi += $script_day;
#	    print "PP $jour,$month,$year - $usermax - $user_day\n";
	}
	close(INFILE);
#	$i--;

	($unit_div,$unit) = &Return_Unit($traficmax,0);
    }

    if ($file eq $dayerror) {
	$i = 0;
	$errormax = 0;
	open(INFILE, "$fileopen") || &error_exit("Error, unable to open $fileopen",1);
	$start_date = <INFILE>;
	($jour,$month,$year) = split(/\s+/,$start_date);
	$listdateerror[$i] = "$jour $month $year";
	while (<INFILE>) {
	    next if ($_ =~ /^#/);
	    (@datatab) = split('\s+');
	    $val = 0;
	    for ($j=0;$j<$#datatab;$j++) {
		$val += $datatab[$j];
	    }
	    $taberror[$i] = $val;

	    $errormax = $val if ($val > $errormax);
	    $listdateerror[$i] = &date_intervalle($start_date,$i);
	    $i++;
	}
	close(INFILE);
#	$i--;
    }

    if ($file eq $filerssdaily) {
	$rssmax = 0;
	$i = 0;
	open(INFILE, "$fileopen") || &error_exit("Error, unable to open $fileopen",1);
	while (<INFILE>) {
	    next if ($_ =~ /^#/);
	    ($jour,$month,$year,@datatab) = split('\s+');
	    $val = $datatab[$page];
	    $tabrss[$i] = $val;
	    $listdaterss[$i] = "$jour $month $year";
	    $i++;
	    $start_date = "$jour $month $year" if ($start_date eq '');
	    $rssmax = $val if ($val > $rssmax);
	}
	close(INFILE);
#	$i--;
    }

  if ($file eq $datafile_refer) {
      $refermax = 0;
      $line = 0;
	$i = 0;
	open(INFILE, "$fileopen") || &error_exit("Error, unable to open $fileopen",1);
	while (<INFILE>) {
	    $line++;
	    next if ($line <= 3);
	    next if ($_ =~ /^#/);

	    ($jour,$month,$year,$val) = split('\s+');
	    $tabrefer[$i] = $val;
	    $listdaterefer[$i] = "$jour $month $year";
	    $i++;
	    $start_date = "$jour $month $year" if ($start_date eq '');
	    $refermax = $val if ($val > $refermax);
	}
	close(INFILE);
#	$i--;
    }

  if ($file eq $incsession) {
	$i = 0;
	$sessionmax = 0;
	open(INFILE, "$fileopen") || &error_exit("Error, unable to open $fileopen",1);
	while (<INFILE>) {
	    next if ($_ =~ /^#/);
	    ($jour,$month,$year,$val) = split('\s+');
	    $tabsession[$i] = $val;
	    $listdatesession[$i] = "$jour $month $year";
	    $i++;
	    $start_date = "$jour $month $year" if ($start_date eq '');
	    $sessionmax = $val if ($val > $sessionmax);
	}
	close(INFILE);
#	$i--;
    }

  if ($file eq $spam) {
	$i = 0;
	$spammax = 0;
	open(INFILE, "$fileopen") || &error_exit("Error, unable to open $fileopen",1);
	while (<INFILE>) {
	    next if ($_ =~ /^#/);
	    ($jour,$month,$year,@val) = split('\s+');
	    $tabspam[$i] = $val[2]+$val[3];
	    $listdatespam[$i] = "$jour $month $year";
	    $start_date = "$jour $month $year" if ($start_date eq '');
	    $spammax = $tabspam[$i] if ($tabspam[$i] > $spammax);
	    $i++;
	}
	close(INFILE);
#	$i--;
  }

  if ($file eq $incnewfile) {
	$i = 0;
	$newfilemax = 0;
	open(INFILE, "$fileopen") || &error_exit("Error, unable to open $fileopen",1);
	$start_date = <INFILE>;
	($jour,$month,$year) = split(/\s+/,$start_date);
	$listdatenewfile[$i] = "$jour $month $year";
	while (<INFILE>) {
	    next if ($_ =~ /^#/);
	    ($val) = split('\s+');
	    $nbmodif[$i] = $val;
	    $listdatenewfile[$i] = &date_intervalle($start_date,$i);
	    $i++;

	    $newfilemax = $val if ($val > $newfilemax);
	}
	close(INFILE);
#	$i--;
    }

    return $i;
}

sub class_homepage {
    ($tmp_color) = @_;
    $tmp_color++;	
    if (int($tmp_color/2) == ($tmp_color/2)) {
	$class_home = "left";
    } else {
	$class_home = "left_alter_home";
    }
    return $class_home;
}

sub update_homepage {

if (-f "$path$dirinc$dirsep$incgeneral") {

    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    print "Updating stats homepage           \n";
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

#    &load_basic_stats if ($nb_stats_run eq '' || $nb_stats_run == 0);

    ### Pages
    $update_homepage = 1;
    $file_home_hits = "home-hits";
    $file_home_page = "home-pages";
    $file_home_host = "home-hosts";
    $file_home_trafic = "home-trafic";
    $file_home_script = "home-scripts";
    $file_home_rss = "home-rss";
    $file_home_users = "home-users";
    $file_home_error = "home-error";
    $file_home_refer = "home-refer";
    $file_home_session = "home-session";
    $file_home_newfile = "home-newfile";
    $file_home_spam = "home-spam";

#    if ($mail_format == 1 && $spam_found != 0) {
#    if ($mail_format == 1) {
#	$i = &Load_DailyData($spam,$dirdata);
#	$map_spam_graph = &MakeGraph($i,$spammax,$unit,$start_date,$xmax_home,$ymax_home,$file_home_spam,'',0,'Spam',0,1,\@tabspam,\@tabreq,\@tabmm,\@tabdoc,\@tabtrafic,\@tabscript,\@tabuser);
#    }

    if ($fly_set == 1) {
	if (-f "$path$dirdata$dirsep$filerssdaily" && $rss_file ne '') {
	    $i = &Load_DailyData($filerssdaily,$dirdata,0); # Use the first RSS as default
	    $map_rss_graph = &MakeGraph($i,$rssmax,$unit,$start_date,$xmax_home,$ymax_home,$file_home_rss,'',0,$rss_file[0],0,1,\@tabrss,\@tabreq,\@tabmm,\@tabdoc,\@tabtrafic,\@tabscript,\@tabuser);
	}

	$i = &Load_DailyData($datafile,$dirdata);

	if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	    $map_page_graph = &MakeGraph($i,$accessmax,$unit,$start_date,$xmax_home,$ymax_home,$file_home_page,$dirpage,0,'Accesses',1,1,\@tabacc,\@tabreq,\@tabmm,\@tabdoc,\@tabtrafic,\@tabscript,\@tabuser);
#	$map_hits_graph = &MakeGraph($i,$reqmax,$unit,$start_date,$xmax_home,$ymax_home,$file_home_hits,$dirpage,0,'Requests',1,2,\@tabacc,\@tabreq,\@tabmm,\@tabdoc,\@tabtrafic,\@tabscript,\@tabuser);
	} else {
	    $map_page_graph = &MakeGraph($i,$reqmax,$unit,$start_date,$xmax_home,$ymax_home,$file_home_page,$dirpage,0,'Requests',1,2,\@tabacc,\@tabreq,\@tabmm,\@tabdoc,\@tabtrafic,\@tabscript,\@tabuser) if ($cups_format == 0 || $dhcp_format == 1);
	    $map_page_graph = &MakeGraph($i,$reqmax,$unit,$start_date,$xmax_home,$ymax_home,$file_home_page,$dirpage,0,'Pages',1,2,\@tabacc,\@tabreq,\@tabmm,\@tabdoc,\@tabtrafic,\@tabscript,\@tabuser) if ($cups_format == 1 && $dhcp_format == 0);
	}

	$map_host_graph = &MakeGraph($i,$machmax,$unit,$start_date,$xmax_home,$ymax_home,$file_home_host,$dirsite,0,'Hosts',1,3,\@tabacc,\@tabreq,\@tabmm,\@tabdoc,\@tabtrafic,\@tabscript,\@tabuser);
	$map_trafic_graph = &MakeGraph($i,$traficmax,$unit,$start_date,$xmax_home,$ymax_home,$file_home_trafic,$dirtraffic,0,'Trafic',1,5,\@tabacc,\@tabreq,\@tabmm,\@tabdoc,\@tabtrafic,\@tabscript,\@tabuser);

	$map_script_graph = &MakeGraph($i,$scriptmax,$unit,$start_date,$xmax_home,$ymax_home,$file_home_script,$dirscript,0,'Scripts',1,6,\@tabacc,\@tabreq,\@tabmm,\@tabdoc,\@tabtrafic,\@tabscript,\@tabuser);

	if ($nb_user != 0) {
	    $map_user_graph = &MakeGraph($i,$usermax,$unit,$start_date,$xmax_home,$ymax_home,$file_home_users,$users,0,'Users',1,7,\@tabacc,\@tabreq,\@tabmm,\@tabdoc,\@tabtrafic,\@tabscript,\@tabuser);
	}
    }

#    print "Filetype\n";
    # Filetype

    if (-f "$path$dirinc$dirsep$inchomepage") {
	$scan = 0;
	open(HOSTHOME,"$path$dirinc$dirsep$inchomepage");
	while (<HOSTHOME>) {
	    chop;
	    $scan = 0 if ($_ =~ /^#/);
	    $scan = 1 if ($_ =~ /^#FILETYPE/);
	    if ($scan == 1) {
		next if ($_ =~ /^#/);
		$nb = ($page,$tmp2) = split(/\t/);
		$downloadext{$page} = $tmp2;
	    }
	}
	close(HOSTHOME);

	&load_fileext;
	if ($fly_set == 1) {
	    $filetype_home_pie = "home-filetype".$gifext;
	    ($line_filetype_pie,$map_filetype_pie) = &MakePieChart($filetype_home_pie,$reqtot,\%downloadext,2,0,"$dirlist$dirsepurl$filetype$htmlext",$rayon_home);
	}

	# Status code

	$scan = 0;
	$found_status = 0;
	open(HOSTHOME,"$path$dirinc$dirsep$inchomepage") || &error_exit("Error, unable to open $path$dirinc$dirsep$inchomepage");
	while (<HOSTHOME>) {
	    chop;
	    $scan = 0 if ($_ =~ /^#/);
	    $scan = 1 if ($_ =~ /^#STATUS/);
	    if ($scan == 1) {
		next if ($_ =~ /^#/);
		$nb = ($status,$tmp2) = split(/\t/);
		$status_code{$status} = $tmp2;
		$found_status = 1;
	    }
	}
	close(HOSTHOME);

	if ($fly_set == 1) {
	    if ($found_status == 1) {
		$status_home_pie = "home-status".$gifext;
		($line_status_pie,$map_status_pie) = &MakePieChart($status_home_pie,$loglines,\%status_code,5,0,"$dirlist$dirsepurl$incstatus$htmlext",$rayon_home);
	    }
	}

	# Directories
	$scan = 0;
	open(HOSTHOME,"$path$dirinc$dirsep$inchomepage") || &error_exit("Error, unable to open $path$dirinc$dirsep$inchomepage");
	while (<HOSTHOME>) {
	    chop;
	    $scan = 0 if ($_ =~ /^#/);
	    $scan = 1 if ($_ =~ /^#DIRECTORY/);
	    if ($scan == 1) {
		next if ($_ =~ /^#/);
		$nb = ($repert,$tmp2) = split(/\t/);
		$freqrachome{$repert} = $tmp2;
	    }
	}
	close(HOSTHOME);

	# City

	if ($geoipcity == 1) {

	    $skip_city = 0;
	    $filecity_ajax = $filecity."_search";

	    $skip_city = 1;
	    $skip_city = 0 if (-f "$path$dirinc$dirsep$filecity_ajax$txtext" || -f "$path$dirinc$dirsep$filecity_ajax");
	    if (-f "$path$dirinc$dirsep$filecity_ajax$txtext") {
		$skip_city = 1 if (-z "$path$dirinc$dirsep$filecity_ajax$txtext");
	    }
	    if (-f "$path$dirinc$dirsep$filecity_ajax") {
		$skip_city = 1 if (-z "$path$dirinc$dirsep$filecity_ajax");
	    }

	    $scan = 0;
	    if ($skip_city == 0) {
	    open(HOSTHOME,"$path$dirinc$dirsep$inchomepage") || &error_exit("Error, unable to open $path$dirinc$dirsep$inchomepage");
	    while (<HOSTHOME>) {
		chop;
		$scan = 0 if ($_ =~ /^#/);
		$scan = 1 if ($_ =~ /^#COUNTRYCITY/);
		$scan = 2 if ($_ =~ /^#CITY/);
		if ($scan == 1) {
		    next if ($_ =~ /^#/);
		    $nb = ($pays,$tmp2) = split(/\t/);
		    $serverpayscity{$pays} = $tmp2;
		}
		if ($scan == 2) {
		    next if ($_ =~ /^#/);
		    $nb = ($pays,$tmp2) = split(/\t/);
		    $citylist{$pays} = $tmp2;
		    $tmp = $pays;
		    $tmp =~ s/://;
		    $found_city_list{$tmp} = 1;
#		    print "$pays - $tmp - $found_city_list{$tmp}\n";
		}
	    }
	    close(HOSTHOME);
	    }
	}

	# Country

	&load_countries_map;

	$scan = 0;
	open(HOSTHOME,"$path$dirinc$dirsep$inchomepage") || &error_exit("Error, unable to open $path$dirinc$dirsep$inchomepage");
	while (<HOSTHOME>) {
	    chop;
	    $scan = 0 if ($_ =~ /^#/);
	    $scan = 1 if ($_ =~ /^#COUNTRY/);
	    if ($scan == 1) {
		next if ($_ =~ /^#/);
		$nb = ($pays,$tmp2) = split(/\t/);
		$serverpays{$pays} = $tmp2;
	    }
	}
	close(HOSTHOME);
	
	$pays_home_pie = "home-country".$gifext;

	$tmp = $serverunique+$locserver if ($localonly != 1);
	$tmp = $locserver if ($localonly == 1);

	if ($fly_set == 1) {
	    ($line_pays_pie,$map_country_pie) = &MakePieChart($pays_home_pie,$tmp,\%serverpays,3,0,"$dirpays$dirsepurl$filepays",$rayon_home) if ($geoipcity == 0);
	    ($line_pays_pie,$map_country_pie) = &MakePieChart($pays_home_pie,$tmp,\%serverpayscity,3,0,"$dirpays$dirsepurl$filepays",$rayon_home) if ($geoipcity == 1);
	}

	# Download

	if ($notrafic == 0 && $totsize != 0) {
	    $scan = 0;
	    open(HOSTHOME,"$path$dirinc$dirsep$inchomepage") || &error_exit("Error, unable to open $path$dirinc$dirsep$inchomepage");
	    $count = 1;
	    while (<HOSTHOME>) {
		chop;
		$scan = 0 if ($_ =~ /^#/);
		$scan = 1 if ($_ =~ /^#DOWNLOAD/);
		if ($scan == 1) {
		    next if ($_ =~ /^#/);
		    $nb = ($page,$tmp2,$tmp3) = split(/\t/);
		    $downloadunit[$count] = $tmp2;
		    $downloadrange2{$page} = $tmp3;
		    $count++;
		}
	    }
	    close(HOSTHOME);
	
	    $download_home_pie = "home-download".$gifext;
#	    $tmp = $totsize*1024*1024;
	    $tmp = $totsize;
	    if ($fly_set == 1) {
		($line_download_pie,$map_download_pie) = &MakePieChart($download_home_pie,$tmp,\%downloadrange2,6,1,"$dirlist$dirsepurl$dirdownload$htmlext",$rayon_home);
	    }
	}
    }


    # Error

    if (-f "$path$dirinc$dirsep$dayerror") {
	$i = &Load_DailyData($dayerror,$dirinc) if ($fly_set == 1);
	$count = 1;
	$home_error_lines = "<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
	$home_error_lines .= "<thead>\n";

	$home_error_lines .= "<TR><TH class=\"table-sortable:default\">&nbsp;Error&nbsp;</TH>\n";
	$home_error_lines .= "<TH class=\"table-sortable:numeric\">&nbsp;Occurence&nbsp;</TH></TR>\n";
	$home_error_lines .= "</thead>\n<tbody>\n";

	open(INFILE, "$path$dirinc$dirsep$incerror") || &error_exit("Error, unable to open $incerror",1);
	$a = (<INFILE>);
	($tmp,$tmp1,$tmp2,$tmp3,$start_date) = split(/\t/,$a);
#	($start_date) = split(/\t/,$a);
	while (<INFILE>) {
	    chop;
	    ($err,$nb) = split(/\t/);
	    $home_error_lines .= "<TR><TD CLASS=\"left\">$err</TD><TD CLASS=\"right\">$nb</TD></TR>\n" if ($count <= $top_home);
	    $count++;
	}
	close(INFILE);
	$home_error_lines .= "</tbody></TABLE>";
	if ($fly_set == 1) {
	    $map_error_graph = &MakeGraph($i,$errormax,$unit,$start_date,$xmax_home,$ymax_home,$file_home_error,$dirscript,0,'Occurence',0,1,\@taberror,\@tabreq,\@tabmm,\@tabdoc,\@tabtrafic,\@tabscript,\@tabuser);
	}
    }

    # Browser

    if (-f "$path$dirinc$dirsep$incbrowser") {
	$browser_home_pie = "home-browser".$gifext;
	$os_home_pie = "home-os".$gifext;

	open(INFILE, "$path$dirinc$dirsep$incbrowser") || &error_exit("Error, unable to open $incbrowser",1);
	$a = (<INFILE>);
	($tmp,$tmp1,$tmp2,$start_date) = split(/\t/,$a);
	while (<INFILE>) {
	    chop;
	    ($err,$nb) = split(/\t/);
	    ($err) = split(/[\/ ]/,$err);
	    $browserhome{$err} += $nb;
	    $count++;
	}
	close(INFILE);
	$count = 1;
	open(INFILE, "$path$dirinc$dirsep$incos") || &error_exit("Error, unable to open $incos",1);
	$count_os = (<INFILE>);
	chop($count_os);
	while (<INFILE>) {
	    chop;
	    $nb1 = ($err,$nb) = split(/\t/);
	    $oshome{$err} = $nb if (($count <= 5 && $fly_set == 1) || $fly_set == 0);
	    $count++;
	}
	close(INFILE);
	if ($fly_set == 1) {
	    ($line_browser_pie,$map_browser_pie) = &MakePieChart($browser_home_pie,$count_browser,\%browserhome,7,0,"$dirlist$dirsepurl$agent",$rayon_home);
	    ($line_os_pie,$map_os_pie) = &MakePieChart($os_home_pie,$count_os,\%oshome,8,0,"$dirlist$dirsepurl$agent",$rayon_home);
	}

    }

    # Keywords
   if (-f "$path$dirinc$dirsep$increfkey") {
       $count = 1;
	open(INFILE, "$path$dirinc$dirsep$increfkey") || &error_exit("Error, unable to open $increfkey",1);
	while (<INFILE>) {
	    chop;
	    $nb = ($tmp,$tmp1) = split(/\t/);
	    if ($nb == 3 && $count <= 10) {
		$w{$tmp} = $tmp1;
		$count++;
	    }
	}
	close(INFILE);

	($line_search_cloud,$line_search_cloud_sort) = &MakeCloud(\%w,'',1);
    }

    # Referer
    $datafile_refer = "time-refer";
    if (-f "$path$dirdata$dirsep$datafile_refer") {
	$i = &Load_DailyData($datafile_refer,$dirdata) if ($fly_set == 1);
	$count = 1;
	$home_refer_lines = "<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
	$home_refer_lines .= "<thead>\n";
	$home_refer_lines .= "<TR><TH class=\"table-sortable:default\">&nbsp;Referer&nbsp;</TH>\n";
	$home_refer_lines .= "<TH class=\"table-sortable:numeric\">&nbsp;Hosts&nbsp;</TH></TR>\n";
	$home_refer_lines .= "</thead>\n<tbody>\n";
	open(INFILE,"$path$dirinc$dirsep$increfsites") || &error_exit("Error, unable to open $path$dirinc$dirsep$increfersites",1);
	$tmp = (<INFILE>);
	while (<INFILE>) {
	    chop;
	    ($site,$tmp,$tmp1,$tmp2) = split(/\s/);
	    $tabreferhome{$site} = $tmp1 if ($tmp1 ne '');
	    $tabreferhome{$site} = $tmp2 if ($tmp1 eq '' && $tmp2 ne '');
	}
	close(INFILE);
	foreach $adresse (&reverse_sort_by_value(*tabreferhome)) {
	    $home_refer_lines .= "<TR><TD CLASS=\"left\">$adresse</TD><TD CLASS=\"right\">$tabreferhome{$adresse}</TD></TR>\n" if ($count <= $top_home);
	    $count++;
	}

	$home_refer_lines .= "</tbody></TABLE>";

	if ($fly_set == 1) {
	    $tmp = $tabnamerefer;
	    $tmp =~ s/$htmlext//;
	    $map_refer_graph = &MakeGraph($i,$refermax,$unit,$start_date,$xmax_home,$ymax_home,$file_home_refer,$tmp,0,'Referer hosts',0,1,\@tabrefer,\@tabreq,\@tabmm,\@tabdoc,\@tabtrafic,\@tabscript,\@tabuser);
	}
    }

    # Session

    $incsession = "session";
    $incsessionmult = "sessionmult";
    if (-f "$path$dirinc$dirsep$incsession") {
	$i = &Load_DailyData($incsession,$dirinc) if ($fly_set == 1);
	$count = 1;
	$home_session_lines = "<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
	$home_session_lines .= "<thead>\n";

	$home_session_lines .= "<TR><TH class=\"table-sortable:default\">&nbsp;Hosts&nbsp;</TH>\n";
	$home_session_lines .= "<TH class=\"table-sortable:numeric\">&nbsp;Sessions&nbsp;</TH></TR>\n";
	$home_session_lines .= "</thead>\n<tbody>\n";
	open(INFILE,"$path$dirinc$dirsep$incsessionmult") || &error_exit("Error, unable to open $path$dirinc$dirsep$insessionmult",1);
	while (<INFILE>) {
	    chop;
	    ($adresse,$tmp) = split(/\t/);
	    $home_session_lines .= "<TR><TD CLASS=\"left\">$adresse</TD><TD CLASS=\"right\">$tmp</TD></TR>\n" if ($count <= $top_home);
	    $count++;
	}
	close(INFILE);

	$home_session_lines .= "</tbody></TABLE>";

	if ($fly_set == 1) {
	    $map_session_graph = &MakeGraph($i,$sessionmax,$unit,$start_date,$xmax_home,$ymax_home,$file_home_session,$dirsession,0,'Sessions',0,1,\@tabsession,\@tabreq,\@tabmm,\@tabdoc,\@tabtrafic,\@tabscript,\@tabuser);
	}
    }


    # Spam
    if ($mail_format == 1) {
	if (-f "$path$dirinc$dirsep$spam") {
	    $spam_found = 0;
	    $spam_found_ext = 0;
	    $spam_found_local = 0;
	    $i = &Load_DailyData($spam,$dirdata) if ($fly_set == 1);
	    $count = 1;

	    open(INFILE,"$path$dirinc$dirsep$spam") || &error_exit("Error, unable to open $path$dirinc$dirsep$spam");
	    while (<INFILE>) {
		($page,$tmp,$tmp1) = split(/\t/);
		if ($tmp1 eq '' && $tmp ne '') {
		    $spam_found += $tmp;
		    if ($page =~ /\@/) {
			$spam_found_ext += $tmp;
		    } else {
			$spam_found_local += $tmp;
		    }
		}
	    }
	    close(INFILE);

	    if ($fly_set == 1) {
		$map_spam_graph = &MakeGraph($i,$spammax,$unit,$start_date,$xmax_home,$ymax_home,$file_home_spam,$spam,0,'Spam',0,1,\@tabspam,\@tabreq,\@tabmm,\@tabdoc,\@tabtrafic,\@tabscript,\@tabuser);
	    }
	}
    }

    # Destination

    if ($squid_format == 1 || $virtualunique != 0) {
	if (-f "$path$dirinc$dirsep$incssvirtual$txtext") {
	    $count = 1;
	    open(INFILE,"$path$dirinc$dirsep$incssvirtual$txtext") || &error_exit("Error, unable to open $path$dirinc$dirsep$incssvirtual$txtext");
	    while (<INFILE>) {
		next if ($_ =~ /^#/);
		($vserver,$tmp) = split('\s+');
		$ssdomvirtualreq2{$vserver} = $tmp if ($count <= 10);
		$count++;
	    }
	    close (INFILE);
	}
	($line_dest_cloud,$line_dest_cloud_sort) = &MakeCloud(\%ssdomvirtualreq2,'',1);
   }


    # Squid

    if ($squid_format == 1) {
	$count_peersize = 0;
	$squid_home_pie = "home-squid".$gifext;
	open(INFILE, "$path$dirinc$dirsep$incproxystatus") || &error_exit("Error, unable to open $incproxystatus",1);
	while (<INFILE>) {
	    chop;
	    ($tmp,$tmp1,$tmp2,$tmp3) = split(/\t/);
	    $peer_size{$tmp} = $tmp3;
#	    $count++;
	    $count_peersize += $tmp3;
	}
	close(INFILE);
	if ($fly_set == 1) {
	    ($line_squid_pie,$map_squid_pie) = &MakePieChart($squid_home_pie,$count_peersize,\%peer_size,7,1,"$dirproxy$dirsepurl$filesquid",$rayon_home);
	}
    }

    # Screensize

    if (-f "$path$dirinc$dirsep$incscreensize") {
	$count_screensize = 0;
	$count = 0;
	$screensize_home_pie = "home-screensize".$gifext;
	open(INFILE, "$path$dirinc$dirsep$incscreensize") || &error_exit("Error, unable to open $incscreensize",1);
	while (<INFILE>) {
	    chop;
	    ($tmp1,$tmp,$tmp3) = split(/\t/);
	    if ($tmp1 eq "screen") {
		$screensize{$tmp} = $tmp3 if ($count <= $top_home);
		$count++;
		$count_screensize += $tmp3;
	    }
	}
	close(INFILE);
	if ($fly_set == 1) {
	    ($line_screensize_pie,$map_screensize_pie) = &MakePieChart($screensize_home_pie,$count_screensize,\%screensize,7,0,"$dirlist$dirsepurl$filescreensize",$rayon_home);
	}

    }

    # Documents

    $incnewfile = "newfile";
    if (-f "$path$dirinc$dirsep$incnewfile") {
	$i = &Load_DailyData($incnewfile,$dirinc) if ($fly_set == 1);
	$count = 1;
	$home_url_lines = "<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
	$home_url_lines .= "<thead>\n";

	$home_url_lines .= "<TR><TH class=\"table-sortable:default\">&nbsp;Number of files&nbsp;</TH>\n";
	$home_url_lines .= "<TH class=\"table-sortable:numeric\">&nbsp;New files&nbsp;</TH></TR>\n";
	$home_url_lines .= "</thead>\n<tbody>\n";
	$home_url_lines .= "</tbody></TABLE>";
	if ($fly_set == 1) {
	    $map_url_graph = &MakeGraph($i,$newfilemax,$unit,$start_date,$xmax_home,$ymax_home,$file_home_newfile,$dirdocument,0,'Updated files',0,1,\@nbmodif,\@tabreq,\@tabmm,\@tabdoc,\@tabtrafic,\@tabscript,\@tabuser);
	}
    }

   # Heatmap

   if (-f "$path$dirinc$dirsep$fileheatmap") {

	$count2 = 0;
	$count = 0;
	$heatmap_home_pie = "home-heatmap".$gifext;
	open(INFILE, "$path$dirinc$dirsep$fileheatmap");
	while (<INFILE>) {
	    chop;
	    next if ($_ =~ /^#/);
	    ($url,$val) = split('\s+');
	    $heat_home{$url} = $val if ($count <= $top_home);
	    $count2 += $val;
	    $count++;
	}
	close(INFILE);
	if ($fly_set == 1) {
	    ($line_heatmap_pie,$map_heatmap_pie) = &MakePieChart($heatmap_home_pie,$count2,\%heat_home,7,0,"$dirlist$dirsepurl$fileheatmap$htmlext",$rayon_home);
	}
    }

    # Virus

   if (-f "$path$dirinc$dirsep$virusdef") {

	$count2 = 0;
	$count = 0;
	$virus_home_pie = "home-virus".$gifext;
	open(INFILE, "$path$dirinc$dirsep$virusdef");
	while (<INFILE>) {
	    chop;
	    next if ($_ =~ /^#/);
	    ($url,$val,$val2,$val3) = split('\t');
	    if ($val3 ne '') {
		$virus_home{$url} = $val if ($count <= $top_home);
		$count2 += $val;
		$count++;
	    }
	}
	close(INFILE);
	if ($fly_set == 1) {
	    ($line_virus_pie,$map_virus_pie) = &MakePieChart($virus_home_pie,$count2,\%virus_home,7,0,"$dirlist$dirsepurl$filevirus",$rayon_home);
	}
    }

   # Real
    $inchour = "real";
    if (-f "$path$dirinc$dirsep$inchour") {
	open(INFILE, "$path$dirinc$dirsep$inchour");
	$tmp = (<INFILE>);
	($tmp1,$tmp2) = split(/\t/,$tmp);
	($tmp3,$tmp5,$tmp6) = split(/:/,$tmp2);
	($dayreal_csv,$tmp4,$tmp7) = split(/:/,$tmp1);
	$dayreal_csv =~ s/\// /g;

	$tmp = (<INFILE>);
	($req_tot,$access_day,$nbfilejour,$script,$m_tot,$m_new,$user_day,$totsize_day,$unit) = split(/\t/,$tmp);
	close(INFILE);

	$link = "$path$lang[0]$dirsep$dirdate$dirsep$file_now";

	($unit_div,$unit) = &Return_Unit($totsize_day,0);
	$tmp = int(10*$totsize_day/$unit_div)/10;

	$tmp_color = 0;
	$home_real_lines = "<table><tr>\n";
	$home_real_lines .= "<th colspan=2 ALIGN=center>$dayreal_csv<BR>";
	$home_real_lines .= "<A HREF=\"<!-- langhome -->$dirsep$dirdate$dirsep$file_now\">" if (-f $link);
	$home_real_lines .= "$tmp4:$tmp7 - $tmp5:$tmp6";
	$home_real_lines .= "</A>" if (-f $link);
	$home_real_lines .= "</th></tr>\n";
	$class_home = &class_homepage($tmp_color);
	$home_real_lines .= "<tr><td class=\"$class_home\">Requests</td><td class=\"$class_home\">$req_tot</td></tr>\n";
	if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	    $class_home = &class_homepage($tmp_color);
	    $home_real_lines .= "<tr><td class=\"$class_home\">Accesses</td><td class=\"$class_home\">$access_day</td></tr>\n";
	}
	if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	    $class_home = &class_homepage($tmp_color);
	    $home_real_lines .= "<tr><td class=\"$class_home\">Documents</td><td class=\"$class_home\">$nbfilejour</td></tr>\n";
	}
	if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	    $class_home = &class_homepage($tmp_color);
	    $home_real_lines .= "<tr><td class=\"$class_home\">Scripts</td><td class=\"$class_home\">$script</td></tr>\n";
	}
	$class_home = &class_homepage($tmp_color);
	$home_real_lines .= "<tr><td class=\"$class_home\">Hosts</td><td class=\"$class_home\">$m_tot</td></tr>\n";
#	$class_home = &class_homepage($tmp_color);
#	$home_real_lines .= "<tr><td class=\"$class_home\">New_Hosts</td><td class=\"$class_home\">$m_new</td></tr>\n";
	if ($user_day != 0) {
	    $class_home = &class_homepage($tmp_color);
	    $home_real_lines .= "<tr><td class=\"$class_home\">Users</td><td class=\"$class_home\">$user_day</td></tr>\n";
	}
	if ($notrafic == 0) {
	    $class_home = &class_homepage($tmp_color);
	    $home_real_lines .= "<tr><td class=\"$class_home\">Traffic</td><td class=\"$class_home\">$tmp $unit</td></tr>\n";
	}
	$home_real_lines .= "</table>\n";
    }

    
    # Hourly
    $inchour = "hour";
    if (-f "$path$dirinc$dirsep$inchour") {
	open(INFILE, "$path$dirinc$dirsep$inchour");
	$tmp = (<INFILE>);
	($tmp1,$tmp2) = split(/\t/,$tmp);
	($tmp3,$tmp5,$tmp6) = split(/:/,$tmp2);
	($dayhour_csv,$tmp4,$tmp7) = split(/:/,$tmp1);
	$dayhour_csv =~ s/\// /g;

	$tmp = (<INFILE>);
	($req_tot,$access_day,$nbfilejour,$script,$m_tot,$m_new,$user_day,$totsize_day,$unit) = split(/\t/,$tmp);
	close(INFILE);

	$link = "$path$lang[0]$dirsep$dirdate$dirsep$filenamehour";

	($unit_div,$unit) = &Return_Unit($totsize_day);
	$tmp = int(10*$totsize_day/$unit_div)/10;

	$tmp_color = 0;
	$home_hourly_lines = "<table border=0><tr>\n";
	$home_hourly_lines .= "<th colspan=2 ALIGN=center>$dayhour_csv<BR>";
	$home_hourly_lines .= "<A HREF=\"<!-- langhome -->$dirsep$dirdate$dirsep$filenamehour\">" if (-f $link);
	$home_hourly_lines .= "$tmp4:$tmp7 - $tmp5:$tmp6";
	$home_hourly_lines .= "</A>" if (-f $link);
	$home_hourly_lines .= "</th></tr>\n";
	$class_home = &class_homepage($tmp_color);
	$home_hourly_lines .= "<tr><td class=\"$class_home\">Requests</td><td class=\"$class_home\">$req_tot</td></tr>\n";
	if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	    $class_home = &class_homepage($tmp_color);
	    $home_hourly_lines .= "<tr><td class=\"$class_home\">Accesses</td><td class=\"$class_home\">$access_day</td></tr>\n";
	}
	if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	    $class_home = &class_homepage($tmp_color);
	    $home_hourly_lines .= "<tr><td class=\"$class_home\">Documents</td><td class=\"$class_home\">$nbfilejour</td></tr>\n";
	}
	if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	    $class_home = &class_homepage($tmp_color);
	    $home_hourly_lines .= "<tr><td class=\"$class_home\">Scripts</td><td class=\"$class_home\">$script</td></tr>\n";
	}
	$class_home = &class_homepage($tmp_color);
	$home_hourly_lines .= "<tr><td class=\"$class_home\">Hosts</td><td class=\"$class_home\">$m_tot</td></tr>\n";
#	$class_home = &class_homepage($tmp_color);
#	$home_hourly_lines .= "<tr><td class=\"$class_home\">New_Hosts</td><td class=\"$class_home\">$m_new</td></tr>\n";
	if ($user_day != 0) {
	    $class_home = &class_homepage($tmp_color);
	    $home_hourly_lines .= "<tr><td class=\"$class_home\">Users</td><td class=\"$class_home\">$user_day</td></tr>\n";
	}
	if ($notrafic == 0) {
	    $class_home = &class_homepage($tmp_color);
	    $home_hourly_lines .= "<tr><td class=\"$class_home\">Traffic</td><td class=\"$class_home\">$tmp $unit</td></tr>\n";
	}
	$home_hourly_lines .= "</table>\n";
    }

    # Daily

    open(INFILE, "$path$dirdata$dirsep$datafile") || &error_exit("Error, unable to open $datafile",1);
    while (<INFILE>) {
    ($jour,$month,$year,$m_tot,$m_new,$m_dom,$req_tot,$req_dom,$access_day,$totsize_day,$tothtmlsize,$domsize_day,$script,$pays,$nbfilejour,$user_day) = split('\s+');
    }
    close(INFILE);

    $lastday = "$jour $month $year";
    $currentmonth = $month;
    $currentyear = $year;

    $dirresume = $year."-".$month."-".$jour;
    $link = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$menu";
    $tmp_color = 0;

#    $tmp = $totsize_day;
#    $tmp2 = $domsize_day;
#    $unit = "bytes";



    ($unit_div,$unit2) = &Return_Unit($domsize_day,0);
    $tmp2 = int(10*$domsize_day/$unit_div)/10;

#    if ($totsize_day > 1024) {
#	$tmp = int(10*$totsize_day/1024)/10;
#	$tmp2 = int(10*$domsize_day/1024)/10;
#	$unit = "Kb";
 #   }
#    if ($totsize_day > (1024*1024)) {
#	$tmp = int(10*$totsize_day/(1024*1024))/10;
#	$tmp2 = int(10*$domsize_day/(1024*1024))/10;
#	$unit = "Mb";
 #   }
#    if ($totsize_day > (1024*1024*1024)) {
#	$tmp = int(10*$totsize_day/(1024*1024*1024))/10;
#	$tmp2 = int(10*$domsize_day/(1024*1024*1024))/10;
#	$unit = "Gb";
 #   }
#    if ($totsize_day > (1024*1024*1024*1024)) {
#	$tmp = int(10*$totsize_day/(1024*1024*1024*1024))/10;
#	$tmp2 = int(10*$domsize_day/(1024*1024*1024*1024))/10;
#	$unit = "Tb";
 #   }
	
    $home_daily2_lines = "<table><tr>\n";
    $home_daily2_lines .= "<th colspan=2 ALIGN=center>";
    $home_daily2_lines .= "<A HREF=\"<!-- langhome -->$dirsep$dirdate$dirsep$dirresume$dirsep$menu\">" if (-f $link);
    $home_daily2_lines .= "$jour $month $year";
    $home_daily2_lines .= "</A>" if (-f $link);
    $home_daily2_lines .= "</th></tr>\n";
    $home_daily2_lines .= "<tr><th colspan=2 ALIGN=center>Domain</th></tr>\n";
    $home_daily2_lines .= "<tr><td class=\"$class_home\">Requests</td><td class=\"$class_home\">$req_dom</td></tr>\n";
    $class_home = &class_homepage($tmp_color);
    $home_daily2_lines .= "<tr><td class=\"$class_home\">Hosts</td><td class=\"$class_home\">$m_dom</td></tr>\n";
    if ($notrafic == 0) {
	$class_home = &class_homepage($tmp_color);
	$home_daily2_lines .= "<tr><td class=\"$class_home\">Traffic</td><td class=\"$class_home\">$tmp2 $unit</td></tr>\n";
    }
    $home_daily2_lines .= "</table>\n";

    ($unit_div,$unit) = &Return_Unit($totsize_day,0);
    $tmp = int(10*$totsize_day/$unit_div)/10;

    $tmp_color = 0;
#    $home_daily_lines = "<table cellpadding=0 cellspacing=0 style=\"border:solid 1px #ffddbb;font-size: 100%;\"><tr>\n";
    $home_daily_lines = "<table><tr>\n";
    $home_daily_lines .= "<th colspan=2 ALIGN=center>";
    $home_daily_lines .= "<A HREF=\"<!-- langhome -->$dirsep$dirdate$dirsep$dirresume$dirsep$menu\">" if (-f $link);
    $home_daily_lines .= "$jour $month $year";
    $home_daily_lines .= "</A>" if (-f $link);
    $home_daily_lines .= "</th></tr>\n";
    $class_home = &class_homepage($tmp_color);
    $home_daily_lines .= "<tr><td class=\"$class_home\">Requests</td><td class=\"$class_home\">$req_tot</td></tr>\n";
    if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	$class_home = &class_homepage($tmp_color);
	$home_daily_lines .= "<tr><td class=\"$class_home\">Accesses</td><td class=\"$class_home\">$access_day</td></tr>\n";
    }
    if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	$class_home = &class_homepage($tmp_color);
	$home_daily_lines .= "<tr><td class=\"$class_home\">Documents</td><td class=\"$class_home\">$nbfilejour</td></tr>\n";
    }
    if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	$class_home = &class_homepage($tmp_color);
	$home_daily_lines .= "<tr><td class=\"$class_home\">Scripts</td><td class=\"$class_home\">$script</td></tr>\n";
    }
    $class_home = &class_homepage($tmp_color);
    $home_daily_lines .= "<tr><td class=\"$class_home\">Hosts</td><td class=\"$class_home\">$m_tot</td></tr>\n";
    $class_home = &class_homepage($tmp_color);
    $home_daily_lines .= "<tr><td class=\"$class_home\">New_Hosts</td><td class=\"$class_home\">$m_new</td></tr>\n";
    if ($user_day != 0) {
	$class_home = &class_homepage($tmp_color);
	$home_daily_lines .= "<tr><td class=\"$class_home\">Users</td><td class=\"$class_home\">$user_day</td></tr>\n";
    }
    if ($notrafic == 0) {
	$class_home = &class_homepage($tmp_color);
	$home_daily_lines .= "<tr><td class=\"$class_home\">Traffic</td><td class=\"$class_home\">$tmp $unit</td></tr>\n";
    }
    if ($pays != 0) {
	$class_home = &class_homepage($tmp_color);
	$home_daily_lines .= "<tr><td class=\"$class_home\">Countries</td><td class=\"$class_home\">$pays</td></tr>\n";
    }
    $home_daily_lines .= "</table>\n";

    # Weekly

    $date = &date_intervalle($lastday,-6);
    $scan = 0;

    $m_tot2 = 0;
    $m_new2 = 0;
    $req_tot2 = 0;
    $access_day2 = 0;
    $nbfilejour2 = 0;
    $script2 = 0;
    $user_day2 = 0;
    $totsize_day2 = 0;
    $pays2 = 0;
    open(INFILE, "$path$dirdata$dirsep$datafile") || &error_exit("Error, unable to open $datafile",1);
    while (<INFILE>) {
	($jour,$month,$year,$m_tot,$m_new,$m_dom,$req_tot,$req_dom,$access_day,$totsize_day,$tothtmlsize,$domsize_day,$script,$pays,$nbfilejour,$user_day) = split('\s+');
	next if ($jour !~ /\d/ || $year !~ /\d/);
	$scan = 1 if (&nbday("$jour $month $year") >= &nbday($date));
	if ($scan == 1) {
	    $m_tot2 += $m_tot;
	    $m_new2 += $m_new;
	    $req_tot2 += $req_tot;
	    $access_day2 += $access_day;
	    $nbfilejour2 += $nbfilejour;
	    $script2 += $script;
	    $user_day2 += $user_day;
	    $totsize_day2 += $totsize_day;
	    $pays2 += $pays;
	}
    }
    close(INFILE);
    

    ($unit_div,$unit) = &Return_Unit($totsize_day2,0);
    $tmp = int(10*$totsize_day2/$unit_div)/10;

#   $tmp = $totsize_day2;
#    $unit = "bytes";
#    if ($totsize_day2 > 1024) {
#	$tmp = int(10*$totsize_day2/1024)/10;
#	$unit = "Kb";
 #   }
  #  if ($totsize_day2 > (1024*1024)) {
#	$tmp = int(10*$totsize_day2/(1024*1024))/10;
#	$unit = "Mb";
 #   }
#    if ($totsize_day2 > (1024*1024*1024)) {
#	$tmp = int(10*$totsize_day2/(1024*1024*1024))/10;
#	$unit = "Gb";
 #   }
#    if ($totsize_day2 > (1024*1024*1024*1024)) {
#	$tmp = int(10*$totsize_day2/(1024*1024*1024*1024))/10;
#	$unit = "Tb";
 #   }

    $tmp_color = 0;
    $home_weekly_lines = "<table><tr>\n";
    $home_weekly_lines .= "<th colspan=2 ALIGN=center>$date - $lastday</th></tr>\n";
    $class_home = &class_homepage($tmp_color);
    $home_weekly_lines .= "<tr><td class=\"$class_home\">Requests</td><td class=\"$class_home\">$req_tot2</td></tr>\n";
    if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	$class_home = &class_homepage($tmp_color);
	$home_weekly_lines .= "<tr><td class=\"$class_home\">Accesses</td><td class=\"$class_home\">$access_day2</td></tr>\n";
    }
    if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	$class_home = &class_homepage($tmp_color);
	$home_weekly_lines .= "<tr><td class=\"$class_home\">Documents</td><td class=\"$class_home\">$nbfilejour2</td></tr>\n";
    }
    if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	$class_home = &class_homepage($tmp_color);
	$home_weekly_lines .= "<tr><td class=\"$class_home\">Scripts</td><td class=\"$class_home\">$script2</td></tr>\n";
    }
    $class_home = &class_homepage($tmp_color);
    $home_weekly_lines .= "<tr><td class=\"$class_home\">Hosts</td><td class=\"$class_home\">$m_tot2</td></tr>\n";
    $class_home = &class_homepage($tmp_color);
    $home_weekly_lines .= "<tr><td class=\"$class_home\">New_Hosts</td><td class=\"$class_home\">$m_new2</td></tr>\n";
    if ($user_day2 != 0) {
	$class_home = &class_homepage($tmp_color);
	$home_weekly_lines .= "<tr><td class=\"$class_home\">Users</td><td class=\"$class_home\">$user_day2</td></tr>\n";
    }
    if ($notrafic == 0) {
	$class_home = &class_homepage($tmp_color);
	$home_weekly_lines .= "<tr><td class=\"$class_home\">Traffic</td><td class=\"$class_home\">$tmp $unit</td></tr>\n";
    }
#    $class_home = &class_homepage($tmp_color);
#    $home_weekly_lines .= "<tr><td class=\"$class_home\">Countries</td><td class=\"$class_home\">$pays2</td></tr>\n";
    $home_weekly_lines .= "</table>\n";

    # Monthly
   $scan = 0;

    $m_tot2 = 0;
    $m_new2 = 0;
    $req_tot2 = 0;
    $access_day2 = 0;
    $nbfilejour2 = 0;
    $script2 = 0;
    $user_day2 = 0;
    $totsize_day2 = 0;
    $pays2 = 0;
    open(INFILE, "$path$dirdata$dirsep$datafile") || &error_exit("Error, unable to open $datafile",1);
    while (<INFILE>) {
	($jour,$month,$year,$m_tot,$m_new,$m_dom,$req_tot,$req_dom,$access_day,$totsize_day,$tothtmlsize,$domsize_day,$script,$pays,$nbfilejour,$user_day) = split('\s+');
	$scan = 1 if ($month eq $currentmonth && $year eq $currentyear);
	if ($scan == 1) {
	    $m_tot2 += $m_tot;
	    $m_new2 += $m_new;
	    $req_tot2 += $req_tot;
	    $access_day2 += $access_day;
	    $nbfilejour2 += $nbfilejour;
	    $script2 += $script;
	    $user_day2 += $user_day;
	    $totsize_day2 += $totsize_day;
	    $pays2 += $pays;
	}
    }
    close(INFILE);

    $dirresume = $currentyear."-".$currentmonth;
    $link = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$menu";

    ($unit_div,$unit) = &Return_Unit($totsize_day2,0);
    $tmp = int(10*$totsize_day2/$unit_div)/10;

#  $tmp = $totsize_day2;
#    $unit = "bytes";
#    if ($totsize_day2 > 1024) {
#	$tmp = int(10*$totsize_day2/1024)/10;
#	$unit = "Kb";
 #   }
#    if ($totsize_day2 > (1024*1024)) {
#	$tmp = int(10*$totsize_day2/(1024*1024))/10;
#	$unit = "Mb";
 #   }
#    if ($totsize_day2 > (1024*1024*1024)) {
#	$tmp = int(10*$totsize_day2/(1024*1024*1024))/10;
#	$unit = "Gb";
 #   }
#    if ($totsize_day2 > (1024*1024*1024*1024)) {
#	$tmp = int(10*$totsize_day2/(1024*1024*1024*1024))/10;
#	$unit = "Tb";
 #   }

    $tmp_color = 0;
    $home_monthly_lines = "<table><tr>\n";

    $home_monthly_lines .= "<th colspan=2 ALIGN=center>";
    $home_monthly_lines .= "<A HREF=\"<!-- langhome -->$dirsep$dirdate$dirsep$dirresume$dirsep$menu\">" if (-f $link);
    $home_monthly_lines .= "$currentmonth $currentyear";
    $home_monthly_lines .= "</A>" if (-f $link);
    $home_monthly_lines .= "</th></tr>\n";

#    $home_monthly_lines .= "<th colspan=2 ALIGN=center>$currentmonth $currentyear</th></tr>\n";
    $class_home = &class_homepage($tmp_color);
    $home_monthly_lines .= "<tr><td class=\"$class_home\">Requests</td><td class=\"$class_home\">$req_tot2</td></tr>\n";
    if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	$class_home = &class_homepage($tmp_color);
	$home_monthly_lines .= "<tr><td class=\"$class_home\">Accesses</td><td class=\"$class_home\">$access_day2</td></tr>\n";
    }
    if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	$class_home = &class_homepage($tmp_color);
	$home_monthly_lines .= "<tr><td class=\"$class_home\">Documents</td><td class=\"$class_home\">$nbfilejour2</td></tr>\n";
    }
    if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	$class_home = &class_homepage($tmp_color);
	$home_monthly_lines .= "<tr><td class=\"$class_home\">Scripts</td><td class=\"$class_home\">$script2</td></tr>\n";
    }
    $class_home = &class_homepage($tmp_color);
    $home_monthly_lines .= "<tr><td class=\"$class_home\">Hosts</td><td class=\"$class_home\">$m_tot2</td></tr>\n";
    $class_home = &class_homepage($tmp_color);
    $home_monthly_lines .= "<tr><td class=\"$class_home\">New_Hosts</td><td class=\"$class_home\">$m_new2</td></tr>\n";
    if ($user_day2 != 0) {
	$class_home = &class_homepage($tmp_color);
	$home_monthly_lines .= "<tr><td class=\"$class_home\">Users</td><td class=\"$class_home\">$user_day2</td></tr>\n";
    }
    if ($notrafic == 0) {
	$class_home = &class_homepage($tmp_color);
	$home_monthly_lines .= "<tr><td class=\"$class_home\">Traffic</td><td class=\"$class_home\">$tmp $unit</td></tr>\n";
    }
#    $class_home = &class_homepage($tmp_color);
#    $home_monthly_lines .= "<tr><td class=\"$class_home\">Countries</td><td class=\"$class_home\">$pays2</td></tr>\n";
    $home_monthly_lines .= "</table>\n";

  # Yearly
   $scan = 0;

    $m_tot2 = 0;
    $m_new2 = 0;
    $req_tot2 = 0;
    $access_day2 = 0;
    $nbfilejour2 = 0;
    $script2 = 0;
    $user_day2 = 0;
    $totsize_day2 = 0;
    $pays2 = 0;
    open(INFILE, "$path$dirdata$dirsep$datafile") || &error_exit("Error, unable to open $datafile",1);
    while (<INFILE>) {
	($jour,$month,$year,$m_tot,$m_new,$m_dom,$req_tot,$req_dom,$access_day,$totsize_day,$tothtmlsize,$domsize_day,$script,$pays,$nbfilejour,$user_day) = split('\s+');
	$scan = 1 if ($year eq $currentyear);
	if ($scan == 1) {
	    $m_tot2 += $m_tot;
	    $m_new2 += $m_new;
	    $req_tot2 += $req_tot;
	    $access_day2 += $access_day;
	    $nbfilejour2 += $nbfilejour;
	    $script2 += $script;
	    $user_day2 += $user_day;
	    $totsize_day2 += $totsize_day;
	    $pays2 += $pays;
	}
    }
    close(INFILE);


    ($unit_div,$unit) = &Return_Unit($totsize_day2,0);
    $tmp = int(10*$totsize_day2/$unit_div)/10;

#  $tmp = $totsize_day2;
#    $unit = "bytes";
 #   if ($totsize_day2 > 1024) {
#	$tmp = int(10*$totsize_day2/1024)/10;
#	$unit = "Kb";
 #   }
#    if ($totsize_day2 > (1024*1024)) {
#	$tmp = int(10*$totsize_day2/(1024*1024))/10;
#	$unit = "Mb";
 #   }
#    if ($totsize_day2 > (1024*1024*1024)) {
#	$tmp = int(10*$totsize_day2/(1024*1024*1024))/10;
#	$unit = "Gb";
 #   }
#    if ($totsize_day2 > (1024*1024*1024*1024)) {
#	$tmp = int(10*$totsize_day2/(1024*1024*1024*1024))/10;
#	$unit = "Tb";
 #   }

    $link = "$path$lang[0]$dirsep$dirdate$dirsep$year$dirsep$menu";

    $tmp_color = 0;
    $home_yearly_lines = "<table><tr>\n";
    $home_yearly_lines .= "<th colspan=2 ALIGN=center>";
    $home_yearly_lines .= "<A HREF=\"<!-- langhome -->$dirsep$dirdate$dirsep$year$dirsep$menu\">" if (-f $link);
    $home_yearly_lines .= "$currentyear";
    $home_yearly_lines .= "</A>" if (-f $link);
    $home_yearly_lines .= "</th></tr>\n";
    $class_home = &class_homepage($tmp_color);
    $home_yearly_lines .= "<tr><td class=\"$class_home\">Requests</td><td class=\"$class_home\">$req_tot2</td></tr>\n";
    if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	$class_home = &class_homepage($tmp_color);
	$home_yearly_lines .= "<tr><td class=\"$class_home\">Accesses</td><td class=\"$class_home\">$access_day2</td></tr>\n";
    }
    if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	$class_home = &class_homepage($tmp_color);
	$home_yearly_lines .= "<tr><td class=\"$class_home\">Documents</td><td class=\"$class_home\">$nbfilejour2</td></tr>\n";
    }
    if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	$class_home = &class_homepage($tmp_color);
	$home_yearly_lines .= "<tr><td class=\"$class_home\">Scripts</td><td class=\"$class_home\">$script2</td></tr>\n";
    }
    $class_home = &class_homepage($tmp_color);
    $home_yearly_lines .= "<tr><td class=\"$class_home\">Hosts</td><td class=\"$class_home\">$m_tot2</td></tr>\n";
    $class_home = &class_homepage($tmp_color);
    $home_yearly_lines .= "<tr><td class=\"$class_home\">New_Hosts</td><td class=\"$class_home\">$m_new2</td></tr>\n";
    if ($user_day2 != 0) {
	$class_home = &class_homepage($tmp_color);
	$home_yearly_lines .= "<tr><td class=\"$class_home\">Users</td><td class=\"$class_home\">$user_day2</td></tr>\n";
    }
    if ($notrafic == 0) {
	$class_home = &class_homepage($tmp_color);
	$home_yearly_lines .= "<tr><td class=\"$class_home\">Traffic</td><td class=\"$class_home\">$tmp $unit</td></tr>\n";
    }
#    $class_home = &class_homepage($tmp_color);
#    $home_yearly_lines .= "<tr><td class=\"$class_home\">Countries</td><td class=\"$class_home\">$pays2</td></tr>\n";
    $home_yearly_lines .= "</table>\n";

    ###

    if ($precision == 1) {
	for ($nblang=0;$nblang<=$#lang;$nblang++) {
	    $file_to_open = "$path$homepages[$nblang]";
	    open(LITTLEINDEX,">$file_to_open") || die &error_exit("Error,  unable to open $file_to_open");
	    &CreateLittleIndex(*LITTLEINDEX, eval($Lang{$lang[$nblang]}), $homepages[$nblang], $lang[$nblang]);
	    close (LITTLEINDEX);
	}
    } else {
    
	for ($nblang=0;$nblang<=$#lang;$nblang++) {
	    $file_to_open = $path.$homepages[$nblang];
#	    $tmp = "Lang".$lang[$nblang];

#	    $home_daily_lines =~ s/Requests/$$tmp{'Requests'}/;

#	    print "$home_daily_lines\n";
	    open(MAININDEX,">$file_to_open") || die &error_exit("Error, unable to open $file_to_open");
	    &CreateMainIndex(*MAININDEX, eval($Lang{$lang[$nblang]}), $homepages[$nblang], $lang[$nblang]);
	    close (MAININDEX);
	}
    }

#    if ($opt_w ne '' && $opt_y ne '' && $opt_u == 1) {
#	&update_css_menu;
#    }

#    if ($opt_y eq '') {
#	&update_css_menu;
#    }

}
}


#################################################################
####         Check if other stats have been built         #######
#################################################################

sub LoadLocconf {
    local($locconf) = @_;
    local(@oldlines,$i,$tmp,$w3perlloc,$abort);

    $w3perlloc = "$pathinit$dirress$dirsepurl$diradmin$dirsepurl$locconf";

    if (-f $w3perlloc && -r $w3perlloc) {
	open(CONFLOC,$w3perlloc);
	@oldlines = (<CONFLOC>);
	close(CONFLOC);
    }

    foreach $oldline (@oldlines) {
	($tmp) = split(/\t/,$oldline);
	$pos = rindex($tmp,$dirsep);
	$tmp = substr($tmp,$pos+1,length($tmp));
	push(@lines,$tmp) if (-f "$pathinit$dirconfig$dirsep$tmp");
    }

    $nb_stats_run = -1;
    for ($i=0;$i<=$#lines;$i++) {
	open(FILE,"$pathinit$dirconfig$dirsep$lines[$i]");
	$abort = 0;
	while (<FILE>) {
	    if (/^\$logfile_format\s+=\s+\"/) {
		($tmp,$log_sum) = split(/=/);
		$log_sum =~ s/\#.*//;
		$log_sum =~ s/\s+//g;
		$log_sum =~ s/[\";]//g;
	    }
	    if (/^\$path\s+/) {
		($tmp,$output_sum) = split(/=/);
		$output_sum =~ s/\#.*//;
		$output_sum =~ s/\s+//g;
		$output_sum =~ s/[\";]//g;
		if (-f "$output_sum$dirinc$dirsep$incgeneral" && $output_sum ne $path) {
		    $nb_stats_run++;
		    $output_sum[$nb_stats_run] = $output_sum;
		    $config_sum[$nb_stats_run] = $lines[$i];
		} else {
		    $abort = 1;
		}
	    }

	    if ($abort == 0) {
		if (/^\$localserver\s+=\s+\"/) {
		    ($tmp,$www_sum[$nb_stats_run]) = split(/=/);
		    $www_sum[$nb_stats_run] =~ s/\#.*//;
		    $www_sum[$nb_stats_run] =~ s/\s+//g;
		    $www_sum[$nb_stats_run] =~ s/[\";]//g;

		    $log_sum[$nb_stats_run] = $log_sum;
		}
		if (/^\$localhost\s+=\s+\"/) {
		    ($tmp,$localhost_sum[$nb_stats_run]) = split(/=/);
		    $localhost_sum[$nb_stats_run] =~ s/\#.*//;
		    $localhost_sum[$nb_stats_run] =~ s/\s+//g;
		    $localhost_sum[$nb_stats_run] =~ s/[\";]//g;
		}
		if (/^\$localserver_port\s+=\s+\d+;/) {
		    ($tmp,$localserver_port_sum[$nb_stats_run]) = split(/=/);
		    $localserver_port_sum[$nb_stats_run] =~ s/\#.*//;
		    $localserver_port_sum[$nb_stats_run] =~ s/\s+//g;
		    $localserver_port_sum[$nb_stats_run] =~ s/[\";]//g;
		}
#		if (/^\$defaulthomepage\s+=\s+\"/) {
		if (/^\$defaulthomepage\s+=\s+\"(.*)\"/) {
		    $defaulthome_sum[$nb_stats_run] = $1;
		}
		if (/^\$localserver_protocol\s+=\s+\"\w+\";/ && $localserver_protocol_sum[$nb_stats_run] eq '') {
		    ($tmp,$localserver_protocol_sum[$nb_stats_run]) = split(/=/);
		    $localserver_protocol_sum[$nb_stats_run] =~ s/\#.*//;
		    $localserver_protocol_sum[$nb_stats_run] =~ s/\s+//g;
		    $localserver_protocol_sum[$nb_stats_run] =~ s/[\";]//g;
		}
		if (/^\$linkpath_url\s+=\s+\"/) {
		    ($tmp,$linkpath_url_sum[$nb_stats_run]) = split(/=/);
		    $linkpath_url_sum[$nb_stats_run] =~ s/\#.*//;
		    $linkpath_url_sum[$nb_stats_run] =~ s/\s+//g;
		    $linkpath_url_sum[$nb_stats_run] =~ s/[\";]//g;
		}		

	    }
	}
	close(FILE);

	$remote_output = 0;
	$remote_output = 1 if ($www_sum[$nb_stats_run] eq $localhost_sum[$nb_stats_run]);
	if ($abort == 0 && $nb_stats_run != -1) {
	    if ($remote_output == 1) {
		# remote host
		$link_other_stats[$nb_stats_run] = "$localserver_protocol_sum[$nb_stats_run]://$www_sum[$nb_stats_run]";
		$link_other_stats[$nb_stats_run] .= ":$localserver_port_sum[$nb_stats_run]" if ($localserver_port_sum[$nb_stats_run] != 80 && $localserver_port_sum[$nb_stats_run] ne '');
		$link_other_stats[$nb_stats_run] .= "$linkpath_url_sum[$nb_stats_run]$defaulthome_sum[$nb_stats_run]";
	    } else {
		$link_other_stats[$nb_stats_run] = "$linkpath_url_sum[$nb_stats_run]$defaulthome_sum[$nb_stats_run]";
	    }
	}


# Check if local or remote output
#	if ($abort == 0 && $nb_stats_run != -1) {

#	    $rcode = &check_external_link($localhost,$localhost_port,$linkpath_url_sum[$nb_stats_run]);

#	    if ($rcode != 200 && $rcode != 401) {
		# remote host
#		$rcode = &check_external_link($www_sum[$nb_stats_run],$localserver_port,$linkpath_url_sum[$nb_stats_run]);
#		$link_other_stats[$nb_stats_run] = "$localserver_protocol://$www_sum[$nb_stats_run]";
#		$link_other_stats[$nb_stats_run] .= ":$localserver_port" if ($localserver_port != 80);
#		$link_other_stats[$nb_stats_run] .= "$linkpath_url_sum[$nb_stats_run]$defaulthome_sum[$nb_stats_run]";
#	    } else {
#		$link_other_stats[$nb_stats_run] = "$linkpath_url_sum[$nb_stats_run]$defaulthome_sum[$nb_stats_run]";
#	    }
#	}

    }

}


#################################################################
####                   Homepage                           #######
#################################################################

sub CreateLittleIndex {
#  local(*FOUT,*L, $H, $I, $J) = @_;
  local(*FOUT,*L, $H, $I) = @_;
  local($count);

  print FOUT "$doctype\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Stats_about_host'} $localserver </TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<META NAME=\"ROBOTS\" CONTENT=\"NOINDEX\">\n";
  print FOUT "<META NAME=\"ROBOTS\" CONTENT=\"NOFOLLOW\">\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";

  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,0);

  print FOUT "</HEAD>\n";

  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";

  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,0);

  print FOUT "<TABLE><TR>";
  print FOUT "<TD CLASS=\"left\">$L{'Total_number_of_requests'} ($L{'all_sites'})</TD><TD CLASS=\"right\">$reqtot\n</TD>";
  print FOUT "</TR><TR>";
  print FOUT "<TD CLASS=\"left\">$L{'Total_number_of_requests'} $L{'from_dom'} <I>$localdomainename</I></TD><TD CLASS=\"right\">$reqdomtot\n</TD>" if ($locallog != 0 && $locserver != 0);
  print FOUT "</TR><TR>";
  print FOUT "<TD CLASS=\"left_alter\">$L{'Number_of_different_sites'}</TD><TD CLASS=\"right_alter\"> $serveruniquetot\n</TD>";
  print FOUT "</TR><TR>";
  print FOUT "<TD CLASS=\"left\">$L{'Number_of_pages_read'}</TD><TD CLASS=\"right\">$access\n</TD>";
  print FOUT "</TR><TR>";
  print FOUT "<TD CLASS=\"left_alter\">$L{'Number_of_different_pages_used'}</TD><TD CLASS=\"right_alter\">$pageunique\n\n</TD>";
  print FOUT "</TR>\n";
  if ($notrafic == 0) {
      print FOUT "<TR>";
      print FOUT "<TD>$L{'Total_data_sent'}</TD><TD CLASS=\"right\">";
      printf FOUT "%.2f",$totsize;
      print FOUT " $L{'Mb'}\n";
      if ($locallog != 0 && $locserver != 0) {
	  print FOUT "($L{'among'} ";
	  printf FOUT "%.2f",$externesize;
	  print FOUT " $L{'from_outside'})";
      }
      print FOUT "\n</TD></TR>";
  }
  
  print FOUT "</TABLE><P>";

  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} $topten $L{'top_external_sites'} ($L{'among'} $serverunique)</I></DIV><P>\n";

  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";

#  print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"little_hosts\">";
#  print FOUT "<TR><TH>$L{'Hosts'}</TH>\n<TH>$L{'Occurence'}</TH></TR>\n";

  foreach $adresse (&reverse_sort_by_value(*server)) {
      print FOUT "<TR><TD CLASS=\"left\">$adresse</TD><TD CLASS=\"right\"<b>$server{$adresse}</b> $L{'times'}</TD></TR>\n";
  }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE><P>\n";

  if ($locallog != 0 && $locserver != 0) {
      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} $topten $L{'top_local_sites'} ($L{'among'} $locserver)</I></DIV><P>\n";

      print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
      print FOUT "<thead>\n";
      print FOUT "<TR>\n";
      print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
      print FOUT "</TR>\n";
      print FOUT "</thead>\n";
      print FOUT "<tbody>\n";

      foreach $adresse (&reverse_sort_by_value(*localserver)) {
	  print FOUT "<TR><TD CLASS=\"left\">$adresse</TD><TD CLASS=\"right\"><b>$localserver{$adresse}</b></TD></TR>";
      }
      print FOUT "</tbody>\n";
      print FOUT "</TABLE>\n";
  }

  print FOUT "<P>\n";

  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} $topten $L{'pages'} ($L{'among'} $pageunique) $L{'MostSuccesf'}</I></DIV><P>\n";

  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Pages'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";

  foreach $page (&reverse_sort_by_value(*pageslues)) {
      if ($count < $topten) {
	  $count++;
	  print FOUT "<TR><TD CLASS=\"left\"><A HREF=\"$page\">";
	  $link = &AddHREF($page); # if ($squid_format == 0);
#		  $link = &AddHREF($tmp6) if ($squid_format == 1);
	  print FOUT "$link";
#	  print FOUT "$page" if ($titlename == 0);
#	  print FOUT "<b>$urlconv{$page}</b>" if ($titlename == 1 && $urlconv{$page} ne '');
#	  print FOUT "$page" if ($titlename == 1 && $urlconv{$page} eq '');
#	  print FOUT "</A>";
	  print FOUT "</TD>\n<TD CLASS=\"right\"><B>$pageslues{$page}</B> $L{'times'}</TD></TR>\n";
      }
  }
  
  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n";

  print FOUT "</BODY>\n";
  print FOUT "</HTML>\n";
}

#################################################################
####                   Homepage                           #######
#################################################################

sub translate_homepage {
    ($lines) = @_;
    $lines =~ s/Requests/$L{'Requests'}/;
    $lines =~ s/Accesses/$L{'Accesses'}/;
    $lines =~ s/Documents/$L{'Documents'}/;
    $lines =~ s/Scripts/$L{'Scripts'}/;
    $lines =~ s/Hosts/$L{'Hosts'}/;
    $lines =~ s/New_Hosts/$L{'New_Hosts'}/;
    $lines =~ s/Users/$L{'Users'}/;
    $lines =~ s/Traffic/$L{'Traffic'}/;
    $lines =~ s/Countries/$L{'Countries'}/;
    $lines =~ s/<!-- langhome -->/$I/g;
    return $lines;
}


sub CreateTempIndex {
#  local(*FOUT,$msg) = @_;
  local(*FOUT) = @_;
  local($tmp);

  $msg =~ s/\n/<BR>\n/g;

  print FOUT "$doctype\n";
  print FOUT "<HTML><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<META HTTP-EQUIV=Refresh CONTENT=\"30\">\n";
  print FOUT "<TITLE>W3Perl - Stats being generated</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<META NAME=\"ROBOTS\" CONTENT=\"NOFOLLOW\">\n";
  print FOUT "<META NAME=\"ROBOTS\" CONTENT=\"NOINDEX\">\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<link rel=\"icon\" type=\"image/png\" href=\"$linkpathinit$dirress$dirsepurl$favicon$pngext\">\n";
  print FOUT "<link rel=\"shortcut icon\" type=\"image/x-icon\" href=\"$linkpathinit$dirress$dirsepurl$favicon$icoext\">\n";
  print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
  print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";

  print FOUT "</HEAD>\n";

  print FOUT "<BODY BACKGROUND=\"$linkpathinit$dirress$dirsepurl$matrix\" TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\" OnLoad=\"javascript:UpdateProgress();\">\n";

  print FOUT "<FORM method=\"POST\" name=\"ajax\" ACTION=\"\">\n";
  print FOUT "<INPUT type=\"hidden\" name=\"datafile\" value=\"$linkpath_url$progress_log\">\n";
  print FOUT "</FORM>\n";

  print FOUT "<CENTER>"; # if ($msg !~ /\n/);
  print FOUT "<TABLE BORDER=0>\n";
  print FOUT "<TR>\n<TD VALIGN=MIDDLE>";
  print FOUT "<P><BR>";
  print FOUT "<DIV ID=\"display_output\" STYLE=\"color: #00FF00;\"></DIV>\n";
#  print FOUT "$msg\n";
  print FOUT "</TD></TR>";
  print FOUT "</TABLE>\n";
  print FOUT "</CENTER>\n"; # if ($msg !~ /\n/);
#  print FOUT "<SCRIPT LANGUAGE=\"Javascript\" TYPE=\"text/javascript\">\n";
#  print FOUT "UpdateProgress();";
#  print FOUT "</SCRIPT>\n";
  print FOUT "</BODY></HTML>\n";
}

sub aff_mem {
    local($msg,$proc_mem) = @_;
    local($val,$tmp,$unit,$unit_div);

    chomp($msg);
    my $gtop = GTop->new;
    my $proc_mem = $gtop->proc_mem($$);

#    print "\n MEM : $msg\n";

    $tmp = $proc_mem->size;
    ($unit,$unit_div) = &Return_Unit($tmp,1);
    $tmp = int($tmp/$unit);
#    print "SIZE : $tmp $unit_div\n";;

    $val = "$tmp";

    $tmp = $proc_mem->vsize;
    ($unit,$unit_div) = &Return_Unit($tmp,1);
    $tmp = int($tmp/$unit);
#    print "VSIZE : $tmp $unit_div\n";;

    $val .= "\t$tmp";

    $tmp = $proc_mem->resident;
    ($unit,$unit_div) = &Return_Unit($tmp,1);
    $tmp = int($tmp/$unit);
#    print "RESIDENT : $tmp $unit_div\n";;

    $val .= "\t$tmp";
    $mem_idx++;

    print MEM_DEBUG "$mem_idx\t\"$msg\"\t$val\n";

#    print "\n";
}

sub Return_Unit {
    local($val,$mode) = @_;
#    local($unit,$unit_div);

    if ($val < 1024) {
	$unit = "bytes";
	$unit_div = 1;
    }
    if ($val >= 1024 && $val < (1024*1024)) {
	$unit = "Kb";
	$unit_div = 1024;
    }

    if ($val >= (1024*1024) && $val < (1024*1024*1024)) {
	$unit = "Mb";
	$unit_div = 1024*1024;
    }

    if ($val >= (1024*1024*1024) && $val < (1024*1024*1024*1024)) {
	$unit = "Gb";
	$unit_div = 1024*1024*1024;
    }
    if ($val >= (1024*1024*1024*1024)) {
	$unit = "Tb";
	$unit_div = 1024*1024*1024*1024;
    }

    # decrease one magnitude for a nicer display
    if ($mode == 0 && int($val/$unit_div) < 10) {
	$unit_div /= 1024;
	$unit = "bytes" if ($unit eq "Kb");
	$unit = "Kb" if ($unit eq "Mb");
	$unit = "Mb" if ($unit eq "Gb");
	$unit = "Gb" if ($unit eq "Tb");

    }

#    print "II $unit_div / $unit\n";
    return $unit_div,$unit
}

sub CreateTempIndexLevel2 {
  local(*FOUT,$msg) = @_;
  local($tmp);

  $msg =~ s/\n/<BR>\n/g;

  print FOUT "$doctype\n";
  print FOUT "<HTML><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<META HTTP-EQUIV=Refresh CONTENT=\"30\">\n";
  print FOUT "<TITLE>W3Perl - Stats being generated</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<META NAME=\"ROBOTS\" CONTENT=\"NOFOLLOW\">\n";
  print FOUT "<META NAME=\"ROBOTS\" CONTENT=\"NOINDEX\">\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<link rel=\"icon\" type=\"image/png\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$favicon$pngext\">\n";
  print FOUT "<link rel=\"shortcut icon\" type=\"image/x-icon\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$favicon$icoext\">\n";
  print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
  print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";

  print FOUT "</HEAD>\n";

  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";

  print FOUT "<CENTER>" if ($msg !~ /\n/);
  print FOUT "<TABLE BORDER=0 WIDTH=\"100%\">\n";
  print FOUT "<TR>\n<TD ALIGN=CENTER VALIGN=MIDDLE>";
  print FOUT "<P><BR>";
  print FOUT "$msg\n";
  print FOUT "</TD></TR>";
  print FOUT "</TABLE>\n";
  print FOUT "</CENTER>\n" if ($msg !~ /\n/);
  print FOUT "</BODY></HTML>\n";
}

sub CreateMainIndex {
  local(*FOUT2,*L, $H, $I) = @_;
  local($tmp,$tmp_color,$moy);
  local($linew,$line,$lined,$tmp4,$tmp5,$tmp6);

  $linew = 0;
  $line = 0;
  $lined = 0;
  $tmp6 = 0;
  $tmp4 = 0;
  $tmp5 = 0;
  open(INFILEDATA,"$path$dirdata$dirsep$datafile");
  while (<INFILEDATA>) {
      $line++;
      next if ($line < 3);
      $lined++;
      
      ($tmp1,$tmp2,$tmp3,$m_tot3) = split('\s+');
      $tmp4 += $m_tot3;
      $tmp6 += $m_tot3;
      if ($lined > 6) {
	  $linew++;
	  $lined = 0;
	  $tmp5 += int($tmp6/7);
	  $tmp6 = 0;
      }
  }
  close(INFILEDATA);

  $countw = int($nbdays/7);
  $moy_host = int($tmp4/$nbdays) if ($nbdays != 0);
  $moy_w_host = int($tmp5/$countw) if ($countw != 0);


  print FOUT2 "$doctype\n";
  print FOUT2 "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT2 "$charset\n";
  print FOUT2 "<TITLE>$L{'Stats_about_host'} $localserver - $L{'Index'}</TITLE>\n";
  print FOUT2 "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT2 "<META NAME=\"ROBOTS\" CONTENT=\"NOFOLLOW\">\n";
  print FOUT2 "<META NAME=\"ROBOTS\" CONTENT=\"NOINDEX\">\n";
  &popup_help(*FOUT2,0);
  print FOUT2 "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT2 "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT2 "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT2 "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT2 "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT2 "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT2 "<script LANGUAGE=\"Javascript\" type=\"text/javascript\">\n";

  print FOUT2 "function ToggleHome(obj) {\n";
  print FOUT2 "target = document.getElementById(obj);\n";
#  print FOUT2 "target.style.display = \"inline\";\n";
  print FOUT2 "target.style.display  = (target.style.display != 'none' ? 'none' : 'inline');\n";
  print FOUT2 "}\n";
  print FOUT2 "function PopIt(ref,x,y) {\n";
  print FOUT2 "var xwin;\n";
  print FOUT2 "var ywin;\n";
  print FOUT2 "xwin = x+100;\n";
  print FOUT2 "ywin = y*2;\n";
  print FOUT2 "popup = window.open(\"\"+ref,\"popDialog\",\"height=\"+ywin+\",width=\"+xwin+\",scrollbars=yes,resizable=yes\")\n";
  print FOUT2 "popup.focus()\n";
  print FOUT2 "}\n";
  print FOUT2 "</SCRIPT>\n";
  print FOUT2 "$curvy_bottom_jss\n";

  &add_jqplot_js(*FOUT2,0);
  &add_css_style(*FOUT2,0);

#  print FOUT2 "<link href=\"$filerss$xmlext\" rel=\"alternate\" title=\"w3perl stats rss\" type=\"application/rss+xml\">\n"; # if ($rss_nb != 0);
  print FOUT2 "</HEAD>\n";
  print FOUT2 "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";

  &add_css_menu(*FOUT2,*L,$lang[$nblang],$nblang,0);
  &help_div(*FOUT2);

  print FOUT2 "<noscript>\n";
  print FOUT2 "<center><h2>This web site needs javascript activated to work properly. Please activate it. Thanks!</h2></center>\n";
  print FOUT2 "<center><h3>If you cannot and want graphics, use Fly rather than Jqplot as Jqplot is a javascript library</h3></center>\n" if ($fly_set == 0);
  print FOUT2 "</noscript>\n";

  if ($found_pble == 1) {
      print FOUT2 "$msg";
      return;
  }



### Big tableau

  print FOUT2 "<CENTER>\n";
  print FOUT2 "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=5 WIDTH=\"100%\">\n<TR>\n<TD VALIGN=TOP>\n";
  
### 1er tableau

  print FOUT2 "<TABLE BORDER=0>\n<TR>\n";
  $tmp_help = "global.html";
  if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help") {
      print FOUT2 "<TH ALIGN=LEFT><A HREF=\"javascript:HelpDisplay('$tmp_help')\"><IMG SRC=\"$linkpathinit$dirress$dirsepurl$icon_help\" BORDER=0 ALT=\"help\"></A></TH>";
  }
  print FOUT2 "<TH>&nbsp;$L{'Global_access'}&nbsp;</TH>\n<TH ALIGN=CENTER>&nbsp;<I>$L{'Total'}</I>&nbsp;</TH>\n";
  print FOUT2 "<TH>&nbsp;<I>$L{'external'}</I>&nbsp;</TH><TH ALIGN=CENTER>&nbsp;<I>$L{'local'}</I>&nbsp;</TH>" if ($locallog == 1 && $localonly != 1);
  print FOUT2 "</TR>\n<TR>\n";

  $tmp_color++;
  print FOUT2 "<TD ";
  print FOUT2 "COLSPAN=2 " if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help");
  print FOUT2 "CLASS=\"left_alter\" ";
  print FOUT2 "onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$L{'Title_requests'}','$L{'Line_requests'}','$L{'Desc_requests'}','$L{'Link_requests'}',0,'','$help_width')\"" if ($mail_format == 0);
  print FOUT2 ">$L{'Requests'}</TD>\n";
#  print FOUT2 "CLASS=\"left_alter\">$L{'Emails'}</TD>\n" if ($mail_format == 1);
  print FOUT2 "<TD CLASS=\"right_alter\">&nbsp;$reqtot&nbsp;</TD>\n";
  if ($locallog == 1 && $localonly != 1) {
      print FOUT2 "<TD CLASS=\"right_alter\">&nbsp;".($reqtot - $reqdomtot)."&nbsp;</TD>\n";
      print FOUT2 "<TD CLASS=\"right_alter\">&nbsp;$reqdomtot&nbsp;</TD>\n";
  }
  print FOUT2 "</TR>\n";

  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
      $tmp_color++;
      print FOUT2 "<TR>\n";
      print FOUT2 "<TD ";
      print FOUT2 "COLSPAN=2 " if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help");
      print FOUT2 "CLASS=\"left\" " if (int($tmp_color/2) == ($tmp_color/2));
      print FOUT2 "CLASS=\"left_alter\" " if (int($tmp_color/2) != ($tmp_color/2));
      print FOUT2 "onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$L{'Title_accesses'}','$L{'Line_accesses'}','$L{'Desc_accesses'}','$L{'Link_accesses'}',0,'','$help_width')\">$L{'Accesses'}</TD>\n";
      print FOUT2 "<TD";
      print FOUT2 " CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
      print FOUT2 " CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
      print FOUT2 ">&nbsp;$access&nbsp;</TD>\n";
      if ($locallog == 1 && $localonly != 1) {
	  print FOUT2 "<TD";
	  print FOUT2 " CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
	  print FOUT2 " CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
	  print FOUT2 ">&nbsp;".($access - $accessdom)."&nbsp;</TD>\n";
	  print FOUT2 "<TD";
	  print FOUT2 " CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
	  print FOUT2 " CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
	  print FOUT2 ">&nbsp;$accessdom&nbsp;</TD>\n";
      }
      print FOUT2 "</TR>\n";
  }
  if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
      $tmp_color++;
      print FOUT2 "<TR>\n";
      print FOUT2 "<TD ";
      print FOUT2 "COLSPAN=2 " if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help");
      print FOUT2 "CLASS=\"left\" " if (int($tmp_color/2) == ($tmp_color/2));
      print FOUT2 "CLASS=\"left_alter\" " if (int($tmp_color/2) != ($tmp_color/2));
      print FOUT2 "onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$L{'Title_nbfile'}','$L{'Line_nbfile'}','$L{'Desc_nbfile'}','$L{'Link_nbfile'}',0,'','$help_width')\">$L{'Documents'}</TD>\n";
      print FOUT2 "<TD";
      print FOUT2 " CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
      print FOUT2 " CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
      print FOUT2 ">&nbsp;$nbfile&nbsp;</TD>\n";
      if ($locallog == 1 && $localonly != 1) {
	  print FOUT2 "<TD";
	  print FOUT2 " CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
	  print FOUT2 " CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
	  print FOUT2 ">&nbsp;".($nbfile - $nbfiledom)."&nbsp;</TD>\n";
	  print FOUT2 "<TD";
	  print FOUT2 " CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
	  print FOUT2 " CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
	  print FOUT2 ">&nbsp;$nbfiledom&nbsp;</TD>\n";
      }
      print FOUT2 "</TR>\n";
  }

  if ($mail_format == 1 && $spam_found != 0) {
      $tmp_color++;
      print FOUT2 "<TR>\n";
      print FOUT2 "<TD ";
      print FOUT2 "CLASS=\"left\" " if (int($tmp_color/2) == ($tmp_color/2));
      print FOUT2 "CLASS=\"left_alter\" " if (int($tmp_color/2) != ($tmp_color/2));
      print FOUT2 "COLSPAN=2" if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help");
      print FOUT2 " onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$L{'Title_spam'}','$L{'Line_spam'}','$L{'Desc_spam'}','$L{'Link_spam'}',0,'','$help_width')\">$L{'Spam'} ";
      print FOUT2 "</TD>\n";
      print FOUT2 "<TD";
      print FOUT2 " CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
      print FOUT2 " CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
      print FOUT2 ">&nbsp;$spam_found";
      print FOUT2 "&nbsp;</TD>\n";
      if ($locallog == 1 && $localonly != 1) {
	  print FOUT2 "<TD";
	  print FOUT2 " CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
	  print FOUT2 " CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
	  print FOUT2 ">&nbsp;$spam_found_ext";
	  print FOUT2 "&nbsp;</TD>\n";
	  print FOUT2 "<TD";
	  print FOUT2 " CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
	  print FOUT2 " CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
	  print FOUT2 ">&nbsp;$spam_found_local";
	  print FOUT2 "&nbsp;</TD>\n";
      }
      print FOUT2 "</TR>\n";
  }


#  if ($ftp_format == 1 || $mail_format == 1) {
  if ($nb_user != 0) {
      $tmp_color++;
      print FOUT2 "<TR>\n";
      print FOUT2 "<TD ";
      print FOUT2 "CLASS=\"left\" " if (int($tmp_color/2) == ($tmp_color/2));
      print FOUT2 "CLASS=\"left_alter\" " if (int($tmp_color/2) != ($tmp_color/2));
      print FOUT2 "COLSPAN=2" if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help");
      print FOUT2 ">";
      print FOUT2 "$L{'Users'}";
      print FOUT2 "</TD>\n";
      print FOUT2 "<TD";
      print FOUT2 " CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
      print FOUT2 " CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
      print FOUT2 ">&nbsp;$nb_user";
      print FOUT2 "&nbsp;</TD>\n";
      if ($locallog == 1 && $localonly != 1) {
	  print FOUT2 "<TD";
	  print FOUT2 " CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
	  print FOUT2 " CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
	  print FOUT2 ">&nbsp;$user_ext&nbsp;</TD>\n";
	  print FOUT2 "<TD";
	  print FOUT2 " CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
	  print FOUT2 " CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
	  print FOUT2 ">&nbsp;$user_local&nbsp;</TD>\n";
      }
      print FOUT2 "</TR>\n";
  }


  if ($bandwidth_input != 0) {
      $tmp_color++;
      ($unit_div,$unit) = &Return_Unit($bandwith_input,1);
      $tmp = int(100*$bandwith_input/$unit_div)/100;
 #     $tmp = $tmp2/1024 if ($tmp2 >= 1024 && $tmp2 < (1024*1024));
 #     $tmp = $tmp2/(1024*1024) if ($tmp2 >= (1024*1024));
      print FOUT2 "<TR>\n";
      print FOUT2 "<TD ";
      print FOUT2 "CLASS=\"left\" " if (int($tmp_color/2) == ($tmp_color/2));
      print FOUT2 "CLASS=\"left_alter\" " if (int($tmp_color/2) != ($tmp_color/2));
      print FOUT2 "COLSPAN=2" if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help");
      print FOUT2 ">$L{'Incoming_bandwidth'} ";
      print FOUT2 "($L{$unit})" if ($tmp2 < 1024);
#      print FOUT2 "($L{'Mb'})" if ($tmp2 < 1024);
#      print FOUT2 "($L{'Gb'})" if ($tmp2 > 1024 && $tmp2 < (1024*1024));
#      print FOUT2 "($L{'Tb'})" if ($tmp2 > (1024*1024));
      print FOUT2 "</TD>\n";
      print FOUT2 "<TD";
      print FOUT2 " CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
      print FOUT2 " CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
      print FOUT2 ">&nbsp;";
#      printf FOUT2 "%.1f",$tmp;
      print FOUT2 "$tmp";
      print FOUT2 "&nbsp;</TD>\n";
      print FOUT2 "<TD";
      print FOUT2 " CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
      print FOUT2 " CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
      print FOUT2 ">&nbsp;";
      print FOUT2 "&nbsp;</TD>\n";
      print FOUT2 "</TR>\n";
  }
  if ($bandwidth_output != 0) {
      $tmp_color++;
#      $tmp2 = $bandwidth_output;
      ($unit_div,$unit) = &Return_Unit($bandwith_output,1);
      $tmp = int(100*$bandwith_output/$unit_div)/100;
#      $tmp = $tmp2;
#      $tmp = $tmp2/1024 if ($tmp2 >= 1024 && $tmp2 < (1024*1024));
#      $tmp = $tmp2/(1024*1024) if ($tmp2 >= (1024*1024));

      print FOUT2 "<TR>\n";
      print FOUT2 "<TD ";
      print FOUT2 "CLASS=\"left\" " if (int($tmp_color/2) == ($tmp_color/2));
      print FOUT2 "CLASS=\"left_alter\" " if (int($tmp_color/2) != ($tmp_color/2));
      print FOUT2 "COLSPAN=2" if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help");
      print FOUT2 ">$L{'Outgoing_bandwidth'} ";
      print FOUT2 "($L{$unit})";
#      print FOUT2 "($L{'Mb'})" if ($tmp2 < 1024);
#      print FOUT2 "($L{'Gb'})" if ($tmp2 > 1024 && $tmp2 < (1024*1024));
#      print FOUT2 "($L{'Tb'})" if ($tmp2 > (1024*1024));
      print FOUT2 "</TD>\n";
      print FOUT2 "<TD";
      print FOUT2 " CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
      print FOUT2 " CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
      print FOUT2 ">&nbsp;";
#      printf FOUT2 "%.1f",$tmp;
      print FOUT2 "$tmp";
      print FOUT2 "&nbsp;</TD>\n";
      print FOUT2 "<TD";
      print FOUT2 " CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
      print FOUT2 " CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
      print FOUT2 ">&nbsp;";
      print FOUT2 "&nbsp;</TD>\n";
      print FOUT2 "</TR>\n";
  }
  if ($notrafic == 0) {
      $tmp_color++;
      print FOUT2 "<TR>\n";
      ($unit_div,$unit) = &Return_Unit($totsize,1);
      $tmp = int(100*$totsize/$unit_div)/100;

#      $tmp2 = $totsize;
#      $tmp = $tmp2;
#      $tmp = $tmp2/1024 if ($tmp2 > 1024 && $tmp2 < (1024*1024));
#      $tmp = $tmp2/(1024*1024) if ($tmp2 > (1024*1024));
      print FOUT2 "<TD ";
      print FOUT2 "CLASS=\"left\" " if (int($tmp_color/2) == ($tmp_color/2));
      print FOUT2 "CLASS=\"left_alter\" " if (int($tmp_color/2) != ($tmp_color/2));
      print FOUT2 "COLSPAN=2 " if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help");
      if ($ftp_format == 1) {
	  print FOUT2 "onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$L{'Title_traffic'}','$L{'Line_traffic'}','$L{'Desc_traffic'}','$L{'Link_traffic'}',0,'','$help_width')\">";
	  print FOUT2 "$L{'Incoming_traffic'} " if ($ftp_direction eq "i");
	  print FOUT2 "$L{'Outgoing_traffic'} " if ($ftp_direction eq "o");
      }
      print FOUT2 "onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$L{'Title_traffic'}','$L{'Line_traffic'}','$L{'Desc_traffic'}','$L{'Link_traffic'}',0,'','$help_width')\">$L{'Traffic'} " if ($ftp_format == 0);
      print FOUT2 "($L{$unit})";
#      print FOUT2 "($L{'Mb'})" if ($tmp2 < 1024);
#      print FOUT2 "($L{'Gb'})" if ($tmp2 > 1024 && $tmp2 < (1024*1024));
#      print FOUT2 "($L{'Tb'})" if ($tmp2 > (1024*1024));
      print FOUT2 "</TD>\n";

      print FOUT2 "<TD";
      print FOUT2 " CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
      print FOUT2 " CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
      print FOUT2 ">&nbsp;";
#      printf FOUT2 "%.1f",$tmp;
      print FOUT2 "$tmp";
      print FOUT2 "&nbsp;</TD>\n";

      if ($locallog == 1 && $localonly != 1) {
#	  $tmp3 = $externesize;
#	  $tmp = $tmp3;
#	  $tmp = $tmp3/1024 if ($tmp2 > 1024 && $tmp2 < (1024*1024));
#	  $tmp = $tmp3/(1024*1024) if ($tmp2 > (1024*1024));
	  $tmp = int(100*$externesize/$unit_div)/100;
	  print FOUT2 "<TD";
	  print FOUT2 " CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
	  print FOUT2 " CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
	  print FOUT2 ">&nbsp;";
#	  printf FOUT2 "%.2f",$tmp;
	  print FOUT2 "$tmp";
	  print FOUT2 "&nbsp;</TD>\n";
	  $tmp = int(100*$domsize/$unit_div)/100;
#	  $tmp3 = $domsize;
#	  $tmp = $tmp3;
#	  $tmp = $tmp3/1024 if ($tmp2 > 1024 && $tmp2 < (1024*1024));
#	  $tmp = $tmp3/(1024*1024) if ($tmp2 > (1024*1024));
	  print FOUT2 "<TD";
	  print FOUT2 " CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
	  print FOUT2 " CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
	  print FOUT2 ">&nbsp;";
#	  printf FOUT2 "%.2f",$tmp;
	  print FOUT2 "$tmp";
	  print FOUT2 "&nbsp;</TD>\n";
      }
      print FOUT2 "</TR>\n";
  }
  $tmp_color++;
  print FOUT2 "<TR>\n";
  print FOUT2 "<TD ";
  print FOUT2 "CLASS=\"left\" " if (int($tmp_color/2) == ($tmp_color/2));
  print FOUT2 "CLASS=\"left_alter\" " if (int($tmp_color/2) != ($tmp_color/2));
  print FOUT2 "COLSPAN=2" if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help");
  print FOUT2 ">$L{'Number_of_different_sites'}</TD>" if ($cups_format == 0);
  print FOUT2 ">$L{'Hosts'}</TD>" if ($cups_format == 1);
  print FOUT2 "<TD";
  print FOUT2 " CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
  print FOUT2 " CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
  print FOUT2 ">&nbsp;$serveruniquetot&nbsp;</TD>\n";
  if ($locallog == 1 && $localonly != 1) {
      print FOUT2 "<TD";
      print FOUT2 " CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
      print FOUT2 " CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
      print FOUT2 ">&nbsp;$serverunique&nbsp;</TD>\n";
      print FOUT2 "<TD";
      print FOUT2 " CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
      print FOUT2 " CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
      print FOUT2 ">&nbsp;$locserver&nbsp;</TD>\n";
  }
  print FOUT2 "</TR>\n";

  if ($mail_format == 0) {
      $tmp_color++;
      print FOUT2 "<TR>\n";
      print FOUT2 "<TD ";
      print FOUT2 "CLASS=\"left\" " if (int($tmp_color/2) == ($tmp_color/2));
      print FOUT2 "CLASS=\"left_alter\" " if (int($tmp_color/2) != ($tmp_color/2));
      print FOUT2 "COLSPAN=2" if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help");
      print FOUT2 ">$L{'Number_of_different_pages_used'}</TD>" if ($cups_format == 0);
      print FOUT2 ">$L{'Files'}</TD>" if ($cups_format == 1);
      print FOUT2 "<TD ";
      print FOUT2 " CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
      print FOUT2 " CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
      print FOUT2 ">&nbsp;$pageunique&nbsp;</TD>\n";
      if ($locallog == 1 && $localonly != 1) {
	  print FOUT2 "<TD";
	  print FOUT2 " CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
	  print FOUT2 " CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
	  print FOUT2 ">&nbsp;</TD>\n";
	  print FOUT2 "<TD";
	  print FOUT2 " CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
	  print FOUT2 " CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
	  print FOUT2 ">&nbsp;</TD>\n";
      }
      print FOUT2 "</TR>\n";
  }

  if ($precision > 2 && $paysunique != 0) {
      $tmp_color++;
      print FOUT2 "<TR>\n<TD ";
      print FOUT2 "CLASS=\"left\" " if (int($tmp_color/2) == ($tmp_color/2));
      print FOUT2 "CLASS=\"left_alter\" " if (int($tmp_color/2) != ($tmp_color/2));
      print FOUT2 "COLSPAN=2" if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help");
      print FOUT2 ">$L{'Number_of_different_resolved_countries'}</TD>" if ($cups_format == 0);
      print FOUT2 ">$L{'Countries'}</TD>" if ($cups_format == 1);
      print FOUT2 "<TD ";
      print FOUT2 " CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
      print FOUT2 " CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
      print FOUT2 ">&nbsp;$paysunique&nbsp;</TD>\n";
      if ($locallog == 1 && $localonly != 1) {
	  print FOUT2 "<TD";
	  print FOUT2 " CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
	  print FOUT2 " CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
	  print FOUT2 ">&nbsp;</TD>\n";
	  print FOUT2 "<TD";
	  print FOUT2 " CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
	  print FOUT2 " CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
	  print FOUT2 ">&nbsp;</TD>\n";
      }
      print FOUT2 "</TR>\n";
  }

  print FOUT2 "</TABLE>\n";

####

#  print FOUT2 "</TD><TD VALIGN=TOP ROWSPAN=2>";
  print FOUT2 "</TD><TD VALIGN=TOP>";

### 4ieme tableau

  if ($nbdays != 0) {
      $tmp_color = 0;
      $tmp_color++;
      print FOUT2 "<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=3>\n<TR>\n";
      print FOUT2 "<TH ALIGN=LEFT>&nbsp;$L{'Average'}&nbsp;</TH>\n";
      print FOUT2 "<TH ALIGN=LEFT>&nbsp;$L{'Days'}&nbsp;</TH>\n";
      print FOUT2 "<TH ALIGN=LEFT>&nbsp;$L{'Weeks'}&nbsp;</TH>\n" if ($nbdays > 6);
      print FOUT2 "</TR>\n<TR>\n";
      print FOUT2 "<TD ";
      print FOUT2 "CLASS=\"left_alter\">$L{'Requests'}</TD>\n";# if ($mail_format == 0);
      print FOUT2 "<TD ";
      print FOUT2 "CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
      print FOUT2 "CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
      print FOUT2 ">".int($reqtot/$nbdays)."</TD>\n";
      if ($nbdays > 6) {
	  print FOUT2 "<TD ";
	  print FOUT2 "CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
	  print FOUT2 "CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
	  print FOUT2 ">".int(7*$reqtot/$nbdays)."</TD>\n";
      }
      print FOUT2 "</TR>\n";
      if ($cups_format == 1) {
	  $tmp_color++;
	  print FOUT2 "<TR>\n";
	  print FOUT2 "<TD ";
	  print FOUT2 "CLASS=\"left\"" if (int($tmp_color/2) == ($tmp_color/2));
	  print FOUT2 "CLASS=\"left_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
	  print FOUT2 ">$L{'Files'}</TD>\n";
	  print FOUT2 "<TD ";
	  print FOUT2 "CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
	  print FOUT2 "CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
	  print FOUT2 ">".int($pageunique/$nbdays)."</TD>\n";
	  if ($nbdays > 6) {
	      print FOUT2 "<TD ";
	      print FOUT2 "CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
	      print FOUT2 "CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
	      print FOUT2 ">".int(7*$pageunique/$nbdays)."</TD>\n";
	  }
	  print FOUT2 "</TR>\n";
      }
      if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	  $tmp_color++;
	  print FOUT2 "<TR>\n";
	  print FOUT2 "<TD ";
	  print FOUT2 "CLASS=\"left\"" if (int($tmp_color/2) == ($tmp_color/2));
	  print FOUT2 "CLASS=\"left_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
	  print FOUT2 ">$L{'Accesses'}</TD>\n";
	  print FOUT2 "<TD ";
	  print FOUT2 "CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
	  print FOUT2 "CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
	  print FOUT2 ">".int($access/$nbdays)."</TD>\n";
	  if ($nbdays > 6) {
	      print FOUT2 "<TD ";
	      print FOUT2 "CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
	      print FOUT2 "CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
	      print FOUT2 ">".int(7*$access/$nbdays)."</TD>\n";
	  }
	  print FOUT2 "</TR>\n";
      }
      if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	  $tmp_color++;
	  print FOUT2 "<TR>\n";
	  print FOUT2 "<TD ";
	  print FOUT2 "CLASS=\"left\" " if (int($tmp_color/2) == ($tmp_color/2));
	  print FOUT2 "CLASS=\"left_alter\" " if (int($tmp_color/2) != ($tmp_color/2));
	  print FOUT2 ">$L{'Documents'}</TD>\n";
	  print FOUT2 "<TD ";
	  print FOUT2 "CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
	  print FOUT2 "CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
	  print FOUT2 ">".int($nbfile/$nbdays)."</TD>\n";
	  if ($nbdays > 6) {
	      print FOUT2 "<TD ";
	      print FOUT2 "CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
	      print FOUT2 "CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
	      print FOUT2 ">".int(7*$nbfile/$nbdays)."</TD>\n";
	  }
	  print FOUT2 "</TR>\n";
      }


      $tmp_color++;
      print FOUT2 "<TR>\n";
      print FOUT2 "<TD ";
      print FOUT2 "CLASS=\"left\"" if (int($tmp_color/2) == ($tmp_color/2));
      print FOUT2 "CLASS=\"left_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
      print FOUT2 ">$L{'Hosts'}</TD>\n";
      print FOUT2 "<TD ";
      print FOUT2 "CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
      print FOUT2 "CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
      print FOUT2 ">$moy_host</TD>\n";
#      print FOUT2 ">".int($serveruniquetot/$nbdays)."</TD>\n";
      if ($nbdays > 6) {
	  print FOUT2 "<TD ";
	  print FOUT2 "CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
	  print FOUT2 "CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
#	  print FOUT2 ">".int(7*$serveruniquetot/$nbdays)."</TD>\n";
	  print FOUT2 ">$moy_w_host</TD>\n";
      }
      print FOUT2 "</TR>\n";

      if ($notrafic == 0) {
	  $tmp_color++;
	  print FOUT2 "<TR>\n";
	  print FOUT2 "<TD ";
	  print FOUT2 "CLASS=\"left\"" if (int($tmp_color/2) == ($tmp_color/2));
	  print FOUT2 "CLASS=\"left_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
	  print FOUT2 ">$L{'Traffic'} ";
	  $tmp = $totsize/$nbdays;
#	  $tmp = $tmp1;
#	  $tmp = $tmp1/1024 if ($tmp1 > 1024);
#	  $tmp = $tmp1/(1024*1024) if ($tmp1 > (1024*1024));


	  ($unit_div,$unit) = &Return_Unit($tmp,0);
	  $tmp = int(100*$tmp/$unit_div)/100;
	  print FOUT2 "($L{$unit})";
#	  print FOUT2 "($L{'Mb'})" if ($tmp1 < 1024);
#	  print FOUT2 "($L{'Gb'})" if ($tmp1 > 1024 && $tmp1 < (1024*1024));
#	  print FOUT2 "($L{'Tb'})" if ($tmp1 > (1024*1024));
	  print FOUT2 "</TD>\n";
	  print FOUT2 "<TD ";
	  print FOUT2 "CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
	  print FOUT2 "CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
#	  printf FOUT2 ">%.1f</TD>\n",$tmp;
	  print FOUT2 ">$tmp</TD>\n";
	  if ($nbdays > 6) {
	      print FOUT2 "<TD ";
	      print FOUT2 "CLASS=\"right\"" if (int($tmp_color/2) == ($tmp_color/2));
	      print FOUT2 "CLASS=\"right_alter\"" if (int($tmp_color/2) != ($tmp_color/2));
	      printf FOUT2 ">%.1f</TD>\n",$tmp*7;
	  }
	  print FOUT2 "</TR>\n";
      }
      print FOUT2 "</TABLE>\n";
  }

###

#  print FOUT2 "</TD><TD VALIGN=TOP ROWSPAN=2>";
  print FOUT2 "</TD><TD VALIGN=TOP>";

### 3ieme tableau

  if (($loglines-$reqtot) > 0) {
  print FOUT2 "<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=3>\n<TR>\n";
  $tmp_help = "take_account.html";
  print FOUT2 "<TH ALIGN=LEFT COLSPAN=4>";
  print FOUT2 "<TABLE WIDTH=\"100%\" BORDER=0 CELLPADDING=0 CELLSPACING=0><TR>";
  if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help") {
      print FOUT2 "<TH><A HREF=\"javascript:HelpDisplay('$tmp_help')\"><IMG SRC=\"$linkpathinit$dirress$dirsepurl$icon_help\" BORDER=0 ALT=\"help\"></A></TH>";
  }
  print FOUT2 "<TH>$L{'Acces_not_taken_into_account'}</TH>\n";
  print FOUT2 "</TR></TABLE>\n";
  print FOUT2 "</TR>\n<TR>\n";
  print FOUT2 "<TD COLSPAN=3";
  print FOUT2 " CLASS=\"left_alter\">$L{'Total'} :</TD><TD CLASS=\"right_alter\">".($loglines - $reqtot)."</TD>\n";
  print FOUT2 "</TR>\n<TR>\n";
  print FOUT2 "<TD CLASS=\"left\">$L{'Proxy'} (304)</TD>\n";
  print FOUT2 "<TD CLASS=\"right\">";
  print FOUT2 "<STRIKE>" if ($redirect_flag == 1);
  print FOUT2 "$proxy";
  print FOUT2 "</STRIKE>" if ($redirect_flag == 1);
  print FOUT2 "</TD>\n";
#  print FOUT2 "<TD CLASS=\"left\"></TD><TD CLASS=\"right\"></TD>\n" if ($redirect_flag == 1);
  print FOUT2 "<TD CLASS=\"left\">$L{'Pages_excluding'}</TD><TD CLASS=\"right\">$exclpages</TD>\n";
  print FOUT2 "</TR>\n<TR>\n";
  print FOUT2 "<TD CLASS=\"left_alter\">$L{'Redirect'} (301/2)</TD>";
  print FOUT2 "<TD CLASS=\"right_alter\">";
  print FOUT2 "<STRIKE>" if ($redirect_flag == 1);
  print FOUT2 "$redirect";
  print FOUT2 "</STRIKE>" if ($redirect_flag == 1);
  print FOUT2 "</TD>\n";
#  print FOUT2 "<TD CLASS=\"left_alter\"></TD><TD CLASS=\"right_alter\"></TD>\n" if ($redirect_flag == 1);
  print FOUT2 "<TD CLASS=\"left_alter\">$L{'Hosts_excluding'}</TD><TD CLASS=\"right_alter\">$excladdr</TD>\n";
  print FOUT2 "</TR>\n<TR>\n";
  $status = "401";
  print FOUT2 "<TD CLASS=\"left\">";
  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsep$incstatus$status$htmlext\">" if (-f "$path$I$dirsep$dirlist$dirsep$incstatus$status$htmlext" && $unauthorized != 0 && $mail_format == 0);
  print FOUT2 "$L{'Unauthorized'}";
  print FOUT2 "</A>" if (-f "$path$I$dirsep$dirlist$dirsep$incstatus$status$htmlext" && $unauthorized != 0 && $mail_format == 0);
  print FOUT2 "&nbsp;($status)</TD><TD CLASS=\"right\">$unauthorized</TD>\n";

#  if ($mail_format == 0) {
      print FOUT2 "<TD CLASS=\"left\" onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$L{'Title_referspam_excluded'}','$L{'Line_referspam_excluded'}','$L{'Desc_referspam_excluded'}','$L{'Link_referspam_excluded'}',0,'','$help_width')\">";
      print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsep$increferspam$htmlext\">" if (-f "$path$I$dirsep$dirlist$dirsep$increferspam$htmlext" && $exclrefererspam != 0);
      print FOUT2 "$L{'ReferSpam_excluding'}";
      print FOUT2 "</A>" if (-f "$path$I$dirsep$dirlist$dirsep$increferspam$htmlext" && $exclrefererspam != 0);
      print FOUT2 "</TD><TD CLASS=\"right\">";
      print FOUT2 "$exclrefererspam" if ($exclude_refererspam == 1);
      print FOUT2 "-" if ($exclude_refererspam == 0);
      print FOUT2 "</TD>\n";
#  } else {
#      print FOUT2 "<TD CLASS=\"left\" onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$L{'Title_spam'}','$L{'Line_spam'}','$L{'Desc_spam'}','$L{'Link_spam'}',0,'','$help_width')\">";
#      print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsep$spam$htmlext\">" if (-f "$path$I$dirsep$dirlist$dirsep$spam$htmlext" && $spam_found != 0);
#      print FOUT2 "$L{'Spam'}";
#      print FOUT2 "</A>" if (-f "$path$I$dirsep$dirlist$dirsep$spam$htmlext" && $spam_found != 0);
#      print FOUT2 "</TD><TD CLASS=\"right\">";
#      print FOUT2 "$spam_found" if ($spam_found != 0);
#      print FOUT2 "-" if ($spam_found == 0);
#      print FOUT2 "</TD>\n";
#  }


  print FOUT2 "</TR>\n<TR>\n";
  $status = "403";
  print FOUT2 "<TD CLASS=\"left_alter\">";
  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsep$incstatus$status$htmlext\">" if (-f "$path$I$dirsep$dirlist$dirsep$incstatus$status$htmlext" && $forbiden != 0 && $mail_format == 0);
  print FOUT2 "$L{'Forbidden'}";
  print FOUT2 "</A>" if (-f "$path$I$dirsep$dirlist$dirsep$incstatus$status$htmlext" && $forbiden != 0 && $mail_format == 0);
  print FOUT2 "&nbsp;($status)</TD><TD CLASS=\"right_alter\">$forbiden</TD>\n";
  print FOUT2 "<TD CLASS=\"left_alter\" onMouseOut=\"hideLayer();overdiv--;\"  onMouseOver=\"overdiv++;popLayer('$L{'Title_frame_excluded'}','$L{'Line_frame_excluded'}','$L{'Desc_frame_excluded'}','$L{'Link_frame_excluded'}',0,'','$help_width')\">$L{'Frames_excluding'}</TD><TD CLASS=\"right_alter\">";
  print FOUT2 "$exclframed" if ($exclude_frame == 1);
  print FOUT2 "-" if ($exclude_frame == 0);
  print FOUT2 "</TD>\n";
  print FOUT2 "</TR>\n<TR>\n";
  $status = "404";
  print FOUT2 "<TD CLASS=\"left\">";
  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsep$incstatus$status$htmlext\">" if (-f "$path$I$dirsep$dirlist$dirsep$incstatus$status$htmlext" && $notfound != 0 && $mail_format == 0);
  print FOUT2 "$L{'Not_found'}";
  print FOUT2 "</A>" if (-f "$path$I$dirsep$dirlist$dirsep$incstatus$status$htmlext" && $notfound != 0 && $mail_format == 0);
  print FOUT2 "&nbsp;($status)</TD><TD CLASS=\"right\">$notfound</TD>\n";
  print FOUT2 "<TD onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$L{'Title_robot_excluded'}','$L{'Line_robot_excluded'}','$L{'Desc_robot_excluded'}','$L{'Link_robot_excluded'}',0,'','$help_width')\">";
  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsep$incrobot$htmlext\">" if (-f "$path$I$dirsep$dirlist$dirsep$incrobot$htmlext" && $exclrobots != 0);
  print FOUT2 "$L{'Robots_excluding'}";
  print FOUT2 "</A>" if (-f "$path$I$dirsep$dirlist$dirsep$incrobot$htmlext" && $exclrobots != 0);
  print FOUT2 "</TD><TD CLASS=\"right\">";
  print FOUT2 "$exclrobots" if ($exclude_robot == 1);
  print FOUT2 "-" if ($exclude_robot == 0);
  print FOUT2 "</TD>\n";
  print FOUT2 "</TR>\n</TABLE>\n";
  }

  print FOUT2 "</TD></TR></TABLE>\n";
  print FOUT2 "</CENTER>\n";

  print FOUT2 "<P><HR><P>\n";

#################################################

  print FOUT2 "<CENTER>\n";
  print FOUT2 "<TABLE WIDTH=\"100%\" CELLPADDING=0 CELLSPACING=0 BORDER=0>\n";
  print FOUT2 "<TR>\n";
  print FOUT2 "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";

### pointeurs sur les heures,jours, semaines et mois

  print FOUT2 "<TABLE BORDER=0 CELLSPACING=3 CELLPADDING=0>\n";
  print FOUT2 "<TR>\n";
  if (-e "$path$lang[0]$dirsep$dirdate$dirsep$file_now") {
      print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
      print FOUT2 " CLASS=\"homepage\"";
      print FOUT2 ">\n";

      print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";

      print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #

      print FOUT2 "<A HREF=\"$I$dirsepurl$dirdate$dirsepurl$file_now\">" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$file_now");
      print FOUT2 "<IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_duree\" BORDER=0 ALT=\"Real-time\">";
      print FOUT2 "</A>\n" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$file_now");
      
      print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";
      print FOUT2 "<A HREF=\"$I$dirsepurl$dirdate$dirsepurl$file_now\">" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$file_now");
      print FOUT2 "$L{'Real_time'}";
      print FOUT2 "</A>\n" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$file_now");
      print FOUT2 "</TD><TD ALIGN=RIGHT>\n";

      print FOUT2 "</TD></TR>\n";

      print FOUT2 "</TABLE>\n"; #
      print FOUT2 "</TD></TR>\n"; #

      print FOUT2 "<TR><TD ALIGN=CENTER>";

      $home_real_lines2 = &translate_homepage($home_real_lines);

      print FOUT2 "$home_real_lines2";

      print FOUT2 "</TD></TR></TABLE>\n";
      print FOUT2 "</TD>";
  }

  # Hour

  if (-e "$path$lang[0]$dirsep$dirdate$dirsep$filenamehour") {
      print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
      print FOUT2 " CLASS=\"homepage\"";
      print FOUT2 ">\n";

      print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";

      print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #

#      print FOUT2 "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0><TR><TD ALIGN=CENTER>\n";
      print FOUT2 "<A HREF=\"$I$dirsepurl$dirdate$dirsepurl$filenamehour\">" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$filenamehour");
      print FOUT2 "<IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_hours\" BORDER=0 ALT=\"Hourly\">";
      print FOUT2 "</A>\n" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$filenamehour");
#      print FOUT2 "</TD></TR><TR><TD ALIGN=CENTER>\n";
#      print FOUT2 "<A HREF=\"$I$dirsepurl$dirdate$dirsepurl$filehour\">" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$filenamehour");
#      print FOUT2 "$L{'Hours'}";
#      print FOUT2 "</A>\n" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$filenamehour");
#      print FOUT2 "</TD></TR></TABLE>\n";
      
      print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";
      print FOUT2 "<A HREF=\"$I$dirsepurl$dirdate$dirsepurl$filehour\">" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$filenamehour");
      print FOUT2 "$L{'Hours'}";
      print FOUT2 "</A>\n" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$filenamehour");
      print FOUT2 "</TD><TD ALIGN=RIGHT>\n";
      
      ($tmp1,$tmp2,$tmp3) = split(/ /,$dayhour_csv);
      $tabnamecsv = $tmp3."-".$tmp2."-".$tmp1;

      print FOUT2 "<A HREF=\"$dircsv$dirsepurl$tabnamecsv$csvext\" TITLE=\"CSV - Hourly\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>" if ($home_hourly_lines ne '');
      print FOUT2 "</TD></TR>\n";

      print FOUT2 "</TABLE>\n"; #
      print FOUT2 "</TD></TR>\n"; #
      print FOUT2 "<TR><TD ALIGN=CENTER>";
      
      print FOUT2 "<DIV ID=\"tog_hour1_home\" STYLE=\"display:inline\">";
      $home_hourly_lines2 = &translate_homepage($home_hourly_lines);
      print FOUT2 "$home_hourly_lines2";      
      print FOUT2 "</DIV>";
      
      print FOUT2 "</TD></TR></TABLE>\n";
      print FOUT2 "</TD>";
  }

  # Day

  if ($nbdays > 0) {
  print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
  print FOUT2 " CLASS=\"homepage\"";
  print FOUT2 ">\n";

  print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";

  print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #
      
#  print FOUT2 "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0><TR><TD ALIGN=CENTER>\n";
  print FOUT2 "<A HREF=\"$I$dirsepurl$dirdate$dirsepurl$fileday\">" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$filenameday");
  print FOUT2 "<IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_days\" BORDER=0 ALT=\"Daily\">";
  print FOUT2 "</A>\n" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$filenameday");
#  print FOUT2 "</TD></TR><TR><TD ALIGN=CENTER>\n";
#  print FOUT2 "<A HREF=\"$I$dirsepurl$dirdate$dirsepurl$fileday\">" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$filenameday");
#  print FOUT2 "$L{'Days'}";
#  print FOUT2 "</A>\n" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$filenameday");
#  print FOUT2 "</TD></TR></TABLE>\n";
      
  print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";

  print FOUT2 "<A HREF=\"$I$dirsepurl$dirdate$dirsepurl$fileday\">" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$filenameday");
  print FOUT2 "$L{'Days'}";
  print FOUT2 "</A>\n" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$filenameday");

  print FOUT2 "</TD><TD ALIGN=CENTER>";

  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_day1_home','tog_day2_home');\">External</A><BR>";
  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_day2_home','tog_day1_home');\">Domain</A><BR>";
  print FOUT2 "</TD><TD ALIGN=RIGHT>\n";
  
  $tabnamecsv = $tabnamedays;
  $tabnamecsv =~ s/$htmlext//;
      
  print FOUT2 "<A HREF=\"$dircsv$dirsepurl$tabnamecsv$csvext\" TITLE=\"CSV - Daily\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>";
  print FOUT2 "</TD></TR>\n";
      
  print FOUT2 "</TABLE>\n"; #
  print FOUT2 "</TD></TR>\n"; #
      
  print FOUT2 "<TR><TD ALIGN=CENTER>";
  
  print FOUT2 "<DIV ID=\"tog_day1_home\" STYLE=\"display:inline\">";

  $home_daily_lines2 = &translate_homepage($home_daily_lines);

  print FOUT2 "$home_daily_lines2";
  print FOUT2 "</DIV>";
  print FOUT2 "<DIV ID=\"tog_day2_home\" STYLE=\"display:none\">";
  print FOUT2 "$home_daily2_lines";
  print FOUT2 "</DIV>";
  print FOUT2 "</TD></TR></TABLE>\n";
      
  print FOUT2 "</TD>\n";

  # Week

  print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
  print FOUT2 " CLASS=\"homepage\"";
  print FOUT2 ">\n";

  print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";

  print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #

  print FOUT2 "<A HREF=\"$I$dirsepurl$dirdate$dirsepurl$fileweek\">" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$statnameweek");
  print FOUT2 "<IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_weeks\" BORDER=0 ALT=\"Weekly\">";
  print FOUT2 "</A>\n" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$statnameweek");

  print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";

  print FOUT2 "<A HREF=\"$I$dirsepurl$dirdate$dirsepurl$fileweek\">" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$statnameweek");
  print FOUT2 "$L{'Weeks'}";
  print FOUT2 "</A>\n" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$statnameweek");
      
  print FOUT2 "</TD><TD ALIGN=CENTER>";
  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_week1_home','tog_week2_home');\">External</A><BR>";
  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_week2_home','tog_week1_home');\">Domain</A><BR>";
  print FOUT2 "</TD><TD ALIGN=RIGHT>\n";
  
  $tabnamecsv = $tabnameweek;
  $tabnamecsv =~ s/$htmlext//;
      
  print FOUT2 "<A HREF=\"$dircsv$dirsepurl$tabnamecsv$csvext\" TITLE=\"CSV - Weekly\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>";
  print FOUT2 "</TD></TR>\n";
      
  print FOUT2 "</TABLE>\n"; #
  print FOUT2 "</TD></TR>\n"; #
  
  print FOUT2 "<TR><TD ALIGN=CENTER>";

  $home_weekly_lines2 = &translate_homepage($home_weekly_lines);
  
  print FOUT2 "<DIV ID=\"tog_week1_home\" STYLE=\"display:inline\">";
  print FOUT2 "$home_weekly_lines2";
  print FOUT2 "</DIV>";
  print FOUT2 "<DIV ID=\"tog_week2_home\" STYLE=\"display:none\">";
  print FOUT2 "</DIV>";
  
  print FOUT2 "</TD></TR></TABLE>\n";
  print FOUT2 "</TD>";

  # Months

  print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
  print FOUT2 " CLASS=\"homepage\"";
  print FOUT2 ">\n";

  print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";

  print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #

  print FOUT2 "<A HREF=\"$I$dirsepurl$dirdate$dirsepurl$filemonth\">" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$statnamemonth");
  print FOUT2 "<IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_months\" BORDER=0 ALT=\"Monthly\">";
  print FOUT2 "</A>\n" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$statnamemonth");

  print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";

  print FOUT2 "<A HREF=\"$I$dirsepurl$dirdate$dirsepurl$filemonth\">" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$statnamemonth");
  print FOUT2 "$L{'Months'}";
  print FOUT2 "</A>\n" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$statnamemonth");
  
  print FOUT2 "</TD><TD ALIGN=CENTER>";
  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_month1_home','tog_month2_home');\">External</A><BR>";
  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_month2_home','tog_month1_home');\">Domain</A><BR>";
  print FOUT2 "</TD><TD ALIGN=RIGHT>\n";
  
  $tabnamecsv = $tabnamemonth;
  $tabnamecsv =~ s/$htmlext//;
  
  print FOUT2 "<A HREF=\"$dircsv$dirsepurl$tabnamecsv$csvext\" TITLE=\"CSV - Monthly\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>";
  print FOUT2 "</TD></TR>\n";
  
  print FOUT2 "</TABLE>\n"; #
  print FOUT2 "</TD></TR>\n"; #
  print FOUT2 "<TR><TD ALIGN=CENTER>";

  $home_monthly_lines2 = &translate_homepage($home_monthly_lines);

  print FOUT2 "<DIV ID=\"tog_month1_home\" STYLE=\"display:inline\">";
  print FOUT2 "$home_monthly_lines2";
  print FOUT2 "</DIV>";
  print FOUT2 "<DIV ID=\"tog_month2_home\" STYLE=\"display:none\">";
  print FOUT2 "</DIV>";
  
  print FOUT2 "</TD></TR></TABLE>\n";
  print FOUT2 "</TD>";

  # Year

  print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
  print FOUT2 " CLASS=\"homepage\"";
  print FOUT2 ">\n";

  print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";
  print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #

  print FOUT2 "<A HREF=\"$I$dirsepurl$dirdate$dirsepurl$statnameyear\">" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$statnameyear");
  print FOUT2 "<IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_year\" BORDER=0 ALT=\"Yearly\">";
  print FOUT2 "</A>\n" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$statnameyear");
  
  print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";
  print FOUT2 "<A HREF=\"$I$dirsepurl$dirdate$dirsepurl$statnameyear\">" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$statnameyear");
  print FOUT2 "$L{'Years'}";
  print FOUT2 "</A>\n" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$statnameyear");

  print FOUT2 "</TD><TD ALIGN=CENTER>";
  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_year1_home','tog_year2_home');\">External</A><BR>";
  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_year2_home','tog_year1_home');\">Domain</A><BR>";
  print FOUT2 "</TD><TD ALIGN=RIGHT>\n";
  
  $tabnamecsv = $tabnameyear;
  $tabnamecsv =~ s/$htmlext//;
  
  print FOUT2 "<A HREF=\"$dircsv$dirsepurl$tabnamecsv$csvext\" TITLE=\"CSV - Yearly\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>";
  print FOUT2 "</TD></TR>\n";

  print FOUT2 "</TABLE>\n"; #
  print FOUT2 "</TD></TR>\n"; #
  
  print FOUT2 "<TR><TD ALIGN=CENTER>";
  
  $home_yearly_lines2 = &translate_homepage($home_yearly_lines);

  print FOUT2 "<DIV ID=\"tog_year1_home\" STYLE=\"display:inline\">";
  print FOUT2 "$home_yearly_lines2";
  print FOUT2 "</DIV>";
  print FOUT2 "<DIV ID=\"tog_year2_home\" STYLE=\"display:none\">";
  print FOUT2 "</DIV>";
      
  print FOUT2 "</TD></TR></TABLE>\n";

  print FOUT2 "</TD>\n";

  } # End if ($nbdays > 0)
  print FOUT2 "</TR>\n";
  print FOUT2 "</TABLE>\n";
#  print FOUT2 "</TD>\n";
  
  $count_block = 0;

#  print FOUT2 "</TR>\n";
#  print FOUT2 "</TABLE>\n";
  print FOUT2 "</TD>\n";
  print FOUT2 "</TR>\n";
  print FOUT2 "<TR>\n";
  print FOUT2 "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";

  ### second line
#  print "Hosts\n" if ($debug == 1);
  $count_block++;
  print FOUT2 "<TABLE BORDER=0 CELLSPACING=3 CELLPADDING=0>\n";
  print FOUT2 "<TR>\n";
  print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
  print FOUT2 " CLASS=\"homepage\"";
  print FOUT2 ">\n";

  print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";
  print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #

  print FOUT2 "<A HREF=\"$I$dirsepurl$dirsite$dirsepurl$filesites\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_hosts\" BORDER=0 ALT=\"Hosts\"></A>\n";
  
  print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";
  print FOUT2 "<A HREF=\"$I$dirsepurl$dirsite$dirsepurl$filesites\">$L{'Hosts'}</A>\n";
  print FOUT2 "</TD><TD ALIGN=CENTER>";
  
  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_hosts1_home','tog_hosts2_home');\">Graph</A><BR>";
  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_hosts2_home','tog_hosts1_home');\">Top $top_home</A>";
  
  print FOUT2 "</TD><TD ALIGN=RIGHT>";
  
  print FOUT2 "<A HREF=\"$dircsv$dirsepurl$incservexterne$csvext\" TITLE=\"CSV - External hosts\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>";

  print FOUT2 "<A HREF=\"$dircsv$dirsepurl$incservinterne$csvext\" TITLE=\"CSV - Internal hosts\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>";

  print FOUT2 "</TD></TR>";
  print FOUT2 "</TABLE>\n"; #
  print FOUT2 "</TD></TR>\n"; #

  print FOUT2 "<TR><TD>";
  print FOUT2 "<DIV ID=\"tog_hosts1_home\" STYLE=\"display:inline\">";

  if ($fly_set == 0) {

      $chart_id = 0;
      &Load_DailyData($datafile,$dirdata);

      $xlegend = "";
      $ylegend = "";
      
      $info = "info".$chart_id;	

      undef @ref_tab;
      push(@ref_tab,\@tabreq) if ($mail_format == 0);
      push(@ref_tab,\@tabacc);
      push(@ref_tab,\@tabmm);
      push(@ref_tab,\@tabdoc);
      push(@ref_tab,\@tabscript);
      push(@ref_tab,\@tabuser);
      push(@ref_tab,\@tabtrafic);
	
      @ref_tab_name = ('requests','accesses','hosts','documents2','scripts','users','traffic') if ($mail_format == 0);
      @ref_tab_name = ('accesses','hosts','documents2','scripts','users','traffic') if ($mail_format == 1);

      &MakeDailyGraphJqplotInit(*FOUT2, eval($Lang{$lang[$nblang]}),$I,1,$unit_div,\@ref_tab,\@ref_tab_name,\@listdate,$chart_id);

      @graph_to_display = ('Hosts');

      undef @ref_tab;
      push(@ref_tab,\@tabmm);

	
      &MakeDailyGraphJqplot(*FOUT2, eval($Lang{$lang[$nblang]}),$I,1,\@graph_to_display,\@ref_tab,\@listdate,\@serie_color,1,$unit,$chart_id,3,"hosts",$info,0,$xlegend,$ylegend,$xmax_home_jqplot,$dirsite);

      &AddJqplotHtml(*FOUT2, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_home_jqplot,$ymax_home_jqplot,0);

      $chart_id += $#list_graph_name_jqplot+1;
  }

  if ($fly_set == 1) {

      $tmp = $dirgraph.$dirsep."home-hostsy".$gifext;
      if (-f "$path$tmp") {
	  print FOUT2 "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
	  print FOUT2 "<TR>\n";
	  print FOUT2 "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"y\"></TD>\n";
	  $tmp = $dirgraph.$dirsep."home-hosts".$gifext;
	  print FOUT2 "<TD><IMG WIDTH=$xmax_home HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"graph\" ";
	  print FOUT2 "USEMAP=\"#map_host_graph\" " if ($map_host_graph ne '');
	  print FOUT2 "BORDER=0></TD>\n";
	  print FOUT2 "</TR><TR><TD></TD>\n";
	  $tmp = $dirgraph.$dirsep."home-hostsx".$gifext;
	  print FOUT2 "<TD><IMG WIDTH=$xmax_home HEIGHT=$ydecal SRC=\"$tmp\" ALT=\"x\"></TD>\n";
	  print FOUT2 "</TR>\n";
	  print FOUT2 "</TABLE></CENTER>\n";
      }
  }

  print FOUT2 "</DIV>";
  print FOUT2 "<DIV ID=\"tog_hosts2_home\" STYLE=\"display:none\">";
  &HostsTab(*FOUT2,*L,$I,5,1);
  print FOUT2 "</DIV>";
  print FOUT2 "</TD></TR></TABLE>\n";

  if ($map_host_graph ne '' && $fly_set == 1) {
      $tmp = &map_homepage_check($map_host_graph,$I);
      if ($tmp ne '') {
	  print FOUT2 "<MAP NAME=\"map_host_graph\">";
	  print FOUT2 "$tmp";
	  print FOUT2 "</MAP>\n";
      }
  }
  print FOUT2 "</TD>\n";

  # Hits

#  $count_block++;
#  print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
#  print FOUT2 " CLASS=\"homepage\"";
#  print FOUT2 ">\n";

#  print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";
#  print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #

#  print FOUT2 "<A HREF=\"$I$dirsepurl$dirpage$dirsepurl$filepages\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_pages\" BORDER=0 ALT=\"Requests\"></A>\n";
#  print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";
#  print FOUT2 "<A HREF=\"$I$dirsepurl$dirpage$dirsepurl$filepages\">$L{'Requests'}</A>\n";
#  print FOUT2 "</TD><TD ALIGN=CENTER>";

#  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_hits1_home','tog_hits2_home');\">Graph</A><BR>";
#  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_hits2_home','tog_hits1_home');\">Top $top_home</A>";
  
#  print FOUT2 "</TD><TD ALIGN=RIGHT>";
  
##  print FOUT2 "<A HREF=\"$dircsv$dirsepurl$incpage$csvext\" TITLE=\"CSV - Pages\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>";

#  print FOUT2 "</TD></TR>\n";
#  print FOUT2 "</TABLE>\n"; #
#  print FOUT2 "</TD></TR>\n"; #

#  print FOUT2 "<TR><TD ALIGN=CENTER COLSPAN=3>";
  
#  print FOUT2 "<DIV ID=\"tog_hits1_home\" STYLE=\"display:inline\">";
#  $tmp = $dirgraph.$dirsep."home-hitsy".$gifext;
#  if (-f "$path$tmp") {
#      print FOUT2 "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
#      print FOUT2 "<TR>\n";
#      print FOUT2 "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"y\"></TD>\n";
#      $tmp = $dirgraph.$dirsep."home-hits".$gifext;
#      print FOUT2 "<TD><IMG WIDTH=$xmax_home HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"graph\" USEMAP=\"#map_hits_graph\" BORDER=0></TD>\n";
#      print FOUT2 "</TR><TR><TD></TD>\n";
#      $tmp = $dirgraph.$dirsep."home-hitsx".$gifext;
#      print FOUT2 "<TD><IMG WIDTH=$xmax_home HEIGHT=$ydecal SRC=\"$tmp\" ALT=\"x\"></TD>\n";
#      print FOUT2 "</TR>\n";
#      print FOUT2 "</TABLE></CENTER>\n";
#  }
#  print FOUT2 "</DIV>";
  
#  print FOUT2 "<DIV ID=\"tog_hits2_home\" STYLE=\"display:none\">";
##  &PagesTab(*FOUT2,*L,$I,5,1);
#  print FOUT2 "</DIV>";
  
#  print FOUT2 "</TD></TR></TABLE>\n";
  
#  print FOUT2 "<MAP NAME=\"map_hits_graph\">";
#  $tmp = &map_homepage_check($map_hit_graph,$I);
#  print FOUT2 "$tmp";
#  print FOUT2 "</MAP>\n";

#  print FOUT2 "</TD>\n";


  # Pages
#  print "Pages\n" if ($debug == 1);
  $count_block++;
  print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
  print FOUT2 " CLASS=\"homepage\"";
  print FOUT2 ">\n";

  print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";
  print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #

  print FOUT2 "<A HREF=\"$I$dirsepurl$dirpage$dirsepurl$filepages\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_pages\" BORDER=0 ALT=\"Pages\"></A>\n";
  print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";
  print FOUT2 "<A HREF=\"$I$dirsepurl$dirpage$dirsepurl$filepages\">$L{'Pages'}</A>\n";
  print FOUT2 "</TD><TD ALIGN=CENTER>";

  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_pages1_home','tog_pages2_home');\">Graph</A><BR>";
  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_pages2_home','tog_pages1_home');\">Top $top_home</A>";
  
  print FOUT2 "</TD><TD ALIGN=RIGHT>";
  
  print FOUT2 "<A HREF=\"$dircsv$dirsepurl$incpage$csvext\" TITLE=\"CSV - Pages\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>";

  print FOUT2 "</TD></TR>\n";
  print FOUT2 "</TABLE>\n"; #
  print FOUT2 "</TD></TR>\n"; #

  print FOUT2 "<TR><TD ALIGN=CENTER COLSPAN=3>";
  
  print FOUT2 "<DIV ID=\"tog_pages1_home\" STYLE=\"display:inline\">";

  if ($fly_set == 0) {

	$info = "info".$chart_id;	
	undef @ref_tab;
	push(@ref_tab,\@tabacc);

	@graph_to_display = ('Pages');

	&MakeDailyGraphJqplot(*FOUT2, eval($Lang{$lang[$nblang]}),$I,1,\@graph_to_display,\@ref_tab,\@listdate,\@serie_color,1,$unit,$chart_id,3,"accesses",$info,0,$xlegend,$ylegend,$xmax_home_jqplot,$dirpage);

	&AddJqplotHtml(*FOUT2, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_home_jqplot,$ymax_home_jqplot,0);

	$chart_id += $#list_graph_name_jqplot+1;
  }

  if ($fly_set == 1) {

      $tmp = $dirgraph.$dirsep."home-pagesy".$gifext;
      if (-f "$path$tmp") {
	  print FOUT2 "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
	  print FOUT2 "<TR>\n";
	  print FOUT2 "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"y\"></TD>\n";
	  $tmp = $dirgraph.$dirsep."home-pages".$gifext;
	  print FOUT2 "<TD><IMG WIDTH=$xmax_home HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"graph\" ";
	  print FOUT2 "USEMAP=\"#map_page_graph\" " if ($map_page_graph ne '');
	  print FOUT2 "BORDER=0></TD>\n";
	  print FOUT2 "</TR><TR><TD></TD>\n";
	  $tmp = $dirgraph.$dirsep."home-pagesx".$gifext;
	  print FOUT2 "<TD><IMG WIDTH=$xmax_home HEIGHT=$ydecal SRC=\"$tmp\" ALT=\"x\"></TD>\n";
	  print FOUT2 "</TR>\n";
	  print FOUT2 "</TABLE></CENTER>\n";
      }
  }

  print FOUT2 "</DIV>";
  
  print FOUT2 "<DIV ID=\"tog_pages2_home\" STYLE=\"display:none\">";
  &PagesTab(*FOUT2,*L,$I,5,1);
  print FOUT2 "</DIV>";
  
  print FOUT2 "</TD></TR></TABLE>\n";
  if ($map_page_graph ne '' && $fly_set == 1) {
      $tmp = &map_homepage_check($map_page_graph,$I);
      if ($tmp ne '') {
	  print FOUT2 "<MAP NAME=\"map_page_graph\">";
	  print FOUT2 "$tmp";
	  print FOUT2 "</MAP>\n";
      }
  }

  print FOUT2 "</TD>\n";


  if ($precision > 2) {
      if (-f "$path$I$dirsep$dirlist$dirsep$filetype$htmlext") {
#	  print "Filetype\n" if ($debug == 1);
	  $count_block++;
	  print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
	  print FOUT2 " CLASS=\"homepage\"";
	  print FOUT2 ">\n";

	  print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";
	  print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #

	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$filetype$htmlext\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_filetype\" BORDER=0 ALT=\"Filetype\"></A>\n";
	  print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";
	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$filetype$htmlext\">$L{'Filetype'}</A>\n";
	  print FOUT2 "</TD><TD ALIGN=CENTER>\n";
	  
	  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_filetype1_home','tog_filetype2_home');\">Graph</A><BR>";
	  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_filetype2_home','tog_filetype1_home');\">Top $top_home</A>";
	  print FOUT2 "</TD></TR>\n";

	  print FOUT2 "</TABLE>\n"; #
	  print FOUT2 "</TD></TR>\n"; #
	  print FOUT2 "<TR><TD ALIGN=CENTER COLSPAN=2>";
	  
	  print FOUT2 "<DIV ID=\"tog_filetype1_home\" STYLE=\"display:inline\">";

	  if ($fly_set == 0) {
	      $info = "info".$chart_id;
	      $line_filetype_pie = &MakePieGraphJqplot(*FOUT2, eval($Lang{$lang[$nblang]}),$I,\%downloadext,\@serie_color,$reqtot,2,1,$unit,$chart_id,0,$info,"","","$dirlist$dirsepurl$filetype$htmlext");

	      print FOUT2 "<div id=\"";
	      print FOUT2 "chart".$chart_id;
	      print FOUT2 "\" ";
	      print FOUT2 "style=\"";
	      print FOUT2 "height:".$ymax_home_jqplot."px; width:".$ymax_home_jqplot."px;\">";
	      print FOUT2 "</div>\n";
	      $chart_id++;	      
	  }


	  if ($fly_set == 1) {
	      $tmp = $dirgraph.$dirsep."home-filetype".$gifext;
	      if (-f "$path$tmp") {
		  if (-f "$path$dirgraph$dirsepurl$filetype_home_pie") {
		      print FOUT2 "<BR><IMG WIDTH=\"$pie_square_home\" HEIGHT=\"$pie_square_home\" SRC=\"$tmp\" ";
		      print FOUT2 "USEMAP=\"#map_filetype\" " if ($map_filetype_pie ne '');
		      print FOUT2 "BORDER=0 ALT=\"graph\">\n";
		  }
	      }
	  }

	  print FOUT2 "</DIV>\n";
	  
	  print FOUT2 "<DIV ID=\"tog_filetype2_home\" STYLE=\"display:none\">";
	  print FOUT2 "<TABLE BORDER=0>";
	  print FOUT2 "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Filetype'}</TH></TR>";
	  print FOUT2 "$line_filetype_pie";
	  print FOUT2 "</TABLE>\n";
	  print FOUT2 "</DIV>\n";
	  
	  print FOUT2 "</TD></TR></TABLE>\n";

	  if ($map_filetype_pie ne '' && $fly_set == 1) {
	      $tmp = &map_homepage_check($map_filetype_pie,$I);
	      if ($tmp ne '') {
		  print FOUT2 "<MAP NAME=\"map_filetype\">\n";
		  print FOUT2 "$tmp";
		  print FOUT2 "</MAP>\n";
	      }
	  }

	  print FOUT2 "</TD>\n";
      }
  }

  if (-s "$path$dirinc$dirsep$incstatus") {
      $count_block++;
#      print "Status\n" if ($debug == 1);
      print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP\n";
      print FOUT2 " CLASS=\"homepage\"";
      print FOUT2 ">\n";

      print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";
      print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #
      
      print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$incstatus$htmlext\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_status\" BORDER=0 ALT=\"Status_code\"></A>\n";

      print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";

      print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$incstatus$htmlext\">$L{'Status_code'}</A>\n";  
      print FOUT2 "</TD><TD ALIGN=CENTER>\n";
      
      print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_status1_home','tog_status2_home');\">Graph</A><BR>";
      print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_status2_home','tog_status1_home');\">Top $top_home</A>";
      print FOUT2 "</TD></TR>\n";
      
      print FOUT2 "</TABLE>\n"; #
      print FOUT2 "</TD></TR>\n"; #
      
      print FOUT2 "<TR><TD ALIGN=CENTER COLSPAN=2>";
      
      print FOUT2 "<DIV ID=\"tog_status1_home\" STYLE=\"display:inline\">";

      if ($fly_set == 0) {
	  $info = "info".$chart_id;
#	  ($line_status_pie,$map_status_pie) = &MakePieChart($status_home_pie,$loglines,\%status_code,5,0,"$dirlist$dirsepurl$incstatus$htmlext",$rayon_home);
	  $line_status_pie = &MakePieGraphJqplot(*FOUT2, eval($Lang{$lang[$nblang]}),$I,\%status_code,\@serie_color,$loglines,5,1,$unit,$chart_id,0,$info,"","",$dirstatus);

	  print FOUT2 "<div id=\"";
	  print FOUT2 "chart".$chart_id;
	  print FOUT2 "\" ";
	  print FOUT2 "style=\"";
	  print FOUT2 "height:".$ymax_home_jqplot."px; width:".$ymax_home_jqplot."px;\">";
	  print FOUT2 "</div>\n";
	  $chart_id++;	      
      }

      if ($fly_set == 1) {
	  if (-f "$path$dirgraph$dirsepurl$status_home_pie") {
	      print FOUT2 "<BR><IMG WIDTH=\"$pie_square_home\" HEIGHT=\"$pie_square_home\" SRC=\"$dirgraph$dirsepurl$status_home_pie\" ";
	      print FOUT2 "USEMAP=\"#map_status\" " if ($map_status_pie ne '');
	      print FOUT2 "BORDER=0 ALT=\"graph\">\n";
	  }
      }
      
      print FOUT2 "</DIV>\n";
  
      print FOUT2 "<DIV ID=\"tog_status2_home\" STYLE=\"display:none\">";
      print FOUT2 "<TABLE BORDER=0>";
      print FOUT2 "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Status_code'}</TH></TR>";
      print FOUT2 "$line_status_pie";
      print FOUT2 "</TABLE>\n";
      print FOUT2 "</DIV>\n";
      
      print FOUT2 "</TD></TR></TABLE>\n";
  
      if ($map_status_pie ne '' && $fly_set == 1) {
	  $tmp = &map_homepage_check($map_status_pie,$I);
	  if ($tmp ne '') {
	      print FOUT2 "<MAP NAME=\"map_status\">\n";
	      print FOUT2 "$tmp";
	      print FOUT2 "</MAP>\n";
	  }
      }

#  print FOUT2 "</TABLE>\n";
      print FOUT2 "</TD>\n";
  }

  if ($count_block == 4) {
      print FOUT2 "</TR>\n";
      print FOUT2 "</TABLE>\n";

      print FOUT2 "</TD>\n";
      print FOUT2 "</TR>\n";

      print FOUT2 "<TR>\n";
      print FOUT2 "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";
      print FOUT2 "<TABLE BORDER=0 CELLSPACING=3 CELLPADDING=0>\n";
      print FOUT2 "<TR>\n";
      $count_block = 0;
  }

#  print FOUT2 "</TR>\n";

###

#  if ($precision > 2 && ($inc_script == 1 && $ftp_format == 0 && $scriptunique != 0) || $notrafic == 0 || ($paysunique != 0 && $skip_pays == 0)) {

#  print FOUT2 "<TR>\n";
#  print FOUT2 "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";
#  print FOUT2 "<TABLE BORDER=0 CELLSPACING=10 CELLPADDING=0>\n";


  ### Third line

 #     print FOUT2 "<TR>\n";

      
      if ($inc_script == 1 && $ftp_format == 0 && $scriptunique != 0) {
	  $count_block++;
#	  print "Script\n" if ($debug == 1);
	  print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
	  print FOUT2 " CLASS=\"homepage\"";
	  print FOUT2 ">\n";

	  print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";
	  print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #

	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirscript$dirsepurl$filescripts\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_script\" BORDER=0 ALT=\"Scripts\"></A>\n";

	  print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";
	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirscript$dirsepurl$filescripts\">$L{'Scripts'}</A>\n";
	  
	  print FOUT2 "</TD><TD ALIGN=CENTER>";
	  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_scripts1_home','tog_scripts2_home');\">Graph</A><BR>";
	  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_scripts2_home','tog_scripts1_home');\">Top $top_home</A><BR>";
	  print FOUT2 "</TD><TD ALIGN=RIGHT>\n";

	  print FOUT2 "<A HREF=\"$dircsv$dirsepurl$incscript$csvext\" TITLE=\"CSV - Pages\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>";
	  print FOUT2 "</TD></TR>\n";

	  print FOUT2 "</TABLE>\n"; #
	  print FOUT2 "</TD></TR>\n"; #

	  print FOUT2 "<TR><TD ALIGN=CENTER COLSPAN=3 HEIGHT=\"$ymax_home_jqplot\">";
	  
	  print FOUT2 "<DIV ID=\"tog_scripts1_home\" STYLE=\"display:inline\">";

	  if ($scriptmax > 0) {
	      if ($fly_set == 0) {
		  $info = "info".$chart_id;
		  @graph_to_display = ('Scripts');

		  undef @ref_tab;
		  push(@ref_tab,\@tabscript);

		  &MakeDailyGraphJqplot(*FOUT2, eval($Lang{$lang[$nblang]}),$I,1,\@graph_to_display,\@ref_tab,\@listdate,\@serie_color,1,$unit,$chart_id,3,"scripts",$info,0,$xlegend,$ylegend,$xmax_home_jqplot,$dirscript);
		  
		  &AddJqplotHtml(*FOUT2, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_home_jqplot,$ymax_home_jqplot,0);
	      
		  $chart_id += $#list_graph_name_jqplot+1;
	      }
	  } else {
	      $msg = "$L{'No_enough_data_to_display_graph'}";
	      &NoDataToDisplay(*FOUT2,$msg);
	  }

	  if ($fly_set == 1) {
	      $tmp = $dirgraph.$dirsep."home-scriptsy".$gifext;
	      if (-f "$path$tmp") {
		  print FOUT2 "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
		  print FOUT2 "<TR>\n";
		  print FOUT2 "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"y\"></TD>\n";
		  $tmp = $dirgraph.$dirsep."home-scripts".$gifext;
		  print FOUT2 "<TD><IMG WIDTH=$xmax_home HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"graph\" ";
		  print FOUT2 "USEMAP=\"#map_script_graph\" " if ($map_script_graph ne '');
		  print FOUT2 "BORDER=0></TD>\n";
		  print FOUT2 "</TR><TR><TD></TD>\n";
		  $tmp = $dirgraph.$dirsep."home-scriptsx".$gifext;
		  print FOUT2 "<TD><IMG WIDTH=$xmax_home HEIGHT=$ydecal SRC=\"$tmp\" ALT=\"x\"></TD>\n";
		  print FOUT2 "</TR>\n";
		  print FOUT2 "</TABLE></CENTER>\n";
	      }
	  }
	  print FOUT2 "</DIV>";
	  print FOUT2 "<DIV ID=\"tog_scripts2_home\" STYLE=\"display:none\">";
	  &ScriptsTab(*FOUT2,*L,$I,5,1);
	  print FOUT2 "</DIV>";
	  
	  print FOUT2 "</TD></TR></TABLE>\n";
	  if ($map_script_graph ne '' && $fly_set == 1) {
	      $tmp = &map_homepage_check($map_script_graph,$I);
	      if ($tmp ne '') {
		  print FOUT2 "<MAP NAME=\"map_script_graph\">";
		  print FOUT2 "$tmp";
		  print FOUT2 "</MAP>\n";
	      }
	  }
	  print FOUT2 "</TD>\n";
      }

  if ($count_block == 4) {
      print FOUT2 "</TR>\n";
      print FOUT2 "</TABLE>\n";

      print FOUT2 "</TD>\n";
      print FOUT2 "</TR>\n";

      print FOUT2 "<TR>\n";
      print FOUT2 "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";
      print FOUT2 "<TABLE BORDER=0 CELLSPACING=3 CELLPADDING=0>\n";
      print FOUT2 "<TR>\n";
      $count_block = 0;
  }

      if ($notrafic == 0) {
	  $count_block++;
#	  print "Traffic\n" if ($debug == 1);
	  print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
	  print FOUT2 " CLASS=\"homepage\"";
	  print FOUT2 ">\n";
	  print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";
	  print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #

	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$dirtraffic$htmlext\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_traffic\" BORDER=0 ALT=\"Pages\"></A>\n";
	  print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";
	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$dirtraffic$htmlext\">$L{'Traffic'}</A>\n";

	  print FOUT2 "</TD><TD ALIGN=CENTER>\n";
	  print FOUT2 "<A HREF=\"javascript:ToggleDelta('tog_traffic1_home','tog_traffic2_home','tog_traffic3_home');\">Graph</A><BR>";
	  print FOUT2 "<A HREF=\"javascript:ToggleDelta('tog_traffic2_home','tog_traffic1_home','tog_traffic3_home');\">Top $top_home $L{'Pages'}</A><BR>";
	  print FOUT2 "<A HREF=\"javascript:ToggleDelta('tog_traffic3_home','tog_traffic1_home','tog_traffic2_home');\">Top $top_home $L{'Hosts'}</A>";
	  print FOUT2 "</TD></TR>\n";

	  print FOUT2 "</TABLE>\n"; #
	  print FOUT2 "</TD></TR>\n"; #

	  print FOUT2 "<TR><TD ALIGN=CENTER COLSPAN=2>";

	  print FOUT2 "<DIV ID=\"tog_traffic1_home\" STYLE=\"display:inline\">";

	  if ($fly_set == 0) {
	      $info = "info".$chart_id;
	      @graph_to_display = ('Trafic');

	      undef @ref_tab;
	      push(@ref_tab,\@tabtrafic);

	      &MakeDailyGraphJqplot(*FOUT2, eval($Lang{$lang[$nblang]}),$I,1,\@graph_to_display,\@ref_tab,\@listdate,\@serie_color,$unit_div,$unit,$chart_id,3,"traffic",$info,0,$xlegend,$ylegend,$xmax_home_jqplot,$dirtraffic);

	      &AddJqplotHtml(*FOUT2, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_home_jqplot,$ymax_home_jqplot,0);
	      
	      $chart_id += $#list_graph_name_jqplot+1;
	  }
	  
	  if ($fly_set == 1) {
	      $tmp = $dirgraph.$dirsep."home-traficy".$gifext;
	      if (-f "$path$tmp") {
		  print FOUT2 "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
		  print FOUT2 "<TR>\n";
		  print FOUT2 "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"y\"></TD>\n";
		  $tmp = $dirgraph.$dirsep."home-trafic".$gifext;
		  print FOUT2 "<TD><IMG WIDTH=$xmax_home HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"graph\" ";
		  print FOUT2 "USEMAP=\"#map_trafic_graph\" " if ($map_trafic_graph ne '');
		  print FOUT2 "BORDER=0></TD>\n";
		  print FOUT2 "</TR><TR><TD></TD>\n";
		  $tmp = $dirgraph.$dirsep."home-traficx".$gifext;
		  print FOUT2 "<TD><IMG WIDTH=$xmax_home HEIGHT=$ydecal SRC=\"$tmp\" ALT=\"x\"></TD>\n";
		  print FOUT2 "</TR>\n";
		  print FOUT2 "</TABLE></CENTER>\n";
	      }
	  }

	  print FOUT2 "</DIV>";
	  print FOUT2 "<DIV ID=\"tog_traffic2_home\" STYLE=\"display:none\">";
	  $line_page_display = &TraficPageTab(*FOUT2,*L,$I,5,1);
	  print FOUT2 "$line_page_display";
	  print FOUT2 "</DIV>";
	  print FOUT2 "<DIV ID=\"tog_traffic3_home\" STYLE=\"display:none\">";
	  $line_page_display = &TraficServerTab(*FOUT2,*L,$I,5,1);
	  print FOUT2 "$line_page_display";
	  print FOUT2 "</DIV>";
	  
	  print FOUT2 "</TD></TR></TABLE>\n";
	  if ($map_trafic_graph ne '' && $fly_set == 1) {
	      $tmp = &map_homepage_check($map_trafic_graph,$I);
	      if ($tmp ne '') {
		  print FOUT2 "<MAP NAME=\"map_trafic_graph\">";
		  print FOUT2 "$tmp";
		  print FOUT2 "</MAP>\n";
	      }
	  }
	  print FOUT2 "</TD>\n";	  
      }

  if ($count_block == 4) {
      print FOUT2 "</TR>\n";
      print FOUT2 "</TABLE>\n";

      print FOUT2 "</TD>\n";
      print FOUT2 "</TR>\n";

      print FOUT2 "<TR>\n";
      print FOUT2 "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";
      print FOUT2 "<TABLE BORDER=0 CELLSPACING=3 CELLPADDING=0>\n";
      print FOUT2 "<TR>\n";
      $count_block = 0;
  }

      if ($notrafic == 0 && $totsize != 0) {
#	  print "Download\n" if ($debug == 1);
	  $count_block++;
	  print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
	  print FOUT2 " CLASS=\"homepage\"";
	  print FOUT2 ">\n";
	  print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";
	  print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #

	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$dirdownload$htmlext\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_pie\" BORDER=0 ALT=\"Download\"></A>\n";

	  print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";
	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$dirdownload$htmlext\">$L{'Download'}</A>\n";
	  
	  print FOUT2 "</TD><TD ALIGN=CENTER>";
	  
	  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_download1_home','tog_download2_home');\">Graph</A><BR>";
	  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_download2_home','tog_download1_home');\">Top $top_home</A><BR>";
	  
	  print FOUT2 "</TD></TR>";

	  print FOUT2 "</TABLE>\n"; #
	  print FOUT2 "</TD></TR>\n"; #
	  print FOUT2 "<TR><TD ALIGN=CENTER COLSPAN=2>";
	  print FOUT2 "<DIV ID=\"tog_download1_home\" STYLE=\"display:inline\">";

      if ($fly_set == 0) {

	  $info = "info".$chart_id;

	  $line_download_pie = &MakePieGraphJqplot(*FOUT2, eval($Lang{$lang[$nblang]}),$I,\%downloadrange2,\@serie_color,$totsize,6,$unit_div,$unit,$chart_id,0,$info,"","",$dirstatus);

	  print FOUT2 "<div id=\"";
	  print FOUT2 "chart".$chart_id;
	  print FOUT2 "\" ";
	  print FOUT2 "style=\"";
	  print FOUT2 "height:".$ymax_home_jqplot."px; width:".$ymax_home_jqplot."px;\">";
	  print FOUT2 "</div>\n";
	  $chart_id++;	      
      }

	  if ($fly_set == 1) {
	      if (-f "$path$dirgraph$dirsepurl$download_home_pie") {
		  print FOUT2 "<BR><IMG WIDTH=\"$pie_square_home\" HEIGHT=\"$pie_square_home\" SRC=\"$dirgraph$dirsepurl$download_home_pie\" ";
		  print FOUT2 "USEMAP=\"#map_download\" " if ($map_download_pie ne '');
		  print FOUT2 "BORDER=0 ALT=\"graph\">\n";
	      }
	  }
	  print FOUT2 "</DIV>\n";
	  print FOUT2 "<DIV ID=\"tog_download2_home\" STYLE=\"display:none\">";
	  print FOUT2 "<TABLE BORDER=0>";
	  print FOUT2 "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Download'}</TH></TR>";
	  print FOUT2 "$line_download_pie";
	  print FOUT2 "</TABLE>\n";

	  print FOUT2 "</DIV>\n";
	      
	  print FOUT2 "</TD></TR></TABLE>\n";
	  if ($map_download_pie ne '' && $fly_set == 1) {
	      $tmp = &map_homepage_check($map_download_pie,$I);
	      if ($tmp ne '') {
		  print FOUT2 "<MAP NAME=\"map_download\">\n";
		  print FOUT2 "$tmp";
		  print FOUT2 "</MAP>\n";
	      }
	  }
	  print FOUT2 "</TD>\n";	  
      }

  if ($count_block == 4) {
      print FOUT2 "</TR>\n";
      print FOUT2 "</TABLE>\n";

      print FOUT2 "</TD>\n";
      print FOUT2 "</TR>\n";

      print FOUT2 "<TR>\n";
      print FOUT2 "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";
      print FOUT2 "<TABLE BORDER=0 CELLSPACING=3 CELLPADDING=0>\n";
      print FOUT2 "<TR>\n";
      $count_block = 0;
  }


      if ($paysunique != 0 && $skip_pays == 0) {
	  $count_block++;
#	  print "Country\n" if ($debug == 1);
	  print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
	  print FOUT2 " CLASS=\"homepage\"";
	  print FOUT2 ">\n";
	  print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";
	  print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #

	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirpays$dirsepurl$filepays\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_countries\" BORDER=0 ALT=\"Countries\"></A>\n";
	  print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";
	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirpays$dirsepurl$filepays\">$L{'Countries'}</A>\n";

	  
	  print FOUT2 "</TD><TD ALIGN=CENTER>";
	  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_country1_home','tog_country2_home');\">Graph</A><BR>";
	  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_country2_home','tog_country1_home');\">Top $top_home</A><BR>";
	  print FOUT2 "</TD><TD ALIGN=RIGHT>";

	  print FOUT2 "</TD></TR>";
	  print FOUT2 "</TABLE>\n"; #
	  print FOUT2 "</TD></TR>\n"; #
	  print FOUT2 "<TR><TD COLSPAN=3 ALIGN=CENTER>";
	  
	  print FOUT2 "<DIV ID=\"tog_country1_home\" STYLE=\"display:inline\">";

	  if ($fly_set == 0) {
	      $info = "info".$chart_id;
	      $tmp = $serverunique+$locserver if ($localonly != 1);
	      $tmp = $locserver if ($localonly == 1);

	      $line_pays_pie = &MakePieGraphJqplot(*FOUT2, eval($Lang{$lang[$nblang]}),$I,\%serverpays,\@serie_color,$tmp,3,1,$unit,$chart_id,0,$info,"","","$dirpays$dirsepurl$filepays") if ($geoipcity == 0);
	      $line_pays_pie = &MakePieGraphJqplot(*FOUT2, eval($Lang{$lang[$nblang]}),$I,\%serverpayscity,\@serie_color,$tmp,3,1,$unit,$chart_id,0,$info,"","","$dirpays$dirsepurl$filepays") if ($geoipcity == 1);
	      
	      print FOUT2 "<div id=\"";
	      print FOUT2 "chart".$chart_id;
	      print FOUT2 "\" ";
	      print FOUT2 "style=\"";
	      print FOUT2 "height:".$ymax_home_jqplot."px; width:".$ymax_home_jqplot."px;\">";
	      print FOUT2 "</div>\n";
	      $chart_id++;	      
	  }

	  if ($fly_set == 1) {	      
	      if (-f "$path$dirgraph$dirsepurl$pays_home_pie") {
		  print FOUT2 "<BR><IMG WIDTH=\"$pie_square_home\" HEIGHT=\"$pie_square_home\" SRC=\"$dirgraph$dirsepurl$pays_home_pie\" ";
		  print FOUT2 "USEMAP=\"#map_country\" " if ($map_country_pie ne '');
		  print FOUT2 "BORDER=0 ALT=\"graph\">\n";
	      } 
	  }

	  print FOUT2 "</DIV>\n";
	  print FOUT2 "<DIV ID=\"tog_country2_home\" STYLE=\"display:none\">";
	  print FOUT2 "<TABLE BORDER=0>";
	  print FOUT2 "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Countries'}</TH></TR>";
	  print FOUT2 "$line_pays_pie";
	  print FOUT2 "</TABLE>\n";
	  print FOUT2 "</DIV>\n";
	  
	  print FOUT2 "</TD></TR></TABLE>\n";
	  if ($map_country_pie ne '' && $fly_set == 1) {
	      $tmp = &map_homepage_check($map_country_pie,$I);
	      if ($tmp ne '') {
		  print FOUT2 "<MAP NAME=\"map_country\">\n";
		  print FOUT2 "$tmp";
		  print FOUT2 "</MAP>\n";
	      }
	  }
	  print FOUT2 "</TD>\n";	  
      }

  if ($count_block == 4) {
      print FOUT2 "</TR>\n";
      print FOUT2 "</TABLE>\n";

      print FOUT2 "</TD>\n";
      print FOUT2 "</TR>\n";

      print FOUT2 "<TR>\n";
      print FOUT2 "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";
      print FOUT2 "<TABLE BORDER=0 CELLSPACING=3 CELLPADDING=0>\n";
      print FOUT2 "<TR>\n";
      $count_block = 0;
  }


###

      if (-f "$path$I$dirsep$dirlist$dirsep$filerepert") {
#	  print "Repert\n" if ($debug == 1);
	  $count_block++;
	  print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
	  print FOUT2 " CLASS=\"homepage\"";
	  $tmp = $xmax_home+$xdecal;
	  print FOUT2 " WIDTH=$tmp>\n";
#	  print FOUT2 ">\n";
	  
	  ($line_cloud,$line_cloud_sort) = &MakeCloud(\%freqrachome,'',0) if ($virtualCLF == 0 && $squid_format == 0 && $ftp_format == 0);
	  ($line_cloud,$line_cloud_sort) = &MakeCloud(\%freqrachome,'',1) if ($virtualCLF == 1 || $squid_format == 1 || $ftp_format == 1);
	  
	  print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";
	  print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #
	  
	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$filerepert\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_dir\" BORDER=0 ALT=\"Directories\"></A>\n";
	  
	  print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";
	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$filerepert\">$L{'Directories'}</A>\n";
      
	  print FOUT2 "</TD><TD ALIGN=CENTER>";
	  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_alpha','tog_value');\">Alphabetically</A><BR><A HREF=\"javascript:ToggleBeta('tog_value','tog_alpha');\">By size</A>\n";
	  print FOUT2 "</TD><TD ALIGN=RIGHT>";
	  print FOUT2 "<A HREF=\"$dircsv$dirsepurl$increpert$csvext\" TITLE=\"CSV - Directories\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>";
	  print FOUT2 "</TD></TR>";
	  print FOUT2 "</TABLE>\n"; #
	  
	  print FOUT2 "</TD></TR>\n"; #
	  print FOUT2 "<TR><TD COLSPAN=3>";
	  print FOUT2 "<DIV ID=\"tog_alpha\" STYLE=\"display:inline\">";
	  print FOUT2 "$line_cloud\n";
	  print FOUT2 "</DIV>\n";
	  
	  print FOUT2 "<DIV ID=\"tog_value\" STYLE=\"display:none\">";
	  print FOUT2 "$line_cloud_sort\n";
	  print FOUT2 "</DIV>\n";	      
	  
	  print FOUT2 "</TD></TR></TABLE>\n";
	  print FOUT2 "</TD>\n";      
      }

  if ($count_block == 4) {
      print FOUT2 "</TR>\n";
      print FOUT2 "</TABLE>\n";

      print FOUT2 "</TD>\n";
      print FOUT2 "</TR>\n";

      print FOUT2 "<TR>\n";
      print FOUT2 "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";
      print FOUT2 "<TABLE BORDER=0 CELLSPACING=3 CELLPADDING=0>\n";
      print FOUT2 "<TR>\n";
      $count_block = 0;
  }

      if (-f "$path$dirinc$dirsep$incsession") {
#	  print "Session\n" if ($debug == 1);
	  $count_block++;
	  print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
	  print FOUT2 " CLASS=\"homepage\"";
	  print FOUT2 ">\n";
	  print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";
	  print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #
	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirsession$dirsepurl$filesession\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_session\" BORDER=0 ALT=\"Sessions\"></A>\n";
	  print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";
	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirsession$dirsepurl$filesession\">$L{'Session'}</A>\n";
	  
	  print FOUT2 "</TD><TD ALIGN=CENTER>";
	  
	  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_session1_home','tog_session2_home');\">Graph</A><BR>";
	  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_session2_home','tog_session1_home');\">Top $top_home</A>";
	  
	  print FOUT2 "</TD><TD ALIGN=RIGHT>";
	  
	  print FOUT2 "</TD></TR>";
	  print FOUT2 "</TABLE>\n"; #
	  print FOUT2 "</TD></TR>\n"; #
	  print FOUT2 "<TR><TD COLSPAN=3 HEIGHT=\"$ymax_home_jqplot\">";

	  print FOUT2 "<DIV ID=\"tog_session1_home\" STYLE=\"display:inline\">";

	  if ($fly_set == 0) {

	      $incsession = "session";
	      if (-f "$path$dirinc$dirsep$incsession") {
		  &Load_DailyData($incsession,$dirinc);
	      }

	      if ($sessionmax > 0) {
		  $info = "info".$chart_id;
		  undef @ref_tab;
		  push(@ref_tab,\@tabsession);
	
		  @ref_tab_name = ('sessions');
	
		  &MakeDailyGraphJqplotInit(*FOUT2, eval($Lang{$lang[$nblang]}),$I,1,$unit_div,\@ref_tab,\@ref_tab_name,\@listdatesession,$chart_id);

		  @graph_to_display = ('Sessions');

		  &MakeDailyGraphJqplot(*FOUT2, eval($Lang{$lang[$nblang]}),$I,1,\@graph_to_display,\@ref_tab,\@listdatesession,\@serie_color,1,$unit,$chart_id,3,"sessions",$info,$chart_id,$xlegend,$ylegend,$xmax_home_jqplot,$dirsession);

		  &AddJqplotHtml(*FOUT2, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_home_jqplot,$ymax_home_jqplot,0);
	      
		  $chart_id += $#list_graph_name_jqplot+1;
	      } else {
		  $msg = "$L{'No_enough_data_to_display_graph'}";
		  &NoDataToDisplay(*FOUT2,$msg);
	      }

	  }
	  
	  if ($fly_set == 1) {
	      $tmp = $dirgraph.$dirsep."home-sessiony".$gifext;
	      if (-f "$path$tmp") {
		  print FOUT2 "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
		  print FOUT2 "<TR>\n";
		  print FOUT2 "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"y\"></TD>\n";
		  $tmp = $dirgraph.$dirsep."home-session".$gifext;
		  print FOUT2 "<TD><IMG WIDTH=$xmax_home HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"graph\" ";
		  print FOUT2 "USEMAP=\"#map_session_graph\" " if ($map_session_graph ne '');
		  print FOUT2 "BORDER=0></TD>\n";
		  print FOUT2 "</TR><TR><TD></TD>\n";
		  $tmp = $dirgraph.$dirsep."home-sessionx".$gifext;
		  print FOUT2 "<TD><IMG WIDTH=$xmax_home HEIGHT=$ydecal SRC=\"$tmp\" ALT=\"x\"></TD>\n";
		  print FOUT2 "</TR>\n";
		  print FOUT2 "</TABLE></CENTER>\n";
	      }
	  }

	  print FOUT2 "</DIV>";

	  print FOUT2 "<DIV ID=\"tog_session2_home\" STYLE=\"display:none\">";
	  print FOUT2 "$home_session_lines\n";
	  print FOUT2 "</DIV>";

	  print FOUT2 "</TD></TR></TABLE>\n";
	  if ($map_session_graph ne '' && $fly_set == 1) {
	      $tmp = &map_homepage_check($map_session_graph,$I);
	      if ($tmp ne '') {
		  print FOUT2 "<MAP NAME=\"map_session_graph\">";
		  print FOUT2 "$tmp";
		  print FOUT2 "</MAP>\n";
	      }
	  }
	  print FOUT2 "</TD>\n";      
      }

  if ($count_block == 4) {
      print FOUT2 "</TR>\n";
      print FOUT2 "</TABLE>\n";

      print FOUT2 "</TD>\n";
      print FOUT2 "</TR>\n";

      print FOUT2 "<TR>\n";
      print FOUT2 "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";
      print FOUT2 "<TABLE BORDER=0 CELLSPACING=3 CELLPADDING=0>\n";
      print FOUT2 "<TR>\n";
      $count_block = 0;
  }

      if ($virtualfilter eq '' && $virtualunique > 1) {
	  $count_block++;
#	  print "Virtual\n" if ($debug == 1);
	  print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
	  print FOUT2 " CLASS=\"homepage\"";
	  $tmp = $xmax_home+$xdecal;
	  print FOUT2 " WIDTH=$tmp>\n";

	  print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";
	  print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #
	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$filevirtual\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_destination\" BORDER=0 ALT=\"Destination\"></A>\n";
	  print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";
	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$filevirtual\">$L{'Destination'}</A>\n";
	  
	  print FOUT2 "</TD><TD ALIGN=CENTER>";
	  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_dest_alpha','tog_dest_value');\">Alphabetically</A><BR><A HREF=\"javascript:ToggleBeta('tog_dest_value','tog_dest_alpha');\">By size</A>\n";
	  print FOUT2 "</TD><TD ALIGN=RIGHT>";
	  
	  print FOUT2 "</TD></TR>";
	  print FOUT2 "</TABLE>\n"; #
	  print FOUT2 "</TD></TR>\n"; #
	  print FOUT2 "<TR><TD COLSPAN=3>";
	  print FOUT2 "<DIV ID=\"tog_dest_alpha\" STYLE=\"display:inline\">";
	  print FOUT2 "$line_dest_cloud\n";
	  print FOUT2 "</DIV>\n";
	  
	  print FOUT2 "<DIV ID=\"tog_dest_value\" STYLE=\"display:none\">";
	  print FOUT2 "$line_dest_cloud_sort\n";
	  print FOUT2 "</DIV>\n";	      
	  
	  print FOUT2 "</TD></TR></TABLE>\n";
	  print FOUT2 "</TD>\n";
      }

  if ($count_block == 4) {
      print FOUT2 "</TR>\n";
      print FOUT2 "</TABLE>\n";

      print FOUT2 "</TD>\n";
      print FOUT2 "</TR>\n";

      print FOUT2 "<TR>\n";
      print FOUT2 "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";
      print FOUT2 "<TABLE BORDER=0 CELLSPACING=3 CELLPADDING=0>\n";
      print FOUT2 "<TR>\n";
      $count_block = 0;
  }
     if ($squid_format == 1) {
	  if (-e "$path$I$dirsep$dirproxy$dirsep$filesquid") {
#	      print "Squid\n" if ($debug == 1);
	      $count_block++;
	      print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
	      print FOUT2 " CLASS=\"homepage\"";
	      print FOUT2 ">\n";

	      print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";
	      print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #

	      print FOUT2 "<A HREF=\"$I$dirsepurl$dirproxy$dirsepurl$filesquid\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_squid\" BORDER=0 ALT=\"Proxy\"></A>\n";

	      print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";
	      print FOUT2 "<A HREF=\"$I$dirsepurl$dirproxy$dirsepurl$filesquid\">$L{'Proxy'}</A>\n";

	      print FOUT2 "</TD><TD ALIGN=CENTER>";

	      print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_squid1_home','tog_squid2_home');\">Graph</A><BR>";
	      print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_squid2_home','tog_squid1_home');\">Top $top_home</A><BR>";

	      print FOUT2 "</TD></TR>";
	      print FOUT2 "</TABLE>\n"; #
	      print FOUT2 "</TD></TR>\n"; #

	      print FOUT2 "<TR><TD ALIGN=CENTER COLSPAN=2>";
	      print FOUT2 "<DIV ID=\"tog_squid1_home\" STYLE=\"display:inline\">";


	      if ($fly_set == 0) {

		  $count_peersize = 0;
		  open(INFILE, "$path$dirinc$dirsep$incproxystatus") || &error_exit("Error, unable to open $incproxystatus",1);
		  while (<INFILE>) {
		      chop;
		      ($tmp,$tmp1,$tmp2,$tmp3) = split(/\t/);
		      $peer_size{$tmp} = $tmp3;
		      $count_peersize += $tmp3;
		  }
		  close(INFILE);

		  $info = "info".$chart_id;

		  $line_squid_pie = &MakePieGraphJqplot(*FOUT2, eval($Lang{$lang[$nblang]}),$I,\%peer_size,\@serie_color,$count_peersize,7,1,$unit,$chart_id,0,$info,"","","$dirproxy$dirsepurl$filesquid");

		  print FOUT2 "<div id=\"";
		  print FOUT2 "chart".$chart_id;
		  print FOUT2 "\" ";
		  print FOUT2 "style=\"";
		  print FOUT2 "height:".$ymax_home_jqplot."px; width:".$ymax_home_jqplot."px;\">";
		  print FOUT2 "</div>\n";
	      
		  $chart_id++;
	      }

	      if ($fly_set == 1) {
		  if (-f "$path$dirgraph$dirsepurl$squid_home_pie") {
		      print FOUT2 "<BR><IMG WIDTH=\"$pie_square_home\" HEIGHT=\"$pie_square_home\" SRC=\"$dirgraph$dirsepurl$squid_home_pie\" ";
		      print FOUT2 "USEMAP=\"#map_squid\" " if ($map_squid_pie ne '');
		      print FOUT2 "BORDER=0 ALT=\"graph\">\n";
		  }
	      }

	      print FOUT2 "</DIV>\n";
	      print FOUT2 "<DIV ID=\"tog_squid2_home\" STYLE=\"display:none\">";
	      print FOUT2 "<TABLE BORDER=0>";
	      print FOUT2 "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Proxy'}</TH></TR>";
	      print FOUT2 "$line_squid_pie";
	      print FOUT2 "</TABLE>\n";
	      print FOUT2 "</DIV>\n";

	      print FOUT2 "</TD></TR></TABLE>\n";

	      if ($map_squid_pie ne '' && $fly_set == 1) {
		  $tmp = &map_homepage_check($map_squid_pie,$I);
		  if ($tmp ne '') {
		      print FOUT2 "<MAP NAME=\"map_squid\">\n";
		      print FOUT2 "$tmp";
		      print FOUT2 "</MAP>\n";
		  }
	      }
	      print FOUT2 "</TD>\n";
	  }
      }

  if ($count_block == 4) {
      print FOUT2 "</TR>\n";
      print FOUT2 "</TABLE>\n";

      print FOUT2 "</TD>\n";
      print FOUT2 "</TR>\n";

      print FOUT2 "<TR>\n";
      print FOUT2 "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";
      print FOUT2 "<TABLE BORDER=0 CELLSPACING=3 CELLPADDING=0>\n";
      print FOUT2 "<TR>\n";
      $count_block = 0;
  }

###

      if ($geoipcity == 1 && $skip_city == 0) {
	  $count_block++;
#	  print "City\n" if ($debug == 1);
	  print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
	  print FOUT2 " CLASS=\"homepage\"";
	  $tmp = $xmax_home+$xdecal;
	  print FOUT2 " WIDTH=$tmp>\n";

	  ($line_cloud,$line_cloud_sort) = &MakeCloud(\%citylist,"$dircity$dirsepurl",3);

	  print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";
	  print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #

	  print FOUT2 "<A HREF=\"$I$dirsepurl$dircity$dirsepurl$menu\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_city\" BORDER=0 ALT=\"Cities\"></A>\n";
	  print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";
	  print FOUT2 "<A HREF=\"$I$dirsepurl$dircity$dirsepurl$menu\">$L{'Cities'}</A>\n";
	  
	  print FOUT2 "</TD><TD ALIGN=CENTER>";
	  
	  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_alpha_city','tog_value_city');\">Alphabetically</A><BR><A HREF=\"javascript:ToggleBeta('tog_value_city','tog_alpha_city');\">By size</A><BR>\n";
	  print FOUT2 "</TD><TD ALIGN=RIGHT>";
	  
	  print FOUT2 "</TD></TR>";
	  print FOUT2 "</TABLE>\n"; #
	  print FOUT2 "</TD></TR>\n"; #
	  print FOUT2 "<TR><TD COLSPAN=3 ALIGN=CENTER>";
	  
	  print FOUT2 "<DIV ID=\"tog_alpha_city\" STYLE=\"display:inline\">";
	  $tmp = $line_cloud;
	  $tmp =~ s/<!-- langhome -->/$I/g;
	  print FOUT2 "$tmp";
	  print FOUT2 "</DIV>\n";
	  
	  print FOUT2 "<DIV ID=\"tog_value_city\" STYLE=\"display:none\">";
	  $tmp = $line_cloud_sort;
	  $tmp =~ s/<!-- langhome -->/$I/g;
	  print FOUT2 "$tmp";
	  print FOUT2 "</DIV>\n";	      
	  
	  print FOUT2 "</TD></TR></TABLE>\n";
	  print FOUT2 "</TD>\n";	  
      }

  if ($count_block == 4) {
      print FOUT2 "</TR>\n";
      print FOUT2 "</TABLE>\n";

      print FOUT2 "</TD>\n";
      print FOUT2 "</TR>\n";

      print FOUT2 "<TR>\n";
      print FOUT2 "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";
      print FOUT2 "<TABLE BORDER=0 CELLSPACING=3 CELLPADDING=0>\n";
      print FOUT2 "<TR>\n";
      $count_block = 0;
  }

  if ($nb_user != 0) {
      if (-e "$path$I$dirsep$dirlist$dirsep$users$htmlext") {
#	  print "User\n" if ($debug == 1);
	  $count_block++;
	  print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
	  print FOUT2 " CLASS=\"homepage\"";
	  print FOUT2 ">\n";

	  print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";
	  print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #

	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$users$htmlext\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_users\" BORDER=0 ALT=\"Users\"></A>\n";
	  print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";
	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$users$htmlext\">$L{'Users'}</A>\n";
	  
	  print FOUT2 "</TD><TD ALIGN=CENTER>";
	      
	  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_user1_home','tog_user2_home');\">Graph</A><BR>";
	  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_user2_home','tog_user1_home');\">Top $top_home</A>";
	      
	  print FOUT2 "</TD><TD ALIGN=RIGHT>";
	  print FOUT2 "<A HREF=\"$dircsv$dirsepurl$users$csvext\" TITLE=\"Export in CSV\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>";
	  print FOUT2 "<A HREF=\"$dircsv$dirsepurl$listuserscsv\" TITLE=\"Export in CSV\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV-FullList\"></A>";

	  print FOUT2 "</TD></TR>";
	  print FOUT2 "</TABLE>\n"; #
	  print FOUT2 "</TD></TR>\n"; #
#	  print FOUT2 "<TR><TD COLSPAN=3 ALIGN=CENTER HEIGHT=\"$ymax_home_jqplot\">";
	  print FOUT2 "<TR><TD COLSPAN=3 ALIGN=CENTER>";
	      
	  print FOUT2 "<DIV ID=\"tog_user1_home\" STYLE=\"display:inline\">";


	  if ($fly_set == 0) {
	      if ($usermax > 0) {
		  $info = "info".$chart_id;
		  @graph_to_display = ('Users');
		  
		  undef @ref_tab;
		  push(@ref_tab,\@tabuser);
		  
		  &MakeDailyGraphJqplot(*FOUT2, eval($Lang{$lang[$nblang]}),$I,1,\@graph_to_display,\@ref_tab,\@listdate,\@serie_color,1,$unit,$chart_id,3,"users",$info,0,$xlegend,$ylegend,$xmax_home_jqplot,$users);

		  &AddJqplotHtml(*FOUT2, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_home_jqplot,$ymax_home_jqplot,0);
		  
		  $chart_id += $#list_graph_name_jqplot+1;
		  
	      } else {
		  $msg = "$L{'No_enough_data_to_display_graph'}";
		  &NoDataToDisplay(*FOUT2,$msg);
	      }
	  }

	  if ($fly_set == 1) {
	      $tmp = $dirgraph.$dirsep."home-usersy".$gifext;
	      if (-f "$path$tmp") {
		  print FOUT2 "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
		  print FOUT2 "<TR>\n";
		  print FOUT2 "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"y\"></TD>\n";
		  $tmp = $dirgraph.$dirsep."home-users".$gifext;
		  print FOUT2 "<TD><IMG WIDTH=$xmax_home HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"graph\" ";
		  print FOUT2 "USEMAP=\"#map_user_graph\" " if ($map_user_graph ne '');
		  print FOUT2 "BORDER=0></TD>\n";
		  print FOUT2 "</TR><TR><TD></TD>\n";
		  $tmp = $dirgraph.$dirsep."home-usersx".$gifext;
		  print FOUT2 "<TD><IMG WIDTH=$xmax_home HEIGHT=$ydecal SRC=\"$tmp\" ALT=\"x\"></TD>\n";
		  print FOUT2 "</TR>\n";
		  print FOUT2 "</TABLE></CENTER>\n";
	      }
	  }

	  print FOUT2 "</DIV>";
	  
	  print FOUT2 "<DIV ID=\"tog_user2_home\" STYLE=\"display:none\">";
	  &UsersTab(*FOUT2,*L,$I,5,0,1);
	  print FOUT2 "</DIV>";
	  
	  print FOUT2 "</TD></TR></TABLE>\n";
	  if ($map_user_graph ne '' && $fly_set == 1) {
	      $tmp = &map_homepage_check($map_user_graph,$I);
	      if ($tmp ne '') {
		  print FOUT2 "<MAP NAME=\"map_user_graph\">";
		  print FOUT2 "$tmp";
		  print FOUT2 "</MAP>\n";
	      }
	  }
	  print FOUT2 "</TD>\n";
      }
  }

  if ($count_block == 4) {
      print FOUT2 "</TR>\n";
      print FOUT2 "</TABLE>\n";

      print FOUT2 "</TD>\n";
      print FOUT2 "</TR>\n";

      print FOUT2 "<TR>\n";
      print FOUT2 "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";
      print FOUT2 "<TABLE BORDER=0 CELLSPACING=3 CELLPADDING=0>\n";
      print FOUT2 "<TR>\n";
      $count_block = 0;
  }

  if (-f "$path$I$dirsep$dirlist$dirsep$spam$htmlext") {
#  if ($spam_found != 0) {
#      print "Spam\n" if ($debug == 1);
	  $count_block++;
	  print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
	  print FOUT2 " CLASS=\"homepage\"";
	  print FOUT2 ">\n";

	  print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";
	  print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #

	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$spam$htmlext\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_spam\" BORDER=0 ALT=\"Users\"></A>\n";
	  print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";
	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$spam$htmlext\">$L{'Spam'}</A>\n";
	  
	  print FOUT2 "</TD><TD ALIGN=CENTER>";

	  print FOUT2 "<A HREF=\"javascript:ToggleDelta('tog_spam1_home','tog_spam2_home','tog_spam3_home');\">Graph</A><BR>";
	  print FOUT2 "<A HREF=\"javascript:ToggleDelta('tog_spam2_home','tog_spam1_home','tog_spam3_home');\">Top $top_home $L{'external'}</A><BR>";
	  print FOUT2 "<A HREF=\"javascript:ToggleDelta('tog_spam3_home','tog_spam1_home','tog_spam2_home');\">Top $top_home $L{'local'}</A>" if ($spam_found_local != 0);
	      
	  print FOUT2 "</TD><TD ALIGN=RIGHT>";
	  print FOUT2 "<A HREF=\"$dircsv$dirsepurl$listspamextcsv\" TITLE=\"Export in CSV\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV-External\"></A>";
	  print FOUT2 "<A HREF=\"$dircsv$dirsepurl$listspamloccsv\" TITLE=\"Export in CSV\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV-Local\"></A>";
	  
	  print FOUT2 "</TD></TR>";
	  print FOUT2 "</TABLE>\n"; #
	  print FOUT2 "</TD></TR>\n"; #
	  print FOUT2 "<TR><TD COLSPAN=3 HEIGHT=\"$ymax_home_jqplot\">";
	      
	  print FOUT2 "<DIV ID=\"tog_spam1_home\" STYLE=\"display:inline\">";

	  if ($fly_set == 0) {

	      if (-f "$path$dirinc$dirsep$spam") {
		  &Load_DailyData($spam,$dirdata);
	      }

	      if ($spammax > 0) {
		  $info = "info".$chart_id;
		  undef @ref_tab;
		  push(@ref_tab,\@tabspam);
	
		  @ref_tab_name = ('spam');
	
		  &MakeDailyGraphJqplotInit(*FOUT2, eval($Lang{$lang[$nblang]}),$I,1,$unit_div,\@ref_tab,\@ref_tab_name,\@listdatespam,$chart_id);

		  @graph_to_display = ('Spam');

		  &MakeDailyGraphJqplot(*FOUT2, eval($Lang{$lang[$nblang]}),$I,1,\@graph_to_display,\@ref_tab,\@listdatespam,\@serie_color,1,$unit,$chart_id,3,"spam",$info,$chart_id,$xlegend,$ylegend,$xmax_home_jqplot,$dirsession);

		  &AddJqplotHtml(*FOUT2, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_home_jqplot,$ymax_home_jqplot,0);
	      
		  $chart_id += $#list_graph_name_jqplot+1;
	      } else {
		  $msg = "$L{'No_enough_data_to_display_graph'}";
		  &NoDataToDisplay(*FOUT2,$msg);
	      }
	  }


	  if ($fly_set == 1) {
	  $tmp = $dirgraph.$dirsep."home-spamy".$gifext;
	  if (-f "$path$tmp") {
	      print FOUT2 "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
	      print FOUT2 "<TR>\n";
	      print FOUT2 "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"y\"></TD>\n";
	      $tmp = $dirgraph.$dirsep."home-spam".$gifext;
	      print FOUT2 "<TD><IMG WIDTH=$xmax_home HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"graph\" ";
	      print FOUT2 "USEMAP=\"#map_spam_graph\" " if ($map_spam_graph ne '');
	      print FOUT2 "BORDER=0></TD>\n";
	      print FOUT2 "</TR><TR><TD></TD>\n";
	      $tmp = $dirgraph.$dirsep."home-spamx".$gifext;
	      print FOUT2 "<TD><IMG WIDTH=$xmax_home HEIGHT=$ydecal SRC=\"$tmp\" ALT=\"x\"></TD>\n";
	      print FOUT2 "</TR>\n";
	      print FOUT2 "</TABLE></CENTER>\n";
	  }
	  }
	  print FOUT2 "</DIV>";
	  
	  print FOUT2 "<DIV ID=\"tog_spam2_home\" STYLE=\"display:none\">";
	  &SpamTab(*FOUT2,*L,$I,5,1);
	  print FOUT2 "</DIV>";
	  print FOUT2 "<DIV ID=\"tog_spam3_home\" STYLE=\"display:none\">";
	  &SpamLocTab(*FOUT2,*L,$I,5,1) if ($spam_found_local != 0);
	  print FOUT2 "</DIV>";
	  
	  print FOUT2 "</TD></TR></TABLE>\n";
	  if ($map_spam_graph ne '' && $fly_set == 1) {
	      $tmp = &map_homepage_check($map_spam_graph,$I);
	      if ($tmp ne '') {
		  print FOUT2 "<MAP NAME=\"map_spam_graph\">";
		  print FOUT2 "$tmp";
		  print FOUT2 "</MAP>\n";
	      }
	  }
	  print FOUT2 "</TD>\n";
  }

  if ($count_block == 4) {
      print FOUT2 "</TR>\n";
      print FOUT2 "</TABLE>\n";

      print FOUT2 "</TD>\n";
      print FOUT2 "</TR>\n";

      print FOUT2 "<TR>\n";
      print FOUT2 "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";
      print FOUT2 "<TABLE BORDER=0 CELLSPACING=3 CELLPADDING=0>\n";
      print FOUT2 "<TR>\n";
      $count_block = 0;
  }


  if (-e "$path$I$dirsep$dirdocument$dirsep$menu") {
#      print "Document\n" if ($debug == 1);
      $count_block++;

      print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP\n";
      print FOUT2 " CLASS=\"homepage\"";
      print FOUT2 ">\n";

      print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";
      print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #
      print FOUT2 "<A HREF=\"$I$dirsepurl$dirdocument$dirsepurl$menu\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_doc\" BORDER=0 ALT=\"Documents\"></A>\n";
      print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";
      print FOUT2 "<A HREF=\"$I$dirsepurl$dirdocument$dirsepurl$menu\">$L{'Documents'}</A>\n";

      print FOUT2 "</TD><TD ALIGN=CENTER>";
      print FOUT2 "</TD><TD ALIGN=RIGHT>\n";
	  
      print FOUT2 "</TD></TR>\n";
      print FOUT2 "</TABLE>\n"; #
      print FOUT2 "</TD></TR>\n"; #

      print FOUT2 "<TR><TD ALIGN=CENTER COLSPAN=3 HEIGHT=\"$ymax_home_jqplot\">";
	  
      print FOUT2 "<DIV ID=\"tog_doc1_home\" STYLE=\"display:inline\">";

	  if ($fly_set == 0) {

	      $incnewfile = "newfile";
	      if (-f "$path$dirinc$dirsep$incnewfile") {
		  &Load_DailyData($incnewfile,$dirinc);
	      }
	      if ($newfilemax > 0) {
		  $info = "info".$chart_id;
		  undef @ref_tab;
		  push(@ref_tab,\@nbmodif);
	
		  @ref_tab_name = ('newest_pages');
	
		  &MakeDailyGraphJqplotInit(*FOUT2, eval($Lang{$lang[$nblang]}),$I,1,$unit_div,\@ref_tab,\@ref_tab_name,\@listdatenewfile,$chart_id);

		  @graph_to_display = ('Updated');

		  &MakeDailyGraphJqplot(*FOUT2, eval($Lang{$lang[$nblang]}),$I,1,\@graph_to_display,\@ref_tab,\@listdatenewfile,\@serie_color,1,$unit,$chart_id,3,"newest_pages",$info,$chart_id,$xlegend,$ylegend,$xmax_home_jqplot,"");

		  &AddJqplotHtml(*FOUT2, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_home_jqplot,$ymax_home_jqplot,0);
	      
		  $chart_id += $#list_graph_name_jqplot+1;
	      } else {
		  $msg = "$L{'No_enough_data_to_display_graph'}";
		  &NoDataToDisplay(*FOUT2,$msg);
	      }
	  }

#	    $map_url_graph = &MakeGraph($i,$newfilemax,$unit,$start_date,$xmax_home,$ymax_home,$file_home_newfile,$dirdocument,0,'Updated files',0,1,\@nbmodif,\@tabreq,\@tabmm,\@tabdoc,\@tabtrafic,\@tabscript,\@tabuser);

	if ($fly_set == 1) {
	    $tmp = $dirgraph.$dirsep."home-newfiley".$gifext;
	    if (-f "$path$tmp") {
		print FOUT2 "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
		print FOUT2 "<TR>\n";
		print FOUT2 "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"y\"></TD>\n";
		$tmp = $dirgraph.$dirsep."home-newfile".$gifext;
		print FOUT2 "<TD><IMG WIDTH=$xmax_home HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"graph\" BORDER=0></TD>\n";
		print FOUT2 "</TR><TR><TD></TD>\n";
		$tmp = $dirgraph.$dirsep."home-newfilex".$gifext;
		print FOUT2 "<TD><IMG WIDTH=$xmax_home HEIGHT=$ydecal SRC=\"$tmp\" ALT=\"x\"></TD>\n";
		print FOUT2 "</TR>\n";
		print FOUT2 "</TABLE></CENTER>\n";
	    }
	}

      print FOUT2 "</DIV>";
      
      print FOUT2 "</TD></TR></TABLE>\n";
      print FOUT2 "</TD>\n";
  }

  if ($count_block == 4) {
      print FOUT2 "</TR>\n";
      print FOUT2 "</TABLE>\n";

      print FOUT2 "</TD>\n";
      print FOUT2 "</TR>\n";

      print FOUT2 "<TR>\n";
      print FOUT2 "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";
      print FOUT2 "<TABLE BORDER=0 CELLSPACING=3 CELLPADDING=0>\n";
      print FOUT2 "<TR>\n";
      $count_block = 0;
  }

#  print "PP RS $Schart_id\n";
      if ($rss_nb != 0) {
#	  print "RSS\n" if ($debug == 1);
	  $count_block++;
	  print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
	  print FOUT2 " CLASS=\"homepage\"";
	  print FOUT2 ">\n";

	  print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";
	  print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #
	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$filerss$htmlext\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_rss\" BORDER=0 ALT=\"RSS\"></A>\n";
	  print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";
	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$filerss$htmlext\">$L{'RSS'}</A>\n";
	  
	  print FOUT2 "</TD><TD ALIGN=CENTER>";
	  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_rss1_home','tog_rss2_home');\">Graph</A><BR>";
	  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_rss2_home','tog_rss1_home');\">Top $top_home</A><BR>";
	  print FOUT2 "</TD><TD ALIGN=RIGHT>\n";
	  
	  print FOUT2 "</TD></TR>\n";
	  print FOUT2 "</TABLE>\n"; #
	  print FOUT2 "</TD></TR>\n"; #

	  print FOUT2 "<TR><TD ALIGN=CENTER COLSPAN=3 HEIGHT=\"$ymax_home_jqplot\">";
	  
	  print FOUT2 "<DIV ID=\"tog_rss1_home\" STYLE=\"display:inline\">";


	  if ($fly_set == 0) {
	      if (-f "$path$dirdata$dirsep$filerssdaily" && $rss_file ne '') {
		  &Load_DailyData($filerssdaily,$dirdata,0); # Use the first RSS as default
	      }

	      if ($rssmax > 0) {
	      $info = "info".$chart_id;
	      undef @ref_tab;
	      push(@ref_tab,\@tabrss);
	
	      @ref_tab_name = ('RSS');
	
	      &MakeDailyGraphJqplotInit(*FOUT2, eval($Lang{$lang[$nblang]}),$I,1,$unit_div,\@ref_tab,\@ref_tab_name,\@listdaterss,$chart_id);

	      @graph_to_display = ('RSS');

	      &MakeDailyGraphJqplot(*FOUT2, eval($Lang{$lang[$nblang]}),$I,1,\@graph_to_display,\@ref_tab,\@listdaterss,\@serie_color,1,$unit,$chart_id,3,"RSS",$info,$chart_id,$xlegend,$ylegend,$xmax_home_jqplot,"$dirlist$dirsep$filerss$htmlext");

	      &AddJqplotHtml(*FOUT2, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_home_jqplot,$ymax_home_jqplot,0);
	      
	      $chart_id += $#list_graph_name_jqplot+1;

	      } else {
		  $msg = "$L{'No_enough_data_to_display_graph'}";
		  &NoDataToDisplay(*FOUT2,$msg);
	      }
	  }

	  if ($fly_set == 1) {
	      $tmp = $dirgraph.$dirsep."home-rssy".$gifext;
	      if (-f "$path$tmp") {
		  print FOUT2 "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
		  print FOUT2 "<TR>\n";
		  print FOUT2 "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"y\"></TD>\n";
		  $tmp = $dirgraph.$dirsep."home-rss".$gifext;
		  print FOUT2 "<TD><IMG WIDTH=$xmax_home HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"graph\" ";
		  print FOUT2 "USEMAP=\"#map_rss_graph\" " if ($map_rss_graph ne '');
		  print FOUT2 "BORDER=0></TD>\n";
		  print FOUT2 "</TR><TR><TD></TD>\n";
		  $tmp = $dirgraph.$dirsep."home-rssx".$gifext;
		  print FOUT2 "<TD><IMG WIDTH=$xmax_home HEIGHT=$ydecal SRC=\"$tmp\" ALT=\"x\"></TD>\n";
		  print FOUT2 "</TR>\n";
		  print FOUT2 "</TABLE></CENTER>\n";
	      }
	  }
	  print FOUT2 "</DIV>";
	  print FOUT2 "<DIV ID=\"tog_rss2_home\" STYLE=\"display:none\">";
	  &RSSTab(*FOUT2,*L,$I,5,1);
	  print FOUT2 "</DIV>";
	  
	  print FOUT2 "</TD></TR></TABLE>\n";
	  if ($map_rss_graph ne '' && $fly_set == 1) {
	      $tmp = &map_homepage_check($map_rss_graph,$I);
	      if ($tmp ne '') {
		  print FOUT2 "<MAP NAME=\"map_rss_graph\">";
		  print FOUT2 "$tmp";
		  print FOUT2 "</MAP>\n";
	      }
	  }
	  print FOUT2 "</TD>\n";
      }

  if ($count_block == 4) {
      print FOUT2 "</TR>\n";
      print FOUT2 "</TABLE>\n";

      print FOUT2 "</TD>\n";
      print FOUT2 "</TR>\n";

      print FOUT2 "<TR>\n";
      print FOUT2 "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";
      print FOUT2 "<TABLE BORDER=0 CELLSPACING=3 CELLPADDING=0>\n";
      print FOUT2 "<TR>\n";
      $count_block = 0;
  }

### pointeurs sur les erreurs, references, fureteurs, search engine et ftp users

      if (-e "$path$I$dirsep$dirlist$dirsep$error") {

#	  print "Error\n" if ($debug == 1);
	  $count_block++;
	  print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
	  print FOUT2 " CLASS=\"homepage\"";
	  print FOUT2 ">\n";

	  print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";
	  print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #
	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$error\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_error\" BORDER=0 ALT=\"Errors\"></A>\n";
	  print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";
	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$error\">$L{'Errors'}</A>\n";
	  
	  print FOUT2 "</TD><TD ALIGN=CENTER>";
	  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_error1_home','tog_error2_home');\">Graph</A><BR>";
	  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_error2_home','tog_error1_home');\">Top $top_home</A><BR>";
	  print FOUT2 "</TD><TD ALIGN=RIGHT>\n";

#	      print FOUT2 "<A HREF=\"$dircsv$dirsepurl$filerss$csvext\" TITLE=\"CSV - RSS\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>";
	  print FOUT2 "</TD></TR>\n";

	  print FOUT2 "</TABLE>\n"; #
	  print FOUT2 "</TD></TR>\n"; #
	  print FOUT2 "<TR><TD ALIGN=CENTER COLSPAN=3 HEIGHT=\"$ymax_home_jqplot\">";

	  print FOUT2 "<DIV ID=\"tog_error1_home\" STYLE=\"display:inline\">";

	  if ($fly_set == 0) {

	      if (-f "$path$dirinc$dirsep$dayerror") {
		  &Load_DailyData($dayerror,$dirinc);
	      }

	      if ($errormax > 0) {
	      $info = "info".$chart_id;
	      undef @ref_tab;
	      push(@ref_tab,\@taberror);
	
	      @ref_tab_name = ('errors');
	
	      &MakeDailyGraphJqplotInit(*FOUT2, eval($Lang{$lang[$nblang]}),$I,1,$unit_div,\@ref_tab,\@ref_tab_name,\@listdateerror,$chart_id);

	      @graph_to_display = ('errors');

	      &MakeDailyGraphJqplot(*FOUT2, eval($Lang{$lang[$nblang]}),$I,1,\@graph_to_display,\@ref_tab,\@listdateerror,\@serie_color,1,$unit,$chart_id,3,"errors",$info,$chart_id,$xlegend,$ylegend,$xmax_home_jqplot,$dirscript);

	      &AddJqplotHtml(*FOUT2, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_home_jqplot,$ymax_home_jqplot,0);
	      
	      $chart_id += $#list_graph_name_jqplot+1;
	      } else {
		  $msg = "$L{'No_enough_data_to_display_graph'}";
		  &NoDataToDisplay(*FOUT2,$msg);
	      }
	  }


	    if ($fly_set == 1) {
		$tmp = $dirgraph.$dirsep."home-errory".$gifext;
		if (-f "$path$tmp") {
		    print FOUT2 "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
		    print FOUT2 "<TR>\n";
		    print FOUT2 "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"y\"></TD>\n";
		    $tmp = $dirgraph.$dirsep."home-error".$gifext;
		    print FOUT2 "<TD><IMG WIDTH=$xmax_home HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"graph\" ";
		    print FOUT2 "USEMAP=\"#map_error_graph\" " if ($map_error_graph ne '');
		    print FOUT2 "BORDER=0></TD>\n";
		    print FOUT2 "</TR><TR><TD></TD>\n";
		    $tmp = $dirgraph.$dirsep."home-errorx".$gifext;
		    print FOUT2 "<TD><IMG WIDTH=$xmax_home HEIGHT=$ydecal SRC=\"$tmp\" ALT=\"x\"></TD>\n";
		    print FOUT2 "</TR>\n";
		    print FOUT2 "</TABLE></CENTER>\n";
		}
	    }

	  print FOUT2 "</DIV>";
	  print FOUT2 "<DIV ID=\"tog_error2_home\" STYLE=\"display:none\">";
	  print FOUT2 "$home_error_lines";
	  print FOUT2 "</DIV>";
	      
	  print FOUT2 "</TD></TR></TABLE>\n";
	  if ($map_error_graph ne '' && $fly_set == 1) {
	      $tmp = &map_homepage_check($map_error_graph,$I);
	      if ($tmp ne '') {
		  print FOUT2 "<MAP NAME=\"map_error_graph\">";
		  print FOUT2 "$tmp";
		  print FOUT2 "</MAP>\n";
	      }
	  }
	  print FOUT2 "</TD>\n";
      }

  if ($count_block == 4) {
      print FOUT2 "</TR>\n";
      print FOUT2 "</TABLE>\n";

      print FOUT2 "</TD>\n";
      print FOUT2 "</TR>\n";

      print FOUT2 "<TR>\n";
      print FOUT2 "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";
      print FOUT2 "<TABLE BORDER=0 CELLSPACING=3 CELLPADDING=0>\n";
      print FOUT2 "<TR>\n";
      $count_block = 0;
  }

      if (-e "$path$I$dirsep$dirlist$dirsep$refer") {
#	  print "Refer\n" if ($debug == 1);

	  $count_block++;
	  print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
	  print FOUT2 " CLASS=\"homepage\"";
	  print FOUT2 ">\n";
	  print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";
	  print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #
	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$refer\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_refer\" BORDER=0 ALT=\"Referer\"></A>\n";
	  print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";
	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$refer\">$L{'Referer'}</A>\n";
	  
	  print FOUT2 "</TD><TD ALIGN=CENTER>";
	  
	    if ($fly_set == 0) {

		$datafile_refer = "time-refer";
		&Load_DailyData($datafile_refer,$dirdata);

		if ($refermax > 0) {
		    print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_refer1_home','tog_refer2_home');\">Graph</A><BR>";
		    print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_refer2_home','tog_refer1_home');\">Top $top_home</A>";
		}
	    }

	  print FOUT2 "</TD><TD ALIGN=RIGHT>";
	  
	  print FOUT2 "</TD></TR>";
	  print FOUT2 "</TABLE>\n"; #
	  print FOUT2 "</TD></TR>\n"; #
	  print FOUT2 "<TR><TD COLSPAN=3>";
	  
	  print FOUT2 "<DIV ID=\"tog_refer1_home\" STYLE=\"display:inline\">";

	  if ($fly_set == 0) {

	      $datafile_refer = "time-refer";
	      &Load_DailyData($datafile_refer,$dirdata);
	      
	      if ($refermax > 0) {

		  $info = "info".$chart_id;
		  undef @ref_tab;
		  push(@ref_tab,\@tabrefer);
	
		  @ref_tab_name = ('referer');
	
		  &MakeDailyGraphJqplotInit(*FOUT2, eval($Lang{$lang[$nblang]}),$I,1,$unit_div,\@ref_tab,\@ref_tab_name,\@listdaterefer,$chart_id);
		  @graph_to_display = ('referer');
		
		  &MakeDailyGraphJqplot(*FOUT2, eval($Lang{$lang[$nblang]}),$I,1,\@graph_to_display,\@ref_tab,\@listdaterefer,\@serie_color,1,$unit,$chart_id,3,"referer",$info,$chart_id,$xlegend,$ylegend,$xmax_home_jqplot,$tabnamerefer);

		  &AddJqplotHtml(*FOUT2, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_home_jqplot,$ymax_home_jqplot,0);
	      
		  $chart_id += $#list_graph_name_jqplot+1;
	      } else {
		  $msg = "$L{'No_enough_data_to_display_graph'}";
		  &NoDataToDisplay(*FOUT2,$msg);
	      }
	  }

	    if ($fly_set == 1) {
		$tmp = $dirgraph.$dirsep."home-refery".$gifext;
		if (-f "$path$tmp") {
		    print FOUT2 "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
		    print FOUT2 "<TR>\n";
		    print FOUT2 "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"y\"></TD>\n";
		    $tmp = $dirgraph.$dirsep."home-refer".$gifext;
		    print FOUT2 "<TD><IMG WIDTH=$xmax_home HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"graph\" ";
		    print FOUT2 "USEMAP=\"#map_refer_graph\" " if ($map_refer_graph ne '');
		    print FOUT2 "BORDER=0></TD>\n";
		    print FOUT2 "</TR><TR><TD></TD>\n";
		    $tmp = $dirgraph.$dirsep."home-referx".$gifext;
		    print FOUT2 "<TD><IMG WIDTH=$xmax_home HEIGHT=$ydecal SRC=\"$tmp\" ALT=\"x\"></TD>\n";
		    print FOUT2 "</TR>\n";
		    print FOUT2 "</TABLE></CENTER>\n";
		}
	    }

	  print FOUT2 "</DIV>";
	  
	  print FOUT2 "<DIV ID=\"tog_refer2_home\" STYLE=\"display:none\">";
	  print FOUT2 "$home_refer_lines";
	  print FOUT2 "</DIV>";
	  
	  print FOUT2 "</TD></TR></TABLE>\n";
	  if ($map_refer_graph ne '' && $fly_set == 1) {
	      $tmp = &map_homepage_check($map_refer_graph,$I);
	      if ($tmp ne '') {
		  print FOUT2 "<MAP NAME=\"map_refer_graph\">";
		  print FOUT2 "$tmp";
		  print FOUT2 "</MAP>\n";
	      }
	  }
	  print FOUT2 "</TD>\n";
      }

  if ($count_block == 4) {
      print FOUT2 "</TR>\n";
      print FOUT2 "</TABLE>\n";

      print FOUT2 "</TD>\n";
      print FOUT2 "</TR>\n";

      print FOUT2 "<TR>\n";
      print FOUT2 "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";
      print FOUT2 "<TABLE BORDER=0 CELLSPACING=3 CELLPADDING=0>\n";
      print FOUT2 "<TR>\n";
      $count_block = 0;
  }


      if (-e "$path$I$dirsep$dirlist$dirsep$agent") {
#	  print "Agent\n" if ($debug == 1);

	  $count_block++;
	  print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
	  print FOUT2 " CLASS=\"homepage\"";
	  print FOUT2 ">\n";

	  print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";
	  print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #
	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$agent\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_agent\" BORDER=0 ALT=\"Browsers\"></A>\n";
	  print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";
	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$agent\">$L{'Browsers'}</A>\n";

	  print FOUT2 "</TD><TD ALIGN=CENTER>";
	  
	  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_agent1_home','tog_agent2_home');\">Graph</A><BR>";
	  print FOUT2 "<A HREF=\"javascript:ToggleAlpha('tog_agent2_home','tog_agent1_home');\">Top $top_home</A><BR>";
	  print FOUT2 "</TD></TR>";
	  print FOUT2 "</TABLE>\n"; #
	  print FOUT2 "</TD></TR>\n"; #
	  print FOUT2 "<TR><TD ALIGN=CENTER COLSPAN=2>";
	  print FOUT2 "<DIV ID=\"tog_agent1_home\" STYLE=\"display:inline\">";

	  if ($fly_set == 0) {
	      $info = "info".$chart_id;

	      $line_browser_pie = &MakePieGraphJqplot(*FOUT2, eval($Lang{$lang[$nblang]}),$I,\%browserhome,\@serie_color,$count_os,7,1,$unit,$chart_id,0,$info,"","","$dirlist$dirsepurl$agent");

	      print FOUT2 "<div id=\"";
	      print FOUT2 "chart".$chart_id;
	      print FOUT2 "\" ";
	      print FOUT2 "style=\"";
	      print FOUT2 "height:".$ymax_home_jqplot."px; width:".$ymax_home_jqplot."px;\">";
	      print FOUT2 "</div>\n";
	      $chart_id++;	      
	  }

	  if ($fly_set == 1) {
	      if (-f "$path$dirgraph$dirsepurl$browser_home_pie") {
		  print FOUT2 "<BR><IMG WIDTH=\"$pie_square_home\" HEIGHT=\"$pie_square_home\" SRC=\"$dirgraph$dirsepurl$browser_home_pie\" ";
		  print FOUT2 "USEMAP=\"#map_browser\" " if ($map_browser_pie ne '');
		  print FOUT2 "BORDER=0 ALT=\"graph\">\n";
	      }
	  }

	  print FOUT2 "</DIV>\n";
	  print FOUT2 "<DIV ID=\"tog_agent2_home\" STYLE=\"display:none\">";
	  print FOUT2 "<TABLE BORDER=0>";
	  print FOUT2 "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Browsers'}</TH></TR>";
	  print FOUT2 "$line_browser_pie";
	  print FOUT2 "</TABLE>\n";
	  print FOUT2 "</DIV>\n";

	  print FOUT2 "</TD></TR></TABLE>\n";

	  if ($map_browser_pie ne '' && $fly_set == 1) {
	      $tmp = &map_homepage_check($map_browser_pie,$I);
	      if ($tmp ne '') {
		  print FOUT2 "<MAP NAME=\"map_browser\">\n";
		  print FOUT2 "$tmp";
		  print FOUT2 "</MAP>\n";
	      }
	  }

	  print FOUT2 "</TD>\n";
      }

 if ($count_block == 4) {
      print FOUT2 "</TR>\n";
      print FOUT2 "</TABLE>\n";

      print FOUT2 "</TD>\n";
      print FOUT2 "</TR>\n";

      print FOUT2 "<TR>\n";
      print FOUT2 "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";
      print FOUT2 "<TABLE BORDER=0 CELLSPACING=3 CELLPADDING=0>\n";
      print FOUT2 "<TR>\n";
      $count_block = 0;
  }


      if (-e "$path$I$dirsep$dirlist$dirsep$agent") {
	  $count_block++;
#	  print "OS\n" if ($debug == 1);
	  print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
	  print FOUT2 " CLASS=\"homepage\"";
	  print FOUT2 ">\n";

	  print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";
	  print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #
	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$agent\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_agent\" BORDER=0 ALT=\"OS\"></A>\n";
	  print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";
	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$agent\">$L{'OS'}</A>\n";

	  print FOUT2 "</TD><TD ALIGN=CENTER>";
	  
	  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_os1_home','tog_os2_home');\">Graph</A><BR>";
	  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_os2_home','tog_os1_home');\">Top $top_home</A><BR>";
	  
	  print FOUT2 "</TD></TR>";
	  print FOUT2 "</TABLE>\n"; #
	  print FOUT2 "</TD></TR>\n"; #
	  print FOUT2 "<TR><TD ALIGN=CENTER COLSPAN=2>";
	  print FOUT2 "<DIV ID=\"tog_os1_home\" STYLE=\"display:inline\">";

	  if ($fly_set == 0) {
	      $info = "info".$chart_id;

	      $line_os_pie = &MakePieGraphJqplot(*FOUT2, eval($Lang{$lang[$nblang]}),$I,\%oshome,\@serie_color,$count_os,8,1,$unit,$chart_id,0,$info,"","","$dirlist$dirsepurl$agent");

	      print FOUT2 "<div id=\"";
	      print FOUT2 "chart".$chart_id;
	      print FOUT2 "\" ";
	      print FOUT2 "style=\"";
	      print FOUT2 "height:".$ymax_home_jqplot."px; width:".$ymax_home_jqplot."px;\">";
	      print FOUT2 "</div>\n";
	      $chart_id++;	      
	  }


	  if (-f "$path$dirgraph$dirsepurl$os_home_pie" && $fly_set == 1) {
	      print FOUT2 "<BR><IMG WIDTH=\"$pie_square_home\" HEIGHT=\"$pie_square_home\" SRC=\"$dirgraph$dirsepurl$os_home_pie\" ";
	      print FOUT2 "USEMAP=\"#map_os\" " if ($map_os_pie ne '');
	      print FOUT2 "BORDER=0 ALT=\"graph\">\n";
	  }
	  print FOUT2 "</DIV>\n";
	  print FOUT2 "<DIV ID=\"tog_os2_home\" STYLE=\"display:none\">";
	  print FOUT2 "<TABLE BORDER=0>";
	  print FOUT2 "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'OS'}</TH></TR>";
	  print FOUT2 "$line_os_pie";
	  print FOUT2 "</TABLE>\n";
	  print FOUT2 "</DIV>\n";

	  print FOUT2 "</TD></TR></TABLE>\n";

	  if ($map_os_pie ne '' && $fly_set == 1) {
	      $tmp = &map_homepage_check($map_os_pie,$I);
	      if ($tmp ne '') {
		  print FOUT2 "<MAP NAME=\"map_os\">\n";
		  print FOUT2 "$tmp";
		  print FOUT2 "</MAP>\n";
	      }
	  }
	  print FOUT2 "</TD>\n";
      }


  if ($count_block == 4) {
      print FOUT2 "</TR>\n";
      print FOUT2 "</TABLE>\n";

      print FOUT2 "</TD>\n";
      print FOUT2 "</TR>\n";

      print FOUT2 "<TR>\n";
      print FOUT2 "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";
      print FOUT2 "<TABLE BORDER=0 CELLSPACING=3 CELLPADDING=0>\n";
      print FOUT2 "<TR>\n";
      $count_block = 0;
  }

      if (-e "$path$I$dirsep$dirlist$dirsep$tabnamekeyword") {
	  $count_block++;
#	  print "Keyword\n" if ($debug == 1);
	  print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
	  print FOUT2 " CLASS=\"homepage\"";
	  if ($line_search_cloud ne '') {
	      $tmp = $xmax_home+$xdecal;
	      print FOUT2 " WIDTH=$tmp";
	  }
	      print FOUT2 ">\n";
	  print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";
	  print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #
	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$tabnamekeyword\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_spider\" BORDER=0 ALT=\"Keywords\"></A>\n";
	  print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";
	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$tabnamekeyword\">$L{'Search_engine'}</A>\n";

	  print FOUT2 "</TD><TD ALIGN=CENTER>";
	  
	  if ($line_search_cloud ne '') {
	      print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_w_alpha','tog_w_value');\">Alphabetically</A><BR><A HREF=\"javascript:ToggleBeta('tog_w_value','tog_w_alpha');\">By size</A>\n";
	  }
	  print FOUT2 "</TD><TD ALIGN=RIGHT>";
	  print FOUT2 "</TD></TR>";
	  print FOUT2 "</TABLE>\n"; #
	  print FOUT2 "</TD></TR>\n"; #
	  print FOUT2 "<TR>";
	  print FOUT2 "<TD COLSPAN=3>";
	  if ($line_search_cloud ne '') {
	      print FOUT2 "<DIV ID=\"tog_w_alpha\" STYLE=\"display:inline\">";
	      print FOUT2 "$line_search_cloud\n";
	      print FOUT2 "</DIV>\n";
	  
	      print FOUT2 "<DIV ID=\"tog_w_value\" STYLE=\"display:none\">";
	      print FOUT2 "$line_search_cloud_sort\n";
	      print FOUT2 "</DIV>\n";
	  } else {
	      print FOUT2 "<P><I>$L{'No_request'}</I>\n";
	  }	  
	  print FOUT2 "</TD></TR></TABLE>\n";
	  print FOUT2 "</TD>\n";
      }

  if ($count_block == 4 && ($screensize_val != 0 || $heatmap_val != 0 || $nb_virus != 0)) {
      print FOUT2 "</TR>\n";
      print FOUT2 "</TABLE>\n";

      print FOUT2 "</TD>\n";
      
      print FOUT2 "</TR>\n";
      
      print FOUT2 "<TR>\n";
      print FOUT2 "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";
      print FOUT2 "<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=3>\n";
      print FOUT2 "<TR>\n";
      $count_block = 0;
  }

###

      if ($screensize_val != 0) {
	  $count_block++;
#	  print "Screensize\n" if ($debug == 1);
	  print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
	  print FOUT2 " CLASS=\"homepage\"";
	  print FOUT2 ">\n";
	  print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";
	  print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #

	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$filescreensize\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_screensize\" BORDER=0 ALT=\"Screensize\"></A>\n";
	  print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";
	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$filescreensize\">$L{'Screensize'}</A>\n";
	  
	  print FOUT2 "</TD><TD ALIGN=CENTER>";
	  
	  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_screensize1_home','tog_screensize2_home');\">Graph</A><BR>";
	  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_screensize2_home','tog_screensize1_home');\">Top $top_home</A><BR>";
	  
	  print FOUT2 "</TD></TR>";
	  print FOUT2 "</TABLE>\n"; #
	  print FOUT2 "</TD></TR>\n"; #
	  print FOUT2 "<TR><TD ALIGN=CENTER COLSPAN=2>";
	  print FOUT2 "<DIV ID=\"tog_screensize1_home\" STYLE=\"display:inline\">";

	  if ($fly_set == 0) {

	      $count_screensize = 0;
	      open(INFILE, "$path$dirinc$dirsep$incscreensize") || &error_exit("Error, unable to open $incscreensize",1);
	      while (<INFILE>) {
		  chop;
		  ($tmp1,$tmp,$tmp3) = split(/\t/);
		  if ($tmp1 eq "screen") {
		      $screensize{$tmp} = $tmp3 if ($count <= $top_home);
		      $count++;
		      $count_screensize += $tmp3;
		  }
	      }
	      close(INFILE);

	      $info = "info".$chart_id;

	      $line_screensize_pie = &MakePieGraphJqplot(*FOUT2, eval($Lang{$lang[$nblang]}),$I,\%screensize,\@serie_color,$count_screensize,7,1,$unit,$chart_id,0,$info,"","","$dirlist$dirsepurl$filescreensize");

	      print FOUT2 "<div id=\"";
	      print FOUT2 "chart".$chart_id;
	      print FOUT2 "\" ";
	      print FOUT2 "style=\"";
	      print FOUT2 "height:".$ymax_home_jqplot."px; width:".$ymax_home_jqplot."px;\">";
	      print FOUT2 "</div>\n";
	      $chart_id++;	      
	  }

	  if ($fly_set == 1) {
	      if (-f "$path$dirgraph$dirsepurl$screensize_home_pie") {
		  print FOUT2 "<BR><IMG WIDTH=\"$pie_square_home\" HEIGHT=\"$pie_square_home\" SRC=\"$dirgraph$dirsepurl$screensize_home_pie\" ";
		  print FOUT2 "USEMAP=\"#map_screensize\" " if ($map_screensize_pie ne '');
		  print FOUT2 "BORDER=0 ALT=\"graph\">\n";
	      }
	  }

	  print FOUT2 "</DIV>\n";
	  print FOUT2 "<DIV ID=\"tog_screensize2_home\" STYLE=\"display:none\">";
	  print FOUT2 "<TABLE BORDER=0>";
	  print FOUT2 "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Screensize'}</TH></TR>";
	  print FOUT2 "$line_screensize_pie";
	  print FOUT2 "</TABLE>\n";
	  print FOUT2 "</DIV>\n";
	  
	  print FOUT2 "</TD></TR></TABLE>\n";
	  if ($map_screensize_pie ne '' && $fly_set == 1) {
	      $tmp = &map_homepage_check($map_screensize_pie,$I);
	      if ($tmp ne '') {
		  print FOUT2 "<MAP NAME=\"map_screensize\">\n";
		  print FOUT2 "$tmp";
		  print FOUT2 "</MAP>\n";
	      }
	  }
	  print FOUT2 "</TD>\n";	  
      }

 if ($count_block == 4 && ($heatmap_val != 0 || $nb_virus != 0)) {
      print FOUT2 "</TR>\n";
      print FOUT2 "</TABLE>\n";

      print FOUT2 "</TD>\n";
      print FOUT2 "</TR>\n";

      print FOUT2 "<TR>\n";
      print FOUT2 "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";
      print FOUT2 "<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=3>\n";
      print FOUT2 "<TR>\n";
      $count_block = 0;
  }

      if ($heatmap_val != 0) {
	  $count_block++;
#	  print "Heatmap\n" if ($debug == 1);
	  print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
	  print FOUT2 " CLASS=\"homepage\"";
	  print FOUT2 ">\n";

#	  print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
#	  print FOUT2 " CLASS=\"homepage\"";
#	  print FOUT2 ">\n";
	  print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";
	  print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #

	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$fileheatmap$htmlext\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_heatmap\" BORDER=0 ALT=\"Heatmap\"></A>\n";
	  print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";
	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$fileheatmap$htmlext\">$L{'Heatmap'}</A>\n";
	  
	  print FOUT2 "</TD><TD ALIGN=CENTER>";
	  
	  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_heatmap1_home','tog_heatmap2_home');\">Graph</A><BR>";
	  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_heatmap2_home','tog_heatmap1_home');\">Top $top_home</A><BR>";
	  
	  print FOUT2 "</TD></TR>";
	  print FOUT2 "</TABLE>\n"; #
	  print FOUT2 "</TD></TR>\n"; #
	  print FOUT2 "<TR><TD ALIGN=CENTER COLSPAN=2>";
	  print FOUT2 "<DIV ID=\"tog_heatmap1_home\" STYLE=\"display:inline\">";


      if ($fly_set == 0) {

	  $count2 = 0;
	  $count = 0;
	  $heatmap_home_pie = "home-heatmap".$gifext;
	  open(INFILE, "$path$dirinc$dirsep$fileheatmap");
	  while (<INFILE>) {
	      chop;
	      next if ($_ =~ /^#/);
	      ($url,$val) = split('\s+');
	      $heat_home{$url} = $val if ($count <= $top_home);
	      $count2 += $val;
	      $count++;
	  }
	  close(INFILE);

	  $info = "info".$chart_id;

	  $line_heatmap_pie = &MakePieGraphJqplot(*FOUT2, eval($Lang{$lang[$nblang]}),$I,\%heat_home,\@serie_color,$count2,7,1,$unit,$chart_id,0,$info,"","","$dirlist$dirsepurl$fileheatmap$htmlext");

	  print FOUT2 "<div id=\"";
	  print FOUT2 "chart".$chart_id;
	  print FOUT2 "\" ";
	  print FOUT2 "style=\"";
	  print FOUT2 "height:".$ymax_home_jqplot."px; width:".$ymax_home_jqplot."px;\">";
	  print FOUT2 "</div>\n";
	  $chart_id++;	      
      }


	if ($fly_set == 1) {
	    if (-f "$path$dirgraph$dirsepurl$heatmap_home_pie") {
		print FOUT2 "<BR><IMG WIDTH=\"$pie_square_home\" HEIGHT=\"$pie_square_home\" SRC=\"$dirgraph$dirsepurl$heatmap_home_pie\" ";
		print FOUT2 "USEMAP=\"#map_heatmap\" " if ($map_heatmap_pie ne '');
		print FOUT2 "BORDER=0 ALT=\"graph\">\n";
	    }
	}
	print FOUT2 "</DIV>\n";
	print FOUT2 "<DIV ID=\"tog_heatmap2_home\" STYLE=\"display:none\">";
	print FOUT2 "<TABLE BORDER=0>";
	print FOUT2 "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Click'}</TH></TR>";
	print FOUT2 "$line_heatmap_pie";
	print FOUT2 "</TABLE>\n";
	print FOUT2 "</DIV>\n";
	  
	print FOUT2 "</TD></TR></TABLE>\n";

	  if ($map_heatmap_pie ne '' && $fly_set == 1) {
	      $tmp = &map_homepage_check($map_heatmap_pie,$I);
	      if ($tmp ne '') {
		  print FOUT2 "<MAP NAME=\"map_heatmap\">\n";
		  print FOUT2 "$tmp";
		  print FOUT2 "</MAP>\n";
	      }
	  }
	  print FOUT2 "</TD>\n";	  
      }

 if ($count_block == 4 && $nb_virus != 0) {
      print FOUT2 "</TR>\n";
      print FOUT2 "</TABLE>\n";

      print FOUT2 "</TD>\n";
      print FOUT2 "</TR>\n";

      print FOUT2 "<TR>\n";
      print FOUT2 "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";
      print FOUT2 "<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=3>\n";
      print FOUT2 "<TR>\n";
      $count_block = 0;
  }

      if ($nb_virus != 0) {
	  $count_block++;
#	  print "Virus\n" if ($debug == 1);
	  print FOUT2 "<TD ALIGN=CENTER VALIGN=TOP";
	  print FOUT2 " CLASS=\"homepage\"";
	  print FOUT2 ">\n";

	  print FOUT2 "<TABLE BORDER=0><TR><TD ALIGN=LEFT CLASS=\"homepage_header\">";
	  print FOUT2 "<TABLE BORDER=0 WIDTH=\"100%\"><TR><TD ALIGN=CENTER>\n"; #

	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$filevirus\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"$homeicons$dirsepurl$icon_virus\" BORDER=0 ALT=\"Virus\"></A>\n";
	  print FOUT2 "</TD><TD ALIGN=CENTER CLASS=\"homepage_titre\">";
	  print FOUT2 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$filevirus\">$L{'Virus'}</A>\n";
	  
	  print FOUT2 "</TD><TD ALIGN=CENTER>";
	  
	  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_virus1_home','tog_virus2_home');\">Graph</A><BR>";
	  print FOUT2 "<A HREF=\"javascript:ToggleBeta('tog_virus2_home','tog_virus1_home');\">Top $top_home</A><BR>";
	  
	  print FOUT2 "</TD></TR>";
	  print FOUT2 "</TABLE>\n"; #
	  print FOUT2 "</TD></TR>\n"; #
	  print FOUT2 "<TR><TD ALIGN=CENTER COLSPAN=2>";
	  print FOUT2 "<DIV ID=\"tog_virus1_home\" STYLE=\"display:inline\">";
	  if (-f "$path$dirgraph$dirsepurl$virus_home_pie") {
	      print FOUT2 "<BR><IMG WIDTH=\"$pie_square_home\" HEIGHT=\"$pie_square_home\" SRC=\"$dirgraph$dirsepurl$virus_home_pie\" ";
	      print FOUT2 "USEMAP=\"#map_virus\" " if ($map_virus_pie ne '');
	      print FOUT2 "BORDER=0 ALT=\"graph\">\n";
	  }
	  print FOUT2 "</DIV>\n";
	  print FOUT2 "<DIV ID=\"tog_virus2_home\" STYLE=\"display:none\">";
	  print FOUT2 "<TABLE BORDER=0>";
	  print FOUT2 "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Virus'}</TH></TR>";
	  print FOUT2 "$line_virus_pie";
	  print FOUT2 "</TABLE>\n";
	  print FOUT2 "</DIV>\n";
	  
	  print FOUT2 "</TD></TR></TABLE>\n";
	  if ($map_virus_pie ne '') {
	      $tmp = &map_homepage_check($map_virus_pie,$I);
	      if ($tmp ne '') {
		  print FOUT2 "<MAP NAME=\"map_virus\">\n";
		  print FOUT2 "$tmp";
		  print FOUT2 "</MAP>\n";
	      }
	  }
	  print FOUT2 "</TD>\n";

      }

  print FOUT2 "</TR>\n";
  print FOUT2 "</TABLE>\n";  

##

  print FOUT2 "</TD>\n";
  print FOUT2 "</TR>\n";
  print FOUT2 "</TABLE>\n";
  
  print FOUT2 "</CENTER>\n";
  print FOUT2 "</BODY></HTML>\n";

}

#################################################################
####              Detect W3C logfile format               #######
#################################################################

sub detect_w3c_logformat {
    local($line) = @_;
    local(@tmp,$tmp,$tmpa,$struct_logfile,$i);

    undef %fields_logfile;

       if ($line =~ /^\#Fields:/ || $line =~ /^\!\!LOG_FORMAT/) {
	   $struct_logfile = '';
	   ($tmpa,@tmp) = split(/\s+/,$line);
	   foreach $tmp (@tmp) {
	       $tmp =~ tr/A-Z/a-z/;
	       $struct_logfile .= $w3c_struct_logfile{$tmp}." " if ($w3c_struct_logfile{$tmp} ne '');
	       $struct_logfile .= "%null " if ($w3c_struct_logfile{$tmp} eq '');
	   }
       }
    @logfile_fields = split(/\s+/,$struct_logfile);

    for ($i=0;$i<=$#logfile_fields;$i++) {
	$fields_logfile{$logfile_fields[$i]} = $i;
#	print "TOTO $i - $logfile_fields[$i] - $fields_logfile{$logfile_fields[$i]}\n";
    }

#c-dns found with Webstar if found c-ip => n%ull

    $iis_format = 1;
    $type_serveur = 1;
#    $date_format =~ s/[\-\/ ]//g; # remove extra chracters if found 
#    @date_string = split(/%/,$date_format);

    $logfile_sep = ", " if ($logfile_fields[1] eq "%login"); # IIS 3
#    $logfile_sep = " " if ($logfile_fields[1] ne "%login");  # IIS 4, 5
    $logfile_sep = "\\s+" if ($logfile_fields[1] ne "%login");  # IIS 4, 5
    $logfile_sep = "\\t" if ($logfile_format eq "Webstar");

#    print "UU $logfile_sep\n";

    $referlog = $prefixlog if ($struct_logfile =~ "%referer");
    $agentlog = $prefixlog if ($struct_logfile =~ "%agent");

    $notrafic = 1 if ($struct_logfile !~ /\%requetesize/);
    return $struct_logfile;

}

#################################################################
####          Extract date from log file                  #######
#################################################################

sub extract_date_syslog {
    local($scalar) = @_;
    local(@line_log,$date,$tmp);

    @line_log = split(/\s+/,$scalar);
    $tmp = $fullyear;
    ($day) = split(/\//,$today);
    $tmp-- if ($month_equiv{$line_log[0]} > $monthindex);
    $tmp-- if ($month_equiv{$line_log[0]} == $monthindex && $line_log[1] > $day);
    
    $date = "$line_log[1]";
    $date = "0".$date if (length($line_log[1]) == 1);
    $date .= "/$line_log[0]/$tmp:$line_log[2]";
    return $date;
}

sub extract_date_from_log {
#    local($filelog) = @_;
    local(*FILE_FIND) = @_;
#    local($scalar,$sep,$date,$line,$tmpyear);
    local($sep,$date,$line,$tmpyear);

    $sep = $logfile_sep;
#    $sep = "]" if ($filelog =~ /^$fileroot$errorlog/ && $errorlog ne '');
    $sep = "]" if ($scriptname eq "cron-error.pl");

   while ($date !~ m/^((\d+)\/(\w+)\/(\d\d\d\d))/ && $line < 100) {

	$scalar_file = (<FILE_FIND>);
	$scalar = $scalar_file if ($scalar_file ne ''); # if EOF, use $scalar
	$line++;

	$tmpyear = $year;

	if ($scriptname ne "cron-hour.pl" && $scalar =~ /\r\n$/ && $line == 1 && $type_serveur != 1) {
	    $dos_format = 1;
	    print "*** Warning *** Dos file found\n";
	}

	$struct_logfile = &detect_w3c_logformat($scalar) if ($scalar =~ /^\#Fields:/ || $scalar =~ /^\!\!LOG_FORMAT/);

#	return(-1) if ($scalar eq '');

	if ($mail_format == 1) {
	    @line_log = split(/\s+/,$scalar);
	    if ($line_log[0] =~ /(\d\d\d\d)-(\d\d)-(\d\d)/) {
		$date = $3.$dirsep.$month_nb[$2-1].$dirsep.$1.":".$line_log[$fields_logfile{'%time'}];
	    } else {
		$date = &extract_date_syslog($scalar);
#		$tmpyear-- if ($month_equiv{$line_log[0]} > $monthindex);
#		$tmpyear-- if ($month_equiv{$line_log[0]} == $monthindex && $line_log[1] > $day);
		
#		$date = "$line_log[1]";
#		$date = "0".$date if (length($line_log[1]) == 1);
#		$date .= "/$line_log[0]/$tmpyear:$line_log[2]";
	    }
	} elsif ($ftp_format == 1) {
	    @line_log = split(/\s+/,$scalar);
	    chomp($line_log[$#line_log]) if ($#line_log != -1);
	    chop($line_log[$#line_log]) if ($#line_log != -1 && $dos_format == 1);
#	    $line_log[2] = "0".$line_log[2] if ($line_log[2] < 10);
	    $date = "$line_log[2]/$line_log[1]/$line_log[4]:$line_log[3]";
	    $date = "0".$date if (length($line_log[2]) == 1);
	    if ($date !~ m/^((\d+)\/(\w+)\/(\d\d\d\d):)(.*)/) {
		$date = &extract_date_syslog($scalar);
	    }
	    $date = &date_common($line_log[$fields_logfile{'%date'}+$fields_after_login{'%date'}*$add_fields_logfile],$line_log[$fields_logfile{'%time'}+$fields_after_login{'%time'}*$add_fields_logfile]) if ($fields_logfile{'%time'} ne '');
	    $date = $day.$dirsepurl.$lettermonth.$dirsepurl.$tmpyear.":".$line_log[$fields_logfile{'%time'}+$fields_after_login{'%time'}*$add_fields_logfile] if ($fields_logfile{'%date'} eq '');
	} elsif ($dhcp_format == 1) {
	    # ISC
	    @line_log = split(/\s+/,$scalar);
	    if ($line_log[0] =~ /(\d\d\d\d)-(\d\d)-(\d\d)/) {
		$date = $3.$dirsep.$month_nb[$2-1].$dirsep.$1;
#		$date1 = $3.$dirsep.$month_nb[$2-1].$dirsep.$1.":";
#		if ($line_log[0] =~ /\d\dT\d\d/) {
#		    ($tmp1,$tmp2) = split('T',$line_log[0]);
#		    ($tmp1,$tmp2) = split(/[+-]/,$tmp2);	    
#		    $date = $date1.$tmp1;
#		}
	    } else {
		$date = &extract_date_syslog($scalar);
	    }


#	    if ($date =~ /(\d\d\d\d)-(\d\d)-(\d\d)/) {
#		$date = $3.$dirsep.$month_nb[$2-1].$dirsep.$1;
#		if ($date =~ /\d\dT\d\d/) {
#		    ($tmp1,$tmp2) = split('T',$date);
#		    ($tmp1,$tmp2) = split(/[+-]/,$tmp2);	    
#		    $date = $date1.$tmp1;
#		}
#	    }
#	    if ($date =~ /(\d\d\d\d)-(\d\d)-(\d\d)/) {
#		$date = $3.$dirsep.$month_nb[$2-1].$dirsep.$1;
#	    }


	} else {
	    @line_log = split(/$sep/,$scalar);
	    chomp($line_log[$#line_log]) if ($#line_log != -1);
	    chop($line_log[$#line_log]) if ($#line_log != -1 && $dos_format == 1);
	    $add_fields_logfile = &LoginWithSpace(@line_log) if ($line_log[$fields_logfile{'%login'}] =~ /^\"/);
	    $date = $line_log[$fields_logfile{'%date'}+$fields_after_login{'%date'}*$add_fields_logfile];
	    $date =~ s/\[//;
	    $date = &date_squid($date) if ($date =~ /\d{9}\.\d{3}/);
	    $date = &date_common($line_log[$fields_logfile{'%date'}+$fields_after_login{'%date'}*$add_fields_logfile],$line_log[$fields_logfile{'%time'}+$fields_after_login{'%time'}*$add_fields_logfile]) if ($fields_logfile{'%time'} ne '');

#	    $date = $date_filename.":".$line_log[$fields_logfile{'%time'}+$fields_after_login{'%time'}*$add_fields_logfile] if ($fields_logfile{'%date'} eq '');
#	    $date = $day.$dirsepurl.$lettermonth.$dirsepurl.$fyear.":".$line_log[$fields_logfile{'%time'}+$add_fields_logfile] if ($fields_logfile{'%date'} eq '');
	    $date = $day.$dirsepurl.$lettermonth.$dirsepurl.$tmpyear.":".$line_log[$fields_logfile{'%time'}+$fields_after_login{'%time'}*$add_fields_logfile] if ($fields_logfile{'%date'} eq '');

	    if ($scriptname eq "cron-error.pl") {
#	    if ($filelog =~ /^$fileroot$errorlog/ && $errorlog ne '') {
		$tmp = $line_log[0];
		$tmp =~ s/\[//;
		($tmp1,$tmp2,$tmp3,$tmp4,$tmp5) = split(/\s+/,$tmp);
		$date = "$tmp3$dirsep$tmp2$dirsep$tmp5";
	    }
	}
	($date) = split(/:/,$date);
#	($date) = split(/T/,$date);

#	if ($date =~ /(\d\d\d\d)-(\d\d)-(\d\d)/) {
#	    $date = $3.$dirsep.$month_nb[$2-1].$dirsep.$1;
#        }
#    print "UU $date - $date1\n";

    }	

#    close(FILE_FIND);
    return(-1) if ($date eq '');
#    return(-1) if ($date !~ /\d\d\/\W\w\w\/\d\d\d\d/m/^((\d+)\/(\w+)\/(\d\d\d\d))/) {
    return(-1) if ($date !~ m/^(\d+)\/(\w+)\/(\d\d\d\d)/);

    return $date;
}

#################################################################
####                Find logfile index                    #######
#################################################################

sub find_index_way {
    local($file1,$file2) = @_;
    local($date1,$date2,$tmp);

    if (-f "$file1$zipext") {
	if (!(-r "$file1$zipext")) { 
	    $msg = "WARNING : $file1$zipext cannot be read. \n";
	    if ($ENV{'REQUEST_METHOD'} eq "GET") {
		$msg .= "Your web server should be able to read your logfile.\n";
	    } else {
		$msg .= "Check your logfile permission\n";
	    }
	    &error_exit($msg);
	}
	open(INFILE, "$GZIP $file1$zipext |");
    } else {
	if (!(-r "$file1")) { 
	    $msg = "WARNING : $file1 cannot be read. \n";
	    if ($ENV{'REQUEST_METHOD'} eq "GET") {
		$msg .= "Your web server should be able to read your logfile.\n";
	    } else {
		$msg .= "Check your logfile permission\n";
	    }
	    &error_exit($msg);
	}
	open(INFILE,"$file1");# || die "Error, unable to open $file1\n";
    }
    $date1 = &extract_date_from_log(*INFILE);
    close(INFILE);

    # same file
    if ($file2 eq $file1 && $zipcut == 3 && $max_rotate_index == 1) {
	$file2 = $fileroot.$prefixlog;
    }

#    print "PP $date1 - $file2\n";

    if (-f "$file2$zipext") {
	if (!(-r "$file2$zipext")) { 
	    $msg = "WARNING : $file2$zipext cannot be read. \n";
	    if ($ENV{'REQUEST_METHOD'} eq "GET") {
		$msg .= "Your web server should be able to read your logfile.\n";
	    } else {
		$msg .= "Check your logfile permission\n";
	    }
	    &error_exit($msg);
	}
	open(INFILE, "$GZIP $file2$zipext |");
    } else {
	if (!(-r "$file2")) { 
	    $msg = "WARNING : $file2 cannot be read. \n";
	    if ($ENV{'REQUEST_METHOD'} eq "GET") {
		$msg .= "Your web server should be able to read your logfile.\n";
	    } else {
		$msg .= "Check your logfile permission\n";
	    }
	    &error_exit($msg);
	}
	open(INFILE,"$file2"); # || die "Error, unable to open $file2\n";
    }
    $date2 = &extract_date_from_log(*INFILE);
    close(INFILE);

#    print "UU $date1 ($file1) - $date2 ($file2)\n";

    if ($date1 == -1) {
	$msg = "Unable to extract date from $file1";
	$msg .= "$zipext" if ($zip == 1);
	$msg .= "\nCheck your logfile format match \$struct_logfile\n";
	&error_exit($msg);
    }

    if ($date2 == -1) {
	$msg = "Unable to extract date from $file2";
	$msg .= "$zipext" if ($zip == 1);
	$msg .= "\nCheck your logfile format match \$struct_logfile\n";
	&error_exit($msg);
    }

#    $sec_deb1 = &nb_sec_deb($date1);
#    $sec_deb2 = &nb_sec_deb($date2);
#    print "LL $sec_deb1 ($file1) - $sec_deb2 ($file2)\n";

#    print "UU $date1 ($file1) - $date2 ($file2)\n";

    $date1 = &nbday($date1);
    $date2 = &nbday($date2);

    if ($date1 > $date2) {
	$rotate_inc = 1;
	$tmp = $max_rotate_index;
	$max_rotate_index = $min_rotate_index;
	$min_rotate_index = $tmp;
	$msg = "Logfile rotation number found with increasing number !\n";
	&output_log($msg);
    }
    if ($date1 < $date2) {
	$rotate_inc = -1;
	$tmp = $filetmpzip;
	$filetmpzip =  $first_logfile;
	$first_logfile = $tmp;
    }

    if ($date1 == $date2) {
	$msg = "Both first and last logfile share the same date ($date1)\n";
	&output_log($msg);
	if ($type_serveur == 1) {
	    $rotate_inc = 1;
#	    print "AA : $min_rotate_index / $max_rotate_index - $first_logfile\n";
	    $tmp = $max_rotate_index;
	    $max_rotate_index = $min_rotate_index;
	    $min_rotate_index = $tmp;
	    $msg = "Assuming increasing rotation number\n";
	    &output_log($msg);
#	    print "MIN : $min_rotate_index / $max_rotate_index\n";
	}
	if ($type_serveur == 0) {
	    $rotate_inc = -1;
	    $tmp = $filetmpzip;
	    $filetmpzip =  $first_logfile;
	    $first_logfile = $tmp;
	    $msg = "Assuming decreasing rotation number\n";
	    &output_log($msg);
	}
    }

#    print "PP $rotate_inc - $rotate\n";
    return $rotate_inc;
}

#################################################################
####                Find logfile index                    #######
#################################################################

sub find_index_log {
    local($fileroot,$filelog,$date_find) = @_;
    local($tmp,$tmp_name,$struct,$tmp_sec);
#    local($day,$month,$year);

    opendir(SOURCEDIR,$fileroot) || &error_exit("Couldn't open directory $fileroot !");
    local(@filenames) = readdir(SOURCEDIR);
    closedir(SOURCEDIR);

    $log_date = &nbday($date_find);

    $diff_log_max = -1;
    $diff_log = 0;
    $diff_log_old = '';
    $rotate = -2;
    for ($i=0;$i<=$#filenames;$i++) {
#	print "II $filenames[$i]\n";
	next if ($filenames[$i] =~ /^\./);
	next if ($filenames[$i] =~ /~$/);
	if ($filenames[$i] =~ /$filelog/) {

	    if ($filenames[$i] ne "$prefixlog") {
		$struct = '';
		$struct2 = '';
		$struct3 = '';
		$tmp_name = $filenames[$i];
		$tmp_name =~ s/$zipext//;
		$tmp_name =~ s/$filelog//;
	    
		$struct_tmp = $struct_compressed_logfile;
		$struct_tmp =~ s/%prefixlog//;

		for ($j=1;$j<=$#compressed_logfile_fields;$j++) {
		    $tmp = $compressed_logfile_fields[$j];
		    $tmp_sep = $compressed_sep_fields[$j];
		    $struct .= "$logfile_field_type{$tmp}";
		    $struct3 .= "($logfile_field_type{$tmp})" if ($j > 1);
		    $struct2 .= "$tmp";
		    $struct .= "\\$tmp_sep" if ($tmp_sep ne '');
		}
		$struct .= "\$";
		next if ($tmp_name !~ /$struct/);
		$tmp_name =~ s/$struct//;
		next if ($tmp_name ne '');
	    }

	    $tmp = $fileroot.$filenames[$i];
	    $tmp =~ s/$zipext//;
#	    print "EXTRACT from $tmp\n";
	    if (-s $tmp || -s "$tmp$zipext") {
		if (-f "$tmp$zipext") {
		    open(INFILE, "$GZIP $tmp$zipext |");
		} else {
		    open(INFILE,"$tmp");
		}

		$date = &extract_date_from_log(*INFILE);
		close(INFILE);
	    }
#	    print "DATE $i - $tmp - $date - $date_find - $rotate\n";
	    next if ($date == -1 || $date eq '');

	    $log_date_search = &nbday($date);
	    $diff_log = $log_date-$log_date_search;
	    $diff_log_max = $diff_log if ($diff_log > $diff_log_max);
#	    print "LOG $log_date-$log_date_search - $diff_log < $diff_log_old - $diff_log_max\n";

#	    print "LL1 - $diff_log < $diff_log_old - $i\n";
	    if ($diff_log >= 0 && (($diff_log < $diff_log_old) || $diff_log_old eq '')) {
		$tmp = $filenames[$i];
		$tmp =~ s/$filelog$compressed_sep_fields[1]//;
		$tmp =~ s/$zipext//;
#		print "MM $filenames[$i] - $tmp\n";
		if ($tmp ne $prefixlog) {
		    for ($j=1;$j<=$#compressed_logfile_fields;$j++) {
			$tmp =~ s/\Q$compressed_sep_fields[$j]\E//;
		    }
		}
		$rotate = $tmp if ($tmp =~ /^\d/);
#		$rotate -= $rotate_inc if ($diff_log == 0); # Read the previous one as it may start before
		$rotate = -2 if ($tmp eq $prefixlog);
#		print "LL $rotate - $diff_log - $rotate_inc - $tmp\n";
		$diff_log_old = $diff_log;
	    }
	}
    }


#    $struct =~ s/\\$compressed_sep_fields[1]//;
#    print "JJ - $rotate - $diff_log_old - $struct \n";

    $file_re = $fileroot;

#    if ($struct_compressed_logfile =~ /\%hour/ && $struct_compressed_logfile =~ /\%min/ && $struct_compressed_logfile =~ /\%sec/) {
    if ($struct_compressed_logfile =~ /\%hour/) {
	$rotate2 = $rotate;
	$rotate2 =~ s/\D//g;
	$struct2 =~ s/%prefixlog//;
	@struct2_field = split(/\%/,$struct2);
#	print "OO $rotate - $rotate2 - $struct - $struct2 - $struct3\n";
	if ($rotate2 =~ m/$struct3/) {
	    for ($i=1;$i<=$#struct2_field;$i++) {
		${$struct2_field[$i]} = $$i;
	    }
#	    print "FOUND $1 - $struct2 - $struct2_field[1] - $year - $month - $day - $hour - $min - $sec\n";
	}
	$file_re = &Get_LogfileName($fileroot);
	$file_re_zip = $file_re.$zipext;
	undef $rotate;
    } else {

#	print "JJ1 - $rotate - $rotate_inc - $diff_log_old\n";
	if ($diff_log_old == 0 && $diff_log_old ne '') {
	    if ($rotate == -2) {
		$rotate = -$rotate_inc;
	    } else {
		$rotate += -$rotate_inc;
	    }
	} 
#	print "JJ2 - $rotate - $diff_log_old\n";
	$rotate = -2 if (int($rotate) !~ /^\d/);
#    print "JJ2 - $rotate\n";
#    return(-1) if ($rotate == 0); 

	($day,$month,$year) = split(/[\s+\/]/,$date_find);

#   print "JJ - $date_find - $file_re\n";
#    $file_re = $fileroot;

	if ($rotate != -2) {
	    $file_re = &Get_LogfileName($fileroot);
	    $file_re_zip = $file_re.$zipext;
	    if (!(-f $file_re) && !(-f $file_re_zip)) {
		$rotate += $rotate_inc;
		$file_re = &Get_LogfileName($fileroot);
	    }
	} else {
	    $file_re .= $prefixlog;
	}
    }

#    print "A $file_re - $day $month $year\n";

    return $file_re;

}

#################################################################
####                Find the last logfile                 #######
#################################################################

sub find_last_log {
    local($fileroot,$filelog) = @_;
#    local($re,$i,$j,$yday_max,$yday,$tmp3,$field_re,$tmp);
#    local($year,$month,$day,$hour,$min,$sec);
    local($yday,$tmp3);
    local($tmp);

    # $datetmpzip is global

    opendir(SOURCEDIR,$fileroot) || &error_exit("Couldn't open directory $fileroot !");
    local(@filenames) = readdir(SOURCEDIR);
    closedir(SOURCEDIR);

#    if ($struct_compressed_logfile !~ /\%hour/) {
	$re = -1;
	$max_rotate_index = 0;

	for ($i=0;$i<=$#filenames;$i++) {
	    next if ($filenames[$i] =~ /^\./);
	    next if ($filenames[$i] =~ /~$/);
	    if ($filenames[$i] =~ /$filelog\Q$compressed_sep_fields[1]\E/ && !(-z "$fileroot$filenames[$i]")) {

		$tmp = $filenames[$i];
		if ($tmp !~ /$zipext$/) {
		    if (!(-r "$fileroot$tmp")) { 
			$msg = "WARNING : $fileroot$filenames[$i] cannot be read. \n";
			if ($ENV{'REQUEST_METHOD'} eq "GET") {
			    $msg .= "Your web server should be able to read your logfile.\n";
			} else {
			    $msg .= "Check your logfile permission\n";
			}
#			&output_log($msg);
			&error_exit($msg);
#			next;
		    }
		} else {
		    if (!(-r "$fileroot$filenames[$i]")) { 
			$msg = "WARNING : $fileroot$filenames[$i] cannot be read. \n";
			if ($ENV{'REQUEST_METHOD'} eq "GET") {
			    $msg .= "Your web server should be able to read your logfile.\n";
			} else {
			    $msg .= "Check your logfile permission\n";
			}
#			&output_log($msg);
			&error_exit($msg);
#			next;
		    }
		    open(FILE, "$GZIP $fileroot$filenames[$i] |") || &error_exit("Error, unable to open $fileroot$filenames[$i]",0);
		    $scalar = (<FILE>);
		    close(FILE);
		    if ($scalar eq '') {
			$msg = "WARNING : $fileroot$filenames[$i] is empty\n";
			&output_log($msg);
			next;
		    }
		}

		$tmp =~ s/$filelog$compressed_sep_fields[1]//;
		$tmp =~ s/$zipext//;
		for ($j=1;$j<=$#compressed_logfile_fields;$j++) {
		    $tmp =~ s/\Q$compressed_sep_fields[$j]\E//;
		}
#		print "AA - $filenames[$i] - $tmp\n";
		if ($tmp =~ /^\d/ && $tmp !~ /\d+$/) {
		    print "Warning : Seems an extension have been found for $filenames[$i] which is not matching $zipext\n" if ($zip == 1);
		    print "Warning : Unable to extract rotation number from $filenames[$i]\n" if ($zip == 0);
		}
		next if ($tmp !~ /^\d+$/);

		$re++;
		$tab_re[$re] = $filenames[$i];
		
		$max_rotate_index = $tmp if ($tmp > $max_rotate_index);
#		print "TOTO $filelog$compressed_sep_fields[1] - $filenames[$i] - $re - $max_rotate_index\n";
	    }
	}
	return(-1) if ($re == -1); 
#    }

    $yday_max = 0;

    for ($j=0;$j<=$re;$j++) {
	for ($i=1;$i<=$#compressed_logfile_fields;$i++) {
	    $field_re = $compressed_logfile_fields[$i];
	    $tmp = $compressed_sep_fields[$i];
	    $tab_re[$j] =~ s/$filelog//;
#	    $tab_re[$j] =~ s/$filelog// if ($field_re eq "%prefixlog" || $field_re eq "%errorlog");
	
	    if ($field_re eq "%year") {
		$tab_re[$j] =~ s/^(\d\d\d\d)//;
		$year_re[$j] = $1;
	    }
	    if ($field_re eq "%smallyear") {
		$tab_re[$j] =~ s/^(\d\d)//;
		$year_re[$j] = $smallyear2_today.$1 if ($1 <= $smallyear_today);
		$year_re[$j] = ($smallyear2_today-1).$1 if ($1 > $smallyear_today);
	    }
	    if ($field_re eq "%month") {
		$tab_re[$j] =~ s/^(\d\d)//;
		$month_re[$j] = $1;
	    }
	    if ($field_re eq "%lettermonth") {
		$tab_re[$j] =~ s/^(\w\w\w)//;
		$lettermonth_re[$j] = $month_equiv{$1};
	    }
	    if ($field_re eq "%day") {
		$tab_re[$j] =~ s/^(\d\d)//;
		$day_re[$j] = $1;
	    }
	    if ($field_re eq "%hour") {
		$tab_re[$j] =~ s/^(\d\d)//;
		$hour_re[$j] = $1;
	    }
	    if ($field_re eq "%min") {
		$tab_re[$j] =~ s/^(\d\d)//;
		$min_re[$j] = $1;
	    }
	    if ($field_re eq "%sec") {
		$tab_re[$j] =~ s/^(\d\d)//;
		$sec_re[$j] = $1;
	    }
	    $tab_re[$j] =~ s/$tmp// if ($tmp ne '');
	}
	$jour = "$day_re[$j] $month_re[$j] $year_re[$j]";
#	print "TYTY $j - $jour\n";
	if ($jour =~ /\d\d \d\d \d\d\d\d/) {
	    $yday = &nbday($jour);
	    $tab_re[$j] = $jour;
	    if ($yday > $yday_max) {
		$yday_max = $yday;
		$yday_max_indice = $j;
	    }
	    $year = $year_re[$yday_max_indice];
	    $month = $month_re[$yday_max_indice];
	    $day = $day_re[$yday_max_indice];
	    $hour = $hour_re[$yday_max_indice];
	    $min = $min_re[$yday_max_indice];
	    $sec = $sec_re[$yday_max_indice];
	    $datetmpzip = $year.$month.$day;
	}
    }

    $rotate = $max_rotate_index;

    $file_re = $fileroot;
    $file_re = &Get_LogfileName($file_re);

#    print "MAX $file_re - $rotate\n";

    &error_exit("\nYou are using daily/monthly splitted logfiles and not apache rotation logfiles\nModify your configuration files (\$zipcut and \$struct_compressed_logfile)",1) if ($zipcut == 3 && $rotate > 10000);
    return $file_re;

}

#################################################################
####               Find the first logfile                 #######
#################################################################

#todo manage load-balancing
#for ($load_iter=0;$load_iter<=$#fileroot;$load_iter++) {

sub find_log_size {
    local($fileroot,$filelog) = @_;
    local($tmp,$struct,$size,$i,$j,$totsize,$totsize2);
    local($pasttoday,$yday,$ydaypast,$openfile,$skipfile);
    local($startday,$stopday);

    $openfile = 0;
    $skipfile = 0;

    if ($opt_d ne '') {
	$pasttoday = &date_intervalle($today,-$opt_d);
	$ydaypast = &nbday($pasttoday);
	$openfile = 1;# if ($zipcut != 2);
	$skipfile = 1;
#	print "OPT_D $today - $ydaypast\n";
    }

    if ($opt_s ne '') {
	$skipfile = 1;
	$openfile = 1;# if ($zipcut != 2);
	$ydaypast = &nbday($opt_s);
#	print "OPT_S $opt_s - $ydaypast\n";
    }

    if ($opt_r ne '') {
	$skipfile = 1;
	$openfile = 1;# if ($zipcut != 2);
	$stopday = &nbday($opt_r);
#	print "OPT_R $opt_r - $stopday\n";
    }

    opendir(SOURCEDIR,$fileroot) || &error_exit("Couldn't open directory $fileroot !");
    local(@filenames) = readdir(SOURCEDIR);
    closedir(SOURCEDIR);


    $struct = '';
#    $struct2 = '';
#    $struct3 = '';
    for ($j=1;$j<=$#compressed_logfile_fields;$j++) {
	$tmp = $compressed_logfile_fields[$j];
	$tmp_sep = $compressed_sep_fields[$j];
	$struct .= "$logfile_field_type{$tmp}";
#	$struct3 .= "($logfile_field_type{$tmp})" if ($j > 1);
#	$struct2 .= "$tmp";
	$struct .= "\\$tmp_sep" if ($tmp_sep ne '');
    }
    $struct .= "\$";

    for ($i=0;$i<=$#filenames;$i++) {
	next if ($filenames[$i] =~ /^\./);
	next if ($filenames[$i] =~ /~$/);
	if ($filenames[$i] eq "$prefixlog") {
	    if (!(-r "$fileroot$prefixlog")) { 
		$msg = "WARNING : $fileroot$prefixlog cannot be read. \n";
		if ($ENV{'REQUEST_METHOD'} eq "GET") {
		    $msg .= "Your web server should be able to read your logfile.\n";
		} else {
		    $msg .= "Check your logfile permission\n";
		}
		&error_exit($msg);
		next;
	    } else {
		$size = -s "$fileroot$prefixlog";
		open(FILE, "$fileroot$prefixlog") || &error_exit("Error, unable to open $fileroot$prefixlog",0);
		$date = &extract_date_from_log(*FILE);
		close(FILE);
		$yday = &nbday($date);
		if ($yday < $ydaypast && $ydaypast ne '') {
		    next;
		}
		if ($yday > $stopday && $stopday ne '') {
		    next;
		}
		$totsize += $size;
#		print "INI - $fileroot$prefixlog - $size\n";
	    }
	} else {

	if ($filenames[$i] =~ /$filelog\Q$compressed_sep_fields[1]\E/ && !(-z "$fileroot$filenames[$i]")) {
	    $tmp = $filenames[$i];
	    $tmp2 = $filenames[$i];

	    $tmp2 =~ s/$filelog//;
	    $tmp2 =~ s/$zipext//;
#	    print "ZZ $tmp2 - $struct\n";
	    if ($tmp2 !~ /^$struct/ && $mode_lb == 0) {
		print "Warning : rejected logfile found : $filenames[$i]\n";
		next;
	    }
#	    $tmp2 =~ s/$compressed_sep_fields[1]//;

#	    print "PP $tmp - $compressed_sep_fields[1]\n";

	    if ($tmp !~ /$zipext$/) {
		if (!(-r "$fileroot$tmp")) { 
		    $msg = "WARNING : $fileroot$filenames[$i] cannot be read. \n";
		    if ($ENV{'REQUEST_METHOD'} eq "GET") {
			$msg .= "Your web server should be able to read your logfile.\n";
		    } else {
			$msg .= "Check your logfile permission\n";
		    }
		    &error_exit($msg);
		    next;
		} else {

		    if ($openfile == 1) {
			open(FILE, "$fileroot$filenames[$i]") || &error_exit("Error, unable to open $fileroot$filenames[$i]",0);
			$date = &extract_date_from_log(*FILE);
			close(FILE);
			$yday = &nbday($date);
			if ($yday < $ydaypast && $ydaypast ne '') {
			    next;
			}
			if ($yday > $stopday && $stopday ne '') {
			    next;
			}
		    }
		    $size = -s "$fileroot$tmp";
		    $totsize += $size;
#		    if ($skipfile == 1) {
#			$yday = &nbday($date);
#		    }

#		    print "A - $fileroot$tmp - $size - $date - $yday\n";
		}
	    } else {
		if (!(-r "$fileroot$filenames[$i]")) { 
		    $msg = "WARNING : $fileroot$filenames[$i] cannot be read. \n";
		    if ($ENV{'REQUEST_METHOD'} eq "GET") {
			$msg .= "Your web server should be able to read your logfile.\n";
		    } else {
			$msg .= "Check your logfile permission\n";
		    }
		    &error_exit($msg);
		}
		open(FILE, "$GZIP $fileroot$filenames[$i] |") || &error_exit("Error, unable to open $fileroot$filenames[$i]",0);
		$size = 0;
		if ($openfile == 1) {
		    $date = &extract_date_from_log(*FILE);
		    $yday = &nbday($date);
		    if ($yday < $ydaypast && $ydaypast ne '') {
			close(FILE);
			next;
		    }
#		    print "$yday - $stopday\n";
		    if ($yday > $stopday && $stopday ne '') {
			close(FILE);
			next;
		    }
		}
#		if ($skipfile == 1) {
#		    $date = $tmp2 if ($zipcut == 2);
#		    $yday = &nbday($date);
#		print "DEBUG $date - $yday - $ydaypast\n";
#		}
		while ($scalar = <FILE>) {
		    $size += length($scalar);
		}
		close(FILE);
		$totsize += $size;
#		print "B - $fileroot$filenames[$i] - $size - $date - $yday\n";
	    }
	}
	}
    }

    ($unit_val,$unit) = &Return_Unit($totsize,0);
    $tmp = int(10*$totsize/$unit_val)/10;

#    $unit = "bytes";
#    $unit_val = 1;

#    if ($totsize > 1024) {
#	$unit = "Kb";
#	$unit_val = 1024;
 #   }
  #  if ($totsize > 1024*1024) {
#	$unit = "Mb";
#	$unit_val = 1024*1024;
 #   }
  #  if ($totsize > 1024*1024*1024) {
##	$unit = "Gb";
#	$unit_val = 1024*1024*1024;
 #   }
#    if ($totsize > 1024*1024*1024*1024) {
#	$unit = "Tb";
#	$unit_val = 1024*1024*1024*1024;
 #   }

    $totsize2 = int(10*$totsize/$unit_val)/10;
    if ($totsize2 != 0) {
	$msg = "Logfile size is $totsize2 $unit\n";

	&output_log($msg);
	if ($ENV{'REQUEST_METHOD'} eq "GET") {
	    print "<BR>";
	}

	return $totsize;
    }# else {
#	$msg = "No logfile match";
#	&error_exit($msg,2);
#	return -1;
 #   }

}

#################################################################
####               Find the first logfile                 #######
#################################################################

sub find_first_log {
    local($fileroot,$filelog) = @_;
#    local($re,$i,$j,$yday_min,$yday,$tmp3,$field_re,$tmp);
#    local($year,$month,$day,$hour,$min,$sec);
    local($yday);
    local($tmp);

    opendir(SOURCEDIR,$fileroot) || &error_exit("Couldn't open directory $fileroot !");
    local(@filenames) = readdir(SOURCEDIR);
    closedir(SOURCEDIR);

    $re = -1;
    $min_rotate_index = $max_rotate_index;
    for ($i=0;$i<=$#filenames;$i++) {
	next if ($filenames[$i] =~ /^\./);
	next if ($filenames[$i] =~ /~$/);
	if ($filenames[$i] =~ /$filelog\Q$compressed_sep_fields[1]\E/ && !(-z "$fileroot$filenames[$i]")) {
	    $tmp = $filenames[$i];
	    if ($tmp !~ /$zipext$/) {
		if (!(-r "$fileroot$tmp")) { 
		    $msg = "WARNING : $fileroot$filenames[$i] cannot be read. \n";
		    if ($ENV{'REQUEST_METHOD'} eq "GET") {
			$msg .= "Your web server should be able to read your logfile.\n";
		    } else {
			$msg .= "Check your logfile permission\n";
		    }
		    &error_exit($msg);
#		    $msg = "WARNING : $fileroot$filenames[$i] is empty\n";
#		    &output_log($msg);
		    next;
		}
	    } else {
		if (!(-r "$fileroot$filenames[$i]")) { 
		    $msg = "WARNING : $fileroot$filenames[$i] cannot be read. \n";
		    if ($ENV{'REQUEST_METHOD'} eq "GET") {
			$msg .= "Your web server should be able to read your logfile.\n";
		    } else {
			$msg .= "Check your logfile permission\n";
		    }
		    &error_exit($msg);
		}
		open(FILE, "$GZIP $fileroot$filenames[$i] |") || &error_exit("Error, unable to open $fileroot$filenames[$i]",0);
		$scalar = (<FILE>);
		close(FILE);
		if ($scalar eq '') {
#		    $msg = "WARNING : $fileroot$filenames[$i] is empty\n";
#		    &output_log($msg);
		    next;
		}
	    }

	    $tmp =~ s/$filelog$compressed_sep_fields[1]//;
	    $tmp =~ s/$zipext//;
	    for ($j=1;$j<=$#compressed_logfile_fields;$j++) {
                $tmp =~ s/\Q$compressed_sep_fields[$j]\E//;
            }

	    next if ($tmp !~ /^\d+$/);

	    $re++;
	    $tab_re[$re] = $filenames[$i];

	    $min_rotate_index = $tmp if ($tmp < $min_rotate_index && $tmp =~ /^\d+$/);
	}
    }

    return(-1) if ($re == -1); 

    $yday_min = &nbday($today);

    for ($j=0;$j<=$re;$j++) {
	for ($i=1;$i<=$#compressed_logfile_fields;$i++) {
	    $field_re = $compressed_logfile_fields[$i];
	    $tmp = $compressed_sep_fields[$i];
	    $tab_re[$j] =~ s/$filelog//;
#	    $tab_re[$j] =~ s/$filelog// if ($field_re eq "%prefixlog" || $field_re eq "%errorlog");
	
	    if ($field_re eq "%year") {
		$tab_re[$j] =~ s/^(\d\d\d\d)//;
		$year_re[$j] = $1;
	    }
	    if ($field_re eq "%smallyear") {
		$tab_re[$j] =~ s/^(\d\d)//;
		$year_re[$j] = $smallyear2_today.$1 if ($1 <= $smallyear_today);
		$year_re[$j] = ($smallyear2_today-1).$1 if ($1 > $smallyear_today);
	    }
	    if ($field_re eq "%month") {
		$tab_re[$j] =~ s/^(\d\d)//;
		$month_re[$j] = $1;
	    }
	    if ($field_re eq "%lettermonth") {
		$tab_re[$j] =~ s/^(\w\w\w)//;
		$lettermonth_re[$j] = $month_equiv{$1};
	    }
	    if ($field_re eq "%day") {
		$tab_re[$j] =~ s/^(\d\d)//;
		$day_re[$j] = $1;
	    }
	    if ($field_re eq "%hour") {
		$tab_re[$j] =~ s/^(\d\d)//;
		$hour_re[$j] = $1;
	    }
	    if ($field_re eq "%min") {
		$tab_re[$j] =~ s/^(\d\d)//;
		$min_re[$j] = $1;
	    }
	    if ($field_re eq "%sec") {
		$tab_re[$j] =~ s/^(\d\d)//;
		$sec_re[$j] = $1;
	    }
	    $tab_re[$j] =~ s/$tmp// if ($tmp ne '');
	}
	$jour = "$day_re[$j] $month_re[$j] $year_re[$j]";
	if ($jour =~ /\d\d \d\d \d\d\d\d/) {
	    $yday = &nbday($jour);
	    $tab_re[$j] = $jour;
	    if ($yday < $yday_min) {
		$yday_min = $yday;
		$tmp2 = $j;
	    }
	    $year = $year_re[$tmp2];
	    $month = $month_re[$tmp2];
	    $day = $day_re[$tmp2];
	    $hour = $hour_re[$tmp2];
	    $min = $min_re[$tmp2];
	    $sec = $sec_re[$tmp2];
	}
    }

#    print "II $rotate - $min_rotate_index\n";
    $rotate = $min_rotate_index;

    $file_re = $fileroot;
    $file_re = &Get_LogfileName($file_re);

#    for ($i=1;$i<=$#compressed_logfile_fields;$i++) {
#	$tmp = $compressed_logfile_fields[$i];
#	$tmp =~ s/\%/\$/;
#	$file_re .= eval($tmp).$compressed_sep_fields[$i];
#    }

    return $file_re;

}

#################################################################
####             Return logfile name                      #######
#################################################################

sub Get_LogfileName {
    local($file) = @_;
    local($i,$tmp,$k);
#    local($j,$abort,$hour,$min,$sec);
    local($j,$hour,$min,$sec);
    local($filezip);

    if ($real_deb == 0) {
	for ($i=1;$i<=$#compressed_logfile_fields;$i++) {
#	$date_filename = $day.$dirsepurl.$lettermonth.$dirsepurl.$year; # Format XX/Mmm/YYYY
	    $tmp = $compressed_logfile_fields[$i];
	    $tmp =~ s/\%/\$/;
	    $file .= eval($tmp).$compressed_sep_fields[$i];
	}    
    }

   if ($real_deb == 1) {
#	if ($struct_compressed_logfile =~ /\%hour/ && $struct_compressed_logfile =~ /\%min/ && $struct_compressed_logfile =~ /\%sec/) {
	if ($struct_compressed_logfile =~ /\%hour/) {

	    $abort = 1;
	    for ($j=0;$j<=$re;$j++) {
		$abort = 0 if ($tab_re[$j] eq "$day $month $year");
	    }

	    $file = $fileroot.$prefixlog;
	    $filetmpzip = $file.$zipext; # NEW

	    if ($abort == 0) {
		$sec = -1;
		$min = 0;
#		$hour = 0 if ($hour eq '');
		$hour = $hour_log;

		if ($zipcut == 4) {
		    for ($k=$hour;$k<24;$k++) {
			$file = $fileroot;
			$hour = "0".$hour if (length($hour) == 1);
			$min = "00";
			$sec = "00";

			for ($i=1;$i<=$#compressed_logfile_fields;$i++) {
			    $tmp = $compressed_logfile_fields[$i];
			    $tmp =~ s/\%/\$/;
			    $file .= eval($tmp).$compressed_sep_fields[$i];
			}    

#			print "\nOO $file - $day - $hour - $k\n";
			$filezip = $file.$zipext if ($zip == 1);
			if (-f $file || -f $filezip) {
#			$re_index++;
			    last;
			}
		    }
#		    exit;
		}
		if ($zipcut != 4) {
		$hour = 0;
		for ($k=0;$k<86400;$k++) {

		    $file = $fileroot;
		    $sec++;
		    if ($sec > 59) {
			$min++;
			$sec = 0;
			if ($min > 59) {
			    $min = 0;
			    $hour++;
			}
		    }
		    if ($sec < 0) {
			$min--;
			if ($min < 0) {
			    $hour--;
			    $min = 59;
			}
			$sec = 59;
		    }

		    $hour = "0".$hour if (length($hour) == 1);
		    $min = "0".$min if (length($min) == 1);
		    $sec = "0".$sec if (length($sec) == 1);

		    for ($i=1;$i<=$#compressed_logfile_fields;$i++) {
			$tmp = $compressed_logfile_fields[$i];
			$tmp =~ s/\%/\$/;
			$file .= eval($tmp).$compressed_sep_fields[$i];
		    }    

#		    $file = &Get_LogfileName($fileroot);
		    $filezip = $file.$zipext if ($zip == 1);
		    if (-f $file || -f $filezip) {
#			$re_index++;
			last;
		    }
		}
		}
	    }
#	    print "UU2 - $file\n";
	}
    }

    return $file;
}

#################################################################
####             Create stats ouput directories           #######
#################################################################

sub MakeDirectories {
    local($i,$j,$tmp,$tmp2);

    $readme = ".w3perl";

    # directory a la racine

    $tmp2 = 1;
    $tmp = $path;
    chop($tmp);
    $tmp2 = mkdir ($tmp,0775) unless -d $tmp;

    # en cas d'echec, on essaye un repertoire en dessous

    $i = 0;
    while ($tmp2 == 0 && $tmp ne '') {
	$i++;
	$tmpold[$i] = $tmp;
	$tmp = substr($tmp,0,rindex($tmp,$dirsep)+1);
	chop($tmp);
	$tmp2 = mkdir ($tmp,0775) unless -d $tmp;
    }

    if ($tmp eq '') {
#	print "<FONT COLOR=\"#FF0000\">" if ($ENV{'REQUEST_METHOD'} eq "GET");
	$msg = "Problem creating directory $path\n";
#	print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	$msg .= "Check write permission\n";
#	print "</FONT>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	&error_exit($msg,4);
    }


    if ($i != 0) {
	for ($j=$i;$j>$0;$j--) {
	    $tmp = $tmpold[$j];
	    $tmp2 = mkdir ($tmp,0775) unless -d $tmp;
	}
    }

    if ($tmp2 == 0) {
	&error_exit("Unable to create $path",4);
    }

    # repertoire tmp en 777

    $tmp = umask(0);
    $dir = $path.$dirtmp;
    $tmp2 = mkdir ($dir,0777) unless -d $dir;
    umask($tmp);

    if ($tmp2 == 0) {
#        print "<FONT COLOR=\"#FF0000\">" if ($ENV{'REQUEST_METHOD'} eq "GET");
        $msg = "Unable to create subdirectories in $path\n";
#        print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
        $msg .= "$path should be writeable ";
	$msg .= "by the web server " if ($ENV{'REQUEST_METHOD'} eq "GET");
	$msg .= "- Check write permission\n";
#        print "</FONT>" if ($ENV{'REQUEST_METHOD'} eq "GET");
        &error_exit($msg,4);
    }

    $dir = $path.$dirinc;
    mkdir ($dir,0775) unless -d $dir;

    $dir = $path.$dirdata;
    mkdir ($dir,0775) unless -d $dir;

    $dir = $path.$dirgraph;
    mkdir ($dir,0775) unless -d $dir;

    $dir = $path.$dircsv;
    mkdir ($dir,0775) unless -d $dir;

    $dir = $path.$dirxml;
    mkdir ($dir,0775) unless -d $dir;

    $dir = $path.$dirpdf;
    mkdir ($dir,0775) unless -d $dir;

    $dir = $path.$readme;
    $tmp = $conf_file;
    $tmp = substr($conf_file,rindex($conf_file,$dirsep)+1,length($conf_file));
    open(FILE,">$dir");
    print FILE "W3Perl stats directory : $tmp\n";
    print FILE "Don't remove this file as it is used to bypass output directory scan\n";
    close(FILE);

    if (substr($pathinit,1,1) ne ':') {
	# Dir docs

	$newfile = $path."docs";
	$oldfile = $pathinit."docs";

	symlink($oldfile,$newfile) if (!(-l $newfile));
	
	# Dir resources
    
	$newfile = $path."resources";
	$oldfile = $pathinit."resources";
	
	symlink($oldfile,$newfile) if (!(-l $newfile));

	# Dir admin
	
	$newfile = $path."admin";
	$oldfile = $pathinit."admin";
    
	symlink($oldfile,$newfile) if (!(-l $newfile));
    }

# ML

    for ($nblang=0;$nblang<=$#lang;$nblang++) {

	$dir = $path.$lang[$nblang];
	mkdir ($dir,0775) unless -d $dir;
	
#	$dir = $path.$lang[$nblang].$dirsep.$dirframe;
#	mkdir ($dir,0775) unless -d $dir;

	$dir = $path.$lang[$nblang].$dirsep.$dirpays;
	mkdir ($dir,0775) unless -d $dir;

	if ($geoipcity == 1) {
	    $dir = $path.$lang[$nblang].$dirsep.$dircity;
	    mkdir ($dir,0775) unless -d $dir;
	}

	$dir = $path.$lang[$nblang].$dirsep.$dirsite;
	mkdir ($dir,0775) unless -d $dir;

	$dir = $path.$lang[$nblang].$dirsep.$dirlist;
	mkdir ($dir,0775) unless -d $dir;

	$dir = $path.$lang[$nblang].$dirsep.$dirscript;
	mkdir ($dir,0775) unless -d $dir;

	$dir = $path.$lang[$nblang].$dirsep.$dirpage;
	mkdir ($dir,0775) unless -d $dir;

	$dir = $path.$lang[$nblang].$dirsep.$dirdate;
	mkdir ($dir,0775) unless -d $dir;

	$dir = $path.$lang[$nblang].$dirsep.$dirsession;
	mkdir ($dir,0775) unless -d $dir;

	$dir = $path.$lang[$nblang].$dirsep.$dirdocument;
	mkdir ($dir,0775) unless -d $dir;

	$dir = $path.$lang[$nblang].$dirsep.$dirdomain;
	mkdir ($dir,0775) unless -d $dir;

	if ($squid_format == 1) {
	    $dir = $path.$lang[$nblang].$dirsep.$dirproxy;
	    mkdir ($dir,0775) unless -d $dir;
	}


#$dir = $path.$lang[$nblang].$dirsep.$dirdays;
#mkdir ($dir,0775) unless -d $dir;
    }

}

#################################################################
####              Get full agent string                   #######
#################################################################

sub GetAgentString {
    local($f,$i) = @_;
    local($tmpi);
#    local($tmpi,$tt1);
    
    $add_fields_agent = 0;

    if ($iis_format != 1) {
	$f3 = '';

	if ($f !~ m/\"/) {
	    $f2 = '';
	    $add_fields_agent = $i + 1;
	    $f3 = $line_log[$add_fields_agent]." ";
	    while ($f3 !~ /\-\s+/ && $f3 !~ /https?:\/\//i && $f3 ne ' ') {
		$f2 .= $f3;
		$add_fields_agent++;
		$f3 = $line_log[$add_fields_agent]." ";
#	    $f3 = $line_log[$tmpi++]." ";
	    }
	    $f .= " ".$f2;
	}

	$f =~ s/\"//;

#    if ($type_serveur == 0 && $f3 eq '') {    
	if ($dos_format == 0 && $f3 eq '') {    
	    while ($f !~ /\"/ && (rindex($f,'"')+1) != length($f) && ($f !~ /\n/)) {
		$i++;
		$add_fields_agent++;
		$line_log[$i] = "[".$line_log[$i] if ($line_log[$i] =~ /\]/);
		$f .= " ".$line_log[$i];
#		print "PP $i - $f\n";
		return $f if ($line_log[$i] eq '');
#		$tt = rindex($f,'"')+1;
#		$tt1 = length($f);
		if ($i > 100 && $f ne "-" && $previous_pble ne $adresse) {
		    $msg = "\nThe agent string seems to be too long ... skipping ...\n";
		    $msg .= "$_";
		    chop($msg);
		    $previous_pble = $adresse;
#		    $msg .= "\n A - $previous_pble";

#		    &error_exit($msg,2);
		    print "<BR><DIV CLASS=\"warning_msg\">" if ($opt_w ne '' && $ENV{'REQUEST_METHOD'} eq "GET");
		    &output_log($msg);
		    print "</DIV>" if ($ENV{'REQUEST_METHOD'} eq "GET");

		    $f = "-";
#		    print STDERR "$_ \n";
#		    print STDERR "\n\nThe agent string seems to be too long ... please check !\n";
		    return $f;

		}
	    }
	}
    }

    $f =~ s/\+/ /g if ($f !~ /\s/);# if ($type_serveur == 1);
    $f =~ s/^A://;
    $f =~ s/\n//;
    $f =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

    next if ($f eq '');

    chop($f) if ($iis_format != 1);

    return $f;
}

#################################################################
####            Use help popup javascript                 #######
#################################################################

sub popup_help {
    local(*FOUT,$level) = @_;
    local($link,$i);

    for ($i=1;$i<=$level;$i++) {
	$link .= "..$dirsepurl";
    }

    print FOUT "<SCRIPT LANGUAGE=\"Javascript\" TYPE=\"text/javascript\">\n";
    print FOUT "var popup_help = null;\n";
    print FOUT "function HelpDisplay(file) {\n";
    print FOUT "xwin = screen.width/2;\n";
    print FOUT "ywin = screen.height/3;\n";
    print FOUT "popup_help = window.open(\"\",\"popDialogHelp\",\"height=\"+ywin+\",width=\"+xwin+\",scrollbars=yes\")\n";
    print FOUT "popup_help.location.href=\"$link$linkpathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl\"+file;\n";
    print FOUT "popup_help.document.close();\n";
    print FOUT "popup_help.focus();\n";
    print FOUT "}\n";
    print FOUT "</SCRIPT>\n";
} 

#################################################################
####         sort an associative array by value           #######
#################################################################

# convert YYYYMMDD to DD/Mmm/YYYY

sub aff_date {
    local($date) = @_;
    local($string);

#    $string = substr($date,6,2)."/".$month_nb[substr($date,4,2)-1]."/".substr($date,0,4);
    $string = substr($date,6,2)."&nbsp;".$month_nb[substr($date,4,2)-1]."&nbsp;".substr($date,0,4);
    return $string;
}

# convert DD/Mmm/YYYY into YYYYMMDD

sub encode_date {
    local($date) = @_;
    local($string,$day,$month,$year);

    ($day,$month,$year) = split(/[\/\s]/,$date);

    $string = "$year$month_equiv{$month}$day";
    return $string;
}

sub sort_by_value {
    local(*x) = @_;
    sub _by_value { $x{$a} <=> $x{$b}; } 
    sort _by_value keys %x;
} 

sub reverse_sort_by_value {
    local(*x) = @_;
    sub _by_value { $x{$a} <=> $x{$b}; } 
    reverse sort _by_value keys %x;
} 

#sub reverse_sort_by_string {
#        local(*x) = @_;
#        sub _by_value { $x{$a} cmp $x{$b}; } 
#        reverse sort _by_value keys %x;
#    } 

#################################################################
####                Exclude robot from a list             #######
#################################################################

sub ExcludeRobot {
    local($agent) = @_;
    local($bot,$i,$foundrobot);

    $foundrobot = 0;
    $foundrobot = 1 if ($robots{$agent} != 0);
#    if ($#RobotHash > -1) {
	if (!$TmpRobot{$agent} && $foundrobot == 0) {
	    for ($i=0;$i<=keys(%RobotHash);$i++) {
		$bot = $RobotIdx[$i];
		if ($agent =~ /$bot/i) {
		    $TmpRobot{$agent} = $RobotHash{$bot};
#		print "LL $agent - $bot - $TmpRobot{$agent}\n";
		    $foundrobot = 1;
		    last;
		}
	    }
	} else {
#	print "MM $agent\n";
	    $foundrobot = 1;
	}
#    }
    return $foundrobot;
}


sub LoadRobot {
    local($inc) = @_;
    local($firstletter,$tmp,$count);
    local($tmp,$tmp1,$tmp2,$tmp3,$tmp4);

    if ($inc != 1) {
	open(LOADROBOT,"$pathinit$dirress$dirsep$incrobot$txtext") || &error_exit("Error, unable to open $pathinit$dirress$dirsep$incrobot$txtext",1);	
	while (<LOADROBOT>) {
	    next if ($_ =~ /\#/);
	    chop;
	    ($bot,$botname) = split(/\s*,\s*/);
	    next if ($bot eq '');
#	    ($bot,$botname) = split(/,/);
	    $bot =~ s/\"//g;
	    $botname =~ s/\"//g;
	    $RobotHash{$bot} = $botname;
	    $RobotIdx[$count] = $bot;
	    $count++;
	}
	close LOADROBOT;
    } else {
	# we load the incremental data
	open(ROBOT,"$path$dirinc$dirsep$incrobot") || &error_exit("Error, unable to open $path$dirinc$dirsep$incrobot\nFirst run the main stats",1);
	while (<ROBOT>) {
	    ($page,$tmp1,$tmp2,$tmp3,$tmp4) = split(/\t/);
	    $robots_fullname{$page} = $tmp4;
#	    $robot_list .= "$page|" if ($page ne '.' && $page ne '');
	    if ($page ne '') {
		if ($page =~ /[0-9]+$/) {
		    $robot_list_ip .= "$page|";
		} else {
		    $robot_list .= "$page|";
		}
	    }
	}
	chop($robot_list);
	chop($robot_list_ip);
	close(ROBOT);
 #   print "AA $robot_list\n";
 #   print "BB $robot_list_ip\n";
    }
}


#################################################################
####         Exclude Referer Spammer from a list          #######
#################################################################

sub LoadReferSpamByKeyword {
    local($inc) = @_;
    local($firstletter,$tmp);

    open(REFSPAM,"$pathinit$dirress$dirsep$refspam_keyword") || die "Error, unable to open $pathinit$dirress$dirsep$refspam_keyword\n";
    while (<REFSPAM>) {
	next if ($_ =~ /\#/);
	chop;
	next if ($_ eq '');
	push(@spam_keyword,$_);
    }
    close REFSPAM;
}

sub LoadReferSpamByIP {
    local($inc) = @_;
    local($firstletter,$tmp);

    open(REFSPAM,"$pathinit$dirress$dirsep$refspam_ip") || die "Error, unable to open $pathinit$dirress$dirsep$refspam_ip\n";
    while (<REFSPAM>) {
	next if ($_ =~ /\#/);
	chop;
	$firstletter = substr($_,0,1);
	$tmp = $increferspamip."_".$firstletter;
	push(@{$tmp},$_);
    }
    close REFSPAM;
}

###

sub LoadReferSpamByDomain {
    local($inc) = @_;
    local($firstletter,$tmp);

    open(REFSPAM,"$pathinit$dirress$dirsep$refspam_standard") || &error_exit("Error, unable to open $pathinit$dirress$dirsep$refspam_standard",1);
    while (<REFSPAM>) {
	next if ($_ =~ /\#/);
	chop;
	$firstletter = substr($_,0,1);
	$tmp = $increferspam."_".$firstletter;
	push(@{$tmp},$_);
    }
    close REFSPAM;
}

###

sub LoadReferSpamList {
    local($inc) = @_;
    local($firstletter,$tmp);

    # we load the incremental data
    open(SPAMREF,"$path$dirinc$dirsep$increferspam") || &error_exit("Error, unable to open $path$dirinc$dirsep$increferspam\nRun first the main stats",1);
    $spam_list = '';
    while (<SPAMREF>) {
	($page) = split(/\t/);
	$spam_list .= "$page|";
    }
    chop($spam_list);
    close(SPAMREF);
}

###

sub ExcludeRefererSpamByKeyword {
    local($host) = @_;

    $foundreferspam = 0;
    if (!$TmpReferSpam{$host}) {
	for ($i=0;$i<=$#spam_keyword;$i++) {
	    if ($host =~ /$spam_keyword[$i]/i) {
		$TmpReferSpam{$host} = 1;
		$foundreferspam = 1;
		last;
	    }
	}
    } else {
	$foundreferspam = 1;
    }

    return $foundreferspam;
}

sub ExcludeRefererSpamByIP {
    local($host) = @_;
    local($referspam,$foundreferspam,$i,$firstletter,$tmp);

    $foundreferspam = 0;
    if (!$TmpReferSpam{$host}) {
	$firstletter = substr($host,0,1);
	$tmp = $increferspamip."_".$firstletter;
	for ($i=0;$i<$#{$tmp};$i++) {
	    if ($host =~ /$$tmp[$i]/i) {
		$TmpReferSpam{$host} = 1;
		$foundreferspam = 1;
		last;
	    }
	}
    } else {
	$foundreferspam = 1;
    }
    return $foundreferspam;
}

sub ExcludeRefererSpamByDomain {
    local($host) = @_;
    local($referspam,$foundreferspam,$i,$firstletter,$tmp);

    $foundreferspam = 0;
    if (!$TmpReferSpam{$host}) {
	$firstletter = substr($host,0,1);
	$tmp = $increferspam."_".$firstletter;
	for ($i=0;$i<$#{$tmp};$i++) {
	    if ($host =~ /$$tmp[$i]/i) {
		$TmpReferSpam{$host} = 1;
		$foundreferspam = 1;
		last;
	    }
	}
    } else {
	$foundreferspam = 1;
    }
    return $foundreferspam;
}



#################################################################
####         Pages/Inc main output functions              #######
#################################################################

#
##############################################################
### Pagesbysites
##############################################################
#

sub Pagesbysites {
    local(*FOUT,*L,$I) = @_;

    foreach $site (sort (keys(%server))) {

#        if ($server{$site} > $seuilsite) {
#        if ($nbpageserveur{$site} > $seuilsite) {
        if ($nbpageserveur{$site} > 0) {
	    $newsite = $site;
	    $newsite =~ s/[.:]/_/g;
#	    $newsite .= $htmlext;
	    
	    if ($site =~ /[0-9]+$/ || $site =~ /:/) {
		$file_to_open = "$path$I$dirsep$dirsite$dirsep$newsite$htmlext";
		open(PAGESITE,">$file_to_open") || die "Error, unable to open $file_to_open\n";
		print PAGESITE "$doctype\n";
		print PAGESITE "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
		print PAGESITE "$charset\n";
		print PAGESITE "<TITLE>$L{'Pages'} - $site</TITLE>\n";
		print PAGESITE "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
		print PAGESITE "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
		print PAGESITE "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
		print PAGESITE "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
		print PAGESITE "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
		print PAGESITE "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
		print PAGESITE "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
		print PAGESITE "$curvy_bottom_jss\n";

		&add_css_style(*PAGESITE,2);

		print PAGESITE "</HEAD>\n";
		print PAGESITE "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";

		&add_css_menu(*PAGESITE,*L,$lang[$nblang],$nblang,2);
	    } else {
		$pospoint = index($site,'.',0);
		$domadresse = substr($newsite,$pospoint+1,(length($newsite)-length($pospoint)));
		$domadresse = $newsite if ($domadresse !~ /_/);


		# si le fichier existe deja, on ajoute l'adresse dans le fichier de domaine
		
		$file_to_open = "$path$I$dirsep$dirsite$dirsep$domadresse$htmlext";
#		if (-e "$file_to_open") {
		if ($file_domain{$domadresse} == 1) {
		    open(PAGESITE,">>$file_to_open") || die "Error, unable to open $file_to_open\n";
		} else {
#		if ($file_domain{$domadresse} == 0) {
		    $file_domain{$domadresse} = 1;
		    open(PAGESITE,">$file_to_open") || die "Error, unable to open $file_to_open\n";
		    print PAGESITE "$doctype\n";
		    print PAGESITE "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
		    print PAGESITE "$charset\n";
		    print PAGESITE "<TITLE>$L{'Pages'} - $L{'domain'} $domadresse </TITLE>\n";
		    print PAGESITE "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
		    print PAGESITE "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
		    print PAGESITE "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
		    print PAGESITE "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
		    print PAGESITE "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
		    print PAGESITE "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
		    print PAGESITE "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
		    print PAGESITE "$curvy_bottom_jss\n";

		    &add_css_style(*PAGESITE,2);

		    print PAGESITE "</HEAD>\n";
		    print PAGESITE "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";

		    &add_css_menu(*PAGESITE,*L,$lang[$nblang],$nblang,2);
		}
	    }

	    print PAGESITE "<A NAME=\"$site\"></A>\n";
	    print PAGESITE "<H2>";
	    print PAGESITE "$L{'Pages'}" if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0);
	    print PAGESITE "$L{'Files'}" if ($ftp_format == 1 || $cups_format == 1);
	    print PAGESITE "$L{'Emails'}" if ($mail_format == 1);
	    print PAGESITE "$L{'Hosts'}" if ($dhcp_format == 1);
#	    print PAGESITE "$L{'Pages'}";
	    print PAGESITE " - $site";
	    print PAGESITE " - $nbpageserveur{$site} $L{'accesses'}" if ($cups_format == 0);
	    print PAGESITE " - $resolv_user{$site}" if ($resolv_user{$site} ne '');
	    print PAGESITE "</H2>";

	    $maxpage = $nbpageserveurunique{$site};
	    $maxpage = $max_item_page if ($nbpageserveurunique{$site} > $max_item_page);

#		if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	    if ($ftp_format == 0) {
		print PAGESITE "<I>$maxpage ";
		if ($cups_format == 0 && $ftp_format == 0) {
		    print PAGESITE "$L{'pages'} " if ($nbpageserveur{$site} != 1);
		    print PAGESITE "$L{'page'} " if ($nbpageserveur{$site} == 1);
		} else {
		    print PAGESITE "$L{'files'} "; # if ($nbpageserveur{$site} != 1);
		}
		print PAGESITE "$L{'among'} $nbpageserveurunique{$site}" if ($nbpageserveurunique{$site} != $maxpage);
		if ($mail_format == 0) {
		    print PAGESITE " - $server{$site} ";
		    print PAGESITE "$L{'request'}" if ($server{$site} == 1);
		    print PAGESITE "$L{'requests'}" if ($server{$site} != 1);
		}
#		print PAGESITE " - $nbpageserveurunique{$site} $L{'hosts'}";
		print PAGESITE "</I>\n";
	    }
	    print PAGESITE "<P>\n";

	    if ($nbpageserveurunique{$site} != 0) {

		if ($maxpage != 0) {
#		$tmp = int($nbpageserveurunique{$site}/$table_big_lines_aff);
		    $tmp = int($maxpage/$table_big_lines_aff);
#		    if ($tmp != ($nbpageserveurunique{$site}/$table_big_lines_aff)) {
		    if ($tmp != ($maxpage/$table_big_lines_aff)) {
			$tmp++;
		    }
		}

		if ($tmp > 1) {
		    print PAGESITE "\n<table class=\"tablesort table-autosort table-autostripe table-autopage:$table_big_lines_aff table-stripeclass:alternate\" id=\"page\">\n";
		} else {
		    print PAGESITE "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
		}
		print PAGESITE "<thead>\n";
		print PAGESITE "<TR>\n";
		if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
		    print PAGESITE "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Level'}&nbsp;</TH>\n";
		    print PAGESITE "<TH class=\"table-sortable:default\">&nbsp;$L{'Directories'}&nbsp;</TH>\n" if ($squid_format == 0);
		    print PAGESITE "<TH class=\"table-sortable:default\">&nbsp;$L{'Destination'}&nbsp;</TH>\n" if ($squid_format == 1);
		}

		print PAGESITE "<TH class=\"table-sortable:default\">&nbsp;$L{'Pages'}&nbsp;</TH>\n" if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
		print PAGESITE "<TH class=\"table-sortable:default\">&nbsp;$L{'Files'}&nbsp;</TH>\n" if ($ftp_format == 1 || $cups_format == 1);
		print PAGESITE "<TH class=\"table-sortable:default\">&nbsp;$L{'Emails'}&nbsp;</TH>\n" if ($mail_format == 1);
		print PAGESITE "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
		print PAGESITE "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
		if ($spam_found != 0 && $spamonly != 1) {
		    print PAGESITE "<TH class=\"table-sortable:numeric\">$L{'Spam'}</TH>\n";
		    print PAGESITE "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n";
		}
		print PAGESITE "<TH class=\"table-sortable:date\">&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n";
		print PAGESITE "<TH class=\"table-sortable:numeric\">&nbsp;$L{'General_ranking'}&nbsp;</TH>\n" if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0);
		print PAGESITE "</TR>\n";
		print PAGESITE "</thead>\n";

		if ($tmp > 1) {
		print PAGESITE "<tfoot>\n";
		print PAGESITE "<TR>\n";
		if ($mail_format == 0 && $cups_format == 0 && $cups_format == 0) {
		    print PAGESITE "<TH>&nbsp;$L{'Level'}&nbsp;</TH>\n";
		    print PAGESITE "<TH>&nbsp;$L{'Directories'}&nbsp;</TH>\n" if ($squid_format == 0);
		    print PAGESITE "<TH>&nbsp;$L{'Destination'}&nbsp;</TH>\n" if ($squid_format == 1);
		}
		print PAGESITE "<TH>&nbsp;$L{'Page'}&nbsp;</TH>\n" if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
		print PAGESITE "<TH>&nbsp;$L{'Files'}&nbsp;</TH>\n" if ($ftp_format == 1 || $cups_format == 1);
		print PAGESITE "<TH>&nbsp;$L{'Emails'}&nbsp;</TH>\n" if ($mail_format == 1);
		print PAGESITE "<TH>&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
		print PAGESITE "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
		if ($spam_found != 0 && $spamonly != 1) {
		    print PAGESITE "<TH>$L{'Spam'}</TH>\n";
		    print PAGESITE "<TH>$L{'Percentage'}</TH>\n";
		}
		print PAGESITE "<TH>&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n";
		print PAGESITE "<TH>&nbsp;$L{'General_ranking'}&nbsp;</TH>\n" if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0);
		print PAGESITE "</TR>\n";


		print PAGESITE "<tr>\n";
		$tmp2 = 4;
		$tmp2 += 2 if ($spam_found != 0);
		$tmp2 += 2 if ($mail_format == 0 && $cups_format == 0 && $cups_format == 0);
		$tmp2++ if ($mail_format == 0 && $spamonly != 1);
		print PAGESITE "<td colspan=$tmp2>\n";
		print PAGESITE "<a href=\"#\" onclick=\"pageexample('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
		
		for ($i=1;$i<=$tmp;$i++) {
		    $iminus = $i-1;
		    print PAGESITE "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexample($iminus); return false;\">$i</a>\n";
		}
		print PAGESITE "<a href=\"#\" onclick=\"pageexample('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
		print PAGESITE "<a href=\"#\" onclick=\"pageexample('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
		print PAGESITE "</td>\n";
		print PAGESITE "</tr>\n";
		print PAGESITE "</tfoot>\n";
		}

		print PAGESITE "<tbody>\n";

#		print PAGESITE "<TABLE CLASS=\"sortable_base\" ID=\"H$site\">\n";

#		for ($i=1;$i<=$nbpageserveurunique{$site};$i++) {
		for ($i=1;$i<=$maxpage;$i++) {
#		    if (!($seen{"$I $site $pagesite{$site,$i}"}++)) {
			print PAGESITE "<TR>\n";
			if ($mail_format == 0 && $dhcp_format == 0 && $cups_format == 0) {
			    $tmp2 = 0;
			    $tmp1 = $pagesite{$site,$i};
			    $tmp3 = substr($tmp1,0,index($tmp1,$dirsepurl,1)+1) if (index($tmp1,$dirsepurl,1) != -1);
			    $tmp3 = $dirsepurl if (index($tmp1,$dirsepurl,1) == -1);
			    $tmp2++ while $tmp1 =~ s/$dirsepurl//;
			    $tmp2-- if ($squid_format == 1);
			    print PAGESITE "<TD CLASS=\"right\">&nbsp;$tmp2&nbsp;</TD>\n";
			    print PAGESITE "<TD CLASS=\"right\">&nbsp;$tmp3&nbsp;</TD>\n";
			}
			$tmp = $pagesite{$site,$i};
			$tmp1 = index($tmp,$dirsep,1);
			$tmp = substr($tmp,$tmp1,length($tmp)) if ($squid_format == 1);
			print PAGESITE "<TD CLASS=\"left\"";
#			print PAGESITE " TITLE=\"$pagesite{$site,$i}\"" if ($titlename == 1 && $urlconv{$tmp} ne '');
			print PAGESITE ">&nbsp;";
			$tmp = $pagesite{$site,$i};
			$tmp =~ s/$tmp3/$dirsepurl/;
			$link = &AddHREF($pagesite{$site,$i}) if ($squid_format == 0);
			$link = &AddHREF($tmp) if ($squid_format == 1);
			$link = &EncryptLink($link) if ($crypt == 1);
			print PAGESITE "$link";
			print PAGESITE "&nbsp;</TD>\n";
			print PAGESITE "<TD CLASS=\"right\">$pagesite_occur{$site,$pagesite{$site,$i}}</TD>\n";
			$percentage = (100*$pagesite_occur{$site,$pagesite{$site,$i}})/$nbpageserveur{$site};
			$tmp2 = int($percentage);
			print PAGESITE "<TD CLASS=\"left\">";
			print PAGESITE "<img width=$tmp2 height=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($tmp2 != 0);
			printf PAGESITE "%.1f %",$percentage;
			print PAGESITE "</TD>\n";
			($tmp) = &get_time(86400*$pagesite_date{$site,$pagesite{$site,$i}});
			$tmp =~ s/\// /g;
#			print PAGESITE "<TD CLASS=\"right\">$pagesite_date{$site,$pagesite{$site,$i}}</TD>\n";

			if ($spam_found != 0 && $spamonly != 1) {
			    print PAGESITE "<TD CLASS=\"right\">";
			    print PAGESITE "$spam_page{$pagesite{$site,$i}}</TD>\n";
			    print PAGESITE "<TD CLASS=\"left\">";
			    $percentage = ($spam_page{$pagesite{$site,$i}}*100)/$pagesite_occur{$site,$pagesite{$site,$i}} if ($pagesite_occur{$site,$pagesite{$site,$i}} != 0);
			    $tmp2 = int($percentage);
			    print PAGESITE "<img width=$tmp2 height=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">&nbsp;" if ($tmp2 != 0);

			    printf PAGESITE "%3.1f %",$percentage;
			    print PAGESITE "</TD>\n";
			}
			print PAGESITE "<TD CLASS=\"right\">$tmp";
			print PAGESITE " $pagesite_datehour{$site,$pagesite{$site,$i}}" if ($mail_format == 1);
			print PAGESITE "</TD>\n";

			print PAGESITE "<TD CLASS=\"right\">$pageslues_rank{$pagesite{$site,$i}}</TD>\n" if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0);
			print PAGESITE "</TR>\n";
#		    }
		}
		print PAGESITE "</tbody>\n";
		print PAGESITE "</TABLE>\n";
	    } else {
		print PAGESITE "$L{'No_request'}<P>\n";
	    }
#	    print PAGESITE "<P><HR><P>\n";
	    close PAGESITE;
	}
    }

# serveur locaux

    if ($locallog != 0) {
        foreach $site (sort (keys(%localserver))) {
#	    if ($localserver{$site} > $seuilsite) {
#	    if ($nbpageserveur{$site} > $seuilsite) {
	    if ($nbpageserveur{$site} > 0) {
		$newsite = $site;
		$newsite =~ s/[.:]/_/g;
#		$newsite .= $htmlext;
#                $pospoint = index($newsite,'_',0);
                $pospoint = index($site,'.',0);
                $domadresse = substr($newsite,$pospoint+1,(length($newsite)-length($pospoint)));
		$domadresse = $newsite if ($domadresse !~ /_/);
                
                # si le fichier existe deja, on ajoute l'adresse dans le fichier de domaine

#		print "LL $site - $domadresse\n";

		if ($site =~ /[0-9]+$/ || $site =~ /:/) {
		    $file_to_open = "$path$I$dirsep$dirsite$dirsep$newsite$htmlext";

#		    print "A2 $dirsite$dirsep$newsite$htmlext\n";
		    open(PAGESITE,">$file_to_open") || die "Error, unable to open $file_to_open\n";
		    print PAGESITE "$doctype\n";
		    print PAGESITE "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
		    print PAGESITE "$charset\n";
		    print PAGESITE "<TITLE>$L{'Pages'} - $site</TITLE>\n";
		    print PAGESITE "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
		    print PAGESITE "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
		    print PAGESITE "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
		    print PAGESITE "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
		    print PAGESITE "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
		    print PAGESITE "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
		    print PAGESITE "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
		    print PAGESITE "$curvy_bottom_jss\n";

		    &add_css_style(*PAGESITE,2);

		    print PAGESITE "</HEAD>\n";
		    print PAGESITE "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
		    &add_css_menu(*PAGESITE,*L,$lang[$nblang],$nblang,2);
		} else {                

		    $file_to_open = "$path$I$dirsep$dirsite$dirsep$domadresse$htmlext" if ($split_localhost == 0);
		    $file_to_open = "$path$I$dirsep$dirsite$dirsep$newsite$htmlext" if ($split_localhost == 1);
#		    print "A3 $dirsite$dirsep$domadresse$htmlext\n" if ($split_localhost == 0);
#		    print "A3 $dirsite$dirsep$newsite$htmlext\n" if ($split_localhost == 1);

#		    if ($split_localhost == 1) {
#			open(PAGESITE,">$file_to_open") || die "Error, unable to open $file_to_open\n";
#		    } else {
			if ($file_domain{$domadresse} == 1 && $split_localhost == 0) {
			    open(PAGESITE,">>$file_to_open") || die "Error, unable to open $file_to_open\n";
			} else {
			    $file_domain{$domadresse} = 1 if ($split_localhost == 0);
			    open(PAGESITE,">$file_to_open") || die "Error, unable to open $file_to_open\n";
			    print PAGESITE "$doctype\n";
			    print PAGESITE "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
			    print PAGESITE "$charset\n";
			    print PAGESITE "<TITLE>$L{'Pages'} - $L{'domaine'} $domadresse</TITLE>\n";
			    print PAGESITE "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
			    print PAGESITE "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
			    print PAGESITE "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
			    print PAGESITE "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
			    print PAGESITE "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
			    print PAGESITE "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
			    print PAGESITE "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
			    print PAGESITE "$curvy_bottom_jss\n";
			    
			    &add_css_style(*PAGESITE,2);
			    
			    print PAGESITE "</HEAD>\n";
			    print PAGESITE "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
			&add_css_menu(*PAGESITE,*L,$lang[$nblang],$nblang,2);
			}
		    }
#		}

		print PAGESITE "<A NAME=\"$site\"></A>\n";
		print PAGESITE "<H2>";
		print PAGESITE "$L{'Pages'}" if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
		print PAGESITE "$L{'Files'}" if ($ftp_format == 1 || $cups_format == 1);
		print PAGESITE "$L{'Emails'}" if ($mail_format == 1);
		print PAGESITE " - $site";
		print PAGESITE " - $nbpageserveur{$site} $L{'accesses'}" if ($cups_format == 0);
		print PAGESITE " - $resolv_user{$site}" if ($resolv_user{$site} ne '');
		print PAGESITE "</H2>";

		$maxpage = $nbpageserveurunique{$site};
		$maxpage = $max_item_page if ($nbpageserveurunique{$site} > $max_item_page);

#		if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
		if ($ftp_format == 0) {
		    print PAGESITE "<I>$maxpage ";
		    if ($cups_format == 0 && $ftp_format == 0) {
			print PAGESITE "$L{'pages'} " if ($nbpageserveur{$site} != 1);
			print PAGESITE "$L{'page'} " if ($nbpageserveur{$site} == 1);
		    } else {
			print PAGESITE "$L{'files'} "; # if ($nbpageserveur{$site} == 1);
		    }
		    print PAGESITE "$L{'among'} $nbpageserveurunique{$site}" if ($nbpageserveurunique{$site} != $maxpage);
		    if ($mail_format == 0) {
			print PAGESITE " - $localserver{$site} ";
			print PAGESITE "$L{'request'}" if ($localserver{$site} == 1);
			print PAGESITE "$L{'requests'}" if ($localserver{$site} != 1);
		    }
#		    print PAGESITE " - $nbpageserveurunique{$site} $L{'hosts'}";
		    print PAGESITE "</I>\n";
		}
		print PAGESITE "<P>\n";

#		if ($nbpageserveurunique{$site} != 0) {
		if ($maxpage != 0) {

#		    $tmp = int($nbpageserveurunique{$site}/$table_big_lines_aff);
		    $tmp = int($maxpage/$table_big_lines_aff);
#		    if ($tmp != ($nbpageserveurunique{$site}/$table_big_lines_aff)) {
		    if ($tmp != ($maxpage/$table_big_lines_aff)) {
			$tmp++;
		    }

		    if ($tmp > 1) {
			print PAGESITE "\n<table class=\"tablesort table-autosort table-autostripe table-autopage:$table_big_lines_aff table-stripeclass:alternate\" id=\"page\">\n";
		    } else {
			print PAGESITE "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
		    }

		    print PAGESITE "<thead>\n";
		    print PAGESITE "<TR>\n";
		    if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
			print PAGESITE "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Level'}&nbsp;</TH>\n";
			print PAGESITE "<TH class=\"table-sortable:default\">&nbsp;$L{'Directories'}&nbsp;</TH>\n" if ($squid_format == 0);
			print PAGESITE "<TH class=\"table-sortable:default\">&nbsp;$L{'Destination'}&nbsp;</TH>\n" if ($squid_format == 1);
		    }

		    print PAGESITE "<TH class=\"table-sortable:default\">&nbsp;$L{'Pages'}&nbsp;</TH>\n" if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
		    print PAGESITE "<TH class=\"table-sortable:default\">&nbsp;$L{'Files'}&nbsp;</TH>\n" if ($ftp_format == 1 || $cups_format == 1);
		    print PAGESITE "<TH class=\"table-sortable:default\">&nbsp;$L{'Emails'}&nbsp;</TH>\n" if ($mail_format == 1);
		    print PAGESITE "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
		    print PAGESITE "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
		    if ($spam_found != 0 && $spamonly != 1) {
			print PAGESITE "<TH class=\"table-sortable:numeric\">$L{'Spam'}</TH>\n";
			print PAGESITE "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n";
		    }
		    print PAGESITE "<TH class=\"table-sortable:date\">&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n";
		    print PAGESITE "<TH class=\"table-sortable:numeric\">&nbsp;$L{'General_ranking'}&nbsp;</TH>\n" if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0);
		    print PAGESITE "</TR>\n";
		    print PAGESITE "</thead>\n";

		    if ($tmp > 1) {
		    print PAGESITE "<tfoot>\n";
		    print PAGESITE "<TR>\n";
		    if ($mail_format == 0 && $cups_format == 0) {
			print PAGESITE "<TH>&nbsp;$L{'Level'}&nbsp;</TH>\n";
			print PAGESITE "<TH>&nbsp;$L{'Directories'}&nbsp;</TH>\n" if ($squid_format == 0);
			print PAGESITE "<TH>&nbsp;$L{'Destination'}&nbsp;</TH>\n" if ($squid_format == 1);
		    }
		    print PAGESITE "<TH>&nbsp;$L{'Page'}&nbsp;</TH>\n" if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
		    print PAGESITE "<TH>&nbsp;$L{'Files'}&nbsp;</TH>\n" if ($ftp_format == 1 || $cups_format == 1);
		    print PAGESITE "<TH>&nbsp;$L{'Emails'}&nbsp;</TH>\n" if ($mail_format == 1);
		    print PAGESITE "<TH>&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
		    print PAGESITE "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
		    if ($spam_found != 0 && $spamonly != 1) {
			print PAGESITE "<TH>$L{'Spam'}</TH>\n";
			print PAGESITE "<TH>$L{'Percentage'}</TH>\n";
		    }
		    print PAGESITE "<TH>&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n";
		    print PAGESITE "<TH>&nbsp;$L{'General_ranking'}&nbsp;</TH>\n" if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0);
		    print PAGESITE "</TR>\n";
		    
		    print PAGESITE "<tr>\n";
		    $tmp2 = 4;
		    $tmp2 += 2 if ($spam_found != 0 && $spamonly != 1);
		    $tmp2 += 2 if ($mail_format == 0 && $cups_format == 0 && $cups_format == 0);
		    $tmp2++ if ($mail_format == 0 && $spamonly != 1);
		    print PAGESITE "<td colspan=$tmp2>\n";
		    print PAGESITE "<a href=\"#\" onclick=\"pageexample('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
		    
		    for ($i=1;$i<=$tmp;$i++) {
			$iminus = $i-1;
			print PAGESITE "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexample($iminus); return false;\">$i</a>\n";
		    }
		    print PAGESITE "<a href=\"#\" onclick=\"pageexample('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
		    print PAGESITE "<a href=\"#\" onclick=\"pageexample('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
		    print PAGESITE "</td>\n";
		    print PAGESITE "</tr>\n";

		    print PAGESITE "</tfoot>\n";
		    }
		    
		    print PAGESITE "<tbody>\n";
		    
#		    for ($i=0;$i<($nbpageserveur{$site});$i++) {
#		    for ($i=1;$i<=$nbpageserveurunique{$site};$i++) {

		    for ($i=1;$i<=$maxpage;$i++) {
#			if (!($seen{"$I $site $pagesite{$site,$i}"}++)) {

			    print PAGESITE "<TR>";
			    if ($mail_format == 0 && $dhcp_format == 0 && $cups_format == 0) {
				$tmp2 = 0;
				$tmp1 = $pagesite{$site,$i};
				$tmp3 = substr($tmp1,0,index($tmp1,$dirsepurl,1)+1) if (index($tmp1,$dirsepurl,1) != -1);
				$tmp3 = $dirsepurl if (index($tmp1,$dirsepurl,1) == -1);
				$tmp2++ while $tmp1 =~ s/$dirsepurl//;
				$tmp2-- if ($squid_format == 1);
				print PAGESITE "<TD CLASS=\"right\">&nbsp;$tmp2&nbsp;</TD>\n";
				print PAGESITE "<TD CLASS=\"right\">&nbsp;$tmp3&nbsp;</TD>\n";
			    }
			    print PAGESITE "<TD CLASS=\"left\"";
			    print PAGESITE " TITLE=\"$pagesite{$site,$i}\"" if ($titlename == 1 && $urlconv{$tmp} ne '');
			    print PAGESITE ">&nbsp;";
			    $tmp = $pagesite{$site,$i};
			    $tmp =~ s/$tmp3/$dirsepurl/;
			    $link = &AddHREF($pagesite{$site,$i}) if ($squid_format == 0);
			    $link = &AddHREF($tmp) if ($squid_format == 1);
			    $link = &EncryptLink($link) if ($crypt == 1);
			    print PAGESITE "$link";
			    print PAGESITE "&nbsp;</TD>\n";
			    print PAGESITE "<TD CLASS=\"right\">$pagesite_occur{$site,$pagesite{$site,$i}}</TD>\n";
			    $percentage = (100*$pagesite_occur{$site,$pagesite{$site,$i}})/$nbpageserveur{$site};
			    $tmp2 = int($percentage);
			    print PAGESITE "<TD CLASS=\"left\">";
			    print PAGESITE "<img width=$tmp2 height=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($tmp2 != 0);
			    printf PAGESITE "%.1f %",$percentage;
			    print PAGESITE "</TD>\n";
			    ($tmp) = &get_time(86400*$pagesite_date{$site,$pagesite{$site,$i}});
			    $tmp =~ s/\// /g;
#			    print PAGESITE "<TD CLASS=\"right\">$pagesite_date{$site,$pagesite{$site,$i}}</TD>\n";

			if ($spam_found != 0 && $spamonly != 1) {
			    print PAGESITE "<TD CLASS=\"right\">";
			    print PAGESITE "$spam_page{$pagesite{$site,$i}}</TD>\n";
			    print PAGESITE "<TD CLASS=\"left\">";
			    $percentage = ($spam_page{$pagesite{$site,$i}}*100)/$pagesite_occur{$site,$pagesite{$site,$i}} if ($pagesite_occur{$site,$pagesite{$site,$i}} != 0);
			    $tmp2 = int($percentage);
			    print PAGESITE "<img width=$tmp2 height=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">&nbsp;" if ($tmp2 != 0);
			    printf PAGESITE "%3.1f %",$percentage;
			    print PAGESITE "</TD>\n";
			}

			    print PAGESITE "<TD CLASS=\"right\">$tmp";
			    print PAGESITE " $pagesite_datehour{$site,$pagesite{$site,$i}}" if ($mail_format == 1);
			    print PAGESITE "</TD>\n";
			    print PAGESITE "<TD CLASS=\"right\">$pageslues_rank{$pagesite{$site,$i}}</TD>\n" if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0);
			    print PAGESITE "</TR>\n";
#			}
		    }
		    print PAGESITE "</tbody>\n";
		    print PAGESITE "</TABLE>\n";
		} else {
		    print PAGESITE "$L{'No_request'}<P>\n";
		}
#		print PAGESITE "<P><HR><P>\n";
		close PAGESITE;
	    }
	}
    }

### enfin ajout du </BODY></HTML> sur tous les fichiers

# sites externes

    foreach $site (keys(%server)) {
#        if ($server{$site} > $seuilsite) {
	    if ($nbpageserveur{$site} > 0) {
	    $newsite = $site;
	    $newsite =~ s/[.:]/_/g;
#	    $newsite .= $htmlext;

	    if ($site =~ /[0-9]+$/ || $site =~ /:/) {
		open(PAGESITE,">>$path$I$dirsep$dirsite$dirsep$newsite$htmlext") || die "Error, unable to open $path$I$dirsep$dirsite$dirsep$newsite$htmlext\n";
		print PAGESITE "</BODY></HTML>\n";
		close PAGESITE;
	    }
	    else {
#		$pospoint = index($newsite,'_',0);
		$pospoint = index($site,'.',0);
		$domadresse = substr($newsite,$pospoint+1,(length($newsite)-length($pospoint)));
		$domadresse = $newsite if ($domadresse !~ /_/);
		open(PAGESITE,">>$path$I$dirsep$dirsite$dirsep$domadresse$htmlext") || die "Error, unable to open $path$I$dirsep$dirsite$dirsep$domadresse$htmlext\n";
		print PAGESITE "</BODY></HTML>\n" unless $seen{$domadresse}++;
		close PAGESITE;
	    }
	}
    }
    
# sites locaux

    if ($locallog != 0) {
        foreach $site (keys(%localserver)) {
	    if ($nbpageserveur{$site} > 0) {
#	    if ($nbpageserveur{$site} > $seuilpage) {
#	    if ($server{$site} > $seuilsite) {
		$newsite = $site;
		$newsite =~ s/[.:]/_/g;
#		$newsite .= $htmlext;
		if ($site =~ /[0-9]+$/ || $site =~ /:/) {
		    open(PAGESITE,">>$path$I$dirsep$dirsite$dirsep$newsite$htmlext") || die "Error, unable to open $path$I$dirsep$dirsite$dirsep$newsite$htmlext\n";
		    print PAGESITE "</BODY></HTML>\n";
		    close PAGESITE;
		}
		else {
#		    $pospoint = index($newsite,'_',0);
		    $pospoint = index($site,'.',0);
		    $domadresse = substr($newsite,$pospoint+1,(length($newsite)-length($pospoint)));
		    $domadresse = $newsite if ($domadresse !~ /_/);
		    open(PAGESITE,">>$path$I$dirsep$dirsite$dirsep$domadresse$htmlext") || die "Error, unable to open $path$I$dirsep$dirsite$dirsep$domadresse$htmlext\n";
		    print PAGESITE "</BODY></HTML>\n"; # unless $seen{$domadresse}++;
		    close PAGESITE;
		}
	    }
	}
    }
}


#
##############################################################
### Page Selection
##############################################################
#

sub PageSelection {
  local(*FOUT,*L,$I,$pageselect) = @_;
  local($k,@tabreq);

  print FOUT "$doctype\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Hosts'} $L{'connecting_to'} $L{'page'} $selection[$i] </TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_jqplot_js(*FOUT,2);
  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";

  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);

  print FOUT "<H2>$L{'Hosts'} $L{'connecting_to'} $L{'page'} $pageselect</H2>\n";
  print FOUT "<P><HR><P>\n";
  print FOUT "<CENTER>\n";

#  if ($#list != -1) {
  if ($count_selection{$pageselect} > 0) {
      if ($fly_set == 0) {
	  $chart_id = 0;
	  $info = "info".$chartd_id;

#	  $tmp = $lastday_nb-$firstday_nb;
#	  print "AA $tmp\n";
#	  $add = 0;
#	  $add = ($tmp - $nbdayscf) if ($tmp > $nbdayscf);
#	  $add = $add + $ydaystarttoday +1 - $lastday_nb +1 if ($tmp > $nbdayscf);
#	  $tmp = $nbdayscf if ($add != 0);
#	  print "BB $tmp\n";
	  $tmp = $yday-$ydayfirst;
#	  print "CC $tmp\n";
	  undef(@listdate);
	  undef(@tabreq);

	  $xlegend = "$tmp $L{'days'}";
	  $xlegend .= " (starting $start_date)";
	  $ylegend = $L{'Hosts'};

	  for ($k=0;$k<=$tmp;$k++) {
#	      $k2 = $k + $add;
	      push(@tabreq,$pagesel{$pageselect,$k});
	      $tmp2 = &date_intervalle($firstday,$k);
#	      $tmp = &date_intervalle($firstday,$k) if ($add == 0);
#	      $tmp = &date_intervalle($pasttoday,$k) if ($add != 0);
	      push(@listdate,$tmp2);
	  }


	undef @ref_tab;
	push(@ref_tab,\@tabreq);
	
	@ref_tab_name = ('occurence');
	
	&MakeDailyGraphJqplotInit(*FOUT, eval($Lang{$lang[$nblang]}),$I,1,$unit_div,\@ref_tab,\@ref_tab_name,\@listdate,$chart_id);

	@graph_to_display = ('Occurence');

	undef @ref_tab;
	push(@ref_tab,\@tabreq);
	
	&MakeDailyGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,1,\@graph_to_display,\@ref_tab,\@listdate,\@serie_color,1,$unit,$chart_id,3,"occurence",$info,0,$xlegend,$ylegend,$xmax_jqplot,$dirsite);

	&AddJqplotHtml(*FOUT, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_jqplot,$ymax_jqplot,2);

	$chart_id += $#list_graph_name_jqplot+1;
      }
      if ($fly_set == 1) {
	  print FOUT "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
	  print FOUT "<TR>\n";
	  print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linkgraphpagey\" ALT=\"y\"></TD>\n";
	  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"$linkgraphpage\" ALT=\"graph\"></TD>\n";
	  print FOUT "</TR><TR><TD></TD>\n";
	  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linkgraphpagex\" ALT=\"x\"></TD>\n";
	  print FOUT "</TR>\n";
	  print FOUT "</TABLE><P>\n";
      }
      print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
      print FOUT "<thead>\n";
      print FOUT "<TR>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:date\">&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n";
      print FOUT "</TR>\n";
      print FOUT "</thead>\n";
      print FOUT "<tbody>\n";

      for ($k=1;$k<=$count_selection{$pageselect};$k++) {
	  $adresse = $selecadresse{$page,$k};
	  ($tmp1,$tmp2,$tmp3,$tmp4) = split(/:/,$seleclastdate{$pageselect,$adresse});
	  print FOUT "<TR>\n";
	  print FOUT "<TD CLASS=\"left\">$adresse</TD>\n";
	  print FOUT "<TD CLASS=\"right\">$selecfound{$page,$adresse}</TD>\n";
	  print FOUT "<TD CLASS=\"right\"><I>$tmp1&nbsp;&nbsp;$tmp2:$tmp3:$tmp4</I></TD>\n";
	  print FOUT "</TR>\n";
      }

#      for ($k=$#list;$k>=0;$k--) {
#	  ($tmp1,$tmp2,$tmp3,$tmp4) = split(/:/,$version[$k]);
#	      print FOUT "<TR>\n";
#	      print FOUT "<TD CLASS=\"left\">$list[$k]</TD>\n";
#	      print FOUT "<TD CLASS=\"right\">$selecfound{$page,$list[$k]}</TD>\n";
#	      print FOUT "<TD CLASS=\"right\"><I>$tmp1&nbsp;&nbsp;$tmp2:$tmp3:$tmp4</I></TD>\n";
#	      print FOUT "</TR>\n";
 #     }
      print FOUT "</tbody>\n";
      print FOUT "</TABLE></CENTER>\n";
  } else {
      print FOUT "$L{'No_request'}<P>\n";
   }

  print FOUT "<P>\n";
  print FOUT "</BODY></HTML>\n";
}

#
##############################################################
### ZonePays
##############################################################
#

sub ZonePays {
  local(*FOUT,*L,$I,$zone) = @_;
  local($i,$j,$idx);

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Stats'} - $L{'countries'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";
  &add_jqplot_js(*FOUT,2);
  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";

  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);

  print FOUT "<H2>$L{$zone[$zone]}</H2><P>\n";
  print FOUT "<P><HR><P>\n";

  *tmplist = *payslist if ($geoipcity == 0);
  *tmplist = *payslistcity if ($geoipcity == 1);


  if ($geoipcity == 1) {

      &help_div(*FOUT);

      print FOUT "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
      print FOUT "<TR><TD STYLE=\"vertical-align:middle;text-align:center;\">\n";
      print FOUT "<DIV STYLE=\"position:relative;\">\n";

      print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirpays$dirsepurl$zone[$zone]$pngext\" WIDTH=\"$zone_x[$zone]\" HEIGHT=\"$zone_y[$zone]\" ALT=\"$L{$zone[$zone]}\">\n";

      $tmp1 = int(-$zone_x[$zone]/2);
      $tmp2 = int(-$zone_y[$zone]/2);

      print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirgraph$dirsepurl$zone[$zone]$pngext\" STYLE='z-index:10;position:absolute;left:50%;top:50%; margin-left:";
      print FOUT "$tmp1";
      print FOUT "px;margin-top:";
      print FOUT "$tmp2";
      print FOUT "px;' ALT=\"$L{$zone[$zone]}\" WIDTH=\"$zone_x[$zone]\" HEIGHT=\"$zone_y[$zone]\" BORDER=0 USEMAP=\"#$zone[$zone]\">\n";
      print FOUT "</DIV>\n";
      print FOUT "</TD>\n";
      print FOUT "<TD>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>\n";
      print FOUT "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";


  #
  ### Pie chart
  #

      if ($geoipcity == 0) {
	  ($line_cloud,$line_cloud_sort) = &MakeCloud(\%payslist,'',4);
      } else {
	  ($line_cloud,$line_cloud_sort) = &MakeCloud(\%payslistcity,'',4);
      }

      print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
      print FOUT "<TR><TD VALIGN=TOP>\n";
  
      $tmp = $zoneserver[$zone] if ($geoipcity == 0);
      $tmp = $zoneservercity[$zone] if ($geoipcity == 1);

      if ($tmp > 1) {

	  if ($fly_set == 0) {
	      $chart_id = 0;
	      $info = "info".$chart_id;
	      $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%serverpays,\@serie_color,$tmp,4,1,$unit,$chart_id,0,$info,"","","$dirpays$dirsepurl$filepays") if ($geoipcity == 0);
	      $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%serverpayscity,\@serie_color,$tmp,4,1,$unit,$chart_id,0,$info,"","","$dirpays$dirsepurl$filepays") if ($geoipcity == 1);
	  }

	  if ($fly_set == 1) {
	      $pays_pie = "pays_pie1_".$zone.$gifext;
	      ($line_pie,$map_pays_pie) = &MakePieChart($pays_pie,$tmp,\%serverpays,4,0,'',$rayon) if ($geoipcity == 0);
	      ($line_pie,$map_pays_pie) = &MakePieChart($pays_pie,$tmp,\%serverpayscity,4,0,'',$rayon) if ($geoipcity == 1);
	  }

	  print FOUT "<DIV ID=\"tog_hosts\" STYLE=\"display:inline\">";
	  print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
	  print FOUT "<TR><TD ALIGN=CENTER VALIGN=MIDDLE>";
	  print FOUT "<TABLE BORDER=0>";
	  print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Countries'}</TH></TR>";
	  print FOUT "$line_pie";
	  print FOUT "</TABLE>\n";
	  print FOUT "</TD>\n";
  
	  print FOUT "<TD ALIGN=CENTER>";
	  print FOUT "<IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$pays_pie\" USEMAP=\"#map_pays_graph\" BORDER=0 ALT=\"graph\">\n" if ($fly_set == 1);

	  if ($fly_set == 0) {
	      print FOUT "<div id=\"";
	      print FOUT "chart".$chart_id;
	      print FOUT "\" ";
	      print FOUT "style=\"";
	      print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
	      print FOUT "</div>\n";
	      $chart_id++;
	  }	     

	  print FOUT "<P><I>$L{'Hosts'} - ";
	  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	      print FOUT "<A HREF=\"javascript:ToggleAlpha('tog_req','tog_traffic','tog_hosts','tog_acc');\">" if ($fly_set == 1);
	      print FOUT "<A HREF=\"javascript:ToggleJqplotGraph4(plot1,'tog_req','tog_traffic','tog_hosts','tog_acc');\">" if ($fly_set == 0);
	  } else {
	      print FOUT "<A HREF=\"javascript:ToggleDelta('tog_req','tog_traffic','tog_hosts');\">" if ($fly_set == 1);
	      print FOUT "<A HREF=\"javascript:ToggleJqplotGraph3(plot1,'tog_req','tog_traffic','tog_hosts');\">" if ($fly_set == 0);
	  }
	  print FOUT "$L{'Requests'}</A> ";
	  if ($fly_set == 1) {
	      print FOUT "- <A HREF=\"javascript:ToggleAlpha('tog_acc','tog_req','tog_hosts','tog_hosts');\">$L{'Accesses'}</A> " if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
	  }
	  if ($fly_set == 0) {
	      print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph4(plot2,'tog_acc','tog_req','tog_hosts','tog_hosts');\">$L{'Accesses'}</A> " if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
	  }
	  if ($notrafic == 0) {
	      if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
		  print FOUT "- <A HREF=\"javascript:ToggleAlpha('tog_traffic','tog_hosts','tog_req','tog_acc');\">" if ($fly_set == 1);
		  print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph4(plot3,'tog_traffic','tog_hosts','tog_req','tog_acc');\">" if ($fly_set == 0);
	      } else {
		  print FOUT "- <A HREF=\"javascript:ToggleDelta('tog_traffic','tog_hosts','tog_req');\">" if ($fly_set == 1);
		  print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph3(plot2,'tog_traffic','tog_hosts','tog_req');\">" if ($fly_set == 0);
	      }
	      print FOUT "$L{'Traffic'}</A>";
	  }
	  print FOUT "</I></TD></TR></TABLE>\n";

	  if ($fly_set == 1) {
	      print FOUT "<MAP NAME=\"map_pays_graph\">\n";
	      $tmp = $map_pays_pie;
	      $tmp =~ s/<!-- langhome -->/$I/g;
	      print FOUT "$tmp";
#	  print FOUT "$map_pays_pie\n";
	      print FOUT "</MAP>\n";
	  }

	  if ($fly_set == 0) {
	      if ($xmax_jqplot != $xmax_home_jqplot) {
		  print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
	      }
	      print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
	  }
	  print FOUT "</DIV>";
      }


      $tmp = $zonehits[$zone] if ($geoipcity == 0);
      $tmp = $zonehitscity[$zone] if ($geoipcity == 1);

      if ($tmp > 1) {

	  if ($fly_set == 0) {
	      $info = "info".$chart_id;
	      $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%payslist,\@serie_color,$tmp,4,1,$unit,$chart_id,0,$info,"","","$dirpays$dirsepurl$filepays") if ($geoipcity == 0);
	      $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%payslistcity,\@serie_color,$tmp,4,1,$unit,$chart_id,0,$info,"","","$dirpays$dirsepurl$filepays") if ($geoipcity == 1);
	  }

	  if ($fly_set == 1) {
	      $pays_pie = "pays_pie2_".$zone.$gifext;
	      ($line_pie,$map_pays_pie) = &MakePieChart($pays_pie,$tmp,\%payslist,4,0,'',$rayon) if ($geoipcity == 0);
	      ($line_pie,$map_pays_pie) = &MakePieChart($pays_pie,$tmp,\%payslistcity,4,0,'',$rayon) if ($geoipcity == 1);
	  }

	  print FOUT "<DIV ID=\"tog_req\" STYLE=\"display:none\">";
	  print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
	  print FOUT "<TR><TD ALIGN=CENTER VALIGN=MIDDLE>";
	  print FOUT "<TABLE BORDER=0>";
	  print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Countries'}</TH></TR>";
	  print FOUT "$line_pie";
	  print FOUT "</TABLE>\n";
	  print FOUT "</TD>\n";
	  
	  print FOUT "<TD ALIGN=CENTER>";
	  print FOUT "<IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$pays_pie\" USEMAP=\"#map_pays2_graph\" BORDER=0 ALT=\"graph\">\n" if ($fly_set == 1);
	  if ($fly_set == 0) {
	      print FOUT "<div id=\"";
	      print FOUT "chart".$chart_id;
	      print FOUT "\" ";
	      print FOUT "style=\"";
	      print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
	      print FOUT "</div>\n";
	      $chart_id++;
}	     
	  print FOUT "<P><I>";
	  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	      print FOUT "<A HREF=\"javascript:ToggleAlpha('tog_hosts','tog_req','tog_acc','tog_traffic');\">" if ($fly_set == 1);
	      print FOUT "<A HREF=\"javascript:ToggleJqplotGraph4(plot0,'tog_hosts','tog_req','tog_acc','tog_traffic');\">" if ($fly_set == 0);
	  } else {
	      print FOUT "<A HREF=\"javascript:ToggleDelta('tog_hosts','tog_req','tog_traffic');\">" if ($fly_set == 1);
	      print FOUT "<A HREF=\"javascript:ToggleJqplotGraph3(plot0,'tog_hosts','tog_req','tog_traffic');\">" if ($fly_set == 0);
	  }
	  print FOUT "$L{'Hosts'}</A> - $L{'Requests'} ";
	  if ($fly_set == 1) {
	      print FOUT "- <A HREF=\"javascript:ToggleAlpha('tog_acc','tog_req','tog_traffic','tog_hosts');\">$L{'Accesses'}</A> " if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
	  }
	  if ($fly_set == 0) {
	      print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph4(plot2,'tog_acc','tog_req','tog_traffic','tog_hosts');\">$L{'Accesses'}</A> " if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
	  }
	  if ($notrafic == 0) {
	      if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
		  print FOUT "- <A HREF=\"javascript:ToggleAlpha('tog_traffic','tog_hosts','tog_req','tog_acc');\">" if ($fly_set == 1);
		  print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph4(plot3,'tog_traffic','tog_hosts','tog_req','tog_acc');\">" if ($fly_set == 0);
	      } else {
		  print FOUT "- <A HREF=\"javascript:ToggleDelta('tog_traffic','tog_hosts','tog_req');\">" if ($fly_set == 1);
		  print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph3(plot2,'tog_traffic','tog_hosts','tog_req');\">" if ($fly_set == 0);
	      }
	      print FOUT "$L{'Traffic'}</A>";
	  }
	  print FOUT "</I></TD></TR></TABLE>\n";

	  if ($fly_set == 1) {
	      print FOUT "<MAP NAME=\"map_pays2_graph\">\n";
	      $tmp = $map_pays_pie;
	      $tmp =~ s/<!-- langhome -->/$I/g;
	      print FOUT "$tmp";
	      print FOUT "</MAP>\n";
	  }
	  if ($fly_set == 0) {
	      if ($xmax_jqplot != $xmax_home_jqplot) {
		  print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
	      }
	      print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
	  }
	  print FOUT "</DIV>";   
      }


      $tmp = $zonehtml[$zone] if ($geoipcity == 0);
      $tmp = $zonehtmlcity[$zone] if ($geoipcity == 1);

      if ($tmp > 1 && ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0)) {
	  if ($fly_set == 0) {
	      $info = "info".$chart_id;
	      $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%payshtml,\@serie_color,$tmp,4,1,$unit,$chart_id,0,$info,"","","$dirpays$dirsepurl$filepays") if ($geoipcity == 0);
	      $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%payshtmlcity,\@serie_color,$tmp,4,1,$unit,$chart_id,0,$info,"","","$dirpays$dirsepurl$filepays") if ($geoipcity == 1);
	  }

	  if ($fly_set == 1) {
	      $pays_pie = "pays_pie3_".$zone.$gifext;
	      ($line_pie,$map_pays_pie) = &MakePieChart($pays_pie,$tmp,\%payshtml,4,0,'',$rayon) if ($geoipcity == 0);
	      ($line_pie,$map_pays_pie) = &MakePieChart($pays_pie,$tmp,\%payshtmlcity,4,0,'',$rayon) if ($geoipcity == 1);
	  }

	  print FOUT "<DIV ID=\"tog_acc\" STYLE=\"display:none\">";
	  print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
	  print FOUT "<TR><TD ALIGN=CENTER VALIGN=MIDDLE>";
	  print FOUT "<TABLE BORDER=0>";
	  print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Countries'}</TH></TR>";
	  print FOUT "$line_pie";
	  print FOUT "</TABLE>\n";
	  print FOUT "</TD>\n";
	  
	  print FOUT "<TD ALIGN=CENTER>";
	  print FOUT "<BR><IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$pays_pie\" USEMAP=\"#map_pays3_graph\" BORDER=0 ALT=\"graph\">\n" if ($fly_set == 1);
	  if ($fly_set == 0) {
	      print FOUT "<div id=\"";
	      print FOUT "chart".$chart_id;
	      print FOUT "\" ";
	      print FOUT "style=\"";
	      print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
	      print FOUT "</div>\n";
	      $chart_id++;
	  }	     
	  print FOUT "<P><I><A HREF=\"javascript:ToggleAlpha('tog_hosts','tog_req','tog_acc','tog_traffic');\">$L{'Hosts'}</A> - <A HREF=\"javascript:ToggleAlpha('tog_req','tog_acc','tog_hosts','tog_hosts');\">$L{'Requests'}</A> - $L{'Accesses'} " if ($fly_set == 1);
	  print FOUT "<P><I><A HREF=\"javascript:ToggleJqplotGraph4(plot0,'tog_hosts','tog_req','tog_acc','tog_traffic');\">$L{'Hosts'}</A> - <A HREF=\"javascript:ToggleJqplotGraph4('plot1','tog_req','tog_acc','tog_hosts','tog_hosts');\">$L{'Requests'}</A> - $L{'Accesses'} " if ($fly_set == 0);
	  if ($notrafic == 0) {
	      print FOUT "- <A HREF=\"javascript:ToggleAlpha('tog_traffic','tog_hosts','tog_req','tog_acc');\">$L{'Traffic'}</A>" if ($fly_set == 1);
	      print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph4(plot3,'tog_traffic','tog_hosts','tog_req','tog_acc');\">$L{'Traffic'}</A>" if ($fly_set == 0);
	  }
	  print FOUT "</I></TD></TR></TABLE>\n";

	  if ($fly_set == 1) {
	      print FOUT "<MAP NAME=\"map_pays3_graph\">\n";
	      print FOUT "$map_pays_pie\n";
	      print FOUT "</MAP>\n";
	  }
	  if ($fly_set == 0) {
	      if ($xmax_jqplot != $xmax_home_jqplot) {
		  print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
	      }
	      print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
	  }
	  print FOUT "</DIV>";
      }

    if ($notrafic == 0) {
	$pays_pie = "pays_pie4_".$zone.$gifext;

	$tmp = $zonesize[$zone] if ($geoipcity == 0);
	$tmp = $zonesizecity[$zone] if ($geoipcity == 1);

	  if ($fly_set == 0) {
	      $info = "info".$chart_id;
	      $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%sizepays,\@serie_color,$tmp,4,$unit_div,$unit,$chart_id,0,$info,"","","$dirpays$dirsepurl$filepays") if ($geoipcity == 0);
	      $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%sizepayscity,\@serie_color,$tmp,4,$unit_div,$unit,$chart_id,0,$info,"","","$dirpays$dirsepurl$filepays") if ($geoipcity == 1);
	  }

	  if ($fly_set == 1) {
	      ($line_pie,$map_pays_pie) = &MakePieChart($pays_pie,$tmp,\%sizepays,4,1,'',$rayon) if ($geoipcity == 0);
	      ($line_pie,$map_pays_pie) = &MakePieChart($pays_pie,$tmp,\%sizepayscity,4,1,'',$rayon) if ($geoipcity == 1);
	  }

	print FOUT "<DIV ID=\"tog_traffic\" STYLE=\"display:none\">";
	print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
	print FOUT "<TR><TD ALIGN=CENTER VALIGN=MIDDLE>";
	print FOUT "<TABLE BORDER=0>";
	print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Countries'}</TH></TR>";
	print FOUT "$line_pie";
	print FOUT "</TABLE>\n";
	print FOUT "</TD>\n";
	
	print FOUT "<TD ALIGN=CENTER>";
	print FOUT "<BR><IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$pays_pie\" USEMAP=\"#map_pays4_graph\" BORDER=0 ALT=\"graph\">\n" if ($fly_set == 1);
	if ($fly_set == 0) {
	    print FOUT "<div id=\"";
	    print FOUT "chart".$chart_id;
	    print FOUT "\" ";
	    print FOUT "style=\"";
	    print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
	    print FOUT "</div>\n";
	    $chart_id++;
	}	     
	print FOUT "<P><I>";
	if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	    print FOUT "<A HREF=\"javascript:ToggleAlpha('tog_hosts','tog_req','tog_acc','tog_traffic');\">" if ($fly_set == 1);
	    print FOUT "<A HREF=\"javascript:ToggleJqplotGraph4(plot0,'tog_hosts','tog_req','tog_acc','tog_traffic');\">" if ($fly_set == 0);
	} else {
	    print FOUT "<A HREF=\"javascript:ToggleDelta('tog_hosts','tog_req','tog_traffic');\">" if ($fly_set == 1);
	    print FOUT "<A HREF=\"javascript:ToggleJqplotGraph3(plot0,'tog_hosts','tog_req','tog_traffic');\">" if ($fly_set == 0);
	}
	print FOUT "$L{'Hosts'}</A> - ";
	if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	    print FOUT "<A HREF=\"javascript:ToggleAlpha('tog_req','tog_hosts','tog_acc','tog_traffic');\">" if ($fly_set == 1);
	    print FOUT "<A HREF=\"javascript:ToggleJqplotGraph4(plot1,'tog_req','tog_hosts','tog_acc','tog_traffic');\">" if ($fly_set == 0);
	} else {
	    print FOUT "<A HREF=\"javascript:ToggleDelta('tog_req','tog_hosts','tog_traffic');\">" if ($fly_set == 1);
	    print FOUT "<A HREF=\"javascript:ToggleJqplotGraph3(plot1,'tog_req','tog_hosts','tog_traffic');\">" if ($fly_set == 0);
	}
	print FOUT "$L{'Requests'}</A> ";
	if ($fly_set == 1) {
	    print FOUT "- <A HREF=\"javascript:ToggleAlpha('tog_acc','tog_req','tog_hosts','tog_traffic');\">$L{'Accesses'}</A> " if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
	}
	if ($fly_set == 0) {
	    print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph4(plot2,'tog_acc','tog_req','tog_hosts','tog_traffic');\">$L{'Accesses'}</A> " if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
	}
	print FOUT "- $L{'Traffic'}";
	print FOUT "</I></TD></TR></TABLE>\n";

	if ($fly_set == 1) {
	    print FOUT "<MAP NAME=\"map_pays4_graph\">\n";
	    $tmp = $map_pays_pie;
	    $tmp =~ s/<!-- langhome -->/$I/g;
	    print FOUT "$tmp";
	    print FOUT "</MAP>\n";
	}
	if ($fly_set == 0) {
	    if ($xmax_jqplot != $xmax_home_jqplot) {
		print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
	    }
	    print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
	}
	print FOUT "</DIV>";
    }

    print FOUT "</TD></TR><TR><TD VALIGN=TOP align=\"justify\">";

    print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'Requests'} - $L{'Sort'} : <A HREF=\"javascript:ToggleBeta('tog_alpha','tog_value');\">$L{'Alphabetically'}</A> - <A HREF=\"javascript:ToggleBeta('tog_value','tog_alpha');\">$L{'By_size'}</A></DIV><P>";

      print FOUT "<DIV ID=\"tog_alpha\" STYLE=\"display:inline\">";
      print FOUT "$line_cloud\n";
      print FOUT "</DIV>\n";
      print FOUT "<P>";
      
      print FOUT "<DIV ID=\"tog_value\" STYLE=\"display:none\">";
      print FOUT "$line_cloud_sort\n";
      print FOUT "</DIV>\n";

      print FOUT "</TD></TR>\n";
      print FOUT "</TABLE>\n";

      print FOUT "</TD>\n";
      print FOUT "</TR>\n</TABLE>\n";

      print FOUT "<MAP NAME=\"$zone[$zone]\">\n";
      print FOUT "$map_city[$zone]";
      print FOUT "</MAP>\n";

  }
  print FOUT "<P>\n";

#  if ($geoipcity == 0) {
      $zone_other = '';

      for ($j=1;$j<=$nbzone;$j++) {
	  next if ($j == $nbzone && $geoipcity == 1);
	  if ($j != $zone && $zoneserver[$j] != 0) {
#	      if (-f "$path$lang[$nblang]$dirsep$dirpays$dirsepurl$zone[$j]$htmlext") {
		  $zone_other .= "&nbsp;<A HREF=\"$zone[$j]$htmlext\">";
		  $zone_other .= "$L{$zone[$j]}";
		  $zone_other .= "</A> | ";
#	      }
	  }
      }
      chop($zone_other);
      chop($zone_other);
#  }

  if ($zone_other ne '') {
      print FOUT "[ ";
      print FOUT "$zone_other";
      print FOUT "]";
  }



  $i = '';
  $found = 0;
  foreach $pays (&reverse_sort_by_value(*tmplist)) {
      $i++;
      next if ($pays eq "Unknown");      
      if ($zonepays{$pays} == $zone && $found == 0) {
	  $j = $i;
	  $found = 1;
#	  print "FOUND $j - $pays - $zonepays{$pays} - $zone\n";
#	  last;
      }      
  }


  ($unit_div,$unit) = &Return_Unit($tmp_unit,0);
#  $tmp_unit = $sizepays{(&reverse_sort_by_value(*sizepays))[$j]} if ($geoipcity == 0);
#  $tmp_unit = $sizepayscity{(&reverse_sort_by_value(*sizepayscity))[$j]} if ($geoipcity == 1);

#  print "A $zone - $pays - $zonepays{$pays} - $j - $tmp_unit\n";

  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Countries'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Cities'}&nbsp;</TH>\n" if ($geoipcity == 1);
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Requests'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  if ($spam_found != 0 && $spamonly != 1) {
      print FOUT "<TH class=\"table-sortable:numeric\">$L{'Spam'}</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n";
  }
  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  }
  if ($notrafic == 0) { 
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'} (";
      print FOUT "$L{$unit}"; 
#      print FOUT "$L{'bytes'}" if ($tmp_unit < 1024);
#      print FOUT "$L{'Kb'}" if ($tmp_unit > 1024 && $tmp_unit < (1024*1024));
#      print FOUT "$L{'Mb'}" if ($tmp_unit > (1024*1024) && $tmp_unit < (1024*1024*1024));
#      print FOUT "$L{'Gb'}" if ($tmp_unit > (1024*1024*1024) && $tmp_unit < (1024*1024*1024*1024));
#      print FOUT "$L{'Tb'}" if ($tmp_unit > (1024*1024*1024*1024));
      print FOUT ")&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  }
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";

  foreach $pays (&reverse_sort_by_value(*tmplist)) {
      next if ($pays eq "Unknown");
      if ($zonepays{$pays} == $zone) {

	  if ($geoipcity == 1) {
	      $tmp = "country_city_".$pays;
	      $nbcity = keys(%$tmp);
	  }
	  
	  print FOUT "<TR>\n";

	  print FOUT "<TD CLASS=\"left\">";
	  print FOUT "<A HREF=\"$flagpage{$pays}\"\>" if ($geoipcity == 0 && $found{$pays} == 1 && $payslist{$pays} > $seuilsite);
	  if ($pays !~ /$country_generic/ && $flagpage{$pays} !~ /^divers/) {
	      print FOUT "<A HREF=\"..$dirsepurl$dircity$dirsepurl$flagpage{$pays}\"\>" if ($geoipcity == 1 && $found_city{$pays} == 1 && $payslistcity{$pays} > $seuilsite);
	  }
	  print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirflags$dirsepurl$pays$gifext\" WIDTH=14 HEIGHT=14 BORDER=0 TITLE=\"$L{$newflag{$pays}}\" ALT=\"$pays$gifext\">";
	  print FOUT "</A>" if ($geoipcity == 0 && $found{$pays} == 1 && $payslist{$pays} > $seuilsite);
	  print FOUT "</A>" if ($geoipcity == 1 && $found_city{$pays} == 1 && $payslistcity{$pays} > $seuilsite && $pays !~ /$country_generic/ && $flagpage{$pays} !~ /^divers/);

	  print FOUT "&nbsp;";
	  print FOUT "<A HREF=\"$flagpage{$pays}\"\>" if ($geoipcity == 0 && $found{$pays} == 1 && $payslist{$pays} > $seuilsite);
	  if ($pays !~ /$country_generic/ && $flagpage{$pays} !~ /^divers/) {
	      print FOUT "<A HREF=\"..$dirsepurl$dircity$dirsepurl$flagpage{$pays}\"\>" if ($geoipcity == 1 && $found_city{$pays} == 1 && $payslistcity{$pays} > $seuilsite);
	  }
	  print FOUT "$L{$newflag{$pays}}";
	  print FOUT "</A>" if ($geoipcity == 0 && $found{$pays} == 1 && $payslist{$pays} > $seuilsite);
	  print FOUT "</A>" if ($geoipcity == 1 && $found_city{$pays} == 1 && $payslistcity{$pays} > $seuilsite && $pays !~ /$country_generic/ && $flagpage{$pays} !~ /^divers/);
	  print FOUT "</TD>";

	  print FOUT "<TD CLASS=\"left\"><B>$nbcity</B></TD>" if ($geoipcity == 1);

	  $percentage = 0;
	  $percentage = ($serverpays{$pays}*100)/$zoneserver[$zone] if ($zoneserver[$zone] != 0 && $geoipcity == 0);
	  $percentage = ($serverpayscity{$pays}*100)/$zoneservercity[$zone] if ($zoneservercity[$zone] != 0 && $geoipcity == 1);
	  $tmp2 = int($percentage);
	  print FOUT "<TD CLASS=\"left\">";
	  print FOUT "<img width=$tmp2 height=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[4]\" ALT=\"$gcolor[4]\">&nbsp;" if ($tmp2 != 0);
	  # CHECK
#	  printf FOUT " <B>$serverpays{$pays}</B>",$tmp2;
	  print FOUT "<B>$serverpays{$pays}</B>" if ($geoipcity == 0);
	  print FOUT "<B>$serverpayscity{$pays}</B>" if ($geoipcity == 1);
	  print FOUT "</TD>\n";
	  printf FOUT "<TD CLASS=\"right\">%.1f %",$percentage;
	  print FOUT "</TD>\n";        

	  print FOUT "<TD CLASS=\"left\">";
	  $percentage = ($payslist{$pays}*100)/$zonehits[$zone] if ($geoipcity == 0);
	  $percentage = ($payslistcity{$pays}*100)/$zonehitscity[$zone] if ($geoipcity == 1 && $zonehitscity[$zone] != 0);
	  $tmp2 = int($percentage);
	  print FOUT "<img width=$tmp2 height=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($tmp2 != 0);
	  print FOUT "<B>$payslist{$pays}</B></TD>\n" if ($geoipcity == 0);
	  print FOUT "<B>$payslistcity{$pays}</B></TD>\n" if ($geoipcity == 1);
	  printf FOUT "<TD CLASS=\"right\">%3.1f %",$percentage;
	  print FOUT "</TD>\n";

	  if ($spam_found != 0 && $spamonly != 1) {
	      print FOUT "<TD CLASS=\"left\">";
	      $percentage = ($spam_pays{$pays}*100)/$spam_zone[$zone] if ($spam_zone[$zone] != 0 && $geoipcity == 0);
	      $percentage = ($spam_citypays{$pays}*100)/$spam_zone[$zone] if ($spam_zone[$zone] != 0 && $geoipcity == 1);
	      $tmp2 = int($percentage);
	      print FOUT "<img width=$tmp2 height=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">&nbsp;" if ($tmp2 != 0);
	      print FOUT "<B>$spam_pays{$pays}</B></TD>\n" if ($geoipcity == 0);
	      print FOUT "<B>$spam_citypays{$pays}</B></TD>\n" if ($geoipcity == 1);
	      printf FOUT "<TD CLASS=\"right\">%3.1f %",$percentage;
	      print FOUT "</TD>\n";
	  }

	  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	      $percentage = 0;
	      $percentage = ($payshtml{$pays}*100)/$zonehtml[$zone] if ($zonehtml[$zone] != 0 && $geoipcity == 0);
	      $percentage = ($payshtmlcity{$pays}*100)/$zonehtmlcity[$zone] if ($zonehtmlcity[$zone] != 0 && $geoipcity == 1);
	      $tmp2 = int($percentage);
	      print FOUT "<TD CLASS=\"left\">";
	      print FOUT "<img width=$tmp2 height=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">&nbsp;" if ($tmp2 != 0);
	      printf FOUT "<B>%d</B></TD>\n",$payshtml{$pays} if ($geoipcity == 0);
	      printf FOUT "<B>%d</B></TD>\n",$payshtmlcity{$pays} if ($geoipcity == 1);
	      printf FOUT "<TD CLASS=\"right\">%3.1f %",$percentage;
	      print FOUT "</TD>\n";
	  }

	  if ($notrafic == 0) {
	      $percentage = 0;
	      $percentage = $sizepays{$pays}*100/$zonesize[$zone] if ($zonesize[$zone] != 0 && $geoipcity == 0);
	      $percentage = $sizepayscity{$pays}*100/$zonesizecity[$zone] if ($zonesizecity[$zone] != 0 && $geoipcity == 1);
	      $tmp = int($percentage);
	      $tmp2 = $sizepays{$pays} if ($geoipcity == 0);
	      $tmp2 = $sizepayscity{$pays} if ($geoipcity == 1);
	      $tmp2 /= $unit_div;
#	      $tmp2 /= 1024 if ($tmp_unit > 1024 && $tmp_unit < (1024*1024)); 
#	      $tmp2 /= (1024*1024) if ($tmp_unit > (1024*1024));

	      print FOUT "<TD CLASS=\"left\">";
	      print FOUT "<img width=$tmp height=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">&nbsp;" if ($tmp != 0);
	      printf FOUT "<B>%d</B></TD>",$tmp2 if ($unit_div < 1024);
	      printf FOUT "<B>%.2f</B></TD>",$tmp2 if ($unit_div > 1024);
	      printf FOUT "<TD CLASS=\"right\">%3.1f %",$percentage;
	      print FOUT "</TD>\n";
	  }
	  print FOUT "</TR>\n";
      }
  }
  print FOUT "</tbody>\n";  
  print FOUT "</TABLE>\n";
  
  print FOUT "</BODY></HTML>\n";
}

#
##############################################################
### Countries
##############################################################
#

sub PagePays {
  local(*FOUT,*L,$I) = @_;
  local($tmp2);

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Stats'} - $L{'countries'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";
  &add_jqplot_js(*FOUT,2);
  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";

  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
  &help_div(*FOUT);

  print FOUT "<H2> $L{'Countries'} $L{'connecting_to_the_server'} :</H2><P>\n";
  print FOUT "<P><HR><P>\n";

  #
  ### Zone
  #

  if ($paysunique != 0) {
      print FOUT "<CENTER>\n";
      if ($geoipcity == 1) {
	  print FOUT "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0><TR><TD STYLE=\"vertical-align:middle;text-align:center;\">\n";
	  print FOUT "<DIV STYLE=\"position:relative;\">\n";
      }
      print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$earthmap\" WIDTH=\"500\" HEIGHT=\"250\" BORDER=0 USEMAP=\"#world\" ALT=\"earthmap\">\n";
      
      if ($geoipcity == 1) {
#	  print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirgraph$dirsepurl$worldmap\" STYLE='z-index:10;position:absolute;left:50%;top:50%; margin-left:-250px;margin-top:-125px;' ALT=\"cities_worldmap\" WIDTH=\"500\" HEIGHT=\"250\">\n";
	  print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirgraph$dirsepurl$worldmap\" STYLE='z-index:10;position:absolute;left:50%;top:50%; margin-left:-250px;margin-top:-125px;' ALT=\"cities_worldmap\" WIDTH=\"500\" HEIGHT=\"250\" BORDER=0 USEMAP=\"#world\">\n";
	  print FOUT "</DIV>\n";
	  print FOUT "</TD></TR></TABLE>\n";
      }

      print FOUT "<P><MAP NAME=\"world\">\n";
      $tmp2 = 0;
      $unit = "$L{'bytes'}";
      for ($i=1;$i<=$nbzone;$i++) {
	  if ($zonesize[$i] > $tmp2) {
	      $tmp2 = $zonesize[$i];
	      $unit = "$L{'Kb'}" if ($tmp2 > 1024);
	      $unit = "$L{'Mb'}" if ($tmp2 > (1024*1024));
	      $unit = "$L{'Gb'}" if ($tmp2 > (1024*1024*1024));
	      $unit = "$L{'Tb'}" if ($tmp2 > (1024*1024*1024*1024));
	  }
	  if ($zonehits[$i] ne '') {
	      print FOUT "<AREA SHAPE=\"";
	      print FOUT "POLY" if ($zone[$i] ne "Europe");
	      print FOUT "RECT" if ($zone[$i] eq "Europe");
	      print FOUT "\" COORDS=\"$string_map{$zone[$i]}\" HREF=\"$zone[$i]$htmlext\" TITLE=\"$L{$zone[$i]}\" ALT=\"$L{$zone[$i]}\">\n";
	  }
      }
      print FOUT "<AREA SHAPE=\"POLY\" COORDS=\"1,100,90,142,90,200,1,200\" HREF=\"Oceania$htmlext\" ALT=\"$L{'Oceania'}\">\n" if ($zonehits[$i] ne '');
      print FOUT "</MAP>\n";


      print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
      print FOUT "<thead>\n";
      print FOUT "<TR>\n";
      print FOUT "<TH>&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Requests'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      if ($spam_found != 0 && $spamonly != 1) {
	  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Spam'}</TH>\n";
	  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n";
      }
      if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      }
      if ($notrafic == 0) {
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}";
	  print FOUT " ($unit)";
	  print FOUT "&nbsp;</TH>\n<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      }
      print FOUT "</TR>\n";
      print FOUT "</thead>\n";
      print FOUT "<tbody>\n";

      
      for ($i=1;$i<=$nbzone;$i++) {
	  if (($zonehits[$i] ne '' && $geoipcity == 0) || ($zonehitscity[$i] ne '' && $geoipcity == 1)) {
	  print FOUT "<TR>\n<TD CLASS=\"left\">";
	  print FOUT "<A HREF=\"$zone[$i]$htmlext\">"; # if ($zonehits[$i] ne '' && $geoipcity == 0);
#	  print FOUT "<A HREF=\"$zone[$i]$htmlext\">"; # if ($zonehitscity[$i] ne '' && $geoipcity == 1);
	  print FOUT "$L{$zone[$i]}";
	  print FOUT "</A>"; # if ($zonehits[$i] ne '' && $geoipcity == 0);
#	  print FOUT "</A>" if ($zonehitscity[$i] ne '' && $geoipcity == 1);
	  print FOUT "&nbsp;</TD>\n";

	  $tmp = ($zoneserver[$i]*1000/($serverunique+$locserver))/10 if ($geoipcity == 0);
	  $tmp = ($zoneservercity[$i]*1000/($serverunique+$locserver))/10 if ($geoipcity == 1);
	  $tmp2 = int($tmp);
	  print FOUT "<TD CLASS=\"left\">&nbsp;" if ($tmp2 == 0);
	  print FOUT "<TD CLASS=\"left\">&nbsp;<IMG WIDTH=$tmp2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[4]\" ALT=\"$gcolor[4]\">&nbsp;" if ($tmp2 != 0);
	  print FOUT "<B>$zoneserver[$i]</B>&nbsp;</TD>\n" if ($geoipcity == 0);
	  print FOUT "<B>$zoneservercity[$i]</B>&nbsp;</TD>\n" if ($geoipcity == 1);
	  printf FOUT "<TD CLASS=\"right\">%.1f&nbsp;%</TD>\n",$tmp;


	  $tmp = ($zonehits[$i]*1000/$reqtot)/10 if ($geoipcity == 0);
	  $tmp = ($zonehitscity[$i]*1000/$reqtot)/10 if ($geoipcity == 1);
	  $tmp2 = int($tmp);

	  print FOUT "<TD CLASS=\"left\">&nbsp;" if ($tmp2 == 0);
	  print FOUT "<TD CLASS=\"left\">&nbsp;<IMG WIDTH=$tmp2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($tmp2 != 0);
	  print FOUT "<B>$zonehits[$i]</B>&nbsp;</TD>\n" if ($geoipcity == 0);
	  print FOUT "<B>$zonehitscity[$i]</B>&nbsp;</TD>\n" if ($geoipcity == 1);
	  printf FOUT "<TD CLASS=\"right\">%.1f&nbsp;%</TD>\n",$tmp;

	  if ($spam_found != 0 && $spamonly != 1) {
	      $tmp = ($spam_zone[$i]*1000/$spam_found)/10;
	      $tmp2 = int($tmp);

	      print FOUT "<TD CLASS=\"left\">&nbsp;" if ($tmp2 == 0);
	      print FOUT "<TD CLASS=\"left\">&nbsp;<IMG WIDTH=$tmp2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">&nbsp;" if ($tmp2 != 0);
	      print FOUT "<B>$spam_zone[$i]</B>&nbsp;</TD>\n";
	      printf FOUT "<TD CLASS=\"right\">%.1f&nbsp;%</TD>\n",$tmp;
	  }

	  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	      $tmp = ($zonehtml[$i]*1000/$access)/10 if ($access != 0 && $geoipcity == 0);
	      $tmp = ($zonehtmlcity[$i]*1000/$access)/10 if ($access != 0 && $geoipcity == 1);
	      $tmp2 = int($tmp);
	      print FOUT "<TD CLASS=\"left\">&nbsp;" if ($tmp2 == 0);
	      print FOUT "<TD CLASS=\"left\">&nbsp;<IMG WIDTH=$tmp2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">&nbsp;" if ($tmp2 != 0);
	      print FOUT "<B>$zonehtml[$i]</B>&nbsp;</TD>\n" if ($geoipcity == 0);
	      print FOUT "<B>$zonehtmlcity[$i]</B>&nbsp;</TD>\n" if ($geoipcity == 1);
	      printf FOUT "<TD CLASS=\"right\">%.1f&nbsp;%</TD>\n",$tmp;
	  }

	  if ($notrafic == 0) {
	      $tmp = ($zonesize[$i]*1000/$totsize)/10 if ($geoipcity == 0);
	      $tmp = ($zonesizecity[$i]*1000/$totsizecity)/10 if ($geoipcity == 1);
	      $tmp2 = int($tmp);
	      print FOUT "<TD CLASS=\"left\">&nbsp;" if ($tmp2 == 0);
	      print FOUT "<TD CLASS=\"left\">&nbsp;<IMG WIDTH=$tmp2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">&nbsp;" if ($tmp2 != 0);
	      $tmp2 = $zonesize[$i] if ($geoipcity == 0);
	      $tmp2 = $zonesizecity[$i] if ($geoipcity == 1);
	      $tmp2 /= 1024 if ($unit eq "$L{'Kb'}");
	      $tmp2 /= (1024*1024) if ($unit eq "$L{'Mb'}");
	      $tmp2 /= (1024*1024*1024) if ($unit eq "$L{'Gb'}");
	      $tmp2 /= (1024*1024*1024*1024) if ($unit eq "$L{'Tb'}");
	      printf FOUT "<B>%d</B>&nbsp;</TD>\n",$tmp2 if ($unit eq "$L{'bytes'}");
	      printf FOUT "<B>%.1f</B>&nbsp;</TD>\n",$tmp2 if ($unit ne "$L{'bytes'}");
	      printf FOUT "<TD CLASS=\"right\">%.1f&nbsp;%</TD>\n",$tmp;
	  }
	  print FOUT "</TR>\n";
      }
      }

      if ($found{Unknown} == 1) {
	  
	  print FOUT "<TR>\n";
	  print FOUT "<TD CLASS=\"left\">\n";
	  print FOUT "<A HREF=\"$unresolved\"\>" if ($reverse_geo == 0 && $payslist{Unknown} > $seuilsite);
	  print FOUT "<A HREF=\"Unknown$unresolved\"\>" if ($reverse_geo == 1 && $payslist{Unknown} > $seuilsite);
	  print FOUT "$L{'List_of_unresolved_hosts'}";
	  print FOUT "</A>" if ($payslist{Unknown} > $seuilsite);
	  print FOUT "</TD>\n";


	  print FOUT "<TD CLASS=\"left\">&nbsp;";
	  $tmpa = $serverpays{Unknown}*100/($serverunique+$locserver) if ($localonly != 1);
	  $tmpa = $serverpays{Unknown}*100/$locserver if ($localonly == 1);
	  $tmp2 = int($tmpa);
	  print FOUT "<IMG WIDTH=$tmp2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[4]\" ALT=\"$gcolor[4]\">&nbsp;" if ($tmp2 != 0);
	  print FOUT "<B>$serverpays{Unknown}</B>";
	  print FOUT "</TD>\n";
	  printf FOUT "<TD CLASS=\"right\">%.1f %",$tmpa;
	  print FOUT "</TD>\n";

	  $tmp = ($payslist{Unknown}*1000/$reqtot)/10; # if ($geoipcity == 0);
#	  $tmp = ($zonehitscity[$i]*1000/$reqtot)/10 if ($geoipcity == 1);
#	  $tmp2 = int($pourcentpaysunknown);
	  $tmp2 = int($tmp);
	  print FOUT "<TD CLASS=\"left\">&nbsp;";
	  print FOUT "<IMG WIDTH=$tmp2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($tmp2 != 0);
	  print FOUT "<B>$payslist{Unknown}</B></TD>\n";
	  printf FOUT "<TD CLASS=\"right\">%3.1f %",$tmp;
	  print FOUT "</TD>\n";

	  if ($spam_found != 0 && $spamonly != 1) {
	      $tmp = ($spam_pays{Unknown}*1000/$spam_found)/10;
	      $tmp2 = int($tmp);

	      print FOUT "<TD CLASS=\"left\">&nbsp;" if ($tmp2 == 0);
	      print FOUT "<TD CLASS=\"left\">&nbsp;<IMG WIDTH=$tmp2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">&nbsp;" if ($tmp2 != 0);
	      print FOUT "<B>$spam_pays{Unknown}</B>&nbsp;</TD>\n";
	      printf FOUT "<TD CLASS=\"right\">%.1f&nbsp;%</TD>\n",$tmp;
	  }

	  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	      print FOUT "<TD CLASS=\"left\">&nbsp;";
	      $tmp = ($payshtml{Unknown}*1000/$access)/10 if ($access != 0);
#	      $tmp2 = int($pourcentpays2unknown);
	      $tmp2 = int($tmp);
	      print FOUT "<IMG WIDTH=$tmp2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">&nbsp;" if ($tmp2 != 0);
	      printf FOUT "<B>%d</B></TD>\n",$payshtml{Unknown};
	      printf FOUT "<TD CLASS=\"right\">%3.1f %",$tmp;
	      print FOUT "</TD>\n";
	  }

	  if ($notrafic == 0) {
	      $pourcentvalue = $sizepays{Unknown}*100/$totsize;
	      $tmp = int($pourcentvalue);

	      print FOUT "<TD CLASS=\"left\">&nbsp;";        
	      print FOUT "<IMG WIDTH=$tmp HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">&nbsp;" if ($tmp != 0);
	      $tmp2 = $sizepays{Unknown};
	      $tmp2 /= 1024 if ($unit eq "$L{'Kb'}");
	      $tmp2 /= (1024*1024) if ($unit eq "$L{'Mb'}");
	      $tmp2 /= (1024*1024*1024) if ($unit eq "$L{'Tb'}");
	      $tmp2 /= (1024*1024*1024*1024) if ($unit eq "$L{'Gb'}");
	      printf FOUT "<B>%d</B>&nbsp;</TD>\n",$tmp2 if ($unit eq "$L{'bytes'}");
	      printf FOUT "<B>%.1f</B>&nbsp;</TD>\n",$tmp2 if ($unit ne "$L{'bytes'}");
#	      printf FOUT "<B>%d</B></TD>",$tmp2 if ($zonesize[0] < 1024);
#	      printf FOUT "<B>%.1f</B></TD>",$tmp2 if ($zonesize[0] > 1024);
	      printf FOUT "\n<TD CLASS=\"right\">%.1f %",$pourcentvalue;
	      print FOUT "</TD>\n";
	  }
	  print FOUT "</TR>";

      }
      print FOUT "</tbody>\n";
      print FOUT "</TABLE></CENTER><P>\n";
  }

  #
  ###
  #

  $tmp_unit = $sizepays{(&reverse_sort_by_value(*sizepays))[0]} if ($geoipcity == 0);
  $tmp_unit = $sizepayscity{(&reverse_sort_by_value(*sizepayscity))[0]} if ($geoipcity == 1);
  *tmplist = *payslist if ($geoipcity == 0);
  *tmplist = *payslistcity if ($geoipcity == 1);

  #
  ### Pie chart
  #

  $zone = 0;
  if ($geoipcity == 0) {
#      $max = $payslist{(&reverse_sort_by_value(*payslist))[0]};
#      $min = $payslist{(&reverse_sort_by_value(*payslist))[$count_cloud_max]};
      ($line_cloud,$line_cloud_sort) = &MakeCloud(\%payslist,'',4);
  } else {
#      $max = $payslistcity{(&reverse_sort_by_value(*payslistcity))[0]};
#      $min = $payslistcity{(&reverse_sort_by_value(*payslistcity))[$count_cloud_max]};
      ($line_cloud,$line_cloud_sort) = &MakeCloud(\%payslistcity,'',4);
  }


  print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
  print FOUT "<TR><TD VALIGN=TOP WIDTH=\"50%\">\n";
  print FOUT "<DIV ID=\"tog_hosts\" STYLE=\"display:inline\">";

  $tmp = $serverunique+$locserver if ($localonly != 1);
  $tmp = $locserver if ($localonly == 1);

  if ($fly_set == 1) {
      $pays_pie = "pays_pie1".$gifext;
      ($line_pie,$map_city_pie) = &MakePieChart($pays_pie,$tmp,\%serverpays,3,0,'',$rayon) if ($geoipcity == 0);
      ($line_pie,$map_city_pie) = &MakePieChart($pays_pie,$tmp,\%serverpayscity,3,0,'',$rayon) if ($geoipcity == 1);
  }

  if ($fly_set == 0) {
      $chart_id = 0;
      $info = "info".$chart_id;

  ## Associer plot0->tog_hosts plot1->tog_req ... Hosts-Req-Acc-Trafic

      $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%serverpays,\@serie_color,$tmp,3,1,$unit,$chart_id,0,$info,"","",$dirstatus) if ($geoipcity == 0);
      $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%serverpayscity,\@serie_color,$tmp,3,1,$unit,$chart_id,0,$info,"","",$dirstatus) if ($geoipcity == 1);
  }


  print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
  print FOUT "<TR><TD ALIGN=CENTER VALIGN=MIDDLE>";
  print FOUT "<TABLE BORDER=0>";
  print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Countries'}</TH></TR>";
  print FOUT "$line_pie";
  print FOUT "</TABLE>\n";
  print FOUT "</TD>\n";
  
  print FOUT "<TD ALIGN=CENTER>";

  if ($fly_set == 1) {
      print FOUT "<IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$pays_pie\" USEMAP=\"#map_city_graph\" BORDER=0 ALT=\"graph\">\n";
  }

  if ($fly_set == 0) {
      print FOUT "<div id=\"";
      print FOUT "chart".$chart_id;
      print FOUT "\" ";
      print FOUT "style=\"";
      print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
      print FOUT "</div>\n";
  }

  print FOUT "<P><I>$L{'Hosts'} - ";
  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
      print FOUT "<A HREF=\"javascript:ToggleAlpha('tog_req','tog_acc','tog_hosts','tog_traffic');\">" if ($fly_set == 1);
      print FOUT "<A HREF=\"javascript:ToggleJqplotGraph4(plot1,'tog_req','tog_acc','tog_hosts','tog_traffic');\">" if ($fly_set == 0);
  } else {
      print FOUT "<A HREF=\"javascript:ToggleDelta('tog_req','tog_traffic','tog_hosts');\">" if ($fly_set == 1);
      print FOUT "<A HREF=\"javascript:ToggleJqplotGraph3(plot1,'tog_req','tog_traffic','tog_hosts');\">" if ($fly_set == 0);
  }
  print FOUT "$L{'Requests'}</A> ";
  if ($fly_set == 1) {
      print FOUT "- <A HREF=\"javascript:ToggleAlpha('tog_acc','tog_req','tog_hosts','tog_traffic');\">$L{'Accesses'}</A> " if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
  }
  if ($fly_set == 0) {
      print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph4(plot2,'tog_acc','tog_req','tog_hosts','tog_traffic');\">$L{'Accesses'}</A> " if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
  }
  if ($notrafic == 0) {
      if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	  print FOUT "- <A HREF=\"javascript:ToggleAlpha('tog_traffic','tog_hosts','tog_req','tog_acc');\">" if ($fly_set == 1);
	  print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph4(plot3,'tog_traffic','tog_hosts','tog_req','tog_acc');\">" if ($fly_set == 0);
      } else {
	  print FOUT "- <A HREF=\"javascript:ToggleDelta('tog_traffic','tog_hosts','tog_req');\">" if ($fly_set == 1);
	  print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph3(plot2,'tog_traffic','tog_hosts','tog_req');\">" if ($fly_set == 0);
      }
      print FOUT "$L{'Traffic'}</A>";
  }
  print FOUT "</I></TD></TR></TABLE>\n";

  if ($fly_set == 1) {
      print FOUT "<MAP NAME=\"map_city_graph\">\n";
      $tmp = $map_city_pie;
      $tmp =~ s/<!-- langhome -->/$I/g;
      print FOUT "$tmp";
      print FOUT "</MAP>\n";
  }

  if ($fly_set == 0) {
      if ($xmax_jqplot != $xmax_home_jqplot) {
	  print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
      }
      print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
  }
  print FOUT "</DIV>";

  if ($fly_set == 1) {
      $pays_pie = "pays_pie2".$gifext;
      ($line_pie,$map_city_pie) = &MakePieChart($pays_pie,$reqtot,\%payslist,3,0,'',$rayon) if ($geoipcity == 0);
      ($line_pie,$map_city_pie) = &MakePieChart($pays_pie,$reqtot,\%payslistcity,3,0,'',$rayon) if ($geoipcity == 1);
  }

  if ($fly_set == 0) {
      $chart_id++;
      $info = "info".$chart_id;
      $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%payslist,\@serie_color,$reqtot,3,1,$unit,$chart_id,0,$info,"","",$dirstatus) if ($geoipcity == 0);
      $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%payslistcity,\@serie_color,$reqtot,3,1,$unit,$chart_id,0,$info,"","",$dirstatus) if ($geoipcity == 1);
  }

  print FOUT "<DIV ID=\"tog_req\" STYLE=\"display:none\">";
  print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
  print FOUT "<TR><TD ALIGN=CENTER VALIGN=MIDDLE>";
  print FOUT "<TABLE BORDER=0>";
  print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Countries'}</TH></TR>";
  print FOUT "$line_pie";
  print FOUT "</TABLE>\n";
  print FOUT "</TD>\n";
    
  print FOUT "<TD ALIGN=CENTER>";
  if ($fly_set == 1) {
      print FOUT "<IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$pays_pie\" USEMAP=\"#map_city2_graph\" BORDER=0 ALT=\"graph\">\n";
  }
  if ($fly_set == 0) {
      print FOUT "<div id=\"";
      print FOUT "chart".$chart_id;
      print FOUT "\" ";
      print FOUT "style=\"";
      print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
      print FOUT "</div>\n";
  }
  print FOUT "<P><I>";
  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
      print FOUT "<A HREF=\"javascript:ToggleAlpha('tog_hosts','tog_req','tog_acc','tog_traffic');\">" if ($fly_set == 1);
      print FOUT "<A HREF=\"javascript:ToggleJqplotGraph4(plot0,'tog_hosts','tog_req','tog_acc','tog_traffic');\">" if ($fly_set == 0);
  } else {
      print FOUT "<A HREF=\"javascript:ToggleDelta('tog_hosts','tog_req','tog_traffic');\">" if ($fly_set == 1);
      print FOUT "<A HREF=\"javascript:ToggleJqplotGraph3(plot0,'tog_hosts','tog_req','tog_traffic');\">" if ($fly_set == 0);
  }
  print FOUT "$L{'Hosts'}</A> - $L{'Requests'} ";
  if ($fly_set == 1) {
      print FOUT "- <A HREF=\"javascript:ToggleAlpha('tog_acc','tog_req','tog_traffic','tog_hosts');\">$L{'Accesses'}</A> " if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
  }
  if ($fly_set == 0) {
      print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph4(plot2,'tog_acc','tog_req','tog_traffic','tog_hosts');\">$L{'Accesses'}</A> " if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
  }
  if ($notrafic == 0) {
      if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	  print FOUT "- <A HREF=\"javascript:ToggleAlpha('tog_traffic','tog_hosts','tog_req','tog_acc');\">" if ($fly_set == 1);
	  print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph4(plot3,'tog_traffic','tog_hosts','tog_req','tog_acc');\">" if ($fly_set == 0);
      } else {
	  print FOUT "- <A HREF=\"javascript:ToggleDelta('tog_traffic','tog_hosts','tog_req');\">" if ($fly_set == 1);
	  print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph3(plot2,'tog_traffic','tog_hosts','tog_req');\">" if ($fly_set == 0);
      }
      print FOUT "$L{'Traffic'}</A>";
  }
  print FOUT "</I></TD></TR></TABLE>\n";

  if ($fly_set == 1) {
      print FOUT "<MAP NAME=\"map_city2_graph\">\n";
      $tmp = $map_city_pie;
      $tmp =~ s/<!-- langhome -->/$I/g;
      print FOUT "$tmp";
      print FOUT "</MAP>\n";
  }

  if ($fly_set == 0) {
      if ($xmax_jqplot != $xmax_home_jqplot) {
	  print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
      }
      print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
  }
  print FOUT "</DIV>";


  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {

      if ($fly_set == 1) {
	  $pays_pie = "pays_pie3".$gifext;
	  ($line_pie,$map_city_pie) = &MakePieChart($pays_pie,$access,\%payshtml,3,0,'',$rayon) if ($geoipcity == 0);
	  ($line_pie,$map_city_pie) = &MakePieChart($pays_pie,$access,\%payshtmlcity,3,0,'',$rayon) if ($geoipcity == 1);
      }

      if ($fly_set == 0) {
	  $chart_id++;
	  $info = "info".$chart_id;
	  $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%payshtml,\@serie_color,$access,3,1,$unit,$chart_id,0,$info,"","",$dirstatus) if ($geoipcity == 0);
	  $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%payshtmlcity,\@serie_color,$access,3,1,$unit,$chart_id,0,$info,"","",$dirstatus) if ($geoipcity == 1);
      }

      print FOUT "<DIV ID=\"tog_acc\" STYLE=\"display:none\">";
      print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
      print FOUT "<TR><TD ALIGN=CENTER VALIGN=MIDDLE>";
      print FOUT "<TABLE BORDER=0>";
      print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Countries'}</TH></TR>";
      print FOUT "$line_pie";
      print FOUT "</TABLE>\n";
      print FOUT "</TD>\n";
    
      print FOUT "<TD ALIGN=CENTER>";
      if ($fly_set == 1) {
	  print FOUT "<IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$pays_pie\" USEMAP=\"#map_city3_graph\" BORDER=0 ALT=\"graph\">\n";
      }
      if ($fly_set == 0) {
	  print FOUT "<div id=\"";
	  print FOUT "chart".$chart_id;
	  print FOUT "\" ";
	  print FOUT "style=\"";
	  print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
	  print FOUT "</div>\n";
      }

      print FOUT "<P><I>";
      print FOUT "<A HREF=\"javascript:ToggleAlpha('tog_hosts','tog_req','tog_acc','tog_traffic');\">$L{'Hosts'}</A> - " if ($fly_set == 1);
      print FOUT "<A HREF=\"javascript:ToggleJqplotGraph4(plot0,'tog_hosts','tog_req','tog_acc','tog_traffic');\">$L{'Hosts'}</A> - " if ($fly_set == 0);
      print FOUT "<A HREF=\"javascript:ToggleAlpha('tog_req','tog_acc','tog_hosts','tog_hosts');\">$L{'Requests'}</A> - $L{'Accesses'} " if ($fly_set == 1);
      print FOUT "<A HREF=\"javascript:ToggleJqplotGraph4(plot1,'tog_req','tog_acc','tog_hosts','tog_hosts');\">$L{'Requests'}</A> - $L{'Accesses'} " if ($fly_set == 0);
      if ($fly_set == 1) {
	  print FOUT "- <A HREF=\"javascript:ToggleAlpha('tog_traffic','tog_hosts','tog_req','tog_acc');\">$L{'Traffic'}</A>" if ($notrafic == 0);
      }
      if ($fly_set == 0) {
	  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	      print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph4(plot3,'tog_traffic','tog_hosts','tog_req','tog_acc');\">$L{'Traffic'}</A>" if ($notrafic == 0);
	  } else {
	      print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph3(plot2,'tog_traffic','tog_hosts','tog_req');\">$L{'Traffic'}</A>" if ($notrafic == 0);
	  }
      }
      print FOUT "</I></TD></TR></TABLE>\n";

      if ($fly_set == 1) {
	  print FOUT "<MAP NAME=\"map_city3_graph\">\n";
	  $tmp = $map_city_pie;
	  $tmp =~ s/<!-- langhome -->/$I/g;
	  print FOUT "$tmp";
	  print FOUT "</MAP>\n";
      }

      if ($fly_set == 0) {
	  if ($xmax_jqplot != $xmax_home_jqplot) {
	      print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
	  }
	  print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
      }
      print FOUT "</DIV>";
  }

  $tmp = $totsize if ($geoipcity == 0);
  $tmp = $totsizecity if ($geoipcity == 1);

  if ($notrafic == 0 && $tmp != 0) {

      if ($fly_set == 1) {
	  $pays_pie = "pays_pie4".$gifext;
	  ($line_pie,$map_city_pie) = &MakePieChart($pays_pie,$tmp,\%sizepays,3,2,'',$rayon) if ($geoipcity == 0);
	  ($line_pie,$map_city_pie) = &MakePieChart($pays_pie,$tmp,\%sizepayscity,3,2,'',$rayon) if ($geoipcity == 1);
      }

      if ($fly_set == 0) {
	  $chart_id++;
	  $info = "info".$chart_id;
	  $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%sizepays,\@serie_color,$tmp,3,$unit_div,$unit,$chart_id,2,$info,"","",$dirstatus) if ($geoipcity == 0);
	  $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%sizepayscity,\@serie_color,$tmp,3,$unit_div,$unit,$chart_id,2,$info,"","",$dirstatus) if ($geoipcity == 1);
      }

      print FOUT "<DIV ID=\"tog_traffic\" STYLE=\"display:none\">";
      print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
      print FOUT "<TR><TD ALIGN=CENTER VALIGN=MIDDLE>";
      print FOUT "<TABLE BORDER=0>";
      print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Countries'}</TH></TR>";
      print FOUT "$line_pie";
      print FOUT "</TABLE>\n";
      print FOUT "</TD>\n";
      
      print FOUT "<TD ALIGN=CENTER>";
      if ($fly_set == 1) {
	  print FOUT "<IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$pays_pie\" USEMAP=\"#map_city4_graph\" BORDER=0 ALT=\"graph\">\n";
      }
      if ($fly_set == 0) {
	  print FOUT "<div id=\"";
	  print FOUT "chart".$chart_id;
	  print FOUT "\" ";
	  print FOUT "style=\"";
	  print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
	  print FOUT "</div>\n";
      }
      print FOUT "<P><I>";
	if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	    print FOUT "<A HREF=\"javascript:ToggleAlpha('tog_hosts','tog_req','tog_acc','tog_traffic');\">" if ($fly_set == 1);
	    print FOUT "<A HREF=\"javascript:ToggleJqplotGraph4(plot0,'tog_hosts','tog_req','tog_acc','tog_traffic');\">" if ($fly_set == 0);
	} else {
	    print FOUT "<A HREF=\"javascript:ToggleDelta('tog_hosts','tog_req','tog_traffic');\">" if ($fly_set == 1);
	    print FOUT "<A HREF=\"javascript:ToggleJqplotGraph3(plot0,'tog_hosts','tog_req','tog_traffic');\">" if ($fly_set == 0);
	}
	print FOUT "$L{'Hosts'}</A> - ";
	if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	    print FOUT "<A HREF=\"javascript:ToggleAlpha('tog_req','tog_hosts','tog_acc','tog_traffic');\">" if ($fly_set == 1);
	    print FOUT "<A HREF=\"javascript:ToggleJqplotGraph4(plot1,'tog_req','tog_hosts','tog_acc','tog_traffic');\">" if ($fly_set == 0);
	} else {
	    print FOUT "<A HREF=\"javascript:ToggleDelta('tog_req','tog_hosts','tog_traffic');\">" if ($fly_set == 1);
	    print FOUT "<A HREF=\"javascript:ToggleJqplotGraph3(plot1,'tog_req','tog_hosts','tog_traffic');\">" if ($fly_set == 0);
	}
	print FOUT "$L{'Requests'}</A> ";
      if ($fly_set == 1) {
	  print FOUT "- <A HREF=\"javascript:ToggleAlpha('tog_acc','tog_req','tog_hosts','tog_traffic');\">$L{'Accesses'}</A> " if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
      }
      if ($fly_set == 0) {
	  print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph4(plot2,'tog_acc','tog_req','tog_hosts','tog_traffic');\">$L{'Accesses'}</A> " if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
      }
	print FOUT "- $L{'Traffic'}";
	print FOUT "</I></TD></TR></TABLE>\n";

	if ($fly_set == 1) {
	    print FOUT "<MAP NAME=\"map_city4_graph\">\n";
	    $tmp = $map_city_pie;
	    $tmp =~ s/<!-- langhome -->/$I/g;
	    print FOUT "$tmp";
	    print FOUT "</MAP>\n";
	}
      if ($fly_set == 0) {
	  if ($xmax_jqplot != $xmax_home_jqplot) {
	      print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
	  }
	  print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
      }
      print FOUT "</DIV>";
    }

    print FOUT "</TD><TD VALIGN=TOP WIDTH=\"50%\" align=\"justify\">";

    print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'Requests'} - $L{'Sort'} : <A HREF=\"javascript:ToggleBeta('tog_alpha','tog_value');\">$L{'Alphabetically'}</A> - <A HREF=\"javascript:ToggleBeta('tog_value','tog_alpha');\">$L{'By_size'}</A></DIV><P>";

    print FOUT "<DIV ID=\"tog_alpha\" STYLE=\"display:inline\">";
    print FOUT "$line_cloud\n";
    print FOUT "</DIV>\n";
    print FOUT "<P>";

    print FOUT "<DIV ID=\"tog_value\" STYLE=\"display:none\">";
    print FOUT "$line_cloud_sort\n";
    print FOUT "</DIV>\n";


    print FOUT "</TD></TR>\n";
    print FOUT "</TABLE>\n";

  #
  ### List
  #

  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Countries'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Cities'}&nbsp;</TH>\n" if ($geoipcity == 1);
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Requests'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  if ($spam_found != 0 && $spamonly != 1) {
      print FOUT "<TH class=\"table-sortable:numeric\">$L{'Spam'}</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n";
  }
  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  }
  if ($notrafic == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'} (";
#      print FOUT " ($unit)";
      print FOUT "$L{'bytes'}" if ($tmp_unit < 1024);
      print FOUT "$L{'Kb'}" if ($tmp_unit > 1024 && $tmp_unit < (1024*1024));
      print FOUT "$L{'Mb'}" if ($tmp_unit > (1024*1024) && $tmp_unit < (1024*1024*1024));
      print FOUT "$L{'Gb'}" if ($tmp_unit > (1024*1024*1024) && $tmp_unit < (1024*1024*1024*1024));
      print FOUT "$L{'Tb'}" if ($tmp_unit > (1024*1024*1024*1024));
      print FOUT ")&nbsp;</TH>"; # if ($locallog == 1 && $localonly == 0);
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  }
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";

  foreach $pays (&reverse_sort_by_value(*tmplist)) {
#  foreach $pays (&reverse_sort_by_value(*payslist)) {
      next if ($pays eq "Unknown");

      if ($geoipcity == 1) {
	  $tmp = "country_city_".$pays;
	  $nbcity = keys(%$tmp);
      }

      if ($flagpage{$pays} eq "") {
	  $flagpage{$pays} = "divers-$pays".$htmlext;
      }

      print FOUT "<TR>\n";
      print FOUT "<TD CLASS=\"left\">";

      print FOUT "<A HREF=\"$flagpage{$pays}\"\>" if ($geoipcity == 0 && $found{$pays} == 1 && $payslist{$pays} > $seuilsite);
      if ($pays !~ /$country_generic/ && $flagpage{$pays} !~ /^divers/) {
	  print FOUT "<A HREF=\"..$dirsepurl$dircity$dirsepurl$flagpage{$pays}\"\>" if ($geoipcity == 1 && $found_city{$pays} == 1 && $payslistcity{$pays} > $seuilsite);
      }
      if (-f "$pathinit$dirress$dirsep$dirflags$dirsep$pays$gifext") {
	  print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirflags$dirsepurl$pays$gifext\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=0 ALT=\"$pays\">";
      } else {
	  $tmp2 = "Unknown";
	  print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirflags$dirsepurl$tmp2$gifext\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=0 ALT=\"$tmp2\">";
      }
      print FOUT "</A>" if ($geoipcity == 0 && $found{$pays} == 1 && $payslist{$pays} > $seuilsite);
      print FOUT "</A>" if ($geoipcity == 1 && $found_city{$pays} == 1 && $payslistcity{$pays} > $seuilsite && $pays !~ /$country_generic/ && $flagpage{$pays} !~ /^divers/);
      print FOUT "&nbsp;";
      print FOUT "<A HREF=\"$flagpage{$pays}\"\>" if ($geoipcity == 0 && $found{$pays} == 1 && $payslist{$pays} > $seuilsite);

      if ($pays !~ /$country_generic/ && $flagpage{$pays} !~ /^divers/) {
	  print FOUT "<A HREF=\"..$dirsepurl$dircity$dirsepurl$flagpage{$pays}\"\>" if ($geoipcity == 1 && $found_city{$pays} == 1 && $payslistcity{$pays} > $seuilsite);
      }
      if (-f "$pathinit$dirress$dirsep$dirflags$dirsep$pays$gifext") {
	  print FOUT "$L{$newflag{$pays}}";
      } else {
	  print FOUT "$tmp2 &nbsp;<I>($pays)</I>";
      }
      print FOUT "</A>" if ($geoipcity == 0 && $found{$pays} == 1 && $payslist{$pays} > $seuilsite);
      print FOUT "</A>" if ($geoipcity == 1 && $found_city{$pays} == 1 && $payslistcity{$pays} > $seuilsite && $pays !~ /$country_generic/ && $flagpage{$pays} !~ /^divers/);
      print FOUT "</TD>\n";

      print FOUT "<TD CLASS=\"left\"><B>$nbcity</B></TD>\n" if ($geoipcity == 1);

      $tmp3 = $serverpays{$pays} if ($geoipcity == 0);
      $tmp3 = $serverpayscity{$pays} if ($geoipcity == 1);
      $tmpa = $tmp3*100/($serverunique+$locserver) if ($localonly != 1);
      $tmpa = $tmp3*100/$locserver if ($localonly == 1);
      $tmp2 = int($tmpa);
      print FOUT "<TD CLASS=\"left\">\n";
      print FOUT "<IMG WIDTH=$tmp2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[4]\" ALT=\"$gcolor[4]\">&nbsp;" if ($tmp2 != 0);
#      print FOUT "<B>$serverpays{$pays}</B>";
      print FOUT "<B>$tmp3</B>";
      print FOUT "</TD>\n";
      printf FOUT "<TD CLASS=\"right\">%.1f",$tmpa;
      print FOUT "&nbsp;%</TD>\n";        

      print FOUT "<TD CLASS=\"left\">\n";
      if ($reqtot != 0) {
	  $tmp2 = int($payslist{$pays}*100/$reqtot) if ($geoipcity == 0);
	  $tmp2 = int($payslistcity{$pays}*100/$reqtot) if ($geoipcity == 1);
      }
      $tmp3 = int($tmp2);
      print FOUT "<IMG WIDTH=$tmp3 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($tmp2 != 0);
      print FOUT "<B>$payslist{$pays}</B></TD>\n" if ($geoipcity == 0);
      print FOUT "<B>$payslistcity{$pays}</B></TD>\n" if ($geoipcity == 1);
      printf FOUT "<TD CLASS=\"right\">%3.1f",$tmp2;
      print FOUT "&nbsp;%</TD>\n";

      if ($spam_found != 0 && $spamonly != 1) {
	  $tmp2 = $spam_pays{$pays}*100/$spam_found if ($geoipcity == 0);
	  $tmp2 = $spam_citypays{$pays}*100/$spam_found if ($geoipcity == 1);
          $tmp3 = int($tmp2);
	  print FOUT "<TD CLASS=\"left\">\n";
	  print FOUT "<IMG WIDTH=$tmp2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">&nbsp;" if ($tmp2 != 0);
	  print FOUT "<B>$spam_pays{$pays}</B></TD>\n" if ($geoipcity == 0);
	  print FOUT "<B>$spam_citypays{$pays}</B></TD>\n" if ($geoipcity == 1); 
	  printf FOUT "<TD CLASS=\"right\">%3.1f",$tmp3;
	  print FOUT "&nbsp;%</TD>\n";
      }

      if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	  if ($access != 0) {
	      $tmp2 = $payshtml{$pays}*100/$access if ($geoipcity == 0);
	      $tmp2 = $payshtmlcity{$pays}*100/$access if ($geoipcity == 1);
	  }
          $tmp3 = int($tmp2);
	  print FOUT "<TD CLASS=\"left\">\n";
	  print FOUT "<IMG WIDTH=$tmp3 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">&nbsp;" if ($tmp2 != 0);
	  printf FOUT "<B>%d</B></TD>\n",$payshtml{$pays} if ($geoipcity == 0);
	  printf FOUT "<B>%d</B></TD>\n",$payshtmlcity{$pays} if ($geoipcity == 1);
	  printf FOUT "<TD CLASS=\"right\">%3.1f",$tmp3;
	  print FOUT "&nbsp;%</TD>\n";
      }

      $tmp4 = $totsize if ($geoipcity == 0);
      $tmp4 = $totsizecity if ($geoipcity == 1);

      if ($notrafic == 0 && $tmp4 != 0) {
	  $tmp3 = $sizepays{$pays} if ($geoipcity == 0);
	  $tmp3 = $sizepayscity{$pays} if ($geoipcity == 1);
	  $pourcentvalue = $tmp3*100/$tmp4; # if ($geoipcity == 0);
#	  $pourcentvalue = $tmp3*100/($totsize*1024) if ($geoipcity == 0);
#	  $pourcentvalue = $tmp3*100/$totsizecity if ($geoipcity == 1);
	  $tmp = int($pourcentvalue);

	  $tmp2 = $tmp3;
	  $tmp2 /= 1024 if ($tmp_unit > 1024 && $tmp_unit < (1024*1024)); 
	  $tmp2 /= (1024*1024) if ($tmp_unit > (1024*1024) && $tmp_unit < (1024*1024*1024));
	  $tmp2 /= (1024*1024*1024) if ($tmp_unit > (1024*1024*1024) && $tmp_unit < (1024*1024*1024*1024));
	  $tmp2 /= (1024*1024*1024*1024) if ($tmp_unit > (1024*1024*1024*1024));
      
	  print FOUT "<TD CLASS=\"left\">\n";
	  print FOUT "<IMG WIDTH=$tmp HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">&nbsp;" if ($tmp != 0);
	  printf FOUT "<B>%d</B></TD>",$tmp2 if ($tmp_unit < 1024);
	  printf FOUT "<B>%.1f</B></TD>",$tmp2 if ($tmp_unit > 1024);

	  printf FOUT "\n<TD CLASS=\"right\">%3.1f",$pourcentvalue;
	  print FOUT "&nbsp;%</TD>\n";
      }
      print FOUT "</TR>\n";

      $tmpb = $payslist{$pays} if ($geoipcity == 0);
      $tmpb = $payslistcity{$pays} if ($geoipcity == 1);
      $tmpb -= $reqdomtot if ($locallog == 1);
      if ($tmpb != 0 && $locallog == 1 && $serverunique != 0 && $localonly == 0 && $pays eq substr($localdomainename,(rindex($localdomainename,'.')+1),length($localdomaine))) {
	    print FOUT "<TR>\n";
#	    print FOUT "<TD><TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0><TR>";
#	    print FOUT "<TD WIDTH=15>";
	    print FOUT "<TD CLASS=\"left\">";
	    print FOUT "<A HREF=\"$flagpage{$pays}\"\>" if ($found{$pays} == 1 && $payslist{$pays} > $seuilsite);
	    if (-f "$pathinit$dirress$dirsep$dirflags$dirsep$pays$gifext") {
		print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirflags$dirsepurl$pays$gifext\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=0 ALT=\"$pays\">";
	    } else {
		$tmp2 = "Unknown";
		print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirflags$dirsepurl$tmp2$gifext\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=0 ALT=\"$tmp2\">";
	    }
	    print FOUT "</A>" if ($found{$pays} == 1 && $payslist{$pays} > $seuilsite);
	    print FOUT "&nbsp;";
#	    print FOUT "</TD>\n";
#	    print FOUT "<TD CLASS=\"left\">";
	    print FOUT "<A HREF=\"$flagpage{$pays}\"\>" if ($found{$pays} == 1 && $payslist{$pays} > $seuilsite);
	    if (-f "$pathinit$dirress$dirsep$dirflags$dirsep$pays$gifext") {
		print FOUT "<I>$L{$newflag{$pays}}</I>";
	    } else {
		print FOUT "<I>$tmp2 ($pays)</I>";
	    }
	    print FOUT "</A>" if ($found{$pays} == 1 && $payslist{$pays} > $seuilsite);
	    print FOUT "&nbsp;<I>($L{'excluding'} $localdomainename)</I>";
	    print FOUT "</TD>";

	    print FOUT "<TD CLASS=\"left\"><B>$nbcity</B></TD>\n" if ($geoipcity == 1);

	    if ($geoipcity == 0) {
		$tmpa = ($serverpays{$pays}-$locserver)*100/($serverunique+$locserver) if ($localonly != 1);
		$tmpa = $serverpays{$pays}*100/$locserver if ($localonly == 1);
	    } else {
		$tmpa = ($serverpayscity{$pays}-$locserver)*100/($serverunique+$locserver) if ($localonly != 1);
		$tmpa = $serverpayscity{$pays}*100/$locserver if ($localonly == 1);
	    }
	    $tmp2 = int($tmpa);
	    print FOUT "<TD CLASS=\"left\">\n";
	    print FOUT "<IMG WIDTH=$tmp2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[4]\" ALT=\"$gcolor[4]\">&nbsp;" if ($tmp2 != 0);
	    printf FOUT "<I><B>%d</B></I>",($serverpays{$pays}-$locserver) if ($geoipcity == 0);
	    printf FOUT "<I><B>%d</B></I>",($serverpayscity{$pays}-$locserver) if ($geoipcity == 1);
	    print FOUT "</TD>\n";
	    printf FOUT "<TD CLASS=\"right\"><I>%.1f</I>",$tmpa;
	    print FOUT "&nbsp;%</TD>\n";

	    print FOUT "<TD CLASS=\"left\">\n";
#	    $tmpb = $payslist{$pays};
#	    $tmpb -= $reqdomtot if ($locallog == 1);
	    $tmpa = $tmpb*100/($reqtot-$reqdomtot) if ($reqtot != $reqdomtot);
	    $tmpa = 100 if ($reqtot == $reqdomtot);        
	    $tmp2 = int($tmpa);
	    print FOUT "<IMG WIDTH=$tmp2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($tmp2 != 0);
	    printf FOUT "<I><B>%d</B></I></TD>",$tmpb;
	    printf FOUT "<TD CLASS=\"right\"><I>%3.1f</I>",$tmpa;
	    print FOUT "&nbsp;%</TD>\n";

	    if ($spam_found != 0 && $spamonly != 1) {
		$tmp2 = $spam_pays{$pays}*100/$spam_found if ($geoipcity == 0);
		$tmp2 = $spam_citypays{$pays}*100/$spam_found if ($geoipcity == 1);
		$tmp3 = int($tmp2);
		print FOUT "<TD CLASS=\"left\">\n";
		print FOUT "<IMG WIDTH=$tmp2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">&nbsp;" if ($tmp2 != 0);
		print FOUT "<B>$spam_pays{$pays}</B></TD>\n" if ($geoipcity == 0);
		print FOUT "<B>$spam_citypays{$pays}</B></TD>\n" if ($geoipcity == 1);
		printf FOUT "<TD CLASS=\"right\">%3.1f",$tmp3;
		print FOUT "&nbsp;%</TD>\n";
	    }

	    if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
		$tmpb = $payshtml{$pays} if ($geoipcity == 0);
		$tmpb = $payshtmlcity{$pays} if ($geoipcity == 1);
		$tmpb -= $payshtmldom if ($locallog == 1);
		$tmpa = $tmpb*100/($access-$payshtmldom) if ($access != $payshtmldom);
		$tmpa = 100 if ($access == $payshtmldom);
		$tmp2 = int($tmpa);
		print FOUT "<TD CLASS=\"left\">\n";
		print FOUT "<IMG WIDTH=$tmp2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">&nbsp;" if ($tmp2 != 0);
		printf FOUT "<I><B>%d</B></I></TD>\n",$tmpb;
		printf FOUT "<TD CLASS=\"right\"><I>%3.1f</I>",$tmpa;        
		print FOUT "&nbsp;%</TD>\n"; 
	    }

	    if ($notrafic == 0) {
		$tmpa = $sizepays{$pays} if ($geoipcity == 0);
		$tmpa = $sizepayscity{$pays} if ($geoipcity == 1);
		$tmpa -= ($totsize-$externesize)*1024 if ($locallog == 1);
		$tmp2 = $tmpa;
		$tmp2 /= 1024 if ($tmp_unit > 1024 && $tmp_unit < (1024*1024)); 
		$tmp2 /= (1024*1024) if ($tmp_unit > (1024*1024) && $tmp_unit < (1024*1024*1024));
		$tmp2 /= (1024*1024*1024) if ($tmp_unit > (1024*1024*1024) && $tmp_unit < (1024*1024*1024*1024));
		$tmp2 /= (1024*1024*1024*1024) if ($tmp_unit > (1024*1024*1024*1024));
		# CHECK
		$pourcentvalue = $tmpa*100/$totsize;
#	    $pourcentvalue = $tmpa*100/($externesize*1024);
		$tmp = int($pourcentvalue);
		print FOUT "<TD CLASS=\"left\">\n";
		print FOUT "<IMG WIDTH=$tmp HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">&nbsp;" if ($tmp != 0);
		printf FOUT "<I><B>%d</B></I></TD>",$tmp2 if ($tmp_unit < 1024);
		printf FOUT "<I><B>%.1f</B></I></TD>",$tmp2 if ($tmp_unit > 1024);
		printf FOUT "<TD CLASS=\"right\"><I>%3.1f</I>",$pourcentvalue;        
		print FOUT "&nbsp;%</TD>\n";
	    }
	    print FOUT "</TR>\n";
        }
  }

  if ($found{Unknown} == 1) {
      $pays ="Unknown";

#      if ($geoipcity == 1) {
#	  $tmp = "country_city_".$pays;
#	  $nbcity = keys(%$tmp);
#      }

      print FOUT "<TR>\n";
      # Check
#      print FOUT "<TD WIDTH=15>";
      print FOUT "<TD CLASS=\"left\">";
      print FOUT "<A HREF=\"$unresolved\"\>" if ($reverse_geo == 0 && $payslist{$pays} > $seuilsite);
      print FOUT "<A HREF=\"Unknown$unresolved\"\>" if ($reverse_geo == 1 && $payslist{$pays} > $seuilsite);
      print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirflags$dirsepurl$pays$gifext\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=0 ALT=\"$unresolved\">";
      print FOUT "</A>" if ($payslist{$pays} > $seuilsite);
      print FOUT "&nbsp;";
      print FOUT "<A HREF=\"$unresolved\"\>" if ($reverse_geo == 0 && $payslist{$pays} > $seuilsite);
      print FOUT "<A HREF=\"Unknown$unresolved\"\>" if ($reverse_geo == 1 && $payslist{$pays} > $seuilsite);
      print FOUT "$L{'List_of_unresolved_hosts'}";
      print FOUT "</A>" if ($payslist{$pays} > $seuilsite);
      print FOUT "&nbsp;";
      print FOUT "</TD>";

      print FOUT "<TD CLASS=\"left\"><B>$nbcityunknown</B></TD>\n" if ($geoipcity == 1);

      print FOUT "<TD CLASS=\"left\">\n";
      if ($geoipcity == 0) {
	  $tmpa = $serverpays{$pays}*100/($serverunique+$locserver) if ($localonly != 1);
	  $tmpa = $serverpays{$pays}*100/$locserver if ($localonly == 1);
      } else {
	  $tmpa = $serverpayscity{$pays}*100/($serverunique+$locserver) if ($localonly != 1);
	  $tmpa = $serverpayscity{$pays}*100/$locserver if ($localonly == 1);
      }
      $tmp2 = int($tmpa);
      print FOUT "<IMG WIDTH=$tmp2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[4]\" ALT=\"$gcolor[4]\">&nbsp;" if ($tmp2 != 0);
      $serverpays{$pays} = 0 if ($serverpays{$pays} eq '');
      $serverpayscity{$pays} = 0 if ($serverpayscity{$pays} eq '');
      print FOUT "<B>$serverpays{$pays}</B>" if ($geoipcity == 0);
      print FOUT "<B>$serverpayscity{$pays}</B>" if ($geoipcity == 1);
      print FOUT "</TD>\n";
      printf FOUT "<TD CLASS=\"right\">%.1f",$tmpa;
      print FOUT "&nbsp;%</TD>\n";


      print FOUT "<TD CLASS=\"left\">\n";
#      $tmpa = $payslist{Unknown}*100/$reqtot if ($reqtot != 0);
      $tmpa = $payslist{Unknown}*100/$reqtot if ($reqtot != 0 && $geoipcity == 0);
      $tmpa = $payslistcity{Unknown}*100/$reqtot if ($reqtot != 0 && $geoipcity == 1);
      $tmp2 = int($tmpa);
      print FOUT "<IMG WIDTH=$tmp2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($tmp2 != 0);
      $payslist{$pays} = 0 if ($payslist{$pays} eq '');
      $payslistcity{$pays} = 0 if ($payslistcity{$pays} eq '');
#      print FOUT "<B>$payslist{$pays}</B></TD>\n";
      print FOUT "<B>$payslist{$pays}</B></TD>\n" if ($geoipcity == 0);
      print FOUT "<B>$payslistcity{$pays}</B></TD>\n" if ($geoipcity == 1);
      printf FOUT "<TD CLASS=\"right\">%3.1f",$tmpa;
      print FOUT "&nbsp;%</TD>\n";

      if ($spam_found != 0 && $spamonly != 1) {
	  $tmp2 = $spam_pays{$pays}*100/$spam_found if ($geoipcity == 0);
	  $tmp2 = $spam_citypays{$pays}*100/$spam_found if ($geoipcity == 1);
	  $tmp3 = int($tmp2);
	  print FOUT "<TD CLASS=\"left\">\n";
	  print FOUT "<IMG WIDTH=$tmp2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">&nbsp;" if ($tmp2 != 0);
	  print FOUT "<B>$spam_pays{$pays}</B></TD>\n" if ($geoipcity == 0);
	  print FOUT "<B>$spam_citypays{$pays}</B></TD>\n" if ($geoipcity == 1);
	  printf FOUT "<TD CLASS=\"right\">%3.1f",$tmp3;
	  print FOUT "&nbsp;%</TD>\n";
      }

      if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
#	  $tmpa = $payshtml{$pays}*100/$access if ($access != 0);
	  $tmpa = $payshtml{$pays}*100/$access if ($access != 0 && $geoipcity == 0);
	  $tmpa = $payshtmlcity{$pays}*100/$access if ($access != 0 && $geoipcity == 1);
	  $tmp2 = int($tmpa);
	  print FOUT "<TD CLASS=\"left\">\n";
	  print FOUT "<IMG WIDTH=$tmp2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">&nbsp;" if ($tmp2 != 0);
	  printf FOUT "<B>%d</B></TD>\n",$payshtml{$pays} if ($geoipcity == 0);
#	  print FOUT "<B>$payshtml{$pays}</B></TD>\n";
	  printf FOUT "<B>%d</B></TD>\n",$payshtmlcity{$pays} if ($geoipcity == 1);
	  printf FOUT "<TD CLASS=\"right\">%3.1f",$tmpa;
	  print FOUT "&nbsp;%</TD>\n";
	  }

      if ($notrafic == 0) {
#	  $pourcentvalue = $sizepays{$pays}*100/($totsize*1024);
	  $pourcentvalue = $sizepays{$pays}*100/$totsize if ($geoipcity == 0);
	  $pourcentvalue = $sizepayscity{$pays}*100/$totsize if ($geoipcity == 1);
	  $tmp = int($pourcentvalue);

	  print FOUT "<TD CLASS=\"left\">\n";
#	  $tmp2 = $sizepays{$pays}; # if ($geoipcity == 0);
	  $tmp2 = $sizepays{$pays} if ($geoipcity == 0);
	  $tmp2 = $sizepayscity{$pays} if ($geoipcity == 1);
	  $tmp2 /= 1024 if ($tmp_unit > 1024 && $tmp_unit < (1024*1024)); 
	  $tmp2 /= (1024*1024) if ($tmp_unit > (1024*1024) && $tmp_unit < (1024*1024*1024));
	  $tmp2 /= (1024*1024*1024) if ($tmp_unit > (1024*1024*1024) && $tmp_unit < (1024*1024*1024*1024));        
	  $tmp2 /= (1024*1024*1024*1024) if ($tmp_unit > (1024*1024*1024*1024));

	  print FOUT "<IMG WIDTH=$tmp HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">&nbsp;" if ($tmp != 0);
	  printf FOUT "<B>%d</B></TD>",$tmp2 if ($tmp_unit < 1024);
	  printf FOUT "<B>%.1f</B></TD>",$tmp2 if ($tmp_unit > 1024);
	  printf FOUT "\n<TD CLASS=\"right\">%3.1f",$pourcentvalue;
	  print FOUT "&nbsp;%</TD>\n";
      }

      print FOUT "</TR>\n ";
  }

  if ($locallog == 1 && $localonly == 0 && substr($localdomainename,(rindex($localdomainename,'.')+1),length($localdomaine)) =~ /\d/) {
      print FOUT "<TR>\n";
      print FOUT "<TD CLASS=\"left\"><A HREF=\"$unresolved\"\><IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirflags$dirsepurl$pays$gifext\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=0 ALT=\"$unresolved\"></A>&nbsp;\n";
      print FOUT "<A HREF=\"$unresolved\"\><I>$L{'List_of_unresolved_hosts'}</I></A>&nbsp;";
      print FOUT "<I>($L{'excluding'} $localserver)</I>";
      print FOUT "</TD>\n";

      print FOUT "<TD CLASS=\"left\"><B>$nbcity</B></TD>\n" if ($geoipcity == 1);

      print FOUT "<TD CLASS=\"left\">\n"; 
      if ($geoipcity == 0) {
	  $tmpa = $serverpays{$pays}*100/($serverunique+$locserver) if ($localonly != 1);
	  $tmpa = $serverpays{$pays}*100/$locserver if ($localonly == 1);
      } else {
	  $tmpa = $serverpayscity{$pays}*100/($serverunique+$locserver) if ($localonly != 1);
	  $tmpa = $serverpayscity{$pays}*100/$locserver if ($localonly == 1);
      }
      $tmp2 = int($tmpa);
      print FOUT "<TD CLASS=\"left\">\n";
      print FOUT "<IMG WIDTH=$tmp2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[4]\" ALT=\"$gcolor[4]\">&nbsp;" if ($tmp2 != 0);
      printf FOUT "<I><B>%d</B></I>",($serverpays{$pays}-$locserver);
      print FOUT "</TD>\n";
      printf FOUT "<TD CLASS=\"right\"><I>%.1f</I>",$tmpa;
      print FOUT "&nbsp;%</TD>\n";

      print FOUT "<TD CLASS=\"left\">\n";
      $tmpb = $payslist{$pays} if ($geoipcity == 0);
      $tmpb = $payslistcity{$pays} if ($geoipcity == 1);
      $tmpb -= $reqdomtot if ($locallog == 1 && $paysunique == 0);
      $tmpa = $tmpb*100/($reqtot-$reqdomtot) if ($reqtot != $reqdomtot);
      $tmpa = 100 if ($reqtot == $reqdomtot);
      $tmp2 = int($tmpa);
      print FOUT "<IMG WIDTH=$tmp2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($tmp2 != 0);
      printf FOUT "<I><B>%d</B></I></TD>\n",$tmpb;
      printf FOUT "<TD CLASS=\"right\"><I>%3.1f</I>",$tmpa;
      print FOUT "&nbsp;%</TD>\n";

      if ($spam_found != 0 && $spamonly != 1) {
	  $tmp2 = $spam_pays{$pays}*100/$spam_found if ($geoipcity == 0);
	  $tmp2 = $spam_citypays{$pays}*100/$spam_found if ($geoipcity == 1);
	  $tmp3 = int($tmp2);
	  print FOUT "<TD CLASS=\"left\">\n";
	  print FOUT "<IMG WIDTH=$tmp2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">&nbsp;" if ($tmp2 != 0);
	  print FOUT "<B>$spam_pays{$pays}</B></TD>\n" if ($geoipcity == 0);
	  print FOUT "<B>$spam_citypays{$pays}</B></TD>\n" if ($geoipcity == 1);
	  printf FOUT "<TD CLASS=\"right\">%3.1f",$tmp3;
	  print FOUT "&nbsp;%</TD>\n";
      }

      if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	  print FOUT "<TD CLASS=\"left\">\n";
	  $tmpb = $payshtml{$pays} if ($geoipcity == 0);
	  $tmpb = $payshtmlcity{$pays} if ($geoipcity == 1);
	  $tmpb -= $payshtmldom if ($locallog == 1 && $paysunique == 0);
	  $tmpa = $tmpb*100/($access-$payshtmldom) if ($access != $payshtmldom);
	  $tmpa = 100 if ($access == $payshtmldom);
	  $tmp2 = int($tmpa);
	  print FOUT "<IMG WIDTH=$tmp2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">&nbsp;" if ($tmp2 != 0);
	  printf FOUT "<I><B>%d</B></I></TD>\n",$tmpb;
	  printf FOUT "<TD CLASS=\"right\"><I>%3.1f</I>",$tmpa;        
	  print FOUT "&nbsp;%</TD>\n";
	  }

      if ($notrafic == 0) {
	  $tmpa = $sizepays{$pays} if ($geoipcity == 0);
	  $tmpa = $sizepayscity{$pays} if ($geoipcity == 1);
	  $tmpa -= ($totsize-$externesize)*1024 if ($locallog == 1 && $paysunique == 0);
	  $tmp2 = $tmpa;
	  $tmp2 /= 1024 if ($tmp_unit > 1024 && $tmp_unit < (1024*1024)); 
	  $tmp2 /= (1024*1024) if ($tmp_unit > (1024*1024) && $tmp_unit < (1024*1024*1024));
	  $tmp2 /= (1024*1024*1024) if ($tmp_unit > (1024*1024*1024) && $tmp_unit < (1024*1024*1024*1024));        
	  $tmp2 /= (1024*1024*1024*1024) if ($tmp_unit > (1024*1024*1024*1024));
	  $pourcentvalue = $tmpa*100/(($totsize-$domsize)*1024) if ($domsize != $totsize);        
	  $pourcentvalue = 100 if ($domsize == $totsize);        
	  $tmp = int($pourcentvalue);
	  print FOUT "<TD CLASS=\"left\">\n";
	  print FOUT "<IMG WIDTH=$tmp HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">&nbsp;" if ($tmp != 0);
	  printf FOUT "<I><B>%d</B></I></TD>",$tmp2 if ($tmp_unit < 1024);
	  printf FOUT "<I><B>%.1f</B></I></TD>",$tmp2 if ($tmp_unit > 1024);
	  printf FOUT "\n<TD CLASS=\"right\"><I>%3.1f</I>",$pourcentvalue;        
	  print FOUT "&nbsp;%</TD>\n";
      }
      print FOUT "</TR>\n";
  }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n";
#  print FOUT "<P><HR><P>\n";
  print FOUT "</BODY></HTML>\n";
}

#
##############################################################
### Countries header (unknown countries)
##############################################################
#

sub PageHeaderPaysUnknown {
  local(*FOUT,$tmp10,*L,$I) = @_;
#  local($tmp10);

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Pages'} $L{'read_by'} $L{'sites'} $L{'unresolved'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
#  print FOUT "<H2>$L{'Pages'} $L{'read_by'} $L{'sites'} $L{'unresolved'}</H2>\n";
  print FOUT "<H2>$L{'Hosts'} $L{'unresolved'}</H2>\n";
#  $tmp = int($payslist{$pays}/$serverpays{$pays})*10 if ($serverpays{$pays} != 0);
#  $tmp = 0 if ($serverpays{$pays} == 0);

#  $tmp10 = $serverpays{'Unknown'};
  $tmp10 = $max_item_page if ($tmp10 > $max_item_page);

  print FOUT "<P><HR><P>\n";
  print FOUT "<i>($L{'Only_hosts'} $L{'with_at_least'} $seuil_auto $L{'requests'} $L{'are_shown'})</i><P>\n" if ($seuil_auto > 1);

  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} $tmp10 $L{'top_external_sites'} ";
  print FOUT "($L{'among'} $unresolved_nb_hosts{$extpays}) " if ($tmp10 == $max_item_page);
  print FOUT "</I>:</DIV><P>\n";

  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe ";
  print FOUT "table-autopage:$table_big_lines_aff " if ($tmp10 > $table_big_lines_aff);
  print FOUT "table-stripeclass:alternate\" id=\"page\">\n";

#  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
#  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Cities'}&nbsp;</TH>\n" if ($geoipcity == 1);
  print FOUT "<TH class=\"table-sortable:date\">&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n";

  if ($found{Unknown} == 0 || -f "$path$lang[$nblang]$dirsep$dirpays$dirsep$extpays$unresolved") {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  }
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Requests'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
#      print FOUT "<TH class=\"table-sortable:numeric\">$L{'Different_accesses'}&nbsp;</TH>\n" if ($squid_format == 0 && $precision > 3);
  }
  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Different_accesses'}&nbsp;</TH>\n" if ($squid_format == 0 && $precision > 3);
  if ($notrafic == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit{Unknown})&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  }
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";

   if ($tmp10 > $table_big_lines_aff) {

	$tmp = int($tmp10/$table_big_lines_aff);
	if ($tmp != ($tmp10/$table_big_lines_aff)) {
	    $tmp++;
	}
    
	print FOUT "<tfoot>\n";
	print FOUT "<tr>\n";
	print FOUT "<TH>$L{'Hosts'}</TH>\n";
#	print FOUT "<TH>$L{'Cities'}</TH>\n" if ($geoipcity == 1);
	print FOUT "<TH>$L{'Last_occurence'}</TH>\n";
	if ($geoipcity == 1) {
	    print FOUT "<TH>&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
	    print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
	}
	print FOUT "<TH>$L{'Requests'}</TH>\n";
	print FOUT "<TH>$L{'Percentage'}</TH>\n";
	if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	    print FOUT "<TH>&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
	    print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
	}
	print FOUT "<TH>$L{'Different_accesses'}&nbsp;</TH>\n" if ($squid_format == 0 && $precision > 3);
	print FOUT "<TH>&nbsp;$L{'Traffic'}&nbsp;($unit{Unknown})&nbsp;</TH><TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n" if ($notrafic == 0);
	print FOUT "</tr>\n";
	print FOUT "<tr>\n";

	if ($tmp > 1) {
	    $tmp2 = 4;
	    $tmp2 += 2 if ($notrafic == 0);
	    $tmp2 += 3 if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
	    $tmp2 += 2 if ($found{Unknown} == 0);
	    $tmp2++ if ($squid_format == 0 && $precision > 3);
	    print FOUT "<td colspan=$tmp2>\n";
	    print FOUT "<a href=\"#\" onclick=\"pageexample('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	    
	    for ($i=1;$i<=$tmp;$i++) {
		$iminus = $i-1;
		print FOUT "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexample($iminus); return false;\">$i</a>\n";
	    }
	    print FOUT "<a href=\"#\" onclick=\"pageexample('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	    print FOUT "<a href=\"#\" onclick=\"pageexample('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	    print FOUT "</td>\n";
	    print FOUT "</tr>\n";
	}
	print FOUT "</tfoot>\n";
    }

  print FOUT "<tbody>\n";
}


#
##############################################################
### Countries header
##############################################################
#

sub PageHeaderPays {
  local(*FOUT,*L,$I) = @_;

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Hosts'} $L{'in'} $L{$newflag{$pays}} </TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
  print FOUT "<H2>$L{'Domain'} $L{'in'} $L{$newflag{$pays}}</H2><P>\n";

  print FOUT "<P><HR><P>\n";
  print FOUT "<I>($L{'Only_hosts'} $L{'with_at_least'} $seuilsite $L{'requests'} $L{'are_shown'})</I><P>\n" if ($seuilsite > 1);

  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Domain'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:date\">&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Requests'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  if ($spam_found != 0 && $spamonly != 1) {
      print FOUT "<TH class=\"table-sortable:numeric\">$L{'Spam'}</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n";
  }
  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  }
  if ($notrafic == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit{$pays})&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  }
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";
}


sub PageHeaderUnresolved {
  local(*FOUT,$tmp10,*L,$I) = @_;
  local($tmp,$tmp2);

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Hosts'} $L{'in'} $L{$newflag{$extpays}} </TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
  print FOUT "<H2>$L{'List_of_unresolved_hosts'} $L{'in'} $L{$newflag{$extpays}}</H2><P>\n";

#  $tmp10 = $unresolved_nb_hosts{$extpays};
  $tmp10 = $max_item_page if ($tmp10 > $max_item_page);

  print FOUT "<P><HR><P>\n";
  print FOUT "<I>($L{'Only_hosts'} $L{'with_at_least'} $seuilsite $L{'requests'} $L{'are_shown'})</I><P>\n" if ($seuilsite > 1);

  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} $tmp10 $L{'top_external_sites'} ";
  print FOUT "($L{'among'} $unresolved_nb_hosts{$extpays}) " if ($tmp10 == $max_item_page);
  print FOUT "</I>:</DIV><P>\n";

  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe ";
  print FOUT "table-autopage:$table_big_lines_aff " if ($tmp10 > $table_big_lines_aff);
  print FOUT "table-stripeclass:alternate\" id=\"page\">\n";

#  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Cities'}&nbsp;</TH>\n" if ($geoipcity == 1);
  print FOUT "<TH class=\"table-sortable:date\">&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Requests'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  if ($spam_found != 0 && $spamonly != 1) {
      print FOUT "<TH class=\"table-sortable:numeric\">$L{'Spam'}</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n";
  }
  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">$L{'Different_accesses'}&nbsp;</TH>\n" if ($squid_format == 0 && $precision > 3);

  }
# print FOUT "<TH class=\"table-sortable:numeric\">$L{'Different_accesses'}&nbsp;</TH>\n" if ($squid_format == 0 && $precision > 3);

  if ($notrafic == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit2{$extpays})&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  }
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";


   if ($tmp10 > $table_big_lines_aff) {

	$tmp = int($tmp10/$table_big_lines_aff);
	if ($tmp != ($tmp10/$table_big_lines_aff)) {
	    $tmp++;
	}
    
	print FOUT "<tfoot>\n";
	print FOUT "<tr>\n";
	print FOUT "<TH>$L{'Hosts'}</TH>\n";
	print FOUT "<TH>$L{'Cities'}</TH>\n" if ($geoipcity == 1);
	print FOUT "<TH>$L{'Last_occurence'}</TH>\n";
	print FOUT "<TH>$L{'Requests'}</TH>\n";
	print FOUT "<TH>$L{'Percentage'}</TH>\n";
	if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	    print FOUT "<TH>&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
	    print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
	    print FOUT "<TH>$L{'Different_accesses'}&nbsp;</TH>\n" if ($squid_format == 0 && $precision > 3);
	}
	if ($spam_found != 0 && $spamonly != 1) {
	    print FOUT "<TH >$L{'Spam'}</TH>\n";
	    print FOUT "<TH>$L{'Percentage'}</TH>\n";
	}
	print FOUT "<TH>&nbsp;$L{'Traffic'}&nbsp;($unit2{$extpays})&nbsp;</TH><TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n" if ($notrafic == 0);
	print FOUT "</tr>\n";
	print FOUT "<tr>\n";

	if ($tmp > 1) {
	    $tmp2 = 4;
	    $tmp2 += 2 if ($notrafic == 0);
	    $tmp2 += 2 if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
	    $tmp2++ if ($geoipcity == 1);
	    $tmp2++ if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $squid_format == 0 && $precision > 3);
	    print FOUT "<td colspan=$tmp2>\n";
	    print FOUT "<a href=\"#\" onclick=\"pageexample('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	    
	    for ($i=1;$i<=$tmp;$i++) {
		$iminus = $i-1;
		print FOUT "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexample($iminus); return false;\">$i</a>\n";
	    }
	    print FOUT "<a href=\"#\" onclick=\"pageexample('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	    print FOUT "<a href=\"#\" onclick=\"pageexample('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	    print FOUT "</td>\n";
	    print FOUT "</tr>\n";
	}
	print FOUT "</tfoot>\n";
    }

  print FOUT "<tbody>\n";

}


#
##############################################################
### Countries Cities List
##############################################################
#

sub CountryCityList {
  local(*FOUT,*L,$I,$adresse,$pays) = @_;
  local($adresse2,$tmp,$tmp2,$unit,$tmp_unit,$val,$val2,$tmp10);
  local($unit_div,$unit);

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Hosts'} $L{'from'} $adresse - $pays</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);

  $tmp = "country_city_".$pays;

  $tmp10 = $$tmp{$adresse};
  $tmp10 = $max_item_page if ($tmp10 > $max_item_page);

  print FOUT "<H2>$L{'Hosts'} $L{'from'} $adresse - $L{$newflag{$pays}}</H2><P>\n";

  print FOUT "<P><HR><P>\n";
  print FOUT "<I>($L{'Only_hosts'} $L{'with_at_least'} $seuilsite $L{'requests'} $L{'are_shown'})</I><P>\n" if ($seuilsite > 1);

  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} $tmp10 $L{'top_external_sites'} ";
  print FOUT "($L{'among'} $$tmp{$adresse}) " if ($tmp10 == $max_item_page);
  print FOUT "</I>:</DIV><P>\n";

  if ($notrafic == 0) {
      ($unit_div,$unit) = &Return_Unit($serversize{(&reverse_sort_by_value(*serversize))[0]},0);
#      print "AL2 $unit_div - $unit\n";
#      $tmp_unit = $serversize{(&reverse_sort_by_value(*serversize))[0]};
#      $tmp_unit = $localserversize{(&reverse_sort_by_value(*localserversize))[0]} if ($tmp_unit eq '');
#      $unit = "$L{'bytes'}";
#      $unit = "$L{'Kb'}" if ($tmp_unit > 1024);		    
#      $unit = "$L{'Mb'}" if ($tmp_unit > (1024*1024));
#      $unit = "$L{'Gb'}" if ($tmp_unit > (1024*1024*1024));
#      $unit = "$L{'Tb'}" if ($tmp_unit > (1024*1024*1024*1024));
  }

  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe ";
  print FOUT "table-autopage:$table_big_lines_aff " if ($tmp10 > $table_big_lines_aff);
  print FOUT "table-stripeclass:alternate\" id=\"page\">\n";
#  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:date\">&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Requests'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  }
  if ($notrafic == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  }
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";


   if ($tmp10 > $table_big_lines_aff) {

	$tmp = int($tmp10/$table_big_lines_aff);
	if ($tmp != ($tmp10/$table_big_lines_aff)) {
	    $tmp++;
	}
    
	print FOUT "<tfoot>\n";
	print FOUT "<tr>\n";
	print FOUT "<TH>$L{'Hosts'}</TH>\n";
	print FOUT "<TH>$L{'Last_occurence'}</TH>\n";
	print FOUT "<TH>$L{'Requests'}</TH>\n";
	print FOUT "<TH>$L{'Percentage'}</TH>\n";
	if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	    print FOUT "<TH>&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
	    print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
	}
	print FOUT "<TH>&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH><TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n" if ($notrafic == 0);
	print FOUT "</tr>\n";
	print FOUT "<tr>\n";

	if ($tmp > 1) {
	    $tmp2 = 4;
	    $tmp2 += 2 if ($notrafic == 0);
	    $tmp2 += 2 if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
	    print FOUT "<td colspan=$tmp2>\n";
	    print FOUT "<a href=\"#\" onclick=\"pageexample('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	    
	    for ($i=1;$i<=$tmp;$i++) {
		$iminus = $i-1;
		print FOUT "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexample($iminus); return false;\">$i</a>\n";
	    }
	    print FOUT "<a href=\"#\" onclick=\"pageexample('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	    print FOUT "<a href=\"#\" onclick=\"pageexample('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	    print FOUT "</td>\n";
	    print FOUT "</tr>\n";
	}
	print FOUT "</tfoot>\n";
    }


  print FOUT "<tbody>\n";

  for ($i=1;$i<=$$tmp{$adresse};$i++) {
#      if ($city_hosts_hit{$adresse,$i} > $seuilsite) {

      $adresse2 = $city_hosts{"$pays:$adresse",$i};
#      if ($city_pays{$adresse2} eq $pays) {
      $val = $server{$adresse2};
      $val = $localserver{$adresse2} if ($adresse2 =~ /$localdomaine/i);

      if ($val > $seuilsite) {

      $found_city_list{"$pays$adresse"} = 1;

#      if ($adresse2 =~ /[0-9]+$/ || $adresse2 =~ /:/) {
#	  $newserveur = $adresse2;
#	  $newserveur =~ s/[.:]/_/g;
 #     } else {
#	  $newserveur = $adresse2;
#	  $pospoint = index($newserveur,'.',0);
#	  $newserveur =~ s/[.:]/_/g;

#	  $saveadresse = $newserveur;
#	  if ($newserveur !~ /[0-9]$/ && $newserveur !~ /:/) {
#	      $saveadresse = substr($newserveur,$pospoint+1,(length($newserveur)-length($pospoint)));
#	      $saveadresse = $newserveur if ($saveadresse !~ /_/);
#	  }
#      }

      print FOUT "<TR>\n";
      print FOUT "<TD CLASS=\"left\">";


      $newserveur = $adresse2;
      $newserveur =~ s/[.:]/_/g;

      if ($adresse2 =~ /[0-9]+$/ || $adresse2 =~ /:/) {
	  print FOUT "<A HREF=\"..$dirsepurl$dirsite$dirsepurl$newserveur$htmlext\" TITLE=\"$resolv_user{$adresse2}\">" if ($precision > 3 && $nbpageserveur{$adresse2} > 0);
	  print FOUT "$adresse2";
	  print FOUT "</A> " if ($precision > 3 && $nbpageserveur{$adresse2} > 0);
      } else {
	  $pospoint = index($adresse2,'.',0);
	  $domadresse = substr($newserveur,$pospoint+1,(length($newserveur)-length($pospoint)));

	  if (($precision > 3 && $nbpageserveur{$adresse2} > 0) || $mail_format == 1) {
	      if ($mail_format == 0) {
		  print FOUT "<A HREF=\"..$dirsepurl$dirsite$dirsepurl$newserveur$htmlext\" TITLE=\"$resolv_user{$adresse2}\">" if ($domadresse !~ /_/);
		  if ($adresse2 =~ /$localdomaine/) {
		      print FOUT "<A HREF=\"..$dirsepurl$dirsite$dirsepurl$domadresse$htmlext#$adresse2\" TITLE=\"$resolv_user{$adresse2}\">" if ($split_localhost == 0 && $domadresse =~ /_/);
		      print FOUT "<A HREF=\"..$dirsepurl$dirsite$dirsepurl$newserveur$htmlext\" TITLE=\"$resolv_user{$adresse2}\">" if ($split_localhost == 1 && $domadresse =~ /_/);
		  } else {
		      print FOUT "<A HREF=\"..$dirsepurl$dirsite$dirsepurl$domadresse$htmlext#$adresse2\" TITLE=\"$resolv_user{$adresse2}\">" if ($domadresse =~ /_/);
		      print FOUT "<A HREF=\"..$dirsepurl$dirsite$dirsepurl$newserveur$htmlext\" TITLE=\"$resolv_user{$adresse2}\">" if ($domadresse !~ /_/);
		  }
	      } else {
		  print FOUT "<A HREF=\"..$dirsepurl$dirdomain$dirsepurl$newserveur$htmlext\">" if ($domadresse !~ /_/);
		  if ($adresse2 =~ /$localdomaine/) {
		      print FOUT "<A HREF=\"..$dirsepurl$dirdomain$dirsepurl$domadresse$htmlext#$adresse2\">" if ($split_localhost == 0 && $domadresse =~ /_/);
		      print FOUT "<A HREF=\"..$dirsepurl$dirdomain$dirsepurl$newserveur$htmlext\">" if ($split_localhost == 1 && $domadresse =~ /_/);
		  } else {
		      print FOUT "<A HREF=\"..$dirsepurl$dirdomain$dirsepurl$domadresse$htmlext#$adresse2\">" if ($domadresse =~ /_/);
		      print FOUT "<A HREF=\"..$dirsepurl$dirdomain$dirsepurl$newserveur$htmlext\">" if ($domadresse !~ /_/);
		  }
	      }
	  }
	  print FOUT "<I>" if ($adresse2 =~ /$localdomaine/);
	  print FOUT "$adresse2";
	  print FOUT "</I>" if ($adresse2 =~ /$localdomaine/);
	  print FOUT "</A> " if (($precision > 3 && $nbpageserveur{$adresse2} > 0) || $mail_format == 1);
      }



#      if ($precision > 3 && $nbpageserveur{$adresse2} != 0) {
#	  print FOUT "<A HREF=\"..$dirsepurl$dirsite$dirsepurl$saveadresse$htmlext#$adresse2\">" if ($adresse2 !~ /[0-9]+$/ && $adresse2 !~ /:/ && -f "$path$lang[$nblang]$dirsep$dirsite$dirsepurl$saveadresse$htmlext");
#	  print FOUT "<A HREF=\"..$dirsepurl$dirsite$dirsepurl$newserveur$htmlext\">" if (($adresse2 =~ /[0-9]+$/ || $adresse2 =~ /:/) && -f "$path$lang[$nblang]$dirsep$dirsite$dirsepurl$newserveur$htmlext");
#      }

#      print FOUT "<I>" if ($adresse2 =~ /$localdomaine/);
#      print FOUT "$adresse2";
#      print FOUT "</I>" if ($adresse2 =~ /$localdomaine/);

#      if ($precision > 3 && $nbpageserveur{$adresse2} != 0) {
#	  print FOUT "</A>" if ($adresse2 !~ /[0-9]+$/ && $adresse2 !~ /:/ && -f "$path$lang[$nblang]$dirsep$dirsite$dirsepurl$saveadresse$htmlext");
#	  print FOUT "</A>" if (($adresse2 =~ /[0-9]+$/ || $adresse2 =~ /:/) && -f "$path$lang[$nblang]$dirsep$dirsite$dirsepurl$newserveur$htmlext");
 #     }
      print FOUT "</TD>\n";
      print FOUT "<TD CLASS=\"right\">";
      print FOUT "$serverdate{$adresse2}" if ($adresse2 !~ /$localdomaine/);
      print FOUT "$localserverdate{$adresse2}" if ($adresse2 =~ /$localdomaine/);
      print FOUT "</TD>\n";

#      $pourcentage = (($server{$adresse2}*1000)/$city_hit{$adresse})/10;
      $pourcentage = (($val*1000)/$city_hit{"$pays:$adresse"})/10;
      $pourcentageint = int($pourcentage);

#      $a = "$pays:$adresse";
#      print "AA $val - $pays:$adresse - $city_hit{$a}\n";

      print FOUT "<TD CLASS=\"left\">&nbsp;";
      print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($pourcentageint != 0);
      print FOUT "$val</TD>\n";
      print FOUT "<TD CLASS=\"right\">&nbsp;";
      printf FOUT "%.1f",$pourcentage;
      print FOUT "&nbsp;%</TD>\n";

      if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
#      $pourcentage = (($nbpageserveur{$adresse2}*1000)/$city_access{$adresse})/10 if ($city_access{$adresse} != 0);
#      $pourcentage = 0 if ($city_access{$adresse} == 0);
	  $pourcentage = (($nbpageserveur{$adresse2}*1000)/$city_access{"$pays:$adresse"})/10 if ($city_access{"$pays:$adresse"} != 0);
	  $pourcentage = 0 if ($city_access{"$pays:$adresse"} == 0);
	  $pourcentageint = int($pourcentage);
	  print FOUT "<TD CLASS=\"left\">&nbsp;";
	  print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">&nbsp;" if ($pourcentageint != 0);
	  print FOUT "$nbpageserveur{$adresse2}</TD>\n";
	  print FOUT "<TD CLASS=\"right\">&nbsp;";
	  printf FOUT "%.1f",$pourcentage;
	  print FOUT "&nbsp;%</TD>\n";
      }

      if ($notrafic == 0) {
	  $val = $serversize{$adresse2};
	  $val = $localserversize{$adresse2} if ($adresse2 =~ /$localdomaine/);

#	  $tmp2 = $val/1024 if ($tmp_unit > 1024); 
#	  $tmp2 = $val/(1024*1024) if ($tmp_unit > (1024*1024));
#	  $tmp2 = $val/(1024*1024*1024) if ($tmp_unit > (1024*1024*1024));
#	  $tmp2 = $val/(1024*1024*1024*1024) if ($tmp_unit > (1024*1024*1024*1024));
	  $tmp2 = $val/$unit_div;
#	  print "PP $tmp2 $val $unit_div\n";
	  $tmp2 = int($tmp2*100)/100 if ($unit ne "$L{'Kb'}");			    
	  $tmp2 = int($tmp2) if ($unit eq "$L{'Kb'}");

#	  print FOUT "<TD CLASS=\"right\">$val</TD>\n";

#	  $pourcentage = (($val*1000)/$city_size{$adresse})/10 if ($city_size{$adresse} != 0);
#	  $pourcentage = 0 if ($city_size{$adresse} == 0);
	  $pourcentage = (($val*1000)/$city_size{"$pays:$adresse"})/10 if ($city_size{"$pays:$adresse"} != 0);
	  $pourcentage = 0 if ($city_size{"$pays:$adresse"} == 0);
	  $pourcentageint = int($pourcentage);

	  print FOUT "<TD CLASS=\"left\">&nbsp;";
	  print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">&nbsp;" if ($pourcentageint != 0);
	  print FOUT "$tmp2</TD>\n";
	  print FOUT "<TD CLASS=\"right\">&nbsp;";
	  printf FOUT "%.1f",$pourcentage;
	  print FOUT "&nbsp;%</TD>\n";
      }

      print FOUT "</TR>";
`
 ` }
  }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n";  
  print FOUT "</BODY></HTML>\n";
}

sub MakeCloud {
#    local($ref,$min,$max,$seuil,$mode) = @_;
    local($ref,$linkpage,$mode) = @_;
    local($line_cloud,$line_cloud_sort,$count,$val_max);
    local(%value,%value2,%value2pays);
    local($min,$max);

    %value = %$ref;
    $count = 0;
 
    $linkpage =  "<!-- langhome -->$dirsepurl$linkpage" if ($linkpage ne '');

    $val_max = $count_cloud_max;
    $val_max = keys(%value) if (keys(%value) < $count_cloud_max);

    $max = $value{(sort {$value{$b} <=> $value{$a} } keys %value)[0]};
    $min = $value{(sort {$value{$b} <=> $value{$a} } keys %value)[$count_cloud_max]};

    # subset of %value
    if ($mode == 4 && $zone != 0) {
	$min = $max;
	$max = 0;
	foreach $val (keys %value) {
	    next if ($zonepays{$val} != $zone);
	    $max = $value{$val} if ($value{$val} > $max);
	    $min = $value{$val} if ($value{$val} < $min);
	}
    }

    $fact = 0;
    $fact = ($cloudtag_max-$cloudtag_min)/($max-$min) if ($max != $min);

    $count = 0;
    foreach $val (sort {$value{$b} <=> $value{$a} } keys %value) {
	next if ($zonepays{$val} != $zone && $mode == 4 && $zone != 0);

	($pays,$adresse) = split(/:/,$val) if ($mode == 3);
#	if ($count < $count_cloud_max && $value{$val} > $seuil) { 
	if ($count < $val_max && $value{$val} != 0) { 
#	if ($count < $count_cloud_max && $value{$val} != 0) { 
	    $tmp3 = &noaccentinhtml($adresse) if ($mode == 3);

	    if ($count < $count_cloud_max) {
		$count++;
		$tmp = int($fact*$value{$val})+$cloudtag_min;
		if ($mode == 3) {
		    $value2{$adresse} = $value{$val};
		    $value2pays{$adresse} = $pays;
		}
		$value2{$val} = $value{$val} if ($mode != 3);
		# link
		if ($mode == 0) {
		    $line_cloud_sort .= "<SPAN><A HREF=\"$linkpage$val\" ";
		    $line_cloud_sort .= "STYLE=\"text-decoration: none;font-size: ".$tmp."px\" onmouseover=\"this.style.color='#209090';this.style.fontSize='".$tmp."px'\" onmouseout=\"this.style.color='$custom_link';this.style.fontSize='".$tmp."px'\" TITLE=\"$val\">";
		    $line_cloud_sort .= "$val</A></SPAN>\n";
		}
		# No link
		if ($mode == 1) {
		    $line_cloud_sort .= "<SPAN ";
		    $line_cloud_sort .= "STYLE=\"text-decoration: none;font-size: ".$tmp."px\" onmouseover=\"this.style.color='#209090';this.style.fontSize='".$tmp."px'\" onmouseout=\"this.style.color='$custom_link';this.style.fontSize='".$tmp."px'\" TITLE=\"$val\">";
		    $line_cloud_sort .= "$val</SPAN>\n";
		}
		# Status code
		if ($mode == 2) {
		    $line_cloud_sort .= "<A HREF=\"$linkpage$incstatus$val$htmlext\" " if (-f "$path$lang[$nblang]$dirsep$dirlist$dirsep$incstatus$val$htmlext");
		    $line_cloud_sort .= "<SPAN " if (!(-f "$path$lang[$nblang]$dirsep$dirlist$dirsep$incstatus$val$htmlext"));
		    $line_cloud_sort .= "STYLE=\"text-decoration: none;font-size: ".$tmp."px\" onmouseover=\"this.style.color='#209090';this.style.fontSize='".$tmp."px'\" onmouseout=\"this.style.color='$custom_link';this.style.fontSize='".$tmp."px'\" TITLE=\"$val\">";
		    $line_cloud_sort .= "$FailStatusMsgs{$val}";
		    $line_cloud_sort .= "</A>\n" if (-f "$path$lang[$nblang]$dirsep$dirlist$dirsep$incstatus$val$htmlext");
		    $line_cloud_sort .= "</SPAN>\n" if (!(-f "$path$lang[$nblang]$dirsep$dirlist$dirsep$incstatus$val$htmlext"));
		}
		# City
		if ($mode == 3) {
		    $line_cloud_sort .= "<SPAN><A HREF=\"$linkpage$pays$tmp3$htmlext\" " if ($found_city_list{"$pays$tmp3"} == 1);
		    $line_cloud_sort .= "<SPAN " if ($found_city_list{"$pays$tmp3"} != 1);
		    $line_cloud_sort .= "STYLE=\"text-decoration: none;font-size: ".$tmp."px\" onmouseover=\"this.style.color='#209090';this.style.fontSize='".$tmp."px'\" onmouseout=\"this.style.color='$custom_link';this.style.fontSize='".$tmp."px'\" TITLE=\"$adresse\">";
		    $line_cloud_sort .= "$adresse";
		    $line_cloud_sort .= "</A></SPAN>\n" if ($found_city_list{"$pays$tmp3"} == 1);
		    $line_cloud_sort .= "</SPAN>\n" if ($found_city_list{"$pays$tmp3"} != 1);
		}
		# Pays
		if ($mode == 4) {
		    $link = '';
		    $link =  "<A HREF=\"$linkpage$flagpage{$val}\" " if ($geoipcity == 0 && $found{$val} == 1 && $value{$val} > $seuilsite);
		    if ($val !~ /$country_generic/ && $flagpage{$val} !~ /^divers/) {
			$link = "<A HREF=\"..$dirsepurl$dircity$dirsepurl$flagpage{$val}\" " if ($geoipcity == 1 && $found_city{$val} == 1 && $value{$val} > $seuilsite);
		    }
		    if ($link eq '') {
			$line_cloud_sort .= "<SPAN ";
		    } else {
			$line_cloud_sort .= "$link";
		    }
		    $line_cloud_sort .= "STYLE=\"text-decoration: none;font-size: ".$tmp."px\" onmouseover=\"this.style.color='#209090';this.style.fontSize='".$tmp."px'\" onmouseout=\"this.style.color='$custom_link';this.style.fontSize='".$tmp."px'\" TITLE=\"$L{$newflag{$val}}\">";
		    $line_cloud_sort .= "$L{$newflag{$val}}";
		    $line_cloud_sort .= "</A>\n" if ($link ne '');
		    $line_cloud_sort .= "</SPAN>\n" if ($link eq '');
		}
		# Keywords
		if ($mode == 5) {
		    $line_cloud_sort .= "<A HREF=\"$linkpage$w_max{$val}\" ";
		    $line_cloud_sort .= "STYLE=\"text-decoration: none;font-size: ".$tmp."px\" onmouseover=\"this.style.color='#209090';this.style.fontSize='".$tmp."px'\" onmouseout=\"this.style.color='$custom_link';this.style.fontSize='".$tmp."px'\" TITLE=\"$w_max{$val}\">";
		    $line_cloud_sort .= "$val</A>\n";
		}
	    }
	}
    }


    foreach $val (sort keys %value2) {
#	($pays,$adresse2) = split(/:/,$val) if ($mode == 3);
#	    $tmp3 = &noaccentinhtml($adresse2) if ($mode == 3);
	if ($mode == 3) {
	    $tmp3 = &noaccentinhtml($val);
	    $pays = $value2pays{$val};
	}

		$tmp = int($fact*$value2{$val})+$cloudtag_min;
		if ($mode == 0) {
		    $line_cloud .= "<SPAN><A HREF=\"$linkpage$val\" ";
		    $line_cloud .= "STYLE=\"text-decoration: none;font-size: ".$tmp."px\" onmouseover=\"this.style.color='#209090';this.style.fontSize='".$tmp."px'\" onmouseout=\"this.style.color='$custom_link';this.style.fontSize='".$tmp."px'\" TITLE=\"$val\">";
		    $line_cloud .= "$val</A></SPAN>\n";
		}
		if ($mode == 1) {
		    $line_cloud .= "<SPAN ";
		    $line_cloud .= "STYLE=\"text-decoration: none;font-size: ".$tmp."px\" onmouseover=\"this.style.color='#209090';this.style.fontSize='".$tmp."px'\" onmouseout=\"this.style.color='$custom_link';this.style.fontSize='".$tmp."px'\" TITLE=\"$val\">";
		    $line_cloud .= "$val</SPAN>\n";
		}
		if ($mode == 2) {
		    $line_cloud .= "<A HREF=\"$linkpage$incstatus$val$htmlext\" " if (-f "$path$lang[$nblang]$dirsep$dirlist$dirsep$incstatus$val$htmlext");
		    $line_cloud .= "<SPAN " if !(-f "$path$lang[$nblang]$dirsep$dirlist$dirsep$incstatus$val$htmlext");
		    $line_cloud .= "STYLE=\"text-decoration: none;font-size: ".$tmp."px\" onmouseover=\"this.style.color='#209090';this.style.fontSize='".$tmp."px'\" onmouseout=\"this.style.color='$custom_link';this.style.fontSize='".$tmp."px'\" TITLE=\"$val\">";
		    $line_cloud .= "$FailStatusMsgs{$val}";
		    $line_cloud .= "</A>\n" if (-f "$path$lang[$nblang]$dirsep$dirlist$dirsep$incstatus$val$htmlext");
		    $line_cloud .= "</SPAN>\n" if !(-f "$path$lang[$nblang]$dirsep$dirlist$dirsep$incstatus$val$htmlext");
		}
		if ($mode == 3) {
		    $tmp = int($fact*$value{"$pays:$val"})+$cloudtag_min;
		    $line_cloud .= "<SPAN><A HREF=\"$linkpage$pays$tmp3$htmlext\" " if ($found_city_list{"$pays$val"} == 1);
		    $line_cloud .= "<SPAN " if ($found_city_list{"$pays$val"} != 1);
		    $line_cloud .= "STYLE=\"text-decoration: none;font-size: ".$tmp."px\" onmouseover=\"this.style.color='#209090';this.style.fontSize='".$tmp."px'\" onmouseout=\"this.style.color='$custom_link';this.style.fontSize='".$tmp."px'\" TITLE=\"$val\">";
		    $line_cloud .= "$val";
		    $line_cloud .= "</A></SPAN>\n" if ($found_city_list{"$pays$val"} == 1);
		    $line_cloud .= "</SPAN>\n" if ($found_city_list{"$pays$val"} != 1);
		}
		# Pays
		if ($mode == 4) {
		    $link = '';
		    $link =  "<A HREF=\"$linkpage$flagpage{$val}\" " if ($geoipcity == 0 && $found{$val} == 1 && $value{$val} > $seuilsite);
		    if ($val !~ /$country_generic/ && $flagpage{$val} !~ /^divers/) {
			$link = "<A HREF=\"..$dirsepurl$dircity$dirsepurl$flagpage{$val}\" " if ($geoipcity == 1 && $found_city{$val} == 1 && $value{$val} > $seuilsite);
		    }
		    if ($link eq '') {
			$line_cloud .= "<SPAN ";
		    } else {
			$line_cloud .= "$link";
		    }
		    $line_cloud .= "STYLE=\"text-decoration: none;font-size: ".$tmp."px\" onmouseover=\"this.style.color='#209090';this.style.fontSize='".$tmp."px'\" onmouseout=\"this.style.color='$custom_link';this.style.fontSize='".$tmp."px'\" TITLE=\"$L{$newflag{$val}}\">";
		    $line_cloud .= "$L{$newflag{$val}}";
		    $line_cloud .= "</A>\n" if ($link ne '');
		    $line_cloud .= "</SPAN>\n" if ($link eq '');
		}
		if ($mode == 5) {
		    $line_cloud .= "<A HREF=\"$linkpage$w_max{$val}\" ";
		    $line_cloud .= "STYLE=\"text-decoration: none;font-size: ".$tmp."px\" onmouseover=\"this.style.color='#209090';this.style.fontSize='".$tmp."px'\" onmouseout=\"this.style.color='$custom_link';this.style.fontSize='".$tmp."px'\" TITLE=\"$w_max{$val}\">";
		    $line_cloud .= "$val</A>\n";
		}
    }

    undef %value2;

    return ($line_cloud, $line_cloud_sort);
}

#
##############################################################
### Cities
##############################################################
#

sub Cities {
    local(*FOUT,*L,$I,$display_all) = @_;
    local($tmp3,$tmp4,$pays,$count);

    print FOUT "$doctype\n";
#    print FOUT "<HTML><HEAD>\n";
    print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
    print FOUT "$charset\n";
    print FOUT "<TITLE>$L{'Cities'}</TITLE>\n";
    print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
    print FOUT "$curvy_bottom_jss\n";
    &add_jqplot_js(*FOUT,2);
    &add_css_style(*FOUT,2);

    $tmp10 = keys(%citylist);

    print FOUT "</HEAD>\n";
    print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
    &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);    
    print FOUT "<H2>$L{'Cities'}</H2><P>\n";

    print FOUT "<P>\n";

    &help_div(*FOUT);

    if ($linkpath_url ne '' && $display_all == 0) {
	$datafileinc = $linkpath_url.$dirinc.$dirsepurl.$filecity."_search".$txtext;
	$string_title = "$L{'Search'}:$L{'Search_on'}:$L{'No_item_found'}:$L{'Processing'}";
	$string_th = "$L{'Cities'}:$L{'Region_name'}:$L{'Countries'}:$L{'Hosts'}:$L{'Requests'}:$L{'Accesses'}:$L{'Traffic'}:$L{'Mb'}";
	
	print FOUT "<P>";
	print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'Search'}</I> :</DIV><P>\n";

	print FOUT "<FORM method=\"POST\" name=\"ajax\" action=\"javascript:SearchVirtual()\">\n";
	print FOUT "<TABLE BORDER=0><TR>\n";
	print FOUT "<TD VALIGN=MIDDLE>";
#	print FOUT "<TD VALIGN=MIDDLE onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$L{'Title_search_cities'}','$L{'Line_search_cities'}','$L{'Desc_search_cities'}','$L{'Link_search_cities'}',0,'','$help_width')\">";
	print FOUT "<INPUT type=\"hidden\" name=\"precision\" value=\"$precision\">\n";
	print FOUT "<INPUT type=\"hidden\" name=\"seuilsite\" value=\"$seuilsite\">\n";
	print FOUT "<INPUT type=\"hidden\" name=\"notrafic\"  value=\"$notrafic\">\n";
	print FOUT "<INPUT type=\"hidden\" name=\"seuil_auto\" value=\"$seuil_auto\">\n";
	if ($ftp_format == 0 && $squid_format == 0 && $mail_format == 0) {
	    print FOUT "<INPUT type=\"hidden\" name=\"aff_access\" value=\"1\">\n";
	} else {
	    print FOUT "<INPUT type=\"hidden\" name=\"aff_access\" value=\"0\">\n";
	}
	print FOUT "<INPUT type=\"hidden\" name=\"stats\" value=\"city\">\n";
	print FOUT "<INPUT type=\"hidden\" name=\"datafile\" value=\"$datafileinc\">\n";
	print FOUT "<INPUT type=\"hidden\" name=\"string_th\"  value=\"$string_th\">\n";
	print FOUT "<INPUT type=\"hidden\" name=\"string_title\"  value=\"$string_title\">\n";
	print FOUT "<INPUT type=\"hidden\" name=\"string_sep\"  value=\"\t\">\n";
	print FOUT "<INPUT type=\"hidden\" name=\"index_hit\"  value=\"1\">\n";

	print FOUT "<TABLE BORDER=0><TR>\n";
	print FOUT "<TH ALIGN=CENTER onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$L{'Title_search_cities'}','$L{'Line_search_cities'}','$L{'Desc_search_cities'}','$L{'Link_search_cities'}',0,'','$help_width')\">";
	print FOUT "$L{'Search'}</TH>\n";
	print FOUT "</TR><TR>\n";
	print FOUT "<TD>\n";
#	print FOUT "<INPUT type=\"text\" id=\"txtSearch\" name=\"search_value\"  value=\"\" onkeyup=\"searchSuggest();\" autocomplete=\"off\" OnFocus=\"javascript:clean()\">\n";
	print FOUT "<INPUT type=\"text\" id=\"txtSearch\" name=\"search_value\"  value=\"\" onkeyup=\"searchSuggest();\" OnBlur=\"javascript:clean_focus()\" OnFocus=\"javascript:clean()\">\n";
	print FOUT "<div id=\"search_suggest\"></div>\n";
	print FOUT "</TD>\n";
	print FOUT "</TR></TABLE>\n";
	print FOUT "</TD><TD VALIGN=TOP>";

	print FOUT "<TABLE BORDER=0><TR>\n";
	print FOUT "<TH COLSPAN=2 ALIGN=CENTER>$L{'Requests'}</TH>\n";
	print FOUT "</TR><TR>\n";
	print FOUT "<TD>$L{'Threshold'}</TD><TD><INPUT type=\"text\" size=\"3\" name=\"search_threshold\"  value=\"$seuilsite\"></TD>\n";
	print FOUT "</TR></TABLE>\n";
	print FOUT "</TD><TD VALIGN=MIDDLE>";
	print FOUT "<INPUT type=\"submit\" name=\"search_button\"  class=\"submit_button\" value=\"$L{'Search'}\">\n";
	print FOUT "</TD></TR></TABLE>";
	print FOUT "</FORM><P>\n";

	print FOUT "<DIV ID=\"search_header\"></DIV>\n";
	print FOUT "<DIV ID=\"search_results\"></DIV>\n";
	print FOUT "<BR><P>\n";
    }

    #

#    $max = $citylist{(&reverse_sort_by_value(*citylist))[0]};
#    $min = $citylist{(&reverse_sort_by_value(*citylist))[$count_cloud_max]};

    if ($display_all == 0) {

    ($line_cloud,$line_cloud_sort) = &MakeCloud(\%citylist,'',3);

    print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
    print FOUT "<TR><TD VALIGN=TOP>\n";

    $city_pie = "city_pie1".$gifext;
    $tmp = $serverunique+$locserver if ($localonly != 1);
    $tmp = $locserver if ($localonly == 1);

    if ($fly_set == 0) {
	$chart_id = 0;
	$info = "info".$chart_id;
	$line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%citylist,\@serie_color,$tmp,3,1,$unit,$chart_id,0,$info,"","",$dircity);
    }

    ($line_pie,$map_city_pie) = &MakePieChart($city_pie,$tmp,\%citylist,3,0,'',$rayon) if ($fly_set == 1);

    print FOUT "<DIV ID=\"tog_hosts\" STYLE=\"display:inline\">";
    print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
    print FOUT "<TR><TD ALIGN=CENTER VALIGN=MIDDLE>";
    print FOUT "<TABLE BORDER=0>";
    print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Cities'}</TH></TR>";
    print FOUT "$line_pie";
    print FOUT "</TABLE>\n";
    print FOUT "</TD>\n";
  
    print FOUT "<TD ALIGN=CENTER>";
    print FOUT "<IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$city_pie\" USEMAP=\"#map_city_graph\" BORDER=0 ALT=\"graph\">\n" if ($fly_set == 1);
    if ($fly_set == 0) {
	print FOUT "<div id=\"";
	print FOUT "chart".$chart_id;
	print FOUT "\" ";
	print FOUT "style=\"";
	print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
	print FOUT "</div>\n";
    }
    print FOUT "<P><I>$L{'Hosts'} - ";
    if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	print FOUT "<A HREF=\"javascript:ToggleAlpha('tog_req','tog_acc','tog_hosts','tog_traffic');\">" if ($fly_set == 1);
	print FOUT "<A HREF=\"javascript:ToggleJqplotGraph4(plot1,'tog_req','tog_acc','tog_hosts','tog_traffic');\">" if ($fly_set == 0);
    } else {
	print FOUT "<A HREF=\"javascript:ToggleDelta('tog_req','tog_hosts','tog_traffic');\">" if ($fly_set == 1);
	print FOUT "<A HREF=\"javascript:ToggleJqplotGraph3(plot1,'tog_req','tog_hosts','tog_traffic');\">" if ($fly_set == 0);
    }
    print FOUT "$L{'Requests'}</A> ";
    if ($fly_set == 1) {
	print FOUT "- <A HREF=\"javascript:ToggleAlpha('tog_acc','tog_req','tog_hosts','tog_hosts');\">$L{'Accesses'}</A> " if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
    }
    if ($fly_set == 0) {
	print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph4(plot2,'tog_acc','tog_req','tog_hosts','tog_hosts');\">$L{'Accesses'}</A> " if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
    }

    if ($notrafic == 0) {
	if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	    print FOUT "- <A HREF=\"javascript:ToggleAlpha('tog_traffic','tog_hosts','tog_req','tog_acc');\">" if ($fly_set == 1);
	    print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph4(plot3,'tog_traffic','tog_hosts','tog_req','tog_acc');\">" if ($fly_set == 0);
	} else {
	    print FOUT "- <A HREF=\"javascript:ToggleDelta('tog_traffic','tog_hosts','tog_req');\">" if ($fly_set == 1);
	    print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph3(plot2,'tog_traffic','tog_hosts','tog_req');\">" if ($fly_set == 0);
	}
	print FOUT "$L{'Traffic'}</A>";
    }
    print FOUT "</I></TD></TR></TABLE>\n";

    if ($fly_set == 1) {
	print FOUT "<MAP NAME=\"map_city_graph\">\n";
	$tmp = $map_city_pie;
	$tmp =~ s/<!-- langhome -->/$I/g;
	print FOUT "$tmp";
	print FOUT "</MAP>\n";
    }
    if ($fly_set == 0) {
	if ($xmax_jqplot != $xmax_home_jqplot) {
	    print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
	}
	print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
    }
    print FOUT "</DIV>";


   if ($fly_set == 0) {
	$chart_id++;
	$line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%city_hit,\@serie_color,$reqtot,3,1,$unit,$chart_id,0,"info2","","",$dircity);
    }

    if ($fly_set == 1) {
	$city_pie = "city_pie2".$gifext;
	($line_pie,$map_city_pie) = &MakePieChart($city_pie,$reqtot,\%city_hit,3,0,'',$rayon);
    }

    print FOUT "<DIV ID=\"tog_req\" STYLE=\"display:none\">";
    print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
    print FOUT "<TR><TD ALIGN=CENTER VALIGN=MIDDLE>";
    print FOUT "<TABLE BORDER=0>";
    print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Cities'}</TH></TR>";
    print FOUT "$line_pie";
    print FOUT "</TABLE>\n";
    print FOUT "</TD>\n";
    
    print FOUT "<TD ALIGN=CENTER>";
    print FOUT "<IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$city_pie\" USEMAP=\"#map_city2_graph\" BORDER=0 ALT=\"graph\">\n" if ($fly_set == 1);
   if ($fly_set == 0) {
	print FOUT "<div id=\"";
	print FOUT "chart".$chart_id;
	print FOUT "\" ";
	print FOUT "style=\"";
	print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
	print FOUT "</div>\n";
    }
    print FOUT "<P><I>";
    if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	print FOUT "<A HREF=\"javascript:ToggleAlpha('tog_hosts','tog_req','tog_acc','tog_traffic');\">" if ($fly_set == 1);
	print FOUT "<A HREF=\"javascript:ToggleJqplotGraph4(plot0,'tog_hosts','tog_req','tog_acc','tog_traffic');\">" if ($fly_set == 0);
    } else {
	print FOUT "<A HREF=\"javascript:ToggleDelta('tog_hosts','tog_req','tog_traffic');\">" if ($fly_set == 1);
	print FOUT "<A HREF=\"javascript:ToggleJqplotGraph3(plot0,'tog_hosts','tog_req','tog_traffic');\">" if ($fly_set == 0);
    }
    print FOUT "$L{'Hosts'}</A> - $L{'Requests'} ";
    if ($fly_set == 1) {
	print FOUT "- <A HREF=\"javascript:ToggleAlpha('tog_acc','tog_req','tog_traffic','tog_hosts');\">$L{'Accesses'}</A> " if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
    }
   if ($fly_set == 0) {
	print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph4(plot2,'tog_acc','tog_req','tog_traffic','tog_hosts');\">$L{'Accesses'}</A> " if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
    }

    if ($notrafic == 0) {
	if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	    print FOUT "- <A HREF=\"javascript:ToggleAlpha('tog_traffic','tog_hosts','tog_req','tog_acc');\">" if ($fly_set == 1);
	    print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph4(plot3,'tog_traffic','tog_hosts','tog_req','tog_acc');\">" if ($fly_set == 0);
	} else {
	    print FOUT "- <A HREF=\"javascript:ToggleDelta('tog_traffic','tog_hosts','tog_req');\">" if ($fly_set == 1);
	    print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph3(plot2,'tog_traffic','tog_hosts','tog_req');\">" if ($fly_set == 0);
	}
	print FOUT "$L{'Traffic'}</A>";
    }
    print FOUT "</I></TD></TR></TABLE>\n";

    if ($fly_set == 1) {
	print FOUT "<MAP NAME=\"map_city2_graph\">\n";
	$tmp = $map_city_pie;
	$tmp =~ s/<!-- langhome -->/$I/g;
	print FOUT "$tmp";
	print FOUT "</MAP>\n";
    }
    if ($fly_set == 0) {
	if ($xmax_jqplot != $xmax_home_jqplot) {
	    print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
	}
	print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
    }
    print FOUT "</DIV>";

    if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {

	if ($fly_set == 0) {
	    $chart_id++;
	    $info = "info".$chart_id;
	    $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%city_access,\@serie_color,$reqtot,3,1,$unit,$chart_id,0,$info,"","",$dircity);
	}

	if ($fly_set == 1) {
	    $city_pie = "city_pie3".$gifext;
	    ($line_pie,$map_city_pie) = &MakePieChart($city_pie,$access,\%city_access,3,0,'',$rayon);
	}

	print FOUT "<DIV ID=\"tog_acc\" STYLE=\"display:none\">";
	print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
	print FOUT "<TR><TD ALIGN=CENTER VALIGN=MIDDLE>";
	print FOUT "<TABLE BORDER=0>";
	print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Cities'}</TH></TR>";
	print FOUT "$line_pie";
	print FOUT "</TABLE>\n";
	print FOUT "</TD>\n";
    
	print FOUT "<TD ALIGN=CENTER>";
	print FOUT "<IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$city_pie\" USEMAP=\"#map_city3_graph\" BORDER=0 ALT=\"graph\">\n" if ($fly_set == 1);
	if ($fly_set == 0) {
	    print FOUT "<div id=\"";
	    print FOUT "chart".$chart_id;
	    print FOUT "\" ";
	    print FOUT "style=\"";
	    print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
	    print FOUT "</div>\n";
	}
	print FOUT "<P><I><A HREF=\"javascript:ToggleAlpha('tog_hosts','tog_req','tog_acc','tog_traffic');\">$L{'Hosts'}</A> - <A HREF=\"javascript:ToggleAlpha('tog_req','tog_acc','tog_hosts','tog_hosts');\">$L{'Requests'}</A> - $L{'Accesses'} " if ($fly_set == 1);
	print FOUT "<P><I><A HREF=\"javascript:ToggleJqplotGraph4(plot0,'tog_hosts','tog_req','tog_acc','tog_traffic');\">$L{'Hosts'}</A> - <A HREF=\"javascript:ToggleJqplotGraph4('plot1','tog_req','tog_acc','tog_hosts','tog_hosts');\">$L{'Requests'}</A> - $L{'Accesses'} " if ($fly_set == 0);
	if ($notrafic == 0) {
	    print FOUT "- <A HREF=\"javascript:ToggleAlpha('tog_traffic','tog_hosts','tog_req','tog_acc');\">$L{'Traffic'}</A>" if ($fly_set == 1);
	    if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
		print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph4(plot3,'tog_traffic','tog_hosts','tog_req','tog_acc');\">$L{'Traffic'}</A>" if ($fly_set == 0);
	    } else {
		print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph3(plot2,'tog_traffic','tog_hosts','tog_req');\">$L{'Traffic'}</A>" if ($fly_set == 0);
	    }
	}
	print FOUT "</I></TD></TR></TABLE>\n";

	if ($fly_set == 1) {
	    print FOUT "<MAP NAME=\"map_city3_graph\">\n";
	    $tmp = $map_city_pie;
	    $tmp =~ s/<!-- langhome -->/$I/g;
	    print FOUT "$tmp";
	    print FOUT "</MAP>\n";
	}
	if ($fly_set == 0) {
	    if ($xmax_jqplot != $xmax_home_jqplot) {
		print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
	    }
	    print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
	}
	print FOUT "</DIV>";
    }

    if ($notrafic == 0) {

	if ($fly_set == 0) {
	    $chart_id++;
	    $info = "info".$chart_id;
	    $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%city_size,\@serie_color,$sizepayscity,3,$unit_div,$unit,$chart_id,0,$info,"","",$dircity);
	}

	if ($fly_set == 1) {
	    $city_pie = "city_pie4".$gifext;
#	    $tmp = $sizepayscity*1024;
	    $tmp = $sizepayscity;
	    ($line_pie,$map_city_pie) = &MakePieChart($city_pie,$tmp,\%city_size,3,1,'',$rayon);
	}
	
	print FOUT "<DIV ID=\"tog_traffic\" STYLE=\"display:none\">";
	print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
	print FOUT "<TR><TD ALIGN=CENTER VALIGN=MIDDLE>";
	print FOUT "<TABLE BORDER=0>";
	print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Cities'}</TH></TR>";
	print FOUT "$line_pie";
	print FOUT "</TABLE>\n";
	print FOUT "</TD>\n";
	
	print FOUT "<TD ALIGN=CENTER>";
	print FOUT "<IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$city_pie\" USEMAP=\"#map_city4_graph\" BORDER=0 ALT=\"graph\">\n" if ($fly_set == 1);
	if ($fly_set == 0) {
	    print FOUT "<div id=\"";
	    print FOUT "chart".$chart_id;
	    print FOUT "\" ";
	    print FOUT "style=\"";
	    print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
	    print FOUT "</div>\n";
	}
	print FOUT "<P><I>";
	if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	    print FOUT "<A HREF=\"javascript:ToggleAlpha('tog_hosts','tog_req','tog_acc','tog_traffic');\">" if ($fly_set == 1);
	} else {
	    print FOUT "<A HREF=\"javascript:ToggleJqplotGraph3(plot0,'tog_hosts','tog_req','tog_traffic');\">" if ($fly_set == 0);
	}
	print FOUT "$L{'Hosts'}</A> - ";
	if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	    print FOUT "<A HREF=\"javascript:ToggleAlpha('tog_req','tog_hosts','tog_acc','tog_traffic');\">" if ($fly_set == 1);
	} else {
	    print FOUT "<A HREF=\"javascript:ToggleJqplotGraph3(plot1,'tog_req','tog_hosts','tog_traffic');\">" if ($fly_set == 0);
	}
	print FOUT "$L{'Requests'}</A> ";
	if ($fly_set == 1) {
	    print FOUT "- <A HREF=\"javascript:ToggleAlpha('tog_acc','tog_req','tog_hosts','tog_traffic');\">$L{'Accesses'}</A> " if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
	}
	if ($fly_set == 0) {
	    print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph4(plot2,'tog_acc','tog_req','tog_hosts','tog_traffic');\">$L{'Accesses'}</A> " if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
	}
	print FOUT "- $L{'Traffic'}";
	print FOUT "</I></TD></TR></TABLE>\n";

	if ($fly_set == 1) {
	    print FOUT "<MAP NAME=\"map_city4_graph\">\n";
	    $tmp = $map_city_pie;
	    $tmp =~ s/<!-- langhome -->/$I/g;
	    print FOUT "$tmp";
	    print FOUT "</MAP>\n";
	}
	if ($fly_set == 0) {
	    if ($xmax_jqplot != $xmax_home_jqplot) {
		print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
	    }
	    print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
	}
	print FOUT "</DIV>";
    }

    print FOUT "</TD><TD VALIGN=TOP align=\"justify\">";

    print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'Sort'} : <A HREF=\"javascript:ToggleBeta('tog_alpha','tog_value');\">$L{'Alphabetically'}</A> - <A HREF=\"javascript:ToggleBeta('tog_value','tog_alpha');\">$L{'By_size'}</A></DIV><P>";

    print FOUT "<DIV ID=\"tog_alpha\" STYLE=\"display:inline\">";
    print FOUT "$line_cloud\n";
    print FOUT "</DIV>\n";
    print FOUT "<P>";

    print FOUT "<DIV ID=\"tog_value\" STYLE=\"display:none\">";
    print FOUT "$line_cloud_sort\n";
    print FOUT "</DIV>\n";


    print FOUT "</TD></TR>\n";
    print FOUT "</TABLE>\n";
    }

    #
    ($unit_div,$unit) = &Return_Unit($city_size{(&reverse_sort_by_value(*city_size))[0]},0);

    print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'Cities'}</I> : $tmp10 \n";
    print FOUT "(<A HREF=\"$listcity\">$L{'Full_list'}</A>)" if ($show_all == 1 && $display_all == 0);
    print FOUT "</DIV><P>\n";
    print FOUT "<I>($L{'Only_cities'} $L{'with_at_least'} $seuilsite $L{'hosts'} $L{'are_shown'})</I><P>\n" if ($seuilsite > 1 && $display_all == 0);

    print FOUT "\n<table class=\"tablesort  table-autosort table-autostripe table-stripeclass:alternate\">\n";
    print FOUT "<thead>\n";
    print FOUT "<TR>\n";
    print FOUT "<TH class=\"table-sortable:default\">$L{'Cities'}</TH>\n";
    print FOUT "<TH class=\"table-sortable:default\">$L{'Region_name'}</TH>\n";
    print FOUT "<TH class=\"table-sortable:default\">$L{'Countries'}</TH>\n";
    print FOUT "<TH class=\"table-sortable:numeric\">$L{'Hosts'}</TH>\n";
    print FOUT "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n";
    print FOUT "<TH class=\"table-sortable:numeric\">$L{'Requests'}</TH>\n";
    print FOUT "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n";
    if ($spam_found != 0 && $spamonly != 1) {
	print FOUT "<TH class=\"table-sortable:numeric\">$L{'Spam'}</TH>\n";
	print FOUT "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n";
    }
    if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
	print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
    }
    if ($notrafic == 0) {
	print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n";
	print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
    }
    print FOUT "</TR>\n";
    print FOUT "</thead>\n";

  if ($display_all == 1 && $tmp10 > $table_big_lines_aff) {

      $tmp = int($tmp10/$table_big_lines_aff);
      if ($tmp != ($tmp10/$table_big_lines_aff)) {
	  $tmp++;
      }

      print FOUT "<tfoot>\n";
      print FOUT "<tr>\n";
      print FOUT "<TH>&nbsp;$L{'Cities'}&nbsp;</TH>\n";
      print FOUT "<TH>&nbsp;$L{'Region_name'}&nbsp;</TH>\n";
      print FOUT "<TH>&nbsp;$L{'Countries'}&nbsp;</TH>\n";
      print FOUT "<TH>&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
      print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      print FOUT "<TH>&nbsp;$L{'Requests'}&nbsp;</TH>\n";
      print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      if ($spam_found != 0 && $spamonly != 1) {
	  print FOUT "<TH>$L{'Spam'}</TH>\n";
	  print FOUT "<TH>$L{'Percentage'}</TH>\n";
      }
      if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	  print FOUT "<TH>&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
	  print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      }
      if ($notrafic == 0) {
	  print FOUT "<TH>&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n";
	  print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      }

      print FOUT "</tr>\n";
      print FOUT "<tr>\n";
      
      if ($tmp > 1) {
	  $tmp2 = 7;
	  $tmp2 += 2 if ($spam_found != 0 && $spamonly != 1);
	  $tmp2 += 2 if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
	  $tmp2 += 2 if ($notrafic == 0);
	  print FOUT "<td colspan=$tmp2>\n";
	  print FOUT "<a href=\"#\" onclick=\"pageexample('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	  
	  for ($i=1;$i<=$tmp;$i++) {
	      $iminus = $i-1;
	      print FOUT "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexample($iminus); return false;\">$i</a>\n";
	  }
	  print FOUT "<a href=\"#\" onclick=\"pageexample('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "<a href=\"#\" onclick=\"pageexample('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "</td>\n";
	  print FOUT "</tr>\n";
      }
      print FOUT "</tfoot>\n";
      
  }


    print FOUT "<tbody>\n";


#    $tmp_unit =  $city_size{(&reverse_sort_by_value(*city_size))[0]};

    $count = 0;
    foreach $value (&reverse_sort_by_value(*citylist)) {
	($pays,$adresse2) = split(/:/,$value);
	if (($citylist{$value} > $seuilsite && $display_all == 0) || ($count < $max_item_page && $display_all == 1)) {
	    $tmp3 = &noaccentinhtml($adresse2);
	    $count++;

	    print FOUT "<TR>\n";
	    print FOUT "<TD CLASS=\"left\">";
	    print FOUT "<A HREF=\"$pays$tmp3$htmlext\">" if ($found_city_list{"$pays$adresse2"} == 1);
	    print FOUT "$adresse2";
	    print FOUT "</A>" if ($found_city_list{"$pays$adresse2"} == 1);
	    print FOUT "</TD>\n";
	    print FOUT "<TD CLASS=\"left\">$city_region{$value}</TD>\n";
	    print FOUT "<TD CLASS=\"left\">";
	    print FOUT "<A HREF=\"$flagpage{$pays}\">" if (-f "$path$lang[$nblang]$dirsep$dircity$dirsep$flagpage{$pays}");
	    print FOUT "$newflag{$pays}";
	    print FOUT "</A>" if (-f "$path$lang[$nblang]$dirsep$dircity$dirsep$flagpage{$pays}");
	    print FOUT "</TD>\n";

	    $pourcentage = (($citylist{$value}*1000)/($serverunique+$locserver))/10 if ($localonly != 1);
	    $pourcentage = (($citylist{$value}*1000)/$locserver)/10 if ($localonly == 1);
	    $pourcentageint = int($pourcentage);
	    print FOUT "<TD CLASS=\"left\">&nbsp;";
	    print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($pourcentageint != 0);
	    print FOUT "$citylist{$value}</TD>\n";
	    print FOUT "<TD CLASS=\"right\">&nbsp;";
	    printf FOUT "%.1f",$pourcentage;
	    print FOUT "&nbsp;%</TD>\n";

	    $pourcentage = (($city_hit{$value}*1000)/$payslistcity)/10 if ($payslistcity != 0);
	    $pourcentageint = int($pourcentage);
	    print FOUT "<TD CLASS=\"left\">&nbsp;";
	    print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[2]\">&nbsp;" if ($pourcentageint != 0);
	    print FOUT "$city_hit{$value}</TD>\n";
	    print FOUT "<TD CLASS=\"right\">&nbsp;";
	    printf FOUT "%.1f",$pourcentage;
	    print FOUT "&nbsp;%</TD>\n";

	    if ($spam_found != 0 && $spamonly != 1) {
		print FOUT "<TD CLASS=\"left\">";
		$percentage = ($spam_city{$value}*100)/$spam_found;
		$tmp2 = int($percentage);
		print FOUT "<img width=$tmp2 height=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[4]\" ALT=\"$gcolor[4]\">&nbsp;" if ($tmp2 != 0);
		print FOUT "$spam_city{$value}</TD>\n";
		printf FOUT "<TD CLASS=\"right\">%3.1f %",$percentage;
		print FOUT "</TD>\n";
	    }

	    if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {	    
		$city_access{$value} = 0 if ($city_access{$value} eq '');
		$pourcentage = (($city_access{$value}*1000)/$payshtmlcity)/10 if ($payshtmlcity != 0);
		$pourcentageint = int($pourcentage);
		print FOUT "<TD CLASS=\"left\">&nbsp;";
		print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[3]\">&nbsp;" if ($pourcentageint != 0);
		print FOUT "$city_access{$value}</TD>\n";
		print FOUT "<TD CLASS=\"right\">\n";
		printf FOUT "%.1f",$pourcentage;
		print FOUT "&nbsp;%</TD>\n";
	    }

	    if ($notrafic == 0) {
#		$tmp2 = $city_size{$value}/1024 if ($tmp_unit > 1024); 
#		$tmp2 = $city_size{$value}/(1024*1024) if ($tmp_unit > (1024*1024));
#		$tmp2 = $city_size{$value}/(1024*1024*1024) if ($tmp_unit > (1024*1024*1024));
#		$tmp2 = $city_size{$value}/(1024*1024*1024*1024) if ($tmp_unit > (1024*1024*1024*1024));
		$tmp2 = $city_size{$value}/$unit_div;
		$tmp2 = int($tmp2*100)/100 if ($unit ne "$L{'Kb'}");			    
		$tmp2 = int($tmp2) if ($unit eq "$L{'Kb'}");
		
#		$pourcentage = (($city_size{$value}*1000)/($sizepayscity*1024))/10 if ($sizepayscity != 0);
		$pourcentage = (($city_size{$value}*1000)/$sizepayscity)/10 if ($sizepayscity != 0);
		$pourcentageint = int($pourcentage);
		print FOUT "<TD CLASS=\"left\">&nbsp;\n";
		print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[4]\">&nbsp;" if ($pourcentageint != 0);
		print FOUT "$tmp2</TD>\n";
		print FOUT "<TD CLASS=\"right\">&nbsp;";
		printf FOUT "%.1f",$pourcentage;
		print FOUT "&nbsp;%</TD>\n";
	    }
	    print FOUT "</TR>";
	}
    }
    print FOUT "</tbody>\n";
    print FOUT "</TABLE>\n";  

    print FOUT "<P>\n";  
    print FOUT "</BODY></HTML>\n";
}


#
##############################################################
### Countries Cities
##############################################################
#

sub CountryCity {
  local(*FOUT,*L,$I) = @_;
  local($tmp,$tmp3,$tmp4,$unit,$tmp_unit);
  local($adresse);

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Cities'} $L{'from'} $L{$newflag{$pays}} </TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
  print FOUT "<H2>$L{'Cities'} $L{'from'} $L{$newflag{$pays}}</H2><P>\n";

  print FOUT "<P><HR><P>\n";

  $tmp = "country_region_".$pays;
  if ($$tmp{(&reverse_sort_by_value(*$tmp))[0]}) {

      print FOUT "\n<table class=\"tablesort  table-autosort table-autostripe table-stripeclass:alternate\">\n";
      print FOUT "<thead>\n";
      print FOUT "<TR>\n";
      print FOUT "<TH class=\"table-sortable:default\">$L{'Region_name'}</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">$L{'Hosts'}</TH>\n";
      print FOUT "</TR>\n";
      print FOUT "</thead>\n";
      print FOUT "<tbody>\n";

  foreach $adresse (&reverse_sort_by_value(*$tmp)) {
      print FOUT "<TR>\n";
      print FOUT "<TD CLASS=\"left\">$adresse</TD>\n";
      print FOUT "<TD CLASS=\"right\">$$tmp{$adresse}</TD>\n";
      print FOUT "</TR>";
  }
      print FOUT "</tbody>\n";
      print FOUT "</TABLE>\n";  
      print FOUT "<P><BR>\n";  
  }

  $tmp = "country_city_".$pays;

  if ($notrafic == 0) {
      ($unit_div,$unit) = &Return_Unit($city_size{(&reverse_sort_by_value(*city_size))[0]},0);
#      $tmp_unit = $city_size{(&reverse_sort_by_value(*city_size))[0]};
#      $unit = "$L{'bytes'}";
#      $unit = "$L{'Kb'}" if ($tmp_unit > 1024);		    
#      $unit = "$L{'Mb'}" if ($tmp_unit > (1024*1024));
#      $unit = "$L{'Gb'}" if ($tmp_unit > (1024*1024*1024));
#      $unit = "$L{'Tb'}" if ($tmp_unit > (1024*1024*1024*1024));
  }

  print FOUT "<I>($L{'Only_cities'} $L{'with_at_least'} $seuilsite $L{'requests'} $L{'are_shown'})</I><P>\n" if ($seuilsite > 1);
#  print FOUT "<I>($L{'Only_cities'} $L{'with_at_least'} $seuilsite $L{'hosts'} $L{'are_shown'})</I><P>\n" if ($seuilsite > 1);
#  print FOUT "<I>($L{'Only_cities'} $L{'with_at_least'} $seuilsite $L{'requests'} $L{'are_shown'})</I><P>\n" if ($seuilsite > 1);

#  print FOUT "<TABLE><TR><TD VALIGN=TOP ALIGN=LEFT>\n";
  if ($$tmp{(&reverse_sort_by_value(*$tmp))[0]}) {

#      $tmp4 = $pays."-city_hosts";

      print FOUT "\n<table class=\"tablesort  table-autosort table-autostripe table-stripeclass:alternate\">\n";
      print FOUT "<thead>\n";
      print FOUT "<TR>\n";
      print FOUT "<TH class=\"table-sortable:default\">$L{'Cities'}</TH>\n";
      print FOUT "<TH class=\"table-sortable:default\">$L{'Region_name'}</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">$L{'Hosts'}</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">$L{'Requests'}</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n";
    if ($spam_found != 0 && $spamonly != 1) {
	print FOUT "<TH class=\"table-sortable:numeric\">$L{'Spam'}</TH>\n";
	print FOUT "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n";
    }
      if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      }
      if ($notrafic == 0) {
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n";
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      }
      print FOUT "</TR>\n";
      print FOUT "</thead>\n";
      print FOUT "<tbody>\n";

#      print FOUT "<P>\n<TABLE CLASS=\"sortable_base\" ID=\"$tmp4\">\n";

      foreach $adresse (&reverse_sort_by_value(*$tmp)) {
#	  if ($city_hit{$adresse} > $seuilsite) {
	  $adresse_ext = "$pays:$adresse";
	  if ($city_hit{$adresse_ext} > $seuilsite) {
#	  if ($$tmp{$adresse} > $seuilsite) {

	      $found_city{$pays} = 1;

	      $tmp3 = &noaccentinhtml($adresse);
	      open(PAGECITYLIST,">$path$lang[$nblang]$dirsep$dircity$dirsep$pays$tmp3$htmlext") || &error_exit("Error, unable to open $path$lang[$nblang]$dirsep$dircity$dirsep$pays$tmp3$htmlext");
	      &CountryCityList(*PAGECITYLIST, eval($Lang{$lang[$nblang]}),$lang[$nblang],$adresse,$pays);
	      close (PAGECITYLIST);

	      print FOUT "<TR>\n";
	      print FOUT "<TD CLASS=\"left\">";
	      print FOUT "<A HREF=\"$pays$tmp3$htmlext\">" if ($found_city_list{"$pays$adresse"} == 1);
	      print FOUT "$adresse";
	      print FOUT "</A>" if ($found_city_list{"$pays$adresse"} == 1);
	      print FOUT "</TD>\n";
	      print FOUT "<TD CLASS=\"left\">$city_region{$adresse_ext}</TD>\n";

	      $pourcentage = ($$tmp{$adresse}*100)/$serverpayscity{$pays} if ($serverpayscity{$pays} != 0);
	      $pourcentageint = int($pourcentage);

	      print FOUT "<TD CLASS=\"left\">";
	      print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[4]\" ALT=\"$gcolor[4]\">&nbsp;" if ($pourcentageint != 0);
	      print FOUT "$$tmp{$adresse}</TD>\n";
	      print FOUT "<TD CLASS=\"right\">&nbsp;";
	      printf FOUT "%.1f",$pourcentage;
	      print FOUT "&nbsp;%</TD>\n";

#	      $pourcentage = (($city_hit{$adresse}*1000)/$payslistcity{$pays})/10 if ($payslistcity{$pays} != 0);
	      $pourcentage = (($city_hit{$adresse_ext}*1000)/$payslistcity{$pays})/10 if ($payslistcity{$pays} != 0);
	      $pourcentageint = int($pourcentage);
	      print FOUT "<TD CLASS=\"left\">";
	      print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($pourcentageint != 0);
#	      print FOUT "$city_hit{$adresse}</TD>\n";
	      print FOUT "$city_hit{$adresse_ext}</TD>\n";
	      print FOUT "<TD CLASS=\"right\">&nbsp;";
	      printf FOUT "%.1f",$pourcentage;
	      print FOUT "&nbsp;%</TD>\n";

	    if ($spam_found != 0 && $spamonly != 1) {
		print FOUT "<TD CLASS=\"left\">";
		$percentage = ($spam_city{$adresse_ext}*100)/$spam_found;
		$tmp2 = int($percentage);
		print FOUT "<img width=$tmp2 height=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[4]\" ALT=\"$gcolor[4]\">&nbsp;" if ($tmp2 != 0);
		print FOUT "$spam_city{$adresse_ext}</TD>\n";
		printf FOUT "<TD CLASS=\"right\">%3.1f %",$percentage;
		print FOUT "</TD>\n";
	    }

	      if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
#	      $city_access{$adresse} = 0 if ($city_access{$adresse} eq '');
		  $city_access{$adresse_ext} = 0 if ($city_access{$adresse_ext} eq '');
#	      $pourcentage = (($city_access{$adresse}*1000)/$payshtmlcity{$pays})/10 if ($payshtmlcity{$pays} != 0);
		  $pourcentage = (($city_access{$adresse_ext}*1000)/$payshtmlcity{$pays})/10 if ($payshtmlcity{$pays} != 0);
		  $pourcentageint = int($pourcentage);
		  print FOUT "<TD CLASS=\"left\">";
		  print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">&nbsp;" if ($pourcentageint != 0);
#	      print FOUT "$city_access{$adresse}</TD>\n";
		  print FOUT "$city_access{$adresse_ext}</TD>\n";
		  print FOUT "<TD CLASS=\"right\">&nbsp;";
		  printf FOUT "%.1f",$pourcentage;
		  print FOUT "&nbsp;%</TD>\n";
	      }

	      if ($notrafic == 0) {
#		  $tmp2 = $city_size{$adresse_ext}/1024 if ($tmp_unit > 1024); 
#		  $tmp2 = $city_size{$adresse_ext}/(1024*1024) if ($tmp_unit > (1024*1024));
#		  $tmp2 = $city_size{$adresse_ext}/(1024*1024*1024) if ($tmp_unit > (1024*1024*1024));
#		  $tmp2 = $city_size{$adresse_ext}/(1024*1024*1024*1024) if ($tmp_unit > (1024*1024*1024*1024));
		  $tmp2 = $city_size{$adresse_ext}/$unit_div;
		  $tmp2 = int($tmp2*100)/100 if ($unit ne "$L{'Kb'}");			    
		  $tmp2 = int($tmp2) if ($unit eq "$L{'Kb'}");

		  $pourcentage = (($city_size{$adresse_ext}*1000)/$sizepayscity{$pays})/10 if ($sizepayscity{$pays} != 0);
		  $pourcentageint = int($pourcentage);
		  print FOUT "<TD CLASS=\"left\">";
		  print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">&nbsp;" if ($pourcentageint != 0);
		  print FOUT "$tmp2</TD>\n";
		  print FOUT "<TD CLASS=\"right\">&nbsp;";
		  printf FOUT "%.1f",$pourcentage;
		  print FOUT "&nbsp;%</TD>\n";
	      }
	      print FOUT "</TR>";
	  }
      }
      print FOUT "</tbody>\n";
      print FOUT "</TABLE>\n";  
      print FOUT "<P>\n";  
  }

  print FOUT "</BODY></HTML>\n";

}

#
##############################################################
### Hosts
##############################################################
#

sub PageSitesAll {
    local(*FOUT,*L,$I) = @_;
    local($count,$unit);

    print FOUT "$doctype\n";
    print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
    print FOUT "$charset\n";
    print FOUT "<TITLE>$L{'Hosts'} $L{'connecting_to_the_server'}</TITLE>\n";
    print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
    print FOUT "$curvy_bottom_jss\n";

    &add_css_style(*FOUT,2);

    print FOUT "</HEAD>\n";
    print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
    &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
    print FOUT "<H2>$L{'Hosts'} $L{'connecting_to_the_server'} :</H2><P>\n";

#    &PagesExportPDF(*FOUT,"$I$dirsep$dirpage$dirsep$listsites",$L{'Hosts'},2,2,0,0) if ($enable_pdf == 1);

    print FOUT "<A HREF=\"..$dirsepurl..$dirsepurl$dircsv$dirsepurl$incservexterne$csvext\" TITLE=\"Export in CSV\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>";

    $tmp10 = $serverunique;
    $tmp10 = $max_item_page if ($tmp10 > $max_item_page);

    print FOUT "<P>\n";
    print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} $tmp10 $L{'top_external_sites'} ";
    print FOUT "($L{'among'} $serverunique) " if ($tmp10 == $max_item_page);
    print FOUT "</I>:</DIV><P>\n";

    $tmp = $serversize{(&reverse_sort_by_value(*serversize))[0]};
    $unit = "$L{'bytes'}";
    $unit = "$L{'Kb'}" if ($tmp > 1024);		    
    $unit = "$L{'Mb'}" if ($tmp > (1024*1024));
    $unit = "$L{'Gb'}" if ($tmp > (1024*1024*1024));
    $unit = "$L{'Tb'}" if ($tmp > (1024*1024*1024*1024));

#    print FOUT "<I>($L{'Only_hosts'} $L{'with_at_least'} $seuilsite $L{'requests'} $L{'are_shown'})</I><P>\n" if ($seuilsite > 1);

    print FOUT "\n<table class=\"tablesort table-autosort table-autostripe ";
    print FOUT "table-autopage:$table_big_lines_aff " if ($tmp10 > $table_big_lines_aff);
    print FOUT "table-stripeclass:alternate\" id=\"page\">\n";
    print FOUT "<thead>\n";
    print FOUT "<TR>\n";
    print FOUT "<TH class=\"table-sortable:default\">$L{'Hosts'}</TH>\n";
#    print FOUT "<TH class=\"filterable\" class=\"table-sortable:numeric\">$L{'Requests'}</TH>\n";
    print FOUT "<TH class=\"table-sortable:numeric\">$L{'Requests'}</TH>\n";
    print FOUT "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n";
    if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      }
    print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH><TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n" if ($notrafic == 0);
    if ($precision > 3 && $squid_format == 0) {
	print FOUT "<TH class=\"table-sortable:numeric\">$L{'Different_accesses'}&nbsp;</TH>\n";
    }
    print FOUT "<TH class=\"table-sortable:date\">$L{'Last_occurence'}</TH>\n";
#    print FOUT "</TR>\n";

#    print FOUT "<tr>\n";
#    print FOUT "<th>Filter:</th>\n";
#    print FOUT "<th><select onchange=\"Table.filter(this,this)\"><option value=\"function(){return true;}\">All</option><option value=\"function(val){return val>1;}\">&gt; 10</option><option value=\"function(val){return val<=10;}\">&lt;= 10</option></th>\n";
#    print FOUT "<th><select onchange=\"Table.filter(this,this)\"><option value=\"function(){return true;}\">All</option><option value=\"function(val){return parseFloat(val.replace(/\%/,''))>10;}\">&gt; 10%</option><option value=\"function(val){return parseFloat(val.replace(/\%/,''))<=10;}\">&lt;= 10%</option></th>\n";

#    print FOUT "<th><select onchange=\"Table.filter(this,this)\"><option value=\"function(){return true;}\">All</option><option value=\"function(val){return val>1;}\">&gt; 10</option><option value=\"function(val){return val<=10;}\">&lt;= 10</option></th>\n";
#    print FOUT "<th><select onchange=\"Table.filter(this,this)\"><option value=\"function(){return true;}\">All</option><option value=\"function(val){return parseFloat(val.replace(/\%/,''))>10;}\">&gt; 10%</option><option value=\"function(val){return parseFloat(val.replace(/\%/,''))<=10;}\">&lt;= 10%</option></th>\n";
#    if ($notrafic == 0) {
#	print FOUT "<th><input name=\"filter\" size=\"8\" onkeyup=\"Table.filter(this,this)\"></th>\n";
#	print FOUT "<th><select onchange=\"Table.filter(this,this)\"><option value=\"function(){return true;}\">All</option><option value=\"function(val){return parseFloat(val.replace(/\%/,''))>10;}\">&gt; 10%</option><option value=\"function(val){return parseFloat(val.replace(/\%/,''))<=10;}\">&lt;= 10%</option></th>\n";
#    }
#    print FOUT "<th></th>\n";




#    print FOUT "<th><select onchange=\"Table.filter(this,this)\"><option value=\"\">All</option><option value=\"0\">0</option><option value=\"1\">1</option><option value=\"2\">2</option><option value=\"3\">3</option><option value=\"4\">4</option><option value=\"5\">5</option></th>\n";
#    print FOUT "<th><input name=\"filter\" size=\"8\" onkeyup=\"Table.filter(this,this)\"></th>\n";
#    print FOUT "<th><select onchange=\"Table.filter(this,this)\"><option value=\"function(){return true;}\">All</option><option value=\"function(val){return parseFloat(val.replace(/\$/,''))>1;}\">&gt; $1</option><option value=\"function(val){return parseFloat(val.replace(/\$/,''))<=1;}\">&lt;= $1</option></th>\n";
    print FOUT "</tr>\n";

    print FOUT "</thead>\n";

    if ($tmp10 > $table_big_lines_aff) {	

#    $tmp = int(scalar(%server)/$table_big_lines_aff);
#    if ($tmp != (scalar(%server)/$table_big_lines_aff)) {
	$tmp = int($tmp10/$table_big_lines_aff);
	if ($tmp != ($tmp10/$table_big_lines_aff)) {
	    $tmp++;
	}

    	print FOUT "<tfoot>\n";
	print FOUT "<tr>\n";
	print FOUT "<TH>$L{'Hosts'}</TH>\n";
	print FOUT "<TH>$L{'Requests'}</TH>\n";
	print FOUT "<TH>$L{'Percentage'}</TH>\n";
	if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	    print FOUT "<TH>&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
	    print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
	}
	print FOUT "<TH>&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH><TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n" if ($notrafic == 0);
	if ($precision > 3 && $squid_format == 0) {
	    print FOUT "<TH>$L{'Different_accesses'}&nbsp;</TH>\n";
	}
	print FOUT "<TH>$L{'Last_occurence'}</TH>\n";
	print FOUT "</tr>\n";
	print FOUT "<tr>\n";
	
	if ($tmp > 1) {
	    $tmp2 = 4;
	    if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
		$tmp2 += 2;
	    }
	    $tmp2++ if ($precision > 3 && $squid_format == 0);
	    $tmp2 += 2 if ($notrafic == 0);
	    print FOUT "<td colspan=$tmp2>\n";
	    print FOUT "<a href=\"#\" onclick=\"pageexample('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	    
	    for ($i=1;$i<=$tmp;$i++) {
		$iminus = $i-1;
		print FOUT "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexample($iminus); return false;\">$i</a>\n";
	    }
	    print FOUT "<a href=\"#\" onclick=\"pageexample('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	    print FOUT "<a href=\"#\" onclick=\"pageexample('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	    print FOUT "</td>\n";
	    print FOUT "</tr>\n";
	}
	print FOUT "</tfoot>\n";
    }

    print FOUT "<tbody>\n";

    $count = 0;

    foreach $adresse (&reverse_sort_by_value(*server)) {

	$count++;
	if ($count < $max_item_page) {

	$newserveur = $adresse;
	$newserveur =~ s/[.:]/_/g;
#	$newserveur = $newserveur.$htmlext;
#	$newserveur = $newserveur;

#	if ($server{$adresse} > $seuilsite) {
	    print FOUT "<TR><TD CLASS=\"left\">\n";
	    if ($adresse =~ /[0-9]+$/ || $adresse =~ /:/) {
#		print FOUT "<A HREF=\"$newserveur#$adresse\"\>" if ($precision > 3 && $nbpageserveur{$adresse} > $seuilsite);
		print FOUT "<A HREF=\"$newserveur$htmlext#$adresse\"\>" if ($precision > 3 && $nbpageserveur{$adresse} > 0);
		print FOUT "$adresse";
#		print FOUT "</A>" if ($precision > 3 && $nbpageserveur{$adresse} > $seuilsite);		
		print FOUT "</A>" if ($precision > 3 && $nbpageserveur{$adresse} > 0);
	    } else {
#		$pospoint = index($newserveur,'_',0);
		$pospoint = index($adresse,'.',0);
		$domadresse = substr($newserveur,$pospoint+1,(length($newserveur)-length($pospoint)));
		
#		print FOUT "<A HREF=\"$domadresse#$adresse\"\>" if ($precision > 3 && $nbpageserveur{$adresse} > $seuilsite);
		if ($precision > 3 && $nbpageserveur{$adresse} > 0) {
		    print FOUT "<A HREF=\"$newserveur$htmlext\">" if ($domadresse !~ /_/);
		    if ($adresse =~ /$localdomaine/) {
			print FOUT "<A HREF=\"$domadresse$htmlext#$adresse\">" if ($split_localhost == 0 && $domadresse =~ /_/);
			print FOUT "<A HREF=\"$newserveur$htmlext\">" if ($split_localhost == 1 && $domadresse =~ /_/);
		    } else {
			print FOUT "<A HREF=\"$domadresse$htmlext#$adresse\">" if ($domadresse =~ /_/);
			print FOUT "<A HREF=\"$newserveur$htmlext\">" if ($domadresse !~ /_/);
		    }
		}

		print FOUT "$adresse";
#		print FOUT "</A>" if ($precision > 3 && $nbpageserveur{$adresse} > $seuilsite);
		print FOUT "</A>" if ($precision > 3 && $nbpageserveur{$adresse} > 0);
	    }
	    print FOUT "&nbsp;</TD>\n";
	    print FOUT "<TD CLASS=\"right\">&nbsp;<B>$server{$adresse}</B>";
	    print FOUT "&nbsp;</TD>\n";
	    $pourcentage = (($server{$adresse}*1000)/$reqtot)/10;
	    $pourcentageint = int($pourcentage);
	    print FOUT "<TD CLASS=\"left\">&nbsp;";
	    print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
	    printf FOUT "%.1f ",$pourcentage;
	    print FOUT " %</TD>\n";

	    #

	    if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
		print FOUT "<TD CLASS=\"right\">&nbsp;<B>$nbpageserveur{$adresse}</B>";
		print FOUT "&nbsp;</TD>\n";
		$pourcentage = (($nbpageserveur{$adresse}*1000)/$access)/10 if ($access != 0);
		$pourcentageint = int($pourcentage);
		print FOUT "<TD CLASS=\"left\">&nbsp;";
		print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
		printf FOUT "%.1f ",$pourcentage;
		print FOUT " %</TD>\n";
	    }
	    
	    #
	    
	    if ($notrafic == 0) {
		$tmp = $serversize{$adresse}/1024 if ($unit eq "$L{'Kb'}");
		$tmp = $serversize{$adresse}/(1024*1024) if ($unit eq "$L{'Mb'}");
		$tmp = $serversize{$adresse}/(1024*1024*1024) if ($unit eq "$L{'Gb'}");
		$tmp = $serversize{$adresse}/(1024*1024*1024*1024) if ($unit eq "$L{'Tb'}");
		if ($externesize != 0) {
		    $pourcentage = 100*$tmp/($externesize*1024) if ($unit eq "$L{'Kb'}");
		    $pourcentage = 100*$tmp/$externesize if ($unit eq "$L{'Mb'}");
		    $pourcentage = 100*$tmp/($externesize/1024) if ($unit eq "$L{'Gb'}");
		    $pourcentage = 100*$tmp/($externesize/(1024*1024)) if ($unit eq "$L{'Tb'}");
		}
		$tmp = int($tmp*100)/100 if ($unit ne "$L{'Kb'}");			    
		$tmp = int($tmp) if ($unit eq "$L{'Kb'}");
		
		print FOUT "<TD CLASS=\"right\">&nbsp;<B>$tmp</B>";
		print FOUT "&nbsp;</TD>\n";
	    
		$pourcentageint = int($pourcentage);
		print FOUT "<TD CLASS=\"left\">&nbsp;";
		print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
		printf FOUT "%.1f ",$pourcentage;
		print FOUT " %</TD>\n";
	    }

	print FOUT "<TD CLASS=\"right\">&nbsp;<B>$nbpageserveurunique{$adresse}</B>&nbsp;</TD>\n" if ($precision > 3 && $squid_format == 0);
	    print FOUT "<TD CLASS=\"right\">\n";
	    print FOUT "$serverdate{$adresse}</TD>\n";
	    print FOUT "</TR>\n";
	}
#	}
    }
    print FOUT "</tbody>\n";
    print FOUT "</TABLE>\n";
    print FOUT "</BODY></HTML>\n";
}



###

sub PageLocSitesAll {
    local(*FOUT,*L,$I) = @_;
    local($count,$unit);

    print FOUT "$doctype\n";
    print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
    print FOUT "$charset\n";
    print FOUT "<TITLE>$L{'Hosts'} $L{'connecting_to_the_server'}</TITLE>\n";
    print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
    print FOUT "$curvy_bottom_jss\n";

    &add_css_style(*FOUT,2);

    print FOUT "</HEAD>\n";
    print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
    &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
    print FOUT "<H2>$L{'Hosts'} $L{'connecting_to_the_server'} :</H2><P>\n";

    print FOUT "<A HREF=\"..$dirsepurl..$dirsepurl$dircsv$dirsepurl$incservinterne$csvext\" TITLE=\"Export in CSV\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>";
    print FOUT "<P>\n";


    $count = 0;
    $tmp10 = $locserver;
    $tmp10 = $max_item_page if ($tmp10 > $max_item_page);

    print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} $tmp10 $L{'top_local_sites'} ";
    print FOUT "($L{'among'} $locserver) " if ($tmp10 == $max_item_page);
    print FOUT "</I>:</DIV><P>\n";

#    print FOUT "<I>($L{'Only_hosts'} $L{'with_at_least'} $seuilsite $L{'requests'} $L{'are_shown'})</I><P>\n" if ($seuilsite > 1);

    $tmp = $localserversize{(&reverse_sort_by_value(*localserversize))[0]};
    $unit = "$L{'bytes'}";
    $unit = "$L{'Kb'}" if ($tmp > 1024);		    
    $unit = "$L{'Mb'}" if ($tmp > (1024*1024));
    $unit = "$L{'Gb'}" if ($tmp > (1024*1024*1024));
    $unit = "$L{'Tb'}" if ($tmp > (1024*1024*1024*1024));

    print FOUT "\n<table class=\"tablesort  table-autosort table-autostripe ";
    print FOUT "table-autopage:$table_big_lines_aff " if ($tmp10 > $table_big_lines_aff);
    print FOUT "table-stripeclass:alternate\" id=\"page\">\n";
    print FOUT "<thead>\n";
    print FOUT "<TR>\n";
    print FOUT "<TH class=\"table-sortable:default\">$L{'Hosts'}</TH>\n";
    print FOUT "<TH class=\"table-sortable:default\">$L{'Users'}</TH>\n" if (-f "$resolv_users_file");
    print FOUT "<TH class=\"table-sortable:numeric\">$L{'Requests'}</TH>\n";
    print FOUT "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n";
    if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      }
    print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH><TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n" if ($notrafic == 0);
    if ($precision > 3 && $squid_format == 0) {
	print FOUT "<TH class=\"table-sortable:numeric\">$L{'Different_accesses'}&nbsp;</TH>\n";
    }
    print FOUT "<TH class=\"table-sortable:date\">$L{'Last_occurence'}</TH>\n";
    print FOUT "</TR>\n";
    print FOUT "</thead>\n";

    if ($tmp10 > $table_big_lines_aff) {

	$tmp = int($tmp10/$table_big_lines_aff);
	if ($tmp != ($tmp10/$table_big_lines_aff)) {
	    $tmp++;
	}
    
	print FOUT "<tfoot>\n";
	print FOUT "<tr>\n";
	print FOUT "<TH>$L{'Hosts'}</TH>\n";
	print FOUT "<TH>$L{'Requests'}</TH>\n";
	print FOUT "<TH>$L{'Percentage'}</TH>\n";
	if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	    print FOUT "<TH>&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
	    print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
	}
	print FOUT "<TH>&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH><TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n" if ($notrafic == 0);
	print FOUT "<TH>$L{'Last_occurence'}</TH>\n";
	print FOUT "</tr>\n";
	print FOUT "<tr>\n";

	if ($tmp > 1) {
	    $tmp2 = 4;
	    if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
		$tmp2 += 2;
	    }
	    $tmp2++ if ($precision > 3 && $squid_format == 0);
	    $tmp2 += 2 if ($notrafic == 0);
	    print FOUT "<td colspan=$tmp2>\n";
	    print FOUT "<a href=\"#\" onclick=\"pageexample('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	    
	    for ($i=1;$i<=$tmp;$i++) {
		$iminus = $i-1;
		print FOUT "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexample($iminus); return false;\">$i</a>\n";
	    }
	    print FOUT "<a href=\"#\" onclick=\"pageexample('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	    print FOUT "<a href=\"#\" onclick=\"pageexample('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	    print FOUT "</td>\n";
	    print FOUT "</tr>\n";
	}
	print FOUT "</tfoot>\n";
    }

    print FOUT "<tbody>\n";
	
#    print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"local_sites_all\">\n";
#    print FOUT "<TR><TH>&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
#    print FOUT "<TH>&nbsp;$L{'Requests'}&nbsp;</TH><TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n"; # if ($mail_format == 0);
##    print FOUT "<TH>&nbsp;$L{'Emails'}&nbsp;</TH><TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n" if ($mail_format == 1);
#    print FOUT "<TH>&nbsp;$L{'Accesses'}&nbsp;</TH><TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n" if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
#    print FOUT "<TH>&nbsp;$L{'Traffic'}&nbsp;($unit)</TH><TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n" if ($notrafic == 0);
#    print FOUT "<TH>&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n";
#    print FOUT "</TR>\n";

    $newserveur_dom = $localdomaine;
    $newserveur_dom =~ s/[.:]/_/g;
#    $newserveur_dom = $newserveur_dom.$htmlext;

    foreach $adresse (&reverse_sort_by_value(*localserver)) {

	$count++;
	if ($count < $max_item_page) {

#	if ($localserver{$adresse} > $seuilsite) {
	    print FOUT "<TR>\n<TD CLASS=\"left\">\n";
	    $newserveur = $adresse;
	    $newserveur =~ s/[.:]/_/g;
#	    $newserveur = $newserveur.$htmlext;

	    if ($adresse =~ /[0-9]+$/ || $adresse =~ /:/) {
		print FOUT "<A HREF=\"$newserveur$htmlext\" TITLE=\"$resolv_user{$adresse}\">" if ($precision > 3 && $nbpageserveur{$adresse} > 0);
		print FOUT "$adresse";
		print FOUT "</A>" if ($precision > 3 && $nbpageserveur{$adresse} > 0);
	    } else {
		$pospoint = index($adresse,'.',0);
		$domadresse = substr($newserveur,$pospoint+1,(length($newserveur)-length($pospoint)));
		if ($precision > 3 && $nbpageserveur{$adresse} > 0) {
		    print FOUT "<A HREF=\"$newserveur$htmlext\" TITLE=\"$resolv_user{$adresse}\">" if ($domadresse !~ /_/);
		    print FOUT "<A HREF=\"$domadresse$htmlext#$adresse\" TITLE=\"$resolv_user{$adresse}\">" if ($split_localhost == 0 && $domadresse =~ /_/);
		    print FOUT "<A HREF=\"$newserveur$htmlext\" TITLE=\"$resolv_user{$adresse}\">" if ($split_localhost == 1 && $domadresse =~ /_/);
#		    print FOUT "<A HREF=\"$newserveur$htmlext\" TITLE=\"$resolv_user{$adresse}\">" if ($adresse !~ /_/);
#		    print FOUT "<A HREF=\"$newserveur_dom$htmlext#$adresse\" TITLE=\"$resolv_user{$adresse}\">" if ($adresse =~ /_/);
		}
		print FOUT "$adresse";
		print FOUT "</A>" if ($precision > 3 && $nbpageserveur{$adresse} > 0);
	    }
	    print FOUT "&nbsp;</TD>\n";
	    if (-f "$resolv_users_file") {
		print FOUT "<TD CLASS=\"right\">";
		print FOUT "$resolv_user{$adresse}";
		print FOUT "</TD>\n";
	    }
	    print FOUT "<TD CLASS=\"right\">&nbsp;<B>$localserver{$adresse}</B>";
	    print FOUT "&nbsp;</TD>\n";
	    $pourcentage = (($localserver{$adresse}*1000)/$reqtot)/10;
	    $pourcentageint = int($pourcentage);
	    print FOUT "<TD CLASS=\"left\">&nbsp;";
	    print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
	    printf FOUT "%.1f ",$pourcentage;
	    print FOUT " %</TD>\n";

	    #

	    if ($mail_format == 0 && $ftp_format == 0 && $cups_format == 0) {
		print FOUT "<TD CLASS=\"right\">&nbsp;<B>$nbpageserveur{$adresse}</B>";
		print FOUT "&nbsp;</TD>\n";
		$pourcentage = (($nbpageserveur{$adresse}*1000)/$access)/10 if ($access != 0);
		$pourcentageint = int($pourcentage);
		print FOUT "<TD CLASS=\"left\">&nbsp;";
		print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
		printf FOUT "%.1f ",$pourcentage;
		print FOUT " %</TD>\n";
	    }
	    
	    #

	    if ($notrafic == 0) {
		$tmp = $localserversize{$adresse}/1024 if ($unit eq "$L{'Kb'}");
		$tmp = $localserversize{$adresse}/(1024*1024) if ($unit eq "$L{'Mb'}");
		$tmp = $localserversize{$adresse}/(1024*1024*1024) if ($unit eq "$L{'Gb'}");
		$tmp = $localserversize{$adresse}/(1024*1024*1024*1024) if ($unit eq "$L{'Tb'}");
		$pourcentage = 100*$tmp/($domsize*1024) if ($unit eq "$L{'Kb'}");
		$pourcentage = 100*$tmp/$domsize if ($unit eq "$L{'Mb'}");
		$pourcentage = 100*$tmp/($domsize/1024) if ($unit eq "$L{'Gb'}");
		$pourcentage = 100*$tmp/($domsize/(1024*1024)) if ($unit eq "$L{'Tb'}");
		$tmp = int($tmp*100)/100 if ($unit ne "$L{'Kb'}");			    
		$tmp = int($tmp) if ($unit eq "$L{'Kb'}");
		
		print FOUT "<TD CLASS=\"right\">&nbsp;<B>$tmp</B>";
		print FOUT "&nbsp;</TD>\n";
		
		$pourcentageint = int($pourcentage);
		print FOUT "<TD CLASS=\"left\">&nbsp;";
		print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
		printf FOUT "%.1f ",$pourcentage;
		print FOUT " %</TD>\n";
	    }
	    print FOUT "<TD CLASS=\"right\">&nbsp;<B>$nbpageserveurunique{$adresse}</B>&nbsp;</TD>\n" if ($precision > 3 && $squid_format == 0);
	    print FOUT "<TD CLASS=\"right\">";
	    print FOUT "$localserverdate{$adresse}</TD>\n";
	    print FOUT "</TR>\n";
	}
#	}
    }
    print FOUT "</tbody>\n";
    print FOUT "</TABLE>\n";
    print FOUT "</BODY></HTML>\n";
}



###

sub PageSites {
    local(*FOUT,*L,$I) = @_;
    local($count);

    print FOUT "$doctype\n";
    print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
    print FOUT "$charset\n";
    print FOUT "<TITLE>$L{'Stats'} - $L{'Hosts'}</TITLE>\n";
    print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
    print FOUT "$curvy_bottom_jss\n";

    &add_jqplot_js(*FOUT,2);
    &add_css_style(*FOUT,2);
#    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/JavaScript\">\n";
#    print FOUT "function send_html_pdf() {\n";
#    print FOUT "var html;\n";
#    print FOUT "\$(document).ready(function () {\n";
#    print FOUT " html = \$('body').html();\n";
##    print FOUT " html = \$('#plotted_image_div0').outerHTML;\n";
#    print FOUT "});\n";
#    print FOUT "PDF_Jqplot('/cgi-bin/w3perl/pagesend.pl','config-web.pl',html,'2','uk');\n";
#    print FOUT "}\n";
#    print FOUT "</script>\n";
    print FOUT "</HEAD>\n";

    print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
    &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
    &help_div(*FOUT);

    &PageSitesDesc(eval($Lang{$lang[$nblang]}),$I) if ($precision > 2);

    print FOUT "<H2>$L{'Hosts'} $L{'connecting_to_the_server'}</H2>\n";
    $count = 0;

    if ($localonly != 1 && $serverunique != 0) {

#	print FOUT "<P>\n";
	print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} $topten $L{'top_external_sites'} ";
	print FOUT "(<A HREF=\"$listsites\">$L{'Full_list'}</A>)" if ($show_all == 1 && $serverunique > $topten);
	print FOUT "</I></DIV><BR>\n";

	&HostsTab(*FOUT,*L,$I,$topten,0);

#	$tmp = $serversize{(&reverse_sort_by_value(*serversize))[0]};
#	$unit = "$L{'Data_unit_octet'}";
#	$unit = "$L{'Kb'}" if ($tmp > 1024);		    
#	$unit = "$L{'Mb'}" if ($tmp > (1024*1024));
#	$unit = "$L{'Gb'}" if ($tmp > (1024*1024*1024));

#	print FOUT "<P>\n";
#	print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} $topten $L{'top_external_sites'} ";
#	print FOUT "(<A HREF=\"$listsites\">$L{'Full_list'}</A>)" if ($show_all == 1);
#	print FOUT "</I></DIV><P>\n";
	
#	print FOUT "\n<table class=\"tablesort  table-autosort table-autostripe table-stripeclass:alternate\">\n";
#	print FOUT "<thead>\n";
#	print FOUT "<TR>\n";
#	print FOUT "<TH class=\"table-sortable:default\">$L{'Hosts'}</TH>\n";
#	print FOUT "<TH class=\"table-sortable:numeric\">$L{'Requests'}</TH>\n";
#	print FOUT "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n";
#	if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
#	    print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
#	    print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
#	}
#	print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH><TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n" if ($notrafic == 0);
#	print FOUT "<TH class=\"table-sortable:date\">$L{'Last_occurence'}</TH>\n";
#	print FOUT "</TR>\n";
#	print FOUT "</thead>\n";
#	print FOUT "<tbody>\n";

#	foreach $adresse (&reverse_sort_by_value(*server)) {
	    
#	    if ($count < $topten) {
#		$count++;
#		$newserveur = $adresse;
#		$newserveur =~ s/[.:]/_/g;
		
#		print FOUT "<TR>\n<TD CLASS=\"left\">\n";
#		if ($adresse =~ /[0-9]+$/) {
#		    print FOUT "<A HREF=\"$newserveur$htmlext\" TITLE=\"$resolv_user{$adresse}\">" if ($precision > 3 && $nbpageserveur{$adresse} > 0);
#		    print FOUT "$adresse";
#		    print FOUT "</A> " if ($precision > 3 && $nbpageserveur{$adresse} > 0);
#		} else {
#		    $pospoint = index($adresse,'.',0);
#		    $domadresse = substr($newserveur,$pospoint+1,(length($newserveur)-length($pospoint)));
#		
#		    if ($precision > 3 && $server{$adresse} > 0) {
#			print FOUT "<A HREF=\"$newserveur$htmlext\">" if ($domadresse !~ /_/);
#			print FOUT "<A HREF=\"$domadresse$htmlext#$adresse\">" if ($domadresse =~ /_/);
#		    }
#		    print FOUT "$adresse";
	#print FOUT "</A> " if ($precision > 3 && $server{$adresse} > 0);
#		}

#		print FOUT "&nbsp;</TD>\n";
#		print FOUT "<TD CLASS=\"right\">&nbsp;<B>$server{$adresse}</B> ";
#		print FOUT "&nbsp;</TD>\n";
	    
#		$pourcentage = (($server{$adresse}*1000)/$reqtot)/10;
#		$pourcentageint = int($pourcentage);
#		print FOUT "<TD CLASS=\"left\">&nbsp;\n";
#		print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
#		printf FOUT "%.1f ",$pourcentage;
#		print FOUT " %</TD>\n";

#		if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
#		    print FOUT "<TD CLASS=\"right\">&nbsp;<B>$nbpageserveur{$adresse}</B> ";
#		    print FOUT "&nbsp;</TD>\n";
#		    $pourcentage = (($nbpageserveur{$adresse}*1000)/$access)/10 if ($access != 0);
#		    $pourcentageint = int($pourcentage);
#		    print FOUT "<TD CLASS=\"left\">&nbsp;\n";
#		    print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
#		    printf FOUT "%.1f ",$pourcentage;
#		    print FOUT " %</TD>\n";
#		}


#	    if ($notrafic == 0) {
#		$tmp = $serversize{$adresse}/1024 if ($unit eq "$L{'Kb'}");
#		$tmp = $serversize{$adresse}/(1024*1024) if ($unit eq "$L{'Mb'}");
#		$tmp = $serversize{$adresse}/(1024*1024*1024) if ($unit eq "$L{'Gb'}");
#		if ($externesize != 0) {
#		    $pourcentage = 100*$tmp/($externesize*1024) if ($unit eq "$L{'Kb'}");
#		    $pourcentage = 100*$tmp/$externesize if ($unit eq "$L{'Mb'}");
#		    $pourcentage = 100*$tmp/($externesize/1024) if ($unit eq "$L{'Gb'}");
#		}
#		$tmp = int($tmp*100)/100 if ($unit ne "$L{'Kb'}");			    
#		$tmp = int($tmp) if ($unit eq "$L{'Kb'}");
		
#		print FOUT "<TD CLASS=\"right\">&nbsp;<B>$tmp</B> ";
#		print FOUT "&nbsp;</TD>\n";
	    
#		$pourcentageint = int($pourcentage);
#		print FOUT "<TD CLASS=\"left\">&nbsp;\n";
#		print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
#		printf FOUT "%.1f ",$pourcentage;
#		print FOUT " %</TD>\n";
#	    }

#		print FOUT "<TD CLASS=\"right\">$serverdate{$adresse}</TD>\n";
#		print FOUT "</TR>\n";
#	    }
#	}
#	print FOUT "</tbody>\n";
#	print FOUT "</TABLE>\n";
    }
    

    if ($locallog != 0 && $locserver != 0) {

	$tmp = $localserversize{(&reverse_sort_by_value(*localserversize))[0]};
	$unit = "$L{'bytes'}";
	$unit = "$L{'Kb'}" if ($tmp > 1024);		    
	$unit = "$L{'Mb'}" if ($tmp > (1024*1024));
	$unit = "$L{'Gb'}" if ($tmp > (1024*1024*1024));
	$unit = "$L{'Tb'}" if ($tmp > (1024*1024*1024*1024));

	$count = 0;
	print FOUT "<P>\n";
	print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} $topten $L{'top_local_sites'} ";
	print FOUT "(<A HREF=\"$listlocsites\">$L{'Full_list'}</A>)" if ($show_all == 1 && $locserver > $topten);
	print FOUT "</I></DIV><P>\n";

	print FOUT "\n<table class=\"tablesort  table-autosort table-autostripe table-stripeclass:alternate\">\n";
	print FOUT "<thead>\n";
	print FOUT "<TR>\n";
	print FOUT "<TH class=\"table-sortable:default\">$L{'Hosts'}</TH>\n";
	print FOUT "<TH class=\"table-sortable:numeric\">$L{'Requests'}</TH>\n";
	print FOUT "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n";
	if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	    print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
	    print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
	}

	if ($spam_found != 0 && $spamonly != 1) {
	    print FOUT "<TH class=\"table-sortable:numeric\">$L{'Spam'}</TH>\n";
	    print FOUT "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n";
	}

	if ($precision > 3 && $squid_format == 0) {
#	    if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
		print FOUT "<TH class=\"table-sortable:numeric\">$L{'Different_accesses'}&nbsp;</TH>\n";
#	    } else {
#		print FOUT "<TH class=\"table-sortable:numeric\">$L{'Requests'}&nbsp;($L{'Unique'})&nbsp;</TH>\n";
#	    }
	}

	print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH><TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n" if ($notrafic == 0);
	print FOUT "<TH class=\"table-sortable:date\">$L{'Last_occurence'}</TH>\n";
	print FOUT "</TR>\n";
	print FOUT "</thead>\n";
	print FOUT "<tbody>\n";
	
	foreach $adresse (&reverse_sort_by_value(*localserver)) {

	    if ($count < $topten) {
	    $count++;
	    $newserveur = $adresse;
	    $newserveur =~ s/[.:]/_/g;

	    print FOUT "<TR>\n<TD CLASS=\"left\">\n";
	    if ($adresse =~ /[0-9]+$/ || $adresse =~ /:/) {
		print FOUT "<A HREF=\"$newserveur$htmlext\" TITLE=\"$resolv_user{$adresse}\">" if ($precision > 3 && $nbpageserveur{$adresse} > 0);
		print FOUT "$adresse";
		print FOUT "</A> " if ($precision > 3 && $nbpageserveur{$adresse} > 0);
            } else {
		$pospoint = index($adresse,'.',0);
		$domadresse = substr($newserveur,$pospoint+1,(length($newserveur)-length($pospoint)));

		if (($precision > 3 && $nbpageserveur{$adresse} > 0) || $mail_format == 1) {
		    if ($mail_format == 0) {
			print FOUT "<A HREF=\"$newserveur$htmlext\" TITLE=\"$resolv_user{$adresse}\">" if ($domadresse !~ /_/);
			print FOUT "<A HREF=\"$domadresse$htmlext#$adresse\" TITLE=\"$resolv_user{$adresse}\">" if ($split_localhost == 0 && $domadresse =~ /_/);
			print FOUT "<A HREF=\"$newserveur$htmlext\" TITLE=\"$resolv_user{$adresse}\">" if ($split_localhost == 1 && $domadresse =~ /_/);
		    } else {
			print FOUT "<A HREF=\"..$dirsepurl$dirdomain$dirsepurl$newserveur$htmlext\">" if ($domadresse !~ /_/);
			print FOUT "<A HREF=\"..$dirsepurl$dirdomain$dirsepurl$domadresse$htmlext#$adresse\">" if ($split_localhost == 0 && $domadresse =~ /_/);
			print FOUT "<A HREF=\"..$dirsepurl$dirdomain$dirsepurl$newserveur$htmlext\">" if ($split_localhost == 1 && $domadresse =~ /_/);
		    }
		}
		print FOUT "$adresse";
		print FOUT "</A> " if (($precision > 3 && $nbpageserveur{$adresse} > 0) || $mail_format == 1);
	    }

	    print FOUT "&nbsp;</TD>\n<TD CLASS=\"right\">&nbsp;<B>$localserver{$adresse}</B> ";

	    $pourcentage = 0;
	    $pourcentage = (($localserver{$adresse}*1000)/$reqdomtot)/10 if ($reqdomtot != 0);
	    $pourcentageint = int($pourcentage);

	    print FOUT "&nbsp;</TD>\n";
	    print FOUT "<TD CLASS=\"left\">&nbsp;";
	    print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
	    printf FOUT "%.1f ",$pourcentage;
	    print FOUT " %</TD>\n";

#	    print FOUT "<TD CLASS=\"right\">&nbsp;<B>$nbpageserveurunique{$adresse}</B>&nbsp;</TD>\n";

	    if ($mail_format == 0 && $ftp_format == 0 && $cups_format == 0) {
#	    if ($mail_format == 0 && $ftp_format == 0) {
		print FOUT "<TD CLASS=\"right\">&nbsp;<B>$nbpageserveur{$adresse}</B>&nbsp;</TD>\n";
		$pourcentage = (($nbpageserveur{$adresse}*1000)/$access)/10 if ($access != 0);
		$pourcentageint = int($pourcentage);
		print FOUT "<TD CLASS=\"left\">&nbsp;";
		print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
	    printf FOUT "%.1f ",$pourcentage;
		print FOUT " %</TD>\n";
	    }

	    if ($spam_found != 0 && $spamonly != 1) {
		print FOUT "<TD CLASS=\"right\">";
		print FOUT "$spam_dom{$adresse}</TD>\n";
		print FOUT "<TD CLASS=\"left\">";
		$percentage = ($spam_dom{$adresse}*100)/$spam_found if ($spam_found != 0);
		$tmp2 = int($percentage);
		print FOUT "<img width=$tmp2 height=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">&nbsp;" if ($tmp2 != 0);
		printf FOUT "%3.1f %",$percentage;
		print FOUT "</TD>\n";
	    }

	    print FOUT "<TD CLASS=\"right\">&nbsp;<B>$nbpageserveurunique{$adresse}</B>&nbsp;</TD>\n" if ($home == 0 && $squid_format == 0 && $precision > 3);

	    if ($notrafic == 0) {
		$tmp = $localserversize{$adresse}/1024 if ($unit eq "$L{'Kb'}");
		$tmp = $localserversize{$adresse}/(1024*1024) if ($unit eq "$L{'Mb'}");
		$tmp = $localserversize{$adresse}/(1024*1024*1024) if ($unit eq "$L{'Gb'}");
		$tmp = $localserversize{$adresse}/(1024*1024*1024*1024) if ($unit eq "$L{'Tb'}");
		$pourcentage = 100*$tmp/($domsize*1024) if ($unit eq "$L{'Kb'}");
		$pourcentage = 100*$tmp/$domsize if ($unit eq "$L{'Mb'}");
		$pourcentage = 100*$tmp/($domsize/1024) if ($unit eq "$L{'Gb'}");
		$pourcentage = 100*$tmp/($domsize/(1024*1024)) if ($unit eq "$L{'Tb'}");
		$tmp = int($tmp*100)/100 if ($unit ne "$L{'Kb'}");			    
		$tmp = int($tmp) if ($unit eq "$L{'Kb'}");
		
		print FOUT "<TD CLASS=\"right\">&nbsp;<B>$tmp</B> ";
		print FOUT "&nbsp;</TD>\n";
		
		$pourcentageint = int($pourcentage);
		print FOUT "<TD CLASS=\"left\">&nbsp;";
		print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
		printf FOUT "%.1f ",$pourcentage;
		print FOUT " %</TD>\n";
	    }

	    print FOUT "<TD CLASS=\"right\">$localserverdate{$adresse}</TD>\n";
	    print FOUT "</TR>\n";

	}
	}
	print FOUT "</tbody>\n";
	print FOUT "</TABLE>\n";
    }

    print FOUT "<P>\n";

    if ($fly_set == 0) {
	$chart_id = 0;
	$info = "info".$chart_id;
	$i = &Load_DailyData($datafile,$dirdata);

	$xlegend = "$i $L{'days'}";
#    $xlegend .= "s" if ($count_month > 1);
	$xlegend .= " (starting $start_date)";
	$ylegend = $L{'Hosts'};
	
	undef @ref_tab;
	push(@ref_tab,\@tabreq) if ($mail_format == 0);
	push(@ref_tab,\@tabacc);
	push(@ref_tab,\@tabmm);
	push(@ref_tab,\@tabdoc);
	push(@ref_tab,\@tabscript);
	push(@ref_tab,\@tabuser);
	push(@ref_tab,\@tabtrafic);
	
	@ref_tab_name = ('requests','accesses','hosts','documents2','scripts','users','traffic') if ($mail_format == 0);
	@ref_tab_name = ('accesses','hosts','documents2','scripts','users','traffic') if ($mail_format == 1);
	
	&MakeDailyGraphJqplotInit(*FOUT, eval($Lang{$lang[$nblang]}),$I,1,$unit_div,\@ref_tab,\@ref_tab_name,\@listdate,$chart_id);

	@graph_to_display = ('Hosts');

	undef @ref_tab;
	push(@ref_tab,\@tabmm);
	
	&MakeDailyGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,1,\@graph_to_display,\@ref_tab,\@listdate,\@serie_color,1,$unit,$chart_id,3,"hosts",$info,0,$xlegend,$ylegend,$xmax_jqplot,$dirsite);

	&AddJqplotHtml(*FOUT, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_jqplot,$ymax_jqplot,2);

	$chart_id += $#list_graph_name_jqplot+1;
    }

    
    if ($fly_set == 1) {
	$file_page_page = "hosts-home";
	print FOUT "<P><CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
	print FOUT "<TR>\n";
	$tmp = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$file_page_page."y".$gifext;
	print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"y\"></TD>\n";
	$tmp = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$file_page_page.$gifext;
	print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"graph\" USEMAP=\"#map_page_graph\" BORDER=0></TD>\n";
	print FOUT "</TR><TR><TD></TD>\n";
	$tmp = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$file_page_page."x".$gifext;
	print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$tmp\" ALT=\"x\"></TD>\n";
	print FOUT "</TR>\n";
	print FOUT "</TABLE></CENTER>\n";
	print FOUT "<MAP NAME=\"map_page_graph\">";
	$tmp = $map_page_graph;
	$tmp =~ s/<!-- langhome -->/$I/g;
	print FOUT "$tmp";
#    print FOUT "$map_page_graph";
	print FOUT "</MAP>\n";
    }

    print FOUT "<P>";
    if ($linkpath_url ne '') {
	$datafileinc = $linkpath_url.$dirinc.$dirsepurl.$incservexterne.$txtext; #$"inc/serv-externe";
	$datafileinc_local = $linkpath_url.$dirinc.$dirsepurl.$incservinterne.$txtext; #"inc/serv-interne";
	$string_title = "$L{'Search'}:$L{'Search_on'}:$L{'No_item_found'}:$L{'Processing'}";
	$string_th = "$L{'Hosts'}:$L{'Requests'}:$L{'Accesses'}:$L{'Different_accesses'}:$L{'Traffic'}:$L{'Kb'}:$L{'Last_occurence'}";
	
	# Things to add 
	# - Page display if search item > 20
	# - Translate 'Search on', ' no iten found' 'here the XX items found'
	print FOUT "<P>";
	print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'Search'}</I> :</DIV><P>\n";

	print FOUT "<FORM method=\"POST\" name=\"ajax\" action=\"javascript:SearchHosts()\">\n";
	print FOUT "<TABLE BORDER=0><TR>\n";
	print FOUT "<TD VALIGN=MIDDLE>\n";
	print FOUT "<INPUT type=\"hidden\" name=\"precision\" value=\"$precision\">\n";
	print FOUT "<INPUT type=\"hidden\" name=\"notrafic\"  value=\"$notrafic\">\n";
	print FOUT "<INPUT type=\"hidden\" name=\"seuilsite\" value=\"$seuilsite\">\n";
	print FOUT "<INPUT type=\"hidden\" name=\"seuil_auto\" value=\"$seuil_auto\">\n";
	if ($ftp_format == 0 && $squid_format == 0 && $mail_format == 0 && $dhcp_format == 0) {
	    print FOUT "<INPUT type=\"hidden\" name=\"aff_access\" value=\"1\">\n";
	} else {
	    print FOUT "<INPUT type=\"hidden\" name=\"aff_access\" value=\"0\">\n";
	}
	if ($precision > 3 || $cups_format == 1 || $dhcp_format == 1) {
	    print FOUT "<INPUT type=\"hidden\" name=\"aff_uniq\" value=\"1\">\n";
	} else {
	    print FOUT "<INPUT type=\"hidden\" name=\"aff_uniq\" value=\"0\">\n";
	}

	print FOUT "<INPUT type=\"hidden\" name=\"datafile\" value=\"$datafileinc\">\n" if ($serverunique != 0);
	print FOUT "<INPUT type=\"hidden\" name=\"datafile\" value=\"$datafileinc_local\">\n" if ($serverunique == 0);
	print FOUT "<INPUT type=\"hidden\" name=\"datafile_local\" value=\"$datafileinc_local\">\n" if ($locallog != 0 && $locserver != 0 && $serverunique != 0);
	print FOUT "<INPUT type=\"hidden\" name=\"string_th\"  value=\"$string_th\">\n";
	print FOUT "<INPUT type=\"hidden\" name=\"string_title\"  value=\"$string_title\">\n";
	print FOUT "<INPUT type=\"hidden\" name=\"string_sep\"  value=\"\t\">\n";
	print FOUT "<INPUT type=\"hidden\" name=\"index_hit\"  value=\"1\">\n";

	print FOUT "<TABLE BORDER=0><TR>\n";
	print FOUT "<TH ALIGN=CENTER onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$L{'Title_search_hosts'}','$L{'Line_search_hosts'}','$L{'Desc_search_hosts'}','$L{'Link_search_hosts'}',0,'','$help_width')\">";
	print FOUT "$L{'Search'}</TH>\n";
	print FOUT "</TR><TR>\n";
#	print FOUT "<TD><INPUT type=\"text\" name=\"search_value\"  value=\"\" OnFocus=\"javascript:clean()\"></TD>\n";
	print FOUT "<TD>";
#	print FOUT "<INPUT type=\"text\" id=\"txtSearch\" name=\"search_value\"  value=\"\" onkeyup=\"searchSuggest();\" autocomplete=\"off\" OnFocus=\"javascript:clean()\">\n";
	print FOUT "<INPUT type=\"text\" id=\"txtSearch\" name=\"search_value\"  value=\"\" onkeyup=\"searchSuggest();\" OnBlur=\"javascript:clean_focus()\" OnFocus=\"javascript:clean()\">\n";
	print FOUT "<div id=\"search_suggest\"></div>\n";
	print FOUT "</TD>\n";
	print FOUT "</TR></TABLE>\n";
	print FOUT "</TD><TD VALIGN=TOP>";


	print FOUT "<TABLE BORDER=0><TR>\n";
	print FOUT "<TH COLSPAN=2 ALIGN=CENTER>$L{'Requests'}</TH>\n";
	print FOUT "</TR><TR>\n";
	print FOUT "<TD>$L{'Threshold'}</TD><TD><INPUT type=\"text\" size=\"3\" name=\"search_threshold\"  value=\"$seuilsite\"></TD>\n";
	print FOUT "</TR></TABLE>\n";
	print FOUT "</TD><TD VALIGN=TOP>";
	if ($locallog != 0 && $locserver != 0) {
	    if ($serverunique != 0) {
		print FOUT "<TABLE BORDER=0><TR>\n";
		print FOUT "<TH COLSPAN=4 ALIGN=CENTER>$L{'Hosts'}</TH>\n";
		print FOUT "</TR><TR>\n";
		print FOUT "<TD>$L{'external'}</TD><TD><INPUT type=\"radio\" name=\"mode_local\" value=\"0\" CHECKED></TD>\n";
		print FOUT "<TD>$L{'local'}</TD><TD><INPUT type=\"radio\" name=\"mode_local\" value=\"1\"></TD>\n";
		print FOUT "</TR></TABLE>\n";
	    } else {
		print FOUT "<INPUT type=\"hidden\" name=\"mode_local\"  value=\"0\">\n";
	    }
	} else {
	    print FOUT "<INPUT type=\"hidden\" name=\"mode_local\"  value=\"0\">\n";
	}
	print FOUT "</TD><TD VALIGN=MIDDLE>";
#	print FOUT "<INPUT type=\"submit\" name=\"search_button\"  class=\"submit_button\" value=\"Search\" OnFocus=\"javascript:document.ajax.search_button.value='$L{'Processing'}'\">\n";
	print FOUT "<INPUT type=\"submit\" name=\"search_button\"  class=\"submit_button\" value=\"$L{'Search'}\">\n";
	print FOUT "</TD></TR></TABLE>";
	print FOUT "</FORM><P>\n";
#	print FOUT "</TD></TR></TABLE>\n";

	print FOUT "<DIV ID=\"search_header\"></DIV>\n";
	print FOUT "<DIV ID=\"search_results\"></DIV>\n";
	print FOUT "<BR><P>\n";
    }


    if ($precision > 2 && $paysunique != 0) {
	print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'Sorted_countries_list'} $L{'by'} $L{'hosts'}</I></DIV><P>\n";

	print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
	print FOUT "<thead>\n";
	print FOUT "<TR>\n";
	print FOUT "<TH class=\"table-sortable:default\">$L{'Domain'}</TH>\n";
	print FOUT "<TH class=\"table-sortable:numeric\">$L{'Hosts'}</TH>\n";
	print FOUT "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n";
	print FOUT "<TH class=\"table-sortable:numeric\">$L{'Requests'}</TH>\n";
	print FOUT "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n";
	if ($spam_found != 0 && $spamonly != 1) {
	    print FOUT "<TH class=\"table-sortable:numeric\">$L{'Spam'}</TH>\n";
	    print FOUT "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n";
	}
	print FOUT "<TH class=\"table-sortable:numeric\">$L{'Requests'}/$L{'Hosts'}</TH>\n";

	if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	    print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
	    print FOUT "<TH class=\"table-sortable:numeric\">$L{'Accesses'}/$L{'Hosts'}</TH>\n";
	}
	print FOUT "</TR>\n";
	print FOUT "</thead>\n";
	print FOUT "<tbody>\n";

#      print FOUT "<A HREF=\"$flagpage{$pays}\"\>" if ($geoipcity == 0 && $found{$pays} == 1 && $payslist{$pays} > $seuilsite);

	foreach $pays (&reverse_sort_by_value(*serverpays)) {
	    next if ($pays eq '');
	    print FOUT "<TR>\n<TD CLASS=\"left\">";

	    print FOUT "<A HREF=\"..$dirsepurl$dirpays$dirsepurl$flagpage{$pays}\"\>" if ($found{$pays} == 1 && $payslist{$pays} > $seuilsite);
	    if (-f "$pathinit$dirress$dirsep$dirflags$dirsep$pays$gifext") {
		print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirflags$dirsepurl$pays$gifext\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=0 ALT=\"$pays\">";
	    } else {
		$tmp2 = "Unknown";
		print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirflags$dirsepurl$tmp2$gifext\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=0 ALT=\"$tmp2\">";
	    }
	    print FOUT "</A>" if ($found{$pays} == 1 && $payslist{$pays} > $seuilsite);
	    print FOUT "&nbsp;";
	    
	    print FOUT "<A HREF=\"..$dirsepurl$dirpays$dirsepurl$flagpage{$pays}\"\>" if ($found{$pays} == 1 && $payslist{$pays} > $seuilsite);

	    print FOUT "$L{$newflag{$pays}}" if ($L{$newflag{$pays}} ne '');
	    print FOUT "$L{'Unknown'}" if ($L{$newflag{$pays}} eq '');
	    print FOUT "</A>" if ($found{$pays} == 1 && $payslist{$pays} > $seuilsite);
	    print FOUT "&nbsp;(<I>$pays</I>)&nbsp;</TD>\n";


	    print FOUT "<TD CLASS=\"right\"><B>$serverpays{$pays}</B></TD>\n";
	    $pourcentage = (($serverpays{$pays}*1000)/$serveruniquetot)/10;
	    $pourcentageint = int($pourcentage);
	    print FOUT "<TD CLASS=\"left\">&nbsp;";
	    print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\"> " if ($pourcentageint != 0);
	    printf FOUT "%.1f ",$pourcentage;
	    print FOUT " %</TD>\n";

	    print FOUT "<TD CLASS=\"right\">$payslist{$pays}</TD>\n";
	    $pourcentage = (1000*$payslist{$pays}/$reqtot)/10;
	    $pourcentageint = int($pourcentage);
	    print FOUT "<TD CLASS=\"left\">&nbsp;";
	    print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
	    printf FOUT "%.1f ",$pourcentage;
	    print FOUT " %</TD>\n";

	    if ($spam_found != 0 && $spamonly != 1) {
		print FOUT "<TD CLASS=\"right\">$spam_pays{$pays}</TD>\n";
		$pourcentage = (1000*$spam_pays{$pays}/$spam_found)/10 if ($spam_pays{$pays} != 0);
		$pourcentageint = int($pourcentage);
		print FOUT "<TD CLASS=\"left\">&nbsp;";
		print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
		printf FOUT "%.1f ",$pourcentage;
		print FOUT " %</TD>\n";
	    }

	    $tmp = int($payslist{$pays}/$serverpays{$pays}) if ($serverpays{$pays} != 0);
	    print FOUT "<TD CLASS=\"right\"><I>$tmp</I></TD>\n";
#	    printf FOUT "%.1f ",$tmp;
#	    print FOUT "</I></TD>\n";

	    if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
		print FOUT "<TD CLASS=\"right\">$payshtml{$pays}</TD>\n";
		$tmp = int($payshtml{$pays}/$serverpays{$pays}) if ($serverpays{$pays} != 0);
		print FOUT "<TD CLASS=\"right\"><I>$tmp</I></TD>\n";
#		printf FOUT "%.1f ",$tmp;
#		print FOUT "</I></TD>\n";
		}
	    print FOUT "</TR>\n";
	}
	print FOUT "</tbody>\n";
	print FOUT "</TABLE>\n";
    }
    print FOUT "</BODY></HTML>\n";

#    &PageSitesDesc(eval($Lang{$lang[$nblang]}));
}



###

sub PageSitesDesc {
    local(*L,$I) = @_;
    local($count,$count2,%countpays);
    local(%tmp_line);

#
### External DNS hosts
#

	#
	### External IP Hosts
	#

	# Need to be build first
    $count2 = 0;
#    undef %countpays;
	foreach $serveur (&reverse_sort_by_value(*server)) {
#	foreach $serveur (sort keys(%server)) {
#	    if ($serveur =~ /[0-9]+$/ && $server{$serveur} > $seuil_auto) {
	    if ($serveur =~ /[0-9]+$/ || $serveur =~ /:/) {
		
		$newserveur = $serveur;
		$newserveur =~ s/[.:]/_/g;

		if ($reverse_geo == 1) {
		    $extpays = $pays_ip{$serveur};

		    $pourcentage = 0;
		    $pourcentage2 = 0;
		    $pourcentage = 100*$server{$serveur}/$payslist{$extpays} if ($payslist{$extpays} != 0 && $geoipcity == 0);
#		    $pourcentage = 100*$server{$serveur}/$payslistcity{$extpays} if ($payslistcity{$extpays} != 0 && $geoipcity == 1);
		    $pourcentage = 100*$server{$serveur}/$unresolved_hits{$extpays} if ($unresolved_hits{$extpays} != 0 && $geoipcity == 1);
		    $pourcentageint = int($pourcentage);
		    $pourcentage2 = 100*$nbpageserveur{$serveur}/$payshtml{$extpays} if ($payshtml{$extpays} != 0 && $geoipcity == 0);
#		    $pourcentage2 = 100*$nbpageserveur{$serveur}/$payshtmlcity{$extpays} if ($payshtmlcity{$extpays} != 0 && $geoipcity == 1);
		    $pourcentage2 = 100*$nbpageserveur{$serveur}/$unresolved_access{$extpays} if ($unresolved_access{$extpays} != 0 && $geoipcity == 1);
		    $pourcentage2int = int($pourcentage2);


#$unresolved_hits{$extpays} $unresolved_access{$extpays}  $unresolved_size{$extpays} 

		    $unit2{$extpays} = "Kb";
		    $unitsize = 1024;
		    if ($unresolved_size{$extpays} > (1024*1024)) {
			$unit2{$extpays} = "Mb";
			$unitsize = 1024*1024;
		    }
		    if ($unresolved_size{$extpays} > (1024*1024*1024)) {
			$unit2{$extpays} = "Gb";
			$unitsize = 1024*1024*1024;
		    }
		    if ($unresolved_size{$extpays} > (1024*1024*1024*1024)) {
			$unit2{$extpays} = "Tb";
			$unitsize = 1024*1024*1024*1024;
		    }

                    # decrease one magnitude for a nicer display
		    if (int($unresolved_size{$extpays}/$unitsize) < 10) {
			$unitsize /= 1024;
			$unit2{$extpays} = "$L{'Kb'}" if ($unit2{$extpays} eq "$L{'Mb'}");
			$unit2{$extpays} = "$L{'Mb'}" if ($unit2{$extpays} eq "$L{'Gb'}");
			$unit2{$extpays} = "$L{'Gb'}" if ($unit2{$extpays} eq "$L{'Tb'}");
		    }

#		    if ($tmp_line{$extpays} eq '') {

		    if ($server{$serveur} > $seuilsite && $countpays{$extpays} < $max_item_page) {
			$found{$extpays} = 1;
			$countpays{$extpays}++;

#			    open(FILESITEPAYSLIST,">>$path$lang[$nblang]$dirsep$dirpays$dirsep$extpays$unresolved") || &error_exit("Error, unable to open file $path$lang[$nblang]$dirsep$dirpays$dirsep$extpays$unresolved");
			    $tmp_line{$extpays} .= "<TR>\n<TD CLASS=\"left\">";
			    $tmp_line{$extpays} .= "<A HREF=\"..$dirsepurl$dirsite$dirsepurl$newserveur$htmlext\">" if ($precision > 3 && $nbpageserveur{$serveur} > 0);
			    $tmp_line{$extpays} .= "<B>$serveur</B>";
			    $tmp_line{$extpays} .= "</A>" if ($precision > 3 && $nbpageserveur{$serveur} > 0);
			    $tmp_line{$extpays} .= "</TD>\n";
			    if ($geoipcity == 1) {
				$tmp_line{$extpays} .= "<TD>&nbsp;";
				$tmp = $revcity{$serveur};
				$tmp = &noaccentinhtml($tmp);
				$tmp_line{$extpays} .= "<A HREF=\"\.\.$dirsepurl$dircity$dirsepurl$extpays$tmp$htmlext\">" if (-f "$path$lang[$nblang]$dirsep$dircity$dirsepurl$extpays$tmp$htmlext");
				$tmp_line{$extpays} .= "$revcity{$serveur}";
				$tmp_line{$extpays} .= "</A>" if (-f "$path$lang[$nblang]$dirsep$dircity$dirsepurl$extpays$tmp$htmlext");
				$tmp_line{$extpays} .= "&nbsp;</TD>\n";
			    }
			    $tmp_line{$extpays} .= "<TD CLASS=\"right\"><I>$domaindate{$serveur}</I></TD>\n";


#		    $tmp_line{$extpays} .= "<TD CLASS=\"left\">&nbsp;";
#		    if (int($pourcentage3) != 0) {
#			$$tmp_line{$extpays} .= "<IMG WIDTH=";
#			$tmp_line{$extpays} .= "%d",$pourcentage3;
#			$tmp_line{$extpays} .= " HEIGHT=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[4]\" ALT=\"$gcolor[4]\">";
#		    }
#		    $tmp_line{$extpays} .= " 1</TD>\n";
#		    $tmp_line{$extpays} .= "<TD CLASS=\"right\">TOTO \%</TD>";


			    $tmp_line{$extpays} .= "<TD CLASS=\"left\">&nbsp;";
			    if ($pourcentage != 0) {
				$tmp_line{$extpays} .= "<IMG WIDTH=$pourcentageint";
				$tmp_line{$extpays} .= " HEIGHT=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">";
			    }
			    $tmp_line{$extpays} .= " $server{$serveur}</TD>\n";
			$pourcentage = int($pourcentage*100)/100;
			$tmp_line{$extpays} .= "<TD CLASS=\"right\">$pourcentage \%&nbsp;</TD>\n";

			    if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
				$tmp_line{$extpays} .= "<TD CLASS=\"left\">&nbsp;";
				if ($pourcentage2 != 0) {
				    $tmp_line{$extpays} .= "<IMG WIDTH=$pourcentage2int";
				    $tmp_line{$extpays} .= " HEIGHT=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">";
				}
				$tmp_line{$extpays} .= "&nbsp;$nbpageserveur{$serveur}</TD>\n";
				$pourcentage2 = int($pourcentage2*100)/100;
				$tmp_line{$extpays} .= "<TD CLASS=\"right\">$pourcentage2 \%&nbsp;</TD>\n";
			    }

			$tmp_line{$extpays} .= "<TD CLASS=\"right\">&nbsp;$nbpageserveurunique{$serveur}&nbsp;</TD>\n" if ($precision > 3);

			    if ($notrafic == 0) {
				$tmp_line{$extpays} .= "<TD CLASS=\"left\">\n";
				$tmp = $serversize{$serveur};
				$tmp = $serversize{$serveur}/1024 if ($unit2{$extpays} eq "Kb");
				$tmp = $serversize{$serveur}/(1024*1024) if ($unit2{$extpays} eq "Mb");
				$tmp = $serversize{$serveur}/(1024*1024*1024) if ($unit2{$extpays} eq "Gb");
				$tmp = $serversize{$serveur}/(1024*1024*1024*1024) if ($unit2{$extpays} eq "Tb");
				$pourcentage = 100*$serversize{$serveur}/$sizepays{$extpays} if ($sizepays{$extpays} != 0 && $geoipcity == 0);
				$pourcentage = 100*$serversize{$serveur}/$unresolved_size{$extpays} if ($unresolved_size{$extpays} != 0 && $geoipcity == 1);
				$pourcentageint = int($pourcentage);
				$tmp = int($tmp*100)/100 if ($unit2{$extpays} ne "Kb");			    
				$tmp = int($tmp) if ($unit2{$extpays} eq "Kb");
				if ($pourcentageint != 0) {
				    $tmp_line{$extpays} .= "<IMG WIDTH=$pourcentageint";
				    $tmp_line{$extpays} .= " HEIGHT=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">";
				}
				$tmp_line{$extpays} .= "&nbsp;$tmp";
				$pourcentage = int($pourcentage*100)/100;
				$tmp_line{$extpays} .= "</TD>\n";
				$tmp_line{$extpays} .= "<TD CLASS=\"right\">$pourcentage \%&nbsp;</TD>\n";
			    }
			    $tmp_line{$extpays} .= "</TR>\n";

#			    close(FILESITEPAYSLIST);

#			} # rtototo
			    }
#		    }
		    
		}
		

		if ($found{Unknown} == 1) {

		    if ($server{$serveur} > $seuil_auto && $count2 < $max_item_page) {

			next if ($pays_ip{$serveur} ne '' && $reverse_geo == 1);
			$count2++;

			$nbcityunknown++;

			$pourcentage = 100*$server{$serveur}/$payslist{Unknown} if ($payslist{Unknown} != 0 && $geoipcity == 0);
			$pourcentage = 100*$server{$serveur}/$payslistcity{Unknown} if ($payslistcity{Unknown} != 0 && $geoipcity == 1);
			$pourcentageint = int($pourcentage);
			$pourcentage2 = 100*$nbpageserveur{$serveur}/$payshtml{Unknown} if ($payshtml{Unknown} != 0 && $geoipcity == 0);
			$pourcentage2 = 100*$nbpageserveur{$serveur}/$payshtmlcity{Unknown} if ($payshtmlcity{Unknown} != 0 && $geoipcity == 1);
			$pourcentage2int = int($pourcentage2);

#			open(FILESITEPAYS,">>$path$lang[$nblang]$dirsep$dirpays$dirsep$unresolved") || die "Error, unable to open $path$lang[$nblang]$dirsep$dirpays$dirsep$unresolved\n";
			$tmp_line .= "<TR>\n<TD CLASS=\"left\">";
			$tmp_line .= "<A HREF=\"..$dirsepurl$dirsite$dirsepurl$newserveur$htmlext\">" if ($precision > 3 && $nbpageserveur{$serveur} > 0);
			$tmp_line .= "<B>$serveur</B>";
			$tmp_line .= "</A>" if ($precision > 3 && $nbpageserveur{$serveur} > 0);
			$tmp_line .= "</TD>\n";
			$tmp_line .= "<TD>&nbsp;$revcity{$serveur}&nbsp;</TD>\n" if ($geoipcity == 1);
			$tmp_line .= "<TD CLASS=\"right\"><I>$domaindate{$serveur}</I></TD>\n";

#		    $tmp_line .= "<TD CLASS=\"left\">&nbsp;";
#		    if (int($pourcentage3) != 0) {
#			$$tmp_line{$extpays} .= "<IMG WIDTH=";
#			$tmp_line{$extpays} .= "%d",$pourcentage3;
#			$tmp_line{$extpays} .= " HEIGHT=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[4]\" ALT=\"$gcolor[4]\">";
#		    }
#		    $tmp_line .= " 1</TD>\n";
#		    $tmp_line .= "<TD CLASS=\"right\">TOTO \%</TD>";

			$tmp_line .= "<TD CLASS=\"left\">&nbsp;";
			if ($pourcentageint != 0) {
			    $tmp_line .= "<IMG WIDTH=$pourcentageint";
#			    printf FILESITEPAYS "%d",$pourcentage;
			    $tmp_line .= " HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">";
			}
			$tmp_line .= " $server{$serveur}</TD>\n";
			$pourcentage = int($pourcentage*100)/100;
			$tmp_line .= "<TD CLASS=\"right\">$pourcentage \%&nbsp;</TD>\n";
#			printf FILESITEPAYS "<TD CLASS=\"right\">%3.1f \%",$pourcentage;
#			print FILESITEPAYS "&nbsp;</TD>\n";

			if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
			    $tmp_line .= "<TD CLASS=\"left\">&nbsp;";
			    if ($pourcentage2int != 0) {
				$tmp_line .= "<IMG WIDTH=$pourcentage2int";
#				printf FILESITEPAYS "%d",$pourcentage2;
				$tmp_line .= " HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">";
			    }
			    $tmp_line .= " $nbpageserveur{$serveur}</TD>\n";
			    $pourcentage2 = int($pourcentage2*10)/10;
			    $tmp_line .= "<TD CLASS=\"right\">$pourcentage2 \%";
			    $tmp_line .= "</TD>\n";
			}

			$tmp_line .= "<TD CLASS=\"right\">&nbsp;$nbpageserveurunique{$serveur}&nbsp;</TD>\n" if ($precision > 3);
			
			if ($notrafic == 0) {
			    $tmp_line .= "<TD CLASS=\"left\">";
			    $tmp = $serversize{$serveur} if ($unit{Unknown} eq "octects");
			    $tmp = $serversize{$serveur}/1024 if ($unit{Unknown} eq "Kb");
			    $tmp = $serversize{$serveur}/(1024*1024) if ($unit{Unknown} eq "Mb");
			    $tmp = $serversize{$serveur}/(1024*1024*1024) if ($unit{Unknown} eq "Gb");
			    $tmp = $serversize{$serveur}/(1024*1024*1024*1024) if ($unit{Unknown} eq "Tb");
			    $pourcentage = 100*$serversize{$serveur}/$sizepays{Unknown} if ($sizepays{Unknown} != 0 && $geoipcity == 0);
			    $pourcentage = 100*$serversize{$serveur}/$sizepayscity{Unknown} if ($sizepayscity{Unknown} != 0 && $geoipcity == 1);
			    $pourcentageint = int($pourcentage);
			    $tmp = int($tmp*10)/10 if ($unit{Unknown} ne "Kb");			    
			    $tmp = int($tmp) if ($unit{Unknown} eq "Kb");
			    if ($pourcentageint != 0) {
				$tmp_line .= "<IMG WIDTH=$pourcentageint";
#				printf FILESITEPAYS "%d",$pourcentage;
				$tmp_line .= " HEIGHT=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[4]\" ALT=\"$gcolor[4]\">";
			    }
#		    printf FILESITEPAYS " %.1f $unit",($serversize{$serveur}/(1024*1024));
			    $tmp_line .= " $tmp</TD>\n";
#			    printf FILESITEPAYS " %.1f",$tmp;
#			    printf FILESITEPAYS "</TD>\n";
			    $pourcentage = int($pourcentage*10)/10;
			    $tmp_line .= "<TD CLASS=\"right\">$pourcentage \%";
			    $tmp_line .= "</TD>\n";
			}
			$tmp_line .= "</TR>\n";
#			close(FILESITEPAYS);
		    }
		}
	    }
	} # foreach $server

    if ($reverse_geo == 1) {
	foreach $extpays (keys(%countpays)) {
#	    print "A1 - $extpays - $countpays{$extpays} - $tmp_line{$extpays}\n";
#		    if (!(-f "$path$lang[$nblang]$dirsep$dirpays$dirsep$extpays$unresolved") || $count{$extpays} eq '') {
	    if (!(-f "$path$lang[$nblang]$dirsep$dirpays$dirsep$extpays$unresolved") || $scriptname eq "cron-inc.pl") {
		open(PAGEUNRESOLVED,">$path$lang[$nblang]$dirsep$dirpays$dirsep$extpays$unresolved") || &error_exit("Error, unable to open $path$lang[$nblang]$dirsep$dircity$dirsep$extpays$unresolved");
		&PageHeaderUnresolved(*PAGEUNRESOLVED, $countpays{$extpays},eval($Lang{$lang[$nblang]}),$lang[$nblang]);
		close (PAGEUNRESOLVED);
	    }
	    
	    open(FILESITEPAYSLIST,">>$path$lang[$nblang]$dirsep$dirpays$dirsep$extpays$unresolved") || &error_exit("Error, unable to open file $path$lang[$nblang]$dirsep$dirpays$dirsep$extpays$unresolved");
	    print FILESITEPAYSLIST "$tmp_line{$extpays}";
	    close(FILESITEPAYSLIST);

	}
	
	undef %count_pays;

    }

	if ($found{Unknown} == 1) {
	    $file_to_open = "$path$lang[$nblang]$dirsep$dirpays$dirsep$unresolved";
	    open(FILESITEPAYS,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
	    &PageHeaderPaysUnknown(*FILESITEPAYS, $count2,eval($Lang{$lang[$nblang]}),$lang[$nblang]);
	    close (FILESITEPAYS);

	    open(FILESITEPAYS,">>$path$lang[$nblang]$dirsep$dirpays$dirsep$unresolved") || die "Error, unable to open $path$lang[$nblang]$dirsep$dirpays$dirsep$unresolved\n";
	    print FILESITEPAYS "$tmp_line";
	    close(FILESITEPAYS);
	    $tmp_line = '';
	}


	#
	### Domain server
	#


	foreach $domadresse (sort keys(%domserver)) {

	    if ($domserver{$domadresse} > $seuilsite) {
		
		$newsite = $domadresse;
		$newsite =~ s/[.:]/_/g;

		$pospoint = rindex($domadresse,'.');
#		$extpays = substr($domadresse,$pospoint+1,length($domadresse));
		$extpays = $domserverpays{$domadresse};
		$pourcentage = 100*$domserver{$domadresse}/$payslist{$extpays} if ($payslist{$extpays} != 0);
		$pourcentage2 = 100*$domserverhtml{$domadresse}/$payshtml{$extpays} if ($payshtml{$extpays} != 0);                
		$pourcentage2 = 0 if ($payshtml{$extpays} == 0);                
		$pourcentage3 = 100*$nb{$domadresse}/$serverpays{$extpays} if ($serverpays{$extpays} != 0);
		$pourcentage4 = 100*$spam_dom{$domadresse}/$spam_pays{$extpays} if ($spam_pays{$extpays} != 0);

		$found{$extpays} = 1;

#		if ($found{$extpays} == 1) {

		    $flag_dom = 0;
		    for ($j=1;$j<=$nb{$domadresse};$j++) {          
			if ($server{$domsites{$domadresse,$j}} > $seuilsite) {
			    $flag_dom = 1;
			}
		    }

		    open(FILESITEPAYS,">>$path$lang[$nblang]$dirsep$dirpays$dirsep$flagpage{$extpays}") || die "Error, unable to open file $path$lang[$nblang]$dirsep$dirpays$dirsep$flagpage{$extpays}\n";

		    print FILESITEPAYS "<TR><TD CLASS=\"left\"><B>";
		    print FILESITEPAYS "<A HREF=\"..$dirsepurl$dirdomain$dirsepurl$newsite$htmlext\">" if ($flag_dom == 1);
		    print FILESITEPAYS "$domadresse";
		    print FILESITEPAYS "</A>" if ($flag_dom == 1);
		    print FILESITEPAYS "</B></TD>\n";
		    print FILESITEPAYS "<TD CLASS=\"right\"><I>$domaindate{$domadresse}</I></TD>\n";
		    print FILESITEPAYS "<TD CLASS=\"left\">&nbsp;";
		    if (int($pourcentage3) != 0) {
			print FILESITEPAYS "<IMG WIDTH=";
			printf FILESITEPAYS "%d",$pourcentage3;
			print FILESITEPAYS " HEIGHT=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[4]\" ALT=\"$gcolor[4]\">";
		    }
		    print FILESITEPAYS " $nb{$domadresse}</TD>\n";
		    printf FILESITEPAYS "<TD CLASS=\"right\">%3.1f \%</TD>",$pourcentage3;
		    print FILESITEPAYS "<TD CLASS=\"left\">&nbsp;";
		    if (int($pourcentage) != 0) {
			print FILESITEPAYS "<IMG WIDTH=";
			printf FILESITEPAYS "%d",$pourcentage;
			print FILESITEPAYS " HEIGHT=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">";
		    }
		    print FILESITEPAYS " $domserver{$domadresse}</TD>\n";
		    printf FILESITEPAYS "<TD CLASS=\"right\">%3.1f \%",$pourcentage;
		    print FILESITEPAYS "&nbsp;</TD>\n";

		if ($spam_found != 0 && $spamonly != 1) {
		    print FILESITEPAYS "<TD CLASS=\"left\">&nbsp;";
		    if (int($pourcentage4) != 0) {
			print FILESITEPAYS "<IMG WIDTH=";
			printf FILESITEPAYS "%d",$pourcentage4;
			print FILESITEPAYS " HEIGHT=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">";
		    }
		    print FILESITEPAYS " $spam_dom{$domadresse}</TD>\n";
		    printf FILESITEPAYS "<TD CLASS=\"right\">%3.1f \%",$pourcentage4;
		    print FILESITEPAYS "&nbsp;</TD>\n";
		}

		    if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
			print FILESITEPAYS "<TD CLASS=\"left\">&nbsp;";
			if (int($pourcentage2) != 0) {
			    print FILESITEPAYS "<IMG WIDTH=";
			    printf FILESITEPAYS "%d",$pourcentage2;
			    print FILESITEPAYS " HEIGHT=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">";
			}
			print FILESITEPAYS " $domserverhtml{$domadresse}</TD>\n";
			printf FILESITEPAYS "<TD CLASS=\"right\">%3.1f \%",$pourcentage2;
			print FILESITEPAYS "&nbsp;</TD>\n";                
		    }

#		print FILESITEPAYS "<TD CLASS=\"right\">&nbsp;<B>$nbpageserveurunique{$domsites{$domadresse,$j}}</B>&nbsp;</TD>\n" if ($precision > 3);

		    if ($notrafic == 0) {
			$pourcentage4 = 100*($domserversize{$domadresse}*1024)/$sizepays{$extpays} if ($sizepays{$extpays} != 0);

			print FILESITEPAYS "<TD CLASS=\"left\">&nbsp;";
			if (int($pourcentage4) != 0) {
			    print FILESITEPAYS "<IMG WIDTH=";
			    printf FILESITEPAYS "%d",$pourcentage4;
			    print FILESITEPAYS " HEIGHT=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">";
			}

			$tmp = $domserversize{$domadresse} if ($unit{$extpays} eq "Kb");
			$tmp = $domserversize{$domadresse}/1024 if ($unit{$extpays} eq "Mb");
			$tmp = $domserversize{$domadresse}/(1024*1024) if ($unit{$extpays} eq "Gb");
			$tmp = $domserversize{$domadresse}/(1024*1024*1024) if ($unit{$extpays} eq "Tb");
			
			$tmp = int($tmp) if ($unit{$extpays} eq "Kb");
			$tmp = int(100*$tmp)/100 if ($unit{$extpays} ne "Kb");
			printf FILESITEPAYS " $tmp</TD>";
			printf FILESITEPAYS "<TD CLASS=\"right\">%3.1f \%",$pourcentage4;
			print FILESITEPAYS "&nbsp;</TD>\n";
		    }

		    $tmp2 = 0;
		    $unit = "$L{'bytes'}";
		    for ($j=1;$j<=$nb{$domadresse};$j++) {
			if ($domsites{$domadresse,$j} =~ /$domadresse$/) {
			    if ($server{$domsites{$domadresse,$j}} > $seuilsite) {
				if ($serversize{$domsites{$domadresse,$j}} > $tmp2) {
				    $tmp2 = $serversize{$domsites{$domadresse,$j}};
				    $unit = "$L{'Kb'}" if ($tmp2 > 1024);
				    $unit = "$L{'Mb'}" if ($tmp2 > (1024*1024));
				    $unit = "$L{'Gb'}" if ($tmp2 > (1024*1024*1024));
				    $unit = "$L{'Tb'}" if ($tmp2 > (1024*1024*1024*1024));
				}
			    }
			}
		    }
		    
		    print FILESITEPAYS "</TR>\n";


		    if ($flag_dom == 1) {

			$file_to_open = "$path$lang[$nblang]$dirsep$dirdomain$dirsep$newsite$htmlext";
#			print "C - $dirdomain$dirsep$newsite$htmlext\n";
			open(FILESITEPAYSLIST,">$file_to_open") || die "Error, unable to open file $file_to_open\n";
			
			print FILESITEPAYSLIST "$doctype\n";
#			print FILESITEPAYSLIST "<HTML><HEAD>\n";
			print FILESITEPAYSLIST "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
			print FILESITEPAYSLIST "$charset\n";
			print FILESITEPAYSLIST "<TITLE>$L{'Hosts'} - $domadresse</TITLE>\n";
			print FILESITEPAYSLIST "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
			print FILESITEPAYSLIST "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
			print FILESITEPAYSLIST "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
			print FILESITEPAYSLIST "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
			print FILESITEPAYSLIST "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
			print FILESITEPAYSLIST "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
			print FILESITEPAYSLIST "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
			print FILESITEPAYSLIST "$curvy_bottom_jss\n";

			&add_css_style(*FILESITEPAYSLIST,2);
			print FILESITEPAYSLIST "</HEAD>\n";
			print FILESITEPAYSLIST "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
			&add_css_menu(*FILESITEPAYSLIST,*L,$lang[$nblang],$nblang,2);
			print FILESITEPAYSLIST "<H2>$L{'Hosts'} - $domadresse</H2><P>\n";
			print FILESITEPAYSLIST "<P><HR><P>\n";
			print FILESITEPAYSLIST "<I>($L{'Only_hosts'} $L{'with_at_least'} $seuilsite $L{'requests'} $L{'are_shown'})</I><P>\n" if ($seuilsite > 1);

			print FILESITEPAYSLIST "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
			print FILESITEPAYSLIST "<thead>\n";
			print FILESITEPAYSLIST "<TR>\n";
			print FILESITEPAYSLIST "<TH class=\"table-sortable:default\">$L{'Hosts'}</TH>\n";
			print FILESITEPAYSLIST "<TH class=\"table-sortable:default\">$L{'Cities'}</TH>\n" if ($geoipcity == 1);
			print FILESITEPAYSLIST "<TH class=\"table-sortable:date\">&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n";
			print FILESITEPAYSLIST "<TH class=\"table-sortable:numeric\">$L{'Requests'}</TH>\n";
			print FILESITEPAYSLIST "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n";

			if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
			    print FILESITEPAYSLIST "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
			    print FILESITEPAYSLIST "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n"
			}
			
			if ($spam_found != 0 && $spamonly != 1) {
			    print FILESITEPAYSLIST "<TH class=\"table-sortable:numeric\">$L{'Spam'}</TH>\n";
			    print FILESITEPAYSLIST "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n";
			}

			if ($precision > 3 && $squid_format == 0) {
#			    if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
				print FILESITEPAYSLIST "<TH class=\"table-sortable:numeric\">$L{'Different_accesses'}&nbsp;</TH>\n";
#			    } else {
#				print FILESITEPAYSLIST "<TH class=\"table-sortable:numeric\">$L{'Requests'}&nbsp;($L{'Unique'})&nbsp;</TH>\n";
#			    }
			}

			print FILESITEPAYSLIST "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n" if ($notrafic == 0);
			print FILESITEPAYSLIST "</TR>\n";
			print FILESITEPAYSLIST "</thead>\n";
			print FILESITEPAYSLIST "<tbody>\n";

			for ($j=1;$j<=$nb{$domadresse};$j++) {          
			    if ($server{$domsites{$domadresse,$j}} > $seuilsite) {
				$newserveur = $domsites{$domadresse,$j};
				$pospoint = index($newserveur,'.',0);
				$newserveur =~ s/[.:]/_/g;
				
				$saveadresse = $newserveur;
				if ($newserveur !~ /[0-9]$/ && $newserveur !~ /:/) {
				    $saveadresse = substr($newserveur,$pospoint+1,(length($newserveur)-length($pospoint)));
				    $saveadresse = $newserveur if ($saveadresse !~ /_/);
				}

				$pourcentage = 100*$server{$domsites{$domadresse,$j}}/$domserver{$domadresse}; # if ($mail_format == 0);
#				$pourcentage = 100*$server{$domsites{$domadresse,$j}}/$reqtot if ($mail_format == 1);

				print FILESITEPAYSLIST "<TR>\n<TD CLASS=\"left\">";
				print FILESITEPAYSLIST "<A HREF=\"..$dirsepurl$dirsite$dirsepurl$saveadresse$htmlext#$domsites{$domadresse,$j}\"\>"  if ($precision > 3 && $nbpageserveur{$domsites{$domadresse,$j}} > 0 && -f "$path$lang[$nblang]$dirsep$dirsite$dirsepurl$saveadresse$htmlext");
				print FILESITEPAYSLIST "$domsites{$domadresse,$j}";
				print FILESITEPAYSLIST "</A> " if ($precision > 3 && $nbpageserveur{$domsites{$domadresse,$j}} > 0 && -f "$path$lang[$nblang]$dirsep$dirsite$dirsepurl$saveadresse$htmlext");
				print FILESITEPAYSLIST "</TD>\n";
				if ($geoipcity == 1) {
				    $tmp = $revcity{$domsites{$domadresse,$j}};
				    $tmp = &noaccentinhtml($tmp);
				    print FILESITEPAYSLIST "<TD CLASS=\"right\">&nbsp;";
				    print FILESITEPAYSLIST "<A HREF=\"\.\.$dirsepurl$dircity$dirsepurl$extpays$tmp$htmlext\">" if (-f "$path$lang[$nblang]$dirsep$dircity$dirsepurl$extpays$tmp$htmlext");
				    # NEWNEW Never work because city pages are built after !
				    print FILESITEPAYSLIST "$revcity{$domsites{$domadresse,$j}}";
				    print FILESITEPAYSLIST "</A>" if (-f "$path$lang[$nblang]$dirsep$dircity$dirsepurl$extpays$tmp$htmlext");
				    print FILESITEPAYSLIST "&nbsp;</TD>\n";
				}
				print FILESITEPAYSLIST "<TD CLASS=\"right\">";
				print FILESITEPAYSLIST "$serverdate{$domsites{$domadresse,$j}}";
				print FILESITEPAYSLIST "</TD>\n";
				print FILESITEPAYSLIST "<TD CLASS=\"left\">";
				if (int($pourcentage) != 0) {
				    print FILESITEPAYSLIST "<IMG WIDTH=";
				    printf FILESITEPAYSLIST "%d",$pourcentage;
				    print FILESITEPAYSLIST " HEIGHT=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;";
				}
				print FILESITEPAYSLIST "$server{$domsites{$domadresse,$j}}";
				printf FILESITEPAYSLIST "</TD>\n<TD CLASS=\"right\">%3.1f&nbsp;\%",$pourcentage;
				print FILESITEPAYSLIST "</TD>\n";

				if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
				    $pourcentage2 = 100*$nbpageserveur{$domsites{$domadresse,$j}}/$domserverhtml{$domadresse} if ($domserverhtml{$domadresse} != 0);
				    $pourcentage2 = 0 if ($domserverhtml{$domadresse} == 0); 
				    
				    print FILESITEPAYSLIST "<TD CLASS=\"left\">";
				    if (int($pourcentage2) != 0) {
					print FILESITEPAYSLIST "<IMG WIDTH=";
					printf FILESITEPAYSLIST "%d",$pourcentage2;
					print FILESITEPAYSLIST " HEIGHT=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">&nbsp;";
				    }
				    print FILESITEPAYSLIST "$nbpageserveur{$domsites{$domadresse,$j}}";
				    printf FILESITEPAYSLIST "</TD>\n<TD CLASS=\"right\">%3.1f&nbsp;\%",$pourcentage2;                        
				    print FILESITEPAYSLIST "</TD>\n";
				}

				if ($spam_found != 0 && $spamonly != 1) {
				    $spam_dom{$domsites{$domadresse,$j}} = 0 if ($spam_dom{$domsites{$domadresse,$j}} eq '');
				    print FILESITEPAYSLIST "<TD CLASS=\"right\">";
				    print FILESITEPAYSLIST "$spam_dom{$domsites{$domadresse,$j}}</TD>\n";
				    print FILESITEPAYSLIST "<TD CLASS=\"left\">";
				    $percentage = ($spam_dom{$domsites{$domadresse,$j}}*100)/$spam_found; # if ($server{$domsites{$domadresse,$j}} != 0);
				    $tmp2 = int($percentage);
				    print FILESITEPAYSLIST "<img width=$tmp2 height=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">&nbsp;" if ($tmp2 != 0);
				    printf FILESITEPAYSLIST "%3.1f %",$percentage;
				    print FILESITEPAYSLIST "</TD>\n";
				}

				print FILESITEPAYSLIST "<TD CLASS=\"right\">&nbsp;$nbpageserveurunique{$domsites{$domadresse,$j}}&nbsp;</TD>\n" if ($precision > 3);

				if ($notrafic == 0) {
				    print FILESITEPAYSLIST "<TD CLASS=\"left\">\n";

				    $percentage = 0;
				    $tmp = $serversize{$domsites{$domadresse,$j}}/1024 if ($unit eq "$L{'Kb'}");
				    $tmp = $serversize{$domsites{$domadresse,$j}}/(1024*1024) if ($unit eq "$L{'Mb'}");
				    $tmp = $serversize{$domsites{$domadresse,$j}}/(1024*1024*1024) if ($unit eq "$L{'Gb'}");
				    $tmp = $serversize{$domsites{$domadresse,$j}}/(1024*1024*1024*1024) if ($unit eq "$L{'Tb'}");
				    $pourcentage = 100*$serversize{$domsites{$domadresse,$j}}/($domserversize{$domadresse}*1024) if ($domserversize{$domadresse} != 0);

				    $tmp = int($tmp*10)/10 if ($unit ne "$L{'Kb'}");			    
				    $tmp = int($tmp) if ($unit eq "$L{'Kb'}");
				    if (int($pourcentage) != 0) {
					print FILESITEPAYSLIST "<IMG WIDTH=";
					printf FILESITEPAYSLIST "%d",$pourcentage;
					print FILESITEPAYSLIST " HEIGHT=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[4]\" ALT=\"$gcolor[4]\">";
				    }
				    printf FILESITEPAYSLIST " %.1f",$tmp;
				    printf FILESITEPAYSLIST "</TD>\n<TD CLASS=\"right\">%3.1f \%",$pourcentage;
				    print FILESITEPAYSLIST "</TD>\n";
				}
				print FILESITEPAYSLIST "</TR>\n";
			    }     
			}
			print FILESITEPAYSLIST "</tbody>\n";			
			print FILESITEPAYSLIST "</TABLE>\n<P>\n</BODY></HTML>\n";
			close(FILESITEPAYSLIST);
		    } # flag_dom
#		}	#	if ($found{$extpays} == 1) {
	    } #$domrserver
	} #foreach $domadresse (sort keys(%domserver)) {

	# Add an entry for flesitepays

#			    if (!(-f "$path$lang[$nblang]$dirsep$dirpays$dirsep$extpays-$unresolved")) {
#				open(PAGEUNRESOLVED,">$path$lang[$nblang]$dirsep$dirpays$dirsep$extpays-$unresolved") || &error_exit("Error, unable to open $path$lang[$nblang]$dirsep$dircity$dirsep$extpays-$unresolved");
#				&PageHeaderUnresolved(*PAGEUNRESOLVED, eval($Lang{$lang[$nblang]}));
#				close (PAGEUNRESOLVED);
#			    }

	foreach $extpays (sort keys(%payslist)) {
	    if (-f "$path$lang[$nblang]$dirsep$dirpays$dirsep$extpays$unresolved") {
		open(PAGEUNRESOLVED,">>$path$lang[$nblang]$dirsep$dirpays$dirsep$extpays$unresolved") || &error_exit("Error, unable to open $path$lang[$nblang]$dirsep$dircity$dirsep$extpays$unresolved");
		print PAGEUNRESOLVED "</tbody>\n";
		print PAGEUNRESOLVED "</TABLE>\n";
		print PAGEUNRESOLVED "</BODY></HTML>\n";
		close (PAGEUNRESOLVED);

		$pourcentage = 100*$unresolved_hits{$extpays}/$payslist{$extpays} if ($payslist{$extpays} != 0);
		$pourcentage2 = 100*$unresolved_access{$extpays}/$payshtml{$extpays} if ($payshtml{$extpays} != 0);                
		$pourcentage2 = 0 if ($payshtml{$extpays} == 0);                
		$pourcentage3 = 100*$unresolved_nb_hosts{$extpays}/$serverpays{$extpays} if ($serverpays{$extpays} != 0);

		open(FILESITEPAYS,">>$path$lang[$nblang]$dirsep$dirpays$dirsep$flagpage{$extpays}") || die "Error, unable to open file $path$lang[$nblang]$dirsep$dirpays$dirsep$flagpage{$extpays}\n";
		# add unresolved for the country if file exist
		print FILESITEPAYS "<TR>\n<TD CLASS=\"left\"><B><I>";
		print FILESITEPAYS "<A HREF=\"$extpays$unresolved\">";
		print FILESITEPAYS "$L{'unresolved'}";
		print FILESITEPAYS "</A>";
		print FILESITEPAYS "</I></B></TD>\n";
		print FILESITEPAYS "<TD CLASS=\"right\"><I>$domaindateip{$extpays}</I></TD>\n";

		print FILESITEPAYS "<TD CLASS=\"left\">&nbsp;";
		if (int($pourcentage3) != 0) {
		    print FILESITEPAYS "<IMG WIDTH=";
		    printf FILESITEPAYS "%d",$pourcentage3;
		    print FILESITEPAYS " HEIGHT=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[4]\" ALT=\"$gcolor[4]\">";
		}
		print FILESITEPAYS "&nbsp;$unresolved_nb_hosts{$extpays}</TD>\n";
		printf FILESITEPAYS "<TD CLASS=\"right\">%3.1f \%</TD>",$pourcentage3;


		print FILESITEPAYS "<TD CLASS=\"left\">&nbsp;";
		if (int($pourcentage) != 0) {
		    print FILESITEPAYS "<IMG WIDTH=";
		    printf FILESITEPAYS "%d",$pourcentage;
		    print FILESITEPAYS " HEIGHT=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">";
		}
		print FILESITEPAYS " $unresolved_hits{$extpays}</TD>\n";
		printf FILESITEPAYS "<TD CLASS=\"right\">%3.1f \%",$pourcentage;
		print FILESITEPAYS "&nbsp;</TD>\n";

		if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
		    print FILESITEPAYS "<TD CLASS=\"left\">&nbsp;";
		    if (int($pourcentage2) != 0) {
			print FILESITEPAYS "<IMG WIDTH=";
			printf FILESITEPAYS "%d",$pourcentage2;
			print FILESITEPAYS " HEIGHT=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">";
		    }
		    print FILESITEPAYS " $unresolved_access{$extpays}</TD>\n";
		    printf FILESITEPAYS "<TD CLASS=\"right\">%3.1f \%",$pourcentage2;
		    print FILESITEPAYS "&nbsp;</TD>\n";                
		}

#		print FILESITEPAYS "<TD CLASS=\"right\">&nbsp;<B>$nbpageserveurunique{$domsites{$domadresse,$j}}</B>&nbsp;</TD>\n" if ($precision > 3);

		if ($notrafic == 0) {
		    $pourcentage4 = 100*$unresolved_size{$extpays}/$sizepays{$extpays} if ($sizepays{$extpays} != 0);

		    print FILESITEPAYS "<TD CLASS=\"left\">&nbsp;";
		    if (int($pourcentage4) != 0) {
			print FILESITEPAYS "<IMG WIDTH=";
			printf FILESITEPAYS "%d",$pourcentage4;
			print FILESITEPAYS " HEIGHT=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">";
		    }


		    $tmp = $unresolved_size{$extpays};
		    $tmp = $unresolved_size{$extpays}/1024 if ($unit{$extpays} eq "Kb");
		    $tmp = $unresolved_size{$extpays}/(1024*1024) if ($unit{$extpays} eq "Mb");
		    $tmp = $unresolved_size{$extpays}/(1024*1024*1024) if ($unit{$extpays} eq "Gb");
		    $tmp = $unresolved_size{$extpays}/(1024*1024*1024*1024) if ($unit{$extpays} eq "Tb");
		    
		    $tmp = int($tmp) if ($unit{$extpays} eq "Kb");
		    $tmp = int(100*$tmp)/100 if ($unit{$extpays} ne "Kb");
		    printf FILESITEPAYS " $tmp</TD>";
		    printf FILESITEPAYS "<TD CLASS=\"right\">%3.1f \%",$pourcentage4;
		    print FILESITEPAYS "&nbsp;</TD>\n";
		}

		print FILESITEPAYS "</TR>\n";
		close(FILESITEPAYS);
	    }
	}


	#
        ### Local host
	#

	if ($locallog != 0 && $totlocaldomainename != 0 && ($localdomainename !~ m/[0-9]+$/ && $localdomainename !~ /:/)) {

	    $pospoint = rindex($localdomainename,'.');
	    $extpays = substr($localdomainename,$pospoint+1,length($localdomainename));
	    $tmp = 0;
	    $domserverhtml{$localdomainename} = 0;
	    
	    foreach $serveur (sort keys(%localserver)) {
		$tmp++; # if ($localserver{$serveur} > $seuilsite);
		$domserverhtml{$localdomainename} += $nbpageserveur{$serveur};
	    }
	    
	    $found{$extpays} = 1;
#	    if ($found{$extpays} == 1) {
#	    print "Op ALPHA1 $path$lang[$nblang]$dirsep$dirpays$dirsep$flagpage{$extpays}\n";

	    open(FILESITEPAYS,">>$path$lang[$nblang]$dirsep$dirpays$dirsep$flagpage{$extpays}") || die "Error, unable to open file $path$lang[$nblang]$dirsep$dirpays$dirsep$flagpage{$extpays}\n";
        
	    $newsite = $localdomainename;        
	    $newsite =~ s/[.:]/_/g;
#		$newsite .= $htmlext; 
		
	    $pourcentage = 100*$totlocaldomainename/$payslist{$extpays} if ($payslist{$extpays} != 0);
	    $pourcentage2 = 100*$domserverhtml{$localdomainename}/$payshtml{$extpays} if ($payshtml{$extpays} != 0);
	    $pourcentage2 = 0 if ($payshtml{$extpays} == 0);
	    $pourcentage3 = 100*$tmp/$serverpays{$extpays} if ($serverpays{$extpays} != 0);

		
		print FILESITEPAYS "<TR>\n<TD CLASS=\"left\"><I><B><A HREF=\"..$dirsepurl$dirdomain$dirsepurl$newsite$htmlext\">$localdomainename</A></B></I></TD>\n";
		print FILESITEPAYS "<TD CLASS=\"right\"><I>$domaindate{$localdomainename}</I></TD>\n";
		print FILESITEPAYS "<TD CLASS=\"left\">&nbsp;";
		if (int($pourcentage3) != 0) {
		    print FILESITEPAYS "<IMG WIDTH=";
		    printf FILESITEPAYS "%d",$pourcentage3;
		    print FILESITEPAYS " HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[4]\" ALT=\"$gcolor[4]\">";
		}
		print FILESITEPAYS " $tmp</TD>\n";
		printf FILESITEPAYS "<TD CLASS=\"right\">%3.1f %</TD>",$pourcentage3;
		print FILESITEPAYS "<TD CLASS=\"left\">&nbsp;";
		if (int($pourcentage) != 0) {
		    print FILESITEPAYS "<IMG WIDTH=";
		    printf FILESITEPAYS "%d",$pourcentage;
		    print FILESITEPAYS " HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">";
		}
		print FILESITEPAYS " $totlocaldomainename</TD>\n";
		printf FILESITEPAYS "<TD CLASS=\"right\">%3.1f %",$pourcentage;
		print FILESITEPAYS "&nbsp;</TD>";

		if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
		    print FILESITEPAYS "<TD CLASS=\"left\">&nbsp;";
		    if (int($pourcentage2) != 0) {
			print FILESITEPAYS "<IMG WIDTH=";
			printf FILESITEPAYS "%d",$pourcentage2;
			printf FILESITEPAYS " HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">";
		    }
		    print FILESITEPAYS " $domserverhtml{$localdomainename}</TD>";
		    printf FILESITEPAYS "<TD CLASS=\"right\">%3.1f %",$pourcentage2;
		    print FILESITEPAYS "&nbsp;</TD>\n";
		}

	    if ($spam_found != 0 && $spamonly != 1) {
		print FILESITEPAYS "<TD CLASS=\"left\">&nbsp;";
		    if (int($pourcentage4) != 0) {
			print FILESITEPAYS "<IMG WIDTH=";
			printf FILESITEPAYS "%d",$pourcentage4;
			print FILESITEPAYS " HEIGHT=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">";
		    }
		    print FILESITEPAYS " $spam_dom{$domadresse}</TD>\n";
		    printf FILESITEPAYS "<TD CLASS=\"right\">%3.1f \%",$pourcentage4;
		    print FILESITEPAYS "&nbsp;</TD>\n";
		}

		if ($notrafic == 0) {
		    $pourcentage4 = 100*($domserversize{$localdomainename}*1024)/$sizepays{$extpays} if ($sizepays{$extpays} != 0);
		    $tmp = $domserversize{$localdomainename} if ($unit{$extpays} eq "Kb");
		    $tmp = $domserversize{$localdomainename}/1024 if ($unit{$extpays} eq "Mb");
		    $tmp = $domserversize{$localdomainename}/(1024*1024) if ($unit{$extpays} eq "Gb");
		    $tmp = $domserversize{$localdomainename}/(1024*1024*1024) if ($unit{$extpays} eq "Tb");
			
		    $tmp = int($tmp) if ($unit{$extpays} eq "Kb");
		    $tmp = int(100*$tmp)/100 if ($unit{$extpays} ne "Kb");

		    print FILESITEPAYS "<TD CLASS=\"left\">&nbsp;";
		    if (int($pourcentage4) != 0) {
			print FILESITEPAYS "<IMG WIDTH=";
			printf FILESITEPAYS "%d",$pourcentage4;
			print FILESITEPAYS " HEIGHT=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">";
		    }
		    printf FILESITEPAYS " %.1f</TD>\n",$tmp;
		    printf FILESITEPAYS "<TD CLASS=\"right\">%3.1f \%",$pourcentage4;
		    print FILESITEPAYS "&nbsp;</TD>\n";                

		    $tmp2 = 0;
#		    $unit = "$L{'Kb'}";
		    $unit = "$L{'bytes'}";
		    foreach $serveur (sort keys(%localserver)) {
			if ($localserver{$serveur} > $seuilsite) {
			    if ($localserversize{$serveur} > $tmp2) {
				$tmp2 = $localserversize{$serveur};
				$unit = "$L{'Kb'}" if ($tmp2 > 1024);
				$unit = "$L{'Mb'}" if ($tmp2 > (1024*1024));
				$unit = "$L{'Gb'}" if ($tmp2 > (1024*1024*1024));
				$unit = "$L{'Tb'}" if ($tmp2 > (1024*1024*1024*1024));
			    }
			}
		    }
		}

	    print FILESITEPAYS "</TR>\n";
	    close(FILESITEPAYS);
	    
#	    print "D $dirdomain$dirsep$newsite$htmlext\n";
	    open(FILESITEPAYSLIST,">$path$lang[$nblang]$dirsep$dirdomain$dirsep$newsite$htmlext") || die "Error, unable to open file $path$lang[$nblang]$dirsep$dirdomain$dirsep$newsite$htmlext\n";
	    
	    print FILESITEPAYSLIST "$doctype\n";
#	    print FILESITEPAYSLIST "<HTML><HEAD>\n";
	    print FILESITEPAYSLIST "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
	    print FILESITEPAYSLIST "$charset\n";
	    print FILESITEPAYSLIST "<TITLE>$L{'Hosts'} - $localdomainename</TITLE>\n";
	    print FILESITEPAYSLIST "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
	    print FILESITEPAYSLIST "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
	    print FILESITEPAYSLIST "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
	    print FILESITEPAYSLIST "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
	    print FILESITEPAYSLIST "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
	    print FILESITEPAYSLIST "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
	    print FILESITEPAYSLIST "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
	    print FILESITEPAYSLIST "$curvy_bottom_jss\n";
	    &add_css_style(*FILESITEPAYSLIST,2);

	    print FILESITEPAYSLIST "</HEAD>\n";

	    print FILESITEPAYSLIST "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
	    &add_css_menu(*FILESITEPAYSLIST,*L,$lang[$nblang],$nblang,2);

	    print FILESITEPAYSLIST "<H2>$L{'Hosts'} - $localdomainename</H2><P>\n";
	    print FILESITEPAYSLIST "<P><HR><P>\n";
	    print FILESITEPAYSLIST "<I>($L{'Only_hosts'} $L{'with_at_least'} $seuilsite $L{'requests'} $L{'are_shown'})</I><P>\n" if ($seuilsite > 1);

	    print FILESITEPAYSLIST "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
	    print FILESITEPAYSLIST "<thead>\n";
	    print FILESITEPAYSLIST "<TR>\n";
	    print FILESITEPAYSLIST "<TH class=\"table-sortable:default\">$L{'Hosts'}</TH>\n";
	    print FILESITEPAYSLIST "<TH class=\"table-sortable:default\">$L{'Users'}</TH>\n" if (-f "$resolv_users_file");
	    print FILESITEPAYSLIST "<TH class=\"table-sortable:date\">&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n";
	    print FILESITEPAYSLIST "<TH class=\"table-sortable:numeric\">$L{'Requests'}</TH>\n";
	    print FILESITEPAYSLIST "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n";
	    if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
		print FILESITEPAYSLIST "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
		print FILESITEPAYSLIST "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
	    }
	    if ($spam_found != 0 && $spamonly != 1) {
		print FILESITEPAYSLIST "<TH class=\"table-sortable:numeric\">$L{'Spam'}</TH>\n";
		print FILESITEPAYSLIST "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n";
	    }
	    if ($precision > 3 && $squid_format == 0) {
#		if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
		    print FILESITEPAYSLIST "<TH class=\"table-sortable:numeric\">$L{'Different_accesses'}&nbsp;</TH>\n";
#		} else {
#			print FILESITEPAYSLIST "<TH class=\"table-sortable:numeric\">$L{'Requests'}&nbsp;($L{'Unique'})&nbsp;</TH>\n";
#		}
	    }

	    print FILESITEPAYSLIST "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n" if ($notrafic == 0);
	    print FILESITEPAYSLIST "</TR>\n";
	    print FILESITEPAYSLIST "</thead>\n";
	    print FILESITEPAYSLIST "<tbody>\n";

		foreach $serveur (sort keys(%localserver)) {
		    if ($localserver{$serveur} > $seuilsite) {
			$pourcentage = 100*$localserver{$serveur}/$totlocaldomainename; # if ($mail_format == 0);
#			$pourcentage = 100*$localserver{$serveur}/$reqtot if ($mail_format == 1);
			$pourcentage2 = 100*$nbpageserveur{$serveur}/$domserverhtml{$localdomainename} if ($domserverhtml{$localdomainename} != 0);                        
			$pourcentage2 = 0 if ($domserverhtml{$localdomainename} == 0); 
		
			$newsite = $serveur;
			$pospoint = index($newsite,'.',0);
			$newsite =~ s/[.:]/_/g;

			$saveadresse = $newsite;
			if ($newsite !~ /[0-9]$/ && $newsite !~ /:/) {
			    $saveadresse = substr($newsite,$pospoint+1,(length($newsite)-length($pospoint)));
			    $saveadresse = $newsite if ($saveadresse !~ /_/);
			}

			print FILESITEPAYSLIST "<TR>\n<TD CLASS=\"left\"";
			print FILESITEPAYSLIST " TITLE=\"$resolv_user{$serveur}\"" if ($resolv_user{$serveur} ne '');
			print FILESITEPAYSLIST ">";
			print FILESITEPAYSLIST "<A HREF=\"..$dirsepurl$dirsite$dirsepurl$saveadresse$htmlext#$serveur\"\>"  if ($split_localhost == 0 && $precision > 3 && -f "$path$lang[$nblang]$dirsep$dirsite$dirsepurl$saveadresse$htmlext");
			print FILESITEPAYSLIST "<A HREF=\"..$dirsepurl$dirsite$dirsepurl$newsite$htmlext\"\>"  if ($split_localhost == 1 && $precision > 3 && -f "$path$lang[$nblang]$dirsep$dirsite$dirsepurl$saveadresse$htmlext");
			print FILESITEPAYSLIST "<I>$serveur</I>";
			print FILESITEPAYSLIST "</A> " if ($precision > 3 && -f "$path$lang[$nblang]$dirsep$dirsite$dirsepurl$saveadresse$htmlext");
			print FILESITEPAYSLIST "</TD>\n";
			if (-f "$resolv_users_file") {
			    print FILESITEPAYSLIST "<TD CLASS=\"right\">";
			    print FILESITEPAYSLIST "$resolv_user{$serveur}";
			    print FILESITEPAYSLIST "</TD>\n";
			}
			print FILESITEPAYSLIST "<TD CLASS=\"right\">";
			print FILESITEPAYSLIST "$localserverdate{$serveur}";
			print FILESITEPAYSLIST "</TD>\n";
			print FILESITEPAYSLIST "<TD CLASS=\"left\">";
			if (int($pourcentage) != 0) {
			    print FILESITEPAYSLIST "<IMG WIDTH=";
			    printf FILESITEPAYSLIST "%d",$pourcentage;
			    print FILESITEPAYSLIST " HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">";
			}
			print FILESITEPAYSLIST " <B>$localserver{$serveur}</B>";
			printf FILESITEPAYSLIST "</TD>\n<TD CLASS=\"right\">%3.1f \%",$pourcentage;
			print FILESITEPAYSLIST "</TD>\n";

			if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
			    print FILESITEPAYSLIST "<TD CLASS=\"left\">";
			    if (int($pourcentage2) != 0) {
				print FILESITEPAYSLIST "<IMG WIDTH=";
				printf FILESITEPAYSLIST "%d",$pourcentage2;
				print FILESITEPAYSLIST " HEIGHT=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">";
			    }
			    print FILESITEPAYSLIST " <B>$nbpageserveur{$serveur}</B>";
			    printf FILESITEPAYSLIST "</TD>\n<TD CLASS=\"right\">%3.1f \%</TD>\n",$pourcentage2;
			}

			if ($spam_found != 0 && $spamonly != 1) {
			    $spam_dom{$serveur} = 0 if ($spam_dom{$serveur} eq '');
			    print FILESITEPAYSLIST "<TD CLASS=\"right\">";
			    print FILESITEPAYSLIST "$spam_dom{$serveur}";
			    print FILESITEPAYSLIST "</TD>\n";
			    print FILESITEPAYSLIST "<TD CLASS=\"left\">";
			    $percentage = ($spam_dom{$serveur}*100)/$spam_found; # if ($spam != 0);
			    $tmp2 = int($percentage);
			    print FILESITEPAYSLIST "<img width=$tmp2 height=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">&nbsp;" if ($tmp2 != 0);
			    printf FILESITEPAYSLIST "%3.1f %",$percentage;
			    print FILESITEPAYSLIST "</TD>\n";
			}

			print FILESITEPAYSLIST "<TD CLASS=\"right\">&nbsp;$nbpageserveurunique{$serveur}&nbsp;</TD>\n" if ($precision > 3);

			if ($notrafic == 0) {
			    print FILESITEPAYSLIST "<TD CLASS=\"left\">";

			    $tmp2 = $localserversize{$serveur}/1024 if ($unit eq "$L{'Kb'}");
			    $tmp2 = $localserversize{$serveur}/(1024*1024) if ($unit eq "$L{'Mb'}");
			    $tmp2 = $localserversize{$serveur}/(1024*1024*1024) if ($unit eq "$L{'Gb'}");
			    $tmp2 = $localserversize{$serveur}/(1024*1024*1024*1024) if ($unit eq "$L{'Tb'}");
#			    if ($mail_format == 0) {
				$pourcentage = 100*$tmp2/($domsize*1024) if ($unit eq "$L{'Kb'}");
				$pourcentage = 100*$tmp2/$domsize if ($unit eq "$L{'Mb'}");
				$pourcentage = 100*$tmp2/($domsize/1024) if ($unit eq "$L{'Gb'}");
				$pourcentage = 100*$tmp2/($domsize/(1024*1024)) if ($unit eq "$L{'Tb'}");
#			    } else {
#				$pourcentage = 100*$tmp2/($totsize*1024) if ($unit eq "$L{'Kb'}");
#				$pourcentage = 100*$tmp2/$totsize if ($unit eq "$L{'Mb'}");
#				$pourcentage = 100*$tmp2/($totsize/1024) if ($unit eq "$L{'Gb'}");
#				$pourcentage = 100*$tmp2/($totsize/(1024*1024)) if ($unit eq "$L{'Tb'}");
#			    }
			    $tmp2 = int($tmp2*10)/10 if ($unit ne "$L{'Kb'}");			    
			    $tmp2 = int($tmp2) if ($unit eq "$L{'Kb'}");
			    if (int($pourcentage) != 0) {
				print FILESITEPAYSLIST "<IMG WIDTH=";
				printf FILESITEPAYSLIST "%d",$pourcentage;
				print FILESITEPAYSLIST " HEIGHT=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[4]\" ALT=\"$gcolor[4]\">";
			    }
			    print FILESITEPAYSLIST " $tmp2";
			    printf FILESITEPAYSLIST "</TD>\n<TD CLASS=\"right\">%3.1f \%",$pourcentage;
			    print FILESITEPAYSLIST "</TD>\n";
			}
			print FILESITEPAYSLIST "</TR>\n";
		    }
		}
	    print FILESITEPAYSLIST "</tbody>\n";
	    print FILESITEPAYSLIST "</TABLE>\n";
	    print FILESITEPAYSLIST "<P>\n</BODY></HTML>\n";
	    close(FILESITEPAYSLIST);
	}


    if ($precision > 2) {
	foreach $pays (keys(%payslist)) {
	    if ($found{$pays} == 1) {
		open(FILESITEPAYS,">>$path$lang[$nblang]$dirsep$dirpays$dirsep$flagpage{$pays}") || die "Error, unable to open $path$lang[$nblang]$dirsep$dirpays$dirsep$flagpage{$pays}\n";
		print FILESITEPAYS "</TABLE><P>\n</BODY></HTML>\n";
		close FILESITEPAYS;
	    }
	}
    }


}

#
##############################################################
### Pages
##############################################################
#

#	    &PagesExportPDF(*FOUT,"$newpage3",'',$level,2,0,1) if ($enable_pdf == 1);
sub PagesExportPDF {
  local(*FOUT,$file,$title,$level,$mode,$popit,$mode_menu) = @_;
  local($tmp2,$link_use2,$sizeicon,$linkbase,$link);

  $sizeicon = 40;
  $sizeicon = 20 if ($mode_menu == 1);

  $link = '';
  $linkbase = '';
  for ($i=1;$i<=$level;$i++) {
      $link .= "..$dirsepurl";
  }

  $linkbase = $link;
#  $link .= $I.$dirsepurl;

  # From cgi
  if ($level == -1) {
      $linkbase = $link_use;
      $linkbase =~ s/$dirsepurl$dirress//;
#      $link = $linkbase.$I.$dirsepurl;
  }

  $cgipagesend = $w3perlcgiurl.$dirsepurl."pagesend".$plext;
  $tmp2 = $opt_c;
  $tmp2 = substr($tmp2,rindex($tmp2,$dirsep)+1,length($tmp2)) if ($opt_c =~ /^\//);

  $title =~ s/\s+//g;

  $link_use2 = "$linkbase$homeicons$dirsepurl"; # if ($link_use eq '');

#  $link_use2 = "..$dirsepurl..$dirsepurl$homeicons$dirsepurl" if ($link_use eq '');
#  $link_use2 = "$link_use$homeicons2$dirsepurl" if ($link_use ne '');

 if ($w3perlcgiurl ne '') {
     if ($fly_set == 1) {
	 print FOUT "<A HREF=\"$cgipagesend?" if ($popit == 0);
	 print FOUT "<A HREF=\"javascript:PopIt('$cgipagesend?" if ($popit == 1);
	 if ($opt_c ne '') {
	     print FOUT "c='$tmp2'&amp;" if ($popit == 0);
	     print FOUT "c=\\\'$tmp2\\\'&amp;" if ($popit == 1);
	 }
	 print FOUT "l=$I&amp;";
	 print FOUT "k=$mode&amp;";
	 print FOUT "p='$file'&amp;" if ($popit == 0);
	 print FOUT "p=\\\'$file\\\'&amp;" if ($popit == 1);
	 print FOUT "t='$title'" if ($popit == 0);
	 print FOUT "t=\\\'$title\\\'" if ($popit == 1);
	 print FOUT "',$xmax,$ymax)" if ($popit == 1);
	 print FOUT "\" ";
	 print FOUT "onClick=\"javascript:add_jqplot_img();\" " if ($fly_set == 0);
	 print FOUT "TITLE=\"Export in PDF\">" if ($mode == 2);
	 print FOUT "TITLE=\"Send by email\">" if ($mode == 1);

	 print FOUT "<IMG SRC=\"$link_use2$icon_pdf\" WIDTH=\"$sizeicon\" HEIGHT=\"$sizeicon\" BORDER=0 ALT=\"pdf\">" if ($mode == 2);
	 print FOUT "<IMG SRC=\"$link_use2$icon_mail\" WIDTH=\"$sizeicon\" HEIGHT=\"$sizeicon\" BORDER=0 ALT=\"mail\">" if ($mode == 1);
	 print FOUT "</A>\n";
     } else {
	 print FOUT "<FORM method=\"POST\" name=\"pdf_send\" action=\"$cgipagesend\">\n";
	 print FOUT "<INPUT TYPE=\"hidden\" NAME=\"l\" VALUE=\"$I\">\n";
	 print FOUT "<INPUT TYPE=\"hidden\" NAME=\"k\" VALUE=\"$mode\">\n";
	 print FOUT "<INPUT TYPE=\"hidden\" NAME=\"t\" VALUE=\"\">\n";
	 print FOUT "<INPUT TYPE=\"hidden\" NAME=\"p\" VALUE=\"\">\n";
         if ($opt_c ne '') {
	     print FOUT "<INPUT TYPE=\"hidden\" NAME=\"c\" VALUE=\"$tmp2\">\n";
	 }

	 print FOUT "<INPUT TYPE=\"image\" SRC=\"$link_use2$icon_pdf\" ALT=\"pdf\" onClick=\"javascript:document.pdf_send.t.value = document.title;var html;\$(document).ready(function () {html = escape(\$('body').html());});document.pdf_send.p.value = html;return true;\">\n" if ($mode == 2);

#	 print FOUT "<INPUT TYPE=\"image\" SRC=\"../../resources/homepage/pdf.png\" ALT=\"pdf\" onClick=\"javascript:\$(document).ready(function(){var tmp = '#chart0';var toto = \$(''+tmp+'');var tmp2 = '#plotted_image_div0';var toto2 = \$(''+tmp2+'');var imgData = toto.jqplotToImageStr({});var imgElem = \$('<img/>').attr({'src':imgData,title:'Right click on plot to save'});toto2.empty();toto2.append(imgElem);var tmp2 = '#plotted_image_div0';var toto2 = \$(''+tmp2+'');toto2.toggle();});document.pdf_send.t.value = document.title;var html;\$(document).ready(function () {html = escape(\$('body').html());});document.pdf_send.p.value = html;return true;\">\n";


#	 print FOUT "<INPUT TYPE=\"image\" SRC=\"$link_use2$icon_pdf\" ALT=\"pdf\" onClick=\"javascript:;var html;document.pdf_send.t.value = document.title;\$(document).ready(function(){var tmp = '#chart0';var toto = \$(''+tmp+'');var tmp2 = '#plotted_image_div0';var toto2 = \$(''+tmp2+'');var imgData = toto.jqplotToImageStr({});var imgElem = \$('<img/>').attr({'src':imgData,title:'Right click on plot to save'});toto2.empty();toto2.append(imgElem);var tmp2 = '#plotted_image_div0';var toto2 = \$(''+tmp2+'');toto2.toggle();html = escape(\$('body').html());toto2.toggle();});document.pdf_send.p.value = html;return true;\">\n";
	 print FOUT "</FORM>\n";


#	 print FOUT "<INPUT type=\"submit\" class=\"submit_button\" name=\"search_button\"  value=\"$L{'Search'}\" onClick=\"javascript:var html;\$(document).ready(function () {html = \$('body').html();});document.pdf_send.p.value = html;return true;\">\n";

#
#	 print FOUT "TITI <A HREF=\"$cgipagesend?";
#         if ($opt_c ne '') {
#             print FOUT "c='$tmp2'&amp;";
#         }
#         print FOUT "l=$I&amp;";
#         print FOUT "k=$mode&amp;";
##        print FOUT "k=$mode";                                                                                                                        
##        print FOUT "p='$file'&amp;";                                                                                                                 
#         print FOUT "p=html";
##       print FOUT "t='$title'" if ($popit == 0);                                                                                                    
##       print FOUT "',$xmax,$ymax)" if ($popit == 1);                                                                                                
#         print FOUT "\" ";
##       print FOUT "onClick=\"javascript:add_jqplot_img();\" ";   
#         print FOUT "onClick=\"javascript:var html;\$(document).ready(function () {html = \$('body').html();});alert(\'TOTO\'+html);return true;\" ";
#	 print FOUT "TITLE=\"Export in PDF\">ALPHA</A>" if ($mode == 2);
#	 print FOUT "TITLE=\"Send by email\">" if ($mode == 1);
###	 print FOUT "<A HREF=\"#\" onclick=\"javascript:send_html_pdf();return false;\" TITLE=\"Export in PDF\">";
#	 print FOUT "onClick=\"javascript:var html;\$(document).ready(function () {html = \$('body').html();});\" ";

     }

     print FOUT "<DIV ID=\"pdf_msg\" STYLE=\"display:none\"></DIV>\n";

     }
}
  

sub PagesListAll {
  local(*FOUT,*L,$I) = @_;
  local($tmp5);

  print FOUT "$doctype\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE> $L{'Stats'} - $L{'Pages'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";

#  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\">\n";
#  print FOUT "function PopIt(ref,x,y) {\n";
#  print FOUT "var xwin;\n";
#  print FOUT "var ywin;\n";
#  print FOUT "xwin = x+100;\n";
#  print FOUT "ywin = y*2;\n";
#  print FOUT "popup = window.open(\"\"+ref,\"popDialog\",\"height=\"+ywin+\",width=\"+xwin+\",scrollbars=yes,resizable=yes\")\n";
##  print FOUT "popup = window.open(\"\"+ref,\"popDialog\",\"height=\"+ywin+\",width=\"+xwin+\",resizable=yes\")\n";
##  print FOUT "var end = \"<CENTER><FORM><INPUT TYPE='BUTTON' VALUE='Fermer'\" + \" onClick='self.close()'>\" + \"</FORM></CENTER>\\n\"\n";
#  print FOUT "popup.focus()\n";
##  print FOUT "popup.document.close()\n";
#  print FOUT "}\n";
#  print FOUT "</SCRIPT>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";

  $tmp4 = $curvy_bottom_jss;
  if ($w3perlcgiurl ne '' && -d $cgipath_install && $precision > 2 && $cups_format == 0 && (-f "$path$dirinc$dirsep$pagehas")) {
      $tmp2 = $opt_c;
      $tmp2 = substr($tmp2,rindex($tmp2,$dirsep)+1,length($tmp2)) if ($opt_c =~ /^\//);
      $tmp3 = (&reverse_sort_by_value(*pageslues))[0];
      $tmp = "GraphHosts('$cgipagegraph',";
      $tmp .= "'$tmp2'," if ($opt_c ne '');
      $tmp .= "'config.pl'," if ($opt_c eq '');
      $tmp .= "'$pagehas{$tmp3}',";
      $tmp .= "'0',";
      $tmp .= "'$I'";
      $tmp .= ")";

      $tmp4 =~ s/UpdateToolHeader\(\);/UpdateToolHeader\(\);\n$tmp;/;
  }

#  print FOUT "$curvy_bottom_jss\n";
  print FOUT "$tmp4\n";

  &add_jqplot_js(*FOUT,2);  
  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";

  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);

  $count = 0;
  $tmp10 = $pageunique;
  $tmp10 = $max_item_page if ($tmp10 > $max_item_page);

  print FOUT "<H2>";
  print FOUT "$L{'Pages'}" if ($mail_format == 0 && $cups_format == 0 && $ftp_format == 0);
  print FOUT "$L{'Emails'}" if ($mail_format == 1);
  print FOUT "$L{'Files'}" if ($cups_format == 1 || $ftp_format == 1);
  print FOUT "</H2><P>\n";

  print FOUT "<A HREF=\"..$dirsepurl..$dirsepurl$dircsv$dirsepurl$incpage$csvext\" TITLE=\"Export in CSV\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>";

  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} $tmp10 ";
  if ($ftp_format == 1 || $cups_format == 1) {
      print FOUT "$L{'files'}";
  } else {
      print FOUT "$L{'pages'}";
  }
  print FOUT " ($L{'among'} $pageunique) " if ($tmp10 == $max_item_page);
  print FOUT "</I>:</DIV><P>\n";

  print FOUT "<TABLE><TR><TD VALIGN=TOP>\n";
  
  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe ";
  print FOUT "table-autopage:$table_big_lines_aff " if ($tmp10 > $table_big_lines_aff);
  print FOUT "table-stripeclass:alternate\" id=\"page\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'General_ranking'}&nbsp;</TH>\n" if ($mail_format == 0 && $dhcp_format == 0 && $cups_format == 0 && $precision > 3);
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Destination'}&nbsp;</TH>\n" if ($squid_format == 1);
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Pages'}&nbsp;</TH>\n" if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Files'}&nbsp;</TH>\n" if ($ftp_format == 1 || $cups_format == 1);
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Emails'}&nbsp;</TH>\n" if ($mail_format == 1);
  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Occurence'}</TH>\n";
  print FOUT "<TH>&nbsp;</TH>\n" if ($cups_format == 0 && $dhcp_format == 0);
  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n" if ($precision > 3 && $mail_format == 0);
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n" if ($precision > 3 && $mail_format == 0 && $cups_format == 1);
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";

  if ($tmp10 > $table_big_lines_aff) {

      $tmp = int($tmp10/$table_big_lines_aff);
      if ($tmp != ($tmp10/$table_big_lines_aff)) {
	  $tmp++;
      }
    
      print FOUT "<tfoot>\n";
      print FOUT "<tr>\n";
      print FOUT "<TH>&nbsp;$L{'General_ranking'}&nbsp;</TH>\n" if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0 && $precision > 3);
      print FOUT "<TH>&nbsp;$L{'Destination'}&nbsp;</TH>\n" if ($squid_format == 1);
      print FOUT "<TH>&nbsp;$L{'Pages'}&nbsp;</TH>\n" if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
      print FOUT "<TH>&nbsp;$L{'Files'}&nbsp;</TH>\n" if ($ftp_format == 1 || $cups_format == 1);
      print FOUT "<TH>&nbsp;$L{'Emails'}&nbsp;</TH>\n" if ($mail_format == 1);
      print FOUT "<TH>$L{'Occurence'}</TH>\n";
      print FOUT "<TH>&nbsp;</TH>\n" if ($cups_format == 0 && $dhcp_format == 0);
      print FOUT "<TH>$L{'Percentage'}</TH>\n";
      print FOUT "<TH>&nbsp;$L{'Hosts'}&nbsp;</TH>\n" if ($precision > 3 && $mail_format == 0);
      print FOUT "<TH>&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n" if ($precision > 3 && $mail_format == 0 && $cups_format == 1);
      print FOUT "</tr>\n";
      print FOUT "<tr>\n";
      
      if ($tmp > 1) {
	  $tmp2 = 3;
	  $tmp2++ if ($cups_format == 0);
	  $tmp2++ if ($precision > 3 && $mail_format == 0);
	  $tmp2++ if ($mail_format == 0 && $cups_format == 0 && $precision > 3);
	  $tmp2++ if ($squid_format == 1);
	  $tmp2++ if ($precision > 3 && $mail_format == 0 && $cups_format == 1);
	  print FOUT "<td colspan=$tmp2>\n";
	  print FOUT "<a href=\"#\" onclick=\"pageexample('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	  
	  for ($i=1;$i<=$tmp;$i++) {
	      $iminus = $i-1;
	      print FOUT "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexample($iminus); return false;\">$i</a>\n";
	  }
	  print FOUT "<a href=\"#\" onclick=\"pageexample('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "<a href=\"#\" onclick=\"pageexample('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "</td>\n";
	  print FOUT "</tr>\n";
      }
      print FOUT "</tfoot>\n";
  }

  print FOUT "<tbody>\n";

  $tmp2 = $opt_c;
  $tmp2 = substr($tmp2,rindex($tmp2,$dirsep)+1,length($tmp2)) if ($opt_c =~ /^\//);

  $tmp5 = $tmpagenb;
  $tmp5 = $diffmax_ini if ($tmp5 > $diffmax_ini);

    foreach $page (&reverse_sort_by_value(*pageslues)) {

	$count++;
	if ($count < $max_item_page && $pageslues{$page} > 0) {

#	if ($pageslues{$page} > $seuilpage) {
  
	    $pourcentage = (($pageslues{$page}*1000)/$access)/10 if ($access != 0);
	    $pourcentageint = int($pourcentage);
	  print FOUT "<TR>\n";
	  if ($precision > 3 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	      print FOUT "<TD CLASS=\"right\">&nbsp;$pageslues_rank{$page}&nbsp;</TD>\n";
	  }
	  if ($squid_format == 1) {
	      $tmp = index($page,$dirsep,1);
	      $tmp1 = substr($page,0,$tmp+1);
	      $tmp6 = substr($page,$tmp,length($page));
	      print FOUT "<TD CLASS=\"left\">$tmp1</TD>\n";
	  }
	  print FOUT "<TD CLASS=\"left\">";

	  $link = &AddHREF($page) if ($squid_format == 0);
	  $link = &AddHREF($tmp6) if ($squid_format == 1);
	  print FOUT "$link";

	  print FOUT "&nbsp;</TD>\n";
	  print FOUT "<TD CLASS=\"right\">&nbsp;<B>";

	  if ($cups_format == 0) {
	      $cur = $pagesluesday{$page} if ($scriptname eq "cron-inc.pl");
	      $cur = $tmpage{0,$pagehas{$page}} if ($scriptname ne "cron-inc.pl");

	      $tmp = 0;
	      for ($i=0;$i<=$tmp5;$i++) {
#		  $tmp1 .= "<TD CLASS=\"right\">$tmpage{$i,$pagehas{$page}}</TD>\n";
		  $tmp += $tmpage{$i,$pagehas{$page}};
	      }
	      $tmp = int($tmp/($tmp5+1));
	      $val = $tmp*10/100; # threshold to 10% to get increase/decrease

	      $tmpstr = "same" if (abs($cur - $tmp) <= $val);
	      $tmpstr = "increase" if ($cur > ($tmp+$val));
	      $tmpstr = "decrease" if ($cur < ($tmp-$val));
	  }

	  if ($w3perlcgiurl ne '' && -d $cgipath_install && $cups_format == 0 && $precision > 2 && (-f "$path$dirinc$dirsep$pagehas")) {
	      print FOUT "<A HREF=\"javascript:GraphHosts('$cgipagegraph',";
	      print FOUT "'$tmp2'," if ($opt_c ne '');
	      print FOUT "'config.pl'," if ($opt_c eq '');
	      print FOUT "'$pagehas{$page}',";
	      print FOUT "'0',";
	      print FOUT "'$I'";
	      print FOUT ")\">";
#	      print FOUT "<A HREF=\"javascript:PopIt('$cgipagegraph?";
#	      print FOUT "c=\\\'$tmp2\\\'&amp;" if ($opt_c ne '');
#	      print FOUT "k=$pagehas{$page}&amp;";
#	      print FOUT "l=$I";
#	      print FOUT "',$xmax,$ymax)\">";
	  }
	  print FOUT "$pageslues{$page}";
	  print FOUT "</A>" if ($w3perlcgiurl ne '' && -d $cgipath_install && $cups_format == 0 && $precision > 2 && (-f "$path$dirinc$dirsep$pagehas"));

	  print FOUT "</B>&nbsp;</TD>\n";
	  if ($cups_format == 0 && $dhcp_format == 0) {
	      print FOUT "<TD><!-- 9 --><IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$array_up\" WIDTH=12 HEIGHT=12 ALT=\"up\"></TD>\n" if ($tmpstr eq "increase");
	      print FOUT "<TD><!-- 5 --><IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$array_same\" WIDTH=12 HEIGHT=12 ALT=\"same\"></TD>\n" if ($tmpstr eq "same");
	      print FOUT "<TD><!-- 1 --><IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$array_down\" WIDTH=12 HEIGHT=12 ALT=\"down\"></TD>\n" if ($tmpstr eq "decrease");
	  }
	    print FOUT "<TD CLASS=\"left\">&nbsp;\n";
	    print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
	    printf FOUT "%.1f ",$pourcentage;
	    print FOUT " %</TD>\n";
	    if ($precision > 3 && $mail_format == 0 && $cups_format == 0) {
		print FOUT "<TD CLASS=\"right\">";
		print FOUT "<A HREF=\"$pagehas{$page}$htmlext\">" if ($pageslues{$page} >= $seuilpage);
		print FOUT "$nbpagehost{$pagehas{$page}}";
		print FOUT "</A>" if ($pageslues{$page} >= $seuilpage);
		print FOUT "</TD>\n";
	}
	  $adresse = $pagelist{$pagehas{$page},1};
	  print FOUT "<TD CLASS=\"right\">$adresse</TD>\n" if ($precision > 3 && $mail_format == 0 && $cups_format == 1);
	  $tmp3 = $pagelist_date{$pagehas{$page},$adressehad{$adresse}};
	  ($date) = &get_time($tmp3*86400);
	  $date =~ s/\// /g;
	  print FOUT "<TD CLASS=\"right\">$date</TD>\n" if ($precision > 3 && $mail_format == 0 && $cups_format == 1);
	  print FOUT "</TR>\n";
	}
#      }
    }
  
  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n"; 

  print FOUT "</TD><TD VALIGN=TOP>";
  print FOUT "<DIV ID=\"graph_print\"></DIV>\n";
  print FOUT "</TD></TR></TABLE>\n";

  print FOUT "</BODY></HTML>\n";
}


sub Pages {
  local(*FOUT,*L,$I) = @_;
  local($count,$link);

  print FOUT "$doctype\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Stats'} - $L{'Pages'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";

  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  &add_jqplot_js(*FOUT,2);

  $tmp4 = $curvy_bottom_jss;

  if ($w3perlcgiurl ne '' && -d $cgipath_install && $precision > 2 && $cups_format == 0 && (-f "$path$dirinc$dirsep$pagehas")) {
      $tmp2 = $opt_c;
      $tmp2 = substr($tmp2,rindex($tmp2,$dirsep)+1,length($tmp2)) if ($opt_c =~ /^\//);
      $tmp3 = (&reverse_sort_by_value(*pageslues))[0];
      $tmp = "GraphHosts('$cgipagegraph',";
      $tmp .= "'$tmp2'," if ($opt_c ne '');
      $tmp .= "'config.pl'," if ($opt_c eq '');
      $tmp .= "'$pagehas{$tmp3}',";
      $tmp .= "'0',";
      $tmp .= "'$I'";
      $tmp .= ")";

      $tmp4 =~ s/UpdateToolHeader\(\);/UpdateToolHeader\(\);\n$tmp;/;
  }

  print FOUT "$tmp4\n";

  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";

  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\"";
  print FOUT ">\n";

  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
  &help_div(*FOUT);

  print FOUT "<H2>";
  print FOUT "$L{'ListOf'} $L{'pages'} $L{'used'}" if ($mail_format == 0 && $cups_format == 0 && $ftp_format == 0);
  print FOUT "$L{'ListOf'} $L{'emails'}" if ($mail_format == 1);
  print FOUT "$L{'ListOf'} $L{'files'}" if ($cups_format == 1 || $ftp_format == 1);
  print FOUT "</H2><P>\n";

  print FOUT "<P>\n";

  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} $topten ";
  if ($ftp_format == 1 || $cups_format == 1) {
      print FOUT "$L{'files'}";
  } else {
      print FOUT "$L{'pages'}";
  }
  print FOUT " (<A HREF=\"$listpages\">$L{'Full_list'}</A>)" if ($show_all == 1 && scalar(%pageslues) > 0);
  print FOUT "</I></DIV><P>\n";

  print FOUT "<TABLE><TR><TD VALIGN=TOP>\n";

  &PagesTab(*FOUT,*L,$I,$topten,0);

  print FOUT "</TD>\n";
  print FOUT "</TR><TR>" if ($squid_format == 1);
  print FOUT "<TD ROWSPAN=2 VALIGN=TOP>";

  print FOUT "<DIV ID=\"graph_print\"></DIV>\n";

  print FOUT "</TD></TR>\n";
  print FOUT "<TR><TD VALIGN=TOP>\n";


  print FOUT "<TABLE><TR><TD>" if ($cups_format == 1);

  if ($fly_set == 0) {
      $chart_id = 10; # first graph being used by $cgipagegraph
      $info = "info".$chart_id;
      $i = &Load_DailyData($datafile,$dirdata);

      $xlegend = "$i $L{'days'}";
#    $xlegend .= "s" if ($count_month > 1);
      $xlegend .= " (starting $start_date)";
      $ylegend = $L{'Accesses'};

      undef @ref_tab;
      push(@ref_tab,\@tabreq) if ($mail_format == 0);
      push(@ref_tab,\@tabacc);
      push(@ref_tab,\@tabmm);
      push(@ref_tab,\@tabdoc);
      push(@ref_tab,\@tabscript);
      push(@ref_tab,\@tabuser);
      push(@ref_tab,\@tabtrafic);
      
      @ref_tab_name = ('requests','accesses','hosts','documents2','scripts','users','traffic') if ($mail_format == 0);
      @ref_tab_name = ('accesses','hosts','documents2','scripts','users','traffic') if ($mail_format == 1);

      &MakeDailyGraphJqplotInit(*FOUT, eval($Lang{$lang[$nblang]}),$I,1,$unit_div,\@ref_tab,\@ref_tab_name,\@listdate,$chart_id);

      @graph_to_display = ('Accesses');

      undef @ref_tab;
      push(@ref_tab,\@tabacc);
      
      &MakeDailyGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,1,\@graph_to_display,\@ref_tab,\@listdate,\@serie_color,1,$unit,$chart_id,3,'accesses',$info,$chart_id,$xlegend,$ylegend,$xmax_jqplot,$dirpage);
      
      &AddJqplotHtml(*FOUT, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_jqplot,$ymax_jqplot,2);
      
      $chart_id += $#list_graph_name_jqplot+1;
  }

  if ($fly_set == 1) {
      $file_page_page = "pages-home";
      print FOUT "<P><CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
      print FOUT "<TR>\n";
      $tmp = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$file_page_page."y".$gifext;
      print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"y\"></TD>\n";
      $tmp = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$file_page_page.$gifext;
      print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"graph\" USEMAP=\"#map_page_graph\" BORDER=0></TD>\n";
      print FOUT "</TR><TR><TD></TD>\n";
      $tmp = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$file_page_page."x".$gifext;
      print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$tmp\" ALT=\"x\"></TD>\n";
      print FOUT "</TR>\n";
      print FOUT "</TABLE></CENTER>\n";
      print FOUT "<MAP NAME=\"map_page_graph\">";
      $tmp = $map_page_graph;
      $tmp =~ s/<!-- langhome -->/$I/g;
      print FOUT "$tmp";
#  print FOUT "$map_page_graph";
      print FOUT "</MAP>\n";
  }

  print FOUT "<P>";

  print FOUT "</TD><TD>" if ($cups_format == 1);

  if ($dhcp_format == 0) {

      if ($fly_set == 0) {
	  $xlegend = "$L{'Histogram'} - $L{'Pages'} $L{'Occurence'}";
	  $ylegend = "$L{'Occurence'}";
      
	  $info = "info".$chart_id;	
	  
	  undef @listdate;
	  for ($i=0;$i<=$histo_max_page;$i++) {
	      $listdate[$i] = int($i);
	  }



#	  for ($i=0;$i<=$#histo_page;$i++) {
#	      print "II $i - $histo_page[$i] - $listdate[$i] - $histo_max_page\n" if ($histo_page[$i] ne '');
#	  }

	  undef @ref_tab;
	  push(@ref_tab,\@histo_page);
	  
	  @ref_tab_name = ('occurence');

	  &MakeDailyGraphJqplotInit(*FOUT, eval($Lang{$lang[$nblang]}),$I,0,$unit_div,\@ref_tab,\@ref_tab_name,\@listdate,$chart_id);

	  @graph_to_display = ('Histo-page');
	  
#	  undef @ref_tab;
#	  push(@ref_tab,\@histo_page);
	  
	  &MakeDailyGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,0,\@graph_to_display,\@ref_tab,\@listdate,\@serie_color,1,$unit,$chart_id,3,"occurence",$info,$chart_id,$xlegend,$ylegend,$xmax_jqplot,'');

	  &AddJqplotHtml(*FOUT, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_jqplot,$ymax_jqplot,2);

	  $chart_id++;
	  undef (@listdate);
      }

      if ($fly_set == 1) {
	  print FOUT "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
	  print FOUT "<TR>\n";
	  print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linklienfiley\" ALT=\"y\"></TD>\n";
	  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"$linklienfile\" ALT=\"graph\" BORDER=0></TD>\n";
	  print FOUT "</TR><TR><TD></TD>\n";
	  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linklienfilex\" ALT=\"x\"></TD>\n";
	  print FOUT "</TR>\n";
	  print FOUT "</TABLE></CENTER>\n";
      }

  print FOUT "<P>\n";


  print FOUT "<CENTER><table class=\"tablesort  table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Pages'}</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Occurence'}</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n";
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";

  $previ = 0;
  $tmp = 0;
  for ($i=1;$i<=$ylinkmax;$i++) {
      $tmp += $histo_page[$i];
      if ($i == 1 || $i == 2 || $i == 5 || $i == 15 || $i == 30 || $i == 60 || $i == $ylinkmax) {
	  print FOUT "<TR><TD CLASS=\"left\">$previ";
	  print FOUT " - $i" if ($i != $ylinkmax);
	  print FOUT "+" if ($i == $ylinkmax);
	  print FOUT "</TD>\n<TD CLASS=\"right\">$tmp</TD>";
	  $percentage = int(100*$tmp/$pageunique);
	  print FOUT "<TD CLASS=\"right\">$percentage&nbsp;%</TD></TR>\n";
	  $previ= $i;
	  $tmp = 0;
      }
  }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE></CENTER>\n";
  }

  print FOUT "</TD></TR></TABLE>" if ($cups_format == 1);

  if ($precision > 3 && $dhcp_format == 0 && $mail_format == 0 && $cups_format == 0) {

      if ($dhcp_format == 0) {

	  if ($fly_set == 0) {
#	      $xlegend = "$L{'Histogram'} - $L{'Hosts'} $L{'Occurence'}";
	      $xlegend = "$L{'Histogram'} - $L{'Pages'} $L{'Number'}";
#	      $ylegend = "$L{'Pages'}";
	      $ylegend = "$L{'Hosts'}";
	      
	      $info = "info".$chart_id;	
	      
	      for ($i=0;$i<=$histo_max_page_host;$i++) {
		  $listdate[$i] = int($i);
	      }

#	  for ($i=0;$i<=$#histo_page;$i++) {
#	      print "II $i - $histo_page[$i] - $listdate[$i] - $histo_max_page\n" if ($histo_page[$i] ne '');
#	  }

	      undef @ref_tab;
	      push(@ref_tab,\@histo_host);
	      
	      @ref_tab_name = ('occurence');
	      
	      &MakeDailyGraphJqplotInit(*FOUT, eval($Lang{$lang[$nblang]}),$I,0,$unit_div,\@ref_tab,\@ref_tab_name,\@listdate,$chart_id);
	      
	      @graph_to_display = ('Histo-host');
	  
#	      undef @ref_tab;
#	      push(@ref_tab,\@histo_host);
	  
	      &MakeDailyGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,0,\@graph_to_display,\@ref_tab,\@listdate,\@serie_color,1,$unit,$chart_id,3,"occurence",$info,$chart_id,$xlegend,$ylegend,$xmax_jqplot,'');

	      &AddJqplotHtml(*FOUT, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_jqplot,$ymax_jqplot,2);

	      $chart_id++;
	      undef (@listdate);
	  }

	  if ($fly_set == 1) {
	      print FOUT "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
	      print FOUT "<TR>\n";
	      print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linklienfilehy\" ALT=\"y\"></TD>\n";
	      print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"$linklienfileh\" ALT=\"graph\" BORDER=0></TD>\n";
	      print FOUT "</TR><TR><TD></TD>\n";
	      print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linklienfilehx\" ALT=\"x\"></TD>\n";
	      print FOUT "</TR>\n";
	      print FOUT "</TABLE></CENTER>\n";
	  }
      }
  }

  print FOUT "</TD></TR></TABLE>\n";
  
  if ($precision > 2 && $selection[0] ne '' && $#selecpages != -1 && $mail_format == 0) {
#  if ($precision > 2 && $selection[0] ne '') {

      print FOUT "<P><DIV CLASS=\"item_page\">-&nbsp;<I>$L{'Selected_pages'}</I></DIV><P>\n";
      for ($i=0;$i<=$#selecpages;$i++) {
	  $numero = $i+1;
	  $newpage = "page".$i.$htmlext;
	  $pageslues{$selecpages[$i]} = 0 unless ($pageslues{$selecpages[$i]} != '');
	  print FOUT "$L{'Page'} n.$numero : ";

	  $link = &AddHREF($selecpages[$i]); # if ($squid_format == 0);
#	  $link = &AddHREF($tmp) if ($squid_format == 1);
	  print FOUT "$link";

	  print FOUT ": <B>";
	  print FOUT "<A HREF=\"$newpage\">" if ($pageslues{$selecpages[$i]} != 0);
	  print FOUT "$pageslues{$selecpages[$i]} $L{'times'}";
	  print FOUT "</A>" if ($pageslues{$selecpages[$i]} != 0);
	  print FOUT "</B>";
	  print FOUT "<BR>";
      }
  }

  if ($linkpath_url ne '') {
      $datafileinc = $linkpath_url.$dirinc.$dirsepurl.$incpage.$txtext;
      $string_th = "$L{'Pages'}:$L{'Occurence'}" if ($mail_format == 0);
      $string_th = "$L{'Emails'}:$L{'Occurence'}" if ($mail_format != 0);
      $string_th = "$L{'Files'}:$L{'Occurence'}" if ($cups_format == 1);
      $string_th .= ":$L{'Hosts'}" if ($precision > 3);
      $string_title = "$L{'Search'}:$L{'Search_on'}:$L{'No_item_found'}";
      $datafileinc_url = $linkpath_url.$dirdata.$dirsepurl.$fileurl if ($titlename == 1);

      # Things to add 
      # - Page display if search item > 20
      # - Translate 'here the XX items found'
      print FOUT "<P>";

      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'Search'}</I> :</DIV><P>\n";

      print FOUT "<FORM method=\"POST\" name=\"ajax\" action=\"javascript:SearchPages()\">\n";
      print FOUT "<TABLE BORDER=0>\n<TR>\n";
      print FOUT "<TD VALIGN=MIDDLE>";
      #print FOUT "<TD VALIGN=MIDDLE onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$L{'Title_search_pages'}','$L{'Line_search_pages'}','$L{'Desc_search_pages'}','$L{'Link_search_pages'}',0,'','$help_width')\">\n" if ($mail_format == 0);
 #     print FOUT "<TD VALIGN=MIDDLE onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$L{'Title_search_email'}','$L{'Line_search_email'}','$L{'Desc_search_email'}','$L{'Link_search_email'}',0,'','$help_width')\">\n" if ($mail_format != 0);
      if ($cups_format == 1) {
	  print FOUT "<INPUT type=\"hidden\" name=\"diffmax\"  value=\"1\">\n";
      } else {
	  print FOUT "<INPUT type=\"hidden\" name=\"diffmax\"  value=\"$diffmax_ini\">\n";
      }

      print FOUT "<INPUT type=\"hidden\" name=\"lang\" value=\"$I\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"xmax\" value=\"$xmax\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"ymax\" value=\"$ymax\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"precision\" value=\"$precision\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"notrafic\" value=\"$notrafic\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"config\" value=\"$tmp2\">\n";
      if ($ftp_format == 1 || $mail_format == 1 || $squid_format == 1 || $cups_format == 1) {
	  print FOUT "<INPUT type=\"hidden\" name=\"linkpage\" value=\"0\">\n";
      } else {
	  print FOUT "<INPUT type=\"hidden\" name=\"linkpage\" value=\"1\">\n";
      }
      print FOUT "<INPUT type=\"hidden\" name=\"linkpathinit\" value=\"$linkpathinit\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"datafile\" value=\"$datafileinc\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"datafile_url\" value=\"$datafileinc_url\">\n" if ($titlename == 1);
      print FOUT "<INPUT type=\"hidden\" name=\"datafile_url\" value=\"\">\n" if ($titlename == 0);
      print FOUT "<INPUT type=\"hidden\" name=\"string_title\" value=\"$string_title\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"string_th\" value=\"$string_th\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"yesterday\" value=\"$yesterday\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"cgipagegraph\" value=\"$cgipagegraph\">\n" if (-f "$path$dirinc$dirsep$pagehas");
      print FOUT "<INPUT type=\"hidden\" name=\"cgipagegraph\" value=\"\">\n" if (!(-f "$path$dirinc$dirsep$pagehas"));
      $tmp = 3;
      $tmp++ if ($cups_format == 0 && $precision > 3);

      print FOUT "<INPUT type=\"hidden\" name=\"index_hit\" value=\"$tmp\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"string_sep\" value=\"\t\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"seuilpage\" value=\"$seuilpage\">\n";

      print FOUT "<TABLE>\n<TR>\n";
      print FOUT "<TH VALIGN=MIDDLE onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$L{'Title_search_pages'}','$L{'Line_search_pages'}','$L{'Desc_search_pages'}','$L{'Link_search_pages'}',0,'','$help_width')\">\n" if ($mail_format == 0);
      print FOUT "<TH VALIGN=MIDDLE onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$L{'Title_search_email'}','$L{'Line_search_email'}','$L{'Desc_search_email'}','$L{'Link_search_email'}',0,'','$help_width')\">\n" if ($mail_format != 0);
      print FOUT "$L{'Search'}</TH>\n";
      print FOUT "</TR>\n<TR>\n";
      print FOUT "<TD>";
#      print FOUT "<INPUT type=\"text\" id=\"txtSearch\" name=\"search_value\"  value=\"\" onkeyup=\"searchSuggest();\" autocomplete=\"off\" OnFocus=\"javascript:clean()\">\n";
      print FOUT "<INPUT type=\"text\" id=\"txtSearch\" name=\"search_value\"  value=\"\" onkeyup=\"searchSuggest();\" OnBlur=\"javascript:clean_focus()\" OnFocus=\"javascript:clean()\">\n";
      print FOUT "<div id=\"search_suggest\"></div>\n";
      print FOUT "</TD>\n";
      print FOUT "</TR>\n</TABLE>\n";

      print FOUT "</TD><TD VALIGN=TOP>\n";

      print FOUT "<TABLE>\n<TR>\n";
      print FOUT "<TH COLSPAN=2>$L{'Requests'}</TH>\n";
      print FOUT "</TR>\n<TR>";
      print FOUT "<TD>$L{'Threshold'}</TD>\n<TD><INPUT type=\"text\" size=\"3\" name=\"search_threshold\"  value=\"$seuilpage\"></TD>\n";
      print FOUT "</TR>\n</TABLE>";
      
      print FOUT "</TD><TD VALIGN=TOP>\n";

      if ($titlename == 1) {
	  print FOUT "<TABLE><TR>";
	  print FOUT "<TH COLSPAN=4>$L{'Search_on'}</TH>";
	  print FOUT "</TR><TR>";
	  print FOUT "<TD>$L{'URL'}</TD>\n<TD><INPUT type=\"radio\" name=\"mode_search\"  value=\"0\" OnClick=\"javascript:document.getElementById('display_off').style.display='block';\" CHECKED></TD>\n";
	  print FOUT "<TD>$L{'Title'}</TD>\n<TD><INPUT type=\"radio\" name=\"mode_search\" OnClick=\"javascript:document.getElementById('display_off').style.display='none';\" value=\"1\"></TD>\n";
	  print FOUT "</TR></TABLE>";
      } else {
	  print FOUT "<INPUT type=\"hidden\" name=\"mode_search\" value=\"0\">\n";
      }

      print FOUT "</TD><TD VALIGN=TOP>\n";

      if ($titlename == 1) {
	  print FOUT "<DIV ID=\"display_off\" STYLE=\"display:block\">\n";
	  print FOUT "<TABLE>\n<TR>\n";
	  print FOUT "<TH COLSPAN=4>$L{'URL_mapping'}</TH>\n";
	  print FOUT "</TR>\n<TR>\n";
	  print FOUT "<TD>$L{'Enabled'}</TD>\n<TD><INPUT type=\"radio\" name=\"mode_fast\" value=\"0\" CHECKED></TD>\n";
	  print FOUT "<TD>$L{'Disabled'}</TD>\n<TD><INPUT type=\"radio\" name=\"mode_fast\" value=\"1\"></TD>\n";
	  print FOUT "</TR>\n</TABLE>\n";
	  print FOUT "</DIV>\n";
      } else {
	  print FOUT "<INPUT type=\"hidden\" name=\"mode_fast\" value=\"1\">\n";
      }

      print FOUT "</TD><TD VALIGN=MIDDLE>\n";

      print FOUT "<INPUT type=\"submit\" class=\"submit_button\" name=\"search_button\"  value=\"$L{'Search'}\" OnFocus=\"javascript:document.ajax.search_button.value='$L{'Processing'}'\">\n";

      print FOUT "</TD>\n</TR>\n</TABLE>\n";
      print FOUT "</FORM>\n<P>\n";
      
      print FOUT "<DIV ID=\"search_header\"></DIV>\n";
      print FOUT "<DIV ID=\"search_results\"></DIV>\n";
#      print FOUT "<BR><HR><P>\n";
  }


  if ($maxdepth ne '') {
      if ($mail_format == 0 && ($squid_format == 0 || $precision > 3)) {

	  print FOUT "<P><DIV CLASS=\"item_page\">-&nbsp;<I>$L{'Directories'}</I></DIV><P>\n";

	  if ($seuilpage != 1 && $seuilpage != 0) {
	      print FOUT "<I>($L{'Only_directories'} $L{'with_at_least'} $seuilpage $L{'accesses'} $L{'are_shown'})</I>\n<BR>";
	  }

	  if ($seuilrepert != 1 && $seuilrepert != 0 && $squid_format == 1 && $precision > 3) {
	      print FOUT "<I>($L{'Only_directories'} $L{'with_at_least'} $seuilrepert $L{'requests'} $L{'are_shown'})</I>\n";
	  }

#  print FOUT "<I>$L{'Legend_in_bracket'} :</I>\n<UL>\n";
#  print FOUT "<LI> $L{'Number_of_HTML_files'} $L{'in_whole_directory'}\n";
#  print FOUT "<LI> $L{'Number_of_HTML_files'} $L{'in_this_directory'}\n";
#  print FOUT "</UL>\n<P>\n";
  
#	  print FOUT "<TABLE><TR>\n";
#	  for ($i=0;$i<$maxdepth;$i++) {
#	      print FOUT "<TH>$L{'Level'}&nbsp;$i</TH>\n";
#	  }
#	  print FOUT "</TR>\n";

	  print FOUT "<P><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0><TR>\n";  
#	  for ($i=($depthinit+1);$i<$maxdepth;$i++) {
	  for ($i=1;$i<$maxdepth;$i++) {
	      print FOUT "<TH></TH>";
	      print FOUT "<TH>$L{'Level'}&nbsp;$i</TH>";
	      print FOUT "<TH></TH><TH></TH>\n";
	  }
	  print FOUT "</TR>\n";

# display the tree

	  open(TMPTREE,"$path$dirtmp$dirsep$vtmp$dirtmp") || die "Error, unable to open $path$dirtmp$dirsep$vtmp$dirtmp\n";
	  while (<TMPTREE>) {
	      s/TITLE=\"(\w+)\"/TITLE=\"$L{'Accesses'} - $L{$1}\"/;
	      print FOUT ;
	  }
	  close(TMPTREE);
	  print FOUT "</TABLE>\n";
#	  print FOUT "<P><HR><P>\n";
      }
  }
  print FOUT "</BODY></HTML>\n";
}

####

sub HostsTab {
    local(*FOUT,*L,$I,$topten,$home) = @_;
    local($count,$link,$tmplink,$tmplink2);

    if ($update_homepage == 1 && $home == 1 && $nblang == 0) {
	$scan = 0;
	$adresse = '';
	if (-f "$path$dirinc$dirsep$inchomepage") {
	    open(HOSTHOME,"$path$dirinc$dirsep$inchomepage"); # || &error_exit("Error, unable to open $path$dirinc$dirsep$inchomepage");
	    while (<HOSTHOME>) {
		chop;
		$scan = 0 if ($_ =~ /^#/);
		if ($scan == 1) {
		    $nb = ($adresse,$tmp2,$tmp3,$tmp4,$tmp5,$tmp6) = split(/\t/);
		    $resolv_user{$adresse} = $tmp2;
		    $server{$adresse} = $tmp3;
		    $nbpageserveur{$adresse} = $tmp4;
		    $nbpageserveurunique{$adresse} = $tmp5;
		    $serversize{$adresse} = $tmp6;
		}
		$scan = 1 if ($_ =~ /^#HOST/);
		$scan = 1 if ($_ =~ /^#LOCALHOST/ && $adresse eq '');
	    }
	    close(HOSTHOME);
	}
    }

    $tmp = $serversize{(&reverse_sort_by_value(*serversize))[0]};
    $unit = "$L{'bytes'}";
    $unit = "$L{'Kb'}" if ($tmp > 1024);		    
    $unit = "$L{'Mb'}" if ($tmp > (1024*1024));
    $unit = "$L{'Gb'}" if ($tmp > (1024*1024*1024));
    $unit = "$L{'Tb'}" if ($tmp > (1024*1024*1024*1024));

    $tmplink = "..$dirsepurl..$dirsepurl" if ($home == 0);
    $tmplink = "" if ($home == 1);

    $tmplink2 = "..$dirsepurl$dirdomain$dirsepurl" if ($mail_format == 1);
    $tmplink2 = "$I$dirsepurl$dirsite$dirsepurl" if ($home == 1 && $mail_format == 0);
    $tmplink2 = "$I$dirsepurl$dirdomain$dirsepurl" if ($home == 1 && $mail_format == 1);

    print FOUT "\n<table class=\"tablesort  table-autosort table-autostripe table-stripeclass:alternate\">\n";
    print FOUT "<thead>\n";
    print FOUT "<TR>\n";
    print FOUT "<TH class=\"table-sortable:default\">$L{'Hosts'}</TH>\n";
    print FOUT "<TH class=\"table-sortable:numeric\">$L{'Requests'}</TH>\n";
    print FOUT "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n" if ($home == 0);
    if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
	print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n" if ($home == 0);
#	print FOUT "<TH class=\"table-sortable:numeric\">$L{'Accesses'}&nbsp;($L{'Unique'})&nbsp;</TH>\n" if ($home == 0);
    }
    if ($spam_found != 0 && $spamonly != 1) {
	print FOUT "<TH class=\"table-sortable:numeric\">$L{'Spam'}</TH>\n";
	print FOUT "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n" if ($home == 0);
    }
#    if ($home == 0 && $precision > 3 && $squid_format == 0) {
    if (($home == 0 && $precision > 3) || $cups_format == 1) {
#	if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	    print FOUT "<TH class=\"table-sortable:numeric\">$L{'Different_accesses'}&nbsp;</TH>\n";
#	} else {
#	    print FOUT "<TH class=\"table-sortable:numeric\">$L{'Requests'}&nbsp;($L{'Unique'})&nbsp;</TH>\n";
#	}
    }

    if ($notrafic == 0) {
	print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n";
	print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n" if ($home == 0); 
    }
    print FOUT "<TH class=\"table-sortable:date\">$L{'Last_occurence'}</TH>\n" if ($home == 0);
    print FOUT "</TR>\n";
    print FOUT "</thead>\n";
    print FOUT "<tbody>\n";

    foreach $adresse (&reverse_sort_by_value(*server)) {
	    
	if ($count < $topten) {
	    $count++;
	    $newserveur = $adresse;
	    $newserveur =~ s/[.:]/_/g;
		
	    print FOUT "<TR>\n<TD CLASS=\"left\">\n";
	    if ($adresse =~ /[0-9]+$/ || $adresse =~ /:/) {
		if ($precision > 3 && $nbpageserveur{$adresse} > 0) {
		    print FOUT "<A HREF=\"$tmplink2$newserveur$htmlext\"";
		    print FOUT " TITLE=\"$resolv_user{$adresse}\"" if ($resolv_user{$adresse} ne '');
		    print FOUT ">";
		}
		print FOUT "$adresse";
		print FOUT "</A> " if ($precision > 3 && $nbpageserveur{$adresse} > 0);
	    } else {
		$pospoint = index($adresse,'.',0);
		$domadresse = substr($newserveur,$pospoint+1,(length($newserveur)-length($pospoint)));

		if (($precision > 3 && $nbpageserveur{$adresse} > 0) || $mail_format == 1) {
		    print FOUT "<A HREF=\"$tmplink2$newserveur$htmlext\">" if ($domadresse !~ /_/);
		    print FOUT "<A HREF=\"$tmplink2$domadresse$htmlext#$adresse\">" if ($domadresse =~ /_/);
#		    print FOUT "<A HREF=\"$tmplink2$domadresse$htmlext#$adresse\">" if ($split_localhost == 0 && $domadresse =~ /_/);
#		    print FOUT "<A HREF=\"$tmplink2$newserveur$htmlext\">" if ($split_localhost == 1 && $domadresse =~ /_/);
		}
#		$tmp = $adresse;
#		$tmp = &EncryptLink($tmp) if ($crypt == 1);
		print FOUT "$adresse";
		print FOUT "</A> " if (($precision > 3 && $nbpageserveur{$adresse} > 0) || $mail_format == 1);
	    }

	    print FOUT "&nbsp;</TD>\n";
	    print FOUT "<TD CLASS=\"right\">&nbsp;<B>$server{$adresse}</B> ";
	    print FOUT "&nbsp;</TD>\n";
	    
	    if ($home == 0) {
		$pourcentage = (($server{$adresse}*1000)/$reqtot)/10 if ($reqtot != 0);
		$pourcentageint = int($pourcentage);
		print FOUT "<TD CLASS=\"left\">&nbsp;\n";
		print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"$tmplink$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
		printf FOUT "%.1f ",$pourcentage;
		print FOUT " %</TD>\n";
	    }


	    if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
		print FOUT "<TD CLASS=\"right\">&nbsp;<B>$nbpageserveur{$adresse}</B>&nbsp;</TD>\n";
		if ($home == 0) {
		    $pourcentage = (($nbpageserveur{$adresse}*1000)/$access)/10 if ($access != 0);
		    $pourcentageint = int($pourcentage);
		    print FOUT "<TD CLASS=\"left\">&nbsp;\n";
		    print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"$tmplink$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
		    printf FOUT "%.1f ",$pourcentage;
		    print FOUT " %</TD>\n";
		}
	    }

	    if ($spam_found != 0 && $spamonly != 1) {
		print FOUT "<TD CLASS=\"right\">";
		print FOUT "$spam_dom{$adresse}</TD>\n";
		if ($home == 0) {
		    print FOUT "<TD CLASS=\"left\">";
		    $percentage = ($spam_dom{$adresse}*100)/$spam_found if ($spam_found != 0);
		    $tmp2 = int($percentage);
		    print FOUT "<img width=$tmp2 height=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">&nbsp;" if ($tmp2 != 0);
		    printf FOUT "%3.1f %",$percentage;
		    print FOUT "</TD>\n";
		}
	    }

#	    print FOUT "<TD CLASS=\"right\">&nbsp;<B>$nbpageserveurunique{$adresse}</B>&nbsp;</TD>\n" if (($home == 0 && $precision > 3) || $cups_format == 1);
	    print FOUT "<TD CLASS=\"right\">&nbsp;<B>$nbpageserveurunique{$adresse}</B>&nbsp;</TD>\n" if (($home == 0 && $precision > 3) || $cups_format == 1);

	    if ($notrafic == 0) {
		$tmp = $serversize{$adresse}/1024 if ($unit eq "$L{'Kb'}");
		$tmp = $serversize{$adresse}/(1024*1024) if ($unit eq "$L{'Mb'}");
		$tmp = $serversize{$adresse}/(1024*1024*1024) if ($unit eq "$L{'Gb'}");
		$tmp = $serversize{$adresse}/(1024*1024*1024*1024) if ($unit eq "$L{'Tb'}");
		if ($externesize != 0) {
		    $pourcentage = 100*$tmp/($externesize*1024) if ($unit eq "$L{'Kb'}");
		    $pourcentage = 100*$tmp/$externesize if ($unit eq "$L{'Mb'}");
		    $pourcentage = 100*$tmp/($externesize/1024) if ($unit eq "$L{'Gb'}");
		    $pourcentage = 100*$tmp/($externesize/(1024*1024)) if ($unit eq "$L{'Tb'}");
		}
		$tmp = int($tmp*100)/100 if ($unit ne "$L{'Kb'}");			    
		$tmp = int($tmp) if ($unit eq "$L{'Kb'}");
		
		print FOUT "<TD CLASS=\"right\">&nbsp;<B>$tmp</B> ";
		print FOUT "&nbsp;</TD>\n";
	    
		if ($home == 0) {
		    $pourcentageint = int($pourcentage);
		    print FOUT "<TD CLASS=\"left\">&nbsp;\n";
		    print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"$tmplink$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
		    printf FOUT "%.1f ",$pourcentage;
		    print FOUT " %</TD>\n";
		}
	    }

	    print FOUT "<TD CLASS=\"right\">$serverdate{$adresse}</TD>\n" if ($home == 0);
	    print FOUT "</TR>\n";
	}
    }
    print FOUT "</tbody>\n";
    print FOUT "</TABLE>\n";
   
}


####

sub AddHREF {
    local($page) = @_;
    local($link,$tmp,$tmp3);

    $tmp = 0;
    $tmp = 1 if ($ftp_format == 0 || $spip == 1);
    if ($ftp_format == 1) {
	$tmp = 1 if (-r "$ftpserver$page");
    }
    if ($cups_format == 1) {
	$tmp = 0 if ($printer_server eq '');
    }

    $tmp3 = $page;
    $tmp3 =~ s/\&/\&amp;/g;

#    $cups_file = "d".$page."-001";

    if ($mail_format == 0 && $squid_format == 0 && $dhcp_format == 0) {

	if ($tmp == 1) {
	    $link .= "<A HREF=\"";
	    $link .= "$localserver_protocol://$localserver" if (!(-r "$pathserver$page") && $ftp_format == 0 && $cups_format == 0);
	    $link .= "ftp://$localserver" if (-r "$ftpserver$page" && $ftp_format == 1);
	    if ($cups_format == 1) {
#		$link .= "$link_cups$cups_file\"" if (-r "$basedir_cups$cups_file");
		$link .= "http://$printer_server:631/jobs/?op=restart-job&amp;job_id=$page&amp;job_printer_uri=http://$printer_server:631/printers/$printer_default\"" if ($printer_server ne '');
	    }
	    $link .= "$tmp3\"" if ($cups_format == 0);
	    $link .= " TITLE=\"$page\"" if ($titlename == 1 && $urlconv{$page} ne '');
	    $link .= ">";

#	    print "BB $cups_format - $basedir_cups$cups_file - $link\n";
	}
    }
    if ($titlename == 1 && $urlconv{$page} ne '') {
	$link .= "<b>$urlconv{$page}</b>";
    } else {
	$link .= "$page";
    }

    if ($mail_format == 0 && $squid_format == 0 && $dhcp_format == 0) {
	$link .= "</A>" if ($tmp == 1);
    }

    return $link;
}


sub PagesTab {
  local(*FOUT,*L,$I,$topten,$home) = @_;
  local($count,$link,$tmplink,$tmplink2,$date);
  local($page,$tmp2,$tmp3,$tmp4,$tmp5);

#  $cgipagegraph = $w3perlcgiurl.$dirsepurl."pagegraph".$plext;

  if ($update_homepage == 1 && $home == 1 && $nblang == 0) {
      $scan = 0;
      if (-f "$path$dirinc$dirsep$inchomepage") {
	  open(HOSTHOME,"$path$dirinc$dirsep$inchomepage"); # || &error_exit("Error, unable to open $path$dirinc$dirsep$inchomepage");
	  while (<HOSTHOME>) {
	      chop;
	      $scan = 0 if ($_ =~ /^#/);
	      $scan = 1 if ($_ =~ /^#PAGE/);
	      if ($scan == 1) {
		  next if ($_ =~ /^#/);
		  $nb = ($page,$tmp2,$tmp3,$tmp4,$tmp5) = split(/\t/);
		  $urlconv{$page} = $tmp2; # if ($cups_format == 0);
		  $pagehas{$page} = $tmp3;
		  $pageslues{$page} = $tmp4;
		  if ($precision > 3) {
		      if ($cups_format == 1) {
			  $pagelist{$pagehas{$page},1} = $tmp5;
		      } else {
			  $nbpagehost{$pagehas{$page}} = $tmp5;
		      }
		  }
	      }
	  }
	  close(HOSTHOME);
      }
  }

  $tmplink = "..$dirsepurl..$dirsepurl" if ($home == 0);
  $tmplink = "" if ($home == 1);

  $tmplink2 = "" if ($home == 0);
  $tmplink2 = "$I$dirsepurl$dirpage$dirsepurl" if ($home == 1);

  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Destination'}&nbsp;</TH>\n" if ($squid_format == 1);
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Pages'}&nbsp;</TH>\n" if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Files'}&nbsp;</TH>\n" if ($ftp_format == 1 || $cups_format == 1);
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Emails'}&nbsp;</TH>\n" if ($mail_format == 1);
  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Occurence'}</TH>\n" if ($cups_format == 0);
  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Requests'}</TH>\n" if ($cups_format == 1);
  print FOUT "<TH class=\"table-sortable:numeric_array\">&nbsp;</TH>\n" if ($cups_format == 0);
  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n" if ($home == 0);
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n" if ($precision > 3 && $mail_format == 0);
  if ($home == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n" if ($precision > 3 && $mail_format == 0 && $cups_format == 1);
  }
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";

  $tmp2 = $opt_c;
  $tmp2 = substr($tmp2,rindex($tmp2,$dirsep)+1,length($tmp2)) if ($opt_c =~ /^\//);

  $tmp5 = $tmpagenb;
  $tmp5 = $diffmax_ini if ($tmp5 > $diffmax_ini);



  foreach $page (&reverse_sort_by_value(*pageslues)) {
      if ($count < $topten && $pageslues{$page} > 0) {
	  $count++;

	  $pourcentage = (($pageslues{$page}*1000)/$access)/10 if ($access != 0);
	  $pourcentageint = int($pourcentage);
	  print FOUT "<TR>\n";
	  if ($squid_format == 1) {
	      $tmp = index($page,$dirsep,1);
	      $tmp1 = substr($page,0,$tmp+1);
	      $tmp6 = substr($page,$tmp,length($page));
	      print FOUT "<TD CLASS=\"left\">$tmp1</TD>\n";
	  }
	  print FOUT "<TD CLASS=\"left\"";
	  print FOUT " TITLE=\"$page\"" if ($titlename == 1 && $urlconv{$page} ne '');
	  print FOUT " TITLE=\"$resolv_user{$page}\"" if ($resolv_user{$page} ne '');
	  print FOUT ">";
#	  if ($mail_format == 0 && $squid_format == 0 && $cups_format == 0) {
#	  if ($mail_format == 0 && $squid_format == 0) {
	  $link = &AddHREF($page) if ($squid_format == 0);
	  $link = &AddHREF($tmp6) if ($squid_format == 1);
	  $link = &EncryptLink($link) if ($crypt == 1);
	  print FOUT "$link";
	  print FOUT "&nbsp;</TD>\n";

	  if ($cups_format == 0) {
	      $cur = $pagesluesday{$page} if ($scriptname eq "cron-inc.pl");
	      $cur = $tmpage{0,$pagehas{$page}} if ($scriptname ne "cron-inc.pl");

	      $tmp = 0;
	      for ($i=0;$i<=$tmp5;$i++) {
		  $tmp += $tmpage{$i,$pagehas{$page}};
	      }
	      $tmp = int($tmp/($tmp5+1));
	      $val = $tmp*10/100; # threshold to 10% to get increase/decrease

	      $tmpstr = "same" if (abs($cur - $tmp) <= $val);
	      $tmpstr = "increase" if ($cur > ($tmp+$val));
	      $tmpstr = "decrease" if ($cur < ($tmp-$val));
	  }

	  print FOUT "<TD CLASS=\"right\">&nbsp;<B>";
	  if ($w3perlcgiurl ne '' && -d $cgipath_install && $home == 0 && $cups_format == 0 && $precision > 2 && (-f "$path$dirinc$dirsep$pagehas")) {
	      print FOUT "<A HREF=\"javascript:GraphHosts('$cgipagegraph',";
	      print FOUT "'$tmp2'," if ($opt_c ne '');
	      print FOUT "'config.pl'," if ($opt_c eq '');
	      print FOUT "'$pagehas{$page}',";
	      print FOUT "'0',";
	      print FOUT "'$I'";
	      print FOUT ")\">";
	  }
	  print FOUT "$pageslues{$page}";
	  print FOUT "</A>" if ($home == 0 && $w3perlcgiurl ne '' && -d $cgipath_install && $home == 0 && $cups_format == 0 && $precision > 2 && (-f "$path$dirinc$dirsep$pagehas"));


	  print FOUT "</B>&nbsp;</TD>\n";
	  if ($cups_format == 0) {
	      print FOUT "<TD><!-- 9 --><IMG SRC=\"$tmplink$linkpathinit$dirress$dirsepurl$array_up\" WIDTH=12 HEIGHT=12 ALT=\"up\"></TD>\n" if ($tmpstr eq "increase");
	      print FOUT "<TD><!-- 5 --><IMG SRC=\"$tmplink$linkpathinit$dirress$dirsepurl$array_same\" WIDTH=12 HEIGHT=12 ALT=\"same\"></TD>\n" if ($tmpstr eq "same");
	      print FOUT "<TD><!-- 1 --><IMG SRC=\"$tmplink$linkpathinit$dirress$dirsepurl$array_down\" WIDTH=12 HEIGHT=12 ALT=\"down\"></TD>\n" if ($tmpstr eq "decrease");
	  }
	  if ($home == 0) {
	      print FOUT "<TD CLASS=\"left\">&nbsp;";
	      print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"$tmplink$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
	      printf FOUT "%.1f",$pourcentage;
	      print FOUT " %</TD>\n";
	  }
	  if ($precision > 3 && $mail_format == 0 && $cups_format == 0) {
	      print FOUT "<TD CLASS=\"right\">";
	      print FOUT "<A HREF=\"$tmplink2$pagehas{$page}$htmlext\">" if ($pageslues{$page} >= $seuilpage);
	      print FOUT "$nbpagehost{$pagehas{$page}}";
	      print FOUT "</A>" if ($pageslues{$page} >= $seuilpage);
	      print FOUT "</TD>\n";
	  }
	  $adresse = $pagelist{$pagehas{$page},1};
	  print FOUT "<TD CLASS=\"right\">$adresse</TD>\n" if ($precision > 3 && $mail_format == 0 && $cups_format == 1);
	  $tmp3 = $pagelist_date{$pagehas{$page},$adressehad{$adresse}};
	  ($date) = &get_time($tmp3*86400);
	  $date =~ s/\// /g;
	  if ($home == 0) {
	      print FOUT "<TD CLASS=\"right\">$date</TD>\n" if ($precision > 3 && $mail_format == 0 && $cups_format == 1);
	  }
	  print FOUT "</TR>\n";
      }
  }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE>";


}

sub TraficServerTab {
  local(*FOUT,*L,$I,$topten,$home) = @_;
  local($count,$link,$tmplink,$tmp,$count_server2);

  if ($update_homepage == 1 && $home == 1 && $nblang == 0) {
      $scan = 0;
      if (-f "$path$dirinc$dirsep$inchomepage") {
	  open(HOSTHOME,"$path$dirinc$dirsep$inchomepage"); # || &error_exit("Error, unable to open $path$dirinc$dirsep$inchomepage");
	  while (<HOSTHOME>) {
	      chop;
	      $scan = 0 if ($_ =~ /^#/);
	      $scan = 1 if ($_ =~ /^#SIZESERVER/);
	      if ($scan == 1) {
		  next if ($_ =~ /^#/);
		  $nb = ($adresse,$tmp2) = split(/\t/);
		  $serversize{$adresse} = $tmp2;
	      }
	  }
	  close(HOSTHOME);
      }
  }

  $tmplink = "..$dirsepurl..$dirsepurl" if ($home == 0);
  $tmplink = "" if ($home == 1);

  $line_display = '';
  $count_server2 = 0;
  $count_server = keys(%serversize);
  
  foreach $adresse (&reverse_sort_by_value(*serversize)) {
      if ($count_server2 < $topten) {
	  $count_server2++;

	  if ($count_server2 == 1) {

	      $tmp = $serversize{$adresse};
	      $unit = "$L{'bytes'}";
	      $unit = "$L{'Kb'}" if ($tmp > 1024);		    
	      $unit = "$L{'Mb'}" if ($tmp > (1024*1024));
	      $unit = "$L{'Gb'}" if ($tmp > (1024*1024*1024));
	      $unit = "$L{'Tb'}" if ($tmp > (1024*1024*1024*1024));

	      if ($home == 0) {
		  $line_display .= "<I>$L{'The_Top'} $topten $L{'top_external_sites'} ";
		  $line_display .= "(<A HREF=\"..$dirsepurl$dirsite$dirsepurl$listsites\">$L{'Full_list'}</A>)" if ($show_all == 1 && $count_server > $topten);
		  $line_display .= "</I> :<P>\n";
	      }

	      $line_display .= "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
	      $line_display .= "<thead>\n";
	      $line_display .= "<TR>\n";
	      $line_display .= "<TH class=\"table-sortable:default\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
	      $line_display .= "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n";
	      $line_display .= "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
	      $line_display .= "</TR>\n";
	      $line_display .= "</thead>\n";
	      $line_display .= "<tbody>\n";
	  }

	  $pourcentage = 100*$serversize{$adresse}/$totsize if ($totsize != 0);
	  $pourcentageint = int($pourcentage);
	  $pourcentage = int($pourcentage*10)/10;
	  $line_display .= "<TR>\n<TD CLASS=\"left\">";
	  $line_display .= "$adresse";
	  $line_display .= "</TD>\n<TD CLASS=\"right\">&nbsp;<B>";
	  $tmp = $serversize{$adresse}/1024 if ($unit eq "$L{'Kb'}");
	  $tmp = $serversize{$adresse}/(1024*1024) if ($unit eq "$L{'Mb'}");
	  $tmp = $serversize{$adresse}/(1024*1024*1024) if ($unit eq "$L{'Gb'}");
	  $tmp = $serversize{$adresse}/(1024*1024*1024*1024) if ($unit eq "$L{'Tb'}");
	  $tmp = int($tmp*10)/10;
	  $line_display .= "$tmp";
	  $line_display .= "</B>&nbsp;</TD>\n<TD CLASS=\"left\">&nbsp;\n";
	  $line_display .= "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"$tmplink$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
	  $line_display .= "$pourcentage";
	  $line_display .= "&nbsp;%</TD>\n</TR>\n";
      }
  }

  if ($count_server2 >= 1) {
      $line_display .= "</tbody>\n";
      $line_display .= "</TABLE>\n";
  }

#  print FOUT "$line_display" if ($home == 1);
  return $line_display;

}


sub TraficPageTab {
  local(*FOUT,*L,$I,$topten,$home) = @_;
  local($count,$link,$tmplink,$tmp);

  if ($update_homepage == 1 && $home == 1 && $nblang == 0) {
      $scan = 0;
      if (-f "$path$dirinc$dirsep$inchomepage") {
	  open(HOSTHOME,"$path$dirinc$dirsep$inchomepage"); # || &error_exit("Error, unable to open $path$dirinc$dirsep$inchomepage");
	  while (<HOSTHOME>) {
	      chop;
	      $scan = 0 if ($_ =~ /^#/);
	      $scan = 1 if ($_ =~ /^#SIZEPAGE/);
	      if ($scan == 1) {
		  next if ($_ =~ /^#/);
		  $nb = ($page,$tmp2) = split(/\t/);
		  $sizepage{$page} = $tmp2;
	      }
	  }
	  close(HOSTHOME);
      }
  }

  $tmplink = "..$dirsepurl..$dirsepurl" if ($home == 0);
  $tmplink = "" if ($home == 1);

  $count_pages = 0;
  $line_page_display = '';

  foreach $page (&reverse_sort_by_value(*sizepage)) {

      if ($count_pages < $topten) {
	  $count_pages++;

	  if ($count_pages == 1) {
	      $tmp = $sizepage{$page};
	      $unit = "$L{'bytes'}";
	      $unit = "$L{'Kb'}" if ($tmp > 1024);		    
	      $unit = "$L{'Mb'}" if ($tmp > (1024*1024));
	      $unit = "$L{'Gb'}" if ($tmp > (1024*1024*1024));
	      $unit = "$L{'Tb'}" if ($tmp > (1024*1024*1024*1024));

	      if ($home == 0) {
		  $line_page_display .= "<I>$L{'The_Top'} $topten $L{'files'} ";
		  $line_page_display .= "(<A HREF=\"$listtrafic\">$L{'Full_list'}</A>)" if ($show_all == 1 && scalar(%sizepage) > $topten);
		  $line_page_display .= "</I> :<P>";
	      }

	      $line_page_display .= "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
	      $line_page_display .= "<thead>\n";
	      $line_page_display .= "<TR>\n";
	      $line_page_display .= "<TH class=\"table-sortable:default\">&nbsp;$L{'Destination'}&nbsp;</TH>\n" if ($squid_format == 1);
	      $line_page_display .= "<TH class=\"table-sortable:default\">&nbsp;$L{'Files'}&nbsp;</TH>\n";
	      $line_page_display .= "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n";
	      $line_page_display .= "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
	      $line_page_display .= "</TR>\n";
	      $line_page_display .= "</thead>\n";
	      $line_page_display .= "<tbody>\n";
	  }
	  $page =~ s/\?(.*)//;
	  $pourcentvalue = $sizepage{$page}*100/$totsize if ($totsize != 0);
	  $tmp2 = int($pourcentvalue);
	  $pourcentvalue = int($pourcentvalue*10)/10;
	  
	  $line_page_display .= "<TR>\n";

	  if ($squid_format == 1) {
	      $tmp = index($page,$dirsep,1);
	      if ($tmp != -1) {
		  $tmp1 = substr($page,0,$tmp+1);
		  $tmp6 = substr($page,$tmp,length($page));
	      } else {
		  $tmp1 = $page;
		  $tmp6 = "";
	      }
	      $line_page_display .= "<TD CLASS=\"left\">$tmp1</TD>\n";
#	      $line_page_display .= "<TD CLASS=\"left\">$tmp6</TD>\n";
	  }

	  $line_page_display .= "<TD CLASS=\"left\">";
	  $link = &AddHREF($page) if ($squid_format == 0);
	  $link = &AddHREF($tmp6) if ($squid_format == 1);
	  $link = &EncryptLink($link) if ($crypt == 1);
	  $line_page_display .= $link;
	  $line_page_display .= "&nbsp;</TD>\n";

#	  if ($squid_format == 0) {
#	      $line_page_display .= "<TD CLASS=\"left\">&nbsp;";
#	      $line_page_display .= "$page" if ($titlename == 0);
#	      $line_page_display .= "$urlconv{$page}" if ($titlename == 1 && $urlconv{$page} ne '');
#	      $line_page_display .= "$page" if ($titlename == 1 && $urlconv{$page} eq '');
#	      $line_page_display .= "&nbsp;</TD>\n";
#	  }


	  $line_page_display .= "<TD CLASS=\"right\">&nbsp;";
	  $tmp = $sizepage{$page}/1024 if ($unit eq "$L{'Kb'}");
	  $tmp = $sizepage{$page}/(1024*1024) if ($unit eq "$L{'Mb'}");
	  $tmp = $sizepage{$page}/(1024*1024*1024) if ($unit eq "$L{'Gb'}");
	  $tmp = $sizepage{$page}/(1024*1024*1024*1024) if ($unit eq "$L{'Tb'}");
	  $tmp = int($tmp*10)/10;
	  
	  $line_page_display .= "<B>$tmp</B>&nbsp;</TD>";
	  $line_page_display .= "<TD CLASS=\"left\">&nbsp;";
	  $line_page_display .= "<IMG WIDTH=$tmp2 HEIGHT=$square SRC=\"$tmplink$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($tmp != 0);
	  $line_page_display .= "$pourcentvalue %";
	  $line_page_display .= "&nbsp;</TD>\n";
	  $line_page_display .= "</TR>\n";
	  
      }
  }
  if ($count_pages >= 1) {
      $line_page_display .= "</tbody>\n";
      $line_page_display .= "</TABLE>\n";
  }

#  print FOUT "$line_page_display" if ($home == 1);
#  print "$line_page_display";
  return $line_page_display;

}


sub ScriptsTab {
  local(*FOUT,*L,$I,$topten,$home) = @_;
  local($count,$link,$tmplink,$tmplink2);

  if ($update_homepage == 1 && $home == 1 && $nblang == 0) {
      $scan = 0;
      if (-f "$path$dirinc$dirsep$inchomepage") {
	  open(HOSTHOME,"$path$dirinc$dirsep$inchomepage"); # || &error_exit("Error, unable to open $path$dirinc$dirsep$inchomepage");
	  while (<HOSTHOME>) {
	      chop;
	      $scan = 0 if ($_ =~ /^#/);
	      $scan = 1 if ($_ =~ /^#SCRIPT/);
	      if ($scan == 1) {
		  next if ($_ =~ /^#/);
		  $nb = ($script,$tmp2) = split(/\t/);
		  $script{$script} = $tmp2;
	      }
	  }
	  close(HOSTHOME);
      }
  }

  $tmplink = "..$dirsepurl..$dirsepurl" if ($home == 0);
  $tmplink = "" if ($home == 1);

  $tmplink2 = "" if ($home == 0);	
  $tmplink2 = "$I$dirsepurl$dirscript$dirsepurl" if ($home == 1);

  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Destination'}&nbsp;</TH>\n" if ($squid_format == 1);
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Scripts'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";

  $i=0;
  foreach $script (&reverse_sort_by_value(*script)) {
      $scriptparam = "script".$i.$htmlext;

      $pourcentage = (($script{$script}*1000)/$allscriptcgi)/10 if ($allscriptcgi != 0);
      $pourcentageint = int($pourcentage);

      print FOUT "<TR>";
      if ($squid_format == 1) {
	  $tmp = index($script,$dirsep,1);
	  $tmp1 = substr($script,0,$tmp+1);
	  $tmp6 = substr($script,$tmp,length($script));
	  print FOUT "<TD CLASS=\"left\">$tmp1</TD>\n";
      }
      print FOUT "<TD CLASS=\"left\">";
      print FOUT "<A HREF=\"$tmplink2$scriptparam\">" if ($argunique{$script} != 0 && $script{$script} > $seuilscript);
      print FOUT "$script" if ($squid_format == 0);
      print FOUT "$tmp6" if ($squid_format == 1);
      print FOUT "</A>" if ($argunique{$script} != 0 && $script{$script} > $seuilscript);
      print FOUT "&nbsp;</TD>\n";
      print FOUT "<TD CLASS=\"right\">&nbsp;$script{$script}</TD>\n";
      print FOUT "<TD CLASS=\"left\">";
      print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"$tmplink$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
      printf FOUT "%.1f %",$pourcentage;
      print FOUT "</TD>\n";
      print FOUT "</TR>\n";
      if ($argunique{$script} ne '' && $home == 0) {
	  open(SCRIPTPARAM,">$path$lang[$nblang]$dirsep$dirscript$dirsep$scriptparam") || die "Error, unable to open $path$lang[$nblang]$dirsep$dirscript$dirsep$scriptparam\n";
	  &ScriptsParam(*SCRIPTPARAM, eval($Lang{$lang[$nblang]}),$I,$script);
	  close(SCRIPTPARAM);
      }	  
      $i++;
      last if ($i == $topten);
  }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n";
}

sub MakeDailyGraphJqplotInit {
#    local(*FOUT,*L,$I,$mode_date,$conv,$ref,$ref1,$ref2,$ref3,$ref4,$ref5,$ref6) = @_;
    local(*FOUT,*L,$I,$mode_date,$conv,$ref_tab,$ref_tab_name,$ref,$chart_id) = @_;
    local($i,$j,$val);
    local($nb_idx,$start_date);

    @tabdate = @$ref;

    @ref_tab_func = @$ref_tab;
    @ref_tab_name = @$ref_tab_name;

    if ($conv != 1) {
	($unit_div,$unit) = &Return_Unit($conv,1);
    }

    for ($i=0;$i<=$#ref_tab_func;$i++) {
	$val = "tab".$i;
	@$val = @{$ref_tab_func[$i]};
    }

    print FOUT "\n<script LANGUAGE=\"Javascript\" type=\"text/javascript\">\n";

    print FOUT "date_graph$chart_id = [";
    for ($i=0;$i<=$#tabdate;$i++) {
	$val = $tabdate[$i];
	if ($mode_date != 0 && $mode_date != 5) {
	    $val = &date_intervalle($val_prev,1) if ($val eq '');
	    $val_prev = $val if ($val ne '');
	    ($val1,$val2,$val3) = split(/\s/,$val);
	    if ($mode_date == 1) {
		$tmp = $val1." ".$val2." ".$val3;
	    }
	    if ($mode_date == 2) {
		$val1 = &date_intervalle($val,6);
		$val = $val." / ".$val1;
	    }
	    $val = $val2." ".$val3 if ($mode_date == 3);
	    $val = $val3 if ($mode_date == 4);
	    if ($mode_date == 1) {
		$wday = $day_of_week[(localtime(&nbday("$tmp")*86400))[6]];
		print FOUT "'$wday $val'";
	    } else {
		print FOUT "'$val'";
	    }
	}
	if ($mode_date == 0 || $mode_date == 5) {
	    print FOUT "'$val'";
	}
	print FOUT "," if ($i != $#tabdate);
    }
    print FOUT "];\n";

    for ($j=0;$j<=$#ref_tab_func;$j++) {
	$som[$j] = 0;
	$tmp_file = "tab$j";
	$nb_element = $#$tmp_file+1;
#	print "II $j - $#ref_tab_func - $tmp_file - $nb_element\n";
	if ($nb_element > 0) {
	    print FOUT "$ref_tab_name[$j]$chart_id = [";
#	    print FOUT "$tmp$chart_id = [";
#	    print "KKK $j - $nb_element - $i - $#$tmp_file - $#tabdate<BR>\n";
	    for ($i=0;$i<=$#$tmp_file;$i++) {
		$val = $$tmp_file[$i];
		$val = 0 if ($val eq '');
#		print  "$val - $i - $#tabdate - $tmpfile - $conv - $ref_tab_name[$j]<BR>";
		$val = int(100*$val/$conv)/100 if ($conv != 0 && ($ref_tab_name[$j] eq "traffic" || $ref_tab_name[$j] eq "percent"));
#		print "$i - $val - $#tabdate\n";


		$som[$j] += $val;

		print FOUT "$val";
#		print FOUT "$i";
		print FOUT "," if ($i != ($#$tmp_file) && $i != ($#tabdate));
		last if ($i == $#tabdate); # skip if no date have been set
	    }
#	    print "\n";
	    print FOUT "];\n";
	}
    }

    $add_br = "<br>";
    $add_br = "" if (scalar(@ref_tab_func) == 1);

    ###

#   print FOUT "function editit(str, si, pi, plot, mode) {\n";
    print FOUT "\nfunction editit$chart_id(str, si, pi, plot) {\n";

    print FOUT "var count = 0;\n";
    print FOUT "var mode = 0;\n";
    print FOUT "var ch_id = plot.targetId;\n";
    print FOUT "ch_id = ch_id.replace(\"#chart\",\"\");\n";
    print FOUT "var plot_number = \"plot\"+ch_id;\n";
    print FOUT "var mode = document.getElementById(plot_number).value;\n";

#    print FOUT "if (mode == 3) {\n";
    print FOUT "var plot_draw_number = \"plot_draw\"+ch_id;\n";
    print FOUT "var mode_line = document.getElementById(plot_draw_number).value;\n";
#    print FOUT "}\n";

#    if ($precision > 2 && $notrafic == 0) {
#	print FOUT "var tmp = Math.floor(10*size[pi]/$conv)/10;\n";
#    }

    if ($mode_date == 5) {
	print FOUT "var date_graph_val_next = date_graph$chart_id";
	print FOUT "[pi];\n";
	print FOUT "date_graph_val_next++;\n";
	print FOUT "if (date_graph_val_next < 10) date_graph_val_next = '0'+date_graph_val_next++;\n";
    }
    $val_txt1 = "<table width=\"120\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">";
    $val_txt1 .= "<tr>";
    $val_txt1 .= "<td style=\"-moz-opacity:.85;opacity:.85;\">";
    $val_txt1 .= "<table width=\"120\" cellspacing=\"0\" cellpadding=\"0\">";
    $val_txt1 .= "<tr>";
    $val_txt1 .= "<td width=\"120\" style=\"text-align:center;background-color:#ffddbb;padding:5px;\">";

    $val_txt2 = "<span style=\"color:Navy;font-size:11px;font-weight:bold;text-decoration:none;\">'+";
    $val_txt2 .= "date_graph$chart_id";
    $val_txt2 .= "[pi]+'";
    if ($mode_date == 5) {
	$val_txt2 .= " - '+date_graph_val_next+' $L{'hours'}";
    }
    $val_txt2 .= "<\\\/span>";

    $val_txt3 = "<\\\/td>";
    $val_txt3 .= "<\\\/tr>";
    $val_txt3 .= "<tr>";
    $val_txt3 .= "<td width=\"118\" style=\"background-color:#ffeecc;text-align:left;padding:5px;\">";

#    $val_txt3 .= "<br><span style=\"font-size:9px;\">$L{'Files'} : '+pageunique[pi]+'</span>" if ($cups_format == 1);
#    $val_txt10b .= "<br><span style=\"font-size:10px;\"><b>$L{'Users'} : '+user[pi]+'</b></span>" if ($inc_user == 1 && $found_user == 1);

    $val_txte = "<\\\/span>";
    $val_txte .= "&nbsp;<\\\/td>";
    $val_txte .= "<\\\/tr>";
    $val_txte .= "<\\\/table>";
    $val_txte .= "<\\\/td><\\\/tr><\\\/table>";

    print FOUT "var txt = '$val_txt1';\n";
    print FOUT "txt += '$val_txt2';\n";
    print FOUT "txt += '$val_txt3';\n";

    for ($j=0;$j<=$#ref_tab_func;$j++) {

	if ($som[$j] != 0) {

	$tmp = $ref_tab_name[$j];
	$tmp =~ s/\d//g;
	$tmp = ucfirst($tmp);

	$val_txt4a = "";
	$val_txt4a .= "$add_br" if ($j != 0);
	$val_txt4a .= "<span style=\"font-size:10px;color:#000000;\">";
	if ($L{$tmp} eq '') {
	    if ($L_temp{$ref_tab_name[$j]} eq '') {
		$val_txt4a .= "$ref_tab_name[$j]";
	    } else {
		$val_txt4a .= "$L_temp{$ref_tab_name[$j]}";
	    }
	} else {
	    $val_txt4a .= "$L{$tmp}";
	}
	$val_txt4a .= " : '+";
	$val_txt4a .= "$ref_tab_name[$j]$chart_id";
	if ($tmp eq "Traffic") {
	    $val_txt4a .= "[pi]+' $unit<\\\/span>";
	} else {
	    $val_txt4a .= "[pi]+'<\\\/span>";
	}

	$val_txt4b = "";
	$val_txt4b .= "$add_br" if ($j != 0);
	$val_txt4b .= "<span style=\"font-weight:bold;color:#990000;font-size:10px;\">";
	if ($L{$tmp} eq '') {
	    if ($L_temp{$ref_tab_name[$j]} eq '') {
		$val_txt4b .= "$ref_tab_name[$j]";
	    } else {
		$val_txt4b .= "$L_temp{$ref_tab_name[$j]}";
	    }
	} else {
	    $val_txt4b .= "$L{$tmp}";
	}
	$val_txt4b .= " : '+";
	$val_txt4b .= "$ref_tab_name[$j]$chart_id";
#	$val_txt4b .= "[pi]+'</span>";
	if ($tmp eq "Traffic") {
	    $val_txt4b .= "[pi]+' $unit<\\\/span>";
	} else {
	    $val_txt4b .= "[pi]+'<\\\/span>";
	}
	
	print FOUT "if (typeof($ref_tab_name[$j]$chart_id) != 'undefined') {\n";
	print FOUT "if (mode == 0) {\n";

	print FOUT "if (si != count) txt += '$val_txt4a';\n";
	print FOUT "if (si == count) txt += '$val_txt4b';\n"; 
	print FOUT "count++;\n";
	print FOUT "}\n";
	print FOUT "if (mode == 3) {\n";
	print FOUT "   if (mode_line != '$ref_tab_name[$j]') txt += '$val_txt4a';\n";
	print FOUT "   if (mode_line == '$ref_tab_name[$j]') txt += '$val_txt4b';\n";
	print FOUT "}\n";
	print FOUT "if (mode != 0 && mode != 3) {\n";
	print FOUT "txt += '$val_txt4a';\n";
	print FOUT "}\n";
	print FOUT "}\n";
	}
    }

    print FOUT "txt += '$val_txte';\n";

    print FOUT "return txt;\n";

#    return "<b><i>NHT: "+plot.targetId+', Series: '+si+', Point: '+pi+', '+str+"</b></i><br>";
    print FOUT "}\n";


    ###

#    print FOUT "function next_week() {\n";
 #   print FOUT "var monthIndexes = {'Jan':0,'Feb':1,'Mar':2,'Apr':3,'May':4,'Jun':5,'Jul':6,'Aug':7,'Sep':8,'Oct':9,'Nov':10,'Dec':11};\n";
#    print FOUT "var mn=['Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec'];\n";

#    print FOUT "var elem = graph1[pointIndex][0].split(' ');\n";
#    print FOUT "var month_link = monthIndexes[elem[1]];\n";
#    print FOUT "var part1 = elem[2]+'-'+elem[1]+'-'+elem[0];\n";
    
#    print FOUT "var date_link2 = new Date(elem[2],month_link,elem[0]);\n";
#    print FOUT "date_link2.setDate(date_link2.getDate()+6);\n";
    
#    print FOUT "var link_day = date_link2.getDate();\n";
#    print FOUT "if (link_day < 10) link_day = '0'+link_day;\n";
#    print FOUT "return txt;\n";
#    print FOUT "}\n";

    ###
    print FOUT "function editit$chart_id";
    print FOUT "_txt(str, si, pi, plot) {\n";

#    print FOUT "if (typeof(requests) != 'undefined') {\n";

    $val_txt4b = "<b>$L{'Requests'} : '+";
    $val_txt4b .= "requests$chart_id";
    $val_txt4b .= "[pi]+'<\\\/b>";
#    $val_txt4b .= "}\n";

    if ($mail_format == 0 && $ftp_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
#	$val_txt5b = "if (typeof(accesses";
#	$val_txt5b .= "$chart_id) != 'undefined') {\n";
	if ($cups_format == 0) {
	    $val_txt5b = "<b>$L{'Accesses'} : '+";
	    $val_txt5b .= "accesses$chart_id";
	    $val_txt5b .= "[pi]+'<\\\/b>";
	} else {
	    $val_txt5b = "<b>$L{'Files'} : '+";
	    $val_txt5b .= "accesses$chart_id";
	    $val_txt5b .= "[pi]+'<\\\/b>";
	}
#	$val_txt5b .= "}\n";
    }

    if ($mail_format == 1 && $spam_found != 0) {
#	$val_txt6a = "if (typeof(spam";
#	$val_txt6a .= "$chart_id) != 'undefined') {\n";
	$val_txt6a = "<b>$L{'Spam'} : '+";
	$val_txt6a .= "spam$chart_id";
	$val_txt6a .= "[pi]+'<\\\/b>";
#	$val_txt6a .= "}\n";
    }

#    $val_txt7b = "if (typeof(spam";
#    $val_txt7b .= "$chart_id) != 'undefined') {\n";
    $val_txt7b = "<b>$L{'Hosts'} : '+";
    $val_txt7b .= "hosts$chart_id";
    $val_txt7b .= "[pi]+'<\\\/b>";
#    $val_txt7b .= "}\n";

#    print FOUT "if (typeof(requests";
#    print FOUT "$chart_id) != 'undefined') {\n";
    print FOUT "if (si == 0) txt = '$val_txt4b';\n";
    if ($mail_format == 0 && $ftp_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	print FOUT "if (si == 1) txt = '$val_txt5b';\n";
    }
    if ($mail_format == 1 && $spam_found != 0) {
	print FOUT "if (si == 2) txt = '$val_txt6b';\n";
	print FOUT "if (si == 3) txt = '$val_txt7b';\n";
    } else {
	print FOUT "if (si == 2) txt = '$val_txt7b';\n";
    }
    print FOUT "return txt;\n";

    print FOUT "}\n";


    print FOUT "</script>\n";
}


sub MakeGraphJqplotInit {
    local(*FOUT,*L,$I,$conv,$ref1,$ref2,$ref3,$ref4,$ref5,$ref6,$ref7,$ref8) = @_;
    local($i,$val,$found);
    local($nb_idx);

    @tabreq = @$ref1;
    @tabacc = @$ref2;
    @tabmm = @$ref3;
    @tabdoc = @$ref4;
    @tabtrafic = @$ref5;
    @tabuser = @$ref6;
    @tabunique = @$ref7;
    @tabspam = @$ref8;

    print FOUT "\n<script LANGUAGE=\"Javascript\" type=\"text/javascript\">\n";
    
    if ($conv != 1) {
#	print "CONV : $conv\n";
	($unit_div,$unit) = &Return_Unit($conv,1);
#	print "RETURN $unit_div - $unit\n";
    }

    
#    $found = 0;
    print FOUT "request = [";
    for ($i=0;$i<=$#tabreq;$i++) {
	$val = $tabreq[$i];
	$val = 0 if ($val eq '');
#	$found = 1 if ($val ne '');
#	if ($val ne '' && $found == 1) {
	    print FOUT "$val";
	    print FOUT "," if ($i != $#tabreq);
#	}
    }
    print FOUT "];\n";

    if ($mail_format == 0 && $ftp_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
#	$found = 0;
	print FOUT "access = [";
	for ($i=0;$i<=$#tabacc;$i++) {
	    $val = $tabacc[$i];
	    $val = 0 if ($val eq '');
#	    $found = 1 if ($val ne '');
#	    if ($val ne '' && $found == 1) {
		print FOUT "$val";
		print FOUT "," if ($i != $#tabacc);
#	    }
	}
	print FOUT "];\n";
    }

#    $found = 0;
    print FOUT "host = [";
    for ($i=0;$i<=$#tabmm;$i++) {
	$val = $tabmm[$i];
	$val = 0 if ($val eq '');
#	$found = 1 if ($val ne '');
#	if ($val ne '' && $found == 1) {
	    print FOUT "$val";
	    print FOUT "," if ($i != $#tabmm);
#	}
    }
    print FOUT "];\n";

    if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
#	$found = 0;
	print FOUT "document2 = [";
	for ($i=0;$i<=$#tabdoc;$i++) {
	    $val = $tabdoc[$i];
	    $val = 0 if ($val eq '');
#	    $found = 1 if ($val ne '');
#	    if ($val ne '' && $found == 1) {
		print FOUT "$val";
		print FOUT "," if ($i != $#tabdoc);
#	    }
	}
	print FOUT "];\n";
    }

    if ($precision > 2 && $notrafic == 0) {
#	$found = 0;
	print FOUT "trafic = [";
	for ($i=0;$i<=$#tabtrafic;$i++) {
	    $val = int(100*$tabtrafic[$i]/$conv)/100;
	    $val = 0 if ($val eq '');
#	    $found = 1 if ($val ne '');
#	    if ($val ne '' && $found == 1) {
		print FOUT "'$val $unit'";
#		print FOUT "$val";
		print FOUT "," if ($i != $#tabtrafic);
#	    }
	}
	print FOUT "];\n";
    }

    if ($inc_user == 1 && $nb_user != 0) {
#	$found = 0;
	print FOUT "user = [";
	for ($i=0;$i<=$#tabuser;$i++) {
	    $val = $tabuser[$i];
	    $val = 0 if ($val eq '');
#	    $found = 1 if ($val ne '');
#	    if ($val ne '' && $found == 1) {
		print FOUT "$val";
		print FOUT "," if ($i != $#tabuser);
#	    }
	}
	print FOUT "];\n";
    }

    if ($cups_format == 1) {
#	$found = 0;
	print FOUT "pageunique = [";
	for ($i=0;$i<=$#tabunique;$i++) {
	    $val = $tabunique[$i];
	    $val = 0 if ($val eq '');
#	    $found = 1 if ($val ne '');
#	    if ($val ne '' && $found == 1) {
		print FOUT "$val";
		print FOUT "," if ($i != $#tabunique);
#	    }
	}
	print FOUT "];\n";
    }

    if ($mail_format == 1 && $spam_found != 0) {
#	$found = 0;
	print FOUT "spam = [";
	for ($i=0;$i<=$#tabspam;$i++) {
	    $val = $tabspam[$i];
	    $val = 0 if ($val eq '');
#	    $found = 1 if ($val ne '');
#	    if ($val ne '' && $found == 1) {
		print FOUT "$val";
		print FOUT "," if ($i != $#tabspam);
#	    }
	}
	print FOUT "];\n";
    }

    print FOUT "</script>\n";

}

#plot.series[0].canvas._elem.toggle()

sub MakeDailyGraphJqplot {
    local(*FOUT,*L,$I,$mode_date,$ref,$ref_tab,$ref_date,$ref_color,$conv,$unit,$chart_id,$mode,$line_hl,$info,$mode_editit,$labelx,$labely,$xmax,$link) = @_;
    local($i,$j,$k,$val,$val_txt,$nb_idx,$format,$nb_element,$min,$max,$valmax,$count,$count2);
    local(@listdate,@tab_color,@ref_tab_func);
    local($factor,$average,$show_line,$val_min,$val_max,$rms,$sigma);
    local ($tmp,$tmp1,$tmp2,$tmp3,$tmp3a,$tmp3b);

    ### mode_date : 0-Histo 1-daily 2-weekly 3-monthly 4-yearly 5-hourly
    ### mode : 1-stack (2-no info ?) <0-DataClick 3-mode display one line
    ### mode_editit : -1 on utilise le previous editit (un seul init). -2 pas de toggleset

#    print "NN $mode_date - @$ref - @$ref_tab - @$ref_date - @$ref_color - $conv - $unit - $chartd_id - $mode -  $line_hl - $info - $mode_editit - $labelx - $labely - $xmax - $link\n";

# Histo
#https://groups.google.com/forum/?fromgroups#!topic/jqplot-users/QwCulYxUV1w
#http://techslides.com/demos/jqplot-histogram.html

    $max_item_display = 1000;

#    $fontsize = "1.20em";
#    $fontsize = "0.70em" if ($xmax == $xmax_home_jqplot);
    $link =~ s/$htmlext//;

    @tab_color = @$ref_color;
    @listdate = @$ref_date;


    if ($conv != 1) {
	$format = "%.2f";
	$factor = 100;
    } else {
	$format = "%d";
	$factor = 10;
    }

    @tab_graph = @$ref;
    $nb_idx = scalar(@tab_graph);

    @ref_tab_func = @$ref_tab;


    for ($i=0;$i<=$#ref_tab_func;$i++) {
	$val = "tab".$i;
	@$val = @{$ref_tab_func[$i]};
    }

    $count2 = 0;
    $show_line = 1 if ($xmax != $xmax_home_jqplot && $nb_idx == 1 && scalar(@tab0) > 1);

    ### Average/Sigma/RMS
    $val_tot = 0;
    $val_min = $tab0[0];
    $val_max = 0;
    for ($i=0;$i<=$#tab0;$i++) {
	$val_tot += $tab0[$i];
	if ($tab0[$i] > $val_max) {
	    $val_max = int($factor*$tab0[$i])/$factor;
	} 
	if ($tab0[$i] < $val_min || $val_min eq '') {
	    $val_min = int($factor*$tab0[$i])/$factor;
	} 
    }
    $val_max = int($factor*$val_max/$conv)/$factor;
    $val_min = int($factor*$val_min/$conv)/$factor;

    $tmp = $conv*scalar(@tab0);
    $average = 0;
    $average = int($factor*$val_tot/$tmp)/$factor if ($tmp != 0);

    $sigma = 0;
    for ($i=0;$i<=$#tab0;$i++) {
	$sigma += (($tab0[$i]/$conv)-$average)**2;
    }
    $sigma = int($factor*sqrt($sigma/scalar(@tab0)))/$factor if ($#tab0 != -1);

    $rms = 0;
    $rms = int($factor*sqrt(($average**2)+($sigma**2)))/$factor;

    ### Get 95% from input histogram data
    if ($mode_date == 0) {
	# @listdate and @tab0 should have same number of items
#	print "AA $#tab0 - $#listdate - @listdate - @tab0\n";
#	$val_tot = 0;
	# To skip hourly histo
	if ($#tab0 > 24 && $#tab0 <= $#listdate) {

#	    if ($val_tot != 0) {
#		for ($i=0;$i<=$#tab0;$i++) {
#		    $val_tot += $tab0[$i];
#		}
#	    }

	    if ($val_tot != 0) {
		$tmp = 0;
		for ($i=0;$i<=$#tab0;$i++) {
		    $tmp += (100*$tab0[$i])/$val_tot;	    
		    if ($tmp > 99 || $i > $max_item_display) {
			pop(@listdate);
		    }
		    
		}		
	    }
	}
 #   print "RR $val_tot - @listdate - $#listdate - $listdate[$#listdate] - @tab0\n";
    }


    @list_graph_name_jqplot = ("graphline","barchart","graphlinefill");
    if (scalar(@listdate) < 2 || $mode_date == 0) {
	@list_graph_name_jqplot = ("barchart");
    }

    $nb_element = 1;
#    $count = 1;
    $count = $chart_id;
#    $count2 = 0;
    $valmax = 0;

    $nb_pt = scalar(@listdate);

    if ($show_line == 1) {
	print FOUT "<INPUT type=\"text\" style=\"display:none\" id=\"min$chart_id\" VALUE=\"$val_min\">\n";
	print FOUT "<INPUT type=\"text\" style=\"display:none\" id=\"max$chart_id\" VALUE=\"$val_max\">\n";
	print FOUT "<INPUT type=\"text\" style=\"display:none\" id=\"average$chart_id\" VALUE=\"$average\">\n";
	print FOUT "<INPUT type=\"text\" style=\"display:none\" id=\"sigma$chart_id\" VALUE=\"$sigma\">\n";
	print FOUT "<INPUT type=\"text\" style=\"display:none\" id=\"rms$chart_id\" VALUE=\"$rms\">\n";
	print FOUT "<INPUT type=\"text\" style=\"display:none\" id=\"infoid$chart_id\" VALUE=\"$info\">\n";
    }

    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\">\n";
#		  print FOUT2 "$L{'No enough data to compute graph'}";
    if ($show_line == 1) {
#	for ($i=$chart_id;$i<=($chart_id+$#list_graph_name_jqplot);$i++) {
	    print FOUT "function line_avg(i,j) {\n";
	    print FOUT "var plotnb = 'plot'+i;\n";
	    print FOUT "i = i-j;\n";
#	    print FOUT "var linename = 'infoid$chart_id';\n";
	    print FOUT "var linename = 'infoid'+i;\n";
	    print FOUT "var infoname = document.getElementById(linename).value;\n";
	    print FOUT "var co = eval(plotnb).plugins.canvasOverlay;\n";
#	    print FOUT "var linename = 'average$chart_id';\n";
	    print FOUT "var linename = 'average'+i;\n";
	    print FOUT "var val = document.getElementById(linename).value;\n";
	    print FOUT "var line = co.get(linename);\n";
	    print FOUT "var found = 0;\n";
	    print FOUT "if (line.options.y == -10) {\n";
	    print FOUT "  found = 1;\n";
	    print FOUT "  line.options.y = val;\n";
	    print FOUT "  \$('#'+infoname).html('$L{'Average'} : '+val);\n";
	    print FOUT "}\n";
	    print FOUT "if (found == 0 && line.options.y == val) {\n";
	    print FOUT "  line.options.y = -10;\n";
	    print FOUT "  \$('#'+infoname).html('&nbsp;');\n";
	    print FOUT "}\n";
	    print FOUT "co.draw(eval(plotnb));\n";
	    print FOUT "}\n";

	    print FOUT "function line_min(i,j) {\n";
	    print FOUT "var plotnb = 'plot'+i;\n";
	    print FOUT "i = i-j;\n";
#	    print FOUT "var linename = 'infoid$chart_id';\n";
	    print FOUT "var linename = 'infoid'+i;\n";
	    print FOUT "var infoname = document.getElementById(linename).value;\n";
	    print FOUT "var co = eval(plotnb).plugins.canvasOverlay;\n";
#	    print FOUT "var linename = 'min$chart_id';\n";
	    print FOUT "var linename = 'min'+i;\n";
	    print FOUT "var val = document.getElementById(linename).value;\n";
	    print FOUT "var line = co.get(linename);\n";
	    print FOUT "var found = 0;\n";
	    print FOUT "if (line.options.y == -10) {\n";
	    print FOUT "  found = 1;\n";
	    print FOUT "  line.options.y = val;\n";
	    print FOUT "  \$('#'+infoname).html('$L{'Minimum'} : '+val);\n";
	    print FOUT "}\n";
	    print FOUT "if (found == 0 && line.options.y == val) {\n";
	    print FOUT "  line.options.y = -10;\n";
	    print FOUT "  \$('#'+infoname).html('&nbsp;');\n";
	    print FOUT "}\n";
	    print FOUT "co.draw(eval(plotnb));\n";
	    print FOUT "}\n";

	    print FOUT "function line_max(i,j) {\n";
	    print FOUT "var plotnb = 'plot'+i;\n";
	    print FOUT "i = i-j;\n";
#	    print FOUT "var linename = 'infoid$chart_id';\n";
	    print FOUT "var linename = 'infoid'+i;\n";
	    print FOUT "var infoname = document.getElementById(linename).value;\n";
	    print FOUT "var co = eval(plotnb).plugins.canvasOverlay;\n";
#	    print FOUT "var linename = 'max$chart_id';\n";
	    print FOUT "var linename = 'max'+i;\n";
	    print FOUT "var val = document.getElementById(linename).value;\n";
	    print FOUT "var line = co.get(linename);\n";
	    print FOUT "var found = 0;\n";
	    print FOUT "if (line.options.y == -10) {\n";
	    print FOUT "  found = 1;\n";
	    print FOUT "  line.options.y = val;\n";
	    print FOUT "  \$('#'+infoname).html('$L{'Maximum'} : '+val);\n";
	    print FOUT "}\n";
	    print FOUT "if (found == 0 && line.options.y == val) {\n";
	    print FOUT "  line.options.y = -10;\n";	    
	    print FOUT "  \$('#'+infoname).html('&nbsp;');\n";
	    print FOUT "}\n";
	    print FOUT "co.draw(eval(plotnb));\n";
	    print FOUT "}\n";

	    print FOUT "function line_sigma(i,j) {\n";
	    print FOUT "var tmp = '';\n";
	    print FOUT "var plotnb = 'plot'+i;\n";
	    print FOUT "i = i-j;\n";
#	    print FOUT "var linename = 'infoid$chart_id';\n";
	    print FOUT "var linename = 'infoid'+i;\n";
	    print FOUT "var infoname = document.getElementById(linename).value;\n";
	    print FOUT "var co = eval(plotnb).plugins.canvasOverlay;\n";

#	    print FOUT "var linename = 'average$chart_id';\n";
	    print FOUT "var linename = 'average'+i;\n";
	    print FOUT "var avg = document.getElementById(linename).value;\n";
#	    print FOUT "var linename = 'sigma$chart_id';\n";
	    print FOUT "var linename = 'sigma'+i;\n";
	    print FOUT "var val = document.getElementById(linename).value;\n";

#	    print FOUT "var linename = 'sigma1$chart_id';\n";
	    print FOUT "var linename = 'sigma1'+i;\n";
	    print FOUT "var line = co.get(linename);\n";
#	    print FOUT "var linename = 'sigma2$chart_id';\n";
	    print FOUT "var linename = 'sigma2'+i;\n";
	    print FOUT "var line2 = co.get(linename);\n";

	    print FOUT "var found = 0;\n";
	    print FOUT "tmp = parseFloat(avg)+parseFloat(val);\n";
	    print FOUT "if (line.options.y == -10) {\n";
	    print FOUT "  found = 1;\n";
#	    $tmp = $average+$sigma;
	    print FOUT "  line.options.y = tmp;\n";
#	    $tmp = $average-$sigma;
	    print FOUT "  tmp = parseFloat(avg)-parseFloat(val);\n";
	    print FOUT "  line2.options.y = tmp\n";
	    print FOUT "  \$('#'+infoname).html('Sigma : '+val);\n";
	    print FOUT "}\n";
	    print FOUT "if (found == 0 && line.options.y == tmp) {\n";
	    print FOUT "  line.options.y = -10;\n";
	    print FOUT "  line2.options.y = -10;\n";	    
	    print FOUT "  \$('#'+infoname).html('&nbsp;');\n";
	    print FOUT "}\n";
	    print FOUT "co.draw(eval(plotnb));\n";
	    print FOUT "}\n";

	    print FOUT "function line_rms(i,j) {\n";
	    print FOUT "var plotnb = 'plot'+i;\n";
	    print FOUT "i = i-j;\n";
#	    print FOUT "var linename = 'infoid$chart_id';\n";
	    print FOUT "var linename = 'infoid'+i;\n";
	    print FOUT "var infoname = document.getElementById(linename).value;\n";
	    print FOUT "var co = eval(plotnb).plugins.canvasOverlay;\n";
#	    print FOUT "var linename = 'rms$chart_id';\n";
	    print FOUT "var linename = 'rms'+i;\n";
	    print FOUT "var val = document.getElementById(linename).value;\n";
	    print FOUT "var line = co.get(linename);\n";
#	    print FOUT "var line = co.get('rms1');\n";
#	    print FOUT "var line2 = co.get('rms2');\n";
	    print FOUT "var found = 0;\n";
	    print FOUT "if (line.options.y == -10) {\n";
	    print FOUT "  found = 1;\n";
	    $tmp = $rms;
#	    $tmp = $average+$rms;
	    print FOUT "  line.options.y = val;\n";
#	    $tmp = $average-$rms;
#	    print FOUT "  line2.options.y = $tmp;\n";
	    print FOUT "  \$('#'+infoname).html('RMS : '+val);\n";
	    print FOUT "}\n";
#	    print FOUT "if (found == 0 && line2.options.y == $tmp) {\n";
	    print FOUT "if (found == 0 && line.options.y == val) {\n";
	    print FOUT "  line.options.y = -10;\n";
#	    print FOUT "  line2.options.y = -10;\n";
	    print FOUT "  \$('#'+infoname).html('&nbsp;');\n";
	    print FOUT "}\n";
	    print FOUT "co.draw(eval(plotnb));\n";
	    print FOUT "}\n";

#	}
    }

    for ($i=$chart_id;$i<=($chart_id+$#list_graph_name_jqplot);$i++) {
	print FOUT "var plot$i;\n";
    }

    # grid
    if ($show_line == 1) {
	print FOUT "var grid = {\n";
	print FOUT "  gridLineWidth: 1,\n";
	print FOUT "  gridLineColor: 'rgb(235,235,235)',\n";
	print FOUT "  drawGridlines: true\n";
	print FOUT "};\n";
    }


    print FOUT "\n\$(document).ready(function(){\n";

    $data_extended = 0;

    for ($j=1;$j<=$nb_idx;$j++) {

	$tmp_file = "tab$count2";
#	print "UU $count2 - $j - $tmp_file - @$tmp_file $tmp_file $$tmp_file[0]\n";
#	if ($$tmp_file[0] ne '' && $$tmp_file[1] ne '') {
	if ($$tmp_file[0] ne '') {
	    if ($#{$$tmp_file[0]} == -1) {
		$nb_element = $#$tmp_file+1;
		if ($#listdate < $#$tmp_file) {
		    $nb_element = $#listdate+1;
#		    $data_extended = 1;
#		    print "A2 $#listdate - $#$tmp_file\n";
		}
		print FOUT "var graph$count = ";
#		print "var graph$count = ";
		$som[$count] = 0;
		print FOUT "[";
		for ($i=0;$i<=$#$tmp_file;$i++) {
		    $tmp = $listdate[$i];
		    if ($mode_date != 0) {
			$tmp = &date_intervalle($tmp_prev,1) if ($tmp eq '');
			$tmp_prev = $tmp if ($tmp ne '');
		    } else {
			$tmp = $listdate[$i];
		    }
		    $val = $$tmp_file[$i];
		    $val = 0 if ($val eq '');
		    $som[$count] += $val;
		    $val = int(100*$val/$conv)/100;
		    $valmax = $val if ($val > $valmax);
#		    print "AA $tmp\n";
#		    $tmp = &date_intervalle($start_date,$i);
		    print FOUT "['$tmp'," if ($mode_date != 0 || $data_extended == 1);
		    print FOUT "$val";
		    print FOUT "]" if ($mode_date != 0 || $data_extended == 1);
#		    print FOUT "," if ($i != ($#$tmp_file));
		    print FOUT "," if ($i != ($#$tmp_file) && $i != ($#listdate));
		    last if ($i == $#listdate); # skip if no date have been set
		}
		print FOUT "];\n";
		$count++;
	    } else {
		# Multi-dim
		for ($k=0;$k<=$#{$$tmp_file[0]};$k++) {
		    print FOUT "var graph$count = ";
		    $som[$count] = 0;
		    print FOUT "[";
		    for ($i=0;$i<=$#$tmp_file;$i++) {
			$nb_element = $#$tmp_file+1;
			$nb_element = $#listdate+1 if ($#listdate < $#$tmp_file);
			$tmp = $listdate[$i];
			if ($mode_date != 0) {
			    $tmp = &date_intervalle($tmp_prev,1) if ($tmp eq '');
			    $tmp_prev = $tmp if ($tmp ne '');
			}
#			$val = @$tmp_file->[$i][$k];
			$val = $$tmp_file[$i][$k];
			$val = 0 if ($val eq '');
			$som[$count] += $val;
			$val = int(100*$val/$conv)/100;
			$valmax = $val if ($val > $valmax);
#			$tmp = &date_intervalle($start_date,$i);
#			$tmp = $listdate[$i];
			print FOUT "['$tmp',";
			print FOUT "$val]";
#			print FOUT "," if ($i != ($#$tmp_file));
			print FOUT "," if ($i != ($#$tmp_file) && $i != ($#listdate));
			last if ($i == $#listdate); # skip if no date have been set
		    }
		    print FOUT "];\n";
		    $j++ if ($k != 0);
		    $count++;
		}
		# End multi-dim
	    }
	} else {
#	    print FOUT "var graph$count = [];\n";
	    $som[$count] = 0;
	    $count++;
	}
	$count2++;
    }


#    print "LL $nb_pt - @listdate\n";

    $chart_id_plus = $chart_id+$#list_graph_name_jqplot;
#    for ($i=$chart_id;$i<=($chart_id+$#list_graph_name_jqplot);$i++) {
    for ($i=$chart_id;$i<=$chart_id_plus;$i++) {

	if ($nb_pt > 1 && $mode_date != 0) {
	    $barchart = 0;
	    $fill = 0;
	    $barchart = 1 if (($i-$chart_id) == 1);
	    $fill = 1 if (($i-$chart_id) == 2);
	} else {
	    $barchart = 1;
	}

	if ($#listdate != -1) {
	    if ($mode_date != 0 && $mode_date != 5) {
		$min = $listdate[0];
		($tmp1,$tmp2,$tmp3a) = split(/ /,$min);
		$max = $listdate[$#listdate];
		($tmp1,$tmp2,$tmp3b) = split(/ /,$max);
		
		$same_year = 0;
		$same_year = 1 if ($tmp3a == $tmp3b);

		if ($fill == 0) {
		    $min = &date_intervalle($listdate[0],-1);
		    $max = &date_intervalle($listdate[$#listdate],1);
		}
#	    print "YY $min - $max\n";
		$min = &nb_sec_deb($min)*1000;
		$max = &nb_sec_deb($max)*1000;
#	    print "YY2 $min - $max\n";
	    } else {
		$min = $listdate[0];
		$max = $listdate[$#listdate];
	    }
	}


#	    print "YY3 $min - $max\n";
	print FOUT "\n\n// /////////////////// Plot $i\n";
	print FOUT "plot$i = \$.jqplot (";
	print FOUT "'chart$i'";
	print FOUT ", [";

#	for ($j=$nb_idx;$j>=1;$j--) {
	$last_idx_som = '';
	$first_idx_som = '';
	for ($j=($chart_id+$nb_idx-1);$j>=$chart_id;$j--) {
#	    if ($som[$j] != 0) {
	    if ($som[$j] == 0 && $first_idx_som eq '') {
		$first_idx_som = $j;
	    }
	    if ($som[$j] != 0 && $last_idx_som eq '') {
		$last_idx_som = $j;
#		last;
	    } 
	}

	$graph_nb_found = 0;
#	for ($j=1;$j<=$nb_idx;$j++) {
	for ($j=$chart_id;$j<($chart_id+$nb_idx);$j++) {
#	    print "GR $j - $som[$j]\n";
	    if ($som[$j] != 0) {
		$tmp = $j+1;
		$graph_nb_found++; 
		print FOUT "graph$j";
		print FOUT "," if ($j != ($chart_id+$nb_idx-1) && $j != $last_idx_som);
	    }
	}
	print FOUT "], {\n";

	print FOUT "seriesColors: [";
#	for ($k=0;$k<$#tab_color;$k++) {
#	for ($k=1;$k<=$nb_idx;$k++) {
	for ($k=$chart_id;$k<($chart_id+$nb_idx);$k++) {
#	    $k2 = $k+1;
#	    $k2 = $k-1;
	    $k2 = $k-$chart_id;
	    if ($som[$k] != 0) {
		print FOUT "'$tab_color[$k2]'"; 
#	    print FOUT "," if ($k != $nb_idx && ($som[$k+1] != 0 && $k <= $nb_idx));
		print FOUT "," if ($k != ($chart_id+$nb_idx-1) && $k != $last_idx_som);
	    }
#	    print "$k - $k2 - $tab_color[$k] - $#tab_color\n";
	}
	print FOUT "],\n";
	print FOUT "stackSeries: true,\n" if ($mode == 1);
	print FOUT "seriesDefaults: {\n";
	if ($nb_pt < 10) {
	    if ($mode == 1) {
		print FOUT "pointLabels: { show:true, stackedValue: true},\n";
	    } else {
		print FOUT "pointLabels: { show:true },\n";
	    }
	}
	if  ($barchart == 1) {
	    print FOUT "renderer: \$.jqplot.BarRenderer,\n";
	    print FOUT "rendererOptions:{\n";
#	    $tmp2 = $nbdays;
	    $tmp2 = $nb_element+1;
	    $tmp2 += 2; # if ($mode_date == 2 || $mode_date == 3 || $mode_date == 4);
#	    $tmp2 = $tmp2*$nb_idx if ($mode == 0);
	    $tmp2 = $tmp2*$graph_nb_found if ($graph_nb_found != 0 && $mode != 1);

#	  @graph_to_display = ('Users');
	    if ($graph_nb_found == 0 && $xmax != $xmax_home_jqplot) {
		if ($#$tmp_file == -1) {
		    print "ERROR : Graph array is empty\n";
		    print "DEBUG : Script $scriptname : Graph : @tab_graph - GraphName : $graph_to_display[0] - ChartId : $chart_id - Mode : $mode\n";
		    exit;
		} elsif ($$tmp_file[0] eq '') {
		    print "ERROR : First graph value is null\n";
		    print "DEBUG : Script : $scriptname : Graph : @tab_graph - GraphName : $graph_to_display[0] - ChartId : $chart_id - Mode : $mode\n";
		    exit;
		} else {
#		    print "TOTO $graph_nb_found\n";
#		    print "WARNING : $tab_graph[0] - Graph \'$ref_tab_name[0]\' with empty values (ChartId : $chart_id - Mode : $mode)\n";
		    print "WARNING : $first_idx_som - $tab_graph[$first_idx_som] - Graph \'$graph_to_display[0]\' with empty values (ChartId : $chart_id - Mode : $mode)\n";
		}
	    }

#	length = graph1.length;
# var insidewidth = plot0.grid._width;  
#     var colwidth = insidewidth / length;  
#	print FOUT "barWidth: getColumnLocation(plot,gridpos,graph1.length),\n";
#	    $aa = $xmax-($xmax/10);
	    $tmp = int(($xmax-($xmax/5))/$tmp2);  ######## Faux retrouve le nombre de bar affiche !!!!!!!!!!!!!!
#	    $tmp = int($xmax/$tmp2);  ######## Faux retrouve le nombre de bar affiche !!!!!!!!!!!!!!
#	    print "UU $tmp = $xmax - $aa - $tmp2 - $nb_element\n";
	    $tmp = 1 if ($tmp == 0);
	    print FOUT "barWidth: $tmp,\n";
	    print FOUT "barPadding: 1,\n";
	    print FOUT "fillToZero: true,\n";
	    print FOUT "barMargin: 0\n";
	    print FOUT "},\n";
	}
	if ($fill == 1) {
	    print FOUT "fill: true,\n";
	}
	print FOUT "lineWidth: 1\n";
	print FOUT "},\n";


## jsfiddle.net/wN2SA/12/

	print FOUT "series: [\n";
#	for ($k=1;$k<=$nb_idx;$k++) {
	for ($k=$chart_id;$k<($chart_id+$nb_idx);$k++) {
#	    $k2 = $k-1;
	    $k2 = $k-$chart_id;
	    if ($som[$k] != 0) {
		print FOUT "{\n";
		print FOUT "label: '$tab_graph[$k2]',\n";
#	    print FOUT "show: false,\n" if ($som[$j] == 0);
		print FOUT "markerOptions: { style: 'circle', size: 2 }\n" if ($barchart == 0);
		print FOUT "markerOptions: { style: 'circle', size: 0 }\n" if ($barchart == 1);
		print FOUT "}\n";
	    }
	    print FOUT ",\n" if ($k != ($chart_id+$nb_idx-1) && $som[$k] != 0);
	}
	
	print FOUT "],\n";

	
	print FOUT "axesDefaults: {\n";
	print FOUT "labelRenderer: \$.jqplot.CanvasAxisLabelRenderer,\n";
	print FOUT "tickRenderer: \$.jqplot.CanvasAxisTickRenderer\n";
	print FOUT "},\n";

	print FOUT "axes: {\n";
	print FOUT "xaxis: {\n";
	print FOUT "renderer: \$.jqplot.DateAxisRenderer,\n"  if ($mode_date != 0 && $mode_date != 5);
#	print FOUT "renderer: \$.jqplot.CanvasAxisRenderer,\n"  if ($mode_date == 0 || $mode_date == 5);
	if ($mode_date == 0 || $mode_date == 5) {
#	    if ($data_extended == 1) {
	    if ($listdate[0] =~ /\d+/) {
		print FOUT "renderer: \$.jqplot.CanvasAxisRenderer,\n";
	    } else {
		print FOUT "renderer: \$.jqplot.CategoryAxisRenderer,\n";
	    }
	}




	$tmp2 = $nb_pt-1 if ($mode_date == 0); # Histo avec 1 seul point (-2 si 100%)
	$tmp2 = $nb_pt-1 if ($mode_date != 0);
#	print "AA @listdate - $listdate[0] - $listdate[$#listdate]\n";
#	if ($barchart == 1 && ($mode_date == 2 || $mode_date == 3 || $mode_date == 4)) {
	if ($graph_nb_found != 0) {
	    if ($barchart == 1 && $mode != 1) {
		$step_ticks = 1;
		$step_ticks = int($nb_element/10) if ($nb_element > 10);
		print FOUT "ticks: [";
		if ($mode_date != 0 && $mode_date != 5) {
		    ($val1,$val2,$val3) = split(/\s/,$listdate[0]);
		    if ($mode_date == 1) {
			$tmp = &date_intervalle($listdate[0],-1);
		    }
		    if ($mode_date == 2) {
			$tmp = &date_intervalle($listdate[0],-7);
		    }
		    if ($mode_date == 3) {
			$val2 = $month_nb[$month_equiv{$val2}-2];
			$val3-- if ($val2 eq "Dec");
			$tmp = $val1." ".$val2." ".$val3;
		    }
		    if ($mode_date == 4) {
			$val3--;
			$tmp = $val1." ".$val2." ".$val3;
		    }
		}
		print FOUT "'$tmp'," if ($mode_date != 0 && $mode_date != 5);
#		print "AA $tmp2 - $step_ticks\n";
#		for ($k=0;$k<=$tmp2;$k+=$step_ticks) {
		# $tmp2-1 : Nbre de points a partir de 0
		for ($k=0;$k<=$tmp2;$k+=$step_ticks) {
		    $val = $listdate[$k];
#		    print "LL - $k - $val\n";
		    if ($mode_date != 0 && $mode_date != 5) {
			$val = &date_intervalle($val_prev,$step_ticks) if ($val eq '');
			$val_prev = $val if ($val ne '');
		    }
		    if ($val ne '') {
			$tmp3 = $k+$step_ticks;
			print FOUT "'$val'";
#			print FOUT "," if ($mode_date != 0 || ($mode_date == 0 && $k < $listdate[$#listdate]));
			print FOUT "," if ($mode_date != 0 && $mode_date != 5);
#			print FOUT "," if (($mode_date == 0 || $mode_date == 5) && (($k+$step_ticks) < $listdate[$#listdate]));
#			print FOUT "," if (($mode_date == 0 && $k != $tmp2) || ($mode_date == 5 && (($k+$step_ticks) < $listdate[$#listdate])));
			print FOUT "," if (($mode_date == 0 && $k != $tmp2) || ($mode_date == 5 && (($k+$step_ticks) <= $listdate[$#listdate])));
#			print "($k $step_ticks - $val - $listdate[$#listdate],\n" if (($mode_date == 0 || $mode_date == 5) && (($k+$step_ticks) < $listdate[$#listdate]));
		    }
		}
#		if ($mode_date != 0 && $mode_date != 5) {
#		if ($mode_date != 5) {
		    ($val1,$val2,$val3) = split(/\s/,$listdate[$#listdate]);
		    if ($mode_date == 0) {
			# 6 for day of week
			$tmp = $listdate[$#listdate] if ($tmp2 >= 6);
			$tmp = $listdate[$#listdate]+1 if ($tmp2 < 6);
		    }
		    if ($mode_date == 1) {
			$tmp = &date_intervalle($listdate[$#listdate],1);
		    }
		    if ($mode_date == 2) {
			$tmp = &date_intervalle($listdate[$#listdate],7);
		    }
		    if ($mode_date == 3) {
			$tmp = $month_of_year{$val2};
			$tmp = &date_intervalle($listdate[$#listdate],$tmp);
		    }
		    if ($mode_date == 4) {
			$val3++;
			$tmp = $val1." ".$val2." ".$val3;
		    }
#		} else {
#		    print "II $mode_date - $k - $step_ticks - $listdate[$#listdate]\n";
#		    print FOUT "," if ($listdate[$#listdate] != 24);
#		}
#		print FOUT "'$tmp'" if (($mode_date == 0 || $mode_date == 5) && ($k < $listdate[$#listdate]));
		print FOUT "'$tmp'" if ($mode_date != 0 && $mode_date != 5);
#		print FOUT "'$tmp'" if ($mode_date != 5 && $listdate[$#listdate] =~ /\d+/);
#		print FOUT "'$tmp'" if ($mode_date != 5 && $k != $tmp2);
		print FOUT "],\n";
		$tmp2 += 2;
	    }
	}
	$tmp2++ if ($mode_date != 0);
	$tmp2 += 2 if ($mode_date == 0);
	$tmp2 = 10 if ($tmp2 > 10);
	$tmp2 = 24 if ($mode_date == 5);
	print FOUT "numberTicks: $tmp2,\n";
	print FOUT "drawMajorGridlines: false,\n";
	print FOUT "rendererOptions: { tickRenderer: \$.jqplot.CanvasAxisTickRenderer },\n";
	if ($max > $min) {
#	$tmp = &date_intervalle($start_date,-1);
	    print FOUT "min: $min,\n";
#	$tmp = &date_intervalle($yesterday,1);
	    print FOUT "max: $max,\n";
	}
	print FOUT "label: \"".$labelx."\",\n" if ($labelx ne '');
	print FOUT "labelRenderer: \$.jqplot.CanvasAxisLabelRenderer,\n";
	print FOUT "labelOptions: {\n";
#	print FOUT "fontSize: '".$fontsize."',\n";
	print FOUT "fontFamily: 'Arial, Verdana, Helvetica',\n";
#	print FOUT "fontWeight: 'bold',\n";
	print FOUT "textColor: '#000000'";
	print FOUT "},\n";
	
	# test si listdate[0] et listdate[$#listdate] is same year : if not show %Y
	print FOUT "tickOptions: {\n";
	if ($mode_date == 0) {
	    print FOUT "formatString: '%d',\n";
	}
	if ($mode_date == 1) {
	    print FOUT "formatString: '%Y-%b-%d',\n" if ($same_year == 0);
	    print FOUT "formatString: '%b-%d',\n" if ($same_year == 1);
	}
	if ($mode_date == 2) {
	    print FOUT "formatString: '%Y-%b-%d',\n" if ($same_year == 0);
	    print FOUT "formatString: '%b-%d',\n" if ($same_year == 1);
	}
	if ($mode_date == 5) {
	    print FOUT "formatString: '%d',\n";
	}
	print FOUT "formatString: '%Y-%b',\n" if ($mode_date == 3);
	print FOUT "formatString: '%Y',\n" if ($mode_date == 4);
####	print FOUT "fontSize: '".$fontsize."',\n";
	print FOUT "textColor: '#0070A3',\n";
	print FOUT "fontFamily: 'Arial, Verdana, Helvetica',\n";
#	print FOUT "fontWeight: 'bold',\n";
	print FOUT "angle: -30\n";
	print FOUT "}\n";
	print FOUT "},\n";

	print FOUT "yaxis: {\n";
	print FOUT "label: \"".$labely."\",\n" if ($labely ne '');
	print FOUT "rendererOptions: { tickRenderer: \$.jqplot.CanvasAxisTickRenderer },\n";
	print FOUT "labelOptions: {\n";
#	print FOUT "fontSize: '".$fontsize."',\n";
#	print FOUT "fontWeight: 'bold',\n";
	print FOUT "fontFamily: 'Arial, Verdana, Helvetica',\n";
	print FOUT "textColor: '#000000'";
	print FOUT "},\n";
        print FOUT "tickInterval: 1,\n" if ($valmax < 10 && $conv == 1); # size
	print FOUT "tickOptions: {\n";
	print FOUT "formatString: '%d',\n" if ($conv == 1);
######	print FOUT "fontSize: '".$fontsize."',\n";
	print FOUT "fontFamily: 'Arial, Verdana, Helvetica',\n";
#	print FOUT "fontFamily: \"Trebuchet MS\", Arial, Helvetica, sans-serif,\n";
#	print FOUT "fontWeight: 'bold',\n";
	print FOUT "textColor: '#0070A3'\n";
	print FOUT "},\n";
	print FOUT "min: 0,\n";
	print FOUT "pad: 1.2\n";
	print FOUT "}\n";
	print FOUT "},\n";

	if ($show_line == 1) {
	print FOUT "grid: grid,\n";
	print FOUT "   canvasOverlay: {\n";
	print FOUT " show: true,\n";
	print FOUT " objects: [\n";
	print FOUT "   {horizontalLine: {\n";
	print FOUT "        name: 'average$chart_id',\n";
	print FOUT "        y: -10,\n";
	print FOUT "        lineWidth: 2,\n";
	print FOUT "        color: 'rgb(100,55,100)',\n";
	print FOUT "        shadow: false\n";
	print FOUT "        }},\n";
	print FOUT "   {horizontalLine: {\n";
	print FOUT "        name: 'min$chart_id',\n";
	print FOUT "        y: -10,\n";
	print FOUT "        lineWidth: 2,\n";
	print FOUT "        color: 'rgb(100,55,100)',\n";
	print FOUT "        shadow: false\n";
	print FOUT "        }},\n";
	print FOUT "   {horizontalLine: {\n";
	print FOUT "        name: 'max$chart_id',\n";
	print FOUT "        y: -10,\n";
	print FOUT "        lineWidth: 2,\n";
	print FOUT "        color: 'rgb(100,55,100)',\n";
	print FOUT "        shadow: false\n";
	print FOUT "        }},\n";
	print FOUT "   {horizontalLine: {\n";
	print FOUT "        name: 'rms$chart_id',\n";
	print FOUT "        y: -10,\n";
	print FOUT "        lineWidth: 2,\n";
	print FOUT "        color: '#0DC58B',\n";
	print FOUT "        shadow: false\n";
	print FOUT "        }},\n";
#	print FOUT "   {horizontalLine: {\n";
#	print FOUT "        name: 'rms2',\n";
#	print FOUT "        y: -10,\n";
#	print FOUT "        lineWidth: 2,\n";
#	print FOUT "        color: '#0DC58B',\n";
#	print FOUT "        shadow: false\n";
#	print FOUT "        }},\n";
	print FOUT "   {dashedHorizontalLine: {\n";
	print FOUT "        name: 'sigma1$chart_id',\n";
	print FOUT "        y: -10,\n";
	print FOUT "        lineWidth: 2,\n";
	print FOUT "        color: '#2B0DC5',\n";
	print FOUT "        shadow: false\n";
	print FOUT "        }},\n";
	print FOUT "   {dashedHorizontalLine: {\n";
	print FOUT "        name: 'sigma2$chart_id',\n";
	print FOUT "        y: -10,\n";
	print FOUT "        lineWidth: 2,\n";
	print FOUT "        color: '#2B0DC5',\n";
	print FOUT "        shadow: false\n";
	print FOUT "        }\n";
	print FOUT "}\n";
	print FOUT "]},\n";
	}

	if ($nb_pt > 10 && $xmax != $xmax_home_jqplot) {
	    print FOUT "cursor: {\n";
	    print FOUT "show: true,\n";
	    print FOUT "zoom: true,\n";
	    print FOUT "showTooltip: false\n";
	    print FOUT "},\n";
	}
	if ($nb_idx > 1) {
	    $tmp = int($nb_idx/5);
	    $tmp = 1 if ($tmp == 0);
	    print FOUT "legend: {\n";
	    print FOUT "renderer: \$.jqplot.EnhancedLegendRenderer,\n";
	    print FOUT "rendererOptions: {\n";
	    print FOUT "numberRows: $tmp,\n";
	    print FOUT "seriesToggle : 'normal'\n";
	    print FOUT "},\n";
	    print FOUT "show: true,\n";
	    print FOUT "placement: 'outsideGrid',\n";
	    print FOUT "location: 's'\n";
	    print FOUT "},\n";
	}

	print FOUT "highlighter: {\n";
	print FOUT "showTooltip: true,\n";
	print FOUT "useAxesFormatters: false,\n";
	print FOUT "show: true,\n";
#	print FOUT "tooltipContentEditor: editit(ev, seriesIndex, pointIndex, data, $mode),\n";
#	print FOUT "tooltipContentEditor: editit(ev, seriesIndex, pointIndex, data),\n";
#	if ($mode_editit == -1) {
#	    print FOUT "tooltipContentEditor: editit0,\n";
#	} else {
#	    print FOUT "tooltipContentEditor: editit$chart_id,\n";
#	}
	if ($mode_editit >= 0) {
	    print FOUT "tooltipContentEditor: editit$mode_editit,\n";
	}
	print FOUT "sizeAdjust: 0\n";
	print FOUT "}\n";


	print FOUT "});\n";

#	var legendTable = $($('.jqplot-table-legend')[0]);    
#    legendTable.css('display','block');
#    legendTable.css('z-index',100);
#    legendTable.css('height','100px');
#    legendTable.css('overflow-y','scroll');

#	  $checklink = $path.$lang[$nblang].$dirsepurl.$dirdate.$dirsepurl.$tmp.$dirsepurl;
#	  $checklink .= $menu if ($link eq '');
#	  $checklink .= $link.$htmlext if ($link ne '');

#	  $linkjour = "<!-- langhome -->".$dirsepurl.$dirdate.$dirsepurl.$tmp.$dirsepurl if ($fontsize == 0);
#	  $linkjour = "..".$dirsepurl."..".$dirsepurl."<!-- langhome -->".$dirsepurl.$dirdate.$dirsepurl.$tmp.$dirsepurl if ($fontsize == 1);
#	  if ($link eq '' || (!(-f $checklink))) {
#	      $linkjour .= $menu;
#	  } else {
#	      $linkjour .= $link.$htmlext;
#	  }

#    plot1.series[seriesIndex].data[pointIndex]=[plot1.series[seriesIndex].data[pointIndex][0],y]; 

	if ($link ne '') {
	print FOUT "\$('#chart$i').bind('jqplotDataClick',\n";
	print FOUT "function (ev, seriesIndex, pointIndex, data) {\n";
	print FOUT "var elem = graph$chart_id";
	print FOUT "[pointIndex][0].split(' ');\n";
	if ($xmax == $xmax_home_jqplot && ($0 =~ /cron-pages/ || $0 =~ /cron-inc/)) {
	    print FOUT "var prefix_url = '$I';\n";
	} else {
	    print FOUT "var prefix_url = '..';\n";
	}
	print FOUT "if (data[1] != 0) {\n";
	print FOUT "var date_link = prefix_url+'/date/'+elem[2]+'-'+elem[1]+'-'+elem[0]+'/$link$htmlext';\n" if ($mode_date == 1);
	if ($mode_date == 2) {
	    print FOUT "var monthIndexes = {'Jan':0,'Feb':1,'Mar':2,'Apr':3,'May':4,'Jun':5,'Jul':6,'Aug':7,'Sep':8,'Oct':9,'Nov':10,'Dec':11};\n";
	    print FOUT "var mn=['Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec'];\n";

	    print FOUT "var elem = graph$chart_id";
	    print FOUT "[pointIndex][0].split(' ');\n";
	    print FOUT "var month_link = monthIndexes[elem[1]];\n";
	    print FOUT "var part1 = elem[2]+'-'+elem[1]+'-'+elem[0];\n";
	    
	    print FOUT "var date_link2 = new Date(elem[2],month_link,elem[0]);\n";
	    print FOUT "date_link2.setDate(date_link2.getDate()+6);\n";
	    
	    print FOUT "var link_day = date_link2.getDate();\n";
	    print FOUT "if (link_day < 10) link_day = '0'+link_day;\n";
	    print FOUT "var link_month = mn[date_link2.getMonth()];\n";
	    print FOUT "var link_year = date_link2.getFullYear();\n";
	    print FOUT "var part2 = link_year+'-'+link_month+'-'+link_day;\n";

	    print FOUT "var date_link = prefix_url+'/date/'+part1+'_'+part2+'/$link$htmlext';\n";
	}
	print FOUT "var date_link = prefix_url+'/date/'+elem[2]+'-'+elem[1]+'/$link$htmlext';\n" if ($mode_date == 3);
	print FOUT "var date_link = prefix_url+'/date/'+elem[2]+'/$link$htmlext';\n" if ($mode_date == 4);
#    print FOUT "\$('#info1').html('series: '+date_link+', point: '+pointIndex+', data: '+data);\n";
	print FOUT "window.location.href=date_link;\n";
	print FOUT "}\n";
	print FOUT "}\n";
	print FOUT ")\n";
	}

#	if ($mode == 0 || ($mode_editit >= 0 && ($mode_date == 2 || $mode_date == 3 || $mode_date == 4))) {
	if ($mode != 1 || ($mode_editit >= 0 && ($mode_date == 2 || $mode_date == 3 || $mode_date == 4))) {
	    print FOUT "\$('#chart$i').bind('jqplotHighlighterHighlight', \n";
#	print FOUT "\$('#chart$i').bind('jqplotDataHighlight',\n";
	    print FOUT "function (ev, seriesIndex, pointIndex, data) {\n";
#	    if ($mode == 0) {
	    if ($mode != 1 && $mode != 3) {
		if ($mode_editit >= 0) {
		    print FOUT "    var txt = editit$mode_editit";
		} else {
		    print FOUT "    var txt = editit$chart_id";
		}
		print FOUT "_txt(ev, seriesIndex, pointIndex, data);\n";
		print FOUT "    \$('#$info').html(txt);\n";
	    }
#	    if ($mode_editit < 0 && ($mode_date == 2 || $mode_date == 3 || $mode_date == 4)) {
#	    if ($mode == 2 && ($mode_date == 2 || $mode_date == 3 || $mode_date == 4)) {
	    if ($mode < 0 && ($mode_date == 2 || $mode_date == 3 || $mode_date == 4)) {
		print FOUT "var elem_data_pt = graph$chart_id";
		print FOUT "[pointIndex][0].split(' ');\n";
		print FOUT "var data_pt = elem_data_pt[2]+'_'+elem_data_pt[1]+'_'+elem_data_pt[0];\n" if ($mode_date == 2); 
		print FOUT "var data_pt = elem_data_pt[2]+'_'+elem_data_pt[1];\n" if ($mode_date == 3);
		print FOUT "var data_pt = elem_data_pt[2];\n" if ($mode_date == 4);
		print FOUT "     ToggleSet('TOGGLE_'+data_pt);\n";
	    }
	    print FOUT "}\n";
	    print FOUT ");\n";
     
	    print FOUT "\$('#chart$i').bind('jqplotHighlighterUnhighlight', \n";
	    print FOUT "     function (ev) {\n";
	    print FOUT "        \$('#$info').html('&nbsp;');\n";
	    print FOUT "    }\n";
	    print FOUT ");\n";
	}

  }

    print FOUT "\n\n\n";

    # Zoom reset
#    print FOUT "\$('.button-reset').click(function() { plot$chart_id.resetZoom() });\n";
#    print FOUT "<style type=\"text/css\">    .button-reset {      margin: 30px;      margin-left: 90px;    }\n";

## www.treutech.com/58/jqplot-clickable-bar-graphs
	## brandon-creativeblog.blogspot.fr/2009/12/customizing-jqplot-stacked-bar-chart.html
## codeblitz.wordpress.com/2009/06/22/jquery-charts/
# CSS .jqplot-yaxis{min-width: 1px;margin-right:10px;}????

##http://jsfiddle.net/Boro/WFm42/ Highlight one line
#  $('#chart1').bind('jqplotMouseMove', function(event, xy, axesData, neighbor, plot) {
#        var drawingCanvas = $(".jqplot-highlight-canvas")[0];
#        var context = drawingCanvas.getContext('2d');
#        context.clearRect(0, 0, drawingCanvas.width, drawingCanvas.height);     
#        for (var i = 0; i < plot.series.length; i++){
#            var value = hitTestSegments(plot.series[i].gridData, xy, plot.series[i].lineWidth);
#            if (value > -1) {
#                //draw the highlight
#                context.beginPath();
#                for(var j = 0; j < plot.series[i].gridData.length; j++){
#                    var p = plot.series[i].gridData[j];
#                    if(j == 0)
#                       context.moveTo(p[0],p[1]);
#                    else context.lineTo(p[0],p[1]);
#                }
#                //adding some sort of a glow effect
#                context.lineWidth = plot.series[i].lineWidth + 9;
#                context.strokeStyle = "rgba(154,205,50, 0.25)";//#9ACD32
#                context.stroke();
#              //  context.lineWidth = plot.series[i].lineWidth + 6;
#             //   context.strokeStyle = "rgba(154,205,50, 0.5)";
#             //   context.stroke();
#                context.lineWidth = plot.series[i].lineWidth + 3;
#                context.strokeStyle = "rgba(154,205,50, 0.75)";
#                context.stroke();
#                //just highlight the line using its actual width
#               // context.lineWidth = plot.series[i].lineWidth;
#               /// context.strokeStyle = "rgba(154,205,50, 1)";//"yellowgreen";//#9ACD32
#              //  context.stroke();
#                break;
#            }
#        }
#    });
#function hitTestSegments(points, point, thickness) {
#        if (points.length < 2) return -1;
#        for (var i = 0; i < points.length - 1; i++) {
#            var p0 = points[i];
#            var p1 = points[i + 1];
#            var distance = dotLineLength(point.x, point.y, p0[0], p0[1], p1[0], p1[1], true);
#            if (distance < thickness) return i;
#        }
#        return -1;
#    }
#
#  //+ Jonas Raoni Soares Silva
#    //@ http://jsfromhell.com/math/dot-line-length [rev. #1]
#    dotLineLength = function(x, y, x0, y0, x1, y1, o) {
#        function lineLength(x, y, x0, y0) {
#            return Math.sqrt((x -= x0) * x + (y -= y0) * y);
#        }
#        if (o && !(o = function(x, y, x0, y0, x1, y1) {
#            if (!(x1 - x0)) return {
#                x: x0,
#                y: y
#            };
#            else if (!(y1 - y0)) return {
#                x: x,
#                y: y0
#            };
#            var left, tg = -1 / ((y1 - y0) / (x1 - x0));
#            return {
#                x: left = (x1 * (x * tg - y + y0) + x0 * (x * -tg + y - y1)) / (tg * (x1 - x0) + y0 - y1),
#                y: tg * left - tg * x + y
#            };
#        }(x, y, x0, y0, x1, y1), o.x >= Math.min(x0, x1) && o.x <= Math.max(x0, x1) && o.y >= Math.min(y0, y1) && o.y <= Math.max(y0, y1))) {
#            var l1 = lineLength(x, y, x0, y0),
#                l2 = lineLength(x, y, x1, y1);
#            return l1 > l2 ? l2 : l1;
#        }
#        else {
#            var a = y0 - y1,
#                b = x1 - x0,
#                c = x0 * y1 - y0 * x1;
#            return Math.abs(a * x + b * y + c) / Math.sqrt(a * a + b * b);
#        }
#    };



#http://stackoverflow.com/questions/12182598/jqplot-as-image
# <button id="show_plotted_image_btn" class="jqplot-image-button">View Plot Image</button>
#<div id="plotted_image_div" class="" style="display: none;"></div>

    if ($xmax != $xmax_home_jqplot) {
	print FOUT "function genImg(i){\n";
	print FOUT "  var tmp = '#chart'+i;\n";
	print FOUT "  var toto = \$(''+tmp+'');\n";

	print FOUT "  var tmp2 = '#plotted_image_div'+i;\n";
	print FOUT "  var toto2 = \$(''+tmp2+'');\n";

#	print FOUT "  var tmp3 = '#show_plotted_image_btn0';\n";
#	print FOUT "  var toto3 = \$(''+tmp3+'');\n";

	print FOUT "  var imgData = toto.jqplotToImageStr({});\n";
#    print FOUT "  var imgData = \$('#chart0').jqplotToImageStr({});\n";
	print FOUT "  var imgElem = \$('<img/>').attr({'src':imgData,title:\"Right click on plot to save\"});\n";
	print FOUT "  toto2.empty(); // remove the old graph\n";
	print FOUT "  toto2.append(imgElem);   \n";   
#     print FOUT "       header.html('Right Click to Save Image As...');\n";
#	print FOUT "toto3.html('Right click on plot to save image');\n";
	print FOUT "};\n\n";

	print FOUT "\$('#show_plotted_image_btn$chart_id').click(\n";
	print FOUT "function(){\n";
	print FOUT "var idx = 0;\n";
	print FOUT "var divs = document.getElementsByTagName(\"div\");\n";
	print FOUT "for (var i = 0; i < divs.length; i++) {\n";
	print FOUT "var el = divs[i].id;\n";
	print FOUT "if (el.indexOf(\"TOGGLE_\") != -1) {\n";
	print FOUT "     if (divs[i].style.display == 'inline') {\n";
	print FOUT "		    idx = divs[i].id.replace(\"TOGGLE_\",\"\");\n";
	print FOUT "                if (idx >= $chart_id && idx <= $chart_id_plus) break;\n";
	print FOUT "     }\n";
	print FOUT "}\n";
	print FOUT "}\n";

	print FOUT " genImg(idx);\n";
	print FOUT "  var tmp2 = '#plotted_image_div'+idx;\n";
	print FOUT "  var toto2 = \$(''+tmp2+'');\n";
	print FOUT "  toto2.toggle();\n";
#	print FOUT " \$('#plotted_image_div$chart_id').toggle();\n";
	print FOUT "});\n\n";
    }
            
#print FOUT "genImg();\n";
#print FOUT "\$('#plotted_image_div').css('display','block');\n";



#var imgelem = $('#chart0').jqplotToImageStr({});
#        if (imgelem) {
#           window.location.href=imgelem;
#}

#    print FOUT "if (!\$.jqplot.use_excanvas) {\n";
#    print FOUT "\$('div.jqplot-target').each(function(){\n";
#    print FOUT "        var outerDiv = \$(document.createElement('div'));\n";
#    print FOUT "        var header = \$(document.createElement('div'));\n";
#    print FOUT "        var div = \$(document.createElement('div'));\n";

#     print FOUT "       outerDiv.append(header);\n";
#     print FOUT "       outerDiv.append(div);\n";

#     print FOUT "       outerDiv.addClass('jqplot-image-container');\n";
#     print FOUT "       header.addClass('jqplot-image-container-header');\n";
#     print FOUT "       div.addClass('jqplot-image-container-content');\n";

#     print FOUT "       header.html('Right Click to Save Image As...');\n";

#      print FOUT "      var close = \$(document.createElement('a'));\n";
#      print FOUT "      close.addClass('jqplot-image-container-close');\n";
#      print FOUT "      close.html('Close');\n";
#      print FOUT "      close.attr('href', '#');\n";
#      print FOUT "      close.click(function() {\n";
#      print FOUT "          \$(this).parents('div.jqplot-image-container').hide(500);\n";
#      print FOUT "      })\n";
#      print FOUT "      header.append(close);\n";

#      print FOUT "      \$(this).after(outerDiv);\n";
#      print FOUT "      outerDiv.hide();\n";

#      print FOUT "      outerDiv = header = div = close = null;\n";

#      print FOUT "      if (!\$.jqplot._noToImageButton) {\n";
#      print FOUT "          var btn = \$(document.createElement('button'));\n";
#      print FOUT "          btn.text('View Plot Image');\n";
#      print FOUT "          btn.addClass('jqplot-image-button');\n";
#      print FOUT "          btn.bind('click', {chart: \$(this)}, function(evt) {\n";
#      print FOUT "              var imgelem = evt.data.chart.jqplotToImageElem();\n";
#      print FOUT "              var div = \$(this).nextAll('div.jqplot-image-container').first();\n";
#      print FOUT "              div.children('div.jqplot-image-container-content').empty();\n";
#      print FOUT "              div.children('div.jqplot-image-container-content').append(imgelem);\n";
#      print FOUT "              div.show(500);\n";
#      print FOUT "              div = null;\n";
 #     print FOUT "          });\n";

 #     print FOUT "          \$(this).after(btn);\n";
 #      print FOUT "         btn.after('<br />');\n";
 #     print FOUT "          btn = null;\n";
 #     print FOUT "      }\n";
 #     print FOUT "  });\n";
 #   print FOUT "    }\n";


    print FOUT "\$(window).resize(function() {\n";
#    print FOUT "   if (plot) {\n";
    print FOUT "      \$.each(plot.series,function(index,series) {\n";
    print FOUT "         series.barWidth = undefined;\n";
    print FOUT "       });\n";
    print FOUT "       plot.replot( { resetAxes: true} );\n";
#    print FOUT "   }\n";
    print FOUT "});\n";

#jqplot.trendline.min.js
#jquery-ui.min.js and jquery-ui.min.css

    print FOUT "});\n";    
    print FOUT "</script>\n";

#    if ($xmax != $xmax_home_jqplot) {
#	print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\">Save</button>\n";
#	print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
#    }

#    if ($mode_date != 0) {
	for ($i=$chart_id;$i<=($chart_id+$#list_graph_name_jqplot);$i++) {
	    if (abs($mode) == 3 || ($mode == 1 && $line_hl ne '')) {
		print FOUT "<input type=\"text\" id=\"plot$i\" style=\"display:none\" value=\"3\">\n";
	    } else {
		print FOUT "<input type=\"text\" id=\"plot$i\" style=\"display:none\" value=\"0\">\n";
	    }
	    print FOUT "<input type=\"text\" id=\"plot_draw$i\" style=\"display:none\" value=\"$line_hl\">\n";
	}
#    }

#    print FOUT "function getColumnLocation(plot,gridpos,length)  {\n";
#    print FOUT "   // Get the width of the graph area minus the space taken up with axises. \n"; 
#    print FOUT "   var insidewidth = plot.grid._width;\n";  
#    print FOUT "   var colwidth = insidewidth / length; \n"; 
#    print FOUT "   var column = parseInt(gridpos.x / colwidth); \n"; 
#    print FOUT "return column;  \n";
#    print FOUT "}\n"; 

}



sub MakeGraphJqplot {
#    local(*FOUT,*L,$I,$ref,$conv,$chart_id,$labelx,$labely,$width,$height) = @_;
    local(*FOUT,*L,$I,$ref,$conv,$chart_id,$mode,$labelx,$labely,$width,$height) = @_;
    local($i,$val,$val_txt,$convunit_data);
    local($min,$max);

    # mode : 0 - lines / 1 - points

    @tab = @$ref;
#    @listdate = @$ref_date;

    $min = 0;
    $max = scalar($#tab)+1;
#    print "A $#tab - $max\n";

#    print "@listdate - $min - $max\n";

    if ($conv != 1) {
	$format = "%.2f";
	($tmp,$convunit_data) = split(/\s+/,$labely);
	$convunit_data =~ s/\(//;
	$convunit_data =~ s/\)//;
    } else {
	$format = "%d";
    }

    print FOUT "<div id=\"";
    print FOUT "chart".$chart_id;
    print FOUT "\" style=\"";
    print FOUT "height:".$height."px; width:".$width."px;\"></div>\n";

    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\">\n";

    print FOUT "var plot1;\n";

    print FOUT "function editit$chart_id";
    print FOUT "(str, si, pi, plot) {\n";

    $val_txt1 = "<table width=\"120\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">";
    $val_txt1 .= "<tr>";
    $val_txt1 .= "<td style=\"border: 1px double #209090;-moz-opacity:.85;opacity:.85;\">";
    $val_txt1 .= "<table width=\"120\" style=\"border: 1px solid #d9d9d9;\" cellspacing=\"0\" cellpadding=\"0\">";
    $val_txt1 .= "<tr>";
    $val_txt1 .= "<td width=\"118\" style=\"text-align:center;background-color:#ffddbb;padding:5px;\">";

    print FOUT "var pi_pp = pi+1;\n";
    print FOUT "if (pi_pp < 10) pi_pp = '0'+pi_pp;\n";
    print FOUT "var pi1 = pi;\n";
    print FOUT "if (pi1 < 10) pi1 = '0'+pi1;\n";
    $val_txt2 = "<span style=\"color:Navy;font-size:10px;font-weight:bold;text-decoration:none;\">'+pi1+' - '+pi_pp+' h<\\\/span>";

    $val_txt3 = "<\\\/td>";
    $val_txt3 .= "<\\\/tr>";
    $val_txt3 .= "<tr>";
    $val_txt3 .= "<td width=\"118\" style=\"background-color:#ffeecc;text-align:left;padding:5px;\">";
    $val_txt3 .= "<span style=\"font-size:9px;\">$L{'Requests'} : '+request[pi]+'<\\\/span>";
    $val_txt3 .= "<br><span style=\"font-size:9px;\">$L{'Spam'} : '+spam[pi]+'<\\\/span>" if ($mail_format == 1 && $spam_found != 0);
    $val_txt3 .= "<br><span style=\"font-size:9px;\">$L{'Files'} : '+pageunique[pi]+'<\\\/span>" if ($cups_format == 1);
    $val_txt3 .= "<br><span style=\"font-size:9px;\">$L{'Accesses'} : '+access[pi]+'<\\\/span>" if ($mail_format == 0 && $ftp_format == 0 && $cups_format == 0);
    $val_txt3 .= "<br><span style=\"font-size:9px;\">$L{'Documents'} : '+document2[pi]+'<\\\/span>" if ($mail_format == 0 && $cups_format == 0);
    $val_txt3 .= "<br><span style=\"font-size:9px;\">$L{'Hosts'} : '+host[pi]+'<\\\/span>";
#    $val_txt3 .= "<br><span style=\"font-size:9px;\">$L{'Traffic'} : '+trafic[pi]+' $convunit_data</span>" if ($precision > 2 && $notrafic == 0);
    $val_txt3 .= "<br><span style=\"font-size:9px;\">$L{'Traffic'} : '+trafic[pi]+'<\\\/span>" if ($precision > 2 && $notrafic == 0);
    $val_txt3 .= "<br><span style=\"font-size:9px;\">$L{'Users'} : '+user[pi]+'<\\\/span>" if ($inc_user == 1 && $found_user == 1);
    $val_txt3 .= "<\\\/span>";
    $val_txt3 .= "&nbsp;<\\\/td>";
    $val_txt3 .= "<\\\/tr><\\\/table>";
    $val_txt3 .= "<\\\/td><\\\/tr><\\\/table>";

    print FOUT "var txt = '$val_txt1';\n";
    print FOUT "txt += '$val_txt2';\n";
    print FOUT "txt += '$val_txt3';\n";

#    print FOUT "var txt = 'Requests : '+requests[pi];\n";
#    print FOUT "txt += 'Accesses '+access[pi];\n";
    print FOUT "return txt;\n";
    #    return "<b><i>NHT: "+plot.targetId+', Series: '+si+', Point: '+pi+', '+str+"</b></i><br>";
    print FOUT "}\n";

    print FOUT "\$(document).ready(function(){\n";
    print FOUT "plot1 = \$.jqplot (";
    print FOUT "'chart$chart_id'";
    print FOUT ", [[";
    $line = '';
   for ($i=0;$i<=$#tab;$i++) {
#   for ($i=0;$i<=$max;$i++) {
#   for ($i=0;$i<=$#listdate;$i++) {
       $val = int(100*$tab[$i]/$conv)/100;
#       if ($val != 0) {
       $line .= "[$i,$val]," if ($val != 0);
       $line .= "[$i,null]," if ($mode == 1 || $val == 0);
#       }

#	$val = int(100*$tab[$i]/$conv)/100;
#	$val = int(100*$tab[$val_tmp]/$conv)/100;
#	if ($val != 0) {
#	    $line .= "[$listdate[$i],$val]";
#	} else {
#	    $line .= "[$listdate[$i],null],";
#	}
#	$line .= "," if ($i != $#tab);
#	$line .= "," if ($i != $max);
    }
    chop($line);
    print FOUT "$line";
    print FOUT "]], {\n";
#    print FOUT "title: 'Test',\n";

    print FOUT "series: [{\n";
    print FOUT "lineWidth: 1,\n";
    print FOUT "color: 'red',\n";
    print FOUT "breakOnNull: true,\n";# if ($mode == 1);
    print FOUT "markerOptions: { style: 'circle', color: 'red', size: 2 }\n";
    print FOUT "}],\n";

    print FOUT "axesDefaults: {\n";
    print FOUT "labelRenderer: \$.jqplot.CanvasAxisLabelRenderer\n";
    print FOUT "},\n";

    print FOUT "axes: {\n";
    print FOUT "xaxis: {\n";
    print FOUT "label: \"".$labelx."\",\n";
    print FOUT "labelRenderer: \$.jqplot.CanvasAxisLabelRenderer,\n";
    print FOUT "labelOptions: {\n";
    print FOUT "fontSize: '8pt'\n";
    print FOUT "},\n";
    print FOUT "tickOptions: {\n";
    print FOUT "formatString: '%d'\n";
    print FOUT "},\n";
    print FOUT "min: 0,\n";
    print FOUT "max: $max\n" if ($mode == 0);
    print FOUT "pad: 1.2\n" if ($mode == 1);
    print FOUT "},\n";
    print FOUT "yaxis: {\n";
#    print FOUT "tickOptions:{\n";
#    print FOUT "formatString:'$\%.2f'\n";
#    print FOUT "},\n";
    print FOUT "label: \"".$labely."\",\n";
    print FOUT "labelRenderer: \$.jqplot.CanvasAxisLabelRenderer,\n";
    print FOUT "labelOptions: {\n";
    print FOUT "fontSize: '8pt'\n";
    print FOUT "},\n";
    print FOUT "min: 0,\n";
    print FOUT "pad: 1.2\n";
    print FOUT "}\n";
    print FOUT "},\n";

    print FOUT "highlighter: {\n";
    print FOUT "showTooltip: true,\n";
    print FOUT "useAxesFormatters: false,\n";
    print FOUT "tooltipAxes: 'xy',\n";
    print FOUT "show: true,\n";
#    print FOUT "formatString: '$val_txt',\n";
    print FOUT "tooltipContentEditor: editit$chart_id,\n";
    print FOUT "sizeAdjust: 0\n";
    print FOUT "},\n";

    print FOUT "cursor: {\n";
    print FOUT "show: false\n";
    print FOUT "}\n";

    print FOUT "});\n";
    print FOUT "});\n";
    
    print FOUT "</script>\n";
}

##################

sub MakeRealGraphJqplot {
    local(*FOUT,*L,$I,$ref,$refpos,$seriecolor,$conv,$chart_id,$labelx,$labely,$width,$height) = @_;
    local($i,$val,$val_txt,$convunit_data);

    @tab = @$ref;
    @tabpos = @$refpos;

    if ($conv != 1) {
	$format = "%.2f";
    } else {
	$format = "%d";
    }

    print FOUT "<div id=\"";
    print FOUT "chart".$chart_id;
    print FOUT "\" style=\"";
    print FOUT "height:".$height."px; width:".$width."px;\"></div>\n";

    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\">\n";

    print FOUT "var plot1;\n";

    print FOUT "function editit$chart_id";
    print FOUT "(str, si, pi, plot) {\n";
    print FOUT "var vals = str.split(',');\n";
    $val_txt1 = "<table width=\"120\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">";
    $val_txt1 .= "<tr>";
    $val_txt1 .= "<td style=\"border: 1px double #209090;-moz-opacity:.85;opacity:.85;\">";
    $val_txt1 .= "<table width=\"120\" style=\"border: 1px solid #d9d9d9;\" cellspacing=\"0\" cellpadding=\"0\">";
    $val_txt1 .= "<tr>";
    $val_txt1 .= "<td width=\"118\" style=\"text-align:center;background-color:#ffddbb;padding:5px;\">";

    $val_txt2 = "<span style=\"color:Navy;font-size:10px;font-weight:bold;text-decoration:none;\">'+vals[0]+'<\\\/span>";

    $val_txt3 = "<\/td>";
    $val_txt3 .= "<\/tr>";
    $val_txt3 .= "<tr>";
    $val_txt3 .= "<td width=\"118\" style=\"background-color:#ffeecc;text-align:left;padding:5px;\">";
    $val_txt3 .= "<span style=\"font-size:9px;\">$L{'Requests'} : '+request[pi]+'<\\\/span>";
    $val_txt3a = "<br><span style=\"font-size:9px;\">$L{'Spam'} : '+spam[pi]+'<\\\/span>" if ($mail_format == 1 && $spam_found != 0);
#    $val_txt3 .= "<br><span style=\"font-size:9px;\">$L{'Files'} : '+pageunique[pi]+'</span>" if ($cups_format == 1);
    

    $val_txt3b = "<br><span style=\"font-size:9px;\">$L{'Accesses'} : '+access[pi]+'<\\\/span>" if ($mail_format == 0 && $ftp_format == 0 && $cups_format == 0);

#    $val_txt3 .= "<br><span style=\"font-size:9px;\">$L{'Documents'} : '+document2[pi]+'</span>" if ($mail_format == 0 && $cups_format == 0);
    $val_txt3c = "<br><span style=\"font-size:9px;\">$L{'Hosts'} : '+host[pi]+'<\\\/span>";
    $val_txt3c .= "<br><span style=\"font-size:9px;\">$L{'Traffic'} : '+trafic[pi]+' $convunit_data<\\\/span>" if ($precision > 2 && $notrafic == 0);
#    $val_txt3c .= "<br><span style=\"font-size:9px;\">$L{'Users'} : '+user[pi]+'</span>" if ($inc_user == 1 && $found_user == 1);
    $val_txt3c .= "<\\\/span>";
    $val_txt3c .= "&nbsp;<\\\/td>";
    $val_txt3c .= "<\\\/tr><\\\/table>";
    $val_txt3c .= "<\\\/td><\\\/tr><\\\/table>";

    print FOUT "var txt = '$val_txt1';\n";
    print FOUT "txt += '$val_txt2';\n";
    print FOUT "txt += '$val_txt3';\n";
    print FOUT "if (typeof(spam) != 'undefined') {\n";
    print FOUT "txt += '$val_txt3a';\n";
    print FOUT "}\n";
    print FOUT "if (typeof(access) != 'undefined') {\n";
    print FOUT "txt += '$val_txt3b';\n";
    print FOUT "}\n";
    print FOUT "txt += '$val_txt3c';\n";

#    print FOUT "var txt = 'Requests : '+requests[pi];\n";
#    print FOUT "txt += 'Accesses '+access[pi];\n";
    print FOUT "return txt;\n";
    #    return "<b><i>NHT: "+plot.targetId+', Series: '+si+', Point: '+pi+', '+str+"</b></i><br>";
    print FOUT "}\n";

    print FOUT "\$(document).ready(function(){\n";

    $nb_element = scalar(@tab);
    $tick_val = "[";
    # Add first date
    $tick_val .= "";

    print FOUT "var graph$chart_id = [";
    for ($i=0;$i<=$#tab;$i++) {
	$val = int(100*$tab[$i]/$conv)/100;
#	print "UU $i - $tab[$i] - $val\n";
	$valstep = $tabpos[$i];

	$valstep = int($valstep/60);
	$valstep += $min_begin;
	$valstep2 = $hour_begin;
	if ($valstep > 59) {
	    $valstep2 += int($valstep/60);
	    $valstep = $valstep-(int($valstep/60)*60);
	    $valstep2 = "0".$valstep2 if (length($valstep2) == 1);
	}
	$valstep = "0".$valstep if (length($valstep) == 1);
	$valstep3 = $start_date.":".$valstep2.":".$valstep.":00";
	$valstep = $start_date." ".$valstep2.":".$valstep.":00";

#	$valstep = $start_date;

	if ($i == 0) {
#	    print "MIN : $valstep3\n";
	    $min = &nb_sec_deb($valstep3)*1000;
#	    print "MIN : $min\n";
	}

	if ($i == $#tab) {
#	    print "MAX : $valstep3\n";
	    $max = &nb_sec_deb($valstep3)*1000;
#	    print "MAX : $max\n";
	}

#	print FOUT "[$tabpos[$i],";
	print FOUT "['$valstep',";
	$tick_val .= "'$valstep',";
	print FOUT "$val]";
	print FOUT "," if ($i != $#tab);
    }
    print FOUT "];\n";
    chop($tick_val);
    $tick_val .= ']';

    print FOUT "plot1 = \$.jqplot (";
    print FOUT "'chart$chart_id'";
    print FOUT ", [";
    print FOUT "graph$chart_id";
    print FOUT "], {\n";
    print FOUT "seriesColors: ['$seriecolor'],\n";
    print FOUT "seriesDefaults: {\n";
    print FOUT "renderer: \$.jqplot.BarRenderer,\n";
    print FOUT "rendererOptions:{\n";
    $tmp2 = $nb_element+1;
#    $tmp2 += 2; # if ($mode_date == 2 || $mode_date == 3 || $mode_date == 4);
    $tmp = int(($width-($width/10))/$tmp2);  ######## Faux retrouve le nombre de bar affiche !!!!!!!!!!!!!!
    $tmp = 1 if ($tmp == 0);
    print FOUT "barWidth: $tmp,\n";
    print FOUT "barPadding: 1,\n";
    print FOUT "fillToZero: true,\n";
    print FOUT "barMargin: 0\n";
    print FOUT "},\n";
    print FOUT "lineWidth: 1\n";
    print FOUT "},\n";
    print FOUT "series: [{\n";
#    print FOUT "label: 'Hosts',\n";
    print FOUT "markerOptions: { style: 'circle', size: 0 }\n";
#    print FOUT "}\n";

#    print FOUT "lineWidth: 1,\n";
#    print FOUT "breakOnNull: true,\n";
#    print FOUT "color: 'red',\n";

    print FOUT "}],\n";

    print FOUT "axesDefaults: {\n";
    print FOUT "labelRenderer: \$.jqplot.CanvasAxisLabelRenderer,\n";
    print FOUT "tickRenderer: \$.jqplot.CanvasAxisTickRenderer\n";
    print FOUT "},\n";

    print FOUT "axes: {\n";
    print FOUT "xaxis: {\n";
    print FOUT "renderer: \$.jqplot.DateAxisRenderer,\n";
    print FOUT "numberTicks: 10,\n";

    print FOUT "ticks: $tick_val,\n";
    print FOUT "drawMajorGridlines: false,\n";
    print FOUT "rendererOptions: { tickRenderer: \$.jqplot.CanvasAxisTickRenderer },\n";
    print FOUT "label: \"".$labelx."\",\n";
    print FOUT "min: $sec_deb_jqplot,\n";
    print FOUT "max: $max,\n";
    print FOUT "labelRenderer: \$.jqplot.CanvasAxisLabelRenderer,\n";
    print FOUT "labelOptions: {\n";
    print FOUT "fontFamily: 'Arial, Verdana, Helvetica',\n";
    print FOUT "textColor: '#000000',\n";
    print FOUT "fontSize: '8pt'\n";
    print FOUT "},\n";

    print FOUT "tickOptions: {\n";
    print FOUT "formatString: '%R',\n";
#    print FOUT "fontSize: '1.20em',\n";
    print FOUT "textColor: '#0070A3',\n";
    print FOUT "fontFamily: 'Arial, Verdana, Helvetica',\n";
    print FOUT "angle: -30\n";
    print FOUT "}\n";

#    $min = $tabpos[0];	    
#    $min = &nb_sec_deb($min)*1000;
#    $max = $tabpos[$#tabpos];
#    $max = $filter_sec;
#    $max = &nb_sec_deb($max)*1000;

#    print "AA $min - $max\n";
#    print FOUT "min: $min,\n";
#    print FOUT "max: $max,\n";
#    print FOUT "pad: 1.2\n";

    print FOUT "},\n";
    print FOUT "yaxis: {\n";
#    print FOUT "tickOptions:{\n";
#    print FOUT "formatString:'$\%.2f'\n";
#    print FOUT "},\n";
    print FOUT "label: \"".$labely."\",\n";
    print FOUT "labelRenderer: \$.jqplot.CanvasAxisLabelRenderer,\n";
    print FOUT "labelOptions: {\n";
#    print FOUT "fontSize: '8pt'\n";
    print FOUT "fontFamily: 'Arial, Verdana, Helvetica',\n";
    print FOUT "textColor: '#000000'},\n";

    print FOUT "tickOptions: {\n";
    print FOUT "formatString: '%d',\n";
#    print FOUT "fontSize: '1.20em',\n";
    print FOUT "fontFamily: 'Arial, Verdana, Helvetica',\n";
    print FOUT "textColor: '#0070A3'\n";
    print FOUT "},\n";


    print FOUT "min: 0,\n";
    print FOUT "pad: 1.2\n";
    print FOUT "}\n";
    print FOUT "},\n";

    print FOUT "highlighter: {\n";
    print FOUT "showTooltip: true,\n";
    print FOUT "useAxesFormatters: true,\n";
#    print FOUT "tooltipAxes: 'xy',\n";
    print FOUT "show: true,\n";
#    print FOUT "formatString: '$val_txt',\n";
    print FOUT "tooltipContentEditor: editit$chart_id,\n";
    print FOUT "sizeAdjust: 0\n";
    print FOUT "}\n";

    print FOUT "});\n";
    print FOUT "});\n";
    
    print FOUT "</script>\n";
}

##################


sub MakeGraph {
  local($count_day,$repmax,$unit,$start_date,$xmax,$ymax,$graphpage,$link,$fontsize,$title,$mode,$idx,$ref1,$ref2,$ref3,$ref4,$ref5,$ref6,$ref7) = @_;
  local($xstep,$ystep,$date,$i,$nblang,$grad);
  local(@tab,@tabacc,@tabreq,@tabmm,@tabdoc,@tabtrafic,@tabscript,@tabuser);
  local($tmp3);

  $linegraph = 1;
  $bargraph = 0;

  $tmp = "ref".$idx;
  @tab = @$$tmp;

  $font = "tiny" if ($fontsize == 0);
  $font = "medium" if ($fontsize == 1);

#  print "$count_day - $repmax,$unit,$start_date,$xmax,$ymax,$graphpage,$fontsize,$title,$mode,$idx @tab\n";

  @tabacc = @$ref1;
  @tabreq = @$ref2;
  @tabmm = @$ref3;
  @tabdoc = @$ref4;
  @tabtrafic = @$ref5;
  @tabscript = @$ref6;
  @tabuser = @$ref7;

  $tmp3 = 1;
  if ($unit eq "Tb") {
      $tmp3 = 1024*1024*1024*1024;
  }
  if ($unit eq "Gb") {
      $tmp3 = 1024*1024*1024;
  }
  if ($unit eq "Mb") {
      $tmp3 = 1024*1024;
  }
  if ($unit eq "Kb") {
      $tmp3 = 1024;
  }

  $graphpagex = $path.$dirgraph.$dirsep.$graphpage."x".$gifext;
  $graphpagey = $path.$dirgraph.$dirsep.$graphpage."y".$gifext;
  $graphpage = $path.$dirgraph.$dirsep.$graphpage.$gifext;

  $grad = 10/2;                # number of graduation
  $xstep = int($xmax/$grad); # x step for graph
  $ystep = int($ymax/$grad); # y step for graph

  $it = length($count_day)-1;
  $div = 10**$it;
  $factx = ($div*(int($count_day/$div)+1))/$grad;
  
  $it = length($repmax)-1;
  $div = 10**$it;
  $facty = ($div*(int($repmax/$div)+1))/$grad;

  $fymax = $ymax-2;
  $date = $start_date;
  $map = '';

### image pour les abscisses

  ($startday, $startmonth) = split(/ /,$start_date);

  $moischiffre = $month_equiv{$startmonth};
  $moischiffre--;
  $moisvar = $startmonth;
  $valmois = $moischiffre;

  $valstep = $startday;
  $valstep = "0".$valstep if (length($valstep) == 1);

  $xlegend = "$count_day days (starting $start_date)";
  $county = 0;
  $countx = 0;

  open(FLY,">$tmpfly$vtmp");
  print FLY "new\n";
  print FLY "size $xmax,$ydecal\n";
  print FLY "frect 0,0,$xmax,$ydecal,243,243,243\n";
  if ($count_day != 0) {
      $posx = (($xmax/2)-(length($xlegend)*7/2));
      print FLY "string 0,0,0,$posx,$ydecalm,$font,$xlegend\n";
      for ($i=$xstep;$i<$xmax;$i+=$xstep) {
	  $valstep = int(($i/$xmax)*(($xmax*$factx/$xstep)))+$startday;
	  
	  $moisvar = $startmonth;
	  $valmois = $moischiffre;

	  while  ($valstep > $month_of_year{$moisvar}) {
	      $valstep = ($valstep - $month_of_year{$moisvar});
	      $valmois++;
	      $valmois = 0 if ($valmois > 11);
	      $moisvar = $month_nb[$valmois];
	  }

	  $valstep = "0".$valstep if (length($valstep) == 1);
	  $val = "$moisvar/$valstep";
	  $posx = $i - length($valstep)*10;
	  print FLY "line $i,0,$i,5,0,0,0\n";
	  $line_graphy[$county] = $i;
	  $county++;
	  print FLY "string 0,0,0,$posx,10,$font,$val\n";
      }
      print FLY "line 0,0,$xmax,0,0,0,0\n";
  }
  print FLY "transparent 243,243,243\n";
  close (FLY);
 
  &BuildFly("$tmpfly$vtmp",$graphpagex);

### image pour les ordonnees

  $title = $title." (".$unit.")" if ($idx == 5);

  open(FLY,">$tmpfly$vtmp");
  print FLY "new\n";
  print FLY "size $xdecal,$ymax\n";
  print FLY "frect 0,0,$xdecal,$ymax,243,243,243\n";
  if ($count_day != 0) {
      $posy = $ymax - (($ymax/2)-(length($title)*2));
      print FLY "stringup 0,0,0,5,$posy,$font,$title\n";

      for ($j=$ystep;$j<$ymax;$j+=$ystep) {
	  $valstep = int(($ymax - $j) * ($facty/$ystep));
	  $valstep = int(10*$valstep/$tmp3)/10 if ($idx == 5);
	  
	  $pos = ($xdecal - length($valstep)*11);
	  $posy = $j-5;
	  print FLY "line $xdecalm,$j,$xdecal,$j,0,0,0\n";
	  print FLY "string 0,0,0,$pos,$posy,$font,$valstep\n";
	  $line_graphx[$countx] = $j;
	  $countx++;
      }
  }
  print FLY "transparent 243,243,243\n";
  close (FLY);

  &BuildFly("$tmpfly$vtmp",$graphpagey);

###

# $graphpage
  $nblang = 0;
  for ($k=0;$k<=$#homepages;$k++) {
      $nblang = $k if ($homepages[$k] !~ /-/);
  }

  open(FLY,">$tmpfly$vtmp");
  print FLY "new\n";
  print FLY "size $xmax,$ymax\n";
  print FLY "frect 0,0,$xmax,$ymax,243,243,243\n";
  if ($count_day != 0) {

      for ($j=1;$j<=($count_day+$bargraph);$j++) {

	  $x1 = ($j-1)*$xstep/$factx;
	  $x2 = $j*$xstep/$factx;

	  $y2 = $ymax - ($ystep/$facty * $tab[$j]);

	  ($val1,$val2,$val3) = split(/\s/,$date);
	  $tmp = $val3."-".$val2."-".$val1;
	  
	  $checklink = $path.$lang[$nblang].$dirsepurl.$dirdate.$dirsepurl.$tmp.$dirsepurl;
	  $checklink .= $menu if ($link eq '');
	  $checklink .= $link.$htmlext if ($link ne '');

	  $linkjour = "<!-- langhome -->".$dirsepurl.$dirdate.$dirsepurl.$tmp.$dirsepurl if ($fontsize == 0);
	  $linkjour = "..".$dirsepurl."..".$dirsepurl."<!-- langhome -->".$dirsepurl.$dirdate.$dirsepurl.$tmp.$dirsepurl if ($fontsize == 1);
	  if ($link eq '' || (!(-f $checklink))) {
	      $linkjour .= $menu;
	  } else {
	      $linkjour .= $link.$htmlext;
	  }
	  $linkjour = "#" if ($linkjour eq '');

	  $tmp2 =  int($tabtrafic[$j]*100/$tmp3)/100;
	  $tmp4 = '';
	  if ($mode == 0) {
	      $tmp4 .= "Occurence : $tab[$j]";
	  }
	  if ($mode == 1) {
	      $tmp4 .= "<B>" if ($idx == 2);
	      $tmp4 .= "Requests : $tabreq[$j]" if ($cups_format == 0);
	      $tmp4 .= "Pages : $tabreq[$j]" if ($cups_format == 1);
	      $tmp4 .= "</B>" if ($idx == 2);
	      $tmp4 .= "|";

	      if ($ftp_format == 0 && $mail_format == 0 && $dhcp_format == 0) {
		  $tmp4 .= "<B>" if ($idx == 1);
		  $tmp4 .= "Accesses" if ($cups_format == 0);
		  $tmp4 .= "Files" if ($cups_format == 1);
		  $tmp4 .= " : $tabacc[$j]";
		  $tmp4 .= "</B>" if ($idx == 1);
		  $tmp4 .= "|";
	      }
	      if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
		  $tmp4 .= "<B>" if ($idx == 4);
		  $tmp4 .= "Documents : $tabdoc[$j]";
		  $tmp4 .= "</B>" if ($idx == 4);
		  $tmp4 .= "|";
	      }
	      
	      $tmp4 .= "<B>" if ($idx == 3);
	      $tmp4 .= "Hosts : $tabmm[$j]";
	      $tmp4 .= "</B>" if ($idx == 3);

	      if ($scriptmax != 0) {
		  $tmp4 .= "|";
		  $tmp4 .= "<B>" if ($idx == 6);
		  $tmp4 .= "Scripts : $tabscript[$j]";
		  $tmp4 .= "</B>" if ($idx == 6);
	      }

	      if ($usermax != 0) {
		  $tmp4 .= "|";
		  $tmp4 .= "<B>" if ($idx == 7);
		  $tmp4 .= "Users : $tabuser[$j]";
		  $tmp4 .= "</B>" if ($idx == 7);
	      }

	      if ($notrafic == 0) {
		  $tmp4 .= "|";
		  $tmp4 .= "<B>" if ($idx == 5);
		  $tmp4 .= "Traffic : $tmp2&nbsp;$unit";
		  $tmp4 .= "</B>" if ($idx == 5);
	      }
	  }

	  $tmp = $val1." ".$val2." ".$val3;
	  $wday = $day_of_week[(localtime(&nbday("$tmp")*86400))[6]];

	  if ($bargraph == 1) {
	      $map .= "<AREA SHAPE=\"rect\" COORDS=\"$x1,0,$x2,$ymax\" HREF=\"$linkjour\" ALT=\"$tmp\" onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$wday $tmp','$tmp4','','$linkjour',1,'','$popup_graph_width')\">\n";

	  }
	  if ($linegraph == 1) {
	      $tmp5 = $x2-int(($x1+$x2)/2);
	      $x1a = $x1-$tmp5;
	      ;	  $x1b = $x1+$tmp5;
	      $map .= "<AREA SHAPE=\"rect\" COORDS=\"$x1a,0,$x1b,$ymax\" HREF=\"$linkjour\" ALT=\"$tmp\" onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$wday $tmp','$tmp4','','$linkjour',1,'','$popup_graph_width')\">\n";
	  }

	  $date = &date_intervalle($date,1);

	  if ($bargraph == 1) {
	      print FLY "frect $x1,$y2,$x2,$ymax,$red[0],$green[0],$blue[0]\n";
	      print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n";
	      if ($tridim == 1 && $y2 != $ymax) {
		  
		  $x1plus = $x1+$perspec;
		  $x2plus = $x2+$perspec;
		  $y2plus = $y2-$perspec;
		  $y1plus = $ymax - $perspec;

		  print FLY "fpoly $red[0],$green[0],$blue[0],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
		  print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";

		  print FLY "fpoly $red[0],$green[0],$blue[0],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
		  print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
	      }
	  }

	  if ($linegraph == 1) {
	      $y1 = $ymax - ($ystep/$facty * $tab[$j+1]);
	      if ($j != $count_day) {
		  print FLY "line $x1,$y2,$x2,$y1,$red[0],$green[0],$blue[0]\n";
	      }
	      print FLY "fcircle $x1,$y2,3,$red[0],$green[0],$blue[0]\n" if ($y2 < ($ymax-3));

	      for ($k=0;$k<$countx;$k++) {
		  print FLY "dline 0,$line_graphx[$k],$xmax,$line_graphx[$k],150,150,150\n";
	      }
	      for ($k=0;$k<$county;$k++) {
		  print FLY "line $line_graphy[$k],$ymax,$line_graphy[$k],0,150,150,150\n";
	      }
	      
	  }
      }
  }

  if ($count_day == 0) {
        $xlegend = "No enough data to compute graph";
	$posy = $ymax/2;
	$font = "medium";
	print FLY "string 250,100,100,0,$posy,$font,$xlegend\n";
  }
  print FLY "transparent 243,243,243\n";
  close (FLY);
  &BuildFly("$tmpfly$vtmp",$graphpage);

  return $map;

}


#
##############################################################
### PagesHost
##############################################################
#

sub clean_url {
    local($url,$mode) = @_;
    
    if ($mode == 1 || $mode == 2) {
	# to save a filename
	$url =~ s/$dirsepurl/_/g if ($mode == 1);
	$url =~ s/\?(.*)//;
	$url =~ s/\~/_/g; 
	$url =~ s/\&/_/g; 
	$url =~ s/\s+/_/g;
	$url =~ s/\+/_/g;
	$url =~ s/\)/_/g;
	$url =~ s/\(/_/g;
	$url =~ s/[\[\]]/_/g;
	$url =~ s/\*/_/g;
	$url =~ s/\;/_/g;
	$url =~ s/\,/_/g;
	$url =~ s/\=/_/g;
	$url =~ s/\:/_/g;
	$url =~ s/\./_/g;
	$url =~ s/\!/_/g;
    }
    if ($mode == 0) {
#	$url =~ s/\&/\\&/g; 
	$url =~ s/\+/\\+/g; 
	$url =~ s/\~/\\~/g; 
	$url =~ s/\)/\\)/g;
	$url =~ s/\(/\\(/g;
	$url =~ s/[\[\]]//g; 
	$url =~ s/\*/\\*/g;
	$url =~ s/\./_/g;
    }
    if ($mode == 3) {
	$url =~ s/\~/\\~/g; 
	$url =~ s/[\$]/\\\$/g; 
	$url =~ s/\&/\\&/g; 
	$url =~ s/\+/\\+/g; 
	$url =~ s/\)/\\)/g;
	$url =~ s/\(/\\(/g;
	$url =~ s/[\[\]]//g; 
	$url =~ s/\*/\\*/g;
    }

    return $url;
    
}

#  &PagesHostsGraph($page,0) if ($nbpagehost{$tmp} > $seuilsite);
sub PagesHostsGraph {
#  local($val,$mode) = @_;
  local(*FOUT,*L,$I,$val,$mode) = @_;
  local($i,$tmp,@val_page_date,$tmp1,$tmp2,@tab,%tabdate);
  local($date_min,$date_max,$repmax,$count,$page);
  local($start_month,$start_year,$tmp2,$tmp3,$tmp4,$oldmonth,$countmonth,@tabmonth,@tabmonth_date);
  local($countmonth_nb,$tmp1,$tmp2,$tmp3);
  local($repmax,$repmaxmonth);

  if ($mode == 0) {
      $page = $pagehas{$val};
      $val = $page;
      $val = &clean_url($page,3);
  }

  if ($mode == 1) {
      $page = $val;
      $page = &clean_url($page,1);
      $val = &clean_url($val,3);
  }

  
  $tmp = $incpagehost if ($mode == 0);
  $tmp = $incfilehost if ($mode == 1);

  $date_max = 0;
  $repmax = 0;
  $repmaxmonth = 0;


#  print "opening $path$dirinc$dirsep$tmp - $mode - $val - $page\n";
  open(HOSTDATE,"$path$dirinc$dirsep$tmp") || &error_exit("Error, unable to open $path$dirinc$dirsep$tmp");
  while (<HOSTDATE>) {
      chop;
#	  if ((/^$page\t/ && $mode == 0) || (/^$val\t/ && $mode == 1)) {
      if (/^$val\t/) {
	  @val_page_date = split(/\t/);
	  
	  for ($i=1;$i<=$#val_page_date;$i++) {
	      ($tmp1,$tmp2,$tmp3) = split(/\|/,$val_page_date[$i]);
	      ($tmp3,$tmp1) = split(/\t/,$tmp3);
	      $date_min = $tmp3 if ($date_min eq '');
	      $date_min = $tmp3 if ($tmp3 < $date_min);
	      $date_max = $tmp3 if ($tmp3 > $date_max);
	  }
	  last;
      }
  }
  close(HOSTDATE);

  undef @tabdate;
  undef @tab;

  $count_day = $date_max-$date_min+1;
  for ($i=0;$i<($count_day-1);$i++) {
      $tab[$i] = 0;
  }

  for ($i=1;$i<=$#val_page_date;$i++) {
      ($tmp1,$tmp2,$tmp3) = split(/\|/,$val_page_date[$i]);
      ($tmp3,$tmp1) = split(/\t/,$tmp3);
      $idx = $tmp3-$date_min;
#      print "IIVV @val_page_date - $i - $val_page_date[$i] - $idx - $tmp3 - $date_min\n";
      $tab[$idx]++;
#      $tabtridate[$idx] = $tmp3;
      $tabdate[$idx] = $tmp3;
      $repmax = $tab[$idx] if ($tab[$idx] > $repmax);
  }

  $tmp_start = $date_min*86400;
  ($tmp1,$tmp2,$tmp3) = &get_time($tmp_start);

  $start_date = $tmp1;
  $start_date =~ s/\// /g;

  ($tmp2,$tmp3,$tmp4) = split(/\//,$tmp1);
  $start_month = $tmp3;
  $start_year = $tmp4;
  $countmonth = $month_equiv{$tmp3};

  $tmp_linkmap = '';

  #

  $oldmonth = $start_month;
  $tmp_linkmapmois = '';

#  $countmonth_nb = 1;
  $countmonth_nb = 0;

  open(OUT, ">$path$dircsv$dirsep$page$csvext");
  print OUT "#\"Date\";\"Hosts ($val)\"\n";
  for ($i=0;$i<=$#tab;$i++) {
#      print "II $start_date - $i\n";
      $tmp1 = &date_intervalle($start_date,$i);
      $tabdate[$i] = $tmp1;
      ($tmp2,$tmp3,$tmp4) = split(/ /,$tmp1);
      if ($oldmonth ne $tmp3) {
	  $countmonth++;
	  $countmonth_nb++;
	  $countmonth = 1 if ($countmonth == 13);
      }
      $tabmonth[$countmonth_nb] += $tab[$i];
      $tabmonth_date[$countmonth_nb] = "01 $month_nb[$countmonth] $tmp4";
      $oldmonth = $tmp3;
      print OUT "\"$tmp1\";\"$tab[$i]\"\n";
      $repmaxmonth = $tab[$idx] if ($tabmonth[$countmonth_nb] > $repmaxmonth);
  }
  close(OUT);

  $line_month = "<CENTER>\n";
  $line_month .= "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  $line_month .= "<thead>\n";
  $line_month .= "<TR>\n";
  $line_month .= "<TH class=\"table-sortable:date\">&nbsp;$L{'Date'}&nbsp;</TH>\n";
  $line_month .= "<TH class=\"table-sortable:numeric\">$L{'Hosts'}</TH>\n";
  $line_month .= "</TR>\n";
  $line_month .= "</thead>\n";
  $line_month .= "<tbody>\n";

  $repmaxmois = 0;
  $tmp = $path.$dircsv.$dirsep.$page."m".$csvext;
  open(OUT, ">$tmp");
  print OUT "#\"Date\";\"Hosts ($val)\"\n";
  for ($i=0;$i<=$countmonth_nb;$i++) {
      if ($tabmonth[$i] ne '') {
	  $repmaxmois = $tabmonth[$i] if ($repmaxmois < $tabmonth[$i]);
	  $tmp = $tabmonth_date[$i];
	  ($tmp1,$tmp2,$tmp3) = split(/\s/,$tmp);
	  $tmp = "$tmp2 $tmp3";
	  $line_month .= "<TR><TD CLASS=\"left\">$tmp</TD><TD CLASS=\"right\">$tabmonth[$i]</TD></TR>\n";
	  print OUT "\"$tmp\";\"$tabmonth[$i]\"\n";
      }
  }
  close(OUT);
  $line_month .= "</tbody>\n";
  $line_month .= "</TABLE>\n";
  $line_month .= "</CENTER>\n";

### graph
  if ($fly_set == 0 && $repmax != 0) {
      $chart_id = 0;
      $info = "info".$chart_id;
      $ylegend = $L{'Hosts'};
      
      $xlegend = "$count_day $L{'days'} (starting $start_date)";
	  
      undef @ref_tab;
      push(@ref_tab,\@tab);
      
      @ref_tab_name = ('hosts');

      &MakeDailyGraphJqplotInit(*FOUT, eval($Lang{$lang[$nblang]}),$I,1,$unit_div,\@ref_tab,\@ref_tab_name,\@tabdate,$chart_id);
      
      @graph_to_display = ('Hosts');


      &MakeDailyGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,1,\@graph_to_display,\@ref_tab,\@tabdate,\@serie_color,1,$unit,$chart_id,3,"hosts",$info,0,$xlegend,$ylegend,$xmax_jqplot,$dirsite);
      
      &AddJqplotHtml(*FOUT, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_jqplot,$ymax_jqplot,2);

      $chart_id += $#list_graph_name_jqplot+1;
  }

  if ($fly_set == 0) {
      @tabtri = reverse sort bynumber @tab;

      for ($i=0;$i<=$topten;$i++) {
	  for ($j=0;$j<=$#tab;$j++) {
	      if ($tabtri[$i] eq $tab[$j]) {
		  $tabtridate[$i] = $tabdate[$j];
		  $tab[$j] = 0;
		  last;
	      }
	  }
      }

      $line_peak = "<CENTER>\n";
      $line_peak .= "<TABLE BORDER=0>\n";
      $count = 0;
      for ($i=0;$i<=$#tabtridate;$i++) {
	  if ($count <= $topten) {
	      $line_peak .= "<TR>\n";
	      $line_peak .= "<TD><I>";
	      $line_peak .= "$tabtridate[$i]";
	      $line_peak .= "</I></TD>";
	      $tmp1 = int(100*$tabtri[$i]/$repmax) if ($repmax != 0);
	      $line_peak .= "<TD ALIGN=LEFT>";
	      $line_peak .= "<IMG WIDTH=\"$tmp1\" SRC=\"..$dirsepurl..$dirsepurl$dirress$dirsepurl$gcolor[1]\" HEIGHT=\"$square\" ALT=\"$gcolor[1]\">&nbsp;$tabtri[$i]</TD>\n";
	      $line_peak .= "</TR>\n";
	      $count++;
	  }
      }
      $line_peak .= "</TABLE></CENTER>\n";
  }

  if ($fly_set == 0 && $repmaxmonth != 0) {
      &AddPeakTable(*FOUT,*L,$I,$page,$line_peak);

      $info = "info".$chart_id;
      $xlegend = "$count_month $L{'month'} (starting $start_date)";
	  
      undef @ref_tab;
      push(@ref_tab,\@tabmonth);
      
      @ref_tab_name = ('hosts');

      &MakeDailyGraphJqplotInit(*FOUT, eval($Lang{$lang[$nblang]}),$I,3,$unit_div,\@ref_tab,\@ref_tab_name,\@tabmonth_date,$chart_id);
      
      @graph_to_display = ('Hosts');
     
      &MakeDailyGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,3,\@graph_to_display,\@ref_tab,\@tabmonth_date,\@serie_color,1,$unit,$chart_id,3,"hosts",$info,$chart_id,$xlegend,$ylegend,$xmax_jqplot,$dirsite);
      
      &AddJqplotHtml(*FOUT, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_jqplot,$ymax_jqplot,2);

      $chart_id += $#list_graph_name_jqplot+1;

      &AddPeakTable(*FOUT,*L,$I,$page,$line_month);
  }

  if ($fly_set == 1) {

  $graphpage = $path.$dirgraph.$dirsep.$page.$gifext;
  $graphpagex = $path.$dirgraph.$dirsep.$page."x".$gifext;
  $graphpagey = $path.$dirgraph.$dirsep.$page."y".$gifext;

  $graphpagemois = $path.$dirgraph.$dirsep.$page."m".$gifext;
  $graphpagemoisx = $path.$dirgraph.$dirsep.$page."mx".$gifext;
  $graphpagemoisy = $path.$dirgraph.$dirsep.$page."my".$gifext;

  $it = length($count_day)-1;
  $div = 10**$it;
  $factx = ($div*(int($count_day/$div)+1))/$grad;
  
  $it = length($repmax)-1;
  $div = 10**$it;
  $facty = ($div*(int($repmax/$div)+1))/$grad;

  $fymax = $ymax-2;

  open(FLY,">$tmpfly$vtmp");
  print FLY "new\n";
  print FLY "size $xmax,$ymax\n";
  print FLY "frect 0,0,$xmax,$ymax,200,200,200\n";
  
  for ($j=1;$j<=($count_day+$bargraph);$j++) {

      $x1 = ($j-1+$linegraph)*$xstep/$factx;
      $x2 = ($j+$linegraph)*$xstep/$factx;

      $y2 = $ymax - ($ystep/$facty * $tab[$j]);

      if ($bargraph == 1) {
	  print FLY "frect $x1,$y2,$x2,$ymax,$red[0],$green[0],$blue[0]\n";
	  print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n";
	  if ($tridim == 1 && $y2 != $ymax) {

	      $x1plus = $x1+$perspec;
	      $x2plus = $x2+$perspec;
	      $y2plus = $y2-$perspec;
	      $y1plus = $ymax - $perspec;

	      print FLY "fpoly $red[0],$green[0],$blue[0],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
	      print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";

	      print FLY "fpoly $red[0],$green[0],$blue[0],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
	      print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
	  }
      }

      if ($linegraph == 1) {
	  $y1 = $ymax - ($ystep/$facty * $tab[$j+1]);
	  print FLY "line $x1,$y2,$x2,$y1,$red[0],$green[0],$blue[0]\n";

	  if ($fillgraph == 1) {
	      $fx1 = ($x1+$x2)/2;
	      $fx1 = $x2 if ($fx1 < ($x1+1.5));
	      if ($fx1 < $x2 && ($y2 < $fymax || $y1 < $fymax)) {
		  print FLY "line $x1,$ymax,$x1,$y2,$red[0],$green[0],$blue[0]\n";
		  print FLY "line $x2,$ymax,$x2,$y1,$red[0],$green[0],$blue[0]\n";

		  print FLY "line $x1,$ymax,$x2,$ymax,$red[0],$green[0],$blue[0]\n";
		  print FLY "fill $fx1,$fymax,$red[0],$green[0],$blue[0]\n";
	      }
	  }
      }

      if ($tab[$j] ne '') {
#	  $tmp = $tabtridate[$j]*86400;
	  $tmp = $tabdate[$j]*86400;
	  ($tmp1) = &get_time($tmp);
	  ($tmp,$tmp1,$tmp2) = split(/\//,$tmp1);
	  $tmp3 = "$pathserver$linkpath_url$I$dirsepurl$dirdate$dirsepurl$tmp2-$tmp1-$tmp$dirsepurl$dirpage$htmlext";
	  $tmp5 = "Requests : $tab[$j]";
	  if (-f $tmp3) {
	      $tmp_linkmap .= "<AREA SHAPE=\"rect\" COORDS=\"$x1,0,$x2,$ymax\" HREF=\"..$dirsepurl$dirdate$dirsepurl$tmp2-$tmp1-$tmp$dirsepurl$dirpage$htmlext\" onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$tmp2-$tmp1-$tmp','$tmp5','','',1,'','$popup_graph_width')\" ALT=\"$tmp2-$tmp1-$tmp\">\n";
	  }
      }

  }

  print FLY "transparent 200,200,200\n";
  close (FLY);

  &BuildFly("$tmpfly$vtmp",$graphpage);

### image pour les abscisses

  $xlegend = "$count_day days (starting $start_date)";

  ($startday, $startmonth) = split(/ /,$start_date);

  $moischiffre = $month_equiv{$startmonth};
  $moischiffre--;
  $moisvar = $startmonth;
  $valmois = $moischiffre;

  $valstep = $startday;
  $valstep = "0".$valstep if (length($valstep) == 1);

  open(FLY,">$tmpfly$vtmp");
  print FLY "new\n";
  print FLY "size $xmax,$ydecal\n";
  print FLY "frect 0,0,$xmax,$ydecal,200,200,200\n";
  $posx = (($xmax/2)-(length($xlegend)*7/2));
  print FLY "string 0,0,0,$posx,$ydecalm,medium,$xlegend\n";

  for ($j=$xstep;$j<$xmax;$j+=$xstep) {

      $valstep = int(($j/$xmax)*(($xmax*$factx/$xstep)))+$startday;

      $moisvar = $startmonth;
      $valmois = $moischiffre;

      while  ($valstep > $month_of_year{$moisvar}) {
	  $valstep = ($valstep - $month_of_year{$moisvar});
	  $valmois++;
	  $valmois = 0 if ($valmois > 11);
	  $moisvar = $month_nb[$valmois];
      }

      $valstep = "0".$valstep if (length($valstep) == 1);
      $val = "$moisvar/$valstep";
      $posx = $j - length($valstep)*10;
      print FLY "line $j,0,$j,5,0,0,0\n";
      print FLY "string 0,0,0,$posx,10,small,$val\n";
  }

  print FLY "transparent 200,200,200\n";
  close (FLY);

  &BuildFly("$tmpfly$vtmp",$graphpagex);

### image pour les ordonnees

  open(FLY,">$tmpfly$vtmp");
  print FLY "new\n";
  print FLY "size $xdecal,$ymax\n";
  print FLY "frect 0,0,$xdecal,$ymax,200,200,200\n";
  $posy = $ymax - (($ymax/2)-(length("Hosts")));
  print FLY "stringup 0,0,0,5,$posy,medium,Hosts\n";

  for ($j=$ystep;$j<$ymax;$j+=$ystep) {
      $valstep = int(($ymax - $j) * ($facty/$ystep));
      $valstep_next = int(($ymax - $j - $ystep) * ($facty/$ystep));
      $pos = ($xdecal - length($valstep)*13);
      $posy = $j-5;
      print FLY "line $xdecalm,$j,$xdecal,$j,0,0,0\n";
      if ($valstep != 0) {
	  print FLY "string 0,0,0,$pos,$posy,small,$valstep\n" if ($valstep_next != $valstep);
      }
 }
  
  $tmp = $xdecal-1;

  print FLY "line $tmp,0,$tmp,$ymax,0,0,0\n";
  print FLY "transparent 200,200,200\n";

  close (FLY);

  &BuildFly("$tmpfly$vtmp",$graphpagey);


############


### graph
   
  $it = length($countmonth_nb); #-1;
  $div = 10**$it;
  $factx = ($div*(int($countmonth_nb/$div)+1))/$grad;
  
  $it = length($repmaxmois)-1;
  $div = 10**$it;
  $facty = ($div*(int($repmaxmois/$div)+1))/$grad;
  
  $fymax = $ymax-2;

  open(FLY,">$tmpfly$vtmp");
  print FLY "new\n";
  print FLY "size $xmax,$ymax\n";
  print FLY "frect 0,0,$xmax,$ymax,200,200,200\n";
  
  for ($j=0;$j<=($countmonth_nb+$bargraph+1);$j++) {

      $x1 = ($j+$linegraph)*$xstep/$factx;
      $x2 = ($j+1+$linegraph)*$xstep/$factx;

      $y2 = $ymax - ($ystep/$facty * $tabmonth[$j]);

      if ($bargraph == 1) {
	  print FLY "frect $x1,$y2,$x2,$ymax,$red[0],$green[0],$blue[0]\n";
	  print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n";
	  if ($tridim == 1 && $y2 != $ymax) {

	      $x1plus = $x1+$perspec;
	      $x2plus = $x2+$perspec;
	      $y2plus = $y2-$perspec;
	      $y1plus = $ymax - $perspec;

	      print FLY "fpoly $red[0],$green[0],$blue[0],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
	      print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";

	      print FLY "fpoly $red[0],$green[0],$blue[0],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
	      print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
	  }
      }

      if ($linegraph == 1) {
	  $y1 = $ymax - ($ystep/$facty * $tabmonth[$j+1]);
	  print FLY "line $x1,$y2,$x2,$y1,$red[0],$green[0],$blue[0]\n";

	  if ($fillgraph == 1) {
	      $fx1 = ($x1+$x2)/2;
	      $fx1 = $x2 if ($fx1 < ($x1+1.5));
	      if ($fx1 < $x2 && ($y2 < $fymax || $y1 < $fymax)) {
		  print FLY "line $x1,$ymax,$x1,$y2,$red[0],$green[0],$blue[0]\n";
		  print FLY "line $x2,$ymax,$x2,$y1,$red[0],$green[0],$blue[0]\n";

		  print FLY "line $x1,$ymax,$x2,$ymax,$red[0],$green[0],$blue[0]\n";
		  print FLY "fill $fx1,$fymax,$red[0],$green[0],$blue[0]\n";
	      }
	  }
      }

      if ($tabmonth[$j] ne '') {
	  ($tmp2,$tmp1) = split(/-/,$tabmonth_date[$j]);
	  $tmp3 = "$pathserver$linkpath_url$I$dirsepurl$dirdate$dirsepurl$tmp2-$tmp1$dirsepurl$dirpage$htmlext";
	  $tmp5 = "Requests : $tabmonth[$j]";
	  if (-f $tmp3) {
	      $tmp_linkmapmois .= "<AREA SHAPE=\"rect\" COORDS=\"$x1,0,$x2,$ymax\" HREF=\"..$dirsepurl$dirdate$dirsepurl$tmp2-$tmp1$dirsepurl$dirpage$htmlext\" onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$tmp2-$tmp1','$tmp5','','',1,'','$popup_graph_width')\" ALT=\"$tmp2-$tmp1\">\n";
	  }
      }

  }

  print FLY "transparent 200,200,200\n";
  close (FLY);

  &BuildFly("$tmpfly$vtmp",$graphpagemois);

### image pour les abscisses

  $tmp = $countmonth_nb+1;
  $xlegend = "$tmp month";
  $xlegend .= "s" if ($countmonth_nb > 0);
  $xlegend .= " (starting $start_month $start_year)";

  open(FLY,">$tmpfly$vtmp");
  print FLY "new\n";
  print FLY "size $xmax,$ydecal\n";
  print FLY "frect 0,0,$xmax,$ydecal,200,200,200\n";
  $posx = (($xmax/2)-(length($xlegend)*7/2));
  print FLY "string 0,0,0,$posx,$ydecalm,medium,$xlegend\n";
  for ($i=$xstep;$i<$xmax;$i+=$xstep) {
    $val = ($i*$factx/$xstep);
    $val--;
    $val += 12 if ($val < 0);
    $val -= 12 if ($val > 11);
    $posx = $i - 8;
    print FLY "line $i,0,$i,5,0,0,0\n";
#    print "AA $val - $i - $factx / $xstep\n";
    print FLY "string 0,0,0,$posx,10,small,$month_nb[$val]\n";
  }
  print FLY "transparent 200,200,200\n";
  close (FLY);
  
  &BuildFly("$tmpfly$vtmp",$graphpagemoisx);

### image pour les ordonnees

  open(FLY,">$tmpfly$vtmp");
  print FLY "new\n";
  print FLY "size $xdecal,$ymax\n";
  print FLY "frect 0,0,$xdecal,$ymax,200,200,200\n";
  $posy = $ymax - (($ymax/2)-(length("Hosts")));
  print FLY "stringup 0,0,0,5,$posy,medium,Hosts\n";

  for ($j=$ystep;$j<$ymax;$j+=$ystep) {
      $valstep = int(($ymax - $j) * ($facty/$ystep));
      $valstep_next = int(($ymax - $j - $ystep) * ($facty/$ystep));
      $pos = ($xdecal - length($valstep)*13);
      $posy = $j-5;
      print FLY "line $xdecalm,$j,$xdecal,$j,0,0,0\n";
      if ($valstep != 0) {
	  print FLY "string 0,0,0,$pos,$posy,small,$valstep\n" if ($valstep_next != $valstep);
      }
 }
  
  $tmp = $xdecal-1;

  print FLY "line $tmp,0,$tmp,$ymax,0,0,0\n";
  print FLY "transparent 200,200,200\n";

  close (FLY);

  &BuildFly("$tmpfly$vtmp",$graphpagemoisy);
  }





}

sub FileHosts {
  local(*FOUT,*L,$I,$page,$count_revlink) = @_;
  local($i,$tmp,$newserveur,$domadresse,$date);
  local($page2,$reverselink,$reverselink2);

  for ($i=1;$i<=$count_revlink;$i++) {
      $reverselink .= "..$dirsepurl";
  }

  $reverselink2 = '';
  if ($precision > 3) {
      for ($i=1;$i<=($count_revlink-2);$i++) {
	  $reverselink2 .= "..$dirsepurl";
      }
  }

  print FOUT "$doctype\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE> $L{'Stats'} - $L{'Hosts'} - $page</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$reverselink$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$reverselink$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$reverselink$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$reverselink$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$reverselink$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$reverselink$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";
  &add_jqplot_js(*FOUT,2);

  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2); 
  print FOUT "<H2> $L{'Files'} : $page</H2><P>\n";
  print FOUT "<P><HR><P>\n";

  $tmp = $page;
  $line_peak = '';

  $page2 = $page;
  $page2 = &clean_url($page2,1);
#  $page2 =~ s/\?(.*)//;
#  $page2 =~ s/$dirsepurl/_/g;

  &help_div(*FOUT);

  if ($fly_set == 1) {
      $linkgraphpage = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$page2.$gifext;
      $linkgraphpagex = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$page2."x".$gifext;
      $linkgraphpagey = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$page2."y".$gifext;
      
      $linkgraphpagemois = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$page2."m".$gifext;
      $linkgraphpagemoisx = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$page2."mx".$gifext;
      $linkgraphpagemoisy = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$page2."my".$gifext;
  }

  $tmp10 = $nbfilehost{$tmp};
  $tmp10 = $max_item_page if ($tmp10 > $max_item_page);

  print FOUT "<TABLE BORDER=0><TR>";
  print FOUT "<TD ALIGN=LEFT VALIGN=TOP>";

  print FOUT "<H3>$tmp10 ";
  print FOUT "$L{'among'} $nbfilehost{$tmp} " if ($tmp10 == $max_item_page);
  print FOUT "$L{'hosts'}" if ($nbfilehost{$tmp} > 1);
  print FOUT "$L{'host'}" if ($nbfilehost{$tmp} == 1) ;
  print FOUT " - $filetype{$page} $L{'times'}</H3><P>\n";

#  print FOUT "\n<table><tr><td valign=top>";  

  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe ";
  print FOUT "table-autopage:$table_big_lines_aff " if ($tmp10 > $table_big_lines_aff);
  print FOUT "table-stripeclass:alternate\" id=\"page\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Occurence'}</TH>\n";
  print FOUT "<TH class=\"table-sortable:date\">$L{'Last_occurence'}</TH>\n";
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";

  if ($tmp10 > $table_big_lines_aff) {	

	$tmp2 = int($tmp10/$table_big_lines_aff);
	if ($tmp2 != ($tmp10/$table_big_lines_aff)) {
	    $tmp2++;
	}

    	print FOUT "<tfoot>\n";
	print FOUT "<tr>\n";
	print FOUT "<TH>$L{'Hosts'}</TH>\n";
	print FOUT "<TH>$L{'Occurence'}</TH>\n";
	print FOUT "<TH>$L{'Last_occurence'}</TH>\n";
	print FOUT "</tr>\n";
	print FOUT "<tr>\n";
	
	if ($tmp2 > 1) {
	    print FOUT "<td colspan=3>\n";
	    print FOUT "<a href=\"#\" onclick=\"pageexample('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	    
	    for ($i=1;$i<=$tmp2;$i++) {
		$iminus = $i-1;
		print FOUT "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexample($iminus); return false;\">$i</a>\n";
	    }
	    print FOUT "<a href=\"#\" onclick=\"pageexample('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	    print FOUT "<a href=\"#\" onclick=\"pageexample('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	    print FOUT "</td>\n";
	    print FOUT "</tr>\n";
	}
	print FOUT "</tfoot>\n";
  }


  print FOUT "<tbody>\n";

  for ($i=1;$i<=$tmp10;$i++) {
      $adresse = $filelist{$tmp,$i};
      print FOUT "<TR>\n";
      print FOUT "<TD CLASS=\"left\">";
      print FOUT "<I>" if ($adresse =~ /$localdomainename$/i);

      $newserveur = $adresse;
      $newserveur =~ s/[.:]/_/g;
		
      if ($adresse =~ /[0-9]+$/ || $adresse =~ /:/) {
	  print FOUT "<A HREF=\"\.\.$dirsepurl$dirsite$dirsepurl$newserveur$htmlext\">" if (-f "$path$I$dirsepurl$dirsite$dirsepurl$newserveur$htmlext");
	  print FOUT "$adresse";
	  print FOUT "</A> " if (-f "$path$I$dirsepurl$dirsite$dirsepurl$newserveur$htmlext");
      } else {
	  $pospoint = index($adresse,'.',0);
	  $domadresse = substr($newserveur,$pospoint+1,(length($newserveur)-length($pospoint)));
	  $domadresse = $newserveur if ($domadresse !~ /_/);
	  print FOUT "<A HREF=\"\.\.$dirsepurl$dirsite$dirsepurl$domadresse$htmlext#$adresse\"\>" if (-f "$path$I$dirsepurl$dirsite$dirsepurl$domadresse$htmlext");
	  print FOUT "$adresse";
	  print FOUT "</A>" if (-f "$path$I$dirsepurl$dirsite$dirsepurl$domadresse$htmlext");
      }

      print FOUT "</I>" if ($adresse =~ /$localdomainename$/i);
      print FOUT "</TD>\n";
      print FOUT "<TD CLASS=\"right\">$filelist_host{$tmp,$adressehad{$adresse}}</TD>\n";
      $tmp2 = $filelist_date{$tmp,$adressehad{$adresse}};
      ($date) = &get_time($tmp2*86400);
      $date =~ s/\// /g;
      print FOUT "<TD CLASS=\"right\">$date</TD>\n";
      print FOUT "</TR>\n";
  }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n";

  print FOUT "</TD><TD VALIGN=TOP>\n";


  if ($nbfilehost{$tmp} > $seuilsite) {
      print FOUT "<P><BR>\n";

#      print "Sending2 $page - $tmp\n";

      print FOUT "<TABLE><TR><TD ALIGN=CENTER VALIGN=TOP>\n";

      &PagesHostsGraph(*FOUT,*L,$I,$page,1) if ($fly_set == 0);

      if ($fly_set == 1) {
	  print FOUT "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
	  print FOUT "<TR>\n";
	  print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linkgraphpagey\" ALT=\"y\"></TD>\n";
	  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"$linkgraphpage\" ALT=\"graph1\" BORDER=0 USEMAP=\"#pageday\"></TD>\n";
	  print FOUT "</TR><TR><TD></TD>\n";
	  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linkgraphpagex\" ALT=\"x\"></TD>\n";
	  print FOUT "</TR>\n";
	  print FOUT "</TABLE></CENTER>\n";

	  print FOUT "</TD></TR><TR><TD ALIGN=CENTER>\n";

	  &AddPeakTable(*FOUT,*L,$I,$page2,$line_peak);


#	  print FOUT "<TABLE><TR><TD ALIGN=CENTER>\n";
#	  print FOUT "$line_peak\n";
#	  print FOUT "</TD><TD ALIGN=CENTER VALIGN=TOP>\n";
#	  print FOUT "<A HREF=\"$reverselink$dircsv$dirsepurl$page2$csvext\" TITLE=\"Export in CSV\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"$reverselink$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>";
#	  print FOUT "</TD></TR>\n";
#	  print FOUT "</TABLE>\n";


	  print FOUT "</TD></TR>";
	  print FOUT "<TR><TD>";

	  print FOUT "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
	  print FOUT "<TR>\n";
	  print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linkgraphpagemoisy\" ALT=\"y\"></TD>\n";
	  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"$linkgraphpagemois\" ALT=\"graph1\" BORDER=0 USEMAP=\"#pagemonth\"></TD>\n";
	  print FOUT "</TR><TR><TD></TD>\n";
	  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linkgraphpagemoisx\" ALT=\"x\"></TD>\n";
	  print FOUT "</TR>\n";
	  print FOUT "</TABLE></CENTER>\n";
	  
	  print FOUT "</TD></TR><TR><TD ALIGN=CENTER>\n";
	  
	  $tmp = $page2."m";
	  &AddPeakTable(*FOUT,*L,$I,$tmp,$line_month);

#	  print FOUT "<TABLE><TR><TD ALIGN=CENTER>\n";
#	  print FOUT "$line_month\n";
#	  print FOUT "</TD><TD ALIGN=CENTER VALIGN=TOP>\n";
#	  $tmp2 = $page2."m";
#	  print FOUT "<A HREF=\"$reverselink$dircsv$dirsepurl$tmp2$csvext\" TITLE=\"Export in CSV\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"$reverselink$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>";
#	  print FOUT "</TD></TR>\n";
#	  print FOUT "</TABLE>\n";


	  print FOUT "</TD></TR></TABLE>\n";

	  print FOUT "<MAP NAME=\"pageday\">\n";
	  print FOUT "$tmp_linkmap";
	  print FOUT "</MAP>\n";

	  if ($tmp_linkmapmois ne '') {
	      print FOUT "<MAP NAME=\"pagemonth\">\n";
	      print FOUT "$tmp_linkmapmois";
	      print FOUT "</MAP>\n";
	  }
      }
  }

  print FOUT "</TD></TR></TABLE>\n";
  print FOUT "</TD></TR></TABLE>\n";
  print FOUT "</BODY></HTML>\n";
}

sub PagesHosts {
  local(*FOUT,*L,$I,$page) = @_;
  local($i,$tmp,$newserveur,$domadresse,$date);

  print FOUT "$doctype\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE> $L{'Stats'} - $L{'Pages'} - $L{'Hosts'} - $page</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_jqplot_js(*FOUT,2);
  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2); 
  print FOUT "<H2> $L{'Pages'} : $page</H2><P>\n";
#  print FOUT "<P><HR><P>\n";

  $tmp = $pagehas{$page};
  $line_peak = '';

  &help_div(*FOUT);

  if ($fly_set == 1) {
      $linkgraphpage = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$tmp.$gifext;
      $linkgraphpagex = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$tmp."x".$gifext;
      $linkgraphpagey = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$tmp."y".$gifext;

      $linkgraphpagemois = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$tmp."m".$gifext;
      $linkgraphpagemoisx = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$tmp."mx".$gifext;
      $linkgraphpagemoisy = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$tmp."my".$gifext;
  }

  $tmp10 = $nbpagehost{$tmp};
  $tmp10 = $max_item_page if ($tmp10 > $max_item_page);

#  print FOUT "<TABLE><TR>";
#  print FOUT "<TD ALIGN=LEFT VALIGN=TOP>";

  print FOUT "<I>$tmp10 ";
  print FOUT "$L{'among'} $nbpagehost{$tmp} " if ($tmp10 == $max_item_page);
  print FOUT "$L{'hosts'}" if ($nbpagehost{$tmp} > 1);
  print FOUT "$L{'host'}" if ($nbpagehost{$tmp} == 1) ;
  print FOUT " - $pageslues{$page} $L{'times'}</I><P>\n";


  print FOUT "\n<table><tr><td valign=top>";  

  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe ";
  print FOUT "table-autopage:$table_big_lines_aff " if ($tmp10 > $table_big_lines_aff);
  print FOUT "table-stripeclass:alternate\" id=\"page\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Occurence'}</TH>\n";
  print FOUT "<TH class=\"table-sortable:date\">$L{'Last_occurence'}</TH>\n";
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";

  if ($tmp10 > $table_big_lines_aff) {	

	$tmp2 = int($tmp10/$table_big_lines_aff);
	if ($tmp2 != ($tmp10/$table_big_lines_aff)) {
	    $tmp2++;
	}

    	print FOUT "<tfoot>\n";
	print FOUT "<tr>\n";
	print FOUT "<TH>$L{'Hosts'}</TH>\n";
	print FOUT "<TH>$L{'Occurence'}</TH>\n";
	print FOUT "<TH>$L{'Last_occurence'}</TH>\n";
	print FOUT "</tr>\n";
	print FOUT "<tr>\n";
	
	if ($tmp2 > 1) {
	    print FOUT "<td colspan=3>\n";
	    print FOUT "<a href=\"#\" onclick=\"pageexample('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	    
	    for ($i=1;$i<=$tmp2;$i++) {
		$iminus = $i-1;
		print FOUT "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexample($iminus); return false;\">$i</a>\n";
	    }
	    print FOUT "<a href=\"#\" onclick=\"pageexample('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	    print FOUT "<a href=\"#\" onclick=\"pageexample('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	    print FOUT "</td>\n";
	    print FOUT "</tr>\n";
	}
	print FOUT "</tfoot>\n";
  }


  print FOUT "<tbody>\n";

  for ($i=1;$i<=$tmp10;$i++) {
      $adresse = $pagelist{$tmp,$i};
      print FOUT "<TR>\n";
      print FOUT "<TD CLASS=\"left\">";
      print FOUT "<I>" if ($adresse =~ /$localdomainename$/i);

      $newserveur = $adresse;
      $newserveur =~ s/[.:]/_/g;
		
      if ($adresse =~ /[0-9]+$/ || $adresse =~ /:/) {
	  print FOUT "<A HREF=\"\.\.$dirsepurl$dirsite$dirsepurl$newserveur$htmlext\">" if (-f "$path$I$dirsepurl$dirsite$dirsepurl$newserveur$htmlext");
	  print FOUT "$adresse";
	  print FOUT "</A> " if (-f "$path$I$dirsepurl$dirsite$dirsepurl$newserveur$htmlext");
      } else {
	  $pospoint = index($adresse,'.',0);
	  $domadresse = substr($newserveur,$pospoint+1,(length($newserveur)-length($pospoint)));
	  $domadresse = $newserveur if ($domadresse !~ /_/);
	  print FOUT "<A HREF=\"\.\.$dirsepurl$dirsite$dirsepurl$domadresse$htmlext#$adresse\"\>" if (-f "$path$I$dirsepurl$dirsite$dirsepurl$domadresse$htmlext");
	  print FOUT "$adresse";
	  print FOUT "</A>" if (-f "$path$I$dirsepurl$dirsite$dirsepurl$domadresse$htmlext");
      }

      print FOUT "</I>" if ($adresse =~ /$localdomainename$/i);
      print FOUT "</TD>\n";
      print FOUT "<TD CLASS=\"right\">$pagelist_host{$tmp,$adressehad{$adresse}}</TD>\n";
      $tmp2 = $pagelist_date{$tmp,$adressehad{$adresse}};
      ($date) = &get_time($tmp2*86400);
      $date =~ s/\// /g;
      print FOUT "<TD CLASS=\"right\">$date</TD>\n";
      print FOUT "</TR>\n";
  }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n";

  print FOUT "</TD><TD VALIGN=TOP>\n";

  if ($nbpagehost{$tmp} > $seuilsite) {
      print FOUT "<P><BR>\n";

#      print "Sending $page - $tmp\n";

      print FOUT "<TABLE><TR><TD ALIGN=CENTER>\n";

      &PagesHostsGraph(*FOUT,*L,$I,$page,0); # if ($fly_set == 0);

      if ($fly_set == 1) {
	  print FOUT "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
	  print FOUT "<TR>\n";
	  print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linkgraphpagey\" ALT=\"y\"></TD>\n";
	  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"$linkgraphpage\" ALT=\"graph1\" BORDER=0 USEMAP=\"#pageday\"></TD>\n";
	  print FOUT "</TR><TR><TD></TD>\n";
	  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linkgraphpagex\" ALT=\"x\"></TD>\n";
	  print FOUT "</TR>\n";
	  print FOUT "</TABLE></CENTER>\n";

	  print FOUT "</TD></TR><TR><TD ALIGN=CENTER>\n";

	  &AddPeakTable(*FOUT,*L,$I,$tmp,$line_peak);
      
	  print FOUT "</TD></TR>";
	  print FOUT "<TR><TD>";

	  print FOUT "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
	  print FOUT "<TR>\n";
	  print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linkgraphpagemoisy\" ALT=\"y\"></TD>\n";
	  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"$linkgraphpagemois\" ALT=\"graph1\" BORDER=0 USEMAP=\"#pagemonth\"></TD>\n";
	  print FOUT "</TR><TR><TD></TD>\n";
	  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linkgraphpagemoisx\" ALT=\"x\"></TD>\n";
	  print FOUT "</TR>\n";
	  print FOUT "</TABLE></CENTER>\n";

	  print FOUT "</TD></TR><TR><TD ALIGN=CENTER>\n";

	  $tmp = $tmp."m";
	  &AddPeakTable(*FOUT,*L,$I,$tmp,$line_month);

	  print FOUT "</TD></TR></TABLE>\n";

	  print FOUT "<MAP NAME=\"pageday\">\n";
	  print FOUT "$tmp_linkmap";
	  print FOUT "</MAP>\n";
	  
	  if ($tmp_linkmapmois ne '') {
	      print FOUT "<MAP NAME=\"pagemonth\">\n";
	      print FOUT "$tmp_linkmapmois";
	      print FOUT "</MAP>\n";
	  }
      }

  }

  print FOUT "</TD></TR></TABLE>\n";
  print FOUT "</TD></TR></TABLE>\n";
  print FOUT "</BODY></HTML>\n";

}


sub AddPeakTable {
    local(*FOUT,*L,$I,$tmp,$line_peak) = @_;

    print FOUT "<TABLE><TR><TD ALIGN=CENTER>\n";
    print FOUT "$line_peak\n";
    print FOUT "</TD><TD ALIGN=CENTER VALIGN=TOP>\n";
    print FOUT "<A HREF=\"..$dirsepurl..$dirsepurl$dircsv$dirsepurl$tmp$csvext\" TITLE=\"Export in CSV\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>";
    print FOUT "</TD></TR>\n";
    print FOUT "</TABLE>\n";

}

#
##############################################################
### PagesDir
##############################################################
#

sub PagesDirPopUp {
  local(*FOUT,*L,$I,$racine) = @_;
  local(%tmp_page,$tmp3);

  print FOUT "<DIV STYLE=\"border-style:solid;border-width:1px;border-color:#000000;font-size:10px\">\n";
  print FOUT "\n<table border=0 cellpadding=0 cellspacing=0>\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"head\">&nbsp;$L{'Page'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"head\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"head\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"head\">&nbsp;$L{'Total'}&nbsp;%&nbsp;</TH>\n";
  print FOUT "<TH class=\"head\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n" if ($precision > 3);
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody CLASS=\"font-size:small\">\n";

  for ($j=1;$j<=$count{$racine};$j++) {
      $page = $newpageslues{$racine,$j};
      $tmp_page{$page} = $pageslues{$page};
  }

  foreach $page (&reverse_sort_by_value(*tmp_page)) {

	  print FOUT "<TR><TD CLASS=\"left_alter\">";

	  $link = &AddHREF($page);
	  print FOUT "$link";

#          print FOUT "$page" if ($titlename == 0);
 #         print FOUT "<b>$urlconv{$page}</b>" if ($titlename == 1 && $urlconv{$page} ne '');
  #        print FOUT "$page" if ($titlename == 1 && $urlconv{$page} eq '');
	  print FOUT "</TD>\n";
	  print FOUT "<TD CLASS=\"right_alter\">";

	  print FOUT "<B>$pageslues{$page}</B>";

	  $percentage = $pageslues{$page}*100/$freq2rachtml{$racine} if ($freq2rachtml{$racine} != 0);
	  $percentage = 0 if ($freq2rachtml{$racine} == 0);
	  
	  print FOUT "</TD>\n<TD CLASS=\"right_alter\">";
	  printf FOUT "%.1f %",$percentage;
	  print FOUT "</TD>\n";
	  $tmp3 = $pageslues{$page}*100/$access if ($access != 0);

	  print FOUT "<TD CLASS=\"right_alter\">";
	  printf FOUT "%.2f</TD>",$tmp3;

	  print FOUT "<TD CLASS=\"right_alter\">$nbpagehost{$pagehas{$page}}</TD>\n" if ($precision > 3);

	  print FOUT "</TR>\n";
      }

  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n";
  print FOUT "</div>\n";

}

sub PagesDir {
  local(*FOUT,*L,$I,$racine,$tmp_acc,$count_revlink) = @_;
  local($i,$tmp,$tmp2,$tmp2a,$tmp2b,$tmp2c,$tmp2d,$tmp3,$tmp5,$tmp6,$count,$reverselink,$reverselink2,$cur);
  local($found);

  for ($i=1;$i<=$count_revlink;$i++) {
      $reverselink .= "..$dirsepurl";
  }

  $reverselink2 = '';
  if ($precision > 3) {
      for ($i=1;$i<=($count_revlink-2);$i++) {
	  $reverselink2 .= "..$dirsepurl";
      }
  }

  print FOUT "$doctype\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE> $L{'Stats'} - $L{'Pages'} - $racine</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
#  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\">\n";
#  print FOUT "function PopIt(ref,x,y) {\n";
#  print FOUT "var xwin;\n";
#  print FOUT "var ywin;\n";
#  print FOUT "xwin = x+100;\n";
#  print FOUT "ywin = y*2;\n";
#  print FOUT "popup = window.open(\"\"+ref,\"popDialog\",\"height=\"+ywin+\",width=\"+xwin+\",scrollbars=yes,resizable=yes\")\n";
##  print FOUT "popup = window.open(\"\"+ref,\"popDialog\",\"height=\"+ywin+\",width=\"+xwin+\",resizable=yes\")\n";
#  print FOUT "popup.focus()\n";
#  print FOUT "}\n";
#  print FOUT "</SCRIPT>\n";

  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$reverselink$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$reverselink$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$reverselink$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$reverselink$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$reverselink$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$reverselink$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  &add_jqplot_js(*FOUT,$count_revlink);

  $tmp3 = $curvy_bottom_jss;

  if ($w3perlcgiurl ne '' && -d $cgipath_install && $precision > 2) {
      $tmp4 = $opt_c;
      $tmp4 = substr($tmp4,rindex($tmp4,$dirsep)+1,length($tmp4)) if ($opt_c =~ /^\//);
#  $found = 0;

      for ($j=1;$j<=$count{$racine};$j++) {
	  $page = $newpageslues{$racine,$j};
	  if ($pageslues{$page} > $seuilpage) {
#	      if ($w3perlcgiurl ne '' && -d $cgipath_install && $precision > 2) {
		  $tmp6 = "javascript:GraphHosts('$cgipagegraph',";
		  $tmp6 .= "'$tmp4'," if ($opt_c ne '');
		  $tmp6 .= "'config.pl'," if ($opt_c eq '');
		  $tmp6 .= "'$pagehas{$page}',";
		  $tmp6 .= "'0',";
		  $tmp6 .= "'$I'";
		  $tmp6 .= ");";
#	      $found = 1;
		  last;
#	      }
	  }
      }
  
#  if ($fly_set == 0) {
#      $tmp6 .= "\$(function(){\n";
#      $tmp6 .= "\n\$(\"#response-div\").find(\"script\").each(function(i) {\n";
#      $tmp6 .= "eval(\$(this).text());\n";
#      $tmp6 .= "});\n";
#      $tmp6 .= "});\n";
#  }

      $tmp3 =~ s/UpdateToolHeader\(\);/UpdateToolHeader\(\);\n$tmp6/;
  }

#  print FOUT "$curvy_bottom_jss\n";
  print FOUT "$tmp3\n";

  &add_css_style(*FOUT,$count_revlink);

  print FOUT "</HEAD>\n";

  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\"";
#  print FOUT " onLoad=\"$tmp6\"" if ($found == 1);
  print FOUT ">\n";

  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,$count_revlink);

  print FOUT "<H2> $L{'Directories'} : $racine</H2><P>\n";
  print FOUT "<P><HR><P>\n";

  &help_div(*FOUT);

  print FOUT "<H3> $L{'ListOf'} $L{'pages'} - $L{'internal'}</H3><P>\n";

  if ($seuilpage != 1 && $seuilpage != 0) {
      print FOUT "<I>($L{'Only_pages'} $L{'with_at_least'} $seuilpage $L{'accesses'} $L{'are_shown'})</I>\n<P>";

      print FOUT "<TABLE><TR>\n";
      print FOUT "<TH CLASS=\"left\">$L{'Files'}</TH>\n";
      print FOUT "<TD CLASS=\"head_left\">$freqracurl{$racine} ($L{'among'} $freqracurltot{$racine})</TD>\n";
      print FOUT "</TR>\n";
      print FOUT "<TR>\n";
      print FOUT "<TH CLASS=\"left\">$L{'Occurence'}</TH>\n";
      print FOUT "<TD CLASS=\"head_left\">$tmp_acc ($L{'among'} $freq2rachtml{$racine})</TD>\n";
      print FOUT "</TR></TABLE>\n";
  }

  print FOUT "<P>\n<TABLE>\n<TR>\n";
  print FOUT "<TD>&nbsp;<IMG SRC=\"$reverselink$linkpathinit$dirress$dirsepurl$array_up\" WIDTH=12 HEIGHT=12 ALT=\"up\">&nbsp;</TD>\n<TD>&nbsp;$L{'Increase_over_the_previous_day'}&nbsp;</TD>\n";
  print FOUT "<TD>&nbsp;<IMG SRC=\"$reverselink$linkpathinit$dirress$dirsepurl$array_same\" WIDTH=12 HEIGHT=12 ALT=\"same\">&nbsp;</TD>\n<TD>&nbsp;$L{'Same_over_the_previous_day'}&nbsp;</TD>\n";
  print FOUT "<TD>&nbsp;<IMG SRC=\"$reverselink$linkpathinit$dirress$dirsepurl$array_down\" WIDTH=12 HEIGHT=12 ALT=\"down\">&nbsp;</TD>\n<TD>&nbsp;$L{'Decrease_over_the_previous_day'}&nbsp;</TD>\n";
  print FOUT "</TR>\n</TABLE>\n";
  $tmp = $cmonth."/".$cday;

  $testday = $cday;
  $testmonth = $cmonth;
  $testccmonth = $ccmonth;

  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Page'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Occurence'}</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Total'}&nbsp;%</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Hosts'}</TH>\n" if ($precision > 3);
  print FOUT "<TH>&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">$tmp</TH>\n" if ($scriptname eq "cron-inc.pl");

  $tmp5 = $tmpagenb;
  $tmp5 = $diffmax_ini if ($tmp5 > $diffmax_ini);

  for ($i=0;$i<=$tmp5;$i++) {

      $testday-- if ($scriptname eq "cron-inc.pl");
      $testday = "0".$testday if (length($testday) == 1 && $struct_compressed_logfile !~ /\%smallday/);

      if ($testday < 1) {
	  $testccmonth--;
	  if ($testccmonth < 1) {
	      $testccmonth = 12;
	  }
	  $testmonth = $month_nb[$testccmonth-1];
	  $testday = $month_of_year{$testmonth};
      }
      
      $tmp = "$testmonth/$testday";

      print FOUT "<TH class=\"table-sortable:numeric\">$tmp</TH>\n";
      $testday-- if ($scriptname eq "cron-pages.pl");
  }

  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";


  for ($j=1;$j<=$count{$racine};$j++) {

      $page = $newpageslues{$racine,$j};

      if ($pageslues{$page} > $seuilpage) {

	  print FOUT "<TR><TD CLASS=\"left\">";
	  $link = &AddHREF($page);
	  print FOUT "$link";
	  print FOUT "</TD>\n";
	  print FOUT "<TD CLASS=\"right\">";

	  if ($w3perlcgiurl ne '' && -d $cgipath_install && $precision > 2) {
	      print FOUT "<A HREF=\"javascript:GraphHosts('$cgipagegraph',";
	      print FOUT "'$tmp4'," if ($opt_c ne '');
	      print FOUT "'config.pl'," if ($opt_c eq '');
	      print FOUT "'$pagehas{$page}',";
	      print FOUT "'0',";
	      print FOUT "'$I'";
	      print FOUT ")\">";
	  }

	  print FOUT "<B>$pageslues{$page}</B>";
	  print FOUT "</A>" if ($w3perlcgiurl ne '' && -d $cgipath_install && $precision > 2);

	  $percentage = $pageslues{$page}*100/$freq2rachtml{$racine} if ($freq2rachtml{$racine} != 0);
	  $percentage = 0 if ($freq2rachtml{$racine} == 0);
	  $percentageint = int($percentage);
	  
	  print FOUT "</TD>\n<TD CLASS=\"left\">";
	  print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"$reverselink$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($percentageint != 0);
	  printf FOUT "%.1f %",$percentage;
	  print FOUT "</TD>\n";

	  $tmp = 0;
	  $tmp1 = '';

	  for ($i=0;$i<=$tmp5;$i++) {
	      $tmpage{$i,$pagehas{$page}} = 0 if ($tmpage{$i,$pagehas{$page}} eq '');
	      $tmp1 .= "<TD CLASS=\"right\">$tmpage{$i,$pagehas{$page}}</TD>\n";
	      $tmp += $tmpage{$i,$pagehas{$page}};
	  }

	  $tmp = int($tmp/($tmp5+1));
	  $val = $tmp*10/100; # threshold to 10% to get increase/decrease
	      
	  $cur = $pagesluesday{$page} if ($scriptname eq "cron-inc.pl");
	  $cur = $tmpage{0,$pagehas{$page}} if ($scriptname ne "cron-inc.pl");
	  $tmpstr = "same" if (abs($cur - $tmp) <= $val);
	  $tmpstr = "increase" if ($cur > ($tmp+$val));
	  $tmpstr = "decrease" if ($cur < ($tmp-$val));
	      
	  $tmp3 = $pageslues{$page}*100/$access if ($access != 0);
	  print FOUT "<TD CLASS=\"$tmpstr\">";
	  printf FOUT "%.2f",$tmp3;
	  print FOUT "</TD>\n";

	  print FOUT "<TD CLASS=\"right\"><A HREF=\"$reverselink2$pagehas{$page}$htmlext\">$nbpagehost{$pagehas{$page}}</A></TD>\n" if ($precision > 3);

	  print FOUT "<TD><!-- 9 --><IMG SRC=\"$reverselink$linkpathinit$dirress$dirsepurl$array_up\" WIDTH=12 HEIGHT=12 ALT=\"up\"></TD>\n" if ($tmpstr eq "increase");
	  print FOUT "<TD><!-- 5 --><IMG SRC=\"$reverselink$linkpathinit$dirress$dirsepurl$array_same\" WIDTH=12 HEIGHT=12 ALT=\"same\"></TD>\n" if ($tmpstr eq "same");
	  print FOUT "<TD><!-- 1 --><IMG SRC=\"$reverselink$linkpathinit$dirress$dirsepurl$array_down\" WIDTH=12 HEIGHT=12 ALT=\"down\"></TD>\n" if ($tmpstr eq "decrease");
	  $pagesluesday{$page} = 0 if ($pagesluesday{$page} eq '');
	  print FOUT "<TD CLASS=\"right\">$pagesluesday{$page}</TD>\n" if ($scriptname eq "cron-inc.pl");

	  print FOUT "$tmp1\n";
	  }


	  print FOUT "</TR>\n";
  }

 # }

  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n";
  print FOUT "<P><HR><P>\n";

  print FOUT "<DIV ID=\"graph_print\"></DIV>\n";

  print FOUT "<P><HR><P>\n";

  ### Including sub directories

  $tmp2a = 0;
  $tmp2b = 0;
  $tmp2c = 0;
  $tmp2d = 0;

  $count = 0;
  foreach $racine_all (sort keys(%freqrac)) {
      if ($racine_all =~ /^\Q$racine\E/) {
	  $racine_find = $racine_all;

	  $count++;
	  for ($j=1;$j<=$count{$racine_find};$j++) {
	      $page = $newpageslues{$racine_find,$j};
	      $tmp2a += $pageslues{$page};
	  }
	  $tmp2b += $freqracurl{$racine_find};
	  $tmp2c += $freqracurltot{$racine_find};
	  $tmp2d += $freq2rachtml{$racine_find};
      }
  }

  if ($count > 1 && $tmp2b != $freqracurl{$racine}) {

#      $tmpb = $tmpa."full";

      print FOUT "<H3> $L{'ListOf'} $L{'pages'} - $L{'Tree'}</H3><P>\n";

      if ($seuilpage != 1 && $seuilpage != 0) {
	  print FOUT "<I>($L{'Only_pages'} $L{'with_at_least'} $seuilpage $L{'accesses'} $L{'are_shown'})</I>\n<P>";
      
	  print FOUT "<TABLE><TR>\n";
	  print FOUT "<TH CLASS=\"left\">$L{'Files'}</TH>\n";
	  print FOUT "<TD CLASS=\"head_left\">$tmp2b ($L{'among'} $tmp2c)</TD>\n";
	  print FOUT "</TR>\n";
	  print FOUT "<TR>\n";
	  print FOUT "<TH CLASS=\"left\">$L{'Occurence'}</TH>\n";
	  print FOUT "<TD CLASS=\"head_left\">$tmp2a ($L{'among'} $tmp2d)</TD>\n";
	  print FOUT "</TR></TABLE>\n";
      }

      print FOUT "<P>\n<TABLE>\n<TR>\n";
#      print FOUT "<TD WIDTH=10 HEIGHT=10 CLASS=\"increase\">&nbsp;</TD>\n<TD>&nbsp;$L{'Increase_over_the_previous_day'}&nbsp;</TD>\n";
#      print FOUT "<TD WIDTH=10 HEIGHT=10 CLASS=\"same\">&nbsp;</TD>\n<TD>&nbsp;$L{'Same_over_the_previous_day'}&nbsp;</TD>\n";
#      print FOUT "<TD WIDTH=10 HEIGHT=10 CLASS=\"decrease\">&nbsp;</TD>\n<TD>&nbsp;$L{'Decrease_over_the_previous_day'}&nbsp;</TD>\n";
      print FOUT "<TD>&nbsp;<IMG SRC=\"$reverselink$linkpathinit$dirress$dirsepurl$array_up\" WIDTH=12 HEIGHT=12 ALT=\"up\">&nbsp;</TD>\n<TD>&nbsp;$L{'Increase_over_the_previous_day'}&nbsp;</TD>\n";
      print FOUT "<TD>&nbsp;<IMG SRC=\"$reverselink$linkpathinit$dirress$dirsepurl$array_same\" WIDTH=12 HEIGHT=12 ALT=\"same\">&nbsp;</TD>\n<TD>&nbsp;$L{'Same_over_the_previous_day'}&nbsp;</TD>\n";
      print FOUT "<TD>&nbsp;<IMG SRC=\"$reverselink$linkpathinit$dirress$dirsepurl$array_down\" WIDTH=12 HEIGHT=12 ALT=\"down\">&nbsp;</TD>\n<TD>&nbsp;$L{'Decrease_over_the_previous_day'}&nbsp;</TD>\n";
      print FOUT "</TR>\n</TABLE>\n";
      $tmp = $cmonth."/".$cday;
      
      $testday = $cday;
      $testmonth = $cmonth;
      $testccmonth = $ccmonth;
      
      print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
      print FOUT "<thead>\n";
      print FOUT "<TR>\n";
      print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Page'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">$L{'Level'}</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">$L{'Occurence'}</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">$L{'Percentage'}</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">$L{'Total'}&nbsp;%</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">$L{'Hosts'}</TH>\n" if ($precision > 3);
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;</TH>\n";

      print FOUT "<TH class=\"table-sortable:numeric\">$tmp</TH>\n" if ($scriptname eq "cron-inc.pl");
      $tmp5 = $tmpagenb;
      $tmp5 = $diffmax_ini if ($tmp5 > $diffmax_ini);
      for ($i=0;$i<=$tmp5;$i++) {

	  $testday-- if ($scriptname eq "cron-inc.pl");
#	  $testday--;
	  $testday = "0".$testday if (length($testday) == 1 && $struct_compressed_logfile !~ /\%smallday/);

	  if ($testday < 1) {
	      $testccmonth--;
	      if ($testccmonth < 1) {
		  $testccmonth = 12;
	      }
	      $testmonth = $month_nb[$testccmonth-1];
	      $testday = $month_of_year{$testmonth};
	  }
	      
	  $tmp = "$testmonth/$testday";

	  print FOUT "<TH class=\"table-sortable:numeric\">$tmp</TH>\n";
	  $testday-- if ($scriptname eq "cron-pages.pl");
      }

      print FOUT "</TR>\n";
      print FOUT "</thead>\n";
      print FOUT "<tbody>\n";

      $tmp4 = $opt_c;
      $tmp4 = substr($tmp4,rindex($tmp4,$dirsep)+1,length($tmp4)) if ($opt_c =~ /^\//);

      foreach $racine_all (sort keys(%freqrac)) {
	  if ($racine_all =~ /^\Q$racine\E/) {
	      $racine_find = $racine_all;
	      
	      for ($j=1;$j<=$count{$racine_find};$j++) {
		  $page = $newpageslues{$racine_find,$j};
		  if ($pageslues{$page} > $seuilpage) {
		      
		      print FOUT "<TR><TD CLASS=\"left\">";
		      $link = &AddHREF($page);
		      print FOUT "$link";
		      print FOUT "</TD>\n";
		      $tmp = &URLDepth($racine_find);
		      print FOUT "<TD CLASS=\"right\">$tmp</TD>\n";
		      print FOUT "<TD CLASS=\"right\">";
		  
		      if ($w3perlcgiurl ne '' && -d $cgipath_install && $precision > 2) {
			  print FOUT "<A HREF=\"javascript:GraphHosts('$cgipagegraph',";
			  print FOUT "'$tmp4'," if ($opt_c ne '');
			  print FOUT "'config.pl'," if ($opt_c eq '');
			  print FOUT "'$pagehas{$page}',";
			  print FOUT "'0',";
			  print FOUT "'$I'";
			  print FOUT ")\">";
		      }

		      print FOUT "<B>$pageslues{$page}</B>";
		      print FOUT "</A>" if ($w3perlcgiurl ne '' && $precision > 2);

		      $percentage = $pageslues{$page}*100/$tmp2d if ($tmp2d != 0);
		      $percentage = 0 if ($tmp2d == 0);
		      $percentageint = int($percentage);
		  
		      print FOUT "</TD>\n<TD CLASS=\"left\">";
		      print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"$reverselink$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($percentageint != 0);
		      printf FOUT "%.1f %",$percentage;

		      print FOUT "</TD>\n";

		      $tmp = 0;
		      $tmp1 = '';

		      for ($i=0;$i<=$tmp5;$i++) {
			  $tmpage{$i,$pagehas{$page}} = 0 if ($tmpage{$i,$pagehas{$page}} eq '');
			  $tmp1 .= "<TD CLASS=\"right\">$tmpage{$i,$pagehas{$page}}</TD>\n";
			  $tmp += $tmpage{$i,$pagehas{$page}};
		      }
		      $tmp = int($tmp/($tmp5+1));
		      $val = $tmp*10/100; # threshold to 10% to get increase/decrease

		      $cur = $pagesluesday{$page} if ($scriptname eq "cron-inc.pl");
		      $cur = $tmpage{0,$pagehas{$page}} if ($scriptname ne "cron-inc.pl");		      
		      $tmpstr = "same" if (abs($cur - $tmp) <= $val);
		      $tmpstr = "increase" if ($cur > ($tmp+$val));
		      $tmpstr = "decrease" if ($cur < ($tmp-$val));

		      $tmp3 = $pageslues{$page}*100/$access if ($access != 0);

		      print FOUT "<TD CLASS=\"$tmpstr\">";
		      printf FOUT "%.2f",$tmp3;
		      
		      print FOUT "</TD>\n";
		      print FOUT "<TD CLASS=\"right\"><A HREF=\"$reverselink2$pagehas{$page}$htmlext\">$nbpagehost{$pagehas{$page}}</A></TD>\n" if ($precision > 3);
		      
		      
		      print FOUT "<TD><!-- 9 --><IMG SRC=\"$reverselink$linkpathinit$dirress$dirsepurl$array_up\" WIDTH=12 HEIGHT=12 ALT=\"up\"></TD>\n" if ($tmpstr eq "increase");
		      print FOUT "<TD><!-- 5 --><IMG SRC=\"$reverselink$linkpathinit$dirress$dirsepurl$array_same\" WIDTH=12 HEIGHT=12 ALT=\"same\"></TD>\n" if ($tmpstr eq "same");
		      print FOUT "<TD><!-- 1 --><IMG SRC=\"$reverselink$linkpathinit$dirress$dirsepurl$array_down\" WIDTH=12 HEIGHT=12 ALT=\"down\"></TD>\n" if ($tmpstr eq "decrease");

		      print FOUT "<TD CLASS=\"right\">$pagesluesday{$page}</TD>\n" if ($scriptname eq "cron-inc.pl");
		      
			  print FOUT "$tmp1\n";
		      }
		      
#		      print FOUT "</TR>\n";
	      }

#	      }
	  }

      }
	      print FOUT "</TR>\n";
      print FOUT "</tbody>\n";
      print FOUT "</TABLE>\n";
#      print FOUT "<P><HR><P>\n";
  }


  print FOUT "</BODY></HTML>\n";
}

#
##############################################################
### Directories
##############################################################
#

sub PagesRepert {
  local(*FOUT,*L,$I) = @_;
  local($line,$dir_tot_all);

  print FOUT "$doctype\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Stats'} - $L{'Directories'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";
  &add_jqplot_js(*FOUT,2);
  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
  print FOUT "<H2> $L{'ListOf'} $L{'directories'} $L{'used2'} </H2><P>\n" if ($squid_format == 0);
  print FOUT "<H2> $L{'Destination'} </H2><P>\n" if ($squid_format == 1);
#  print FOUT "<P><HR><P>\n";

  &help_div(*FOUT);


  print FOUT "<A HREF=\"..$dirsepurl..$dirsepurl$dircsv$dirsepurl$increpert$csvext\" TITLE=\"Export in CSV\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A><P>";

  if ($selecrepert[0] ne '' && $nbdays > 14 && -f "$path$dirdata$dirsep$statrepert") {

      print FOUT "<!-- ADD_USEMAP -->\n";

      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'Directories_graphs'}</I> :</DIV><P>\n";

      print FOUT "<TABLE WIDTH=\"100%\">\n";
      print FOUT "<TR>\n";
      print FOUT "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";
      
#      if ($nbdays > 14) {

	  for ($i=$#selecrepert;$i>=0;$i--) {
	      $selecrepertbis[$i] = "dir".$i.$htmlext;
	  }

	  if ($fly_set == 0) {

	      undef(@dir_tot);
	      undef(@dir_acc);
#	      print "Reading $path$dirdata$dirsep$statrepert\n";
	      open(INFILE, "$path$dirdata$dirsep$statrepert"); # || &error_exit("Error, unable to open $path$dirdata$dirsep$statrepert",1);

	      $line = 0;
	      $count_day = 0;
	      $count_week = 0;
	      $count = 0;

	    BOUCLE_REPERT:
	      while (<INFILE>) {
		  chop;                                                                                                                      
		  next if ($_ eq '');
		  @dirname = split(/\s+/) unless ($line != 0);
		  $line++;
		  $count++;
		  $count-- if ($line < 3);
		  next if ($line < 3);

		  $oldjour = $jour;
		  $oldyear = $year;
		  $old_date = $current_date;
		  $oldmonth = $month;

		  ($jour,$month,$year,@dir) = split('\s+');
		  $current_date = $jour." ".$month." ".$year;
		  if ($line == 3) {
		      $start_date = $jour." ".$month." ".$year;
		  }

		  if ($opt_s ne '' || $opt_r ne '') {
		      $fa = "$jour/$month/$year";
		      ($fa1,$fa2,$fa3) = split('/',$fa);
		      last BOUCLE_REPERT if ($fa3 > $de3);
		      next if ($fa3 < $ds3 || $fa3 > $de3);
		      $mequiv = $month_equiv{$fa2};
		      last BOUCLE_REPERT if ($fa3 == $de3 && $mequiv > $mde2);
		      next if (($fa3 == $ds3 && $mequiv < $mds2) || ($fa3 == $de3 && $mequiv > $mde2));
		      last BOUCLE_REPERT if ($fa3 == $de3 && $mequiv == $mde2 && $fa1 > $de1);
		      next if (($fa3 == $ds3 && $mequiv == $mds2 && $fa1 < $ds1) || ($fa3 == $de3 && $mequiv == $mde2 && $fa1 > $de1));
		  }
		  
		  $count_day++;

		  ### test sur le jour suivant
		  
		  $intervalle = &nbday($current_date) - &nbday($old_date) if ($old_date ne '');
		  if ($intervalle != 1 && $line > 3) {
		      while (($count_day+$intervalle-1) > 8) {
			  @oldyear = split(/[\s+\/]/,$pre_date);
			  $intervalle -= 7;   # suppose un intervalle inferieur a 7 !

			  for ($i=0;$i<=($#dir);$i++) {
			      $maxdir_req{$count_week,$i} = $dir_tot[$i];
			      $maxdir_acc{$count_week,$i} = $dir_acc[$i];
#			      $repmax = $dir_tot[$i] if ($dir_tot[$i] > $repmax);
			  }
			  for ($i=0;$i<=($#dir);$i++) {
			      ($tmp1,$tmp2) = split(/\|/,$dir[$i]);
			      $dir_tot[$i] = $tmp1;
			      $dir_acc[$i] = $tmp2;
			  }
			  $count_week++;
			  $line++;
		      }

		      while ($intervalle > 8) {
			  for ($i=0;$i<=($#dir);$i++) {
			      ($tmp1,$tmp2) = split(/\|/,$dir[$i]);
			      $dir_tot[$i] += $tmp1;
			      $dir_acc[$i] += $tmp2;
			  }
		      }

		      $count+=$intervalle-1;
		      $count_day += $intervalle-1;
		  }

		  if ( $count_day <  8) {
		      for ($i=0;$i<=($#dir);$i++) {
			  ($tmp1,$tmp2) = split(/\|/,$dir[$i]);
			  $dir_tot[$i] += $tmp1;
			  $dir_acc[$i] += $tmp2;
#			  print "Read Graph$i $dir_tot[$i] - $dir_acc[$i] / $tmp1 - $tmp2\n";
		      }
		  }
		  else {
		      for ($i=0;$i<=($#dir);$i++) {
			  $maxdir_req{$count_week,$i} = $dir_tot[$i];
			  $maxdir_acc{$count_week,$i} = $dir_acc[$i];
#			  print "Dir Graph$i - $count_week - $maxdir_req{$count_week,$i}\n";
#			  $repmax = $dir_tot[$i] if ($dir_tot[$i] > $repmax);
		      }
		      for ($i=0;$i<=($#dir);$i++) {
			  ($tmp1,$tmp2) = split(/\|/,$dir[$i]);
			  $dir_tot[$i] = $tmp1;
			  $dir_acc[$i] = $tmp2;
		      }
		      $count_day -= 7;   # suppose un intervalle inferieur a 7 !
		      $count_week++;
		      $line++;
		  }
	      }

	      close(INFILE);

	      $tmp = 0;
	      for ($i=0;$i<=($#dir);$i++) {
		  $dir_tot_all += $dir_tot[$i];
	      }
	      
	      #
	      if ($dir_tot_all != 0) {

	      $chart_id = 10;

	      $xlegend = "$count_week week";
	      $xlegend .= "s" if ($count_week > 1);
	      $xlegend .= " (starting $start_date)";
	      
	      $ylegend = "$L{'Requests'}";
	      
	      $info = "info".$chart_id;	
	      
	      undef @ref_tab;
	      undef @ref_tab2;
	      undef @ref_tab_name;
	      undef @graph_to_display;

	      for ($i=0;$i<$#selecrepert;$i++) {
		  for ($j=0;$j<$count_week;$j++) {
		      $tmp = "valdata$i";
		      $tmp2 = "val2data$i";
		      $$tmp[$j] = $maxdir_req{$j,$i};
		      $$tmp2[$j] = $maxdir_acc{$j,$i};
		      $som += $maxdir_req{$j,$i};
		      $tmp = $j*7;
		      $listdate[$j] = &date_intervalle($start_date,$tmp);
#		      print "II $j - $valdata[$j] - $listdate[$j]\n";
		  }
		  if ($som != 0) {
		      $tmp = "valdata$i";
		      $tmp2 = "val2data$i";
#		      print "ADd Graph$i - $selecrepert[$i] - @$tmp\n";
		      push(@ref_tab,\@$tmp);
		      push(@ref_tab2,\@$tmp2);
#		      print "NN @ref_tab2\n";
#		      push(@ref_tab,\@val2data);
		      $tmp = "requests_$i";
		      push(@ref_tab_name,$tmp);
		      push(@ref_tab_name,$tmp2);
		      push(@graph_to_display,$selecrepert[$i]);
#		      push(@graph_to_display2,$selecrepert[$i]);

		  }
	      }

	      &MakeDailyGraphJqplotInit(*FOUT, eval($Lang{$lang[$nblang]}),$I,2,$unit_div,\@ref_tab,\@ref_tab_name,\@listdate,$chart_id);
		  
	      &MakeDailyGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,2,\@graph_to_display,\@ref_tab,\@listdate,\@serie_color,1,$unit,$chart_id,0,"requests",$info,$chart_id,$xlegend,$ylegend,$xmax_jqplot,'');

	      print FOUT "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0><TR><TD>\n";
	      &AddJqplotHtml(*FOUT, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_jqplot,$ymax_jqplot,2);
	      print FOUT "</TD><TD>";

	      $chart_id_old = $chart_id;
#	      print "UU $chart_id_old\n";
	      $chart_id += $#list_graph_name_jqplot+1;

	      #

	      $ylegend = "$L{'Accesses'}";
	      $info = "info".$chart_id;	

	      &MakeDailyGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,2,\@graph_to_display,\@ref_tab2,\@listdate,\@serie_color,1,$unit,$chart_id,0,"accesses",$info,$chart_id_old,$xlegend,$ylegend,$xmax_jqplot,'');

	      &AddJqplotHtml(*FOUT, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_jqplot,$ymax_jqplot,2);
	      print FOUT "</TD></TR></TABLE></CENTER>";
	      $chart_id += $#list_graph_name_jqplot+1;
	      undef(@listdate);

	      for ($i=0;$i<$#selecrepert;$i++) {
		  $tmp = "valdata$i";
		  $tmp2 = "val2data$i";
		  undef(@$tmp);
		  undef(@$tmp2);
	      }
	      }
	  }


	  if ($fly_set == 1) {

	  print FOUT "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
	  print FOUT "<TR>\n";
	  print FOUT "<TD><IMG  WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linkfilerepy\" ALT=\"ylabel\"></TD>\n";
#      print FOUT "<TD><IMG  WIDTH=$xmax HEIGHT=$ymax SRC=\"$linkfilerep\" ALT=\"graph\" USEMAP=\"dir_week\"></TD>\n";
	  print FOUT "<TD><IMG  WIDTH=$xmax HEIGHT=$ymax SRC=\"$linkfilerep\" ALT=\"graph\"></TD>\n";
	  print FOUT "</TR><TR><TD></TD>\n";
	  print FOUT "<TD><IMG  WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linkfilerepx\" ALT=\"xlabel\"></TD>\n";
	  print FOUT "</TR>\n";
	  print FOUT "<TR><TD></TD>\n";
	  print FOUT "<TD ALIGN=CENTER>\n";

	  print FOUT "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0>\n";
	  for ($i=$#selecrepert;$i>=0;$i--) {
	      $j = $i % ($#gcolor);
	      $couleur = $gcolor[$j];
	      
#	      $selecrepertbis[$i] = "dir".$i.$htmlext;

	      print FOUT "<TR><TD><IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$couleur\" ALT=\"couleur\"></TD>\n";
	      print FOUT "<TD ALIGN=LEFT>&nbsp; $L{'directory'} : <B>";
	      print FOUT "<A HREF=\"$selecrepertbis[$i]\">";
	      print FOUT "$selecrepert[$i]";
	      print FOUT "</A>";
	      print FOUT "</B></TD></TR>\n";
	  }
	  print FOUT "</TABLE>\n";
	  
	  print FOUT "</TD></TR>\n";        
	  print FOUT "</TABLE></CENTER><P>\n";
	  }
#      }

      print FOUT "</TD>";
      print FOUT "</TR><TR>" if ($fly_set == 0);
      print FOUT "<TD ALIGN=CENTER VALIGN=MIDDLE>\n";


      print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
      print FOUT "<thead>\n";
      print FOUT "<TR>\n";
      print FOUT "<TH>&nbsp;</TH>\n";

#      print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"dir_list\">\n";

#      print FOUT "<TR><TH>&nbsp;</TH>\n";
      print FOUT "<TH COLSPAN=2>&nbsp;$L{'Requests'}&nbsp;</TH>\n";
      if ($locallog == 1 || $localonly == 1) {
	  print FOUT "<TH COLSPAN=6>&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
	  print FOUT "<TH COLSPAN=6>&nbsp;$L{'Traffic'}&nbsp;</TH>\n" if ($notrafic == 0);
      } else {
	  print FOUT "<TH COLSPAN=2>&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
	  print FOUT "<TH COLSPAN=2>&nbsp;$L{'Traffic'}&nbsp;</TH>\n" if ($notrafic == 0);
      }
      print FOUT "</TR>\n";

      print FOUT "<TR><TH class=\"table-sortable:default\">&nbsp;$L{'Directories'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Total'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;%&nbsp;</TH>\n";
      # Accesses

      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Total'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;%&nbsp;</TH>\n";

      if ($locallog == 1 || $localonly == 1) {
	  if ($localonly == 0) {
	      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'external'}&nbsp;</TH>\n";
	      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;%&nbsp;</TH>\n";
	  }
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'local'}&nbsp;</TH>\n";
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;%&nbsp;</TH>\n";
      }
      # Trafic
      if ($notrafic == 0) {
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Total'}&nbsp;($L{'Mb'})</TH>\n";
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;%&nbsp;</TH>\n";
	  if ($locallog == 1 || $localonly == 1) {
	      if ($localonly == 0) {
		  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'external'}&nbsp;</TH>\n";
		  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;%&nbsp;</TH>\n";
	      }
	      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'local'}&nbsp;</TH>\n";
	      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;%&nbsp;</TH>\n";
	  }
      }

      print FOUT "</TR>\n";
      print FOUT "</thead>\n";
      print FOUT "<tbody>\n";

      for ($i=0;$i<=($#selecrepert);$i++) {
	  
	  print FOUT "<TR>\n<TD CLASS=\"left\">";
	  print FOUT "<A HREF=\"$selecrepertbis[$i]\">" if ($nbdays > 14 && -f "$path$lang[$nblang]$dirsepurl$dirlist$dirsepurl$selecrepertbis[$i]");
	  print FOUT "<I>$selecrepert[$i]</I>";
	  print FOUT "</A>" if ($nbdays > 14 && -f "$path$lang[$nblang]$dirsepurl$dirlist$dirsepurl$selecrepertbis[$i]");
	  print FOUT "</TD>\n";

	  $p = 100*$freqrac{$selecrepert[$i]}/$reqtot if ($reqtot != 0);

	  print FOUT "<TD CLASS=\"left_bordure\">";

	  print FOUT "$freqrac{$selecrepert[$i]}";
	  print FOUT "&nbsp;</TD>\n";

	  print FOUT "<TD CLASS=\"right_bordure\">";

	  printf FOUT "%.1f&nbsp;%&nbsp;",$p;
	  print FOUT "</TD>\n";

	  # Accesses
	  $p = 100*$freqrachtml{$selecrepert[$i]}/$access if ($access != 0);

	  print FOUT "<TD CLASS=\"left_bordure\">";

	  print FOUT "$freqrachtml{$selecrepert[$i]}";
	  print FOUT "&nbsp;</TD>\n";
	  if ($locallog == 1 || $localonly == 1) {
	      print FOUT "<TD CLASS=\"right\">";
	  } else {
	      print FOUT "<TD CLASS=\"right_bordure\">";
	  }
	  printf FOUT "%.1f&nbsp;%&nbsp;",$p;
	  print FOUT "</TD>\n";

	  if ($locallog == 1 || $localonly == 1) {

#	      $p1 = 100*$freqrachtmldom{$selecrepert[$i]}/$reqtot;
#	      $p2 = $p - $p1;

	      if ($localonly == 0) {
		  $value2 = $freqrachtml{$selecrepert[$i]} - $freqrachtmldom{$selecrepert[$i]};
		  $p2 = int($value2*1000/$access)/10 if ($access != 0);
		  $p1 = int(1000*$freqrachtmldom{$selecrepert[$i]}/$access)/10 if ($access != 0);

		  print FOUT "<TD CLASS=\"right\">";
		  print FOUT "$value2"; # if ($value2 != 0);
#	      print FOUT "-" if ($value2 == 0);
		  print FOUT "</TD>\n";
		  print FOUT "<TD CLASS=\"right\">";
		  printf FOUT "%.1f&nbsp;%&nbsp;",$p2; # if ($p2 != 0);
#	      print FOUT "-" if ($p2 == 0);
		  print FOUT "</TD>\n";
	      }

	      print FOUT "<TD CLASS=\"right\">";
	      print FOUT "$freqrachtmldom{$selecrepert[$i]}"; # if ($freqrachtmldom{$selecrepert[$i]} != 0);
#	      print FOUT "-" if ($freqrachtmldom{$selecrepert[$i]} == 0);
	      print FOUT "</TD>\n";
	      print FOUT "<TD CLASS=\"right_bordure\">";

	      printf FOUT "%.1f&nbsp;%&nbsp;",$p1; # if ($p1 != 0);
#	      print FOUT "-" if ($p1 == 0);
	      print FOUT "</TD>\n";
	  }

	  # Traffic
	  if ($notrafic == 0) {
#	      $p = 100*$freqtotsize{$selecrepert[$i]}/(1024*1024*$totsize);
	      $p = 100*$freqtotsize{$selecrepert[$i]}/$totsize;
	  
	      print FOUT "<TD CLASS=\"left_bordure\">";
	      
#	      printf FOUT "%.1f",($freqtotsize{$selecrepert[$i]}/(1024*1024));
	      printf FOUT "%.1f",($freqtotsize{$selecrepert[$i]}/$unit_div);
	      print FOUT "&nbsp;</TD>\n";
	      if ($locallog == 1 || $localonly == 1) {
		  print FOUT "<TD CLASS=\"right\">";
	      } else {
		  print FOUT "<TD CLASS=\"right_bordure\">";
	      }
	      printf FOUT "%.1f&nbsp;%&nbsp;",$p;
	      print FOUT "</TD>\n";

	      if ($locallog == 1 || $localonly == 1) {

		  if ($localonly == 0) {
#		      $p = 100*$freqextsize{$selecrepert[$i]}/(1024*1024*$totsize);
		      $p = 100*$freqextsize{$selecrepert[$i]}/$totsize;

		      print FOUT "<TD CLASS=\"right\">";
#		      printf FOUT "%.1f&nbsp;",($freqextsize{$selecrepert[$i]}/(1024*1024)); # if ($freqextsize{$selecrepert[$i]}/(1024*1024) != 0);
		      printf FOUT "%.1f&nbsp;",($freqextsize{$selecrepert[$i]}/$unit_div); # if ($freqextsize{$selecrepert[$i]}/(1024*1024) != 0);
#	      print FOUT "-" if ($freqextsize{$selecrepert[$i]}/(1024*1024) == 0);
		      print FOUT "</TD>\n";

		      print FOUT "<TD CLASS=\"right\">";
		      printf FOUT "%.1f&nbsp;%&nbsp;",$p; # if ($p != 0);
		      print FOUT "</TD>\n";
#	      print FOUT "-" if ($p == 0);
		  }
	  
#		  $p = 100*$freqdomsize{$selecrepert[$i]}/(1024*1024*$totsize);
		  $p = 100*$freqdomsize{$selecrepert[$i]}/$totsize;

		  print FOUT "<TD CLASS=\"right\">";
#		  printf FOUT "%.1f&nbsp;",($freqdomsize{$selecrepert[$i]}/(1024*1024)); # if ($freqdomsize{$selecrepert[$i]}/(1024*1024) != 0);
		  printf FOUT "%.1f&nbsp;",($freqdomsize{$selecrepert[$i]}/$unit_div); # if ($freqdomsize{$selecrepert[$i]}/(1024*1024) != 0);
#	      print FOUT "-" if ($freqdomsize{$selecrepert[$i]}/(1024*1024) == 0);
		  print FOUT "</TD>\n";
		  print FOUT "<TD CLASS=\"right_bordure\">";
		  printf FOUT "%.1f&nbsp;%&nbsp;",$p; # if ($p != 0);
#	      print FOUT "-" if ($p == 0);
		  print FOUT "</TD>";
	      }
	  }

	  print FOUT "</TR>\n";
      }
      print FOUT "</tbody>\n";
      print FOUT "</TABLE>\n";
#      print FOUT "</TD></TR></TABLE></CENTER>\n";

  print FOUT "</TD></TR></TABLE><P>\n";
  }

#  $search_on = "ajax_loader_small.gif";

  if ($linkpath_url ne '') {
      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'Search'}</I> :</DIV><P>\n";

      $datafileinc = $linkpath_url.$dirinc.$dirsepurl.$increpert.$txtext;
      $string_title = "$L{'Search'}:$L{'Search_on'}:$L{'No_item_found'}:$L{'Processing'}";
      $string_th = "$L{'Directories'}:$L{'Requests'}:$L{'Accesses'}:$L{'Traffic'}:$L{'Mb'}:$L{'Tree'}:$L{'internal'}";

      print FOUT "<FORM method=\"POST\" name=\"ajax\" action=\"javascript:SearchVirtual()\">\n";
      print FOUT "<TABLE BORDER=0><TR>\n";
      print FOUT "<TD VALIGN=MIDDLE>";
      print FOUT "<INPUT type=\"hidden\" name=\"precision\" value=\"$precision\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"seuilsite\" value=\"$seuilrepert\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"notrafic\"  value=\"$notrafic\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"datafile\" value=\"$datafileinc\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"stats\" value=\"repert\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"string_th\"  value=\"$string_th\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"string_title\"  value=\"$string_title\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"string_sep\"  value=\" \">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"index_hit\"  value=\"1\">\n";

      print FOUT "<TABLE BORDER=0><TR>\n";
      print FOUT "<TH ALIGN=CENTER onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$L{'Title_search_dir'}','$L{'Line_search_dir'}','$L{'Desc_search_dir'}','$L{'Link_search_dir'}',0,'','$help_width')\">";
      print FOUT "$L{'Search'}</TH>\n";
      print FOUT "</TR><TR>\n";
      print FOUT "<TD>";
      print FOUT "<INPUT type=\"text\" id=\"txtSearch\" name=\"search_value\"  value=\"\" onkeyup=\"searchSuggest();\" OnBlur=\"javascript:clean_focus()\" OnFocus=\"javascript:clean()\">\n";
      print FOUT "<div id=\"search_suggest\"></div>\n";
      print FOUT "</TD>\n";
      print FOUT "</TR></TABLE>\n";
      print FOUT "</TD><TD VALIGN=TOP>";

      print FOUT "<TABLE BORDER=0><TR>\n";
      print FOUT "<TH COLSPAN=2 ALIGN=CENTER>$L{'Requests'}</TH>\n";
      print FOUT "</TR><TR>\n";
      print FOUT "<TD>$L{'Threshold'}</TD><TD><INPUT type=\"text\" size=\"3\" name=\"search_threshold\"  value=\"$seuilrepert\"></TD>\n";
      print FOUT "</TR></TABLE>\n";
      print FOUT "</TD><TD VALIGN=MIDDLE>";
      print FOUT "<INPUT type=\"submit\" name=\"search_button\"  class=\"submit_button\" value=\"$L{'Search'}\">\n";
#      print FOUT "<DIV ID=\"search_ima\" STYLE=\"display:none\"><IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$search_on\"></DIV>";
      print FOUT "</TD></TR></TABLE>";
      print FOUT "</FORM><P>\n";
      
      print FOUT "<DIV ID=\"search_header\"></DIV>\n";
      print FOUT "<DIV ID=\"search_results\"></DIV>\n";
      print FOUT "<BR><P>\n";
  }

  ($unit_div,$unit) = &Return_Unit($freqtotsize{$dirsepurl},0);


  $line = "<P><DIV CLASS=\"item_page\">-&nbsp;<I>";
  $line .= "$L{'Directories'}" if ($squid_format == 0);
  $line .= "$L{'Destination'}" if ($squid_format == 1);
  $line .= "</I> :</DIV><P>\n";
  $line .= "<I>($L{'Only_directories'} $L{'with_at_least'} $seuilrepert $L{'requests'} $L{'are_shown'})</i><P>\n" if ($seuilrepert > 1);

  $line .= "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  $line .= "<thead>\n";
  $line .= "<TR>\n";

  $line .= "<TH>&nbsp;</TH>\n";
  $line .= "<TH>&nbsp;</TH>\n" if ($squid_format == 0 || $precision > 3);
  $line .= "<TH COLSPAN=4>&nbsp;$L{'Requests'}&nbsp;</TH>\n";
  $line .= "<TH COLSPAN=4>&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
#  $line .= "<TH COLSPAN=4>&nbsp;$L{'Traffic'}&nbsp;($L{'Mb'})&nbsp;</TH>\n" if ($notrafic == 0);
  $line .= "<TH COLSPAN=4>&nbsp;$L{'Traffic'}&nbsp;($L{$unit})&nbsp;</TH>\n" if ($notrafic == 0);
  $line .= "</TR><TR>\n";

  $line .= "<TH class=\"table-sortable:default\">&nbsp;";
  $line .= "$L{'Directories'}" if ($squid_format == 0);
  $line .= "$L{'Destination'}" if ($squid_format == 1);
  $line .= "&nbsp;</TH>\n";
  $line .= "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Level'}&nbsp;</TH>\n" if ($squid_format == 0 || $precision > 3);

  $line .= "<TH class=\"table-sortable:numeric\" onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$L{'Title_internal'}','$L{'Line_internal'}','$L{'Desc_internal'}','$L{'Link_internal'}',0,'','$help_width')\">&nbsp;$L{'internal'}&nbsp;</TH>\n";
  $line .= "<TH class=\"table-sortable:numeric\">&nbsp;%&nbsp;</TH>\n";
  $line .= "<TH class=\"table-sortable:numeric\" onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$L{'Title_tree'}','$L{'Line_tree'}','$L{'Desc_tree'}','$L{'Link_tree'}',0,'','$help_width')\">&nbsp;$L{'Tree'}&nbsp;</TH>\n";
  $line .= "<TH class=\"table-sortable:numeric\">&nbsp;%&nbsp;</TH>\n";
  $line .= "<TH class=\"table-sortable:numeric\" onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$L{'Title_internal'}','$L{'Line_internal'}','$L{'Desc_internal'}','$L{'Link_internal'}',0,'','$help_width')\">&nbsp;$L{'internal'}&nbsp;</TH>\n";
  $line .= "<TH class=\"table-sortable:numeric\">&nbsp;%&nbsp;</TH>\n";
  $line .= "<TH class=\"table-sortable:numeric\" onMouseOut=\"hideLayer();overdiv--;\"  onMouseOver=\"overdiv++;popLayer('$L{'Title_tree'}','$L{'Line_tree'}','$L{'Desc_tree'}','$L{'Link_tree'}',0,'','$help_width')\">&nbsp;$L{'Tree'}&nbsp;</TH>\n";
  $line .= "<TH class=\"table-sortable:numeric\">&nbsp;%&nbsp;</TH>\n";
  if ($notrafic == 0) {
      $line .= "<TH  class=\"table-sortable:numeric\" onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$L{'Title_internal'}','$L{'Line_internal'}','$L{'Desc_internal'}','$L{'Link_internal'}',0,'','$help_width')\">&nbsp;$L{'internal'}&nbsp;</TH>\n";
      $line .= "<TH class=\"table-sortable:numeric\">&nbsp;%&nbsp;</TH>\n";
      $line .= "<TH class=\"table-sortable:numeric\" onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$L{'Title_tree'}','$L{'Line_tree'}','$L{'Desc_tree'}','$L{'Link_tree'}',0,'','$help_width')\">&nbsp;$L{'Tree'}&nbsp;</TH>\n";
      $line .= "<TH class=\"table-sortable:numeric\">&nbsp;%&nbsp;</TH>\n";
  }

  $line .= "</TR>\n";
  $line .= "</thead>\n";
  $line .= "<tbody>\n";

  $tot3rac = 0;
  $tot3acc = 0;
  $tot3size = 0;

  foreach $racine (sort keys(%freqrac)) {

      $tmp = $racine;
      $tmp =~ s/$dirsep//g;
      $tmp = length($racine)-length($tmp);      
      $tmp -= $tmptri;

      if ($tmp == 2) {
	  $freqtmp1{$racine} = $freqrac{$racine};
	  $freqtmp2{$racine} = $freqrachtml{$racine};
	  $freqtmp3{$racine} = $freqtotsize{$racine};
      }

      if ($tmp == 3) {
	  $freqtmp4{$racine} = $freqrac{$racine};
	  $tot3rac += $freqrac{$racine};
	  $freqtmp5{$racine} = $freqrachtml{$racine};
	  $tot3acc += $freqrachtml{$racine};
	  $freqtmp6{$racine} = $freqtotsize{$racine};
	  $tot3size += $freqtotsize{$racine};
      }

      if ($freqrac{$racine} > $seuilrepert) {
	  if (($squid_format == 1 && $tmp < 3 && $precision <= 3) || $precision > 3 || $squid_format == 0) {
	  $line .= "<TR>\n";
	  $line .= "<TD ";
	  $line .= "CLASS=\"left\"" if ($tmp > 2);
	  $line .= "CLASS=\"head_left\"" if ($tmp < 3);
	  $line .= "><I>";
	  $tmp2 = $racine;
	  $tmp3 = $racine;
	  chop($tmp3);
	  $tmp3 =~ s/^$dirsep//;
	  $tmp3 =~ s/$dirsep/_/g;
	  $tmp3 .= $htmlext;
	  $tmp4 = "..".$dirsepurl.$dirpage.$dirsepurl.$tmp3;
	  $line .= "<A HREF=\"$tmp4\">" if (-f "$path$lang[$nblang]$dirsepurl$dirpage$dirsepurl$tmp3" && ($squid_format == 0 || $precision > 3));

	  $tmp2 =~ s/$dirsep//g if ($squid_format == 1 && $tmp == 2);
	  $line .= "$tmp2";
	  $line .= "</A>" if (-f "$path$lang[$nblang]$dirsepurl$dirpage$dirsepurl$tmp3" && ($squid_format == 0 || $precision > 3));
	  $line .= "</I></TD>\n";

	  if ($squid_format == 0 || $precision > 3) {
	      $line .= "<TD ";
	      $line .= "CLASS=\"right\"" if ($tmp > 2);
	      $line .= "CLASS=\"head_right\"" if ($tmp < 3);
	      $line .= ">$tmp</TD>\n";
	      }

	  $p = int(1000*$freqrac{$racine}/$reqtot)/10;
	  $p2 = int(1000*$freq2rac{$racine}/$reqtot)/10;
	  
	  $line .= "<TD ";
	  $line .= "CLASS=\"right\"" if ($tmp > 2);
	  $line .= "CLASS=\"head_right_dir_req\"" if ($tmp < 3);
	  $line .= ">$freq2rac{$racine}";
	  $line .= "</TD>\n<TD ";
	  $line .= "CLASS=\"right\"" if ($tmp > 2);
	  $line .= "CLASS=\"head_right_dir_req\"" if ($tmp < 3);
	  $line .= ">$p2 %";
	  $line .= "</TD>\n";
	  $line .= "<TD ";
	  $line .= "CLASS=\"right\"" if ($tmp > 2);
	  $line .= "CLASS=\"head_right_dir_req\"" if ($tmp < 3);
	  $line .= ">$freqrac{$racine}";
	  $line .= "</TD>\n<TD ";
	  $line .= "CLASS=\"right\"" if ($tmp > 2);
	  $line .= "CLASS=\"head_right_dir_req\"" if ($tmp < 3);
	  $line .= ">$p %";
	  $line .= "</TD>\n";
          
	  if ($access != 0) {
	      $p = int(1000*$freqrachtml{$racine}/$access)/10;
	      $p2 = int(1000*$freq2rachtml{$racine}/$access)/10;
	  }
     
	  $line .= "<TD ";
	  $line .= "CLASS=\"right\"" if ($tmp > 2);
	  $line .= "CLASS=\"head_right_dir_access\"" if ($tmp < 3);
	  $line .= ">$freq2rachtml{$racine}"; # if ($freq2rachtml{$racine} != 0);
#	  $line .= ">-" if ($freq2rachtml{$racine} == 0);
	  $line .= "</TD>\n<TD ";
	  $line .= "CLASS=\"right\"" if ($tmp > 2);
	  $line .= "CLASS=\"head_right_dir_access\"" if ($tmp < 3);
#	  printf FOUT ">%.1f %",$p2; # if ($p2 != 0);
	  $line .= ">$p2 %";
#	  $line .= ">-" if ($p2 == 0);
	  $line .= "</TD>\n";
	  $line .= "<TD ";
	  $line .= "CLASS=\"right\"" if ($tmp > 2);
	  $line .= "CLASS=\"head_right_dir_access\"" if ($tmp < 3);
	  $line .= ">$freqrachtml{$racine}"; # if ($freqrachtml{$racine} != 0);
#	  $line .= ">-" if ($freqrachtml{$racine} == 0);
	  $line .= "</TD>\n<TD ";
	  $line .= "CLASS=\"right\"" if ($tmp > 2);
	  $line .= "CLASS=\"head_right_dir_access\"" if ($tmp < 3);
#	  printf FOUT ">%.1f %",$p; # if ($p != 0);
	  $line .= ">$p %";
#	  printf FOUT ">-" if ($p == 0);
	  $line .= "</TD>\n";

	  if ($notrafic == 0) {          
	      $p = int(1000*$freqtotsize{$racine}/$totsize)/10;
	      $p2 = int(1000*$freq2totsize{$racine}/$totsize)/10;     
	      $p3 = int(100*$freq2totsize{$racine}/$unit_div)/100;
	      $p4 = int(100*$freqtotsize{$racine}/$unit_div)/100;
	      $line .= "<TD ";
	      $line .= "CLASS=\"right\"" if ($tmp > 2);
	      $line .= "CLASS=\"head_right_dir_traffic\"" if ($tmp < 3);

	      $line .= ">$p3";
	      $line .= "</TD>\n<TD ";
	      $line .= "CLASS=\"right\"" if ($tmp > 2);
	      $line .= "CLASS=\"head_right_dir_traffic\"" if ($tmp < 3);
#	      printf FOUT ">%.1f %",$p2;     
	      $line .= ">$p2 %";
	      $line .= "</TD>\n";
	  
	      $line .= "<TD ";
	      $line .= "CLASS=\"right\"" if ($tmp > 2);
	      $line .= "CLASS=\"head_right_dir_traffic\"" if ($tmp < 3);
	      $line .= ">$p4";
	      $line .= "</TD>\n<TD ";
	      $line .= "CLASS=\"right\"" if ($tmp > 2);
	      $line .= "CLASS=\"head_right_dir_traffic\"" if ($tmp < 3);
#	      printf FOUT ">%.1f %",$p;
	      $line .= ">$p %";
	      $line .= "</TD>\n";
	  }
          
	  $line .= "</TR>\n";
      }
      }

  }

  $line .= "</tbody>\n";
  $line .= "</TABLE>\n";

  # Substract internal req from level
  $tmp = $freqrac{$dirsepurl}-$freq2rac{$dirsepurl};

  print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";

  if ($tmp != 0) {
  print FOUT "<TR><TH>$L{'Level'} 2</TH>";
  print FOUT "<TH>$L{'Level'} 3</TH>" if (($squid_format == 0 && $tot3size > 0) || $precision > 3);
  print FOUT "</TR><TR><TD>\n";

  # Level 2

  if ($fly_set == 1) {
      $repert_pie = "repert_pie1".$gifext;
      ($line_pie,$map_dir_pie) = &MakePieChart($repert_pie,$tmp,\%freqtmp1,0,0,'',$rayon);
  }

  if ($fly_set == 0) {
      $chart_id = 0;
      $info = "info".$chart_id;
      $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%freqtmp1,\@serie_color,$tmp,0,1,$unit,$chart_id,0,$info,"","",$dirstatus);
  }

# Si reqtot =>
#  $line_pie .= "<TR>\n";
#  $line_pie .= "<TD CLASS=\"left\" " if (($j/2) == int($j/2));
#  $line_pie .= "<TD CLASS=\"left_alter\" " if (($j/2) != int($j/2));
#  $line_pie .= "VALIGN=\"BOTTOM\"><IMG WIDTH=\"$square\" HEIGHT=\"$square\" SRC=\"$tmplink$linkpathinit$dirress$dirsepurl$others\" ALT=\"$others\">&nbsp;";
#  $line_pie .= "$dirsepurl";
#  $line_pie .= "&nbsp;</TD>";
	    
#  $line_pie .= "<TD CLASS=\"right\">" if (($j/2) == int($j/2));
#  $line_pie .= "<TD CLASS=\"right_alter\">" if (($j/2) != int($j/2));

#  $line_pie .= "$freq2rac{$dirsepurl}";
#  $line_pie .= "</TD>\n";

#  $pourcentvalue = int(100*$freq2rac{$dirsepurl}/$reqtot);
		
#  $line_pie .= "<TD CLASS=\"right\">" if (($j/2) == int($j/2));
#  $line_pie .= "<TD CLASS=\"right_alter\">" if (($j/2) != int($j/2));
#  $line_pie .= "$pourcentvalue" if (int($pourcentvalue) != $pourcentvalue);
#  $line_pie .= $pourcentvalue.".0" if (int($pourcentvalue) == $pourcentvalue);
#  $line_pie .= "&nbsp;%</TD></TR>\n";

  print FOUT "<DIV ID=\"tog_req\" STYLE=\"display:inline\">";
  print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
  print FOUT "<TR><TD ALIGN=CENTER VALIGN=MIDDLE>";
  print FOUT "<TABLE BORDER=0>";
  print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Directories'}</TH></TR>";
  print FOUT "$line_pie";
  print FOUT "</TABLE>\n";
  print FOUT "</TD>\n";
  
  print FOUT "<TD ALIGN=CENTER>";
  if ($fly_set == 1) {
      print FOUT "<IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$repert_pie\" USEMAP=\"#map_dir_graph\" BORDER=0 ALT=\"graph\">\n";
  }
  if ($fly_set == 0) {
      print FOUT "<div id=\"";
      print FOUT "chart".$chart_id;
      print FOUT "\" ";
      print FOUT "style=\"";
      print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
      print FOUT "</div>\n";
  }
  print FOUT "<P><I>$L{'Requests'} ";
  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
      print FOUT " - <A HREF=\"javascript:ToggleDelta('tog_access','tog_req','tog_traffic');\">$L{'Accesses'}</A>" if ($fly_set == 1);
      print FOUT " - <A HREF=\"javascript:ToggleJqplotGraph3(plot1,'tog_access','tog_req','tog_traffic');\">$L{'Accesses'}</A>" if ($fly_set == 0);
  }
  if ($notrafic == 0) {
      if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	  print FOUT " - <A HREF=\"javascript:ToggleDelta('tog_traffic','tog_req','tog_access');\">$L{'Traffic'}</A>" if ($fly_set == 1);
	  print FOUT " - <A HREF=\"javascript:ToggleJqplotGraph3(plot2,'tog_traffic','tog_req','tog_access');\">$L{'Traffic'}</A>" if ($fly_set == 0);
      } else {
	  print FOUT " - <A HREF=\"javascript:ToggleBeta('tog_traffic','tog_req');\">$L{'Traffic'}</A>" if ($fly_set == 1);
	  print FOUT " - <A HREF=\"javascript:ToggleJqplotGraph2(plot1,'tog_traffic','tog_req');\">$L{'Traffic'}</A>" if ($fly_set == 0);
      }
  }
  print FOUT "</I></TD></TR></TABLE>\n";

  if ($fly_set == 1) {
      print FOUT "<MAP NAME=\"map_dir_graph\">\n";
      $tmp = $map_dir_pie;
      $tmp =~ s/<!-- langhome -->/$I/g;
      print FOUT "$tmp";
      print FOUT "</MAP>\n";
  }
  if ($fly_set == 0) {
      if ($xmax_jqplot != $xmax_home_jqplot) {
	  print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
      }
      print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
  }
  print FOUT "</DIV>";

  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {

      $tmp = $freqrachtml{$dirsepurl}-$freq2rachtml{$dirsepurl};
      if ($fly_set == 1) {
	  $repert_pie = "repert_pie2".$gifext;
	  ($line_pie,$map_dir_pie) = &MakePieChart($repert_pie,$tmp,\%freqtmp2,0,0,'',$rayon);
      }

      if ($fly_set == 0 && $tmp != 0) {
	  $chart_id++;
	  $info = "info".$chart_id;
	  $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%freqtmp2,\@serie_color,$tmp,0,1,$unit,$chart_id,0,$info,"","",$dirstatus);
      }

#      $line_pie .= "<TR>\n";
#      $line_pie .= "<TD CLASS=\"left\" " if (($j/2) == int($j/2));
#      $line_pie .= "<TD CLASS=\"left_alter\" " if (($j/2) != int($j/2));
#      $line_pie .= "VALIGN=\"BOTTOM\"><IMG WIDTH=\"$square\" HEIGHT=\"$square\" SRC=\"$tmplink$linkpathinit$dirress$dirsepurl$others\" ALT=\"$others\">&nbsp;";
#      $line_pie .= "$dirsepurl";
#      $line_pie .= "&nbsp;</TD>";
      
#      $line_pie .= "<TD CLASS=\"right\">" if (($j/2) == int($j/2));
#      $line_pie .= "<TD CLASS=\"right_alter\">" if (($j/2) != int($j/2));
      
#      $line_pie .= "$freq2rachtml{$dirsepurl}";
#      $line_pie .= "</TD>\n";

#      $pourcentvalue = int(100*$freq2rachtml{$dirsepurl}/$access);
		
#      $line_pie .= "<TD CLASS=\"right\">" if (($j/2) == int($j/2));
#      $line_pie .= "<TD CLASS=\"right_alter\">" if (($j/2) != int($j/2));
#      $line_pie .= "$pourcentvalue" if (int($pourcentvalue) != $pourcentvalue);
#      $line_pie .= $pourcentvalue.".0" if (int($pourcentvalue) == $pourcentvalue);
#      $line_pie .= "&nbsp;%</TD></TR>\n";


      print FOUT "<DIV ID=\"tog_access\" STYLE=\"display:none\">";
      print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
      print FOUT "<TR><TD ALIGN=CENTER VALIGN=MIDDLE>";
      print FOUT "<TABLE BORDER=0>";
      print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Directories'}</TH></TR>";
      print FOUT "$line_pie";
      print FOUT "</TABLE>\n";
      print FOUT "</TD>\n";
      
      print FOUT "<TD ALIGN=CENTER>";
      if ($fly_set == 1) {
	  print FOUT "<IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$repert_pie\" USEMAP=\"#map_dir2_graph\" BORDER=0 ALT=\"graph\">\n";
      }
      if ($fly_set == 0) {
	  print FOUT "<div id=\"";
	  print FOUT "chart".$chart_id;
	  print FOUT "\" ";
	  print FOUT "style=\"";
	  print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
	  print FOUT "</div>\n";
      }

      print FOUT "<P><I><A HREF=\"javascript:ToggleDelta('tog_req','tog_access','tog_traffic');\">$L{'Requests'}</A> - $L{'Accesses'} " if ($fly_set == 1);
      print FOUT "<P><I><A HREF=\"javascript:ToggleJqplotGraph3(plot0,'tog_req','tog_access','tog_traffic');\">$L{'Requests'}</A> - $L{'Accesses'} " if ($fly_set == 0);
      if ($notrafic == 0) {
	  print FOUT "- <A HREF=\"javascript:ToggleDelta('tog_traffic','tog_req','tog_access');\">$L{'Traffic'}</A>" if ($fly_set == 1);
	  print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph3(plot2,'tog_traffic','tog_req','tog_access');\">$L{'Traffic'}</A>" if ($fly_set == 0);
      }
      print FOUT "</I></TD></TR></TABLE>\n";

      if ($fly_set == 1) {
	  print FOUT "<MAP NAME=\"map_dir2_graph\">\n";
	  $tmp = $map_dir_pie;
	  $tmp =~ s/<!-- langhome -->/$I/g;
	  print FOUT "$tmp";
	  print FOUT "</MAP>\n";
      }
      if ($fly_set == 0) {
	  if ($xmax_jqplot != $xmax_home_jqplot) {
	      print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
	  }
	  print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
      }
      print FOUT "</DIV>";
  }

  if ($notrafic == 0) {

      if ($fly_set == 1) {
	  $repert_pie = "repert_pie3".$gifext;
	  $tmp = $totsize;
	  ($line_pie,$map_dir_pie) = &MakePieChart($repert_pie,$tmp,\%freqtmp3,0,1,'',$rayon);
      }

      if ($fly_set == 0 && $totsize != 0) {
	  $chart_id++;
	  $info = "info".$chart_id;
	  $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%freqtmp3,\@serie_color,$totsize,0,$unit_div,$unit,$chart_id,0,$info,"","",$dirstatus);
      }

      print FOUT "<DIV ID=\"tog_traffic\" STYLE=\"display:none\">";
      print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
      print FOUT "<TR><TD ALIGN=CENTER VALIGN=MIDDLE>";
      print FOUT "<TABLE BORDER=0>";
      print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Directories'}</TH></TR>";
      print FOUT "$line_pie";
      print FOUT "</TABLE>\n";
      print FOUT "</TD>\n";
  
      print FOUT "<TD ALIGN=CENTER>";
      if ($fly_set == 1) {
	  print FOUT "<IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$repert_pie\" USEMAP=\"#map_dir3_graph\" BORDER=0 ALT=\"graph\">\n";
      }
      if ($fly_set == 0) {
	  print FOUT "<div id=\"";
	  print FOUT "chart".$chart_id;
	  print FOUT "\" ";
	  print FOUT "style=\"";
	  print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
	  print FOUT "</div>\n";
      }
      print FOUT "<P><I>";
      if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	  print FOUT "<A HREF=\"javascript:ToggleDelta('tog_req','tog_access','tog_traffic');\">" if ($fly_set == 1);
	  print FOUT "<A HREF=\"javascript:ToggleJqplotGraph3(plot0,'tog_req','tog_access','tog_traffic');\">" if ($fly_set == 0);
      } else {
	  print FOUT "<A HREF=\"javascript:ToggleBeta('tog_req','tog_traffic');\">" if ($fly_set == 1);
	  print FOUT "<A HREF=\"javascript:ToggleJqplotGraph2(plot0,'tog_req','tog_traffic');\">" if ($fly_set == 0);
      }
      print FOUT "$L{'Requests'}</A> - ";
      if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	  print FOUT "<A HREF=\"javascript:ToggleDelta('tog_access','tog_traffic','tog_req');\">$L{'Accesses'}</A> - " if ($fly_set == 1);
	  print FOUT "<A HREF=\"javascript:ToggleJqplotGraph3(plot1,'tog_access','tog_traffic','tog_req');\">$L{'Accesses'}</A> - " if ($fly_set == 0);
      }
      print FOUT "$L{'Traffic'}";
      print FOUT "</I></TD></TR></TABLE>\n";
      if ($fly_set == 1) {
	  print FOUT "<MAP NAME=\"map_dir3_graph\">\n";
	  $tmp = $map_dir_pie;
	  $tmp =~ s/<!-- langhome -->/$I/g;
	  print FOUT "$tmp";
	  print FOUT "</MAP>\n";
      }
      if ($fly_set == 0) {
	  if ($xmax_jqplot != $xmax_home_jqplot) {
	      print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
	  }
	  print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
      }
      print FOUT "</DIV>";
  }


  print FOUT "</TD>\n";
  print FOUT "<TD>\n";

  # Level 3

  if (($squid_format == 0 && $tot3size > 0) || $precision > 3) {

      if ($fly_set == 1) {
	  $repert_pie = "repert_pie4".$gifext;
	  ($line_pie,$map_dir_pie) = &MakePieChart($repert_pie,$tot3rac,\%freqtmp4,0,0,'',$rayon);
      }

      if ($fly_set == 0 && $tot3rac != 0) {
	  $chart_id++;
	  $info = "info".$chart_id;
	  $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%freqtmp4,\@serie_color,$tot3rac,0,1,$unit,$chart_id,0,$info,"","",$dirstatus);
      }

      print FOUT "<DIV ID=\"tog2_req\" STYLE=\"display:inline\">";
      print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
      print FOUT "<TR><TD ALIGN=CENTER VALIGN=MIDDLE>";
      print FOUT "<TABLE BORDER=0>";
      print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Directories'}</TH></TR>";
      print FOUT "$line_pie";
      print FOUT "</TABLE>\n";
      print FOUT "</TD>\n";
      
      print FOUT "<TD ALIGN=CENTER>";
      if ($fly_set == 1) {
	  print FOUT "<IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$repert_pie\" USEMAP=\"#map_dir4_graph\" BORDER=0 ALT=\"graph\">\n";
      }
      if ($fly_set == 0) {
	  print FOUT "<div id=\"";
	  print FOUT "chart".$chart_id;
	  print FOUT "\" ";
	  print FOUT "style=\"";
	  print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
	  print FOUT "</div>\n";
      }
      print FOUT "<P><I>$L{'Requests'} ";
      if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	  print FOUT " - <A HREF=\"javascript:ToggleDelta('tog2_access','tog2_req','tog2_traffic');\">$L{'Accesses'}</A>" if ($fly_set == 1);
	  print FOUT " - <A HREF=\"javascript:ToggleJqplotGraph3(plot4,'tog2_access','tog2_req','tog2_traffic');\">$L{'Accesses'}</A>" if ($fly_set == 0);
      }
      if ($notrafic == 0) {
	  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	      print FOUT " - <A HREF=\"javascript:ToggleDelta('tog2_traffic','tog2_req','tog2_access');\">$L{'Traffic'}</A>" if ($fly_set == 1);
	      print FOUT " - <A HREF=\"javascript:ToggleJqplotGraph3(plot5,'tog2_traffic','tog2_req','tog2_access');\">$L{'Traffic'}</A>" if ($fly_set == 0);
	  } else {
	      print FOUT " - <A HREF=\"javascript:ToggleBeta('tog2_traffic','tog2_req');\">$L{'Traffic'}</A>" if ($fly_set == 1);
	      print FOUT " - <A HREF=\"javascript:ToggleJqplotGraph2(plot3,'tog2_traffic','tog2_req');\">$L{'Traffic'}</A>" if ($fly_set == 0);
	  }
      }
      print FOUT "</I></TD></TR></TABLE>\n";
      
      if ($fly_set == 1) {
	  print FOUT "<MAP NAME=\"map_dir4_graph\">\n";
	  $tmp = $map_dir_pie;
	  $tmp =~ s/<!-- langhome -->/$I/g;
	  print FOUT "$tmp";
	  print FOUT "</MAP>\n";
      }
      if ($fly_set == 0) {
	  if ($xmax_jqplot != $xmax_home_jqplot) {
	      print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
	  }
	  print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
      }
      print FOUT "</DIV>";

      if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {

	  if ($fly_set == 1) {
	      $repert_pie = "repert_pie5".$gifext;
	      ($line_pie,$map_dir_pie) = &MakePieChart($repert_pie,$tot3acc,\%freqtmp5,0,0,'',$rayon);
	  }

	  if ($fly_set == 0 && $tot3acc != 0) {
	      $chart_id++;
	      $info = "info".$chart_id;
	      $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%freqtmp5,\@serie_color,$tot3acc,0,1,$unit,$chart_id,0,$info,"","",$dirstatus);
	  }

	  print FOUT "<DIV ID=\"tog2_access\" STYLE=\"display:none\">";
	  print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
	  print FOUT "<TR><TD ALIGN=CENTER VALIGN=MIDDLE>";
	  print FOUT "<TABLE BORDER=0>";
	  print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Directories'}</TH></TR>";
	  print FOUT "$line_pie";
	  print FOUT "</TABLE>\n";
	  print FOUT "</TD>\n";
	  print FOUT "<TD ALIGN=CENTER>";
	  if ($fly_set == 1) {
	      print FOUT "<IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$repert_pie\" USEMAP=\"#map_dir5_graph\" BORDER=0 ALT=\"graph\">\n";
	  }
	  if ($fly_set == 0) {
	      print FOUT "<div id=\"";
	      print FOUT "chart".$chart_id;
	      print FOUT "\" ";
	      print FOUT "style=\"";
	      print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
	      print FOUT "</div>\n";
	  }
	  print FOUT "<P><I><A HREF=\"javascript:ToggleDelta('tog2_req','tog2_access','tog2_traffic');\">$L{'Requests'}</A> - $L{'Accesses'} " if ($fly_set == 1);
	  print FOUT "<P><I><A HREF=\"javascript:ToggleJqplotGraph3(plot3,'tog2_req','tog2_access','tog2_traffic');\">$L{'Requests'}</A> - $L{'Accesses'} " if ($fly_set == 0);
	  if ($notrafic == 0) {
	      print FOUT "- <A HREF=\"javascript:ToggleDelta('tog2_traffic','tog2_req','tog2_access');\">$L{'Traffic'}</A>" if ($fly_set == 1);
	      print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph3(plot5,'tog2_traffic','tog2_req','tog2_access');\">$L{'Traffic'}</A>" if ($fly_set == 0);
	  }
	  print FOUT "</I></TD></TR></TABLE>\n";
	 
	  if ($fly_set == 1) {
	      print FOUT "<MAP NAME=\"map_dir5_graph\">\n";
	      $tmp = $map_dir_pie;
	      $tmp =~ s/<!-- langhome -->/$I/g;
	      print FOUT "$tmp";
	      print FOUT "</MAP>\n";
	  }
	  if ($fly_set == 0) {
	      if ($xmax_jqplot != $xmax_home_jqplot) {
		  print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
	      }
	      print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
	  }
	  print FOUT "</DIV>";
      }
      
      if ($notrafic == 0) {
	  $repert_pie = "repert_pie6".$gifext;

	  if ($fly_set == 1) {
	      $tmp = $tot3size;
	      ($line_pie,$map_dir_pie) = &MakePieChart($repert_pie,$tmp,\%freqtmp6,0,1,'',$rayon);
	  }

	  if ($fly_set == 0 && $tot3size != 0) {
	      $chart_id++;
	      $info = "info".$chart_id;
	      $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%freqtmp6,\@serie_color,$tot3size,0,$unit_div,$unit,$chart_id,0,$info,"","",$dirstatus);
	  }

	  print FOUT "<DIV ID=\"tog2_traffic\" STYLE=\"display:none\">";
	  print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
	  print FOUT "<TR><TD ALIGN=CENTER VALIGN=MIDDLE>";
	  print FOUT "<TABLE BORDER=0>";
	  print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Directories'}</TH></TR>";
	  print FOUT "$line_pie";
	  print FOUT "</TABLE>\n";
	  print FOUT "</TD>\n";
	  
	  print FOUT "<TD ALIGN=CENTER>";
	  print FOUT "<IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$repert_pie\" USEMAP=\"#map_dir6_graph\" BORDER=0 ALT=\"graph\">\n" if ($fly_set == 1);
	  if ($fly_set == 0) {
	      print FOUT "<div id=\"";
	      print FOUT "chart".$chart_id;
	      print FOUT "\" ";
	      print FOUT "style=\"";
	      print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
	      print FOUT "</div>\n";
	  }
	  print FOUT "<P><I>";
	  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	      print FOUT "<A HREF=\"javascript:ToggleDelta('tog2_req','tog2_access','tog2_traffic');\">" if ($fly_set == 1);
	      print FOUT "<A HREF=\"javascript:ToggleJqplotGraph3(plot3,'tog2_req','tog2_access','tog2_traffic');\">" if ($fly_set == 0);
	  } else {
	      print FOUT "<A HREF=\"javascript:ToggleBeta('tog2_req','tog2_traffic');\">" if ($fly_set == 1);
	      print FOUT "<A HREF=\"javascript:ToggleJqplotGraph2(plot3,'tog2_req','tog2_traffic');\">" if ($fly_set == 0);
	  }
	  print FOUT "$L{'Requests'}</A> - ";
	  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	      print FOUT "<A HREF=\"javascript:ToggleDelta('tog2_access','tog2_traffic','tog2_req');\">$L{'Accesses'}</A> - " if ($fly_set == 1);
	      print FOUT "<A HREF=\"javascript:ToggleJqplotGraph3(plot4,'tog2_access','tog2_traffic','tog2_req');\">$L{'Accesses'}</A> - " if ($fly_set == 0);
	  } 
	  print FOUT "$L{'Traffic'}";
	  print FOUT "</I></TD></TR></TABLE>\n";
	  if ($fly_set == 1) {
	      print FOUT "<MAP NAME=\"map_dir6_graph\">\n";
	      $tmp = $map_dir_pie;
	      $tmp =~ s/<!-- langhome -->/$I/g;
	      print FOUT "$tmp";
	      print FOUT "</MAP>\n";
	  }
	  if ($fly_set == 0) {
	      if ($xmax_jqplot != $xmax_home_jqplot) {
		  print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
	      }
	      print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
	  }
	  print FOUT "</DIV>";
      }
      
  }
  print FOUT "</TD>";
  print FOUT "</TR>";
  }
  print FOUT "<TR>\n";

  print FOUT "<TD VALIGN=TOP><DIV CLASS=\"item_page\">-&nbsp;$L{'Requests'} - $L{'Sort'} : <A HREF=\"javascript:ToggleBeta('tog_alpha','tog_value');\">$L{'Alphabetically'}</A> - <A HREF=\"javascript:ToggleBeta('tog_value','tog_alpha');\">$L{'By_size'}</A></DIV></TD>";
  print FOUT "<TD VALIGN=TOP><DIV CLASS=\"item_page\">-&nbsp;$L{'Accesses'} - $L{'Sort'} : <A HREF=\"javascript:ToggleBeta('tog_alpha2','tog_value2');\">$L{'Alphabetically'}</A> - <A HREF=\"javascript:ToggleBeta('tog_value2','tog_alpha2');\">$L{'By_size'}</A></DIV></TD>";
  print FOUT "</TR>\n";
  print FOUT "<TR>\n";
  print FOUT "<TD VALIGN=TOP align=\"justify\">\n";

  ($line_cloud,$line_cloud_sort) = &MakeCloud(\%freqrac,'',0) if ($virtualCLF == 0 && $squid_format == 0 && $ftp_format == 0);
  ($line_cloud,$line_cloud_sort) = &MakeCloud(\%freqrac,'',1) if ($virtualCLF == 1 ||  $squid_format == 1 || $ftp_format == 1);

  print FOUT "<DIV ID=\"tog_alpha\" STYLE=\"display:inline\">";
  print FOUT "$line_cloud\n";
  print FOUT "</DIV>\n";
  print FOUT "<P>";

  print FOUT "<DIV ID=\"tog_value\" STYLE=\"display:none\">";
  print FOUT "$line_cloud_sort\n";
  print FOUT "</DIV>\n";

  print FOUT "</TD><TD VALIGN=TOP align=\"justify\">";

  ($line_cloud,$line_cloud_sort) = &MakeCloud(\%freqrachtml,'',0) if ($virtualCLF == 0 && $squid_format == 0 && $ftp_format == 0);
  ($line_cloud,$line_cloud_sort) = &MakeCloud(\%freqrachtml,'',1) if ($virtualCLF == 1 || $squid_format == 1 || $ftp_format == 1);

  print FOUT "<DIV ID=\"tog_alpha2\" STYLE=\"display:inline\">";
  print FOUT "$line_cloud\n";
  print FOUT "</DIV>\n";
  print FOUT "<P>";

  print FOUT "<DIV ID=\"tog_value2\" STYLE=\"display:none\">";
  print FOUT "$line_cloud_sort\n";
  print FOUT "</DIV>\n";


  print FOUT "</TD></TR></TABLE>\n";

  print FOUT "<BR><P>\n";

  print FOUT "$line";

  print FOUT "</BODY></HTML>\n";

  undef %freqtmp1;
  undef %freqtmp2;
  undef %freqtmp3;
  undef %freqtmp4;
  undef %freqtmp5;
  undef %freqtmp6;

}

#
##############################################################
### Virtual hosts
##############################################################
#

sub PagesVirtualAcc {
  local(*FOUT,*L,$I,$vserver) = @_;
  print FOUT "$doctype\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Stats_about_destinations'} - $vserver</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\">\n";
  print FOUT "function ToggleMenu(obj) {\n";
  print FOUT "target = document.getElementById(obj);\n";
  print FOUT "if (target.style.display == \"none\"){\n";
  print FOUT "target.style.display = \"inline\";\n";
  print FOUT "} else {\n";
  print FOUT "target.style.display = \"none\";\n";
  print FOUT "}\n";
  print FOUT "}\n";
  print FOUT "function ToggleMenuAll(obj) {\n";
  print FOUT " var elementsDIV = document.getElementsByTagName('div');\n";
  print FOUT "	for (var i = 0; i < elementsDIV.length; i++) {\n";
  print FOUT "     var el = elementsDIV[i].id;\n";
  print FOUT "     if (el.indexOf(\"TOGGLE_\") != -1) {\n";
  print FOUT "     elementsDIV[i].style.display  = (elementsDIV[i].style.display != 'none' ? 'none' : 'inline');\n";
  print FOUT "     }\n";
  print FOUT "	}\n";
  print FOUT "}\n";
  print FOUT "</SCRIPT>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
  &help_div(*FOUT);


  $tmp10 = $ssdomvirtualhtml{$ssvserver};
  $tmp10 = $max_item_page if ($tmp10 > $max_item_page);

  print FOUT "<H2>$L{'Stats_about_destinations'} - $vserver</H2><P>\n";

  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} ";
 # if ($display_all == 1) {
      print FOUT "$tmp10 ";
      print FOUT "($L{'among'} $ssdomvirtualhtml{$ssvserver}) " if ($tmp10 == $max_item_page);
  #}
#  if ($show_all == 1 && $display_all == 0) {
 #     print FOUT "$topten";
  #    print FOUT " (<A HREF=\"$listdestination\">$L{'Full_list'}</A>)" if ($tmp10 > $topten);
  #}
  print FOUT "</I></DIV><P>\n";

  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe ";
  print FOUT "table-autopage:$table_big_lines_aff " if ($tmp10 > $table_big_lines_aff);
  print FOUT "table-stripeclass:alternate\" id=\"page\">\n";
  print FOUT "<thead>\n";
  print FOUT "<tr>\n";
#  print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"virtual\"><TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Requests'}&nbsp;</TH>\n";
#  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n";
  if ($notrafic == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'} (";
      print FOUT "$L{'bytes'}" if ($unitdom == 1);
      print FOUT "$L{'Kb'}" if ($unitdom == 1024);
      print FOUT "$L{'Mb'}" if ($unitdom == (1024*1024));
      print FOUT "$L{'Gb'}" if ($unitdom == (1024*1024*1024));
      print FOUT "$L{'Tb'}" if ($unitdom == (1024*1024*1024*1024));
      print FOUT ")&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH></TR>\n";
  }
  print FOUT "</thead>\n";

  if ($display_all == 1 && $tmp10 > $table_big_lines_aff) {

      $tmp = int($tmp10/$table_big_lines_aff);
      if ($tmp != ($tmp10/$table_big_lines_aff)) {
	  $tmp++;
      }

      print FOUT "<tfoot>\n";
      print FOUT "<tr>\n";
      print FOUT "<TH>&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
      print FOUT "<TH>&nbsp;$L{'Requests'}&nbsp;</TH>\n";
#      print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      print FOUT "<TH>&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
      print FOUT "<TH>&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n";
      if ($notrafic == 0) {
	  print FOUT "<TH>&nbsp;$L{'Traffic'}&nbsp;</TH>\n";
	  print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      }
      print FOUT "</tr>\n";
      print FOUT "<tr>\n";
      
      if ($tmp > 1) {
	  $tmp4 = 4;
	  $tmp4 += 2 if ($notrafic == 0);
	  print FOUT "<td colspan=$tmp4>\n";
	  print FOUT "<a href=\"#\" onclick=\"pageexample('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	  
	  for ($i=1;$i<=$tmp;$i++) {
	      $iminus = $i-1;
	      print FOUT "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexample($iminus); return false;\">$i</a>\n";
	  }
	  print FOUT "<a href=\"#\" onclick=\"pageexample('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "<a href=\"#\" onclick=\"pageexample('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "</td>\n";
	  print FOUT "</tr>\n";
      }
      print FOUT "</tfoot>\n";
      
  }

  print FOUT "<tbody>\n";

  $tmp = "virtualpages_".$ssvserver;
  @$tmp = reverse sort bynumber @$tmp;

  $count = 0;
  for ($i=0;$i<=$#$tmp;$i++) {

      $count++;
      if ($count < $max_item_page) {
	  $page = $$tmp[$i];
	  $adresse = $pagelist{$pagehas{$page},1};
	  $tmp3 = $pagelist_date{$pagehas{$page},$adressehad{$adresse}};
	  ($date) = &get_time($tmp3*86400);
	  $date =~ s/\// /g;
	  print FOUT "<TR>\n<TD CLASS=\"left\">&nbsp;";
	  $link = &AddHREF($page);
	  $link = &EncryptLink($link) if ($crypt == 1);		  
	  print FOUT "$link";
	  print FOUT "&nbsp;</TD>\n";

	  print FOUT "<TD CLASS=\"right\">&nbsp;$pageslues{$page}&nbsp;</TD>\n";
	  print FOUT "<TD CLASS=\"right\"";
	  print FOUT " TITLE=\"$resolv_user{$adresse}\"" if ($resolv_user{$adresse} ne '');
	  print FOUT ">&nbsp;$adresse&nbsp;</TD>\n";
	  print FOUT "<TD CLASS=\"right\">&nbsp;$date&nbsp;</TD>\n";
	  print FOUT "</TR>\n";
      }
#      print FOUT "<BR>$page - $pageslues{$page} - $adresse - $date";
  }

  print FOUT "</tbody>\n";
  print FOUT "</TABLE><P>\n";


  print FOUT "</BODY></HTML>\n";

}

sub PagesVirtual {
  local(*FOUT,*L,$I,$display_all) = @_;

  print FOUT "$doctype\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Stats_about_destinations'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\">\n";
  print FOUT "function ToggleMenu(obj) {\n";
  print FOUT "target = document.getElementById(obj);\n";
  print FOUT "if (target.style.display == \"none\"){\n";
  print FOUT "target.style.display = \"inline\";\n";
  print FOUT "} else {\n";
  print FOUT "target.style.display = \"none\";\n";
  print FOUT "}\n";
  print FOUT "}\n";
  print FOUT "function ToggleMenuAll(obj) {\n";
  print FOUT " var elementsDIV = document.getElementsByTagName('div');\n";
  print FOUT "	for (var i = 0; i < elementsDIV.length; i++) {\n";
  print FOUT "     var el = elementsDIV[i].id;\n";
  print FOUT "     if (el.indexOf(\"TOGGLE_\") != -1) {\n";
  print FOUT "     elementsDIV[i].style.display  = (elementsDIV[i].style.display != 'none' ? 'none' : 'inline');\n";
  print FOUT "     }\n";
  print FOUT "	}\n";
  print FOUT "}\n";
  print FOUT "</SCRIPT>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";
  &add_jqplot_js(*FOUT,2);
  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
  &help_div(*FOUT);

  $tmp10 = $virtualunique;
  $tmp10 = $max_item_page if ($tmp10 > $max_item_page);

  print FOUT "<H2>$L{'Stats_about_destinations'}</H2><P>\n";

  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'Sorted_destination_servers'} : $L{'The_Top'} ";
  if ($display_all == 1) {
      print FOUT "$tmp10 ";
      print FOUT "($L{'among'} $virtualunique) " if ($tmp10 == $max_item_page);
  }
  if ($show_all == 1 && $display_all == 0) {
      print FOUT "$topten";
      print FOUT " (<A HREF=\"$listdestination\">$L{'Full_list'}</A>)" if ($tmp10 > $topten);
  }
  print FOUT "</I></DIV><P>\n";

  $tmp = $ssdomvirtualsize{(&reverse_sort_by_value(*ssdomvirtualsize))[0]};

  ($unitdom,$unit) = &Return_Unit($tmp,0);
#  $tmp = $ssdomvirtualsize{(&reverse_sort_by_value(*ssdomvirtualsize))[0]};

#  $unitdom = 1;
#  $unitdom = 1024 if ($tmp > 1024);
#  $unitdom = 1024*1024 if ($tmp > (1024*1024));
#  $unitdom = 1024*1024*1024 if ($tmp > (1024*1024*1024));
#  $unitdom = 1024*1024*1024*1024 if ($tmp > (1024*1024*1024*1024));

  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe ";
  print FOUT "table-autopage:$table_big_lines_aff " if ($tmp10 > $table_big_lines_aff);
  print FOUT "table-stripeclass:alternate\" id=\"page\">\n";
  print FOUT "<thead>\n";
  print FOUT "<tr>\n";
#  print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"virtual\"><TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Destination'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Requests'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  if ($dhcp_format == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  }
  if ($notrafic == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'} (";
      print FOUT "$L{$unit}";
#      print FOUT "$L{'bytes'}" if ($unitdom == 1);
#      print FOUT "$L{'Kb'}" if ($unitdom == 1024);
#      print FOUT "$L{'Mb'}" if ($unitdom == (1024*1024));
#      print FOUT "$L{'Gb'}" if ($unitdom == (1024*1024*1024));
#      print FOUT "$L{'Tb'}" if ($unitdom == (1024*1024*1024*1024));
      print FOUT ")&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH></TR>\n";
  }
  print FOUT "</thead>\n";

  if ($display_all == 1 && $tmp10 > $table_big_lines_aff) {

      $tmp = int($tmp10/$table_big_lines_aff);
      if ($tmp != ($tmp10/$table_big_lines_aff)) {
	  $tmp++;
      }

      print FOUT "<tfoot>\n";
      print FOUT "<tr>\n";
      print FOUT "<TH>&nbsp;$L{'Destination'}&nbsp;</TH>\n";
      print FOUT "<TH>&nbsp;$L{'Requests'}&nbsp;</TH>\n";
      print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      if ($dhcp_format == 0) {
	  print FOUT "<TH>&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
	  print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      }
      if ($notrafic == 0) {
	  print FOUT "<TH>&nbsp;$L{'Traffic'}&nbsp;</TH>\n";
	  print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      }
      print FOUT "</tr>\n";
      print FOUT "<tr>\n";
      
      if ($tmp > 1) {
	  $tmp4 = 3;
	  $tmp4 += 2 if ($notrafic == 0);
	  $tmp4 += 2 if ($dhcp_format == 0);
	  print FOUT "<td colspan=$tmp4>\n";
	  print FOUT "<a href=\"#\" onclick=\"pageexample('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	  
	  for ($i=1;$i<=$tmp;$i++) {
	      $iminus = $i-1;
	      print FOUT "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexample($iminus); return false;\">$i</a>\n";
	  }
	  print FOUT "<a href=\"#\" onclick=\"pageexample('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "<a href=\"#\" onclick=\"pageexample('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "</td>\n";
	  print FOUT "</tr>\n";
      }
      print FOUT "</tfoot>\n";
      
  }

  print FOUT "<tbody>\n";

  $count = 0;
  foreach $ssvserver (&reverse_sort_by_value(*ssdomvirtualreq)) {
#      if (($count < $topten && $ssdomvirtualreq{$ssvserver} > $seuilsite && $display_all == 0) || ($count < $max_item_page && $display_all == 1)) {
      if (($count < $topten && $display_all == 0) || ($count < $max_item_page && $display_all == 1)) {
	  $count++;
	  $pourcentage = ($ssdomvirtualreq{$ssvserver}*100)/$totvirtual if ($totvirtual != 0);
	  $pourcentageint = int($pourcentage);
#	  $pourcentage2 = ($ssdomvirtualsize{$ssvserver}*100)/($totvirtualsize*$unit_virtual) if ($totvirtualsize != 0);
	  $pourcentage2 = ($ssdomvirtualsize{$ssvserver}*100)/$totvirtualsize if ($totvirtualsize != 0);
	  $pourcentageint2 = int($pourcentage2);
	  print FOUT "<TR>\n<TD CLASS=\"left\">&nbsp;";
	  $tmp = $ssvserver;
	  $tmp =~ s/ /_/g;
	  print FOUT "<A HREF=\"$tmp$htmlext\">" if ($cups_format == 1);
	  print FOUT "$ssvserver";
	  print FOUT "</A>" if ($cups_format == 1);
	  print FOUT "&nbsp;</TD>\n";
	  print FOUT "<TD CLASS=\"left\">";
	  print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\"> " if ($pourcentageint != 0);
	  print FOUT "$ssdomvirtualreq{$ssvserver}</TD>\n";
	  printf FOUT "<TD CLASS=\"right\">%.1f %</TD>\n",$pourcentage;

	  if ($dhcp_format == 0) {
	      $pourcentage = ($ssdomvirtualhtml{$ssvserver}*100)/$totvirtualhtml if ($totvirtualhtml != 0);
	      $pourcentageint = int($pourcentage);
	      print FOUT "<TD CLASS=\"left\">";
	      print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\"> " if ($pourcentageint != 0);
	      print FOUT "$ssdomvirtualhtml{$ssvserver}</TD>\n";
	      printf FOUT "<TD CLASS=\"right\">%.1f %</TD>\n",$pourcentage;
	  }

	  if ($notrafic == 0) {
	      print FOUT "<TD CLASS=\"left\">";
	      print FOUT "<IMG WIDTH=$pourcentageint2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\"> " if ($pourcentageint2 != 0);
#	  $tmp2 = $ssdomvirtualsize{$ssvserver}*$unit_virtual/$unitdom;
	      $tmp2 = $ssdomvirtualsize{$ssvserver}/$unitdom;
	      printf FOUT "%.2f</TD>\n",$tmp2;
	      printf FOUT "<TD CLASS=\"right\">%.1f %</TD>\n",$pourcentage2;
	  }
	  print FOUT "</TR>\n";
      }
  }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE><P>\n";

  if ($display_all == 0) {

  print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
  print FOUT "<TR><TD VALIGN=TOP>\n";

  ($line_cloud,$line_cloud_sort) = &MakeCloud(\%ssdomvirtualreq,'',1);

  if ($fly_set == 0) {
      $chart_id = 0;
      $info = "info".$chart_id;
      $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%ssdomvirtualreq,\@serie_color,$totvirtual,2,1,$unit,$chart_id,0,$info,"","",$dirstatus);
  }

  if ($fly_set == 1) {
      $destination_pie = "desrtination_pie".$gifext;
      ($line_pie,$map_virtual_pie) = &MakePieChart($destination_pie,$totvirtual,\%ssdomvirtualreq,0,0,'',$rayon);
  }

  print FOUT "<DIV ID=\"tog_req\" STYLE=\"display:inline\">";
  print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
  print FOUT "<TR><TD ALIGN=CENTER VALIGN=MIDDLE>";
  print FOUT "<TABLE BORDER=0>";
  print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Destination'}</TH></TR>";
  print FOUT "$line_pie";
  print FOUT "</TABLE>\n";
  print FOUT "</TD>\n";
  
  print FOUT "<TD ALIGN=CENTER>";
  if ($fly_set == 0) {
      print FOUT "<div id=\"";
      print FOUT "chart".$chart_id;
      print FOUT "\" ";
      print FOUT "style=\"";
      print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
      print FOUT "</div>\n";
  }
  print FOUT "<IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$destination_pie\" USEMAP=\"#map_virtual_graph\" BORDER=0 ALT=\"graph\">\n" if ($fly_set == 1);
  print FOUT "<P><I>$L{'Requests'} ";
  if ($notrafic == 0) {
      print FOUT "- <A HREF=\"javascript:ToggleDelta('tog_acc','tog_traffic','tog_req');\">$L{'Accesses'}</A> " if ($fly_set == 1 && $dhcp_format == 0);
      print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph3(plot1,'tog_acc','tog_traffic','tog_req');\">$L{'Accesses'}</A> " if ($fly_set == 0 && $dhcp_format == 0);
      print FOUT "- <A HREF=\"javascript:ToggleDelta('tog_traffic','tog_req','tog_acc');\">$L{'Traffic'}</A>" if ($fly_set == 1);
      print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph3(plot2,'tog_traffic','tog_req','tog_acc');\">$L{'Traffic'}</A>" if ($fly_set == 0);
  } else {
      print FOUT "- <A HREF=\"javascript:ToggleBeta('tog_acc','tog_req');\">$L{'Accesses'}</A> " if ($fly_set == 1 && $dhcp_format == 0);
      print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph2(plot1,'tog_acc','tog_req');\">$L{'Accesses'}</A> " if ($fly_set == 0 && $dhcp_format == 0);
  }
  print FOUT "</I></TD></TR></TABLE>\n";

  if ($fly_set == 1) {
      print FOUT "<MAP NAME=\"map_virtual_graph\">\n";
      $tmp = $map_virtual_pie;
      $tmp =~ s/<!-- langhome -->/$I/g;
      print FOUT "$tmp";
      print FOUT "</MAP>\n";
  }
  if ($fly_set == 0) {
      if ($xmax_jqplot != $xmax_home_jqplot) {
	  print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
      }
      print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
  }
  print FOUT "</DIV>";

  if ($dhcp_format == 0) {

      if ($fly_set == 0) {
	  $chart_id++;	  
	  $info = "info".$chart_id;
	  $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%ssdomvirtualhtml,\@serie_color,$totvirtualhtml,2,1,$unit,$chart_id,0,$info,"","",$dirstatus);

      }

      if ($fly_set == 1) {      
	  $desthtml_pie = "destination_pie3".$gifext;
	  ($line_pie,$map_virtual_pie) = &MakePieChart($desthtml_pie,$totvirtualhtml,\%ssdomvirtualhtml,0,0,'',$rayon);
      }

      print FOUT "<DIV ID=\"tog_acc\" STYLE=\"display:none\">";
      print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
      print FOUT "<TR><TD ALIGN=CENTER VALIGN=MIDDLE>";
      print FOUT "<TABLE BORDER=0>";
      print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Destination'}</TH></TR>";
      print FOUT "$line_pie";
      print FOUT "</TABLE>\n";
      print FOUT "</TD>\n";
      
      print FOUT "<TD ALIGN=CENTER>";
      if ($fly_set == 0) {
	  print FOUT "<div id=\"";
	  print FOUT "chart".$chart_id;
	  print FOUT "\" ";
	  print FOUT "style=\"";
	  print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
	  print FOUT "</div>\n";
      }
      print FOUT "<IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$desthtml_pie\" USEMAP=\"#map_virtual3_graph\" BORDER=0 ALT=\"graph\">\n" if ($fly_set == 1);
      if ($notrafic == 0) {
	  print FOUT "<P><I><A HREF=\"javascript:ToggleDelta('tog_req','tog_acc','tog_traffic');\">$L{'Requests'}</A> " if ($fly_set == 1);
	  print FOUT "<P><I><A HREF=\"javascript:ToggleJqplotGraph3(plot0,'tog_req','tog_acc','tog_traffic');\">$L{'Requests'}</A> " if ($fly_set == 0);
      }
      if ($notrafic == 1) {
	  print FOUT "<P><I><A HREF=\"javascript:ToggleBeta('tog_req','tog_acc');\">$L{'Requests'}</A> " if ($fly_set == 1);
	  print FOUT "<P><I><A HREF=\"javascript:ToggleJqplotGraph2(plot0,'tog_req','tog_acc');\">$L{'Requests'}</A> " if ($fly_set == 0);
      }
      print FOUT "- $L{'Accesses'} ";
      if ($notrafic == 0) {
	  print FOUT "- <A HREF=\"javascript:ToggleDelta('tog_traffic','tog_req','tog_acc');\">$L{'Traffic'}</A>" if ($fly_set == 1);
	  print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph3(plot2,'tog_traffic','tog_req','tog_acc');\">$L{'Traffic'}</A>" if ($fly_set == 0);
      }
      print FOUT "</I></TD></TR></TABLE>\n";

      if ($fly_set == 1) {
	  print FOUT "<MAP NAME=\"map_virtual3_graph\">\n";
	  $tmp = $map_virtual_pie;
	  $tmp =~ s/<!-- langhome -->/$I/g;
	  print FOUT "$tmp";
	  print FOUT "</MAP>\n";
      }
      if ($fly_set == 0) {
	  if ($xmax_jqplot != $xmax_home_jqplot) {
	      print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
	  }
	  print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
      }
      print FOUT "</DIV>";
  }

  if ($notrafic == 0) {

      if ($fly_set == 0) {
	  $chart_id++;	  
	  $info = "info".$chart_id;
	  $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%ssdomvirtualsize,\@serie_color,$totvirtualsize,2,$unitdom,$unit,$chart_id,0,$info,"","",$dirstatus);
      }

      if ($fly_set == 1) {      
	  $destsize_pie = "destination_pie2".$gifext;
	  ($line_pie,$map_virtual_pie) = &MakePieChart($destsize_pie,$totvirtualsize,\%ssdomvirtualsize,0,1,'',$rayon);
      }

      print FOUT "<DIV ID=\"tog_traffic\" STYLE=\"display:none\">";
      print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
      print FOUT "<TR><TD ALIGN=CENTER VALIGN=MIDDLE>";
      print FOUT "<TABLE BORDER=0>";
      print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Destination'}</TH></TR>";
      print FOUT "$line_pie";
      print FOUT "</TABLE>\n";
      print FOUT "</TD>\n";
      
      print FOUT "<TD ALIGN=CENTER>";
      if ($fly_set == 0) {
	  print FOUT "<div id=\"";
	  print FOUT "chart".$chart_id;
	  print FOUT "\" ";
	  print FOUT "style=\"";
	  print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
	  print FOUT "</div>\n";
      }
      if ($fly_set == 1) {
	  print FOUT "<IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$destsize_pie\" USEMAP=\"#map_virtual2_graph\" BORDER=0 ALT=\"graph\">\n";
      }

      print FOUT "<P><I><A HREF=\"javascript:ToggleDelta('tog_req','tog_traffic','tog_acc');\">$L{'Requests'}</A> " if ($fly_set == 1);
      print FOUT "<P><I><A HREF=\"javascript:ToggleJqplotGraph3(plot0,'tog_req','tog_traffic','tog_acc');\">$L{'Requests'}</A> " if ($fly_set == 0);
      print FOUT "- <A HREF=\"javascript:ToggleDelta('tog_acc','tog_req','tog_traffic');\">$L{'Accesses'}</A> " if ($fly_set == 1 && $dhcp_format == 0);
      print FOUT "- <A HREF=\"javascript:ToggleJqplotGraph3(plot1,'tog_acc','tog_req','tog_traffic');\">$L{'Accesses'}</A> " if ($fly_set == 0 && $dhcp_format == 0);
      print FOUT "- $L{'Traffic'}";
      print FOUT "</I></TD></TR></TABLE>\n";

      if ($fly_set == 1) {
	  print FOUT "<MAP NAME=\"map_virtual2_graph\">\n";
	  $tmp = $map_virtual_pie;
	  $tmp =~ s/<!-- langhome -->/$I/g;
	  print FOUT "$tmp";
	  print FOUT "</MAP>\n";
      }
      if ($fly_set == 0) {
	  if ($xmax_jqplot != $xmax_home_jqplot) {
	      print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
	  }
	  print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
      }
      print FOUT "</DIV>";
  }

  print FOUT "</TD><TD VALIGN=TOP align=\"justify\">";

  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'Requests'} - $L{'Sort'} : <A HREF=\"javascript:ToggleBeta('tog_alpha','tog_value');\">$L{'Alphabetically'}</A> - <A HREF=\"javascript:ToggleBeta('tog_value','tog_alpha');\">$L{'By_size'}</A></DIV><P>";
  
  print FOUT "<DIV ID=\"tog_alpha\" STYLE=\"display:inline\">";
  print FOUT "$line_cloud\n";
  print FOUT "</DIV>\n";
  print FOUT "<P>";
  
  print FOUT "<DIV ID=\"tog_value\" STYLE=\"display:none\">";
  print FOUT "$line_cloud_sort\n";
  print FOUT "</DIV>\n";

  print FOUT "</TD></TR>\n";
  print FOUT "</TABLE><P>\n";


  if ($linkpath_url ne '') {
      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'Search'}</I> :</DIV><P>\n";

      $datafileinc = $linkpath_url.$dirinc.$dirsepurl.$incvirtual.$txtext;
      $string_title = "$L{'Search'}:$L{'Search_on'}:$L{'No_item_found'}:$L{'Processing'}";
#      $string_th = "$L{'Hosts'}" if ($cups_format == 0);
      $string_th = "$L{'Destination'}"; # if ($cups_format == 1);
      $string_th .= ":$L{'Requests'}";
      $string_th .= ":$L{'Traffic'}:$L{'Mb'}" if ($notrafic == 0);
      if ($ftp_format == 0 && $squid_format == 0 && $mail_format == 0) {
	  $string_th .= ":$L{'Accesses'}";
      }

      print FOUT "<FORM method=\"POST\" name=\"ajax\" action=\"javascript:SearchVirtual()\">\n";
      print FOUT "<TABLE BORDER=0><TR>\n";
      print FOUT "<TD VALIGN=MIDDLE>";
#      print FOUT "<TD VALIGN=MIDDLE onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$L{'Title_search_hosts'}','$L{'Line_search_hosts'}','$L{'Desc_search_hosts'}','$L{'Link_search_hosts'}',0,'','$help_width')\">";
      print FOUT "<INPUT type=\"hidden\" name=\"precision\" value=\"$precision\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"seuilsite\" value=\"$seuilsite\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"notrafic\"  value=\"$notrafic\">\n";
      if ($ftp_format == 0 && $squid_format == 0 && $mail_format == 0) {
	  print FOUT "<INPUT type=\"hidden\" name=\"aff_access\" value=\"1\">\n";
      } else {
	  print FOUT "<INPUT type=\"hidden\" name=\"aff_access\" value=\"0\">\n";
      }
#  print FOUT "<INPUT type=\"hidden\" name=\"seuil_auto\" value=\"$seuil_auto\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"datafile\" value=\"$datafileinc\">\n";

      if ($cups_format == 1) {
	  print FOUT "<INPUT type=\"hidden\" name=\"stats\" value=\"cups\">\n";
      } else {
	  print FOUT "<INPUT type=\"hidden\" name=\"stats\" value=\"virtual\">\n";
      }
#  print FOUT "<INPUT type=\"hidden\" name=\"datafile_local\" value=\"$datafileinc_local\">\n" if ($locallog != 0 && $locserver != 0);
      print FOUT "<INPUT type=\"hidden\" name=\"string_th\"  value=\"$string_th\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"string_title\"  value=\"$string_title\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"string_sep\"  value=\"\t\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"index_hit\"  value=\"1\">\n";

      print FOUT "<TABLE BORDER=0><TR>\n";
      print FOUT "<TH ALIGN=CENTER onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$L{'Title_search_hosts'}','$L{'Line_search_hosts'}','$L{'Desc_search_hosts'}','$L{'Link_search_hosts'}',0,'','$help_width')\">";
      print FOUT "$L{'Search'}</TH>\n";
      print FOUT "</TR><TR>\n";
      print FOUT "<TD>";
#      print FOUT "<INPUT type=\"text\" id=\"txtSearch\" name=\"search_value\"  value=\"\" onkeyup=\"searchSuggest();\" autocomplete=\"off\" OnFocus=\"javascript:clean()\">\n";
      print FOUT "<INPUT type=\"text\" id=\"txtSearch\" name=\"search_value\"  value=\"\" onkeyup=\"searchSuggest();\" OnBlur=\"javascript:clean_focus()\" OnFocus=\"javascript:clean()\">\n";
      print FOUT "<div id=\"search_suggest\"></div>\n";
      print FOUT "</TR></TABLE>\n";
      print FOUT "</TD><TD VALIGN=TOP>";

      print FOUT "<TABLE BORDER=0><TR>\n";
      print FOUT "<TH COLSPAN=2 ALIGN=CENTER>$L{'Requests'}</TH>\n";
      print FOUT "</TR><TR>\n";
      print FOUT "<TD>$L{'Threshold'}</TD><TD><INPUT type=\"text\" size=\"3\" name=\"search_threshold\"  value=\"$seuilsite\"></TD>\n";
      print FOUT "</TR></TABLE>\n";
      print FOUT "</TD><TD VALIGN=MIDDLE>";
      print FOUT "<INPUT type=\"submit\" name=\"search_button\"  class=\"submit_button\" value=\"$L{'Search'}\">\n";
      print FOUT "</TD></TR></TABLE>";
      print FOUT "</FORM><P>\n";
      
      print FOUT "<DIV ID=\"search_header\"></DIV>\n";
      print FOUT "<DIV ID=\"search_results\"></DIV>\n";
      print FOUT "<BR><P>\n";
  }

  if ($cups_format == 0) {

  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'Sorted_destination_servers'} $L{'by'} $L{'requests'}</I> :</DIV><P>\n";

  print FOUT "<P><I>($L{'Only_hosts'} $L{'with_at_least'} $seuilsite $L{'requests'} $L{'are_shown'})</I>\n<P>" if ($seuilsite > 1);

  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";

#  print FOUT "<TABLE><TR>\n";
#  print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"virtual\"><TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Destination'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Level'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Requests'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  if ($notrafic == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'} (";
      print FOUT "$L{$unit}";
#      print FOUT "$L{'bytes'}" if ($unit_virtual == 1);
#      print FOUT "$L{'Kb'}" if ($unit_virtual == 1024);
#      print FOUT "$L{'Mb'}" if ($unit_virtual == (1024*1024));
#      print FOUT "$L{'Gb'}" if ($unit_virtual == (1024*1024*1024));
#      print FOUT "$L{'Tb'}" if ($unit_virtual == (1024*1024*1024*1024));
      print FOUT ")&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  }
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";

  foreach $domvserver (&reverse_sort_by_value(*domvirtualreq)) {

      $tmp2 = '';
      $tmp2 = "Unknown" if (!(-f "$pathinit$dirress$dirsep$dirflags$dirsep$domvserver$gifext"));

      # display below only if not empty

      $found_ssv = 0;

#      $tmp_li = "</tbody><tbody class=\"table-nosort\">\n";


#      $tmp_li = "</tbody><tbody class=\"table-nosort\">\n";
      $tmp_li = "<TR>\n";
      $tmp_li .= "<TD WIDTH=\"100%\" COLSPAN=6>\n";
      $tmp_li .= "<DIV ID=\"$newflag{$domvserver}\" STYLE=\"display:none\">\n" if ($tmp2 ne "Unknown");
      $tmp_li .= "<DIV ID=\"$domvserver\" STYLE=\"display:none\">\n" if ($tmp2 eq "Unknown");


      $tmp_li .= "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\" ID=\"NO_$domvserver\">\n";
      $tmp_li .= "<thead>\n";
      $tmp_li .= "<TR>\n";
      $tmp_li .= "<TH><A HREF=\"javascript:ToggleMenuAll('Toggle_all');\"><IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$toggle_on\" NAME=\"ima_toggle\" BORDER=0 WIDTH=\"12\" HEIGHT=\"21\" ALT=\"toggle\"></A></TH>\n" if ($precision > 3);
      $tmp_li .= "<TH class=\"table-sortable:default\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
      $tmp_li .= "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Level'}&nbsp;</TH>\n";
      $tmp_li .= "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Requests'}&nbsp;</TH>\n";
      $tmp_li .= "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      if ($notrafic == 0) {
	  $tmp_li .= "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;</TH>";
	  $tmp_li .= "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      }
      $tmp_li .= "</TR>\n";
      $tmp_li .= "</thead>\n";
      $tmp_li .= "<tbody>\n";

      if ($newflag{$domvserver} eq "Unknown" && $precision > 3) {
	  
	  foreach $vserver (&reverse_sort_by_value(*virtual)) {
	      if ($vserver =~ /[0-9]$/ || $vserver =~ /:/) {
		  if ($virtual{$vserver} > $seuilsite) {
		      
		      $found_ssv = 1;
		      $pourcentage = ($virtual{$vserver}*100)/$domvirtualreq{$domvserver};
		      $pourcentageint = int($pourcentage);

		      $tmp = $dirsepurl.$vserver.$dirsepurl;
		      $tmp_li .= "<TR>\n<TD CLASS=\"left\" COLSPAN=2><I>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;-&nbsp;$vserver&nbsp;</I></TD>\n";
		      $tmp_li .= "<TD CLASS=\"right\">3</TD>\n";
		      $tmp_li .= "<TD CLASS=\"left\">";
		      $tmp_li .= "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
		      $tmp_li .= "<I>$virtual{$vserver}</I></TD>\n";
		      $tmpo = int($pourcentage*10)/10;
#		      $tmp_li .= "<TD CLASS=\"right\"><I>$pourcentage</I></TD>\n";;
		      $tmp_li .= "<TD CLASS=\"right\"><I>$tmpo %</I></TD>\n";;
		      
		      if ($notrafic == 0) {
#			  $pourcentage2 = ($virtualsize{$vserver}*100)/($unit_virtual*$domvirtualsize{$domvserver});
			  $pourcentage2 = ($virtualsize{$vserver}*100)/$domvirtualsize{$domvserver};
			  $pourcentageint2 = int($pourcentage2);

			  $tmp_li .= "<TD CLASS=\"left\">";
			  $tmp_li .= "<IMG WIDTH=$pourcentageint2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint2 != 0);
			  if ($virtualCLF == 1) {
#			      $tmpo = $freqtotsize{$tmp}/$unit_virtual;
			      $tmpo = $freqtotsize{$tmp}/$unitdom;
			      $tmpo = int($tmpo*100)/100;
			      $tmp_li .= "<I>$tmpo</I>";
			  } else {
#			      $tmpo = $virtualsize{$vserver}/$unit_virtual;
			      $tmpo = $virtualsize{$vserver}/$unitdom;
			      $tmpo = int($tmpo*100)/100;
			      $tmp_li .= "<I>$tmpo</I>";
			  }
			  $tmpo = int($pourcentage2*10)/10;		    
			  $tmp_li .= "</TD>\n<TD CLASS=\"right\"><I>$tmpo %</I>";;
			  $tmp_li .= "&nbsp;</TD>\n";
		      }
		      $tmp_li .= "</TR>\n";
		  }
	      }
	  }
      }

      #

      foreach $ssvserver (&reverse_sort_by_value(*ssdomvirtualreq)) {
	  if (substr($ssvserver,rindex($ssvserver,'.')+1,length($ssvserver)) eq $domvserver) {
	      if ($ssdomvirtualreq{$ssvserver} > $seuilsite) {

		  $found_ssv = 1;

		  $subvirt = 0;
		  if ($ssdomvirtual{$ssvserver} != 1 && $precision > 3) {

		      $tmp_li2 = "<TR>\n<TD WIDTH=\"100%\" COLSPAN=6>\n";
		      $tmp_li2 .= "<DIV ID=\"TOGGLE_$ssvserver\" STYLE=\"display:none\">\n";

		      $tmp_li2 .= "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\" ID=\"$ssvserver\">\n";
		      $tmp_li2 .= "<thead>\n";
		      $tmp_li2 .= "<TR>\n";
		      $tmp_li2 .= "<TH class=\"table-sortable:default\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
		      $tmp_li2 .= "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Level'}&nbsp;</TH>\n";
		      $tmp_li2 .= "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Requests'}&nbsp;</TH>\n";
		      $tmp_li2 .= "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
		      if ($notrafic == 0) {
			  $tmp_li2 .= "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;</TH>";
			  $tmp_li2 .= "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
		      }
		      $tmp_li2 .= "</TR>\n";
		      $tmp_li2 .= "</thead>\n";
		      $tmp_li2 .= "<tbody>\n";

		      foreach $vserver (&reverse_sort_by_value(*virtual)) {
			  if ($virtual{$vserver} > $seuilsite) {
			      $tmp = substr($vserver,0,rindex($vserver,'.'));
			      if (substr($vserver,rindex($tmp,'.')+1,length($vserver)) eq $ssvserver) {
				  $pourcentage = ($virtual{$vserver}*100)/$ssdomvirtualreq{$ssvserver};
				  $pourcentageint = int($pourcentage);
#				  $pourcentage2 = ($virtualsize{$vserver}*100)/($unit_virtual*$ssdomvirtualsize{$ssvserver});

				  $tmp = $dirsepurl.$vserver.$dirsepurl;
				  $subvirt = 1;
				  $tmp_li2 .= "<TR>\n<TD CLASS=\"left\"><I>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;-&nbsp;$vserver&nbsp;</I></TD>\n";
				  $tmp_li2 .= "<TD CLASS=\"right\">3</TD>\n";
				  $tmp_li2 .= "<TD CLASS=\"left\">";
				  $tmp_li2 .= "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
				  $tmp_li2 .= "<I>$virtual{$vserver}</I></TD>\n";
				  $tmpo = int($pourcentage*10)/10;
				  $tmp_li2 .= "<TD CLASS=\"right\"><I>$tmpo %</I></TD>\n";

				  if ($notrafic == 0) {
				      $pourcentage2 = ($virtualsize{$vserver}*100)/$ssdomvirtualsize{$ssvserver} if ($ssdomvirtualsize{$ssvserver} != 0);
				      $pourcentageint2 = int($pourcentage2);
				      $tmp_li2 .= "<TD CLASS=\"left\">";
				      $tmp_li2 .= "<IMG WIDTH=$pourcentageint2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint2 != 0);

				      if ($virtualCLF == 1) {
#					  $tmpo = $freqtotsize{$tmp}/$unit_virtual;
					  $tmpo = $freqtotsize{$tmp}/$unitdom;
					  $tmpo = int($tmpo*100)/100;
					  $tmp_li2 .= "<I>$tmpo</I>";
				      } else {
#					  $tmpo = $virtualsize{$vserver}/$unit_virtual;
					  $tmpo = $virtualsize{$vserver}/$unitdom;
					  $tmpo = int($tmpo*100)/100;
					  $tmp_li2 .= "<I>$tmpo</I>";
				      }
				      $tmpo = int($pourcentage2*10)/10;
				      $tmp_li2 .= "</TD>\n<TD CLASS=\"right\"><I>$tmpo %</I>";
				      $tmp_li2 .= "&nbsp;</TD>\n";
				  }
				  $tmp_li2 .= "</TR>\n";
			      }
			  }
		      }
		      $tmp_li2 .= "</tbody>\n";
		      $tmp_li2 .= "</TABLE>\n";
		      $tmp_li2 .= "</DIV>\n";
		      $tmp_li2 .= "</TD>\n</TR>\n";


#		      $tmp_li .= $tmp_li2 if ($subvirt == 1);
#		      $tmp_li .= "</tbody><tbody>\n";

		  }

		  $pourcentage = ($ssdomvirtualreq{$ssvserver}*100)/$domvirtualreq{$domvserver};
		  $pourcentageint = int($pourcentage);


		  $tmp_li3 = "<TR>";
		  if  ($precision > 3) {
		      $tmp_li3 .= "<TD CLASS=\"left\"";
		      if ($ssdomvirtual{$ssvserver} != 1 && $subvirt == 1) {
			  $tmp_li3 .= " OnClick=\"javascript:ToggleMenu('";
			  $tmp_li3 .= "TOGGLE_$ssvserver";
			  $tmp_li3 .= "')\"";
			  $tmp_li3 .= " TITLE=\"$L{'Click_here'}\"";
		      }
		      $tmp_li3 .= ">&gt;</TD>";
		  }
		  $tmp_li3 .= "<TD>&nbsp;&nbsp;&nbsp;";
		  if ($ssdomvirtual{$ssvserver} != 1 && $precision > 3 && $subvirt == 1) {
		      $tmp_li3 .= "<A HREF=\"javascript:ToggleMenu('";
		      $tmp_li3 .= "TOGGLE_$ssvserver";
		      $tmp_li3 .= "')\" TITLE=\"$L{'Click_here'}\">";
		  }
		  $tmp_li3 .= "$ssvserver";
		  $tmp_li3 .= "</A>" if ($ssdomvirtual{$ssvserver} != 1 && $precision > 3 && $subvirt == 1);
		  $tmp_li3 .= "&nbsp;</TD>\n";
		  $tmp_li3 .= "<TD CLASS=\"right\">2</TD>\n";
		  $tmp_li3 .= "<TD CLASS=\"left\">";
		  $tmp_li3 .= "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">&nbsp;" if ($pourcentageint != 0);
		  $tmp_li3 .= "$ssdomvirtualreq{$ssvserver}</TD>\n";
		  $tmpo = int($pourcentage*10)/10;
		  $tmp_li3 .= "<TD CLASS=\"right\">$tmpo %</TD>\n";

		  if ($notrafic == 0) {
#		  $pourcentage2 = ($ssdomvirtualsize{$ssvserver}*100)/($unit_virtual*$domvirtualsize{$domvserver});
		      $pourcentage2 = ($ssdomvirtualsize{$ssvserver}*100)/$domvirtualsize{$domvserver} if ($domvirtualsize{$domvserver} != 0);
		      $pourcentageint2 = int($pourcentage2);
		      $tmp_li3 .= "<TD CLASS=\"left\">";
		      $tmp_li3 .= "<IMG WIDTH=$pourcentageint2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">&nbsp;" if ($pourcentageint2 != 0);
#		      $tmpo = $ssdomvirtualsize{$ssvserver}/$unit_virtual;
		      $tmpo = $ssdomvirtualsize{$ssvserver}/$unitdom;
		      $tmpo = int($tmpo*100)/100;
		      $tmp_li3 .= "$tmpo</TD>\n";;
		      $tmpo = int($pourcentage2*10)/10;
		      $tmp_li3 .= "<TD CLASS=\"right\">$tmpo %</TD>\n";
		  }
		  $tmp_li3 .= "</TR>\n";

		  $tmp_li .= $tmp_li3;
		  $tmp_li .= $tmp_li2 if ($subvirt == 1);
	      }
	  }
      }


      $tmp_li .= "</tbody>\n";
      $tmp_li .= "</TABLE>\n";
      $tmp_li .= "</DIV>\n";
      $tmp_li .= "</TD>\n</TR>\n";
#      $tmp_li .= "</tbody><tbody>\n";
      #

      $pourcentage = ($domvirtualreq{$domvserver}*100)/$totvirtual if ($totvirtual != 0);
      $tmpo = int($pourcentage*10)/10;
      $pourcentageint = int($pourcentage);

      print FOUT "<TR>\n<TD CLASS=\"left\"";
      print FOUT " TITLE=\"$L{'Click_here'}\">";
      $tmp2 = '';
      if ($found_ssv == 1) {
	  print FOUT "<A HREF=\"javascript:ToggleMenu('";
	  if (-f "$pathinit$dirress$dirsep$dirflags$dirsep$domvserver$gifext") {
	      print FOUT "$newflag{$domvserver}";
	      print FOUT "')\" TITLE=\"$L{'Click_here'}\">";
	      print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirflags$dirsepurl$domvserver$gifext\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=0 ALT=\"$domserver\">";
	  } else {
	      $tmp2 = "Unknown";
	      print FOUT "$domvserver";
	      print FOUT "')\" TITLE=\"$L{'Click_here'}\">";
	      print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirflags$dirsepurl$tmp2$gifext\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=0 ALT=\"$tmp2\">";
	  }
	  print FOUT "</A>";
      } else {

	  if (-f "$pathinit$dirress$dirsep$dirflags$dirsep$domvserver$gifext") {
	      print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirflags$dirsepurl$domvserver$gifext\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=0 ALT=\"$domserver\">";
	  } else {
	      $tmp2 = "Unknown";
	      print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirflags$dirsepurl$tmp2$gifext\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=0 ALT=\"$tmp2\">";
	  }
      }
      print FOUT "&nbsp;&nbsp;";
      if ($found_ssv == 1) {
	  print FOUT "<A HREF=\"javascript:ToggleMenu('";
	  print FOUT "$newflag{$domvserver}" if ($tmp2 ne "Unknown");
	  print FOUT "$domvserver" if ($tmp2 eq "Unknown");
	  print FOUT "')\" TITLE=\"Click here to view hosts\">";
	  print FOUT "$newflag{$domvserver}" if ($tmp2 ne "Unknown");
	  print FOUT "$newflag{$tmp2}&nbsp;($domvserver)" if ($tmp2 eq "Unknown");
	  print FOUT "</A>";
      } else {
	  print FOUT "$newflag{$domvserver}" if ($tmp2 ne "Unknown");
	  print FOUT "$newflag{$tmp2}&nbsp;($domvserver)" if ($tmp2 eq "Unknown");
      }
      print FOUT "</TD>\n";
      print FOUT "<TD CLASS=\"right\">1</TD>\n";
      print FOUT "<TD CLASS=\"left\">";
      print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"> " if ($pourcentageint != 0);
      print FOUT "$domvirtualreq{$domvserver}</TD>";
#      printf FOUT "<TD CLASS=\"right\">%.1f %</TD>\n",$pourcentage;
      print FOUT "<TD CLASS=\"right\">$tmpo %</TD>\n";
      if ($notrafic == 0) {
#	  $pourcentage2 = ($domvirtualsize{$domvserver}*100)/($totvirtualsize*$unit_virtual) if ($totvirtualsize != 0);
	  $pourcentage2 = ($domvirtualsize{$domvserver}*100)/$totvirtualsize if ($totvirtualsize != 0);
	  $pourcentageint2 = int($pourcentage2);
	  $tmpo = int($pourcentage2*10)/10;
	  print FOUT "<TD CLASS=\"left\">";
	  print FOUT "<IMG WIDTH=$pourcentageint2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"> " if ($pourcentageint2 != 0);
#	  printf FOUT "%.2f</TD>\n",$domvirtualsize{$domvserver}/$unit_virtual;
	  printf FOUT "%.2f</TD>\n",$domvirtualsize{$domvserver}/$unitdom;
#	  printf FOUT "<TD CLASS=\"right\">%.1f %</TD>",$pourcentage2;
	  print FOUT "<TD CLASS=\"right\">$tmpo %</TD>";
      }
      print FOUT "</TR>\n";

      print FOUT "$tmp_li" if ($found_ssv == 1);
  }

  print FOUT "</tbody>\n";  
  print FOUT "</TABLE>\n";
  }
#  print FOUT "</UL>\n";
#  print FOUT "<P><HR><P>";

  }
  print FOUT "</BODY></HTML>\n";
}

#################################################################
###              Build day/weekly summary                     ###
#################################################################

sub BuildEmptyReferResume {
  local($scriptname,$mode_web) = @_;

  for ($nblang=0;$nblang<=$#lang;$nblang++) {
      
      $tmp = $path;
      $tmp .= $dirtmp.$dirsep if ($mode_web == 1);
      $tmp .= $lang[$nblang].$dirsep;
      $tmp .= $dirdate.$dirsep if ($mode_web == 0);
      $tmp .= $dirresume;
      mkdir ($tmp,0775) unless -d $tmp;
      
      $file_to_open = $path;
      $file_to_open .= $dirtmp.$dirsep if ($mode_web == 1) ;
      $file_to_open .= $lang[$nblang].$dirsep;
      $file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
      $file_to_open .= $dirresume.$dirsep.$tabnamerefer;
      
      open(FILEDAYREFER,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
      close (FILEDAYREFER);
      
      $file_to_open = $path;
      $file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
      $file_to_open .= $lang[$nblang].$dirsep;
      $file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
      $file_to_open .= $dirresume.$dirsep.$tabnamekeyword;
      open(FILEDAYKEYWORD,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
      close (FILEDAYKEYWORD);
      
      if ($show_all == 1) {
	  $file_to_open = $path;
	  $file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
	  $file_to_open .= $lang[$nblang].$dirsep;
	  $file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
	  $file_to_open .= $dirresume.$dirsep.$listdailyrefer.$htmlext;
	  open(FILEDAYREFERALL,">$file_to_open");
	  close(FILEDAYREFERALL);
	  $file_to_open = $path;
	  $file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
	  $file_to_open .= $lang[$nblang].$dirsep;
	  $file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
	  $file_to_open .= $dirresume.$dirsep.$listdailykeyword.$htmlext;
	  open(FILEDAYKEYWORDALL,">$file_to_open");
	  close(FILEDAYKEYWORDALL);
      }

  }
}

sub BuildDailyReferResume {
  local($scriptname,$link_next,$mode_web) = @_;

  for ($nblang=0;$nblang<=$#lang;$nblang++) {
      
      $tmp = $path;
      $tmp .= $dirtmp.$dirsep if ($mode_web == 1);
      $tmp .= $lang[$nblang].$dirsep;
      $tmp .= $dirdate.$dirsep if ($mode_web == 0);
      $tmp .= $dirresume;
      mkdir ($tmp,0775) unless -d $tmp;
      
      $file_to_open = $path;
      $file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
      $file_to_open .= $lang[$nblang].$dirsep;
      $file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
      $file_to_open .= $dirresume.$dirsep.$tabnamerefer;

      open(FILEDAYREFER,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
      &ReferDay(*FILEDAYREFER, eval($Lang{$lang[$nblang]}),$lang[$nblang],0);
      close (FILEDAYREFER);

      $file_to_open = $path;
      $file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
      $file_to_open .= $lang[$nblang].$dirsep;
      $file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
      $file_to_open .= $dirresume.$dirsep.$tabnamekeyword;

      open(FILEDAYKEYWORD,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
      &KeywordDay(*FILEDAYKEYWORD, eval($Lang{$lang[$nblang]}),$lang[$nblang],0);
      close (FILEDAYKEYWORD);

      if ($show_all == 1) {
	  $file_to_open = $path;
	  $file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
	  $file_to_open .= $lang[$nblang].$dirsep;
	  $file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
	  $file_to_open .= $dirresume.$dirsep.$listdailyrefer.$htmlext;

	  open(FILEDAYREFERALL,">$file_to_open");
	  &ReferDay(*FILEDAYREFERALL, eval($Lang{$lang[$nblang]}),$lang[$nblang],1);
	  close(FILEDAYREFERALL);

	  $file_to_open = $path;
	  $file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
	  $file_to_open .= $lang[$nblang].$dirsep;
	  $file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
	  $file_to_open .= $dirresume.$dirsep.$listdailykeyword.$htmlext;

	  open(FILEDAYKEYWORDALL,">$file_to_open");
	  &KeywordDay(*FILEDAYKEYWORDALL, eval($Lang{$lang[$nblang]}),$lang[$nblang],1);
	  close(FILEDAYKEYWORDALL);
      }

  }
}

sub UpdatePageResumeMenu {
    local($scriptname,$link_next,$mode_web) = @_;
    local($tmp);

    for ($nblang=0;$nblang<=$#lang;$nblang++) {
	$file_to_open = $path;
	$file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
	$file_to_open .= $lang[$nblang].$dirsep;
	$file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
	$file_to_open .= $dirresume.$dirsep.$fileresumemenu;
	open(FILERESUMEMENU,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
	&PageResumeTab(*FILERESUMEMENU, eval($Lang{$lang[$nblang]}),$lang[$nblang],$link_next);	
	close (FILERESUMEMENU);
    }
}


sub BuildEmptyAgentResume {
  local($scriptname,$mode_web) = @_;

  for ($nblang=0;$nblang<=$#lang;$nblang++) {
	    
      $tmp = $path;
      $tmp .= $dirtmp.$dirsep if ($mode_web == 1);
      $tmp .= $lang[$nblang].$dirsep;
      $tmp .= $dirdate.$dirsep if ($mode_web == 0);
      $tmp .= $dirresume;
      mkdir ($tmp,0775) unless -d $tmp;

      $file_to_open = $path;
      $file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
      $file_to_open .= $lang[$nblang].$dirsep;
      $file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
      $file_to_open .= $dirresume.$dirsep.$tabnamebrowser;

      open(FILEDAYAGENT,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
      close (FILEDAYAGENT);      
  }
}


sub BuildDailyAgentResume {
  local($scriptname,$link_next,$mode_web) = @_;

  for ($nblang=0;$nblang<=$#lang;$nblang++) {
	    
      $tmp = $path;
      $tmp .= $dirtmp.$dirsep if ($mode_web == 1);
      $tmp .= $lang[$nblang].$dirsep;
      $tmp .= $dirdate.$dirsep if ($mode_web == 0);
      $tmp .= $dirresume;
      mkdir ($tmp,0775) unless -d $tmp;

      $file_to_open = $path;
      $file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
      $file_to_open .= $lang[$nblang].$dirsep;
      $file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
      $file_to_open .= $dirresume.$dirsep.$tabnamebrowser;

      open(FILEDAYAGENT,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
      &AgentDay(*FILEDAYAGENT, eval($Lang{$lang[$nblang]}),$lang[$nblang],0);
      close (FILEDAYAGENT);      
  }
}


sub BuildDailyResume {
    local($scriptname,$link_next,$mode_web) = @_;
    local($tmp,$adresse,$rootrepert,$page);

    # Sorting dailysites
    foreach $adresse (&reverse_sort_by_value(*serverjour)) {
	undef %tab;
	undef @sorted;
	undef @unsorted;
	undef %dailypageserv2;
	for ($j=1;$j<=$nbpageday{$adresse};$j++) {
	    $page = $dailypageserv{$adresse,$j};
	    $dailypageserv2{$adresse,$j} = $dailypageserv{$adresse,$j};
	    @tab{$seen_page{$adresse,$page}} .= $j."-";
	    push @unsorted, $seen_page{$adresse,$page};
	}

	@sorted = reverse sort { $a <=> $b } @unsorted;

	undef @i;
	for ($j=0;$j<=$#sorted;$j++) {
	    @i = split(/-/,$tab{$sorted[$j]});
	    for ($k=0;$k<=$#i;$k++) {
		$page = $dailypageserv2{$adresse,$i[$k]};
		$seen_page{$adresse,$page} = $sorted[$j];
		$tmp = $j+$k+1;
		$dailypageserv{$adresse,$tmp} = $page;
	    }
	    $j+=$#i;
	}
    }

    # Sorting dailypages
   foreach $page (&reverse_sort_by_value(*pagesluesday)) {
	undef %tab;
	undef @sorted;
	undef @unsorted;
	undef %dailyhostpage2;
	for ($j=1;$j<=$nbhostpageday{$page};$j++) {
	    $host = $dailyhostpage{$page,$j};
	    $dailyhostpage2{$page,$j} = $dailyhostpage{$page,$j};
	    @tab{$seen_host{$page,$host}} .= $j."-";
	    push @unsorted, $seen_host{$page,$host};
	}

	@sorted = reverse sort { $a <=> $b } @unsorted;

	undef @i;
	for ($j=0;$j<=$#sorted;$j++) {
	    @i = split(/-/,$tab{$sorted[$j]});
	    for ($k=0;$k<=$#i;$k++) {
		$host = $dailyhostpage2{$page,$i[$k]};
		$seen_host{$page,$host} = $sorted[$j];
		$tmp = $j+$k+1;
		$dailyhostpage{$page,$tmp} = $host;
	    }
	    $j+=$#i;
	}
    }
 
  # Sorting userday
   foreach $user (&reverse_sort_by_value(*userday)) {
	undef %tab;
	undef @sorted;
	undef @unsorted;
	undef %dailylogindest2;
	for ($j=1;$j<=$nbusersday{$user};$j++) {
	    $host = $dailylogindest{$user,$j};
	    $dailylogindest2{$user,$j} = $dailylogindest{$user,$j};
	    @tab{$seen_users{$user,$host}} .= $j."-";
	    push @unsorted, $seen_users{$user,$host};
	}

	@sorted = reverse sort { $a <=> $b } @unsorted;

	undef @i;
	for ($j=0;$j<=$#sorted;$j++) {
	    @i = split(/-/,$tab{$sorted[$j]});
	    for ($k=0;$k<=$#i;$k++) {
		$host = $dailylogindest2{$user,$i[$k]};
		$seen_user{$user,$host} = $sorted[$j];
		$tmp = $j+$k+1;
		$dailylogindest{$user,$tmp} = $host;
	    }
	    $j+=$#i;
	}
    }

  # Sorting dailydest
   foreach $user (&reverse_sort_by_value(*dailydest)) {
	undef %tab;
	undef @sorted;
	undef @unsorted;
	undef %dailyhostdest2;
	for ($j=1;$j<=$nbhostday{$user};$j++) {
	    $host = $dailyhostdest{$user,$j};
	    $dailyhostdest2{$user,$j} = $dailyhostdest{$user,$j};
	    @tab{$seen_dest{$user,$host}} .= $j."-";
	    push @unsorted, $seen_dest{$user,$host};
	}

	@sorted = reverse sort { $a <=> $b } @unsorted;

	undef @i;
	for ($j=0;$j<=$#sorted;$j++) {
	    @i = split(/-/,$tab{$sorted[$j]});
	    for ($k=0;$k<=$#i;$k++) {
		$host = $dailyhostdest2{$user,$i[$k]};
		$seen_dest{$user,$host} = $sorted[$j];
		$tmp = $j+$k+1;
		$dailyhostdest{$user,$tmp} = $host;
	    }
	    $j+=$#i;
	}
    }

    for ($nblang=0;$nblang<=$#lang;$nblang++) {
	
	$tmp = $path;
	$tmp .= $dirtmp.$dirsep if ($mode_web == 1);
	$tmp .= $lang[$nblang].$dirsep;
	$tmp .= $dirdate.$dirsep if ($mode_web == 0);
	$tmp .= $dirresume;
	mkdir ($tmp,0775) unless -d $tmp;

	if ($dailydest_unique != 0 && ($squid_format == 1 || $cups_format == 1 || $dhcp_format == 1)) {
	    $file_to_open = $path;
	    $file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
	    $file_to_open .= $lang[$nblang].$dirsep;
	    $file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
	    $file_to_open .= $dirresume.$dirsep.$filevirtual;

	    open(FILERESUMEDEST,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
	    &PageResumeDest(*FILERESUMEDEST, eval($Lang{$lang[$nblang]}),$lang[$nblang],0);
	    close (FILERESUMEDEST);
	}

	if ($paysuniquejour != 0) {
	    $file_to_open = $path;
	    $file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
	    $file_to_open .= $lang[$nblang].$dirsep;
	    $file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
	    $file_to_open .= $dirresume.$dirsep.$dirpays.$htmlext;

	    open(FILERESUMEPAYS,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
	    &PageResumePays(*FILERESUMEPAYS, eval($Lang{$lang[$nblang]}),$lang[$nblang],0);
	    close (FILERESUMEPAYS);
	}


	$file_to_open = $path;
	$file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
	$file_to_open .= $lang[$nblang].$dirsep;
	$file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
	$file_to_open .= $dirresume.$dirsep.$menu;
	open(FILERESUMETAB,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
	&PageResumeTab(*FILERESUMETAB, eval($Lang{$lang[$nblang]}),$lang[$nblang],$link_next);
	close (FILERESUMETAB);

	$file_to_open = $path;
	$file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
	$file_to_open .= $lang[$nblang].$dirsep;
	$file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
	$file_to_open .= $dirresume.$dirsep.$dirlist.$csvext;
	open(CSV,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
	print CSV "#Directory;Requests;Accesses";
	print CSV ";Traffic" if ($notrafic == 0);
	print CSV "\n";
	foreach $rootrepert (&reverse_sort_by_value(*freqjourrachtml)) {
	    print CSV "\"$rootrepert\";\"$freqjourrac{$rootrepert}\";\"$freqjourrachtml{$rootrepert}\"";
	    print CSV "\"$sizejourrachtml{$rootrepert}\"" if ($notrafic == 0);
	    print CSV "\n";
	}
	close(CSV);

	if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	    $file_to_open = $path;
	    $file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
	    $file_to_open .= $lang[$nblang].$dirsep;
	    $file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
	    $file_to_open .= $dirresume.$dirsep.$dirlist.$htmlext;
	    open(FILERESUMEDIR,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
	    &PageResumeDir(*FILERESUMEDIR, eval($Lang{$lang[$nblang]}),$lang[$nblang],0);
	    close (FILERESUMEDIR);
	}

	if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	    $file_to_open = $path;
	    $file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
	    $file_to_open .= $lang[$nblang].$dirsep;
	    $file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
	    $file_to_open .= $dirresume.$dirsep.$dirpage.$csvext;
	    open(CSV,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
	    print CSV "#Page;Occurence\n";
	    foreach $page (&reverse_sort_by_value(*pagesluesday)) {
		print CSV "\"$page\";\"$pagesluesday{$page}\"\n";
	    }
	    close(CSV);
	}

	# NEW

	$file_to_open = $path;
	$file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
	$file_to_open .= $lang[$nblang].$dirsep;
	$file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
	$file_to_open .= $dirresume.$dirsep.$listpagescsv;
	open(CSV,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
	print CSV "#Page;Occurence;Hosts;Occurence\n";
	foreach $page (&reverse_sort_by_value(*pagesluesday)) {
	    print CSV "\"$page\";\"$pagesluesday{$page}\"\n";
	    if ($nbhostpageday{$page} != 0 && $mail_format == 0) {
		for ($j=1;$j<=$nbhostpageday{$page};$j++) {
		    $host = $dailyhostpage{$page,$j};
		    print CSV "\"\";\"\";\"$host\";\'$seen_host{$page,$host}\"\n";
		}
	    }
	}
	close(CSV);

	$file_to_open = $path;
	$file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
	$file_to_open .= $lang[$nblang].$dirsep;
	$file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
	$file_to_open .= $dirresume.$dirsep.$dirpage.$htmlext;
	open(FILERESUMEPAGE,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
	&PageResumePage(*FILERESUMEPAGE, eval($Lang{$lang[$nblang]}),$lang[$nblang],0);
	close (FILERESUMEPAGE);

	if ($mail_format == 1 && ($spam_day_ext != 0 || $spam_day_local != 0)) {
	    $file_to_open = $path;
	    $file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
	    $file_to_open .= $lang[$nblang].$dirsep;
	    $file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
	    $file_to_open .= $dirresume.$dirsep.$spam.$htmlext;
	    open(FILERESUMESPAM,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
	    &PageResumeSpam(*FILERESUMESPAM, eval($Lang{$lang[$nblang]}),$lang[$nblang],0);
	    close (FILERESUMESPAM);

	    $file_to_open = $path;
	    $file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
	    $file_to_open .= $lang[$nblang].$dirsep;
	    $file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
	    $file_to_open .= $dirresume.$dirsep.$spam.$csvext;

	    open(CSV,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
	    print CSV "#Host;Occurence";
	    print CSV "\n";
	    foreach $adresse (&reverse_sort_by_value(*spam_daily_user_ext)) {
		print CSV "\"$adresse\";\"$spam_daily_user_ext{$adresse}\"";
		print CSV "\n";
	    }
	    foreach $adresse (&reverse_sort_by_value(*spam_daily_user_loc)) {
		print CSV "\"$adresse\";\"$spam_daily_user_loc{$adresse}\"";
		print CSV "\n";
	    }
	    close(CSV);

	    $file_to_open = $path;
	    $file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
	    $file_to_open .= $lang[$nblang].$dirsep;
	    $file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
	    $file_to_open .= $dirresume.$dirsep.$listspamcsv;

	    open(CSV,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
	    print CSV "#Host;Occurence";
	    print CSV "\n";
	    foreach $adresse (&reverse_sort_by_value(*spam_daily_user_ext)) {
		print CSV "\"$adresse\";\"$spam_daily_user_ext{$adresse}\"";
		print CSV "\n";
		for ($j=1;$j<=$spam_daily_user_ext{$adresse};$j++) {
		    $host = $spam_daily_page{$adresse,$j};
		    print CSV "\"$host\";\"$seen_spam{$adresse,$host}\"\n";
		}
	    }
	    foreach $adresse (&reverse_sort_by_value(*spam_daily_user_loc)) {
		print CSV "\"$adresse\";\"$spam_daily_user_loc{$adresse}\"";
		print CSV "\n";
		for ($j=1;$j<=$spam_daily_user_loc{$adresse};$j++) {
		    $host = $spam_daily_page{$adresse,$j};
		    print CSV "\"$host\";\"$seen_spam{$adresse,$host}\"\n";
		}
	    }
	    close(CSV);
	}

	$file_to_open = $path;
	$file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
	$file_to_open .= $lang[$nblang].$dirsep;
	$file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
	$file_to_open2 = $file_to_open.$dirresume.$dirsep.$listsitescsv;
	$file_to_open .= $dirresume.$dirsep.$dirsite.$csvext;

	open(CSV,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
	open(CSV2,">$file_to_open2") || &error_exit("Error, unable to open $file_to_open2");

	print CSV "#Host;Requests";
	print CSV ";City" if ($geoipcity == 1);
	print CSV ";Accessses" if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
	print CSV ";Traffic" if ($notrafic == 0);
	print CSV "\n";

	print CSV2 "#Host;Requests";
	print CSV2 ";City" if ($geoipcity == 1);
	print CSV2 ";Accessses" if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
	print CSV2 ";Traffic" if ($notrafic == 0);
	print CSV2 ";Page;Occurence";
	print CSV2 "\n";

	foreach $adresse (&reverse_sort_by_value(*serverjour)) {
	    print CSV "\"$adresse\";\"$serverjour{$adresse}\"";
	    print CSV ";\"$revcity{$adresse}\"" if ($geoipcity == 1);
	    print CSV ";\"$hostluesday{$adresse}\"" if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
	    print CSV ";\"$serversizejour{$adresse}\"" if ($notrafic == 0);
	    print CSV "\n";

	    print CSV2 "\"$adresse\";\"$serverjour{$adresse}\"";
	    print CSV2 ";\"$revcity{$adresse}\"" if ($geoipcity == 1);
	    print CSV2 ";\"$hostluesday{$adresse}\"" if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
	    print CSV2 ";\"$serversizejour{$adresse}\"" if ($notrafic == 0);
	    print CSV2 "\n";

	    if ($nbpageday{$adresse} != 0) {
		for ($j=1;$j<=$nbpageday{$adresse};$j++) {
		    $page = $dailypageserv{$adresse,$j};
		    print CSV2 "\"\";\"\"";
		    print CSV2 ";\"\"" if ($geoipcity == 1);
		    print CSV2 ";\"\"" if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
		    print CSV2 ";\"\"" if ($notrafic == 0);
		    print CSV2 ";\"$page\";\"$seen_page{$adresse,$page}\"\n";
		}
	    }
	}
	close(CSV);
	close(CSV2);

	$file_to_open = $path;
	$file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
	$file_to_open .= $lang[$nblang].$dirsep;
	$file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
	$file_to_open .= $dirresume.$dirsep.$dirsite.$htmlext;
	open(FILERESUMEHOSTS,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
	&PageResumeHosts(*FILERESUMEHOSTS, eval($Lang{$lang[$nblang]}),$lang[$nblang],0);
	close (FILERESUMEHOSTS);

	if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	    $file_to_open = $path;
	    $file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
	    $file_to_open .= $lang[$nblang].$dirsep;
	    $file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
	    $file_to_open .= $dirresume.$dirsep.$dirscript.$htmlext;
	    open(FILERESUMESCRIPT,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
	    &PageResumeScript(*FILERESUMESCRIPT, eval($Lang{$lang[$nblang]}),$lang[$nblang],0);
	    close (FILERESUMESCRIPT);
	}

	if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	    $file_to_open = $path;
	    $file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
	    $file_to_open .= $lang[$nblang].$dirsep;
	    $file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
	    $file_to_open .= $dirresume.$dirsep.$filetype.$htmlext;
	    open(FILERESUMEFILETYPE,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
	    &PageResumeFiletype(*FILERESUMEFILETYPE, eval($Lang{$lang[$nblang]}),$lang[$nblang],0);
	    close (FILERESUMEFILETYPE);
	}

	if ($nb_userday != 0) {

	    $file_to_open = $path;
	    $file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
	    $file_to_open .= $lang[$nblang].$dirsep;
	    $file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
	    $file_to_open .= $dirresume.$dirsep.$users.$csvext;
	    open(CSV,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
	    print CSV "#User;Requests;Accesses;Traffic\n";
	    foreach $login (&reverse_sort_by_value(*userday)) {
		print CSV "\"$login\";\"$userday{$login}\";\"$user_accessday{$login}\";\"$user_trafficday{$login}\"\n";
	    }
	    close(CSV);

	    $file_to_open = $path;
	    $file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
	    $file_to_open .= $lang[$nblang].$dirsep;
	    $file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
	    $file_to_open .= $dirresume.$dirsep.$listuserscsv;
	    open(CSV,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
	    print CSV "#User;Requests;Accesses;Traffic;Pages;Occurence\n";
	    foreach $login (&reverse_sort_by_value(*userday)) {
		print CSV "\"$login\";\"$userday{$login}\";\"$user_accessday{$login}\";\"$user_trafficday{$login}\"\n";
		if ($user_accessday{$login} != 0) {
		    for ($j=1;$j<=$nbusersday{$login};$j++) {
			$host = $dailylogindest{$login,$j};
			print CSV "\"$login\";\"\";\"\";\"\";\"$host\";\"$seen_users{$login,$host}\"\n";
		    }
		}
	    }
	    close(CSV);

	}

#	if ($inc_user == 1) {
	if ($nb_userday != 0 && $inc_user == 1) {
	    $file_to_open = $path;
	    $file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
	    $file_to_open .= $lang[$nblang].$dirsep;
	    $file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
	    $file_to_open .= $dirresume.$dirsep.$users.$htmlext;
	    open(FILERESUMEUSERS,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
	    &PageResumeUsers(*FILERESUMEUSERS, eval($Lang{$lang[$nblang]}),$lang[$nblang],0);
	    close (FILERESUMEUSERS);
	}

	if ($notrafic == 0) {
	    $file_to_open = $path;
	    $file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
	    $file_to_open .= $lang[$nblang].$dirsep;
	    $file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
	    $file_to_open .= $dirresume.$dirsep.$dirtraffic.$csvext;
	    open(CSV,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
	    print CSV "#Page;Traffic;Occurence\n";
	    foreach $page (&reverse_sort_by_value(*dailysizepage)) {
		print CSV "\"$page\";\"$dailysizepage{$page}\"";
		$tmp = $filetypejour{$page};
		$tmp = $pagesluesday{$page} if ($tmp eq '');
		print CSV ";\"$tmp\"";
		print CSV "\n";
	    }
	    close(CSV);


	    $file_to_open = $path;
	    $file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
	    $file_to_open .= $lang[$nblang].$dirsep;
	    $file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
	    $file_to_open .= $dirresume.$dirsep.$dirtraffic.$htmlext;
	    open(FILERESUMETRAFIC,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
	    &PageResumeTrafic(*FILERESUMETRAFIC, eval($Lang{$lang[$nblang]}),$lang[$nblang],0);
	    close (FILERESUMETRAFIC);
	}



	###

	if ($show_all == 1) {

#	    if ($serveruniquejour-$locserverjour > $topten) {
		$file_to_open = $path;
		$file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
		$file_to_open .= $lang[$nblang].$dirsep;
		$file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
		$file_to_open .= $dirresume.$dirsep.$listdailysites.$htmlext;
		open(FILERESUMEHOSTSALL,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
		&PageResumeHosts(*FILERESUMEHOSTSALL, eval($Lang{$lang[$nblang]}),$lang[$nblang],1);
		close (FILERESUMEHOSTSALL);
#	    }

#	    if ($pageuniquejour > $topten) {
		$file_to_open = $path;
		$file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
		$file_to_open .= $lang[$nblang].$dirsep;
		$file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
		$file_to_open .= $dirresume.$dirsep.$listdailypages.$htmlext;
		open(FILERESUMEPAGESALL,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
		&PageResumePage(*FILERESUMEPAGESALL, eval($Lang{$lang[$nblang]}),$lang[$nblang],1);
		close (FILERESUMEPAGESALL);
#	    }

		if ($mail_format == 1 && ($spam_day_ext != 0 || $spam_day_local != 0)) {
		    $file_to_open = $path;
		    $file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
		    $file_to_open .= $lang[$nblang].$dirsep;
		    $file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
		    $file_to_open .= $dirresume.$dirsep.$listdailyspam.$htmlext;
		    open(FILERESUMESPAMALL,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
		    &PageResumeSpam(*FILERESUMESPAMALL, eval($Lang{$lang[$nblang]}),$lang[$nblang],1);
		    close (FILERESUMESPAMALL);
		}

		if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
		    $file_to_open = $path;
		    $file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
		    $file_to_open .= $lang[$nblang].$dirsep;
		    $file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
		    $file_to_open .= $dirresume.$dirsep.$listdailyscripts.$htmlext;
		    open(FILERESUMESCRIPTSALL,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
		    &PageResumeScript(*FILERESUMESCRIPTSALL, eval($Lang{$lang[$nblang]}),$lang[$nblang],1);
		    close (FILERESUMESCRIPTSALL);
		}

#	    if ($nb_userday > $topten) {
	    if ($nb_userday != 0 && $inc_user == 1) {
		$file_to_open = $path;
		$file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
		$file_to_open .= $lang[$nblang].$dirsep;
		$file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
		$file_to_open .= $dirresume.$dirsep.$listdailyusers.$htmlext;
		open(FILERESUMEUSERSALL,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
		&PageResumeUsers(*FILERESUMEUSERSALL, eval($Lang{$lang[$nblang]}),$lang[$nblang],1);
		close (FILERESUMEUSERSALL);
	    }

#	    if ($notrafic == 0 && keys(%dailysizepage) > $topten) {
	    if ($notrafic == 0) {
		$file_to_open = $path;
		$file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
		$file_to_open .= $lang[$nblang].$dirsep;
		$file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
		$file_to_open .= $dirresume.$dirsep.$listdailytrafic.$htmlext;
		open(FILERESUMETRAFICALL,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
		&PageResumeTrafic(*FILERESUMETRAFICALL, eval($Lang{$lang[$nblang]}),$lang[$nblang],1);
		close (FILERESUMETRAFICALL);
	    }

#	    if (keys(%freqjourrachtml) > $topten) {
		if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
		    $file_to_open = $path;
		    $file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
		    $file_to_open .= $lang[$nblang].$dirsep;
		    $file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
		    $file_to_open .= $dirresume.$dirsep.$listdailydir.$htmlext;
		    open(FILERESUMEDIRALL,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
		    &PageResumeDir(*FILERESUMEDIRALL, eval($Lang{$lang[$nblang]}),1);
		    close (FILERESUMEDIRALL);
		}

#	    if ($squid_format == 1 && $dailydest_unique > $topten) {
#	    if ($squid_format == 1 || $cups_format == 1 || $dhcp_format == 1) {
		if ($dailydest_unique != 0 && ($squid_format == 1 || $cups_format == 1 || $dhcp_format == 1)) {
		    $file_to_open = $path;
		    $file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
		    $file_to_open .= $lang[$nblang].$dirsep;
		    $file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
		    $file_to_open .= $dirresume.$dirsep.$listdailydestination.$htmlext;
		    
		    open(FILERESUMEDEST,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
		    &PageResumeDest(*FILERESUMEDEST, eval($Lang{$lang[$nblang]}),1);
		    close (FILERESUMEDEST);
		}

#	    if ($paysuniquejour > $topten) {
	    if ($paysuniquejour != 0) {
		$file_to_open = $path;
		$file_to_open .= $dirtmp.$dirsep if ($mode_web == 1);
		$file_to_open .= $lang[$nblang].$dirsep;
		$file_to_open .= $dirdate.$dirsep if ($mode_web == 0);
		$file_to_open .= $dirresume.$dirsep.$listdailycountries.$htmlext;
		open(FILERESUMECOUNTRIESALL,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
		&PageResumePays(*FILERESUMECOUNTRIESALL, eval($Lang{$lang[$nblang]}),$lang[$nblang],1);
		close (FILERESUMECOUNTRIESALL);
	    }
	}

    }

    &SaveResumeDaily($dirresume) if ($scriptname eq "cron-pages.pl" || $scriptname eq "cron-inc.pl");
}

  #

sub SaveResumeDaily {
  local($dirresume) = @_;
  local($page,$rootrepert,$adresse,$pays);
  local(@i,$i,$j,$k);

  open(FILERESUMEHOSTSALL,">$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailysites$txtext") || &error_exit("Error, unable to open $path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailysites$txtext");
  foreach $adresse (&reverse_sort_by_value(*serverjour)) {
      print FILERESUMEHOSTSALL "$adresse\t$serverjour{$adresse}\t";
      print FILERESUMEHOSTSALL "$hostluesday{$adresse}" if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
      print FILERESUMEHOSTSALL "\t";
      print FILERESUMEHOSTSALL "$serversizejour{$adresse}" if ($notrafic == 0);
      print FILERESUMEHOSTSALL "\t$pays_ip{$adresse}" if ($reverse_geo == 1 && ($adresse =~ /[0-9]+$/ || $adresse =~ /:/));
      print FILERESUMEHOSTSALL "\n";

      for ($j=1;$j<=$nbpageday{$adresse};$j++) {
	  $page = $dailypageserv{$adresse,$j};
	  print FILERESUMEHOSTSALL "$page\t$seen_page{$adresse,$page}";
	  print FILERESUMEHOSTSALL "\n";
      }
  }
  close(FILERESUMEHOSTSALL);

  open(FILERESUMEPAGESALL,">$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailypages$txtext") || &error_exit("Error, unable to open $path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailypages$txtext");
  foreach $page (&reverse_sort_by_value(*pagesluesday)) {
      print FILERESUMEPAGESALL "$page\t$pagesluesday{$page}";
      print FILERESUMEPAGESALL "\n";
      if ($mail_format == 0) { 
	  for ($j=1;$j<=$nbhostpageday{$page};$j++) {
	      $host = $dailyhostpage{$page,$j};
	      print FILERESUMEPAGESALL "A\t$host\t$seen_host{$page,$host}";
	      print FILERESUMEPAGESALL "\n";
	  }
      }
  }
  print FILERESUMEPAGESALL "File\n";
  foreach $page (&reverse_sort_by_value(*filetypejour)) {
      print FILERESUMEPAGESALL "$page\t$filetypejour{$page}";
      print FILERESUMEPAGESALL "\n";
  }
  close(FILERESUMEPAGESALL);
  
  open(FILERESUMESCRIPTSALL,">$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailyscripts$txtext") || &error_exit("Error, unable to open $path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailyscripts$txtext");
  foreach $page (&reverse_sort_by_value(*scriptday)) {
      print FILERESUMESCRIPTSALL "$page\t$scriptday{$page}";
      print FILERESUMESCRIPTSALL "\n";
  }
  if (keys(%client_day_error) != 0) {
      print FILERESUMESCRIPTSALL "404\n";
      foreach $page (&reverse_sort_by_value(*client_day_error)) {
	  print FILERESUMESCRIPTSALL "$page\t$client_day_error{$page}\t$client_day_refer{$page}";
	  print FILERESUMESCRIPTSALL "\n";
      }
  }
  close(FILERESUMESCRIPTSALL);
  
  if ($notrafic == 0) {
      open(FILERESUMETRAFICALL,">$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailytrafic$txtext") || &error_exit("Error, unable to open $path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailytrafic$txtext");
      foreach $page (&reverse_sort_by_value(*dailysizepage)) {
	  print FILERESUMETRAFICALL "$page\t$dailysizepage{$page}";
	  print FILERESUMETRAFICALL "\n";
      }
      close(FILERESUMETRAFICALL);
  }

  open(FILERESUMEDIRALL,">$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailydir$txtext") || &error_exit("Error, unable to open $path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailydir$txtext");
  foreach $rootrepert (&reverse_sort_by_value(*freqjourrachtml)) {
      print FILERESUMEDIRALL "$rootrepert\t$freqjourrac{$rootrepert}\t$freqjourrachtml{$rootrepert}\t$sizejourrachtml{$rootrepert}";
      print FILERESUMEDIRALL "\n";	      
  }
  close(FILERESUMEDIRALL);

  open(FILERESUMECOUNTRIESALL,">$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailycountries$txtext") || &error_exit("Error, unable to open $path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailycountries$txtext");
  foreach $pays (&reverse_sort_by_value(*paysjour)) {
      print FILERESUMECOUNTRIESALL "$pays\t$paysjour{$pays}\t$payshtmljour{$pays}\t$paysjourlist{$pays}";
      print FILERESUMECOUNTRIESALL "\n";	      
  }
  close(FILERESUMECOUNTRIESALL);
  
  open(FILERESUMEUSERSALL,">$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailyusers$txtext") || &error_exit("Error, unable to open $path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailyusers$txtext");
  foreach $tmp (&reverse_sort_by_value(*userday)) {
      print FILERESUMEUSERSALL "$tmp\t$userday{$tmp}\t$user_adresseday{$tmp}\t$user_trafficday{$tmp}\t$user_accessday{$tmp}\n";
      for ($j=1;$j<=$nbusersday{$tmp};$j++) {
	  $host = $dailylogindest{$tmp,$j};
	  print FILERESUMEUSERSALL "$host\t$seen_users{$tmp,$host}";
	  print FILERESUMEUSERSALL "\t$dailyuserssizedest{$tmp,$host}";# if ($squid_format == 1);
	  print FILERESUMEUSERSALL "\n";
      }
  }
  close(FILERESUMEUSERSALL);

  if (($squid_format == 1 || $cups_format == 1 || $dhcp_format == 1) && $fullday == 1) {
      $tmp = $listdestination;
      $tmp =~ s/$htmlext/$txtext/;
      open(FILERESUMEDESTALL,">$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$tmp") || &error_exit("Error, unable to open $path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$tmp");
      foreach $tmp (&reverse_sort_by_value(*dailydest)) {
	  print FILERESUMEDESTALL "$tmp\t$dailydest{$tmp}\t$dailysizedest{$tmp}\n";
	  for ($j=1;$j<=$nbhostday{$tmp};$j++) {
	      $host = $dailyhostdest{$tmp,$j};
	      print FILERESUMEDESTALL "$host\t$dailyusersdest{$tmp,$j}\t$seen_dest{$tmp,$host}\t$dailyhostsizedest{$tmp,$host}";
	      print FILERESUMEDESTALL "\n";
	  }
      }
      close(FILERESUMEDESTALL);
  }

  open(FILERESUMEFILETYPEALL,">$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailyfiletype$txtext") || &error_exit("Error, unable to open $path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailyfiletype$txtext");
  for ($i=0;$i<=$#listext;$i++) {
      print FILERESUMEFILETYPEALL "$listext[$i]\t$filetypenb{$listext[$i]}\t$extfilenb{$listext[$i]}\t$downloadjour{$listext[$i]}";
      print FILERESUMEFILETYPEALL "\n";
  }
  close(FILERESUMEFILETYPEALL);
  

  if ($mail_format == 1 && $spam_found != 0) {
      open(FILERESUMESPAMALL,">$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailyspam$txtext") || &error_exit("Error, unable to open $path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailyspam$txtext");
      print FILERESUMESPAMALL "#EXTERNAL\n";
      foreach $tmp (&reverse_sort_by_value(*spam_daily_user_ext)) {
	  print FILERESUMESPAMALL "$tmp\t$spam_daily_user_ext{$tmp}";
	  print FILERESUMESPAMALL "\n";
	  for ($j=1;$j<=$spam_daily_user_ext_unique{$tmp};$j++) {
	      $host = $spam_daily_page{$tmp,$j};
	      print FILERESUMESPAMALL "$j\t$host\t$seen_spam{$tmp,$host}\n";
	  }
      }
      if ($spam_day_local != 0) {
	  print FILERESUMESPAMALL "#LOCAL\n";
	  foreach $tmp (&reverse_sort_by_value(*spam_daily_user_loc)) {
	      print FILERESUMESPAMALL "$tmp\t$spam_daily_user_loc{$tmp}";
	      print FILERESUMESPAMALL "\n";
	      for ($j=1;$j<=$spam_daily_user_loc_unique{$tmp};$j++) {
		  $host = $spam_daily_page{$tmp,$j};
		  print FILERESUMESPAMALL "$j\t$host\t$seen_spam{$tmp,$host}\n";
	      }
	  }
      }
      close(FILERESUMESPAMALL);      
  }


}

#################################################################
###                    day summary                            ###
#################################################################

### Deprecated ###

sub PageResumeFrame {
  local(*FOUT,*L) = @_;

  $tmpa = $dirresume;
  $tmpa = $oldjour if ($scriptname eq "cron-pages.pl");
  $tmpa = $yesterday if ($scriptname eq "cron-inc.pl");
  $tmpa =~ s/\/\-/ /g;
  $tmpa =~ s/\_/ \/ /g;

#  print FOUT "$doctype\n";
  print FOUT "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Frameset//EN\" \"http://www.w3.org/TR/html4/frameset.dtd\">\n";
  print FOUT "<HTML><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>Summary report $tmpa - Frame</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";
  print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
  print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";
#  print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_menu_w3perl\">\n";
  print FOUT "</HEAD>\n";

  print FOUT "<FRAMESET COLS=\"20%,*\">\n";
  print FOUT "<FRAME SCROLLING=\"auto\" MARGINHEIGHT=0 MARGINWIDTH=0 NAME=\"left\" SRC=\"$fileresumemenu\" FRAMEBORDER=0>\n";
  print FOUT "<FRAME SCROLLING=\"auto\" MARGINHEIGHT=0 MARGINWIDTH=0 NAME=\"right\" SRC=\"$filemoyenne\" FRAMEBORDER=0>\n";
  print FOUT "<NOFRAMES>\n";

  print FOUT "<BODY $backgrd2 TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
#  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
  print FOUT "<P>\n";
  print FOUT "</BODY>\n";
  print FOUT "</NOFRAMES>\n";

  print FOUT "</FRAMESET>\n";
  print FOUT "</HTML>\n";
}

###

sub PageResumeTab {
  local(*FOUT,*L,$I,$link_next) = @_;
  local($wday);

  $tmpa = $dirresume;
  $tmpa = $oldjour if ($scriptname eq "cron-pages.pl");
  $tmpa = $yesterday if ($scriptname eq "cron-inc.pl");
  $tmpa =~ s/\/\-/ /g;
  $tmpa =~ s/\_/ \/ /g;

  $tmp2 = $tmpa;
  if ($scriptname eq "cron-week.pl" || $scriptname eq "dayrange.pl") {
      ($tmp2) = split(/ \/ /,$tmpa);
      ($tmp1,$tmp2,$tmp3) = split(/-/,$tmp2);
      $tmp2 = "$tmp3 $tmp2 $tmp1";
  }
#  if ($scriptname ne "dayrange.pl" && $scriptname ne "cron-month.pl" && $scriptname ne "cron-year.pl") {
  if ($scriptname ne "cron-month.pl" && $scriptname ne "cron-year.pl") {
      $tmp_wod = (localtime(&nbday("$tmp2")*86400))[6];
      $wday = $day_of_week[$tmp_wod];
  }

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Summary'} - $tmpa</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";
  &add_jqplot_js(*FOUT,3);
  &add_css_style(*FOUT,3);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd2 TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";

  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,3);

  if ($scriptname eq "cron-week.pl") {
      ($tmp2,$tmp4) = split(/ \/ /,$tmpa);
      ($tmp1,$tmp2,$tmp3) = split(/-/,$tmp2);
      $tmpa = "$tmp3 $tmp2 $tmp1";
      $filegraph = $tmp3."_".$tmp2."_".$tmp1."-";
      ($tmp1,$tmp2,$tmp3) = split(/-/,$tmp4);
      $tmpa .= " / $day_of_week[--$tmp_wod] $tmp3 $tmp2 $tmp1";
      $filegraph .= $tmp3."_".$tmp2."_".$tmp1;
  }
  if ($scriptname eq "dayrange.pl") {
      ($tmp2,$tmp4) = split(/ \/ /,$tmpa);
      ($tmp1,$tmp2,$tmp3) = split(/-/,$tmp2);
      $tmpa = "$tmp3 $tmp2 $tmp1";
      $filegraph = $tmp1."-".$tmp2."-".$tmp3;

      if ($tmp4 ne '') {
	  ($tmp1,$tmp2,$tmp3) = split(/-/,$tmp4);

	  $tmp5 = "$tmp3 $tmp2 $tmp1";
	  $tmp_wod = (localtime(&nbday("$tmp5")*86400))[6];
	  $wday2 = $day_of_week[$tmp_wod];

	  $tmpa .= " / $wday2 $tmp3 $tmp2 $tmp1";
	  $filegraph .= "_".$tmp1."-".$tmp2."-".$tmp3;
      }
  }
  if ($scriptname eq "cron-month.pl") {
      ($tmp2,$tmp4) = split(/-/,$tmpa);
      $tmpa = "$tmp4 $tmp2";
      $filegraph = $tmp2."_".$tmp4;
  }
  if ($scriptname eq "cron-year.pl") {
      $filegraph = $tmpa;
  }

#  print FOUT "<TABLE WIDTH=\"100%\"><TR><TD VALIGN=TOP>\n";

  &PageResumeMenu(*FOUT, $link_next, eval($Lang{$lang[$nblang]}));

#  print FOUT "</TD>\n<TD VALIGN=TOP ALIGN=CENTER>\n";

  print FOUT "<CENTER><H3 CLASS=\"center\">$L{'Summary'} : $wday $tmpa</H3></CENTER>\n";

  print FOUT "<P><CENTER><A HREF=\"..$dirsepurl..$dirsepurl..$dirsepurl$dirpdf$dirsepurl$dirresume$pdfext\" TITLE=\"PDF\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_pdf\" WIDTH=\"20\" HEIGHT=\"20\" BORDER=0 ALT=\"pdf\"></A></CENTER><P>\n" if ($enable_pdf == 1 && $mode_web == 0);
  print FOUT "<P><CENTER><A HREF=\"..$dirsepurl..$dirsepurl$dirresume$pdfext\" TITLE=\"PDF\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_pdf\" WIDTH=\"20\" HEIGHT=\"20\" BORDER=0 ALT=\"pdf\"></A></CENTER><P>\n" if ($enable_pdf == 1 && $mode_web == 1);

  $tmpa =~ s/ (\d\d\d\d)// if ($scriptname eq "cron-pages.pl" || $scriptname eq "cron-inc.pl");
  
  print FOUT "<P>\n";
  
  $tmp1 = int($reqtotjour_moy/$line);
  $tmp = int(1000*($reqtotjour - $reqtotjour_prev)/$reqtotjour_prev)/10 if ($reqtotjour_prev != 0);
  print FOUT "<CENTER>\n<TABLE>\n<TR>\n<TH></TH>\n";
  print FOUT "<TH>$wday $tmpa</TH>\n";

  if ($scriptname eq "cron-pages.pl") {
      if ($oldoldjour ne '') {
	  $oldoldjour2 = $oldoldjour;
	  $oldoldjour2 =~ s/ (\d\d\d\d)//;
	  print FOUT "<TH>$oldoldjour2</TH>\n";
	  print FOUT "<TH>$L{'Difference'}</TH>\n";
	  print FOUT "<TH>$L{'Minimum'}</TH>\n";
	  print FOUT "<TH>$L{'Average'}</TH>\n";
	  print FOUT "<TH>$L{'Maximum'}</TH>\n";
      }
  }
  if ($scriptname eq "cron-inc.pl") {
      $previousjour_tmp = $previousjour;
      $previousjour_tmp =~ s/\// /g;
      $previousjour_tmp =~ s/ (\d\d\d\d)//;
      print FOUT "<TH>$previousjour_tmp</TH>\n";
      print FOUT "<TH>$L{'Difference'}</TH>\n";
      print FOUT "<TH>$L{'Minimum'}</TH>\n";
      print FOUT "<TH>$L{'Average'}</TH>\n";
      print FOUT "<TH>$L{'Maximum'}</TH>\n";
  }

  print FOUT "</TR>\n<TR>\n";

  $tmp_color = 0;
  if (int($tmp_color/2) == ($tmp_color/2)) {
      $class_color = "";
  } else {
      $class_color = "_alter";
  }

  print FOUT "<TD CLASS=\"left$class_color\"><I>$L{'Requests'}</I></TD>\n";

  print FOUT "<TD ";
  if ($oldoldjour ne '' || $scriptname eq "cron-inc.pl") {
      print FOUT "CLASS=\"left$class_color\">";
      $tmp3 = 50/($reqtotjour_max - $reqtotjour_min) if ($reqtotjour_max != $reqtotjour_min);
      $tmp3 = 0 if ($reqtotjour_max == $reqtotjour_min);

      $done = 0;
      if ($reqtotjour >= ($tmp1-4) && $reqtotjour <= ($tmp1+4)) {
	  $tmp5 = int($tmp3*($reqtotjour - $reqtotjour_min));
	  print FOUT "<IMG WIDTH=$tmp5 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">" if ($tmp5 != 0);
	  print FOUT "<IMG WIDTH=2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">";
	  $tmp4 = 100 - ($tmp5+2);
	  print FOUT "<IMG WIDTH=$tmp4 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">" if ($tmp4 > 0);
	  $done = 1;
      }

      if ($tmp1 < $reqtotjour && $done == 0) {
	  $tmp5 = int($tmp3*($tmp1 - $reqtotjour_min));
	  print FOUT "<IMG WIDTH=$tmp5 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">" if ($tmp5 != 0);
	  print FOUT "<IMG WIDTH=2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[7]\" ALT=\"$gcolor[7]\">";
	  $tmp4 = int($tmp3*($reqtotjour - $reqtotjour_min)) - ($tmp5);
	  print FOUT "<IMG WIDTH=$tmp4 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">" if ($tmp4 != 0);
	  print FOUT "<IMG WIDTH=2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">";
	  $tmp4 = 50 - ($tmp4+$tmp5+2);
	  print FOUT "<IMG WIDTH=$tmp4 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">" if ($tmp4 > 0);
      }
      if ($tmp1 > $reqtotjour && $done == 0) {
	  $tmp5 = int($tmp3*($reqtotjour - $reqtotjour_min));
	  print FOUT "<IMG WIDTH=$tmp5 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">" if ($tmp5 != 0);
	  print FOUT "<IMG WIDTH=2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">";
	  $tmp4 = int($tmp3*($tmp1 - $reqtotjour_min)) - ($tmp5);
	  print FOUT "<IMG WIDTH=$tmp4 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">" if ($tmp4 != 0);
	  print FOUT "<IMG WIDTH=2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[7]\" ALT=\"$gcolor[7]\">";
	  $tmp4 = 50 - ($tmp4+$tmp5+2);
	  print FOUT "<IMG WIDTH=$tmp4 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">" if ($tmp4 > 0);
      }

      print FOUT "&nbsp;<B>$reqtotjour</B>";
  } else {
      print FOUT "CLASS=\"right$class_color\">";
      print FOUT " $reqtotjour";
  }

  print FOUT "</TD>\n";
  if ($oldoldjour ne '' || $scriptname eq "cron-inc.pl") {
      print FOUT "<TD CLASS=\"right$class_color\">$reqtotjour_prev</TD>\n";
      print FOUT "<TD CLASS=\"right$class_color\">-</TD>\n" if ($reqtotjour_prev == 0 || $tmp == 0);
      print FOUT "<TD CLASS=\"right$class_color\">$tmp %</TD>\n" if ($reqtotjour_prev != 0 && $tmp != 0);
      print FOUT "<TD CLASS=\"right$class_color\">$reqtotjour_min</TD>\n";
      print FOUT "<TD CLASS=\"right$class_color\">$tmp1</TD>\n";
      print FOUT "<TD CLASS=\"right$class_color\">$reqtotjour_max</TD>\n";
  }
  print FOUT "</TR>\n";

#

  if ($spam_found != 0) {
      $tmp_color++;
      if (int($tmp_color/2) == ($tmp_color/2)) {
	  $class_color = "";
      } else {
	  $class_color = "_alter";
      }

      $tmp1 = int($spamjour_moy/$line);
      $tmp2 = $spam_day_ext+$spam_day_local;
      $tmp = int(1000*($tmp2-$spamjour_prev)/$spamjour_prev)/10 if ($spamjour_prev != 0);
      print FOUT "<TR>\n";
      print FOUT "<TD CLASS=\"left$class_color\"><I>$L{'Spam'}</I></TD><TD CLASS=\"right$class_color\">$tmp2</TD>\n"; 
      if ($oldoldjour ne '' || $scriptname eq "cron-inc.pl") {
	  print FOUT "<TD CLASS=\"right$class_color\">$spamjour_prev</TD>\n";
	  print FOUT "<TD CLASS=\"right$class_color\">-</TD>\n" if ($spamjour_prev == 0 || $tmp == 0);
	  print FOUT "<TD CLASS=\"right$class_color\">$tmp %</TD>\n" if ($spamjour_prev != 0 && $tmp != 0);
	  print FOUT "<TD CLASS=\"right$class_color\">$spamjour_min</TD>\n";
	  print FOUT "<TD CLASS=\"right$class_color\">$tmp1</TD>\n";
	  print FOUT "<TD CLASS=\"right$class_color\">$spamjour_max</TD>\n";
      }
      print FOUT "</TR>\n";
  }

#

  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
      $tmp_color++;
      if (int($tmp_color/2) == ($tmp_color/2)) {
	  $class_color = "";
      } else {
	  $class_color = "_alter";
      }

      $tmp1 = int($accessjour_moy/$line);
      $tmp = int(1000*($accessjour - $accessjour_prev)/$accessjour_prev)/10 if ($accessjour_prev != 0);
      print FOUT "<TR>\n";
      print FOUT "<TD CLASS=\"left$class_color\"><I>$L{'Accesses'}</I></TD>\n"; 
      print FOUT "<TD ";
      if ($oldoldjour ne '' || $scriptname eq "cron-inc.pl") {
	  print FOUT "CLASS=\"left$class_color\">";
	  $tmp3 = 50/($accessjour_max - $accessjour_min) if ($accessjour_max != $accessjour_min);
	  
	  $done = 0;
	  if ($accessjour >= ($tmp1-4) && $accessjour <= ($tmp1+4)) {
	      $tmp5 = int($tmp3*($accessjour - $accessjour_min));
	      print FOUT "<IMG WIDTH=$tmp5 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">" if ($tmp5 != 0);
	      print FOUT "<IMG WIDTH=2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">";
	      $tmp4 = 100 - ($tmp5+2);
	      print FOUT "<IMG WIDTH=$tmp4 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">" if ($tmp4 > 0);
	      $done = 1;
	  }

	  if ($tmp1 < $accessjour && $done == 0) {
	      $tmp5 = int($tmp3*($tmp1 - $accessjour_min));
	      print FOUT "<IMG WIDTH=$tmp5 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">" if ($tmp5 != 0);
	      print FOUT "<IMG WIDTH=2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[7]\" ALT=\"$gcolor[7]\">";
#	      $tmp4 = int($tmp3*($accessjour - $accessjour_min)) - ($tmp5+2);
	      $tmp4 = int($tmp3*($accessjour - $accessjour_min)) - ($tmp5);
	      print FOUT "<IMG WIDTH=$tmp4 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">" if ($tmp4 != 0);
	      print FOUT "<IMG WIDTH=2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">";
#	      $tmp4 = 50 - ($tmp4+$tmp5+4);
	      $tmp4 = 50 - ($tmp4+$tmp5+2);
	      print FOUT "<IMG WIDTH=$tmp4 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">" if ($tmp4 > 0);
	  }
	  if ($tmp1 > $accessjour && $done == 0) {
	      $tmp5 = int($tmp3*($accessjour - $accessjour_min));
	      print FOUT "<IMG WIDTH=$tmp5 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">" if ($tmp5 != 0);
	      print FOUT "<IMG WIDTH=2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">";
	      $tmp4 = int($tmp3*($tmp1 - $accessjour_min)) - ($tmp5+2);
	      print FOUT "<IMG WIDTH=$tmp4 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">" if ($tmp4 != 0);
	      print FOUT "<IMG WIDTH=2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[7]\" ALT=\"$gcolor[7]\">";
	      $tmp4 = 50 - ($tmp4+$tmp5+4);
	      print FOUT "<IMG WIDTH=$tmp4 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">" if ($tmp4 > 0);
	  }
	  
	  print FOUT "&nbsp;<B>$accessjour</B>";
      } else {
	  print FOUT "CLASS=\"right$class_color\">";
	  print FOUT " $accessjour";
      }

      if ($oldoldjour ne '' || $scriptname eq "cron-inc.pl") {
	  print FOUT "<TD CLASS=\"right$class_color\">$accessjour_prev</TD>\n";
	  print FOUT "<TD CLASS=\"right$class_color\">-</TD>\n" if ($accessjour_prev == 0 || $tmp == 0);
	  print FOUT "<TD CLASS=\"right$class_color\">$tmp %</TD>\n" if ($accessjour_prev != 0 && $tmp != 0);
	  print FOUT "<TD CLASS=\"right$class_color\">$accessjour_min</TD>\n";
	  print FOUT "<TD CLASS=\"right$class_color\">$tmp1</TD>\n";
	  print FOUT "<TD CLASS=\"right$class_color\">$accessjour_max</TD>\n";
      }
      print FOUT "</TR>\n";
      }

#

 if ($mail_format == 0) {

      $tmp_color++;
      if (int($tmp_color/2) == ($tmp_color/2)) {
	  $class_color = "";
      } else {
	  $class_color = "_alter";
      }

      $tmp1 = int($pageuniquejour_moy/$line);
      $tmp = int(1000*($pageuniquejour - $pageuniquejour_prev)/$pageuniquejour_prev)/10 if ($pageuniquejour_prev != 0);
      print FOUT "<TR>\n";
      print FOUT "<TD CLASS=\"left$class_color\"><I>$L{'Different_accesses'}</I></TD><TD CLASS=\"right$class_color\">$pageuniquejour</TD>\n"; 
      if ($oldoldjour ne '' || $scriptname eq "cron-inc.pl") {
	  print FOUT "<TD CLASS=\"right$class_color\">$pageuniquejour_prev</TD>\n";
	  print FOUT "<TD CLASS=\"right$class_color\">-</TD>\n" if ($pageuniquejour_prev == 0 || $tmp == 0);
	  print FOUT "<TD CLASS=\"right$class_color\">$tmp %</TD>\n" if ($pageuniquejour_prev != 0 && $tmp != 0);
	  print FOUT "<TD CLASS=\"right$class_color\">$pageuniquejour_min</TD>\n";
	  print FOUT "<TD CLASS=\"right$class_color\">$tmp1</TD>\n";
	  print FOUT "<TD CLASS=\"right$class_color\">$pageuniquejour_max</TD>\n";
      }
      print FOUT "</TR>\n";
  }

#

  if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {

      $tmp_color++;
      if (int($tmp_color/2) == ($tmp_color/2)) {
	  $class_color = "";
      } else {
	  $class_color = "_alter";
      }

      $tmp1 = int($nbfilejour_moy/$line);
      $tmp = int(1000*($nbfilejour - $nbfilejour_prev)/$nbfilejour_prev)/10 if ($nbfilejour_prev != 0);
      print FOUT "<TR>\n";
      print FOUT "<TD CLASS=\"left$class_color\"><I>$L{'Documents'}</I></TD><TD CLASS=\"right$class_color\">$nbfilejour</TD>\n"; 
      if ($oldoldjour ne '' || $scriptname eq "cron-inc.pl") {
	  print FOUT "<TD CLASS=\"right$class_color\">$nbfilejour_prev</TD>\n";
	  print FOUT "<TD CLASS=\"right$class_color\">-</TD>\n" if ($nbfilejour_prev == 0 || $tmp == 0);
	  print FOUT "<TD CLASS=\"right$class_color\">$tmp %</TD>\n" if ($nbfilejour_prev != 0 && $tmp != 0);
	  print FOUT "<TD CLASS=\"right$class_color\">$nbfilejour_min</TD>\n";
	  print FOUT "<TD CLASS=\"right$class_color\">$tmp1</TD>\n";
	  print FOUT "<TD CLASS=\"right$class_color\">$nbfilejour_max</TD>\n";
      }
      print FOUT "</TR>\n";
  }

#

  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {

      $tmp_color++;
      if (int($tmp_color/2) == ($tmp_color/2)) {
	  $class_color = "";
      } else {
	  $class_color = "_alter";
      }

      print FOUT "<TR>\n";

      $tmp1 = int($script_day_moy/$line);
      $tmp = int(1000*($script_day - $script_day_prev)/$script_day_prev)/10 if ($script_day_prev != 0);
      print FOUT "<TD CLASS=\"left$class_color\"><I>$L{'Scripts'}</I></TD><TD CLASS=\"right$class_color\">$script_day</TD>\n"; 
      if ($oldoldjour ne '' || $scriptname eq "cron-inc.pl") {
	  print FOUT "<TD CLASS=\"right$class_color\">$script_day_prev</TD>\n";
	  print FOUT "<TD CLASS=\"right$class_color\">-</TD>\n" if ($script_day_prev == 0 || $tmp == 0);
	  print FOUT "<TD CLASS=\"right$class_color\">$tmp %</TD>\n" if ($script_day_prev != 0 && $tmp != 0);
	  print FOUT "<TD CLASS=\"right$class_color\">$script_day_min</TD>\n";
	  print FOUT "<TD CLASS=\"right$class_color\">$tmp1</TD>\n";
	  print FOUT "<TD CLASS=\"right$class_color\">$script_day_max</TD>\n";
      }
      print FOUT "</TR>\n";
  }

#

  if ($notrafic == 0) {
  $tmp_color++;
  if (int($tmp_color/2) == ($tmp_color/2)) {
      $class_color = "";
  } else {
      $class_color = "_alter";
  }


  print FOUT "<TR>\n";
  $tmp1 = $totsizejour_moy/$line;

  $tmp3 = 0;
  $tmp2 = 0;
  $tmp = int(($totsizejour/1024)*10)/10;
  $tmp2 = int(($tmp/1024)*10)/10 if ($tmp >= 1024);
  $tmp3 = int(($tmp2/1024)*10)/10 if ($tmp2 >= 1024);
  print FOUT "<TD CLASS=\"left$class_color\"><I>$L{'Total_traffic'}</I></TD><TD CLASS=\"right$class_color\">";
  print FOUT "$tmp $L{'Kb'}</TD>" if ($tmp < 1024);
  print FOUT "$tmp2 $L{'Mb'}</TD>\n" if ($tmp >= 1024 && $tmp3 == 0);
  print FOUT "$tmp3 $L{'Gb'}</TD>\n" if (int($tmp3) != 0);
  if ($oldoldjour ne '' || $scriptname eq "cron-inc.pl") {
      $tmp2 = 0;
      $tmp3 = 0;
      $tmp = int(($totsizejour_prev/1024)*10)/10;
      $tmp2 = int(($tmp/1024)*10)/10 if ($tmp >= 1024);
      $tmp3 = int(($tmp2/1024)*10)/10 if ($tmp2 >= 1024);
      print FOUT "<TD CLASS=\"right$class_color\">";
      print FOUT "$tmp $L{'Kb'}</TD>" if ($tmp < 1024);
      print FOUT "$tmp2 $L{'Mb'}</TD>\n" if ($tmp >= 1024 && $tmp3 == 0);
      print FOUT "$tmp3 $L{'Gb'}</TD>\n" if (int($tmp3) != 0);
      $tmp = int(1000*($totsizejour - $totsizejour_prev)/$totsizejour_prev)/10 if ($totsizejour_prev != 0);
      print FOUT "<TD CLASS=\"right$class_color\">-</TD>\n" if ($totsizejour_prev == 0 || $tmp == 0);
      print FOUT "<TD CLASS=\"right$class_color\">$tmp %</TD>\n" if ($totsizejour_prev != 0 && $tmp != 0);
      $tmp5 = 0;
      $tmp4 = 0;
      $tmp3 = int(($totsizejour_min/1024)*10)/10;
      $tmp4 = int(($tmp3/1024)*10)/10 if ($tmp3 >= 1024);
      $tmp5 = int(($tmp4/1024)*10)/10 if ($tmp4 >= 1024);
      print FOUT "<TD CLASS=\"right$class_color\">";
      print FOUT "$tmp3 $L{'Kb'}</TD>" if ($tmp3 < 1024);
      print FOUT "$tmp4 $L{'Mb'}</TD>\n" if ($tmp3 >= 1024 && $tmp5 == 0);
      print FOUT "$tmp5 $L{'Gb'}</TD>\n" if (int($tmp5) != 0);
      $tmp5 = 0;
      $tmp4 = 0;
      $tmp3 = int(($tmp1/1024)*10)/10;
      $tmp4 = int(($tmp3/1024)*10)/10 if ($tmp3 >= 1024);
      $tmp5 = int(($tmp4/1024)*10)/10 if ($tmp4 >= 1024);
      print FOUT "<TD CLASS=\"right$class_color\">";
      print FOUT "$tmp3 $L{'Kb'}</TD>" if ($tmp3 < 1024);
      print FOUT "$tmp4 $L{'Mb'}</TD>\n" if ($tmp3 >= 1024 && $tmp5 == 0);
      print FOUT "$tmp5 $L{'Gb'}</TD>\n" if (int($tmp5) != 0);
      $tmp5 = 0;
      $tmp4 = 0;
      $tmp3 = int(($totsizejour_max/1024)*10)/10;
      $tmp4 = int(($tmp3/1024)*10)/10 if ($tmp3 >= 1024);
      $tmp5 = int(($tmp4/1024)*10)/10 if ($tmp4 >= 1024);
      print FOUT "<TD CLASS=\"right$class_color\">";
      print FOUT "$tmp3 $L{'Kb'}</TD>" if ($tmp3 < 1024);
      print FOUT "$tmp4 $L{'Mb'}</TD>\n" if ($tmp3 >= 1024 && $tmp5 == 0);
      print FOUT "$tmp5 $L{'Gb'}</TD>\n" if (int($tmp5) != 0);
  }
  print FOUT "</TR>\n";

#

  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
      $tmp_color++;
      if (int($tmp_color/2) == ($tmp_color/2)) {
	  $class_color = "";
      } else {
	  $class_color = "_alter";
      }

      print FOUT "<TR>\n";
      $tmp1 = $tothtmlsizejour_moy/$line;
      $tmp4 = 0;
      $tmp3 = 0;
      $tmp2 = 0;
      $tmp = int(($tothtmlsizejour/1024)*10)/10;
      $tmp2 = int(($tmp/1024)*10)/10 if ($tmp >= 1024);
      $tmp3 = int(($tmp2/1024)*10)/10 if ($tmp2 >= 1024);
      $tmp4 = int(($tmp3/1024)*10)/10 if ($tmp3 >= 1024);
      print FOUT "<TD CLASS=\"left$class_color\"><I>$L{'Traffic'} $L{'accesses'}</I></TD><TD CLASS=\"right$class_color\">";
      print FOUT "$tmp $L{'Kb'}</TD>\n" if ($tmp < 1024);
      print FOUT "$tmp2 $L{'Mb'}</TD>\n" if ($tmp >= 1024 && $tmp3 == 0);
      print FOUT "$tmp3 $L{'Gb'}</TD>\n" if (int($tmp3) != 0 && $tmp4 == 0);
      print FOUT "$tmp4 $L{'Tb'}</TD>\n" if (int($tmp4) != 0);
      if ($oldoldjour ne '' || $scriptname eq "cron-inc.pl") {
	  $tmp3 = 0;
	  $tmp2 = 0;
	  $tmp = int(($tothtmlsizejour_prev/1024)*10)/10;
	  $tmp2 = int(($tmp/1024)*10)/10 if ($tmp >= 1024);
	  $tmp3 = int(($tmp2/1024)*10)/10 if ($tmp2 >= 1024);
	  $tmp4 = int(($tmp3/1024)*10)/10 if ($tmp3 >= 1024);
	  print FOUT "<TD CLASS=\"right$class_color\">";
	  print FOUT "$tmp $L{'Kb'}</TD>\n" if ($tmp < 1024);
	  print FOUT "$tmp2 $L{'Mb'}</TD>\n" if ($tmp >= 1024 && $tmp3 == 0);
	  print FOUT "$tmp3 $L{'Gb'}</TD>\n" if (int($tmp3) != 0 && $tmp4 == 0);
	  print FOUT "$tmp4 $L{'Tb'}</TD>\n" if (int($tmp4) != 0);
	  $tmp = int(1000*($tothtmlsizejour - $tothtmlsizejour_prev)/$tothtmlsizejour_prev)/10 if ($tothtmlsizejour_prev != 0);
	  print FOUT "<TD CLASS=\"right$class_color\">-</TD>\n" if ($tothtmlsizejour_prev == 0 || $tmp == 0);
	  print FOUT "<TD CLASS=\"right$class_color\">$tmp %</TD>\n" if ($tothtmlsizejour_prev != 0 && $tmp != 0);
	  $tmp6 = 0;
	  $tmp5 = 0;
	  $tmp4 = 0;
	  $tmp3 = int(($tothtmlsizejour_min/1024)*10)/10;
	  $tmp4 = int(($tmp3/1024)*10)/10 if ($tmp3 >= 1024);
	  $tmp5 = int(($tmp4/1024)*10)/10 if ($tmp4 >= 1024);
	  $tmp6 = int(($tmp5/1024)*10)/10 if ($tmp5 >= 1024);
	  print FOUT "<TD CLASS=\"right$class_color\">";
	  print FOUT "$tmp3 $L{'Kb'}</TD>" if ($tmp3 < 1024);
	  print FOUT "$tmp4 $L{'Mb'}</TD>\n" if ($tmp3 >= 1024 && $tmp5 == 0);
	  print FOUT "$tmp5 $L{'Gb'}</TD>\n" if (int($tmp5) != 0 && $tmp6 == 0);
	  print FOUT "$tmp6 $L{'Tb'}</TD>\n" if (int($tmp6) != 0);
	  $tmp6 = 0;
	  $tmp5 = 0;
	  $tmp4 = 0;
	  $tmp3 = int(($tmp1/1024)*10)/10;
	  $tmp4 = int(($tmp3/1024)*10)/10 if ($tmp3 >= 1024);
	  $tmp5 = int(($tmp4/1024)*10)/10 if ($tmp4 >= 1024);
	  $tmp6 = int(($tmp5/1024)*10)/10 if ($tmp5 >= 1024);
	  print FOUT "<TD CLASS=\"right$class_color\">";
	  print FOUT "$tmp3 $L{'Kb'}</TD>" if ($tmp3 < 1024);
	  print FOUT "$tmp4 $L{'Mb'}</TD>\n" if ($tmp3 >= 1024 && $tmp5 == 0);
	  print FOUT "$tmp5 $L{'Gb'}</TD>\n" if (int($tmp5) != 0 && $tmp6 == 0);
	  print FOUT "$tmp6 $L{'Tb'}</TD>\n" if (int($tmp6) != 0);
	  $tmp6 = 0;
	  $tmp5 = 0;
	  $tmp4 = 0;
	  $tmp3 = int(($tothtmlsizejour_max/1024)*10)/10;
	  $tmp4 = int(($tmp3/1024)*10)/10 if ($tmp3 >= 1024);
	  $tmp5 = int(($tmp4/1024)*10)/10 if ($tmp4 >= 1024);
	  $tmp6 = int(($tmp5/1024)*10)/10 if ($tmp5 >= 1024);
	  print FOUT "<TD CLASS=\"right$class_color\">";
	  print FOUT "$tmp3 $L{'Kb'}</TD>" if ($tmp3 < 1024);
	  print FOUT "$tmp4 $L{'Mb'}</TD>\n" if ($tmp3 >= 1024 && $tmp5 == 0);
	  print FOUT "$tmp5 $L{'Gb'}</TD>\n" if (int($tmp5) != 0 && $tmp6 == 0);
	  print FOUT "$tmp6 $L{'Tb'}</TD>\n" if (int($tmp6) != 0);
      }
      print FOUT "</TR>\n";
  }
}
#

  $tmp_color++;
  if (int($tmp_color/2) == ($tmp_color/2)) {
      $class_color = "";
  } else {
      $class_color = "_alter";
  }

  print FOUT "<TR>\n";
  $tmp1 = int($serveruniquejour_moy/$line);
  $tmp = int(1000*($serveruniquejour - $serveruniquejour_prev)/$serveruniquejour_prev)/10 if ($serveruniquejour_prev != 0);
  print FOUT "<TD CLASS=\"left$class_color\"><I>$L{'Hosts'}</I></TD><TD CLASS=\"right$class_color\">$serveruniquejour</TD>\n";
  if ($oldoldjour ne '' || $scriptname eq "cron-inc.pl") {
      print FOUT "<TD CLASS=\"right$class_color\">$serveruniquejour_prev</TD>\n";
      print FOUT "<TD CLASS=\"right$class_color\">-</TD>\n" if ($serveruniquejour_prev == 0 || $tmp == 0);
      print FOUT "<TD CLASS=\"right$class_color\">$tmp %</TD>\n" if ($serveruniquejour_prev != 0 && $tmp != 0);
      print FOUT "<TD CLASS=\"right$class_color\">$serveruniquejour_min</TD>\n";
      print FOUT "<TD CLASS=\"right$class_color\">$tmp1</TD>\n";
      print FOUT "<TD CLASS=\"right$class_color\">$serveruniquejour_max</TD>\n";
  }
  print FOUT "</TR><TR>\n";

#

  $tmp_color++;
  if (int($tmp_color/2) == ($tmp_color/2)) {
      $class_color = "";
  } else {
      $class_color = "_alter";
  }

  $tmp1 = int($newhost_moy/$line);
  $tmp = int(1000*($newhost - $newhost_prev)/$newhost_prev)/10 if ($newhost_prev != 0);
  print FOUT "<TD CLASS=\"left$class_color\"><I>$L{'New_Hosts'}</I></TD><TD CLASS=\"right$class_color\">$newhost</TD>\n";
  if ($oldoldjour ne '' || $scriptname eq "cron-inc.pl") {
      print FOUT "<TD CLASS=\"right$class_color\">$newhost_prev</TD>\n";
      print FOUT "<TD CLASS=\"right$class_color\">-</TD>\n" if ($newhost_prev == 0 || $tmp == 0);
      print FOUT "<TD CLASS=\"right$class_color\">$tmp %</TD>\n" if ($newhost_prev != 0 && $tmp != 0);
      print FOUT "<TD CLASS=\"right$class_color\">$newhost_min</TD>\n";
      print FOUT "<TD CLASS=\"right$class_color\">$tmp1</TD>\n";
      print FOUT "<TD CLASS=\"right$class_color\">$newhost_max</TD>\n";
  }
  print FOUT "</TR>\n";

  if ($paysuniquejour_prev == 0 && $paysuniquejour == 0) {
      $tmp_color++;
      if (int($tmp_color/2) == ($tmp_color/2)) {
	  $class_color = "";
      } else {
	  $class_color = "_alter";
      }

      print FOUT "<TR>\n";
      $tmp1 = int($paysuniquejour_moy/$line);
      $tmp = int(1000*($paysuniquejour - $paysuniquejour_prev)/$paysuniquejour_prev)/10 if ($paysuniquejour_prev != 0);
      print FOUT "<TD CLASS=\"left$class_color\"><I>$L{'Countries'}</I></TD><TD CLASS=\"right$class_color\">$paysuniquejour</TD>\n";
      if ($oldoldjour ne '' || $scriptname eq "cron-inc.pl") {
	  print FOUT "<TD CLASS=\"right$class_color\">$paysuniquejour_prev</TD>\n";
	  print FOUT "<TD CLASS=\"right$class_color\">-</TD>\n" if ($paysuniquejour_prev == 0 || $tmp == 0);
	  print FOUT "<TD CLASS=\"right$class_color\">$tmp %</TD>\n" if ($paysuniquejour_prev != 0 && $tmp != 0);
	  print FOUT "<TD CLASS=\"right$class_color\">$paysuniquejour_min</TD>\n";
	  print FOUT "<TD CLASS=\"right$class_color\">$tmp1</TD>\n";
	  print FOUT "<TD CLASS=\"right$class_color\">$paysuniquejour_max</TD>\n";
      }
      print FOUT "</TR>\n";
  }

  print FOUT "</TABLE>\n";

  if ($locallog == 1 || $localonly == 1) {

      print FOUT "<P><BR>";

      print FOUT "<TABLE><TR>";
      print FOUT "<TH>&nbsp;<I>$L{'Domain'}</I> : $localdomainename&nbsp;</TH>\n";
      print FOUT "<TH>&nbsp;$wday&nbsp;$tmpa&nbsp;</TH>\n";
      if ($scriptname eq "cron-pages.pl") {
	  if ($oldoldjour ne '') {
	      print FOUT "<TH>&nbsp;$oldoldjour2&nbsp;</TH>\n<TH>&nbsp;$L{'Difference'}&nbsp;</TH>\n<TH>&nbsp;$L{'Average'}&nbsp;</TH>\n";
	  }
      }
      if ($scriptname eq "cron-inc.pl") {
	  print FOUT "<TH>&nbsp;$previousjour_tmp&nbsp;</TH><TH>&nbsp;$L{'Difference'}&nbsp;</TH><TH>&nbsp;$L{'Average'}&nbsp;</TH>\n";
      }
      print FOUT "</TR>\n<TR>";

      $tmp_color = 0;
      if (int($tmp_color/2) == ($tmp_color/2)) {
	  $class_color = "";
      } else {
	  $class_color = "_alter";
      }

      $tmp1 = int($domreq_moy/$line);
      $tmp = int(1000*($domreq - $domreq_prev)/$domreq_prev)/10 if ($domreq_prev != 0);
      print FOUT "<TD CLASS=\"left$class_color\"><I>$L{'Requests'}</I></TD>\n"; # if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
      print FOUT "<TD CLASS=\"right$class_color\">$domreq</TD>\n";
      if ($oldoldjour ne '' || $scriptname eq "cron-inc.pl") {
	  print FOUT "<TD CLASS=\"right$class_color\">$domreq_prev</TD>\n";
	  print FOUT "<TD CLASS=\"right$class_color\">-</TD>\n" if ($domreq_prev == 0 || $tmp == 0);
	  print FOUT "<TD CLASS=\"right$class_color\">$tmp %</TD>\n" if ($domreq_prev != 0 && $tmp != 0);
	  print FOUT "<TD CLASS=\"right$class_color\">$tmp1</TD>\n";
      }
      print FOUT "</TR><TR>\n";


      if ($spam_found != 0) {
	  $tmp_color++;
	  if (int($tmp_color/2) == ($tmp_color/2)) {
	      $class_color = "";
	  } else {
	      $class_color = "_alter";
	  }

	  $tmp1 = int($spamjourloc_moy/$line);
	  $tmp2 = $spam_day_local;
	  $tmp = int(1000*($tmp2-$spamjourloc_prev)/$spamjourloc_prev)/10 if ($spamjourloc_prev != 0);
	  print FOUT "<TR>\n";
	  print FOUT "<TD CLASS=\"left$class_color\"><I>$L{'Spam'}</I></TD><TD CLASS=\"right$class_color\">$tmp2</TD>\n"; 
	  if ($oldoldjour ne '' || $scriptname eq "cron-inc.pl") {
	      print FOUT "<TD CLASS=\"right$class_color\">$spamjourloc_prev</TD>\n";
	      print FOUT "<TD CLASS=\"right$class_color\">-</TD>\n" if ($spamjourloc_prev == 0 || $tmp == 0);
	      print FOUT "<TD CLASS=\"right$class_color\">$tmp %</TD>\n" if ($spamjourloc_prev != 0 && $tmp != 0);
#	      print FOUT "<TD CLASS=\"right$class_color\">$spamjourloc_min</TD>\n";
	      print FOUT "<TD CLASS=\"right$class_color\">$tmp1</TD>\n";
#	      print FOUT "<TD CLASS=\"right$class_color\">$spamjourloc_max</TD>\n";
	  }
	  print FOUT "</TR>\n";
      }

      $tmp_color++;
      if (int($tmp_color/2) == ($tmp_color/2)) {
	  $class_color = "";
      } else {
	  $class_color = "_alter";
      }     


      $tmp1 = int($locserverjour_moy/$line);
      $tmp = int(1000*($locserverjour - $locserverjour_prev)/$locserverjour_prev)/10 if ($locserverjour_prev != 0);
      print FOUT "<TD CLASS=\"left$class_color\"><I>$L{'Hosts'}</I></TD>\n<TD CLASS=\"right$class_color\">$locserverjour</TD>\n";
      if ($oldoldjour ne '' || $scriptname eq "cron-inc.pl") {
	  print FOUT "<TD CLASS=\"right$class_color\">$locserverjour_prev</TD>\n";
	  print FOUT "<TD CLASS=\"right$class_color\">-</TD>\n" if ($locserverjour_prev == 0 || $tmp == 0);
	  print FOUT "<TD CLASS=\"right$class_color\">$tmp %</TD>\n" if ($locserverjour_prev != 0 && $tmp != 0);
	  print FOUT "<TD CLASS=\"right$class_color\">$tmp1</TD>\n";
      }
      print FOUT "</TR>\n";
      if ($notrafic == 0) {
	  $tmp_color++;
	  if (int($tmp_color/2) == ($tmp_color/2)) {
	      $class_color = "";
	  } else {
	      $class_color = "_alter";
	  }

	  print FOUT "<TR>\n";

	  $tmp1 = int($domsize_moy/$line);
	  $tmp3 = int(($tmp1/1024)*10)/10;
	  $tmp4 = int(($tmp3/1024)*10)/10 if ($tmp3 >= 1024 && $tmp3 < (1024*1024));
	  $tmp4 = int(($tmp3/(1024*1024))*10)/10 if ($tmp3 >= (1024*1024));
	  $tmp = int(($domsizejour/1024)*10)/10;
	  $tmp2 = int(($tmp/1024)*10)/10 if ($tmp >= 1024 && $tmp < (1024*1024));
	  $tmp2 = int(($tmp/(1024*1024))*10)/10 if ($tmp >= (1024*1024));
	  print FOUT "<TD CLASS=\"left$class_color\"><I>$L{'Traffic'}</I></TD>\n<TD CLASS=\"right$class_color\">";
	  print FOUT "$tmp $L{'Kb'}</TD>\n" if ($tmp < 1024);
	  print FOUT "$tmp2 $L{'Mb'}</TD>\n" if ($tmp >= 1024 && $tmp < (1024*1024));
	  print FOUT "$tmp2 $L{'Gb'}</TD>\n" if ($tmp >= (1024*1024));
	  if ($oldoldjour ne '' || $scriptname eq "cron-inc.pl") {
	      $tmp = int(($domsize_prev/1024)*10)/10;
	      $tmp2 = int(($tmp/1024)*10)/10 if ($tmp >= 1024 && $tmp < (1024*1024));
	      $tmp2 = int(($tmp/(1024*1024))*10)/10 if ($tmp >= (1024*1024));
	      print FOUT "<TD CLASS=\"right$class_color\">";
	      print FOUT "$tmp $L{'Kb'}</TD>\n" if ($tmp < 1024);
	      print FOUT "$tmp2 $L{'Mb'}</TD>\n" if ($tmp >= 1024 && $tmp < (1024*1024));
	      print FOUT "$tmp2 $L{'Gb'}</TD>\n" if ($tmp >= (1024*1024));
	      $tmp = int(1000*($domsizejour - $domsize_prev)/$domsize_prev)/10 if ($domsize_prev != 0);
	      print FOUT "<TD CLASS=\"right$class_color\">-</TD>\n" if ($domsize_prev == 0 || $tmp == 0);
	      print FOUT "<TD CLASS=\"right$class_color\">$tmp %</TD>\n" if ($domsize_prev != 0 && $tmp != 0);
	      print FOUT "<TD CLASS=\"right$class_color\">";
	      print FOUT "$tmp3 $L{'Kb'}</TD>" if ($tmp3 < 1024);
	      print FOUT "$tmp4 $L{'Mb'}</TD>\n" if ($tmp3 >= 1024 && $tmp3 < (1024*1024));
	      print FOUT "$tmp4 $L{'Gb'}</TD>\n" if ($tmp3 >= (1024*1024));
	  }
	  print FOUT "</TR>";
      }
      print FOUT "</TABLE>\n";
  }

  print FOUT "</CENTER><P><BR>\n";

  if ($paysjournew != 0 && $scriptname eq "cron-inc.pl") {

      print FOUT "<CENTER>\n";
      print FOUT "<TABLE><TR><TH COLSPAN=2 ALIGN=\"left\"><I>$L{'New_country'}</I> : $paysjournew</TH></TR>\n";
      for ($j=1;$j<=$paysjournew;$j++) {

	  if ($newflag{$newpaysjour[$j]} ne '') {

	      print FOUT "<TR>";
	      print FOUT "<TD CLASS=\"left\">" if (($j/2) == int($j/2));
	      print FOUT "<TD CLASS=\"left_alter\">" if (($j/2) != int($j/2));
	      if (-f "$pathinit$dirress$dirsep$dirflags$dirsep$newpaysjour[$j]$gifext") {
		  print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirflags$dirsepurl$newpaysjour[$j]$gifext\" WIDTH=14 HEIGHT=\"14\" BORDER=0 ALT=\"$pays\">";
	      } else {
		  $tmp2 = "Unknown";
		  print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirflags$dirsepurl$tmp2$gifext\" WIDTH=14 HEIGHT=\"14\" BORDER=0 ALT=\"$tmp2\">";
	      }
	      print FOUT "</TD>\n";
	      print FOUT "<TD CLASS=\"left\">" if (($j/2) == int($j/2));
	      print FOUT "<TD CLASS=\"left_alter\">" if (($j/2) != int($j/2));
	      print FOUT "$L{$newflag{$newpaysjour[$j]}}</TD></TR>\n";
	  }

	  if ($newflag{$newpaysjour[$j]} eq '') {
	      print FOUT "<TR>";
	      print FOUT "<TD CLASS=\"left\">" if (($j/2) == int($j/2));
	      print FOUT "<TD CLASS=\"left_alter\">" if (($j/2) != int($j/2));
	      $tmp2 = "Unknown";
	      print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirflags$dirsepurl$tmp2$gifext\" WIDTH=14 HEIGHT=\"14\" BORDER=0 ALT=\"$tmp2\">";
	      print FOUT "</TD>\n";
	      print FOUT "<TD CLASS=\"left\">" if (($j/2) == int($j/2));
	      print FOUT "<TD CLASS=\"left_alter\">" if (($j/2) != int($j/2));
	      print FOUT "$L{'Unknown'} <I>($newpaysjour[$j])</I></TD></TR>\n";
	  }
      }
      print FOUT "</TABLE>\n";
      print FOUT "</CENTER><P><BR>\n";
  }

#  if ($scriptname eq "cron-week.pl" || $scriptname eq "cron-month.pl") {

  &help_div(*FOUT);
#  print FOUT "<-- insert_hourly_graph -->\n";

  print FOUT "<!-- begin_insert_map -->\n" if ($scriptname eq "cron-pages.pl" || $scriptname eq "cron-inc.pl");
  
  if ($reqmax != 0 || ($scriptname eq "cron-pages.pl" || $scriptname eq "cron-inc.pl")) {

      if ($fly_set == 0 && $reqtotjour != 0) {

	  if ($scriptname eq "dayrange.pl" || $scriptname eq "cron-year.pl" || $scriptname eq "cron-month.pl" || $scriptname eq "cron-week.pl") {
#	  if ($scriptname eq "cron-year.pl" || $scriptname eq "cron-month.pl" || $scriptname eq "cron-week.pl") {
	      $chart_id = 0;
	      $info = "info".$chart_id;
	      $xlegend = scalar(@datejq_value)." $L{'days'}";
	      $ylegend = "";
	      undef @ref_tab;
	      push(@ref_tab,\@req_value);
	      push(@ref_tab,\@acc_value);
	      push(@ref_tab,\@host_value);
	      push(@ref_tab,\@doc_value);
	      push(@ref_tab,\@traffic_value);
	      push(@ref_tab,\@spam_value);
	      @ref_tab_name = ('requests','accesses','hosts','documents2','traffic','spam');
	      
	      @graph_to_display = ($L{'Requests'},$L{'Accesses'},$L{'Hosts'});

	      &MakeDailyGraphJqplotInit(*FOUT, eval($Lang{$lang[$nblang]}),$nblang,1,$unit_div,\@ref_tab,\@ref_tab_name,\@datejq_value,$chart_id);

	      undef @ref_tab;
	      push(@ref_tab,\@req_value);
	      push(@ref_tab,\@acc_value);
	      push(@ref_tab,\@host_value);

	      &MakeDailyGraphJqplot(*FOUT,eval($Lang{$lang[$nblang]}),$nblang,1,\@graph_to_display,\@ref_tab,\@datejq_value,\@serie_color,1,$unit,$chart_id,0,"",$info,0,$xlegend,$ylegend,$xmax_jqplot,$dirsite);
	      &AddJqplotHtml(*FOUT, eval($Lang{$lang[$nblang]}),$nblang,$chart_id,$info,$xmax_jqplot,$ymax_jqplot,3);
	      $chart_id += $#list_graph_name_jqplot+1;
	  }

	  print FOUT "<!-- insert_jqplot -->\n";

#	  }

      }

      if ($fly_set == 1) {
      if (( (-f "$path$dirgraph$dirsep$filegraph$gifext" || -f "$path$dirtmp$dirsep$filegraph$gifext")  && ($scriptname eq "cron-week.pl" || $scriptname eq "cron-month.pl")) || ($scriptname eq "cron-pages.pl" || $scriptname eq "cron-inc.pl" || $scriptname eq "cron-year.pl" || $scriptname eq "dayrange.pl")) {
  
	  $linkgraph = "..".$dirsepurl."..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$filegraph.$gifext;
	  $linkgraphx = "..".$dirsepurl."..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$filegraph."x".$gifext;
	  $linkgraphy = "..".$dirsepurl."..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$filegraph."y".$gifext;

	  if (-f "$path$dirtmp$dirsep$filegraph$gifext" && $mode_web == 1) {
	      $linkgraph = "..".$dirsepurl."..".$dirsepurl.$filegraph.$gifext;
	      $linkgraphx = "..".$dirsepurl."..".$dirsepurl.$filegraph."x".$gifext;
	      $linkgraphy = "..".$dirsepurl."..".$dirsepurl.$filegraph."y".$gifext;	      
#	      $linkgraph = "..".$dirsepurl."..".$dirsepurl."..".$dirsepurl.$dirtmp.$dirsepurl.$filegraph.$gifext;
#	      $linkgraphx = "..".$dirsepurl."..".$dirsepurl."..".$dirsepurl.$dirtmp.$dirsepurl.$filegraph."x".$gifext;
#	      $linkgraphy = "..".$dirsepurl."..".$dirsepurl."..".$dirsepurl.$dirtmp.$dirsepurl.$filegraph."y".$gifext;	      
	  }

	  # Windows
	  if (-f "$pathinit$dirtmp$dirsep$filegraph$gifext") {
	      $linkgraph = $dirsepurl."w3perl".$dirsepurl.$dirtmp.$dirsepurl.$filegraph.$gifext;
	      $linkgraphx = $dirsepurl."w3perl".$dirsepurl.$dirtmp.$dirsepurl.$filegraph."x".$gifext;
	      $linkgraphy = $dirsepurl."w3perl".$dirsepurl.$dirtmp.$dirsepurl.$filegraph."y".$gifext;	      
	  }

	  $map2 = $map;

	  $map2 =~ s/Requests/$L{'Requests'}/g if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
	  $map2 =~ s/Requests/$L{'Files'}/g if ($ftp_format == 1);
	  $map2 =~ s/Requests/$L{'Emails'}/g if ($mail_format == 1);
	  $map2 =~ s/Accesses/$L{'Accesses'}/g;
	  $map2 =~ s/Spam/$L{'Spam'}/g;
	  $map2 =~ s/Hosts/$L{'Hosts'}/g;
	  $map2 =~ s/Traffic/$L{'Traffic'}/g;
#	  $map2 =~ s/\.\.$dirsepurl/\.\.$dirsepurl\.\.$dirsepurl\.\.$dirsepurl$lang[$nblang]$dirsepurl$dirdate$dirsepurl/g if ($scriptname eq "dayrange.pl");
	  $map2 =~ s/\.\.$dirsepurl/\.\.$dirsepurl\.\.$dirsepurl\.\.$dirsepurl$lang[$nblang]$dirsepurl$dirdate$dirsepurl/g if ($mode_web == 1);
	  
	  print FOUT "<MAP NAME=\"day1\">\n";
	  print FOUT "$map2\n";
	  print FOUT "</MAP>\n";

#	  print FOUT "$count_day" if ($scriptname eq "cron-year.pl");

	  print FOUT "<CENTER>\n<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
	  print FOUT "<TR>\n";
	  print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linkgraphy\" ALT=\"y\"></TD>\n";
	  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"$linkgraph\" ALT=\"graph1\" USEMAP=\"#day1\" BORDER=0></TD>\n";
	  print FOUT "</TR><TR><TD></TD>\n";
	  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linkgraphx\" ALT=\"x\"></TD>\n";
	  print FOUT "</TR>\n";
	  print FOUT "<TR>\n<TD>\n</TD>\n";
	  print FOUT "<TD ALIGN=CENTER>\n";
	  
	  print FOUT "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0><TR>\n";
	  print FOUT "<TD><IMG WIDTH=$square HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[0]\" ALT=\"$gcolor[0]\"></TD>\n";
	  print FOUT "<TD ALIGN=LEFT>&nbsp; $L{'Number_of'} ";
	  print FOUT "$L{'requests'}" if ($ftp_format == 0 && $mail_format == 0);
	  print FOUT "$L{'files'}" if ($ftp_format == 1);
	  print FOUT "$L{'emails'}" if ($mail_format == 1);
	  print FOUT "</TD>\n";
	  print FOUT "</TR>\n";

	  if ($spam_on == 1 || $spam_found != 0) {
	      print FOUT "<TR>\n";
	      print FOUT "<TD><IMG WIDTH=$square HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"></TD>\n";
	      print FOUT "<TD ALIGN=LEFT>&nbsp; $L{'Number_of'} $L{'spam'}</TD>\n";
	      print FOUT "</TR>\n";
	  }

	  if ($ftp_format == 0 && $mail_format == 0 && $dhcp_format == 0) {
	      print FOUT "<TR>\n";
	      print FOUT "<TD><IMG WIDTH=$square HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"></TD>\n";
	      print FOUT "<TD ALIGN=LEFT>&nbsp; $L{'Number_of'} $L{'accesses'}</TD>\n";
	      print FOUT "</TR>\n";
	  }
	  print FOUT "<TR>\n";
	  print FOUT "<TD><IMG WIDTH=$square HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"></TD>\n";
	  print FOUT "<TD ALIGN=LEFT>&nbsp; $L{'Number_of'} $L{'Conn_Mach'}</TD>\n";
	  print FOUT "</TR>\n</TABLE>\n";
	  print FOUT "</TD>\n</TR>\n";        
	  print FOUT "</TABLE>\n</CENTER>\n";
      }
  }
  }
  print FOUT "<!-- end_insert_map -->\n" if ($scriptname eq "cron-pages.pl" || $scriptname eq "cron-inc.pl");

  print FOUT "</TD>\n</TR></TABLE>\n";

  print FOUT "<P>\n";
  print FOUT "</BODY></HTML>\n";
}


sub PageResumeMenu {
  local(*FOUT,$link_next,*L) = @_;
  local($tmp,$tmpa,$linkcheck_prev,$linkcheck_next,$wday);
  local($tmp1,$tmp2,$tmp3,$tmp4,$tmp5,$tmp6,$tmp7);
  local($val1,$val2,$linkarrow,$count_block);

  $tmpa = $dirresume;
  $tmpa = $oldjour if ($scriptname eq "cron-pages.pl");
  $tmpa = $yesterday if ($scriptname eq "cron-inc.pl");
  $tmpa =~ s/\/\-/ /g;
  $tmpa =~ s/\_/ \/ /g;

  if ($file_to_open ne '') {
      $linkarrow = $file_to_open;
      $linkarrow =~ s/$path$lang[$nblang]$dirsepurl$dirdate$dirsepurl$dirresume$dirsepurl//i if ($mode_web == 0);
      $linkarrow =~ s/$path$dirtmp$dirsepurl$lang[$nblang]$dirsepurl$dirresume$dirsepurl//i if ($mode_web == 1);
  } else {
      $linkarrow = $menu;
  }

  $tmp2 = $tmpa;

  # Default date
#  $tmp = $dirresume;
  ($tmp4,$tmp5,$tmp6) = split(/-/,$dirresume);
  $tmp = $tmp6." ".$tmp5." ".$tmp4;	  

  if ($link_next eq "Undefined") {
      $nextdayresume = "<!-- date_next_undefined -->";
      $previousdayresume = "<!-- date_previous_undefined -->";
      $linkcheck_prev = '';
      $tmp3 = 1;
  }

  if ($scriptname ne "dayrange.pl" && $scriptname ne "cron-week.pl" && $scriptname ne "cron-month.pl" && $scriptname ne "cron-year.pl") {
      if ($tmp2 !~ /^\d{1,2}[\s+\/\-]/) {
	  ($tmp11,$tmp12,$tmp13) = split(/-/,$tmpa);
	  $tmp2 = $tmp13."-".$tmp12."-".$tmp11;	  
      }
      $tmp_wod = (localtime(&nbday("$tmp2")*86400))[6];
      $wday = $day_of_week[$tmp_wod];
  }

  if ($scriptname eq "cron-week.pl" || $scriptname eq "dayrange.pl") {
      $tmp = $dirresume;
      $tmp =~ s/\-/ /g;
      $tmp =~ s/\_/ \/ /g;
      ($tmp1,$tmp2) = split(/_/,$dirresume);

      ($tmp4,$tmp5,$tmp6) = split(/-/,$tmp1);

      $tmp = "$tmp6 $tmp5 $tmp4"; 

      $tmp7 = "$tmp6/$tmp5/$tmp4";
      $tmp7 = &date_intervalle($tmp7,-1);
      ($tmp4,$tmp5,$tmp6) = split(/\s+/,$tmp7);
      $val1 = "$tmp6-$tmp5-$tmp4";

      ($tmp4,$tmp5,$tmp6) = split(/-/,$tmp1);
      $tmp7 = "$tmp6/$tmp5/$tmp4";
      $tmp7 = &date_intervalle($tmp7,-7);
      ($tmp4,$tmp5,$tmp6) = split(/\s+/,$tmp7);
      $val2 = "$tmp6-$tmp5-$tmp4";
      $previousdayresume = "\.\.$dirsepurl".$val2."_".$val1."$dirsepurl$linkarrow";

      $linkcheck_prev = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$val2."_".$val1."$dirsepurl$linkarrow";

      if ($tmp2 ne '') {
	  ($tmp4,$tmp5,$tmp6) = split(/-/,$tmp2);

#      $tmp .= " / $day_of_week[--$tmp_wod] $tmp6 $tmp5 $tmp4"; 
	  $tmp .= " / $tmp6 $tmp5 $tmp4"; 
      }

      $tmp7 = "$tmp6/$tmp5/$tmp4";
      $tmp7 = &date_intervalle($tmp7,1);
      ($tmp4,$tmp5,$tmp6) = split(/\s+/,$tmp7);
      $val1 = "$tmp6-$tmp5-$tmp4";

      ($tmp4,$tmp5,$tmp6) = split(/-/,$tmp2);
      $tmp7 = "$tmp6/$tmp5/$tmp4";
      $tmp7 = &date_intervalle($tmp7,7);
      ($tmp4,$tmp5,$tmp6) = split(/\s+/,$tmp7);
      $val2 = "$tmp6-$tmp5-$tmp4";
      $nextdayresume = "\.\.$dirsepurl".$val1."_".$val2."$dirsepurl$linkarrow";

      $linkcheck_next = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$val1."_".$val2."$dirsepurl$linkarrow";

  }

  if ($scriptname eq "cron-month.pl") {
      $tmp = $dirresume;
      $tmp =~ s/\-/ /g;
      ($val1,$val2) = split(/-/,$dirresume);

      $tmp = "$val2 $val1";

      $tmp2 = $month_equiv{$val2};
      $tmp3 = $tmp2;
      $tmp3--;
      if ($tmp3 < 1) {
	  $tmp3 = 12;
	  $val1--;
      }
      $val2 = $month_nb[$tmp3-1];
      $previousdayresume = "\.\.$dirsepurl".$val1."-".$val2."$dirsepurl$linkarrow";
      $linkcheck_prev = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$val1."-".$val2."$dirsepurl$linkarrow";

      ($val1,$val2) = split(/-/,$dirresume);

      $tmp3 = $tmp2;
      $tmp3++;
      if ($tmp3 > 12) {
	  $tmp3 = 1;
	  $val1++;
      }
      $val2 = $month_nb[$tmp3-1];
      $nextdayresume = "\.\.$dirsepurl".$val1."-".$val2."$dirsepurl$linkarrow";
      $linkcheck_next = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$val1."-".$val2."$dirsepurl$linkarrow";
  }

  if ($scriptname eq "cron-year.pl") {
      $tmp = $dirresume;
      $val1 = $dirresume-1;
      $val2 = $dirresume+1;
      $linkcheck_prev = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$val1.$dirsepurl.$linkarrow;
      $linkcheck_next = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$val2.$dirsepurl.$linkarrow;
      $previousdayresume = "\.\.$dirsepurl".$val1."$dirsepurl$linkarrow";
      $nextdayresume = "\.\.$dirsepurl".$val2."$dirsepurl$linkarrow";
  }


  if ($scriptname eq "cron-pages.pl" || $scriptname eq "cron-refer.pl" || $scriptname eq "cron-agent.pl" ) {
#  if ($scriptname eq "cron-pages.pl") {
      $tmp = $oldjour;
      $tmp =~ s/\// /g;

#      print "A $oldoldjour - $oldjour - $jour\n";

      $jour = &date_intervalle($oldjour,1) if ($oldjour eq $jour);

      ($tmp1,$tmp2,$tmp3) = split(/ /,$jour);
      $nextdayresume = "\.\.$dirsepurl".$tmp3."-".$tmp2."-".$tmp1."$dirsepurl$linkarrow";
      
      $oldoldjour = &date_intervalle($oldjour,-1) if ($oldoldjour eq '');

      ($tmp1,$tmp2,$tmp3) = split(/ /,$oldoldjour);
      $previousdayresume = "\.\.$dirsepurl".$tmp3."-".$tmp2."-".$tmp1."$dirsepurl$linkarrow";

#      print "AA $previousdayresume - $oldoldjour -  $oldjour - $jour - $yesterday - $tmp3 - $linkcheck_prev\n";

#      print "PP $previousdayresume - $nextdayresume\n";
  }

  if ($scriptname eq "cron-inc.pl") {
      $tmp = $yesterday;
      $tmp =~ s/\// /g;

      ($tmp1,$tmp2,$tmp3) = split(/\//,$nextjour);
      $nextdayresume = "\.\.$dirsepurl".$tmp3."-".$tmp2."-".$tmp1."$dirsepurl$linkarrow";

      ($tmp1,$tmp2,$tmp3) = split(/\//,$previousjour);
      $previousdayresume = "\.\.$dirsepurl".$tmp3."-".$tmp2."-".$tmp1."$dirsepurl$linkarrow";
  }

  print FOUT "<TABLE WIDTH=\"100%\">";
  print FOUT "<TR>\n";

  print FOUT "<!-- begin_daily_menu -->\n";

  print FOUT "<TD VALIGN=TOP WIDTH=\"240\">\n";
  print FOUT "<CENTER>\n";

  print FOUT "<H3 CLASS=\"center\">$wday $tmp</H3>\n";
  print FOUT "<P><TABLE CELLPADDING=2 CELLSPACING=2>\n<TR>\n";
  print FOUT "<TD ALIGN=CENTER COLSPAN=3>";
#  print FOUT "<A HREF=\"..$dirsepurl$filenameday\">" if ($scriptname eq "cron-pages.pl" || $scriptname eq "cron-inc.pl" || $scriptname eq "cron-hour.pl");
  if ($scriptname eq "cron-week.pl") {
      print FOUT "<A HREF=\"..$dirsepurl$statnameweek\">";
  } elsif ($scriptname eq "cron-month.pl") {
      print FOUT "<A HREF=\"..$dirsepurl$statnamemonth\">";
  } elsif ($scriptname eq "cron-year.pl") {
      print FOUT "<A HREF=\"..$dirsepurl$statnameyear\">";
  } elsif ($scriptname eq "dayrange.pl") {
      print FOUT "<A HREF=\"..$dirsepurl..$dirsepurl..$dirsepurl$lang[$nblang]$dirsepurl$dirdate$dirsepurl$filenameday\">";
  } else {
      print FOUT "<A HREF=\"..$dirsepurl$filenameday\">";
  }
  print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_flecheh\" WIDTH=\"16\" HEIGHT=\"16\" BORDER=0 ALT=\"up_arrow\"></A>";
  print FOUT "</TD>\n</TR>\n<TR>\n";
  print FOUT "<TD CLASS=\"right\"><!-- date_in -->";
#  print  "BB - $previousdayresume - $linkcheck_prev - $tmp3 \n";
  print FOUT "<A HREF=\"$previousdayresume\"><!-- PREVIOUS \"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_flecheg\" WIDTH=\"16\" HEIGHT=\"16\" BORDER=0 ALT=\"left_arrow\">--></A>" if ($tmp3 ne '' && $linkcheck_prev eq '');
  print FOUT "<A HREF=\"$previousdayresume\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_flecheg\" WIDTH=\"16\" HEIGHT=\"16\" BORDER=0 ALT=\"right_arrow\"></A>" if ($linkcheck_prev ne '' && -f $linkcheck_prev);
  print FOUT "</TD>\n";
#  print FOUT "<TD><A HREF=\"$filemoyenne\">- $L{'Summary'} -</A></TD>\n";
  print FOUT "<TD><A HREF=\"$menu\">- $L{'Summary'} -</A></TD>\n";
  print FOUT "<TD CLASS=\"left\"><!-- date_out -->";
#  print FOUT "BB - $nextdayresume - $linkcheck_next - $link_next \n";
  print FOUT "<A HREF=\"$nextdayresume\"><!-- NEXT \"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_fleched\" WIDTH=\"16\" HEIGHT=\"16\" BORDER=0 ALT=\"right_arrow\">--></A>\n" if ($linkcheck_next eq '');
#  print FOUT "<A HREF=\"$nextdayresume\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_fleched\" WIDTH=\"16\" HEIGHT=\"16\" BORDER=0 ALT=\"right_arrow\"></A>\n" if (-f $linkcheck_next && $link_next == 0);
  print FOUT "<A HREF=\"$nextdayresume\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_fleched\" WIDTH=\"16\" HEIGHT=\"16\" BORDER=0 ALT=\"right_arrow\"></A>\n" if ($linkcheck_next ne '' && $link_next == 0);
  print FOUT "</TD></TR>\n</TABLE>\n</CENTER>\n";

  print FOUT "<P>\n";
  print FOUT "<CENTER>\n<TABLE CELLPADDING=4 CELLSPACING=4>\n";
  
### Hosts, Pages

  print FOUT "<TR>\n";
  print FOUT "<TD ALIGN=CENTER>";
  print FOUT "<A HREF=\"$dirsite$htmlext\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_hosts\" BORDER=0 ALT=\"hosts\"></A>";
  print FOUT "<BR><A HREF=\"$dirsite$htmlext\">$L{'Hosts'}</A>\n";
  print FOUT "</TD>\n";
  print FOUT "<TD ALIGN=CENTER>";
  print FOUT "<A HREF=\"$dirpage$htmlext\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_pages\" BORDER=0 ALT=\"pages\"></A>";
  print FOUT "<BR><A HREF=\"$dirpage$htmlext\">$L{'Pages'}</A>\n";
  print FOUT "</TD>\n";

  print FOUT "</TR>\n<TR>\n";

### Countries
  
  if ($paysuniquejour != 0 || -f "$path$lang[$nblang]$dirsep$dirdate$dirsep$dirresume$dirsep$dirpays$htmlext") {
      $count_block++;
      print FOUT "<TD ALIGN=CENTER>";
      print FOUT "<A HREF=\"$dirpays$htmlext\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_countries\" BORDER=0 ALT=\"Countries\"></A>";
      print FOUT "<BR><A HREF=\"$dirpays$htmlext\">$L{'Countries'}</A>";
      print FOUT "</TD>\n";
  }

### Directories

  if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
      $count_block++;
      print FOUT "<TD ALIGN=CENTER>";
      print FOUT "<A HREF=\"$dirlist$htmlext\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_dir\" BORDER=0 ALT=\"dir\"></A>";
      print FOUT "<BR><A HREF=\"$dirlist$htmlext\">$L{'Directories'}</A>";
      print FOUT "</TD>\n";
  }

  if ($count_block == 2) {
      print FOUT "</TR>\n";
      print FOUT "<TR>\n";
      $count_block = 0;
  }

### Scripts

  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
      $count_block++;
      print FOUT "<TD ALIGN=CENTER>";
      print FOUT "<A HREF=\"$dirscript$htmlext\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_script\" BORDER=0 ALT=\"script\"></A>";
      print FOUT "<BR><A HREF=\"$dirscript$htmlext\">$L{'Scripts'}</A>";
      print FOUT "</TD>\n";
  }

  if ($count_block == 2) {
      print FOUT "</TR>\n";
      print FOUT "<TR>\n";
      $count_block = 0;
  }


### Filetype

  if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
      $count_block++;
      print FOUT "<TD ALIGN=CENTER>";
      print FOUT "<A HREF=\"$filetype$htmlext\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_filetype\" BORDER=0 ALT=\"filetype\"></A>";
      print FOUT "<BR><A HREF=\"$filetype$htmlext\">$L{'Filetype'}</A>";
      print FOUT "</TD>\n";
  }

  if ($count_block == 2) {
      print FOUT "</TR>\n";
      print FOUT "<TR>\n";
      $count_block = 0;
  }

### Trafic

  if ($notrafic == 0) {
      $count_block++;
      print FOUT "<TD ALIGN=CENTER>";
      print FOUT "<A HREF=\"$dirtraffic$htmlext\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_traffic\" BORDER=0 ALT=\"traffic\"></A>\n";
      print FOUT "<BR><A HREF=\"$dirtraffic$htmlext\">$L{'Traffic'}</A>";
      print FOUT "</TD>";
  }

  if ($count_block == 2) {
      print FOUT "</TR>\n";
      print FOUT "<TR>\n";
      $count_block = 0;
  }


### Search engine

  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
      $count_block++;
      print FOUT "<!-- SKIP_REFER_BEGIN -->\n";
      print FOUT "<TD ALIGN=CENTER>";
      if (-e "$path$lang[$nblang]$dirsep$dirdate$dirsep$dirresume$dirsep$tabnamekeyword" || -e "$path$dirtmp$dirsep$lang[$nblang]$dirsep$dirresume$dirsep$tabnamekeyword") {
	  print FOUT "<A HREF=\"$tabnamekeyword\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_spider\" WIDTH=\"40\" HEIGHT=\"40\" BORDER=0 ALT=\"spider\"></A>\n";
	  print FOUT "<BR><A HREF=\"$tabnamekeyword\">$L{'Search_engine'}</A>\n";
      } else {
	  print FOUT "<A HREF=\"$tabnamekeyword\"><!-- REFER \"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_spider\" WIDTH=\"40\" HEIGHT=\"40\" BORDER=0 ALT=\"spider\">--></A>\n";
	  print FOUT "<BR><A HREF=\"$tabnamekeyword\"><!-- REFER2 $L{'Search_engine'} --></A>\n";
      }
      print FOUT "</TD>\n";
      print FOUT "<!-- SKIP_REFER_END -->\n";
  }

### Refer

  if ($count_block == 2) {
      print FOUT "</TR>\n";
      print FOUT "<TR>\n";
      $count_block = 0;
  }

  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
      $count_block++;
      print FOUT "<!-- SKIP_REFER_BEGIN -->\n";
      print FOUT "<TD ALIGN=CENTER>";
      if (-e "$path$lang[$nblang]$dirsep$dirdate$dirsep$dirresume$dirsep$refer" || -e "$path$dirtmp$dirsep$lang[$nblang]$dirsep$dirresume$dirsep$refer") {
	  print FOUT "<A HREF=\"$refer\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_refer\" BORDER=0 ALT=\"refer\"></A>\n";
	  print FOUT "<BR><A HREF=\"$refer\">$L{'Referer'}</A>\n";
      } else {
	  print FOUT "<A HREF=\"$refer\"><!-- REFER \"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_refer\" WIDTH=\"40\" HEIGHT=\"40\" BORDER=0 ALT=\"refer\">--></A>\n";
	  print FOUT "<BR><A HREF=\"$refer\"><!-- REFER2 $L{'Referer'} --></A>\n";
      }
      print FOUT "</TD>\n";
      print FOUT "<!-- SKIP_REFER_END -->\n";
  }

  if ($count_block == 2) {
      print FOUT "</TR>\n";
      print FOUT "<TR>\n";
      $count_block = 0;
  }

### Agent

  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
      $count_block++;
      print FOUT "<!-- SKIP_AGENT_BEGIN -->\n";
      print FOUT "<TD ALIGN=CENTER>";
      if (-e "$path$lang[$nblang]$dirsep$dirdate$dirsep$dirresume$dirsep$agent" || -e "$path$dirtmp$dirsep$lang[$nblang]$dirsep$dirresume$dirsep$agent") {
	  print FOUT "<A HREF=\"$agent\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_agent\" WIDTH=\"40\" HEIGHT=\"40\" BORDER=0 ALT=\"agent\"></A>\n";
	  print FOUT "<BR><A HREF=\"$agent\">$L{'Browsers'}</A>\n";
      } else {
	  print FOUT "<A HREF=\"$agent\"><!-- AGENT \"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_agent\" WIDTH=\"40\" HEIGHT=\"40\" BORDER=0 ALT=\"agent\">--></A>\n";
	  print FOUT "<BR><A HREF=\"$agent\"><!-- AGENT2 $L{'Browsers'} --></A>\n";
      }
      print FOUT "</TD>\n";
      print FOUT "<!-- SKIP_AGENT_END -->\n";
  }

  if ($count_block == 2) {
      print FOUT "</TR>\n";
      print FOUT "<TR>\n";
      $count_block = 0;
  }

### Spam

  if ($mail_format == 1 && $spam_found != 0) {
      $count_block++;
      print FOUT "<!-- SKIP_SPAM_BEGIN -->\n";
      print FOUT "<TD ALIGN=CENTER>\n";
      print FOUT "<A HREF=\"$spam$htmlext\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_spam\" BORDER=0 ALT=\"session\"></A>\n";
      print FOUT "<BR><A HREF=\"$spam$htmlext\">$L{'Spam'}</A>\n";
      print FOUT "</TD>\n";
      print FOUT "<!-- SKIP_SPAM_END -->\n";
  }

  if ($count_block == 2) {
      print FOUT "</TR>\n";
      print FOUT "<TR>\n";
      $count_block = 0;
  }

### Session

  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
      $count_block++;
      print FOUT "<!-- SKIP_SESSION_BEGIN -->\n";
      print FOUT "<TD ALIGN=CENTER>\n";
      if (-e "$path$lang[$nblang]$dirsep$dirdate$dirsep$dirresume$dirsep$dirsession$htmlext") {
	  print FOUT "<A HREF=\"$dirsession$htmlext\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_session\" BORDER=0 ALT=\"session\"></A>\n";
	  print FOUT "<BR><A HREF=\"$dirsession$htmlext\">$L{'Sessions'}</A>\n";
      } else {
	  print FOUT "<A HREF=\"$dirsession$htmlext\"><!-- SESSION \"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_session\" WIDTH=\"40\" HEIGHT=\"40\" BORDER=0 ALT=\"session\">--></A>\n";
	  print FOUT "<BR><A HREF=\"$dirsession$htmlext\"><!-- SESSION2 $L{'Sessions'} --></A>\n";
      }
      print FOUT "</TD>\n";
      print FOUT "<!-- SKIP_SESSION_END -->\n";
  }

  if ($count_block == 2) {
      print FOUT "</TR>\n";
      print FOUT "<TR>\n";
      $count_block = 0;
  }

### Users

  if ($inc_user == 1) {
  print FOUT "<!-- SKIP_USERS_BEGIN -->\n";
  print FOUT "<TD ALIGN=CENTER>";
  $count_block++;
  if ($nb_userday != 0 || -f "$path$lang[$nblang]$dirsep$dirdate$dirsep$dirresume$dirsep$users$htmlext") {
      print FOUT "<A HREF=\"$users$htmlext\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_users\" WIDTH=\"40\" HEIGHT=\"40\" BORDER=0 ALT=\"user\"></A>\n";
      print FOUT "<BR><A HREF=\"$users$htmlext\">$L{'Users'}</A>\n";
  } else {
      print FOUT "<A HREF=\"$users$htmlext\"><!-- USERS \"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_users\" WIDTH=\"40\" HEIGHT=\"40\" BORDER=0 ALT=\"user\">--></A>\n";
      print FOUT "<BR><A HREF=\"$users$htmlext\"><!-- USERS2 $L{'Users'} --></A>\n";
  }

  print FOUT "</TD>\n";
  print FOUT "<!-- SKIP_USERS_END -->\n";

  if ($count_block == 2) {
      print FOUT "</TR>\n";
      print FOUT "<TR>\n";
      $count_block = 0;
  }
  }

### Destination

  if ($squid_format == 1 || $cups_format == 1 || $dhcp_format == 1) {
      $count_block++;
      print FOUT "<TD ALIGN=CENTER>";
      if ($dailydest_unique != 0) {
	  print FOUT "<A HREF=\"$filevirtual\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_destination\" WIDTH=\"40\" HEIGHT=\"40\" ALT=\"destination\" BORDER=0></A>\n";
	  print FOUT "<BR><A HREF=\"$filevirtual\">$L{'Destination'}</A>\n";
      } else {
	  print FOUT "<A HREF=\"$filevirtual\"><!-- DEST \"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_destination\" WIDTH=\"40\" HEIGHT=\"40\" ALT=\"destination\" BORDER=0>--></A>\n";
	  print FOUT "<BR><A HREF=\"$filevirtual\"><!-- DEST2 $L{'Destination'} --></A>\n";
      }
      print FOUT "</TD>\n";
  }

  if ($count_block == 2) {
      print FOUT "</TR>\n";
      print FOUT "<TR>\n";
      $count_block = 0;
  }

### Hours

  ($tmp,$monthletter) = split(/ /,$yesterday);

  $linkjour = $filenamehour;
  $fulljour = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$dirresume.$dirsep.$filenamehour;

  $count_block++;
  print FOUT "<TD ALIGN=CENTER>";
  if (-e $fulljour) {
      print FOUT "<A HREF=\"$linkjour\"><IMG WIDTH=\"40\" HEIGHT=\"40\" SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_hours\" BORDER=0 ALT=\"hours\"></A>\n";
      print FOUT "<BR><A HREF=\"$linkjour\">$L{'Hours'}</A>\n";
  } else {
      print FOUT "<A HREF=\"$linkjour\"><!-- HOUR \"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_hours\" WIDTH=\"40\" HEIGHT=\"40\" BORDER=0 ALT=\"hours\">--></A>\n";
      print FOUT "<BR><A HREF=\"$linkjour\"><!-- HOUR2 $L{'Hours'} --></A>\n";
  }
  print FOUT "</TD>\n";

  if ($count_block == 2) {
      print FOUT "</TR>\n";
      print FOUT "<TR>\n";
      $count_block = 0;
  }

### Virus

  if ($inc_virus == 1 && $nb_virus != 0) {
      $count_block++;
      print FOUT "<TD ALIGN=CENTER>";
      print FOUT "<A HREF=\"$filevirus\"><!-- VIRUS \"..$dirsepurl..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_virus\" WIDTH=\"40\" HEIGHT=\"40\" ALT=\"virus\" BORDER=0>--></A>\n";
      print FOUT "<BR><A HREF=\"$filevirus\"><!-- VIRUS2 $L{'Virus'} --></A>\n";
      print FOUT "</TD>\n";
  }

#  if ($count_block == 2) {
#      print FOUT "</TR>\n";
#      print FOUT "<TR>\n";
#      $count_block = 0;
#  }

  print FOUT "</TR></TABLE></CENTER>\n";

  print FOUT "<!-- end_daily_menu -->\n";

  print FOUT "<TD VALIGN=TOP>\n";


}

###

sub PageResumePays {
  local(*FOUT,*L,$I,$display_all) = @_;
  local ($pays,$j,$percentage,$percentageint);
  local($tmp3);

  $tmpa = $dirresume;
  $tmpa = $oldjour if ($scriptname eq "cron-pages.pl");
  $tmpa = $yesterday if ($scriptname eq "cron-inc.pl");
  $tmpa =~ s/\/\-/ /g;
  $tmpa =~ s/\_/ \/ /g;

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
#  print FOUT "<TITLE>$L{'Stats'} - Summary report $L{'Countries'} - $oldjour</TITLE>\n";
  print FOUT "<TITLE>$L{'Countries'} - $tmpa</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,3);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd2 TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,3);


#  print FOUT "<TABLE WIDTH=\"100%\"><TR><TD VALIGN=TOP>\n";

  &PageResumeMenu(*FOUT, $link_next, eval($Lang{$lang[$nblang]}),$I);

#  print FOUT "</TD>\n<TD VALIGN=TOP>\n";

  print FOUT "<H3> $L{'Countries'} $L{'connecting_to_the_server'}</H3><P>\n";

  $tmp = $paysuniquejour;
#  $tmp = keys(%paysjour);

#  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} ";
#  print FOUT "$topten" if ($topten < $paysuniquejour);
#  print FOUT "$paysjourlist{$paystmp}" if ($topten >= $paysuniquejour);
#  print FOUT " $L{'top'} $L{'resolved_countries'} ($L{'among'} $paysuniquejour)</DIV>\n";

  if ($show_all == 1) {
      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $tmp $L{'countries'}" if ($display_all == 1);
      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $topten $L{'countries'} ($L{'among'} $tmp)" if ($display_all == 0);
      print FOUT "&nbsp;<A HREF=\"$listdailycountries$htmlext\">$L{'Full_list'}</A>" if ($display_all == 0 && $tmp > $topten);
      print FOUT "</DIV>\n";
  }

  if ($show_all == 0) {
      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $tmp $L{'countries'}</DIV>\n";
#      print FOUT "<P><I>($L{'Only_countries'} $L{'with_at_least'} $seuilsite $L{'requests'} $L{'are_shown'})</I><P>\n" if ($seuilsite > 1);
  }

  print FOUT "\n<p><table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Countries'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Requests'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  }
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";
  
  $j = 0;
  foreach $pays (&reverse_sort_by_value(*paysjour)) {
      if ($precision > 3) {
	  $tmp3 = $path;
	  $tmp3 .= $dirtmp.$dirsep if ($mode_web == 1);
	  $tmp3 .= $lang[$nblang].$dirsep;
	  $tmp3 .= $dirdate.$dirsep if ($mode_web == 0);
	  $tmp3 .= $dirresume.$dirsep.$pays.$htmlext;
#	  print "Opening $tmp3\n";
	  $file_to_open = $tmp3;
#	  open(FILERESUMEPAYSHOST,">$tmp3") || die "Error, unable to open $tmp3\n";
	  open(FILERESUMEPAYSHOST,">$file_to_open") || die "Error, unable to open $file_to_open\n";
	  &PageResumePaysHosts(*FILERESUMEPAYSHOST, $Lang{$lang[$nblang]},$I,$pays);
	  close(FILERESUMEPAYSHOST);
#	  open(FILERESUMEPAYSHOSTALL,">$path$lang[$nblang]$dirsep$dirdate$dirsep$dirresume$dirsep$pays$txtext") || die "Error, unable to open $path$lang[$nblang]$dirsep$dirdate$dirsep$dirresume$dirsep$pays$txtext\n";
#	  &PageResumePaysHosts(*FILERESUMEPAYSHOSTALL, $Lang{$lang[$nblang]},$pays,$display_all);
#	  close(FILERESUMEPAYSHOSTALL);
      }
#      if ($display_all == 0 || ($display_all == 1 && $paysjour{$pays} > $seuilsite)) {
      $percentage = $paysjour{$pays}*100/$reqtotjour if ($reqtotjour != 0);
	  $percentageint = int($percentage/3);
	  print FOUT "<TR>";
	  print FOUT "<TD CLASS=\"left\">";
	  print FOUT "<A HREF=\"$pays$htmlext\">" if ($precision > 3);
	  if (-f "$pathinit$dirress$dirsep$dirflags$dirsep$pays$gifext") {
	      print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirflags$dirsepurl$pays$gifext\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=0 ALT=\"$pays\">";
	  } else {
	      $tmp2 = "Unknown";
	      print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirflags$dirsepurl$tmp2$gifext\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=0 ALT=\"$tmp2\">";
	  }
	  print FOUT "</A>" if ($precision > 3);
	  print FOUT "&nbsp;";
	  print FOUT "<A HREF=\"$pays$htmlext\">" if ($precision > 3);
	  if (-f "$pathinit$dirress$dirsep$dirflags$dirsep$pays$gifext") {
	      print FOUT "$L{$newflag{$pays}}";
	  } else {
	      print FOUT "$tmp2 <I>($pays)</I>";
	  }
	  print FOUT "</A>" if ($precision > 3);
	  print FOUT "</TD>\n<TD CLASS=\"right\">$paysjour{$pays}</TD><TD CLASS=\"left\">";
	  print FOUT "<IMG WIDTH=$percentageint HEIGHT=\"$square\" SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($percentageint != 0);
	  printf FOUT "%.1f %</TD>\n",$percentage if ($percentage != 100);
	  print FOUT "$percentage %</TD>\n" if ($percentage == 100);
   
	  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {   
	      $payshtmljour{$pays} = 0 if ($payshtmljour{$pays} eq '');
	      $percentage = $payshtmljour{$pays}*100/$accessjour if ($accessjour != 0);
	      $percentage = 0 if ($accessjour == 0);
	      $percentageint = int($percentage/3);
	      print FOUT "<TD CLASS=\"right\">$payshtmljour{$pays}</TD>\n<TD CLASS=\"left\">";
	      print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"> " if ($percentageint != 0);
	      printf FOUT "%.1f %</TD>\n",$percentage if ($percentage != 100);
	      print FOUT "$percentage %</TD>\n" if ($percentage == 100);
	  }

	  $percentage = $paysjourlist{$pays}*100/$serveruniquejour if ($serveruniquejour != 0);
	  $percentageint = int($percentage/3);
	  print FOUT "<TD CLASS=\"right\">$paysjourlist{$pays}</TD>\n<TD CLASS=\"left\">\n"; 
	  print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[4]\" ALT=\"$gcolor[4]\"> " if ($percentageint != 0);
	  printf FOUT "%.1f %</TD>\n",$percentage if ($percentage != 100);
	  print FOUT "$percentage %</TD>\n" if ($percentage == 100);
	  $j++;
	  last if ($j == $topten && $display_all == 0);
#      }
  }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n";
  print FOUT "<P><BR>\n";

  print FOUT "</TD>\n</TR>\n</TABLE>\n";

  print FOUT "</BODY></HTML>\n";
}

####

sub PageResumePaysHosts {
  local(*FOUT,*L,$I,$paystmp) = @_;
  local($adresse,$tmp,$i,$j,$pays,$percentage,$extpays);

  $tmpa = $dirresume;
  $tmpa = $oldjour if ($scriptname eq "cron-pages.pl");
  $tmpa = $yesterday if ($scriptname eq "cron-inc.pl");
  $tmpa =~ s/\/\-/ /g;
  $tmpa =~ s/\_/ \/ /g;

  $extpays = substr($localdomainename,(rindex($localdomainename,'.')+1),length($localdomaine));

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Countries'} - $newflag{$paystmp} - $tmpa</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\">\n";
  print FOUT "function ToggleMenuAll(obj) {\n";
  print FOUT " var elementsDIV = document.getElementsByTagName('div');\n";
  print FOUT "	for (var i = 0; i < elementsDIV.length; i++) {\n";
  print FOUT "     var el = elementsDIV[i].id;\n";
  print FOUT "     if (el.indexOf(\"TOGGLE_\") != -1) {\n";
  print FOUT "     elementsDIV[i].style.display  = (elementsDIV[i].style.display != 'none' ? 'none' : 'inline');\n";
  print FOUT "     }\n";
  print FOUT "	}\n";
  print FOUT "}\n";
  print FOUT "function ToggleMenuAll2(obj) {\n";
  print FOUT " var elementsDIV = document.getElementsByTagName('div');\n";
  print FOUT "	for (var i = 0; i < elementsDIV.length; i++) {\n";
  print FOUT "     var el = elementsDIV[i].id;\n";
  print FOUT "     if (el.indexOf(\"TOGGLE2_\") != -1) {\n";
  print FOUT "     elementsDIV[i].style.display  = (elementsDIV[i].style.display != 'none' ? 'none' : 'inline');\n";
  print FOUT "     }\n";
  print FOUT "	}\n";
  print FOUT "}\n";
  print FOUT "function ToggleMenu(obj) {\n";
  print FOUT "target = document.getElementById(obj);\n";
  print FOUT "if (target.style.display == \"none\"){\n";
  print FOUT "target.style.display = \"inline\";\n";
  print FOUT "} else {\n";
  print FOUT "target.style.display = \"none\";\n";
  print FOUT "}\n";
  print FOUT "}\n";
  print FOUT "</SCRIPT>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,3);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd2 TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,3);

  &PageResumeMenu(*FOUT, $link_next, eval($Lang{$lang[$nblang]}),$I);

  print FOUT "<H3> $L{'Hosts'} $L{'connecting_to_the_server'}";
  print FOUT " - <IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirflags$dirsepurl$paystmp$gifext\" WIDTH=14 HEIGHT=\"14\" BORDER=0 ALT=\"$paystmp\">" if (-f "$pathinit$dirress$dirsep$dirflags$dirsep$paystmp$gifext");
  print FOUT " - $newflag{$paystmp}</H3><P>\n";

  $tmp = $paysjourlist{$paystmp}-$locserverjour;
  if ($tmp != 0) {

#      $tmp = $serverjour{(&reverse_sort_by_value(*serverjour))[0]};

# Afficher $min_count_file_final si < $topten et $min_count_file_final > lastvaluedisplayed de $serverjour{$adresse}

  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} ";
  print FOUT "$topten" if ($topten < $paysjourlist{$paystmp});
#  print FOUT "$paysjourlist{$paystmp}" if ($topten >= $paysjourlist{$paystmp});
#  print FOUT " $L{'top_external_sites'} ($L{'among'} $paysjourlist{$paystmp})</DIV>\n";
  print FOUT "$tmp" if ($topten >= $tmp);
  print FOUT " $L{'top_external_sites'} ($L{'among'} $tmp)</DIV>\n";
#  print FOUT "<P><I>($L{'The_Top'} $display_subitem $L{'pages'} $L{'are_shown'})</I>\n<P>" if ($scriptname !~ /cron-pages/ && $scriptname !~ /cron-inc/);
  print FOUT "<P><I>($L{'The_Top'} $display_subitem $L{'pages'} $L{'are_shown'})</I>\n<P>" if ($display_subitem != 0);
  print FOUT "\n<p><table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH><A HREF=\"javascript:ToggleMenuAll('Toggle_all');\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$toggle_on\" NAME=\"ima_toggle\" BORDER=0 WIDTH=\"12\" HEIGHT=\"21\" TITLE=\"$L{'Click_here'}\" ALT=\"toggle\"></A></TH>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Cities'}&nbsp;</TH>\n" if ($geoipcity == 1);
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Requests'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  }
  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Different_accesses'}&nbsp;</TH>\n";
  if ($notrafic == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  }
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";

  $i = 0;
  foreach $adresse (&reverse_sort_by_value(*serverjour)) {
#      $adresse = $reverseadressehad[$adresse] if ($adresse =~ /^\d+$/);
#      print "PP $adresse\n"; # if ($adresse =~ /ro$/);
     if ($adresse !~ /$localdomainename$/i && $localdomainename ne '') {
#	  $pays = substr($adresse,rindex($adresse,'.')+1,length($adresse));
#	  $pays = $pays_ip{$adresse} if ($adresse =~ /[0-9]+$/ && $reverse_geo == 1);
	  if (($adresse =~ /[0-9]+$/ || $adresse =~ /:/) && $reverse_geo == 1) {
	      $pays = $pays_ip{$adresse};
	  } else {
	      $pays = substr($adresse,rindex($adresse,'.')+1,length($adresse));
	  }
#	  print "PP $pays - $adresse\n" if ($pays eq "ro");
	  $pays = $city_pays{$adresse} if ($geoipcity == 1);
#	  $pays = "Unknown" if (($pays =~ /\d/ || $adresse =~ /\:\d\d\:/) && $reverse_geo == 0);
	  $pays = "Unknown" if (($adresse =~ /[0-9]+$/ || $adresse =~ /:/) && $reverse_geo == 0);
	  if ($pays eq $paystmp) {
	      $hostluesday{$adresse} = 0 if ($hostluesday{$adresse} eq '');
	      $percentage = $serverjour{$adresse}*100/$paysjour{$pays};
	      $percentageint = int($percentage);


	      print FOUT "<TR>\n";
	      print FOUT "<TD VALIGN=TOP ALIGN=LEFT WIDTH=\"10\" ";
	      print FOUT "OnClick=\"javascript:ToggleMenu('";
	      print FOUT "TOGGLE_$adresse";
	      print FOUT "')\"";
	      print FOUT " TITLE=\"$L{'Click_here'}\">";
	      print FOUT "&gt;</TD>\n";

	      print FOUT "<TD VALIGN=TOP CLASS=\"left\"";
#	      print FOUT "TITLE=\"$L{'Click_here'}\"" if ($hostluesday{$adresse} != 0);
#	      print FOUT "TITLE=\"$L{'Click_here'}\"" if ($nbpageday{$adresse} != 0);
	      print FOUT ">";
#	      print FOUT "<A HREF=\"javascript:ToggleMenu('TOGGLE_$adresse')\" STYLE=\"display:inline\">" if ($hostluesday{$adresse} != 0);
#	      print FOUT "<A HREF=\"javascript:ToggleMenu('TOGGLE_$adresse')\" STYLE=\"display:inline\">" if ($nbpageday{$adresse} != 0);
	      print FOUT "<I>" if ($adresse =~ /$localdomainename$/i);
	      print FOUT "$adresse";
	      print FOUT "</I>" if ($adresse =~ /$localdomainename$/i);
#	      print FOUT "</A>" if ($hostluesday{$adresse} != 0);
#	      print FOUT "</A>" if ($nbpageday{$adresse} != 0);

	      if ($nbpageday{$adresse} != 0) {
#	      if ($hostluesday{$adresse} != 0) {
		  print FOUT "\n<DIV ID=\"TOGGLE_$adresse\" STYLE=\"display:none\">\n";

		  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\" ID=\"$adresse\">\n";
		  print FOUT "<thead>\n";
		  print FOUT "<TR>\n";
#		  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Page'}&nbsp;</TH>\n";
		  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Pages'}&nbsp;</TH>\n" if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
		  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Files'}&nbsp;</TH>\n" if ($ftp_format == 1 || $cups_format == 1);
		  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Emails'}&nbsp;</TH>\n" if ($mail_format == 1);
		  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
		  print FOUT "</TR>\n";
		  print FOUT "</thead>\n";
		  print FOUT "<tbody>\n";

		  $tmp = $nbpageday{$adresse};
		  $tmp = $display_subitem if ($tmp > $display_subitem);

#		  for ($j=1;$j<=$nbpageday{$adresse};$j++) {
		  for ($j=1;$j<=$tmp;$j++) {
		      $page = $dailypageserv{$adresse,$j};
		      print FOUT "<TR>\n";
		      print FOUT "<TD CLASS=\"left\">";

		      $link = &AddHREF($page); # if ($squid_format == 0);
		      $link = &EncryptLink($link) if ($crypt == 1);
		      print FOUT "$link";

		      print FOUT "</TD>\n";
		      print FOUT "<TD CLASS=\"right\">$seen_page{$adresse,$page}</TD>\n";
		      print FOUT "</TR>\n";
		  }
		  print FOUT "</tbody>\n";
		  print FOUT "</TABLE>\n";
	      
		  print FOUT "</DIV>\n";
	      }

	      print FOUT "</TD>\n";
	      print FOUT "<TD CLASS=\"right\" VALIGN=TOP>$revcity{$adresse}</TD>\n" if ($geoipcity == 1);
	      print FOUT "<TD CLASS=\"right\" VALIGN=TOP>$serverjour{$adresse}</TD>\n<TD CLASS=\"left\" VALIGN=TOP>\n";
	      print FOUT "<IMG WIDTH=\"$percentageint\" HEIGHT=\"$square\" SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($percentageint != 0);
	      printf FOUT "%.1f&nbsp;%</TD>\n",$percentage;
	      if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
		  print FOUT "<TD CLASS=\"right\" VALIGN=TOP>$hostluesday{$adresse}</TD><TD CLASS=\"left\" VALIGN=TOP>\n";
		  
		  $percentage = $hostluesday{$adresse}*100/$payshtmljour{$pays} if ($payshtmljour{$pays} != 0);
		  $percentage = 0 if ($payshtmljour{$pays} == 0);
		  $percentageint = int($percentage);
		  print FOUT "<IMG WIDTH=\"$percentageint\" HEIGHT=\"$square\" SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">&nbsp;" if ($percentageint != 0);
		  printf FOUT "%.1f&nbsp;%</TD>\n",$percentage;
	      }

	      print FOUT "<TD CLASS=\"right\" VALIGN=TOP>$nbpageday{$adresse}</TD>\n";
	      if ($notrafic == 0) {
		  $tmp2 = $serversizejour{$adresse}/(1024*1024);
		  printf FOUT "<TD CLASS=\"right\" VALIGN=TOP>%.1f&nbsp;$L{'Mb'}</TD>\n<TD CLASS=\"left\" VALIGN=TOP>\n",$tmp2;
		  $percentage = $serversizejour{$adresse}*100/$totsizejour if ($totsizejour != 0);
		  $percentageint = int($percentage);
		  print FOUT "<IMG WIDTH=\"$percentageint\" HEIGHT=\"$square\" SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[4]\" ALT=\"$gcolor[4]\">&nbsp;" if ($percentageint != 0);
		  printf FOUT "%.1f&nbsp;%</TD>\n",$percentage;
	      }
	      print FOUT "</TR>\n";
	      $i++;
	  }
	  last if ($i == $topten);
      }
  }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n";
  print FOUT "<P><BR>\n";
  }

  if (($locallog == 1 || $localonly == 1) && ($extpays eq $paystmp)) {

      if ($locserverjour != 0) {

	  print FOUT "<A NAME=\"local\"></A>\n";
#	  if ($show_all == 1) {
#	      print FOUT "<P><DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $topten $L{'top_local_sites'} ($L{'among'} $locserverjour)" if ($display_all == 1);
#	      print FOUT "<P><DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $locserverjour $L{'top_local_sites'}\n" if ($display_all == 0);
#	      print FOUT "&nbsp;<A HREF=\"$listdailysites$htmlext#local\">$L{'Full_list'}</A>" if ($display_all == 0);
#	      print FOUT "</DIV>\n";
#	  }
#	  if ($show_all == 0) {
	  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $locserverjour $L{'top_local_sites'}</DIV>\n" if ($topten > $locserverjour);
	  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $topten $L{'top_local_sites'}</DIV>\n" if ($topten <= $locserverjour);
#	  }


	  print FOUT "\n<p><table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
	  print FOUT "<thead>\n";
	  print FOUT "<TR>\n";
	  print FOUT "<TH><A HREF=\"javascript:ToggleMenuAll2('Toggle_all2');\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$toggle_on\" NAME=\"ima_toggle\" BORDER=0 WIDTH=\"12\" HEIGHT=\"21\" TITLE=\"$L{'Click_here'}\" ALT=\"toggle\"></A></TH>\n";
	  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Requests'}&nbsp;</TH>\n";
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
	  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
	      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
	  }
	  if ($notrafic == 0) {
	      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;</TH>\n";
	      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
	  }
	  print FOUT "</TR>\n";
	  print FOUT "</thead>\n";
	  print FOUT "<tbody>\n";
      }

      $i = 0;
      foreach $adresse (&reverse_sort_by_value(*serverjour)) {
#	  $adresse = $reverseadressehad[$adresse] if ($adresse =~ /^\d+$/);
	  if ($adresse =~ /$localdomaine/i) {
	      $pays = substr($adresse,rindex($adresse,'.')+1,length($adresse));
#	      $pays = "Unknown" if ($pays =~ /\d/);
	      $pays = "Unknown" if (($adresse =~ /[0-9]+$/ || $adresse =~ /:/) && $reverse_geo == 0);
	      if ($pays eq $paystmp) {
		  $hostluesday{$adresse} = 0 if ($hostluesday{$adresse} eq '');
		  $percentage = $serverjour{$adresse}*100/$paysjour{$pays};
		  $percentageint = int($percentage);
#		  print FOUT "<TR>\n<TD CLASS=\"left\">";
		  print FOUT "<TR>\n";
		  print FOUT "<TD VALIGN=TOP ALIGN=LEFT WIDTH=\"10\" ";
		  print FOUT "OnClick=\"javascript:ToggleMenu('";
		  print FOUT "TOGGLE2_$adresse";
		  print FOUT "')\"";
		  print FOUT " TITLE=\"$L{'Click_here'}\">";
		  print FOUT "&gt;</TD>\n";

		  print FOUT "<TD  VALIGN=TOP CLASS=\"left\"";
#		  print FOUT "TITLE=\"$L{'Click_here'}\"" if ($hostluesday{$adresse} != 0);
		  print FOUT "TITLE=\"$L{'Click_here'}\"" if ($nbpageday{$adresse} != 0);
		  print FOUT ">";
#		  print FOUT "<A HREF=\"javascript:ToggleMenu('TOGGLE2_$adresse')\" STYLE=\"display:inline\">" if ($hostluesday{$adresse} != 0);
		  print FOUT "<A HREF=\"javascript:ToggleMenu('TOGGLE2_$adresse')\" STYLE=\"display:inline\">" if ($nbpageday{$adresse} != 0);
		  print FOUT "<I>" if ($adresse =~ /$localdomaine/i);
		  print FOUT "$adresse";
		  print FOUT "</I>" if ($adresse =~ /$localdomaine/i);
		  print FOUT "</A>" if ($nbpageday{$adresse} != 0);

		  if ($nbpageday{$adresse} != 0) {
#	      if ($hostluesday{$adresse} != 0) {
		  print FOUT "\n<DIV ID=\"TOGGLE2_$adresse\" STYLE=\"display:none\">\n";

		  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\" ID=\"$adresse\">\n";
		  print FOUT "<thead>\n";
		  print FOUT "<TR>\n";
		  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Page'}&nbsp;</TH>\n";
		  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
		  print FOUT "</TR>\n";
		  print FOUT "</thead>\n";
		  print FOUT "<tbody>\n";

		  $tmp = $nbpageday{$adresse};
		  $tmp = $display_subitem if ($tmp > $display_subitem);
	      
#		  for ($j=1;$j<=$nbpageday{$adresse};$j++) {
		  for ($j=1;$j<=$tmp;$j++) {
		      $page = $dailypageserv{$adresse,$j};
		      print FOUT "<TR>\n";
		      print FOUT "<TD CLASS=\"left\">";
		      $link = &AddHREF($page);
		      print FOUT "$link";
		      print FOUT "</TD>\n";
		      print FOUT "<TD CLASS=\"right\">$seen_page{$adresse,$page}</TD>\n";
		      print FOUT "</TR>\n";
		  }
		  print FOUT "</tbody>\n";
		  print FOUT "</TABLE>\n";
	      
		  print FOUT "</DIV>\n";
	      }

		  print FOUT "</TD>\n";
		  print FOUT "<TD CLASS=\"right\" VALIGN=TOP>$serverjour{$adresse}</TD>\n<TD CLASS=\"left\" VALIGN=TOP>\n";
		  print FOUT "<IMG WIDTH=\"$percentageint\" HEIGHT=\"$square\" SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($percentageint != 0);
		  printf FOUT "%.1f",$percentage;
		  print FOUT "&nbsp;%</TD>\n";
		  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
		      print FOUT "<TD CLASS=\"right\" VALIGN=TOP>$hostluesday{$adresse}</TD><TD CLASS=\"left\" VALIGN=TOP>\n";
		      
		      $percentage = $hostluesday{$adresse}*100/$payshtmljour{$pays} if ($payshtmljour{$pays} != 0);
		      $percentage = 0 if ($payshtmljour{$pays} == 0);
		      $percentageint = int($percentage);
		      print FOUT "<IMG WIDTH=\"$percentageint\" HEIGHT=\"$square\" SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"> " if ($percentageint != 0);
		      printf FOUT "%.1f",$percentage;
		      print FOUT "&nbsp;%</TD>\n";
		  }
		  if ($notrafic == 0) {
		      $tmp2 = $serversizejour{$adresse}/(1024*1024);
		      printf FOUT "<TD CLASS=\"right\" VALIGN=TOP>%.1f&nbsp;$L{'Mb'}</TD>\n<TD CLASS=\"left\" VALIGN=TOP>\n",$tmp2;
		      $percentage = $serversizejour{$adresse}*100/$totsizejour if ($totsizejour != 0);
		      $percentageint = int($percentage);
		      print FOUT "<IMG WIDTH=\"$percentageint\" HEIGHT=\"$square\" SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[4]\" ALT=\"$gcolor[4]\">&nbsp;" if ($percentageint != 0);
		      printf FOUT "%.1f",$percentage;
		      print FOUT "&nbsp;%</TD>\n";
		  }
		  print FOUT "</TR>\n";
		  $i++;
	      }
	      last if ($i == $topten);
	  }
      }
      print FOUT "</tbody>\n";
      print FOUT "</TABLE>\n";
      print FOUT "<P><BR>\n";
  }

  print FOUT "</TD></TR></TABLE>\n";

  print FOUT "</BODY></HTML>\n";
}

####

sub PageResumeHosts {
  local(*FOUT,*L,$I,$display_all) = @_;
  local($adresse,$i,$percentage,$percentageint,$tmp,$tmp2,$rowspan);

  $tmpa = $dirresume;
  $tmpa = $oldjour if ($scriptname eq "cron-pages.pl");
  $tmpa = $yesterday if ($scriptname eq "cron-inc.pl");
  $tmpa =~ s/\/\-/ /g;
  $tmpa =~ s/\_/ \/ /g;

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Hosts'} - $tmpa</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\">\n";
  print FOUT "function ToggleMenuAll(obj) {\n";
  print FOUT " var elementsDIV = document.getElementsByTagName('div');\n";
  print FOUT "	for (var i = 0; i < elementsDIV.length; i++) {\n";
  print FOUT "     var el = elementsDIV[i].id;\n";
  print FOUT "     if (el.indexOf(\"TOGGLE_\") != -1) {\n";
  print FOUT "     elementsDIV[i].style.display  = (elementsDIV[i].style.display != 'none' ? 'none' : 'inline');\n";
  print FOUT "     }\n";
  print FOUT "	}\n";
  print FOUT "}\n";
  print FOUT "function ToggleMenuAll2(obj) {\n";
  print FOUT " var elementsDIV = document.getElementsByTagName('div');\n";
  print FOUT "	for (var i = 0; i < elementsDIV.length; i++) {\n";
  print FOUT "     var el = elementsDIV[i].id;\n";
  print FOUT "     if (el.indexOf(\"TOGGLE2_\") != -1) {\n";
  print FOUT "     elementsDIV[i].style.display  = (elementsDIV[i].style.display != 'none' ? 'none' : 'inline');\n";
  print FOUT "     }\n";
  print FOUT "	}\n";
  print FOUT "}\n";
  print FOUT "function ToggleMenu(obj) {\n";
  print FOUT "target = document.getElementById(obj);\n";
  print FOUT "if (target.style.display == \"none\"){\n";
  print FOUT "target.style.display = \"inline\";\n";
  print FOUT "} else {\n";
  print FOUT "target.style.display = \"none\";\n";
  print FOUT "}\n";
  print FOUT "}\n";
  print FOUT "</SCRIPT>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,3);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd2 TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";  
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,3);

  &PageResumeMenu(*FOUT, $link_next, eval($Lang{$lang[$nblang]}),$I);

  print FOUT "<H3> $L{'Hosts'} $L{'connecting_to_the_server'}</H3><P>\n";

  print FOUT "<A HREF=\"$dirsite$csvext\" TITLE=\"Export in CSV\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$homeicons2$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>";
  print FOUT "<A HREF=\"$listsitescsv\" TITLE=\"Export in CSV\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$homeicons2$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV-FullList\"></A>";


  $tmp = $serveruniquejour-$locserverjour;
  $tmp10 = $tmp;
  $tmp10 = $max_item_page if ($tmp10 > $max_item_page);

  if ($tmp10 != 0) {
      if ($show_all == 1) {
	  if ($display_all == 1) {
	      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $tmp10 $L{'top_external_sites'}";
	      print FOUT " ($L{'among'} $tmp) " if ($tmp10 == $max_item_page);
	  }
	  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $topten $L{'top_external_sites'} ($L{'among'} $tmp)" if ($display_all == 0);
	  print FOUT "&nbsp;<A HREF=\"$listdailysites$htmlext\">$L{'Full_list'}</A>" if ($display_all == 0 && $tmp > $topten);
	  print FOUT "</DIV>\n";

#	  print FOUT "<P><I>($L{'The_Top'} $display_subitem $L{'pages'} $L{'are_shown'})</I>\n<P>" if ($scriptname !~ /cron-pages/ && $scriptname !~ /cron-inc/);
	  print FOUT "<P><I>($L{'The_Top'} $display_subitem $L{'pages'} $L{'are_shown'})</I>\n<P>" if ($display_subitem != 0);
      }

      if ($show_all == 0) {
	  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $tmp $L{'top_external_sites'}</DIV>\n";
      }

      $tmp2 = int($tmp10/$table_lines_aff);
      if ($tmp2 != ($tmp10/$table_lines_aff)) {
	  $tmp2++;
      }

      print FOUT "\n<p><table class=\"tablesort table-autosort table-autostripe ";
      print FOUT "table-autopage:$table_lines_aff " if ($tmp2 > 1 && $display_all == 1);
      print FOUT "table-stripeclass:alternate\" id=\"page\">\n";
      print FOUT "<thead>\n";
      print FOUT "<TR>\n";
      print FOUT "<TH><A HREF=\"javascript:ToggleMenuAll('Toggle_all');\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$toggle_on\" NAME=\"ima_toggle\" BORDER=0 WIDTH=\"12\" HEIGHT=\"21\" TITLE=\"$L{'Click_here'}\" ALT=\"toggle\"></A></TH>\n" if ($display_subitem > 0);
      print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Cities'}&nbsp;</TH>\n" if ($geoipcity == 1);
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Requests'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      }
      print FOUT "<TH class=\"table-sortable:numeric\">$L{'Different_accesses'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Daily_visits'}&nbsp;</TH>\n" if ($scriptname !~ /cron-pages/ && $scriptname !~ /cron-inc/);
      if ($notrafic == 0) {
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;</TH>\n";
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      }
      print FOUT "</TR>\n";
      print FOUT "</thead>\n";

      if ($display_all == 1) {

	  if ($tmp2 > 1) {
	      print FOUT "<tfoot>\n";
	      print FOUT "<tr>\n";
	      print FOUT "<TH><A HREF=\"javascript:ToggleMenuAll('Toggle_all');\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$toggle_on\" NAME=\"ima_toggle\" BORDER=0 WIDTH=\"12\" HEIGHT=\"21\" TITLE=\"$L{'Click_here'}\" ALT=\"toggle\"></A></TH>\n" if ($display_subitem > 0);
	      print FOUT "<TH>$L{'Hosts'}</TH>\n";
	      print FOUT "<TH>&nbsp;$L{'Cities'}&nbsp;</TH>\n" if ($geoipcity == 1);
	      print FOUT "<TH>&nbsp;$L{'Requests'}&nbsp;</TH>\n";
	      print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
	      if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
		  print FOUT "<TH>&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
		  print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
	      }
	      print FOUT "<TH>$L{'Different_accesses'}&nbsp;</TH>\n";
	      print FOUT "<TH>&nbsp;$L{'Daily_visits'}&nbsp;</TH>\n" if ($scriptname !~ /cron-pages/ && $scriptname !~ /cron-inc/);
	      if ($notrafic == 0) {
		  print FOUT "<TH>&nbsp;$L{'Traffic'}&nbsp;</TH>\n";
		  print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
	      }
	      print FOUT "</tr>\n";

	      print FOUT "<tr>\n";
	      $rowspan = 4;
	      $rowspan++ if ($display_subitem > 0);
	      $rowspan++ if ($scriptname !~ /cron-pages/ && $scriptname !~ /cron-inc/);
	      $rowspan++ if ($geoipcity == 1);
	      $rowspan += 2 if ($notrafic == 0);
	      $rowspan += 3 if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
	      print FOUT "<td colspan=$rowspan>\n";
	      
	      print FOUT "<a href=\"#\" onclick=\"pageexample('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	      
	      for ($i=1;$i<=$tmp2;$i++) {
		  $iminus = $i-1;
		  print FOUT "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexample($iminus); return false;\">$i</a>\n";
	      }
	      print FOUT "<a href=\"#\" onclick=\"pageexample('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	      print FOUT "<a href=\"#\" onclick=\"pageexample('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	      print FOUT "</td>\n";
	      print FOUT "</tr>\n";
	      print FOUT "</tfoot>\n";
	  }
      }

      print FOUT "<tbody>\n";

#      print FOUT "<P>\n<TABLE CLASS=\"sortable_base\" ID=\"hosts_daily\">\n";

      $i = 0;
      $count = 0;

#      $adresse_had = '';

  foreach $adresse (&reverse_sort_by_value(*serverjour)) {
#      if ($adresse =~ /^\d+$/) {
#	  $adresse_had = $adresse;
#	  $adresse = $reverseadressehad[$adresse];
 #     }
#		$serverjour{$adresse} += $val1;
#		$hostluesday{$adresse} += $val2;
#		$serversizejour{$adresse} += $val3;

      if ($adresse !~ /$localdomaine/i && $localdomaine ne '') {
#	  if ($display_all == 0 || ($display_all == 1 && $serverjour{$adresse} > $seuilsite)) {
	  $count++;
	  $percentage = $serverjour{$adresse}*100/$reqtotjour; # if ($adresse_had eq '');
#	  $percentage = $serverjour{$adresse_had}*100/$reqtotjour if ($adresse_had ne '');
	  $percentageint = int($percentage);
	  $nbpageday{$adresse} = 0 if ($nbpageday{$adresse} eq '');

	  print FOUT "<TR>\n";
	  if ($display_subitem > 0) {
	      print FOUT "<TD VALIGN=TOP ALIGN=LEFT WIDTH=\"10\" ";
	      if ($nbpageday{$adresse} != 0) {
		  print FOUT "OnClick=\"javascript:ToggleMenu('";
		  print FOUT "TOGGLE_h$adresse";
		  print FOUT "')\"";
		  print FOUT " TITLE=\"$L{'Click_here'}\"";
	      }
	      print FOUT ">";
	      print FOUT "&gt;</TD>\n";
	  }

	  print FOUT "<TD CLASS=\"left\"";
#	  print FOUT "TITLE=\"$L{'Click_here'}\"" if ($nbpageday{$adresse} != 0);
	  print FOUT ">";
#	  print FOUT "<A HREF=\"javascript:ToggleMenu('TOGGLE_h$adresse')\" STYLE=\"display:inline\">" if ($nbpageday{$adresse} != 0 && $display_subitem > 0);
	  print FOUT "$adresse";
#	  print FOUT "</A>" if ($nbpageday{$adresse} != 0 && $display_subitem > 0);

	  if ($nbpageday{$adresse} != 0 && $display_subitem > 0) {
	      print FOUT "\n<DIV ID=\"TOGGLE_h$adresse\" STYLE=\"display:none\">\n";

	      print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\" ID=\"h$adresse\">\n";
	      print FOUT "<thead>\n";
	      print FOUT "<TR>\n";
#	      print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Page'}&nbsp;</TH>\n";
	      print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Pages'}&nbsp;</TH>\n" if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
	      print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Files'}&nbsp;</TH>\n" if ($ftp_format == 1 || $cups_format == 1);
	      print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Emails'}&nbsp;</TH>\n" if ($mail_format == 1);
	      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
	      print FOUT "</TR>\n";
	      print FOUT "</thead>\n";
	      print FOUT "<tbody>\n";

	      $tmp = $nbpageday{$adresse};
	      $tmp = $display_subitem if ($tmp > $display_subitem);

#	      for ($j=1;$j<=$nbpageday{$adresse};$j++) {
	      for ($j=1;$j<=$tmp;$j++) {
		  $page = $dailypageserv{$adresse,$j};
		  print FOUT "<TR>\n";
		  print FOUT "<TD CLASS=\"left\">";
		  $link = &AddHREF($page); # if ($squid_format == 0);
		  $link = &EncryptLink($link) if ($crypt == 1);
		  print FOUT "$link";
		  print FOUT "</TD>\n";
		  print FOUT "<TD CLASS=\"right\">$seen_page{$adresse,$page}</TD>\n";
		  print FOUT "</TR>\n";
	      }
	      print FOUT "</tbody>\n";
	      print FOUT "</TABLE>\n";
	      
	      print FOUT "</DIV>\n";
	  }

	  print FOUT "<TD CLASS=\"right\" VALIGN=TOP>$revcity{$adresse}</TD>\n" if ($geoipcity == 1);
	  print FOUT "<TD CLASS=\"right\" VALIGN=TOP>";
	  print FOUT "$serverjour{$adresse}"; # if ($adresse_had eq '');
#	  print FOUT "$serverjour{$adresse_had}"if ($adresse_had ne '');
	  print FOUT "</TD>\n";
	  print FOUT "<TD CLASS=\"left\" VALIGN=TOP>\n";
	  print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($percentageint != 0);
	  printf FOUT "%.1f",$percentage;
	  print FOUT "&nbsp;%</TD>\n";
	  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
#	      if ($adresse_had eq '') {
		  $hostluesday{$adresse} = 0 if ($hostluesday{$adresse} eq '');
		  print FOUT "<TD CLASS=\"right\" VALIGN=TOP>$hostluesday{$adresse}</TD>\n";
		  print FOUT "<TD CLASS=\"left\" VALIGN=TOP>\n";
		  $percentage = $hostluesday{$adresse}*100/$accessjour if ($accessjour != 0);
#	      } else {
#		  $hostluesday{$adresse_had} = 0 if ($hostluesday{$adresse_had} eq '');
#		  print FOUT "<TD CLASS=\"right\" VALIGN=TOP>$hostluesday{$adresse_had}</TD>\n";
#		  print FOUT "<TD CLASS=\"left\" VALIGN=TOP>\n";
#		  $percentage = $hostluesday{$adresse_had}*100/$accessjour if ($accessjour != 0);
#	      }
		  $percentage = 0 if ($accessjour == 0);
		  $percentageint = int($percentage);
	      print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">&nbsp;" if ($percentageint != 0);
	      printf FOUT "%.1f",$percentage;
	      print FOUT "&nbsp;%</TD>\n";
	  }
	  print FOUT "<TD CLASS=\"right\" VALIGN=TOP>$nbpageday{$adresse}</TD>\n";

	  print FOUT "<TD CLASS=\"right\" VALIGN=TOP>$nbdailyvisits{$adresse}</TD>\n" if ($scriptname !~ /cron-pages/ && $scriptname !~ /cron-inc/);
	  if ($notrafic == 0) {
#	      if ($adresse_had eq '') {
		  printf FOUT "<TD CLASS=\"right\" VALIGN=TOP>%.1f $L{'Mb'}</TD>\n<TD CLASS=\"left\" VALIGN=TOP>\n",($serversizejour{$adresse}/(1024*1024));
		  $percentage = $serversizejour{$adresse}*100/$totsizejour if ($totsizejour != 0);
#	      } else {
#		  printf FOUT "<TD CLASS=\"right\" VALIGN=TOP>%.1f $L{'Mb'}</TD>\n<TD CLASS=\"left\">\n",($serversizejour{$adresse_had}/(1024*1024));
#		  $percentage = $serversizejour{$adresse_had}*100/$totsizejour if ($totsizejour != 0);
#	      }
	      $percentageint = int($percentage);
	      print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[4]\" ALT=\"$gcolor[4]\">&nbsp;" if ($percentageint != 0);
	      printf FOUT "%.1f",$percentage;
	      print FOUT "&nbsp;%</TD>\n";
	  }
	  print FOUT "</TR>\n";
	  $i++;
	  last if (($i == $topten && $display_all == 0) || ($display_all == 1 && $count >= $max_item_page));
#      }
  }
  }
      print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n";
  print FOUT "<P><BR>\n";
}


  if ($locallog == 1 || $localonly == 1) {

      if ($locserverjour != 0) {

	  $tmp10 = $locserverjour;
	  $tmp10 = $max_item_page if ($tmp10 > $max_item_page);

	  print FOUT "<A NAME=\"local\"></A>\n";
	  if ($show_all == 1) {
	      if ($display_all == 1) {
		  print FOUT "<P><DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $tmp10 $L{'top_local_sites'}";
		  print FOUT " ($L{'among'} $locserverjour) " if ($tmp10 == $max_item_page);
	      }
	      print FOUT "<P><DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $topten $L{'top_local_sites'} ($L{'among'} $locserverjour)\n" if ($display_all == 0);
	      print FOUT "&nbsp;<A HREF=\"$listdailysites$htmlext#local\">$L{'Full_list'}</A>" if ($display_all == 0 && $locserverjour > $topten);
	      print FOUT "</DIV>\n";
	  }
	  if ($show_all == 0) {
	      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $locserverjour $L{'top_local_sites'}</DIV>\n";
	  }


	  $tmp2 = int($tmp10/$table_lines_aff);
	  if ($tmp2 != ($tmp10/$table_lines_aff)) {
	      $tmp2++;
	  }

	  print FOUT "\n<p><table class=\"tablesort table-autosort table-autostripe ";
	  print FOUT "table-autopage:$table_lines_aff " if ($tmp2 > 1 && $display_all == 1);
	  print FOUT "table-stripeclass:alternate\" id=\"pagebis\">\n";

	  print FOUT "<thead>\n";
	  print FOUT "<TR>\n";
	  print FOUT "<TH><A HREF=\"javascript:ToggleMenuAll2('Toggle_all2');\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$toggle_on\" NAME=\"ima_toggle\" BORDER=0 WIDTH=\"12\" HEIGHT=\"21\" TITLE=\"$L{'Click_here'}\" ALT=\"toggle\"></A></TH>\n" if ($display_subitem > 0);
	  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Requests'}&nbsp;</TH>\n";
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
	  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
	      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
	  }
	  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Different_accesses'}&nbsp;</TH>\n";
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Daily_visits'}&nbsp;</TH>\n" if ($scriptname !~ /cron-pages/ && $scriptname !~ /cron-inc/);
	  if ($notrafic == 0) {
	      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;</TH>\n";
	      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
	  }
	  print FOUT "</TR>\n";
	  print FOUT "</thead>\n";


      if ($display_all == 1) {

	  if ($tmp2 > 1) {
	      print FOUT "<tfoot>\n";
	      print FOUT "<tr>\n";
	      print FOUT "<TH><A HREF=\"javascript:ToggleMenuAll2('Toggle_all2');\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$toggle_on\" NAME=\"ima_toggle\" BORDER=0 WIDTH=\"12\" HEIGHT=\"21\" TITLE=\"$L{'Click_here'}\" ALT=\"toggle\"></A></TH>\n" if ($display_subitem > 0);
	      print FOUT "<TH>$L{'Hosts'}</TH>\n";
	      print FOUT "<TH>&nbsp;$L{'Cities'}&nbsp;</TH>\n" if ($geoipcity == 1);
	      print FOUT "<TH>&nbsp;$L{'Requests'}&nbsp;</TH>\n";
	      print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
	      if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
		  print FOUT "<TH>&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
		  print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
	      }
	      print FOUT "<TH>$L{'Different_accesses'}&nbsp;</TH>\n";
	      print FOUT "<TH>&nbsp;$L{'Daily_visits'}&nbsp;</TH>\n" if ($scriptname !~ /cron-pages/ && $scriptname !~ /cron-inc/);
	      if ($notrafic == 0) {
		  print FOUT "<TH>&nbsp;$L{'Traffic'}&nbsp;</TH>\n";
		  print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
	      }
	      print FOUT "</tr>\n";

	      print FOUT "<tr>\n";
	      $rowspan = 4;
	      $rowspan++ if ($display_subitem > 0);
	      $rowspan++ if ($scriptname !~ /cron-pages/ && $scriptname !~ /cron-inc/);
	      $rowspan++ if ($geoipcity == 1);
	      $rowspan += 2 if ($notrafic == 0);
	      $rowspan += 3 if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
	      print FOUT "<td colspan=$rowspan>\n";
	      
	      print FOUT "<a href=\"#\" onclick=\"pageexamplebis('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	      
	      for ($i=1;$i<=$tmp2;$i++) {
		  $iminus = $i-1;
		  print FOUT "<a href=\"#\" id=\"pagebis$i\" class=\"pagelink\" onclick=\"pageexamplebis($iminus); return false;\">$i</a>\n";
	      }
	      print FOUT "<a href=\"#\" onclick=\"pageexamplebis('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	      print FOUT "<a href=\"#\" onclick=\"pageexamplebis('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	      print FOUT "</td>\n";
	      print FOUT "</tr>\n";
	      print FOUT "</tfoot>\n";
	  }
      }


	  print FOUT "<tbody>\n";

#	  print FOUT "<P>\n<TABLE CLASS=\"sortable_base\" ID=\"hosts_daily_domain\">\n";

	  $i = 0;
	  $count = 0;
#	  $adresse_had = '';
	  foreach $adresse (&reverse_sort_by_value(*serverjour)) {
#	      if ($adresse =~ /^\d+$/) {
#		  $adresse_had = $adresse;
#		  $adresse = $reverseadressehad[$adresse];
#	      }
	      if ($adresse =~ /$localdomaine/i) {
#		  if ($display_all == 0 || ($display_all == 1 && $serverjour{$adresse} > $seuilsite)) {

		  $count++;
		  $nbpageday{$adresse} = 0 if ($nbpageday{$adresse} eq '');
		  $percentage = $serverjour{$adresse}*100/$reqtotjour; # if ($adresse_had eq '');
#		  $percentage = $serverjour{$adresse_had}*100/$reqtotjour if ($adresse_had ne '');
		  $percentageint = int($percentage);

		  print FOUT "<TR>\n";
		  if ($display_subitem > 0) {
		      print FOUT "<TD VALIGN=TOP ALIGN=LEFT WIDTH=\"10\" ";
		      if ($nbpageday{$adresse} != 0) {
			  print FOUT "OnClick=\"javascript:ToggleMenu('";
			  print FOUT "TOGGLE2_h$adresse";
			  print FOUT "')\"";
			  print FOUT " TITLE=\"$L{'Click_here'}\"";
		      }
		      print FOUT ">";
		      print FOUT "&gt;</TD>\n";
		  }

#		  print FOUT "<TD CLASS=\"left\"";
#		  print FOUT "TITLE=\"$L{'Click_here'}\"" if ($hostluesday{$adresse} != 0);
#		  print FOUT ">";
		  print FOUT "<TD CLASS=\"left\" TITLE=\"$resolv_user{$adresse}\">";
		  print FOUT "<A HREF=\"javascript:ToggleMenu('TOGGLE2_h$adresse')\" STYLE=\"display:inline\">" if ($nbpageday{$adresse} != 0 && $display_subitem > 0);
		  print FOUT "<I>$adresse</I>";
		  print FOUT "</A>" if ($nbpageday{$adresse} != 0 && $display_subitem > 0);

		  if ($nbpageday{$adresse} != 0 && $display_subitem > 0) {
		      print FOUT "\n<DIV ID=\"TOGGLE2_h$adresse\" STYLE=\"display:none\">\n";
		      
		      print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\" ID=\"h$adresse\">\n";
		      print FOUT "<thead>\n";
		      print FOUT "<TR>\n";

		      print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Pages'}&nbsp;</TH>\n" if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
		      print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Files'}&nbsp;</TH>\n" if ($ftp_format == 1 || $cups_format == 1);
		      print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Emails'}&nbsp;</TH>\n" if ($mail_format == 1);

#		      print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Page'}&nbsp;</TH>\n";
		      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
		      print FOUT "</TR>\n";
		      print FOUT "</thead>\n";
		      print FOUT "<tbody>\n";

		      $tmp = $nbpageday{$adresse};
		      $tmp = $display_subitem if ($tmp > $display_subitem);

#	      for ($j=1;$j<=$nbpageday{$adresse};$j++) {
		      for ($j=1;$j<=$tmp;$j++) {
			  $page = $dailypageserv{$adresse,$j};
			  print FOUT "<TR>\n";
			  print FOUT "<TD CLASS=\"left\">";
			  $link = &AddHREF($page);
			  $link = &EncryptLink($link) if ($crypt == 1);
			  print FOUT "$link";
#			  print FOUT "$page" if ($titlename == 0);
#			  print FOUT "$urlconv{$page}" if ($titlename == 1 && $urlconv{$page} ne '');
#			  print FOUT "$page" if ($titlename == 1 && $urlconv{$page} eq '');
			  print FOUT "</TD>\n";
			  print FOUT "<TD CLASS=\"right\">$seen_page{$adresse,$page}</TD>\n";
			  print FOUT "</TR>\n";
		      }
		      print FOUT "</tbody>\n";
		      print FOUT "</TABLE>\n";
		      
		      print FOUT "</DIV>\n";
		  }

		  print FOUT "</TD>\n";
		  print FOUT "<TD CLASS=\"right\" VALIGN=TOP>";
		  print FOUT "$serverjour{$adresse}"; # if ($adresse_had eq '');
#		  print FOUT "$serverjour{$adresse_had}"if ($adresse_had ne '');
		  print FOUT "</TD>\n";
		  print FOUT "<TD CLASS=\"left\">\n";
		  print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($percentageint != 0);
		  printf FOUT "%.1f",$percentage;
		  print FOUT "&nbsp;%</TD>\n";
		  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
#		      if ($adresse_had eq '') {
			  $hostluesday{$adresse} = 0 if ($hostluesday{$adresse} eq '');
			  print FOUT "<TD CLASS=\"right\" VALIGN=TOP>$hostluesday{$adresse}</TD>\n";
			  print FOUT "<TD CLASS=\"left\" VALIGN=TOP>\n";
			  $percentage = $hostluesday{$adresse}*100/$accessjour if ($accessjour != 0);
#		      } else {
#			  $hostluesday{$adresse_had} = 0 if ($hostluesday{$adresse_had} eq '');
#			  print FOUT "<TD CLASS=\"right\" VALIGN=TOP>$hostluesday{$adresse_had}</TD>\n";
#			  print FOUT "<TD CLASS=\"left\" VALIGN=TOP>\n";
#			  $percentage = $hostluesday{$adresse_had}*100/$accessjour if ($accessjour != 0);
#		      }
		      $percentage = 0 if ($accessjour == 0);
		      $percentageint = int($percentage);
		      print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"> " if ($percentageint != 0);
		      printf FOUT "%.1f",$percentage;
		      print FOUT "&nbsp;%</TD>\n";
		  }
		  print FOUT "<TD CLASS=\"right\" VALIGN=TOP>$nbpageday{$adresse}</TD>\n";
		  print FOUT "<TD CLASS=\"right\" VALIGN=TOP>$nbdailyvisits{$adresse}</TD>\n" if ($scriptname !~ /cron-pages/ && $scriptname !~ /cron-inc/);
		  if ($notrafic == 0) {
#		      if ($adresse_had eq '') {
			  printf FOUT "<TD CLASS=\"right\" VALIGN=TOP>%.1f $L{'Mb'}</TD>\n<TD CLASS=\"left\" VALIGN=TOP>\n",($serversizejour{$adresse}/(1024*1024));
			  $percentage = $serversizejour{$adresse}*100/$totsizejour if ($totsizejour != 0);
#		      } else {
#			  printf FOUT "<TD CLASS=\"right\" VALIGN=TOP>%.1f $L{'Mb'}</TD>\n<TD CLASS=\"left\">\n",($serversizejour{$adresse_had}/(1024*1024));
#			  $percentage = $serversizejour{$adresse_had}*100/$totsizejour if ($totsizejour != 0);
#		      }
		      $percentageint = int($percentage);
		      print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[4]\" ALT=\"$gcolor[4]\"> " if ($percentageint != 0);
		      printf FOUT "%.1f",$percentage;
		      printf FOUT "&nbsp;%</TD>\n";
		  }
		  print FOUT "</TR>\n";
		  $i++;
		  last if (($i == $topten && $display_all == 0) || ($display_all == 1 && $count >= $max_item_page));
	      }
#	      }
	  }

	  print FOUT "</tbody>\n";
	  print FOUT "</TABLE>\n";
	  print FOUT "<P><BR>\n";
      }
  }
  
  print FOUT "</TD></TR></TABLE>\n";
  
  print FOUT "</BODY></HTML>\n";
}


####

sub PageResumeDir {
  local(*FOUT,*L,$I,$display_all) = @_;
  local($tmp,$pos,$tmp3,$rootrepert,$i);

  $tmpa = $dirresume;
  $tmpa = $oldjour if ($scriptname eq "cron-pages.pl");
  $tmpa = $yesterday if ($scriptname eq "cron-inc.pl");
  $tmpa =~ s/\/\-/ /g;
  $tmpa =~ s/\_/ \/ /g;

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Directories'} - $tmpa</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,3);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd2 TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,3);

  &PageResumeMenu(*FOUT, $link_next, eval($Lang{$lang[$nblang]}),$I);

  print FOUT "<H3> $L{'ListOf'} $L{'directories'} $L{'used2'}</H3><P>\n";

  print FOUT "<A HREF=\"$dirlist$csvext\" TITLE=\"Export in CSV\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$homeicons2$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>";

  $tmp = keys(%freqjourrachtml);
#  $tmp = scalar(@freqjourrachtml);
  $tmp10 = $tmp;
  $tmp10 = $max_item_page if ($tmp10 > $max_item_page);

  if ($show_all == 1) {
      if ($display_all == 1) {
	  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $tmp10 $L{'directories'}\n";
	  print FOUT " ($L{'among'} $tmp) " if ($tmp10 == $max_item_page);
      }
      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $topten $L{'directories'} ($L{'among'} $tmp)\n" if ($display_all == 0);
      print FOUT "&nbsp;<A HREF=\"$listdailydir$htmlext\">$L{'Full_list'}</A>" if ($display_all == 0 && $tmp > $topten);
      print FOUT "</DIV>\n";
  }

  if ($show_all == 0) {
      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $tmp $L{'directories'}</DIV>\n";
  }

  $tmp2 = int($tmp10/$table_lines_aff);
  if ($tmp2 != ($tmp10/$table_lines_aff)) {
      $tmp2++;
  }

  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe ";
  print FOUT "table-autopage:$table_lines_aff " if ($tmp2 > 1 && $display_all == 1);
  print FOUT "table-stripeclass:alternate\" id=\"page\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Directories'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Level'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Requests'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  }
  if ($notrafic == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($L{'Mb'})</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  }
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";

  if ($display_all == 1) {

      if ($tmp2 > 1) {
	  print FOUT "<tfoot>\n";
	  print FOUT "<tr>\n";
	  print FOUT "<TH>$L{'Directories'}</TH>\n";
	  print FOUT "<TH>$L{'Level'}</TH>\n";
	  print FOUT "<TH>$L{'Requests'}</TH>\n";
	  print FOUT "<TH>$L{'Percentage'}</TH>\n";
	  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	      print FOUT "<TH>$L{'Accesses'}</TH>\n";
	      print FOUT "<TH>$L{'Percentage'}</TH>\n";
	  }
	  if ($notrafic == 0) {
	      print FOUT "<TH>$L{'Traffic'}&nbsp;($L{'Mb'})</TH>\n";
	      print FOUT "<TH>$L{'Percentage'}</TH>\n";
	  }
	  print FOUT "</tr>\n";
	  $tmp3 = 6;
	  $tmp3 += 2 if ($notrafic == 0); 
	  $tmp3 += 2 if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
	  print FOUT "<tr>\n";
	  print FOUT "<td colspan=$tmp3>\n";
	  print FOUT "<a href=\"#\" onclick=\"pageexample('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	  
	  for ($i=1;$i<=$tmp2;$i++) {
	      $iminus = $i-1;
	      print FOUT "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexample($iminus); return false;\">$i</a>\n";
	  }
	  print FOUT "<a href=\"#\" onclick=\"pageexample('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "<a href=\"#\" onclick=\"pageexample('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "</td>\n";
	  print FOUT "</tr>\n";

	  print FOUT "</tfoot>\n";
      }
  }


  print FOUT "<tbody>\n";

  $i = 0;
  $count = 0;
  foreach $rootrepert (&reverse_sort_by_value(*freqjourrachtml)) {

      if ($freqjourrachtml{$rootrepert} ne '') {

	  $tmp = 0;
	  $pos = length($rootrepert);
	  while (($pos = rindex($rootrepert,$dirsepurl,$pos)) >= 0) {
	      $tmp++;
	      $pos--;
	  }
	  $tmp -= $tmptri;

	  $count++;
#	  if ($display_all == 0 || ($display_all == 1 && $freqjourrac{$rootrepert} > $seuilrepert)) {
	      print FOUT "<TR><TD CLASS=\"left\"\n";
	      print FOUT ">$rootrepert</TD>\n";
	      print FOUT "<TD CLASS=\"right\">$tmp</TD>\n";

	      print FOUT "<TD CLASS=\"right\">$freqjourrac{$rootrepert}</TD>\n<TD CLASS=\"left\">";
	      $percentage = $freqjourrac{$rootrepert}*100/$reqtotjour if ($reqtotjour != 0);
	      $percentageint = int($percentage);
	      print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($percentageint != 0);
	      printf FOUT "%.1f",$percentage;
	      print FOUT "&nbsp;%</TD>\n";

	  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	      print FOUT "<TD CLASS=\"right\">$freqjourrachtml{$rootrepert}</TD>\n<TD CLASS=\"left\">";
	      $percentage = $freqjourrachtml{$rootrepert}*100/$accessjour if ($accessjour != 0);
	      $percentageint = int($percentage);
	      print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[1]\"> " if ($percentageint != 0);
	      printf FOUT "%.1f",$percentage;
	      print FOUT "&nbsp;%</TD>\n";
	  }

	      if ($notrafic == 0) {
		  $percentage = $sizejourrachtml{$rootrepert}*100/$tothtmlsizejour if ($tothtmlsizejour != 0);
		  $percentageint = int($percentage);
		  $tmp3 = int(($sizejourrachtml{$rootrepert}/(1024*1024))*100)/100;
		  print FOUT "<TD CLASS=\"right\">";
		  print FOUT "$tmp3</TD>";
		  print FOUT "\n<TD CLASS=\"left\">";
		  print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[2]\"> " if ($percentageint != 0);
		  printf FOUT "%.1f",$percentage;
		  print FOUT "&nbsp;%</TD>\n";
	      }
	      print FOUT "</TR>\n";
	      $i++;
	      last if (($i == $topten && $display_all == 0) || ($display_all == 1 && $count >= $max_item_page));
	  }
#      }
  }

  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n";
  print FOUT "<P><BR>\n";

  print FOUT "</TD></TR></TABLE>\n";

  print FOUT "</BODY></HTML>\n";
}

####

sub PageResumePage {
  local(*FOUT,*L,$I,$display_all) = @_;
  local($page,$page2,$percentage,$percentageint,$i);

  $tmpa = $dirresume;
  $tmpa = $oldjour if ($scriptname eq "cron-pages.pl");
  $tmpa = $yesterday if ($scriptname eq "cron-inc.pl");
  $tmpa =~ s/\/\-/ /g;
  $tmpa =~ s/\_/ \/ /g;

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Pages'} - $tmpa</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\">\n";
  print FOUT "function ToggleMenuAll(obj) {\n";
  print FOUT " var elementsDIV = document.getElementsByTagName('div');\n";
  print FOUT "	for (var i = 0; i < elementsDIV.length; i++) {\n";
  print FOUT "     var el = elementsDIV[i].id;\n";
  print FOUT "     if (el.indexOf(\"TOGGLE_\") != -1) {\n";
  print FOUT "     elementsDIV[i].style.display  = (elementsDIV[i].style.display != 'none' ? 'none' : 'inline');\n";
  print FOUT "     }\n";
  print FOUT "	}\n";
  print FOUT "}\n";
  print FOUT "function ToggleMenu(obj) {\n";
  print FOUT "target = document.getElementById(obj);\n";
  print FOUT "if (target.style.display == \"none\"){\n";
  print FOUT "target.style.display = \"inline\";\n";
  print FOUT "} else {\n";
  print FOUT "target.style.display = \"none\";\n";
  print FOUT "}\n";
  print FOUT "}\n";
  print FOUT "</SCRIPT>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,3);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd2 TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,3);

  &PageResumeMenu(*FOUT, $link_next, eval($Lang{$lang[$nblang]}),$I);

  if ($notrafic == 0) {
  $max = $dailysizepage{(&reverse_sort_by_value(*dailysizepage))[0]};

  $unit = "$L{'bytes'}";
  $unitsize = 1;
  if ($max > 1024) {
      $unit = "$L{'Kb'}";
      $unitsize = 1024;
  }
  if ($max > (1024*1024)) {
      $unit = "$L{'Mb'}";
      $unitsize = 1024*1024;
  }
  if ($max > (1024*1024*1024)) {
      $unit = "$L{'Gb'}";
      $unitsize = 1024*1024*1024;
  }
  if ($max > (1024*1024*1024*1024)) {
      $unit = "$L{'Tb'}";
      $unitsize = 1024*1024*1024*1024;
  }
  }

  print FOUT "<H3> $L{'ListOf'} $L{'pages'} $L{'used'}</H3><P>\n";

  print FOUT "<A HREF=\"$dirpage$csvext\" TITLE=\"Export in CSV\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$homeicons2$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>";
  print FOUT "<A HREF=\"$listpagescsv\" TITLE=\"Export in CSV\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$homeicons2$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV-FullList\"></A>";

  $tmp10 = $pageuniquejour;
  $tmp10 = $max_item_page if ($tmp10 > $max_item_page);

  if ($show_all == 1) {
      if ($display_all == 1) {
	  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $tmp10 $L{'pages'}\n";
	  print FOUT " ($L{'among'} $pageuniquejour) " if ($tmp10 == $max_item_page);
      }

      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $topten $L{'pages'} ($L{'among'} $pageuniquejour)\n" if ($display_all == 0);
      print FOUT "&nbsp;<A HREF=\"$listdailypages$htmlext\">$L{'Full_list'}</A>" if ($display_all == 0 && $pageuniquejour > $topten);
      print FOUT "</DIV>\n";

#      print FOUT "<P><I>($L{'The_Top'} $display_subitem $L{'hosts'} $L{'are_shown'})</I>\n<P>" if ($scriptname !~ /cron-pages/ && $scriptname !~ /cron-inc/);
      print FOUT "<P><I>($L{'The_Top'} $display_subitem $L{'hosts'} $L{'are_shown'})</I>\n<P>" if ($mail_format == 0 && $cups_format == 0 && $display_subitem != 0);
  }

  if ($show_all == 0) {
      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $pageuniquejour $L{'pages'}</DIV>\n";
  }
  

  $tmp = int($tmp10/$table_lines_aff);
  if ($tmp != ($tmp10/$table_lines_aff)) {
      $tmp++;
  }

  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe ";
  print FOUT "table-autopage:$table_lines_aff " if ($tmp > 1 && $display_all == 1);
  print FOUT "table-stripeclass:alternate\" id=\"page\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH><A HREF=\"javascript:ToggleMenuAll('Toggle_all');\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$toggle_on\" NAME=\"ima_toggle\" BORDER=0 WIDTH=\"12\" HEIGHT=\"21\" TITLE=\"$L{'Click_here'}\" ALT=\"toggle\"></A></TH>\n" if ($mail_format == 0 && $cups_format == 0 && $display_subitem > 0);
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Destination'}&nbsp;</TH>\n" if ($squid_format == 1);
#  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Pages'}&nbsp;</TH>\n";

  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Pages'}&nbsp;</TH>\n" if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Files'}&nbsp;</TH>\n" if ($ftp_format == 1 || $cups_format == 1);
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Emails'}&nbsp;</TH>\n" if ($mail_format == 1);

  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n" if ($cups_format == 0);
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Pages'}&nbsp;</TH>\n" if ($cups_format == 1);
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n" if ($notrafic == 0);
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n" if ($mail_format == 0);
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";

  if ($display_all == 1) {

      if ($tmp > 1) {

	  print FOUT "<tfoot>\n";
	  print FOUT "<tr>\n";
	  print FOUT "<TH><A HREF=\"javascript:ToggleMenuAll('Toggle_all');\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$toggle_on\" NAME=\"ima_toggle\" BORDER=0 WIDTH=\"12\" HEIGHT=\"21\" TITLE=\"$L{'Click_here'}\" ALT=\"toggle\"></A></TH>\n" if ($mail_format == 0 && $cups_format == 0 && $display_subitem > 0);
	  print FOUT "<TH>$L{'Destination'}</TH>\n" if ($squid_format == 1);
#	  print FOUT "<TH>$L{'Pages'}</TH>\n";
	  print FOUT "<TH>&nbsp;$L{'Pages'}&nbsp;</TH>\n" if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
	  print FOUT "<TH>&nbsp;$L{'Files'}&nbsp;</TH>\n" if ($ftp_format == 1 || $cups_format == 1);
	  print FOUT "<TH>&nbsp;$L{'Emails'}&nbsp;</TH>\n" if ($mail_format == 1);
	  print FOUT "<TH>$L{'Occurence'}</TH>\n" if ($cups_format == 0);
	  print FOUT "<TH>$L{'Pages'}</TH>\n" if ($cups_format == 1);
	  print FOUT "<TH>$L{'Percentage'}</TH>\n";
	  print FOUT "<TH>$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n" if ($notrafic == 0);
	  print FOUT "<TH>$L{'Hosts'}</TH>\n" if ($mail_format == 0);
	  print FOUT "</tr>\n";

	  print FOUT "<tr>\n";
	  $tmp2 = 2;
	  $tmp2++ if ($display_subitem > 0);
	  $tmp2++ if ($squid_format == 1);
	  $tmp2++ if ($notrafic == 0);
	  $tmp2 += 2 if ($mail_format == 0);
	  print FOUT "<td colspan=$tmp2>\n";
	  print FOUT "<a href=\"#\" onclick=\"pageexample('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	  
	  for ($i=1;$i<=$tmp;$i++) {
	      $iminus = $i-1;
	      print FOUT "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexample($iminus); return false;\">$i</a>\n";
	  }
	  print FOUT "<a href=\"#\" onclick=\"pageexample('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "<a href=\"#\" onclick=\"pageexample('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "</td>\n";
	  print FOUT "</tr>\n";

	  print FOUT "</tfoot>\n";
      }
  }

  print FOUT "<tbody>\n";


  $i = 0;
  $count = 0;
  foreach $page (&reverse_sort_by_value(*pagesluesday)) {
      $count++;
      $percentage = $pagesluesday{$page}*100/$accessjour if ($cups_format == 0 && $accessjour != 0);
      $percentage = $pagesluesday{$page}*100/$reqtotjour if ($cups_format == 1 && $reqtotjour != 0);
      $percentageint = int($percentage);
#      if ($display_all == 0 || ($display_all == 1 && $pagesluesday{$page} > $seuilpage)) {
      $page2 = $page;
      $page2 =~ s/$dirsepurl/_/g;
      print FOUT "<TR>";

      if ($mail_format == 0 && $cups_format == 0 && $display_subitem > 0) {
	  print FOUT "<TD VALIGN=TOP ALIGN=LEFT WIDTH=\"10\" ";
	  print FOUT "OnClick=\"javascript:ToggleMenu('";
	  print FOUT "TOGGLE_p$page2";
	  print FOUT "')\"";
	  print FOUT " TITLE=\"$L{'Click_here'}\">";
	  print FOUT "&gt;</TD>\n";
      }

      if ($squid_format == 1) {
	  $tmp = index($page,$dirsep,1);
	  $tmp1 = substr($page,0,$tmp+1);
	  $tmp6 = substr($page,$tmp,length($page));
	  print FOUT "<TD CLASS=\"left\">$tmp1</TD>\n";
      }
      print FOUT "<TD CLASS=\"left\">";
      $link = &AddHREF($page) if ($squid_format == 0);
      $link = &AddHREF($tmp6) if ($squid_format == 1);
      $link = &EncryptLink($link) if ($crypt == 1);
      print FOUT "$link";

      if ($mail_format == 0 && $cups_format == 0 && $display_subitem > 0) {
	  print FOUT "\n<DIV ID=\"TOGGLE_p$page2\" STYLE=\"display:none\">\n";
	  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\" ID=\"p$page2\">\n";
	  print FOUT "<thead>\n";
	  print FOUT "<TR>\n";
	  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
	  print FOUT "</TR>\n";
	  print FOUT "</thead>\n";
	  print FOUT "<tbody>\n";

	  $tmp = $nbhostpageday{$page};
	  $tmp = $display_subitem if ($tmp > $display_subitem);

#	  for ($j=1;$j<=$nbhostpageday{$page};$j++) {
	  for ($j=1;$j<=$tmp;$j++) {
	      $host = $dailyhostpage{$page,$j};
	      print FOUT "<TR>\n";
	      print FOUT "<TD CLASS=\"left\">";
	      print FOUT "$host";
	      print FOUT "</TD>\n";
	      print FOUT "<TD CLASS=\"right\">$seen_host{$page,$host}</TD>\n";
	      print FOUT "</TR>\n";
	  }
	  print FOUT "</tbody>\n";
	  print FOUT "</TABLE>\n";
	  print FOUT "</DIV>\n";
      }


      print FOUT "</TD>\n";

      print FOUT "<TD CLASS=\"right\" VALIGN=TOP>$pagesluesday{$page}</TD><TD CLASS=\"left\" VALIGN=TOP>";
      print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($percentageint != 0);
      printf FOUT "%.1f",$percentage;
      print FOUT "&nbsp;%</TD>\n";

      if ($notrafic == 0) {
	  print FOUT "<TD CLASS=\"right\" VALIGN=TOP>\n";
	  printf FOUT "%.2f",($dailysizepage{$page}/$unitsize) if ($max >= 1);
	  printf FOUT "%.3f",($dailysizepage{$page}/$unitsize) if ($max < 1);
	  print FOUT "</TD>\n";
      }
      print FOUT "<TD CLASS=\"right\" VALIGN=TOP>$nbhostpageday{$page}</TD>\n" if ($mail_format == 0 && $cups_format == 0);
      print FOUT "<TD CLASS=\"right\" VALIGN=TOP>$dailyhostpage{$page,1}</TD>\n" if ($cups_format == 1);
      print FOUT "</TR>\n";
      $i++;
      last if (($i == $topten && $display_all == 0) || ($display_all == 1 && $count >= $max_item_page));
 #     }
  }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n";
  print FOUT "<P><BR>\n";

  print FOUT "</TD></TR></TABLE>\n";

  print FOUT "</BODY></HTML>\n";
}


####

sub PageResumeSpam {
  local(*FOUT,*L,$I,$display_all) = @_;
  local($page,$page2,$percentage,$percentageint,$i,$spamall);

  $tmpa = $dirresume;
  $tmpa = $oldjour if ($scriptname eq "cron-pages.pl");
  $tmpa = $yesterday if ($scriptname eq "cron-inc.pl");
  $tmpa =~ s/\/\-/ /g;
  $tmpa =~ s/\_/ \/ /g;

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Spam'} - $tmpa</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\">\n";
  print FOUT "function ToggleMenuAll(obj) {\n";
  print FOUT " var elementsDIV = document.getElementsByTagName('div');\n";
  print FOUT "	for (var i = 0; i < elementsDIV.length; i++) {\n";
  print FOUT "     var el = elementsDIV[i].id;\n";
  print FOUT "     if (el.indexOf(\"TOGGLE_\") != -1) {\n";
  print FOUT "     elementsDIV[i].style.display  = (elementsDIV[i].style.display != 'none' ? 'none' : 'inline');\n";
  print FOUT "     }\n";
  print FOUT "	}\n";
  print FOUT "}\n";
  print FOUT "function ToggleMenuAll2(obj) {\n";
  print FOUT " var elementsDIV = document.getElementsByTagName('div');\n";
  print FOUT "	for (var i = 0; i < elementsDIV.length; i++) {\n";
  print FOUT "     var el = elementsDIV[i].id;\n";
  print FOUT "     if (el.indexOf(\"TOGGLE2_\") != -1) {\n";
  print FOUT "     elementsDIV[i].style.display  = (elementsDIV[i].style.display != 'none' ? 'none' : 'inline');\n";
  print FOUT "     }\n";
  print FOUT "	}\n";
  print FOUT "}\n";
  print FOUT "function ToggleMenu(obj) {\n";
  print FOUT "target = document.getElementById(obj);\n";
  print FOUT "if (target.style.display == \"none\"){\n";
  print FOUT "target.style.display = \"inline\";\n";
  print FOUT "} else {\n";
  print FOUT "target.style.display = \"none\";\n";
  print FOUT "}\n";
  print FOUT "}\n";
  print FOUT "</SCRIPT>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,3);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd2 TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,3);

  &PageResumeMenu(*FOUT, $link_next, eval($Lang{$lang[$nblang]}),$I);

  print FOUT "<H3> $L{'ListOf'} $L{'spam'} $L{'used'}</H3><P>\n";

  print FOUT "<A HREF=\"$spam$csvext\" TITLE=\"Export in CSV\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$homeicons2$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>";
  print FOUT "<A HREF=\"$listspamcsv\" TITLE=\"Export in CSV\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$homeicons2$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV-FullList\"></A>";

  if ($spam_day_ext != 0) {
    
      $spamall = keys(%spam_daily_user_ext);
      $tmp10 = $spamall;
      $tmp10 = $max_item_page if ($tmp10 > $max_item_page);
      
      if ($show_all == 1) {
	  if ($display_all == 1) {
	      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $tmp10 $L{'spam'}\n";
	      print FOUT " ($L{'among'} $spamall) " if ($tmp10 == $max_item_page);
	  }
	  
	  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $topten $L{'spam'} ($L{'among'} $spamall)\n" if ($display_all == 0);
	  print FOUT "&nbsp;<A HREF=\"$listdailyspam$htmlext\">$L{'Full_list'}</A>" if ($display_all == 0 && $spamall > $topten);
	  print FOUT "</DIV>\n";
      }

      if ($show_all == 0) {
	  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $spamall $L{'spam'}";
	  print FOUT " ($L{'among'} $spamall)\n" if ($max_item_page == $max_item_page);
	  print FOUT "</DIV>\n";
      }
  
      print FOUT "<P><I>($L{'The_Top'} $display_subitem $L{'pages'} $L{'are_shown'})</I>\n<P>" if ($display_subitem != 0);

      $tmp = int($tmp10/$table_lines_aff);
      if ($tmp != ($tmp10/$table_lines_aff)) {
	  $tmp++;
      }

      print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe ";
      print FOUT "table-autopage:$table_lines_aff " if ($tmp > 1 && $display_all == 1);
      print FOUT "table-stripeclass:alternate\" id=\"page\">\n";
      print FOUT "<thead>\n";
      print FOUT "<TR>\n";
      print FOUT "<TH><A HREF=\"javascript:ToggleMenuAll('Toggle_all');\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$toggle_on\" NAME=\"ima_toggle\" BORDER=0 WIDTH=\"12\" HEIGHT=\"21\" TITLE=\"$L{'Click_here'}\" ALT=\"toggle\"></A></TH>\n";
      print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Emails'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      print FOUT "</TR>\n";
      print FOUT "</thead>\n";
      
      if ($display_all == 1) {
	  
	  if ($tmp > 1) {

	      print FOUT "<tfoot>\n";
	      print FOUT "<tr>\n";
	      print FOUT "<TH><A HREF=\"javascript:ToggleMenuAll('Toggle_all');\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$toggle_on\" NAME=\"ima_toggle\" BORDER=0 WIDTH=\"12\" HEIGHT=\"21\" TITLE=\"$L{'Click_here'}\" ALT=\"toggle\"></A></TH>\n";
	      print FOUT "<TH>$L{'Emails'}</TH>\n";
	      print FOUT "<TH>$L{'Occurence'}</TH>\n";
	      print FOUT "<TH>$L{'Percentage'}</TH>\n";
	      print FOUT "</tr>\n";
	      
	      print FOUT "<tr>\n";
	      $tmp2 = 4;
	      print FOUT "<td colspan=$tmp2>\n";
	      print FOUT "<a href=\"#\" onclick=\"pageexample('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	      
	      for ($i=1;$i<=$tmp;$i++) {
		  $iminus = $i-1;
		  print FOUT "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexample($iminus); return false;\">$i</a>\n";
	      }
	      print FOUT "<a href=\"#\" onclick=\"pageexample('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	      print FOUT "<a href=\"#\" onclick=\"pageexample('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	      print FOUT "</td>\n";
	      print FOUT "</tr>\n";
	      
	      print FOUT "</tfoot>\n";
	  }
      }
      
      print FOUT "<tbody>\n";

      $i = 0;
      $count = 0;
      foreach $page (&reverse_sort_by_value(*spam_daily_user_ext)) {
	  $count++;
	  $percentage = $spam_daily_user_ext{$page}*100/$spam_day_ext;
	  $percentageint = int($percentage);
	  $page2 = $page;
	  $page2 =~ s/[@=]/_/g;
	  print FOUT "<TR>";
	  
	  print FOUT "<TD VALIGN=TOP ALIGN=LEFT WIDTH=\"10\" ";
	  print FOUT "OnClick=\"javascript:ToggleMenu('";
	  print FOUT "TOGGLE_p$page2";
	  print FOUT "')\"";
	  print FOUT " TITLE=\"$L{'Click_here'}\">";
	  print FOUT "&gt;</TD>\n";
	  
	  print FOUT "<TD CLASS=\"left\">";
	  print FOUT "$page";

	  print FOUT "\n<DIV ID=\"TOGGLE_p$page2\" STYLE=\"display:none\">\n";
#	  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\" ID=\"p$page2\">\n";
	  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
	  print FOUT "<thead>\n";
	  print FOUT "<TR>\n";
	  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
	  print FOUT "</TR>\n";
	  print FOUT "</thead>\n";
	  print FOUT "<tbody>\n";

	  $tmp = $spam_daily_user_ext_unique{$page};
	  $tmp = $display_subitem if ($tmp > $display_subitem);

	  for ($j=1;$j<=$tmp;$j++) {
	      $host = $spam_daily_page{$page,$j};
	      print FOUT "<TR>\n";
	      print FOUT "<TD CLASS=\"left\">";
	      print FOUT "$host";
	      print FOUT "</TD>\n";
	      print FOUT "<TD CLASS=\"right\">$seen_spam{$page,$host}</TD>\n";
	      print FOUT "</TR>\n";
	  }
	  print FOUT "</tbody>\n";
	  print FOUT "</TABLE>\n";
	  
	  print FOUT "</DIV>\n";

	  print FOUT "</TD>\n";

	  print FOUT "<TD CLASS=\"right\" VALIGN=TOP>$spam_daily_user_ext{$page}</TD><TD CLASS=\"left\" VALIGN=TOP>";
	  print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($percentageint != 0);
	  printf FOUT "%.1f",$percentage;
	  print FOUT "&nbsp;%</TD>\n";
	  print FOUT "</TR>\n";
	  $i++;
	  last if (($i == $topten && $display_all == 0) || ($display_all == 1 && $count >= $max_item_page));
      }
      print FOUT "</tbody>\n";
      print FOUT "</TABLE>\n";
      print FOUT "<P><BR>\n";
  }


  if ($spam_day_local != 0) {

      $spamall = keys(%spam_daily_user_loc);
      $tmp10 = $spamall;
      $tmp10 = $max_item_page if ($tmp10 > $max_item_page);
      
      if ($show_all == 1) {
	  if ($display_all == 1) {
	      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $tmp10 $L{'spam'}\n";
	      print FOUT " ($L{'among'} $spamall) " if ($tmp10 == $max_item_page);
	  }
	  
	  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $topten $L{'spam'} ($L{'among'} $spamall)\n" if ($display_all == 0);
	  print FOUT "&nbsp;<A HREF=\"$listdailyspam$htmlext\">$L{'Full_list'}</A>" if ($display_all == 0 && $spamall > $topten);
	  print FOUT "</DIV>\n";
      }
      
      if ($show_all == 0) {
	  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $spamall $L{'spam'}";
	  print FOUT " ($L{'among'} $spamall)\n" if ($max_item_page == $max_item_page);
      }
      
      $tmp = int($tmp10/$table_lines_aff);
      if ($tmp != ($tmp10/$table_lines_aff)) {
	  $tmp++;
      }
      
      print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe ";
      print FOUT "table-autopage:$table_lines_aff " if ($tmp > 1 && $display_all == 1);
      print FOUT "table-stripeclass:alternate\" id=\"pagebis\">\n";
      print FOUT "<thead>\n";
      print FOUT "<TR>\n";
      print FOUT "<TH><A HREF=\"javascript:ToggleMenuAll2('Toggle_all2');\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$toggle_on\" NAME=\"ima_toggle\" BORDER=0 WIDTH=\"12\" HEIGHT=\"21\" TITLE=\"$L{'Click_here'}\" ALT=\"toggle\"></A></TH>\n";
      print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Emails'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      print FOUT "</TR>\n";
      print FOUT "</thead>\n";
      
      if ($display_all == 1) {
	  
	  if ($tmp > 1) {

	      print FOUT "<tfoot>\n";
	      print FOUT "<tr>\n";
	      print FOUT "<TH><A HREF=\"javascript:ToggleMenuAll2('Toggle_all2');\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$toggle_on\" NAME=\"ima_toggle\" BORDER=0 WIDTH=\"12\" HEIGHT=\"21\" TITLE=\"$L{'Click_here'}\" ALT=\"toggle\"></A></TH>\n";
	      print FOUT "<TH>$L{'Emails'}</TH>\n";
	      print FOUT "<TH>$L{'Occurence'}</TH>\n";
	      print FOUT "<TH>$L{'Percentage'}</TH>\n";
	      print FOUT "</tr>\n";
	      
	      print FOUT "<tr>\n";
	      $tmp2 = 4;
	      print FOUT "<td colspan=$tmp2>\n";
	      print FOUT "<a href=\"#\" onclick=\"pageexamplebis('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	      
	      for ($i=1;$i<=$tmp;$i++) {
		  $iminus = $i-1;
		  print FOUT "<a href=\"#\" id=\"pagebis$i\" class=\"pagelink\" onclick=\"pageexamplebis($iminus); return false;\">$i</a>\n";
	      }
	      print FOUT "<a href=\"#\" onclick=\"pageexamplebis('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	      print FOUT "<a href=\"#\" onclick=\"pageexamplebis('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	      print FOUT "</td>\n";
	      print FOUT "</tr>\n";
	      
	      print FOUT "</tfoot>\n";
	  }
      }
      
      print FOUT "<tbody>\n";

      $i = 0;
      $count = 0;
      foreach $page (&reverse_sort_by_value(*spam_daily_user_loc)) {
	  $count++;
	  $percentage = $spam_daily_user_loc{$page}*100/$spam_day_local;
	  $percentageint = int($percentage);
	  $page2 = $page;
	  $page2 =~ s/[@=]/_/g;
	  print FOUT "<TR>";
	  
	  print FOUT "<TD VALIGN=TOP ALIGN=LEFT WIDTH=\"10\" ";
	  print FOUT "OnClick=\"javascript:ToggleMenu('";
	  print FOUT "TOGGLE2_p$page2";
	  print FOUT "')\"";
	  print FOUT " TITLE=\"$L{'Click_here'}\">";
	  print FOUT "&gt;</TD>\n";
	  
	  print FOUT "<TD CLASS=\"left\">";
	  print FOUT "$page";
	  
	  print FOUT "\n<DIV ID=\"TOGGLE2_p$page2\" STYLE=\"display:none\">\n";
#	  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\" ID=\"p$page2\">\n";
	  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
	  print FOUT "<thead>\n";
	  print FOUT "<TR>\n";
	  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
	  print FOUT "</TR>\n";
	  print FOUT "</thead>\n";
	  print FOUT "<tbody>\n";

	  $tmp = $spam_daily_user_loc_unique{$page};
	  $tmp = $display_subitem if ($tmp > $display_subitem);

	  for ($j=1;$j<=$tmp;$j++) {
	      $host = $spam_daily_page{$page,$j};
	      print FOUT "<TR>\n";
	      print FOUT "<TD CLASS=\"left\">";
	      print FOUT "$host";
	      print FOUT "</TD>\n";
	      print FOUT "<TD CLASS=\"right\">$seen_spam{$page,$host}</TD>\n";
	      print FOUT "</TR>\n";
	  }
	  print FOUT "</tbody>\n";
	  print FOUT "</TABLE>\n";
	  
	  print FOUT "</DIV>\n";

	  print FOUT "</TD>\n";

	  print FOUT "<TD CLASS=\"right\" VALIGN=TOP>$spam_daily_user_loc{$page}</TD><TD CLASS=\"left\" VALIGN=TOP>";
	  print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($percentageint != 0);
	  printf FOUT "%.1f",$percentage;
	  print FOUT "&nbsp;%</TD>\n";
	  print FOUT "</TR>\n";
	  $i++;
	  last if (($i == $topten && $display_all == 0) || ($display_all == 1 && $count >= $max_item_page));
      }
      print FOUT "</tbody>\n";
      print FOUT "</TABLE>\n";
      print FOUT "<P><BR>\n";
  }

  print FOUT "</TD></TR></TABLE>\n";

  print FOUT "</BODY></HTML>\n";
}

####

sub PageResumeDest {
  local(*FOUT,*L,$I,$display_all) = @_;
  local($page,$percentage,$percentageint,$i,$max,$seen_users);

  $tmpa = $dirresume;
  $tmpa = $oldjour if ($scriptname eq "cron-pages.pl");
  $tmpa = $yesterday if ($scriptname eq "cron-inc.pl");
  $tmpa =~ s/\/\-/ /g;
  $tmpa =~ s/\_/ \/ /g;

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Destination'} - $tmpa</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\">\n";
  print FOUT "function ToggleMenuAll(obj) {\n";
  print FOUT " var elementsDIV = document.getElementsByTagName('div');\n";
  print FOUT "	for (var i = 0; i < elementsDIV.length; i++) {\n";
  print FOUT "     var el = elementsDIV[i].id;\n";
  print FOUT "     if (el.indexOf(\"TOGGLE_\") != -1) {\n";
  print FOUT "     elementsDIV[i].style.display  = (elementsDIV[i].style.display != 'none' ? 'none' : 'inline');\n";
  print FOUT "     }\n";
  print FOUT "	}\n";
  print FOUT "}\n";
  print FOUT "function ToggleMenu(obj) {\n";
  print FOUT "target = document.getElementById(obj);\n";
  print FOUT "if (target.style.display == \"none\"){\n";
  print FOUT "target.style.display = \"inline\";\n";
  print FOUT "} else {\n";
  print FOUT "target.style.display = \"none\";\n";
  print FOUT "}\n";
  print FOUT "}\n";
  print FOUT "</SCRIPT>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,3);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd2 TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,3);

  &PageResumeMenu(*FOUT, $link_next, eval($Lang{$lang[$nblang]}),$I);

  print FOUT "<H3>$L{'Destination'}</H3><P>\n";

  $max = $dailysizedest{(&reverse_sort_by_value(*dailysizedest))[0]};

  $unit = "$L{'bytes'}";
  $unitsize = 1;
  if ($max > 1024) {
      $unit = "$L{'Kb'}";
      $unitsize = 1024;
  }
  if ($max > (1024*1024)) {
      $unit = "$L{'Mb'}";
      $unitsize = 1024*1024;
  }
  if ($max > (1024*1024*1024)) {
      $unit = "$L{'Gb'}";
      $unitsize = 1024*1024*1024;
  }
  if ($max > (1024*1024*1024*1024)) {
      $unit = "$L{'Tb'}";
      $unitsize = 1024*1024*1024*1024;
  }

  $tmp10 = $dailydest_unique;
  $tmp10 = $max_item_page if ($tmp10 > $max_item_page);

  if ($show_all == 1) {
      if ($display_all == 1) {
	  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $tmp10 $L{'destination'}\n";
	  print FOUT " ($L{'among'} $dailydest_unique) " if ($tmp10 == $max_item_page);
      }
      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $topten $L{'destination'} ($L{'among'} $dailydest_unique)\n" if ($display_all == 0);
      print FOUT "&nbsp;<A HREF=\"$listdailydestination$htmlext\">$L{'Full_list'}</A>" if ($display_all == 0 && $dailydest_unique > $topten);
      print FOUT "</DIV>\n";
      print FOUT "<P><I>($L{'The_Top'} $display_subitem $L{'hosts'} $L{'are_shown'})</I>\n<P>" if ($display_subitem != 0);
  }

  if ($show_all == 0) {
      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $dailydest_unique $L{'destination'}</DIV>\n";
  }
  

  $tmp = int($tmp10/$table_lines_aff);
  if ($tmp != ($tmp10/$table_lines_aff)) {
      $tmp++;
  }

  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe ";
  print FOUT "table-autopage:$table_lines_aff " if ($tmp > 1 && $display_all == 1);
  print FOUT "table-stripeclass:alternate\" id=\"page\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH><A HREF=\"javascript:ToggleMenuAll('Toggle_all');\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$toggle_on\" NAME=\"ima_toggle\" BORDER=0 WIDTH=\"12\" HEIGHT=\"21\" TITLE=\"$L{'Click_here'}\" ALT=\"toggle\"></A></TH>\n" if ($display_subitem > 0);
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Destination'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  if ($notrafic == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  }
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";

  if ($display_all == 1) {

      if ($tmp > 1) {

	  print FOUT "<tfoot>\n";
	  print FOUT "<tr>\n";
	  print FOUT "<TH><A HREF=\"javascript:ToggleMenuAll('Toggle_all');\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$toggle_on\" NAME=\"ima_toggle\" BORDER=0 WIDTH=\"12\" HEIGHT=\"21\" TITLE=\"$L{'Click_here'}\" ALT=\"toggle\"></A></TH>\n" if ($display_subitem > 0);
	  print FOUT "<TH>$L{'Destination'}</TH>\n";
	  print FOUT "<TH>$L{'Hosts'}</TH>\n";
	  print FOUT "<TH>$L{'Occurence'}</TH>\n";
	  print FOUT "<TH>$L{'Percentage'}</TH>\n";
	  if ($notrafic == 0) {
	      print FOUT "<TH>$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n";
	      print FOUT "<TH>$L{'Percentage'}</TH>\n";
	  }
	  print FOUT "</tr>\n";

	  print FOUT "<tr>\n";
	  $tmp2 = 6;
	  $tmp2++ if ($display_subitem > 0);
	  $tmp2 -= 2 if ($notrafic == 1);
	  print FOUT "<td colspan=$tmp2>\n";
	  print FOUT "<a href=\"#\" onclick=\"pageexample('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	  
	  for ($i=1;$i<=$tmp;$i++) {
	      $iminus = $i-1;
	      print FOUT "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexample($iminus); return false;\">$i</a>\n";
	  }
	  print FOUT "<a href=\"#\" onclick=\"pageexample('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "<a href=\"#\" onclick=\"pageexample('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "</td>\n";
	  print FOUT "</tr>\n";

	  print FOUT "</tfoot>\n";
      }
  }

  print FOUT "<tbody>\n";


  $i = 0;
  $count = 0;
  foreach $dest (&reverse_sort_by_value(*dailydest)) {
      $count++;
      $percentage = $dailydest{$dest}*100/$reqtotjour if ($reqtotjour != 0);
      $percentageint = int($percentage);
      $dest2 = $dest;
      $dest2 =~ s/$dirsepurl//g;

      $seen_users = 0;
      for ($j=1;$j<=$nbhostday{$dest};$j++) {
	  $host = $dailyhostdest{$dest,$j};
	  $seen_users = 1 if ($dailyusersdest{$dest,$j} ne '');
      }

      print FOUT "<TR>";
      if ($display_subitem > 0) {
	  print FOUT "<TD VALIGN=TOP ALIGN=LEFT WIDTH=\"10\" ";
	  print FOUT "OnClick=\"javascript:ToggleMenu('";
	  print FOUT "TOGGLE_$dest2";
	  print FOUT "')\"";
	  print FOUT " TITLE=\"$L{'Click_here'}\">";
	  print FOUT "&gt;</TD>\n";
      }

      print FOUT "<TD CLASS=\"left\" TITLE=\"$L{'Click_here'}\">";
      print FOUT "<A HREF=\"javascript:ToggleMenu('TOGGLE_$dest2')\" STYLE=\"display:inline\">" if ($display_subitem > 0);
      print FOUT "$dest";
      if ($display_subitem > 0) {
	  print FOUT "</A>";
	  print FOUT "\n<DIV ID=\"TOGGLE_$dest2\" STYLE=\"display:none\">\n";

	  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\" ID=\"$dest2\">\n";
	  print FOUT "<thead>\n";
	  print FOUT "<TR>\n";
	  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
	  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Users'}&nbsp;</TH>\n" if ($seen_users == 1);
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n" if ($notrafic == 0);
	  print FOUT "</TR>\n";
	  print FOUT "</thead>\n";
	  print FOUT "<tbody>\n";
	  
	  $tmp = $nbhostday{$dest};
	  $tmp = $display_subitem if ($tmp > $display_subitem);
	  
#      for ($j=1;$j<=$nbhostday{$dest};$j++) {
	  for ($j=1;$j<=$tmp;$j++) {
	      $host = $dailyhostdest{$dest,$j};
	      print FOUT "<TR>\n";
	      print FOUT "<TD CLASS=\"left\">";
	      print FOUT "$host";
	      print FOUT "</TD>\n";
	      if ($seen_users == 1) {
		  $tmp2 = $dailyusersdest{$dest,$j};
		  $tmp2 = &EncryptLink($tmp) if ($crypt == 1);		  
#		  print FOUT "<TD CLASS=\"right\">$dailyusersdest{$dest,$j}</TD>\n";
		  print FOUT "<TD CLASS=\"right\">$tmp2</TD>\n";
	      }
	      print FOUT "<TD CLASS=\"right\">$seen_dest{$dest,$host}</TD>\n";
	      if ($notrafic == 0) {
		  print FOUT "<TD CLASS=\"right\">\n";
		  printf FOUT "%.2f",($dailyhostsizedest{$dest,$host}/$unitsize) if ($max >= 1);
		  printf FOUT "%.3f",($dailyhostsizedest{$dest,$host}/$unitsize) if ($max < 1);;
		  print FOUT "</TD>\n";
	      }
	      print FOUT "</TR>\n";
	  }
	  print FOUT "</tbody>\n";
	  print FOUT "</TABLE>\n";

	  print FOUT "</DIV>\n";
      }

      print FOUT "</TD>\n";
      print FOUT "<TD CLASS=\"right\">$nbhostday{$dest}</TD>\n";
      print FOUT "<TD CLASS=\"right\">$dailydest{$dest}</TD>\n";
      print FOUT "<TD CLASS=\"left\">";
      print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($percentageint != 0);
      printf FOUT "%.1f",$percentage;
      print FOUT "&nbsp;%</TD>\n";

      if ($notrafic == 0) {
	  $percentage = $dailysizedest{$dest}*100/$totsizejour if ($totsizejour != 0);
	  $percentageint = int($percentage);
	  print FOUT "<TD CLASS=\"right\">";
	  printf FOUT "%.2f",($dailysizedest{$dest}/$unitsize) if ($max >= 1);
	  printf FOUT "%.3f",($dailysizedest{$dest}/$unitsize) if ($max < 1);
	  print FOUT "</TD>\n";
	  print FOUT "<TD CLASS=\"left\">";
	  print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($percentageint != 0);
	  printf FOUT "%.1f",$percentage;
	  print FOUT "&nbsp;%</TD>\n";
      }

      print FOUT "</TR>\n";



      $i++;
      last if (($i == $topten && $display_all == 0) || ($display_all == 1 && $count >= $max_item_page));
  }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n";
  print FOUT "<P><BR>\n";

  print FOUT "</TD></TR></TABLE>\n";

  print FOUT "</BODY></HTML>\n";
}


####

sub PageResumeScript {
  local(*FOUT,*L,$I,$display_all) = @_;
  local($page,$tmp2,$status);

  $tmpa = $dirresume;
  $tmpa = $oldjour if ($scriptname eq "cron-pages.pl");
  $tmpa = $yesterday if ($scriptname eq "cron-inc.pl");
  $tmpa =~ s/\/\-/ /g;
  $tmpa =~ s/\_/ \/ /g;

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Scripts'} - $tmpa</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,3);

  print FOUT "</HEAD>\n";
#  print FOUT "<!-- PAGE BREAK -->\n"; # PDF break
  print FOUT "<BODY $backgrd2 TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,3);

#  print FOUT "<TABLE WIDTH=\"100%\"><TR><TD VALIGN=TOP>\n";

  &PageResumeMenu(*FOUT, $link_next, eval($Lang{$lang[$nblang]}),$I);

#  print FOUT "</TD>\n<TD VALIGN=TOP>\n";

  $tmp10 = $scriptuniquejour;
  $tmp10 = $max_item_page if ($tmp10 > $max_item_page);

  print FOUT "<H3> $L{'ListOf'} $L{'scripts'} $L{'used'}</H3><P>\n";

  if ($scriptuniquejour != 0) {

      if ($show_all == 1) {
	  if ($display_all == 1) {
	      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $tmp10 $L{'scripts'}\n";
	      print FOUT " ($L{'among'} $scriptuniquejour) " if ($tmp10 == $max_item_page);
	  }
	  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $topten $L{'scripts'} ($L{'among'} $scriptuniquejour)\n" if ($display_all == 0);
	  print FOUT "&nbsp;<A HREF=\"$listdailyscripts$htmlext\">$L{'Full_list'}</A>" if ($display_all == 0 && $scriptuniquejour > $topten);
	  print FOUT "</DIV>\n";
      }

      if ($show_all == 0) {
	  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $scriptuniquejour $L{'scripts'}</DIV>\n";
      }
  
      print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe ";
      print FOUT "table-autopage:$table_lines_aff " if ($tmp10 > 1 && $display_all == 1);
#      print FOUT "table-autopage:$table_big_lines_aff " if ($tmp10 > $table_big_lines_aff);
#      print FOUT "table-stripeclass:alternate\" id=\"page\">\n";
      print FOUT "table-stripeclass:alternate\" id=\"page\">\n";
      print FOUT "<thead>\n";
      print FOUT "<TR>\n";
      print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Destination'}&nbsp;</TH>\n" if ($squid_format == 1);
      print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Pages'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
      print FOUT "</TR>\n";
      print FOUT "</thead>\n";

  if ($display_all == 1) {

      $tmp2 = int($tmp10/$table_lines_aff);
      if ($tmp2 != ($tmp10/$table_lines_aff)) {
	  $tmp2++;
      }

      if ($tmp2 > 1) {
	  print FOUT "<tfoot>\n";
	  print FOUT "<tr>\n";
	  print FOUT "<TH>$L{'Destination'}</TH>\n" if ($squid_format == 1);
	  print FOUT "<TH>$L{'Pages'}</TH>\n";
	  print FOUT "<TH>$L{'Occurence'}</TH>\n";
	  print FOUT "</tr>\n";
	  
	  print FOUT "<tr>\n";
	  print FOUT "<td colspan=2>\n" if ($squid_format == 0);
	  print FOUT "<td colspan=3>\n" if ($squid_format == 1);
	      
	  print FOUT "<a href=\"#\" onclick=\"pageexample('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	  
	  for ($i=1;$i<=$tmp2;$i++) {
	      $iminus = $i-1;
	      print FOUT "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexample($iminus); return false;\">$i</a>\n";
	  }
	  print FOUT "<a href=\"#\" onclick=\"pageexample('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "<a href=\"#\" onclick=\"pageexample('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "</td>\n";
	  print FOUT "</tr>\n";

	  print FOUT "</tfoot>\n";
      }
  }

      print FOUT "<tbody>\n";

      $count = 0;
      $i = 0;

      foreach $page (&reverse_sort_by_value(*scriptday)) {
	  $count++;
	  print FOUT "<TR>\n";
	  if ($squid_format == 1) {
	      $tmp = index($page,$dirsep,1);
	      $tmp1 = substr($page,0,$tmp+1);
	      $tmp6 = substr($page,$tmp,length($page));
	      print FOUT "<TD CLASS=\"left\">$tmp1</TD>\n";
#	      print FOUT "<TD CLASS=\"left\">$tmp6</TD>\n";
	  }
	  print FOUT "<TD CLASS=\"left\">";
	  $link = &AddHREF($page) if ($squid_format == 0);
	  $link = &AddHREF($tmp6) if ($squid_format == 1);
	  print FOUT "$link";
#	  if ($squid_format == 0) {
#	      print FOUT "$page" if ($titlename == 0);
#	      print FOUT "$urlconv{$page}" if ($titlename == 1 && $urlconv{$page} ne '');
#	      print FOUT "$page" if ($titlename == 1 && $urlconv{$page} eq '');
#	  }
	  print FOUT "</TD>\n";
	  print FOUT "<TD CLASS=\"right\">$scriptday{$page}</TD>\n</TR>\n";
	  $i++;
	  last if (($i == $topten && $display_all == 0) || ($display_all == 1 && $count >= $max_item_page));	  
      }
      print FOUT "</tbody>\n";
      print FOUT "</TABLE>\n";
  } else {
      print FOUT "<I>$L{'Scripts'} : $L{'No_request'}</I><P>\n";
  }

  $tmp10 = keys(%client_day_error);
  $tmp10 = $max_item_page if ($tmp10 > $max_item_page);

  $status = 404;

  if ($tmp10 != 0) {
      print FOUT "<P><BR>\n";
      print FOUT "<H3>$L{'Status_code'} : $status - $FailStatusMsgs{$status}</H3><P>\n";
      
      $j = 0;

      print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe ";
#      print FOUT "table-autopage:$table_big_lines_aff " if ($tmp10 > $table_big_lines_aff && $display_all == 1);
      print FOUT "table-autopage:$table_lines_aff " if ($tmp10 > 1 && $display_all == 1);
#      print FOUT "table-stripeclass:alternate\" id=\"page\">\n";
#      print FOUT "table-stripeclass:alternate\">\n";
      print FOUT "table-stripeclass:alternate\" id=\"pagebis\">\n";

      print FOUT "<thead>\n";
      print FOUT "<TR>\n";
      print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Destination'}&nbsp;</TH>\n" if ($squid_format == 1);
      print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Pages'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'coming_from'}&nbsp;</TH>\n" if ($struct_logfile =~ /\%refer/);
      print FOUT "</TR>\n";
      print FOUT "</thead>\n";

#  if ($tmp10 > $table_big_lines_aff && $display_all == 1) {
      if ($display_all == 1) {

      $tmp = int($tmp10/$table_lines_aff);
      if ($tmp != ($tmp10/$table_lines_aff)) {
	  $tmp++;
      }

      if ($tmp > 1) {    
	  print FOUT "<tfoot>\n";
	  print FOUT "<tr>\n";

	  print FOUT "<TH>&nbsp;$L{'Destination'}&nbsp;</TH>\n" if ($squid_format == 1);
	  print FOUT "<TH>&nbsp;$L{'Pages'}&nbsp;</TH>\n";
	  print FOUT "<TH>&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
	  print FOUT "<TH>&nbsp;$L{'coming_from'}&nbsp;</TH>\n" if ($struct_logfile =~ /\%refer/);
	  print FOUT "</tr>\n";
	  print FOUT "<tr>\n";
	  
	  $tmp9 = 2;
	  $tmp9++ if ($squid_format == 1);
	  $tmp9++ if ($struct_logfile =~ /\%refer/);
	  print FOUT "<td colspan=$tmp9>\n";
	  print FOUT "<a href=\"#\" onclick=\"pageexamplebis('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	  
	  for ($i=1;$i<=$tmp;$i++) {
	      $iminus = $i-1;
	      print FOUT "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexamplebis($iminus); return false;\">$i</a>\n";
	  }
	  print FOUT "<a href=\"#\" onclick=\"pageexamplebis('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "<a href=\"#\" onclick=\"pageexamplebis('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "</td>\n";
	  print FOUT "</tr>\n";
      }
      print FOUT "</tfoot>\n";
  }

      print FOUT "<tbody>\n";

      $count = 0;
      foreach $page (&reverse_sort_by_value(*client_day_error)) {
#	  if ($display_all == 0 || ($display_all == 1 && $client_day_error{$page} > $seuilscript)) {
	  $count++;
	      $tmp2 = $page;
	      $tmp2 =~ s/\&.*//;
	      $tmp2 =~ s/</&lt;/g;      
	      $tmp2 =~ s/>/&gt;/g;
	      print FOUT "<TR>\n";

	      if ($squid_format == 1) {
		  $tmp = index($tmp2,$dirsep,1);
		  $tmp1 = substr($tmp2,0,$tmp+1);
		  $tmp6 = substr($tmp2,$tmp,length($tmp2));
		  print FOUT "<TD CLASS=\"left\">$tmp1</TD>\n";
	      }
	      print FOUT "<TD CLASS=\"left\">$tmp6</TD>\n" if ($squid_format == 1);
	      print FOUT "<TD CLASS=\"left\">$tmp2</TD>\n" if ($squid_format == 0);
	      print FOUT "<TD CLASS=\"right\">$client_day_error{$page}</TD>\n";
	      if ($struct_logfile =~ /\%refer/) {
		  print FOUT "<TD CLASS=\"right\">$client_day_refer{$page}</TD>\n" if ($client_day_refer{$page} ne "");
		  print FOUT "<TD CLASS=\"right\">&nbsp;</TD>\n" if ($client_day_refer{$page} eq "");
	      }
	      print FOUT "</TR>\n";
	      $j++;
	      last if (($j == $topten && $display_all == 0) || ($display_all == 1 && $count >= $max_item_page));
#	  }
      }
      print FOUT "</tbody>\n";
      print FOUT "</TABLE>\n";
  } else {
      print FOUT "<P><BR>\n";
      print FOUT "<I>$L{'Status_code'} - $status : $L{'No_request'}</I>\n";
  }

  print FOUT "<P><BR>\n";

  print FOUT "</TD></TR></TABLE>\n";

  print FOUT "</BODY></HTML>\n";
}

###

sub PageResumeVirus {
  local(*FOUT,*L,$I) = @_;
  local($page);

  $tmpa = $dirresume;
  $tmpa = $oldjour if ($scriptname eq "cron-pages.pl");
  $tmpa = $yesterday if ($scriptname eq "cron-inc.pl");
  $tmpa =~ s/\/\-/ /g;
  $tmpa =~ s/\_/ \/ /g;

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Virus'} - $tmpa</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,3);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd2 TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,3);

  &PageResumeMenu(*FOUT, $link_next, eval($Lang{$lang[$nblang]}),$I);

  print FOUT "<H3> $L{'ListOf'} $L{'virus'}</H3><P>\n";

  $tmp = 0;
  for ($i=0;$i<=$#list_virus;$i++) {
      $tmp += $count_day_virus[$i];
  }

  if ($tmp != 0) {
      
      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $nb_day_virus $L{'virus'} ($tmp $L{'requests'})</DIV>\n";

      print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
      print FOUT "<thead>\n";
      print FOUT "<TR>\n";
      print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Virus'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
      print FOUT "</TR>\n";
      print FOUT "</thead>\n";
      print FOUT "<tbody>\n";

      for ($i=0;$i<=$#list_virus;$i++) {

	  if ($count_day_virus[$i] != 0) {
	      $pourcentage = (($count_day_virus[$i]*1000)/$tmp)/10;
	      $pourcentageint = int($pourcentage);
	      
	      print FOUT "<TR><TD CLASS=\"head_left\">$list_virus[$i]</TD><TD CLASS=\"left\">";
	      print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"> " if ($pourcentageint != 0);
	      printf FOUT "%.1f",$pourcentage;
	      print FOUT "&nbsp;%";
	      print FOUT "</TD><TD>$count_day_virus[$i]</TD></TR>\n";
	      
	      for ($j=1;$j<=$count_day_host_virus[$i];$j++) {
		  $val = $list_day_host_virus{$i,$j};
		  $pourcentage = (($virus_day_site{$i,$val}*1000)/$count_day_virus[$i])/10;
		  $pourcentageint = int($pourcentage);
		  ($tmp2) = split(/:/,$virus_day_date{$i,$val});
		  print FOUT "<TR>";
		  print FOUT "<TD CLASS=\"right\">$val</TD>\n";
		  print FOUT "<TD CLASS=\"left\">\n";
		  print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
		  printf FOUT "%.1f",$pourcentage;
		  print FOUT "&nbsp;%";
		  print FOUT "</TD>\n<TD CLASS=\"right\">$virus_day_site{$i,$val}</TD>\n";
		  print FOUT "</TR>";
	      }
	  }
      }
      print FOUT "</tbody>\n";
      print FOUT "</TABLE>";
  } else {
      print FOUT "<I>$L{'No_request'}</I>\n";
  }

  print FOUT "<P><BR>\n";
  print FOUT "</TD></TR></TABLE>\n";

  print FOUT "</BODY></HTML>\n";
}

###

sub PageResumeTrafic {
  local(*FOUT,*L,$I,$display_all) = @_;
  local($i,$pourcentage,$unitsize,$max,$tmp,$tmp2,$tmp10);

  $tmpa = $dirresume;
  $tmpa = $oldjour if ($scriptname eq "cron-pages.pl");
  $tmpa = $yesterday if ($scriptname eq "cron-inc.pl");
  $tmpa =~ s/\/\-/ /g;
  $tmpa =~ s/\_/ \/ /g;

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Traffic'} - $tmpa</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\">\n";
  print FOUT "function ToggleMenuAll(obj) {\n";
  print FOUT " var elementsDIV = document.getElementsByTagName('div');\n";
  print FOUT "	for (var i = 0; i < elementsDIV.length; i++) {\n";
  print FOUT "     var el = elementsDIV[i].id;\n";
  print FOUT "     if (el.indexOf(\"TOGGLE_\") != -1) {\n";
  print FOUT "     elementsDIV[i].style.display  = (elementsDIV[i].style.display != 'none' ? 'none' : 'inline');\n";
  print FOUT "     }\n";
  print FOUT "	}\n";
  print FOUT "}\n";
  print FOUT "function ToggleMenu(obj) {\n";
  print FOUT "target = document.getElementById(obj);\n";
  print FOUT "if (target.style.display == \"none\"){\n";
  print FOUT "target.style.display = \"inline\";\n";
  print FOUT "} else {\n";
  print FOUT "target.style.display = \"none\";\n";
  print FOUT "}\n";
  print FOUT "}\n";
  print FOUT "</SCRIPT>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,3);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd2 TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,3);
  $max = $dailysizepage{(&reverse_sort_by_value(*dailysizepage))[0]};

  $unit = "$L{'bytes'}";
  $unitsize = 1;
  if ($max > 1024) {
      $unit = "$L{'Kb'}";
      $unitsize = 1024;
  }
  if ($max > (1024*1024)) {
      $unit = "$L{'Mb'}";
      $unitsize = 1024*1024;
  }
  if ($max > (1024*1024*1024)) {
      $unit = "$L{'Gb'}";
      $unitsize = 1024*1024*1024;
  }
  if ($max > (1024*1024*1024*1024)) {
      $unit = "$L{'Tb'}";
      $unitsize = 1024*1024*1024*1024;
  }

  &PageResumeMenu(*FOUT, $link_next, eval($Lang{$lang[$nblang]}),$I);

  print FOUT "<H3> $L{'Traffic'}</H3><P>\n";

  print FOUT "<A HREF=\"$dirtraffic$csvext\" TITLE=\"Export in CSV\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$homeicons2$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>";

#  $max = $dailysizepage{(&reverse_sort_by_value(*dailysizepage))[0]}/$unitsize;

#  $traficlimit_display = (int(10*($max/$unitsize))/10)/100;
#  $traficlimit_display = 0.1;

  $tmp = keys(%dailysizepage);
  $tmp10 = $tmp;
  $tmp10 = $max_item_page if ($tmp10 > $max_item_page);

  if ($show_all == 1) {
      if ($display_all == 1) {
	  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $tmp10 $L{'files'} ";
	  print FOUT " ($L{'among'} $tmp) " if ($tmp10 == $max_item_page);
      }
      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $topten $L{'files'} ($L{'among'} $tmp)\n" if ($display_all == 0);
      print FOUT "&nbsp;<A HREF=\"$listdailytrafic$htmlext\">$L{'Full_list'}</A>" if ($display_all == 0 && $tmp > $topten);
      print FOUT "</DIV>\n";

      print FOUT "<P><I>($L{'The_Top'} $display_subitem $L{'hosts'} $L{'are_shown'})</I>\n<P>" if ($mail_format == 0 && $cups_format == 0 && $display_subitem != 0);
  }

  if ($show_all == 0) {
      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $tmp $L{'files'}</DIV>\n";
  }

  $tmp2 = int($tmp10/$table_lines_aff);
  if ($tmp2 != ($tmp10/$table_lines_aff)) {
      $tmp2++;
  }

  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe ";
  print FOUT "table-autopage:$table_lines_aff " if ($tmp2 > 1 && $display_all == 1);
  print FOUT "table-stripeclass:alternate\" id=\"page\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH><A HREF=\"javascript:ToggleMenuAll('Toggle_all');\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$toggle_on\" NAME=\"ima_toggle\" BORDER=0 WIDTH=\"12\" HEIGHT=\"21\" TITLE=\"$L{'Click_here'}\" ALT=\"toggle\"></A></TH>\n" if ($mail_format == 0 && $cups_format == 0 && $display_subitem > 0);
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Destination'}&nbsp;</TH>\n" if ($squid_format == 1);
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Files'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  if ($precision > 3 || $squid_format == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  }
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";

  if ($display_all == 1) {

      if ($tmp2 > 1) {
	  print FOUT "<tfoot>\n";
	  print FOUT "<tr>\n";
	  print FOUT "<TH><A HREF=\"javascript:ToggleMenuAll('Toggle_all');\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$toggle_on\" NAME=\"ima_toggle\" BORDER=0 WIDTH=\"12\" HEIGHT=\"21\" TITLE=\"$L{'Click_here'}\" ALT=\"toggle\"></A></TH>\n" if ($mail_format == 0 && $cups_format == 0 && $display_subitem > 0);
	  print FOUT "<TH>$L{'Destination'}</TH>\n" if ($squid_format == 1);
	  print FOUT "<TH>$L{'Files'}</TH>\n";
	  print FOUT "<TH>$L{'Traffic'}&nbsp;($unit)</TH>\n";
	  print FOUT "<TH>$L{'Percentage'}</TH>\n";
	  if ($precision > 3 || $squid_format == 0) {
	      print FOUT "<TH>$L{'Occurence'}</TH>\n";
	      print FOUT "<TH>$L{'Percentage'}</TH>\n";
	  }
	  print FOUT "</tr>\n";
	  
	  print FOUT "<tr>\n";
	  print FOUT "<td colspan=6>\n" if ($squid_format == 0);
	  print FOUT "<td colspan=7>\n" if ($squid_format == 1);
	      
	  print FOUT "<a href=\"#\" onclick=\"pageexample('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	  
	  for ($i=1;$i<=$tmp2;$i++) {
	      $iminus = $i-1;
	      print FOUT "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexample($iminus); return false;\">$i</a>\n";
	  }
	  print FOUT "<a href=\"#\" onclick=\"pageexample('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "<a href=\"#\" onclick=\"pageexample('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "</td>\n";
	  print FOUT "</tr>\n";

	  print FOUT "</tfoot>\n";
      }
  }

  print FOUT "<tbody>\n";

  $i = 0;
  $count = 0;
  foreach $page (&reverse_sort_by_value(*dailysizepage)) {
#     if ($display_all == 0 || ($display_all == 1 && $filetypejour{$page} > $seuilpage)) {
#     if ($display_all == 0 || ($display_all == 1 && $dailysizepage{$page}/$unitsize > $traficlimit_display)) {
      $count++;

      $page2 = $page;
      $page2 =~ s/$dirsepurl/_/g;

      $tmp10 = $nbfilehostday{$page};
      $tmp10 = $display_subitem if ($tmp10 > $display_subitem);

      print FOUT "<TR>\n";
      if ($mail_format == 0 && $cups_format == 0 && $display_subitem > 0) {
	  print FOUT "<TD VALIGN=TOP ALIGN=LEFT WIDTH=\"10\" ";
	  if ($tmp10 > 0) {
	      print FOUT "OnClick=\"javascript:ToggleMenu('";
	      print FOUT "TOGGLE_p$page2";
	      print FOUT "')\"";
	      print FOUT " TITLE=\"$L{'Click_here'}\"";
	  }
	  print FOUT ">&gt;</TD>\n";
      }

      if ($squid_format == 1) {
	  $tmp = index($page,$dirsep,1);
	  if ($tmp != -1) {
	      $tmp1 = substr($page,0,$tmp+1);
	      $tmp6 = substr($page,$tmp,length($page));
	  } else {
	      $tmp1 = $page;
	      $tmp6 = '';
	  }
	  print FOUT "<TD CLASS=\"left\">$tmp1</TD>\n";
      }

      print FOUT "<TD CLASS=\"left\">";
      $link = $page;
      $link = &EncryptLink($link) if ($crypt == 1);
      print FOUT "$link\n" if ($squid_format == 0);
      print FOUT "$tmp6\n" if ($squid_format == 1);

    if ($tmp10 > 0 && $mail_format == 0 && $cups_format == 0 && $display_subitem > 0) {
	  print FOUT "\n<DIV ID=\"TOGGLE_p$page2\" STYLE=\"display:none\">\n";
	  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\" ID=\"p$page2\">\n";
	  print FOUT "<thead>\n";
	  print FOUT "<TR>\n";
	  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
	  print FOUT "</TR>\n";
	  print FOUT "</thead>\n";
	  print FOUT "<tbody>\n";



	  # Tri a mettre ailleurs !
#	  if ($nbfilehostday{$page} > $display_subitem) {
#	  for ($j=1;$j<=$nbfilehostday{$page};$j++) {
#	      $adresse = $filelistday{$page,$j};
#	      $occ = $filelist_hostday{$page,$adressehad{$adresse}};	      
#	      $trafdailymax = $occ if ($occ > $trafdailymax);
#	  }
#	  }

	  for ($j=1;$j<=$tmp10;$j++) {
	      $host = $filelistday{$page,$j};
	      print FOUT "<TR>\n";
	      print FOUT "<TD CLASS=\"left\">";
	      print FOUT "$host";
	      print FOUT "</TD>\n";
	      print FOUT "<TD CLASS=\"right\">$filelist_hostday{$page,$adressehad{$host}}</TD>\n";
	      print FOUT "</TR>\n";
	  }
	  print FOUT "</tbody>\n";
	  print FOUT "</TABLE>\n";
	  print FOUT "</DIV>\n";
      }

      print FOUT "</TD>\n";

#      print FOUT "<TD CLASS=\"right\">$pagesluesday{$page}</TD>\n";
	 print FOUT "<TD CLASS=\"right\" VALIGN=TOP>";
	 printf FOUT "%.2f",($dailysizepage{$page}/$unitsize) if ($max >= 1);
	 printf FOUT "%.3f",($dailysizepage{$page}/$unitsize) if ($max < 1);
	 print FOUT "</TD>\n<TD CLASS=\"left\" VALIGN=TOP>";
	 $pourcentage = 100*$dailysizepage{$page}/$totsizejour if ($totsizejour != 0);
	 $pourcentageint = int($pourcentage);
	 print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
	 printf FOUT "%.1f",$pourcentage;
	 print FOUT "&nbsp;%</TD>\n";
      if ($precision > 3 || $squid_format == 0) {
	  print FOUT "<TD CLASS=\"right\" VALIGN=TOP>&nbsp;";
	  $tmp = $filetypejour{$page};
	  $tmp = $pagesluesday{$page} if ($tmp eq '');
	  print FOUT "$tmp";
	  print FOUT "&nbsp;</TD>\n";
	  print FOUT "<TD CLASS=\"left\" VALIGN=TOP>&nbsp;\n";
#	 $pourcentage = 100*$filetypejour{$page}/$reqtotjour;
	  $pourcentage = 100*$tmp/$reqtotjour if ($reqtotjour != 0);
	 $pourcentageint = int($pourcentage);
	  print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
	 printf FOUT "%.1f",$pourcentage;
	  print FOUT "&nbsp;%";

#	$filelist_hostday{$tmp,$adressehad{$adresse}}++; # Nbre total pour la boucle
#	if ($filelist_hostday{$tmp,$adressehad{$adresse}} == 1) { # Occurence
#	    $nbfilehostday{$tmp}++; # counter
#	    $filelistday{$tmp,$nbfilehostday{$tmp}} = $adresse;
#	}



########################################################################
#  for ($j=1;$j<=$nbfilehost{$page};$j++) {
#      $adresse2 = $filelist{$page,$j};
#      $tmp2 = $filelist_date{$page,$adressehad{$adresse2}};
#      ($date_tmp) = &get_time($tmp2*86400);
#      $date_tmp =~ s/\// /g;
#      print FOUT "$j - $adresse2 - $filelist_host{$page,$adressehad{$adresse2}} - $date_tmp<BR>\n";
#  }
########################################################################


	  print FOUT "</TD>\n";
      }
	 print FOUT "</TR>\n";
	 $i++;
	 last if (($i == $topten && $display_all == 0) || ($display_all == 1 && $count >= $max_item_page));
#     }
 }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n";

  print FOUT "<P><BR>\n";
  print FOUT "</TD></TR></TABLE>\n";

#  print FOUT "<!-- PAGE BREAK -->\n"; # PDF break
  print FOUT "</BODY></HTML>\n";
}

####

sub PageResumeFiletype {
  local(*FOUT,*L,$I,$display_all) = @_;
  local($page,$tmp2,$tmp3,@seen_filetype);

  $tmpa = $dirresume;
  $tmpa = $oldjour if ($scriptname eq "cron-pages.pl");
  $tmpa = $yesterday if ($scriptname eq "cron-inc.pl");
  $tmpa =~ s/\/\-/ /g;
  $tmpa =~ s/\_/ \/ /g;

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Filetype'} - $tmpa</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,3);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd2 TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,3);

  &PageResumeMenu(*FOUT, $link_next, eval($Lang{$lang[$nblang]}),$I);

  print FOUT "<H3> $L{'Filetype'}</H3><P>\n";
  print FOUT "<P>\n";

  print FOUT "<p>\n<table class=\"tablesort table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";

  print FOUT "<TR>\n<TH>&nbsp;$L{'Files'}&nbsp;</TH>\n<TH>&nbsp;$L{'Occurence'}&nbsp;</TH>\n<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";

  for ($l=0;$l<=$nbzonefile;$l++) {

      $k = $filetypejourmax[$l];
#      print "YY $l - $k - $zoneextjour[$k] - $seen_filetype[$k]\n";
      next if ($zoneextjour[$k] == 0 || $seen_filetype[$k] > 0);
      $seen_filetype[$k]++;

      $percentage = $zoneextjour[$k]*100/$reqtotjour if ($reqtotjour != 0);
      $percentage = 0 if ($reqtotjour == 0);
      $percentageint = int($percentage);
      print FOUT "<TR><TD CLASS=\"head_left\">$zonefile[$k]</TD>\n<TD CLASS=\"head_right\">$zoneextjour[$k] $L{'times'}</TD>\n<TD CLASS=\"head_left\">";
      print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"> " if ($percentageint != 0);
      printf FOUT "%.1f",$percentage;
      print FOUT "&nbsp;%</TD></TR>\n";

      $tmp3 = 0;
      for ($i=0;$i<=$#listext;$i++) {
	next if ($listext[$k] =~ /$extension/ && $ftp_format == 0);
	if ($k == $extfilenb{$listext[$i]}) {
	    $tmp2 = $downloadjour{$listext[$i]};
	    if ($tmp2 != 0) {
		$percentage = $tmp2*100/$zoneextjour[$k];
		$percentageint = int($percentage);
		$tmp3++;
		print FOUT "<TR>\n";
		print FOUT "<TD CLASS=\"left\">" if (($tmp3/2) == int($tmp3/2));
		print FOUT "<TD CLASS=\"left_alter\">" if (($tmp3/2) != int($tmp3/2));
		print FOUT "$extfile{$listext[$i]} ($listext[$i])</TD>\n";
		print FOUT "<TD CLASS=\"right\">" if (($tmp3/2) == int($tmp3/2));
		print FOUT "<TD CLASS=\"right_alter\">" if (($tmp3/2) != int($tmp3/2));
		print FOUT "$tmp2</TD>\n";
		print FOUT "<TD CLASS=\"left\">\n" if (($tmp3/2) == int($tmp3/2));
		print FOUT "<TD CLASS=\"left_alter\">\n" if (($tmp3/2) != int($tmp3/2));
		print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($percentageint != 0);
		printf FOUT "%.1f",$percentage;
		print FOUT "&nbsp;%</TD></TR>\n";
	    }
	}
    }
  }
  print FOUT "</TABLE>\n";
  print FOUT "<P><BR>\n";

  print FOUT "</TD></TR>";
  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n";

  print FOUT "</BODY></HTML>\n";
}


####

sub PageResumeUsers {
  local(*FOUT,*L,$I,$display_all) = @_;
  local($page,$percentage,$percentageint,$i);

  $tmpa = $dirresume;
  $tmpa = $oldjour if ($scriptname eq "cron-pages.pl");
  $tmpa = $yesterday if ($scriptname eq "cron-inc.pl");
  $tmpa =~ s/\/\-/ /g;
  $tmpa =~ s/\_/ \/ /g;

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Users'} - $tmpa</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\">\n";
  print FOUT "function ToggleMenuAll(obj) {\n";
  print FOUT " var elementsDIV = document.getElementsByTagName('div');\n";
  print FOUT "	for (var i = 0; i < elementsDIV.length; i++) {\n";
  print FOUT "     var el = elementsDIV[i].id;\n";
  print FOUT "     if (el.indexOf(\"TOGGLE_\") != -1) {\n";
  print FOUT "     elementsDIV[i].style.display  = (elementsDIV[i].style.display != 'none' ? 'none' : 'inline');\n";
  print FOUT "     }\n";
  print FOUT "	}\n";
  print FOUT "}\n";
  print FOUT "function ToggleMenu(obj) {\n";
  print FOUT "target = document.getElementById(obj);\n";
  print FOUT "if (target.style.display == \"none\"){\n";
  print FOUT "target.style.display = \"inline\";\n";
  print FOUT "} else {\n";
  print FOUT "target.style.display = \"none\";\n";
  print FOUT "}\n";
  print FOUT "}\n";
  print FOUT "</SCRIPT>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,3);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd2 TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,3);

  &PageResumeMenu(*FOUT, $link_next, eval($Lang{$lang[$nblang]}),$I);

  print FOUT "<H3> $L{'Users'}</H3><P>\n";

  if (scalar(%userday) > 0) {

  print FOUT "<A HREF=\"$users$csvext\" TITLE=\"Export in CSV\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$homeicons2$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>";
  print FOUT "<A HREF=\"$listuserscsv\" TITLE=\"Export in CSV\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$homeicons2$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV-FullList\"></A>";

  $tmp = $user_trafficday{(&reverse_sort_by_value(*user_trafficday))[0]};
  $unit = "$L{'bytes'}";
  $unit = "$L{'Kb'}" if ($tmp > 1024);
  $unit = "$L{'Mb'}" if ($tmp > (1024*1024));
  $unit = "$L{'Gb'}" if ($tmp > (1024*1024*1024));
  $unit = "$L{'Tb'}" if ($tmp > (1024*1024*1024*1024));

  $tmp10 = $nb_userday;
  $tmp10 = $max_item_page if ($tmp10 > $max_item_page);

  if ($show_all == 1) {
      if ($display_all == 1) {
	  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $tmp10 $L{'Users'}\n";
	  print FOUT " ($L{'among'} $nb_userday) " if ($tmp10 == $max_item_page);
      }

      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $topten $L{'Users'} ($L{'among'} $nb_userday)\n" if ($display_all == 0);
      print FOUT "&nbsp;<A HREF=\"$listdailyusers$htmlext\">$L{'Full_list'}</A>" if ($display_all == 0 && $nb_userday > $topten);
      print FOUT "</DIV>\n";
      print FOUT "<P><I>($L{'The_Top'} $display_subitem $L{'pages'} $L{'are_shown'})</I>\n<P>" if ($display_subitem != 0);
  }

  if ($show_all == 0) {
      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $nb_userday $L{'Users'}</DIV>\n";
  }
  

  $tmp = int($tmp10/$table_lines_aff);
  if ($tmp != ($tmp10/$table_lines_aff)) {
      $tmp++;
  }

  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe ";
  print FOUT "table-autopage:$table_lines_aff " if ($tmp > 1 && $display_all == 1);
  print FOUT "table-stripeclass:alternate\" id=\"page\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH><A HREF=\"javascript:ToggleMenuAll('Toggle_all');\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$toggle_on\" NAME=\"ima_toggle\" BORDER=0 WIDTH=\"12\" HEIGHT=\"21\" TITLE=\"$L{'Click_here'}\" ALT=\"toggle\"></A></TH>\n" if ($display_subitem > 0);
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Users'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Requests'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  }
  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Different_accesses'}&nbsp;</TH>\n";
  if ($notrafic == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  }
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";

  if ($display_all == 1) {

      if ($tmp > 1) {

	  print FOUT "<tfoot>\n";
	  print FOUT "<tr>\n";
	  print FOUT "<TH><A HREF=\"javascript:ToggleMenuAll('Toggle_all');\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$toggle_on\" NAME=\"ima_toggle\" BORDER=0 WIDTH=\"12\" HEIGHT=\"21\" TITLE=\"$L{'Click_here'}\" ALT=\"toggle\"></A></TH>\n" if ($display_subitem > 0);
	  print FOUT "<TH>$L{'Users'}</TH>\n";
	  print FOUT "<TH>$L{'Requests'}</TH>\n";
	  print FOUT "<TH>$L{'Percentage'}</TH>\n";
	  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	      print FOUT "<TH>$L{'Accesses'}</TH>\n";
	      print FOUT "<TH>$L{'Percentage'}</TH>\n";
	  }
	  print FOUT "<TH>$L{'Different_accesses'}&nbsp;</TH>\n";
	  if ($notrafic == 0) {
	      print FOUT "<TH>$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n";
	      print FOUT "<TH>$L{'Percentage'}</TH>\n";
	  }
	  print FOUT "</tr>\n";

	  print FOUT "<tr>\n";
	  $tmp10 = 4;
	  $tmp10++ if ($display_subitem > 0);
	  $tmp10 += 2 if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
	  $tmp10 += 2 if ($notrafic == 0);
	  print FOUT "<td colspan=$tmp10>\n";
	  print FOUT "<a href=\"#\" onclick=\"pageexample('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	  
	  for ($i=1;$i<=$tmp;$i++) {
	      $iminus = $i-1;
	      print FOUT "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexample($iminus); return false;\">$i</a>\n";
	  }
	  print FOUT "<a href=\"#\" onclick=\"pageexample('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "<a href=\"#\" onclick=\"pageexample('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "</td>\n";
	  print FOUT "</tr>\n";

	  print FOUT "</tfoot>\n";
      }
  }

  print FOUT "<tbody>\n";


  $i = 0;
  $count = 0;
  foreach $login (&reverse_sort_by_value(*userday)) {
      $count++;

      $tmp = $login;
      $tmp =~ s/\\//g;

      print FOUT "<TR>";
      if ($display_subitem > 0) {
      print FOUT "<TD VALIGN=TOP ALIGN=LEFT WIDTH=\"10\" ";
      if ($nbusersday{$login} > 0) {
	  print FOUT "OnClick=\"javascript:ToggleMenu('";
	  print FOUT "TOGGLE_$tmp";
	  print FOUT "')\"";
	  print FOUT " TITLE=\"$L{'Click_here'}\"";
      }
      print FOUT ">&gt;</TD>\n";
      }

      print FOUT "<TD CLASS=\"left\" TITLE=\"$L{'Click_here'}\">";
      print FOUT "<A HREF=\"javascript:ToggleMenu('TOGGLE_$tmp')\" STYLE=\"display:inline\">" if ($nbusersday{$login} > 0 && $display_subitem > 0);
      $link = $login;
      $link = &EncryptLink($link) if ($crypt == 1);
      print FOUT "$link";
      if ($nbusersday{$login} > 0 && $display_subitem > 0) {
	  print FOUT "</A>"; 
	  print FOUT "\n<DIV ID=\"TOGGLE_$tmp\" STYLE=\"display:none\">\n";

	  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\" ID=\"$login\">\n";
	  print FOUT "<thead>\n";
	  print FOUT "<TR>\n";
	  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Destination'}&nbsp;</TH>\n" if ($squid_format == 1);
#	  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Pages'}&nbsp;</TH>\n" if ($squid_format == 0);
	  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Pages'}&nbsp;</TH>\n" if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
	  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Files'}&nbsp;</TH>\n" if ($ftp_format == 1 || $cups_format == 1);
	  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Emails'}&nbsp;</TH>\n" if ($mail_format == 1);
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n"; # if ($squid_format == 1);
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n" if ($notrafic == 0);
	  print FOUT "</TR>\n";
	  print FOUT "</thead>\n";
	  print FOUT "<tbody>\n";

	  $tmp = $nbusersday{$login};
	  $tmp = $display_subitem if ($tmp > $display_subitem);

#	  for ($j=1;$j<=$nbusersday{$login};$j++) {
	  for ($j=1;$j<=$tmp;$j++) {
	      $host = $dailylogindest{$login,$j};
	      print FOUT "<TR>\n";
	      print FOUT "<TD CLASS=\"left\">";

	      $link = &AddHREF($host); # if ($squid_format == 0);
	      $link = &EncryptLink($link) if ($crypt == 1);
	      print FOUT "$link";
	      print FOUT "</TD>\n";
	      print FOUT "<TD CLASS=\"right\">$seen_users{$login,$host}</TD>\n";
	      if ($notrafic == 0) {
		  print FOUT "<TD CLASS=\"right\">";
		  printf FOUT "%.1f&nbsp;",$dailyuserssizedest{$login,$host}/1024 if ($unit eq "$L{'Kb'}");
		  printf FOUT "%.1f&nbsp;",$dailyuserssizedest{$login,$host}/(1024*1024) if ($unit eq "$L{'Mb'}");
		  printf FOUT "%.1f&nbsp;",$dailyuserssizedest{$login,$host}/(1024*1024*1024) if ($unit eq "$L{'Gb'}");
		  printf FOUT "%.1f&nbsp;",$dailyuserssizedest{$login,$host}/(1024*1024*1024*1024) if ($unit eq "$L{'Tb'}");
		  print FOUT "</TD>\n";
	      }

#	      print FOUT "<TD CLASS=\"right\">$dailyuserssizedest{$login,$host}</TD>\n" if ($squid_format == 1);
	      print FOUT "</TR>\n";
	  }
	  print FOUT "</tbody>\n";
	  print FOUT "</TABLE>\n";

	  print FOUT "</DIV>\n";
      }
#      if ($display_all == 0 || ($display_all == 1 && $pagesluesday{$page} > $seuilpage)) {


      $percentage = $userday{$login}*100/$reqtotjour if ($reqtotjour != 0);
      $percentageint = int($percentage);
      print FOUT "<TD CLASS=\"right\">$userday{$login}</TD>\n";
      print FOUT "<TD CLASS=\"left\">";
      print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($percentageint != 0);
      printf FOUT "%.1f",$percentage;
      print FOUT "&nbsp;%</TD>\n";

      if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	  $user_accessday{$login} = 0 if ($user_accessday{$login} eq '');
	  $percentage = $user_accessday{$login}*100/$accessjour if ($accessjour != 0);
	  $percentageint = int($percentage);
	  print FOUT "<TD CLASS=\"right\">$user_accessday{$login}</TD>\n";
	  print FOUT "<TD CLASS=\"left\">";
	  print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($percentageint != 0);
	  printf FOUT "%.1f",$percentage;
	  print FOUT "&nbsp;%</TD>\n";
      }
      print FOUT "<TD CLASS=\"right\">$nbusersday{$login}</TD>\n";
      if ($notrafic == 0) {
	  $percentage = 0;
	  $percentage = $user_trafficday{$login}*100/$totsizejour if ($totsizejour != 0);
	  $percentageint = int($percentage);
	  print FOUT "<TD CLASS=\"right\">";
	  printf FOUT "%.1f&nbsp;",$user_trafficday{$login}/1024 if ($unit eq "$L{'Kb'}");
	  printf FOUT "%.1f&nbsp;",$user_trafficday{$login}/(1024*1024) if ($unit eq "$L{'Mb'}");
	  printf FOUT "%.1f&nbsp;",$user_trafficday{$login}/(1024*1024*1024) if ($unit eq "$L{'Gb'}");
	  printf FOUT "%.1f&nbsp;",$user_trafficday{$login}/(1024*1024*1024*1024) if ($unit eq "$L{'Tb'}");
	  print FOUT "</TD>\n";
#      print FOUT "<TD CLASS=\"right\">$user_trafficday{$login}</TD>\n";
	  print FOUT "<TD CLASS=\"left\">";
	  print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($percentageint != 0);
	  printf FOUT "%.1f",$percentage;
	  print FOUT "&nbsp;%</TD>\n";
      }
      
      print FOUT "</TR>\n";
      $i++;
      last if (($i == $topten && $display_all == 0) || ($display_all == 1 && $count >= $max_item_page));
 #     }
  }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n";

  } else {
      print FOUT "<I>$L{'No_request'}</I>\n";
  }

  print FOUT "<P><BR>\n";
  print FOUT "</TD></TR></TABLE>\n";
  print FOUT "</BODY></HTML>\n";
}


#
### Download
#

sub Download {
  local(*FOUT,*L,$I) = @_;
  local($unit);

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Download'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";
  &add_jqplot_js(*FOUT,2);
  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
  &help_div(*FOUT);
  print FOUT "<H2> $L{'Download'}</H2><P>\n";
  print FOUT "<P>\n";

  if ($inc_download_aborted == 1) {
      if ($nbabort_page != 0) {
	  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'Download_not_completed'}</I></DIV><P>\n";

	  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
	  print FOUT "<thead>\n";
	  print FOUT "<TR>\n";
	  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Files'}&nbsp;</TH>\n";
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Size'}&nbsp;($L{'Kb'})&nbsp;</TH>\n";
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Abort'}&nbsp;</TH>\n";
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
	  for ($j=90;$j>=0;$j-=10) {
	      print FOUT "<TH class=\"table-sortable:numeric\">$j&nbsp;-&nbsp;",$j+10,"</TH>\n";
	  }
	  print FOUT "</TR>\n";
	  print FOUT "</thead>\n";
	  print FOUT "<tbody>\n";

	  for ($i=1;$i<=$nbabort_page;$i++) {
	      $page = $abort_name[$i];
	      $percentage = int(100*$abort_occur{$page}/$filetype{$page}) if ($filetype{$page} != 0);
#	      $tmp = $sizepagemax{$page};
	      $tmp = $dm_ok_size{$page} if ($load_dmsize == 0);
	      $tmp = $mostsize{$page} if ($load_dmsize == 1);
#	      if ($dm_ok_size{$page} > 1024) {
		  $tmp = int(10*$tmp/1024)/10;
#		  $unit = "$L{'Kb'}";
#	      }
#	      if ($dm_ok_size{$page} > (1024*1024)) {
#		  $tmp = int(10*$tmp/1024)/10;
#		  $unit = "$L{'Mb'}";
#	      }
#	      print FOUT "<TR><TD CLASS=\"left\">$page</TD>\n<TD CLASS=\"right\">$tmp&nbsp;$unit</TD>\n<TD CLASS=\"right\">$filetype{$page}</TD>\n<TD CLASS=\"right\">$abort_occur{$page}</TD>\n<TD CLASS=\"right\">$percentage</TD>\n";
	      print FOUT "<TR><TD CLASS=\"left\">$page</TD>\n<TD CLASS=\"right\">$tmp</TD>\n<TD CLASS=\"right\">$filetype{$page}</TD>\n<TD CLASS=\"right\">$abort_occur{$page}</TD>\n<TD CLASS=\"right\">$percentage&nbsp;%</TD>\n";
	      for ($j=9;$j>=0;$j--) {
		  print FOUT "<TD CLASS=\"right\">";
		  print FOUT "&nbsp;" if ($abort_page{$page,$j} eq '' || $abort_page{$page,$j} == 0);
		  print FOUT "$abort_page{$page,$j}" if ($abort_page{$page,$j} ne '' && $abort_page{$page,$j} != 0);
		  print FOUT "</TD>\n";
	      }
	      print FOUT "</TR>";
	  }
	  print FOUT "</tbody>\n";
	  print FOUT "</TABLE>\n<P>";
      }
  }

  print FOUT "<P>";

  $download_range = "download-range".$gifext;
  $download_range_acc = "download-range-acc".$gifext;

   for ($j=1;$j<=$maxdownloadlength;$j++) {
	$tmp = 10**($j-1);
	$tmp1 = 10**$j;

	  if ($tmp1 <= 1000) {
	      $unit2 = "$tmp - $tmp1 $L{'bytes'}";
	      }
	  if ($tmp1 > 1000 && $tmp1 <= (1000000)) {
	      $tmp = int($tmp/1000);
	      $tmp1 = int($tmp1/1000);
	      $unit2 = "$tmp - $tmp1 $L{'Kb'}";
	  }
	  if ($tmp1 > 1000000 && $tmp1 <= 1000000000) {
	      $tmp = int($tmp/1000000);
	      $tmp1 = int($tmp1/1000000);
	      $unit2 = "$tmp - $tmp1 $L{'Mb'}";
	  }
	  if ($tmp1 > 1000000000 && $tmp1 <= 1000000000000) {
	      $tmp = int($tmp/1000000000);
	      $tmp1 = int($tmp1/1000000000);
	      $unit2 = "$tmp - $tmp1 $L{'Gb'}";
	  }
	if ($tmp1 > 1000000000000) {
	      $tmp = int($tmp/1000000000000);
	      $tmp1 = int($tmp1/1000000000000);
	      $unit2 = "$tmp - $tmp1 $L{'Tb'}";
	  }
	$downloadunit[$j] = $unit2;
    }

  if ($fly_set == 0) {
      $chart_id = 0;
      $info = "info".$chart_id;
      $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%downloadrange_occ,\@serie_color,$reqtot,6,1,$unit,$chart_id,0,$info,"","",$dirstatus);
  }

  ($line_pie,$map_download_pie) = &MakePieChart($download_range,$reqtot,\%downloadrange_occ,6,0,'',$rayon) if ($fly_set == 1);

  print FOUT "<DIV ID=\"tog_occur\" STYLE=\"display:inline\">";
  print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
  print FOUT "<TR><TD ALIGN=CENTER VALIGN=TOP>";
  print FOUT "<TABLE BORDER=0>";
  print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Download'}</TH></TR>";
  print FOUT "$line_pie";
  print FOUT "</TABLE>\n";
  print FOUT "</TD>\n";
  print FOUT "<TD ALIGN=CENTER>";

  if ($fly_set == 0) {
      print FOUT "<div id=\"";
      print FOUT "chart".$chart_id;
      print FOUT "\" ";
      print FOUT "style=\"";
      print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
      print FOUT "</div>\n";
  }

  if ($fly_set == 1) {
      print FOUT "<IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$download_range\" USEMAP=\"#map_download_graph\" BORDER=0 ALT=\"graph\">\n";
  }

  if ($notrafic != 0) {
      print FOUT "<P><I>$L{'Occurence'}</I>";
  } else {
      print FOUT "<P><I>$L{'Occurence'}</I> - <A HREF=\"javascript:ToggleBeta('tog_traffic','tog_occur');\">$L{'Traffic'}</A>" if ($fly_set == 1);
      print FOUT "<P><I>$L{'Occurence'}</I> - <A HREF=\"javascript:ToggleJqplotGraph2(plot1,'tog_traffic','tog_occur');\">$L{'Traffic'}</A>" if ($fly_set == 0);
  }
  print FOUT "</TD></TR></TABLE>\n";

  if ($fly_set == 1) {
      print FOUT "<MAP NAME=\"map_download_graph\">\n";
      $tmp = $map_download_pie;
      $tmp =~ s/<!-- langhome -->/$I/g;
      print FOUT "$tmp";
      print FOUT "</MAP>\n";
  }
  if ($fly_set == 0) {
      if ($xmax_jqplot != $xmax_home_jqplot) {
	  print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
      }
      print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
  }
  print FOUT "</DIV>";

#  $tmp = $totsize;

#      print "AA $unit_div - $unit\n";

  if ($fly_set == 0) {
      $chart_id++;
      $info = "info".$chart_id;
      $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%downloadrange,\@serie_color,$totsize,6,$unit_div,$unit,$chart_id,0,$info,"","",$dirstatus);
  }

  ($line_pie,$map_download_pie) = &MakePieChart($download_range_acc,$totsize,\%downloadrange,6,1,'',$rayon) if ($fly_set == 1);

  print FOUT "<DIV ID=\"tog_traffic\" STYLE=\"display:none\">";
  print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
  print FOUT "<TR><TD ALIGN=CENTER VALIGN=TOP>";
  print FOUT "<TABLE BORDER=0>";
  print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Download'}</TH></TR>";
  print FOUT "$line_pie";
  print FOUT "</TABLE>\n";
  print FOUT "</TD>\n";
  print FOUT "<TD ALIGN=CENTER>";

  if ($fly_set == 0) {
      print FOUT "<div id=\"";
      print FOUT "chart".$chart_id;
      print FOUT "\" ";
      print FOUT "style=\"";
      print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
      print FOUT "</div>\n";
  }

  if ($fly_set == 1) {
      print FOUT "<IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$download_range_acc\" USEMAP=\"#map_download2_graph\" BORDER=0 ALT=\"graph\">\n";
  }

  if ($fly_set == 0) {
      print FOUT "<P><I><A HREF=\"javascript:ToggleJqplotGraph2(plot0,'tog_occur','tog_traffic');\">$L{'Occurence'}</A> - $L{'Traffic'}</I>";
  }
  if ($fly_set == 1) {
      print FOUT "<P><I><A HREF=\"javascript:ToggleBeta('tog_occur','tog_traffic');\">$L{'Occurence'}</A> - $L{'Traffic'}</I>";
  }

  print FOUT "</TD></TR></TABLE>\n";

  if ($fly_set == 1) {
      print FOUT "<MAP NAME=\"map_download2_graph\">\n";
      $tmp = $map_download_pie;
      $tmp =~ s/<!-- langhome -->/$I/g;
      print FOUT "$tmp";
      print FOUT "</MAP>\n";
  }
  if ($fly_set == 0) {
      if ($xmax_jqplot != $xmax_home_jqplot) {
	  print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
      }
      print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
  }
  print FOUT "</DIV>";

  print FOUT "<P>";

  print FOUT "<I>($L{'Only_files'} $L{'with_at_least'} $seuilpage $L{'requests'} $L{'are_shown'})</I>\n<P>" if ($seuilpage > 1);

  print FOUT "<p>\n<table class=\"tablesort table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR><TH>&nbsp;$L{'Files'}&nbsp;</TH>\n";
  print FOUT "<TH>&nbsp;</TH>\n";
  print FOUT "<TH>&nbsp;$L{'Traffic'}&nbsp;</TH>\n";
  print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  print FOUT "<TH>&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";

  for ($i=0;$i<=$#listext;$i++) {
      $tmp2 = $downloadext{$listext[$i]};
      next if ($tmp2 < $seuilpage);
      $tmp3 = $downloadsizeext{$listext[$i]}/(1024*1024);
      $pourcentage = ($tmp3*100)/$totsize if ($totsizejour != 0);
      $pourcentageint = int($pourcentage);
      print FOUT "<TR><TD CLASS=\"head_left\">&nbsp;";
      if ($mail_format == 0) {# && $ftp_format == 0) {
	  print FOUT "$extfile{$listext[$i]}" if ($extfile{$listext[$i]} ne '');
	  print FOUT "$listext[$i]" if ($extfile{$listext[$i]} eq '');
      } else {
	  print FOUT "$L{'Emails'} ";
	  print FOUT "&lt;$listext[$i]&gt;" if ($listext[$i] ne '.');
	  print FOUT "&lt;$localdomainename&gt;" if ($listext[$i] eq '.');
      }
      print FOUT "&nbsp;</TD><TD CLASS=\"head_right\">&nbsp;</TD><TD CLASS=\"head_left\">";
      print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"> " if (int($pourcentage) != 0);
      if ($tmp3 > 0) {
	  printf FOUT "%.2f",$tmp3;
      } else {
	  print FOUT "0.00";
      }
      print FOUT "&nbsp;$L{'Mb'}</TD>";

      print FOUT "<TD CLASS=\"head_right\">";
      printf FOUT "%.1f",$pourcentage;
      $pourcentage = ($tmp2*100)/$reqtot;
      $pourcentageint = int($pourcentage);
      print FOUT "&nbsp;%</TD><TD CLASS=\"head_left\">";
      print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"> " if (int($pourcentage) != 0);
      print FOUT "$tmp2</TD><TD CLASS=\"head_right\">";

      printf FOUT "%.1f",$pourcentage;
      print FOUT "&nbsp;%</TD></TR>\n";
      
      for ($j=1;$j<=$maxdownloadlength;$j++) {

	  print FOUT "<TR><TD>&nbsp;</TD>";

	  $tmp = 10**($j-1);
	  $tmp1 = 10**$j;

	  print FOUT "<TD CLASS=\"left\">" if (($j/2) == int($j/2));
	  print FOUT "<TD CLASS=\"left_alter\">" if (($j/2) != int($j/2));
	  if ($tmp1 <= 1000) {
	      $unit = "$tmp - $tmp1 $L{'bytes'}";
	      }
	  if ($tmp1 > 1000 && $tmp1 <= 1000000) {
	      $tmp = int($tmp/1000);
	      $tmp1 = int($tmp1/1000);
	      $unit = "$tmp - $tmp1 $L{'Kb'}";
	  }
	  if ($tmp1 > 1000000 && $tmp1 <= 1000000000) {
	      $tmp = int($tmp/1000000);
	      $tmp1 = int($tmp1/1000000);
	      $unit = "$tmp - $tmp1 $L{'Mb'}";
	  }
	  if ($tmp1 > 1000000000 && $tmp1 <= 1000000000000) {
	      $tmp = int($tmp/1000000000);
	      $tmp1 = int($tmp1/1000000000);
	      $unit = "$tmp - $tmp1 $L{'Gb'}";
	  }
	  if ($tmp1 >  1000000000000) {
	      $tmp = int($tmp/1000000000000);
	      $tmp1 = int($tmp1/1000000000000);
	      $unit = "$tmp - $tmp1 $L{'Tb'}";
	  }
	  print FOUT "$unit";
	  print FOUT "</TD>\n";

	  if ($download{$listext[$i],$j} > 0) {
	      $tmp = $downloadsize{$listext[$i],$j}/(1024*1024);
#	      $pourcentage = ($tmp*100)/$tmp3 if (int($tmp3) != 0);
#	      $pourcentage = 0 if (int($tmp3) == 0);
	      $pourcentage = ($tmp*100)/$tmp3 if ($tmp3 != 0);
	      $pourcentage = 0 if ($tmp3 == 0);
	      $pourcentageint = int($pourcentage);
	      print FOUT "<TD CLASS=\"left\">" if (($j/2) == int($j/2));
	      print FOUT "<TD CLASS=\"left_alter\">" if (($j/2) != int($j/2));
	      print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if (int($pourcentage) != 0);
	      if ($tmp > 0) {
		  printf FOUT "%.2f",$tmp;
	      } else {
		  print FOUT "0.00";
	      }
	      print FOUT "&nbsp;$L{'Mb'}";
	      print FOUT "</TD>\n";
	      print FOUT "<TD CLASS=\"right\">" if (($j/2) == int($j/2));
	      print FOUT "<TD CLASS=\"right_alter\">" if (($j/2) != int($j/2));
	      printf FOUT "%.1f ",$pourcentage;
	      print FOUT "&nbsp;%</TD>";
	      print FOUT "<TD CLASS=\"left\">" if (($j/2) == int($j/2));
	      print FOUT "<TD CLASS=\"left_alter\">" if (($j/2) != int($j/2));

	      $pourcentage = ($download{$listext[$i],$j}*100)/$tmp2;
	      $pourcentageint = int($pourcentage);
	      print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if (int($pourcentage) != 0);
	      print FOUT "$download{$listext[$i],$j}</TD>\n";
	      print FOUT "<TD CLASS=\"right\">" if (($j/2) == int($j/2));
	      print FOUT "<TD CLASS=\"right_alter\">" if (($j/2) != int($j/2));
	      printf FOUT "%.1f",$pourcentage;
	      print FOUT "&nbsp;%</TD>\n";
	  } else {
	      print FOUT "<TD ALIGN=CENTER>" if (($j/2) == int($j/2));
	      print FOUT "<TD CLASS=\"alter\">" if (($j/2) != int($j/2));
	      print FOUT "-</TD>\n";
	      print FOUT "<TD ALIGN=CENTER>" if (($j/2) == int($j/2));
	      print FOUT "<TD CLASS=\"alter\">" if (($j/2) != int($j/2));
	      print FOUT "-</TD>\n";
	      print FOUT "<TD ALIGN=CENTER>" if (($j/2) == int($j/2));
	      print FOUT "<TD CLASS=\"alter\">" if (($j/2) != int($j/2));
	      print FOUT "-</TD>\n";
	      print FOUT "<TD ALIGN=CENTER>" if (($j/2) == int($j/2));
	      print FOUT "<TD CLASS=\"alter\">" if (($j/2) != int($j/2));
	      print FOUT "-</TD>\n";
	  }
	  print FOUT "</TR>\n";
      }
  }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n";


  print FOUT "</BODY></HTML>\n";
}

#
##############################################################
### Trafic
##############################################################
#

sub TrafficAll {
  local(*FOUT,*L,$I) = @_;
  local($count,$unit,$tmp,$unitsize,$max,$lines,$lines_header);

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Stats'} - $L{'Traffic'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);  
  print FOUT "<H2> $L{'Traffic'} </H2><P>\n";

#  &PagesExportPDF(*FOUT,"$I$dirsep$dirlist$dirsep$listtrafic",$L{'Traffic'},2,2,0,0) if ($enable_pdf == 1);

 # print FOUT "<P><HR><P>\n";
  print FOUT "<P>\n";

  $tmp = $sizepage{(&reverse_sort_by_value(*sizepage))[0]};
  $unit = "$L{'bytes'}";
  $unitsize = 1;
  if ($tmp > 1024) {
      $unit = "$L{'Kb'}";
      $unitsize = 1024;
  } 
  if ($tmp > (1024*1024)) {
      $unit = "$L{'Mb'}";
      $unitsize = 1024*1024;
  }
  if ($tmp > (1024*1024*1024)) {
      $unit = "$L{'Gb'}";
      $unitsize = 1024*1024*1024;
  }
  if ($tmp > (1024*1024*1024*1024)) {
      $unit = "$L{'Tb'}";
      $unitsize = 1024*1024*1024*1024;
  }
  
  $max = $sizepage{(&reverse_sort_by_value(*sizepage))[0]}/$unitsize;
#  $traficlimit_display = (int(10*$max)/10)/100;
#  $traficlimit_display = 0.1;

  $count = 0;
  $tmp10 = keys(%sizepage);
  $tmp10 = $max_item_page if ($tmp10 > $max_item_page);
  $lines = "<tbody>\n";

  foreach $page (&reverse_sort_by_value(*sizepage)) {

#      if ($filetype{$page} > $seuilpage) {
#      if ($sizepage{$page}/$unitsize > $traficlimit_display) {
	  $count++;
	  if ($count < $max_item_page) {
	  $lines .= "<TR>\n";
	  if ($squid_format == 1) {
	      $tmp = index($page,$dirsep,1);
	      if ($tmp != -1) {
		  $tmp1 = substr($page,0,$tmp+1);
		  $tmp6 = substr($page,$tmp,length($page));
	      } else {
		  $tmp1 = $page;
		  $tmp6 = "";
	      }
	      $lines .= "<TD CLASS=\"left\">$tmp1</TD>\n";
	      $lines .= "<TD CLASS=\"left\">$tmp6</TD>\n";
	  }
	  $lines .= "<TD CLASS=\"left\">$page</TD>\n" if ($squid_format == 0);
	  $lines .= "<TD CLASS=\"right\">&nbsp;<B>";
#	  $tmp1 = int(100*$sizepage{$page}/$unitsize)/100 if ($max >= 1);
#	  $tmp1 = int(1000*$sizepage{$page}/$unitsize)/1000 if ($max < 1);
	  $tmp1 = int(100*$sizepage{$page}/$unitsize)/100 if ($tmp1 >= 1);
	  $tmp1 = int(1000*$sizepage{$page}/$unitsize)/1000 if ($tmp1 < 1);
	  $lines .= "$tmp1</B>&nbsp;</TD>\n<TD CLASS=\"left\">&nbsp;\n";
	  $pourcentage = 100*$sizepage{$page}/$totsize;
	  $pourcentageint = int($pourcentage);
	  $pourcentage = int($pourcentage*10)/10;
	  $lines .= "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
#	  printf FOUT "%.1f",$pourcentage;
	  $lines .= "$pourcentage&nbsp;%</TD>\n";
	  if ($precision > 3 || $squid_format == 0) {
	      $lines .= "<TD CLASS=\"right\">&nbsp;<B>";
	      $tmp = $filetype{$page};
	      $tmp = $pageslues{$page} if ($tmp eq '');
	      $lines .= "$tmp";
	      $lines .= "</B>&nbsp;</TD>\n<TD CLASS=\"left\">&nbsp;\n";
	      $pourcentage = 100*$tmp/$reqtot;
	      $pourcentageint = int($pourcentage);
	      $pourcentage = int($pourcentage*10)/10;
	      $lines .= "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
#	  printf FOUT "%.1f",$pourcentage;
	      $lines .= "$pourcentage&nbsp;%</TD>\n";
	  }
	  $lines .= "</TR>\n";
      }
  }

  $lines .= "</tbody>\n";
  $lines .= "</TABLE>\n";
  $lines .= "</BODY></HTML>\n";

  $lines_header = "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} $count $L{'files'}</I> :</DIV><P>\n";
#  $lines_header .= "<I>($L{'Only_files'} $L{'with_at_least'} $traficlimit_display $unit $L{'are_shown'})</I>\n<P>";

  $lines_header .= "\n<table class=\"tablesort table-autosort table-autostripe ";
  $lines_header .= "table-autopage:$table_big_lines_aff " if ($count > $table_big_lines_aff);
  $lines_header .= "table-stripeclass:alternate\" id=\"page\">\n";
  $lines_header .= "<thead>\n";
  $lines_header .= "<TR>\n";
  $lines_header .= "<TH class=\"table-sortable:default\">&nbsp;$L{'Destination'}&nbsp;</TH>\n" if ($squid_format == 1);
  $lines_header .= "<TH class=\"table-sortable:default\">&nbsp;$L{'Files'}&nbsp;</TH>\n";
  $lines_header .= "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n";
  $lines_header .= "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  if ($precision > 3 || $squid_format == 0) {
      $lines_header .= "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
      $lines_header .= "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  }
  $lines_header .= "</TR>\n";
  $lines_header .= "</thead>\n";

  if ($count > $table_big_lines_aff) {

      $tmp = int($count/$table_big_lines_aff);
      if ($tmp != ($count/$table_big_lines_aff)) {
	  $tmp++;
      }
    
      $lines_header .= "<tfoot>\n";
      $lines_header .= "<tr>\n";
      $lines_header .= "<TH>$L{'Destination'}</TH>\n" if ($squid_format == 1);
      $lines_header .= "<TH>$L{'Files'}</TH>\n";
      $lines_header .= "<TH>$L{'Traffic'}</TH>\n";
      $lines_header .= "<TH>$L{'Percentage'}</TH>\n";
      if ($precision > 3 || $squid_format == 0) {
	  $lines_header .= "<TH>$L{'Occurence'}</TH>\n";
	  $lines_header .= "<TH>$L{'Percentage'}</TH>\n";
      }
      $lines_header .= "</tr>\n";
      $lines_header .= "<tr>\n";
      
      if ($tmp > 1) {
	  $tmpa = 5;
	  $tmpa++ if ($squid_format == 1);
	  $tmpa += 2 if ($precision > 3 || $squid_format == 0);
	  $lines_header .= "<td colspan=$tmpa>\n";
	  $lines_header .= "<a href=\"#\" onclick=\"pageexample('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	  
	  for ($i=1;$i<=$tmp;$i++) {
	      $iminus = $i-1;
	      $lines_header .= "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexample($iminus); return false;\">$i</a>\n";
	  }
	  $lines_header .= "<a href=\"#\" onclick=\"pageexample('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	  $lines_header .= "<a href=\"#\" onclick=\"pageexample('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	  $lines_header .= "</td>\n";
	  $lines_header .= "</tr>\n";
      }
      $lines_header .= "</tfoot>\n";
  }

      print FOUT $lines_header;      
      print FOUT $lines;

}

sub Traffic {
  local(*FOUT,*L,$I) = @_;
  local($count,$count_server,$count_local,$count_pages,$unit,$tmp);

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Stats'} - $L{'Traffic'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";
  
  &add_jqplot_js(*FOUT,2);
  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";

  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
  &help_div(*FOUT);

  print FOUT "<H2> $L{'Traffic'} </H2><P>\n";
  print FOUT "<P><HR><P>\n";

  print FOUT "<TABLE>\n";
  print FOUT "<TR>\n";
  print FOUT "<TD VALIGN=TOP>\n";

  $count_pages = keys(%sizepage);

  $line_page_display = &TraficPageTab(*FOUT,*L,$I,$topten,0);

 #

  $count_server = keys(%serversize);
  $line_host_display = &TraficServerTab(*FOUT,*L,$I,$topten,0);

  print FOUT "$line_host_display\n" if ($count_server != 0);
  print FOUT "$line_page_display\n" if ($count_server == 0);
  print FOUT "</TD>\n";
  print FOUT "<TD WIDTH=50></TD>\n"; # if ($count_server != 0);
  print FOUT "<TD VALIGN=TOP>\n";


  if ($locallog != 0 && $locserver != 0) {
      
      $count_local = 0;
      $tmp2 = keys(%localserversize);

      foreach $adresse (&reverse_sort_by_value(*localserversize)) {
	  if ($count_local < $topten) {
	      $count_local++;
	      
	      if ($count_local == 1) {

		  $tmp = $localserversize{$adresse};
		  $unit = "$L{'bytes'}";
		  $unit = "$L{'Kb'}" if ($tmp > 1024);		    
		  $unit = "$L{'Mb'}" if ($tmp > (1024*1024));
		  $unit = "$L{'Gb'}" if ($tmp > (1024*1024*1024));
		  $unit = "$L{'Tb'}" if ($tmp > (1024*1024*1024*1024));

		  $line_display = "<I>$L{'The_Top'} $topten $L{'top_local_sites'} ";
		  $line_display .= "(<A HREF=\"..$dirsepurl$dirsite$dirsepurl$listlocsites\">$L{'Full_list'}</A>)" if ($show_all == 1 && $tmp2 > $topten);
		  $line_display .= "</I> :<P>\n";

		  $line_display .= "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
		  $line_display .= "<thead>\n";
		  $line_display .= "<TR>\n";
		  $line_display .= "<TH class=\"table-sortable:default\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
		  $line_display .= "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n";
		  $line_display .= "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
		  $line_display .= "</TR>\n";
		  $line_display .= "</thead>\n";
		  $line_display .= "<tbody>\n";
	      }

	      $pourcentage = 100*$localserversize{$adresse}/$totsize;
	      $pourcentageint = int($pourcentage);
	      $pourcentage = int($pourcentage*10)/10;
	      $line_display .= "<TR>\n<TD CLASS=\"left\">";
	      $line_display .= "$adresse";
	      $line_display .= "</TD>\n<TD CLASS=\"right\">&nbsp;<B>";
	      $tmp = $localserversize{$adresse}/1024 if ($unit eq "$L{'Kb'}");
	      $tmp = $localserversize{$adresse}/(1024*1024) if ($unit eq "$L{'Mb'}");
	      $tmp = $localserversize{$adresse}/(1024*1024*1024) if ($unit eq "$L{'Gb'}");
	      $tmp = $localserversize{$adresse}/(1024*1024*1024*1024) if ($unit eq "$L{'Tb'}");
	      $tmp = int($tmp*10)/10;
	      $line_display .= "$tmp";
	      $line_display .= "</B>&nbsp;</TD>\n<TD CLASS=\"left\">&nbsp;\n";
	      $line_display .= "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
	      $line_display .= "$pourcentage";
	      $line_display .= "&nbsp;%</TD>\n</TR>\n";
	      
	  }
      }
      if ($count_local >= 1) {
	  $line_display .= "</tbody>\n";
	  $line_display .= "</TABLE>\n";
      }
      print FOUT "$line_display\n" if ($count_local != 0);
  } else {
      print FOUT "$line_page_display\n" if ($count_pages != 0);
  }

  print FOUT "</TD>\n";
#  print FOUT "<TD WIDTH=50></TD>\n";
  if ($count_pages != 0 && $count_local != 0 && $count_server != 0) {
      print FOUT "</TR><TR>\n";
      print FOUT "<TD VALIGN=TOP COLSPAN=3><P>\n";
      print FOUT "$line_page_display\n";
      print FOUT "</TD>\n";
#      print FOUT "</TR>";
  }
  print FOUT "</TR></TABLE>\n";

  print FOUT "<P>";

  if ($fly_set == 0) {
      $chart_id = 0;
      $info = "info".$chart_id;
      $i = &Load_DailyData($datafile,$dirdata);

      $xlegend = "$i $L{'days'}";
#    $xlegend .= "s" if ($count_month > 1);
      $xlegend .= " (starting $start_date)";
      $ylegend = "$L{'Traffic'} ($unit)";
      
      undef @ref_tab;
      push(@ref_tab,\@tabreq);
      push(@ref_tab,\@tabacc) if ($mail_format == 0);
      push(@ref_tab,\@tabmm);
      push(@ref_tab,\@tabdoc);
      push(@ref_tab,\@tabscript);
      push(@ref_tab,\@tabuser);
      push(@ref_tab,\@tabtrafic);
  
      @ref_tab_name = ('requests','accesses','hosts','documents2','scripts','users','traffic') if ($mail_format == 0);
      @ref_tab_name = ('requests','hosts','documents2','scripts','users','traffic') if ($mail_format == 1);
  
      &MakeDailyGraphJqplotInit(*FOUT, eval($Lang{$lang[$nblang]}),$I,1,$unit_div,\@ref_tab,\@ref_tab_name,\@listdate,$chart_id);
      
      @graph_to_display = ('Traffic');
  
      undef @ref_tab;
      push(@ref_tab,\@tabtrafic);
      
      &MakeDailyGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,1,\@graph_to_display,\@ref_tab,\@listdate,\@serie_color,$unit_div,$unit,$chart_id,3,"traffic",$info,0,$xlegend,$ylegend,$xmax_jqplot,$dirtraffic);
      
      &AddJqplotHtml(*FOUT, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_jqplot,$ymax_jqplot,2);

      $chart_id += $#list_graph_name_jqplot+1;
  }

  if ($fly_set == 1) {
      $file_page_page = "trafic-home";
      print FOUT "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
      print FOUT "<TR>\n";
      $tmp = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$file_page_page."y".$gifext;
      print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"y\"></TD>\n";
      $tmp = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$file_page_page.$gifext;
      print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"graph\" USEMAP=\"#map_page_graph\" BORDER=0></TD>\n";
      print FOUT "</TR><TR><TD></TD>\n";
      $tmp = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$file_page_page."x".$gifext;
      print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$tmp\" ALT=\"x\"></TD>\n";
      print FOUT "</TR>\n";
      print FOUT "</TABLE></CENTER>\n";
      print FOUT "<MAP NAME=\"map_page_graph\">";
      $tmp = $map_page_graph;
      $tmp =~ s/<!-- langhome -->/$I/g;
      print FOUT "$tmp";
#  print FOUT "$map_page_graph";
      print FOUT "</MAP>\n";
  }

  print FOUT "<P>";

  if ($paysunique != 0) {
      
      print FOUT "<P><HR><P>\n";
      print FOUT "<P><CENTER>\n";
      print FOUT "<TABLE BORDER=0 WIDTH=\"100%\"><TR>\n";
      print FOUT "<TD VALIGN=TOP ALIGN=LEFT>\n";

#      $tmp = $sizepays{(&reverse_sort_by_value(*sizepays))[0]};

      $count = 0;
#      $tmp3 = 0;
      $line = '';
      $unit = "$L{'bytes'}";

      foreach $pays (&reverse_sort_by_value(*sizepays)) {

	  $pourcentvalue = $sizepays{$pays}*100/$totsize;
	  if ($sizepays{$pays} != 0) {

	      $tmp = int($pourcentvalue);
	      $pourcentvalue = int($pourcentvalue*10)/10;

	      $count++;

	      if ($count == 1) {

		  $tmp2 = $sizepays{$pays};
		  $unit = "$L{'Kb'}" if ($tmp2 > 1024 && $tmp2 < (1024*1024));
		  $unit = "$L{'Mb'}" if ($tmp2 > (1024*1024) && $tmp2 < (1024*1024*1024));
		  $unit = "$L{'Gb'}" if ($tmp2 > (1024*1024*1024) && $tmp2 < (1024*1024*1024*1024));
		  $unit = "$L{'Tb'}" if ($tmp2 > (1024*1024*1024*1024));

		  $line_display = "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
		  $line_display .= "<thead>\n";
		  $line_display .= "<TR>\n";
		  $line_display .= "<TH class=\"table-sortable:default\">&nbsp;$L{'Domain'}&nbsp;</TH>\n";
		  $line_display .= "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n";
		  $line_display .= "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
		  $line_display .= "</TR>\n";
		  $line_display .= "</thead>\n";
		  $line_display .= "<tbody>\n";

	      }


	      if ($flagpage{$pays} eq "") {
		  $flagpage{$pays} = "divers-$pays".$htmlext;
	      }
	      $line_display .= "<TR>\n";
	      $line_display .= "<TD CLASS=\"left\">";
	      $line_display .= "<A HREF=\"..$dirsepurl$dirpays$dirsepurl$flagpage{$pays}\"\>" if ($found{$pays} == 1 && $payslist{$pays} > $seuilsite);
	      if (-f "$pathinit$dirress$dirsep$dirflags$dirsep$pays$gifext") {
		  $line_display .= "<IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirflags$dirsepurl$pays$gifext\" WIDTH=14 HEIGHT=14 BORDER=0 ALT=\"$pays\">";
	      } else {
		  $tmp2 = "Unknown";
		  $line_display .= "<IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirflags$dirsepurl$tmp2$gifext\" WIDTH=14 HEIGHT=14 BORDER=0 ALT=\"$tmp2\">";
	      }
	      $line_display .= "</A>" if ($found{$pays} == 1 && $payslist{$pays} > $seuilsite);
	      $line_display .= "&nbsp;";
	      $line_display .= "<A HREF=\"..$dirsepurl$dirpays$dirsepurl$flagpage{$pays}\"\>" if ($found{$pays} == 1 && $payslist{$pays} > $seuilsite);
	      if (-f "$pathinit$dirress$dirsep$dirflags$dirsep$pays$gifext") {
		  $line_display .= "$L{$newflag{$pays}}";
	      } else {
		  $line_display .= "$L{'$tmp2'} <I>($pays)</I>";
	      }
	      $line_display .= "</A>" if ($found{$pays} == 1 && $payslist{$pays} > $seuilsite);
	      $line_display .= "</TD>\n";
	      $line_display .= "<TD CLASS=\"left\">\n";
	      $line_display .= "<IMG WIDTH=$tmp HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[4]\" ALT=\"$gcolor[4]\">&nbsp;" if ($tmp != 0);
	      $tmp2 = $sizepays{$pays};
	      $tmp2 /= 1024 if ($unit eq "$L{'Kb'}");
	      $tmp2 /= (1024*1024) if ($unit eq "$L{'Mb'}");
	      $tmp2 /= (1024*1024*1024) if ($unit eq "$L{'Gb'}");
	      $tmp2 /= (1024*1024*1024*1024) if ($unit eq "$L{'Tb'}");
	      $tmp2 = int($tmp2) if ($unit eq "$L{'Kb'}");
	      $tmp2 = int($tmp2*100)/100 if ($unit ne "$L{'Kb'}");
	      $line_display .= "<B>$tmp2</B></TD>";
#	      printf FOUT "<B>%d</B></TD>",$tmp2 if ($unit eq "$L{'Kb'}");
#	      printf FOUT "<B>%.2f</B></TD>",$tmp2 if ($unit ne "$L{'Kb'}");
	      $line_display .= "<TD CLASS=\"right\">$pourcentvalue %";
	      $line_display .= "</TD>\n";
	      $line_display .= "</TR>\n";
	  }
      }

      $line_display .= "</tbody>\n";      
      $line_display .= "</TABLE>\n";

      print FOUT "$line_display\n";
      print FOUT "</TD>\n";
      print FOUT "<TD VALIGN=TOP ALIGN=CENTER>\n";

      if ($paysunique != 0) {

	  print FOUT "<DIV ID=\"tog_all\" STYLE=\"display:inline\">";

	  if ($fly_set == 1) {
	      $tmp5 = $totsize;
	      ($line_pie,$map_download_pie) = &MakePieChart($paysgraph,$tmp5,\%sizepays,1,2,'',$rayon);
	  }

	  if ($fly_set == 0) {
	      $info = "info".$chart_id;
	      $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%sizepays,\@serie_color,$totsize,1,$unit_div,$unit,$chart_id,0,$info,"","",$dirstatus);
	  }

### ???  ($line_cloud,$line_cloud_sort) = &MakeCloud(\%downloadext,'',1);

	  print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
	  print FOUT "<TR><TD ALIGN=CENTER VALIGN=TOP>";
	  print FOUT "<TABLE BORDER=0>";
	  print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Countries'}</TH></TR>";
	  print FOUT "$line_pie";
	  print FOUT "</TABLE>\n";
	  print FOUT "</TD>\n";

	  print FOUT "<TD ALIGN=CENTER>";
	  if ($fly_set == 1) {
	      print FOUT "<IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$paysgraph\" USEMAP=\"#map_trafic_graph\" BORDER=0 ALT=\"graph\">\n";
	  }
	  if ($fly_set == 0) {
	      print FOUT "<div id=\"";
	      print FOUT "chart".$chart_id;
	      print FOUT "\" ";
	      print FOUT "style=\"";
	      print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
	      print FOUT "</div>\n";
	      $chart_id++;
	  }
	  print FOUT "<P><I>$L{'Traffic'} $L{'by'} $L{'countries'}</I><BR>";

	  if ($fly_set == 0) {
	      print FOUT "<I>$L{'all_sites'} ";
	      if ($locallog == 1 && $localonly != 1 && $paysunique != 0 && $serverunique != 0 && $totsize != $externesize && $externesize != 0) {
	      print FOUT " - <A HREF=\"javascript:ToggleJqplotGraph2(plot$chart_id,'tog_nodomain','tog_all');\">$L{'excluding'} $localdomainename</A>";
	      }
	      print FOUT "</I>";
	  }
	  if ($fly_set == 1) {
	      print FOUT "<I>$L{'all_sites'}";
	      if ($locallog == 1 && $localonly != 1 && $paysunique != 0 && $serverunique != 0 && $totsize != $externesize && $externesize != 0) {
		  print FOUT " - <A HREF=\"javascript:ToggleBeta('tog_nodomain','tog_all');\">$L{'excluding'} $localdomainename</A>";
	      }
	      print FOUT "</I>";
	  }

#	  print FOUT "<BR><B>$L{'all_sites'}</B></I>\n";
	  print FOUT "</TD></TR></TABLE>\n";

	  if ($fly_set == 1) {
	      print FOUT "<MAP NAME=\"map_trafic_graph\">\n";
	      $tmp = $map_download_pie;
	      $tmp =~ s/<!-- langhome -->/$I/g;
	      print FOUT "$tmp";
	      print FOUT "</MAP>\n";
	  }
	  if ($fly_set == 0) {
	      if ($xmax_jqplot != $xmax_home_jqplot) {
		  print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
	      }
	      print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
	  }
	  print FOUT "</DIV>";
      }

#      print FOUT "<P>";
      if ($locallog == 1 && $localonly != 1 && $paysunique != 0 && $serverunique != 0 && $totsize != $externesize && $externesize != 0) {

	  foreach $pays (&reverse_sort_by_value(*sizepays)) {
	      $sizepays2{$pays} = $sizepays{$pays};
	      $sizepays2{$pays} = $sizepays2{$pays}-(($totsize-$externesize)) if ($pays eq substr($localdomainename,(rindex($localdomainename,'.')+1),length($localdomaine)) || $paysunique == 0);

	  }

	  if ($fly_set == 1) {
	      $tmp5 = $externesize;
	      ($line_pie,$map_download_pie) = &MakePieChart($paysgraph2,$tmp5,\%sizepays2,1,2,'',$rayon);
	  }

	  if ($fly_set == 0) {
#	      $chart_id++;
	      $info = "info".$chart_id;
	      $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%sizepays2,\@serie_color,$totsize,1,$unit_div,$unit,$chart_id,0,$info,"","",$dirstatus);
	  }

	  undef %sizepays2;

	  print FOUT "<DIV ID=\"tog_nodomain\" STYLE=\"display:none\">";
	  print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
	  print FOUT "<TR><TD ALIGN=CENTER VALIGN=TOP>";
	  print FOUT "<TABLE>";
	  print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Countries'}</TH></TR>";
	  print FOUT "$line_pie";
	  print FOUT "</TABLE>\n";
	  print FOUT "</TD>\n";

	  print FOUT "<TD ALIGN=CENTER>";
	  if ($fly_set == 1) {
	      print FOUT "<IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$paysgraph2\" USEMAP=\"#map_trafic2_graph\" BORDER=0 ALT=\"graph2\"><P>\n";
	  }
	  if ($fly_set == 0) {
	      print FOUT "<div id=\"";
	      print FOUT "chart".$chart_id;
	      print FOUT "\" ";
	      print FOUT "style=\"";
	      print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
	      print FOUT "</div>\n";
	      $chart_id++;
	  }
#	  print FOUT "<P><I>$L{'Traffic'} $L{'by'} $L{'countries'} ($L{'percentage'})";
#	  print FOUT "<BR><B>$L{'excluding'} $localdomainename</B></I>";
	  print FOUT "<P><I>$L{'Traffic'} $L{'by'} $L{'countries'}</I><BR>";

	  if ($fly_set == 0) {
	      $old_chartid = $chart_id-2;
	      print FOUT "<I><A HREF=\"javascript:ToggleJqplotGraph2(plot$old_chartid,'tog_all','tog_nodomain');\">$L{'all_sites'}</A> - $L{'excluding'} $localdomainename</I>";
	  }
	  if ($fly_set == 1) {
	      print FOUT "<I><A HREF=\"javascript:ToggleBeta('tog_all','tog_nodomain');\">$L{'all_sites'}</A> - $L{'excluding'} $localdomainename</I>";
	  }

	  print FOUT "</TD></TR></TABLE>\n";

	  if ($fly_set == 1) {
	      print FOUT "<MAP NAME=\"map_trafic2_graph\">\n";
	      $tmp = $map_download_pie;
	      $tmp =~ s/<!-- langhome -->/$I/g;
	      print FOUT "$tmp";
	      print FOUT "</MAP>\n";
	  }
	  if ($fly_set == 0) {
	      if ($xmax_jqplot != $xmax_home_jqplot) {
		  print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
	      }
	      print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
	  }
	  print FOUT "</DIV>";

      }
      print FOUT "</TD>\n";
      print FOUT "</TR>\n";
      print FOUT "</TABLE>\n";
      print FOUT "</CENTER>\n";
  }
  
  print FOUT "<P>\n</BODY></HTML>\n";
}

#
##############################################################
### Pie Chart
##############################################################
#

sub MakePieChart {
    local($file,$tot,$ref,$type,$datatype,$linkpage,$rayon) = @_;
    local($deg1,$deg2,$count,$tmp3,$tmp4,$tmp5,$tmp6,$unit);
    local(%value);

    %value = %$ref;

    $deg1 = -1;
    $deg2 = 0;

    $halfsize = $rayon;
    $diam = $rayon*2;
    $pie_square = $diam+5;

    $tmplink = "..$dirsepurl..$dirsepurl"; # if ($update_homepage == 0);
    if ($update_homepage == 1) {
	$tmplink = "";
	$count_max_pie = 5;
    }
    if ($update_session_homepage == 1) {
	$count_max_pie = 5;
    }
 
   open(FLY,">$tmpfly$vtmp");
    print FLY "new\n";
    print FLY "size $pie_square,$pie_square\n";
    print FLY "frect 0,0,$pie_square,$pie_square,243,243,243\n";

    print FLY "circle $halfsize,$halfsize,$diam,255,255,255\n";

    $count = 0;
    $line_pie = '';
    $tmp3 = 0;
    $map_pie = '';

    #### CONSTRUIRE UNE MAP
    foreach $pays (sort {$value{$b} <=> $value{$a} } keys %value) {
	next if ($zonepays{$pays} != $zone && $type == 4);
	if ($count < $count_max_pie && $value{$pays} != 0) { 

	    $deg1 = $deg2;
	    $deg2 += int($value{$pays}*360/$tot) if ($tot != 0);

	    if ($deg1 != $deg2) {

		$j = $count % ($#gcolor);
		$count++;

		# segment 1
		$posx = $halfsize+(cos($deg1*$piradiant)*$rayon);
		$posy = $halfsize+(sin($deg1*$piradiant)*$rayon);
		print FLY "line $halfsize,$halfsize,$posx,$posy,255,255,255\n";
		$posxini = int($posx);
		$posyini = int($posy);
		
		# segment 2
		$posx = $halfsize+(cos($deg2*$piradiant)*$rayon);
		$posy = $halfsize+(sin($deg2*$piradiant)*$rayon);
		print FLY "line $halfsize,$halfsize,$posx,$posy,255,255,255\n";

		# fill the arc
		$deg3 = ($deg1 + $deg2)/2;
		$posx = $halfsize+(cos($deg3*$piradiant)*3*$rayon/4);
		$posy = $halfsize+(sin($deg3*$piradiant)*3*$rayon/4);
		print FLY "fill $posx,$posy,$red[$j],$green[$j],$blue[$j]\n";

		###

		$deg_step = 5;
		$deg_step = 1 if ($deg2-$deg1 <= 5);

		$tmp4 = '';
		$tmp4map = '';
		$tmp4 = "$pays" if ($type == 0);

		if ($type == 1) {
		    if (-f "$pathinit$dirress$dirsep$dirflags$dirsep$pays$gifext") {
			$tmp4 = "$L{$newflag{$pays}}";
		    } else {
			$tmp4 = "$L{'Unknown'} <I>($pays)</I>";
		    }
		}

		$tmp4 = "$extfile{$pays}" if ($type == 2 && $extfile{$pays} ne '');
		$tmp4 = "$pays" if ($type == 2 && $extfile{$pays} eq '');

		$tmp = '';
		if ($type == 3 || $type == 4) {
		    ($pays2,$tmp) = split(/:/,$pays) if ($pays =~ /\:/);
		    $pays2 = $pays if ($pays !~ /\:/);
		    $tmp4 = "$tmp" if ($tmp ne '');
		    $tmp4 = "$L{$newflag{$pays2}}" if ($tmp eq '' && $L{$newflag{$pays2}} ne '');
		    $tmp4 = "$newflag{$pays2}" if ($tmp eq '' && $L{$newflag{$pays2}} eq '');
		    $tmp4map = $tmp4;
		    $tmp4 .= "&nbsp;-&nbsp;<IMG SRC=\"$tmplink$linkpathinit$dirress$dirsepurl$dirflags$dirsepurl$pays2$gifext\" WIDTH=14 HEIGHT=14 BORDER=0 TITLE=\"$L{$newflag{$pays2}}\" ALT=\"$pays2$gifext\">";
		}

		$tmp4 = "$pays - $FailStatusMsgs{$pays}" if ($type == 5);
		$tmp4 = "$downloadunit[$pays]" if ($type == 6);
		$tmp4 = "$pays" if ($type == 7);
		$tmp4 = "$translate_os{$pays}" if ($type == 8 && $translate_os{$pays} ne '');
		$tmp4 = "$pays" if ($type == 8 && $translate_os{$pays} eq '');
		$coord = '';
#		print "AA - $file - $tot - $type - $pays - $value{$pays}\n";

		if (($deg2-$deg1) > 1) {

		    for ($i=$deg1;$i<=$deg2;$i+=$deg_step) {
			$posx = int($halfsize+(cos($i*$piradiant)*$rayon));
			$posy = int($halfsize+(sin($i*$piradiant)*$rayon));
			$coord = "$halfsize,$halfsize,$posxini,$posyini,$posx,$posy" if ($i == $deg1);
			$coord .= ",$posx,$posy" if ($i != $deg1);
		    }
		    $tmp4map = $tmp4 if ($type != 3 && $type != 4);

		    $map_pie .= "<AREA SHAPE=\"poly\" COORDS=\"$coord\" HREF=\"";
		    $map_pie .= "<!-- langhome -->$dirsepurl$linkpage" if ($linkpage ne '' && $update_session_homepage == 0);
		    $map_pie .= "$linkpage" if ($update_session_homepage == 1);
		    $map_pie .= "#" if ($linkpage eq '');
		    $map_pie .= "\" ALT=\"$pays\" onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$tmp4map','','','',3,'','$popup_graph_width')\">\n";
		}

		$deg1 = $deg1+$deg_step;
		###

		$pourcentvalue = $value{$pays}*100/$tot;
#		print "Y $pays - $value{$pays} - $tot - $pourcentvalue\n";
		$tmp3 += $pourcentvalue;
		$tmp5 += $value{$pays};

		$couleur = $gcolor[$j];

		$line_pie .= "<TR>\n";
		$line_pie .= "<TD CLASS=\"left\" " if (($j/2) == int($j/2));
		$line_pie .= "<TD CLASS=\"left_alter\" " if (($j/2) != int($j/2));
#		$line_pie .= "VALIGN=\"BOTTOM\"><IMG WIDTH=\"$square\" HEIGHT=\"$square\" SRC=\"$tmplink$linkpathinit$dirress$dirsepurl$couleur\" ALT=\"$couleur\"></TD>";
		$line_pie .= "VALIGN=\"BOTTOM\"><IMG WIDTH=\"$square\" HEIGHT=\"$square\" SRC=\"$tmplink$linkpathinit$dirress$dirsepurl$couleur\" ALT=\"$couleur\">&nbsp;";
#		$line_pie .= "<TD CLASS=\"left\">" if (($j/2) == int($j/2));
#		$line_pie .= "<TD CLASS=\"left_alter\">" if (($j/2) != int($j/2));
		$line_pie .= "$tmp4";
		$line_pie .= "&nbsp;</TD>";

		$line_pie .= "<TD CLASS=\"right\">" if (($j/2) == int($j/2));
		$line_pie .= "<TD CLASS=\"right_alter\">" if (($j/2) != int($j/2));

		$tmp6 = $value{$pays};
		if ($datatype != 0) {
		    $unit = "bytes";# if ($datatype == 1);
#		    $unit = "Kb" if ($datatype == 2);
		    if ($value{$pays} > 1024) {
			$unit = "Kb";# if ($datatype == 1);
#			$unit = "Mb" if ($datatype == 2);
			$tmp6 = int(10*($value{$pays}/1024))/10;
		    }
		    if ($value{$pays} > (1024*1024)) {
			$unit = "Mb"; # if ($datatype == 1);
#			$unit = "Gb" if ($datatype == 2);
			$tmp6 = int(10*($value{$pays}/(1024*1024)))/10;
		    }
		    if ($value{$pays} > (1024*1024*1024)) {
			$unit = "Gb"; # if ($datatype == 1);
#			$unit = "Tb" if ($datatype == 2);
			$tmp6 = int(10*($value{$pays}/(1024*1024*1024)))/10;
		    }
		    if ($value{$pays} > (1024*1024*1024*1024)) {
			$unit = "Tb"; # if ($datatype == 1);
			$tmp6 = int(10*($value{$pays}/(1024*1024*1024*1024)))/10;
		    }
		    $tmp6 = "$tmp6&nbsp;$unit";
		}

		$line_pie .= "$tmp6";
		$line_pie .= "</TD>\n";

		$pourcentvalue = int($pourcentvalue*10)/10;
		
		$line_pie .= "<TD CLASS=\"right\">" if (($j/2) == int($j/2));
		$line_pie .= "<TD CLASS=\"right_alter\">" if (($j/2) != int($j/2));
#		$line_pie .= "$value{$pays} - $tot - $pourcentvalue" if (int($pourcentvalue) != $pourcentvalue);
		$line_pie .= "$pourcentvalue" if (int($pourcentvalue) != $pourcentvalue);
		$line_pie .= $pourcentvalue.".0" if (int($pourcentvalue) == $pourcentvalue);
		$line_pie .= "&nbsp;%</TD></TR>\n";
	    }
	}

    }

### completion du camenbert

    if (int($deg2) < 359) {
	$deg1= int($deg2);
	$deg2 = 360;
	
        # segment 1
	$posx = $halfsize+(cos($deg1*$piradiant)*$rayon);
	$posy = $halfsize+(sin($deg1*$piradiant)*$rayon);
	print FLY "line $halfsize,$halfsize,$posx,$posy,255,255,255\n";

        # segment 2
	$posx = $halfsize+(cos($deg2*$piradiant)*$rayon);
	$posy = $halfsize+(sin($deg2*$piradiant)*$rayon);
	print FLY "line $halfsize,$halfsize,$posx,$posy,255,255,255\n";

        # fill the arc
	$deg1 = ($deg1 + $deg2)/2;
	$posx = $halfsize+(cos($deg1*$piradiant)*3*$rayon/4);
	$posy = $halfsize+(sin($deg1*$piradiant)*3*$rayon/4);
	print FLY "fill $posx,$posy,100,100,100\n";

	if ($tmp3 <= 99.9 && $update_homepage == 0) {

	    $tmp3 = int(10*(100-$tmp3))/10;
	    $tmp4 = int(10*($tot-$tmp5))/10;
	    $line_pie .= "<TR>\n";
	    $line_pie .= "<TD CLASS=\"left\" " if (($count_max_pie/2) == int($count_max_pie/2));
	    $line_pie .= "<TD CLASS=\"left_alter\" " if (($count_max_pie/2) != int($count_max_pie/2));
#	    $line_pie .= "VALIGN=\"BOTTOM\"><IMG WIDTH=\"$square\" HEIGHT=\"$square\" SRC=\"$tmplink$linkpathinit$dirress$dirsepurl$others\" ALT=\"$others\"></TD>";
	    $line_pie .= "VALIGN=\"BOTTOM\"><IMG WIDTH=\"$square\" HEIGHT=\"$square\" SRC=\"$tmplink$linkpathinit$dirress$dirsepurl$others\" ALT=\"$others\">&nbsp;";
#	    $line_pie .= "<TD CLASS=\"left\">" if (($count_max_pie/2) == int($count_max_pie/2));
#	    $line_pie .= "<TD CLASS=\"left_alter\">" if (($count_max_pie/2) != int($count_max_pie/2));
	    $line_pie .= "$L{'Others'}";
	    $line_pie .= "&nbsp;</TD>";

	    $line_pie .= "<TD CLASS=\"right\">" if (($count_max_pie/2) == int($count_max_pie/2));
	    $line_pie .= "<TD CLASS=\"right_alter\">" if (($count_max_pie/2) != int($count_max_pie/2));

	    $tmp5 = $tmp4;
	    if ($datatype != 0) {
		$unit = "bytes"; # if ($datatype == 1);
#		$unit = "Kb" if ($datatype == 2);
		if ($tmp4 > 1024) {
		    $unit = "Kb"; # if ($datatype == 1);
#		    $unit = "Mb" if ($datatype == 2);
		    $tmp5 = int(10*($tmp4/1024))/10;
		}
		if ($tmp4 > (1024*1024)) {
		    $unit = "Mb"; # if ($datatype == 1);
#		    $unit = "Gb" if ($datatype == 2);
		    $tmp5 = int(10*($tmp4/(1024*1024)))/10;
		}
		if ($tmp4 > (1024*1024*1024)) {
		    $unit = "Gb"; # if ($datatype == 1);
#		    $unit = "Tb" if ($datatype == 2);
		    $tmp5 = int(10*($tmp4/(1024*1024*1024)))/10;
		}
		if ($tmp4 > (1024*1024*1024*1024)) {
		    $unit = "Tb"; # if ($datatype == 1);
		    $tmp5 = int(10*($tmp4/(1024*1024*1024*1024)))/10;
		}
		$tmp5 = "$tmp5&nbsp;$unit";
	    }

	    $line_pie .= "$tmp5</TD>\n";

	    $line_pie .= "<TD CLASS=\"right\">" if (($count_max_pie/2) == int($count_max_pie/2));
	    $line_pie .= "<TD CLASS=\"right_alter\">" if (($count_max_pie/2) != int($count_max_pie/2));
	    $line_pie .= "$tmp3&nbsp;%</TD></TR>\n";
	}
    }

    print FLY "transparent 243,243,243\n";
    close (FLY);

    &BuildFly("$tmpfly$vtmp","$path$dirgraph$dirsep$file");
    return $line_pie,$map_pie;
   
}


#
##############################################################
### Extract file extension
##############################################################
#

sub Extract_Filetype {
  local($page) = @_;
  local($tmp1,$tmp);

  $tmp = rindex($page,$dirsep);
  $page = substr($page,$tmp,length($page)) if ($tmp != -1);

#  $page_debug = $page;
#  print "2 $page - $tmp\n";
#  $page =~ s/http:\/(.*)$// if ($page !~ /^http:\//);

#  if ($squid_format == 1) {
      # On remove le nom de domaine
#      $page = $page;
#      $page =~ s/^\///;
#      $page = substr($page,index($page,'/'));
#  }


  if ($page =~ /\?/) {
      $tmp1 = substr($page,0,index($page,'?'));
      $tmp1 = substr($tmp1,rindex($tmp1,$carext)) if (rindex($tmp1,$carext) != -1);
  } elsif ($page =~ /\;/) {
      $tmp1 = substr($page,0,index($page,';'));
      if ($mail_format == 1 && $page =~ /\&lt;/) {
	  $tmp1 = substr($page,index($page,';'),length($page));
      }
      $tmp1 =~ s/&nbsp//;
      $tmp1 = substr($tmp1,rindex($tmp1,$carext)) if (rindex($tmp1,$carext) != -1);
  } elsif ($page =~ /\#/) {
      $tmp1 = substr($page,0,index($page,'#'));
      $tmp1 = substr($tmp1,rindex($tmp1,$carext)) if (rindex($tmp1,$carext) != -1);
  } else {
      $tmp1 = substr($page,rindex($page,$carext)) if (rindex($page,$carext) != -1);
  }

  $tmp1 = lc($tmp1);
  $tmp1 =~ s/\#.*$//;
  $tmp1 =~ s/\/.*$//;

  if ($tmp1 eq '') {
#      print "No extension found for $page ($page_debug)\n";
      $tmp1 = 'Unknown';
#      exit;
  }
#  print "OO $page_debug - $page - $tmp1\n";
  return $tmp1;

}

#
##############################################################
### Filetype
##############################################################
#

sub Filetype {
  local(*FOUT,*L,$I) = @_;

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Stats'} - $L{'Filetype'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";
  &add_jqplot_js(*FOUT,2);

  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);

  &help_div(*FOUT);

  print FOUT "<H2> $L{'Filetype'}</H2><P>\n";
#  print FOUT "<P><HR><P>\n";
  print FOUT "<P>\n";

  print FOUT "<I>($L{'Only_files'} $L{'with_at_least'} $seuilpage $L{'requests'} $L{'are_shown'})</I>\n<P>" if ($seuilpage > 1);

  print FOUT "<p>\n<table class=\"tablesort table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
#  print FOUT "<TABLE>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH>&nbsp;$L{'Files'}&nbsp;</TH>\n";
  print FOUT "<TH>&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  if ($precision > 3 || $squid_format == 0) {
      print FOUT "<TH>&nbsp;$L{'Number'}&nbsp;</TH>\n";
      print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  }
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";

  $tmp4 = 0;
  for ($i=0;$i<=$#listext;$i++) {
      $tmp4 += $filetypenb{$listext[$i]};
  }


  $tmp10 =  $reqtot-$access;
  $tmp10 =  $reqtot if ($tmp10 == 0 || $ftp_format == 1);

  for ($l=0;$l<=$nbzonefile;$l++) {

    $k = $filetypemax[$l];
#    next if ($zoneext[$k] == 0 && $k == 0);

    next if ($zoneext[$k] == 0);

    if ($precision > 3 || $squid_format == 0) {
	$tmp = 0;
	for ($i=0;$i<=$#listext;$i++) {
	    if ($k == $extfilenb{$listext[$i]}) {
		$tmp += $filetypenb{$listext[$i]};
	    }
	}
    
#    print "$l - $zonefile[$k] - $zoneext[$k] - $filetypemax[$l]\n";
#	next if ($tmp < $seuilpage);
    }

    $percentage = $zoneext[$k]*100/$tmp10;

    $percentageint = int($percentage);
    print FOUT "<TR>\n<TD CLASS=\"head_left\">$zonefile[$k]</TD>\n<TD CLASS=\"head_right\">$zoneext[$k]</TD>\n<TD CLASS=\"head_left\">";
    print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"> " if ($percentageint != 0);
    printf FOUT "%.1f %</TD>\n",$percentage;
    if ($precision > 3 || $squid_format == 0) {
	print FOUT "<TD CLASS=\"head_right\">$tmp</TD><TD CLASS=\"head_left\">\n";
	$percentage = $tmp*100/$tmp4 if ($tmp4 != 0);
	$percentageint = int($percentage);
	print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"> " if ($percentageint != 0);
	printf FOUT "%.1f %</TD>\n",$percentage;
    }
    print FOUT "</TR>\n";

    $tmp5 = 0;
    for ($i=0;$i<=$#listext;$i++) {
	next if ($listext[$i] =~ /$extension/ && $ftp_format == 0);
#	next if ($filetypenb{$listext[$i]} < $seuilpage);
	if ($k == $extfilenb{$listext[$i]}) {
	    $tmp2 = $downloadext{$listext[$i]};
	    next if ($tmp2 < $seuilpage);
	    $tmp5++;
	    $percentage = $tmp2*100/$zoneext[$k];
	    $percentageint = int($percentage);
	    print FOUT "<TR>\n<TD CLASS=";
	    print FOUT "\"left\"" if (($tmp5/2) != int($tmp5/2));
	    print FOUT "\"left_alter\"" if (($tmp5/2) == int($tmp5/2));
	    print FOUT ">$extfile{$listext[$i]} ";
	    print FOUT "<A HREF=\"#$listext[$i]\">" if ($precision > 3 || $squid_format == 0);
	    print FOUT "($listext[$i])";
	    print FOUT "</A>" if ($precision > 3 || $squid_format == 0);
	    print FOUT "</TD>\n";
	    print FOUT "<TD CLASS=";
	    print FOUT "\"right\"" if (($tmp5/2) != int($tmp5/2));
	    print FOUT "\"right_alter\"" if (($tmp5/2) == int($tmp5/2));
	    print FOUT ">$tmp2</TD>\n";
	    print FOUT "<TD CLASS=";
	    print FOUT "\"left\"" if (($tmp5/2) != int($tmp5/2));
	    print FOUT "\"left_alter\"" if (($tmp5/2) == int($tmp5/2));
	    print FOUT ">";
	    print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($percentageint != 0);
	    printf FOUT "%.1f %</TD>\n",$percentage;
	    if ($precision > 3 || $squid_format == 0) {
		print FOUT "<TD CLASS=";
		print FOUT "\"right\"" if (($tmp5/2) != int($tmp5/2));
		print FOUT "\"right_alter\"" if (($tmp5/2) == int($tmp5/2));
		print FOUT ">$filetypenb{$listext[$i]}</TD>\n";
		print FOUT "<TD CLASS=";
		print FOUT "\"left\"" if (($tmp5/2) != int($tmp5/2));
		print FOUT "\"left_alter\"" if (($tmp5/2) == int($tmp5/2));
		print FOUT ">";
		$percentage = $filetypenb{$listext[$i]}*100/$tmp if ($tmp != 0);
		$percentageint = int($percentage);
		print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($percentageint != 0);
		printf FOUT "%.1f %</TD>\n",$percentage;
	}
	    print FOUT "</TR>\n";
	}
    }
}
  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n";
  print FOUT "<BR><P>\n";

#  $max = $downloadext{(&reverse_sort_by_value(*downloadext))[0]};
#  $min = $downloadext{(&reverse_sort_by_value(*downloadext))[$count_cloud_max]};

  if ($fly_set == 0) {
      $chart_id = 0;
      $info = "info".$chart_id;
      $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%downloadext,\@serie_color,$reqtot,2,1,$unit,$chart_id,0,$info,"","",$dirstatus);
  }

  ($line_cloud,$line_cloud_sort) = &MakeCloud(\%downloadext,'',1);
  $filetype_pie = "filetype2_pie".$gifext;
  
  print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
  print FOUT "<TR><TD VALIGN=TOP>\n";

  ($line_pie,$map_filetype_pie) = &MakePieChart($filetype_pie,$reqtot,\%downloadext,2,0,'',$rayon) if ($fly_set == 1);

#  &AddPieHtml(*FOUT, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_jqplot,$ymax_jqplot,2);

  print FOUT "<DIV ID=\"tog_occur\" STYLE=\"display:inline\">";
  print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
  print FOUT "<TR><TD ALIGN=CENTER VALIGN=TOP>";
  print FOUT "<TABLE BORDER=0>";
  print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Filetype'}</TH></TR>";
  print FOUT "$line_pie";
  print FOUT "</TABLE>\n";
  print FOUT "</TD>\n";
  print FOUT "<TD ALIGN=CENTER>";
  if ($fly_set == 1) {
      print FOUT "<IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$filetype_pie\" USEMAP=\"#map_filetype_graph\" BORDER=0 ALT=\"graph\">\n";
  }
  if ($fly_set == 0) {
      print FOUT "<div id=\"";
      print FOUT "chart".$chart_id;
      print FOUT "\" ";
      print FOUT "style=\"";
      print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
      print FOUT "</div>\n";
  }

  print FOUT "<P><I>$L{'Occurence'}</I>" if ($notrafic != 0);
  print FOUT "<P><I>$L{'Occurence'}</I> - <A HREF=\"javascript:ToggleBeta('tog_traffic','tog_occur');\">$L{'Traffic'}</A>" if ($notrafic == 0 && $fly_set == 1);
  print FOUT "<P><I>$L{'Occurence'}</I> - <A HREF=\"javascript:ToggleJqplotGraph2(plot1,'tog_traffic','tog_occur');\">$L{'Traffic'}</A>" if ($notrafic == 0 && $fly_set == 0);
  print FOUT "</TD></TR></TABLE>\n";


  if ($fly_set == 1) {
      print FOUT "<MAP NAME=\"map_filetype_graph\">\n";
      $tmp = $map_filetype_pie;
      $tmp =~ s/<!-- langhome -->/$I/g;
      print FOUT "$tmp";
      print FOUT "</MAP>\n";
  }

  if ($fly_set == 0) {
      if ($xmax_jqplot != $xmax_home_jqplot) {
	  print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
      }
      print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
  }
  print FOUT "</DIV>\n";

  # Trafic

  if ($notrafic == 0) {

      $tmp = $totsize;
      if ($fly_set == 0) {
	  $chart_id++;
	  $info = "info".$chart_id;
	  $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%downloadsizeext,\@serie_color,$tmp,2,$unit_div,$unit,$chart_id,1,$info,"","",$filetype);
      }

      if ($fly_set == 1) {
	  $filetype_pie = "filetype_pie".$gifext;
	  ($line_pie,$map_filetype_pie) = &MakePieChart($filetype_pie,$tmp,\%downloadsizeext,2,1,'',$rayon);
      }

      print FOUT "<DIV ID=\"tog_traffic\" STYLE=\"display:none\">";
      print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
      print FOUT "<TR><TD ALIGN=CENTER VALIGN=TOP>";
      print FOUT "<TABLE BORDER=0>";
      print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Filetype'}</TH></TR>";
      print FOUT "$line_pie";
      print FOUT "</TABLE>\n";
      print FOUT "</TD>\n";
      print FOUT "<TD ALIGN=CENTER>";
      if ($fly_set == 1) {
	  print FOUT "<IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$filetype_pie\" USEMAP=\"#map_filetype2_graph\" BORDER=0 ALT=\"graph\">\n";
      }
      if ($fly_set == 0) {
	  print FOUT "<div id=\"";
	  print FOUT "chart".$chart_id;
	  print FOUT "\" ";
	  print FOUT "style=\"";
	  print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
	  print FOUT "</div>\n";
      }

      print FOUT "<P><I><A HREF=\"javascript:ToggleBeta('tog_occur','tog_traffic');\">$L{'Occurence'}</A> - $L{'Traffic'}</I>" if ($fly_set == 1);
      print FOUT "<P><I><A HREF=\"javascript:ToggleJqplotGraph2(plot0,'tog_occur','tog_traffic');\">$L{'Occurence'}</A> - $L{'Traffic'}</I>" if ($fly_set == 0);
      print FOUT "</TD></TR></TABLE>\n";


      if ($fly_set == 1) {
	  print FOUT "<MAP NAME=\"map_filetype2_graph\">\n";
	  $tmp = $map_filetype_pie;
	  $tmp =~ s/<!-- langhome -->/$I/g;
	  print FOUT "$tmp";
	  print FOUT "</MAP>\n";
      }

      if ($fly_set == 0) {

	  if ($xmax_jqplot != $xmax_home_jqplot) {
	      print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
	  }
	  print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
      }
      print FOUT "</DIV>\n";

  }

   print FOUT "</TD><TD VALIGN=TOP align=\"justify\">";

    print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'Sort'} : <A HREF=\"javascript:ToggleBeta('tog_alpha','tog_value');\">$L{'Alphabetically'}</A> - <A HREF=\"javascript:ToggleBeta('tog_value','tog_alpha');\">$L{'By_size'}</A></DIV><P>";

    print FOUT "<DIV ID=\"tog_alpha\" STYLE=\"display:inline\">";
    print FOUT "$line_cloud\n";
    print FOUT "</DIV>\n";
    print FOUT "<P>";

    print FOUT "<DIV ID=\"tog_value\" STYLE=\"display:none\">";
    print FOUT "$line_cloud_sort\n";
    print FOUT "</DIV>\n";


  print FOUT "<P><BR>\n";

  if ($fly_set == 0) {
      $chart_id++;
      $info = "info".$chart_id;
      $i = &Load_DailyData($datafile,$dirdata);

      if ($docmax > 0) {

      $xlegend = "$i $L{'days'}";
#    $xlegend .= "s" if ($count_month > 1);
      $xlegend .= " (starting $start_date)";
      $ylegend = $L{'Documents'};
      
      undef @ref_tab;
      push(@ref_tab,\@tabreq);
      push(@ref_tab,\@tabacc);
      push(@ref_tab,\@tabmm);
      push(@ref_tab,\@tabdoc);
      push(@ref_tab,\@tabscript);
      push(@ref_tab,\@tabuser);
      push(@ref_tab,\@tabtrafic);
      
      @ref_tab_name = ('requests','accesses','hosts','documents2','scripts','users','traffic');

      &MakeDailyGraphJqplotInit(*FOUT, eval($Lang{$lang[$nblang]}),$I,1,$unit_div,\@ref_tab,\@ref_tab_name,\@listdate,$chart_id);
      
      @graph_to_display = ('Document');

      undef @ref_tab;
      push(@ref_tab,\@tabdoc);

      &MakeDailyGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,1,\@graph_to_display,\@ref_tab,\@listdate,\@serie_color,1,$unit,$chart_id,3,"documents2",$info,$chart_id,$xlegend,$ylegend,$xmax_jqplot,$filetype);

      &AddJqplotHtml(*FOUT, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_jqplot,$ymax_jqplot,2);

      $chart_id += $#list_graph_name_jqplot+1;
      }
  }

  if ($fly_set == 1) {
      $file_page_page = "document-home";
      print FOUT "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
      print FOUT "<TR>\n";
      $tmp = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$file_page_page."y".$gifext;
      print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"y\"></TD>\n";
      $tmp = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$file_page_page.$gifext;
      print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"graph\" USEMAP=\"#map_page_graph\" BORDER=0></TD>\n";
      print FOUT "</TR><TR><TD></TD>\n";
      $tmp = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$file_page_page."x".$gifext;
      print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$tmp\" ALT=\"x\"></TD>\n";
      print FOUT "</TR>\n";
      print FOUT "</TABLE></CENTER>\n";
      print FOUT "<MAP NAME=\"map_page_graph\">";
      $tmp = $map_page_graph;
      $tmp =~ s/<!-- langhome -->/$I/g;
      print FOUT "$tmp";
#  print FOUT "$map_page_graph";
      print FOUT "</MAP>\n";
  }

    print FOUT "</TD></TR>\n";
    print FOUT "</TABLE>\n";

  if ($precision > 3 || $squid_format == 0) {

      print FOUT "<I>($L{'Only_files'} $L{'with_at_least'} $seuilpage $L{'requests'} $L{'are_shown'})</I>\n<P>" if ($seuilpage > 1);

      print FOUT "<p>\n<table class=\"tablesort table-stripeclass:alternate\">\n";
      print FOUT "<thead>\n";
      print FOUT "<TR>\n";
      print FOUT "<TH>&nbsp;$L{'Files'}&nbsp;</TH>\n";
      print FOUT "<TH>&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
      print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      if ($notrafic == 0) {
	  print FOUT "<TH>&nbsp;$L{'Traffic'}&nbsp;</TH>\n";
	  print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      }
      print FOUT "</TR>\n";
      print FOUT "</thead>\n";
      print FOUT "<tbody>\n";

      for ($l=0;$l<=$#maxfi;$l++) {

	  $k = $filetypelistmax[$l];

	  next if ($listext[$k] =~ /$extension/ && $ftp_format == 0);
	  $tmp2 = $downloadext{$listext[$k]};
	  if ($tmp2 > $seuilpage) {

	      $percentage = $tmp2*100/$tmp10;
	      $percentageint = int($percentage);
	      print FOUT "<TR>\n";
	      print FOUT "<TD CLASS=";
	      print FOUT "\"head_left\"";
	      print FOUT ">";
	      print FOUT "<A NAME=\"$listext[$k]\"></A>";
	      print FOUT "$extfile{$listext[$k]}" if ($extfile{$listext[$k]} ne '');
	      print FOUT "<I>Unknown</I> ($listext[$k])" if ($extfile{$listext[$k]} eq '');
	      print FOUT "</TD>\n<TD CLASS=";
	      print FOUT "\"head_right\"";
	      print FOUT ">$tmp2</TD>\n<TD CLASS=";
	      print FOUT "\"head_left\"";
	      print FOUT ">";
	      print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"> " if ($percentageint != 0);
	      printf FOUT "%.1f %</TD>\n",$percentage;
	      
	      if ($notrafic == 0) {
		  $tmp4 = $downloadsizeext{$listext[$k]}/(1024*1024);
		  $percentage = ($tmp4*100)/$totsize;
		  $percentageint = int($percentage);
		  
		  print FOUT "<TD CLASS=";
		  print FOUT "\"head_right\"";
		  printf FOUT ">%.2f $L{'Mb'}</TD>\n<TD CLASS=",$tmp4;
		  print FOUT "\"head_left\"";
		  print FOUT ">";
		  print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"> " if ($percentageint != 0);
		  printf FOUT "%.1f %</TD>\n",$percentage;
	      }
	      print FOUT "</TR>\n";

	      $i=0;
	      $tmp = 0;

#	      while ($tmp < $topten && $besttype[$i] != 0) {
	      if ($tmp < $topten) {
		  foreach $page (&reverse_sort_by_value(*filetype)) {
#		  for ($j=1;$j<= $counttype[$besttype[$i]];$j++) {
#		      $page = $occur_countertype{$besttype[$i],$j};
		      $page2 = $page;

		      $page2 = &clean_url($page2,1);

#		      $page2 =~ s/\?(.*)//;
#		      $page2 =~ s/$dirsep/_/g;
#		      $page2 =~ s/\s+/_/g;
#		      $page2 =~ s/\+/_/g;
#		      $page2 =~ s/\)/_/g;
#		      $page2 =~ s/\(/_/g;
#		      $page2 =~ s/[\[\]]/_/g;
#		      $page2 =~ s/\*/_/g;
		      $page2 .= $htmlext;

		      $tmp1 = substr($page,rindex($page,$carext));
		      $tmp1 =~ tr/[A-Z]/[a-z]/;
		      $tmp1 =~ s/\#.*$//;

		      if ($tmp1 eq $listext[$k]) {
			  $tmp++;
			  last if ($tmp > $topten);
			  
#			  $percentage = $besttype[$i]*100/$tmp2;
			  $percentage = $filetype{$page}*100/$tmp2;
			  $percentageint = int($percentage);
			  print FOUT "<TR>\n";
			  print FOUT "<TD CLASS=";
			  print FOUT "\"left\"" if (($tmp/2) != int($tmp/2));
			  print FOUT "\"left_alter\"" if (($tmp/2) == int($tmp/2));
			  print FOUT ">$page</TD>\n";
			  print FOUT "<TD CLASS=";
			  print FOUT "\"right\"" if (($tmp/2) != int($tmp/2));
			  print FOUT "\"right_alter\"" if (($tmp/2) == int($tmp/2));
			  print FOUT ">";
			  print FOUT "<A HREF=\"$page2\">" if ($precision > 3 && $filetype{$page} > $seuilpage);
#			  print FOUT "$besttype[$i]";
			  print FOUT "$filetype{$page}";
			  print FOUT "</A>" if ($precision > 3 && $filetype{$page} > $seuilpage);
			  print FOUT "</TD>\n";
			  print FOUT "<TD CLASS=";
			  print FOUT "\"left\"" if (($tmp/2) != int($tmp/2));
			  print FOUT "\"left_alter\"" if (($tmp/2) == int($tmp/2));
			  print FOUT ">";
			  print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($percentageint != 0);
			  printf FOUT "%.1f %</TD>\n",$percentage;
			  
			  if ($notrafic == 0) {
			      $percentage = $sizepage{$page}*100/($tmp4*1024*1024) if ($tmp4 != 0);
			      $percentageint = int($percentage);
			      
			      print FOUT "<TD CLASS=";
			      print FOUT "\"right\"" if (($tmp/2) != int($tmp/2));
			      print FOUT "\"right_alter\"" if (($tmp/2) == int($tmp/2));
			      print FOUT ">";
			      printf FOUT "%.1f $L{'Kb'}",($sizepage{$page}/1024) if ($sizepage{$page}/1024 < 1024);
			      printf FOUT "%.2f $L{'Mb'}",($sizepage{$page}/(1024*1024)) if ($sizepage{$page}/1024 >= 1024);
			      print FOUT "</TD>\n";
			      print FOUT "<TD CLASS=";
			      print FOUT "\"left\"" if (($tmp/2) != int($tmp/2));
			      print FOUT "\"left_alter\"" if (($tmp/2) == int($tmp/2));
			      print FOUT ">";
			      print FOUT "<IMG WIDTH=$percentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($percentageint != 0);
			      printf FOUT "%.1f %</TD>\n",$percentage;
			  }
			  print FOUT "</TR>\n";
		      }
		  }
		  $i++;
	      }
	  }      
      }
  }

  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n";
  print FOUT "</BODY></HTML>\n";
}

# 
##############################################################
### Squid
##############################################################
#

sub PagesSquid {
    local(*FOUT,*L,$I) = @_;
    local($unit,$unitsize,$max);

    print FOUT "$doctype\n";
#    print FOUT "<HTML><HEAD>\n";
    print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
    print FOUT "$charset\n";
    print FOUT "<TITLE>$L{'Stats'} - $L{'Squid'}</TITLE>\n";
    print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
    print FOUT "$curvy_bottom_jss\n";

    $unit = "$L{'bytes'}";
    $unitsize = 1;
    $max =  $peer_size_tot*1024;
    if ($max > 1024) {
	$unit = "$L{'Kb'}";
	$unitsize = 1024;
    }
    if ($max > (1024*1024)) {
	$unit = "$L{'Mb'}";
	$unitsize = 1024*1024;
    }
    if ($max > (1024*1024*1024)) {
	$unit = "$L{'Gb'}";
	$unitsize = 1024*1024*1024;
    }
    if ($max > (1024*1024*1024*1024)) {
	$unit = "$L{'Tb'}";
	$unitsize = 1024*1024*1024*1024;
    }

    if (int($peer_size_tot/$unitsize) < 10) {
	$unitsize /= 1024;
	$unit = "$L{'bytes'}" if ($unit eq "$L{'Kb'}");
	$unit = "$L{'Kb'}" if ($unit eq "$L{'Mb'}");
	$unit = "$L{'Mb'}" if ($unit eq "$L{'Gb'}");
	$unit = "$L{'Gb'}" if ($unit eq "$L{'Tb'}");
    }

    &add_css_style(*FOUT,2);

    print FOUT "</HEAD>\n";
    print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
    &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
    print FOUT "<P><DIV CLASS=\"item_page\">-&nbsp;$L{'Global_access'}</DIV><P>";

    print FOUT "$L{'Cached_files'} : $tcp_udp_hit{'TCP','HIT'} <BR>$L{'Downloaded_files'} : $tcp_udp_hit{'TCP','MISS'}<P>";

    print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
    print FOUT "<thead>\n";
    print FOUT "<TR>\n";
    print FOUT "<TH class=\"table-sortable:default\">&nbsp;</TH>\n";
    print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
    print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
    print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n";
    print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
    if ($struct_logfile =~ /\%elapsed/) {
	print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Average_elapsed_time'}&nbsp;($L{'milliseconds'})&nbsp;</TH>\n";
	print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Kb'}/s&nbsp;</TH>\n";
    }
    print FOUT "</TR>\n";
    print FOUT "</thead>\n";
    print FOUT "<tbody>\n";

    $pourcentage = 100;
    if ($code_peer_tot != 0) {
	print FOUT "<TR>\n<TD CLASS=\"left\">Total traffic</TD>\n<TD CLASS=\"right\">$code_peer_tot</TD>\n";
	print FOUT "<TD CLASS=\"left\">\n";
	print FOUT "<IMG WIDTH=$pourcentage HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"> ";
	printf FOUT "%.1f %",$pourcentage;
	print FOUT "</TD>\n<TD CLASS=\"right\">\n";
	printf FOUT "%.1f",($peer_size_tot*1024)/$unitsize;
	print FOUT "</TD>\n";
	print FOUT "<TD CLASS=\"left\">\n";
	print FOUT "<IMG WIDTH=$pourcentage HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"> ";
	printf FOUT "%.1f %",$pourcentage;
	print FOUT "</TD>\n";
	if ($struct_logfile =~ /\%elapsed/) {
	    print FOUT "<TD CLASS=\"right\">";
	    printf FOUT "%.1f",$peer_elapsed_tot/$code_peer_tot if ($code_peer_tot != 0);
	    print FOUT "</TD>\n<TD CLASS=\"right\">";
	    printf FOUT "%.1f",$peer_size_tot/($peer_elapsed_tot/1000) if ($peer_elapsed_tot != 0);
	    print FOUT "</TD>\n";
	}
	print FOUT "</TR>\n";
    }

  if ($status_code_peer{'DIRECT'} ne '') {
      $pourcentage = ($status_code_peer{'DIRECT'}*100)/$code_peer_tot if ($code_peer_tot != 0);
      $pourcentageint = int($pourcentage);
      $pourcentage2 = ($peer_size{'DIRECT'}*100)/$peer_size_tot if ($peer_size_tot != 0);
      $pourcentageint2 = int($pourcentage2);

      print FOUT "<TR>\n<TD CLASS=\"left\">Direct fetches</TD>\n<TD CLASS=\"right\">$status_code_peer{'DIRECT'}</TD>\n";
      print FOUT "<TD CLASS=\"left\">";
      print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"> " if ($pourcentageint != 0);
      printf FOUT "%.1f %",$pourcentage;
      print FOUT "</TD>\n<TD CLASS=\"right\">\n";
      printf FOUT "%.1f",($peer_size{'DIRECT'}*1024)/$unitsize;
      print FOUT "</TD>\n";
      print FOUT "<TD CLASS=\"left\">\n";
      print FOUT "<IMG WIDTH=$pourcentageint2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"> " if ($pourcentageint2 != 0);
      printf FOUT "%.1f %",$pourcentage2;
      print FOUT "</TD>\n";
      if ($struct_logfile =~ /\%elapsed/) {
	  print FOUT "<TD CLASS=\"right\">";
	  printf FOUT "%.1f",$peer_elapsed{'DIRECT'}/$code_peer_tot if ($code_peer_tot != 0);
	  print FOUT "</TD>\n<TD CLASS=\"right\">";
	  printf FOUT "%.1f",$peer_size{'DIRECT'}/($peer_elapsed{'DIRECT'}/1000) if ($peer_elapsed{'DIRECT'} != 0);
	  print FOUT "</TD>\n";
      }
      print FOUT "</TR>\n";
  }


  if ($status_code_peer{'NONE'} ne '') {

      $pourcentage = ($status_code_peer{'NONE'}*100)/$code_peer_tot if ($code_peer_tot != 0);;
      $pourcentageint = int($pourcentage);
      $pourcentage2 = ($peer_size{'NONE'}*100)/$peer_size_tot if ($peer_size_tot != 0);
      $pourcentageint2 = int($pourcentage2);
      
      print FOUT "<TR>\n<TD CLASS=\"left\">This server</TD>\n<TD CLASS=\"right\">$status_code_peer{'NONE'}</TD>";
      print FOUT "<TD CLASS=\"left\">\n";
      print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"> " if ($pourcentageint != 0);
      printf FOUT "%.1f %",$pourcentage;
      print FOUT "</TD>\n<TD CLASS=\"right\">\n";
      printf FOUT "%.1f",($peer_size{'NONE'}*1024/$unitsize);
      print FOUT "</TD>\n";
      print FOUT "<TD CLASS=\"left\">\n";
      print FOUT "<IMG WIDTH=$pourcentageint2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"> " if ($pourcentageint2 != 0);
      printf FOUT "%.1f %",$pourcentage2;
      print FOUT "</TD>\n";
      if ($struct_logfile =~ /\%elapsed/) {
	  print FOUT "<TD CLASS=\"right\">";
	  printf FOUT "%.1f",$peer_elapsed{'NONE'}/$code_peer_tot if ($code_peer_tot != 0);
	  print FOUT "</TD>\n<TD CLASS=\"right\">";
	  printf FOUT "%.1f",$peer_size{'NONE'}/($peer_elapsed{'NONE'}/1000) if ($peer_elapsed{'NONE'} != 0);
	  print FOUT "</TD>\n";
      }
      print FOUT "</TR>\n";
  }

  if ($peer_other_server != 0) {
      $pourcentage = ($peer_other_server*100)/$code_peer_tot if ($code_peer_tot != 0);
      $pourcentageint = int($pourcentage);
      $pourcentage2 = ($peer_size_other_server*100)/$peer_size_tot if ($peer_size_tot != 0);
      $pourcentageint2 = int($pourcentage2);

      print FOUT "<TR\n><TD CLASS=\"left\">Other servers</TD>\n<TD CLASS=\"right\">$peer_other_server</TD>\n";
      print FOUT "<TD CLASS=\"left\">\n";
      print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"> " if ($pourcentageint != 0);
      printf FOUT "%.1f %",$pourcentage;
      print FOUT "</TD><TD CLASS=\"right\">\n";
      printf FOUT "%.1f",($peer_size_other_server*1024/$unitsize);
      print FOUT "</TD>\n";
      print FOUT "<TD CLASS=\"left\">\n";
      print FOUT "<IMG WIDTH=$pourcentageint2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"> " if ($pourcentageint2 != 0);
      printf FOUT "%.1f %",$pourcentage2;
      print FOUT "</TD>\n";
      if ($struct_logfile =~ /\%elapsed/) {
	  print FOUT "<TD CLASS=\"right\">";
	  printf FOUT "%.1f",$peer_elapsed_other_server/$code_peer_tot if ($code_peer_tot != 0);
	  print FOUT "</TD>\n<TD CLASS=\"right\">";
	  printf FOUT "%.1f",$peer_size_other_server/($peer_elapsed_other_server/1000) if ($peer_elapsed_other_server != 0);
	  print FOUT "</TD>\n";
      }
      print FOUT "</TR>\n";
  }

  $tmp = $status_code_peer{'NONE'}+$peer_other_server;

  if ($tmp != 0 && $peer_other_server != 0) {
      $pourcentage = ($tmp*100)/$code_peer_tot if ($code_peer_tot != 0);
      $pourcentageint = int($pourcentage);

      $tmp1 = ($peer_size{'NONE'}+$peer_size_other_server)*1024/$unitsize;
      $pourcentage2 = ($tmp1*100)/$peer_size_tot if ($peer_size_tot != 0);
      $pourcentageint2 = int($pourcentage2);
      
      $tmp2 = $peer_elapsed{'NONE'}+$peer_elapsed_other_server;
      
      print FOUT "<TR><TD CLASS=\"left\">Cache hierarchy</TD>\n<TD CLASS=\"right\">$tmp</TD>\n";
      print FOUT "<TD CLASS=\"left\">\n";
      print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"> " if ($pourcentageint != 0);
      printf FOUT "%.1f %",$pourcentage;
      print FOUT "</TD>\n<TD CLASS=\"right\">\n";
      printf FOUT "%.1f",$tmp1;
      print FOUT "</TD>\n";
      print FOUT "<TD CLASS=\"left\">\n";
      print FOUT "<IMG WIDTH=$pourcentageint2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"> " if ($pourcentageint2 != 0);
      printf FOUT "%.1f %",$pourcentage2;
      print FOUT "</TD>\n";
      if ($struct_logfile =~ /\%elapsed/) {
	  print FOUT "<TD CLASS=\"right\">";
	  printf FOUT "%.1f",$tmp2/$code_peer_tot if ($code_peer_tot != 0);
	  print FOUT "</TD>\n<TD CLASS=\"right\">";
	  printf FOUT "%.1f",$tmp1/($tmp2/1000) if ($tmp2 != 0);
	  print FOUT "</TD>\n";
      }
      print FOUT "</TR>\n";
  }

  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n";

  print FOUT "<P><DIV CLASS=\"item_page\">-&nbsp;$L{'Incoming_requests_by_status'}</DIV><P>";

  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Status_code'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  if ($struct_logfile =~ /\%elapsed/) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Average_elapsed_time'}&nbsp;($L{'milliseconds'})&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Kb'}/s&nbsp;</TH>\n";
  }
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";

  $done_hit = 0;
  $done_miss = 0;
    foreach $status (sort (keys %tcp_udp)) {

	$pourcentage = ($tcp_udp{$status}*100)/$tot_tcp_udp if ($tot_tcp_udp != 0);
	$pourcentageint = int($pourcentage);
	$pourcentage2 = ($size_tcp_udp{$status}*100)/$tot_size_tcp_udp if ($tot_size_tcp_udp != 0);
	$pourcentageint2 = int($pourcentage2);

	print FOUT "<TR>\n<TD CLASS=\"head_left\">$status</TD><TD CLASS=\"head_right\">$tcp_udp{$status}</TD>";
	print FOUT "<TD CLASS=\"head_left\">\n";
	print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
	printf FOUT "%.1f %",$pourcentage;
	print FOUT "</TD>\n";
	print FOUT "<TD CLASS=\"head_right\">";
	printf FOUT "%.1f",$size_tcp_udp{$status}*1024/$unitsize;
	print FOUT "</TD>\n";
	print FOUT "<TD CLASS=\"head_left\">\n";
	print FOUT "<IMG WIDTH=$pourcentageint2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint2 != 0);
	printf FOUT "%.1f %",$pourcentage2;
	print FOUT "</TD>\n";
	if ($struct_logfile =~ /\%elapsed/) {
	    print FOUT "<TD CLASS=\"head_right\">";
	    printf FOUT "%.1f ",($tcp_elapsed{$status}/$tcp_udp{$status}) if ($tcp_udp{$status} != 0);
	    print FOUT "</TD>\n";
	    print FOUT "<TD CLASS=\"head_right\">";
	    printf FOUT "%.1f ",($size_tcp_udp{$status}/($tcp_elapsed{$status}/1000)) if ($tcp_elapsed{$status} != 0);
	    print FOUT "</TD>\n";
	}
	print FOUT "</TR>\n";

	foreach $tmp (sort (keys %status_code_squid)) {
	    $tmp1 = $tcp_udp_hit{$status,'HIT'};
	    $tmp2 = $tcp_udp_size_hit{$status,'HIT'};
	    $tmp3 = $tcp_udp_elapsed{$status,'HIT'};
	    if ($tmp =~ /^$status/ && $tmp =~ /HIT/i) {
		if ($done_hit ne $status) {
		    $pourcentage = ($tmp1*100)/$tcp_udp{$status} if ($tcp_udp{$status} != 0);
		    $pourcentageint = int($pourcentage);
		    $pourcentage2 = ($tmp2*100)/$size_tcp_udp{$status} if ($size_tcp_udp{$status} != 0);
		    $pourcentageint2 = int($pourcentage2);
		    print FOUT "<TR>\n<TD CLASS=\"left\">HIT</TD>\n<TD CLASS=\"right\">$tmp1</TD>\n";
		    print FOUT "<TD CLASS=\"left\">\n";
		    print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[2]\"> " if ($pourcentageint != 0);
		    printf FOUT "%.1f %",$pourcentage;
		    print FOUT "</TD>\n";
		    print FOUT "<TD CLASS=\"right\">";
		    printf FOUT "%.1f",$tmp2*1024/$unitsize;
		    print FOUT "</TD>\n";
		    print FOUT "<TD CLASS=\"left\">\n";
		    print FOUT "<IMG WIDTH=$pourcentageint2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\"> " if ($pourcentageint2 != 0);
		    printf FOUT "%.1f %",$pourcentage2;
		    print FOUT "</TD>\n";
		    if ($struct_logfile =~ /\%elapsed/) {
			print FOUT "<TD CLASS=\"right\">";
			printf FOUT "%.1f ",($tmp3/$tmp1) if ($tmp1 != 0);
			print FOUT "</TD>\n";
			print FOUT "<TD CLASS=\"right\">";
			printf FOUT "%.1f ",($tmp2/($tmp3/1000)) if ($tmp3 != 0);
			print FOUT "</TD>\n";
		    }
		    print FOUT "</TR>\n";
		    $done_hit = $status;
		}
		$pourcentage = ($status_code_squid{$tmp}*100)/$tcp_udp{$status} if ($tcp_udp{$status} != 0);
		$pourcentageint = int($pourcentage);
		$pourcentage2 = ($squid_size{$tmp}*100)/$size_tcp_udp{$status} if ($size_tcp_udp{$status} != 0);
		$pourcentageint2 = int($pourcentage2);
		print FOUT "<TR><TD CLASS=\"left\"><I>&nbsp;&nbsp;&nbsp;-&nbsp;$tmp</I></TD>\n<TD CLASS=\"right\"><I>$status_code_squid{$tmp}</I></TD>\n";
		print FOUT "<TD CLASS=\"left\">\n";
		print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
		printf FOUT "%.1f %",$pourcentage;
		print FOUT "</TD>\n";
		print FOUT "<TD CLASS=\"right\">";
		printf FOUT "%.1f",$squid_size{$tmp}*1024/$unitsize;
		print FOUT "</TD>\n";
		print FOUT "<TD CLASS=\"left\">\n";
		print FOUT "<IMG WIDTH=$pourcentageint2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint2 != 0);
		printf FOUT "%.1f %",$pourcentage2;
		print FOUT "</TD>\n";
		if ($struct_logfile =~ /\%elapsed/) {
		    print FOUT "<TD CLASS=\"right\">";
		    printf FOUT "%.1f ",($squid_elapsed{$tmp}/$status_code_squid{$tmp}) if ($status_code_squid{$tmp} != 0);
		    print FOUT "</TD>\n";
		    print FOUT "<TD CLASS=\"right\">";
		    printf FOUT "%.1f ",($squid_size{$tmp}/($squid_elapsed{$tmp}/1000)) if ($squid_elapsed{$tmp} != 0);
		    print FOUT "</TD>\n";
		}
		print FOUT "</TR>\n";
	    }
	}

	foreach $tmp (sort (keys %status_code_squid)) {
	    $tmp1 = $tcp_udp_hit{$status,'MISS'};
	    $tmp2 = $tcp_udp_size_hit{$status,'MISS'};
	    $tmp3 = $tcp_udp_elapsed{$status,'MISS'};
	    if ($tmp =~ /^$status/ && $tmp =~ /MISS/i) {
		if ($done_miss ne $status) {
		    $pourcentage = ($tmp1*100)/$tcp_udp{$status} if ($tcp_udp{$status} != 0);
		    $pourcentageint = int($pourcentage);
		    $pourcentage2 = ($tmp2*100)/$size_tcp_udp{$status} if ($size_tcp_udp{$status} != 0);
		    $pourcentageint2 = int($pourcentage2);
		    print FOUT "<TR><TD CLASS=\"left\">MISS</TD>\n<TD CLASS=\"right\">$tmp1</TD>\n";
		    print FOUT "<TD CLASS=\"left\">\n";
		    print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\"> " if ($pourcentageint != 0);
		    printf FOUT "%.1f %",$pourcentage;
		    print FOUT "</TD>\n";
		    print FOUT "<TD CLASS=\"right\">";
		    printf FOUT "%.1f",$tmp2*1024/$unitsize;
		    print FOUT "</TD>\n";
		    print FOUT "<TD CLASS=\"left\">\n";
		    print FOUT "<IMG WIDTH=$pourcentageint2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\"> " if ($pourcentageint2 != 0);
		    printf FOUT "%.1f %",$pourcentage2;
		    print FOUT "</TD>\n";
		    if ($struct_logfile =~ /\%elapsed/) {
			print FOUT "<TD CLASS=\"right\">";
			printf FOUT "%.1f ",($tmp3/$tmp1);
			print FOUT "</TD>\n";
			print FOUT "<TD CLASS=\"right\">";
			printf FOUT "%.1f ",($tmp2/($tmp3/1000)) if ($tmp3 != 0);
			print FOUT "</TD>\n";
		    }
		    print FOUT "</TR>\n";
		    $done_miss = $status;
		}
		$pourcentage = ($status_code_squid{$tmp}*100)/$tcp_udp{$status} if ($tcp_udp{$status} != 0);
		$pourcentageint = int($pourcentage);
		$pourcentage2 = ($squid_size{$tmp}*100)/$size_tcp_udp{$status} if ($size_tcp_udp{$status} != 0);
		$pourcentageint2 = int($pourcentage2);
		print FOUT "<TR>\n<TD CLASS=\"left\"><I>&nbsp;&nbsp;&nbsp;-&nbsp;$tmp</I></TD><TD CLASS=\"right\"><I>$status_code_squid{$tmp}</I></TD>\n";
		print FOUT "<TD CLASS=\"left\">\n";
		print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
		printf FOUT "%.1f %",$pourcentage;
		print FOUT "</TD>\n";
		print FOUT "<TD CLASS=\"right\">";
		printf FOUT "%.1f",$squid_size{$tmp}*1024/$unitsize;
		print FOUT "</TD>";
		print FOUT "<TD CLASS=\"left\">\n";
		print FOUT "<IMG WIDTH=$pourcentageint2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint2 != 0);
		printf FOUT "%.1f %",$pourcentage2;
		print FOUT "</TD>";
		if ($struct_logfile =~ /\%elapsed/) {
		    print FOUT "<TD CLASS=\"right\">";
		    printf FOUT "%.1f ",($squid_elapsed{$tmp}/$status_code_squid{$tmp}) if ($status_code_squid{$tmp} != 0);
		    print FOUT "</TD>\n";
		    print FOUT "<TD CLASS=\"right\">";
		    printf FOUT "%.1f ",($squid_size{$tmp}/($squid_elapsed{$tmp}/1000)) if ($squid_elapsed{$tmp} != 0);
		    print FOUT "</TD>\n";
		}
		print FOUT "</TR>\n";
	    }
	}

	foreach $tmp (sort (keys %status_code_squid)) {
	    $tmp1 = $tcp_udp_hit{$status,'ERR'};
	    $tmp2 = $tcp_udp_size_hit{$status,'ERR'};
	    $tmp3 = $tcp_udp_elapsed{$status,'ERR'};
	    if ($tmp =~ /^$status/ && $tmp =~ /ERR/i) {
		if ($done_miss ne $status) {
		    $pourcentage = ($tmp1*100)/$tcp_udp{$status} if ($tcp_udp{$status} != 0);
		    $pourcentageint = int($pourcentage);
		    $pourcentage2 = ($tmp2*100)/$size_tcp_udp{$status} if ($size_tcp_udp{$status} != 0);
		    $pourcentageint2 = int($pourcentage2);
		    print FOUT "<TR><TD CLASS=\"left\">ERROR</TD>\n<TD CLASS=\"right\">$tmp1</TD>\n";
		    print FOUT "<TD CLASS=\"left\">\n";
		    print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\"> " if ($pourcentageint != 0);
		    printf FOUT "%.1f %",$pourcentage;
		    print FOUT "</TD>\n";
		    print FOUT "<TD CLASS=\"right\">";
		    printf FOUT "%.1f",$tmp2*1024/$unitsize;
		    print FOUT "</TD>\n";
		    print FOUT "<TD CLASS=\"left\">\n";
		    print FOUT "<IMG WIDTH=$pourcentageint2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\"> " if ($pourcentageint2 != 0);
		    printf FOUT "%.1f %",$pourcentage2;
		    print FOUT "</TD>\n";
		    if ($struct_logfile =~ /\%elapsed/) {
			print FOUT "<TD CLASS=\"right\">";
			printf FOUT "%.1f ",($tmp3/$tmp1);
			print FOUT "</TD>\n";
			print FOUT "<TD CLASS=\"right\">";
			printf FOUT "%.1f ",($tmp2/($tmp3/1000)) if ($tmp3 != 0);
			print FOUT "</TD>\n";
		    }
		    print FOUT "</TR>\n";

		    $done_miss = $status;
		}
		$pourcentage = ($status_code_squid{$tmp}*100)/$tcp_udp{$status} if ($tcp_udp{$status} != 0);
		$pourcentageint = int($pourcentage);
		$pourcentage2 = ($squid_size{$tmp}*100)/$size_tcp_udp{$status} if ($size_tcp_udp{$status} != 0);
		$pourcentageint2 = int($pourcentage2);
		print FOUT "<TR>\n<TD CLASS=\"left\"><I>&nbsp;&nbsp;&nbsp;-&nbsp;$tmp</I></TD>\n<TD CLASS=\"right\"><I>$status_code_squid{$tmp}</I></TD>\n";
		print FOUT "<TD CLASS=\"left\">\n";
		print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
		printf FOUT "%.1f %",$pourcentage;
		print FOUT "</TD>\n";
		print FOUT "<TD CLASS=\"right\">";
		printf FOUT "%.1f",$squid_size{$tmp}*1024/$unitsize;
		print FOUT "</TD>\n";
		print FOUT "<TD CLASS=\"left\">\n";
		print FOUT "<IMG WIDTH=$pourcentageint2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint2 != 0);
		printf FOUT "%.1f %",$pourcentage2;
		print FOUT "</TD>\n";
		if ($struct_logfile =~ /\%elapsed/) {
		    print FOUT "<TD CLASS=\"right\">";
		    printf FOUT "%.1f ",($squid_elapsed{$tmp}/$status_code_squid{$tmp}) if ($status_code_squid{$tmp} != 0);
		    print FOUT "</TD>\n";
		    print FOUT "<TD CLASS=\"right\">";
		    printf FOUT "%.1f ",($squid_size{$tmp}/($squid_elapsed{$tmp}/1000)) if ($squid_elapsed{$tmp} != 0);
		    print FOUT "</TD>\n";
		}
		print FOUT "</TR>";
	    }
	}

	foreach $tmp (sort (keys %status_code_squid)) {
	    if ($tmp !~ /HIT/i && $tmp !~ /MISS/i && $tmp !~ /ERR/i) {
		$pourcentage = ($status_code_squid{$tmp}*100)/$tcp_udp{$status} if ($tcp_udp{$status} != 0);
		$pourcentageint = int($pourcentage);
		$pourcentage2 = ($squid_size{$tmp}*100)/$size_tcp_udp{$status} if ($size_tcp_udp{$status} != 0);
		$pourcentageint2 = int($pourcentage2);
		if ($tmp =~ /^$status/) {
		    print FOUT "<TR>\n<TD CLASS=\"left\">$tmp</TD>\n<TD CLASS=\"right\">$status_code_squid{$tmp}</TD>\n";
		    print FOUT "<TD CLASS=\"left\">\n";
		    print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\"> " if ($pourcentageint != 0);
		    printf FOUT "%.1f %",$pourcentage;
		    print FOUT "</TD>\n";
		    print FOUT "<TD CLASS=\"right\">";
		    printf FOUT "%.1f",$squid_size{$tmp}*1024/$unitsize;
		    print FOUT "</TD>\n";
		    print FOUT "<TD CLASS=\"left\">\n";
		    print FOUT "<IMG WIDTH=$pourcentageint2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\"> " if ($pourcentageint2 != 0);
		    printf FOUT "%.1f %",$pourcentage2;
		    print FOUT "</TD>\n";
		    if ($struct_logfile =~ /\%elapsed/) {
			print FOUT "<TD CLASS=\"right\">";
			printf FOUT "%.1f ",($squid_elapsed{$tmp}/$status_code_squid{$tmp}) if ($status_code_squid{$tmp} != 0);
			print FOUT "</TD>\n";
			print FOUT "<TD CLASS=\"right\">";
			printf FOUT "%.1f",($squid_size{$tmp}/($squid_elapsed{$tmp}/1000)) if ($squid_elapsed{$tmp} != 0);
			print FOUT "0" if ($squid_elapsed{$tmp} == 0);
			print FOUT "</TD>\n";
		    }
		    print FOUT "</TR>\n";
		}
	    }
	}
    }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n";

  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Status_code'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'description'}&nbsp;</TH>\n";
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";

#  print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"squid_status\">";
#  print FOUT "<TR><TH>$L{'Status_code'}</TH>\n<TH>$L{'description'}</TH></TR>\n";
    foreach $status (sort (keys %status_code_squid)) {
	($status) = split(/:/,$status);
	print FOUT "<TR>\n<TD CLASS=\"left\">$status</TD>\n<TD CLASS=\"left\">$code_info_tcp_udp{$status}</TD>\n</TR>\n";
    }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE><P>\n";

  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'Outgoing_requests_by_status'}</DIV><P>";

  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Status_code'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  if ($struct_logfile =~ /\%elapsed/) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Average_elapsed_time'}&nbsp;($L{'milliseconds'})&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Kb'}/s&nbsp;</TH>\n";
  }
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";

#  print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"squid_outgoing_status\">";
#  print FOUT "<TR>\n<TH>$L{'Status_code'}</TH>\n<TH>$L{'Occurence'}</TH>\n<TH>$L{'Percentage'}</TH>\n<TH>$L{'Traffic'} ($L{'Kb'})</TH>\n<TH>$L{'Percentage'}</TH>\n";
#  if ($struct_logfile =~ /\%elapsed/) {
#      print FOUT "<TH>$L{'Average_elapsed_time'} ($L{'milliseconds'})</TH>\n<TH>$L{'Kb'}/s</TH>\n\n";
#  }
#  print FOUT "</TR>\n";

  foreach $status (sort (keys %status_code_peer)) {
      $pourcentage = ($status_code_peer{$status}*100)/$code_peer_tot if ($code_peer_tot != 0);
      $pourcentageint = int($pourcentage);
      $pourcentage2 = ($peer_size{$status}*100)/$peer_size_tot if ($peer_size_tot != 0);
      $pourcentageint2 = int($pourcentage2);
      print FOUT "<TR>";
      print FOUT "<TD CLASS=\"left\">$status</TD>\n<TD CLASS=\"right\">$status_code_peer{$status}</TD>\n";
      print FOUT "<TD CLASS=\"left\">\n";
      print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
      printf FOUT "%.1f %",$pourcentage;
      print FOUT "</TD>\n<TD CLASS=\"right\">\n";
      printf FOUT "%.1f",$peer_size{$status}*1024/$unitsize;
      print FOUT "</TD>\n<TD CLASS=\"left\">\n";
      print FOUT "<IMG WIDTH=$pourcentageint2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint2 != 0);
      printf FOUT "%.1f %",$pourcentage2;
      print FOUT "</TD>\n";
      if ($struct_logfile =~ /\%elapsed/) {
	  print FOUT "<TD CLASS=\"right\">\n";
	  printf FOUT "%.1f",$peer_elapsed{$status}/$code_peer_tot if ($code_peer_tot != 0);
	  print FOUT "</TD>\n<TD CLASS=\"right\">";
	  printf FOUT "%.1f",$peer_size{$status}/($peer_elapsed{$status}/1000) if ($peer_elapsed{$status} != 0);
	  print FOUT "</TD>\n";
      }
      print FOUT "</TR>\n";
  }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE><P>\n";


#  $status = $occur_host_peer{(&reverse_sort_by_value(*occur_host_peer))[0]};

  if (keys(%occur_host_peer) != 0) {

  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'Outgoing_requests_by_destination'}</DIV><P>";

  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  if ($struct_logfile =~ /\%elapsed/) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Average_elapsed_time'}&nbsp;($L{'milliseconds'})&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Kb'}/s&nbsp;</TH>\n";
  }
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";

#  print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"squid_outgoing_destination\">";
#  print FOUT "<TR>\n<TH>$L{'Hosts'}</TH>\n<TH>$L{'Occurence'}</TH>\n<TH>$L{'Percentage'}</TH>\n<TH>$L{'Traffic'} ($L{'Kb'})</TH\n><TH>$L{'Percentage'}</TH>\n";
#  if ($struct_logfile =~ /\%elapsed/) {
#      print FOUT "<TH>$L{'Average_elapsed_time'} ($L{'milliseconds'})</TH>\n<TH>$L{'Kb'}/s</TH>\n";
#  }
#  print FOUT "</TR>\n";

  $tmp_peer = $status_code_peer{'SIBLING_HIT'}+$status_code_peer{'DEFAULT_PARENT'}+$status_code_peer{'TIMEOUT_DEFAULT_PARENT'};
  $tmp_peer_size = $peer_size{'SIBLING_HIT'}+$peer_size{'DEFAULT_PARENT'}+$peer_size{'TIMEOUT_DEFAULT_PARENT'};


  foreach $status (sort (keys %occur_host_peer)) {
      $pourcentage = ($occur_host_peer{$status}*100)/$tmp_peer if ($tmp_peer != 0);
      $pourcentageint = int($pourcentage);
      $pourcentage2 = (($trafic_host_peer{$status}/1024)*100)/$tmp_peer_size if ($tmp_peer_size != 0);
      $pourcentageint2 = int($pourcentage2);
      print FOUT "<TR>\n";
      print FOUT "<TD CLASS=\"left\">$status</TD>\n<TD CLASS=\"right\">$occur_host_peer{$status}</TD>\n";
      print FOUT "<TD CLASS=\"left\">\n";
      print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\"> " if ($pourcentageint != 0);
      printf FOUT "%.1f %",$pourcentage;
      print FOUT "</TD>\n<TD CLASS=\"right\">\n";
#      $tmp = $trafic_host_peer{$status}/1024;
      $tmp = $trafic_host_peer{$status}/$unitsize;
      printf FOUT "%.1f",$tmp;
      print FOUT "</TD>\n<TD CLASS=\"left\">\n";
      print FOUT "<IMG WIDTH=$pourcentageint2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\"> " if ($pourcentageint2 != 0);
      printf FOUT "%.1f %",$pourcentage2;
      print FOUT "</TD>\n";
      if ($struct_logfile =~ /\%elapsed/) {
	  print FOUT "<TD CLASS=\"right\">";
	  printf FOUT "%.1f",($elapsed_host_peer{$status}/$occur_host_peer{$status}) if ($occur_host_peer{$status} != 0);
	  print FOUT "</TD>\n";
	  print FOUT "<TD CLASS=\"right\">";
	  printf FOUT "%.1f",($tmp/($elapsed_host_peer{$status}/1000)) if ($elapsed_host_peer{$status} != 0);
	  print FOUT "</TD>\n";
      }
      print FOUT "</TR>\n";
  }

  print FOUT "</tbody>\n";
  print FOUT "</TABLE><P>\n";
  }

  print FOUT "</BODY></HTML>\n";

}

#
##############################################################
### Status code
##############################################################
#

sub MakePieGraphJqplot {
    local(*FOUT,*L,$I,$ref,$ref_color,$tot,$type,$conv,$unit,$chart_id,$mode,$info,$labelx,$labely,$link) = @_;
    local($i,$j,$k,$val,$val_txt,$nb_idx,$format,$nb_element,$min,$max,$valmax,$string,$count);

##################    $unit,$mode,$labelx,$labely et $link inutile

    %tab = %$ref;
    @tab_color = @$ref_color;
    $string = '';
    $string_idx = '';
    $string_val = '';
#    $i = 1;
    $line_pie = '';
    $j = 0;
    $count = 0;

#      $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$lang,\%downloadsizeext,\@serie_color,$tmp,2,$unit_div,$unit,$chart_id,2,"info2","","",$filetype);

    $datatype = 0;
    $datatype = 1 if ($conv != 1);
    $val = 0;

    $tmplink = "..$dirsepurl..$dirsepurl"; # if ($update_homepage == 0);

    if ($update_homepage == 1) {
	$tmplink = "";
	$count_max_pie = 5;
    }
    if ($update_session_homepage == 1) {
	$count_max_pie = 5;
    }

    $tab_color[$count_max_pie] = '#666666';
    $tmp4flag = '';

    foreach $pays (&reverse_sort_by_value(*tab)) {
	next if ($zonepays{$pays} != $zone && $type == 4);
#	print "$count - $pays - $tab{$pays}\n";
	if ($count < $count_max_pie && $tab{$pays} != 0 && $pays ne "Others") { 

	    $count++;

	    $tmp4 = "$pays" if ($type == 0);
	    if ($type == 1) {
		if (-f "$pathinit$dirress$dirsep$dirflags$dirsep$pays$gifext") {
		    $tmp4 = "$L{$newflag{$pays}}";
		} else {
		    $tmp4 = "$L{'Unknown'} <I>($pays)</I>";
		}
	    }

	    $tmp4 = "$extfile{$pays}" if ($type == 2 && $extfile{$pays} ne '');
	    $tmp4 = "$pays" if ($type == 2 && $extfile{$pays} eq '');

	    $tmp = '';
	    if ($type == 3 || $type == 4) {
		($pays2,$tmp) = split(/:/,$pays) if ($pays =~ /\:/);
		$pays2 = $pays if ($pays !~ /\:/);
		$tmp4 = "$tmp" if ($tmp ne '');
		$tmp4 = "$L{$newflag{$pays2}}" if ($tmp eq '' && $L{$newflag{$pays2}} ne '');
		if ($newflag{$pays2} eq '') {
		    $tmp4 = "$L{'Unknown'} <I>($pays2)</I>";
		    $pays2 = "Unknown";
		} else {
		    $tmp4 = "$newflag{$pays2}" if ($tmp eq '' && $L{$newflag{$pays2}} eq '');
		}

#		$tmp4map = $tmp4;
		$tmp4flag = "<IMG SRC=\"$tmplink$linkpathinit$dirress$dirsepurl$dirflags$dirsepurl$pays2$gifext\" WIDTH=14 HEIGHT=14 BORDER=0 TITLE=\"$L{$newflag{$pays2}}\" ALT=\"$pays2$gifext\">";
		$tmp4 .= "&nbsp;-&nbsp;".$tmp4flag;
	    }
	    
	    $tmp4 = "$pays - $FailStatusMsgs{$pays}" if ($type == 5);
	    $tmp4 = "$downloadunit[$pays]" if ($type == 6);
	    $tmp4 = "$pays" if ($type == 7);
	    $tmp4 = "$translate_os{$pays}" if ($type == 8 && $translate_os{$pays} ne '');
	    $tmp4 = "$pays" if ($type == 8 && $translate_os{$pays} eq '');


	    $string .= "['$tmp4'," if ($tmp4flag eq '');
	    $string .= "['$tmp4flag'," if ($tmp4flag ne '');

#	    $string .= "['$tmp4',";
	    $string .= "$tab{$pays}],";

	    #

	    $pourcentvalue = $tab{$pays}*100/$tot if ($tot != 0);
	    $couleur = $gcolor[$j];

	    $line_pie .= "<TR>\n";
	    $line_pie .= "<TD CLASS=\"left\" " if (($j/2) == int($j/2));
	    $line_pie .= "<TD CLASS=\"left_alter\" " if (($j/2) != int($j/2));
	    $line_pie .= "VALIGN=\"BOTTOM\"><IMG WIDTH=\"$square\" HEIGHT=\"$square\" SRC=\"$tmplink$linkpathinit$dirress$dirsepurl$couleur\" ALT=\"$couleur\">&nbsp;";
	    $line_pie .= "$tmp4";
	    $line_pie .= "&nbsp;</TD>";
	    
	    $line_pie .= "<TD CLASS=\"right\">" if (($j/2) == int($j/2));
	    $line_pie .= "<TD CLASS=\"right_alter\">" if (($j/2) != int($j/2));

	    $tmp6 = $tab{$pays};

	    if ($conv != 1) {
		$unit = "bytes";
		if ($tab{$pays} > 1024) {
		    $unit = "Kb";
		    $tmp6 = int(10*($tab{$pays}/1024))/10;
		}
		if ($tab{$pays} > (1024*1024)) {
		    $unit = "Mb";
		    $tmp6 = int(10*($tab{$pays}/(1024*1024)))/10;
		}
		if ($tab{$pays} > (1024*1024*1024)) {
		    $unit = "Gb";
		    $tmp6 = int(10*($tab{$pays}/(1024*1024*1024)))/10;
		}
		if ($tab{$pays} > (1024*1024*1024*1024)) {
		    $unit = "Tb";
		    $tmp6 = int(10*($tab{$pays}/(1024*1024*1024*1024)))/10;
		}
		$tmp6 = "$tmp6&nbsp;$unit";
	    }

#	    print "KK $datatype - $tmp6\n";

	    $line_pie .= "$tmp6";
	    $line_pie .= "</TD>\n";

	    $string_idx .= "'$tmp4',"; # if ($tmp4flag eq '');
#	    $string_idx .= "'$tmp4flag'," if ($tmp4flag ne '');
	    $string_val .= "'$tmp6',";

	    $pourcentvalue = int($pourcentvalue*10)/10;
		
	    $line_pie .= "<TD CLASS=\"right\">" if (($j/2) == int($j/2));
	    $line_pie .= "<TD CLASS=\"right_alter\">" if (($j/2) != int($j/2));
	    $line_pie .= "$pourcentvalue" if (int($pourcentvalue) != $pourcentvalue);
	    $line_pie .= $pourcentvalue.".0" if (int($pourcentvalue) == $pourcentvalue);
	    $line_pie .= "&nbsp;%</TD></TR>\n";
	    $j++;
	} else {
	    $val += $tab{$pays};
#	    print "AA $val - $pays - $tab{$pays}\n";
	}
    }

    # Others
    if ($val != 0) {
	$line_pie .= "<TR>\n";
	$line_pie .= "<TD CLASS=\"left\" " if (($j/2) == int($j/2));
	$line_pie .= "<TD CLASS=\"left_alter\" " if (($j/2) != int($j/2));
	$line_pie .= "VALIGN=\"BOTTOM\"><IMG WIDTH=\"$square\" HEIGHT=\"$square\" SRC=\"$tmplink$linkpathinit$dirress$dirsepurl$others\" ALT=\"$others\">&nbsp;";
	$line_pie .= "$L{'Others'}";
	$line_pie .= "&nbsp;</TD>";
	
	$line_pie .= "<TD CLASS=\"right\">" if (($j/2) == int($j/2));
	$line_pie .= "<TD CLASS=\"right_alter\">" if (($j/2) != int($j/2));

	$tmp6 = $val;

	if ($conv != 1) {
	    $unit = "bytes";
	    if ($val > 1024) {
		$unit = "Kb";
		$tmp6 = int(10*($val/1024))/10;
	    }
	    if ($val > (1024*1024)) {
		$unit = "Mb";
		$tmp6 = int(10*($val/(1024*1024)))/10;
	    }
	    if ($val > (1024*1024*1024)) {
		$unit = "Gb";
		$tmp6 = int(10*($val/(1024*1024*1024)))/10;
	    }
	    if ($val > (1024*1024*1024*1024)) {
		$unit = "Tb";
		$tmp6 = int(10*($val/(1024*1024*1024*1024)))/10;
	    }
	    $tmp6 = "$tmp6&nbsp;$unit";
	}

#	    print "KK $datatype - $tmp6\n";

	$line_pie .= "$tmp6";
	$line_pie .= "</TD>\n";

	$pourcentvalue = $val*100/$tot;
	$pourcentvalue = int($pourcentvalue*10)/10;

	$line_pie .= "<TD CLASS=\"right\">" if (($j/2) == int($j/2));
	$line_pie .= "<TD CLASS=\"right_alter\">" if (($j/2) != int($j/2));
	$line_pie .= "$pourcentvalue" if (int($pourcentvalue) != $pourcentvalue);
	$line_pie .= $pourcentvalue.".0" if (int($pourcentvalue) == $pourcentvalue);
	$line_pie .= "&nbsp;%</TD></TR>\n";
	
	$string .= "['$L{'Others'}',";
	$string .= "$val],";

	$string_idx .= "'$L{'Others'}',";
	$string_val .= "'$tmp6',";
    }

    chop($string);
    chop($string_idx);
    chop($string_val);


    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\">\n";

    print FOUT "filepie_idx$chart_id = [$string_idx]\n";
    print FOUT "filepie$chart_id = [$string_val]\n";
    print FOUT "function editit_pie$chart_id(str, si, pi, data) {\n";
#    print FOUT "txt = data[0]+' : '+data[1];\n";

    print FOUT "var txt = '<table width=\"120\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr><td style=\"-moz-opacity:.85;opacity:.85;\"><table width=\"120\" cellspacing=\"0\" cellpadding=\"0\"><tr>';\n";
    print FOUT "txt += '<td width=\"118\" style=\"background-color:#ffeecc;padding:5px;\">';\n";
    print FOUT "if (typeof(filepie";
    print FOUT "$chart_id) != 'undefined') {\n";
    print FOUT "txt += '<span style=\"font-size:10px;color:#990000;font-weight:bold;\">'+filepie_idx";
    print FOUT "$chart_id";
    print FOUT "[pi]+'<\\\/span> :<span style=\"font-size:10px;text-align:left;color:#000000;\"> '+filepie";
    print FOUT "$chart_id\n";
    print FOUT "[pi]+'<\\\/span>';\n";
    print FOUT "}\n";
    print FOUT "txt += '&nbsp;<\\\/td><\\\/tr><\\\/table><\\\/td><\\\/tr><\\\/table>';\n";
    print FOUT "return txt;\n";
    print FOUT "}\n";

    print FOUT "\$(document).ready(function(){\n";

    print FOUT "var piegraph$chart_id = ";
    print FOUT "[";
    print FOUT "$string";
    print FOUT "];\n";

    print FOUT "\n\n// /////////////////// Plot $chart_id\n";
    print FOUT "plot$chart_id = \$.jqplot (";
    print FOUT "'chart$chart_id'";
    print FOUT ", [piegraph$chart_id],\n{\n";

    print FOUT "seriesColors: [";
    for ($k=1;$k<=$#tab_color;$k++) {
	    $k2 = $k-1;
	    print FOUT "'$tab_color[$k2]'"; 
	    print FOUT "," if ($k != $#tab_color);
   }
    print FOUT "],\n";

    print FOUT "seriesDefaults: {\n";
    print FOUT "renderer: \$.jqplot.PieRenderer,\n";

    print FOUT "rendererOptions:{\n";
#    print FOUT "fontSize: '0.5em',\n";
    if ($update_homepage == 0 && $update_session_homepage == 0) {
	print FOUT "showDataLabels: true,\n";
    }
    print FOUT "dataLabels: 'label'\n"; # value or percent
    print FOUT "}\n";
    print FOUT "},\n";

    print FOUT "series: [{\n";
    print FOUT "markerOptions: { style: 'circle', size: 0 }\n";
    print FOUT "}],\n";
    if ($update_homepage == 0 || $update_session_homepage == 0) {
	print FOUT "highlighter: {\n";
	print FOUT "showTooltip: true,\n";
	print FOUT "useAxesFormatters: false,\n";
	print FOUT "show: true,\n";
	print FOUT "formatString: '%s',\n";
	print FOUT "tooltipContentEditor: editit_pie$chart_id\n";
#    print FOUT "sizeAdjust: 0\n";
	print FOUT "},\n";
    }
    print FOUT "legend: {\n";
    print FOUT "show: false\n";
#    print FOUT "rendererOptions: {numberCols: 1},\n";
#    print FOUT "placement: 'outsideGrid',\n";
#    print FOUT "location: 'ne'\n";
    print FOUT "}\n";

    print FOUT "}\n";
    print FOUT ");\n"; 



    if ($xmax != $xmax_home_jqplot) {
	print FOUT "function genImg(i){\n";
	print FOUT "  var tmp = '#chart'+i;\n";
	print FOUT "  var toto = \$(''+tmp+'');\n";

	print FOUT "  var tmp2 = '#plotted_image_div'+i;\n";
	print FOUT "  var toto2 = \$(''+tmp2+'');\n";

#	print FOUT "  var tmp3 = '#show_plotted_image_btn0';\n";
#	print FOUT "  var toto3 = \$(''+tmp3+'');\n";

	print FOUT "  var imgData = toto.jqplotToImageStr({});\n";
#    print FOUT "  var imgData = \$('#chart0').jqplotToImageStr({});\n";
	print FOUT "  var imgElem = \$('<img/>').attr({'src':imgData,title:\"Right click on plot to save\"});\n";
	print FOUT "  toto2.empty(); // remove the old graph\n";
	print FOUT "  toto2.append(imgElem);   \n";   
#     print FOUT "       header.html('Right Click to Save Image As...');\n";
#	print FOUT "toto3.html('Right click on plot to save image');\n";
	print FOUT "};\n\n";

	print FOUT "\$('#show_plotted_image_btn$chart_id').click(\n";
	print FOUT "function(){\n";
	print FOUT " var idx = $chart_id;\n";
	print FOUT " genImg(idx);\n";
#	print FOUT "  var tmp2 = '#plotted_image_div'+idx;\n";
#	print FOUT "  var toto2 = \$(''+tmp2+'');\n";
#	print FOUT "  toto2.toggle();\n";
	print FOUT " \$('#plotted_image_div$chart_id').toggle();\n";
	print FOUT "});\n\n";
    }





###http://stackoverflow.com/questions/8209474/how-to-display-tooltips-on-jqplot-pie-chart
#    if ($update_homepage == 0 || $update_session_homepage == 0) {
##    print FOUT "\$('#chart$chart_id').bind('jqplotHighlighterHighlight', \n";
#    print FOUT "\$('#chart$chart_id').bind('jqplotDataHighlight', \n";
#    print FOUT "function (ev, seriesIndex, pointIndex, data) {\n";
#    print FOUT "    var txt = editit_pie$chart_id(ev, seriesIndex, pointIndex, data);\n";
#    print FOUT "    \$('#$info').html(txt);\n";
#    print FOUT "}\n";
#    print FOUT ");\n";
     
##    print FOUT "\$('#chart$chart_id').bind('jqplotHighlighterUnhighlight', \n";
#    print FOUT "\$('#chart$chart_id').bind('jqplotDataUnhighlight', \n";
#    print FOUT "     function (ev) {\n";
#    print FOUT "        \$('#$info').html('&nbsp;');\n";
#    print FOUT "    }\n";
#    print FOUT ");\n";
#    }

    print FOUT "});\n";    
    print FOUT "</script>\n";

    print FOUT "<span id=\"$info\">&nbsp;</span>\n";

    return $line_pie;
}

sub StatusCode {
  local(*FOUT,*L,$I) = @_;
  local($tmp,$i,$tmp2,$tmp_help,$page);

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Stats'} - $L{'Status_code'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  &popup_help(*FOUT,2);
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";
  &add_jqplot_js(*FOUT,2);

  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
 &help_div(*FOUT);
#  $allscriptcgi = 0;
#  foreach $val (keys (%methodcgi)) {
#      $allscriptcgi += $methodcgi{$val};
#  }

#  $allscript = 0;
#  foreach $val (keys (%method)) {
#      $allscript += $method{$val};
#  }

  print FOUT "<H2> $L{'Status_code'}</H2><P>\n";

  print FOUT "<TABLE>";
  print FOUT "<TR><TD VALIGN=TOP>";

  print FOUT "<TABLE>";
  print FOUT "<TR>\n";
  $tmp_help = "status_code.html";
  if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help") {
      print FOUT "<TH>";
      print FOUT "<A HREF=\"javascript:HelpDisplay('$tmp_help')\"><IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$icon_help\" BORDER=0 ALT=\"Help\"></A>";
      print FOUT "</TH>\n";
  }
  print FOUT "<TH COLSPAN=2>$L{'Status_code'}</TH>\n<TH>$L{'Occurence'}</TH>\n</TR>\n";
  $tmp3 = 0;
  foreach $status (sort (keys %FailStatusMsgs)) {
      if ($status > 0) {
	  $tmp = int($status/100);
	  if ($status_code_level[$tmp] != 0 && $tmp ne $tmp2) {
	      print FOUT "<TR>\n<TD COLSPAN=";
	      print FOUT "3 " if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help");
	      print FOUT "2 " if (!(-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help"));
	      print FOUT "CLASS=\"head_left\">$status_level[$tmp]</TD>\n";
	      print FOUT "<TD CLASS=\"head_right\">$status_code_level[$tmp]</TD>\n</TR>\n";
	      $tmp2 = $tmp;
	  }
	  if ($status_code{$status} != 0) {
	      print FOUT "<TR>\n";
	      print FOUT "<TD CLASS=\"right\">" if (($tmp3/2) == int($tmp3/2));
	      print FOUT "<TD CLASS=\"right_alter\">" if (($tmp3/2) != int($tmp3/2));
	      print FOUT "<A HREF=\"..$dirsepurl$dirlist$dirsep$incstatus$status$htmlext\">" if (-f "$path$I$dirsep$dirlist$dirsep$incstatus$status$htmlext");
	      print FOUT "$status";
	      print FOUT "</A>" if (-f "$path$I$dirsep$dirlist$dirsep$incstatus$status$htmlext");
	      print FOUT "</TD>\n";
	      print FOUT "<TD CLASS=\"left\"" if (($tmp3/2) == int($tmp3/2));
	      print FOUT "<TD CLASS=\"left_alter\""  if (($tmp3/2) != int($tmp3/2));
	      print FOUT " COLSPAN=2" if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help");
	      print FOUT ">";
	      print FOUT "<A HREF=\"..$dirsepurl$dirlist$dirsep$incstatus$status$htmlext\">" if (-f "$path$I$dirsep$dirlist$dirsep$incstatus$status$htmlext");
	      print FOUT "$FailStatusMsgs{$status}";
	      print FOUT "</A>" if (-f "$path$I$dirsep$dirlist$dirsep$incstatus$status$htmlext");
	      print FOUT "</TD>\n";
	      print FOUT "<TD CLASS=\"right\">" if (($tmp3/2) == int($tmp3/2));
	      print FOUT "<TD CLASS=\"right_alter\">" if (($tmp3/2) != int($tmp3/2));
	      print FOUT "$status_code{$status}</TD>\n</TR>\n";
	      $tmp3++;
	  }
      }
  }
  print FOUT "</TABLE>\n";

###

 if ($mail_format == 0 && (keys(%method) != 0)) {

  print FOUT "<P><TABLE>";
  print FOUT "<TR>";
  $tmp_help = "method.html";
  if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help") {
      print FOUT "<TH>";
      print FOUT "<A HREF=\"javascript:HelpDisplay('$tmp_help')\"><IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$icon_help\" BORDER=0 ALT=\"Help\"></A>";
      print FOUT "</TH>";
  }
  print FOUT "<TH>&nbsp;$L{'Method'}&nbsp;</TH><TH>&nbsp;$L{'Occurence'}&nbsp;</TH><TH>&nbsp;$L{'Percentage'}&nbsp;</TH></TR>\n";

  $tmp2 = 0;
  foreach $val (&reverse_sort_by_value(*method)) {
      $pourcentage = (($method{$val}*1000)/$allscript)/10;
      $pourcentageint = int($pourcentage);
      print FOUT "<TR>\n";
      print FOUT "<TD CLASS=\"left\"" if (($tmp2/2) == int($tmp2/2));
      print FOUT "<TD CLASS=\"left_alter\"" if (($tmp2/2) != int($tmp2/2));
      print FOUT " COLSPAN=2" if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help");
      print FOUT ">";
      print FOUT "<A HREF=\"$val$htmlext\">" if (-f "$path$I$dirsep$dirlist$dirsep$val$htmlext");
      print FOUT "$val";
      print FOUT "</A>" if (-f "$path$I$dirsep$dirlist$dirsep$val$htmlext");
      print FOUT "&nbsp;</TD>";
      print FOUT "<TD CLASS=\"right\">" if (($tmp2/2) == int($tmp2/2));
      print FOUT "<TD CLASS=\"right_alter\">" if (($tmp2/2) != int($tmp2/2));
      print FOUT "&nbsp;$method{$val}&nbsp;";
      print FOUT "</TD>\n";
      print FOUT "<TD CLASS=\"left\">" if (($tmp2/2) == int($tmp2/2));
      print FOUT "<TD CLASS=\"left_alter\">" if (($tmp2/2) != int($tmp2/2));
      print FOUT "&nbsp;\n";
      print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
      printf FOUT "%.1f ",$pourcentage;
      print FOUT " %</TD></TR>\n";
      $tmp2++;
  }
  print FOUT "</TABLE>\n";

  print FOUT "<P>\n";

# CGI Method

  if (keys(%methodcgi) != 0) {
      print FOUT "<TABLE>";
      print FOUT "<TR>";
      $tmp_help = "method_cgi.html";
      if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help") {
	  print FOUT "<TH>";
	  print FOUT "<A HREF=\"javascript:HelpDisplay('$tmp_help')\"><IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$icon_help\" BORDER=0 ALT=\"Help\"></A>";
	  print FOUT "</TH>";
      }
      print FOUT "<TH>&nbsp;CGI $L{'Method'}&nbsp;</TH><TH>&nbsp;$L{'Occurence'}&nbsp;</TH><TH>&nbsp;$L{'Percentage'}&nbsp;</TH></TR>\n";
      
      $tmp2 = 0;
      foreach $val (&reverse_sort_by_value(*methodcgi)) {
	  $pourcentage = (($methodcgi{$val}*1000)/$allscriptcgi)/10 if ($allscriptcgi != 0);
	  $pourcentageint = int($pourcentage);
	  print FOUT "<TR>\n";
	  print FOUT "<TD CLASS=\"left\"" if (($tmp2/2) == int($tmp2/2));
	  print FOUT "<TD CLASS=\"left_alter\"" if (($tmp2/2) != int($tmp2/2));
	  print FOUT " COLSPAN=2" if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help");
	  print FOUT ">$val&nbsp;</TD>";
	  print FOUT "<TD CLASS=\"right\">" if (($tmp2/2) == int($tmp2/2));
	  print FOUT "<TD CLASS=\"right_alter\">" if (($tmp2/2) != int($tmp2/2));
	  print FOUT "&nbsp;$methodcgi{$val}&nbsp;</TD>\n";
	  print FOUT "<TD CLASS=\"left\">" if (($tmp2/2) == int($tmp2/2));
	  print FOUT "<TD CLASS=\"left_alter\">" if (($tmp2/2) != int($tmp2/2));
	  print FOUT "&nbsp;\n";
	  print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
	  printf FOUT "%.1f ",$pourcentage;
	  print FOUT " %</TD></TR>\n";
	  $tmp2++;
      }
      print FOUT "</TABLE>\n";
      
      print FOUT "<P>";
  }
  }

  print FOUT "</TD><TD VALIGN=TOP>";


  ($line_cloud,$line_cloud_sort) = &MakeCloud(\%status_code,'',2);

  if ($fly_set == 0) {
      $chart_id = 0;
      $info = "info".$chart_id;
      $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%status_code,\@serie_color,$loglines,5,1,$unit,$chart_id,3,$info,"","",$dirstatus);
  }

  if ($fly_set == 1) {
      $status_pie = "status_pie".$gifext;  
      ($line_pie,$map_status_pie) = &MakePieChart($status_pie,$loglines,\%status_code,5,0,'',$rayon);
 }

  print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
  print FOUT "<TR><TD ALIGN=CENTER VALIGN=TOP>";
  print FOUT "<TABLE BORDER=0>";
  print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Status_code'}</TH></TR>";
  print FOUT "$line_pie";
  print FOUT "</TABLE>\n";
  print FOUT "</TD>\n";
  print FOUT "<TD ALIGN=CENTER>";

  if ($fly_set == 0) {
      print FOUT "<div id=\"";
      print FOUT "chart".$chart_id;
      print FOUT "\" ";
      print FOUT "style=\"";
      print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
      print FOUT "</div>\n";
  }

  if ($fly_set == 1) {
      print FOUT "<IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$status_pie\" USEMAP=\"#map_status_graph\" BORDER=0 ALT=\"graph\">\n";
      print FOUT "<P><I>$L{'Occurence'}</I>";
  }
  print FOUT "</TD></TR></TABLE>\n";

  print FOUT "<P>";
  if ($fly_set == 1) {
      print FOUT "<MAP NAME=\"map_status_graph\">\n";
      $tmp = $map_status_pie;
      $tmp =~ s/<!-- langhome -->/$I/g;
      print FOUT "$tmp";
      print FOUT "</MAP>\n";
  }
  if ($fly_set == 0) {
      if ($xmax_jqplot != $xmax_home_jqplot) {
	  print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
      }
      print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
  }
#  print FOUT "</DIV>";

   print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'Sort'} : <A HREF=\"javascript:ToggleBeta('tog_alpha','tog_value');\">$L{'Alphabetically'}</A> - <A HREF=\"javascript:ToggleBeta('tog_value','tog_alpha');\">$L{'By_size'}</A></DIV><P>";

  print FOUT "<DIV ID=\"tog_alpha\" STYLE=\"display:inline\">";
  print FOUT "$line_cloud\n";
  print FOUT "</DIV>\n";
  print FOUT "<P>";

  print FOUT "<DIV ID=\"tog_value\" STYLE=\"display:none\">";
  print FOUT "$line_cloud_sort\n";
  print FOUT "</DIV>\n";

  print FOUT "</TD></TR></TABLE>";
  print FOUT "<P>\n";


  print FOUT "</BODY></HTML>\n";
}


#
##############################################################
### Status code method
##############################################################
#

sub StatusCodeMethod {
  local(*FOUT,*L,$I,$val) = @_;
  local($tmp,$i,$tmp2,$tmp_help,$page,$max,$unit,$unitsize,$tmpstr);

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Stats'} - $L{'Status_code'} - $val</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  &popup_help(*FOUT,2);
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
 &help_div(*FOUT);

  print FOUT "<H2> $L{'Status_code'} : $val</H2><P>\n";

  $tmp10 = keys(%$val);
  $tmp10 = $max_item_page if ($tmp10 > $max_item_page);

  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} $tmp10 $L{'hosts'}";
  print FOUT " ($L{'among'} ".keys(%$val).") " if ($tmp10 == $max_item_page);
  print FOUT "</I></DIV><P>\n";

  $i=0;
  $count = 0;
  $tmpstr = $val."_size";

  $tmp3 = 0;
  $tmp = 0;
  foreach $val2 (keys(%$val)) {
#  foreach $val2 (&reverse_sort_by_value(*$val)) {
      $tmp3 += $$tmpstr{$val2};
      $tmp = $$tmpstr{$val2} if ($$tmpstr{$val2} > $tmp);
  }

  $unit = "$L{'bytes'}";
  $unitsize = 1;
  if ($tmp > 1024) {
      $unit = "$L{'Kb'}";
      $unitsize = 1024;
  }
  if ($tmp > (1024*1024)) {
      $unit = "$L{'Mb'}";
      $unitsize = 1024*1024;
  }
  if ($tmp > (1024*1024*1024)) {
      $unit = "$L{'Gb'}";
      $unitsize = 1024*1024*1024;
  }
  if ($tmp > (1024*1024*1024*1024)) {
      $unit = "$L{'Tb'}";
      $unitsize = 1024*1024*1024*1024;
  }

  # decrease one magnitude for a nicer display
  if (int($tmp/$unitsize) < 10) {
      $unitsize /= 1024;
      $unit = "$L{'bytes'}" if ($unit eq "$L{'Kb'}");
      $unit = "$L{'Kb'}" if ($unit eq "$L{'Mb'}");
      $unit = "$L{'Mb'}" if ($unit eq "$L{'Gb'}");
      $unit = "$L{'Gb'}" if ($unit eq "$L{'Tb'}");
  }


  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe ";
  print FOUT "table-autopage:$table_big_lines_aff " if ($tmp10 > $table_big_lines_aff);
  print FOUT "table-stripeclass:alternate\" id=\"page\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  if ($notrafic == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  }
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";


   if ($tmp10 > $table_big_lines_aff) {

	$tmp = int($tmp10/$table_big_lines_aff);
	if ($tmp != ($tmp10/$table_big_lines_aff)) {
	    $tmp++;
	}
    
	print FOUT "<tfoot>\n";
	print FOUT "<tr>\n";
	print FOUT "<TH>$L{'Host'}</TH>\n";
	print FOUT "<TH>$L{'Occurence'}</TH>\n";
	print FOUT "<TH>$L{'Percentage'}</TH>\n";
	if ($notrafic == 0) {
	    print FOUT "<TH>$L{'Trafic'}</TH>\n";
	    print FOUT "<TH>$L{'Percentage'}</TH>\n";
	}
	print FOUT "</tr>\n";
	print FOUT "<tr>\n";

	if ($tmp > 1) {
	    print FOUT "<td colspan=3>\n" if ($notrafic == 1);
	    print FOUT "<td colspan=5>\n" if ($notrafic == 0);
	    print FOUT "<a href=\"#\" onclick=\"pageexample('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	    
	    for ($i=1;$i<=$tmp;$i++) {
		$iminus = $i-1;
		print FOUT "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexample($iminus); return false;\">$i</a>\n";
	    }
	    print FOUT "<a href=\"#\" onclick=\"pageexample('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	    print FOUT "<a href=\"#\" onclick=\"pageexample('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	    print FOUT "</td>\n";
	    print FOUT "</tr>\n";
	}
	print FOUT "</tfoot>\n";
    }

  print FOUT "<tbody>\n";


  foreach $val2 (&reverse_sort_by_value(*$val)) {

      $count++;
      if ($count < $max_item_page) {

      $pourcentage = (($$val{$val2}*1000)/$method{$val})/10 if ($method{$val} != 0);
      $pourcentageint = int($pourcentage);

      print FOUT "<TR>";
      print FOUT "<TD CLASS=\"left\">$val2</TD>\n";
      print FOUT "<TD CLASS=\"right\">$$val{$val2}</TD>\n";
      print FOUT "<TD CLASS=\"left\">";
      print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
      printf FOUT "%.1f ",$pourcentage;
      print FOUT " %</TD>\n";

      if ($notrafic == 0) {
	  $pourcentage = (($$tmpstr{$val2}*1000)/$tmp3)/10 if ($tmp3 != 0);
	  $pourcentageint = int($pourcentage);
	  $tmp = int($$tmpstr{$val2}*10/$unitsize)/10;
	  print FOUT "<TD CLASS=\"right\">$tmp</TD>\n";
	  print FOUT "<TD CLASS=\"left\">";
	  print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
	  printf FOUT "%.1f ",$pourcentage;
	  print FOUT "%</TD>\n";
      }
      print FOUT "</TR>\n";
      $i++;
  }
  }

  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n";

  print FOUT "</BODY></HTML>\n";
}


#
##############################################################
### Scripts
##############################################################
#

sub PagesScripts {
  local(*FOUT,*L,$I) = @_;
  local($tmp,$i,$tmp2,$tmp_help,$page);

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Stats'} - $L{'Scripts'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";
  &add_jqplot_js(*FOUT,2);

  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
  print FOUT "<H2> $L{'ListOf'} $L{'scripts'} $L{'used2'}</H2><P>\n";

  &help_div(*FOUT);

  if ($scriptunique != 0) {

      print FOUT "<TABLE><TR>\n";
      print FOUT "<TD>";
	  
      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} $topten $L{'scripts'} ";
      print FOUT "(<A HREF=\"$listscripts\">$L{'Full_list'}</A>)" if ($show_all == 1);
      print FOUT "</I></DIV><P>\n";

      &ScriptsTab(*FOUT,*L,$I,$topten,0);

      print FOUT "</TD>";
      print FOUT "</TR><TR>";
      print FOUT "<TD ALIGN=CENTER VALIGN=TOP>";

      if ($fly_set == 0) {
	  $chart_id = 0;
	  $info = "info".$chart_id;
	  $i = &Load_DailyData($datafile,$dirdata);

	  $xlegend = "$i $L{'days'}";
#    $xlegend .= "s" if ($count_month > 1);
	  $xlegend .= " (starting $start_date)";
	  $ylegend = $L{'Scripts'};
	  
	  undef @ref_tab;
	  push(@ref_tab,\@tabreq);
	  push(@ref_tab,\@tabacc);
	  push(@ref_tab,\@tabmm);
	  push(@ref_tab,\@tabdoc);
	  push(@ref_tab,\@tabscript);
	  push(@ref_tab,\@tabuser);
	  push(@ref_tab,\@tabtrafic);
	  
	  @ref_tab_name = ('requests','accesses','hosts','documents2','scripts','users','traffic');
	  
	  &MakeDailyGraphJqplotInit(*FOUT, eval($Lang{$lang[$nblang]}),$I,1,$unit_div,\@ref_tab,\@ref_tab_name,\@listdate,$chart_id);
	  
	  @graph_to_display = ('Scripts');
	  
	  undef @ref_tab;
	  push(@ref_tab,\@tabscript);
	  
	  &MakeDailyGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,1,\@graph_to_display,\@ref_tab,\@listdate,\@serie_color,1,$unit,$chart_id,3,"scripts",$info,0,$xlegend,$ylegend,$xmax_jqplot,$dirscript);

	  &AddJqplotHtml(*FOUT, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_jqplot,$ymax_jqplot,2);

	  $chart_id += $#list_graph_name_jqplot+1;
      }

      if ($fly_set == 1) {
	  $file_page_page = "scripts-home";
	  print FOUT "<P><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
	  print FOUT "<TR>\n";
	  $tmp = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$file_page_page."y".$gifext;
	  print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"y\"></TD>\n";
	  $tmp = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$file_page_page.$gifext;
	  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"graph\" USEMAP=\"#map_page_graph\" BORDER=0></TD>\n";
	  print FOUT "</TR><TR><TD></TD>\n";
	  $tmp = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$file_page_page."x".$gifext;
	  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$tmp\" ALT=\"x\"></TD>\n";
	  print FOUT "</TR>\n";
	  print FOUT "</TABLE>\n";
	  print FOUT "<MAP NAME=\"map_page_graph\">";
	  $tmp = $map_page_graph;
	  $tmp =~ s/<!-- langhome -->/$I/g;
	  print FOUT "$tmp";
#      print FOUT "$map_page_graph";
	  print FOUT "</MAP>\n";
      }

      print FOUT "</TD>";
      print FOUT "</TR>";
      print FOUT "</TABLE>";
  }

  print FOUT "</BODY></HTML>\n";
}

#
##############################################################
### Scripts Parameters
##############################################################
#

sub ScriptsAll {
  local(*FOUT,*L,$I) = @_;

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Stats'} - $L{'Scripts'} : $script</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
  print FOUT "<H2> $L{'Scripts'} : $script</H2><P>\n";

  print FOUT "<A HREF=\"..$dirsepurl..$dirsepurl$dircsv$dirsepurl$incscript$csvext\" TITLE=\"Export in CSV\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>";

#  &PagesExportPDF(*FOUT,"$I$dirsep$dirpage$dirsep$listscripts",$L{'Scripts'},2,2,0,0) if ($enable_pdf == 1);

  $tmp10 = $scriptunique;
  $tmp10 = $max_item_page if ($tmp10 > $max_item_page);

  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} $tmp10 $L{'scripts'}";
  print FOUT " ($L{'among'} $scriptunique) " if ($tmp10 == $max_item_page);
  print FOUT "</I></DIV><P>\n";

  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe ";
  print FOUT "table-autopage:$table_big_lines_aff " if ($tmp10 > $table_big_lines_aff);
  print FOUT "table-stripeclass:alternate\" id=\"page\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Destination'}&nbsp;</TH>\n" if ($squid_format == 1);
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Scripts'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";


   if ($tmp10 > $table_big_lines_aff) {

	$tmp = int($tmp10/$table_big_lines_aff);
	if ($tmp != ($tmp10/$table_big_lines_aff)) {
	    $tmp++;
	}
    
	print FOUT "<tfoot>\n";
	print FOUT "<tr>\n";
	print FOUT "<TH>$L{'Destination'}</TH>\n" if ($squid_format == 1);
	print FOUT "<TH>$L{'Scripts'}</TH>\n";
	print FOUT "<TH>$L{'Occurence'}</TH>\n";
	print FOUT "<TH>$L{'Percentage'}</TH>\n";
	print FOUT "</tr>\n";
	print FOUT "<tr>\n";

	if ($tmp > 1) {
	    print FOUT "<td colspan=3>\n" if ($squid_format == 0);
	    print FOUT "<td colspan=4>\n" if ($squid_format == 1);
	    print FOUT "<a href=\"#\" onclick=\"pageexample('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	    
	    for ($i=1;$i<=$tmp;$i++) {
		$iminus = $i-1;
		print FOUT "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexample($iminus); return false;\">$i</a>\n";
	    }
	    print FOUT "<a href=\"#\" onclick=\"pageexample('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	    print FOUT "<a href=\"#\" onclick=\"pageexample('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	    print FOUT "</td>\n";
	    print FOUT "</tr>\n";
	}
	print FOUT "</tfoot>\n";
    }

  print FOUT "<tbody>\n";

  $i=0;
  $count = 0;
  foreach $script (&reverse_sort_by_value(*script)) {

      $count++;
      if ($count < $max_item_page) {

      $scriptparam = "script".$i.$htmlext;
#      next if ($script{$script} < $seuilscript);
      $pourcentage = (($script{$script}*1000)/$allscriptcgi)/10 if ($allscriptcgi != 0);
      $pourcentageint = int($pourcentage);

      print FOUT "<TR>";
      if ($squid_format == 1) {
	  $tmp = index($script,$dirsep,1);
	  $tmp1 = substr($script,0,$tmp+1);
	  $tmp6 = substr($script,$tmp,length($script));
	  print FOUT "<TD CLASS=\"left\">$tmp1</TD>\n";
      }
      print FOUT "<TD CLASS=\"left\">";
      print FOUT "<A HREF=\"$scriptparam\">" if ($argunique{$script} != 0 && $script{$script} > $seuilscript);
      print FOUT "$script" if ($squid_format == 0);
      print FOUT "$tmp6" if ($squid_format == 1);
      print FOUT "</A>" if ($argunique{$script} != 0 && $script{$script} > $seuilscript);
      print FOUT "&nbsp;</TD>\n<TD CLASS=\"right\">&nbsp;$script{$script}</TD>\n";
      print FOUT "<TD CLASS=\"left\">";
      print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
      printf FOUT "%.1f ",$pourcentage;
      print FOUT "</TD>\n";
      print FOUT "</TR>\n";
      if ($argunique{$script} ne '') {
	  open(SCRIPTPARAM,">$path$lang[$nblang]$dirsep$dirscript$dirsep$scriptparam") || die "Error, unable to open $path$lang[$nblang]$dirsep$dirscript$dirsep$scriptparam\n";
	  &ScriptsParam(*SCRIPTPARAM, eval($Lang{$lang[$nblang]}),$script);
	  close(SCRIPTPARAM);
      }	  
      $i++;
  }
  }

  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n";

  print FOUT "<P>\n</BODY></HTML>\n";
}


sub ScriptsParam {
  local(*FOUT,*L,$I,$script) = @_;

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Stats'} - $L{'Scripts'} : $script</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
#  $tmp = substr($script,rindex($script,$dirsepurl,length($script))+1,length($script));

  print FOUT "<H2> $L{'Scripts'} : $script</H2><P>\n";
  print FOUT "<P><HR><P>\n";

  print FOUT "<I>($L{'Only_scripts'} $L{'with_at_least'} $seuilscript $L{'requests'} $L{'are_shown'})</I><P>\n" if ($seuilscript > 1);

#  print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"$script\"><TR>\n";
#  print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"$script\">\n";

  print FOUT "<TABLE BORDER=0 class=\"maxtablesort\">\n";
  print FOUT "<TR><TD>";
  print FOUT "<TABLE WIDTH=\"100%\"><TR><TH ALIGN=CENTER>$script</TH>\n";
  print FOUT "<TH ALIGN=CENTER>$script{$script}</TH></TR></TABLE>\n";
  print FOUT "</TD></TR>\n";
#  print FOUT "<TH>$L{'Parameter'}</TH>\n";
#  print FOUT "<TH>$L{'Value'}</TH>\n";
#  print FOUT "<TH>$L{'Percentage'}</TH>\n";
#  print FOUT "<TH>$L{'Occurence'}</TH>\n";
#  print FOUT "</TR>\n";

#  $pourcentage = (($script{$script}*1000)/$allscriptcgi)/10;
#  $pourcentageint = int($pourcentage);
#  print FOUT "<TH COLSPAN=2>$script</TD><TH CLASS=\"left\">";
#  print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\"> " if ($pourcentageint != 0);
#  printf FOUT "%.1f ",$pourcentage;
#  print FOUT " %</TH>\n<TH><B>$script{$script}</B> $L{'times'}</TH></TR>\n";

#  foreach $script (&reverse_sort_by_value(*argunique)) {
  for ($j=1;$j<=$argunique{$script};$j++) {
      $tmp = $scriptdata{$script,$j};
      $tmp3 = 0;
      for ($k=1;$k<=$nameunique{$script,$tmp};$k++) {
	  $tmp3++ if ($countarg{$script,$tmp,$countargval{$script,$tmp,$k}} > $seuilscript);
      }
      if ($tmp3 != 0) {
	  print FOUT "<TR><TD>\n";

	  print FOUT "<p>\n<table width=\"100%\" class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
	  print FOUT "<thead>\n";
	  print FOUT "<TR>\n";
	  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Parameter'}&nbsp;:&nbsp;$tmp</TH>\n";
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
	  print FOUT "</TR>\n";
	  print FOUT "</thead>\n";
	  print FOUT "<tbody>\n";

#	  print FOUT "<TABLE CLASS=\"sortable\" ID=\"$script-$tmp\">\n";
#	  print FOUT "<TR>\n<TH CLASS=\"head_left\" VALIGN=TOP>$L{'Parameter'}&nbsp;:&nbsp;$tmp</TH>\n";
#	  print FOUT "<TH>$L{'Percentage'}</TH>\n";
#	  print FOUT "<TH>$L{'Occurence'}</TH></TR>\n";
##	  print FOUT "<TR>\n<TD CLASS=\"head_left\" VALIGN=TOP ROWSPAN=$tmp3>$tmp</TD>\n";
##	  print FOUT "</TR>\n" if ($tmp3 > 1);
#	  $tmp2 = 0;
	  for ($k=1;$k<=$nameunique{$script,$tmp};$k++) {
	      if ($countarg{$script,$tmp,$countargval{$script,$tmp,$k}} > $seuilscript) {
#		  $tmp2++;
		  print FOUT "<TR>\n"; # if ($tmp2 != 1);
		  print FOUT "<TD CLASS=\"right\"><I>"; # if (($tmp2/2) == int($tmp2/2));
#		  print FOUT "<TD CLASS=\"right_alter\"><I>" if (($tmp2/2) != int($tmp2/2));
#		  print FOUT "$countargval{$script,$tmp,$k}" if ($countargval{$script,$tmp,$k} ne '');
#		  print FOUT "&nbsp;" if ($countargval{$script,$tmp,$k} eq '');

		  if ($countargval{$script,$tmp,$k} ne '') {
                      $tmp4 = $script."?".$tmp."=".$countargval{$script,$tmp,$k};
                      print FOUT "$countargval{$script,$tmp,$k}" if ($titlename == 0);
                      print FOUT "$urlconv{$tmp4}" if ($titlename == 1 && $urlconv{$tmp4} ne '');
                      print FOUT "$countargval{$script,$tmp,$k}" if ($titlename == 1 && $urlconv{$tmp4} eq '');

                  } else {
                      print FOUT "&nbsp;";
                  }

		  $pourcentage = (($countarg{$script,$tmp,$countargval{$script,$tmp,$k}}*1000)/$script{$script})/10;
		  $pourcentageint = int($pourcentage);
		  
		  print FOUT "</I></TD>\n";
		  print FOUT "<TD CLASS=\"left\"><I>"; # if (($tmp2/2) == int($tmp2/2));
#		  print FOUT "<TD CLASS=\"left_alter\"><I>" if (($tmp2/2) != int($tmp2/2));
		  print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
		  printf FOUT "%.1f ",$pourcentage;
		  print FOUT " %</TD>\n";
		  print FOUT "<TD CLASS=\"right\"><I>"; # if (($tmp2/2) == int($tmp2/2));
#		  print FOUT "<TD CLASS=\"right_alter\"><I>" if (($tmp2/2) != int($tmp2/2));
		  print FOUT "$countarg{$script,$tmp,$countargval{$script,$tmp,$k}}</TD>\n";
		  print FOUT "</TR>\n";
	      }
	  }
	  print FOUT "</tbody>\n";
	  print FOUT "</TABLE>\n";
	  print FOUT "</TD></TR>\n";
      }
  }

  print FOUT "</TABLE>\n";

  print FOUT "<P>\n</BODY></HTML>\n";
}

#
##############################################################
### RSS
##############################################################
#

sub RSSTab {
  local(*FOUT,*L,$I,$topten,$home) = @_;
  local($count,$link,$tmplink);

  if ($update_homepage == 1 && $home == 1 && $nblang == 0) {
      $scan = 0;
      if (-f "$path$dirinc$dirsep$inchomepage") {
	  open(HOSTHOME,"$path$dirinc$dirsep$inchomepage"); # || &error_exit("Error, unable to open $path$dirinc$dirsep$inchomepage");
	  while (<HOSTHOME>) {
	      chop;
	      $scan = 0 if ($_ =~ /^#/);
	      $scan = 1 if ($_ =~ /^#RSS/);
	      if ($scan == 1) {
		  next if ($_ =~ /^#/);
		  $nb = ($page,$tmp2,$tmp3) = split(/\t/);
		  $rss_nb_page{$page} = $tmp2;
		  $rss_host_unique{$page} = $tmp3;
	      }
	  }
	  close(HOSTHOME);
      }
  }

  $tmplink = "..$dirsepurl..$dirsepurl" if ($home == 0);
  $tmplink = "" if ($home == 1);

  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'RSS'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:date\">&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n" if ($home == 0);
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";

  $tmp2 = $opt_c;
  $tmp2 = substr($tmp2,rindex($tmp2,$dirsep)+1,length($tmp2)) if ($opt_c =~ /^\//);

  for ($i=0;$i<=$#rss_file;$i++) {
      $page = $rss_file[$i];

      if ($rss_nb_page{$page} ne '') {
	  print FOUT "<TR>\n";
	  print FOUT "<TD CLASS=\"left\">";
	  $link = &AddHREF($page);
	  print FOUT "$link";
#	  print FOUT "$page" if ($titlename == 0);
#	  print FOUT "<b>$urlconv{$page}</b>" if ($titlename == 1 && $urlconv{$page} ne '');
#	  print FOUT "$page" if ($titlename == 1 && $urlconv{$page} eq '');

	  print FOUT "</TD>\n";
	  print FOUT "<TD CLASS=\"right\">$rss_nb_page{$page}</TD>\n";
	  print FOUT "<TD CLASS=\"right\">";
	  if ($w3perlcgiurl ne '' && -d $cgipath_install && $home == 0 && $precision > 2) {
	      print FOUT "<A HREF=\"javascript:GraphHosts('$cgipagegraph',";
	      print FOUT "'$tmp2'," if ($opt_c ne '');
	      print FOUT "'config.pl'," if ($opt_c eq '');
	      print FOUT "'$i',";
	      print FOUT "'1',";
	      print FOUT "'$lang[$nblang]'";
	      print FOUT ")\">";
	  }
	  print FOUT "$rss_host_unique{$page}";
	  print FOUT "</A>" if ($home == 0 && $w3perlcgiurl ne '');
	  print FOUT "</TD>\n";
	  print FOUT "<TD CLASS=\"right\">$rss_page_date{$page}</TD>\n" if ($home == 0);
	  print FOUT "</TR>\n";
      }

  }

  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n<P>\n";

}


sub PagesRSS {
  local(*FOUT,*L,$I) = @_;
  local($host,$found,$found_nb,$i,$page,$tab);

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Stats'} - $L{'RSS'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";

  $tmp3 = $curvy_bottom_jss;

  if ($w3perlcgiurl ne '' && -d $cgipath_install && $precision > 2) {
      $tmp2 = $opt_c;
      $tmp2 = substr($tmp2,rindex($tmp2,$dirsep)+1,length($tmp2)) if ($opt_c =~ /^\//);

      $tmp = "GraphHosts('$cgipagegraph',";
      $tmp .= "'$tmp2'," if ($opt_c ne '');
      $tmp .= "'config.pl'," if ($opt_c eq '');
      $tmp .= "'0',";
      $tmp .= "'1',";
      $tmp .= "'$lang[$nblang]'";
      $tmp .= ")";

      $tmp3 =~ s/UpdateToolHeader\(\);/UpdateToolHeader\(\);\n$tmp;/;
  }

  print FOUT "$tmp3\n";

  &add_jqplot_js(*FOUT,2);
  &add_css_style(*FOUT,2);

  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\">\n";
  print FOUT "function ToggleMenu(obj) {\n";
  print FOUT "target = document.getElementById(obj);\n";
  print FOUT "if (target.style.display == \"none\"){\n";
  print FOUT "target.style.display = \"inline\";\n";
  print FOUT "} else {\n";
  print FOUT "target.style.display = \"none\";\n";
  print FOUT "}\n";
  print FOUT "}\n";
  print FOUT "</SCRIPT>\n";
  print FOUT "</HEAD>\n";

  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\"";
  print FOUT ">\n";

  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
  print FOUT "<H2> $L{'RSS'} </H2><P>\n";
  print FOUT "<P><HR><P>\n";

  print FOUT "<TABLE><TR><TD VALIGN=TOP>\n";

  print FOUT "<I>($L{'Only_hosts'} $L{'with_at_least'} $seuilsite $L{'requests'} $L{'are_shown'})</I><P>\n" if ($seuilsite > 1);

  &RSSTab(*FOUT,*L,$I,$topten,0);

  $found_nb = 1;

  print FOUT "<TABLE BORDER=0>\n";
  print FOUT "<TR>\n";

  for ($i=0;$i<=$#rss_file;$i++) {
      $page = $rss_file[$i];
      $page2 = $page;
      $page2 =~ s/\//_/g;

      $tab = "<TABLE>\n";
      $tab .= "<TR>\n";
      $tab .= "<TH>";
      if ($#rss_file > 0) {
	  $tab .= "<A HREF=\"javascript:ToggleMenu('TOGGLE_$page2');\"><IMG SRC=\"..$dirsepurl..$dirsepurl$dirress$dirsepurl$toggle_on\" NAME=\"ima_toggle\" BORDER=0 WIDTH=\"12\" HEIGHT=\"21\" ALT=\"toggle\"></A>\n";
      }
      $tab .= "</TH>";
      $tab .= "<TH";
      if ($#rss_file > 0) {
	  $tab .= " OnClick=\"javascript:ToggleMenu('";
	  $tab .= "TOGGLE_$page2";
	  $tab .= "')\"";
      }
      $tab .= ">";
      $link = &AddHREF($page);
      $tab .= $link;
#      $tab .= "$page" if ($titlename == 0);
 #     $tab .= "<b>$urlconv{$page}</b>" if ($titlename == 1 && $urlconv{$page} ne '');
  #    $tab .= "$page" if ($titlename == 1 && $urlconv{$page} eq '');
      $tab .= "</TH>\n";
      $tab .= "</TR>\n";
      $tab .= "<TR>\n<TD COLSPAN=2>\n";

      $tab .= "\n<DIV ID=\"TOGGLE_$page2\" STYLE=\"display:inline\">\n";

      $tab .= "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
      $tab .= "<thead>\n";
      $tab .= "<TR>\n";
      $tab .= "<TH class=\"table-sortable:default\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
      $tab .= "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
      $tab .= "<TH class=\"table-sortable:date\">&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n";
      $tab .= "</TR>\n";
      $tab .= "</thead>\n";
      $tab .= "<tbody>\n";

      for ($j=1;$j<=$rss_host_unique{$page};$j++) {
	  $host = $rss_host{$page,$j};
	  if ($rss_occur{$page,$host} > $seuilsite) {
	      $found = 1;
	      $tab .= "<TR>\n";
	      $tab .= "<TD CLASS=\"left\" VALIGN=TOP>$host</TD>\n";
	      $tab .= "<TD CLASS=\"right\" VALIGN=TOP>$rss_occur{$page,$host}</TD>\n";
	      $tab .= "<TD CLASS=\"right\" VALIGN=TOP>$rss_date{$page,$host}</TD>\n";
	      $tab .= "</TR>\n";
	  }
      }
      $tab .= "</tbody>\n";
      $tab .= "</TABLE>\n";
      $tab .= "</DIV\n";

      $tab .= "</TD></TR>\n";
      $tab .= "</TABLE>";

      if ($found_nb == 4 && $found == 1) {
	  print FOUT "</TR><TR>";
	  $found_nb = 0;
      }

      if ($found == 1) {
	  print FOUT "<TD ALIGN=LEFT VALIGN=TOP>\n$tab\n</TD>";
	  $found_nb++;
      }

      $found = 0;
  }

  print FOUT "</TR>\n";
  print FOUT "</TABLE>\n";

  print FOUT "</TD><TD VALIGN=TOP>\n";

  print FOUT "<DIV ID=\"graph_print\"></DIV>\n";

  print FOUT "</TD></TR></TABLE>\n";

  print FOUT "<P><HR><P>\n";
  print FOUT "</BODY></HTML>\n";

}


#
##############################################################
### Robots
##############################################################
#

sub PagesRobotAll {
  local(*FOUT,*L,$I) = @_;
  local($host,$found,$i,$tab,$max,%robots_title,%robots_visit,%robots_last_date,%robots_last_visit,%max);

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Stats'} - $L{'Robots_excluding'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
  print FOUT "<H2> $L{'Robots_excluding'} </H2><P>\n";
#  print FOUT "<P><HR><P>\n";

  $found = 0;  
  $tmp = keys(%robots);

  $tab = "<A NAME=\"robot_hosts\"></A>";
  $tab .= "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} $tmp $L{'hosts'} ";
  $tab .= "</I></DIV><P>\n";

  $tab .=  "<I>($L{'Only_hosts'} $L{'with_at_least'} $seuilsite $L{'requests'} $L{'are_shown'})</I><P>\n" if ($seuilsite > 1);

  $tab .= "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  $tab .= "<thead>\n";
  $tab .= "<TR>\n";
  $tab .= "<TH class=\"table-sortable:default\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
  $tab .= "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  $tab .= "<TH class=\"table-sortable:date\">&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n";
  $tab .= "<TH class=\"table-sortable:default\">&nbsp;$L{'Robot_name'}&nbsp;</TH>\n";
  $tab .= "<TH class=\"table-sortable:default\">&nbsp;$L{'String'}&nbsp;</TH>\n";
  $tab .= "</TR>\n";
  $tab .= "</thead>\n";
  $tab .= "<tbody>\n";

#  $tab .=  "<TABLE CLASS=\"sortable_base\" ID=\"robots\">";
#  $tab .=  "<TR>\n";
#  $tab .=  "<TH>&nbsp;$L{'Hosts'}</TH>\n<TH>$L{'Occurence'}&nbsp;</TH>\n";
#  $tab .=  "<TH>&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n";
#  $tab .=  "<TH>&nbsp;$L{'Robot_name'}&nbsp;</TH>\n";
#  $tab .=  "<TH>&nbsp;$L{'String'}&nbsp;</TH>\n";
#  $tab .=  "</TR>\n";
  foreach $host (&reverse_sort_by_value(*robots)) {
      $robots_title{$robots_fullname{$host}} += $robots{$host};
      $robots_visit{$robots_fullname{$host}}++;
      $robots_last_visit{$robots_fullname{$host}} = &nbday($robots_date{$host});
      if ($robots_last_visit{$robots_fullname{$host}} > $max{$robots_fullname{$host}}) {
	  $robots_last_date{$robots_fullname{$host}} = $robots_date{$host};
	  $max{$robots_fullname{$host}} = $robots_last_visit{$robots_fullname{$host}};
      }
      if ($robots{$host} > $seuilsite) {
	  $found = 1;
	  $tab .=  "<TR>\n";
	  $tab .= "<TD CLASS=\"left\" VALIGN=TOP>";
	  $tab .= "<I>" if ($host =~ /$localdomainename$/i);
	  $tab .= "$host";
	  $tab .= "</I>" if ($host =~ /$localdomainename$/i);
	  $tab .= "</TD>\n";
	  $tab .=  "<TD CLASS=\"right\" VALIGN=TOP>$robots{$host}</TD>\n";
	  $tab .=  "<TD CLASS=\"right\">$robots_date{$host}</TD>\n";
	  $tab .=  "<TD CLASS=\"right\"><B>$robots_fullname{$host}</B></TD>\n";
	  $tab .=  "<TD CLASS=\"left\">$robots_name{$host}</TD>\n";
	  $tab .=  "</TR>\n";
      }
  }
  $tab .= "</tbody>\n";
  $tab .=  "</TABLE><P>\n";

  $tmp = keys(%robots_title);

  print FOUT "<A NAME=\"robot_name\"></A>";
  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} $tmp $L{'robots'} ";
  print FOUT "</I></DIV><P>\n";

  print FOUT "<I>($L{'Only_hosts'} $L{'with_at_least'} $seuilsite $L{'requests'} $L{'are_shown'})</I><P>\n" if ($seuilsite > 1);

  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Robot_name'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Number_of_visits'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:date\">&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n";
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";

#  print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"robots_title\">";
#  print FOUT "<TR>\n";
#  print FOUT "<TH>&nbsp;$L{'Robot_name'}&nbsp;</TH>\n";
#  print FOUT "<TH>&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
#  print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
#  print FOUT "<TH>&nbsp;$L{'Number_of_visits'}&nbsp;</TH>\n";
#  print FOUT "<TH>&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n";
#  print FOUT "</TR>\n";

  foreach $host (&reverse_sort_by_value(*robots_title)) {
      if ($robots_title{$host} > $seuilsite) {
	  $percentage = int(100*$robots_title{$host}/$exclrobots);
	  print FOUT "<TR>\n";
	  print FOUT "<TD CLASS=\"right\" VALIGN=TOP>$host</TD>\n";
	  print FOUT "<TD CLASS=\"right\" VALIGN=TOP>$robots_title{$host}</TD>\n";
	  print FOUT "<TD CLASS=\"left\">";
	  if ($percentage != 0) {
	      print FOUT "<IMG WIDTH=$percentage HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> ";
	      print FOUT "&nbsp;$percentage %";
	  }
	  print FOUT "</TD>\n";
	  print FOUT "<TD CLASS=\"right\" VALIGN=TOP>$robots_visit{$host}</TD>\n";
	  print FOUT "<TD CLASS=\"right\" VALIGN=TOP>$robots_last_date{$host}</TD>\n";
	  print FOUT "</TR>\n";
      }
  }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE><P>\n";

  print FOUT "$tab\n" if ($found == 1);

#  print FOUT "<P><HR><P>\n";
  print FOUT "</BODY></HTML>\n";
}

sub PagesRobot {
  local(*FOUT,*L,$I) = @_;
  local($host,$found,$i,$tab,$max,%robots_title,%robots_visit,%robots_last_date,%robots_last_visit,%max);

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Stats'} - $L{'Robots_excluding'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
  print FOUT "<H2> $L{'Robots_excluding'} </H2><P>\n";
#  print FOUT "<P><HR><P>\n";

  $found = 0;  
  $i = 0;

  $tab = "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} $topten $L{'hosts'} ";
  $tab .= "(<A HREF=\"$listrobots#robot_hosts\">$L{'Full_list'}</A>)" if ($show_all == 1);
  $tab .= "</I></DIV><P>\n";

  $tab .=  "<I>($L{'Only_hosts'} $L{'with_at_least'} $seuilsite $L{'requests'} $L{'are_shown'})</I><P>\n" if ($seuilsite > 1);

  $tab .= "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  $tab .= "<thead>\n";
  $tab .= "<TR>\n";
  $tab .= "<TH class=\"table-sortable:default\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
  $tab .= "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  $tab .= "<TH class=\"table-sortable:date\">&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n";
  $tab .= "<TH class=\"table-sortable:default\">&nbsp;$L{'Robot_name'}&nbsp;</TH>\n";
  $tab .= "<TH class=\"table-sortable:default\">&nbsp;$L{'String'}&nbsp;</TH>\n";
  $tab .= "</TR>\n";
  $tab .= "</thead>\n";
  $tab .= "<tbody>\n";

#  $tab .=  "<TABLE CLASS=\"sortable_base\" ID=\"robots\">";
#  $tab .=  "<TR>\n";
#  $tab .=  "<TH>&nbsp;$L{'Hosts'}</TH>\n<TH>$L{'Occurence'}&nbsp;</TH>\n";
#  $tab .=  "<TH>&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n";
#  $tab .=  "<TH>&nbsp;$L{'Robot_name'}&nbsp;</TH>\n";
#  $tab .=  "<TH>&nbsp;$L{'String'}&nbsp;</TH>\n";
#  $tab .=  "</TR>\n";

  foreach $host (&reverse_sort_by_value(*robots)) {
      $robots_title{$robots_fullname{$host}} += $robots{$host};
      $robots_visit{$robots_fullname{$host}}++;
      $robots_last_visit{$robots_fullname{$host}} = &nbday($robots_date{$host});
      if ($robots_last_visit{$robots_fullname{$host}} > $max{$robots_fullname{$host}}) {
	  $robots_last_date{$robots_fullname{$host}} = $robots_date{$host};
	  $max{$robots_fullname{$host}} = $robots_last_visit{$robots_fullname{$host}};
      }
      if ($robots{$host} > $seuilsite && $i < $topten) {
	  $found = 1;
	  $tab .=  "<TR>\n";
	  $tab .= "<TD CLASS=\"left\" VALIGN=TOP>";
	  $tab .= "<I>" if ($host =~ /$localdomainename$/i);
	  $tab .= "$host";
	  $tab .= "</I>" if ($host =~ /$localdomainename$/i);
	  $tab .= "</TD>\n";
	  $tab .=  "<TD CLASS=\"right\" VALIGN=TOP>$robots{$host}</TD>\n";
	  $tab .=  "<TD CLASS=\"right\">$robots_date{$host}</TD>\n";
	  $tab .=  "<TD CLASS=\"right\"><B>$robots_fullname{$host}</B></TD>\n";
	  $tab .=  "<TD CLASS=\"left\">$robots_name{$host}</TD>\n";
	  $tab .=  "</TR>\n";
	  $i++;
      }
  }
  $tab .= "</tbody>\n";
  $tab .=  "</TABLE><P>\n";

  $i = 0;

  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} $topten $L{'robots'} ";
  print FOUT "(<A HREF=\"$listrobots#robot_name\">$L{'Full_list'}</A>)" if ($show_all == 1);
  print FOUT "</I></DIV><P>\n";

  print FOUT "<I>($L{'Only_hosts'} $L{'with_at_least'} $seuilsite $L{'requests'} $L{'are_shown'})</I><P>\n" if ($seuilsite > 1);

  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Robot_name'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Number_of_visits'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:date\">&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n";
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";

#  print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"robots_title\">";
#  print FOUT "<TR>\n";
#  print FOUT "<TH>&nbsp;$L{'Robot_name'}&nbsp;</TH>\n";
#  print FOUT "<TH>&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
#  print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
#  print FOUT "<TH>&nbsp;$L{'Number_of_visits'}&nbsp;</TH>\n";
#  print FOUT "<TH>&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n";
#  print FOUT "</TR>\n";

  foreach $host (&reverse_sort_by_value(*robots_title)) {

      if ($robots_title{$host} > $seuilsite) {
	  $percentage = int(100*$robots_title{$host}/$exclrobots);
	  print FOUT "<TR>\n";
	  print FOUT "<TD CLASS=\"right\" VALIGN=TOP>$host</TD>\n";
	  print FOUT "<TD CLASS=\"right\" VALIGN=TOP>$robots_title{$host}</TD>\n";
	  print FOUT "<TD CLASS=\"left\">";
	  if ($percentage != 0) {
	      print FOUT "<IMG WIDTH=$percentage HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> ";
	      print FOUT "&nbsp;$percentage %";
	  }
	  print FOUT "</TD>\n";
	  print FOUT "<TD CLASS=\"right\" VALIGN=TOP>$robots_visit{$host}</TD>\n";
	  print FOUT "<TD CLASS=\"right\" VALIGN=TOP>$robots_last_date{$host}</TD>\n";
	  print FOUT "</TR>\n";
	  $i++;
	  last if ($i == $topten);
      }
  }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE><P>\n";

  print FOUT "$tab\n" if ($found == 1);

#  print FOUT "<P><HR><P>\n";
  print FOUT "</BODY></HTML>\n";
}

#
##############################################################
### Referer spam
##############################################################
#

sub PagesReferSpam {
  local(*FOUT,*L,$I) = @_;
  local($tmp,$host,$i,$fullsite);

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Stats'} - $L{'ReferSpam_excluding'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
  print FOUT "<H2>$L{'ReferSpam_excluding'}</H2><P>\n";
  print FOUT "<P><HR><P>\n";

  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Referer'}&nbsp;</TH>\n" if ($struct_logfile =~ /\%refer/);
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";

  $count = 0;
  foreach $host (&reverse_sort_by_value(*refer_spam)) {
      $count++;
      print FOUT "<TR>\n<TD VALIGN=TOP CLASS=\"left\">$host</TD>\n<TD CLASS=\"right\" VALIGN=TOP>$refer_spam{$host}</TD>\n";
      $tmp .= "RewriteCond %{REMOTE_ADDR} ^$host ";
      $tmp .= "[OR]" if ($count != keys(%refer_spam));
      $tmp .= "\n<BR>";
      if ($struct_logfile =~ /\%refer/) {
	  print FOUT "<TD CLASS=\"left\">\n<TABLE BORDER=0 WIDTH=\"100%\">\n";
	  for ($i=1;$i<=$count_refer_nb{$host};$i++) {
	      $fullsite = $refer_spam_agent{$host,$i};
	      print FOUT "<TR>\n<TD CLASS=\"left_noborder\">$fullsite</TD>\n<TD CLASS=\"right_noborder\">$refer_fullsite{$host,$fullsite}</TD>\n</TR>\n";
	  }
	  print FOUT "</TABLE>\n</TD>\n";
      }
      print FOUT "</TR>\n";

  }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE><P>\n";

  print FOUT "If you want to ban these unwanted spammer, add an .htaccess file with the following lines at the root of your Apache website :\n<P>";
  print FOUT "Options +FollowSymlinks\n<BR>";
  print FOUT "RewriteEngine On\n<BR>";
  print FOUT "RewriteBase /\n<BR>";
  print FOUT "$tmp";
  print FOUT "RewriteRule ^.*$ - [F]\n<BR>";

  print FOUT "<P><HR><P>\n</BODY></HTML>\n";

}

#
##############################################################
### Status
##############################################################
#

sub PagesStatus {
  local(*FOUT,*L,$I,$status) = @_;
  local($tmp,$tmp1,$tmp2,$i);
  local($tmp3,$tmp4,$count);

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Stats'} - $FailStatusMsgs{$status}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\">\n";
  print FOUT "function ToggleMenuAll(obj) {\n";
  print FOUT " var elementsDIV = document.getElementsByTagName('div');\n";
  print FOUT "	for (var i = 0; i < elementsDIV.length; i++) {\n";
  print FOUT "     var el = elementsDIV[i].id;\n";
  print FOUT "     if (el.indexOf(\"TOGGLE_\") != -1) {\n";
  print FOUT "     elementsDIV[i].style.display  = (elementsDIV[i].style.display != 'none' ? 'none' : 'inline');\n";
  print FOUT "     }\n";
  print FOUT "	}\n";
  print FOUT "}\n";
  print FOUT "function ToggleMenu(obj) {\n";
  print FOUT "target = document.getElementById(obj);\n";
  print FOUT "if (target.style.display == \"none\"){\n";
  print FOUT "target.style.display = \"inline\";\n";
  print FOUT "} else {\n";
  print FOUT "target.style.display = \"none\";\n";
  print FOUT "}\n";
  print FOUT "}\n";
  print FOUT "</SCRIPT>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
  print FOUT "<H2>$L{'Status_code'} : $status - $FailStatusMsgs{$status}</H2><P>\n";
  print FOUT "<P>\n";

#  print FOUT "<I>$L{'Stats_aboutlastdays1'} $topten $L{'Stats_aboutlastdays2'}</I>\n";

  print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2><TR><TD VALIGN=TOP>";

  $i = 0;

  $tmp1 = "client_date_".$status;
  $tmp3 = "client_error_".$status;
  $tmp4 = "client_refer_".$status;

  $tmp10 = keys(%$tmp1);
  $tmp10 = $max_item_page if ($tmp10 > $max_item_page);

  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} $tmp10 $L{'pages'}";
  print FOUT " ($L{'among'} ".keys(%$tmp1).")" if ($tmp10 == $max_item_page);
  print FOUT "</I></DIV><P>\n";


  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe ";
  print FOUT "table-autopage:$table_big_lines_aff " if ($tmp10 > $table_big_lines_aff);
  print FOUT "table-stripeclass:alternate\" id=\"page\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH><A HREF=\"javascript:ToggleMenuAll('Toggle_all');\"><IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$toggle_on\" NAME=\"ima_toggle\" BORDER=0 WIDTH=\"12\" HEIGHT=\"21\" TITLE=\"$L{'Click_here'}\" ALT=\"toggle\"></A></TH>\n" if ($squid_format == 0);
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Destination'}&nbsp;</TH>\n" if ($squid_format == 1);
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$FailStatusMsgs{$status}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:date\">&nbsp;$L{'Last_try'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'coming_from'}&nbsp;</TH>\n" if ($struct_logfile =~ /\%refer/);
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";

  if ($tmp10 > $table_big_lines_aff) {

      $tmp = int($tmp10/$table_big_lines_aff);
      if ($tmp != ($tmp10/$table_big_lines_aff)) {
	  $tmp++;
      }

#      print "A - $status - $tmp10 - $table_big_lines_aff - $tmp\n";

      print FOUT "<tfoot>\n";
      print FOUT "<tr>\n";
      print FOUT "<TH><A HREF=\"javascript:ToggleMenuAll('Toggle_all');\"><IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$toggle_on\" NAME=\"ima_toggle\" BORDER=0 WIDTH=\"12\" HEIGHT=\"21\" TITLE=\"$L{'Click_here'}\" ALT=\"toggle\"></A></TH>\n" if ($squid_format == 0);
      print FOUT "<TH>&nbsp;$L{'Destination'}&nbsp;</TH>\n" if ($squid_format == 1);
      print FOUT "<TH>&nbsp;$FailStatusMsgs{$status}&nbsp;</TH>\n";
      print FOUT "<TH>&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
      print FOUT "<TH>&nbsp;$L{'Last_try'}&nbsp;</TH>\n";
      print FOUT "<TH>&nbsp;$L{'coming_from'}&nbsp;</TH>\n" if ($struct_logfile =~ /\%refer/);
      print FOUT "</tr>\n";
      print FOUT "<tr>\n";
      
      if ($tmp > 1) {
	  $tmp9 = 4;

	  $tmp9++ if ($squid_format == 1);
	  $tmp9++ if ($struct_logfile =~ /\%refer/);
	  print FOUT "<td colspan=$tmp9>\n";
	  print FOUT "<a href=\"#\" onclick=\"pageexample('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	  
	  for ($i=1;$i<=$tmp;$i++) {
	      $iminus = $i-1;
	      print FOUT "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexample($iminus); return false;\">$i</a>\n";
	  }
	  print FOUT "<a href=\"#\" onclick=\"pageexample('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "<a href=\"#\" onclick=\"pageexample('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "</td>\n";
	  print FOUT "</tr>\n";
      }
      print FOUT "</tfoot>\n";
  }

  print FOUT "<tbody>\n";

#

  $count = 0;
  $i = 0;

  $tmp21 = "client_hostlist_".$status;
  $tmp22 = "client_hostlistnb_".$status;

  foreach $page (&reverse_sort_by_value(*$tmp1)) {

#      if ($$tmp3{$page} > $seuilpage) {
	  $tmp2 = $page;
	  $tmp23 = "client_id_".$status;
	  $id = $$tmp23{$tmp2};
#	  $tmp20 = "client_nbhost_".$page."_".$status;
	  $tmp20 = "client_nbhost_".$id."_".$status;

	  $tmp2 =~ s/\&.*//;
	  $tmp2 =~ s/</&lt;/g;      
	  $tmp2 =~ s/>/&gt;/g;
	  $count++;

	  print FOUT "<TR>\n";
	  if ($squid_format == 0) {
	      print FOUT "<TD VALIGN=TOP ALIGN=LEFT WIDTH=\"10\" ";
	      print FOUT "OnClick=\"javascript:ToggleMenu('";
	      print FOUT "TOGGLE_$id";
	      print FOUT "')\"";
	      print FOUT " TITLE=\"$L{'Click_here'}\">";
	      print FOUT "&gt;</TD>\n";
	  }

	  if ($squid_format == 1) {
	      $tmp7 = index($tmp2,$dirsep,1);
	      $tmp5 = substr($tmp2,0,$tmp7+1);
	      $tmp6 = substr($tmp2,$tmp7,length($tmp2));
	      print FOUT "<TD CLASS=\"left\">$tmp5</TD>\n";
	  }

	  print FOUT "<TD CLASS=\"left\">$tmp6</TD>\n" if ($squid_format == 1);
	  if ($squid_format == 0) {
	      print FOUT "<TD CLASS=\"left\">";
	      print FOUT "$tmp2";

	      if ($$tmp20{$tmp2} != 0) {
		  print FOUT "\n<DIV ID=\"TOGGLE_$id\" STYLE=\"display:none\">\n";
		  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\" ID=\"p$tmp2\">\n";
		  print FOUT "<thead>\n";
		  print FOUT "<TR>\n";
		  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
		  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
		  print FOUT "</TR>\n";
		  print FOUT "</thead>\n";
		  print FOUT "<tbody>\n";

		  for ($j=1;$j<=$$tmp20{$tmp2};$j++) {
		      print FOUT "<TR>\n";
		      print FOUT "<TD CLASS=\"left\">";
		      print FOUT "$$tmp21{$tmp2,$j}";
		      print FOUT "</TD>\n";
		      print FOUT "<TD CLASS=\"right\">$$tmp22{$tmp2,$j}</TD>\n";
		      print FOUT "</TR>\n";
		  }
		  print FOUT "</tbody>\n";
		  print FOUT "</TABLE>\n";
		  print FOUT "</DIV>\n";
	      }

	      print FOUT "</TD>\n";
	  } 
	  print FOUT "<TD CLASS=\"right\">$$tmp3{$page}</TD>\n";
	  print FOUT "<TD CLASS=\"right\">".&aff_date($$tmp1{$page})."</TD>\n";
	  if ($struct_logfile =~ /\%refer/) {
	      print FOUT "<TD CLASS=\"right\">";
	      if ($$tmp4{$page} eq "") {
		  print FOUT "&nbsp;";
	      } else {
		  print FOUT "$$tmp4{$page}";
	      }
	      print FOUT "</TD>\n";
	  }
	  print FOUT "</TR>\n";
#	  print "$page - $$tmp1{$page} - $tmp\n";
#	  $i++ if ($$tmp1{$page} ne $tmp);
#	  $tmp = $$tmp1{$page};


##      $i++ if ($client_date{$page} ne $tmp);
##      $tmp = $client_date{$page};
#	  last if ($i == $topten || $count == $max_item_page);
	  last if ($count == $max_item_page);
#      }
  }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE><P>\n";
      

  print FOUT "</TD><TD VALIGN=TOP>";

  $count = 0;
  $i = 0;
  $tmp5 = "client_host_".$status;

  $tmp10 = keys(%$tmp5);
  $tmp10 = $max_item_page if ($tmp10 > $max_item_page);

  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} $tmp10 $L{'hosts'}";
  print FOUT " ($L{'among'} ".keys(%$tmp5).")" if ($tmp10 == $max_item_page);
  print FOUT "</I></DIV><P>\n";


  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe ";
  print FOUT "table-autopage:$table_big_lines_aff " if ($tmp10 > $table_big_lines_aff);
  print FOUT "table-stripeclass:alternate\" id=\"pagebis\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
#  print FOUT "<TH class=\"table-sortable:date\">&nbsp;$L{'Last_try'}&nbsp;</TH>\n";
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";

  if ($tmp10 > $table_big_lines_aff) {

      $tmp = int($tmp10/$table_big_lines_aff);
      if ($tmp != ($tmp10/$table_big_lines_aff)) {
	  $tmp++;
      }
#          print "A - $status - $tmp10 - $table_big_lines_aff - $tmp\n";
      print FOUT "<tfoot>\n";
      print FOUT "<tr>\n";
      print FOUT "<TH>&nbsp;$FailStatusMsgs{$status}&nbsp;</TH>\n";
      print FOUT "<TH>&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
#      print FOUT "<TH>&nbsp;$L{'Last_try'}&nbsp;</TH>\n";
      print FOUT "</tr>\n";
      print FOUT "<tr>\n";
      
      if ($tmp > 1) {
#	  $tmp9 = 3;
	  $tmp9 = 2;
	  print FOUT "<td colspan=$tmp9>\n";
	  print FOUT "<a href=\"#\" onclick=\"pageexamplebis('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	  
	  for ($i=1;$i<=$tmp;$i++) {
	      $iminus = $i-1;
	      print FOUT "<a href=\"#\" id=\"pagebis$i\" class=\"pagelink\" onclick=\"pageexamplebis($iminus); return false;\">$i</a>\n";
	  }
	  print FOUT "<a href=\"#\" onclick=\"pageexamplebis('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "<a href=\"#\" onclick=\"pageexamplebis('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "</td>\n";
	  print FOUT "</tr>\n";
      }
      print FOUT "</tfoot>\n";
  }

  print FOUT "<tbody>\n";

  $count = 0;
  $i = 0;
  foreach $page (&reverse_sort_by_value(*$tmp5)) {

#      if ($$tmp5{$page} > $seuilsite) {
#	  $tmp2 = $page;
#	  $tmp2 =~ s/\&.*//;
#	  $tmp2 =~ s/</&lt;/g;      
#	  $tmp2 =~ s/>/&gt;/g;
	  $count++;

	  print FOUT "<TR>\n";
#	  print FOUT "<TD CLASS=\"left\">$tmp6</TD>\n" if ($squid_format == 1);
	  print FOUT "<TD CLASS=\"left\">$page</TD>\n";
	  print FOUT "<TD CLASS=\"right\">$$tmp5{$page}</TD>\n";
#	  print FOUT "<TD CLASS=\"right\">".&aff_date($$tmp1{$page})."</TD>\n";

	  print FOUT "</TR>\n";
#	  $i++ if ($$tmp5{$page} ne $tmp);
	  $tmp = $$tmp5{$page};
#	  last if ($i == $topten || $count == $max_item_page);
	  last if ($count == $max_item_page);
#      }
  }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE><P>\n";

  print FOUT "</TD></TR></TABLE>\n";

#  foreach $page (&reverse_sort_by_value(*$tmp5)) {
#      print "$status - $page - $$tmp5{$page}\n";
#  }

  print FOUT "</BODY></HTML>\n";

}

#
##############################################################
### Heatmap
##############################################################
#

sub HeatMap {
  local(*FOUT,*L,$I,$ref,$ref2,$ref3) = @_;
  local($curvy2);

#  @screen_iframe = ('2560','1920','1800','1680','1600','1440','1400','1280','1200','1152','1024','800','640');
#  $screen_iframe_default = $screen_iframe[4];


  $curvy2 = $curvy_bottom_jss;
#  if ($w3perlcgiurl ne '' && -d $cgipath_install) {
      $curvy2 =~ s/UpdateToolHeader\(\);/UpdateToolHeader\(\);\nInit_IFrame_Size();/;
#  }

#Update_IFrame(1);
  %maxval = %$ref;
  %valnb = %$ref2;
  @listscreen = @$ref3;

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Stats'} - $L{'Heatmap'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy2\n";
#  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$overlayjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\">\n";
#  print FOUT "function fill_in_screensize() {\n";
#  print FOUT "     document.forms['login_form'].screen_width.value=screen.width;\n";
#  print FOUT "    document.forms['login_form'].screen_height.value=screen.height;\n";
#  print FOUT "    return true;\n";
#  print FOUT "}\n";

  print FOUT "function X_WindowSize() {\n";
  print FOUT "  var myWidth = 0\n";
  print FOUT "  if( typeof( window.innerWidth ) == 'number' ) {\n";
  print FOUT "    //Non-IE\n";
  print FOUT "   myWidth = window.innerWidth;\n";
  print FOUT " } else if( document.documentElement && ( document.documentElement.clientWidth || document.documentElement.clientHeight ) ) {\n";
  print FOUT "    //IE 6+ in 'standards compliant mode'\n";
  print FOUT "   myWidth = document.documentElement.clientWidth;\n";
  print FOUT " } else if( document.body && ( document.body.clientWidth || document.body.clientHeight ) ) {\n";
  print FOUT "   //IE 4 compatible\n";
  print FOUT "   myWidth = document.body.clientWidth;\n";
  print FOUT "}\n";
  print FOUT "return myWidth\n";
  print FOUT "}\n";
  print FOUT "function Y_WindowSize() {\n";
  print FOUT "  myHeight = 0;\n";
  print FOUT "  if( typeof( window.innerWidth ) == 'number' ) {\n";
  print FOUT "    //Non-IE\n";
  print FOUT "   myHeight = window.innerHeight;\n";
  print FOUT " } else if( document.documentElement && ( document.documentElement.clientWidth || document.documentElement.clientHeight ) ) {\n";
  print FOUT "    //IE 6+ in 'standards compliant mode'\n";
  print FOUT "   myHeight = document.documentElement.clientHeight;\n";
  print FOUT " } else if( document.body && ( document.body.clientWidth || document.body.clientHeight ) ) {\n";
  print FOUT "   //IE 4 compatible\n";
  print FOUT "   myHeight = document.body.clientHeight;\n";
  print FOUT "}\n";
  print FOUT "return myHeight\n";
  print FOUT "}\n\n";

  print FOUT "function findPosX(obj){\n";
  print FOUT "        var curleft = 0;\n";
  print FOUT "        if (obj.offsetParent){\n";
  print FOUT "               while (obj.offsetParent){\n";
  print FOUT "                       curleft += obj.offsetLeft\n";
  print FOUT "                       obj = obj.offsetParent;\n";
  print FOUT "              }\n";
  print FOUT "       }else if (obj.x){\n";
  print FOUT "               curleft += obj.x;\n";
  print FOUT "       }\n";
  print FOUT "       return curleft;\n";
  print FOUT "}\n\n";

  print FOUT "function findPosY(obj){\n";
  print FOUT "        var curtop = 0;\n";
  print FOUT "        if (obj.offsetParent){\n";
  print FOUT "               while (obj.offsetParent){\n";
  print FOUT "                        curtop += obj.offsetTop\n";
  print FOUT "                       obj = obj.offsetParent;\n";
  print FOUT "               }\n";
  print FOUT "       }else if (obj.y){\n";
  print FOUT "               curtop += obj.y;\n";
  print FOUT "       }\n";
  print FOUT "       return curtop;\n";
  print FOUT "}\n\n";

#  print FOUT "function CreateIFrame(canvas,url) {\n";
#  print FOUT "          var canvas = document.getElementById(\"canvas\");  \n";
#  print FOUT " if (document.getElementById('heatmap_iframe') == null) {\n";
#  print FOUT "          var iframe = new IFrame(canvas,url);  \n";
#  print FOUT "} else {\n";
#  print FOUT "var iframe = document.getElementById('heatmap_iframe');\n";
#  print FOUT "}\n";

#  print FOUT "myf2 = myf.contentWindow.document || myf.contentDocument;\n";
#  print FOUT "var x = iframe.contentDocument;\n";
#  print FOUT " var x=document.getElementById(\"heatmap_iframe\").contentDocument;\n";
#  print FOUT "alert(\"TOTO \"+x);\n";
#  print FOUT "          var div = iframe.doc.createElement(\"div\");  \n";
#  print FOUT "alert(x.getElementsByTagName(\"action\").firstChild.nodeValue);\n";
#  print FOUT "alert(\"TOTO \"+url);\n";
#  print FOUT "             iframe.src=url;\n";   
#  print FOUT "}\n";

  print FOUT "function Init_IFrame_Size() {\n";

  print FOUT "var screensize_x = screen.width;\n";
  print FOUT "var screensize_y = screen.height;\n";
  print FOUT "var val;\n";

  print FOUT "for (i=0;i<document.resize_iframe.resolution.length;i++) {\n";
  print FOUT "  if (document.resize_iframe.resolution.options[i].value == screensize_x) {\n";
  print FOUT "     document.resize_iframe.resolution.options[i].selected=true;\n";
  print FOUT "     val = document.resize_iframe.resolution.options[i].value;\n";
  print FOUT "   }\n";
  print FOUT "}\n";

  print FOUT "if (val == undefined) val = document.resize_iframe.resolution.options[0].value;\n";
  print FOUT "if (val == undefined) val = screensize_x;\n";
  print FOUT "var iframe = document.getElementById('contentFRM');\n";
  print FOUT "iframe.setAttribute('width',val)\n";
  print FOUT "}\n";

  print FOUT "function Change_IFrame_Size(resolution) {\n";

  print FOUT "var val = document.resize_iframe.resolution.options[resolution.selectedIndex].value;\n";
  print FOUT "var iframe = document.getElementById('contentFRM');\n";

  print FOUT "myf2 = iframe.contentWindow.document || myf.contentDocument;\n";
  print FOUT "iframe.setAttribute('width',val)\n";
  print FOUT "myf2.getElementById('newid_heatmap').innerHTML = '';\n";
  print FOUT "Update_IFrame(0);\n";
  print FOUT "}\n\n";


  print FOUT "function Update_IFrame(update_screen) {\n";

  print FOUT "// Create the string to be inserted in the iframe\n";
  print FOUT "var myf = document.getElementById('contentFRM');\n";
  print FOUT "myf2 = myf.contentWindow.document || myf.contentDocument;\n";
  print FOUT "var val = document.resize_iframe.resolution.options[document.resize_iframe.resolution.selectedIndex].value;\n";
  print FOUT "var currentpage = myf2.location.href\;\n";
  print FOUT "currentpage = currentpage.replace(\"http://\",\"\");\n";
  print FOUT "currentpage = currentpage.replace(\"https://\",\"\");\n";
  print FOUT "var a = currentpage.indexOf('/',0);\n";
  print FOUT "currentpage = currentpage.substr(a,currentpage.length);\n";

  print FOUT "var reg=new RegExp('/', 'g');\n";
  print FOUT "currentpage = currentpage.replace(reg,'_');\n";
  print FOUT "var reg2=new RegExp('\.','g');\n";
  print FOUT "currentpage = currentpage.replace('.','-');\n";


  print FOUT "if (update_screen == 1) {\n";
  print FOUT "// Display screen option value\n";
  print FOUT "var previous = document.resize_iframe.resolution.options.length;\n";
#  print FOUT "var previous_val = document.resize_iframe.resolution.options[document.resize_iframe.resolution.selectedIndex].value;\n";
  print FOUT "document.resize_iframe.resolution.options.length = 0;\n";
  print FOUT "var listdisplay = document.getElementsByName(currentpage).item(0).value;\n";
  print FOUT "var myf = document.getElementById('resolution');\n";
  print FOUT "var reg = new RegExp(',', \"g\");\n";
  print FOUT "var tableau = listdisplay.split(reg);\n";
  print FOUT "var tablength = tableau.length-1;\n";
  print FOUT "var selIdx = 0;\n";
  print FOUT "for (var i=0; i<tablength; i++) {\n";
  print FOUT "var pos = tableau[i].indexOf('-',0);\n";
  print FOUT "var val1 = tableau[i].substring(0,pos);\n";
  print FOUT "var val2 = tableau[i].substring(pos+1,tableau[i].length);\n";
  print FOUT "var text = val1+' ('+val2+' click';\n";
  print FOUT "if (val2 > 1) text += 's';\n";
  print FOUT "text += ')';\n";
  print FOUT "var screensize_x = screen.width;\n";
  print FOUT "document.resize_iframe.resolution.options[i] = new Option(text,val1);\n";
#  print FOUT "if (previous_val == val1) {\n";
  print FOUT "if (screensize_x == val1) {\n";
  print FOUT "    selIdx = i;\n";
  print FOUT "}\n";
  print FOUT "}\n";
  print FOUT "document.resize_iframe.resolution.options[selIdx].selected=true;\n";
  print FOUT "var val = document.resize_iframe.resolution.options[document.resize_iframe.resolution.selectedIndex].value;\n";
  print FOUT "}\n\n";




  print FOUT "var url = val+currentpage\n";
#  print FOUT "alert('A '+url);\n";
  print FOUT "var urltag = \"$linkpath_url\"+\"graph/heatmap\"+url+\".png\";\n";

  print FOUT "var newdiv = myf2.createElement('div');\n";
#  print FOUT "newdiv.id = \"newid_heatmap\";\n";
  print FOUT "newdiv.setAttribute('id',\"newid_heatmap\");\n";

  print FOUT "// Compute Offset\n";
  print FOUT "var firstElement=myf2.getElementsByTagName('body')[0].childNodes[1];\n";
  print FOUT "xOffset=findPosX(firstElement);\n";
  print FOUT "yOffset=findPosY(firstElement);\n";
  print FOUT "var IE = document.all?true:false\n";
  print FOUT "if (IE){ // In IE there's a default margin in the page body. If margin's not defined, use defaults\n";
  print FOUT "var marginLeftExplorer  = parseInt(myf2.getElementsByTagName('body')[0].style.marginLeft);\n";
  print FOUT "var marginTopExplorer   = parseInt(myf2.getElementsByTagName('body')[0].style.marginTop);\n";
  print FOUT "if (isNaN(marginLeftExplorer)) {marginLeftExplorer=10;}\n";
  print FOUT "if (isNaN(marginTopExplorer)) {marginTopExplorer=15;}\n";
  print FOUT "xOffset=xOffset+marginLeftExplorer;\n";
  print FOUT "yOffset=yOffset+marginTopExplorer;\n";
  print FOUT "}\n";

#  print FOUT "alert('A '+xOffset+' B '+yOffset);\n";
  print FOUT "var style='z-index:100;position:absolute;left:'+xOffset+'px;top:'+yOffset+'px'\n";
  print FOUT "newdiv.innerHTML = '<img src=\"'+urltag+'\" id=\"heatmap_calc\" style=\"\'+style+\'\">'\n";
  print FOUT "myf2.body.appendChild(newdiv);\n"; 



  print FOUT "// Display valmax\n";
  print FOUT "var myf = document.getElementById('val_max');\n";
  print FOUT "var myf2 = document.getElementById('val_max_half');\n";
  print FOUT "var myf3 = document.getElementById('val_max_quarter');\n";
  print FOUT "var myf4 = document.getElementById('val_max_third_quarter');\n";
  print FOUT "var max = document.getElementsByName(url).item(0).value;\n";
  print FOUT "myf.innerHTML = max;\n";
  print FOUT "myf2.innerHTML = max/2\n";
  print FOUT "if (max > 3) {\n";
  print FOUT "myf3.innerHTML = max/4\n";
  print FOUT "myf4.innerHTML = 3*max/4\n";
  print FOUT "} else {\n";
  print FOUT "myf3.innerHTML = ''\n";
  print FOUT "myf4.innerHTML = ''\n";
  print FOUT "}\n";

  print FOUT "}\n";
  
#  print FOUT "function Update_IFrame2(url) {\n";
#  print FOUT "var myf = document.getElementById('IframeName');\n";
#  print FOUT "myf2 = myf.contentWindow.document || myf.contentDocument;\n";
#  print FOUT "myf2.location.href=url;\n";

#  print FOUT "var newdiv = document.createElement('div');\n";
#  print FOUT "var style='z-index:100;position:absolute;left:0px;top:0px';\n";
#  print FOUT "var datafile = url;\n";
#  print FOUT "var reg=new RegExp('/', 'g');\n";
#  print FOUT "datafile = datafile.replace(reg,'_');\n";
#  print FOUT "newdiv.innerHTML = '<img src=\"/stats/babel-ftp3/graph/heatmap_\"+datafile+\".png\" id=\"heatmap_calc\">';\n";
#  print FOUT "myf2.body.appendChild(newdiv);\n";
#  print FOUT "alert('TOTO '+datafile);\n";
#  print FOUT "}\n";
#  print FOUT "function PopIt_Heatmap(ref) {\n";
#  print FOUT "var xwin;\n";
#  print FOUT "var ywin;\n";

#  print FOUT "xwin = X_WindowSize();\n";
#  print FOUT "ywin = Y_WindowSize();\n";
#  print FOUT "popup = window.open(\"\"+ref,\"popDialog\",\"height=\"+ywin+\",width=\"+xwin+\",left=0,top=0,screenX=0,screenY=0,scrollbars=no,resizable=no\")\n";
#  print FOUT "popup.focus()\n";
#  print FOUT "}\n";
  print FOUT "</SCRIPT>\n";

  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
#  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n"; # OnLoad=\"javascript:Init_IFrame_Size();\">\n";

  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);  

  print FOUT "<H2> $L{'Heatmap'}</H2><P>\n";
  print FOUT "<P>\n";

  &help_div(*FOUT);

  $tmp2 = $opt_c;
  $tmp2 = substr($tmp2,rindex($tmp2,$dirsep)+1,length($tmp2)) if ($opt_c =~ /^\//);

  $tmp = 0;
  foreach $val (keys(%heatmap)) {
      $tmp += $heatmap{$val};
  }

  print FOUT "<TABLE CELLSPACING=3 CELLPADDING=2>";
  print FOUT "<TR>\n";
  print FOUT "<TD VALIGN=TOP ROWSPAN=2>\n";

  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Page'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Click'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";

#  print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"heatmap\">";
#  print FOUT "<TR>\n";
#  print FOUT "<TH>&nbsp;$L{'Page'}&nbsp;</TH>\n<TH>&nbsp;$L{'Click'}&nbsp;</TH>\n<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
#  print FOUT "</TR>\n";
  $hidden = '';

  foreach $val (&reverse_sort_by_value(*heatmap)) {
      $url = $val;
      $url =~ s/\//_/g;
      $url =~ s/\./-/g;
      if ($heatmap{$val} > $seuilpage) {

      for ($i=0;$i<=$#listscreen;$i++) {
	  $hidden .= "<INPUT NAME=\"$listscreen[$i]$url\" VALUE=\"$maxval{$url,$listscreen[$i]}\" TYPE=\"hidden\">\n" if ($maxval{$url,$listscreen[$i]} ne '');
      }

      $hidden .= "<INPUT NAME=\"$url\" VALUE=\"";
      for ($i=0;$i<=$#listscreen;$i++) {
	  $hidden .= "$listscreen[$i]-$valnb{$url,$listscreen[$i]}," if ($maxval{$url,$listscreen[$i]} ne '');
      }
      $hidden .= "\" TYPE=\"hidden\">\n";

      $xmax_val = $xmax{$url};
      $ymax_val = $ymax{$url};
      $percentage = int($heatmap{$val}*100/$tmp);
      print FOUT "<TR>\n";
      print FOUT "<TD CLASS=\"left\">\n";

      print FOUT "<A HREF=\"$val\" TARGET=\"contentFRM\"";
      print FOUT " TITLE=\"$val\"" if ($titlename == 1 && $urlconv{$val} ne '');
      print FOUT ">";
      print FOUT "$val" if ($titlename == 0 || $urlconv{$val} eq '');
      print FOUT "$urlconv{$val}" if ($titlename == 1 && $urlconv{$val} ne '');
      print FOUT "</A>";

      print FOUT "</TD>\n";
      print FOUT "<TD CLASS=\"right\">$heatmap{$val}</TD>\n";
      print FOUT "<TD CLASS=\"left\">";
      print FOUT "<IMG WIDTH=$percentage HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($percentage != 0);
      print FOUT "&nbsp;$percentage %</TD>\n";
      print FOUT "</TR>\n";
      }
  }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE><P>\n";

  print FOUT "</TD><TD VALIGN=TOP COLSPAN=2>\n";

  $click_color = "click_colors.png";
  #print FOUT "<TD VALIGN=MIDDLE onMouseOver=\"overdiv++;popLayer('$L{'Title_search_pages'}','$L{'Line_search_pages'}','$L{'Desc_search_pages'}','$L{'Link_search_pages'}',0,'','$help_width')\">\n" if ($mail_format == 0);
#      print FOUT "<INPUT type=\"submit\" class=\"submit_button \"name=\"search_button\"  value=\"$L{'Search'}\" OnFocus=\"javascript:document.ajax.search_button.value='$L{'Processing'}'\">\n";

  $tmp = (&reverse_sort_by_value(*heatmap))[0];
  $url = $tmp;
  $url =~ s/\//_/g;
  $url =~ s/\./-/g;

  print FOUT "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
  print FOUT "<TR><TD COLSPAN=5>";
  print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl$dirress$dirsepurl$click_color\" BORDER=0 WIDTH=\"485\" HEIGHT=\"25\" ALT=\"color_bar\">";
  print FOUT "</TD></TR><TR><TD WIDTH=\"20%\" ALIGN=LEFT>";
  print FOUT "0";
  print FOUT "</TD><TD WIDTH=\"20%\" ALIGN=CENTER><DIV ID=\"val_max_quarter\"></DIV>";
  print FOUT "</TD><TD WIDTH=\"20%\" ALIGN=CENTER><DIV ID=\"val_max_half\"></DIV>";
  print FOUT "</TD><TD WIDTH=\"20%\" ALIGN=CENTER><DIV ID=\"val_max_third_quarter\"></DIV>";
  print FOUT "</TD><TD WIDTH=\"20%\" ALIGN=RIGHT><DIV ID=\"val_max\"></DIV>";
  print FOUT "</TD></TR></TABLE>\n";

  print FOUT "</TD></TR>\n";

  print FOUT "<TR><TD>\n";
  print FOUT "<FORM METHOD=\"POST\" ACTION=\"\" NAME=\"resize_iframe\">\n";
  print FOUT "$L{'Screensize'} :\n";

  print FOUT "<SELECT NAME=\"resolution\" ID=\"resolution\" OnChange=\"javascript:Change_IFrame_Size(this)\">\n";
  for ($i=0;$i<=$#listscreen;$i++) {
      next if ($listscreen[$i] eq '');
      if ($maxval{$url,$listscreen[$i]} ne '' && $valnb{$url,$listscreen[$i]} > $seuilpage) {
	  print FOUT "<OPTION VALUE=\"$listscreen[$i]\"";
	  print FOUT ">$listscreen[$i] ($valnb{$url,$listscreen[$i]} click)</OPTION>\n";
      }
  }
#  print FOUT "<OPTION VALUE=\"0\">All</OPTION>\n";
  print FOUT "</SELECT>\n";
  print FOUT "</FORM>\n";

  print FOUT "</TD>";
  print FOUT "<TD VALIGN=MIDDLE onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$L{'Title_heatmap'}','$L{'Line_heatmap'}','$L{'Desc_heatmap'}','$L{'Link_heatmap'}',0,'','$help_width')\">\n";
  print FOUT "<INPUT type=\"submit\" class=\"submit_button \"name=\"search_button\"  value=\"Help\">\n";
  print FOUT "</TD>";
  print FOUT "</TR></TABLE>\n";

  print FOUT "$hidden\n";

#  print FOUT "<FORM NAME=\"ajax\">";
#  print FOUT "<INPUT TYPE=\"hidden\" NAME=\"linkpath\" VALUE=\"$linkpath_url$dirgraph$dirsepurl$link_heatmap\">\n";
#  print FOUT "</FORM>\n";
#  print FOUT "<DIV ID=\"heatmap_results\"></DIV>\n";
#  print FOUT "<div id=\"canvas\" style=\"border: solid 1px #000000; height: 1000px; width: 1000px;\"></div>\n";
  print FOUT "<P><HR><P>";

#  print FOUT "<IFRAME id=\"contentFRM\" src=\"$tmp\" name=\"contentFRM\" onLoad=\"javascript:Update_IFrame();\" width=\"1600\" height=\"1200\" marginheight=\"0\" marginwidth=\"0\" frameborder=0 border=0 align=\"left\" left=0>\n";
#  print FOUT "<IFRAME id=\"contentFRM\" src=\"$tmp\" name=\"contentFRM\" onLoad=\"javascript:Update_IFrame(1);\" width=\"0\" height=\"1200\" marginheight=\"0\" marginwidth=\"0\" frameborder=0 border=0 align=\"left\" left=0>\n";
  print FOUT "<IFRAME id=\"contentFRM\" src=\"$tmp\" name=\"contentFRM\" onLoad=\"javascript:Update_IFrame(1);\" width=\"0\" height=\"1200\" marginheight=\"0\" marginwidth=\"0\" frameborder=0 align=\"left\">\n";
#  print FOUT "<IFRAME id=\"contentFRM\" src=\"$tmp\" name=\"contentFRM\" width=\"0\" height=\"1200\" marginheight=\"0\" marginwidth=\"0\" frameborder=0 align=\"left\">\n";
  print FOUT "</IFRAME>\n";
  print FOUT "</BODY></HTML>\n";

  # Attention updateToolHeader not compatible avec onLoad !
}


#
##############################################################
### Screensize
##############################################################
#

sub Screensize {
  local(*FOUT,*L,$I) = @_;
  local($j,%value,$tmp,$tmp_screen,$tmp_ratio);

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Stats'} - $L{'Miscellaneous'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";
  &add_jqplot_js(*FOUT,2);
  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
  &help_div(*FOUT);

  print FOUT "<H2> $L{'Miscellaneous'} :</H2><P>\n";

  print FOUT "<table><tr><td VALIGN=TOP>\n";

  $tmp_screen = 0;
  $tmp_ratio = 0;
  foreach $val (keys(%screensize)) {
      $tmp_screen += $screensize{$val};
  }

  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Screensize'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";

  foreach $val (&reverse_sort_by_value(*screensize)) {
      $percentage = int($screensize{$val}*100/$tmp_screen);
      print FOUT "<TR>\n";
      print FOUT "<TD CLASS=\"left\">$val</TD>\n";
      print FOUT "<TD CLASS=\"right\">$screensize{$val}</TD>\n";
      print FOUT "<TD CLASS=\"left\">";
      print FOUT "<IMG WIDTH=$percentage HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($percentage != 0);
      print FOUT "&nbsp;$percentage %</TD>\n";
      print FOUT "</TR>\n";

      ($val1,$val2) = split(/x/,$val);
      for ($j=0;$j<$#screen_ratio;$j++) {
	  ($tmp1,$tmp2) = split(/\//,$screen_ratio[$j]);

	  if (($val1/$tmp1) == int($val1/$tmp1)) {
	      if (($val1/$tmp1)*$tmp2 == $val2) {
		  $value{$screen_ratio[$j]} += $screensize{$val};
		  $tmp_ratio += $screensize{$val};
	      }
	  }
      }

  }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE><P>\n";

  #

  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Screensize'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";

  foreach $val (&reverse_sort_by_value(*value)) {
      $percentage = int($value{$val}*100/$tmp_ratio);
      print FOUT "<TR>\n";
      print FOUT "<TD CLASS=\"left\">$val</TD>\n";
      print FOUT "<TD CLASS=\"right\">$value{$val}</TD>\n";
      print FOUT "<TD CLASS=\"left\">";
      print FOUT "<IMG WIDTH=$percentage HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($percentage != 0);
      print FOUT "&nbsp;$percentage %</TD>\n";
      print FOUT "</TR>\n";
  }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE><P>\n";

#

  $tmp = 0;
  foreach $val (keys(%colordepth)) {
      $tmp += $colordepth{$val};
  }

  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Color_depth'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";


  foreach $val (&reverse_sort_by_value(*colordepth)) {
      $percentage = int($colordepth{$val}*100/$tmp);
      print FOUT "<TR>\n";
      print FOUT "<TD CLASS=\"left\">$val</TD>\n";
      print FOUT "<TD CLASS=\"right\">$colordepth{$val}</TD>\n";
      print FOUT "<TD CLASS=\"left\">";
      print FOUT "<IMG WIDTH=$percentage HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($percentage != 0);
      print FOUT "&nbsp;$percentage %</TD>\n";
      print FOUT "</TR>\n";
  }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE><P>\n";

  #

  $tmp = 0;
  foreach $val (keys(%java_support)) {
      $tmp += $java_support{$val};
  }

  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Java_plugin'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";

  foreach $val (&reverse_sort_by_value(*java_support)) {
      $percentage = int($java_support{$val}*100/$tmp);
      print FOUT "<TR>\n";
      print FOUT "<TD CLASS=\"left\">$val</TD>\n";
      print FOUT "<TD CLASS=\"right\">$java_support{$val}</TD>\n";
      print FOUT "<TD CLASS=\"left\">";
      print FOUT "<IMG WIDTH=$percentage HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($percentage != 0);
      print FOUT "&nbsp;$percentage %</TD>\n";
      print FOUT "</TR>\n";
  }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE><P>\n";

  print FOUT "</td><td valign=top>";

#  $max = $screensize{(&reverse_sort_by_value(*screensize))[0]};
#  $min = $screensize{(&reverse_sort_by_value(*screensize))[$count_cloud_max]};

  ($line_cloud,$line_cloud_sort) = &MakeCloud(\%screensize,'',1);

  print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
  print FOUT "<TR><TD VALIGN=TOP>\n";

  if ($fly_set == 0) {
      $chart_id = 0;
      $info = "info".$chart_id;      
      $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%screensize,\@serie_color,$tmp_screen,0,1,$unit,$chart_id,0,$info,"","",'');
  }

  if ($fly_set == 1) {
      $screensize_pie = "screensize_pie".$gifext;  
      ($line_pie,$map_screen_pie) = &MakePieChart($screensize_pie,$tmp_screen,\%screensize,0,0,'',$rayon);
  }

  print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
  print FOUT "<TR><TD ALIGN=CENTER VALIGN=TOP>";

  print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
  print FOUT "<TR><TD ALIGN=CENTER VALIGN=MIDDLE>";
  print FOUT "<TABLE BORDER=0>";
  print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Screensize'}</TH></TR>";
  print FOUT "$line_pie";
  print FOUT "</TABLE>\n";
  print FOUT "</TD>\n";
  print FOUT "<TD ALIGN=CENTER>";
  print FOUT "<IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$screensize_pie\" USEMAP=\"#map_screen_graph\" BORDER=0 ALT=\"graph\">\n" if ($fly_set == 1);
 if ($fly_set == 0) {
      print FOUT "<div id=\"";
      print FOUT "chart".$chart_id;
      print FOUT "\" ";
      print FOUT "style=\"";
      print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
      print FOUT "</div>\n";
  }
  print FOUT "<P><I>$L{'Occurence'}</I>";
  print FOUT "</TD></TR></TABLE>\n";
  if ($fly_set == 1) {
      print FOUT "<MAP NAME=\"map_screen_graph\">\n";
      $tmp = $map_screen_pie;
      $tmp =~ s/<!-- langhome -->/$I/g;
      print FOUT "$tmp";
      print FOUT "</MAP>\n";
  }
  if ($fly_set == 0) {
      if ($xmax_jqplot != $xmax_home_jqplot) {
	  print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
      }
      print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
  }
#  print FOUT "</DIV>";
  print FOUT "</td></tr></table>\n";

  print FOUT "</TD></TR><TR>\n";

  print FOUT "<TD VALIGN=TOP align=\"justify\">";

  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'Sort'} : <A HREF=\"javascript:ToggleBeta('tog_alpha','tog_value');\">$L{'Alphabetically'}</A> - <A HREF=\"javascript:ToggleBeta('tog_value','tog_alpha');\">$L{'By_size'}</A></DIV><P>";

  print FOUT "<DIV ID=\"tog_alpha\" STYLE=\"display:inline\">";
  print FOUT "$line_cloud\n";
  print FOUT "</DIV>\n";
  print FOUT "<P>";
  
  print FOUT "<DIV ID=\"tog_value\" STYLE=\"display:none\">";
  print FOUT "$line_cloud_sort\n";
  print FOUT "</DIV>\n";

  print FOUT "</TD></TR></TABLE>\n";
  print FOUT "</BODY></HTML>\n";
}

#
##############################################################
### Login
##############################################################
#

sub PageUsers {
  local(*FOUT,*L,$I,$user) = @_;
  local($page,$tmp10,$rowspan);
  local(%temp,$maxsize);
  local(@tabreq,@tabacc,@tabhost,@tabsize);

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Stats'} - ";
  print FOUT "$L{'Accesses'}" if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
  print FOUT "$L{'Files'}" if ($ftp_format == 1);
  print FOUT "$L{'Emails'}" if ($mail_format == 1);
  print FOUT " - $L{'Users'} - $user</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_jqplot_js(*FOUT,2);
  &add_css_style(*FOUT,2);

#  $tmp10 = $user{$user};
  $tmp10 = $user_nbacc{$user};
  $tmp10 = $max_item_page if ($tmp10 > $max_item_page);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
  print FOUT "<H2>$L{'Users'} : ";
  print FOUT "$user" if ($user_login{$user} eq '');
  print FOUT "$user_login{$user}" if ($user_login{$user} ne '');
  print FOUT "</H2><P>\n";

  $maxsize = 0;
  for ($i=0;$i<=$#listdate;$i++) {
      $tmp = "requser_$user";
      $val = $$tmp{$listdate[$i]};
      $val = 0 if ($val eq '');
      push(@tabreq,$val);

      if ($cups_format == 0 && $ftp_format == 0 && $mail_format == 0) {
	  $tmp = "accuser_$user";
	  $val = $$tmp{$listdate[$i]};
	  $val = 0 if ($val eq '');
	  push(@tabacc,$val);
      }

      $tmp = "hostuser_$user";
      $val = $$tmp{$listdate[$i]};
      $val = 0 if ($val eq '');
      push(@tabhost,$val);

      $tmp = "sizeuser_$user";
      $val = $$tmp{$listdate[$i]};
      $val = 0 if ($val eq '');
      $maxsize = $val if ($val > $maxsize);
      push(@tabsize,$val);
  }

  ($unit_div,$unit) = &Return_Unit($maxsize,1);

  if ($fly_set == 0) {
      $chart_id = 0;
      $info = "info".$chart_id;
	  
      $xlegend = "$i $L{'days'}";
      $xlegend .= " (starting $start_date)";
      $ylegend = "";

      undef @ref_tab;
      push(@ref_tab,\@tabreq);
      push(@ref_tab,\@tabacc) if ($cups_format == 0 && $ftp_format == 0 && $mail_format == 0);
      push(@ref_tab,\@tabhost);
      push(@ref_tab,\@tabsize) if ($notrafic == 0);

      if ($cups_format == 0 && $ftp_format == 0 && $mail_format == 0) {
	  @ref_tab_name = ('requests','accesses','hosts','traffic');
      } else {

	  if ($cups_format == 1) {
	      @ref_tab_name = ('requests','files');
	  } else {
	      @ref_tab_name = ('requests','unique','traffic');
	  }
      }
	  
      &MakeDailyGraphJqplotInit(*FOUT, eval($Lang{$lang[$nblang]}),$I,1,$unit_div,\@ref_tab,\@ref_tab_name,\@listdate,$chart_id);
	  
      if ($cups_format == 0 && $ftp_format == 0 && $mail_format == 0) {
	  @graph_to_display = ($L{'Requests'},$L{'Accesses'},$L{'Hosts'});
      } else {
	  if ($cups_format == 1) {
	      @graph_to_display = ($L{'Requests'},$L{'Files'});
	  } else {
	      @graph_to_display = ($L{'Requests'},$L{'Unique'});
	  }
      }

      undef @ref_tab;
      push(@ref_tab,\@tabreq);
      push(@ref_tab,\@tabacc) if ($cups_format == 0 && $ftp_format == 0 && $mail_format == 0);
      push(@ref_tab,\@tabhost);
	  
      &MakeDailyGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,1,\@graph_to_display,\@ref_tab,\@listdate,\@serie_color,1,$unit,$chart_id,0,"",$info,0,$xlegend,"",$xmax_jqplot,"$users$htmlext");
      &AddJqplotHtml(*FOUT, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_jqplot,$ymax_jqplot,2);
      
      $chart_id += $#list_graph_name_jqplot+1;

      # Trafic

      if ($maxsize > 0 && $notrafic == 0) {
	  $info = "info".$chart_id;
	  $ylegend = "$L{'Traffic'} ($L{$unit})";

	  @graph_to_display = ($L{'Traffic'});

	  undef @ref_tab;
	  push(@ref_tab,\@tabsize);
	  
	  &MakeDailyGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,1,\@graph_to_display,\@ref_tab,\@listdate,\@serie_color,$unit_div,$unit,$chart_id,1,"traffic",$info,0,$xlegend,$ylegend,$xmax_jqplot,"$users$htmlext");

	  &AddJqplotHtml(*FOUT, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_jqplot,$ymax_jqplot,2);
      
	  $chart_id += $#list_graph_name_jqplot+1;
      }
  }


#  print FOUT "<I>(";
#  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
#      print FOUT "$user_access{$user} ";
#      print FOUT "$L{'pages'}" if ($user_access{$user} != 1);
#      print FOUT "$L{'page'}" if ($user_access{$user} == 1);
#      print FOUT " HTML";
#      print FOUT " $L{'among'} ";
#  }
#  print FOUT "$user{$user} ";
#  print FOUT "$L{'request'}" if ($user{$user} == 1);
#  print FOUT "$L{'requests'}" if ($user{$user} != 1);
#  print FOUT ")</I>\n";
#  print FOUT "<P>\n";

  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} $tmp10 ";
  print FOUT "$L{'files'} " if ($mail_format == 0);
  print FOUT "$L{'emails'} " if ($mail_format == 1);
  print FOUT "($L{'among'} $user{$user}) " if ($tmp10 == $max_item_page);
  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
      print FOUT " ($user_access{$user} $L{'requests'}) ";
#      print FOUT "$L{'pages'}" if ($user_access{$user} != 1);
#      print FOUT "$L{'page'}" if ($user_access{$user} == 1);
  }
  print FOUT "</I>";
  print FOUT ":</DIV><P>\n";

#  &help_div(*FOUT);

#  print FOUT "<P>\n";

  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe ";
  print FOUT "table-autopage:$table_big_lines_aff " if ($tmp10 > $table_big_lines_aff);
  print FOUT "table-stripeclass:alternate\" id=\"page\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";

  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Level'}&nbsp;</TH>\n" if ($mail_format == 0 && $cups_format == 0);
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Destination'}&nbsp;</TH>\n" if ($squid_format == 1);
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Pages'}&nbsp;</TH>\n" if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Files'}&nbsp;</TH>\n" if ($ftp_format == 1 || $cups_format == 1);
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Emails'}&nbsp;</TH>\n" if ($mail_format == 1);
  if ($spamonly != 1 && (($spam_user_ext{$user} != 0 && $val =~ /\@/) || ($spam_user_loc{$user} != 0 && $val !~ /\@/))) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Spam'}&nbsp;</TH>\n" if ($mail_format == 1 && $spam_found != 0);
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Spam_rank'}&nbsp;</TH>\n" if ($mail_format == 1 && $spam_found != 0);
  }
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n" if ($cups_format == 0);
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Requests'}&nbsp;</TH>\n" if ($cups_format == 1);
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";

  if ($tmp10 > $table_big_lines_aff) {	

      $tmp = int($tmp10/$table_big_lines_aff);
      if ($tmp != ($tmp10/$table_big_lines_aff)) {
	  $tmp++;
      }

      print FOUT "<tfoot>\n";
      print FOUT "<tr>\n";
      print FOUT "<TH>&nbsp;$L{'Level'}&nbsp;</TH>\n" if ($mail_format == 0 && $cups_format == 0);
      print FOUT "<TH>&nbsp;$L{'Destination'}&nbsp;</TH>\n" if ($squid_format == 1);
      print FOUT "<TH>&nbsp;$L{'Pages'}&nbsp;</TH>\n" if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
      print FOUT "<TH>&nbsp;$L{'Files'}&nbsp;</TH>\n" if ($ftp_format == 1 || $cups_format == 1);
      print FOUT "<TH>&nbsp;$L{'Emails'}&nbsp;</TH>\n" if ($mail_format == 1);
      if ($spamonly != 1 && (($spam_user_ext{$user} != 0 && $val =~ /\@/) || ($spam_user_loc{$user} != 0 && $val !~ /\@/))) {
	  print FOUT "<TH>&nbsp;$L{'Spam'}&nbsp;</TH>\n" if ($mail_format == 1 && $spam_found != 0);
	  print FOUT "<TH>&nbsp;$L{'Spam_rank'}&nbsp;</TH>\n" if ($mail_format == 1 && $spam_found != 0);
      }
      print FOUT "<TH>&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
      print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n";

      print FOUT "</tr>\n";
      print FOUT "<tr>\n";
	
      if ($tmp > 1) {
	  $rowspan = 3;
	  $rowspan++ if ($squid_format == 1);
	  $rowspan++ if ($mail_format == 0 && $cups_format == 0);
	  $rowspan += 2 if ($spamonly != 1 && (($spam_user_ext{$user} != 0 && $val =~ /\@/) || ($spam_user_loc{$user} != 0 && $val !~ /\@/)));
	  print FOUT "<td colspan=$rowspan>\n";
	  print FOUT "<a href=\"#\" onclick=\"pageexample('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	    
	  for ($i=1;$i<=$tmp;$i++) {
	      $iminus = $i-1;
	      print FOUT "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexample($iminus); return false;\">$i</a>\n";
	  }
	  print FOUT "<a href=\"#\" onclick=\"pageexample('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "<a href=\"#\" onclick=\"pageexample('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "</td>\n";
	  print FOUT "</tr>\n";
      }
      print FOUT "</tfoot>\n";
  }

  print FOUT "<tbody>\n";

  $count = 0;

  for ($i=1;$i<=$user_nbacc{$user};$i++) {
      $page = $user_page{$user,$i};
      $temp{$page} = $user_nbpage{$user,$page};
  }

  foreach $page (&reverse_sort_by_value(*temp)) {

#  for ($i=1;$i<=$user_nbacc{$user};$i++) {
      $count++;
#      $page = $user_page{$user,$i};
      print FOUT "<TR>\n";

      $tmp1 = $page;

      $tmp2 = 0;
      $tmp2++ while $tmp1 =~ s/$dirsepurl//;
      $tmp2-- if ($squid_format == 1);
      print FOUT "<TD CLASS=\"right\">&nbsp;$tmp2&nbsp;</TD>\n" if ($mail_format == 0 && $cups_format == 0);

      if ($squid_format == 1) {
	  $tmp = index($page,$dirsep,1);
	  $tmp1 = substr($page,0,$tmp+1);
	  $tmp6 = substr($page,$tmp,length($page));
	  print FOUT "<TD CLASS=\"left\">$tmp1</TD>\n";
      }

      print FOUT "<TD CLASS=\"left\" TITLE=\"$page\">";
      $link = &AddHREF($page) if ($squid_format == 0);
      $link = &AddHREF($tmp6) if ($squid_format == 1);
      $link = &EncryptLink($link) if ($crypt == 1);
      print FOUT "$link";
#      if ($squid_format == 0) {
#	  print FOUT "$page" if ($titlename == 0);
#	  print FOUT "<b>$urlconv{$page}</b>" if ($titlename == 1 && $urlconv{$page} ne '');
#	  print FOUT "$page" if ($titlename == 1 && $urlconv{$page} eq '');
 #     }

#      print FOUT "$tmp6\n" if ($squid_format == 1);
      print FOUT "</TD>";
      if ($spamonly != 1 && (($spam_user_ext{$user} != 0 && $val =~ /\@/) || ($spam_user_loc{$user} != 0 && $val !~ /\@/))) {
	  print FOUT "<TD CLASS=\"right\">";
	  print FOUT "$spam_page{$page}\n" if ($spam_page{$page} ne '');
	  print FOUT "</TD>";
	  print FOUT "<TD CLASS=\"right\">";
	  if ($spam_page{$page} ne '') {
	      $tmp = int(10*$spam_rank{$page}/$spam_page{$page})/10;
	      print FOUT "$tmp\n";
	  }
	  print FOUT "</TD>";
      }
      print FOUT "<TD CLASS=\"right\">$user_nbpage{$user,$page}</TD>\n";
      $pourcentage = int(1000*$user_nbpage{$user,$page}/$user_access{$user})/10;
      $pourcentageint = int($pourcentage);
      print FOUT "<TD CLASS=\"left\">";
      print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
      print FOUT "$pourcentage&nbsp;%</TD>\n";
      print FOUT "</TR>\n";
      last if ($count == $tmp10);
  }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n";
  print FOUT "</BODY></HTML>\n";

  undef %temp;

}

sub UsersTab {
  local(*FOUT,*L,$I,$topten,$display_all,$home) = @_;
  local($count,$link,$tmplink,$tmplink2);

  if ($update_homepage == 1 && $home == 1 && $nblang == 0) {
      $scan = 0;
      if (-f "$path$dirinc$dirsep$inchomepage") {
	  open(HOSTHOME,"$path$dirinc$dirsep$inchomepage"); # || &error_exit("Error, unable to open $path$dirinc$dirsep$inchomepage");
	  while (<HOSTHOME>) {
	      chop;
	      $scan = 0 if ($_ =~ /^#/);
	      $scan = 1 if ($_ =~ /^#USERS/);
	      if ($scan == 1) {
		  next if ($_ =~ /^#/);
		  ($page,$tmp2,$tmp3) = split(/\t/);
		  $user{$page} = $tmp2;
		  $user_traffic{$page} = $tmp3;
	      }
	  }
	  close(HOSTHOME);
      }
  }

  $tmplink = "..$dirsepurl..$dirsepurl" if ($home == 0);
  $tmplink = "" if ($home == 1);

  $tmplink2 = "" if ($home == 0);	
  $tmplink2 = "$I$dirsepurl$dirlist$dirsepurl" if ($home == 1);

  $tmp10 = $nb_user;
  $tmp10 = $max_item_page if ($tmp10 > $max_item_page);

#  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<table class=\"tablesort table-autosort table-autostripe ";
  print FOUT "table-autopage:$table_big_lines_aff " if ($tmp10 > $table_big_lines_aff && $home == 0);
  print FOUT "table-stripeclass:alternate\"";
  print FOUT " id=\"page\"" if ($display_all == 1);
  print FOUT ">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Users'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Requests'}&nbsp;</TH>\n" if ($ftp_format == 0 && $mail_format == 0);
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Files'}&nbsp;</TH>\n" if ($ftp_format == 1);
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Emails'}&nbsp;</TH>\n" if ($mail_format == 1);
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n" if ($home == 0);
  if ($spam_found != 0 && $spamonly != 1) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Spam'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n" if ($home == 0);
  }
  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n" if ($home == 0);
  }
  if ($notrafic == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n"; 
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n" if ($home == 0);
  }
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Different_accesses'}&nbsp;</TH>\n" if ($home == 0);
  print FOUT "<TH class=\"table-sortable:date\">&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n" if ($home == 0);
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'coming_from'}&nbsp;</TH>\n" if ($home == 0	&& $mail_format == 0);
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";

    if ($tmp10 > $table_big_lines_aff && $home == 0 && $display_all == 1) {	

#    $tmp = int(scalar(%server)/$table_big_lines_aff);
#    if ($tmp != (scalar(%server)/$table_big_lines_aff)) {
	$tmp = int($tmp10/$table_big_lines_aff);
	if ($tmp != ($tmp10/$table_big_lines_aff)) {
	    $tmp++;
	}

    	print FOUT "<tfoot>\n";
	print FOUT "<tr>\n";
	print FOUT "<TH>$L{'Users'}</TH>\n";
	print FOUT "<TH>$L{'Requests'}</TH>\n" if ($ftp_format == 0 && $mail_format == 0);
	print FOUT "<TH>&nbsp;$L{'Files'}&nbsp;</TH>\n" if ($ftp_format == 1);
	print FOUT "<TH>&nbsp;$L{'Emails'}&nbsp;</TH>\n" if ($mail_format == 1);
	print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n" if ($home == 0);
	if ($spam_found != 0 && $spamonly != 1) {
	    print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Spam'}&nbsp;</TH>\n";
	    print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n" if ($home == 0);
	}
	if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	    print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Accesses'}&nbsp;</TH>\n";
	    print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n" if ($home == 0);
	}
	if ($notrafic == 0) {
	    print FOUT "<TH>&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n";
	    print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n" if ($home == 0);
	}
	print FOUT "<TH>&nbsp;$L{'Different_accesses'}&nbsp;</TH>\n" if ($home == 0);
	print FOUT "<TH>&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n" if ($home == 0);
	print FOUT "<TH>&nbsp;$L{'coming_from'}&nbsp;</TH>\n" if ($home == 0 && $mail_format == 0);
	print FOUT "</TR>\n";

	print FOUT "<tr>\n";
	
	if ($tmp > 1) {
	    $tmp2 = 5;
	    $tmp2 += 2 if ($ftp_format == 0 && $mail_format == 0);
	    $tmp2 += 2 if ($notrafic == 0);
	    $tmp2 += 2 if ($spam_found != 0 && $spamonly != 1);
	    $tmp2++ if ($mail_format == 0);
	    print FOUT "<td colspan=$tmp2>\n";
	    print FOUT "<a href=\"#\" onclick=\"pageexample('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	    
	    for ($i=1;$i<=$tmp;$i++) {
		$iminus = $i-1;
		print FOUT "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexample($iminus); return false;\">$i</a>\n";
	    }
	    print FOUT "<a href=\"#\" onclick=\"pageexample('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	    print FOUT "<a href=\"#\" onclick=\"pageexample('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	    print FOUT "</td>\n";
	    print FOUT "</tr>\n";
	}
	print FOUT "</tfoot>\n";
    }

  print FOUT "<tbody>\n";

  $i = 0;
#  $count = 0;
      foreach $val (&reverse_sort_by_value(*user)) {
#	  $count++;
	  $pourcentage = int($user{$val}*1000/$tot_users)/10 if ($tot_users != 0); # && $ftp_format == 0);
#	  $pourcentage = int($user{$val}*1000/($reqtot-$reqdomtot))/10 if (($reqtot-$reqdomtot) != 0 && $ftp_format == 1);
	      
	  $pourcentageint = int($pourcentage);

	  print FOUT "<TR>\n";
	  print FOUT "<TD CLASS=\"left\">";
	  $tmp = $val;
	  $tmp =~ s/\\/_/g;
	  $tmp =~ s/\//_/g;

	  if ($user_access{$val} > $seuilsite && $crypt == 0) {
	      print FOUT "<A HREF=\"$tmplink2$tmp$htmlext\"";
	      print FOUT " TITLE=\"$val\"" if ($user_login{$val} ne '');
	      print FOUT ">";
	  }
	  print FOUT "<I>" if ($mail_format == 1 && $val !~ /\@/);
	  $tmp = $val;
	  $tmp = &EncryptLink($tmp) if ($crypt == 1);
	  print FOUT "$tmp" if ($user_login{$val} eq '');
#	  print FOUT "$val" if ($user_login{$val} eq '');
	  print FOUT "$user_login{$val}" if ($user_login{$val} ne '');
	  print FOUT "</I>" if ($mail_format == 1 && $val !~ /\@/);
	  print FOUT "</A>" if ($user_access{$val} > $seuilsite && $crypt == 0);
	  print FOUT "</TD>\n";
	  print FOUT "<TD CLASS=\"right\"><B>$user{$val}</B></TD>\n";
	  if ($home == 0) {
	      print FOUT "<TD CLASS=\"left\">\n";
	      print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($pourcentageint != 0);
	      print FOUT "$pourcentage %";
	      print FOUT "</TD>\n";
	  }

	  if ($spam_found != 0 && $spamonly != 1) {
	      print FOUT "<TD CLASS=\"right\"><B>";
	      print FOUT "$spam_user_ext{$val}" if ($val =~ /\@/);
	      print FOUT "$spam_user_loc{$val}" if ($val !~ /\@/);
	      print FOUT "</B></TD>\n";
	      if ($home == 0) {
		  $pourcentage2 = int($spam_user_ext{$val}*1000/$user{$val})/10 if ($val =~ /\@/);
		  $pourcentage2 = int($spam_user_loc{$val}*1000/$user{$val})/10 if ($val !~ /\@/);
		  $pourcentageint2 = int($pourcentage2);
		  print FOUT "<TD CLASS=\"left\">\n";
		  print FOUT "<IMG WIDTH=$pourcentageint2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($pourcentageint2 != 0);
		  print FOUT "$pourcentage2 %";
	      }
	      print FOUT "</TD>\n";
	  }

	  if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
	      $pourcentage = 0 if ($user_access{$val} == 0);
	      $pourcentage = int($user_access{$val}*1000/$tot_users_access)/10 if ($user_access{$val} > 0 && $ftp_format == 0 && $tot_users_access != 0);
	      $pourcentageint = int($pourcentage);
	      print FOUT "<TD CLASS=\"right\"><B>$user_access{$val}</B></TD>\n";
	      if ($home == 0) {
		  print FOUT "<TD CLASS=\"left\">\n";
		  print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">&nbsp;" if ($pourcentageint != 0);
		  print FOUT "$pourcentage %";
		  print FOUT "</TD>\n";
	      }
	  }

	  if ($notrafic == 0) {

#		  $pourcentage = 0 if ($tot_users_traffic_local == 0);
	      $tmp = $user_traffic{$val};
#	      $tmp /= (1024*1024);
	      $pourcentage = int($tmp*1000/$tot_users_traffic)/10 if ($tot_users_traffic != 0);
	      $pourcentage = 0 if ($tot_users_traffic == 0);
	      $pourcentageint = int($pourcentage);
	      
	      print FOUT "<TD CLASS=\"right\">";
	      printf FOUT "<B>%.1f</B>&nbsp;",$user_traffic{$val}/1024 if ($unit eq "$L{'Kb'}");
	      printf FOUT "<B>%.1f</B>&nbsp;",$user_traffic{$val}/(1024*1024) if ($unit eq "$L{'Mb'}");
	      printf FOUT "<B>%.1f</B>&nbsp;",$user_traffic{$val}/(1024*1024*1024) if ($unit eq "$L{'Gb'}");
	      printf FOUT "<B>%.1f</B>&nbsp;",$user_traffic{$val}/(1024*1024*1024*1024) if ($unit eq "$L{'Tb'}");
	      print FOUT "</TD>\n";

	      if ($home == 0) {
		  print FOUT "<TD CLASS=\"left\">\n";
		  print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">&nbsp;" if ($pourcentageint != 0);
		  print FOUT "$pourcentage %";
		  print FOUT "</TD>\n";
	      }
	  }
	  print FOUT "<TD CLASS=\"right\">$user_nbacc{$val}</TD>\n" if ($home == 0);
	  print FOUT "<TD CLASS=\"right\">$user_date{$val}</TD>\n" if ($home == 0);
	  if ($home == 0 && $mail_format == 0) {

	      print FOUT "<TD CLASS=\"right\">\n";

	      if ($precision > 3 && $nbpageserveur{$user_adresse{$val}} > 0) {
		  $newsite = $user_adresse{$val};
		  $newsite =~ s/[.:]/_/g;
		  $pospoint = index($user_adresse{$val},'.',0);
		  $domadresse = substr($newsite,$pospoint+1,(length($newsite)-length($pospoint)));
		  $domadresse = $newsite if ($domadresse !~ /_/);
		  
		  print FOUT "<A HREF=\"..$dirsepurl$dirsite$dirsepurl$domadresse$htmlext#$user_adresse{$val}\">" if ($newsite !~ /[0-9]+$/ && $newsite !~ /:/);
		  print FOUT "<A HREF=\"..$dirsepurl$dirsite$dirsepurl$newsite$htmlext\">" if ($newsite =~ /[0-9]+$/ || $newsite =~ /:/);
	      }
	      print FOUT "$user_adresse{$val}";
	      print FOUT "</A>" if ($precision > 3 && $nbpageserveur{$user_adresse{$val}} > 0);
	      print FOUT "</TD>\n";
	  }
	  print FOUT "</TR>\n";
	  $i++;
#	  $count++;
	  last if (($i == $topten && $display_all == 0) || ($display_all == 1 && $i == $max_item_page));
      }
      print FOUT "</tbody>\n";
      print FOUT "</TABLE>\n";

}

sub AddTest {
  local(*FOUT) = @_;
  local($i,$i2);

  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\">\n";
  print FOUT "alert(\"toto\");\n";
  print FOUT "</script>\n";

}

sub AddPieHtml {
  local(*FOUT,*L,$I,$chart_id,$info,$xmax_jqplot,$ymax_jqplot,$level) = @_;
  local($i,$i2,$tmp,$link,$linkbase);
  local($nb_idx);

  print FOUT "<DIV ID=\"tog_occur\" STYLE=\"display:inline\">";
  print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
  print FOUT "<TR><TD ALIGN=CENTER VALIGN=TOP>";
  print FOUT "<TABLE BORDER=0>";
  print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Filetype'}</TH></TR>";
  print FOUT "$line_pie";
  print FOUT "</TABLE>\n";
  print FOUT "</TD>\n";
  print FOUT "<TD ALIGN=CENTER>";
  if ($fly_set == 1) {
      print FOUT "<IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$filetype_pie\" USEMAP=\"#map_filetype_graph\" BORDER=0 ALT=\"graph\">\n";
  }
  if ($fly_set == 0) {
      print FOUT "<div id=\"";
      print FOUT "chart".$chart_id;
      print FOUT "\" ";
      print FOUT "style=\"";
      print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
      print FOUT "</div>\n";
  }

  print FOUT "<P><I>$L{'Occurence'}</I>" if ($notrafic != 0);
  print FOUT "<P><I>$L{'Occurence'}</I> - <A HREF=\"javascript:ToggleBeta('tog_traffic','tog_occur');\">$L{'Traffic'}</A>" if ($notrafic == 0 && $fly_set == 1);
  print FOUT "<P><I>$L{'Occurence'}</I> - <A HREF=\"javascript:ToggleJqplotGraph2(plot1,'tog_traffic','tog_occur');\">$L{'Traffic'}</A>" if ($notrafic == 0 && $fly_set == 0);
  print FOUT "</TD></TR></TABLE>\n";
  print FOUT "</DIV>\n";

  if ($fly_set == 1) {
      print FOUT "<MAP NAME=\"map_filetype_graph\">\n";
      $tmp = $map_filetype_pie;
      $tmp =~ s/<!-- langhome -->/$I/g;
      print FOUT "$tmp";
      print FOUT "</MAP>\n";
  }


}

sub AddJqplotHtml {
  local(*FOUT,*L,$I,$chart_id,$info,$xmax_jqplot,$ymax_jqplot,$level) = @_;
  local($i,$i2,$tmp,$link,$linkbase);
  local($nb_idx);

  # Todo Zoom (use rather an image) : only if nbdays > 10
  #print FOUT "<button class=\"button-reset\">Reset Zoom</button>\n";

    $link = '';
    $linkbase = '';
    for ($i=1;$i<=$level;$i++) {
	$link .= "..$dirsepurl";
    }
    
    $linkbase = $link;
    $level = -1 if ($ENV{'REQUEST_METHOD'} eq "GET" && $opt_w eq '' && $scriptname eq "cron-hour.pl" && $opt_n ne '');

    # From cgi
    if ($level == -1) {
	$linkbase = $link_use;
	$linkbase =~ s/$dirsepurl$dirress//;
    }

    $tmplink = "$linkbase$linkpathinit";

#  if (scalar(@listdate) < 2) {
#      @list_graph_name_jqplot = ("barchart");
#  }

  $tmp = scalar(@list_graph_name_jqplot);
  $nb_idx = scalar(@graph_to_display);

  print FOUT "<center>\n";
  print FOUT "<span id=\"$info\">&nbsp;</span>\n";

  print FOUT "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
  print FOUT "<TR>\n";
  print FOUT "<TD VALIGN=TOP>\n";
  
  print FOUT "<!-- begin_bypass_multigraph -->\n";
  print FOUT "<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=1>\n";
  for ($i=$chart_id;$i<=($chart_id+$#list_graph_name_jqplot);$i++) {
      $i2 = $i-$chart_id;
      print FOUT "<TR>";
      print FOUT "<TD ALIGN=LEFT>";
      if ($tmp > 1) {
	  print FOUT "<A HREF=\"javascript:ToggleJqplotGraph$tmp(";
	  print FOUT "plot$i,'";
	  print FOUT "TOGGLE_$i'";
	  for ($j=$chart_id;$j<=($chart_id+$#list_graph_name_jqplot);$j++) {
	      print FOUT ",'TOGGLE_$j'" if ($j != $i);
	  }
	  print FOUT ");\">";
      }
      print FOUT "<IMG SRC=\"$tmplink$homeicons$dirsepurl$list_graph_name_jqplot[$i2]$gifext\" WIDTH=20 HEIGHT=20 BORDER=0 ALT=\"$L{$list_graph_name_jqplot[$i2]}\" TITLE=\"$L{$list_graph_name_jqplot[$i2]}\">";
      print FOUT "</A>" if ($tmp > 1);
      print FOUT "</TD>\n";
      print FOUT "</TR>";
  }

#  print FOUT "<TR>\n";
#  print FOUT "<TD ALIGN=CENTER VALIGN=BOTTOM>";  

#  print FOUT "</TD>";
#  print FOUT "</TR>";
  print FOUT "</TABLE>\n";
  print FOUT "<!-- end_bypass_multigraph -->\n";
  print FOUT "</TD>\n";
  print FOUT "<TD>\n";
  for ($i=$chart_id;$i<=($chart_id+$#list_graph_name_jqplot);$i++) {
      $toggle_var = "TOGGLE_".$i;
      print FOUT "<!-- begin_bypass_multigraph -->\n"; # if ($i != ($chart_id+$default_graph_idx-1));
      print FOUT "<DIV ID=\"$toggle_var\" STYLE=\"display:";
      if ($i == ($chart_id+$default_graph_idx-1)) {
	  print FOUT "inline";
      } else {
	  print FOUT "none";
      }
      print FOUT "\">\n";

      print FOUT "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n<TR><TD>\n";
      print FOUT "<div id=\"";
      print FOUT "chart".$i;
      print FOUT "\" ";
#     print FOUT " data-height=\"300px\" data-width=\"500px\">";
      print FOUT "style=\"";
      print FOUT "height:".$ymax_jqplot."px; width:".$xmax_jqplot."px;\">";
      print FOUT "</div>\n";
      print FOUT "</TD>\n";
#      if ($xmax_jqplot != $xmax_home_jqplot && $nb_idx == 1 && scalar(@tab0) > 1) {
      if ($xmax_jqplot != $xmax_home_jqplot) {
	  print FOUT "<TD>\n";
#	  print FOUT "<div id=\"plotted_image_legend$i\" class=\"\" style=\"display: none;\">\n";
	  print FOUT "<div id=\"plotted_image_div$i\" class=\"\" style=\"display: none;\"></div>\n";
#	  print FOUT "</div>\n";
	  print FOUT "</TD>\n";
      }
      print FOUT "</TR>\n";
#    $show_line = 1 if ($xmax != $xmax_home_jqplot && $nb_idx == 1 && scalar(@tab0) > 1);
      if ($xmax_jqplot != $xmax_home_jqplot && $nb_idx == 1 && scalar(@tab0) > 1) {
	  $tmp = $i-$chart_id;
	  print FOUT "<TR><TD ALIGN=LEFT CLASS=\"item_page\">\n";
	  print FOUT "<button onclick=\"line_min($i,$tmp)\" CLASS=\"jqplot_button\">$L{'Minimum'}</button>\n";
	  print FOUT "<button onclick=\"line_max($i,$tmp)\" CLASS=\"jqplot_button\">$L{'Maximum'}</button>\n";
	  print FOUT "<button onclick=\"line_avg($i,$tmp)\" CLASS=\"jqplot_button\">$L{'Average'}</button>\n";
	  print FOUT "<button onclick=\"line_sigma($i,$tmp)\" CLASS=\"jqplot_button\">Sigma</button>\n";
	  print FOUT "<button onclick=\"line_rms($i,$tmp)\" CLASS=\"jqplot_button\">RMS</button>\n";
#	  print FOUT "</TD><TD ALIGN=RIGHT CLASS=\"item_page\">\n";
#	  print FOUT "<button id=\"show_plotted_image_btn$i\" class=\"jqplot_button\" TITLE=\"Right click on plot to save\">Export</button>\n";
	  print FOUT "</TD></TR>\n";
      }
      print FOUT "</TABLE>\n";
      print FOUT "</DIV><P>\n";

      if ($xmax_jqplot != $xmax_home_jqplot && $i == ($chart_id+$#list_graph_name_jqplot)) {
	  print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
      }
      print FOUT "<!-- end_bypass_multigraph -->\n";# if ($i != ($chart_id+$default_graph_idx-1));
  }


  print FOUT "</TD>\n";
  print FOUT "</TR>\n";
  print FOUT "</TABLE></CENTER>\n";

}


sub Users {
  local(*FOUT,*L,$I,$display_all) = @_;

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Stats'} - $L{'Users'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  &add_jqplot_js(*FOUT,2);

  print FOUT "$curvy_bottom_jss\n"; 
  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
  print FOUT "<H2>$L{'Users'}</H2><P>\n";

  &help_div(*FOUT);

  print FOUT "<P>\n";

  print FOUT "<A HREF=\"..$dirsepurl..$dirsepurl$dircsv$dirsepurl$users$csvext\" TITLE=\"Export in CSV\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>" if ($display_all == 1);
  print FOUT "<A HREF=\"..$dirsepurl..$dirsepurl$dircsv$dirsepurl$listuserscsv\" TITLE=\"Export in CSV\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV-FullList\"></A>" if ($display_all == 1);

  $tmp = $user_traffic{(&reverse_sort_by_value(*user_traffic))[0]};
  $unit = "$L{'bytes'}";
  $unit = "$L{'Kb'}" if ($tmp > 1024);
  $unit = "$L{'Mb'}" if ($tmp > (1024*1024));
  $unit = "$L{'Gb'}" if ($tmp > (1024*1024*1024));
  $unit = "$L{'Tb'}" if ($tmp > (1024*1024*1024*1024));

  if (($go_ext == 1 || $go_local == 1 && $display_all == 0) || $display_all == 1) {  

      $tmp10 = $nb_user;
      $tmp10 = $max_item_page if ($tmp10 > $max_item_page);

      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} ";
      if ($display_all == 1) {
	  print FOUT "$tmp10 ";
	  print FOUT "($L{'among'} $nb_user) " if ($tmp10 == $max_item_page);
      }
#      print FOUT "$topten $L{'Users'} :</DIV><P>\n";
      if ($show_all == 1 && $display_all == 0) {
	  print FOUT "$topten ";
	  print FOUT "(<A HREF=\"$listusers\">$L{'Full_list'}</A>)" if ($nb_user > $topten);
      }
      print FOUT "</I></DIV><P>\n";


      &UsersTab(*FOUT,*L,$I,$topten,$display_all,0);
  }

  if ($display_all == 0) {

      print FOUT "<P>\n";

      if ($fly_set == 0) {
	  $chart_id = 0;
	  $info = "info".$chart_id;
	  $i = &Load_DailyData($datafile,$dirdata);
	  
	  $xlegend = "$i $L{'days'}";
	  $xlegend .= " (starting $start_date)";
	  $ylegend = $L{'Users'};
	  
	  undef @ref_tab;
	  push(@ref_tab,\@tabreq) if ($mail_format == 0);
	  push(@ref_tab,\@tabacc);
	  push(@ref_tab,\@tabmm);
	  push(@ref_tab,\@tabdoc);
	  push(@ref_tab,\@tabscript);
	  push(@ref_tab,\@tabuser);
	  push(@ref_tab,\@tabtrafic);
	  
	  @ref_tab_name = ('requests','accesses','hosts','documents2','scripts','users','traffic') if ($mail_format == 0);
	  @ref_tab_name = ('accesses','hosts','documents2','scripts','users','traffic') if ($mail_format == 1);

	  &MakeDailyGraphJqplotInit(*FOUT, eval($Lang{$lang[$nblang]}),$I,1,$unit_div,\@ref_tab,\@ref_tab_name,\@listdate,$chart_id);
	  
	  @graph_to_display = ('Users');
	  
	  undef @ref_tab;
	  push(@ref_tab,\@tabuser);
	  
	  &MakeDailyGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,1,\@graph_to_display,\@ref_tab,\@listdate,\@serie_color,1,$unit,$chart_id,3,"users",$info,0,$xlegend,$ylegend,$xmax_jqplot,$users);

	  &AddJqplotHtml(*FOUT, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_jqplot,$ymax_jqplot,2);

	  $chart_id += $#list_graph_name_jqplot+1;
      }

      if ($fly_set == 1) {
	  $file_page_page = "users-home";
	  print FOUT "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
	  print FOUT "<TR>\n";
	  $tmp = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$file_page_page."y".$gifext;
	  print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"y\"></TD>\n";
	  $tmp = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$file_page_page.$gifext;
	  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"graph\" USEMAP=\"#map_page_graph\" BORDER=0></TD>\n";
	  print FOUT "</TR><TR><TD></TD>\n";
	  $tmp = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$file_page_page."x".$gifext;
	  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$tmp\" ALT=\"x\"></TD>\n";
	  print FOUT "</TR>\n";
	  print FOUT "</TABLE></CENTER>\n";
	  print FOUT "<MAP NAME=\"map_page_graph\">";
	  $tmp = $map_page_graph;
	  $tmp =~ s/<!-- langhome -->/$I/g;
	  print FOUT "$tmp";
#  print FOUT "$map_page_graph";
	  print FOUT "</MAP>\n";
      }

      print FOUT "<P>";
  }

  if ($linkpath_url ne '' && $display_all == 0) {
      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'Search'}</I> :</DIV><P>\n";

      $datafileinc = $linkpath_url.$dirinc.$dirsepurl.$incftp.$txtext;
      $string_title = "$L{'Search'}:$L{'Search_on'}:$L{'No_item_found'}:$L{'Processing'}";
      $string_th = "$L{'Users'}:";
      $string_th .= "$L{'Requests'}:" if ($ftp_format == 0 && $mail_format == 0);
      $string_th .= "$L{'Files'}:" if ($ftp_format == 1);
      $string_th .= "$L{'Emails'}:" if ($mail_format == 1);
#      $string_th .= "$L{'Accesses'}:" if ($squid_format == 1);
#      $string_th .= "$L{'Traffic'}:$L{'Mb'}:$L{'Hosts'}:$L{'Date'}:$L{'Last_occurence'}";
      $string_th .= "$L{'Traffic'}:$L{'Mb'}:$L{'Hosts'}:$L{'Last_occurence'}";
      $string_th .= ":$L{'Different_accesses'}";
      print FOUT "<FORM method=\"POST\" name=\"ajax\" action=\"javascript:SearchVirtual()\">\n";
      print FOUT "<TABLE BORDER=0><TR>\n";
      print FOUT "<TD VALIGN=MIDDLE>";
#      print FOUT "<TD VALIGN=MIDDLE onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$L{'Title_search_users'}','$L{'Line_search_users'}','$L{'Desc_search_users'}','$L{'Link_search_users'}',0,'','$help_width')\">";
      print FOUT "<INPUT type=\"hidden\" name=\"precision\" value=\"$precision\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"notrafic\"  value=\"$notrafic\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"seuilsite\" value=\"$seuilsite\">\n";
#  print FOUT "<INPUT type=\"hidden\" name=\"seuil_auto\" value=\"$seuil_auto\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"datafile\" value=\"$datafileinc\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"stats\" value=\"users\">\n";
#  print FOUT "<INPUT type=\"hidden\" name=\"datafile_local\" value=\"$datafileinc_local\">\n" if ($locallog != 0 && $locserver != 0);
      print FOUT "<INPUT type=\"hidden\" name=\"string_th\"  value=\"$string_th\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"string_title\"  value=\"$string_title\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"index_hit\"  value=\"1\">\n";
      print FOUT "<INPUT type=\"hidden\" name=\"string_sep\"  value=\"\t\">\n";

      print FOUT "<TABLE BORDER=0><TR>\n";
      print FOUT "<TH ALIGN=CENTER onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$L{'Title_search_users'}','$L{'Line_search_users'}','$L{'Desc_search_users'}','$L{'Link_search_users'}',0,'','$help_width')\">";
      print FOUT "$L{'Search'}</TH>\n";
      print FOUT "</TR><TR>\n";
      print FOUT "<TD>";
#      print FOUT "<INPUT type=\"text\" id=\"txtSearch\" name=\"search_value\"  value=\"\" onkeyup=\"searchSuggest();\" autocomplete=\"off\" OnFocus=\"javascript:clean()\">\n";
      print FOUT "<INPUT type=\"text\" id=\"txtSearch\" name=\"search_value\"  value=\"\" onkeyup=\"searchSuggest();\" OnBlur=\"javascript:clean_focus()\" OnFocus=\"javascript:clean()\">\n";
      print FOUT "<div id=\"search_suggest\"></div>\n";
      print FOUT "</TR></TABLE>\n";
      print FOUT "</TD><TD VALIGN=TOP>";

      print FOUT "<TABLE BORDER=0><TR>\n";
      print FOUT "<TH COLSPAN=2 ALIGN=CENTER>$L{'Requests'}</TH>\n";
      print FOUT "</TR><TR>\n";
      print FOUT "<TD>$L{'Threshold'}</TD><TD><INPUT type=\"text\" size=\"3\" name=\"search_threshold\"  value=\"$seuilsite\"></TD>\n";
      print FOUT "</TR></TABLE>\n";
      print FOUT "</TD><TD VALIGN=MIDDLE>";
      print FOUT "<INPUT type=\"submit\" name=\"search_button\"  class=\"submit_button\" value=\"$L{'Search'}\">\n";
      print FOUT "</TD></TR></TABLE>";
      print FOUT "</FORM><P>\n";
      
      print FOUT "<DIV ID=\"search_header\"></DIV>\n";
      print FOUT "<DIV ID=\"search_results\"></DIV>\n";
      print FOUT "<BR><P>\n";
  }

  $tmp = $user_traffic{(&reverse_sort_by_value(*user_traffic))[0]};
  $unit = "$L{'bytes'}";
  $unitsize = 1;
  if ($tmp > 1024) {
      $unit = "$L{'Kb'}";
      $unitsize = 1024;
  }
  if ($tmp > (1024*1024)) {
      $unit = "$L{'Mb'}";
      $unitsize = 1024*1024;
  }
  if ($tmp > (1024*1024*1024)) {
      $unit = "$L{'Gb'}";
      $unitsize = 1024*1024*1024;
  }
  if ($tmp > (1024*1024*1024*1024)) {
      $unit = "$L{'Tb'}";
      $unitsize = 1024*1024*1024*1024;
  }

  # decrease one magnitude for a nicer display
  if (int($tmp/$unitsize) < 10) {
      $unitsize /= 1024;
      $unit = "$L{'bytes'}" if ($unit eq "$L{'Kb'}");
      $unit = "$L{'Kb'}" if ($unit eq "$L{'Mb'}");
      $unit = "$L{'Mb'}" if ($unit eq "$L{'Gb'}");
      $unit = "$L{'Gb'}" if ($unit eq "$L{'Tb'}");
  }


  if ($go_ext == 1 && $display_all == 0) {

      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'Users'}&nbsp;($L{'external'})</I> :</DIV><P>\n";
      print FOUT "<I>($L{'Only_users'} $L{'with_at_least'} $seuilpage $L{'requests'} $L{'are_shown'})</I><P>\n" if ($seuilpage > 0);

      print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
      print FOUT "<thead>\n";
      print FOUT "<TR>\n";
      print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Users'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Requests'}&nbsp;</TH>\n" if ($ftp_format == 0 && $mail_format == 0);
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Files'}&nbsp;</TH>\n" if ($ftp_format == 1);

      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Emails'}&nbsp;</TH>\n" if ($mail_format == 1);
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      if ($spamonly != 1 && $spam_found != 0) {
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Spam'}&nbsp;</TH>\n";
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      }
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Accesses'}&nbsp;</TH><TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n" if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);
      if ($notrafic == 0) {
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n";
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      }
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Different_accesses'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:date\">&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'coming_from'}&nbsp;</TH>\n" if ($mail_format == 0);
      print FOUT "</TR>\n";
      print FOUT "</thead>\n";
      print FOUT "<tbody>\n";

      $i = 0;
      foreach $val (&reverse_sort_by_value(*user)) {
#      $go_local = 1 if ($user_adresse{$val} =~ /$localdomaine/ && $user{$val} > $seuilpage);
	  if ($user{$val} > $seuilpage && $user_adresse{$val} !~ /$localdomaine/) {
#	  $pourcentage = int($user{$val}*1000/$access)/10 if ($ftp_format == 0);
	      $pourcentage = int($user{$val}*1000/$tot_users_ext)/10; # if ($ftp_format == 0);
##	      $pourcentage = int($user{$val}*1000/$tot_users)/10 if ($ftp_format == 0);
#	      $pourcentage = int($user{$val}*1000/($reqtot-$reqdomtot))/10 if ($ftp_format == 1);

	      $pourcentageint = int($pourcentage);

	      print FOUT "<TR>\n";
	      print FOUT "<TD CLASS=\"left\">";
	      $tmp = $val;
	      $tmp =~ s/\\/_/g;
	      $tmp =~ s/\//_/g;
	      if ($user_access{$val} > $seuilsite && $crypt == 0) {
		  print FOUT "<A HREF=\"$tmp$htmlext\"";
		  print FOUT " TITLE=\"$val\"" if ($user_login{$val} ne '');
		  print FOUT ">";
	      }
	      $tmp = $val;
	      $tmp = &EncryptLink($tmp) if ($crypt == 1);
#	      print FOUT "$val" if ($user_login{$val} eq '');
	      print FOUT "$tmp" if ($user_login{$val} eq '');
	      print FOUT "$user_login{$val}" if ($user_login{$val} ne '');
	      print FOUT "</A>" if ($user_access{$val} > $seuilsite && $crypt == 0);
	      print FOUT "</TD>\n";
	      print FOUT "<TD CLASS=\"right\"><B>$user{$val}</B></TD>\n";
	      print FOUT "<TD CLASS=\"left\">\n";
	      print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($pourcentageint != 0);
	      print FOUT "$pourcentage %";
	      print FOUT "</TD>\n";

	      if ($spam_found != 0 && $spamonly != 1) {
#		  $spam_user_ext{$val} = 0 if ($spam_user_ext{$val} eq '');
		  $pourcentage2 = int($spam_user_ext{$val}*1000/$user{$val})/10;
		  $pourcentageint2 = int($pourcentage2);
		  print FOUT "<TD CLASS=\"right\"><B>$spam_user_ext{$val}</B></TD>\n";
		  print FOUT "<TD CLASS=\"left\">\n";
		  print FOUT "<IMG WIDTH=$pourcentageint2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($pourcentageint2 != 0);
		  print FOUT "$pourcentage2 %";
		  print FOUT "</TD>\n";
	      }

	      if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
		  $pourcentage = 0 if ($user_access{$val} == 0);
		  $pourcentage = int($user_access{$val}*1000/$tot_users_access_ext)/10 if ($tot_users_access_ext != 0);
#	      $pourcentage = int($user_access{$val}*1000/($access-$accessdom))/10 if ($ftp_format == 1);
	      
		  $pourcentageint = int($pourcentage);
		  print FOUT "<TD CLASS=\"right\"><B>$user_access{$val}</B></TD>\n";
		  print FOUT "<TD CLASS=\"left\">\n";
		  print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">&nbsp;" if ($pourcentageint != 0);
		  print FOUT "$pourcentage %";
		  print FOUT "</TD>\n";
	      }

	      if ($notrafic == 0) {
		  $tmp = $user_traffic{$val};
#	  $pourcentage = int($tmp*1000/$totsize)/10;
		  $pourcentage = int($tmp*1000/$tot_users_traffic_ext)/10 if ($tot_users_traffic != 0);
		  $pourcentage = 0 if ($tot_users_traffic == 0);
		  $pourcentageint = int($pourcentage);
	      
		  print FOUT "<TD CLASS=\"right\">";
		  printf FOUT "<B>%.1f</B>&nbsp;",$user_traffic{$val}/1024 if ($unit eq "$L{'Kb'}");
		  printf FOUT "<B>%.1f</B>&nbsp;",$user_traffic{$val}/(1024*1024) if ($unit eq "$L{'Mb'}");
		  printf FOUT "<B>%.1f</B>&nbsp;",$user_traffic{$val}/(1024*1024*1024) if ($unit eq "$L{'Gb'}");
		  printf FOUT "<B>%.1f</B>&nbsp;",$user_traffic{$val}/(1024*1024*1024*1024) if ($unit eq "$L{'Tb'}");
		  print FOUT "</TD>\n";
		  print FOUT "<TD CLASS=\"left\">\n";
		  print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">&nbsp;" if ($pourcentageint != 0);
		  print FOUT "$pourcentage %";
		  print FOUT "</TD>\n";
	      }
	      print FOUT "<TD CLASS=\"right\">$user_nbacc{$val}</TD>\n";
	      print FOUT "<TD CLASS=\"right\">$user_date{$val}</TD>\n";

	      if ($mail_format == 0) {
		  print FOUT "<TD CLASS=\"right\">";
		  if ($precision > 3 && $nbpageserveur{$user_adresse{$val}} > 0) {
		      $newsite = $user_adresse{$val};
		      $newsite =~ s/[.:]/_/g;
		      $pospoint = index($user_adresse{$val},'.',0);
		      $domadresse = substr($newsite,$pospoint+1,(length($newsite)-length($pospoint)));
		      $domadresse = $newsite if ($domadresse !~ /_/);
		      
		      print FOUT "<A HREF=\"..$dirsepurl$dirsite$dirsepurl$domadresse$htmlext#$user_adresse{$val}\">" if ($newsite !~ /[0-9]+$/ && $newsite !~ /:/);
		      print FOUT "<A HREF=\"..$dirsepurl$dirsite$dirsepurl$newsite$htmlext\">" if ($newsite =~ /[0-9]+$/ || $newsite =~ /:/);
		  }
		  print FOUT "$user_adresse{$val}";;
		  print FOUT "</A>" if ($precision > 3 && $nbpageserveur{$user_adresse{$val}} > 0);
		  print FOUT "</TD>\n";
	      }
	      print FOUT "</TR>\n";
	      $i++;
	      last if ($i == $topten && $display_all == 0);
	  }
      }
      print FOUT "</tbody>\n";
      print FOUT "</TABLE><P>\n";
  }

  if ($locallog != 0 && $locserver != 0 && $go_local == 1 && $display_all == 0) {

      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'Users'}&nbsp;($L{'local'})</I> :</DIV><P>\n";
      print FOUT "<I>($L{'Only_users'} $L{'with_at_least'} $seuilpage $L{'requests'} $L{'are_shown'})</I><P>\n" if ($seuilpage > 0);

      print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
      print FOUT "<thead>\n";
      print FOUT "<TR>\n";
      print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Users'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Requests'}&nbsp;</TH>\n" if ($ftp_format == 0 && $mail_format == 0);
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Files'}&nbsp;</TH>\n" if ($ftp_format == 1);
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Emails'}&nbsp;</TH>\n" if ($mail_format == 1);
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n"; # if ($ftp_format == 1 || $mail_format == 1);
      if ($spamonly != 1 && $spam_found != 0) {
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Spam'}&nbsp;</TH>\n";
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      }
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Accesses'}&nbsp;</TH><TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n" if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0);

      if ($notrafic == 0) {
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n";
	  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      }
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Different_accesses'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:date\">&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'coming_from'}&nbsp;</TH>\n" if ($mail_format == 0);
      print FOUT "</TR>\n";
      print FOUT "</thead>\n";
      print FOUT "<tbody>\n";

      $i = 0;
      foreach $val (&reverse_sort_by_value(*user)) {
	  if ($user{$val} > $seuilpage && $user_adresse{$val} =~ /$localdomaine/) {
##	  $pourcentage = int($user{$val}*1000/$access)/10 if ($ftp_format == 0);
#	      $pourcentage = int($user{$val}*1000/($reqtot-$reqdomtot))/10 if ($ftp_format == 1);
	      $pourcentage = int($user{$val}*1000/$tot_users_local)/10; # if ($ftp_format == 0);

	      $pourcentageint = int($pourcentage);

	      print FOUT "<TR>\n";
	      print FOUT "<TD CLASS=\"left\">";
	      $tmp = $val;
	      $tmp =~ s/\\/_/g;
	      if ($user_access{$val} > $seuilsite && $crypt == 0) {
		  print FOUT "<A HREF=\"$tmp$htmlext\"";
		  print FOUT " TITLE=\"$val\"" if ($user_login{$val} ne '');
		  print FOUT ">";
	      }
	      $tmp = $val;
	      $tmp = &EncryptLink($tmp) if ($crypt == 1);
	      print FOUT "$tmp" if ($user_login{$val} eq '');
	      print FOUT "$user_login{$val}" if ($user_login{$val} ne '');
	      print FOUT "</A>" if ($user_access{$val} > $seuilsite && $crypt == 0);
	      print FOUT "</TD>\n";
	      print FOUT "<TD CLASS=\"right\"><B>$user{$val}</B></TD>\n";
	      print FOUT "<TD CLASS=\"left\">\n";
	      print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($pourcentageint != 0);
	      print FOUT "$pourcentage %";
	      print FOUT "</TD>\n";

	      if ($spam_found != 0 && $spamonly != 1) {
#		  $spam_user_loc{$val} = 0 if ($spam_user_loc{$val} eq '');
		  $pourcentage2 = int($spam_user_loc{$val}*1000/$user{$val})/10;
		  $pourcentageint2 = int($pourcentage2);
		  print FOUT "<TD CLASS=\"right\"><B>$spam_user_loc{$val}</B></TD>\n";
		  print FOUT "<TD CLASS=\"left\">\n";
		  print FOUT "<IMG WIDTH=$pourcentageint2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($pourcentageint2 != 0);
		  print FOUT "$pourcentage2 %";
		  print FOUT "</TD>\n";
	      }
	      if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
		  $pourcentage = 0 if ($user_access{$val} == 0);
		  $pourcentage = int($user_access{$val}*1000/$tot_users_access_local)/10;
#	      $pourcentage = int($user_access{$val}*1000/($access-$accessdom))/10 if ($ftp_format == 1);
	      
		  $pourcentageint = int($pourcentage);
		  print FOUT "<TD CLASS=\"right\"><B>$user_access{$val}</B></TD>\n";
		  print FOUT "<TD CLASS=\"left\">\n";
		  print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">&nbsp;" if ($pourcentageint != 0);
		  print FOUT "$pourcentage %";
		  print FOUT "</TD>\n";
	      }

	      if ($notrafic == 0) {
		  $tmp = $user_traffic{$val};
		  $pourcentage = int($tmp*1000/$tot_users_traffic_local)/10 if ($tot_users_traffic != 0);
		  $pourcentage = 0 if ($tot_users_traffic == 0);
#	  $pourcentage = int($tmp*1000/$totsize)/10;
		  $pourcentageint = int($pourcentage);

		  print FOUT "<TD CLASS=\"right\">";
		  printf FOUT "<B>%.1f</B>&nbsp;",$user_traffic{$val}/1024 if ($unit eq "$L{'Kb'}");
		  printf FOUT "<B>%.1f</B>&nbsp;",$user_traffic{$val}/(1024*1024) if ($unit eq "$L{'Mb'}");
		  printf FOUT "<B>%.1f</B>&nbsp;",$user_traffic{$val}/(1024*1024*1024) if ($unit eq "$L{'Gb'}");
		  printf FOUT "<B>%.1f</B>&nbsp;",$user_traffic{$val}/(1024*1024*1024*1024) if ($unit eq "$L{'Tb'}");
		  print FOUT "</TD>\n";
		  print FOUT "<TD CLASS=\"left\">\n";
		  print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" ALT=\"$gcolor[3]\">&nbsp;" if ($pourcentageint != 0);
		  print FOUT "$pourcentage %";
		  print FOUT "</TD>\n";
	      }
	      print FOUT "<TD CLASS=\"right\">$user_nbacc{$val}</TD>\n";
	      print FOUT "<TD CLASS=\"right\">$user_date{$val}</TD>\n";

	      if ($mail_format == 0) {
		  print FOUT "<TD CLASS=\"right\">";

		  if ($precision > 3 && $nbpageserveur{$user_adresse{$val}} > 0) {
		      $newsite = $user_adresse{$val};
		      $newsite =~ s/[.:]/_/g;
		      $pospoint = index($user_adresse{$val},'.',0);
		      $domadresse = substr($newsite,$pospoint+1,(length($newsite)-length($pospoint)));
		      $domadresse = $newsite if ($domadresse !~ /_/);
		      
		      print FOUT "<A HREF=\"..$dirsepurl$dirsite$dirsepurl$domadresse$htmlext#$user_adresse{$val}\">" if ($newsite !~ /[0-9]+$/ && $newsite !~ /:/);
		      print FOUT "<A HREF=\"..$dirsepurl$dirsite$dirsepurl$newsite$htmlext\">" if ($newsite =~ /[0-9]+$/ || $newsite =~ /:/);
		  }
		  print FOUT "$user_adresse{$val}";
		  print FOUT "</A>" if ($precision > 3 && $nbpageserveur{$user_adresse{$val}} > 0);
		  print FOUT "</TD>\n";
	      }
	      print FOUT "</TR>\n";
	      $i++;
	      last if ($i == $topten && $display_all == 0);
	  }
      }
      print FOUT "</tbody>\n";
      print FOUT "</TABLE>\n";
  }


  print FOUT "</BODY></HTML>\n";
}


#
##############################################################
### Virus
##############################################################
#

sub PagesVirus {
  local(*FOUT,*L,$I) = @_;

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Stats'} - $L{'Virus'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);  
  print FOUT "<H2> $L{'ListOf'} $nb_virus $L{'virus'}</H2><P>\n";
  print FOUT "<P>\n";

  print FOUT "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
  print FOUT "<TR>\n";
  print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linkgraphvirusy\" ALT=\"y\"></TD>\n";
  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"$linkgraphvirus\" ALT=\"graph\" BORDER=0 USEMAP=\"#virus\"></TD>\n";
  print FOUT "</TR><TR><TD></TD>\n";
  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linkgraphvirusx\" ALT=\"x\"></TD>\n";
  print FOUT "</TR>\n";
#  print FOUT "</TABLE><P>\n";

  print FOUT "<TR><TD></TD>\n";
  print FOUT "<TD>\n";

  print FOUT "<TABLE>\n";
  for ($i=$#list_virus;$i>=0;$i--) {
      $j = $i % ($#gcolor);
      $couleur = $gcolor[$j];
      if ($count_virus[$i] != 0) {
	  print FOUT "<TR><TD><IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$couleur\" ALT=\"$couleur\"></TD>\n";
	  print FOUT "<TD>&nbsp; $L{'virus'} : <B>";
	  print FOUT "$list_virus[$i]";
	  print FOUT "</B></TD></TR>\n";
      }
  }
  print FOUT "</TABLE>\n";

  print FOUT "</TD></TR>\n";        
  print FOUT "</TABLE><P>\n";


  print FOUT "<p>\n<table class=\"tablesort table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Virus'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:date\">&nbsp;$L{'Last_try'}&nbsp;</TH>\n";
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";

#  print FOUT "<TABLE>\n";
#  print FOUT "<TR><TH>&nbsp;$L{'Virus'}&nbsp;</TH><TH>&nbsp;$L{'Percentage'}&nbsp;</TH><TH>&nbsp;$L{'Occurence'}&nbsp;</TH><TH>&nbsp;$L{'Last_try'}&nbsp;</TH></TR>\n";

  for ($i=0;$i<=$#list_virus;$i++) {

      if ($count_virus[$i] != 0) {

	  $pourcentage = (($count_virus[$i]*1000)/$tot_virus)/10;
	  $pourcentageint = int($pourcentage);
	  ($tmp1) = split(/:/,$virus_date[$i]);
	  
	  print FOUT "<TR><TH BGCOLOR=\"#D0D0D0\">$list_virus[$i]</TH>\n";
	  print FOUT "<TH BGCOLOR=\"#D0D0D0\">$count_virus[$i]</TH>\n";
	  print FOUT "<TH BGCOLOR=\"#D0D0D0\" CLASS=\"left\">";
	  print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"> " if ($pourcentageint != 0);
	  printf FOUT "%.1f %",$pourcentage;
	  print FOUT "</TH>\n";

	  print FOUT "<TH BGCOLOR=\"#D0D0D0\">$tmp1</TH></TR>\n";
	  
	  for ($j=0;$j<$nb[$i];$j++) {
	      $adresse = $virusdate{$i,$j};
	      $pourcentage = (($virus_site{$i,$adresse}*1000)/$count_virus[$i])/10;
	      $pourcentageint = int($pourcentage);
	      ($tmp2) = split(/:/,$virus_date{$i,$adresse});
	      print FOUT "<TR>";
	      print FOUT "<TD>$adresse</TD>\n";
	      print FOUT "<TD CLASS=\"right\">$virus_site{$i,$adresse}</TD>\n";
	      print FOUT "<TD>\n";
	      print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"> " if ($pourcentageint != 0);
	      printf FOUT "%.1f %",$pourcentage;
	      print FOUT "</TD>\n";
	      print FOUT "<TD CLASS=\"right\">";
	      print FOUT "<I>" if ($tmp2 eq $tmp1);
	      print FOUT "$virus_date{$i,$adresse}";
	      print FOUT "</I>" if ($tmp2 eq $tmp1);
	      print FOUT "</TD>\n";
	      print FOUT "</TR>";
	  }
      }
  }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE></CENTER>\n";

# USEMAP Day1

  $num = 1;
  ($jour, $monthletter,$year) = split(/ /,$pasttoday);
  
  $month = $month_equiv{$monthletter};

  print FOUT "<MAP NAME=\"virus\">\n";
  open(FLY,"$path$dirtmp$dirsep$vtmp$dirtmp");
  while (<FLY>) {
      
      chop;
      $tmp = $_;
      ($x1,$x2,$tmp) = split(/[ ,]/);
      
      if ($jour > $month_of_year{$monthletter}) {
	  $month++;
	  $year++ if ($month == 13);
	  $month = 1 if ($month == 13);
	  $jour = "1" if ($struct_compressed_logfile =~ /\%smallday/);
	  $jour = "01" if ($struct_compressed_logfile !~ /\%smallday/);
      }
      $jour = "0".$jour if (length($jour) == 1 && $struct_compressed_logfile !~ /\%smallday/);
      $month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
      $monthletter = $month_nb[$month-1];
      
      if ($tmp != $ymax) {	
	  $linkvirus = "..".$dirsepurl.$dirdate.$dirsepurl.$year."-".$monthletter."-".$jour.$dirsepurl.$filevirus;
	  $fullvirus = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$year."-".$monthletter."-".$jour.$dirsep.$filevirus;
	  
	  print FOUT "<AREA SHAPE=\"rect\" COORDS=\"$x1,0,$x2,$ymax\" HREF=\"$linkvirus\">\n" if (-e $fullvirus);
	  
      }
#    $num++;
      $jour++;
  }

  print FOUT "</MAP>\n";
  print FOUT "<P></BODY></HTML>\n";
}

#
##############################################################
### Agent
##############################################################
#

sub AgentDay {
  local(*FOUT,*L,$I,$display_all) = @_;
  local($tmp);

  $tmpa = $dirresume;
  $tmpa = $oldjour if ($scriptname eq "cron-pages.pl");
  $tmpa = $yesterday if ($scriptname eq "cron-inc.pl");
  $tmpa =~ s/\/\-/ /g;
  $tmpa =~ s/\_/ \/ /g;

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Browser'} - $tmpa</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - cron-agent.pl $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,3);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd2 TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,3);

#  print FOUT "<TABLE WIDTH=\"100%\"><TR><TD VALIGN=TOP>\n";
  
  &PageResumeMenu(*FOUT, $link_next, eval($Lang{$lang[$nblang]}));

  print FOUT "<H3>$L{'Browsers_used'}</H3><P>\n";  
  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'most_succf_browsers1'} $topten $L{'most_succf_browsers2'} ($L{'among'} $unique_new_browserday)</DIV><P>\n";

  print FOUT "<p>\n<table class=\"tablesort table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\" COLSPAN=2>&nbsp;$L{'Browser'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";

#  print FOUT "<TABLE>\n";
#  print FOUT "<TR><TH COLSPAN=2>&nbsp;$L{'Browser'}&nbsp;</TH><TH>&nbsp;$L{'Occurence'}&nbsp;</TH><TH>&nbsp;$L{'Percentage'}&nbsp;</TH></TR>\n";

  $boucleagentday = $unique_new_browserday if ($unique_new_browserday < $topten);
  $boucleagentday = $topten if ($unique_new_browserday > $topten);

#  foreach $browser (&reverse_sort_by_value(*new_browserday)) {

#for ($i=0;$i<$topten;$i++) {
  for ($i=0;$i<$boucleagentday;$i++) {
      last if ($i == $unique_new_browserday);
#for ($i=0;$i<$unique_new_browserday;$i++) {

#      $pourcentage = ($new_browserday{$browser}*100)/$countday if ($countday != 0);
      $pourcentage = ($occurbrowserday[$i]*100)/$countday if ($countday != 0);
      $intpourcentage = int($pourcentage);
      
#      $tmp_browser = $new_browserday{$browser};
      $tmp_browser = $bestbrowserday[$i];
      $tmp_browser = "Mozilla" if ($tmp_browser =~ /Gecko/i);
      ($tmp) = split(/\s+/,$tmp_browser);

      $tmp = "Unknown" if ($tmp_browser =~ /unknown/g);
      $tmp =~ tr/[A-Z]/[a-z]/;
      $tmp = "Unknown" if (!(-f "$pathinit$dirress$dirsepurl$diros$dirsepurl$tmp$gifext"));

      print FOUT "<TR>\n";
      print FOUT "<TD CLASS=\"head\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$diros$dirsepurl$tmp$gifext\" WIDTH=\"14\" HEIGHT=\"14\" ALT=\"icon\"></TD>\n";
      print FOUT "<TD CLASS=\"head_left\">&nbsp;$tmp_browser</TD>\n";
      print FOUT "<TD CLASS=\"head\">$occurbrowserday[$i] $L{'times'}</TD>\n";
      print FOUT "<TD CLASS=\"head_left\">";
      print FOUT "<IMG WIDTH=\"$intpourcentage\" HEIGHT=\"$square\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">" if ($intpourcentage != 0);
      print FOUT " ";
      printf FOUT "%.1f",$pourcentage;
      print FOUT "&nbsp;%</TD>\n</TR>\n";

      $tmp = 0;
      for ($l=$browser_version_nbday{$bestbrowserday[$i]};$l>0;$l--) {
	  if ($browser_versionday{$bestbrowserday[$i],$l} ne '') {
	      $tmp++;
	  }
      }

      $tmp2 = 0;
      for ($l=$browser_version_nbday{$bestbrowserday[$i]};$l>0;$l--) {
	  if ($browser_versionday{$bestbrowserday[$i],$l} ne '') {
#      for ($l=$browser_version_nbday{$new_browserday{$browser}};$l>0;$l--) {
#	  if ($browser_versionday{$new_browserday{$browser},$l} ne '') {
	      $tmp2++;
	      print FOUT "<TR>";
	      print FOUT "<TD ROWSPAN=$tmp>&nbsp;</TD>\n" if ($l == $browser_version_nbday{$bestbrowserday[$i]});
#	      print FOUT "<TD ROWSPAN=$tmp>&nbsp;</TD>\n" if ($l == $browser_version_nbday{$new_browserday{$browser}});
	      print FOUT "<TD";
	      print FOUT " CLASS=\"left_alter\"" if (($tmp2/2) != int($tmp2/2));
	      print FOUT ">$tmp_browser $l</TD>\n";
	      print FOUT "<TD";
	      print FOUT " CLASS=\"right_alter\"" if (($tmp2/2) != int($tmp2/2));
	      print FOUT " CLASS=\"right\"" if (($tmp2/2) == int($tmp2/2));
	      print FOUT ">$browser_versionday{$bestbrowserday[$i],$l}</TD>\n";
#	      print FOUT "><B>$browser_versionday{$new_browserday{$browser},$l}</B> $L{'times'}</TD>\n";
	      print FOUT "<TD";
	      print FOUT " CLASS=\"left_alter\"" if (($tmp2/2) != int($tmp2/2));
	      print FOUT " CLASS=\"left\"" if (($tmp2/2) == int($tmp2/2));
	      print FOUT ">";
	      $pourcentage = ($browser_versionday{$bestbrowserday[$i],$l}*100)/$occurbrowserday[$i];
#	      $pourcentage = ($browser_versionday{$new_browserday{$browser},$l}*100)/$occurbrowserday[$i];
	      $intpourcentage = int($pourcentage);
	      print FOUT "<img width=$intpourcentage height=$square src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">" if ($intpourcentage != 0);
#	      print FOUT " ";
	      printf FOUT "&nbsp;%.1f",$pourcentage;
	      print FOUT "&nbsp;%</TD>\n</TR>\n";
	  }
      }
  }

#
  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n";

  print FOUT "<P><BR>\n"; 

  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'OS_used1'} $topten $L{'OS_used2'} ($L{'among'} $unique_new_osday)</DIV><p>\n";

  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\" COLSPAN=2>&nbsp;$L{'OS'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";

#  print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"osday\">\n";
#  print FOUT "<TR><TH COLSPAN=2>&nbsp;$L{'OS'}&nbsp;</TH><TH>&nbsp;$L{'Occurence'}&nbsp;</TH><TH>&nbsp;$L{'Percentage'}&nbsp;</TH></TR>\n";

  $i = 0;
  foreach $os (&reverse_sort_by_value(*new_osday)) {
      if ($display_all == 0 || ($display_all == 1 && $new_osday{$os} > $seuilpage)) {

	  $pourcentage = ($new_osday{$os}*100)/$countday if ($countday != 0);
	  $intpourcentage = int($pourcentage);

	  ($tmp) = split(/\s+/,$os);
	  $tmp = "Unknown" if ($os =~ /unknown/g);
	  $tmp =~ tr/[A-Z]/[a-z]/;
	  $tmp = "Unknown" if (!(-f "$pathinit$dirress$dirsepurl$diros$dirsepurl$tmp$gifext"));

	  print FOUT "<TR>\n";
	  print FOUT "<TD><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$diros$dirsepurl$tmp$gifext\" WIDTH=\"14\" HEIGHT=\"14\" ALT=\"$os\"></TD>\n";
	  print FOUT "<TD CLASS=\"left\">$os</TD>\n";
	  print FOUT "<TD CLASS=\"right\">$new_osday{$os} </TD>\n";
	  print FOUT "<TD CLASS=\"left\">";
	  print FOUT "<IMG WIDTH=\"$intpourcentage\" HEIGHT=\"$square\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">" if ($intpourcentage != 0);
#	  print FOUT "";
	  printf FOUT "&nbsp;%.1f",$pourcentage;
	  print FOUT "&nbsp;%</TD>\n";
	  print FOUT "</TR>\n";

	  $i++;
	  last if ($i == $topten && $display_all == 0);
      }
  }

  print FOUT "</tbody>\n";
  print FOUT "</TABLE><P><BR>\n";

  print FOUT "</TD></TR></TABLE>\n";

#  print FOUT "<!-- PAGE BREAK -->\n"; # PDF break
  print FOUT "</BODY></HTML>\n";
}

#
##############################################################
### Referer
##############################################################
#

sub ReferDay {
  local(*FOUT,*L,$I,$display_all) = @_;

  $tmpa = $dirresume;
  $tmpa = $oldjour if ($scriptname eq "cron-pages.pl");
  $tmpa = $yesterday if ($scriptname eq "cron-inc.pl");
  $tmpa =~ s/\/\-/ /g;
  $tmpa =~ s/\_/ \/ /g;

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Referer'} - $tmpa</TITLE>\n";
#  print FOUT "<TITLE>$L{'Referer_about'} $localserver - $oldjour</TITLE>\n" if ($virtualfilter eq '');
#  print FOUT "<TITLE>$L{'Referer_about'} $virtualfilter - $oldjour</TITLE>\n" if ($virtualfilter ne ''); 
  print FOUT "<!-- Page generated by w3perl - cron-refer.pl $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\">\n";
  print FOUT "function ToggleMenuAll(obj) {\n";
  print FOUT " var elementsDIV = document.getElementsByTagName('div');\n";
  print FOUT "	for (var i = 0; i < elementsDIV.length; i++) {\n";
  print FOUT "     var el = elementsDIV[i].id;\n";
  print FOUT "     if (el.indexOf(\"TOGGLE_\") != -1) {\n";
  print FOUT "     elementsDIV[i].style.display  = (elementsDIV[i].style.display != 'none' ? 'none' : 'inline');\n";
  print FOUT "     }\n";
  print FOUT "	}\n";
  print FOUT "}\n";
  print FOUT "function ToggleMenuAll2(obj) {\n";
  print FOUT " var elementsDIV = document.getElementsByTagName('div');\n";
  print FOUT "	for (var i = 0; i < elementsDIV.length; i++) {\n";
  print FOUT "     var el = elementsDIV[i].id;\n";
  print FOUT "     if (el.indexOf(\"TOGGLE2_\") != -1) {\n";
  print FOUT "     elementsDIV[i].style.display  = (elementsDIV[i].style.display != 'none' ? 'none' : 'inline');\n";
  print FOUT "     }\n";
  print FOUT "	}\n";
  print FOUT "}\n";
  print FOUT "function ToggleMenu(obj) {\n";
  print FOUT "target = document.getElementById(obj);\n";
  print FOUT "if (target.style.display == \"none\"){\n";
  print FOUT "target.style.display = \"inline\";\n";
  print FOUT "} else {\n";
  print FOUT "target.style.display = \"none\";\n";
  print FOUT "}\n";
  print FOUT "}\n";
  print FOUT "</SCRIPT>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,3);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd2 TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,3);

#  print FOUT "<TABLE WIDTH=\"100%\"><TR><TD VALIGN=TOP>\n";

  &PageResumeMenu(*FOUT, $link_next, eval($Lang{$lang[$nblang]}));

#  print FOUT "</TD>\n<TD VALIGN=TOP>\n";

  print FOUT "<H3>$L{'References_for'} $localserver</H3>\n<P>\n" if ($virtualfilter eq '');
  print FOUT "<H3>$L{'References_for'} $virtualfilter</H3>\n<P>\n" if ($virtualfilter ne ''); 

  if ($uniqueday == 0 && $uniqueurlday == 0 && $uniquenbrefullday == 0) {  
      print FOUT "<I>$L{'No_request'}</I>\n";      
  }

  if ($uniqueday != 0) {

      if ($show_all == 1) {
	  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $topten $L{'hosts'} ($L{'among'} $uniqueday)" if ($display_all == 0);
	  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $uniqueday $L{'hosts'}\n" if ($display_all == 1);
	  print FOUT "&nbsp;<A HREF=\"$listdailyrefer$htmlext\">$L{'Full_list'}</A>" if ($display_all == 0);
	  print FOUT "</DIV><P>\n";
#      print FOUT "<I>($L{'Only_hosts'} $L{'with_at_least'} $seuilsite $L{'requests'} $L{'are_shown'})</I><P>\n" if ($seuilsite > 1);
      }
  
      if ($show_all == 0) {
	  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $topten $L{'hosts'} ($L{'among'} $uniqueday)</DIV>";
#      print FOUT "<P><I>($L{'Only_hosts'} $L{'with_at_least'} $seuilsite $L{'requests'} $L{'are_shown'})</I><P>\n" if ($seuilsite > 1);
      }
  
  ### Hosts
  
      print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
      print FOUT "<thead>\n";
      print FOUT "<TR>\n";
      print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Hosts_from'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
      print FOUT "</TR>\n";
      print FOUT "</thead>\n";
      print FOUT "<tbody>\n";
      
      $i = 0;
      foreach $site (&reverse_sort_by_value(*nbredayref)) {
#      if ($display_all == 0 || ($display_all == 1 && $nbredayref{$site} > $seuilsite)) {
	  print FOUT "<TR>\n";
	  print FOUT "<TD CLASS=\"left\">$site</TD>\n";
	  print FOUT "<TD CLASS=\"right\">$nbredayref{$site}</TD>\n";
	  print FOUT "</TR>\n";
	  $i++;
	  last if ($i == $topten && $display_all == 0);
#      }
      }
      print FOUT "</tbody>\n";
      print FOUT "</TABLE>\n\n";
  }

###  Referer Pages

  if ($uniquenbrefullday != 0) {
      print FOUT "<P><BR>\n";

      if ($show_all == 1) {
	  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $topten $L{'referer_pages1'} ($L{'among'} $uniquenbrefullday)\n" if ($display_all == 0);
	  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $uniquenbrefullday $L{'referer_pages1'}\n" if ($display_all == 1);
	  print FOUT "&nbsp;<A HREF=\"$listdailyrefer$htmlext\">$L{'Full_list'}</A>" if ($display_all == 0);
	  print FOUT "</DIV>\n";
#     print FOUT "<P><I>($L{'Only_pages'} $L{'with_at_least'} $seuilpage $L{'requests'} $L{'are_shown'})</I><P>\n" if ($seuilsite > 1);
      }
  
      if ($show_all == 0) {
	  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $uniquenbrefullday $L{'referer_pages1'}</DIV>\n";
#      print FOUT "<P><I>($L{'Only_pages'} $L{'with_at_least'} $seuilpage $L{'requests'} $L{'are_shown'})</I><P>\n" if ($seuilpage > 1);
      }
  
      print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
      print FOUT "<thead>\n";
      print FOUT "<TR>\n";
      print FOUT "<TH><A HREF=\"javascript:ToggleMenuAll('Toggle_all');\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$toggle_on\" NAME=\"ima_toggle\" BORDER=0 WIDTH=\"12\" HEIGHT=\"21\" TITLE=\"$L{'Click_here'}\" ALT=\"toggle\"></A></TH>\n";
      print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Referer_pages2'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
      print FOUT "</TR>\n";
      print FOUT "</thead>\n";
      print FOUT "<tbody>\n";
      
      $i = 0;
      foreach $site (&reverse_sort_by_value(*nbrefullday)) {
#      if ($display_all == 0 || ($display_all == 1 && $nbrefullday{$site} > $seuilpage)) {

	  $tmp2 = $site;
	  $tmp2 =~ s/https?:\/\///;

	  if ($tmp2 =~ /\?/) {
	      ($tmp2,$query) = split(/\?/,$tmp2);
	      $tmp2 = substr($tmp2,0,rindex($tmp2,$dirsepurl));
	  }

	  $tmp = $site;
	  $tmp =~ s/$dirsepurl/_/g;

	  $toggle_var = "TOGGLE_".$tmp;

	  print FOUT "<TR>\n";

	  print FOUT "<TD VALIGN=TOP ALIGN=LEFT WIDTH=\"10\" ";
	  print FOUT "OnClick=\"javascript:ToggleMenu('";
	  print FOUT "$toggle_var";
	  print FOUT "')\"";
	  print FOUT " TITLE=\"$L{'Click_here'}\">";
	  print FOUT "&gt;</TD>\n";

	  print FOUT "<TD CLASS=\"left\" VALIGN=TOP><A HREF=\"$site\" rel=\"nofollow\">$tmp2</A>";

	  print FOUT "\n<DIV ID=\"$toggle_var\" STYLE=\"display:none\">\n";

	  print FOUT "<TABLE class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
	  print FOUT "<thead>\n";
	  print FOUT "<TR>\n";
	  print FOUT "<TH class=\"table-sortable:default\">$L{'Page'}</TH>\n<TH class=\"table-sortable:numeric\">$L{'Occurence'}</TH>\n</TR>\n";
	  print FOUT "</thead>\n<tbody>\n";
	  
	  for  ($j=1;$j<=$idx_fullsite_day{$site};$j++) {
	      $tmp2 = $refer_fullsite_page_day{$site,$j};
	      print FOUT "<TR>";
#	      print FOUT "<TD CLASS=\"left\">$tmp2</TD>";
	      print FOUT "<TD CLASS=\"left\">";
	      $link = &AddHREF($tmp2);
	      print FOUT "$link";
	      print FOUT "</TD>";
	      print FOUT "<TD CLASS=\"right\">$refer_fullsite_occur_day{$site,$tmp2}</TD>\n";
	      print FOUT "</TR>\n";
	  }
	  print FOUT "</tbody>\n";
	  print FOUT "</TABLE>\n";
	  print FOUT "</DIV>\n";

	  print FOUT "</TD>\n";
	  print FOUT "<TD CLASS=\"right\" VALIGN=TOP>";
	  print FOUT "$nbrefullday{$site}";
	  print FOUT "</TD>\n";
	  print FOUT "</TR>\n";
	  $i++;
	  last if ($i == $topten && $display_all == 0);
#      }
      }
      print FOUT "</tbody>\n";
      print FOUT "</TABLE>\n\n";
  }


### Entry

if ($type_serveur != 2 && $uniqueurlday != 0) {
    print FOUT "<P><BR>\n";

    if ($show_all == 1) {
	print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $topten $L{'entry_pages'} ($L{'among'} $uniqueurlday)\n" if ($display_all == 0);
	print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $uniqueurlday $L{'entry_pages'}\n" if ($display_all == 1);
	print FOUT "&nbsp;<A HREF=\"$listdailyrefer$htmlext\">$L{'Full_list'}</A>" if ($display_all == 0);
	print FOUT "</DIV><P>\n";
#	print FOUT "<I>($L{'Only_pages'} $L{'with_at_least'} $seuilpage $L{'requests'} $L{'are_shown'})</I><P>\n" if ($seuilsite > 1);
    }
  
    if ($show_all == 0) {
	print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $uniqueurlday $L{'entry_pages'}</DIV>\n";
#	print FOUT "<P><I>($L{'Only_pages'} $L{'with_at_least'} $seuilpage $L{'requests'} $L{'are_shown'})</I><P>\n" if ($seuilpage > 1);
    }

    print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
    print FOUT "<thead>\n";
    print FOUT "<TR>\n";
    print FOUT "<TH><A HREF=\"javascript:ToggleMenuAll2('Toggle_all');\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$toggle_on\" NAME=\"ima_toggle\" BORDER=0 WIDTH=\"12\" HEIGHT=\"21\" TITLE=\"$L{'Click_here'}\" ALT=\"toggle\"></A></TH>\n";
    print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Destination'}&nbsp;</TH>\n" if ($squid_format == 1);
    print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Entry_pages'}&nbsp;</TH>\n";
    print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
    print FOUT "</TR>\n";
    print FOUT "</thead>\n";
    print FOUT "<tbody>\n";

    $i = 0;
    foreach $site (&reverse_sort_by_value(*occurday)) {
#	if ($display_all == 0 || ($display_all == 1 && $occurday{$site} > $seuilpage)) {

	  $tmp = $site;
	  $tmp =~ s/$dirsepurl/_/g;

	  $toggle_var = "TOGGLE2_".$tmp;

	  print FOUT "<TR>\n";
	  print FOUT "<TD VALIGN=TOP ALIGN=LEFT WIDTH=\"10\" ";
	  print FOUT "OnClick=\"javascript:ToggleMenu('";
	  print FOUT "$toggle_var";
	  print FOUT "')\"";
	  print FOUT " TITLE=\"$L{'Click_here'}\">";
	  print FOUT "&gt;</TD>\n";

	  if ($squid_format == 1) {
	      $tmp2 = index($site,$dirsep,1);
	      $tmp1 = substr($site,0,$tmp2+1);
	      $tmp6 = substr($site,$tmp2,length($site));
	      print FOUT "<TD CLASS=\"left\">$tmp1</TD>\n";
	  }

	  print FOUT "<TD VALIGN=TOP CLASS=\"left\">";
	  $link = &AddHREF($site) if ($squid_format == 0);
	  $link = &AddHREF($tmp6) if ($squid_format == 1);
	  print FOUT "$link";
	  print FOUT "\n<DIV ID=\"$toggle_var\" STYLE=\"display:none\">\n";

	  if ($mode_refer_demo == 0) {
	      print FOUT "<TABLE class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
	      print FOUT "<thead>\n";
	      print FOUT "<TR>\n";
	      print FOUT "<TH class=\"table-sortable:default\">$L{'Page'}</TH>\n<TH class=\"table-sortable:numeric\">$L{'Occurence'}</TH>\n</TR>\n";
	      print FOUT "</thead>\n<tbody>\n";
	  
	      for  ($j=1;$j<=$idx_occur_day{$site};$j++) {
		  $tmp2 = $occur_fullsite_page_day{$site,$j};
		  print FOUT "<TR>";
		  print FOUT "<TD CLASS=\"left\">$tmp2</TD>";
		  print FOUT "<TD CLASS=\"right\">$occur_fullsite_occur_day{$site,$tmp2}</TD>\n";
		  print FOUT "</TR>\n";
	      }
	      print FOUT "</tbody>\n";
	      print FOUT "</TABLE>\n";
	  }
	  print FOUT "</DIV>\n";

	  print FOUT "<TD CLASS=\"right\" VALIGN=TOP>$occurday{$site}</TD>\n";
	  print FOUT "</TR>\n";
	  $i++;
	  last if ($i == $topten && $display_all == 0);
#	}
    }
    print FOUT "</tbody>\n";
    print FOUT "</TABLE>\n\n";

}
  print FOUT "<P><BR>\n";

  print FOUT "</TD></TR></TABLE>\n";
  
  print FOUT "</BODY></HTML>\n";
}


#
##############################################################
### Keywords
##############################################################
#

sub KeywordDay {
  local(*FOUT,*L,$I,$display_all) = @_;

  $tmpa = $dirresume;
  $tmpa = $oldjour if ($scriptname eq "cron-pages.pl");
  $tmpa = $yesterday if ($scriptname eq "cron-inc.pl");
  $tmpa =~ s/\/\-/ /g;
  $tmpa =~ s/\_/ \/ /g;

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Search_engine'} - $tmpa</TITLE>\n";
#  print FOUT "<TITLE>$L{'Search_engine'} $localserver - $oldjour</TITLE>\n" if ($virtualfilter eq '');
#  print FOUT "<TITLE>$L{'Search_engine'} $virtualfilter - $oldjour</TITLE>\n" if ($virtualfilter ne ''); 
  print FOUT "<!-- Page generated by w3perl - cron-refer.pl $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_css_style(*FOUT,3);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd2 TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,3);

#  print FOUT "<TABLE WIDTH=\"100%\"><TR><TD VALIGN=TOP>\n";

  &PageResumeMenu(*FOUT, $link_next, eval($Lang{$lang[$nblang]}));

#  print FOUT "</TD>\n<TD VALIGN=TOP>\n";

  print FOUT "<H3>$L{'Search_engine'}</H3>\n<P>\n";

  if (keys(%keyshday) == 0 && ($#wordsday+1) == 0) {
      print FOUT "<I>$L{'No_request'}</I>\n";
  }

  if (($#wordsday+1) != 0) {

  if ($show_all == 1) {
      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $topten $L{'engine_keywords_used'} ($L{'among'} ",($#wordsday+1),")" if ($display_all == 0);
      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} ",($#wordsday+1)," $L{'engine_keywords_used'}" if ($display_all == 1);
      print FOUT "&nbsp;<A HREF=\"$listdailykeyword$htmlext\">$L{'Full_list'}</A>" if ($display_all == 0);
      print FOUT "</DIV>\n";
  }
  
  if ($show_all == 0) {
      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} ",($#wordsday+1)," $L{'engine_keywords_used'}</DIV>\n";
  }

  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Keywords'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";

  $i = 0;
  foreach $site (&reverse_sort_by_value(*wday)) {
	  $tmp = $site;
	  $tmp =~ s/\"//g;
	  print FOUT "<TR>\n<TD CLASS=\"left\">$tmp</TD>\n";
	  print FOUT "<TD CLASS=\"right\">$wday{$site}</TD>\n</TR>\n";
	  $i++;
	  last if ($i == $topten && $display_all == 0);
  }


  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n";
  print FOUT "<P><BR>\n";


  ###
  $tmp = keys(%fullstringday);
  if ($show_all == 1) {
      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $topten $L{'String'} ($L{'among'} $tmp)" if ($display_all == 0);
      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $tmp $L{'String'}" if ($display_all == 1);
      print FOUT "&nbsp;<A HREF=\"$listdailykeyword$htmlext\">$L{'Full_list'}</A>" if ($display_all == 0);
      print FOUT "</DIV>\n";
  }
  
  if ($show_all == 0) {
      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $tmp $L{'String'}</DIV>\n";
  }

  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'String'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";

  $i = 0;
  foreach $site (&reverse_sort_by_value(*fullstringday)) {
	  $tmp = $site;
	  $tmp =~ s/\"//g;
	  print FOUT "<TR>\n<TD CLASS=\"left\">$tmp</TD>\n";
	  print FOUT "<TD CLASS=\"right\">$fullstringday{$site}</TD>\n</TR>\n";
	  $i++;
	  last if ($i == $topten && $display_all == 0);
  }


  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n";
  print FOUT "<P><BR>\n";

  }


  $tmp = keys(%keyshday);
  if ($tmp != 0) {

  if ($show_all == 1) {
      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $topten $L{'search_engine'} ($L{'among'} $tmp)" if ($display_all == 0);
      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $tmp $L{'search_engine'}" if ($display_all == 1);
      print FOUT "&nbsp;<A HREF=\"$listdailykeyword$htmlext\">$L{'Full_list'}</A>" if ($display_all == 0);
      print FOUT "</DIV>\n";
  }
  
  if ($show_all == 0) {
      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $tmp $L{'search_engine'}</DIV>\n";
#      print FOUT "<P><I>($L{'Only_hosts'} $L{'with_at_least'} $seuilsite $L{'requests'} $L{'are_shown'})</I><P>\n" if ($seuilsite > 1);
  }

  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Search_engine'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";
  print FOUT "<tbody>\n";

#  print FOUT "<P><TABLE CLASS=\"sortable_base\" ID=\"search_engine\">\n";
#  print FOUT "<TR>\n<TH>&nbsp;$L{'Search_engine'}&nbsp;</TH><TH>&nbsp;$L{'Occurence'}&nbsp;</TH>\n</TR>\n";

  $i = 0;
  foreach $site (&reverse_sort_by_value(*keyshday)) {
#      if ($display_all == 0 || ($display_all == 1 && $keyshday{$site} > $seuilsite)) {
	  print FOUT "<TR>\n<TD CLASS=\"left\">$site</TD>\n<TD CLASS=\"right\">$keyshday{$site}</TD>\n</TR>\n";
	  $i++;
	  last if ($i == $topten && $display_all == 0);
#      }
  }

  print FOUT "</TABLE>\n";
  }

  print FOUT "</TD></TR></TABLE>\n";

#  print FOUT "<!-- PAGE BREAK -->\n"; # PDF break
  print FOUT "</BODY></HTML>\n";
}

#
##############################################################
### Saving daily agent data
##############################################################
#

sub save_daily_agent {
    local($tmp);

    $tmp = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume";
    mkdir ($tmp,0775) unless -d $tmp;

    return if (-f "$tmp$dirsep$listdailyagent$txtext");

    open(FILEDAYAGENTALL,">$tmp$dirsep$listdailyagent$txtext") || &error_exit("Error, unable to open $tmp$dirsep$listdailyagent$txtext");
    print FILEDAYAGENTALL "$oldjour\t$countday\n";
    foreach $browser (keys(%nbrebrowserday)) {
	print FILEDAYAGENTALL "A\t$browser\t$nbrebrowserday{$browser}\n";
    }
    foreach $browser (keys(%nbreosday)) {
	print FILEDAYAGENTALL "B\t$browser\t$nbreosday{$browser}\n";
    }
    for ($i=1;$i<=$uniqueday;$i++) {
	print FILEDAYAGENTALL "C\t$browserday[$i]\t$nbreday{$browserday[$i]}\n"; 
    }
    close(FILEDAYAGENTALL);
}

#
##############################################################
### Saving daily refer data
##############################################################
#

sub save_daily_refer {    
    local($tmp);

    $tmp = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume";
    mkdir ($tmp,0775) unless -d $tmp;

    open(FILEDAYREFERALL,">$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailyrefer$txtext") || &error_exit("Error, unable to open $path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailyrefer$txtext");    
    foreach $site (keys(%nbredayref)) {
	print FILEDAYREFERALL "A\t$site\t$nbredayref{$site}\n" if ($nbredayref{$site} != 0);
    }
    foreach $site (keys(%nbrefullday)) {
	if ($nbrefullday{$site} != 0) {
	    print FILEDAYREFERALL "B\t$site\t$nbrefullday{$site}\n";
	    for  ($i=1;$i<=$idx_fullsite_day{$site};$i++) {
		$tmp2 = $refer_fullsite_page_day{$site,$i};
		print FILEDAYREFERALL "B1\t$tmp2\t$refer_fullsite_occur_day{$site,$tmp2}\n";
	    }
	}
    }
    foreach $site (keys(%occurday)) {
	if ($occurday{$site} != 0) {
	    print FILEDAYREFERALL "C\t$site\t$occurday{$site}\n";
	    for  ($i=1;$i<=$idx_occur_day{$site};$i++) {
		$tmp2 = $occur_fullsite_page_day{$site,$i};
		print FILEDAYREFERALL "C1\t$tmp2\t$occur_fullsite_occur_day{$site,$tmp2}\n";
	    }
	}
    }
    for ($i=0;$i<=$#wordsday;$i++) {
	$site = $wordsday[$i];
	print FILEDAYREFERALL "D\t$site\t$wday{$site}\n";
    }
    foreach $site (keys(%keyshday)) {
	print FILEDAYREFERALL "E\t$site\t$keyshday{$site}\n";
    }
    foreach $site (keys(%fullstringday)) {
	print FILEDAYREFERALL "F\t$site\t$fullstringday{$site}\n";
    }
    close(FILEDAYREFERALL);
}

#
##############################################################
### Generate PDF list
##############################################################
#

sub generate_pdf_cmd {
    local($dir,$filetitle,$filepdf,$mode_web,*L) = @_;
    local($tmp,$tmppath,@pdf_page);
    local($newfile,$pdf_filetitle,$pdf_export,$nblang,$i);

    $nblang = 0;

    for ($k=0;$k<=$#homepages;$k++) {
	$nblang = $k if ($homepages[$k] !~ /-/);
#	if ($homepages[$k] eq $defaulthomepage) {
#	    $nblang = $k;
#	}
    }

    $tmppath = "$path$lang[$nblang]$dirsep$dirdate$dirsep$dir$dirsep" if ($mode_web == 0);
    $tmppath = "$path$dirtmp$dirsep$lang[$nblang]$dirsep$dir$dirsep" if ($mode_web == 1);

#    if (!(-f "$tmppath$filemoyenne")) {
    if (!(-f "$tmppath$menu")) {
	$msg = "File for PDF report not found : $tmppath$menu\nPDF file will be empty\n";
	&warning_msg($msg);
	return;
    }

#    push(@pdf_page,$filemoyenne) if (-f "$tmppath$filemoyenne");
    if (-f "$tmppath$menu" && $mode_web == 0) {
	push(@pdf_page,$menu);
	# BREAK
	push(@pdf_page,"BREAK");
    }

    push(@pdf_page,"$dirpage$htmlext") if (-f "$tmppath$dirpage$htmlext");
    push(@pdf_page,"BREAK");
    push(@pdf_page,"$dirsite$htmlext") if (-f "$tmppath$dirsite$htmlext");
    push(@pdf_page,"BREAK");
    push(@pdf_page,"$dirlist$htmlext") if (-f "$tmppath$dirlist$htmlext" && $mail_format == 0);
 

    push(@pdf_page,"BREAK");

    push(@pdf_page,"$dirtraffic$htmlext") if (-f "$tmppath$dirtraffic$htmlext");
    push(@pdf_page,"BREAK");
    push(@pdf_page,"$dirscript$htmlext") if (-f "$tmppath$dirscript$htmlext" && $mail_format == 0);
    push(@pdf_page,"BREAK");

    push(@pdf_page,"$filetype$htmlext") if (-f "$tmppath$filetype$htmlext" && $mail_format == 0);
    push(@pdf_page,"BREAK");

    # BREAK
    if (-f "$path$lang[$nblang]$dirsep$dirdate$dirsep$dir$dirsep$dirpays$htmlext") {

	push(@pdf_page,"$dirpays$htmlext");
	push(@pdf_page,"BREAK");

	# add countries if available
	if ($precision > 3) {
	    $file = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$dir.$dirsep.$dirpays.$htmlext;

	    $out = 0;
	    open(FILEHTML,"$file") || &error_exit("Can't open $file");
	    while (<FILEHTML>) {

		$out = 1 if (/<\/BODY/i);
		$out = 1 if (/^<!-- begin_insert_css_menu -->/);
		$out = 1 if (/^<!-- begin_daily_menu -->/);
		$out = 1 if (/^<!-- begin_help_hide_layer/);

		next if (/$listdailycountries$htmlext/);

		if ($out == 0) {
		    if (/<[A|AREA]([",a-z=\s\d]+)HREF="([&;~: &*#0-9a-z_\?\-\/\<\>\!.]+)"([\(\)!';",_a-z=\s\d]*)>/i) {
			push(@pdf_page,$2) if (-f "$path$lang[$nblang]$dirsep$dirdate$dirsep$dir$dirsep$2");
		    }
		}

		$out = 0 if (/<BODY/i);
		$out = 0 if (/^<!-- end_insert_css_menu -->/);
#		$findout = 1 if (/^<!-- end_insert_css_menu -->/);
		$out = 0 if (/^<!-- end_daily_menu -->/);
		$out = 0 if (/^<!-- end_help_hide_layer/);

	    }
	    close(FILEHTML);
	}
    }
	 	   

    push(@pdf_page,"BREAK");


    push(@pdf_page,$tabnamerefer) if (-f "$tmppath$refer");
    push(@pdf_page,"BREAK");
    push(@pdf_page,$tabnamekeyword) if (-f "$tmppath$refer");
    push(@pdf_page,"BREAK");
    push(@pdf_page,$tabnamebrowser) if (-f "$tmppath$agent");
    push(@pdf_page,"BREAK");
    push(@pdf_page,$filevirus) if (-f "$tmppath$filevirus");
    push(@pdf_page,$filenamehour) if (-f "$tmppath$filenamehour");
    push(@pdf_page,"BREAK");
    push(@pdf_page,"$dirsession$htmlext") if (-f "$tmppath$dirsession$htmlext");

    # Build a temporary file without css menu

    # $filetitle
    $filetitle = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$filetitle if ($mode_web == 0);
    $filetitle = $path.$dirtmp.$dirsep.$lang[$nblang].$dirsep.$dir.$dirsep.$filetitle if ($mode_web == 1);

#    print "Test $filetitle\n";
    if (-f $filetitle) {

#	print "OK\n";
	$newfile = "<HTML>\n<HEAD>\n";
	$newfile .= "<TITLE></TITLE>\n";
	$newfile .= "</HEAD>\n";
	$newfile .= "<BODY>\n";
	open(FILEPDF,$filetitle);
	$out = 1;
	$bypass = 0;
	$findout = 0;
	while (<FILEPDF>) {
	    $out = 1 if (/<\/BODY/i);
	    $out = 1 if (/^<!-- begin_insert_css_menu -->/);
	    $out = 1 if (/^<!-- begin_daily_menu -->/);
	    $out = 1 if (/^<!-- begin_help_hide_layer/);
	    $out = 1 if (/^<!-- begin_bypass_multigraph/);
	    $out = 1 if (/^<map/i);
	    $out = 1 if (/^<form/i);
	    $out = 1 if (/^<div/i && /display\:none/i);
	    if ($out == 0 && /^<script LANGUAGE=\"Javascript\" type=\"text\/JavaScript\">/i) {
		$out = 1;
		$bypass = 1;
	    }
	    $newfile .= $_ if ($out == 0);
	    $out = 0 if (/<BODY/i);
	    $out = 0 if (/^<!-- end_insert_css_menu -->/);
	    $findout = 1 if (/^<!-- end_insert_css_menu -->/);
	    $out = 0 if (/^<!-- end_daily_menu -->/);
	    $out = 0 if (/^<!-- end_help_hide_layer/);
	    $out = 0 if (/^<!-- end_bypass_multigraph/);
	    $out = 0 if (/^<\/map>/i);
	    $out = 0 if (/^<\/form>/i && $findout == 1);
	    $out = 0 if (/^<\/div>/i && $findout == 1);
	    $out = 0 if ($bypass == 1 && /^<\/script>/i);
	}
	close(FILEPDF);    
	$newfile .= "</BODY>\n</HTML>\n";
	
	$pdf_filetitle = "PDF_filetitle";

	$file_title_pdf = "$path$lang[$nblang]$dirsep$dirdate$dirsep$pdf_filetitle" if ($mode_web == 0);
	$file_title_pdf = "$path$dirtmp$dirsep$lang[$nblang]$dirsep$dirdate$dirsep$pdf_filetitle" if ($mode_web == 1);
#	print "Create $file_title_pdf\n";
	if (!(-f $file_title_pdf)) {
	    open(FILEPDF,">$file_title_pdf");
#	open(FILEPDF,">$tmppath$pdf_filetitle");
	    print FILEPDF "$newfile";
	    close(FILEPDF);
	}
    }

#

    $newfile = "<HTML>\n<HEAD>\n";
    $newfile .= "<TITLE></TITLE>\n";
    $newfile .= "</HEAD>\n";
    $newfile .= "<BODY>\n";
    for ($i=0;$i<=$#pdf_page;$i++) {
	if ($pdf_page[$i] ne "BREAK") {
	    $tmp = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$dir.$dirsep.$pdf_page[$i] if ($mode_web == 0);
	    $tmp = $path.$dirtmp.$dirsep.$lang[$nblang].$dirsep.$dir.$dirsep.$pdf_page[$i] if ($mode_web == 1);
	    open(FILEPDF,$tmp);
	    $out = 1;
	    $bypass = 0;
	    while (<FILEPDF>) {
		$out = 1 if (/<\/BODY/i);
		$out = 1 if (/^<!-- begin_insert_css_menu -->/);
		$out = 1 if (/^<!-- begin_daily_menu -->/);
		$out = 1 if (/^<!-- begin_insert_map -->/);
		$out = 1 if (/^<!-- begin_help_hide_layer/);
		$out = 1 if (/^<!-- begin_bypass_multigraph/);
		if ($out == 0 && /^<script LANGUAGE=\"Javascript\" type=\"text\/JavaScript\">/i) {
		    $out = 1;
		    $bypass = 1;
		}
		next if (/$toggle_on/);
		next if (/$icon_csv/);
		next if (/$L{'Full_list'}/);
		$newfile .= $_ if ($out == 0);
		$out = 0 if (/<BODY/i);
		$out = 0 if (/^<!-- end_insert_css_menu -->/);
		$out = 0 if (/^<!-- end_daily_menu -->/);
		$out = 0 if (/^<!-- end_insert_map -->/);
		$out = 0 if (/^<!-- end_help_hide_layer/);
		$out = 0 if (/^<!-- end_bypass_multigraph/);
		$out = 0 if ($bypass == 1 && /^<\/script>/i);
	    }
	    close(FILEPDF);
	} else {
	    $newfile .= "<!-- PAGE BREAK -->\n"; # PDF break
	}
    }

    $newfile .= "</BODY>\n</HTML>\n";

    $pdf_export = "PDF_".$dir;
#    print "Create $tmppath$pdf_export\n";
    open(FILEPDF,">$tmppath$pdf_export");
    print FILEPDF "$newfile";
    close(FILEPDF);


#    $filepdf = $path.$dirpdf.$dirsep.$year."-".$month."-".$jour.$pdfext;
#		 $command = "$HTMLDOC $htmldoc_option --titlefile $fileday --outfile $filepdf ";
#    $command = "$htmldoc_option --titlefile $filetitle -f $filepdf | ";
    $command = "$htmldoc_option ";
#    $command .= "--titlefile $tmppath$pdf_filetitle " if (-f "$tmppath$pdf_filetitle");
    $command .= "--titlefile $path$lang[$nblang]$dirsep$dirdate$dirsep$pdf_filetitle " if (-f "$path$lang[$nblang]$dirsep$dirdate$dirsep$pdf_filetitle");
    $command .= "--titlefile $path$dirtmp$dirsep$lang[$nblang]$dirsep$dirdate$dirsep$pdf_filetitle " if (-f "$path$dirtmp$dirsep$lang[$nblang]$dirsep$dirdate$dirsep$pdf_filetitle");
    $command .= "-f $filepdf | ";
#		 $command = "$htmldoc_option -f $filepdf | ";
    $command .= "$tmppath$pdf_export";

#    print "A - $tmppath$pdf_filetitle\n";

#    for ($i=0;$i<=$#pdf_page;$i++) {
#	$tmp = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$dir.$dirsep.$pdf_page[$i];
#	$command .= "$tmp ";
#    }
#    print "TOTO $command<P>\n";
    push(@list_cmd,$command);
    undef(@pdf_page);
}

#
##############################################################
### PDF report
##############################################################
#

sub export_pdf {
    local(@list_cmd) = @_;
    local($tmp,$file_to_remove,$i);

    for ($i=0;$i<=$#list_cmd;$i++) {

	$ENV{HTMLDOC_NOCGI} = 1;
#	select(STDOUT); $| = 1;

	$cmd = $list_cmd[$i];
	($tmp1,$tmp2) = split(/\s+\|\s+/,$cmd);
	@tmp3 = split(/\s+/,$tmp2);

#	print "Write to $path$dirtmp$dirsep$dirpdf$dirtmp\n";
	open(PDFTMP,">$path$dirtmp$dirsep$dirtmp$dirpdf$dirtmp") || &error_exit("Unable to write to $path$dirtmp$dirsep$dirtmp$dirpdf$dirtmp");
	print PDFTMP "#HTMLDOC\n";
	print PDFTMP "$tmp1\n";
#	print "#HTMLDOC\n";
#	print "$tmp1\n";
	for ($j=0;$j<=$#tmp3;$j++) {
	    print PDFTMP "$tmp3[$j]\n";
#	    print "$tmp3[$j]\n";
	    $file_to_remove = $tmp3[$j] if ($tmp3[$j] =~ /^$path/);
	}
	close(PDFTMP);
	$command = "$HTMLDOC --quiet --batch $path$dirtmp$dirsep$dirtmp$dirpdf$dirtmp";
#	print "TOTO $command\n";
#	$command = $list_cmd[$i];
	$commit = system("$command");
	# Add run_and_check_exit
	if ($commit != 0) {
	    &error_exit("The command to create PDF report failed ($command)");
	}
	unlink("$path$dirtmp$dirsep$dirtmp$dirpdf$dirtmp");
#	print "REmove $file_to_remove\n";
	unlink("$file_to_remove");
#	$file_to_remove = substr($file_to_remove,rindex($file_to_remove,$dirsep),length($file_to_remove));
#	$file_to_remove .= $pdf_filetitle;

    }

	$file_to_remove = $file_title_pdf;
#	print "REmove $file_to_remove\n";
	unlink("$file_to_remove");
}


#
##############################################################
### Email report
##############################################################
#

sub export_html_page {
    local($page,*L) = @_;
    local($tmp,$html);
    push(@html_page,$page) if (-e "$page");
    $html = &read_html($page,0,0,*L);
    return $html;
}


sub read_html {
    local($file,$count,$totcount,*L) = @_;
    local($tmp,$tmp1,$tmp2,$tmp3,$tmp4,$tmp5,$html);

    $html = '';
#    $count_ima = 0;

    $out = 1;
    $out2 = 0;
    $found_header = 0;

    open(FILEHTML,"$file") || &error_exit("Can't open $file");
    while (<FILEHTML>) {
	$out = 1 if ($_ =~ /Email_report_exclude_begin/);
	$out = 0 if ($_ =~ /Email_report_exclude_end/);

	$found_header = 1 if ($_ =~ /\<HEAD\>/i);
	$out2 = 1 if ($_ =~ /\<script/ && $found_header == 1);
	if ($_ =~ /\<\/script\>/ && $found_header == 1) {
	    $out2 = 0;
	    next;
	}
	$found_header = 0 if ($_ =~ /\<body/i);

	$out = 1 if ($_ !~ /<body/i && $out == 1 && $count != 0);
	$out = 0 if ($_ =~ /<body/i && $count != 0);
#	$out = 1 if ($_ !~ /<body/i && $out == 1);
#	$out = 0 if ($_ =~ /<body/i);

	$out = 1 if ($_ =~ /^<script LANGUAGE=\"Javascript\" type=\"text\/JavaScript\">/i);
	$out = 0 if ($_ =~ /^<\/script>/i);

#	$out = 1 if (/\"javascript\"/i);
#	$out = 0 if (/^\<\/script\>/i);

	$out2 = 1 if (/^<!-- begin_insert_css_menu -->/);
	$out2 = 1 if (/^<!-- begin_daily_menu -->/);
	$out2 = 1 if (/^<!-- begin_insert_map/);
	$out2 = 1 if (/^<!-- begin_help_hide_layer/);

	$out = 1 if ($_ !~ /<body/i && $out == 1);
#	$out = 0 if ($_ =~ /<body/i);

	$out2 = 0 if (/^<!-- end_insert_css_menu -->/);
	$out2 = 0 if (/^<!-- end_daily_menu -->/);
	$out2 = 0 if (/^<!-- end_insert_map -->/);
	$out2 = 0 if (/^<!-- end_help_hide_layer/);

	$line = $_;

	next if ($line =~ /<thead>/i);
	next if ($line =~ /<\/thead>/i);
	next if ($line =~ /\"javascript\"/i && $line =~ /\<\/script\>/i);
	next if ($line =~ /\"stylesheet\"/i);
	next if ($line =~ /\"alternate stylesheet\"/i);
	next if ($line =~ /<body/i && $count != 0);
	next if ($line =~ /<\/body>/i);
	next if ($line =~ /<\/html>/i);
	next if (($out == 1 && $count != 0) || ($out2 == 1));
#	next if (($out == 1) || ($out2 == 1));

	# extract img file

	$line2 = $line;
	while ($line2 =~ /<IMG([\#"a-z=\s\d]+)SRC="([&;~: 0-9a-z_\-\/\>\<\!.]+)"([\.\/\!\?\[\-\@\]#"a-z_=\s\d]+)>/gi) {
		$tmp1 = $1;
		$tmp2 = $2;
		$tmp3 = $3;
		$delstring = $&;
		$delstring =~ s/\?/\\?/g;
		$delstring =~ s/\*/\\*/g;
		$delstring =~ s/\(/\\(/g;
		$delstring =~ s/\)/\\)/g;

		$link = $tmp2;
		if ($tmp2 =~ /^\.\.\//) {
		    $link =~ s/\.\.\///g;
		    if (substr($pathinit,1,1) eq ":") {
			if ($link =~ /$dirsepurl$dirress$dirsepurl/) {
			    $link = $pathserver.$link;
			} else {
			    $link = $path.$link;
			}
		    } else {
			$link = $path.$link;
		    }
		} elsif ($tmp2 =~ /^\//) {
#		if ($tmp2 =~ /^\//) {
		    $tmp5 = $pathserver;
		    chop($tmp5);
		    $link = $tmp5.$link;
		} else {
		    # Homepage
		    $link = $pathinit.$link;
		}

		if ($seen_ima_html{$link} == 0) {
		    $count_ima++;
		    $ima_find[$count_ima] = $link;
		    $ima_find_nb{$link} = $count_ima;
		    $newlink = "cid:ID$count_ima";
		    $seen_ima_html{$link}++;
		} else {
		    $newlink = "cid:ID".$ima_find_nb{$link};
		}
		
		$line2 =~ s/$delstring//i;
		$line =~ s/$delstring/<IMG $tmp1 SRC=\"$newlink\" $tmp3>/i;
		
	    }
	    
	    $html .= $line;
	}
	$html .= "<BR><BR><HR>\n";
	
	close(FILEHTML);

    $html =~ s/<H3 CLASS=\"center\">/<FONT COLOR=\"\#209090\" SIZE=\"+2\" face=\"arial\"><strong>&nbsp;/gi;
    $html =~ s/<H3>/<FONT COLOR=\"\#209090\" SIZE=\"+1\" style=\"arial\"><strong>&nbsp;/gi;
    $html =~ s/<\/H3>/&nbsp;<\/strong><\/FONT>/gi;
    $html =~ s/<TH/<TH bgcolor=\"\#ffeecc\"/gi;
    $html =~ s/BACKGROUND=\"([&;~: 0-9a-z_\-\/\>\<\!.]+)\"//gi; 
    $html =~ s/CLASS=\"sortable\"//gi;
    $html =~ s/CLASS=\"tablesort\"//gi;
    $html =~ s/CLASS=\"item_page\"//gi;
    $html =~ s/CLASS=\"head\"/align=\"center\" bgcolor=\"\#ffeecc\"/gi;
    $html =~ s/CLASS=\"right\"/align=\"right\"/gi;
    $html =~ s/CLASS=\"left\"/align=\"left\"/gi;
    $html =~ s/CLASS=\"right_alter\"/bgcolor=\"\#f5f5f5\" align=\"right\"/gi;
    $html =~ s/CLASS=\"left_alter\"/bgcolor=\"\#f5f5f5\" align=\"left\"/gi;
    $html =~ s/CLASS=\"head_right\"/bgcolor=\"\#ffeecc\" align=\"right\"/gi;
    $html =~ s/CLASS=\"head_left\"/bgcolor=\"\#ffeecc\" align=\"left\"/gi;
    $html =~ s/$L{'Full_list'}//g;

    $html .= "</body></html>\n" if ($totcount == 0 || $count == $#html_page);
    return $html;

}


sub export_html {
    local($dir,*L) = @_;
    local($tmp,@html_page);
    local($newfile,$pdf_filetitle,$pdf_export,$nblang);

   $nblang = 0;

    for ($k=0;$k<=$#homepages;$k++) {
	$nblang = $k if ($homepages[$k] !~ /-/);
#	if ($homepages[$k] eq $defaulthomepage) {
#	    $nblang = $k;
#	}
    }

#    push(@html_page,$filemoyenne);
    push(@html_page,$menu);
    push(@html_page,"$dirpage$htmlext");
    push(@html_page,"$dirsite$htmlext");
    push(@html_page,"$dirlist$htmlext") if ($mail_format == 0);

#    print "AA - $path$lang[$nblang]$dirsep$dirdate$dirsep$dir$dirsep$dirpays$htmlext\n";
    if (-f "$path$lang[$nblang]$dirsep$dirdate$dirsep$dir$dirsep$dirpays$htmlext") {
	push(@html_page,"$dirpays$htmlext");

	# add countries if available
	if ($precision > 3) {
	    $file = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$dir.$dirsep.$dirpays.$htmlext;
	    
	    $out = 0;
	    open(FILEHTML,"$file") || &error_exit("Can't open $file");
	    while (<FILEHTML>) {
		next if ($_ =~ /\"javascript\"/i);
		next if ($_ =~ /\"stylesheet\"/i);
#		next if ($_ =~ /<body/i && $count != 0);
		next if ($_ =~ /<body/i && $i != 0);
		next if ($_ =~ /<\/body>/i);
		next if ($_ =~ /<\/html>/i);
		next if ($_ =~ /$listdailycountries/);
		next if ($_ =~ /class=\"sub/i);

		$out = 1 if (/^<!-- begin_insert_css_menu -->/);
		$out = 1 if (/^<!-- begin_daily_menu -->/);
		$out = 1 if (/^<!-- begin_help_hide_layer/);
#		$out = 1 if (/^<!-- begin_insert_map/);
		$out = 0 if (/^<!-- end_insert_css_menu -->/);
		$out = 0 if (/^<!-- end_daily_menu -->/);
		$out = 1 if (/^<!-- end_help_hide_layer/);
#		$out = 0 if (/^<!-- end_insert_map/);
		next if ($out == 1);

		if (/<[A|AREA]([",a-z=\s\d]+)HREF="([&;~: &*\#0-9a-z_\?\-\/\<\>\!.]+)"([\(\)!';",_a-z=\s\d]*)>/i) {
		    $tmp = $2;
		    push(@html_page,$tmp) if (-f "$path$lang[$nblang]$dirsep$dirdate$dirsep$dir$dirsep$tmp");
		} 
	    }
	    close(FILEHTML);
	}
    }

    push(@html_page,"$dirscript$htmlext") if ($mail_format == 0);
    push(@html_page,"$filetype$htmlext") if ($mail_format == 0);
    push(@html_page,"$dirtraffic$htmlext") if (-e "$dirresumefull$dirsep$dirtraffic$htmlext");
    push(@html_page,$tabnamerefer) if (-e "$dirresumefull$dirsep$refer");
    push(@html_page,$tabnamekeyword) if (-e "$dirresumefull$dirsep$refer");
    push(@html_page,$tabnamebrowser) if (-e "$dirresumefull$dirsep$agent");
    push(@html_page,$filevirus) if (-e "$dirresumefull$dirsep$filevirus");
    push(@html_page,"$dirsession$htmlext") if (-e "$dirresumefull$dirsep$dirsession$htmlext");
    push(@html_page,$filenamehour) if (-e "$dirresumefull$dirsep$filenamehour");

    $html = '';
    $count_ima = 0;
    for ($i=0;$i<=$#html_page;$i++) {
	$file = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$dir.$dirsep.$html_page[$i];
#	print "TOTO $file - $html\n\n";
	$html .= &read_html($file,$i,1,*L);

    }
}

#
##############################################################
### Sending email
##############################################################
#

sub send_email2 {
    local($emailadr,$subject,$page) = @_;
    local($tmp,$tmp2,$fileext);

#    use MIME::Lite::HTML;
  
    my $mailHTML = new MIME::Lite::HTML
	From     => $from,
	To       => $emailadr,
	Subject => $subject;
    
    $url = "$localhost_protocol://$localhost";
    $url .= ":$localhost_port" if ($localhost_port != 80);
    $url .= "$linkpath_url$page";

#    print "UU $url\n";
    my $MIMEmail = $mailHTML->parse($url);
    $MIMEmail->send_by_smtp($email_smtp, Port=>$email_smtp_port,Timeout=>60) if ($emailadr_pass eq '');
    $MIMEmail->send_by_smtp($email_smtp, Port=>$email_smtp_port, AuthUser=>$emailadr, AuthPass=>$emailadr_pass,Timeout=>60) if ($emailadr_pass ne '');

}

sub send_email {
    local($emailadr,$subject,$html,$css_email,$filepdf) = @_;
    local($tmp,$tmp2,$fileext);

#    if ($perl_mail_module eq "MIME::Lite") {

#    use Net::SMTP_auth;
#    use Net::SMTP;

#    if ($emailadr_pass eq '') {
#	MIME::Lite->send('smtp',$email_smtp, Debug=>4,Timeout=>60) if ($emailadr_pass eq '');
#    } else {
#	MIME::Lite->send('smtp', $email_smtp, AuthUser=>$emailadr, AuthPass=>$emailadr_pass, Debug=>4,Timeout=>60) if ($emailadr_pass ne '');
#    }
#    eval { $msg->send };
#    print $@ if $@;  ### or do_something() if $@;

    $mime = MIME::Lite->new (
	From => $from,
	To => $emailadr,
	Cc => $emailadr_cc,
	Subject => $subject,
	Return-Path => $emailadr,
	Reply-To => $emailadr,
#				   Type => 'multipart/mixed'
	Type => 'multipart/related'
	) || die "Error creating multipart container: $!\n";


	  if ($css_email == 1 || $email_html == 1) {
	      $mime->attach(
			    Type => 'text/html; charset=iso-8859-1',
			    Encoding => '8bit',
			    Data => $html
			    ) || die "Error adding the html message part: $!\n";

	      # Attach images
	      for ($i=1;$i<=$count_ima;$i++) {
		  $tmp = "ID".$i;
		  $fileshort = substr($ima_find[$i],rindex($ima_find[$i],$dirsep)+1,length($ima_find[$i]));
		  ($tmp2,$fileext) = split(/\./,$fileshort);
#		  print "$i - $tmp - $ima_find[$i] - $fileshort - $fileext<BR>\n";
		  $mime->attach(Type => 'image/'.$fileext,
			    Id   => $tmp,
			    Path => $ima_find[$i],
			    Filename   => $fileshort
			    ) || die "Error adding $fileshort: $!\n";
	      }
	  }

	  if ($email_pdf == 1 && $filepdf ne '') {
#	      $fileshort = $dir.$pdfext;
	      $fileshort = $filepdf;
	      $fileshort =~ s/$path$dirpdf$dirsep//;
	      $mime->attach(
			    Type       => 'application/pdf',
			    Encoding   => 'base64',
			    Path       => $filepdf,
			    Filename   => $fileshort
			    ) || die "Error adding $fileshort: $!\n";
	  }


	  #envoi du message

#	  $mime->MIME::Lite::quiet();

#	  if (substr($pathserver,1,1) eq ":") {
             # win
#	      $mime->MIME::Lite::send_by_smtp($email_smtp,Debug=>4) if ($emailadr_pass eq '');


#	      eval {$mime->MIME::Lite::send_by_smtp($email_smtp, Port=>$email_smtp_port,Timeout=>60)};
#	      die "MIME::Lite->send failed: $@\n" if $@;
#	      print $@; # if $@;  ### or do_something() if $@;
#	      $mime->MIME::Lite::send_by_smtp($email_smtp, Port=>$email_smtp_port,Timeout=>60,Debug=>4) if ($emailadr_pass eq '');
	      $mime->MIME::Lite::send_by_smtp($email_smtp, Port=>$email_smtp_port,Timeout=>60) if ($emailadr_pass eq '');
#	      $mime->MIME::Lite::send_by_smtp($email_smtp, Port=>$email_smtp_port, AuthUser=>$emailadr, AuthPass=>$emailadr_pass,Timeout=>60,Debug=>1) if ($emailadr_pass ne '');
	      $mime->MIME::Lite::send_by_smtp($email_smtp, Port=>$email_smtp_port, AuthUser=>$emailadr, AuthPass=>$emailadr_pass,Timeout=>60) if ($emailadr_pass ne '');


#	  } else {
#	      $mime->MIME::Lite::send();

#	 }

#    $Auth_type = 'LOGIN'; #PLAIN, LOGIN, CRAM-MD5#

#    $smtp = Net::SMTP_auth->new($email_smtp, Port->$email_smtp_port, Timeout => 60) or die "No smtp srver";
#    $smtp->auth( $Auth_type, $emailadr , $emailadr_pass) if ($emailadr_pass eq '');
#    $smtp->mail($from);
#    $smtp->to($emailadr);
#    $smtp->cc($emailadr_cc);
#    $smtp->data();
#    $smtp->datasend('From: $from');
#    $smtp->datasend('To: $emailadr\n');
#    $smtp->datasend("Subject: $subject\n");
#    $smtp->datasend($mime->as_string());
#    $smtp->dataend();
#    $smtp->quit();


#      }

}

#
##############################################################
### Admin web go back link
##############################################################
#

sub admin_goback {
    if ($ENV{'REQUEST_METHOD'} eq "GET") {

#	print "\n<P>\n</TD>\n</TR>\n</TABLE>\n";
	print "</TD></TR><TR><TD WIDTH=130></TD><TD>\n";

	print "\n<P>\n<TABLE>\n<TR>\n";
#    print "<A HREF=\"$bkglink\" class=\"admin_home\">Admin&nbsp;Home</A>\n";
#	print "<TD WIDTH=120 VALIGN=TOP><FONT SIZE=+2></FONT></TD>\n";
	print "<TD ALIGN=CENTER VALIGN=TOP>\n";
	print "<I>If you want to check the output stats, go back to the admin page or <A HREF=\"javascript:history.back()\">click</A> here to launch another script</I>\n";
	print "</TD>\n</TR>\n</TABLE>\n";

	print "</TD>\n</TR>\n</TABLE>\n";

	print "</BODY>\n</HTML>\n";
    }

}


#
##############################################################
### Insert div for help bubble
##############################################################
#

sub help_div {
    local(*FOUT) = @_;

    print FOUT "<!-- begin_help_hide_layer -->\n";
    print FOUT "<div id=\"object1\" style=\"text-decoration:none; position:absolute; visibility:visible; left:0px; top:-120px; z-index:10\" onmouseover=\"overdiv=1;\"  onmouseout=\"overdiv=0; setTimeout('hideLayer();overdiv--;',500)\"></div>\n";
    print FOUT "<!-- end_help_hide_layer -->\n";
}

#
##############################################################
### Shift struct_logfile when space is found inside the login field
##############################################################
#

sub LoginWithSpace {
    local(@tmp_val) = @_;
    local($val,$add_fields_logfile);
    
    $add_fields_logfile = 0;
    $val = $fields_logfile{'%login'};
    while ($tmp_val[$val] !~ /\"$/ && $val < 10) {
	$val++;
	$add_fields_logfile++;
#	$tmp = $tmp_val[$val];
    }
    return $add_fields_logfile;
}

sub LoginWithSpaceCups {
    local(@tmp_val) = @_;
    local($val,$add_fields_logfile);
    
    $add_fields_logfile = 0;
    $val = $fields_logfile{'%login'};
    while ($tmp_val[$val] !~ /^\d|^\[/ && $val < 10) {
	$val++;
	$add_fields_logfile++;
#	$tmp = $tmp_val[$val];
    }
    $add_fields_logfile--;
    return $add_fields_logfile;
}


sub ExtractFieldFromLine {
    local($field,$add,@tmp_val) = @_;
    local($val,$login,$i);

    $tmp = "%".$field;
    $val = $fields_logfile{$tmp};
    for ($i=$val;$i<=($val+$add);$i++) {
	$login .= $tmp_val[$i];
    }
    return $login;
}


sub ExtractJobNameFromLog {
    local(@tmp_val) = @_;
    local($title,$start_idx,$i);

    $start_idx  = $fields_logfile{'%title'}+$fields_after_login{'%title'}*$add_fields_login;
#    print "Line $#line_log (should be $#logfile_fields)\n";
    $count = $#line_log-$#logfile_fields-$add_fields_login;
#    print "B $count - $start_idx\n";
    for ($i=$start_idx;$i<=($start_idx+$count);$i++) {
	$title .= $tmp_val[$i]." ";
    }
    chop($title);
#    print "FOUND $title\n";
    return $title;
}

#
##############################################################
### Reads N bytes. If EOF is reached, terminates with an error message
##############################################################
#

sub read_n_bytes {
    local($n) = @_;
    local($ch);
    read(IMA,$ch,$n) == $n || &error_exit("Premature EOF in image file $file! ($n byte)",2);
    $ch;
}

# Reads one byte. If EOF is reached, terminates with an error message.
sub read_1_byte {
    local($ch);
    ($ch = getc(IMA)) || &error_exit("Premature EOF $ch in image file $file (1 byte)",2);
#    $ch = getc(IMA);
#    print "Premature EOF in image file $file (1 byte)!\n" if (!($ch));
    $ch;
}

#
##############################################################
### Check upgrade have been made
##############################################################
#

sub CheckConfigUpgrade {
    local($item) = @_;
    local($tmp,$tmp1,$tmp2);

    # Extract version number from config file
    # match v 3.XXX (YY/YYY/YYYY) or # What's new - [3.XXX]

    open(CFGFILE,$conf_file) || die &error_exit("Unable to open $conf_file");
    while (<CFGFILE>) {
	if (/^####\s+v\s(\d\.\d+)/) {
	    $tmp1 = $1;
	}
	if (/^#\s+What\'s\snew\s-\s\[(\d\.\d+)\]/) {
	    $tmp1 = $1;
	}
    }
    close(CFGFILE);

    # Check $conf_file exist in locconf : Yes => upgrade.pl / No => Edit manually

    $tmp = $tmp1;
    $tmp = int($tmp*1000)/1000;
    $tmp2 = int(($tmp*1000)+1)/1000;

    if (defined($$item) == 0) {
	$msg = "\nFATAL ERROR :\n";
	$msg .= "=> Configuration file too old, \$$item is not defined.\n";
	$msg .= "=> W3Perl version : $version - Config version : $tmp\n";
	$msg .= "You need first to upgrade your configuration file with the upgrade.pl script\n";
	$msg .= "\nIf it failed (config file not created from the web admin interface),\nadd at the end of your configuration file the missing line code blocks\nfrom the file /w3perl/resources/upgrade, starting from section [$tmp2]\n";
	&error_exit($msg,1);
    }
}


#
##############################################################
### Reads N bytes. If EOF is reached, terminates with an error message
##############################################################
#

sub LogoWidth {
    local($file) = @_;
    
#    $file = $pathserver.$logo if ($logo =~ /^\//);
#    $file = $pathinit.$dirress.$dirsep.$logo if ($logo !~ /^\//);

    if ($logo !~ /$dirsep/) {
	$file = $pathinit.$dirress.$dirsep.$logo;
    } else {
	if (!(-f $file)) {
	    $file = $pathserver.$logo;
	}
    }

    &error_exit("\nUnable to extract width size from image $file",1) if (!(-f "$file"));
    ($logo_width,$logo_height) = &imaxy("$file");

    &error_exit("\nImage width or height too large for display in logo $file",1) if ($logo_width > 400 || $logo_height > 100);

#    $logosmall_width = $logo_width/2;
#    $logosmall_height = $logo_height/2;
}


#
##############################################################
### Extract width and height from an image
##############################################################
#

# code by Patrick Atoon <patricka@cs.kun.nl> from his fiximg.pl script
# http://www.sci.kun.nl/thalia/guide/#fiximg

sub imaxy {
    local($file) = @_;
    local($a,$b,$c,$d,$e,$f,$g,$h);

# Define marker types
    $M_SOF0  = "\xC0";        $M_SOF3  = "\xC3";
    $M_SOF5  = "\xC5";        $M_SOF7  = "\xC3";
    $M_SOF9  = "\xC9";        $M_SOF11 = "\xCB";
    $M_SOF13 = "\xCD";        $M_SOF15 = "\xCF";
    $M_SOI   = "\xD8";        $M_EOI   = "\xD9";
    $M_SOS   = "\xDA";        $FF      = "\xFF";

    open(IMA,$file) || die &error_exit("Unable to open $file");

    binmode(IMA);

    local($magic) = '';
    eval { $magic = &read_n_bytes(2); };
    $@ = '';

    $jpgima = 0;
    $gifima = 0;
    $xbmima = 0;
    $pngima = 0;
    $tifima = 0;
#    $pnmima = 0;
    $pmbima = 0;

    ### XBM file
    if ($magic eq "#d") {
	$xbm++;
	$xbmima = 1;
	$a = (<IMA>);
	($a,$b,$width) = split(/ /,$a);
	$a = (<IMA>);
	($a,$b,$height) = split(/ /,$a);
	chop($width);
	chop($height);
	return($width, $height);
    }

    ### PNM file
#    if ( $magic =~ /P[1-6]/ ) {
#        local($buffer) = '';
#        $width = 0+&read_string($buffer);
#        $height = 0+&read_string($buffer);
#	$pnm++;
#	$pnmima = 1;
#        return($width, $height);
#    }

    ### JPEG file
    if ($magic eq "$FF$M_SOI") {
	$jpg++;
	$jpgima = 1;
	while ( 1==1 ) {
	    # Get the next marker
	    $db = 0; $ch = &read_1_byte;
	    if (!($ch)) {
		return(0, 0);
	    }
	    while ( $ch ne $FF ) {
		$db++; $ch = &read_1_byte;
	    };
	    $ch = &read_1_byte while ( $ch eq $FF );
#	    $db && die "Garbage data found in JPEG file : $file\n";
	    if ($db != 0) {
		print "Garbage data found in JPEG file : $file\n";
		return(0, 0);
	    }
	    	$www = unpack("C",$ch);
	    
	    # What type marker are we looking at?
    
	    # Do we have width and height yet?
	    if ( $ch ge $M_SOF0 && $ch le $M_SOF3 ||
		 $ch ge $M_SOF5 && $ch le $M_SOF7 ||
		 $ch ge $M_SOF9 && $ch le $M_SOF11 ||
		 $ch ge $M_SOF13 && $ch le $M_SOF15 ) {
		($l,$d,$height,$width) =
#		    unpack("SCSS",&read_n_bytes(7));
		    unpack("nCnn",&read_n_bytes(7));
		return($width, $height);
	    }
	    # Or have we reached the end of the header?
	    elsif ( $ch eq $M_SOS || $ch eq $M_EOI ) {
		&error_exit("Found no width or height in $file !",2);
		return(0, 0);
	    }
	    # Otherwise, skip this variable
	    else {	
	    
		$l = unpack("n",&read_n_bytes(2)) - 2;
		if ($l < 0 ) {
		    print "Erroneous JPEG marker length!\n";
		}
		&read_n_bytes($l);
#		return "$l,1000";

	    }
	} # while ( 1==1 )
    }

    ### Sun raster
    $magic .= &read_n_bytes(2);
#    if ( $magic eq "\x59\xa6\x6a\x95" ) {
#        ($width,$height) = unpack('NN',&read_n_bytes(8));
#        return($width, $height);
#    }

    ### Tiff
    if ( $magic eq "MM\x00\x2a" || $magic eq "II\x2a\x00" ) {
        # Appears to be a TIFF file

        local($order, $ifd, $len);
        local($tag, $type, $count);
        local($width, $height, $flag);

	$tif++;
	$tifima = 1;
        $order = ($magic eq "MM\x00\x2a");
        $ifd = ($order ? unpack('N', &read_n_bytes(4)) : unpack('V', &read_n_bytes(4)));
        $flag = 0;
        while ( $ifd ) {
            seek(IN, $ifd, 0);
            $len = ($order ? unpack('n', &read_n_bytes(2)) : unpack('v', &read_n_bytes(2)));
            for ( ; $len > 0; $len-- ) {
                ($tag, $type, $count, $offset) = ( $order ? unpack('nnNN', &read_n_bytes(12)) : unpack('vvVV', &read_n_bytes(12)));
                if ( $count == 1 && $type == 1 ) {
                    $offset >>= 24;
                } elsif ( $count == 1 && $type == 3 ) {
                    $offset >>= 16;
                }
		last if ($tag eq '');
                if ( $tag == 256 ) {
                    $width = $offset;
                    return($width, $height) if ( $flag );
                    $flag = 1;
                }
                if ( $tag == 257 ) {
                    $height = $offset;
                    return($width, $height) if ( $flag );
                    $flag = 1;
                }
            }
            $ifd = ($order ? unpack('N', &read_n_bytes(4)) : unpack('V', &read_n_bytes(4)));
        }
	&error_exit("Found no width or height in $file !",2);
	return(0, 0);
    }

    ### GIF file
    
    $magic .= &read_n_bytes(2);
    if ( $magic eq "GIF87a" || $magic eq "GIF89a" ) {
	($width,$height) = unpack('vv',&read_n_bytes(4));
	$gif++;
	$gifima = 1;
	return($width, $height);
    }

    ### PNG file

    $magic .= &read_n_bytes(2);
#    if ($magic eq "\x89\x50\x4e\x47\x0d\x0a\x1a\x0a") {
    if ($magic eq "\211PNG\r\n\032\n") {
	$magic = &read_n_bytes(4);
	$magic = &read_n_bytes(4);
	if ($magic eq "IHDR") {
	    $magic = &read_n_bytes(8);
	    $png++;
	    $pngima = 1;
	    ($a,$b,$c,$d,$e,$f,$g,$h)=unpack("C"x8,$magic);
	    return ($a<<24|$b<<16|$c<<8|$d, $e<<24|$f<<16|$g<<8|$h);
	}
    }

#    if (($gifima != 1) && ($jpgima != 1) && ($xbmima != 1) && ($pngima != 1) && ($pnmima != 1) && ($tifima != 1))
    if (($gifima != 1) && ($jpgima != 1) && ($xbmima != 1) && ($pngima != 1) && ($tifima != 1))
    {
        print "\"$file\" : unknown image format or unable to read this file\n";
        close(IMA);
	print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
        return "";
    }
    
    close(IMA);    
}    

#
##############################################################
### Return depth level from an URL
##############################################################
#

sub URLDepth {
    local($racine) = @_;
    local($tmp,$pos);

      $tmp = 0;
      $pos = length($racine);
      while (($pos = rindex($racine,$dirsepurl,$pos)) >= 0) {
	  $tmp++;
	  $pos--;
      }
    return $tmp;
}


#
##############################################################
### Return the number of lines in a file
##############################################################
#

sub line_file {
    local($file) = @_;
    local($line_file);

    if ($file =~ /$zipext$/) {
	open(INFILE, "$GZIP $file |");
    } else {
	open(INFILE, "$file");
    }
    while (<INFILE>) {
	$line_file++;
    }
    close(INFILE);

    return $line_file;
}


#
##############################################################
### Retrieve external log files
##############################################################
#

sub check_retrieve_logfile {
    local($dir) = @_;
    local($tmp);

    if (-d $dir) {
	opendir(SOURCEDIR,$dir);
	@filenames = readdir(SOURCEDIR);
	closedir(SOURCEDIR);
    }

    $tmp = 0;
    for ($i=0;$i<=$#filenames;$i++) {
	next if ($filenames[$i] eq '.');
	next if ($filenames[$i] eq '..');
	$tmp++ if ($filenames[$i] =~ /$prefixlog/);
    }

    return $tmp;
}

sub retrieve_external_logfile {
    local($fileroot,$remote_host_log,$file) = @_;
    local($tmp);

    $wget_option = "--no-directories -r -np --no-host-directories --directory-prefix=$fileroot ";
    $wget_option .= "--http-user=$wget_user --http-passwd=$wget_pass " if ($wget_user ne '');
    $wget_option .= "-q ";
    $wget_option .= "--timestamping ";

    if ($file eq '') {
#	$tmp = &check_retrieve_logfile($fileroot);
#	if ($tmp == 0) {
	    print "Retrieve remote log files\n";
	    print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET");

#	$tmp2 = $fileroot.$dirsep."*";
#	unlink(<$fileroot$dirsep*>) if -d $fileroot;

#	} else {
#	    return;
#	}
    } else {
	# retrieve new logfile $file
	# check if file already downloaded AND same size !
	if (!(-f $file) || $file eq "$fileroot$dirsep$prefixlog") {

	    print "Retrieve remote log $file\n";
	    print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	} else {
	    return;
	}
    }

#    $found_file = 0;
#    if ($file ne '') {
	# Check first spider mode
#	$wget_option_spider = $wget_option;
#	$wget_option_spider .= "--spider ";
#	$found_file = system("$cmd");
#	if ($found_file != 0) {
#	    print "The command to retrieve remote log $file failed : $cmd\n";
#	    exit;
#	}
#    }

    $cmd = "$wget_bin $wget_option $remote_host_log";
    $cmd .= ":$remote_host_port" if ($remote_host_port ne '');
    $cmd .= "$remote_host_dir" if ($remote_host_dir ne '');
#    $cmd .= "$dirsep$remote_host_dir" if ($remote_host_dir ne '');
    $tmp = $file;
    $tmp =~ s/$fileroot//;
    $cmd .= "$dirsep$tmp" if ($file ne '');

    print "Command : $cmd\n";
    $commit = system("$cmd"); # if ($found_file == 0);
    if ($commit != 0) {
	$msg = "The command to retrieve remote log files failed ($cmd)\n" if ($file eq '');
	$msg = "The command to retrieve remote log $file failed ($cmd)\n" if ($file ne '');
	&error_exit($msg);
    }

    # remove *gif file and index*
    $tmp = $fileroot.$dirsep."index";
    unlink(<$tmp*>);
    unlink(<$fileroot$dirsep*$gifext>);
}

sub InitRSS {
    local($filename) = @_;
    local($i,$j,$tmp);

    $pos = rindex($path,$pathserver);
    if ($pos != -1) {
	$tmp = length($pathserver);
	$link = substr($path,$tmp,length($path));
    }

##    &InitRSSCSS($filename) if (!(-f "$path$filename$cssext"));

    if (!(-f "$path$filename$xmlext")) {
	open(FILERSS,">$path$filename$xmlext") || die &error_exit("Unable to open $path$filename$xmlext");
	print FILERSS "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n";
##	print FILERSS "<?xml-stylesheet type=\"text/css\" href=\"$filename$cssext\" ?>\n";
	print FILERSS "<rss version=\"2.0\" xmlns:atom=\"http://www.w3.org/2005/Atom\">\n";
	print FILERSS "\n<channel>\n";

	print FILERSS "\n<atom:link href=\"$localhost_protocol://$localhost$dirsepurl$filerss$xmlext\" rel=\"self\" type=\"application/rss+xml\" />\n";

	print FILERSS "\t<title>Stats - $localserver</title>\n";
	print FILERSS "\t<link>$localserver_protocol://$localserver$dirsepurl$link</link>\n";
	print FILERSS "\t<description>Stats - $localserver</description>\n";
	print FILERSS "\t<ttl>600</ttl>\n";
	print FILERSS "\t<image>\n";
	print FILERSS "\t\t<title>Stats</title>\n";
	print FILERSS "\t\t<url>";
	print FILERSS "$logo" if ($logo =~ /^http/);
	if ($logo =~ /^\//) {
	    print FILERSS "$localhost_protocol://$localhost";
	    print FILERSS ":$localhost_port" if ($localhost_port != 80);
	    print FILERSS "$logo";
	}
	if ($logo !~ /^\// && $logo !~ /^http/) {
	    print FILERSS "$localhost_protocol://$localhost";
	    print FILERSS ":$localhost_port" if ($localhost_port != 80);
	    print FILERSS "$dirsepurl$link$dirress$dirsepurl$logo";
	}
	print FILERSS "</url>\n";
	print FILERSS "\t\t<link>$localhost_protocol://$localhost";
	print FILERSS ":$localhost_port" if ($localhost_port != 80);
	print FILERSS "$dirsepurl$link</link>\n";
#	print FILERSS "</link>\n";
	print FILERSS "\t\t<width>$logo_width</width>\n";
	print FILERSS "\t\t<height>$logo_height</height>\n";
	print FILERSS "\t</image>\n";

	print FILERSS "\n</channel>\n";
	print FILERSS "</rss>\n";
	close(FILERSS);
    }
}

sub InitRSSCSS {
   local($filename) = @_;
   local($i,$j,$tmp);

    if (!(-f "$path$filename$cssext")) {
	open(FILERSS,">$path$filename$cssext") || die &error_exit("Unable to open $path$filename$cssext");
	print FILERSS "rss {\n";
	print FILERSS "  display: block;\n";
	print FILERSS "    font-family: verdana, arial;\n";
	print FILERSS "}\n";
	print FILERSS "title {\n";
	print FILERSS "display: block;\n";
	print FILERSS "margin: 5px;\n";
	print FILERSS "padding: 2px;\n";
	print FILERSS "color: gray;\n";
	print FILERSS "border-bottom: 1px solid silver;\n";
	print FILERSS "}\n";
	print FILERSS "link {\n";
	print FILERSS "display: block;\n";
	print FILERSS "font-size: small;\n";
	print FILERSS "padding-left: 10px;\n";
	print FILERSS "}\n";
	print FILERSS "item {\n";
	print FILERSS "display: block;\n";
	print FILERSS "padding: 2px 30px 2px 30px;\n";
	print FILERSS "}\n";
	print FILERSS "docs {\n";
	print FILERSS "display: block;\n";
	print FILERSS "background-color: #ffffe6;\n";
	print FILERSS "margin: 20px;\n";
	print FILERSS "text-align: center;\n";
	print FILERSS "padding: 5px;\n";
	print FILERSS "color: #7f7f7f;\n";
	print FILERSS "border: 1px solid silver;\n";
	print FILERSS "}\n";
	print FILERSS "/* all hidden elements */\n";
	print FILERSS "language, lastBuildDate, ttl, guid, category, description, pubDate {\n";
	print FILERSS "display: none;\n";
	print FILERSS "}\n";

	close(FILERSS);
    }
}

sub BuildRSS {
    local($filename,$val,$date,$linkfile) = @_;
#    local($i,$j,$tmp,$tmp2,$found,$day_nb,$week_nb,$month_nb,$nb_item,@lines);
    local($i,$j,$tmp,$tmp2,$found,$week_nb,$month_nb,$nb_item,@lines);
    local($new_item,$date2);

    $pos = rindex($path,$pathserver);
    if ($pos != -1) {
	$tmp = length($pathserver);
	$link = substr($path,$tmp,length($path));
    }

    $linkfile =~ s/\.\.$dirsepurl//g;

    @item = split(/\|/,$val);
    $format_date = $date;

    $new_item = "\n\t<item>\n";
    $new_item .= "\t\t<title>";
    if ($date =~ /^(\w{3})\s(\d{4})$/) {
	$new_item .= "Month : ";
	# Get next month
	$tmp = $month_equiv{$1};
	$tmp = $month_nb[$tmp];	
	$format_date = "01 $tmp $2";
    } 
    if ($date =~ /^\d{4}$/) {
	$tmp = $date+1;
	$format_date = "01 Jan $tmp";
    }
    $new_item .= "Year : " if ($date =~ /^\d{4}$/);
    $new_item .= "Week : " if ($date =~ /^\d{2}\s\w{3}\s\d{4}\s\//);
    $new_item .= "Day : " if ($date =~ /^\d{2}\s\w{3}\s\d{4}$/);
    $new_item .= "$wday " if ($wday ne '');
    $new_item .= "$date</title>\n";
    $new_item .= "\t\t<link>$localhost_protocol://$localhost";
    $new_item .= ":$localhost_port" if ($localhost_port != 80);
    $new_item .= "$linkpath_url$lang[0]$dirsepurl$linkfile</link>\n";
    $new_item .= "\t\t<guid isPermaLink=\"true\">$localhost_protocol://$localhost";
    $new_item .= ":$localhost_port" if ($localhost_port != 80);
    $new_item .= "$linkpath_url$lang[0]$dirsepurl$linkfile</guid>\n";
    $new_item .= "\t\t<description>\n";
    $new_item .= "\t\t<![CDATA[\n";
    for ($j=0;$j<=$#item;$j++) {
	($val1,$val2) = split(/ : /,$item[$j]);
	$new_item .= "\t\t$val1 : <B>$val2</B><BR>\n";
    }
    $new_item .= "\t\t]]>";
    $new_item .= "\n\t\t</description>\n";
    $new_item .= "\t</item>\n";
    
    &InitRSS($filename) if (!(-f "$path$filename$xmlext"));

    open(FILERSS,"$path$filename$xmlext") || die &error_exit("Unable to open $filename$xmlext");	
    @lines = (<FILERSS>);
    close(FILERSS);

    $found = 0;
    $item_found_nb = 0;
    $tmp2 = $wday." " if ($wday ne '');
    $tmp2 .= $date;
    $item_number = 0;
   
 # Search for date
    for ($i=0;$i<=$#lines;$i++) {
	$found = 1 if ($lines[$i] =~ /<item>/);
	next if ($found == 0);
	if ($lines[$i] =~ /<title>/) {
	    $item_found_nb++;
	    $tmp = $lines[$i];
	    chop($tmp);
	    $tmp =~ s/<title>//;
	    $tmp =~ s/<\/title>//;
	    $tmp =~ s/\t//g;
	    $week_nb++ if ($tmp =~ /^Week/);
	    $month_nb++ if ($tmp =~ /^Month/);
	    if ($tmp =~ /^Day/) {
		$tmp =~ s/Day : //;
		$tmp =~ s/^\w\w\w\s//;
	    } 
	    $tmp =~ s/Week : //;
	    $tmp =~ s/Month : //;
	    $tmp =~ s/Year : //;
	    if ($format_date =~ /$tmp$/) {
		$item_number = $item_found_nb;
		$item_number++ if ($date =~ /^\w{3}\s\d{4}$/);
		$item_number++ if ($date =~ /^\d{4}$/);
	    }
#	    print "MM $tmp - $format_date - $item_number\n";
	    return if ($tmp eq $date)
	}
    }

    $out = 0;
    $item_inserted = 0;
    $first_item = 0;
    open(FILERSS,">$path$filename$xmlext") || die &error_exit("Unable to open $filename$xmlext");
    for ($i=0;$i<=$#lines;$i++) {
	$insert = 0;
	if ($item_number > 0 && $lines[$i] =~ /^\t<item>/) {
	    $nb_item++;
	    $insert = 1 if ($nb_item == $item_number);
	}

	if ($item_number == 0 && $lines[$i] =~ /^\t<\/image>/) {
	    $first_item = 1;
	}

#	$out = 1 if ($nb_item > $nb_rss_item);
	$out = 1 if ($lines[$i] =~ /^<\/channel>/);

	print FILERSS "$lines[$i]" if ($out == 0 && $insert == 0);

	if ((($nb_item == $item_number && $item_number > 0) || $first_item == 1) && $item_inserted == 0) {
	    print FILERSS "$new_item";
	    $item_inserted = 1;
	    $insert = 0;
	    print FILERSS "\n$lines[$i]" if ($nb_item == $item_number && $item_number > 0);
	}

    }
    print FILERSS "</channel>\n";
    print FILERSS "</rss>\n";
    close(FILERSS);
}


sub BuildRequestsGraph {
    local($filename,$output_dir,$count_day,$start_date,$ref,$ref1,$ref2,$ref3,$ref4,$ref5,$ref6) = @_;
    local($val1,$val2,$val3,$hourly,$file1,$file1x,$file1y,$tmp6);
    local($bargraph,$linegraph,$fillgraph,$tridim);
    local($reqmax,$maxtot,$tmp3,$msg);
    local(@date_value,@reqmaxtot,@accessmaxtot,@mmaxtot,@sizetot,@docmaxtot,@spammaxtot);

    @date_value = @$ref;
    @reqmaxtot = @$ref1;
    @accessmaxtot = @$ref2;
    @mmaxtot = @$ref3;
    @sizetot = @$ref4;
    @docmaxtot = @$ref5;
    @spammaxtot = @$ref6;

    $hourly = 0;
    $map = '';

    $bargraph = 1;
    $linegraph = 0;
    $fillgraph = 0;
    $tridim = 1;

    if ($count_day > 100) {
	$bargraph = 0;
	$linegraph = 1;
	$fillgraph = 0;
	$tridim = 0;
    }

    if ($filename =~ /$csvext$/) {
	$filename =~ s/$csvext//;
	$hourly = 1;
    }

    $filename =~ s/\s/_/g;

    $file1 = $path.$output_dir.$dirsep.$filename.$gifext;
    $file1x = $path.$output_dir.$dirsep.$filename."x".$gifext;
    $file1y = $path.$output_dir.$dirsep.$filename."y".$gifext;

    $it = length($count_day)-1;
    $div = 10**$it;
    $factx = ($div*(int($count_day/$div)+1))/$grad;

    $reqmax = 0;
    $maxtot = 0;

    for ($i=0;$i<$count_day;$i++) {
	$reqmax = $reqmaxtot[$i] if ($reqmaxtot[$i] > $reqmax);
	$maxtot = $sizetot[$i] if ($sizetot[$i] > $maxtot);
    }

    return if ($reqmax == 0);

    if ($maxtot > (1024*1024*1024*1024)) {
	$tmp3 = 1024*1024*1024*1024;
	$unit = "Tb";
    }

    if ($maxtot > (1024*1024*1024) && $maxtot <= (1024*1024*1024*1024)) {
	$tmp3 = 1024*1024*1024;
	$unit = "Gb";
    }

    if ($maxtot > (1024*1024) && $maxtot <= (1024*1024*1024)) {
	$tmp3 = 1024*1024;
	$unit = "Mb";
    }
    if ($maxtot > 1024 && $maxtot <= (1024*1024)) {
	$tmp3 = 1024;
	$unit = "Kb";
    }

    if ($maxtot <= 1024) {
	$tmp3 = 1;
	$unit = "bytes";
	$unit = "" if ($maxtot == 0);
    }

    $it = length($reqmax)-1;
    $div = 10**$it;
    $facty = ($div*(int($reqmax/$div)+1))/$grad;

    $fymax = $ymax-2;

    $perspec = $xstep/$factx if (($perspec > $xstep/$factx) && ($tridim == 1));

    ### image pour les abscisses

    ($startday, $startmonth) = split(/ /,$start_date);

    $moischiffre = $month_equiv{$startmonth};
    $moischiffre--;
    $moisvar = $startmonth;
    $valmois = $moischiffre;

    $valstep = $startday;
    $valstep = "0".$valstep if (length($valstep) == 1);

    $xlegend = "$count_day days (starting $start_date)" if ($hourly == 0);
    $xlegend = "$count_day hours ($start_date)" if ($hourly == 1);

    open(FLY,">$tmpfly$vtmp");
    print FLY "new\n";
    print FLY "size $xmax,$ydecal\n";
    print FLY "frect 0,0,$xmax,$ydecal,200,200,200\n";
    $posx = (($xmax/2)-(length($xlegend)*7/2));
    print FLY "string 0,0,0,$posx,$ydecalm,medium,$xlegend\n";
    $tmp = $xstep;
    $tmp = int($xmax/24) if ($hourly == 1);

    for ($i=$tmp;$i<$xmax;$i+=$tmp) {
	$valstep = int(($i/$xmax)*(($xmax*$factx/$xstep)));
	$valstep += $startday if ($hourly == 0);

	$moisvar = $startmonth;
	$valmois = $moischiffre;
	
	while  ($valstep > $month_of_year{$moisvar}) {
	    $valstep = ($valstep - $month_of_year{$moisvar});
	    $valmois++;
	    $valmois = 0 if ($valmois > 11);
	    $moisvar = $month_nb[$valmois];
	}

	$valstep = "0".$valstep if (length($valstep) == 1);
	$val = "$moisvar/$valstep" if ($hourly == 0);
	$val = "$valstep" if ($hourly == 1);
	$posx = $i - length($valstep)*10;
	$posx = $i - length($valstep)*3 if ($hourly == 1);
	print FLY "line $i,0,$i,5,0,0,0\n";
	print FLY "string 0,0,0,$posx,10,small,$val\n";
	last if ($valstep == 24 && $hourly == 1);
    }
    print FLY "transparent 200,200,200\n";
    close (FLY);
    
    &BuildFly("$tmpfly$vtmp",$file1x);

### image pour les ordonnees
 
    open(FLY,">$tmpfly$vtmp");
    print FLY "new\n";
    print FLY "size $xdecal,$ymax\n";
    print FLY "frect 0,0,$xdecal,$ymax,200,200,200\n";
    for ($i=$ystep;$i<$ymax;$i+=$ystep) {
	$valstep = int(($ymax - $i) * ($facty/$ystep));
	print FLY "line $xdecalm,$i,$xdecal,$i,0,0,0\n";
	$pos = ($xdecal - length($valstep)*9);
	$posy = $i-5;
	print FLY "string 0,0,0,$pos,$posy,small,$valstep\n";
    }
    print FLY "transparent 200,200,200\n";
    close (FLY);
 
    &BuildFly("$tmpfly$vtmp",$file1y);

###

    open(FLY,">$tmpfly$vtmp");
    print FLY "new\n";
    print FLY "size $xmax,$ymax\n";
    print FLY "frect 0,0,$xmax,$ymax,200,200,200\n"; 
    for ($i=1;$i<=$count_day;$i++) {
	$x1 = ($i-1+$tridim)*$xstep/$factx;
	$x2 = ($i+$tridim)*$xstep/$factx;

	$i2 = $i-1;
	$y2 = $ymax - ($ystep/$facty * $reqmaxtot[$i2]);

	$x1 = $x1 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);
	$x2 = $x2 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);

	$x2 -= $perspec if ($tridim == 1);
	$x1 -= $perspec if ($tridim == 1);

	$y2db = $ymax - ($ystep/$facty * $reqmaxtot[$i2])+1;

	$fymax = $ymax-2;
	$linkjour = "#";

	if ($hourly == 0) {
	    ($val1,$val2,$val3) = split(/[\s\-]/,$date_value[$i2]);

	    $linkjour = "..".$dirsepurl.$date_value[$i2].$dirsepurl.$menu;
	    $fulljour = $path.$lang[0].$dirsep.$dirdate.$dirsep.$date_value[$i2].$dirsep.$menu;

	    $tmp2 =  int($sizetot[$i2]*100/$tmp3)/100;
	    $tmp4 = "Requests" if ($cups_format == 0);
	    $tmp4 = "Pages" if ($cups_format == 1);
	    $tmp4 .= " : $reqmaxtot[$i2]|";
	    if ($ftp_format == 0 && $mail_format == 0 && $dhcp_format == 0) {
		$tmp4 .= "Accesses" if ($cups_format == 0);
		$tmp4 .= "Files" if ($cups_format == 1);
		$tmp4 .= " : $accessmaxtot[$i2]|";
	    }
	    $tmp4 .= "Spam : $spammaxtot[$i2]|" if ($spam_on == 1);
	    $tmp4 .= "Documents : $docmaxtot[$i2]|" if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0);
	    $tmp4 .= "Hosts : $mmaxtot[$i2]";
	    $tmp4 .= "|Traffic : $tmp2 $unit" if ($notrafic == 0);

	    $tmp = $val3."-".$val2."-".$val1;
	    if ($tmp eq "--") {
		$msg = "\nFATAL ERROR :\n";
		$msg .= "=> Date number $i2 extracted from \$date_value is null\n";
		&error_exit($msg,4);
	    }
	    $wday = $day_of_week[(localtime(&nbday("$tmp")*86400))[6]];

	    $map .= "<AREA SHAPE=\"rect\" COORDS=\"$x1,0,$x2,$ymax\" HREF=\"$tabnamedays#$i2\" ALT=\"$tmp\" onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$wday $tmp','$tmp4','','$tabnamedays#$num',1,'display','$popup_graph_width')\">\n" if (!(-e $fulljour) && $reqmaxtot[$i2] != 0);
	    $map .= "<AREA SHAPE=\"rect\" COORDS=\"$x1,0,$x2,$ymax\" HREF=\"$linkjour\" ALT=\"$tmp\" onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$wday $tmp','$tmp4','','$linkjour',1,'display','$popup_graph_width')\">\n" if (-e $fulljour);
	} else {

	    $tmp2 =  int($sizetot[$i2]*100/$tmp3)/100;
	    $tmp4 = "Requests" if ($cups_format == 0);
	    $tmp4 = "Pages" if ($cups_format == 1);
	    $tmp4 .= " : $reqmaxtot[$i2]|";

	    if ($ftp_format == 0 && $mail_format == 0 && $dhcp_format == 0) {
		$tmp4 .= "Accesses" if ($cups_format == 0);
		$tmp4 .= "Files" if ($cups_format == 1);
		$tmp4 .= " : $accessmaxtot[$i2]|";
	    }
	    $tmp4 .= "Spam : $spammaxtot[$i2]|" if ($spam_found != 0 || $spam_on == 1);
	    $tmp4 .= "Documents : $docmaxtot[$i2]|" if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0);
	    $tmp4 .= "Hosts : $mmaxtot[$i2]";
	    $tmp4 .= "|Traffic : $tmp2 $unit" if ($notrafic == 0);

	    $tmp6 = $date_value[$i2]+1;
	    $tmp6 = "0".$tmp6 if (length($tmp6) == 1);
	    $tmp = $date_value[$i2]." h - ".$tmp6." h";

#	$map .= "<AREA SHAPE=\"rect\" COORDS=\"$x1,0,$x2,$ymax\" HREF=\"$linkjour\" ALT=\"$tmp\" onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$wday $tmp','$tmp4','','$linkjour',1,'$popup_graph_width')\">\n" if (-e $fulljour);
	    $map .= "<AREA SHAPE=\"rect\" COORDS=\"$x1,0,$x2,$ymax\"  HREF=\"$linkjour\" ALT=\"$tmp\" onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$tmp','$tmp4','','$linkjour',1,'','$popup_graph_width')\">\n" if ($reqmaxtot[$i2] != 0);
	}


	if ($bargraph == 1) {

	    print FLY "frect $x1,$y2,$x2,$ymax,$red[0],$green[0],$blue[0]\n";
	    print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n"; 

	    if ($y2 != $ymax) {

		$x1plus = $x1+$perspec;
		$x2plus = $x2+$perspec;
		$y2plus = $y2-$perspec;
		$y1plus = $ymax - $perspec;

		print FLY "fpoly $red[0],$green[0],$blue[0],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
		print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
	    
		print FLY "fpoly $red[0],$green[0],$blue[0],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
		print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
		
	    }
	}

	if ($linegraph == 1) {
	    $y1 = $ymax - ($ystep/$facty * $reqmaxtot[$i2+1]);
	    $y1db = $ymax - ($ystep/$facty * $reqmaxtot[$i2+1])+1;
	    print FLY "line $x1,$y2,$x2,$y1,$red[0],$green[0],$blue[0]\n";
	    print FLY "line $x1,$y2db,$x2,$y1db,$red[0],$green[0],$blue[0]\n";

	    if ($fillgraph == 1) {
		$fx1 = ($x1+$x2)/2;
		$fx1 = $x2 if ($fx1 < ($x1+1.5));
		if ($fx1 < $x2 && ($y2 < $fymax || $y1 < $fymax)) {
		    print FLY "line $x1,$ymax,$x1,$y2,$red[0],$green[0],$blue[0]\n";
		    print FLY "line $x2,$ymax,$x2,$y1,$red[0],$green[0],$blue[0]\n";

		    print FLY "line $x1,$ymax,$x2,$ymax,$red[0],$green[0],$blue[0]\n";
		    print FLY "fill $fx1,$fymax,$red[0],$green[0],$blue[0]\n";
		}
	    }
	    
	}

    }

    close (FLY);

   if ($spam_on == 1) {
	open(FLY,">>$tmpfly$vtmp");
	for ($i=1;$i<=$count_day;$i++) {

	    $x1 = ($i-1+$tridim)*$xstep/$factx;
	    $x2 = ($i+$tridim)*$xstep/$factx;
	    
	    $x1 = $x1 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);
	    $x2 = $x2 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);

	    $i2 = $i-1;
	    $y2 = $ymax - ($ystep/$facty * $spammaxtot[$i2]);
	    $y2db = $ymax - ($ystep/$facty * $spammaxtot[$i2])+1;

	    if ($bargraph == 1) {
		$x1 += $factx*$shift_factor;
		$x2 += $factx*$shift_factor;
		$x2 -= $perspec*2 if ($tridim == 1);
		$x1 -= $perspec*2 if ($tridim == 1);
		print FLY "frect $x1,$y2,$x2,$ymax,$red[1],$green[1],$blue[1]\n";
		print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n"; 

		if ($y2 != $ymax) {
		    
		    $x1plus = $x1+$perspec;
		    $x2plus = $x2+$perspec;
		    $y2plus = $y2-$perspec;
		    
		    print FLY "fpoly $red[1],$green[1],$blue[1],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
		    print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
		    
		    print FLY "fpoly $red[1],$green[1],$blue[1],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";
		    print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";

		}
	    }


	if ($linegraph == 1) {
	    $y1 = $ymax - ($ystep/$facty * $spammaxtot[$i2+1]);
	    $y1db = $ymax - ($ystep/$facty * $spammaxtot[$i2+1])+1;
	    print FLY "line $x1,$y2,$x2,$y1,$red[1],$green[1],$blue[1]\n";
	    print FLY "line $x1,$y2db,$x2,$y1db,$red[1],$green[1],$blue[1]\n";

	    if ($fillgraph == 1) {
		$fx1 = ($x1+$x2)/2;
		$fx1 = $x2 if ($fx1 < ($x1+1.5));
		if ($fx1 < $x2 && ($y2 < $fymax || $y1 < $fymax)) {
		    print FLY "line $x1,$ymax,$x1,$y2,$red[1],$green[1],$blue[1]\n";
		    print FLY "line $x2,$ymax,$x2,$y1,$red[1],$green[1],$blue[1]\n";

		    print FLY "line $x1,$ymax,$x2,$ymax,$red[1],$green[1],$blue[1]\n";
		    print FLY "fill $fx1,$fymax,$red[1],$green[1],$blue[1]\n";
		}
	    }
	    
	}
	}
	close (FLY);
    }

#    if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0) {
    if ($ftp_format == 0 && $mail_format == 0 && $dhcp_format == 0) {
	open(FLY,">>$tmpfly$vtmp");
	for ($i=1;$i<=$count_day;$i++) {

	    $x1 = ($i-1+$tridim)*$xstep/$factx;
	    $x2 = ($i+$tridim)*$xstep/$factx;
	    
	    $x1 = $x1 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);
	    $x2 = $x2 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);

	    $i2 = $i-1;
	    $y2 = $ymax - ($ystep/$facty * $accessmaxtot[$i2]);
	    $y2db = $ymax - ($ystep/$facty * $accessmaxtot[$i2])+1;	    
	    if ($bargraph == 1) {
		$x1 += $factx*$shift_factor;
		$x2 += $factx*$shift_factor;
		$x2 -= $perspec*2 if ($tridim == 1);
		$x1 -= $perspec*2 if ($tridim == 1);
		print FLY "frect $x1,$y2,$x2,$ymax,$red[1],$green[1],$blue[1]\n";
		print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n"; 

		if ($y2 != $ymax) {
		    
		    $x1plus = $x1+$perspec;
		    $x2plus = $x2+$perspec;
		    $y2plus = $y2-$perspec;
		    
		    print FLY "fpoly $red[1],$green[1],$blue[1],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
		    print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
		    
		    print FLY "fpoly $red[1],$green[1],$blue[1],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";
		    print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";

		}
	    }


	if ($linegraph == 1) {
	    $y1 = $ymax - ($ystep/$facty * $accessmaxtot[$i2+1]);
	    $y1db = $ymax - ($ystep/$facty * $accessmaxtot[$i2+1])+1;
	    print FLY "line $x1,$y2,$x2,$y1,$red[1],$green[1],$blue[1]\n";
	    print FLY "line $x1,$y2db,$x2,$y1db,$red[1],$green[1],$blue[1]\n";

	    if ($fillgraph == 1) {
		$fx1 = ($x1+$x2)/2;
		$fx1 = $x2 if ($fx1 < ($x1+1.5));
		if ($fx1 < $x2 && ($y2 < $fymax || $y1 < $fymax)) {
		    print FLY "line $x1,$ymax,$x1,$y2,$red[1],$green[1],$blue[1]\n";
		    print FLY "line $x2,$ymax,$x2,$y1,$red[1],$green[1],$blue[1]\n";

		    print FLY "line $x1,$ymax,$x2,$ymax,$red[1],$green[1],$blue[1]\n";
		    print FLY "fill $fx1,$fymax,$red[1],$green[1],$blue[1]\n";
		}
	    }
	    
	}
	}
	close (FLY);
    }

    open(FLY,">>$tmpfly$vtmp");
    for ($i=1;$i<=$count_day;$i++) {

	$x1 = ($i-1+$tridim)*$xstep/$factx;
	$x2 = ($i+$tridim)*$xstep/$factx;

	$x1 = $x1 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);
	$x2 = $x2 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);
		
	$i2 = $i-1;
	$y2 = $ymax - ($ystep/$facty * $mmaxtot[$i2]);
	$y2db = $ymax - ($ystep/$facty * $mmaxtot[$i2])+1;
	if ($bargraph == 1) {
	    $x1 += $factx*2*$shift_factor;
	    $x2 += $factx*2*$shift_factor;
	    $x2 -= $perspec*3 if ($tridim == 1);
	    $x1 -= $perspec*3 if ($tridim == 1);
	    print FLY "frect $x1,$y2,$x2,$ymax,$red[2],$green[2],$blue[2]\n";
	    print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n"; 

	    if ($y2 != $ymax) {
		
		$x1plus = $x1+$perspec;
		$x2plus = $x2+$perspec;
		$y2plus = $y2-$perspec;
		
		print FLY "fpoly $red[2],$green[2],$blue[2],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
		print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";

		print FLY "fpoly $red[2],$green[2],$blue[2],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";
		print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";
		
	    }
	}

	if ($linegraph == 1) {
	    $y1 = $ymax - ($ystep/$facty * $mmaxtot[$i2+1]);
	    $y1db = $ymax - ($ystep/$facty * $mmaxtot[$i2+1])+1;
	    print FLY "line $x1,$y2,$x2,$y1,$red[2],$green[2],$blue[2]\n";
	    print FLY "line $x1,$y2db,$x2,$y1db,$red[2],$green[2],$blue[2]\n";

	    if ($fillgraph == 1) {
		$fx1 = ($x1+$x2)/2;
		$fx1 = $x2 if ($fx1 < ($x1+1.5));
		if ($fx1 < $x2 && ($y2 < $fymax || $y1 < $fymax)) {
		    print FLY "line $x1,$ymax,$x1,$y2,$red[2],$green[2],$blue[2]\n";
		    print FLY "line $x2,$ymax,$x2,$y1,$red[2],$green[2],$blue[2]\n";

		    print FLY "line $x1,$ymax,$x2,$ymax,$red[2],$green[2],$blue[2]\n";
		    print FLY "fill $fx1,$fymax,$red[2],$green[2],$blue[2]\n";
		}
	    }
	    
	}


    }

    print FLY "transparent 200,200,200\n";

    &BuildFly("$tmpfly$vtmp",$file1);
}

sub Extract_WebUrlLink {
    local($file,$found,$tmp3,$dir);
    local($msg);

    $file = $path;

    while ($found == 0 && $file ne '') {
	chop($file);
	$tmp3 = substr($file,(rindex($file,'/')+1),length($file));
	$dir = $pathserver.$tmp3;
#	print "\nA0 - $dir\n";

	if (-d $dir) {
	    $found = 1;
	    $linkpath_url = $dirsepurl.substr($path,rindex($file,$dirsepurl)+1,length($path));
	    $found = 0 if (!(-d "$pathserver$linkpath_url"));
#	    print "OK - $dir - $linkpath_url - $found<BR>\n";
	}

	$file =~ s/$tmp3$//;
#	print "A - $tmp3 - $file<BR>\n" if ($found == 0);
	if ($tmp3 eq '') {
	    $msg = "Unable to extract output URL\n";
	    $msg .= "Please update your configuration file and add a value for \$linkpath_url\n";
	    $msg .= "which is the w3perl output URL from your webserver root\n";
	    $msg .= "(if \$path is set to \"/var/www/html/stats/demo/\", \$linkpath_url should be \"/stats/demo/\")\n";
#	    print "AA $msg\n";
	    &error_exit($msg,3);
	}

#	&error_exit("Unable to extract url path from web server",1) if ($tmp3 eq '');

    }
    $linkpath_url = "/w3perl/" if (substr($pathinit,1,1) eq ':' && $opt_n eq ''); # Real time stats should not use default
    return  $linkpath_url;
}

sub InitProgressBar {
    local($barfiletmp,$scriptname,$reverse_dns) = @_;
    local($link);

#    $scriptname =~ s/$plext//;
    $scriptname .= "-" if ($barfiletmp ne '');

    $link = $linkpath_url;

    if (substr($pathinit,1,1) eq ':') {
	$pos = rindex($pathinit,$pathserver);
	if ($pos != -1) {
	    $tmp = length($pathserver)-1;
	    $link = substr($pathinit,$tmp,length($pathinit));
	} else {
	    $msg = "\$pathinit and \$pathserver should be on the same disk\n";
	    $link = "/w3perl/";
	}
    }

    print "<BR>" if ($scriptname !~ /cron-hour/);;
    print "<span id=\"$scriptname$barfiletmp\">0%</span>\n" if ($reverse_dns == 0);
    print "<span id=\"$scriptname$barfiletmp\">0.0%</span>\n" if ($reverse_dns == 1);
    
    print "<script language=\"javascript\" type=\"text/JavaScript\">\n";
    print "$barfiletmp = new JS_BRAMUS.jsProgressBar(\$('$scriptname$barfiletmp'),0,{boxImage: '$link$dirress$dirsepurl$percentage_ima_bkg', barImage: '$link$dirress$dirsepurl$percentage_ima'});\n";
    print "</script>\n";

}

sub StatusCompleted {
    local($scriptname,$status_script,$msg) = @_;
    chomp($msg);
    $msg =~ s/<BR>//g;
    open(FILESTATUS,">$path$incstatus$txtext");
    print FILESTATUS "$scriptname\t100\t$status_script\t$msg\n";
    close(FILESTATUS);
}


#
##############################################################
### Check external link
##############################################################
#

# code by Darryl Burgdorf <burgdorf@awsd.com> from his webtester.pl script
# http://awsd.com/scripts/

sub check_external_link {
    local($host,$port,$path) = @_;
    local($name,$aliases,$proto,$type,$len,$protocol,$status);
    local($thisaddr,$thataddr,$this,$that,$response);

    $AF_INET = 2;
    $sockaddr = 'S n a4 x8';
    chop($hostname = `hostname`);

    $SOCK_STREAM = 1;	
    ($name,$aliases,$proto) = getprotobyname('tcp');
    ($name,$aliases,$port) = getservbyname($port,'tcp') unless $port =~ /^\d+$/;
    ($name,$aliases,$type,$len,$thisaddr) = gethostbyname($hostname);
    if (!(($name,$aliases,$type,$len,$thataddr) = gethostbyname($host))) {
	return -1;
    }
    $this = pack($sockaddr, $AF_INET, 0, $thisaddr);
    $that = pack($sockaddr, $AF_INET, $port, $thataddr);
    if (!(socket(S, $AF_INET, $SOCK_STREAM, $proto))) {
	$SOCK_STREAM = 2;
	if (!(socket(S, $AF_INET, $SOCK_STREAM, $proto))) { return -2; }
    }
    if (!(bind(S, $this))) {
	return -3;
    }
    if (!(connect(S,$that))) {
	return -4;
    }
    select(S); $| = 1; select(STDOUT);
    print S "HEAD $path HTTP/1.0\n\n";

    $response = <S>;
    ($protocol, $status) = split(/ /, $response);
    close(S);
    return $status;	
}

#
##############################################################
### Check email address
##############################################################
#

sub check_email_adr {
    local($email) = @_;
    local($ok,$err,$j);
    $err = 0;
    $ok = '1234567890qwertyuiop[]asdfghjklzxcvbnm.@-_QWERTYUIOPASDFGHJKLZXCVBNM';

    # check character valid
    for ($j=0;$j<length($email);$j++) {
	$err = -1 if (index($ok,substr($email,$j,1)) < 0);
    }
    
    # check expr
    $err = 2 if ($email !~ /^\w+((-\w+)|(\.\w+))*\@[A-Za-z0-9]+((\.|-)[A-Za-z0-9]+)*\.[A-Za-z0-9]+$/);

    return $err;
}

#
##############################################################
### Fly/Flydraw 
##############################################################
#

sub BuildFly {
    local($input,$output) = @_;

    if ($FLY =~ /flydraw/i) {
	$commit = system("$FLY < $input > $output");
    } else {
	open(FOO,"$FLY -q -i $input -o $output |");
	while (<FOO>) {print;}
	close(FOO);
    }
    unlink("$tmpfly$vtmp");
}


#
##############################################################
### Sanitize input field
##############################################################
#

sub escape_input {
    local($val);

    $val =~ s/([;<>\*\|`&\$!?#\(\)\[\]\{\}:'"\\])/\\$1/g;
    return $val;
}

#
##############################################################
### Load incremental data
##############################################################
#

sub load_inc_data {
    local($path,$init_inc) = @_;
    local($line);

    if ($init_inc == 0) {

	undef %serverdate;
	undef %server;
	undef @listadresse;
	undef @listadresseold;
	undef %nbpageserveur;
	undef %nbpageserveurunique;
	undef %serversize;
	undef %pays_ip if ($reverse_geo == 1);
	undef %localserverdate;
	undef %localserver;
	undef %localserversize;

	undef %domaindate;
	undef %domaindateip if ($reverse_geo == 1);
	undef %found;

	undef %sizepays;
	undef %payslist;
	undef %payshtml;
	undef %serverpays;

	undef %downloadext;
	undef @listext;
	undef %downloadsizeext;
	$maxdownloadlength = 0;
	undef %downloadsize;
	undef %download;

	$reqdomtot = 0; 
	$add = 0;
	$nbdays = 0;
	$pageunique = 0;
	$locserver = 0;
	$serverunique = 0;
	$serveruniquetot = 0;
	$domreq = 0;
	$domsize = 0;
	$access = 0;
	$accessdom = 0;
	$excladdr = 0;
	$exclframed = 0;
	$exclrobots = 0;
	$exclrefererspam = 0;
	$exclpages = 0;
	$notfound = 0;
	$forbiden = 0;
	$redirect = 0;
	$proxy = 0;
	$loglines = 0;
	$unauthorized = 0;
	$nbabort_page = 0;
	$scriptunique = 0;
	$pageunique = 0;

	undef %method;
	undef %methodcgi;
	undef %script;
	undef %argunique;
	undef %nameunique;
	undef %scriptdata;
	undef %countargval;
	undef %countarg;

	undef %sizepage;
	undef %nbpagehost;
	undef %tmpage;
	undef %pageslues;
	undef @histo_page;

	undef %filetype;
	undef %filetypenb;
	undef %filetypemax;

	if ($geoipcity == 1) {
	    undef %revcity2;

	    foreach $city (keys(%payslistcity)) {
		$tmpcity = "country_city_".$city;
		undef %$tmpcity;
		$tmpregion = "country_region_".$city;
		undef %$tmpregion;
	    }

	    undef %payslistcity;
	    undef %payshtmlcity;
	    undef %serverpayscity;
	    undef %sizepayscity;

	    undef %city_region;
	    undef %longitude;
	    undef %latitude;
	    undef %found_city;
	    undef @worldmap;
	    undef @worldmap;
	    undef @worldmap;
	    
	    undef %city_hit;
	    undef %city_access;
	    undef %city_size;

	    undef %revcity;
	    undef %city_idx;
	    undef %city_hosts;
	    undef %city_pays;
	    undef %spam_city;
	    undef %spam_citypays;
	}

	if ((-f "$path$dirinc$dirsep$incftp" || -f "$path$dirinc$dirsep$incftp$txtext") && $inc_user == 1) {
		$user_local = 0;
		$user_ext = 0;
		undef %user;
		undef %user_traffic;
		undef %user_adresse;
		undef %user_date;
		undef %user_access;
		undef %user_nbacc;
		undef %user_page;
		undef %user_nbpage;
	}

	if ($inc_download_aborted == 1) {
	    $nbabort_page = 0;
	    undef %sizepagemax;
	    undef %dm_ok_size;
	    undef %abort_occur;
	    undef %abort_name;
	}

	if (-f "$path$dirinc$dirsep$filerss") {
	    undef %rss_nb_page;
	    undef %rss_host_unique;
	    undef %rss_page_date;
	    undef %rss_host;
	    undef %rss_occur;
	    undef %rss_date;
	}

	if ($mail_format == 1) {
	    $spam_found = 0;
	    $spam_found_local = 0;
	    $spam_found_ext = 0;
	    $spam_day_local = 0;
	    $spam_day_ext = 0;
	    $spam_note_max = 0;
	    undef %spam_rank;
	    undef %spam_page;
	    undef %spam_pays;
	    undef @spam_histo;
	    undef %spam_dom;
	    undef %spam_field_count;
	    undef %spam_flag;

	    undef %spam_user_ext;
	    undef %spam_user_loc;
	}

	if ($exclude_robot == 1) {
	    undef %robots;
	    undef %robots_name;
	    undef %robots_date;
	    undef %robots_fullname;
	}

	if ($exclude_refererspam == 1) {
	    undef %refer_spam;
	    undef %count_refer_nb;
	    undef %refer_spam_agent;
	    undef %refer_fullsite;
	}

	foreach $status (keys %FailStatusMsgs) {
	    $tmp4 = "client_error_".$status;
	    undef %$tmp4;
	    $tmp4 =  "client_date_".$status;
	    undef %$tmp4;
	    $tmp4 =  "client_refer_".$status;
	    undef %$tmp4;
	    $tmp4 =  "client_host_".$status;
	    undef %$tmp4;
	    $tmp4 =  "client_hostlist_".$status;
	    undef %$tmp4;
	    $tmp4 =  "client_hostlistnb_".$status;
	    undef %$tmp4;
	    $tmp4 =  "client_id_".$status;
	    foreach $id (keys %$tmp4) {
		$tmp5 = "client_host_".$id."_",$status;
		undef %$tmp5;
		$tmp5 = "client_nbhost_".$id."_".$status;
		undef %$tmp5;
	    }
	    undef %$tmp4;
	}
	undef %status_code;

	undef %pagehas;
	undef @reversepagehas;

	if (-f "$path$dirinc$dirsep$incscreensize") {
	    $screensize_val = 0;
	    undef %seen_screen;
	    undef %screensize;
	    undef %colordepth;
	    undef %java_support;
	}


	if (-f "$path$dirinc$dirsep$virusdef") {
	    $nb_virus = 0;
	    undef %virus_site;
	    undef %virus_date;
	    undef %list_host_virus;
	    undef @count_virus;
	    undef @virus_date;
	    undef @count_host_virus;
	    undef %dailyvirus;
	    $maxdailyvirus = 0;
	}


	if (-f "$path$dirinc$dirsep$increpert") {
	    undef %freqrac;
	    undef %freqrachtml;
	    undef %freqrachtmldom;
	    undef %freqtotsize;
	    undef %freqextsize;
	    undef %freqdomsize;
	    undef %freq2rac;
	    undef %freq2rachtml;
	    undef %freq2totsize;
	}

	if (-f "$path$dirinc$dirsep$incvirtual") {
	    undef %virtual;
	    undef %virtualhtml;
	    undef %virtualsize;
	    $virtualunique = 0;

	    if ($cups_format == 1) {
		foreach $vserver (keys(%virtual)) {
		    $tmp = "virtualpages_".$vserver;
		    undef @$tmp;
		}
	    }

	}

	if ($precision > 3) {
	    if (-f "$path$dirinc$dirsep$inchosts") {
		undef %pagesite;
		undef %pagesite_occur;
		undef %pagesite_date;
		}
	    if (-f "$path$dirinc$dirsep$incfilehost") {
		undef %filelist_host;
		undef %filelist_date;
		undef %filelist;
		undef %nbfilehost;
	    }
	}

	if (-f "$path$dirinc$dirsep$incpagehost") {
	    undef %pagelist_host;
	    undef %pagelist_date;
	    undef %pagelist;
	}


	if ($squid_format == 1) {
	    if (-f "$path$dirinc$dirsep$incproxystatus") {
		undef %status_code_squid;
		undef %squid_elapsed;
		undef %squid_size;
	    }
	    if (-f "$path$dirinc$dirsep$incproxypeer") {
		undef %status_code_peer;
		undef %peer_elapsed;
		undef %peer_size;
	    }
	    if (-f "$path$dirinc$dirsep$incproxyhosts") {
		undef %occur_host_peer;
		undef %elapsed_host_peer;
		undef %trafic_host_peer;
	    }
	}

    }


###

    open(GENERAL,"$path$dirinc$dirsep$incgeneral") || &error_exit("Error, unable to open $path$dirinc$dirsep$incgeneral");
    while (<GENERAL>) {
	($date1,$date2,$date3,$reqtot,$reqdomtot,$totsize,$externesize,$domsize,$nbdays,$access,$accessdom,$tothtmlsize,$loglines,$proxy,$redirect,$unauthorized,$forbiden,$notfound,$exclpages,$excladdr,$exclframed,$exclrobots,$exclrefererspam,$paysunique,$bandwidth_input,$bandwidth_output,$nbfile,$nbfiledom) = split;
    }
    close GENERAL;

    if (-f "$path$dirinc$dirsep$incftpday$txtext" && $inc_user == 1) {
	open(FTP,"$path$dirinc$dirsep$incftpday$txtext");
	while (<FTP>) {
	    chop;
	    $nb = ($page,$tmp) = split(/\t/,$_);
	    if ($nb == 1) {
		$val = $page;
	    } else {
		($user,$data) = split(/\t/,$_);
		$tmp2 = "requser_$page";
		($val1,$val2,$val3,$val4) = split(/-/,$data);
		$$tmp2{$val} = $val1;
		$tmp2 = "accuser_$page";
		$$tmp2{$val} = $val2;
		$tmp2 = "hostuser_$page";
		$$tmp2{$val} = $val3;
		$tmp2 = "sizeuser_$page";
		$$tmp2{$val} = $val4;
	    }
	}
    }

    if (-f "$path$dirinc$dirsep$incftp$txtext") {
	$tmp = "$path$dirinc$dirsep$incftp$txtext";
    } else {
	$tmp = "$path$dirinc$dirsep$incftp";
    }
    if (-f "$tmp" && $inc_user == 1) {
	open(FTP,"$tmp");
	while (<FTP>) {
	    chop;
	    $nb = ($page,$tmp1,$tmp2,$tmp3,$tmp4,$tmp5) = split(/\t/,$_);
	    if ($nb == 3 && $init_inc == 0) {
		$nb_user = $page;
		$user_local = $tmp1;
		$user_ext = $tmp2;
	    } 

	    if ($nb == 6) {
		$user{$page} += $tmp1;
		$user_traffic{$page} += $tmp2;
		$user_adresse{$page} = $tmp3;
		$user_date{$page} = $tmp4;
		$user_access{$page} += $tmp5; # if ($cups_format == 0);
#		$user_nbacc{$page} += $tmp5 if ($cups_format == 1);
		$login = $page;
		$count = 0 if ($user_nbacc{$login} == 0);
	    }

	    if ($nb == 2) {
                $count++;
		$user_nbacc{$login}++;
		$user_page{$login,$count} = $page;
		$user_nbpage{$login,$page} = $tmp1;

	    }
	}
	close(FTP);
    }

    # TODO
    if ($inc_download_aborted == 1) {
	open(ABORT,"$path$dirinc$dirsep$incabort") || &error_exit("Error, unable to open $path$dirinc$dirsep$incabort");
	while (<ABORT>) {
	    ($page,$tmp1,$tmp2,@tmp) = split(/\t/);
	    $nbabort_page++ if ($abort_occur{$page} eq '');
#	    $sizepagemax{$page} = $tmp1;
	    $dm_ok_size{$page} = $tmp1;
	    $abort_occur{$page} += $tmp2;
	    $abort_name[$nbabort_page] = $page;
	    for ($i=0;$i<=$#tmp;$i++) {
		$j = 9-$i;
		$abort_page{$page,$j} += $tmp[$i];
	    }
	}
	close (ABORT);
    }

    # TODO
    if (-f "$path$dirinc$dirsep$filerss") {
	open(RSS,"$path$dirinc$dirsep$filerss");
	while (<RSS>) {
	    chop;
	    ($page,$tmp,$tmp1,$tmp2) = split(/\t/); 
	    if ($tmp2 ne '') {
		$rss_nb_page{$page} = $tmp;
		$rss_host_unique{$page} = $tmp1;
		$rss_page_date{$page} = $tmp2;
		$count = 0;
		$status = $page;
	    } else {
		$count++;
		$rss_host{$status,$count} = $page;
		$rss_occur{$status,$page} = $tmp;
		$rss_date{$status,$page} = $tmp1;
	    }
	}
	close(RSS);
    }
    
    # TODO
    if ($mail_format == 1) {
	open(SPAM,"$path$dirinc$dirsep$spam");
	while (<SPAM>) {
	    chop;
	    ($page,$tmp,$tmp1) = split(/\t/); 
	    if ($tmp eq '') {
		# Rank
		(@val) = split(/ /,$page);
		for ($i=0;$i<$#val;$i++) {
		    ($tmp2,$tmp3) = split(/\//,$val[$i]);		
		    $spam_histo[$tmp2] = $tmp3;
		}
	    }
	    if ($tmp1 eq '' && $tmp ne '') {
		$spam_found++;
		if ($page =~ /\@/) {
		    ($login,$adresse) = split(/\@/,$page);
		    $spam_user_ext{$login}++;
		    $spam_found_ext++;
		    $domadresse = substr($adresse,(rindex(substr($adresse,0,rindex($adresse,'.')),'.')+1),length($adresse));
		    $spam_dom{$domadresse}++;
		} else {
		    $spam_user_loc{$login}++;
		    $spam_found_local++;
		    $spam_dom{$localdomainename}++;
		}
	    }
	    if ($tmp1 ne '') {
		$spam_page{$page} = $tmp;
		$spam_rank{$page} = $tmp1;
	    }
	}
#	$spam_histo[$spam_note]++;
	#$spam_note_max = $spam_note if ($spam_note > $spam_note_max);
	#$spam_note_val_max = $spam_histo[$spam_note] if ($spam_histo[$spam_note] > $spam_note_val_max);
	close(SPAM);

	$spam_flag = "spam-flag";
	if (-f "$path$dirinc$dirsep$spam_flag") {
	open(SPAM,"$path$dirinc$dirsep$spam_flag"); # || &error_exit("Error, unable to open $path$dirinc$dirsep$spam_flag");
	while (<SPAM>) {
	    chop;
	    ($page,$val) = split(/\t/); 
	    $spam_flag{$page} = $val;
	}
	close(SPAM);
	}
    }

    # TODO
    if ($exclude_robot == 1) {
	open(ROBOT,"$path$dirinc$dirsep$incrobot") || &error_exit("Error, unable to open $path$dirinc$dirsep$incrobot");
	while (<ROBOT>) {
	    chop;
	    ($page,$tmp,$tmp1,$tmp2,$tmp3) = split(/\t/); 
	    $robots{$page} = $tmp;
	    $robots_name{$page} = $tmp1;
	    $robots_date{$page} = $tmp2;
	    $robots_fullname{$page} = $tmp3;
	}
	close(ROBOT);
    }

    # TODO
    if ($exclude_refererspam == 1) {
	open(SPAMREF,"$path$dirinc$dirsep$increferspam") || &error_exit("Error, unable to open $path$dirinc$dirsep$increferspam");
	while (<SPAMREF>) {
	    chop;
	    ($page,$tmp1,@tmp) = split(/\t/);
	    $refer_spam{$page} = $tmp1;
	    $count_refer_nb{$page} = ($#tmp+1)/2;
	    if ($struct_logfile =~ /\%refer/) {
		for ($i=0;$i<=$#tmp;$i+=2) {
		    $tmp = $i+1;
		    $tmp1 = ($i/2)+1;
		    $refer_spam_agent{$page,$tmp1} = $tmp[$i];
		    $refer_fullsite{$page,$tmp[$i]} = $tmp[$tmp];
		}
	    }
	}
	close(SPAMREF);
    }
    
    # DONE

    if (-f "$path$dirinc$dirsep$incstatus") {
	open(STATUS,"$path$dirinc$dirsep$incstatus");
	while (<STATUS>) {
	    chop;
	    ($status,$nb,$tmp1,$tmp2,$tmp3,$tmp5) = split(/\t/);
	    if ($tmp1 eq '') {
		$status_code{$status} += $nb;
	    } else {
		if ($status ne "-") {
		    # Old version
		    if ($nb =~ /^\//) {
			$tmp4 = "client_error_".$status;
			$$tmp4{$nb} += $tmp1;
			$tmp4 =  "client_date_".$status;
			$$tmp4{$nb} = $tmp2;
			$tmp4 =  "client_refer_".$status;
			$$tmp4{$nb} = $tmp3;
			$page = $nb;
		    } else {
			$tmp4 = "client_error_".$status;
			$$tmp4{$tmp1} += $tmp2;
			$tmp4 =  "client_date_".$status;
			$$tmp4{$tmp1} = $tmp3;
			$tmp4 =  "client_refer_".$status;
			$$tmp4{$tmp1} = $tmp5;
			if ($nb ne '') {
			    $tmp4 =  "client_id_".$status;
			    $$tmp4{$tmp1} = $nb;
			}
			$page = $tmp1;
			$id = $nb;
#		    $page = $nb;
		    }
		    $count = 0;
		    $tmp10 = $status;
		} else {
		    $count++;
		    $tmp5 = "client_hostlist_".$tmp10;
		    $$tmp5{$page,$count} = $nb;
		    $tmp5 = "client_hostlistnb_".$tmp10;
		    $$tmp5{$page,$count} = $tmp1;
#		$tmp5 = "client_nbhost_".$page."_".$tmp10;
		    $tmp5 = "client_nbhost_".$id."_".$tmp10;
		    $$tmp5{$page}++;
#		print "OO - $page - $$tmp5{$page}\n";
		    $tmp5 = "client_host_".$id."_",$tmp10;
		    $$tmp5{$tmp1}++;
		    
		    $tmp5 =  "client_host_".$tmp10;
		    $$tmp5{$nb} += $tmp1;
		}
	    }
	}
	close(STATUS);
    }

#    print "STATUS done\n";
    $prevloglines = $loglines;
    $exclframed = 0 if ($exclframed eq '');
    $exclrobots = 0 if ($exclrobots eq '');
    $exclrefererspam = 0 if ($exclrefererspam eq '');

    $firstday = "$date1"." "."$date2"." "."$date3";
    $ydayfirst = &nbday($firstday);

    # DONE
    if (-f "$path$dirinc$dirsep$filetype" && $precision > 2) {
	open(FILETYPE,"$path$dirinc$dirsep$filetype") || &error_exit("Error, unable to open $path$dirinc$dirsep$filetype");
	while (<FILETYPE>) {
	    $line = $_;
	    ($page,$chiffre,$tmp) = split(/\s/,$line);
	    if ($tmp ne '') {
		($page,$chiffre,$tmp) = split(/\t/,$line) if ($line =~ /\t/);
		$filetype{$page} += $chiffre;
#		print "A $page - $extension - $sizepage{$page}\n";
		$sizepage{$page} += $tmp if ($page !~ /$extension/);
	    } else {
		$filetypenb{$page} += $chiffre;
	    }
	}
	close FILETYPE;
    }

    $has = 0 if ($init_inc == 0);

    if (!(-f "$path$dirinc$dirsep$pagehas")) {
	open(PAGEHAS,">$path$dirinc$dirsep$pagehas") || &error_exit("Error, unable to open $path$dirinc$dirsep$pagehas");
	foreach $tmp (keys(%pageslues)) {
	    $has++;
	    $pagehas{$tmp} = $has;
	    $reversepagehas[$has] = $tmp; # if ($precision > 3);
	    print PAGEHAS "$tmp\t$has\n";
	}
	close(PAGEHAS);
    }
# sinon on le lit.
    if (-f "$path$dirinc$dirsep$pagehas") {
	open(PAGEHAS,"$path$dirinc$dirsep$pagehas") || &error_exit("Error, unable to open $path$dirinc$dirsep$pagehas");
	while (<PAGEHAS>) {
	    chop;
	    ($page,$chiffre) = split(/\t/,$_);
	    $has++;
	    $pagehas{$page} = $chiffre;
	    $reversepagehas[$chiffre] = $page; # if ($precision > 3);
	}
	close(PAGEHAS);
    }

    if (-f "$path$dirinc$dirsep$incpage$txtext") {
	$tmp = "$path$dirinc$dirsep$incpage$txtext";
    } else {
	$tmp = "$path$dirinc$dirsep$incpage";
    }
    open(PAGESLUES,"$tmp"); # || &error_exit("Error, unable to open $path$dirinc$dirsep$incpage");
    while (<PAGESLUES>) {
	chop;
	if ($cups_format == 0) {
	    if ($precision > 3 && $notrafic == 0) {
		($tmp1,$page,$tmp3,$tmp4,$tmp2) = split(/\t/);
		($chiffre,@tmp) = split(/\s+/,$tmp2) if ($tmp2 ne '');
		($chiffre,@tmp) = split(/\s+/,$tmp4) if ($tmp2 eq '');
		$sizepage{$tmp1} += $tmp4 if ($tmp2 ne '');
		$nbpagehost{$page} += $tmp3;
	    }
	    if ($precision > 3 && $notrafic != 0) {
		($tmp1,$page,$tmp3,$tmp2) = split(/\t/);
		($chiffre,@tmp) = split(/\s+/,$tmp2);
		$nbpagehost{$page} += $tmp3;
	    }
	    if ($precision <= 3 && $notrafic != 0) {
		($tmp1,$page,$tmp2) = split(/\t/);
		($chiffre,@tmp) = split(/\s+/,$tmp2);
	    }
	    if ($precision <= 3 && $notrafic == 0) {
		($tmp1,$page,$tmp4,$tmp2) = split(/\t/);
		($chiffre,@tmp) = split(/\s+/,$tmp2) if ($tmp2 ne '');
		($chiffre,@tmp) = split(/\s+/,$tmp4) if ($tmp2 eq '');
		$sizepage{$tmp1} += $tmp4 if ($tmp2 ne '');
	    }
	    if ($tmp1 =~ /^\d/ && $cups_format == 0) {
		&error_exit("Error, $path$dirinc$dirsep$incpage format is deprecated");
	    }

	    for ($i=0;$i<=$#tmp;$i++) {
		$tmpage{$i,$reversepagehas[$page]} += $tmp[$i];
	    }
	} else {
	    ($tmp1,$page,$tmp3,$chiffre) = split(/\t/);
	    if ($precision > 3) {
		$nbpagehost{$page} = $tmp3;
	    } else {
		$chiffre = $tmp3;
	    }
	}
	$pageslues{$reversepagehas[$page]} += $chiffre;
#	print "ARG $page - $reversepagehas[$page] - $chiffre\n";
	$pageunique++ # WARNING a recalculer
    }
    close PAGESLUES;
    
    $countext = 0 if ($init_inc == 0);

    if (-f "$path$dirinc$dirsep$dirdownload" && $precision > 2) {
	open(DOWNLOAD,"$path$dirinc$dirsep$dirdownload") || &error_exit("Error, unable to open $path$dirinc$dirsep$dirdownload");
	while (<DOWNLOAD>) {
	    chop;
	    ($tmp1,$tmp2,$tmp3,@val) = split(/ /,$_);
	    $listext[$countext] = $tmp1;
	    $downloadext{$tmp1} += $tmp2;
	    if ($notrafic == 0) {
		$downloadsizeext{$tmp1} += $tmp3;
		$maxdownloadlength = ($#val)+1;
		for ($j=1;$j<=($maxdownloadlength/2);$j++) {
		    $a = 2*($j-1);
		    $chiffre = (2*$j)-1;
		    $downloadsize{$tmp1,$j} += $val[$a];
		    $download{$tmp1,$j} += $val[$chiffre];
		}
		$countext++;
	    }
	}
	close DOWNLOAD;
    }

    $maxdownloadlength /= 2;

    # TODO
    if (-f "$path$dirinc$dirsep$incmethod") {
	open(METHOD,"$path$dirinc$dirsep$incmethod") || &error_exit("Error, unable to open $path$dirinc$dirsep$incmethod");
	while (<METHOD>) {
	    chop;
	    ($tmp1,$tmp2,$tmp3) = split(/\t/,$_);
	    if ($tmp2 eq '') {
		($val1,$val2) = split(/,/,$tmp1);
		($val3,$val4) = split(/-/,$val2);
		$method{$val1} += $val3;
		$methodcgi{$val1} += $val4 if ($val4 ne '');
#		print "II $val1 - $method{$val1} - $methodcgi{$val1}\n";
	    } else {
		$$val1{$tmp1} += $tmp2;
		$tmpstr = $val1."_size";
		$$tmpstr{$tmp1} += $tmp3 if ($notrafic == 0);
#		print "MM $tmp1 - $tmpstr - $$val1{$tmp1}\n";
	    }

	}
	close METHOD;
    }

    # TODO
    if ($inc_script == 1 && (-f "$path$dirinc$dirsep$incscript")) {
	open(SCRIPT,"$path$dirinc$dirsep$incscript") || &error_exit("Error, unable to open $path$dirinc$dirsep$incscript");
	if (!(-f "$path$dirinc$dirsep$incmethod")) {
	    $a = <SCRIPT>;
	    (@val) = split(/ /,$a);
	    for ($i=0;$i<$#val;$i++) {
		($tmp1,$tmp2) = split(/,/,$val[$i]);
		$method{$tmp1} += $tmp2;
	    }
	    $a = <SCRIPT>;
	    (@val) = split(/ /,$a);
	    for ($i=0;$i<$#val;$i++) {
		($tmp1,$tmp2) = split(/,/,$val[$i]);
		$methodcgi{$tmp1} += $tmp2;
	    }
	    }
	while (<SCRIPT>) {
	    chop;
	    ($namescript,$chiffre,@lines) = split(/\^/);
	    $script{$namescript} += $chiffre;
	    $scriptunique++; ### WARNING
	    $argunique{$namescript} = $#lines+1;
	    for ($j=0;$j<=$#lines;$j++) {
		($name,@group) = split(/\t/,$lines[$j]);
		$name =~ s/\[//;
		$nameunique{$namescript,$name} = $#group+1;
		$tmp = $j+1;
		$scriptdata{$namescript,$tmp} = $name;
		
		for ($k=0;$k<=$#group;$k++) {
		    ($value,$b) = split(/,/,$group[$k]);
		    $value =~ s/\"//g;
		    chop($b) if ($k == $#group);
		    $tmp = $k+1;
		    $countargval{$namescript,$name,$tmp} = $value;
		    $countarg{$namescript,$name,$value} = $b;
		}
	    }
	}
	close SCRIPT;
    }

    &load_city_map if ($geoipcity == 1 && -f "$path$dirinc$dirsep$filecity");
    $tmp = $unresolved;
    $tmp =~ s/$htmlext$//;
    &load_unresolved_city if ($geoipcity == 1 && -f "$path$dirinc$dirsep$filecity$tmp");

#    print "CITY done\n";
    open(PAYS,"$path$dirinc$dirsep$incpays") || &error_exit("Error, unable to open $path$dirinc$dirsep$incpays");
    while (<PAYS>) {
	chop;
	($pays,$chiffre,$chiffre2,$chiffre3,$chiffre4,$chiffre5) = split(/\t/);
	&error_exit("Country incremental format have changed ($pays). Restart the stats from scratch\n") if ($chiffre eq '');
	$serverpays{$pays} = $chiffre; # WARNING $server{$adresse} == 1 || $localserver{$adresse} == 1
	$payslist{$pays} += $chiffre2;
	$payshtml{$pays} += $chiffre3;
	$sizepays{$pays} += $chiffre4;
	$domaindateip{$pays} = $chiffre5 if ($reverse_geo == 1);
	$found{$pays} = 1; 
    }
    close PAYS;
    
#    print "PAYS done\n";
    if (-f "$path$dirinc$dirsep$dirdomain") {
	open(DOMAIN,"$path$dirinc$dirsep$dirdomain") || &error_exit("Error, unable to open $path$dirinc$dirsep$dirdomain");
	while (<DOMAIN>) {
	    ($adresse,$date1,$date2,$date3) = split;
	    $domaindate{$adresse} = $date1." ".$date2." ".$date3;
	}
	close DOMAIN;
    }

    if (-f "$path$dirinc$dirsep$incservexterne$txtext") {
	$tmp = "$path$dirinc$dirsep$incservexterne$txtext";
    } else {
	$tmp = "$path$dirinc$dirsep$incservexterne";
    }
    open(SERVEXTERNE,"$tmp"); # || &error_exit("Error, unable to open $path$dirinc$dirsep$incservexterne$txtext");
    while (<SERVEXTERNE>) {
	chop;
	($adresse,$chiffre,$tmp2,$tmp3,$tmp4,$tmp5,$tmp6) = split(/\t/);
	&error_exit("Hosts incremental format have changed. Restart the stats from scratch\n") if ($chiffre eq '');
	$listadresse[$serverunique] = $adresse;
	$server{$adresse} = $chiffre;
	$listadresseold[$serverunique] = $adresse;
	if ($ftp_format == 0 && $squid_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	    $nbpageserveur{$adresse} = $tmp2;
	    if ($precision > 3 || $cups_format == 1 || $dhcp_format == 1) {
		$nbpageserveurunique{$adresse} = $tmp3;
		if ($notrafic == 0) {
		    $serversize{$adresse} = $tmp4;
		    $serverdate{$adresse} = $tmp5;
		    $pays_ip{$adresse} = $tmp6 if ($reverse_geo == 1 && ($adresse =~ /[0-9]+$/ || $adresse =~ /:/));
		} else {
		    $serverdate{$adresse} = $tmp4;
		    $pays_ip{$adresse} = $tmp5 if ($reverse_geo == 1 && ($adresse =~ /[0-9]+$/ || $adresse =~ /:/));
		}
	    } else {
		if ($notrafic == 0) {
		    $serversize{$adresse} = $tmp3;
		    $serverdate{$adresse} = $tmp4;
		    $pays_ip{$adresse} = $tmp5 if ($reverse_geo == 1 && ($adresse =~ /[0-9]+$/ || $adresse =~ /:/));
		} else {
		    $serverdate{$adresse} = $tmp3;
		    $pays_ip{$adresse} = $tmp4 if ($reverse_geo == 1 && ($adresse =~ /[0-9]+$/ || $adresse =~ /:/));
		}
	    }
	} else {
	    if ($precision > 3 || $cups_format == 1 || $dhcp_format == 1) {
		$nbpageserveurunique{$adresse} = $tmp2;
		if ($notrafic == 0) {
		    $serversize{$adresse} = $tmp3;
		    $serverdate{$adresse} = $tmp4;
		    $pays_ip{$adresse} = $tmp5 if ($reverse_geo == 1 && ($adresse =~ /[0-9]+$/ || $adresse =~ /:/));
		} else {
		    $serverdate{$adresse} = $tmp3;
		    $pays_ip{$adresse} = $tmp4 if ($reverse_geo == 1 && ($adresse =~ /[0-9]+$/ || $adresse =~ /:/));
		}
	    } else {
		if ($notrafic == 0) {
		    $serversize{$adresse} = $tmp2;
		    $serverdate{$adresse} = $tmp3;
		    $pays_ip{$adresse} = $tmp4 if ($reverse_geo == 1 && ($adresse =~ /[0-9]+$/ || $adresse =~ /:/));
		} else {
		    $serverdate{$adresse} = $tmp2;
		    $pays_ip{$adresse} = $tmp3 if ($reverse_geo == 1 && ($adresse =~ /[0-9]+$/ || $adresse =~ /:/));
		}
	    }
	}



#	print "AA $adresse,$chiffre,$tmp2,$tmp3,$tmp4,$tmp5 - NB $nbpageserveur{$adresse} - SIZE $serversize{$adresse} - DATE $serverdate{$adresse} - IP $pays_ip{$adresse}\n";
	$serverunique++;
    }
    close SERVEXTERNE;

    $serveruniquetot = $serverunique;

    if (-f "$path$dirinc$dirsep$incservexterne$txtext") {
	$tmp = "$path$dirinc$dirsep$incservinterne$txtext";
    } else {
	$tmp = "$path$dirinc$dirsep$incservinterne";
    }
    open(SERVINTERNE,"$tmp"); # || &error_exit("Error, unable to open $path$dirinc$dirsep$incservinterne$txtext");
    while (<SERVINTERNE>) {
	chop;
	($adresse,$chiffre,$tmp2,$tmp3,$tmp4,$tmp5) = split(/\t/);
	&error_exit("Hosts incremental format have changed. Restart the stats from scratch\n") if ($chiffre eq '');
#	if ($chiffre eq '') {
#	    ($adresse,$chiffre,$tmp2,$tmp3) = split;
#	} else {
#	    $localserverdate{$adresse} = $tmp4;
#	}
#	$localserverdate{$adresse} = $tmp4;
	$localserver{$adresse} = $chiffre;
	$locserver++;
	$serveruniquetot++;
	$listadresse[$serveruniquetot] = $adresse;
	$listadresseold[$serveruniquetot] = $adresse;
	if ($cups_format == 0 && $dhcp_format == 0) {
	    $nbpageserveur{$adresse} = $tmp2;
	    if ($precision > 3 || ($cups_format == 1 || $dhcp_format == 1)) {
		$nbpageserveurunique{$adresse} = $tmp3; 
		$localserversize{$adresse} = $tmp4 if ($notrafic == 0);
		$localserverdate{$adresse} = $tmp5;
	    } else {
		if ($notrafic == 0) {
		    $localserversize{$adresse} = $tmp3;
		    $localserverdate{$adresse} = $tmp4;
		} else {
		    $localserverdate{$adresse} = $tmp3;
		}
	    }
	} else {
	    if ($precision > 3 || ($cups_format == 1 || $dhcp_format == 1)) {
		$nbpageserveurunique{$adresse} = $tmp2; 
		if ($notrafic == 0) {
		    $localserversize{$adresse} = $tmp3;
		    $localserverdate{$adresse} = $tmp4;
		} else {
		    $localserverdate{$adresse} = $tmp3;
		}
	    } else {
		if ($notrafic == 0) {
		    $localserversize{$adresse} = $tmp2;
		    $localserverdate{$adresse} = $tmp3;
		} else {
		    $localserverdate{$adresse} = $tmp2;
		}
	    }
	}
#	$nbpageserveurunique{$adresse} = $tmp2 if ($precision > 3 || ($cups_format == 1 || $dhcp_format == 1));
#	$localserversize{$adresse} = $tmp3 if ($notrafic == 0);
	$payshtmldom += $tmp2;
    }
    close SERVINTERNE;

    $screensize_val = 0;
    if (-f "$path$dirinc$dirsep$incscreensize") {
	open(FILESCREENSIZE,"$path$dirinc$dirsep$incscreensize") || &error_exit("Error, unable to open $path$dirinc$dirsep$incscreensize");
	while (<FILESCREENSIZE>) {
	    chop;
	    ($adresse,$tmp1,$tmp2) = split(/\t/);
	    if ($tmp1 eq '') {
		$seen_screen{$adresse}++;
	    } else {
		if ($adresse eq "screen") {
		    $screensize{$tmp1} = $tmp2;
		    $screensize_val++;
		}
		if ($adresse eq "color") {
		    $colordepth{$tmp1} = $tmp2;
		}
		if ($adresse eq "java") {
		    $java_support{$tmp1} = $tmp2;
		}
	    }
	}
	close(FILESCREENSIZE);
    }
    
    if (-f "$path$dirinc$dirsep$virusdef") {
	$i = -1;
	$nb_virus = 0;
	open(VIRUS,"$path$dirinc$dirsep$virusdef") || &error_exit("Error, unable to open $path$dirinc$dirsep$virusdef");
	while (<VIRUS>) {
	    chop;
	    ($adresse,$tmp1,$tmp2,$tmp3,$tmp4) = split(/\t/);
	    if ($tmp4 eq '') {
		$j++;
		$virus_site{$i,$adresse} = $tmp1;
		$virus_date{$i,$adresse} = $tmp2;
		$list_host_virus{$i,$j} = $adresse;
	    } else {
		$i = $tmp1;
		$j = 0;
		$count_virus[$i] = $tmp2;
		$virus_date[$i] = $tmp3;
		$count_host_virus[$i] = $tmp4;
		$nb_virus++;
	    }
	}
	close VIRUS;

	if (-f "$path$dirdata$dirsep$data$virusdef") {
	    open(FILEDATEVIRUS,"$path$dirdata$dirsep$data$virusdef");
	    while (<FILEDATEVIRUS>) {
		next if ($_ =~ /^#/);
		chop;
		($adresse,@tmp) = split(/\t/);
		next if ($adresse eq ''); 
		$tmp_date = &nbday($adresse);
		if ($tmp_date >= ($ydaytoday-$nbdayscf)) {
		    for ($i=0;$i<=$#tmp;$i++) {
			$tmpdate_virus = $tmp_date-($ydaytoday-$nbdayscf);
			$dailyvirus{$tmpdate_virus,$i} = $tmp[$i];
			$maxdailyvirus = $tmp[$i] if ($tmp[$i] > $maxdailyvirus);
		    }
		}
	    }
	    close(FILEDATEVIRUS);
	}
    }

    open(SERVPAGESELECT,"$path$dirinc$dirsep$incpageselect") || &error_exit("Error, unable to open $path$dirinc$dirsep$incpageselect");
    while (<SERVPAGESELECT>) {
	chop;
	($tmp,$adresse,$date) = split(/\t/);
	if ($date eq '') {
	    $page = $reversepagehas[$tmp];
	    push(@selecpages,$page);
	    @tmp = split('/',$adresse);
	    for ($i=0;$i<=$#tmp;$i++) {
		($tmp1,$tmp2) = split(/-/,$tmp[$i]);
		$tmp1 = $tmp1-$ydayfirst;
		$pagesel{$page,$tmp1} = $tmp2;
		$maxday{$page} = $pagesel{$page,$tmp1} if ($pagesel{$page,$tmp1} > $maxday{$page});
#		print "LOAD $page - $tmp1 - $tmp2 - $ydayfirst\n";
	    }

	} else {
	    if ($adresse !~ /^\d+$/) {
		print "Format have changed\n. Data will be resetted";
	    } else {
		($date_tmp) = split(/:/,$date);
		$yday = &nbday($date_tmp);
#		print "UU $date_tmp - $yday > $ydaytoday $nbdayscf\n";
		if ($yday > ($ydaytoday-$nbdayscf)) {
		    $count_selection{$page}++;
		    $selecadresse{$page,$count_selection{$page}} = $tmp;
		    $selecfound{$page,$tmp} = $adresse;
		    $seleclastdate{$page,$tmp} = $date;
#		    print "OO $page - $count_selection{$page} - $tmp - $adresse - $date\n";
		}
	    }
#	    push(@selecadresse,$adresse);
#	    push(@selecdate,$date);
	}
    }
    close SERVPAGESELECT;

    if (-f "$path$dirinc$dirsep$increpert$txtext") {
	$tmp = "$path$dirinc$dirsep$increpert$txtext";
    } else {
	$tmp = "$path$dirinc$dirsep$increpert";
    }
#    if (-f "$path$dirinc$dirsep$increpert") {
    if (-f "$tmp") {
	open(REPERT,"$tmp"); # || &error_exit("Error, unable to open $path$dirinc$dirsep$increpert");
	while (<REPERT>) {
	    $line = $_;
	    ($racine,$vale1,$vale2,$vale3,$vale4,$vale5,$vale6,$vale7,$vale8,$vale9) = split(/\s/,$line) if ($line !~ /\t/);
	    if ($line =~ /\t/) {
		($racine,$vale) = split(/\t/,$line);
		($vale1,$vale2,$vale3,$vale4,$vale5,$vale6,$vale7,$vale8,$vale9) = split(/\s/,$vale);
	    }
	    $freqrac{$racine} = $vale1;
	    $freqrachtml{$racine} = $vale2;
	    $freqrachtmldom{$racine} = $vale3;
	    $freqtotsize{$racine} = $vale4;
	    $freqextsize{$racine} = $vale5;
	    $freqdomsize{$racine} = $vale6;
	    $freq2rac{$racine} = $vale7;
	    $freq2rachtml{$racine} = $vale8;
	    $freq2totsize{$racine} = $vale9;
	}
	close REPERT;
    }

#    print "REPERT done\n";
    if (-f "$path$dirinc$dirsep$incvirtual$txtext") {
	$tmp = "$path$dirinc$dirsep$incvirtual$txtext";
    } else {
	$tmp = "$path$dirinc$dirsep$incvirtual";
    }
    if (-f "$tmp") {
#    if (-f "$path$dirinc$dirsep$incvirtual") {
	open(VIRTUAL,"$tmp"); # || &error_exit("Error, unable to open $path$dirinc$dirsep$incvirtual");
	while (<VIRTUAL>) {
	    chop;
	    ($vserver,$vale1,$vale2) = split(/\t/);
	    $virtual{$vserver} = $vale1;
	    $virtualhtml{$vserver} = $vale2 if ($cups_format == 1);
	    $virtualsize{$vserver} = $vale2 if ($cups_format == 0);
	    $virtualunique++;
	}
	close (VIRTUAL);
    }

    if ($cups_format == 1) {
	open(VIRTUAL,"$path$dirinc$dirsep$incvirtualhtml") || &error_exit("Error, unable to open $path$dirinc$dirsep$incvirtualhtml");
	while (<VIRTUAL>) {
	    chop;
	    ($vale1,$vale2) = split(/\t/);
	    if ($vale2 ne '') {
		$tmp = "virtualpages_".$vale1;
	    } else {
		push(@$tmp,$vale2);
	    }
	}
	close(VIRTUAL);
    }

    if ($precision > 3) {
	# if precision have been moved to 4, file should not exist
	if (-f "$path$dirinc$dirsep$inchosts") {
#	    print "LOADING\n";
	    open(PAGES,"$path$dirinc$dirsep$inchosts");
	    while (<PAGES>) {
		($adresse,$chiffre,@page) = split;
		$had++;
		$adressehad{$adresse} = $chiffre;
		$reverseadressehad[$chiffre] = $adresse;
#		print "LOAD - $adresse\n";
#		$nbpageserveur{$adresse} = $#page+1;
		$nbpageserveurunique{$adresse} = $#page+1 if ($cups_format == 0);
		undef %seen_tmp;
		for ($i=0;$i<=$#page;$i++) {
		    $tmp2 = '';
		    $tmp3 = '';
		    $i2 = $i+1;
		    ($tmp1,$tmp2,$tmp3) = split(/\|/,$page[$i]);
		    if ($seen_tmp{$tmp1} eq '') {
#			$nbpageserveurunique{$adresse}++;
#			$pagesite{$adresse,$nbpageserveurunique{$adresse}} = $reversepagehas[$tmp1];
			$pagesite{$adresse,$i2} = $reversepagehas[$tmp1];
			$pagesite_occur{$adresse,$reversepagehas[$tmp1]} = $tmp2 if ($tmp2 ne '');
			$pagesite_date{$adresse,$reversepagehas[$tmp1]} = $tmp3 if ($tmp3 ne '');
			$seen_tmp{$tmp1} = 1;
#			print "L - $nbpageserveurunique{$adresse} - $i - $pagesite{$adresse,$i2} - $pagesite_occur{$adresse,$reversepagehas[$tmp1]} - $pagesite_date{$adresse,$reversepagehas[$tmp1]}\n";
		    }
		}
	    }
	    close(PAGES);
	}
    }

#    print "PRECISION 3a done\n";
    if ($precision > 3) {

	if (-f "$path$dirinc$dirsep$incfilehost") {
	    open(FILEHOST,"$path$dirinc$dirsep$incfilehost") || &error_exit("Error, unable to open $path$dirinc$dirsep$incfilehost");
	    while (<FILEHOST>) {
		chop;
		($page,@tmp) = split(/\t/);
		$nbfilehost{$page} = $#tmp+1;
		for ($i=0;$i<=$#tmp;$i++) {
		    ($tmp1,$tmp2,$tmp3) = split(/\|/,$tmp[$i]);
		    $filelist_host{$page,$tmp1} = $tmp2;
		    $filelist_date{$page,$tmp1} = $tmp3;
		    $i2 = $i+1;
		    $filelist{$page,$i2} = $reverseadressehad[$tmp1];
		}
	    }
	    close FILEHOST;
	}
    }
#    print "PRECISION 3b done\n";
    if (-f "$path$dirinc$dirsep$incpagehost") {
	open(PAGEHOST,"$path$dirinc$dirsep$incpagehost") || &error_exit("Error, unable to open $path$dirinc$dirsep$incpagehost");
	while (<PAGEHOST>) {
	    chop;
	    ($page,@tmp) = split(/\t/);
	    $nbpagehost{$page} = $#tmp+1;
	    for ($i=0;$i<=$#tmp;$i++) {
		($tmp1,$tmp2,$tmp3) = split(/\|/,$tmp[$i]);
		$pagelist_host{$page,$tmp1} = $tmp2;
		$pagelist_date{$page,$tmp1} = $tmp3;
		$i2 = $i+1;
		$pagelist{$page,$i2} = $reverseadressehad[$tmp1];
	    }
	}
	close PAGEHOST;
    }
#    print "PAGEHOST done\n";
    if ($squid_format == 1) {
	if (-f "$path$dirinc$dirsep$incproxystatus") {
	    open(PROXYSTATUS,"$path$dirinc$dirsep$incproxystatus");
	    while (<PROXYSTATUS>) {
		($status,$tmp1,$tmp2,$tmp3) = split;
		$status_code_squid{$status} = $tmp1;
		$squid_elapsed{$status} = $tmp2;
		$squid_size{$status} = $tmp3;
	    }
	    close PROXYSTATUS;
	}
	
	if (-f "$path$dirinc$dirsep$incproxypeer") {
	    open(PROXYPEER,"$path$dirinc$dirsep$incproxypeer");
	    while (<PROXYPEER>) {
		($status,$tmp1,$tmp2,$tmp3) = split;
		$status_code_peer{$status} = $tmp1;
		$peer_elapsed{$status} = $tmp2;
		$peer_size{$status} = $tmp3;
	    }
	    close PROXYPEER;
	}

	if (-f "$path$dirinc$dirsep$incproxyhosts") {
	    open(PROXYHOSTS,"$path$dirinc$dirsep$incproxyhosts");
	    while (<PROXYHOSTS>) {
		($status,$tmp1,$tmp2,$tmp3) = split;
		$occur_host_peer{$status} = $tmp1;
		$elapsed_host_peer{$status} = $tmp2;
		$trafic_host_peer{$status} = $tmp3;
	    }
	    close PROXYHOSTS;
	}
    }


}


#
##############################################################
### Add CSS Menu
##############################################################
#

sub Create_CSS_Menu {
    local(*FOUT,*L,$I,$nblang) = @_;
    local($i);

    print FOUT "$doctype\n";
    print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
    print FOUT "$charset\n";
    print FOUT "<TITLE>W3Perl Menu : $L{'Language'}</TITLE>\n";
    print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
    print FOUT "<META NAME=\"ROBOTS\" CONTENT=\"NOFOLLOW\">\n";
    print FOUT "<META NAME=\"ROBOTS\" CONTENT=\"NOINDEX\">\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";

    &add_css_style(*FOUT,2);

    print FOUT "</HEAD>\n";

    print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
    print FOUT "<CENTER>\n";
  
    &add_css_menu(*FOUT,*L,$I,$nblang,1);

    print FOUT "</CENTER>";
    print FOUT "</BODY></HTML>";

}

sub update_css_menu {
#    local(*FOUT,*L,$I,$nblang) = @_;
    local($i,@filename);
    local($found,$file,$level,$current_css_menu,$new_css_menu);

    # Check first new css menu is different from a page created by the main stats (/page/index.html)
    $file = $path.$lang[0].$dirsep.$dirpage.$dirsep.$filepages;
    # If the file doesn't exist, no need to update the css menu
#    print "AA - $file\n";
    return if (!(-f $file)); 

    opendir(SOURCEDIR,$path) || &error_exit("Couldn't open directory $path !!");
    local(@filenames) = readdir(SOURCEDIR);
    closedir(SOURCEDIR);

    $path2 = $path;
    chop($path2);
    @filenames = &list_file_to_update($path2);

    @filenames = sort (@filenames);

    # Load current menu and compare with the new one
    # get css_menu from first file EXCEPT if the file have been produced by the current script !
    $current_css_menu = '';
#    $file = $filenames[0];  ## To check ! $filenames[0] !~ /$dirdocument/

    $skip = 0;
    open(FILE,$file);
    while (<FILE>) {
	if ($_ =~ /<!-- begin_insert_css_menu -->/) {
	    $found = 1;
	}
	$skip = 1 if ($_ =~ /<!-- begin_var_css_menu -->/);
	s/<li class=\"sub[23]\">//i;
	$current_css_menu .= $_ if ($found == 1 && $skip == 0 && $_ !~ /^<!-- Last_update -->/);
	$skip = 0 if ($_ =~ /<!-- end_var_css_menu -->/);
	$found = 0 if ($_ =~ /<!-- end_insert_css_menu -->/);
    }
    close(FILE);

#    print "CURRENT FILE : $file\n";
#    print "CURRENT CSS : $current_css_menu\n";

    # new css_menu 

    for ($i=0;$i<=$#lang;$i++) {
	$nblang = $i if ($filenames[0] =~ /^$path$lang[$i]$dirsepurl/);
    }
    
#    $file = $filenames[0];
    $skip = 0;
    $file =~ s/$path//;
    $level = ($file =~ tr/\//\//);
    open(FILE,">$path$dirtmp$css_menu_w3perl");
#    &add_css_menu(*FILE,eval($Lang{$lang[$nblang]}),$lang[$nblang],$nblang,$level);
    &add_css_menu(*FILE,eval($Lang{$lang[0]}),$lang[0],0,$level);
    close(FILE);
    $new_css_menu = '';
    open(FILE,"$path$dirtmp$css_menu_w3perl");
    while (<FILE>) {
	$skip = 1 if ($_ =~ /<!-- begin_var_css_menu -->/);
	s/<li class=\"sub[23]\">//i;
	$new_css_menu .= $_ if ($skip == 0 && $_ !~ /^<!-- Last_update -->/);
	$skip = 0 if ($_ =~ /<!-- end_var_css_menu -->/);
    }
    close(FILE);
    unlink("$path$dirtmp$css_menu_w3perl");
    
    # Compare if same => exit

#    print "NEW :\n$new_css_menu\n";

    if ($new_css_menu eq $current_css_menu) {
	print "Same CSS menu\n";
	return;
    }

    #

#    $disable_load_basic_stats = 1;

#    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    print "Updating CSS menu ($#filenames files)\n";
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");


#    print "$new_css_menu\n";
#    print "\n\n\n";
#    print "$current_css_menu\n";

    $line_file_step = int($#filenames/100);

    if ($ENV{'REQUEST_METHOD'} eq "GET" && $line_file_step != 0) {
	$barfiletmp = "update_css_file";
	&InitProgressBar($barfiletmp,$scriptname,0);
    }


    for ($j=0;$j<=$#filenames;$j++) {                

	if ($line_file_step != 0) {
	    if (int($j/$line_file_step) == ($j/$line_file_step)) {
		$line_percent = int(100*($j+1)/$#filenames);
#		open(FILESTATUS,">$path$incstatus$txtext");
#		print FILESTATUS "$scriptname\t$line_percent\t$status_script\n";
#		close(FILESTATUS);
		if ($ENV{'REQUEST_METHOD'} eq "GET") {
		    print "<script language=\"javascript\" type=\"text/JavaScript\">\n";
		    print "$barfiletmp.setPercentage('+1');\n";
		    print "</script>\n";
		}
	    }
	}

	$filenames2 = $filenames[$j]."2";

	$found = 0;
	if (-f $filenames[$j]) {
	    move($filenames[$j],$filenames2);
	} else {
	    &error_exit("Unable to move $filenames[$j] to $filenames2\n");
	}

	###

	$found = 0;
	$nblang = '';

	# find $nblang
	for ($i=0;$i<=$#lang;$i++) {
	    if ($filenames[$j] =~ /^$path$lang[$i]$dirsepurl/) {
		$nblang = $i;
	    }
	}

	if ($nblang eq '') {
		# Homepage
		$tmp = $filenames[$j];
		$tmp =~ s/$path//;
		for ($k=0;$k<=$#homepages;$k++) {
		    if ($homepages[$k] eq $tmp) {
			$nblang = $k;
		    }
		}
	}

	$file = $filenames[$j];
	$file_to_open = $file;
	$file =~ s/$path//;
	$level = ($file =~ tr/\//\//);

	open(FILE2,$filenames2);
	open(FILE,">$filenames[$j]");
	while (<FILE2>) {
	    if (/<!-- begin_insert_css_menu -->/) {
		$found = 1;
		&add_css_menu(*FILE,eval($Lang{$lang[$nblang]}),$lang[$nblang],$nblang,$level);
	    }
	    print FILE "$_" if ($found == 0);
	    $found = 0 if (/<!-- end_insert_css_menu -->/);
	}
	close(FILE);
	close(FILE2);

	unlink($filenames2);

#	open(FILE,">$filenames[$j]");
#	for ($i=0;$i<=$#lines;$i++) {
#	    if ($lines[$i] =~ /<!-- begin_insert_css_menu -->/) {
#		$found = 1;
#		&add_css_menu(*FILE,eval($Lang{$lang[$nblang]}),$lang[$nblang],$nblang,$level);
#	    }
#	    print FILE "$lines[$i]" if ($found == 0);
#	    $found = 0 if ($lines[$i] =~ /<!-- end_insert_css_menu -->/);
#	}
#	close(FILE);

    }


    if ($ENV{'REQUEST_METHOD'} eq "GET") {
	print "</DIV>";
	if ($scriptname eq "cron-pages.pl") {
	    $scriptname .= "1" if ($opt_u == 1);
	}
	print "<script language=\"javascript\" type=\"text/JavaScript\">\n";
	print "ToggleMenu('TOGGLE_$scriptname');\n";
	print "</script>\n";
    }

}




# to remove /docs/ /admin/ /resources/
sub list_file_to_update
{
    my ($dir) = @_;
    local($langdir);

    return unless -d $dir;

    my @files;
  if (opendir my $dh, $dir)
  {
    # Capture entries first, so we don't descend with an
    # open dir handle.
    my @list;
    my $file;
    while ($file = readdir $dh)
    {
      push @list, $file;
    }
    closedir $dh;

    for ($i=0;$i<=$#lang;$i++) {
	$langdir .= "^".$lang[$i]."|";
    }
    chop($langdir);

    for $file (@list)
    {
      # Unix file system considerations.
      next if $file eq '.' || $file eq '..';

      # Swap these two lines to follow symbolic links into
      # directories.  Handles circular links by entering an
      # infinite loop.
#      print "$file - $scanok\n";
#      push @files, "$dir/$file" if (-f "$dir/$file" && $file =~ /$htmlext$/ && $dir ne $path2);
      $scanok = 1 if ($file =~ /$langdir/);
      push @files, "$dir/$file" if (-f "$dir/$file" && $file =~ /$htmlext$/);
#      push @files, &list_file_to_update("$dir/$file") if (-d "$dir/$file" && $file !~ /^docs|^admin|^resources/);

      push @files, &list_file_to_update("$dir/$file") if (-d "$dir/$file" && ($file =~ /$langdir/ || $scanok == 1));

    }
  }

  return @files;
}


#sub load_css {
#    local(*OUT,$dir) = @_;
#    local($i,$i2);

#    print OUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"$dir$css_w3perl\" title=\"default\">\n";
#    print OUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"$dir$css_menu_w3perl\" title=\"default\">\n";
#    print OUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"$dir$css_help\" title=\"default\">\n";

#    for ($i2=0;$i2<$nb_css_style;$i2++) {
#	$i = $i2+1;
#	$alt_css_w3perl = "alternate_css_w3perl_".$i.".css";
#	$alt_css_menu = "alternate_css_menu_".$i.".css";
#	$alt_css_help = "alternate_css_help_".$i.".css";
#	print OUT "<link rel=\"alternate stylesheet\" type=\"text/css\" href=\"$dir$alt_css_w3perl\" title=\"style$i\">\n" if (-f "$path$dirress$dirsep$dircss$dirsep$alt_css_w3perl");
#	print OUT "<link rel=\"alternate stylesheet\" type=\"text/css\" href=\"$dir$alt_css_menu_w3perl\" title=\"style$i\">\n" if (-f "$path$dirress$dirsep$dircss$dirsep$alt_css_menu");
#	print OUT "<link rel=\"alternate stylesheet\" type=\"text/css\" href=\"$dir$alt_css_help\" title=\"style$i\">\n" if (-f "$path$dirress$dirsep$dircss$dirsep$alt_css_help");
#    }
#}


sub remove_empty_dir {
    local($page) = @_;

    if ($page =~ /\/\.\.\// && $page !~ /\?/) {
	$page =~ s/$dirsepurl$vserver$dirsepurl// if ($squid_format == 1);
	while ($page =~ /\/\.\.\//) {
	    $pos = index($page,"\.\.\/",1);
	    $tmp = substr($page,0,$pos-1);
	    $tmp = substr($tmp,0,rindex($tmp,$dirsepurl)+1);
	    $tmp2 = substr($page,$pos,length($page));
	    $pos2 = rindex($tmp,$dirsepurl);
	    last if ($pos2 == -1);
	    $tmp2 =~ s/\.\.\///;
	    $page = $tmp.$tmp2;
	}
	$page = $dirsepurl.$vserver.$dirsepurl.$page if ($squid_format == 1);
    }
    return $page;
}

sub add_jqplot_js {
    local(*OUT,$level) = @_;
    local($i,$i2,$tmp,$link,$linkbase,$tmplink);

    $link = '';
    $linkbase = '';
    for ($i=1;$i<=$level;$i++) {
	$link .= "..$dirsepurl";
    }
    
    $linkbase = $link;
    $level = -1 if ($ENV{'REQUEST_METHOD'} eq "GET" && $opt_w eq '' && $scriptname eq "cron-hour.pl" && $opt_n ne '');

    # From cgi
    if ($level == -1) {
	$linkbase = $link_use;
	$linkbase =~ s/$dirsepurl$dirress//;
    }

    $tmplink = "$linkbase$linkpathinit";

    print OUT "<!--[if IE]><script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$tmplink$dirress$dirsepurl$dirjs$dirsepurl$dirjqplot$dirsepurl$jqplot_excanvas\"></script><![endif]-->\n";
    print OUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$tmplink$dirress$dirsepurl$dirjs$dirsepurl$jquery_js\"></script>\n";
    if ($fly_set == 0) {
	print OUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$tmplink$dirress$dirsepurl$dirjs$dirsepurl$dirjqplot$dirsepurl$jqplot_js\"></script>\n";
	print OUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$tmplink$dirress$dirsepurl$dirjs$dirsepurl$dirjqplot$dirsepurl$dirjqplotplugins$dirsepurl$jqplot_plugin_TextRenderer\"></script>\n";
	print OUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$tmplink$dirress$dirsepurl$dirjs$dirsepurl$dirjqplot$dirsepurl$dirjqplotplugins$dirsepurl$jqplot_plugin_AxisLabelRenderer\"></script>\n";
	print OUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$tmplink$dirress$dirsepurl$dirjs$dirsepurl$dirjqplot$dirsepurl$dirjqplotplugins$dirsepurl$jqplot_plugin_highlighter\"></script>\n";
	print OUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$tmplink$dirress$dirsepurl$dirjs$dirsepurl$dirjqplot$dirsepurl$dirjqplotplugins$dirsepurl$jqplot_plugin_cursor\"></script>\n";
	print OUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$tmplink$dirress$dirsepurl$dirjs$dirsepurl$dirjqplot$dirsepurl$dirjqplotplugins$dirsepurl$jqplot_plugin_dateAxisRenderer\"></script>\n";

	print OUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$tmplink$dirress$dirsepurl$dirjs$dirsepurl$dirjqplot$dirsepurl$dirjqplotplugins$dirsepurl$jqplot_plugin_canvasAxis\"></script>\n";
	print OUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$tmplink$dirress$dirsepurl$dirjs$dirsepurl$dirjqplot$dirsepurl$dirjqplotplugins$dirsepurl$jqplot_plugin_categoryAxis\"></script>\n";
	print OUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$tmplink$dirress$dirsepurl$dirjs$dirsepurl$dirjqplot$dirsepurl$dirjqplotplugins$dirsepurl$jqplot_plugin_barRenderer\"></script>\n";
	print OUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$tmplink$dirress$dirsepurl$dirjs$dirsepurl$dirjqplot$dirsepurl$dirjqplotplugins$dirsepurl$jqplot_plugin_pieRenderer\"></script>\n";
	print OUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$tmplink$dirress$dirsepurl$dirjs$dirsepurl$dirjqplot$dirsepurl$dirjqplotplugins$dirsepurl$jqplot_plugin_pointLabels\"></script>\n";
	print OUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$tmplink$dirress$dirsepurl$dirjs$dirsepurl$dirjqplot$dirsepurl$dirjqplotplugins$dirsepurl$jqplot_plugin_enhancedLegendRenderer\"></script>\n";
	print OUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$tmplink$dirress$dirsepurl$dirjs$dirsepurl$dirjqplot$dirsepurl$dirjqplotplugins$dirsepurl$jqplot_plugin_canvasoverlay\"></script>\n";
#    print OUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$tmplink$dirress$dirsepurl$dirjs$dirsepurl$dirjqplot$dirsepurl$dirjqplotplugins$dirsepurl\"></script>\n";
    }

}

sub add_css_style {
    local(*OUT,$level) = @_;
    local($i,$i2,$tmp,$link,$linkbase,$tmplink);

    $link = '';
    $linkbase = '';
    for ($i=1;$i<=$level;$i++) {
	$link .= "..$dirsepurl";
    }
    
    $linkbase = $link;
#    $link .= $I.$dirsepurl;

    $level = -1 if ($ENV{'REQUEST_METHOD'} eq "GET" && $opt_w eq '' && $scriptname eq "cron-hour.pl" && $opt_n ne '');

    # From cgi
    if ($level == -1) {
	$linkbase = $link_use;
	$linkbase =~ s/$dirsepurl$dirress//;
    }

    $tmplink = "$linkbase$linkpathinit";

    print OUT "<link rel=\"icon\" type=\"image/png\" href=\"$tmplink$dirress$dirsepurl$favicon$pngext\">\n";
    print OUT "<link rel=\"shortcut icon\" type=\"image/x-icon\" href=\"$tmplink$dirress$dirsepurl$favicon$icoext\">\n";

    print OUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"$tmplink$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
    print OUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"$tmplink$dirress$dirsepurl$dircss$dirsepurl$css_menu_w3perl\">\n";
    print OUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"$tmplink$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";
    print OUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"$tmplink$dirress$dirsepurl$dircss$dirsepurl$css_jqplot\">\n";


    for ($i=0;$i<=$#alternate_css_style;$i++) {
	$i2 = $i+1;
	$tmp = "alternate_".$i2;
	$css_alternate_file = $tmp.".css";
	print OUT "<link rel=\"alternate stylesheet\" type=\"text/css\" href=\"$tmplink$dirress$dirsepurl$dircss$dirsepurl$css_alternate_file\" title=\"$tmp\">\n" if (-f "$pathinit$dirress$dirsep$dircss$dirsep$css_alternate_file");
	$css_alternate_menu = "alternate_menu_".$i2.".css";
	if (-f "$pathinit$dirress$dirsep$dircss$dirsep$css_alternate_menu") {
	    print OUT "<link rel=\"alternate stylesheet\" type=\"text/css\" href=\"$tmplink$dirress$dirsepurl$dircss$dirsepurl$css_alternate_menu\" title=\"$tmp\">\n";
	}
;
    }

    print OUT "<link href=\"$link$filerss$xmlext\" rel=\"alternate\" title=\"w3perl stats rss\" type=\"application/rss+xml\">\n"; # if ($rss_nb != 0);

}

sub add_css_menu {
    local(*FOUT,*L,$I,$nblang,$level) = @_;
    local($i,$link,$linkbase,$link_lang,$unit_div,$unit,$tmp,$tmp1,$tmp2,$tmp3,$newpage,$tmplink);

    # 6 different menu list
    $class_main = "class_main";
    for ($i=1;$i<=6;$i++) {
	$tmp2 = $class_main.$i;
	$$tmp2 = "sub2";
	$class_submenu = "sub";
    }

    $link = '';
    $linkbase = '';
    for ($i=1;$i<=$level;$i++) {
	$link .= "..$dirsepurl";
    }

    $linkbase = $link;
    $link_lang = $link;
    $link .= $I.$dirsepurl;

    # From cgi
    if ($level == -1) {
	$linkbase = $link_use;
	$linkbase =~ s/$dirsepurl$dirress//;
	$link = $linkbase.$I.$dirsepurl;
    }

    $tmplink = "$linkbase$linkpathinit";

#    if ($newpage2 ne '') {
    $newpage2 = $file_to_open;
	$newpage2 =~ s/$path//i;
	$newpage2 =~ s/$I//i;
	foreach $tmp2 (keys %menu_color_actif) {
	    if ($newpage2 =~ /^$tmp2/) {
		$menuactif = $class_main.$menu_color_actif{$tmp2};
		$menuactif2 = $menu_color_actif{$tmp2};
		$$menuactif = "sub3";
	    }
	}
#    }

    print FOUT "<!-- begin_insert_css_menu -->\n";
    
    print FOUT "<TABLE WIDTH=\"100%\" BORDER=0 CELLPADDING=0 CELLSPACING=0>\n<TR>\n<TD ALIGN=CENTER>\n";
#    print FOUT "<div class=\"topline\">";

#    print FOUT "<DIV CLASS=\"curly\" STYLE='background: #FFEECC;margin: 0px 10px 0px 10px;padding: 0pt'>\n";


#    print FOUT "<DIV CLASS=\"curly\" STYLE='background: #F3DEAB;margin: 0px 10px 0px 10px;padding: 0pt'>\n";
#    print FOUT "<div class=\"topline2\" STYLE='height: $logo_height px;background: #F3DEAB;'>";
#    print FOUT "<div class=\"topline2\" STYLE='height: ".$logo_height."px;background: #FFEECC;'>";
#    print FOUT "<div class=\"topline2\" STYLE='background: #FFEECC;'>";

    print FOUT "<DIV CLASS=\"curly\">\n";
    print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2 WIDTH=\"100%\">\n";
    print FOUT "<TR>\n";
    print FOUT "<TD ALIGN=CENTER VALIGN=MIDDLE>";
    print FOUT "<A HREF=\"$localserver_protocol://$localserver";
#    print FOUT "$dirsepurl" if ($tri !~ /^$dirsepurl/);
    print FOUT "$tri" if ($tri =~ /^$dirsepurl/ && $tri ne $dirsepurl);
    print FOUT "\">";

    print FOUT "<IMG";
    print FOUT " WIDTH=\"$logo_width\" HEIGHT=\"$logo_height\"" if ($logo !~ /^http/);
    print FOUT " SRC=\"";
    print FOUT "$logo" if ($logo =~ /^http/ || $logo =~ /^\//);
    print FOUT "$tmplink$dirress$dirsepurl$logo" if ($logo !~ /^\// && $logo !~ /^http/);
    print FOUT "\" ALT=\"Logo\" BORDER=0>\n";

    print FOUT "</A>\n";
    print FOUT "</TD><TD VALIGN=TOP>\n";
    print FOUT "<div class=\"topline2\">";
    print FOUT "<B>$L{'Stats'} $localserver";
    print FOUT "$tri" if ($tri =~ /^$dirsepurl/);
    print FOUT "<BR>\n";
    print FOUT "</B>";
    print FOUT "<DIV ID=\"display_topheader_line1\"></DIV>\n";
    print FOUT "</div>\n";

    print FOUT "<div CLASS=\"topline3\">\n";

    print FOUT "<DIV ID=\"display_topheader_line2\"></DIV>\n";

    if ($notrafic == 0) {
	($unit_div,$unit) = &Return_Unit($totsize,1);
	$unit = $L{$unit};
    }
    print FOUT "</div>\n";

#    $newpage = $filenames[$j];
#    $newpage2 = $newpage;

#    if ($H =~ /$homepages[$nblang]$/) {
#    if ($w3perlcgiurl ne '' && -d $cgipath_install) {
    if ($linkpath_url ne '') {
	print FOUT "<!-- Last_update -->"; # to find last_update when updating or not css menu
	print FOUT "<div CLASS=\"topline4\">";
	print FOUT "$L{'Last_update'} : <SPAN ID=\"display_topheader_line3\"></SPAN>\n";
	print FOUT "</div>\n";
    }

    $datafileinc = $linkpath_url.$dirinc.$dirsepurl."topheader".$txtext;
    print FOUT "<FORM name=\"topheader\" ACTION=\"topheader\">\n";
    print FOUT "<INPUT type=\"hidden\" name=\"topheaderfile\" value=\"$datafileinc\">\n";

    $datafileinc = $linkpath_url.$dirinc.$dirsepurl.$menuheader;
    print FOUT "<INPUT type=\"hidden\" name=\"menuheaderfile\" value=\"$datafileinc\">\n";
    print FOUT "<INPUT type=\"hidden\" name=\"menulink\" value=\"$link\">\n";
    print FOUT "<INPUT type=\"hidden\" name=\"menulinktop\" value=\"$linkbase\">\n";
    print FOUT "<INPUT type=\"hidden\" name=\"menulinkhome\" value=\"$tmplink\">\n";

    print FOUT "<INPUT type=\"hidden\" name=\"menulinkbase\" value=\"$linkbase$homeicons$dirsepurl\">\n";
    print FOUT "<INPUT type=\"hidden\" name=\"menulang\" value=\"$nblang\">\n";

    print FOUT "<INPUT type=\"hidden\" name=\"menuactif\" value=\"$menuactif2\">\n";
#    print FOUT "<INPUT type=\"hidden\" name=\"newpage\" value=\"$newpage2\">\n";


#    if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
    if ($ftp_format == 0 && $mail_format == 0 && $dhcp_format == 0) {
	print FOUT "<INPUT type=\"hidden\" name=\"skip_acces\" value=\"0\">\n";
    } else {
	print FOUT "<INPUT type=\"hidden\" name=\"skip_acces\" value=\"1\">\n";
    }
    print FOUT "<INPUT type=\"hidden\" name=\"string_topheader\"  value=\"$L{'days'}:$L{'pages'}:$L{'requests'}:$L{'documents'}:$unit:$L{'hosts'}:$L{'countries'}:$L{'from'}:$L{'in'}\">\n";
    print FOUT "</FORM>\n";

    print FOUT "</TD><TD>\n";

    print FOUT "<!-- begin_var_css_menu -->\n";

    print FOUT "<DIV CLASS=\"top_section\">\n";
    # Change CSS Style

    print FOUT "<TABLE BORDER=0><TR>\n";

    # Print / Email / Bigger-Smaller Font / Bookmark

    print FOUT "<TD VALIGN=TOP>\n";

    if ($linkpath_url ne '' && $cgipath ne '' && $nbdays > 1) {

	$tmp = &date_intervalle($firstday,-1);
	($tmp1,$tmp2,$tmp3) = split(/\s+/,$tmp);
	$tmp_in = "$tmp2 $tmp1, $tmp3";

	$tmp = &date_intervalle($yesterday,1);
#	$tmp = $yesterday;
	($tmp1,$tmp2,$tmp3) = split(/\s+/,$tmp);
	$tmp_out = "$tmp2 $tmp1, $tmp3";
	
	# Calendar (Day/Week/Month)
	# Today / Yesterday / Last 3 days / Last 7 days / Current Month

	print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"$tmplink$dirress$dirsepurl$dirjs$dirsepurl$calendarpopupjs\"></script>\n";

	print FOUT "<script language=\"javascript\" type=\"text/javascript\">\n";
	print FOUT "var cal11 = new CalendarPopup(\"testdiv1\");\n";
	print FOUT "cal11.setCssPrefix(\"Calendar\");\n";
	print FOUT "cal11.setReturnFunction(\"setMultipleValues31\");\n";
	print FOUT "cal11.addDisabledDates(null,\"".$tmp_in."\");\n";
	print FOUT "cal11.addDisabledDates(\"".$tmp_out."\",null);\n";
	
	print FOUT "function setMultipleValues31(y,m,d) {\n";
	print FOUT " document.forms.dayrange.date11_year.value=y;\n";
	print FOUT " document.forms.dayrange.date11_month.selectedIndex=m-1;\n";
	print FOUT " document.forms.dayrange.date11_date.selectedIndex=d-1;\n";
	print FOUT " document.forms.dayrange.s.value='\\''+d+' '+document.forms.dayrange.date11_month.value+' '+y+'\\'';\n";
	print FOUT " }\n";
	
	print FOUT "var cal12 = new CalendarPopup(\"testdiv1\");\n";
	print FOUT "cal12.setCssPrefix(\"Calendar\");\n";
	print FOUT "cal12.setReturnFunction(\"setMultipleValues32\");\n";
	print FOUT "cal12.addDisabledDates(null,\"".$tmp_in."\");\n";
	print FOUT "cal12.addDisabledDates(\"".$tmp_out."\",null);\n";
	
	print FOUT "function setMultipleValues32(y,m,d) {\n";
	print FOUT " document.forms.dayrange.date12_year.value=y;\n";
	print FOUT " document.forms.dayrange.date12_month.selectedIndex=m-1;\n";
	print FOUT " document.forms.dayrange.date12_date.selectedIndex=d-1;\n";
	print FOUT " document.forms.dayrange.r.value='\\''+d+' '+document.forms.dayrange.date12_month.value+' '+y+'\\'';\n";
	print FOUT " }\n";

	print FOUT "function IniInnerValue() {\n";
	print FOUT "document.getElementById('error_msg1').innerHTML = \"\";\n";
	print FOUT "}\n";

	print FOUT "function setDateValue() {\n";
	print FOUT "var monthIndexes = {'Jan':0,'Feb':1,'Mar':2,'Apr':3,'May':4,'Jun':5,'Jul':6,'Aug':7,'Sep':8,'Oct':9,'Nov':10,'Dec':11};\n";

	print FOUT "var y = document.forms.dayrange.date11_year.value;\n";
	print FOUT "var m = document.forms.dayrange.date11_month.value;\n";
#	print FOUT "var d = document.forms.dayrange.date11_date.selectedIndex;\n";
	print FOUT "var d = document.forms.dayrange.date11_date.value;\n";
	print FOUT "if (d < 10) d = '0'+d;\n";
	print FOUT "var m2 = monthIndexes[m]+1\n";
	print FOUT "if (m2 < 10) m2 = '0'+m2;\n";
	print FOUT "var dat1 = d+'/'+m+'/'+y;\n";
	print FOUT "var dat11 = y+'-'+m2+'-'+d;\n";

#	print "Firstday : $firstday / $yesterday\n" if ($firstday eq '');
	($tmp1,$tmp2,$tmp3) = split(/ /,$firstday);
	$tmp = "$tmp3-$month_equiv{$tmp2}-$tmp1";
	$year_ini = $tmp3;
	$month_ini = $tmp2;
	$day_ini = $tmp1;

	print FOUT "var dat12 = '$tmp';\n";
	print FOUT "var exit1 = isDateValid(dat1);\n";
	print FOUT "if (exit1 == false || dat11 < dat12) {\n";
	print FOUT "document.getElementById('error_msg1').style.display = \"inline\";\n";
	print FOUT "if (dat11 < dat12) document.getElementById('error_msg1').innerHTML = \"Date \"+dat1+\" is out of range\";\n";
	print FOUT "if (exit1 == false) document.getElementById('error_msg1').innerHTML = \"Invalid date : \"+dat1;\n";
	print FOUT "return false;\n";
	print FOUT "}\n";
	print FOUT "document.forms[\"dayrange\"].s.value='\\''+d+' '+m+' '+y+'\\'';\n";

#	print FOUT "alert(\"TOTO1 \"+document.forms[\"dayrange\"].s.value);\n";	

	print FOUT "var y = document.forms.dayrange.date12_year.value;\n";
	print FOUT "var m = document.forms.dayrange.date12_month.value;\n";
#	print FOUT "var d = document.forms.dayrange.date12_date.selectedIndex;\n";
	print FOUT "var d = document.forms.dayrange.date12_date.value;\n";
	print FOUT "if (d < 10) d = '0'+d;\n";
	print FOUT "var m2 = monthIndexes[m]+1\n";
	print FOUT "if (m2 < 10) m2 = '0'+m2;\n";
	print FOUT "var dat2 = d+'/'+m+'/'+y;\n";
	print FOUT "var dat12 = y+'-'+m2+'-'+d;\n";
	
	($tmp1,$tmp2,$tmp3) = split(/[ \/]/,$yesterday);
#	$tmp = "$tmp3-$month_equiv{$tmp2}-$tmp1";

#	print FOUT "var dat12 = '$tmp';\n";

#	print FOUT "alert(\"TOTO2 \"+dat11);\n";
	
	print FOUT "var exit1 = isDateValid(dat1);\n";
	print FOUT "if (exit1 == false || dat11 > dat12) {\n";
	print FOUT "document.getElementById('error_msg1').style.display = \"inline\";\n";
	print FOUT "if (dat11 > dat12) document.getElementById('error_msg1').innerHTML = \"Date \"+dat1+\" is out of range\";\n";
	print FOUT "if (exit1 == false) document.getElementById('error_msg1').innerHTML = \"Invalid date : \"+dat1;\n";
	print FOUT "return false;\n";
	print FOUT "}\n";
	print FOUT "document.forms[\"dayrange\"].r.value='\\''+d+' '+m+' '+y+'\\'';\n";
	print FOUT "document.forms[\"dayrange\"].d[0].selected = true;\n";
	print FOUT "return true;\n";
	print FOUT "}\n";


	print FOUT "</script>\n";

	print FOUT "\n<DIV ID=\"error_msg1\" STYLE=\"display:none\">\n";
	print FOUT "</DIV>\n";

	if ($w3perlcgiurl ne '' && -d $cgipath_install) {
	print FOUT "<FORM METHOD=\"POST\" NAME=\"dayrange\" OnSubmit=\"return setDateValue()\" ACTION=\"$w3perlcgiurl$dirsepurl$dayrange\">\n";

	print FOUT "<INPUT type=\"hidden\" name=\"c\"  value=\"\'$opt_c\'\">\n";
	print FOUT "<INPUT type=\"hidden\" name=\"t\"  value=\"0\">\n";
	print FOUT "<INPUT type=\"hidden\" name=\"l\"  value=\"\'$I\'\">\n";

	print FOUT "<TABLE BORDER=0><TR><TD>\n";

	# Date in

	print FOUT "<SELECT NAME=\"date11_month\"  OnClick=\"javascript:IniInnerValue()\" CLASS=\"top_section\">\n";
#	print FOUT "	<OPTION>\n";
	for ($i=0;$i<=$#month_nb;$i++) {
	    print FOUT "	<OPTION VALUE=\"$month_nb[$i]\"";
	    print FOUT " SELECTED" if ($month_nb[$i] eq $month_ini);
	    print FOUT ">$month_nb[$i]\n";
	}
	print FOUT "</SELECT>\n";
	print FOUT "/\n";
	print FOUT "<SELECT NAME=\"date11_date\"  OnClick=\"javascript:IniInnerValue()\" CLASS=\"top_section\">\n";
#	print FOUT "	<OPTION>\n";
	for ($i=1;$i<=31;$i++) {
	    print FOUT "	<OPTION VALUE=\"$i\"";
	    print FOUT " SELECTED" if ($i == $day_ini);
	    print FOUT ">$i\n";
	}
	print FOUT "</SELECT>\n";
	print FOUT "/\n";    

	print FOUT "<SELECT NAME=\"date11_year\"  OnClick=\"javascript:IniInnerValue()\" CLASS=\"top_section\">\n";
#	print FOUT "	<OPTION>\n";

#	print "AA $tmp3 - $year_ini / $firstday - $yesterday\n";

	for ($i=$tmp3;$i>=$year_ini;$i--) {
	    print FOUT "	<OPTION VALUE=\"$i\"";
	    print FOUT " SELECTED" if ($i == $year_ini);
	    print FOUT ">$i\n";
	}
	print FOUT "</SELECT>\n";
	print FOUT "\n";    
#	print FOUT "<INPUT TYPE=\"text\" NAME=\"date11_year\" VALUE=\"\" SIZE=5  OnClick=\"javascript:IniInnerValue()\" MAXLENGTH=4 CLASS=\"top_section\">\n";
	print FOUT "</TD>\n<TD>";
#	print FOUT "<A HREF=\"#\" onClick=\"cal11.showCalendar('anchor11'); return false;\" TITLE=\"cal11.showCalendar('anchor11'); return false;\" NAME=\"anchor11\" ID=\"anchor11\"><IMG SRC=\"$linkbase$dirress$dirsep$icon_calendar\" WIDTH=\"16\" HEIGHT=\"16\" BORDER=0 ALT=\"calendar\"></A>\n";
	print FOUT "<A HREF=\"#\" onClick=\"cal11.showCalendar('anchor11'); return false;\" TITLE=\"showCalendar\" NAME=\"anchor11\" ID=\"anchor11\"><IMG SRC=\"$tmplink$dirress$dirsep$icon_calendar\" WIDTH=\"16\" HEIGHT=\"16\" BORDER=0 ALT=\"calendar\"></A>\n";
	print FOUT "</TD>\n";

	# Go

	print FOUT "<TD ROWSPAN=2>\n";
	print FOUT "<INPUT TYPE=\"image\" SRC=\"$tmplink$dirress$dirsep$icon_go\" ALT=\"Go\" VALUE=\"Go\">\n";
	print FOUT "</TD>\n</TR>\n<TR>\n<TD>";

	# Date out

	print FOUT "<SELECT NAME=\"date12_month\" CLASS=\"top_section\">\n";
#	print FOUT "	<OPTION>\n";
	for ($i=0;$i<=$#month_nb;$i++) {
	    print FOUT "	<OPTION VALUE=\"$month_nb[$i]\"";
	    print FOUT " SELECTED" if ($month_nb[$i] eq $tmp2);
	    print FOUT ">$month_nb[$i]\n";
	}
	print FOUT "</SELECT>\n";
	print FOUT "/\n";
	print FOUT "<SELECT NAME=\"date12_date\" CLASS=\"top_section\">\n";
#	print FOUT "	<OPTION>\n";
	for ($i=1;$i<=31;$i++) {
	    print FOUT "	<OPTION VALUE=\"$i\"";
	    print FOUT " SELECTED" if ($i == $tmp1);
	    print FOUT ">$i\n";
	}
	print FOUT "</SELECT>\n";
	print FOUT "/\n";  
  	print FOUT "<SELECT NAME=\"date12_year\"  OnClick=\"javascript:IniInnerValue()\" CLASS=\"top_section\">\n";
#	print FOUT "	<OPTION>\n";
	for ($i=$tmp3;$i>=$year_ini;$i--) {
	    print FOUT "	<OPTION VALUE=\"$i\"";
	    print FOUT " SELECTED" if ($i == $tmp3);
	    print FOUT ">$i\n";
	}
	print FOUT "</SELECT>\n";
	print FOUT "\n";    
#	print FOUT "<INPUT TYPE=\"text\" NAME=\"date12_year\" VALUE=\"\" SIZE=5 MAXLENGTH=4 CLASS=\"top_section\">\n";
	print FOUT "</TD>\n<TD>";
#	print FOUT "<A HREF=\"#\" onClick=\"cal12.showCalendar('anchor12'); return false;\" TITLE=\"cal12.showCalendar('anchor12'); return false;\" NAME=\"anchor12\" ID=\"anchor12\"><IMG SRC=\"$linkbase$dirress$dirsep$icon_calendar\" WIDTH=\"16\" HEIGHT=\"16\" BORDER=0 ALT=\"calendar\"></A>\n"
;	print FOUT "<A HREF=\"#\" onClick=\"cal12.showCalendar('anchor12'); return false;\" TITLE=\"showCalendar\" NAME=\"anchor12\" ID=\"anchor12\"><IMG SRC=\"$tmplink$dirress$dirsep$icon_calendar\" WIDTH=\"16\" HEIGHT=\"16\" BORDER=0 ALT=\"calendar\"></A>\n";

	print FOUT "</TD></TR>\n<TR><TD COLSPAN=3>\n";

	print FOUT "<DIV ID=\"testdiv1\" STYLE=\"position:absolute;visibility:hidden;background-color:white;z-index:50\"></DIV>\n";

	print FOUT "<INPUT TYPE=\"hidden\" NAME=\"s\" VALUE=\"'$day_ini $month_ini $year_ini'\">\n";
	print FOUT "<INPUT TYPE=\"hidden\" NAME=\"r\" VALUE=\"'$tmp1 $tmp2 $tmp3'\">\n";
#	print FOUT "<INPUT TYPE=\"hidden\" NAME=\"s\" VALUE=\"\">\n";
#	print FOUT "<INPUT TYPE=\"hidden\" NAME=\"r\" VALUE=\"\">\n";

	if ($nbdays > 1) {
	    print FOUT "<SELECT NAME=\"d\" CLASS=\"top_section\" onChange='javascript:if (d.options[d.selectedIndex].value != 0) this.form.submit();'>\n";

	    print FOUT "<OPTION VALUE=\"0\">$L{'Select_an_interval'}\n";

	    for ($i=0;$i<=$#last_day_show;$i++) {
		$tmp = $last_day_show[$i];
		if ($tmp <= $nbdays) {
		    $tmp2 = $L{'days'};
		    if ($tmp > 13 && int($tmp/7) == ($tmp/7)) {
			$tmp2 = lc($L{'Weeks'});
			$tmp = int($tmp/7);
		    }
		    if ($tmp >= 30 && int($tmp/30) == ($tmp/30)) {
			$tmp2 = lc($L{'Months'});
			$tmp = int($tmp/30);
		    }
		    print FOUT "<OPTION VALUE=\"$last_day_show[$i]\"";
		    print FOUT " SELECTED" if ($opt_d == $last_day_show[$i]);
		    print FOUT ">$L{'Last'} $tmp $tmp2\n";
		}
	    }

	    print FOUT "</SELECT>\n";
	}
	print FOUT "</TD></TR></TABLE>\n";


	print FOUT "</FORM>\n";
	}
    }

    # Search (Pages/Hosts/Refer/Session)

    print FOUT "</TD><TD VALIGN=TOP ALIGN=CENTER>\n";

    # CSS style switcher

    print FOUT "<FORM METHOD=\"POST\" NAME=\"style_switcher\" ACTION=\"\">\n";
    print FOUT "<SELECT NAME=\"style_switcher\" CLASS=\"top_section\" onchange=\"javascript:setActiveStyleSheet(style_switcher.options[style_switcher.selectedIndex].value); var myBoxObject = new curvyCorners(settings, 'curly'); myBoxObject.applyCornersToAll(); ieFix('menucss');return false;\">\n";
    print FOUT "<OPTION VALUE=\"default\">Default\n";
    for ($i=0;$i<=$#alternate_css_style;$i++) {
	$i2 = $i+1;
	print FOUT "<OPTION VALUE=\"alternate_$i2\">$alternate_css_style[$i]\n";
    }
    print FOUT "</SELECT>\n";
    print FOUT "</FORM>\n";

    # Language
    if ($#lang > 0) {	
#	if ($scriptname eq "cron-hour.pl") {
#	    $newpage = $file_to_open;
#	}

#	$tmp1 = $newpage;
	$tmp1 = $file_to_open;
	$tmp2 = $file_to_open;

	print FOUT "<TABLE>\n<TR>\n";
	for ($i=0;$i<=$#lang;$i++) {
	    if ($i != $nblang) {
		print FOUT "<td><a href=\"";
#		if ($newpage eq '') {
#		    if ($file_to_open =~ /$path$dirtmp$dirsepurl$I$dirsepurl/) {
#			$tmp2 =~ s/$path$dirtmp$dirsepurl$I$dirsepurl//i;
#			print FOUT "\.\.$dirsepurl\.\.$dirsepurl$lang[$i]$dirsepurl$tmp2";
#		    }
#		} else {
#		    if ($newpage =~ /$path$I/) {
#			$tmp1 =~ s/$path$I$dirsepurl//i;
#			print FOUT "$link_lang$lang[$i]$dirsepurl$tmp1";
#		    } else {
#		    print FOUT "$homepages[$i]";
#		    }
#		}


		if ($file_to_open =~ /$path$dirtmp$dirsepurl$I$dirsepurl/) {
		    $tmp2 =~ s/$path$dirtmp$dirsepurl$I$dirsepurl//i;
		    print FOUT "\.\.$dirsepurl\.\.$dirsepurl$lang[$i]$dirsepurl$tmp2";
		} elsif ($file_to_open =~ /$path$I/) {
			$tmp1 =~ s/$path$I$dirsepurl//i;
			print FOUT "$link_lang$lang[$i]$dirsepurl$tmp1";
		} else {
		    print FOUT "$homepages[$i]";
		}

		print FOUT "\"><img src=\"$tmplink$dirress$dirsepurl$flag[$i]\" border=0 WIDTH=\"30\" HEIGHT=\"15\" TITLE=\"$flag[$i]\" ALT=\"$flag[$i]\"></a></td>\n";
	    }
	}
	print FOUT "</TR></TABLE>\n";
    }

    # Bookmark / PDF / Email / Print

#    if ($file_to_open eq '') {
##	$link_use = $linkbase.$linkpathinit.$dirress.$dirsepurl;
#	$newpage3 = $newpage2;
#	$newpage3 =~ s/$path//;
#    } else {
##	$link_use = $linkbase.$linkpathinit.$dirress.$dirsepurl;
	$newpage3 = $file_to_open;
	$newpage3 =~ s/$path//;
#    }

#    print "TOTO $file_to_open - $newpage3\n";
    $tmp = "$localhost_protocol://$localhost";
    $tmp .= ":$localhost_port" if ($localhost_port != 80);
    $tmp .= "$linkpath_url$newpage3";

    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\">\n";
    print FOUT "function get_title() {\n";
    print FOUT "write(document.title);";
    print FOUT "}\n";
    print FOUT "function favoris() {\n";
    print FOUT " var dd = document.title;\n";
    print FOUT "if ( navigator.appName != 'Microsoft Internet Explorer' ) {\n";
    print FOUT "  window.sidebar.addPanel(dd,\"$tmp\",\"\",\"\",0);\n";
    print FOUT "} else {\n";
    print FOUT "window.external.AddFavorite(\"$tmp\",dd);\n";
    print FOUT "}\n";
    print FOUT "}\n";
    print FOUT "function OuvrirPopup(page) {\n";
    print FOUT "window.open(page, '', 'resizable=no, location=no, width=380, height=250, menubar=no, status=no, scrollbars=no, menubar=no');\n";
    print FOUT "}\n";
    print FOUT "</script>\n";
    print FOUT "<TABLE><TR><TD>\n";
    print FOUT "<a href=\"javascript:void(favoris());\" title=\"Bookmark\"><img src=\"$linkbase$homeicons$dirsepurl$icon_bookmark\" WIDTH=\"20\" HEIGHT=\"20\" BORDER=0 ALT=\"bookmark\"></A>";
    print FOUT "</TD><TD>\n";
    print FOUT "<a href=\"javascript:window.print()\" title=\"Print\"><img src=\"$linkbase$homeicons$dirsepurl$icon_print\" WIDTH=\"20\" HEIGHT=\"20\" BORDER=0 ALT=\"print\"></A>";
    print FOUT "</TD></TR>";
    if ($w3perlcgiurl ne '' && -d $cgipath_install) {
	if ($enable_pdf == 1 || ($enable_email == 1 && $emailadr ne '')) {
	    print FOUT "<TR><TD>\n";
	    &PagesExportPDF(*FOUT,"$newpage3",$title,$level,2,0,1) if ($enable_pdf == 1);
	    print FOUT "</TD>";
	    print FOUT "<TD>\n";
	    &PagesExportPDF(*FOUT,"$newpage3",$title,$level,1,0,1) if ($enable_email == 1 && $emailadr ne '');
	    print FOUT "</TD>\n</TR>";
	}
    }
    print FOUT "</TABLE>\n";

    print FOUT "</TD>\n</TR></TABLE>\n";
    print FOUT "</DIV>\n";

    print FOUT "<!-- end_var_css_menu -->\n";

    print FOUT "</TD></TR></TABLE>\n";

    print FOUT "</div>\n";
#    print FOUT "</div>\n";

    if ($precision > 1 && $linkpath_url ne '') {
	print FOUT "<DIV ID=\"display_cssmenu\">\n</DIV>\n";
    }

#    if ($linkpath_url eq '') {
    if ($linkpath_url eq '') {
    print FOUT "<ul id=\"menucss\">\n";

    # Main -1-
    if ($precision > 1) {
    print FOUT "<li class=\"$class_main1\"><a href=\"$linkbase$homepages[$nblang]\"><img src=\"$tmplink$dirress$dirsepurl$flag[$nblang]\" border=0 WIDTH=\"30\" HEIGHT=\"15\" ALT=\"$flag[$nblang]\">&nbsp;$L{'Index'}</a>\n";
    print FOUT "<ul>\n";
    print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirsite$dirsepurl$filesites\"><img src=\"$linkbase$homeicons$dirsepurl$icon_hosts\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Hosts'}\">&nbsp;$L{'Hosts'}</a></li>\n";
    print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirpage$dirsepurl$filepages\"><img src=\"$linkbase$homeicons$dirsepurl$icon_pages\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Pages'}\">&nbsp;$L{'Pages'}</a></li>\n";
    print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirlist$dirsepurl$filetype$htmlext\"><img src=\"$linkbase$homeicons$dirsepurl$icon_filetype\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Filetype'}\">&nbsp;$L{'Filetype'}</a></li>\n" if (-f "$path$lang[$nblang]$dirsep$dirlist$dirsep$filetype$htmlext" && $precision > 2);
    print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirscript$dirsepurl$filescript\"><img src=\"$linkbase$homeicons$dirsepurl$icon_pages\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Scripts'}\">&nbsp;$L{'Scripts'}</a></li>\n" if ($inc_script == 1 && $ftp_format == 0 && $scriptunique != 0);
    if (-s "$path$dirinc$dirsep$incstatus") {
	print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirlist$dirsepurl$incstatus$htmlext\"><img src=\"$linkbase$homeicons$dirsepurl$icon_status\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Status_code'}\">&nbsp;$L{'Status_code'}</a>\n";

#    print FOUT "<ul>\n";
	$tmp2 = '';
	$found_status = 0;
	foreach $status (sort (keys %FailStatusMsgs)) {
	    if ($status_code{$status} != 0 && $status >= 400) {
		$found_status = 1;
		$tmp2 .= "<li class=\"$class_submenu\"><a href=\"$link$dirlist$dirsepurl$incstatus$status$htmlext\">$FailStatusMsgs{$status}</a>\n";
	    }
	}
	print FOUT "<ul>$tmp2</ul>\n" if ($found_status == 1);
	print FOUT "</li>\n";
    }

    print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirlist$dirsepurl$filerepert\"><img src=\"$linkbase$homeicons$dirsepurl$icon_dir\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Directories'}\">&nbsp;$L{'Directories'}</a></li>\n" if (-f "$path$lang[$nblang]$dirsep$dirlist$dirsep$filerepert");
    print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirlist$dirsepurl$dirtraffic$htmlext\"><img src=\"$linkbase$homeicons$dirsepurl$icon_traffic\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Traffic'}\">&nbsp;$L{'Traffic'}</a></li>\n" if ($notrafic == 0 && $totsize != 0);
    print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirlist$dirsepurl$dirdownload$htmlext\"><img src=\"$linkbase$homeicons$dirsepurl$icon_pie\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Download'}\">&nbsp;$L{'Download'}</a></li>\n" if ($notrafic == 0 && $totsize != 0);

    if ($paysunique != 0 && $skip_pays == 0) {
	print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirpays$dirsepurl$filepays\"><img src=\"$linkbase$homeicons$dirsepurl$icon_countries\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Countries'}\">&nbsp;$L{'Countries'}</a>\n";
	$tmp = '';

	for ($i=1;$i<=$nbzone;$i++) {
		$tmp .= "<li class=\"$class_submenu\"><a href=\"$link$dirpays$dirsepurl$zone[$i]$htmlext\">$L{$zone[$i]}</a>\n" if (-f "$path$lang[$nblang]$dirsep$dirpays$dirsep$zone[$i]$htmlext");
	}
	if ($tmp ne '') {
	    print FOUT "<ul>\n";
	    print FOUT "$tmp";
	    print FOUT "</ul>\n";
	}
	print FOUT "</li>\n";
    }

    print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dircity$dirsepurl$menu\"><img src=\"$linkbase$homeicons$dirsepurl$icon_city\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Cities'}\">&nbsp;$L{'Cities'}</a></li>\n" if ($geoipcity == 1 && $skip_city == 0);
    print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirlist$dirsepurl$filerss$htmlext\"><img src=\"$linkbase$homeicons$dirsepurl$icon_rss\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'RSS'}\">&nbsp;$L{'RSS'}</a></li>\n" if ($rss_nb != 0);
    print FOUT "</ul>\n";
    print FOUT "</li>\n";
    }

    # When -2-
    if (-e "$path$lang[$nblang]$dirsep$dirdate$dirsep$file_now" || -e "$path$lang[$nblang]$dirsep$dirdate$dirsep$filenamehour" || -e "$path$lang[$nblang]$dirsep$dirdate$dirsep$filenameday" || -e "$path$lang[$nblang]$dirsep$dirdate$dirsep$statnameweek" || -e "$path$lang[$nblang]$dirsep$dirdate$dirsep$statnamemonth" || -e "$path$lang[$nblang]$dirsep$dirdate$dirsep$statnameyear") {
#	print FOUT "<li class=\"$class_main2\"><a href=\"#\">&nbsp;$L{'When'}</a>\n";
	print FOUT "<li class=\"$class_main2\">&nbsp;$L{'When'}\n";
	print FOUT "<ul>\n";
	print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirdate$dirsepurl$file_now\"><img src=\"$linkbase$homeicons$dirsepurl$icon_duree\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Real_time'}\">&nbsp;$L{'Real_time'}</a></li>\n" if (-e "$path$lang[$nblang]$dirsep$dirdate$dirsep$file_now");
	print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirdate$dirsepurl$filenamehour\"><img src=\"$linkbase$homeicons$dirsepurl$icon_hours\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Hours'}\">&nbsp;$L{'Hours'}</a></li>\n" if (-e "$path$lang[$nblang]$dirsep$dirdate$dirsep$filenamehour" || $actif_hour == 1);
	print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirdate$dirsepurl$fileday\"><img src=\"$linkbase$homeicons$dirsepurl$icon_days\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Days'}\">&nbsp;$L{'Days'}</a></li>\n" if (-e "$path$lang[$nblang]$dirsep$dirdate$dirsep$filenameday" || $actif_day == 1);
	print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirdate$dirsepurl$fileweek\"><img src=\"$linkbase$homeicons$dirsepurl$icon_weeks\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Weeks'}\">&nbsp;$L{'Weeks'}</a></li>\n" if (-e "$path$lang[$nblang]$dirsep$dirdate$dirsep$statnameweek" || ($nbdays > 14 && $actif_week == 1));
	print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirdate$dirsepurl$filemonth\"><img src=\"$linkbase$homeicons$dirsepurl$icon_months\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Months'}\">&nbsp;$L{'Months'}</a></li>\n" if (-e "$path$lang[$nblang]$dirsep$dirdate$dirsep$statnamemonth" || ($nbdays > 30 && $actif_month == 1));
	print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirdate$dirsepurl$statnameyear\"><img src=\"$linkbase$homeicons$dirsepurl$icon_year\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Years'}\">&nbsp;$L{'Years'}</a></li>\n" if (-e "$path$lang[$nblang]$dirsep$dirdate$dirsep$statnameyear" || $actif_year == 1);
	print FOUT "</ul>\n";
	print FOUT "</li>\n";
    }

    # Optional -3-
    if (-e "$path$lang[$nblang]$dirsep$dirlist$dirsep$error" || -e "$path$lang[$nblang]$dirsep$dirlist$dirsep$agent" || -e "$path$lang[$nblang]$dirsep$dirlist$dirsep$refer" || -e "$path$lang[$nblang]$dirsep$dirlist$dirsep$tabnamekeyword" || $nb_user != 0 || $screensize_val != 0 || $heatmap_val != 0 || $nb_virus != 0 || ($virtualfilter eq '' && $virtualunique > 1) || (-e "$path$lang[$nblang]$dirsep$dirproxy$dirsep$filesquid" && $squid_format == 1)) {
#	print FOUT "<li class=\"$class_main\"><span id=\"menu1\">Optional</span>\n";
#	print FOUT "<li class=\"$class_main3\"><a href=\"#\">&nbsp;$L{'Optional'}</a>\n";
	print FOUT "<li class=\"$class_main3\">&nbsp;$L{'Optional'}\n";
	print FOUT "<ul>\n";
	print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirlist$dirsepurl$error\"><img src=\"$linkbase$homeicons$dirsepurl$icon_error\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Errors'}\">&nbsp;$L{'Errors'}</a></li>\n" if (-e "$path$lang[$nblang]$dirsep$dirlist$dirsep$error");
	print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirlist$dirsepurl$agent\"><img src=\"$linkbase$homeicons$dirsepurl$icon_agent\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Browsers'}\">&nbsp;$L{'Browsers'}</a></li>\n" if (-e "$path$lang[$nblang]$dirsep$dirlist$dirsep$agent");
	print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirlist$dirsepurl$refer\"><img src=\"$linkbase$homeicons$dirsepurl$icon_refer\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Referer'}\">&nbsp;$L{'Referer'}</a></li>\n" if (-e "$path$lang[$nblang]$dirsep$dirlist$dirsep$refer");
	print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirlist$dirsepurl$tabnamekeyword\"><img src=\"$linkbase$homeicons$dirsepurl$icon_spider\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Search_engine'}\">&nbsp;$L{'Search_engine'}</a></li>\n" if (-e "$path$lang[$nblang]$dirsep$dirlist$dirsep$tabnamekeyword");
	print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirlist$dirsepurl$users$htmlext\"><img src=\"$linkbase$homeicons$dirsepurl$icon_users\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Users'}\">&nbsp;$L{'Users'}</a></li>\n" if ($nb_user != 0 && $inc_user == 1);
	print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirlist$dirsepurl$spam$htmlext\"><img src=\"$linkbase$homeicons$dirsepurl$icon_spam\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Spam'}\">&nbsp;$L{'Spam'}</a></li>\n" if ($spam_found != 0);
	print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirlist$dirsepurl$filescreensize\"><img src=\"$linkbase$homeicons$dirsepurl$icon_screensize\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Screensize'}\">&nbsp;$L{'Screensize'}</a></li>\n" if ($screensize_val != 0); 
	print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirlist$dirsepurl$fileheatmap$htmlext\"><img src=\"$linkbase$homeicons$dirsepurl$icon_heatmap\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Heatmap'}\">&nbsp;$L{'Heatmap'}</a></li>\n" if ($heatmap_val != 0);
	print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirlist$dirsepurl$filevirus\"><img src=\"$linkbase$homeicons$dirsepurl$icon_virus\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Virus'}\">&nbsp;$L{'Virus'}</a></li>\n" if ($nb_virus != 0);
	print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirlist$dirsepurl$filevirtual\"><img src=\"$linkbase$homeicons$dirsepurl$icon_destination\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Destination'}\">&nbsp;$L{'Destination'}</a></li>\n" if ($virtualfilter eq '' && $virtualunique > 1);
	print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirproxy$dirsepurl$filesquid\"><img src=\"$linkbase$homeicons$dirsepurl$icon_squid\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Proxy'}\">&nbsp;$L{'Proxy'}</a></li>\n" if (-e "$path$lang[$nblang]$dirsep$dirproxy$dirsep$filesquid" && $squid_format == 1);
	print FOUT "</ul>\n";
	print FOUT "</li>\n";
    }

    # Session -4-
    if (-e "$path$lang[$nblang]$dirsep$dirsession$dirsep$filesession") {
	print FOUT "<li class=\"$class_main4\"><a href=\"$link$dirsession$dirsepurl$filesession\"><img src=\"$linkbase$homeicons$dirsepurl$icon_session\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Sessions'}\">&nbsp;$L{'Sessions'}</a>\n";
#	if (($session_visit == 1 && -f "$path$lang[$nblang]$dirsep$dirsession$dirsep$filevisit") || ($session_description == 1 && -f "$path$lang[$nblang]$dirsep$dirsession$dirsep$filemainsites") ||  ($session_description == 1 && -f "$path$lang[$nblang]$dirsep$dirsession$dirsep$dureesession") || ($session_average == 1 && -f "$path$lang[$nblang]$dirsep$dirsession$dirsep$filemoyenne") || ($session_engine == 1 && -f "$path$lang[$nblang]$dirsep$dirsession$dirsep$filerobot") || ($session_reading == 1 && -f "$path$lang[$nblang]$dirsep$dirsession$dirsep$fileaverage") || ($session_login == 1 && -f "$path$lang[$nblang]$dirsep$dirsession$dirsep$filelogin")) {
	if (($session_visit == 1 && -f "$path$lang[$nblang]$dirsep$dirsession$dirsep$filevisit") || ($session_description == 1 && -f "$path$lang[$nblang]$dirsep$dirsession$dirsep$filemainsites") ||  ($session_description == 1 && -f "$path$lang[$nblang]$dirsep$dirsession$dirsep$dureesession") || ($session_average == 1 && -f "$path$lang[$nblang]$dirsep$dirsession$dirsep$filemoyenne") || ($session_engine == 1 && -f "$path$lang[$nblang]$dirsep$dirsession$dirsep$filerobot") || ($session_reading == 1 && -f "$path$lang[$nblang]$dirsep$dirsession$dirsep$fileaverage")) {
	    print FOUT "<ul>\n";
	    print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirsession$dirsepurl$filevisit\"><img src=\"$linkbase$homeicons$dirsepurl$icon_notes\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Number_of_visits'}\">&nbsp;$L{'Number_of_visits'}</a></li>\n" if ($session_visit == 1); # && -f "$path$lang[$nblang]$dirsep$dirsession$dirsep$filevisit");
	    print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirsession$dirsepurl$filemainsites\"><img src=\"$linkbase$homeicons$dirsepurl$icon_sessmul\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Multiple_sessions'}\">&nbsp;$L{'Multiple_sessions'}</a></li>\n" if ($session_description == 1); # && -f "$path$lang[$nblang]$dirsep$dirsession$dirsep$filemainsites");
	    print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirsession$dirsepurl$dureesession\"><img src=\"$linkbase$homeicons$dirsepurl$icon_descsess\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Session_length'}\">&nbsp;$L{'Session_length'}</a></li>\n" if ($session_description == 1); # && -f "$path$lang[$nblang]$dirsep$dirsession$dirsep$dureesession");
	    print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirsession$dirsepurl$filemoyenne\"><img src=\"$linkbase$homeicons$dirsepurl$icon_moyenne\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Average'}\">&nbsp;$L{'Average'}</a></li>\n" if ($session_average == 1); # && -f "$path$lang[$nblang]$dirsep$dirsession$dirsep$filemoyenne");
	    print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirsession$dirsepurl$filerobot\"><img src=\"$linkbase$homeicons$dirsepurl$icon_temp\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'search_engine'}\">&nbsp;$L{'Search_engine'}</a></li>\n" if ($session_engine == 1 && $sessionrobot > 0); # && -f "$path$lang[$nblang]$dirsep$dirsession$dirsep$filerobot");
	    print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirsession$dirsepurl$fileaverage\"><img src=\"$linkbase$homeicons$dirsepurl$icon_reading\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Reading_time'}\">&nbsp;$L{'Reading_time'}</a></li>\n" if ($session_reading == 1); # && -f "$path$lang[$nblang]$dirsep$dirsession$dirsep$fileaverage");
#	    print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirsession$dirsepurl$filelogin\"><img src=\"$linkbase$homeicons$dirsepurl$icon_login\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Login'}\">&nbsp;$L{'Login'}</a></li>\n" if ($session_login == 1); # && -f "$path$lang[$nblang]$dirsep$dirsession$dirsep$filelogin");
	    print FOUT "</ul>\n";
	}
	print FOUT "</li>\n";
    }

    # Document -5-
    if (-e "$path$lang[$nblang]$dirsep$dirdocument$dirsep$menu") {
	print FOUT "<li class=\"$class_main5\"><a href=\"$link$dirdocument$dirsepurl$menu\">&nbsp;<img src=\"$linkbase$homeicons$dirsepurl$icon_doc\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Documents'}\">&nbsp;$L{'Documents'}</a>\n";
	print FOUT "<ul>\n";
	print FOUT "<li class=\"$class_submenu\">$L{'Stats'}\n";
	print FOUT "<ul>\n";
	print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirdocument$dirsepurl$doclien\"><img src=\"$linkbase$homeicons$dirsepurl$icon_links\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Links'}\">&nbsp;$L{'Links'}</a></li>\n" if ($url_link == 1 && -f "$path$lang[$nblang]$dirsep$dirdocument$dirsep$doclien");
	print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirdocument$dirsepurl$docimage\"><img src=\"$linkbase$homeicons$dirsepurl$icon_ima\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Images'}\">&nbsp;$L{'Images'}</a></li>\n" if ($url_image == 1 && -f "$path$lang[$nblang]$dirsep$dirdocument$dirsep$docimage");
	print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirdocument$dirsepurl$docsize\"><img src=\"$linkbase$homeicons$dirsepurl$icon_weight\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Weight_of_files'}\">&nbsp;$L{'Weight_of_files'}</a></li>\n" if ($url_weight == 1 && -f "$path$lang[$nblang]$dirsep$dirdocument$dirsep$docsize");
	print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirdocument$dirsepurl$docrepert\"><img src=\"$linkbase$homeicons$dirsepurl$icon_dir\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Directories'}\">&nbsp;$L{'Directories'}</a></li>\n" if ($url_directory == 1 && -f "$path$lang[$nblang]$dirsep$dirdocument$dirsep$docrepert");
	print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirdocument$dirsepurl$users$htmlext\"><img src=\"$linkbase$homeicons$dirsepurl$icon_users\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Users'}\">&nbsp;$L{'Users'}</a></li>\n" if ($url_users == 1 && -f "$path$lang[$nblang]$dirsep$dirdocument$dirsep$users$htmlext");
	print FOUT "</ul>\n";
	print FOUT "</li>\n";

	if (-f "$path$lang[$nblang]$dirsep$dirdocument$dirsep$doublons" || -f "$path$lang[$nblang]$dirsep$dirdocument$dirsep$imawidth" || -f "$path$lang[$nblang]$dirsep$dirdocument$dirsep$imaalt") {
	    print FOUT "<li class=\"$class_submenu\">$L{'Tag'}\n";
	    print FOUT "<ul>\n";
	    print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirdocument$dirsepurl$doublons\"><img src=\"$linkbase$homeicons$dirsepurl$icon_verif\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Same_title'}\">&nbsp;$L{'Same_title'}</a></li>\n" if ($url_doublon == 1 && -f "$path$lang[$nblang]$dirsep$dirdocument$dirsep$doublons");
	    print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirdocument$dirsepurl$imawidth\"><img src=\"$linkbase$homeicons$dirsepurl$icon_useless\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"WIDTH\">&nbsp;WIDTH</a></li>\n" if ($url_img_tag == 1 && -f "$path$lang[$nblang]$dirsep$dirdocument$dirsep$imawidth");
	    print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirdocument$dirsepurl$imaalt\"><img src=\"$linkbase$homeicons$dirsepurl$icon_info2\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"ALT\">&nbsp;ALT</a></li>\n" if ($url_img_tag == 1 && -f "$path$lang[$nblang]$dirsep$dirdocument$dirsep$imaalt");
	    print FOUT "</ul>\n";
	    print FOUT "</li>\n";
	}

	print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirdocument$dirsepurl$new\"><img src=\"$linkbase$homeicons$dirsepurl$icon_new\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Newest_pages'}\">&nbsp;$L{'Newest_pages'}</a></li>\n" if ($url_new_doc == 1 && -f "$path$lang[$nblang]$dirsep$dirdocument$dirsep$new");
	print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirdocument$dirsepurl$tree\"><img src=\"$linkbase$homeicons$dirsepurl$icon_tree\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Tree'}\">&nbsp;$L{'Tree'}</a></li>\n" if ($url_tree == 1 && -f "$path$lang[$nblang]$dirsep$dirdocument$dirsep$tree");
	print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirdocument$dirsepurl$frame\"><img src=\"$linkbase$homeicons$dirsepurl$icon_null\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Frames'}\">&nbsp;$L{'Frames'}</a></li>\n" if ($url_frame == 1 && -f "$path$lang[$nblang]$dirsep$dirdocument$dirsep$frame");

	print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirdocument$dirsepurl$useless\"><img src=\"$linkbase$homeicons$dirsepurl$icon_trash\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Useless_pages'}\">&nbsp;$L{'Useless_pages'}</a></li>\n" if ($url_useless == 1 && -f "$path$lang[$nblang]$dirsep$dirdocument$dirsep$useless");
	print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirdocument$dirsepurl$cdrom\"><img src=\"$linkbase$homeicons$dirsepurl$icon_cdrom\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'No_index'}\">&nbsp;$L{'No_index'}</a></li>\n" if ($url_cdrom == 1 && -f "$path$lang[$nblang]$dirsep$dirdocument$dirsep$cdrom");

	if (-f "$path$lang[$nblang]$dirsep$dirdocument$dirsep$fileabsolute" || -f "$path$lang[$nblang]$dirsep$dirdocument$dirsep$filelinksym" || -f "$path$lang[$nblang]$dirsep$dirdocument$dirsep$nofile") {
	    print FOUT "<li class=\"$class_submenu\">$L{'Links'}\n";
	    print FOUT "<ul>\n";
	    print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirdocument$dirsepurl$fileabsolute\"><img src=\"$linkbase$homeicons$dirsepurl$icon_linkabs\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Absolute_links'}\">&nbsp;$L{'Absolute_links'}</a></li>\n" if ($url_absolute_link == 1  && -f "$path$lang[$nblang]$dirsep$dirdocument$dirsep$fileabsolute");
	    print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirdocument$dirsepurl$filelinksym\"><img src=\"$linkbase$homeicons$dirsepurl$icon_linksym\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Symbolic_links'}\">&nbsp;$L{'Symbolic_links'}</a></li>\n" if ($url_symbolic_link == 1  && -f "$path$lang[$nblang]$dirsep$dirdocument$dirsep$filelinksym");
	    print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirdocument$dirsepurl$nofile\"><img src=\"$linkbase$homeicons$dirsepurl$icon_linkerr\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"$L{'Bad_links'}\">&nbsp;$L{'Bad_links'}</a></li>\n" if ($url_bad_link == 1 && -f "$path$lang[$nblang]$dirsep$dirdocument$dirsep$nofile");
	    print FOUT "</ul>\n";
	    print FOUT "</li>\n";
	}

	print FOUT "</ul>\n";
	print FOUT "</li>\n";
    }

    # Ressources -6-
    if ($hide_resources_menu == 0) {
#	print FOUT "<li class=\"$class_main6\"><a href=\"#\">&nbsp;$L{'Resources'}</a>\n";
	print FOUT "<li class=\"$class_main6\">&nbsp;$L{'Resources'}\n";
	print FOUT "<ul>\n";
	print FOUT "<li class=\"$class_submenu\"><a href=\"$tmplink$diradmin$dirsepurl$help\" TITLE=\"Admin\">$L{'Admin'}</a></li>\n";
	print FOUT "<li class=\"$class_submenu\"><a href=\"http://www.w3perl.com/demo/docs/uk/new.html?$version\" TITLE=\"Check for new version\">$L{'News'}</a></li>\n" if ($lang[$nblang] ne "fr");
	print FOUT "<li class=\"$class_submenu\"><a href=\"http://www.w3perl.com/demo/docs/fr/new.html?$version\" TITLE=\"Quoi de neuf\">$L{'News'}</a></li>\n" if ($lang[$nblang] eq "fr");
	print FOUT "<li class=\"$class_submenu\"><a href=\"$tmplink$dirdocs$dirsepurl$help\" TITLE=\"v.$version\">$L{'Docs'}</a></li>\n" if ($lang[$nblang] ne "fr");
	print FOUT "<li class=\"$class_submenu\"><a href=\"$tmplink$dirdocs_fr$dirsepurl$help\" TITLE=\"v.$version\">$L{'Docs'}</a></li>\n" if ($lang[$nblang] eq "fr");
	print FOUT "<li class=\"$class_submenu\"><a href=\"$linkbase$filerss$xmlext\" TITLE=\"Web Feed\">$L{'RSS'}</a></li>\n" if (-f "$path$filerss$xmlext");
	print FOUT "<li class=\"$class_submenu\"><a href=\"$link$dirlist$dirsepurl$filecpu$htmlext\" TITLE=\"$L{'CPU'}\">$L{'CPU'}</a></li>\n" if (-e "$path$lang[$nblang]$dirsep$dirlist$dirsep$filecpu$htmlext");

	if ($nb_stats_run >= 0 && $hide_other_report == 0) {
	    print FOUT "<li class=\"$class_submenu\">$L{'Stats'}\n";
	    print FOUT "<ul>\n";
	    for ($i=0;$i<=$nb_stats_run;$i++) {
#	    print FOUT "<li class=\"$class_submenu\"><a href=\"http://$www_sum[$i]$linkpath_url_sum[$i]$defaulthome_sum[$i]\">&nbsp;$www_sum[$i]</a></li>\n";
#	    print FOUT "<li class=\"$class_submenu\"><a href=\"$linkpath_url_sum[$i]$defaulthome_sum[$i]\" TITLE=\"$config_sum[$i]\">&nbsp;$www_sum[$i]</a></li>\n";
		$tmp = "web".$log_sum[$i].$pngext;
		$tmp =~ tr/[A-Z]/[a-z]/;
		$dirhomepage = "homepage";
		print FOUT "<li class=\"$class_submenu\"><a href=\"$link_other_stats[$i]\" TITLE=\"$config_sum[$i]\">";
		print FOUT "<img src=\"$linkbase$homeicons$dirsepurl$tmp\" border=0 WIDTH=\"20\" HEIGHT=\"20\" ALT=\"Log\">" if (-f "$path$dirress$dirsep$dirhomepage$dirsep$tmp");
		print FOUT "&nbsp;$www_sum[$i]</a></li>\n";
	    }
	    print FOUT "</ul>\n";
	    print FOUT "</li>\n";
	}
	
	print FOUT "</ul>\n";
	print FOUT "</li>\n";
    }

    print FOUT "</ul>\n";
}
    print FOUT "</TD></TR></TABLE>\n";
#    print FOUT "<P>\n";
    print FOUT "<!-- end_insert_css_menu -->\n";
}



sub PagesSpam {
  local(*FOUT,*L,$I,$mode,$display_all) = @_;

  print FOUT "$doctype\n";
#  print FOUT "<HTML><HEAD>\n";
  print FOUT "<HTML lang=\"$LangHTML{$I}\"><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Stats'} - $L{'Spam'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";
  &add_jqplot_js(*FOUT,2);
  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
  print FOUT "<H2>$L{'Spam'}</H2><P>\n";

  &help_div(*FOUT);

  print FOUT "<P>\n";

  if ($display_all == 1) {  
      print FOUT "<A HREF=\"..$dirsepurl..$dirsepurl$dircsv$dirsepurl$listspamextcsv\" TITLE=\"Export in CSV\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>" if ($mode == 1);
      print FOUT "<A HREF=\"..$dirsepurl..$dirsepurl$dircsv$dirsepurl$listspamloccsv\" TITLE=\"Export in CSV\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>" if ($mode == 2);
#      print FOUT "<A HREF=\"..$dirsepurl..$dirsepurl$dircsv$dirsepurl$listspamcsv\" TITLE=\"Export in CSV\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV-FullList\"></A>";

      if ($mode == 1) {
	  $tmp9 = keys(%spam_user_ext);
	  $tmp10 = $tmp9; #$spam_found_ext;
	  $tmp10 = $max_item_page if ($tmp10 > $max_item_page);
	  
	  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} ";
	  print FOUT "$tmp10 $L{'spam'} ";
	  print FOUT "($L{'among'} $tmp9) " if ($tmp10 == $max_item_page);
	  print FOUT "</I></DIV><P>\n";
      }

      if ($mode == 2) {
	  $tmp9 = keys(%spam_user_loc); #$spam_found_local;
	  $tmp10 = $tmp9; #$spam_found_local;
	  $tmp10 = $max_item_page if ($tmp10 > $max_item_page);

	  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} ";
	  print FOUT "$tmp10 ";
	  print FOUT "($L{'among'} $tmp9) " if ($tmp10 == $max_item_page);
	  print FOUT "</I></DIV><P>\n";
      }

  }

  &SpamTab(*FOUT,*L,$I,$tmp9,0) if ($display_all == 1 && $mode == 1 && $tmp9 > 0);
  &SpamLocTab(*FOUT,*L,$I,$tmp9,0) if ($display_all == 1 && $mode == 2 && $tmp9 > 0);

  if ($display_all == 0) {

      print FOUT "<TABLE><TR><TD VALIGN=TOP>\n";

      $tmp10 = $spam_found_ext;
      $tmp10 = $max_item_page if ($tmp10 > $max_item_page);
      $tmp2 = 0;

      if ($tmp10 > 0) {
	  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} ";
	  print FOUT "$topten $L{'spam'} ";
	  print FOUT "(<A HREF=\"$listspam_ext\">$L{'Full_list'}</A>)" if ($spam_found_ext > $topten);
	  print FOUT "</I></DIV><P>\n";
      
	  &SpamTab(*FOUT,*L,$I,$topten,0) if ($display_all == 0);
      } else {
	  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} ";
	  print FOUT "$topten $L{'spam'} ";
	  print FOUT "(<A HREF=\"$listspam_loc\">$L{'Full_list'}</A>)" if ($spam_found_local > $topten);
	  print FOUT "</I></DIV><P>\n";

	  &SpamLocTab(*FOUT,*L,$I,$topten,0);
	  $tmp2 = 1;
      }

      print FOUT "</TD><TD VALIGN=TOP>";

      $tmp10 = $spam_found_local;
      $tmp10 = $max_item_page if ($tmp10 > $max_item_page);

      if ($tmp10 > 0 && $tmp2 == 0) {
	  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'The_Top'} ";
	  print FOUT "$topten $L{'spam'} ";
	  print FOUT "(<A HREF=\"$listspam_loc\">$L{'Full_list'}</A>)" if ($spam_found_local > $topten);
	  print FOUT "</I></DIV><P>\n";

	  &SpamLocTab(*FOUT,*L,$I,$topten,0);
      }

       print FOUT "</TD></TR><TR><TD VALIGN=TOP>\n";

      print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
      print FOUT "<thead>\n";
      print FOUT "<TR>\n";
      print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Emails'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Spam_rank'}&nbsp;</TH>\n";
#  print FOUT "<TH class=\"table-sortable:date\">&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n";
      print FOUT "</TR>\n";
      print FOUT "</thead>\n";
      print FOUT "<tbody>\n";

      $i = 0;
      foreach $val (&reverse_sort_by_value(*spam_page)) {
	  $i++;
	  last if ($i == $topten && $display_all == 0);
	  $pourcentage = int($spam_page{$val}*1000/$spam_found)/10;
	  $pourcentageint = int($pourcentage);

	  print FOUT "<TR>\n";
	  print FOUT "<TD CLASS=\"left\">";
	  print FOUT "$val";
	  print FOUT "</TD>\n";
	  print FOUT "<TD CLASS=\"right\"><B>$spam_page{$val}</B></TD>\n";
	  print FOUT "<TD CLASS=\"left\">\n";
	  print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($pourcentageint != 0);
	  print FOUT "$pourcentage %";
	  print FOUT "</TD>\n";
	  print FOUT "<TD CLASS=\"left\">\n";
	  $tmp = int(10*$spam_rank{$val}/$spam_page{$val})/10;
	  print FOUT "$tmp\n";
	  print FOUT "</TD>\n";
	  print FOUT "</TR>\n";
      }
      print FOUT "</tbody>\n";
      print FOUT "</TABLE><P>\n";

       print FOUT "</TD><TD VALIGN=TOP>\n";

  #
      if ($fly_set == 0) {
	  $chart_id = 0;
	  $info = "info".$chart_id;	  
	  $xlegend = "$i $L{'days'}";
	  $xlegend .= " (starting $start_date)";
	  $ylegend = $L{'Spam'};

	  $i = &Load_DailyData($spam,$dirdata);
	  
	  undef @ref_tab;
	  push(@ref_tab,\@tabspam);
	  
	  @ref_tab_name = ('spam');
	  
	  &MakeDailyGraphJqplotInit(*FOUT, eval($Lang{$lang[$nblang]}),$I,1,$unit_div,\@ref_tab,\@ref_tab_name,\@listdatespam,$chart_id);
	  
	  @graph_to_display = ('Spam');
	  
#	  undef @ref_tab;
#	  push(@ref_tab,\@tabspam);
	  
	  &MakeDailyGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,1,\@graph_to_display,\@ref_tab,\@listdatespam,\@serie_color,1,$unit,$chart_id,3,"users",$info,0,$xlegend,$ylegend,$xmax_jqplot,$spam);

	  &AddJqplotHtml(*FOUT, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_jqplot,$ymax_jqplot,2);

	  $chart_id += $#list_graph_name_jqplot+1;
      }


      if ($fly_set == 1) {
	  $file_page_page = "spam-home";
	  print FOUT "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
	  print FOUT "<TR>\n";
	  $tmp = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$file_page_page."y".$gifext;
	  print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"y\"></TD>\n";
	  $tmp = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$file_page_page.$gifext;
	  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax_home SRC=\"$tmp\" ALT=\"graph\" USEMAP=\"#map_page_graph\" BORDER=0></TD>\n";
	  print FOUT "</TR><TR><TD></TD>\n";
	  $tmp = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$file_page_page."x".$gifext;
	  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$tmp\" ALT=\"x\"></TD>\n";
	  print FOUT "</TR>\n";
	  print FOUT "</TABLE></CENTER>\n";
	  print FOUT "<MAP NAME=\"map_page_graph\">";
	  $tmp = $map_spam_graph;
	  $tmp =~ s/<!-- langhome -->/$I/g;
	  print FOUT "$tmp";
	  print FOUT "</MAP>\n";
      }

      print FOUT "</TD></TR><TR><TD VALIGN=TOP>\n";

  #

      if ($fly_set == 0) {
	  $xlegend = "$L{'Histogram'} - $L{'Spam_rank'}";
	  $ylegend = "$L{'Occurence'}";
      
	  $info = "info".$chart_id;	
	  
	  for ($i=0;$i<=$spam_note_max;$i++) {
	      $listdate[$i] = int($i);
	  }

	  undef @ref_tab;
	  push(@ref_tab,\@spam_histo);
	  
	  @ref_tab_name = ('requests');

	  &MakeDailyGraphJqplotInit(*FOUT, eval($Lang{$lang[$nblang]}),$I,0,$unit_div,\@ref_tab,\@ref_tab_name,\@listdate,$chart_id);

	  @graph_to_display = ('Spam_rank');
	  
#	  undef @ref_tab;
#	  push(@ref_tab,\@spam_histo);
	  
	  &MakeDailyGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,0,\@graph_to_display,\@ref_tab,\@listdate,\@serie_color,1,$unit,$chart_id,3,"spam",$info,0,$xlegend,$ylegend,$xmax_jqplot,'');

	  &AddJqplotHtml(*FOUT, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_jqplot,$ymax_jqplot,2);

	  $chart_id++;
	  undef (@listdate);
      }

      if ($fly_set == 1) {
	  print FOUT "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
	  print FOUT "<TR>\n";
	  print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linkspamhistofiley\" ALT=\"y\"></TD>\n";
	  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"$linkspamhistofile\" ALT=\"graph\" BORDER=0></TD>\n";
	  print FOUT "</TR><TR><TD></TD>\n";
	  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linkspamhistofilex\" ALT=\"x\"></TD>\n";
	  print FOUT "</TR>\n";
	  print FOUT "</TABLE></CENTER>\n";
      }

      print FOUT "</TD><TD VALIGN=TOP>\n";


     if ($fly_set == 0) {
	  $xlegend = "$L{'Histogram'} - $L{'Flag'}";
	  $ylegend = "$L{'Occurence'}";
      
	  $info = "info".$chart_id;	
	  
	  for ($i=0;$i<=$spam_field_number_max;$i++) {
	      $listdate[$i] = int($i);
	  }

	  undef @ref_tab;
	  push(@ref_tab,\@spam_flag_histo);
	  
	  @ref_tab_name = ('requests');

	  &MakeDailyGraphJqplotInit(*FOUT, eval($Lang{$lang[$nblang]}),$I,0,$unit_div,\@ref_tab,\@ref_tab_name,\@listdate,$chart_id);

	  @graph_to_display = ('Spam_flag');
	  
#	  undef @ref_tab;
#	  push(@ref_tab,\@spam_flag_histo);
	  
	  &MakeDailyGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,0,\@graph_to_display,\@ref_tab,\@listdate,\@serie_color,1,$unit,$chart_id,3,"spam",$info,0,$xlegend,$ylegend,$xmax_jqplot,'');

	  &AddJqplotHtml(*FOUT, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_jqplot,$ymax_jqplot,2);

	  $chart_id++;
	  undef (@listdate);
      }

      if ($fly_set == 1) {
	  print FOUT "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
	  print FOUT "<TR>\n";
	  print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linkspamflaghistofiley\" ALT=\"y\"></TD>\n";
	  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"$linkspamflaghistofile\" ALT=\"graph\" BORDER=0></TD>\n";
	  print FOUT "</TR><TR><TD></TD>\n";
	  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linkspamflaghistofilex\" ALT=\"x\"></TD>\n";
	  print FOUT "</TR>\n";
	  print FOUT "</TABLE></CENTER>\n";
      }
      print FOUT "</TD></TR></TABLE>\n";

#  print FOUT "Rank max $spam_note_max / value : $spam_note_val_max ";
      
      print FOUT "<P>\n";

#
      print FOUT "<TABLE><TR><TD VALIGN=TOP>\n";

      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'Domain'}&nbsp;</I> :</DIV><P>\n";
      print FOUT "<I>($L{'Only_hosts'} $L{'with_at_least'} $seuilpage $L{'spam'} $L{'are_shown'})</I><P>\n" if ($seuilpage > 0);

      print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
      print FOUT "<thead>\n";
      print FOUT "<TR>\n";
      print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Domain'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Spam'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
#  print FOUT "<TH class=\"table-sortable:date\">&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n";
      print FOUT "</TR>\n";
      print FOUT "</thead>\n";
      print FOUT "<tbody>\n";
      
      foreach $val (&reverse_sort_by_value(*spam_dom)) {
	  if ($spam_dom{$val} > $seuilpage) {
	      $pourcentage = int($spam_dom{$val}*1000/$spam_found)/10;
	      $pourcentageint = int($pourcentage);

	      print FOUT "<TR>\n";
	      print FOUT "<TD CLASS=\"left\">";
	      print FOUT "$val";
	      print FOUT "</TD>\n";
	      print FOUT "<TD CLASS=\"right\"><B>$spam_dom{$val}</B></TD>\n";
	      print FOUT "<TD CLASS=\"left\">\n";
	      print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($pourcentageint != 0);
	      print FOUT "$pourcentage %";
	      print FOUT "</TD>\n";
	      print FOUT "</TR>\n";
	  }
      }
      print FOUT "</tbody>\n";
      print FOUT "</TABLE><P>\n";

      print FOUT "</TD><TD VALIGN=TOP>\n";

      print FOUT "<DIV CLASS=\"item_page\">-&nbsp;<I>$L{'Flag'}&nbsp;</I> :</DIV><P>\n";
      print FOUT "<I>($L{'Flag'} $L{'with_at_least'} $seuilpage $L{'spam'} $L{'are_shown'})</I><P>\n" if ($seuilpage > 0);

      print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
      print FOUT "<thead>\n";
      print FOUT "<TR>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Flag'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
      print FOUT "</TR>\n";
      print FOUT "</thead>\n";
      print FOUT "<tbody>\n";

      foreach $val (&reverse_sort_by_value(*spam_field_count)) {
	  if ($spam_field_count{$val} > $seuilpage) {
	      $pourcentage = int(1000*$spam_field_count{$val}/$spam_found)/10;
	      $pourcentageint = int($pourcentage);
	      $tmp2 = $val;
	      $tmp2 =~ s/^spam_//;
	      print FOUT "<TR>\n";
	      print FOUT "<TD CLASS=\"left\">$tmp2</TD>\n";
	      print FOUT "<TD CLASS=\"right\">$spam_field_count{$val}</TD>\n";
	      print FOUT "<TD CLASS=\"left\">";
	      print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($pourcentageint != 0);
	      print FOUT "$pourcentage %</TD>\n";
	      print FOUT "</TR>\n";
	  }
      }
      print FOUT "</tbody>\n";
      print FOUT "</TABLE><P>\n";

      print FOUT "</TR></TABLE>\n";

  }
  print FOUT "</BODY></HTML>\n";
}

sub SpamTab {
  local(*FOUT,*L,$I,$top,$home) = @_;
  local($count,$link,$tmplink,$tmplink2);

  if ($update_homepage == 1 && $home == 1 && $nblang == 0) {
      $scan = 0;
      if (-f "$path$dirinc$dirsep$inchomepage") {
	  open(HOSTHOME,"$path$dirinc$dirsep$inchomepage"); # || &error_exit("Error, unable to open $path$dirinc$dirsep$inchomepage");
	  while (<HOSTHOME>) {
	      chop;
	      $scan = 0 if ($_ =~ /^#/);
	      $scan = 1 if ($_ =~ /^#SPAM_EXT/);
	      if ($scan == 1) {
		  next if ($_ =~ /^#/);
		  ($page,$tmp2) = split(/\t/);
		  $spam_user_ext{$page} = $tmp2;
	      }
	  }
	  close(HOSTHOME);
      }
  }

  $tmplink = "..$dirsepurl..$dirsepurl" if ($home == 0);
  $tmplink = "" if ($home == 1);

  $tmplink2 = "" if ($home == 0);	
  $tmplink2 = "$I$dirsepurl$dirlist$dirsepurl" if ($home == 1);

  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe ";
  print FOUT "table-autopage:$table_big_lines_aff " if ($top > $table_big_lines_aff);
  print FOUT "table-stripeclass:alternate\" id=\"page\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Emails'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  if ($home == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;";
      print FOUT "($L{'Spam'})" if ($spamonly != 1);
      print FOUT "</TH>\n";
  }
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;($L{'Emails'})</TH>\n" if ($home == 0 && $spamonly != 1);
#  print FOUT "<TH class=\"table-sortable:date\">&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n" if ($home == 0);
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";

  if ($top > $table_big_lines_aff) {

      $tmp = int($top/$table_big_lines_aff);
      if ($tmp != ($top/$table_big_lines_aff)) {
	  $tmp++;
      }
    
      print FOUT "<tfoot>\n";
      print FOUT "<tr>\n";
      
      print FOUT "<TH>&nbsp;$L{'Emails'}&nbsp;</TH>\n";
      print FOUT "<TH>&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
      print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;";
      print FOUT "($L{'Spam'})" if ($spamonly != 1);
      print FOUT "</TH>\n";
      print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;($L{'Emails'})</TH>\n" if ($spamonly != 1);
      print FOUT "</tr>\n";
      print FOUT "<tr>\n";
      
      if ($tmp > 1) {
	  $tmp9 = 3;
	  $tmp9++ if ($spamonly != 1);
	  print FOUT "<td colspan=$tmp9>\n";
	  print FOUT "<a href=\"#\" onclick=\"pageexample('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	  
	  for ($i=1;$i<=$tmp;$i++) {
	      $iminus = $i-1;
	      print FOUT "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexample($iminus); return false;\">$i</a>\n";
	  }
	  print FOUT "<a href=\"#\" onclick=\"pageexample('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "<a href=\"#\" onclick=\"pageexample('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "</td>\n";
	  print FOUT "</tr>\n";
      }
      print FOUT "</tfoot>\n";
  }

  print FOUT "<tbody>\n";

      $i = 0;
      foreach $val (&reverse_sort_by_value(*spam_user_ext)) {
#	  if ($val =~ /\@/) {
	      print FOUT "<TR>\n";
	      print FOUT "<TD CLASS=\"left\">";

	      $tmp = $val;
	      $tmp =~ s/\\/_/g;
	      print FOUT "<A HREF=\"$tmplink2$tmp$htmlext\">" if ($user{$val} > $seuilpage);
	      print FOUT "$val";
	      print FOUT "</A>" if ($user{$val} > $seuilpage);
	      print FOUT "</TD>\n";
	      print FOUT "<TD CLASS=\"right\"><B>";
	      print FOUT "$spam_user_ext{$val}";
	      print FOUT "</B></TD>\n";
	      if ($home == 0) {
		  $pourcentage2 = int($spam_user_ext{$val}*1000/$spam_found)/10;
		  $pourcentageint2 = int($pourcentage2);
		  print FOUT "<TD CLASS=\"left\">\n";
		  print FOUT "<IMG WIDTH=$pourcentageint2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($pourcentageint2 != 0);
		  print FOUT "$pourcentage2 %";
		  print FOUT "</TD>\n";
	      
		  if ($spamonly != 1) {
		      $pourcentage2 = int($spam_user_ext{$val}*1000/$user{$val})/10 if ($user{$val} != 0);
		      $pourcentageint2 = int($pourcentage2);
		      print FOUT "<TD CLASS=\"left\">\n";
		      print FOUT "<IMG WIDTH=$pourcentageint2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($pourcentageint2 != 0);
		      print FOUT "$pourcentage2 %";
		      print FOUT "</TD>\n";
		  }
	      }
	      print FOUT "</TR>\n";
	      $i++;
	      last if ($i == $top && $display_all == 0);
#	  }
      }
      print FOUT "</tbody>\n";
      print FOUT "</TABLE><P>\n";

}



sub SpamLocTab {
  local(*FOUT,*L,$I,$top,$home) = @_;
  local($count,$link,$tmplink,$tmplink2);

  if ($update_homepage == 1 && $home == 1 && $nblang == 0) {
      $scan = 0;
      if (-f "$path$dirinc$dirsep$inchomepage") {
	  open(HOSTHOME,"$path$dirinc$dirsep$inchomepage"); # || &error_exit("Error, unable to open $path$dirinc$dirsep$inchomepage");
	  while (<HOSTHOME>) {
	      chop;
	      $scan = 0 if ($_ =~ /^#/);
	      $scan = 1 if ($_ =~ /^#SPAM_LOC/);
	      if ($scan == 1) {
		  next if ($_ =~ /^#/);
		  ($page,$tmp2) = split(/\t/);
		  $spam_user_loc{$page} = $tmp2;
	      }
	  }
	  close(HOSTHOME);
      }
  }

  $tmplink = "..$dirsepurl..$dirsepurl" if ($home == 0);
  $tmplink = "" if ($home == 1);

  $tmplink2 = "" if ($home == 0);	
  $tmplink2 = "$I$dirsepurl$dirlist$dirsepurl" if ($home == 1);

  print FOUT "<p>\n<table class=\"tablesort table-autosort table-autostripe ";
  print FOUT "table-autopage:$table_big_lines_aff " if ($top > $table_big_lines_aff);
  print FOUT "table-stripeclass:alternate\" id=\"page\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Emails'}&nbsp;</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
  if ($home == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;";
      print FOUT "($L{'Spam'})" if ($spamonly != 1);
      print FOUT "</TH>\n" 
  }
  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;($L{'Emails'})</TH>\n" if ($home == 0 && $spamonly != 1);
#  print FOUT "<TH class=\"table-sortable:date\">&nbsp;$L{'Last_occurence'}&nbsp;</TH>\n" if ($home == 0);
  print FOUT "</TR>\n";
  print FOUT "</thead>\n";

  if ($top > $table_big_lines_aff) {

      $tmp = int($top/$table_big_lines_aff);
      if ($tmp != ($top/$table_big_lines_aff)) {
	  $tmp++;
      }
    
      print FOUT "<tfoot>\n";
      print FOUT "<tr>\n";
      
      print FOUT "<TH>&nbsp;$L{'Emails'}&nbsp;</TH>\n";
      print FOUT "<TH>&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
      print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;";
      print FOUT "($L{'Spam'})" if ($spamonly != 1);
      print FOUT "</TH>\n";
      print FOUT "<TH>&nbsp;$L{'Percentage'}&nbsp;($L{'Emails'})</TH>\n" if ($spamonly != 1);
      print FOUT "</tr>\n";
      print FOUT "<tr>\n";
      
      if ($tmp > 1) {
	  $tmp9 = 3;
	  $tmp9++ if ($spamonly != 1);
	  print FOUT "<td colspan=$tmp9>\n";
	  print FOUT "<a href=\"#\" onclick=\"pageexample('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";
	  
	  for ($i=1;$i<=$tmp;$i++) {
	      $iminus = $i-1;
	      print FOUT "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexample($iminus); return false;\">$i</a>\n";
	  }
	  print FOUT "<a href=\"#\" onclick=\"pageexample('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "<a href=\"#\" onclick=\"pageexample('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
	  print FOUT "</td>\n";
	  print FOUT "</tr>\n";
      }
      print FOUT "</tfoot>\n";
  }

  print FOUT "<tbody>\n";

      $i = 0;
      foreach $val (&reverse_sort_by_value(*spam_user_loc)) {
#	  if ($val !~ /\@/) {
	      print FOUT "<TR>\n";
	      print FOUT "<TD CLASS=\"left\">";
	      $tmp = $val;
	      $tmp =~ s/\\/_/g;
	      print FOUT "<A HREF=\"$tmplink2$tmp$htmlext\">" if ($user{$val} > $seuilpage);
	      print FOUT "$val";
	      print FOUT "</A>" if ($user{$val} > $seuilpage);
	      print FOUT "</TD>\n";
	      print FOUT "<TD CLASS=\"right\"><B>";
	      print FOUT "$spam_user_loc{$val}";
	      print FOUT "</B></TD>\n";
	      if ($home == 0) {
		  $pourcentage2 = int($spam_user_loc{$val}*1000/$spam_found)/10;
		  $pourcentageint2 = int($pourcentage2);
		  print FOUT "<TD CLASS=\"left\">\n";
		  print FOUT "<IMG WIDTH=$pourcentageint2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($pourcentageint2 != 0);
		  print FOUT "$pourcentage2 %";
		  print FOUT "</TD>\n";
	      
		  if ($spamonly != 1) {
		      $pourcentage2 = int($spam_user_loc{$val}*1000/$user{$val})/10 if ($user{$val} != 0);
		      $pourcentageint2 = int($pourcentage2);
		      print FOUT "<TD CLASS=\"left\">\n";
		      print FOUT "<IMG WIDTH=$pourcentageint2 HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">&nbsp;" if ($pourcentageint2 != 0);
		      print FOUT "$pourcentage2 %";
		      print FOUT "</TD>\n";
		  }
	      }
	      print FOUT "</TR>\n";
	      $i++;
	      last if ($i == $top && $display_all == 0);
#	  }
      }
      print FOUT "</tbody>\n";
      print FOUT "</TABLE><P>\n";

}




sub load_spamlog {
    local($file) = @_;
    local($tmp,$tmp1,@val,$mid);

    $file =~ s/$prefixlog/$spamlog/;
    $filezip = $file.$zipext;

    if (-f "$filezip") {
	open(FILESPAM, "$GZIP $filezip |") || &error_exit("Error, unable to open $filezip");
    } else {
	open(FILESPAM,$file) || &error_exit("Error, unable to open $file");
    }

    while (<FILESPAM>) {
	chop;

	if ($_ =~ /result:/) {
	    ($tmp1,$tmp) = split(/result:/);

	    @val = split(/\s+/,$tmp);
	    $note_spam = $val[2];
	    $tmp = $val[$#val];

	    $note_threshold = $tmp;
	    $note_threshold =~ s/.*required_score=//;
	    ($note_threshold) = split(/,/,$note_threshold);
	    $note_threshold = int($note_threshold);

	    $mid = $tmp;
	    $mid =~ s/.*mid=//;
	    ($mid) = split(/,/,$mid);
	    chop($mid);
	    $mid =~ s/[<(]//;

	    if ($note_spam >= $note_threshold) {
#		    $spam_id{$mid} = "$note_spam/$note_threshold";
		$spam_id{$mid} = $note_spam;
		$spam_flag{$mid} = $val[4];
	    }
	}
    }

    close(FILESPAM);
}


sub find_first_date {
    local($prefixlog) = @_;

if ($zip == 1 || $zipcut != 0) {

    $day = $daytmp;
    $month = $monthindex;
    $monthprev = $month-1;
    $yyear = $year;
    $year = $fyear;
    $tmp = 0;

   # detection du premier mois de log zipe

    while ($out == 0) {
	$tmp++;
        if ($zipcut == 2) {
	    $day++;
	    $day = "0".$day if (length($day) == 1 && $struct_compressed_logfile !~ /\%smallday/);
	    if ($day > $month_of_year{$month_nb[$monthprev]}) {
		$month++;
		$monthprev++;
		$day = "1" if ($struct_compressed_logfile =~ /\%smallday/);
		$day = "01" if ($struct_compressed_logfile !~ /\%smallday/);
	    }
	}
	$month++ if ($zipcut == 1);
	$monthprev++ if ($zipcut == 1);
	$year++ if ($month == 13);
	$month = "1" if ($month == 13);
	$month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
	$monthprev = 0 if ($month == 1);       
	$lettermonth =  $month_nb[$monthprev];
        if ((($year ==  $fullyear && $month > $monthindex) || ($year > $fullyear)) && $zipcut != 0) {
	    $msg = "No compressed files found !\n" if ($zip == 1);
	    $msg = "No log files found in $fileroot!\n" if ($zip == 0);
	    if ($iis_format == 1) {
		$msg .= "Make sure your logfiles are readable";
		$msg .= " by the IIS_USER" if ($ENV{'REQUEST_METHOD'} eq "GET");
		$msg .= "\n";
	    }
	    &error_exit($msg);
	}
	$smallyear = $year - int($year/100)*100;
	$smallyear = "0".$smallyear if (length($smallyear) == 1);
	$smallday = $day;
	$smallmonth = $month;

	$file = &Get_LogfileName($fileroot);

	$out = 1 if (-e $file && !(-z $file) && $real_deb == 0 && $zip == 0);
	$out = 1 if ($file eq $first_logfile && !(-z $first_logfile) && $real_deb == 1 && $zip == 0);
	$filezip = $file.$zipext if ($zip == 1);
	$out = 1 if (-e $filezip && !(-z $file) && $zip == 1);
	if ($zipcut == 3 && $filetmpzip eq $file && $rotate == 0) {
	    $out = 1;
	    $zip = 0;
	    $filezip = $file;
	}
	
	# if larger then (today-1996)*366 for daily logfiles
	if ($tmp > 5000) {
	    $msg = "No log files found in $fileroot!\n";
	    if ($iis_format == 1) {
		$msg .= "Make sure your logfiles are readable";
		$msg .= " by the IIS_USER" if ($ENV{'REQUEST_METHOD'} eq "GET");
		$msg .= "\n";
	    }
	    if ($zip == 1) {
		$msg .= "Are you sure you are using compressed logfile ?\n";
		$msg .= "If not, change the \$zip value in your configuration file using the admin interface\n\n";
	    }
	    &error_exit($msg);
	}
    }

    $lastfile = $file;
    $lastfilezip = $filezip;
    $stop = 0;
    $fyear = $year;
    $year = $yyear;
}




if (($zip == 1) && ($file ne $filezip)) {
    $skip = 0;
    &error_open($filezip) if (!(-r $filezip));
    open(FILE, "$GZIP $filezip |") || &error_exit("Error, unable to open $filezip",0);
    } else {
	if (-s $file) {
	    &error_open($file) if (!(-r $file));
	    open(FILE,$file) || &error_exit("Error, unable to open $file",0);
	} else {
	    $msg = "WARNING : $file is empty";
	    $skip = 1;
	    &error_exit($msg,2);
	}
      }

###### date de depart

#print "A - $file - $filezip\n";
if ($skip == 0) {
$scalar = (<FILE>);
while ($scalar =~ /^\#/ || $scalar =~ /^\!/) {
    if ($scalar =~ /^\#Fields:/ || $scalar =~ /^\!\!LOG_FORMAT/ || $scalar =~ /\snewsyslog\[/) {
	if ($logfile_format eq "IIS") {
	    # Error ! This is W3C !
	    $msg = "W3C logformat detected\nYour config file show IIS\nChange \$logfile_format to W3C.";
	    &error_exit($msg,1);
	}
	$struct_logfile = &detect_w3c_logformat($scalar);
    }
    $scalar = (<FILE>);
}

close(FILE);

if ($logfile_format eq "Mdaemon") {
    $scalar = (<FILE>);
    $scalar = (<FILE>);
    $scalar = (<FILE>);
    $scalar = (<FILE>);
}

if ($scalar =~ /\r\n$/) {
    $dos_format = 1;
    print "*** Warning *** Dos file found\n";
}

if ($scalar eq '') {
    $msg = "\nNot able to extract data from your logfile (empty line)\n";
    $msg .= "- Make sure you are using the uncompression tool : $GZIP\n" if ($zip == 1);
    $msg .= "- Empty line in your logfile $file\n";
    &error_exit($msg,1);
}

#print "A - $file - $scalar\n";

if ($mail_format == 1) {
    @line_log = split(/\s+/,$scalar);
    if ($line_log[0] =~ /(\d\d\d\d)-(\d\d)-(\d\d)/) {
	$date = $3.$dirsep.$month_nb[$2-1].$dirsep.$1.":".$line_log[$fields_logfile{'%time'}];
    } else {
	$date = &extract_date_syslog($scalar);
#	$year-- if ($month_equiv{$line_log[0]} > $monthindex);
#	$year-- if ($month_equiv{$line_log[0]} == $monthindex && $line_log[1] > $day);

#	$date = "$line_log[1]";
#	$date = "0".$date if (length($line_log[1]) == 1);
#	$date .= "/$line_log[0]/$year:$line_log[2]";
    }
    if ($line_log[0] =~ /([A-Z][a-z][a-z])/ && $logfile_format eq "Mdaemon") {
	$date2 = $line_log[2];
	chop($date2);	
	$date = &date_common($line_log[1],$date2);
    }
} elsif ($ftp_format == 1) {
    @line_log = split(/\s+/,$scalar);
    $date = "$line_log[2]/$line_log[1]/$line_log[4]:$line_log[3]";
    $date = "0".$date if (length($line_log[2]) == 1);
    if ($date !~ m/^((\d+)\/(\w+)\/(\d\d\d\d):)(.*)/) {
	$date = &extract_date_syslog($scalar);
    }
    $date = &date_common($line_log[$fields_logfile{'%date'}+$fields_after_login{'%date'}*$add_fields_logfile],$line_log[$fields_logfile{'%time'}+$fields_after_login{'%time'}*$add_fields_logfile]) if ($fields_logfile{'%time'} ne '');
    $date = $day.$dirsepurl.$lettermonth.$dirsepurl.$fyear.":".$line_log[$fields_logfile{'%time'}+$fields_after_login{'%time'}*$add_fields_logfile] if ($fields_logfile{'%date'} eq '');
} elsif ($dhcp_format == 1) {
   if ($date =~ /(\d\d\d\d)-(\d\d)-(\d\d)/) {
	$date1 = $3.$dirsep.$month_nb[$2-1].$dirsep.$1.":";
	if ($date =~ /\d\dT\d\d/) {
	    ($tmp1,$tmp2) = split('T',$date);
	    ($tmp1,$tmp2) = split(/[+-]/,$tmp2);	    
	    $date = $date1.$tmp1;
	}
    }
   # ISC
    @line_log = split(/\s+/,$scalar);
    if ($line_log[0] =~ /(\d\d\d\d)-(\d\d)-(\d\d)/) {
	$date1 = $3.$dirsep.$month_nb[$2-1].$dirsep.$1.":";
	if ($line_log[0] =~ /\d\dT\d\d/) {
	    ($tmp1,$tmp2) = split('T',$line_log[0]);
	    ($tmp1,$tmp2) = split(/[+-]/,$tmp2);	    
	    $date = $date1.$tmp1;
	}
    } else {
	$date = &extract_date_syslog($scalar);
    }

} else {
    @line_log = split(/$logfile_sep/,$scalar);
    $add_fields_logfile = &LoginWithSpace(@line_log) if ($line_log[$fields_logfile{'%login'}] =~ /^\"/);
    $date = $line_log[$fields_logfile{'%date'}+$fields_after_login{'%date'}*$add_fields_logfile];
    $date =~ s/\[//;
    if ($squid_format == 1) {
	if ($date =~ /\d{9}\.\d{3}/) {
	    $date_squid = "Squid-Native";
	} else {
	    $date_squid = "Squid-Common";
	}
    }

    $date = &date_squid($date) if ($date =~ /\d{9}\.\d{3}/);
    $date = &date_common($line_log[$fields_logfile{'%date'}+$fields_after_login{'%date'}*$add_fields_logfile],$line_log[$fields_logfile{'%time'}+$fields_after_login{'%time'}*$add_fields_logfile]) if ($fields_logfile{'%time'} ne '');
    $date = $day.$dirsepurl.$lettermonth.$dirsepurl.$fyear.":".$line_log[$fields_logfile{'%time'}+$fields_after_login{'%time'}*$add_fields_logfile] if ($fields_logfile{'%date'} eq '');
}


if ($date !~ m/^((\d+)\/(\w+)\/(\d\d\d\d):)(.*)/) {
    $msg = "\nDate format incorrect $date\n";
    $msg .= "Not able to extract date from this line :\n$scalar";
    $msg .= "- Check \$struct_logfile match your logfile format in your configuration file : ";
    $msg .= "config.pl." if ($opt_c eq '');
    $msg .= "$opt_c." if ($opt_c ne '');
    $msg .= "\n";
    $msg .= "- Or comment this line in your logfile \n";
    $msg .= "$file" if ($zip == 0);
    $msg .= "$filezip" if ($zip == 1);
    $msg .= "\n";
    &error_exit($msg,1);
}
}

($firstjour) = split(/:/,$date);

return $firstjour;
}

sub keycrypt {
    local($val) = @_;
    @charskey = ( "A" .. "Z", "a" .. "z", 0 .. 9, qw(! @ $ % ^ & *) );
    $keycrypt = join("", @charskey[ map { rand @charskey } ( 1 .. $val ) ]);
    return $keycrypt;
}

sub extract_jobname {
    local($path,$prefix,$filename) = @_;

    if (-r "$path$prefix$filename") {
	open(FILEJOBNAME,"$path$prefix$filename");
	local $/ = "\0";
	$found = 0;
	while (<FILEJOBNAME>) {
	    while (/([\040-\176\s]{4,})/g) {
#        print $1, "\n";
		if ($found == 1) {
		    $found = 0;
		    $jobname = $1;	    
		}
		$found = 1 if ($1 =~ /^job-name/);
		
	    }
	}
	close(FILEJOBNAME);
	chop($jobname);
	$jobname =~ tr/\040-\176/ /c;
	$jobname =~ s/^\s*//;
	$jobname =~ s/\"//g;
	$jobname =~ s/\&//g;
	$jobname =~ s/\</&lt;/g;
	$jobname =~ s/\>/&gt;/g;
    } else {
	$msg = "\nCannot open $path$prefix$filename to extract jobname value. Check read permission";
	&error_exit($msg,2);
	$jobname = $filename;
    }

#    print "A $jobname\n";
    return $jobname;
}

sub bsearch {
    local($array, $word) = @_;
    local(@array,$low,$high,$try);

    $low = 0;
    $high = @$array - 1;

    @array = @$array;

#    print "$low - $high - $word - @array\n";

    $ii = 0;
    while ( $low <= $high ) {
        $try = int( ($low+$high)/2);
#	print "1 - TRY $try - $array[$try] / $low - $high\n";
	$ii++;

	if ($ii > @$array) {
	    print "@array\nSearch for $word\n$try - $array[$try] / $low - $high \n";
	    exit;
	}
 
	if ($array[$try] < $word) {
	    $high = $try-1;
#	    print "2 - TRY $try - $array[$try] / $low - $high\n";
	    next;
	} 

	if ($array[$try] > $word) {
	    $low  = $try+1;
#	    print "3 - TRY $try - $array[$try] / $low - $high\n";
	    next;
	}

        return $try;
    }
    return;
}

sub LoadDailyData {
    local($dirresume,$mode) = @_;
    local($i,$tmp10,$index);
    local($tmp,$line);

    $file_daily = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailysites$txtext";
#    print "UU $file_daily\n";

    if (-f $file_daily) {

# To reset after year have been done
#	$count_nb_file = 0;
#@count_file
#$min_count_file

	### Hosts

	$count_exp_file = 0;

	open(FILEDAILY,"$file_daily") || &error_exit("Error, unable to open $file_daily",1);
	while (<FILEDAILY>) {
	    chop;
	    $line = $_;
	    $line =~ s/\r\n(.*)//;
	    $nb = ($adresse,$val1,$val2,$val3,$val4) = split(/\t/,$line);

#	    $adresse = $adressehad{$adresse};

	    if ($nb != 2) {
		$tmp = $adresse;

##		$adressehad{$adresse} = $chiffre;
##		$reverseadressehad[$chiffre] = $adresse;
		# NEW

		$count_exp_file++;

		if ($mode == 2) {
		    if ($nbdailyvisits{$adresse} eq '') {
			if ($adresse =~ /$localdomaine/i) {
			    $mm_dom_tot++;
			}
			$mm_tot++;
		    }
		    $nbdailyvisits{$adresse}++;
		}

		if ($mode == 0) {
		    $found_mode_entry = 0;
#		    if ($serverjour{$adresse} eq '') {
		    if ($nbdailyvisits{$adresse} eq '') {
			if ($adresse =~ /$localdomaine/i) {
			    $mm_dom_tot++;
			}
			$mm_tot++;
			$pays = "Unknown";
			if ($adresse !~ /[0-9]+$/ && $adresse !~ /:/) {
			    $pays = substr($adresse,rindex($adresse,'.')+1,length($adresse));
			} else {
			    $pays = $val4 if ($reverse_geo == 1 && $val4 ne '');
			}
			$paysjourlist{$pays}++;
		    }

		    $nbdailyvisits{$adresse}++;
		    $domsizejour+= $val3 if ($adresse =~ /$localdomaine/);

		    if ($count_exp_file <= $max_item_page) {
#			$nbdailyvisits{$adresse}++;
			$serverjour{$adresse} += $val1;
			$hostluesday{$adresse} += $val2 if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0);
			$serversizejour{$adresse} += $val3;
			$pays_ip{$adresse} = $val4 if ($reverse_geo == 1);
			$found_mode_entry = 1;
		    }
		}

		if ($mode == 1) {
		    $found_mode_entry = 0;

		    if ($serverjour{$adresse} ne '' && $count_exp_file > $max_item_page) {
#			$nbdailyvisits{$adresse}++;
			$serverjour{$adresse} += $val1;
			$hostluesday{$adresse} += $val2 if ($ftp_format == 0 && $mail_format == 0 && $cups_format == 0 && $dhcp_format == 0);
			$serversizejour{$adresse} += $val3;
			$pays_ip{$adresse} = $val4 if ($reverse_geo == 1);
#			$domsizejour+= $val3 if ($adresse =~ /$localdomaine/);
			$found_mode_entry = 1;
		    }
		}

		if ($display_subitem > 0 && $found_mode_entry == 1) {
		$tmp10 = $serverjour{$adresse};
		$count_nb_file++;
		$skip_data = 0;
		if ($count_nb_file <= $max_item_page) {
		    push(@count_file,$tmp10);
#		    $skip_data = 0;
		}
		if ($count_nb_file == $max_item_page) {
		    # Sort @count_file
		    @count_file = reverse sort { $a <=> $b } @count_file;
		    $min_count_file = $count_file[$#count_file];
		    $min_count_file_final = $min_count_file;
#		    print "Final Reached $max_item_page : $min_count_file\n";
		}
		if ($count_nb_file > $max_item_page) {
#		    $skip_data = 0 if ($mode == 1);
		    if ($tmp10 > $min_count_file) {
			# replace old value
			$tmp9 = $tmp10-$val1;
			if ($serverjour{$adresse} > 1 && $tmp9 > $min_count_file) {
			    $index = &bsearch(\@count_file, $tmp9);
			    splice(@count_file, $index, 1,"$tmp10"); 
			    @count_file = reverse sort { $a <=> $b } @count_file;
			} else {
			    $count_file[$#count_file] = $tmp10;
			    @count_file = reverse sort { $a <=> $b } @count_file;
			    $min_count_file = $count_file[$#count_file];
#			    print "Reached $max_item_page : $dirresume : $min_count_file\n";
			    # Find page and Undef $tmp2b / %seen_page $min_data{$page} ? but how
			    $skip_data = 0;
			}
		    } else {
			$skip_data = 1 if ($mode == 0 && $paysjourlist{$pays} > $max_item_page);
#			$skip_data = 1 if ($mode == 0);
#			print "SKIP $adresse - $tmp10 >? $min_count_file - $val1\n";
		    }
		}
		$tmp2b = "min_valdata".$tmp;
#		print "AA $min_count_file\n";
		}
	    } else {
#		$count_file;
		if ($skip_data == 0) {

		    if ($mode == 1 && $found_mode_entry == 1 && $count_exp_file > $max_item_page) {
			$seen_page{$tmp,$adresse} += $val1;
			if ($seen_page{$tmp,$adresse} == $val1) {
			    $nbpageday{$tmp}++;
			    $dailypageserv{$tmp,$nbpageday{$tmp}} = $adresse;
			}
		    }
		    if ($mode == 0 && $count_exp_file <= $max_item_page) {
			$seen_page{$tmp,$adresse} += $val1;
			$nbpageday{$tmp}++ if ($seen_page{$tmp,$adresse} == $val1);
#			print "TOTO $tmp - $adresse\n" if ($tmp eq "46.159.108.65");
		    }

		    ### fill the array with the first day : display_subitem max 

		    # Mode 0
		    if ($display_subitem > 0 && $mode == 0 && $count_exp_file <= $max_item_page) {
		    if ($nbpageday{$tmp} <= $display_subitem && $seen_page{$tmp,$adresse} == $val1) {
			$dailypageserv{$tmp,$nbpageday{$tmp}} = $adresse;
			if ($min_data1{$tmp} eq '' || $val1 <= $min_data1{$tmp}) {
			    $min_data1{$tmp} = $val1;
			    push(@$tmp2b,$val1);
			}
		    }
		    if ($seen_page{$tmp,$adresse} > $min_data1{$tmp}) {
			# tri des seen_page
			$fnd_idx = 0;
			$tmp3 = $seen_page{$tmp,$adresse}-$val1;
			if ($tmp3 != 0) {
			    for ($k=0;$k<$display_subitem;$k++) {
				$k2 = $k+1;
				if ($$tmp2b[$k] == $tmp3 && $dailypageserv{$tmp,$k2} eq $adresse) {
				    $idx1 = $k;
				    $fnd_idx = 1;
				    last;
				}
			    }
			}
			$idx1 = $#$tmp2b if ($fnd_idx == 0);
			if ($fnd_idx == 0 && (scalar(@$tmp2b) != $display_subitem)) {
			    push(@$tmp2b,$seen_page{$tmp,$adresse});
			} else {
			    $$tmp2b[$idx1] = $seen_page{$tmp,$adresse};
			}
			@$tmp2b = reverse sort { $a <=> $b } @$tmp2b;
			$min_data1{$tmp} = $$tmp2b[$#$tmp2b];
			# tri des $dailypageserv
			# non trouve : new item to insert
			if ($fnd_idx == 0) {
			    for ($k=0;$k<$display_subitem;$k++) {
				$idx = $k if ($$tmp2b[$k] == $seen_page{$tmp,$adresse});
			    }
			    for ($k=$display_subitem;$k>$idx;$k--) {
				$kidx=$k-1;
				$dailypageserv{$tmp,$k} = $dailypageserv{$tmp,$kidx};
			    }
			    $idx++;
			    $dailypageserv{$tmp,$idx} = $adresse;
			} else {
			    # deja present
			    for ($k=0;$k<$display_subitem;$k++) {
				if ($$tmp2b[$k] == $seen_page{$tmp,$adresse}) {
				    $idx2 = $k;
				}
			    }
			    
			    if ($idx1 != $idx2) {
				$idx1++;
				for ($k=$idx1;$k>$idx2;$k--) {
				    $kidx=$k-1;
				    $dailypageserv{$tmp,$k} = $dailypageserv{$tmp,$kidx};
				}
				$idx2++;
				$dailypageserv{$tmp,$idx2} = $adresse;
			    } else {
				$idx2++;
				$dailypageserv{$tmp,$idx2} = $adresse;
			    }
			}
		    }
		    }
		}
	    }
	}
	close(FILEDAILY);


	### Pages

	$found = 0;
	$min_val1 = 0;
	$file_daily = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailypages$txtext";

#	print "A2 - $file_daily\n";

	$count_exp_file = 0;
	
	if ($mode != 2) {
	open(FILEDAILY,"$file_daily") || &error_exit("Error, unable to open $file_daily",1);
	while (<FILEDAILY>) {
	    chop;
	    $line = $_;
	    $line =~ s/\r\n(.*)//;
	    $nb = ($page,$val1,$val2) = split(/\t/,$line);
	    $found = 1 if ($val1 eq '');

	    if ($found == 0) {
		if ($nb == 2) {
		    $tmp = $page;

		    $count_exp_file++;

		    if ($mode == 0) {
			$found_mode_entry = 0;
			if ($count_exp_file <= $max_item_page) {
			    $pagesluesday{$page} += $val1;
			    $found_mode_entry = 1;
#			    $pageuniquejour++ unless ($seen_server{$page}++);
#			    print "LOADING $dirresume - $count_exp_file - $page - $val1 - $count_nb_file2\n";
			}
		    }

		    if ($mode == 1) {
			$found_mode_entry = 0;
#			print "AA $page - $count_exp_file - $max_item_page\n";
			if ($pagesluesday{$page} ne '' && $count_exp_file > $max_item_page) {
			    $pagesluesday{$page} += $val1;
			    $found_mode_entry = 1;
#			    print "FOUND $page - $pagesluesday{$page}\n";
			}
		    }

		    $pageuniquejour++ unless ($seen_server{$page}++);

		    if ($display_subitem > 0 &&	$found_mode_entry == 1) {
			$tmp10 = $pagesluesday{$page};
			$count_nb_file2++;
			$skip_data = 0;
			if ($count_nb_file2 <= $max_item_page) {
			    push(@count_file2,$tmp10);
#			    $skip_data = 0;
			}
			if ($count_nb_file2 == $max_item_page) {
			    # Sort @count_file
			    @count_file2 = reverse sort { $a <=> $b } @count_file2;
			    $min_count_file2 = $count_file2[$#count_file2];
			}
			if ($count_nb_file2 > $max_item_page) {
#			    $skip_data = 0 if ($mode == 1);
			    if ($tmp10 > $min_count_file2) {
				$tmp9 = $tmp10-$val1;
				
				if ($nbhostpageday{$page} > 1 && $tmp9 > $min_count_file2) {
				    $index = &bsearch(\@count_file2, $tmp9);
				    splice(@count_file2, $index, 1,"$tmp10"); 
				    @count_file2 = reverse sort { $a <=> $b } @count_file2;
				} else {
				    $count_file2[$#count_file2] = $tmp10;
				    @count_file2 = reverse sort { $a <=> $b } @count_file2;
				    $min_count_file2 = $count_file2[$#count_file2];
				    # Find page and Undef $tmp2b / %seen_page $min_data{$page} ? but how
				    $skip_data = 0;
				}
			    } else {
				$skip_data = 1 if ($mode == 0);
			    }
			}
			
			$tmp2b = "min2_valdata".$tmp;
		    }
		}
		if ($nb == 3) {
#		    print "2a-LOAD $skip_data - $tmp - $val1 - $val2 - $nbhostpageday{$tmp}\n";
		    if ($skip_data == 0) {
			if ($mode == 1 && $found_mode_entry == 1 && $count_exp_file > $max_item_page) {
			    $seen_host{$tmp,$val1} += $val2;
			    if ($seen_host{$tmp,$val1} == $val2) {
				$nbhostpageday{$tmp}++;
				$dailyhostpage{$tmp,$nbhostpageday{$tmp}} = $val1;
			    }
			}

			if ($mode == 0 && $count_exp_file <= $max_item_page) {
			    $seen_host{$tmp,$val1} += $val2;
			    $nbhostpageday{$tmp}++ if ($seen_host{$tmp,$val1} == $val2);
#			    print "2-LOAD $tmp - $val1 - $val2 - $nbhostpageday{$tmp}\n";
			}

		    # fill the array with the first day : display_subitem max 
#		    if ($display_subitem > 0) {
		    if ($display_subitem > 0 && $mode == 0 && $count_exp_file <= $max_item_page) {
		    if ($nbhostpageday{$tmp} <= $display_subitem && $seen_host{$tmp,$val1} == $val2) {
			$dailyhostpage{$tmp,$nbhostpageday{$tmp}} = $val1;
			if ($min_data2{$tmp} eq '' || $val2 <= $min_data2{$tmp}) {
			    $min_data2{$tmp} = $val2;
			    push(@$tmp2b,$val2);
			}
		    }
		    if ($seen_host{$tmp,$val1} > $min_data2{$tmp}) {
			# tri des seen_page
			$fnd_idx = 0;
			$tmp3 = $seen_host{$tmp,$val1}-$val2;
			if ($tmp3 != 0) {
			    for ($k=0;$k<$display_subitem;$k++) {
				$k2 = $k+1;
				if ($$tmp2b[$k] == $tmp3 && $dailyhostpage{$tmp,$k2} eq $val1) {
				    $idx1 = $k;
				    $fnd_idx = 1;
				    last;
				}
			    }
			}
			$idx1 = $#$tmp2b if ($fnd_idx == 0);
			if ($fnd_idx == 0 && (scalar(@$tmp2b) != $display_subitem)) {
			    push(@$tmp2b,$seen_host{$tmp,$val1});
			} else {
			    $$tmp2b[$idx1] = $seen_host{$tmp,$val1};
			}
			@$tmp2b = reverse sort { $a <=> $b } @$tmp2b;

			$min_data2{$tmp} = $$tmp2b[$#$tmp2b];
			# tri des $dailypageserv
			if ($fnd_idx == 0) {
			    for ($k=0;$k<$display_subitem;$k++) {
				$idx = $k if ($$tmp2b[$k] == $seen_host{$tmp,$val1});
			    }
			    for ($k=$display_subitem;$k>$idx;$k--) {
				$kidx=$k-1;
				$dailyhostpage{$tmp,$k} = $dailyhostpage{$tmp,$kidx};
			    }
			    $idx++;
			    $dailyhostpage{$tmp,$idx} = $val1;
			} else {
			    # deja present
			    for ($k=0;$k<$display_subitem;$k++) {
				if ($$tmp2b[$k] == $seen_host{$tmp,$val1}) {
				    $idx2 = $k;
				}
			    }
			    if ($idx1 != $idx2) {
				$idx1++;
				for ($k=$idx1;$k>$idx2;$k--) {
				    $kidx=$k-1;
				    $dailyhostpage{$tmp,$k} = $dailyhostpage{$tmp,$kidx};
				}
				$idx2++;
				$dailyhostpage{$tmp,$idx2} = $val1;
			    } else {
				$idx2++;
				$dailyhostpage{$tmp,$idx2} = $val1;
			    }
			}
		    }
		    }
		}
		}
	    } else {
#		$count_exp_file2++;
#		if ($mode == 0 && $count_exp_file2 <= $max_item_page) {
		$filetypejour{$page} += $val1 if ($mode == 0);
#		}
#		if ($mode == 1 && $filetypejour{$page} ne '' && $count_exp_file2 > $max_item_page) {
#		    $filetypejour{$page} += $val1;
#		}

	    }
	}
	close(FILEDAILY);
	}

	### Spam

	if ($spam_on == 1) {
	    $found = 0;
	    $count_exp_file = 0;
	    $count_exp_file2 = 0;

	    if ($mode != 2) {
	    $file_daily = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailyspam$txtext";
	    open(FILEDAILY,"$file_daily") || &error_exit("Error, unable to open $file_daily",1);
	    while (<FILEDAILY>) {
		chop;
		$found = 1 if ($_ =~ /^#EXTERNAL/);
		$found = 2 if ($_ =~ /^#LOCAL/);
		next if ($_ =~ /^#/);
		$line = $_;
		$line =~ s/\r\n(.*)//;
		$nb = ($page,$val1,$val2) = split(/\t/,$line);
		
		if ($found == 1) {
		    if (($mode == 0 && $count_exp_file <= $max_item_page) || ($mode == 1 && $spam_daily_user_ext{$page} ne '' && $count_exp_file > $max_item_page)) {
		    if ($val2 eq '') {
			$count_exp_file++;
			$spam_daily_user_ext{$page} += $val1;
			$tmp = $page;
			$spam_day_ext += $val1;
		    } else {
			$spam_daily_user_ext_unique{$tmp}++ if ($spam_daily_page{$tmp,$page} eq '');
			$spam_daily_page{$tmp,$page} = $val1;
			$seen_spam{$tmp,$val1} += $val2;

		    }
		    }
		}

		if ($found == 2) {
		    if (($mode == 0 && $count_exp_file2 <= $max_item_page) || ($mode == 1 && $spam_daily_user_loc{$page} ne '' && $count_exp_file2 > $max_item_page)) {
		    if ($val2 eq '') {
			$count_exp_file2++;
			$spam_daily_user_loc{$page} += $val1;
			$tmp = $page;
			$spam_day_local += $val1;
		    } else {
			$spam_daily_user_loc_unique{$tmp}++ if ($spam_daily_page{$tmp,$page} eq '');
			$spam_daily_page{$tmp,$page} = $val1;
			$seen_spam{$tmp,$val1} += $val2;
		    }
		    }
		}
	    }
	    $spam_found = $spam_day_ext+$spam_day_local;
	    close(FILEDAILY);
	}
	}

	### Scripts

	$found = 0;
	$count_exp_file = 0;
	if ($mode != 2) {
	$file_daily = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailyscripts$txtext";
	open(FILEDAILY,"$file_daily") || &error_exit("Error, unable to open $file_daily",1);
	while (<FILEDAILY>) {
	    chop;
	    $line = $_;
	    $line =~ s/\r\n(.*)//;
	    ($page,$val1,$val2) = split(/\t/,$line);
	    $found = 1 if ($val1 eq '');
	    $count_exp_file++;
	    if ($found == 0) {
		if ($mode == 0 && $count_exp_file <= $max_item_page) {
		    $scriptday{$page} += $val1;
		    $scriptuniquejour++ unless ($seen_server{$page}++);
		    $script_day += $val1; # unless ($seen_server{$page}++);
		}
		if ($mode == 1 && $scriptday{$page} ne '' && $count_exp_file > $max_item_page) {
		    $scriptday{$page} += $val1;
		    $scriptuniquejour++ unless ($seen_server{$page}++);
		    $script_day += $val1; # unless ($seen_server{$page}++);
		}

	    } else {
		if ($mode == 0 && $count_exp_file <= $max_item_page) {
		    $client_day_error{$page} += $val1;
		    $client_day_refer{$page} = $val2;
		}
		if ($mode == 1 && $client_day_error{$page} ne '' && $count_exp_file > $max_item_page) {
		    $client_day_error{$page} += $val1;
		    $client_day_refer{$page} = $val2;
		}

	    }
	}
	close(FILEDAILY);
	}

	### Trafic

#	$filelist_hostday{$tmp,$adressehad{$adresse}}++; # Nbre total pour la boucle
#	if ($filelist_hostday{$tmp,$adressehad{$adresse}} == 1) { # Occurence
#	    $nbfilehostday{$tmp}++; # counter
#	    $filelistday{$tmp,$nbfilehostday{$tmp}} = $adresse;
#	}

	$count_exp_file = 0;
	if ($mode != 2) {
	$file_daily = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailytrafic$txtext";
	if (-f $file_daily) {
	    $min_val1 = 0;
	    open(FILEDAILY,"$file_daily") || &error_exit("Error, unable to open $file_daily",1);
	    while (<FILEDAILY>) {
		chop;
		$line = $_;
		$line =~ s/\r\n(.*)//;
		($page,$val1) = split(/\t/,$line);
		$count_exp_file++;
		if ($mode == 0 && $count_exp_file <= $max_item_page) {
		    $dailysizepage{$page} += $val1;
		}
		if ($mode == 1 && $dailysizepage{$page} ne '' && $count_exp_file > $max_item_page) {
		    $dailysizepage{$page} += $val1;
		}
	    }
	    close(FILEDAILY);
	}
	}

	### Directories

#	$count_exp_file = 0;
	if ($mode != 2) {
	$file_daily = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailydir$txtext";
	open(FILEDAILY,"$file_daily") || &error_exit("Error, unable to open $file_daily",1);
	while (<FILEDAILY>) {
	    chop;
	    $line = $_;
	    $line =~ s/\r\n(.*)//;
	    ($rootrepert,$val1,$val2,$val3) = split(/\t/,$line);
#	    $count_exp_file++;
	    if ($mode == 0) {
		$freqjourrac{$rootrepert} += $val1;
		$freqjourrachtml{$rootrepert} += $val2;
		$sizejourrachtml{$rootrepert} += $val3;
		$tothtmlsizejour += $val3;
	    }
#	    if ($mode == 0 && $count_exp_file <= $max_item_page) {
#		$freqjourrac{$rootrepert} += $val1;
#		$freqjourrachtml{$rootrepert} += $val2;
#		$sizejourrachtml{$rootrepert} += $val3;
#		$tothtmlsizejour += $val3;
#	    }
#	    if ($mode == 1 && $freqjourrac{$rootrepert} ne '' && $count_exp_file > $max_item_page) {
#		$freqjourrac{$rootrepert} += $val1;
#		$freqjourrachtml{$rootrepert} += $val2;
#		$sizejourrachtml{$rootrepert} += $val3;
#		$tothtmlsizejour += $val3;
#	    }
	}
	close(FILEDAILY);
	}

	### Countries

#	$count_exp_file = 0;

	if ($mode != 2) {
	$file_daily = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailycountries$txtext";
	open(FILEDAILY,"$file_daily") || &error_exit("Error, unable to open $file_daily",1);
	while (<FILEDAILY>) {
	    chop;
	    $line = $_;
	    $line =~ s/\r\n(.*)//;
	    ($pays,$val1,$val2,$val3) = split(/\t/,$line);
#	    $count_exp_file++;
	    if ($mode == 0) {
		$paysjour{$pays} += $val1;
		$payshtmljour{$pays} += $val2;
#	    $paysjourlist{$pays} += $val3;
		$paysuniquejour++ unless ($seen_server{$pays}++);
	    }

#	    if ($mode == 0 && $count_exp_file <= $max_item_page) {
#		$paysjour{$pays} += $val1;
#		$payshtmljour{$pays} += $val2;
##	    $paysjourlist{$pays} += $val3;
#		$paysuniquejour++ unless ($seen_server{$pays}++);
#	    }
#	    if ($mode == 1 && $paysjour{$pays} ne '' && $count_exp_file > $max_item_page) {
#		$paysjour{$pays} += $val1;
#		$payshtmljour{$pays} += $val2;
##	    $paysjourlist{$pays} += $val3;
#		$paysuniquejour++ unless ($seen_server{$pays}++);
#	    }

	}
	close(FILEDAILY);
	}

	### Users

	$count_exp_file = 0;

	$found = 0;
	$min_val1 = 0;
	if ($mode != 2) {
	$file_daily = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailyusers$txtext";
#	print "Opening $file_daily\n";
	if (-f $file_daily) {
	    open(FILEDAILY,"$file_daily") || &error_exit("Error, unable to open $file_daily",1);
	    while (<FILEDAILY>) {
		chop;
		$line = $_;
		$line =~ s/\r\n(.*)//;
		$nb = ($user,$val1,$val2,$val3,$val4) = split(/\t/,$line);
		if ($nb == 5) {

		    $count_exp_file++;
		    $tmp = $user;

		    if ($mode == 0) {
			$found_mode_entry = 0;
			if ($count_exp_file <= $max_item_page) {
			    $userday{$user} += $val1;
			    $user_adresseday{$user} = $val2;
			    $user_trafficday{$user} += $val3;
			    $user_accessday{$user} += $val4;
			    $nb_userday++ unless ($seen_user{$user}++);
			    
			    $nbdailyuser{$user}++;
			    $found_mode_entry = 1;
			}
		    }

		    if ($mode == 1) {
			$found_mode_entry = 0;
			if ($userday{$user} ne '' && $count_exp_file > $max_item_page) {
			    $userday{$user} += $val1;
			    $user_adresseday{$user} = $val2;
			    $user_trafficday{$user} += $val3;
			    $user_accessday{$user} += $val4;
			    $nb_userday++ unless ($seen_user{$user}++);
			    
			    $nbdailyuser{$user}++;
			    $found_mode_entry = 1;
			}

		    }

		    if ($display_subitem > 0 &&	$found_mode_entry == 1) {
		    $tmp10 = $userday{$user};
		    $count_nb_file3++;
		    if ($count_nb_file3 <= $max_item_page) {
			push(@count_file3,$tmp10);
			$skip_data = 0;
		    }
		    if ($count_nb_file3 == $max_item_page) {
			# Sort @count_file
			@count_file3 = reverse sort { $a <=> $b } @count_file3;
			$min_count_file3 = $count_file3[$#count_file3];
		    }
		    if ($count_nb_file3 > $max_item_page) {
			$skip_data = 0 if ($mode == 1);
			if ($tmp10 > $min_count_file3) {
			    $tmp9 = $tmp10-$val1;

#			    if ($nbhostpageday{$user} > 1 && $tmp9 > $min_count_file3) {
			    if ($nbdailyuser{$user} > 1 && $tmp9 > $min_count_file3) {
			    $index = &bsearch(\@count_file3, $tmp9);
			    splice(@count_file3, $index, 1,"$tmp10"); 
			    @count_file3 = reverse sort { $a <=> $b } @count_file3;
			    } else {
				$count_file3[$#count_file3] = $tmp10;
				@count_file3 = reverse sort { $a <=> $b } @count_file3;
				$min_count_file3 = $count_file3[$#count_file3];
			    # Find page and Undef $tmp2b / %seen_page $min_data{$user} ? but how
				$skip_data = 0;
			    }
			} else {
			    $skip_data = 1 if ($mode == 0);
			}
		    }

		    $tmp2b = "min3_valdata".$tmp;
		    }
		}
		if ($nb == 3) {
		    if ($skip_data == 0) {

			if ($mode == 1 && $found_mode_entry == 1 && $count_exp_file > $max_item_page) {
			    $seen_users{$tmp,$user} += $val1;
			    $nbusersday{$tmp}++ if ($seen_users{$tmp,$user} == $val1);
			    $dailyuserssizedest{$tmp,$user} += $val2;
			}
			if ($mode == 0 && $count_exp_file <= $max_item_page) {
			    $seen_users{$tmp,$user} += $val1;
			    $nbusersday{$tmp}++ if ($seen_users{$tmp,$user} == $val1);
			    $dailyuserssizedest{$tmp,$user} += $val2;
			}

		# fill the array with the first day : display_subitem max
			if ($display_subitem > 0 && $mode == 0 && $count_exp_file <= $max_item_page) {
		if ($nbusersday{$tmp} <= $display_subitem && $seen_users{$tmp,$user} == $val1) {
		    $dailylogindest{$tmp,$nbusersday{$tmp}} = $user;
		    if ($min_data3{$tmp} eq '' || $val1 <= $min_data3{$tmp}) {
			$min_data3{$tmp} = $val1;
			push(@$tmp2b,$val1);
		    }
		}
		if ($seen_users{$tmp,$user} > $min_data3{$tmp}) {
		    # tri des seen_page
		    $fnd_idx = 0;
		    $tmp3 = $seen_users{$tmp,$user}-$val1;
		    if ($tmp3 != 0) {
			for ($k=0;$k<$display_subitem;$k++) {
			    $k2 = $k+1;
			    if ($$tmp2b[$k] == $tmp3 && $dailylogindest{$tmp,$k2} eq $user) {
				$idx1 = $k;
				$fnd_idx = 1;
				last;
			    }
			}
		    }
		    $idx1 = $#$tmp2b if ($fnd_idx == 0);
		    if ($fnd_idx == 0 && (scalar(@$tmp2b) != $display_subitem)) {
			push(@$tmp2b,$seen_users{$tmp,$user});
		    } else {
			$$tmp2b[$idx1] = $seen_users{$tmp,$user};
		    }
		    @$tmp2b = reverse sort { $a <=> $b } @$tmp2b;
		    $min_data3{$tmp} = $$tmp2b[$#$tmp2b];
		    # tri des $dailypageserv
		    # non trouve : new item to insert
		    if ($fnd_idx == 0) {
			for ($k=0;$k<$display_subitem;$k++) {
			    $idx = $k if ($$tmp2b[$k] == $seen_users{$tmp,$user});
			}
			for ($k=$display_subitem;$k>$idx;$k--) {
			    $kidx=$k-1;
			    $dailylogindest{$tmp,$k} = $dailylogindest{$tmp,$kidx}
#			    $dailypageserv{$tmp,$k} = $dailypageserv{$tmp,$kidx};
			}
			$idx++;
			$dailylogindest{$tmp,$idx} = $user;
#			$dailypageserv{$tmp,$idx} = $adresse;
		    } else {
			# deja present
			for ($k=0;$k<$display_subitem;$k++) {
			    if ($$tmp2b[$k] == $seen_users{$tmp,$user}) {
				$idx2 = $k;
			    }
			}

			if ($idx1 != $idx2) {
			    $idx1++;
			    for ($k=$idx1;$k>$idx2;$k--) {
				$kidx=$k-1;
				$dailylogindest{$tmp,$k} = $dailylogindest{$tmp,$kidx};
#				$dailypageserv{$tmp,$k} = $dailypageserv{$tmp,$kidx};
			    }
			    $idx2++;
			    $dailylogindest{$tmp,$idx2} = $user;
#			    $dailypageserv{$tmp,$idx2} = $adresse;
			} else {
			    $idx2++;
			    $dailylogindest{$tmp,$idx2} = $user;
#			    $dailypageserv{$tmp,$idx2} = $adresse;
			}
			
		    }
		}
		    }
		    }
		}
	    }
	    close(FILEDAILY);
	}
	}

	### Destination

	if ($squid_format == 1 || $cups_format == 1 || $dhcp_format == 1) {
	    $count_exp_file = 0;

	    $found = 0;
	    $min_val1 = 0;
	    $tmp = $listdestination;
	    $tmp =~ s/$htmlext/$txtext/;
	    $file_daily = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$tmp";
	    if ($mode != 2) {
	    open(FILEDAILY,"$file_daily") || &error_exit("Error, unable to open $file_daily",1);
	    while (<FILEDAILY>) {
		chop;
		$line = $_;
		$line =~ s/\r\n(.*)//;
		$nb = ($val1,$val2,$val3,$val4) = split(/\t/,$line);
		if ($nb == 3) {
		    $tmp = $val1;

		    $count_exp_file++;

		    $dailydest_unique++ if ($dailydest{$val1} eq '');

		    if ($mode == 0) {
			$found_mode_entry = 0;
			if ($count_exp_file <= $max_item_page) {
#			    $dailydest_unique++ if ($dailydest{$val1} eq '');
			    $dailydest{$val1} += $val2;
			    $dailysizedest{$val1} += $val3;
			    
			    $nbdailydest{$val1}++;
			    $found_mode_entry = 1;
			}
		    }

		    if ($mode == 1) {
			$found_mode_entry = 0;
			if ($dailydest{$val1} ne '' && $count_exp_file > $max_item_page) {
			    $dailydest{$val1} += $val2;
			    $dailysizedest{$val1} += $val3;
			    
			    $nbdailydest{$val1}++;
			    $found_mode_entry = 1;
			}
		    }

		    if ($display_subitem > 0 &&	$found_mode_entry == 1) {
		    $tmp10 = $dailydest{$val1};
		    $count_nb_file4++;
		    if ($count_nb_file4 <= $max_item_page) {
			push(@count_file4,$tmp10);
			$skip_data = 0;
		    }
		    if ($count_nb_file4 == $max_item_page) {
			# Sort @count_file
			@count_file4 = reverse sort { $a <=> $b } @count_file4;
			$min_count_file4 = $count_file4[$#count_file4];
		    }
		    if ($count_nb_file4 > $max_item_page) {
			$skip_data = 0 if ($mode == 1);
			if ($tmp10 > $min_count_file4) {
			    $tmp9 = $tmp10-$val1;

#			    if ($nbhostpageday{$user} > 1 && $tmp9 > $min_count_file3) {
			    if ($nbdailydest{$val1} > 1 && $tmp9 > $min_count_file4) {
			    $index = &bsearch(\@count_file4, $tmp9);
			    splice(@count_file4, $index, 1,"$tmp10"); 
			    @count_file4 = reverse sort { $a <=> $b } @count_file4;
			    } else {
				$count_file4[$#count_file4] = $tmp10;
				@count_file4 = reverse sort { $a <=> $b } @count_file4;
				$min_count_file4 = $count_file4[$#count_file4];
			    # Find page and Undef $tmp2b / %seen_page $min_data{$user} ? but how
				$skip_data = 0;
			    }
			} else {
			    $skip_data = 1 if ($mode == 0);
			}
		    }

		    $tmp2b = "min4_valdata".$tmp;
		    }
		}
		if ($nb == 4) {
		    if ($skip_data == 0) {
			if ($mode == 1 && $found_mode_entry == 1 && $count_exp_file > $max_item_page) {
			    $seen_dest{$tmp,$val1} += $val3;
			    $nbhostday{$tmp}++ if ($seen_dest{$tmp,$val1} == $val3);
			    $dailyhostsizedest{$tmp,$val1} += $val4;
			}
			if ($mode == 0 && $count_exp_file <= $max_item_page) {
			    $seen_dest{$tmp,$val1} += $val3;
			    $nbhostday{$tmp}++ if ($seen_dest{$tmp,$val1} == $val3);
			    $dailyhostsizedest{$tmp,$val1} += $val4;
			}



#			if ($display_subitem > 0) {
		    # fill the array with the first day : display_subitem max 
#		    if ($nbhostday{$tmp} <= $display_subitem && $seen_dest{$tmp,$val1} == $val3) {

		    if ($display_subitem > 0 && $mode == 0 && $count_exp_file <= $max_item_page) {
		    if ($nbhosyday{$tmp} <= $display_subitem && $seen_dest{$tmp,$val1} == $val3) {
			$dailyhostdest{$tmp,$nbhostday{$tmp}} = $val1;
			$dailyusersdest{$tmp,$nbhostday{$tmp}} = $val2;
			if ($min_data4{$tmp} eq '' || $val3 <= $min_data4{$tmp}) {
			    $min_data4{$tmp} = $val3;
			    push(@$tmp2b,$val3);
			}
		    }
		    if ($seen_dest{$tmp,$val1} > $min_data4{$tmp}) {
			# tri des seen_page
			$fnd_idx = 0;
			$tmp3 = $seen_dest{$tmp,$val1}-$val3;
			if ($tmp3 != 0) {
			    for ($k=0;$k<$display_subitem;$k++) {
				$k2 = $k+1;
				if ($$tmp2b[$k] == $tmp3 && $dailyhostdest{$tmp,$k2} eq $val1) {
				    $idx1 = $k;
				    $fnd_idx = 1;
				    last;
				}
			    }
			}
			$idx1 = $#$tmp2b if ($fnd_idx == 0);
			if ($fnd_idx == 0 && (scalar(@$tmp2b) != $display_subitem)) {
			    push(@$tmp2b,$seen_dest{$tmp,$val1});
			} else {
			    $$tmp2b[$idx1] = $seen_dest{$tmp,$val1};
			}
			@$tmp2b = reverse sort { $a <=> $b } @$tmp2b;

			$min_data4{$tmp} = $$tmp2b[$#$tmp2b];
			# tri des $dailypageserv
			if ($fnd_idx == 0) {
			    for ($k=0;$k<$display_subitem;$k++) {
				$idx = $k if ($$tmp2b[$k] == $seen_dest{$tmp,$val1});
			    }
			    for ($k=$display_subitem;$k>$idx;$k--) {
				$kidx=$k-1;
				$dailyhostdest{$tmp,$k} = $dailyhostdest{$tmp,$kidx};
			    }
			    $idx++;
			    $dailyhostdest{$tmp,$idx} = $val1;
			} else {
			    # deja present
			    for ($k=0;$k<$display_subitem;$k++) {
				if ($$tmp2b[$k] == $seen_dest{$tmp,$val1}) {
				    $idx2 = $k;
				}
			    }
			    if ($idx1 != $idx2) {
				$idx1++;
				for ($k=$idx1;$k>$idx2;$k--) {
				    $kidx=$k-1;
				    $dailyhostdest{$tmp,$k} = $dailyhostdest{$tmp,$kidx};
				}
				$idx2++;
				$dailyhostdest{$tmp,$idx2} = $val1;
			    } else {
				$idx2++;
				$dailyhostdest{$tmp,$idx2} = $val1;
			    }
			}
		    }
			}
		}
		}
	    }
	    close(FILEDAILY);
	}
	}

	### Filetype
	$count_exp_file = 0;

	$file_daily = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailyfiletype$txtext";
	if ($mode != 2) {
	open(FILEDAILY,"$file_daily") || &error_exit("Error, unable to open $file_daily",1);
	while (<FILEDAILY>) {
	    chop;
	    ($val1,$val2,$val3,$val4) = split(/\t/);
	    $count_exp_file++;
	    if ($mode == 0 && $count_exp_file <= $max_item_page) {
		$extfilenb{$val1} = $val3;
		$tmp = $extfilenb{$val1};
		$tmp = 0 if ($extfilenb{$val1} eq '');
		$zoneextjour[$tmp] += $val4;
#	    $zoneextjour[$extfilenb{$val1}] += $val3;
		$downloadjour{$val1} += $val4;
		$filetypenb{$val1} += $val2;
		push(@listext,$val1) unless ($seen_server{$val1}++);
	    }
	    if ($mode == 1 && $downloadjour{$val1} ne '' && $count_exp_file > $max_item_page) {
		$extfilenb{$val1} = $val3;
		$tmp = $extfilenb{$val1};
		$tmp = 0 if ($extfilenb{$val1} eq '');
		$zoneextjour[$tmp] += $val4;
#	    $zoneextjour[$extfilenb{$val1}] += $val3;
		$downloadjour{$val1} += $val4;
		$filetypenb{$val1} += $val2;
		push(@listext,$val1) unless ($seen_server{$val1}++);
	    }

	}
	close(FILEDAILY);
    }
    }

    ### Refer
    $count_exp_file = 0;
    if ($mode != 2) {
    $file_daily = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailyrefer$txtext";
    if (-f $file_daily) {
	open(FILEDAILY,"$file_daily");
	while (<FILEDAILY>) {
	    chop;
	    $line = $_;
	    $line =~ s/\r\n(.*)//;
	    ($val1,$val2,$val3) = split(/\t/,$line);


	    if (($mode == 0 && $count_exp_file <= $max_item_page) || ($mode == 1 && $nbredayref{$val2} ne '' && $count_exp_file > $max_item_page)) {


	    if ($val1 eq "A") {
		$nbredayref{$val2} += $val3;
#		    $uniqueday++;
	    }
	    
	    if ($val1 eq "B") {
		$nbrefullday{$val2} += $val3;
		$uniquenbrefullday++;
		$site = $val2;
	    }
	    
	    if ($val1 eq "B1") {
		if ($refer_fullsite_occur_day{$site,$val2} eq '') {
		    $idx_fullsite_day{$site}++;
		    $i = $idx_fullsite_day{$site};
		    $refer_fullsite_page_day{$site,$i} = $val2;
		}
		$refer_fullsite_occur_day{$site,$val2} += $val3;
	    }

	    if ($val1 eq "C") {
		$occurday{$val2} += $val3;
		$uniqueurlday++;	
		$site2 = $val2;

	    }
	    
	    if ($val1 eq "C1") {
		if ($occur_fullsite_occur_day{$site2,$val2} eq '') {
		    $idx_occur_day{$site2}++;
		    $i = $idx_occur_day{$site2};
		    $occur_fullsite_page_day{$site2,$i} = $val2;
		}
		$occur_fullsite_occur_day{$site2,$val2} += $val3;
	    }

	    if ($val1 eq "D") {
		push(@wordsday,$val2) unless ($seen_server{$val2}++);
		$wday{$val2} += $val3;
	    }
		    
	    if ($val1 eq "E") {
		$keyshday{$val2} += $val3;
	    }

	    if ($val1 eq "F") {
		$fullstringday{$val2} += $val3;
	    }
	    }
	}
	close(FILEDAILY);
    }
    }

    ### Agent
    $count_exp_file = 0;

    if ($mode != 2) {
    $file_daily = "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailyagent$txtext";
    if (-f $file_daily) {
	open(FILEDAILY,"$file_daily") || &error_exit("Error, unable to open $file_daily",1);
	$tmp = <FILEDAILY>;
	chop($tmp);
	($val1,$val2) = split(/\t/,$tmp);
	$countday += $val2 if ($mode == 0);

	while (<FILEDAILY>) {
	    chop;
	    $line = $_;
	    $line =~ s/\r\n(.*)//;	

	    ($val1,$val2,$val3) = split(/\t/,$line);
	    if (($mode == 0 && $count_exp_file <= $max_item_page) || ($mode == 1 && $nbrebrowserday{$val2} ne '' && $count_exp_file > $max_item_page)) {
	    if ($val1 eq "A") {
		$nbrebrowserday{$val2} += $val3;
	    }
	    
	    if ($val1 eq "B") {
		$nbreosday{$val2} += $val3;
		$uniqueosday++ unless ($seen_server{"B $val2"}++);
	    }

	    if ($val1 eq "C") {
		if ($idx_browser{$val2} eq '') {
		    $nbagent++;
		    $uniqueday++;
		    $idx_browser{$val2} = $nbagent;
		    $browserday[$nbagent] = $val2;
		    $idx = $nbagent;
		} else {
		    $idx = $idx_browser{$val2};
		}
		$nbreday{$browserday[$idx]} += $val3;
	    }
	    }
	}
	
	close(FILEDAILY);
    }
}
}

#----------------------------------------------------
# Translate Windows Path
sub Windows_ShortPath {
    local($path,$flag) = @_;
    local($tmp,$path2,$tmp_idx,$string,$value,$i,@val);
    local($file,$max,$newpath,$found);

    $max = 9;
    $max = 1 if ($flag == 1);

    if (substr($path,1,1) eq ':') {
	$tmp_idx = 0;
	$path =~ s/\\/\//g;
#	$path2 = $path;
	while ($tmp_idx < $max && !(-d $path2)) {
	    $tmp_idx++;

	    $value = $path;
	    $drive = substr($path,0,3);
	    $value = substr($path,3);
	    
	    $string = '';
	    $file = substr($value,rindex($value,$dirsepurl)+1,length($value));
	    $value = substr($value,0,rindex($value,$dirsepurl)+1);

	    @val = split(/$dirsepurl/,$value);
	    for ($i=0;$i<=$#val;$i++) {
		if ($val[$i] =~ /\s+/) {
		    $val[$i] =~ s/\s+//g;
		    $value = substr($val[$i],0,6);
		    $value .= "~".$tmp_idx.$dirsepurl;
		    $found = 1;
		} else {
		    $value = $val[$i].$dirsepurl;
		}
		$string .= $value;
	    }
	    $path2 = $drive.$string;
	    if ($file eq '') {
		$newpath = $path2;
	    } else {
		$newpath = $path2.$file;
	    }
	}
	if ($tmp_idx == 9) {
	    if ("$path2$file" eq $path) {
		$msg = "WARNING : $path not found\n";
	    } else {
		$msg = "WARNING : not able to convert Windows path $path --> $path2\n";
	    }
	    &error_exit($msg,4);
	}
    } else {
	$newpath = $path;
    }

    return $newpath;
}

sub output_log {
    local($msg) = @_;

#    &flush(FILE2);
    FILE2->autoflush(1);

    &MakeDirectories if (!(-d $path));
    if (-d $path) {
	if (!(-w $path) && $fly_set == 0) {
	    print "</SCRIPT><P><B>$msg</B>\n";
	}
	if (!(-w $path) && $fly_set == 1) {
	    $msg = "Cannot write in $path\n";
	    $msg .= "<BR>" if ($opt_z ne '');
	    $msg .= "It seems you are trying to run the stats from a different user\n";
	    if ($ENV{'REQUEST_METHOD'} eq "GET" || $opt_z ne '') {
		print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
		$msg .= "<BR>" if ($opt_z ne '');
		$msg .= " and the stats have been previously ran from the command line\n";
		print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET");
		$msg .= "<P>" if ($opt_z ne '');
		$msg .= "The web interface have no privilege to overwrite users files\n";
	    } else {
		$msg .= "Change files permission or owner in order to run this script\n";
	    }
	    print "$msg\n";
	}

	if ($opt_y eq '' && $open_outputlog == 0) {
	    open(FILE2,">$path$output_log") || die "Unable to open the output log $path$output_log";
	    $open_outputlog = 1;
	} else {
	    open(FILE2,">>$path$output_log") || die "Unable to open the output log $path$output_log";
	}

	print $msg;
	print FILE2 "$msg";
	close(FILE2);	
    } else {
	print "Directory $path does not exist\n";
    }
}

sub load_reverse_adresse {
    local($adresse,$chiffre);

    if (-f "$path$dirinc$dirsep$increversehosts") {
	open(PAGES,"$path$dirinc$dirsep$increversehosts");
	while (<PAGES>) {
	    chop;
	    ($adresse,$chiffre) = split;
	    $adressehad{$adresse} = $chiffre;
	    $reverseadressehad[$chiffre] = $adresse;
#	    print "A $adresse - $chiffre / $adressehad{$adresse} - $reverseadressehad[$chiffre]\n";
	}
	close(PAGES);
    }
}

sub NoDataToDisplay {
    local(*FOUT,$msg) = @_;
    print FOUT "<CENTER><FONT COLOR=\"#FF0000\">$msg</FONT></CENTER>";    
}



sub UpdateCSSMenu {
    local($topmenu,$menu,$icon,$link,$depth,$submenu) = @_;
    local($i,$tmp,$line,$topline,$column);

    for ($nblang=0;$nblang<=$#lang;$nblang++) {
	$tmp = "Lang".uc($lang[$nblang]);
	if ($$tmp{$topmenu} ne '') {
	    $topline .= "$$tmp{$topmenu}";
	} else {
	    $topline .= "$topmenu";
	}
	$topline .= "|" if ($nblang != $#lang);
    }

    $column = $columns_menu{$topmenu};

    if ($menu eq "-") {
	$topline .= "\t$column\t0\t0\t-\t$link\n";
    } else {
	$topline .= "\t$column\t0\t0\t-\t-\n";
    } 

    $tmp2 = $menu;
    $tmp2 =~ s/Doc-//;
    $tmp2 =~ s/Doc2-//;
    $tmp2 =~ s/Ses-//;

    for ($nblang=0;$nblang<=$#lang;$nblang++) {
	$tmp = "Lang".uc($lang[$nblang]);
	if ($$tmp{$tmp2} ne '') {
	    $line .= "$$tmp{$tmp2}";
	} else {
	    $line .= "$tmp2";
	}
	$line .= "|" if ($nblang != $#lang);
    }
    $line .= "\t$column\t$depth\t$submenu\t$icon\t$link\n";

    open(GENERAL,"$path$dirinc$dirsep$menuheader") || &error_exit("Error, unable to open $path$dirinc$dirsep$menuheader");
    @lines = (<GENERAL>);
    close(GENERAL);

    # include submenu
    if ($menu eq "Status_code") {
	foreach $status (sort (keys %FailStatusMsgs)) {
	    if ($status_code{$status} != 0 && $status >= 400) {
		for ($nblang=0;$nblang<=$#lang;$nblang++) {
		    $line .= "$FailStatusMsgs{$status}";
		    $line .= "|" if ($nblang != $#lang);
		}
		$line .= "\t1\t2\t0\t-\t$dirlist$dirsepurl$incstatus$status$htmlext\n";
	    }
	}
    }
    if ($menu eq "Countries") {
	for ($i=1;$i<=$nbzone;$i++) {
	    if (-f "$path$lang[0]$dirsep$dirpays$dirsep$zone[$i]$htmlext") {
		for ($nblang=0;$nblang<=$#lang;$nblang++) {
		    $line .= "$$tmp{$zone[$i]}";
		    $line .= "|" if ($nblang != $#lang);
		}
		$line .= "\t1\t2\t0\t-\t$dirpays$dirsepurl$zone[$i]$htmlext\n";
	    }
	}
    }

    open(GENERAL,">$path$dirinc$dirsep$menuheader") || &error_exit("Error, unable to open $path$dirinc$dirsep$menuheader");
    for ($i=0;$i<=$#lines;$i++) {
	$lines[$i] = $topline if ($lines[$i] =~ /^#\s+$topmenu\s+#/);
	$lines[$i] = $line if ($lines[$i] =~ /^#\s+$menu\s+#/);
	print GENERAL "$lines[$i]";
    }
    close(GENERAL);

}


sub CreateCSSMenu {
    local($number) = @_;
    local($tmp);

# Section - menu column - depth - submenu - icon - link

    if ($number != 0 && -f "$path$dirinc$dirsep$menuheader") {
	open(GENERAL,"$path$dirinc$dirsep$menuheader");
	@lines = (<GENERAL>);
	close(GENERAL);
    }

    open(GENERAL,">$path$dirinc$dirsep$menuheader") || &error_exit("Error, unable to open $path$dirinc$dirsep$menuheader");

    for ($nblang=0;$nblang<=$#lang;$nblang++) {
	$tmp = "Lang".uc($lang[$nblang]);
	print GENERAL "$$tmp{'Index'}";
	print GENERAL "|" if ($nblang != $#lang);
    }
    print GENERAL "\t1\t0\t0\t";
    for ($nblang=0;$nblang<=$#lang;$nblang++) {
	print GENERAL "LINKBASE$dirress$dirsepurl$flag[$nblang]";
	print GENERAL "|" if ($nblang != $#lang);
    }
    print GENERAL "\t";
    for ($nblang=0;$nblang<=$#lang;$nblang++) {
	print GENERAL "LINKBASE$homepages[$nblang]";
	print GENERAL "|" if ($nblang != $#lang);
    }
    print GENERAL "\n";

    print GENERAL "# Hosts #\n";
    print GENERAL "# Pages #\n";
    print GENERAL "# Filetype #\n";
    print GENERAL "# Scripts #\n";
    print GENERAL "# Status_code #\n";
    print GENERAL "# Directories #\n";
    print GENERAL "# Traffic #\n";
    print GENERAL "# Download #\n";
    print GENERAL "# Countries #\n";
    print GENERAL "# Cities #\n";
    print GENERAL "# RSS #\n";

    ### Menu 2- When

    print GENERAL "# When #\n";
    print GENERAL "# Real_time #\n";
    print GENERAL "# Hours #\n";
    print GENERAL "# Days #\n";
    print GENERAL "# Weeks #\n";
    print GENERAL "# Months #\n";
    print GENERAL "# Years #\n";

    ### Menu 3 - Optional

    print GENERAL "# Optional #\n";
    print GENERAL "# Browsers #\n";
    print GENERAL "# Referer #\n";
    print GENERAL "# Search_engine #\n";
    print GENERAL "# Errors #\n";
    print GENERAL "# Users #\n";
    print GENERAL "# Spam #\n";
    print GENERAL "# Screensize #\n";
    print GENERAL "# Heatmap #\n";
    print GENERAL "# Virus #\n";
    print GENERAL "# Destination #\n";
    print GENERAL "# Squid #\n";

    ### MENU 4 - Session

    print GENERAL "# Sessions #\n";
    print GENERAL "# Ses-Number_of_visits #\n";
    print GENERAL "# Ses-Multiple_sessions #\n";
    print GENERAL "# Ses-Session_length #\n";
    print GENERAL "# Ses-Average #\n";
    print GENERAL "# Ses-Search_engine #\n";
    print GENERAL "# Ses-Reading_time #\n";

    ### MENU 5 - Document

    if ($number == 5) {
	for ($i=0;$i<=$#lines;$i++) {
	   print GENERAL "$lines[$i]" if ($lines[$i] =~ /\t$number\t/); 
	}
    } else {
	print GENERAL "# Documents #\n";
	print GENERAL "# Doc-Stats #\n";
	print GENERAL "# Doc-Links #\n";
	print GENERAL "# Doc-Images #\n";
	print GENERAL "# Doc-Weight_of_files #\n";
	print GENERAL "# Doc-Directories #\n";
	print GENERAL "# Doc-Users #\n";
	print GENERAL "# Doc-Tag #\n";
	print GENERAL "# Doc-Same_title #\n";
	print GENERAL "# Doc-WIDTH #\n";
	print GENERAL "# Doc-ALT #\n";
	print GENERAL "# Doc-Newest_pages #\n";
	print GENERAL "# Doc-Tree #\n";
	print GENERAL "# Doc-Frames #\n";
	print GENERAL "# Doc-Useless_pages #\n";
	print GENERAL "# Doc-No_index #\n";
	print GENERAL "# Doc2-Links #\n";
	print GENERAL "# Doc-Absolute_links #\n";
	print GENERAL "# Doc-Symbolic_links #\n";
	print GENERAL "# Doc-Bad_links #\n";
    }

    ### MENU 6 - Resources

    if ($hide_resources_menu == 0) {

	for ($nblang=0;$nblang<=$#lang;$nblang++) {
	    $tmp = "Lang".uc($lang[$nblang]);
	    print GENERAL "$$tmp{'Resources'}";
	    print GENERAL "|" if ($nblang != $#lang);
	}
	print GENERAL "\t6\t0\t0\t-\t-\n";

	for ($nblang=0;$nblang<=$#lang;$nblang++) {
	    $tmp = "Lang".uc($lang[$nblang]);
	    print GENERAL "$$tmp{'Admin'}";
	    print GENERAL "|" if ($nblang != $#lang);
	}
	print GENERAL "\t6\t1\t0\t-\tLINKHOME$diradmin$dirsepurl$help\n";

	for ($nblang=0;$nblang<=$#lang;$nblang++) {
	    $tmp = "Lang".uc($lang[$nblang]);
	    print GENERAL "$$tmp{'News'}";
	    print GENERAL "|" if ($nblang != $#lang);
	}
	print GENERAL "\t6\t1\t0\t-\thttp://www.w3perl.com/demo/docs/uk/new.html?$version\n";


	for ($nblang=0;$nblang<=$#lang;$nblang++) {
	    $tmp = "Lang".uc($lang[$nblang]);
	    print GENERAL "$$tmp{'Docs'}";
	    print GENERAL "|" if ($nblang != $#lang);
	}
	if ($lang[$nblang] ne "fr") {
	    print GENERAL "\t6\t1\t0\t-\tLINKHOME$dirdocs$dirsepurl$help\n";
	} else {
	    print GENERAL "\t6\t1\t0\t-\tLINKHOME$dirdocs_fr$dirsepurl$help\n";
	}

	if (-f "$path$filerss$xmlext") {
	    for ($nblang=0;$nblang<=$#lang;$nblang++) {
		$tmp = "Lang".uc($lang[$nblang]);
		print GENERAL "$$tmp{'RSS'}";
		print GENERAL "|" if ($nblang != $#lang);
	    }
	    print GENERAL "\t6\t1\t0\t-\tLINKBASE$filerss$xmlext\n";
	}

	print GENERAL "# CPU #\n";

	if ($nb_stats_run >= 0 && $hide_other_report == 0) {
	    for ($nblang=0;$nblang<=$#lang;$nblang++) {
		$tmp = "Lang".uc($lang[$nblang]);
		print GENERAL "$$tmp{'Stats'}";
		print GENERAL "|" if ($nblang != $#lang);
	    }
	    print GENERAL "\t6\t1\t1\t-\t-\n";
	    
	    for ($i=0;$i<=$nb_stats_run;$i++) {
		$tmp = "web".$log_sum[$i].$pngext;
		$tmp =~ tr/[A-Z]/[a-z]/;
		$dirhomepage = "homepage";
		if (-f "$path$dirress$dirsep$dirhomepage$dirsep$tmp") {
		    for ($nblang=0;$nblang<=$#lang;$nblang++) {
			print GENERAL "$www_sum[$i]";
			print GENERAL "|" if ($nblang != $#lang);
		    }
		    print GENERAL "\t6\t2\t0\tLINKBASE$homeicons$dirsepurl$tmp\t$link_other_stats[$i]\t$config_sum[$i]\n";
		}
		
	    }
	}
    }

    close GENERAL;

    chmod 0666, "$path$dirinc$dirsep$tmp";

}

sub EncryptLink {
    local($link) = @_;
    local($tmp,$tmp1,$tmp2,$tmp3,$tmp4,$tmp5);
    if ($mail_format == 1) {
	if ($link =~ /-/) {
	    ($tmp1,$tmp5) = split(/\&nbsp;/,$link);
	    ($tmp1,$tmp2) = split(/\-/,$link) if ($link =~ /-/);
	    ($tmp3) = split(/\@/,$tmp1);
	    ($tmp4) = split(/\@/,$tmp2);
	    $tmp1 = crypt($tmp3,&keycrypt(2));
	    $tmp2 = crypt($tmp4,&keycrypt(2));	  
	    $tmp1 = substr($tmp1,0,5);
	    $tmp2 = substr($tmp2,0,5);
	    $link = "$tmp1\@$localdomainename_crypt&nbsp;$tmp5&nbsp;$tmp2\@$localdomainename_crypt";
	} else {
	    $link = crypt($link,&keycrypt(2));
	}
    } else {
	$link = crypt($link,&keycrypt(2));
    }
    return $link;
}

sub map_homepage_check {
    local($val,$lang) = @_;
    local(@tmp1,$tmp,$tmp2,$i);

    @tmp1 = split(/\n/,$val);
    $tmp = '';

    for ($i=0;$i<=$#tmp1;$i++) {
	$tmp2 = $1 if ($tmp1[$i] =~ /"<!-- langhome -->(.*)"\s+ALT/);
	if (-e "$path$lang$tmp2") {
	    $tmp1[$i] =~ s/<!-- langhome -->/$lang/;
	    $tmp .= "$tmp1[$i]\n";
	}
    }
    
    return $tmp;
}


##

1;
